/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the PPC target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 41;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(PPCInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(PPCInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static PPCInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static PPCInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s1,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s64,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_v256s1,
  GILLT_v512s1,
  GILLT_v1024s1,
  GILLT_v2048s1,
};
const static size_t NumTypeObjects = 12;
const static LLT TypeObjects[] = {
  LLT::scalar(1),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getFixed(256), 1),
  LLT::vector(ElementCount::getFixed(512), 1),
  LLT::vector(ElementCount::getFixed(1024), 1),
  LLT::vector(ElementCount::getFixed(2048), 1),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_In32BitModeBit = 1,
  Feature_In64BitModeBit = 9,
  Feature_HasOnlyMSYNCBit = 23,
  Feature_HasSYNCBit = 22,
  Feature_HasSPEBit = 8,
  Feature_HasICBTBit = 21,
  Feature_HasBPERMDBit = 10,
  Feature_HasExtDivBit = 3,
  Feature_IsISA2_06Bit = 11,
  Feature_IsISA2_07Bit = 40,
  Feature_IsISA3_0Bit = 2,
  Feature_HasFPUBit = 0,
  Feature_PCRelativeMemopsBit = 37,
  Feature_IsNotISA3_1Bit = 39,
  Feature_IsAIXBit = 24,
  Feature_NotAIXBit = 25,
  Feature_IsISAFutureBit = 18,
  Feature_IsNotISAFutureBit = 19,
  Feature_HasAltivecBit = 4,
  Feature_HasP8AltivecBit = 5,
  Feature_HasP8CryptoBit = 6,
  Feature_HasP9AltivecBit = 7,
  Feature_HasVSXBit = 12,
  Feature_IsLittleEndianBit = 26,
  Feature_IsBigEndianBit = 27,
  Feature_IsPPC64Bit = 31,
  Feature_HasOnlySwappingMemOpsBit = 29,
  Feature_NoP8VectorBit = 30,
  Feature_HasP8VectorBit = 13,
  Feature_HasDirectMoveBit = 14,
  Feature_NoP9VectorBit = 28,
  Feature_HasP9VectorBit = 15,
  Feature_NoP9AltivecBit = 32,
  Feature_NoP10VectorBit = 33,
  Feature_HasP10VectorBit = 36,
  Feature_HasHTMBit = 34,
  Feature_MMABit = 20,
  Feature_IsPPC32Bit = 38,
  Feature_PrefixInstrsBit = 16,
  Feature_IsISA3_1Bit = 17,
  Feature_PairedVectorMemopsBit = 35,
};

PredicateBitset PPCInstructionSelector::
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!Subtarget->isPPC64())
    Features.set(Feature_In32BitModeBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_In64BitModeBit);
  if (Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasOnlyMSYNCBit);
  if (!Subtarget->hasOnlyMSYNC())
    Features.set(Feature_HasSYNCBit);
  if (Subtarget->hasSPE())
    Features.set(Feature_HasSPEBit);
  if (Subtarget->hasICBT())
    Features.set(Feature_HasICBTBit);
  if (Subtarget->hasBPERMD())
    Features.set(Feature_HasBPERMDBit);
  if (Subtarget->hasExtDiv())
    Features.set(Feature_HasExtDivBit);
  if (Subtarget->isISA2_06())
    Features.set(Feature_IsISA2_06Bit);
  if (Subtarget->isISA2_07())
    Features.set(Feature_IsISA2_07Bit);
  if (Subtarget->isISA3_0())
    Features.set(Feature_IsISA3_0Bit);
  if (Subtarget->hasFPU())
    Features.set(Feature_HasFPUBit);
  if (Subtarget->hasPCRelativeMemops())
    Features.set(Feature_PCRelativeMemopsBit);
  if (!Subtarget->isISA3_1())
    Features.set(Feature_IsNotISA3_1Bit);
  if (Subtarget->isAIXABI())
    Features.set(Feature_IsAIXBit);
  if (!Subtarget->isAIXABI())
    Features.set(Feature_NotAIXBit);
  if (Subtarget->isISAFuture())
    Features.set(Feature_IsISAFutureBit);
  if (!Subtarget->isISAFuture())
    Features.set(Feature_IsNotISAFutureBit);
  if (Subtarget->hasAltivec())
    Features.set(Feature_HasAltivecBit);
  if (Subtarget->hasP8Altivec())
    Features.set(Feature_HasP8AltivecBit);
  if (Subtarget->hasP8Crypto())
    Features.set(Feature_HasP8CryptoBit);
  if (Subtarget->hasP9Altivec())
    Features.set(Feature_HasP9AltivecBit);
  if (Subtarget->hasVSX())
    Features.set(Feature_HasVSXBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBigEndianBit);
  if (Subtarget->isPPC64())
    Features.set(Feature_IsPPC64Bit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_HasOnlySwappingMemOpsBit);
  if (!Subtarget->hasP8Vector())
    Features.set(Feature_NoP8VectorBit);
  if (Subtarget->hasP8Vector())
    Features.set(Feature_HasP8VectorBit);
  if (Subtarget->hasDirectMove())
    Features.set(Feature_HasDirectMoveBit);
  if (!Subtarget->hasP9Vector())
    Features.set(Feature_NoP9VectorBit);
  if (Subtarget->hasP9Vector())
    Features.set(Feature_HasP9VectorBit);
  if (!Subtarget->hasP9Altivec())
    Features.set(Feature_NoP9AltivecBit);
  if (!Subtarget->hasP10Vector())
    Features.set(Feature_NoP10VectorBit);
  if (Subtarget->hasP10Vector())
    Features.set(Feature_HasP10VectorBit);
  if (Subtarget->hasHTM())
    Features.set(Feature_HasHTMBit);
  if (Subtarget->hasMMA())
    Features.set(Feature_MMABit);
  if (!Subtarget->isPPC64())
    Features.set(Feature_IsPPC32Bit);
  if (Subtarget->hasPrefixInstrs())
    Features.set(Feature_PrefixInstrsBit);
  if (Subtarget->isISA3_1())
    Features.set(Feature_IsISA3_1Bit);
  if (Subtarget->pairedVectorMemops())
    Features.set(Feature_PairedVectorMemopsBit);
  return Features;
}

void PPCInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const PPCSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset PPCInstructionSelector::
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAltivec,
  GIFBS_HasBPERMD,
  GIFBS_HasExtDiv,
  GIFBS_HasFPU,
  GIFBS_HasHTM,
  GIFBS_HasOnlyMSYNC,
  GIFBS_HasP8Altivec,
  GIFBS_HasP8Crypto,
  GIFBS_HasP9Altivec,
  GIFBS_HasSPE,
  GIFBS_HasSYNC,
  GIFBS_HasVSX,
  GIFBS_In32BitMode,
  GIFBS_In64BitMode,
  GIFBS_IsAIX,
  GIFBS_IsISA3_0,
  GIFBS_IsISA3_1,
  GIFBS_IsISAFuture,
  GIFBS_IsNotISA3_1,
  GIFBS_NotAIX,
  GIFBS_PairedVectorMemops,
  GIFBS_HasDirectMove_HasVSX,
  GIFBS_HasFPU_IsISA3_1,
  GIFBS_HasP10Vector_PrefixInstrs,
  GIFBS_HasP8Altivec_HasVSX,
  GIFBS_HasP8Vector_HasVSX,
  GIFBS_HasP9Vector_HasVSX,
  GIFBS_HasVSX_IsISA3_1,
  GIFBS_In64BitMode_IsISA3_0,
  GIFBS_IsISAFuture_MMA,
  GIFBS_IsNotISAFuture_MMA,
  GIFBS_HasP8Altivec_HasVSX_IsBigEndian,
  GIFBS_HasP8Altivec_HasVSX_IsLittleEndian,
  GIFBS_IsISAFuture_MMA_PrefixInstrs,
  GIFBS_IsNotISAFuture_MMA_PrefixInstrs,
  GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian,
  GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector,
  GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64,
  GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAltivecBit, },
  {Feature_HasBPERMDBit, },
  {Feature_HasExtDivBit, },
  {Feature_HasFPUBit, },
  {Feature_HasHTMBit, },
  {Feature_HasOnlyMSYNCBit, },
  {Feature_HasP8AltivecBit, },
  {Feature_HasP8CryptoBit, },
  {Feature_HasP9AltivecBit, },
  {Feature_HasSPEBit, },
  {Feature_HasSYNCBit, },
  {Feature_HasVSXBit, },
  {Feature_In32BitModeBit, },
  {Feature_In64BitModeBit, },
  {Feature_IsAIXBit, },
  {Feature_IsISA3_0Bit, },
  {Feature_IsISA3_1Bit, },
  {Feature_IsISAFutureBit, },
  {Feature_IsNotISA3_1Bit, },
  {Feature_NotAIXBit, },
  {Feature_PairedVectorMemopsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, },
  {Feature_HasFPUBit, Feature_IsISA3_1Bit, },
  {Feature_HasP10VectorBit, Feature_PrefixInstrsBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, },
  {Feature_HasP8VectorBit, Feature_HasVSXBit, },
  {Feature_HasP9VectorBit, Feature_HasVSXBit, },
  {Feature_HasVSXBit, Feature_IsISA3_1Bit, },
  {Feature_In64BitModeBit, Feature_IsISA3_0Bit, },
  {Feature_IsISAFutureBit, Feature_MMABit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsBigEndianBit, },
  {Feature_HasP8AltivecBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, },
  {Feature_IsISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_IsNotISAFutureBit, Feature_MMABit, Feature_PrefixInstrsBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsISA3_0Bit, Feature_IsLittleEndianBit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsLittleEndianBit, Feature_NoP9VectorBit, },
  {Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_1Bit, Feature_IsPPC32Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsISA3_0Bit, Feature_IsPPC64Bit, },
  {Feature_HasDirectMoveBit, Feature_HasVSXBit, Feature_IsBigEndianBit, Feature_IsPPC64Bit, Feature_NoP9VectorBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

PPCInstructionSelector::ComplexMatcherMemFn
PPCInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool PPCInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_Msk2Imm = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_Msk4Imm,
  GICXXPred_I64_Predicate_Msk8Imm,
  GICXXPred_I64_Predicate_i32immNonAllOneNonZero,
  GICXXPred_I64_Predicate_imm32SExt16,
  GICXXPred_I64_Predicate_imm64SExt16,
  GICXXPred_I64_Predicate_imm64ZExt32,
  GICXXPred_I64_Predicate_immNonAllOneAnyExt8,
  GICXXPred_I64_Predicate_immSExt5NonZero,
};
bool PPCInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_Msk2Imm: {
     return isUInt<2>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk4Imm: {
     return isUInt<4>(Imm); 
  }
  case GICXXPred_I64_Predicate_Msk8Imm: {
     return isUInt<8>(Imm); 
  }
  case GICXXPred_I64_Predicate_i32immNonAllOneNonZero: {
     return Imm && (Imm != -1); 
  }
  case GICXXPred_I64_Predicate_imm32SExt16: {
    
      // imm32SExt16 predicate - True if the i32 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int32_t)Imm == (short)Imm;
    
    llvm_unreachable("imm32SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64SExt16: {
    
      // imm64SExt16 predicate - True if the i64 immediate fits in a 16-bit
      // sign extended field.  Used by instructions like 'addi'.
      return (int64_t)Imm == (short)Imm;
    
    llvm_unreachable("imm64SExt16 should have returned");
  }
  case GICXXPred_I64_Predicate_imm64ZExt32: {
    
      // imm64ZExt32 predicate - True if the i64 immediate fits in a 32-bit
      // zero extended field.
      return isUInt<32>(Imm);
    
    llvm_unreachable("imm64ZExt32 should have returned");
  }
  case GICXXPred_I64_Predicate_immNonAllOneAnyExt8: {
    
      return (isInt<8>(Imm) && (Imm != -1)) || (isUInt<8>(Imm) && (Imm != 0xFF));
    
  }
  case GICXXPred_I64_Predicate_immSExt5NonZero: {
     return Imm && isInt<5>(Imm); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool PPCInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool PPCInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("PPCInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
PPCInstructionSelector::CustomRendererFn
PPCInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool PPCInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool PPCInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("PPCInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *PPCInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(289), /*)*//*default:*//*Label 83*/ GIMT_Encode4(211473),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(954),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(1363),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(1804),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(2086),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(2242),
     /*     30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(2398),
     /*     34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(2560), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(2722),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5283),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(48425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 10*/ GIMT_Encode4(57532), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 11*/ GIMT_Encode4(58499), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 12*/ GIMT_Encode4(60776),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 13*/ GIMT_Encode4(61051),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 14*/ GIMT_Encode4(61301),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 15*/ GIMT_Encode4(61432), GIMT_Encode4(0),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 16*/ GIMT_Encode4(61563), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 17*/ GIMT_Encode4(61583), GIMT_Encode4(0),
     /*    302 */ /*TargetOpcode::G_BRCOND*//*Label 18*/ GIMT_Encode4(61708), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 19*/ GIMT_Encode4(61771),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 20*/ GIMT_Encode4(91199), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 21*/ GIMT_Encode4(94091),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 22*/ GIMT_Encode4(114847),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 23*/ GIMT_Encode4(115033), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 24*/ GIMT_Encode4(115185),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 25*/ GIMT_Encode4(130217),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 26*/ GIMT_Encode4(130570),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 27*/ GIMT_Encode4(152040),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 28*/ GIMT_Encode4(152396),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 29*/ GIMT_Encode4(152818), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    390 */ /*TargetOpcode::G_ROTL*//*Label 30*/ GIMT_Encode4(153188),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 31*/ GIMT_Encode4(153496),
     /*    398 */ /*TargetOpcode::G_FCMP*//*Label 32*/ GIMT_Encode4(157498), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 33*/ GIMT_Encode4(160949), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 34*/ GIMT_Encode4(162073),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 35*/ GIMT_Encode4(162203),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 36*/ GIMT_Encode4(162333),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 37*/ GIMT_Encode4(162435),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 38*/ GIMT_Encode4(162537),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 39*/ GIMT_Encode4(162639), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 40*/ GIMT_Encode4(162741),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 41*/ GIMT_Encode4(163036),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 42*/ GIMT_Encode4(163331),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 43*/ GIMT_Encode4(163681), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 44*/ GIMT_Encode4(164262), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 45*/ GIMT_Encode4(164532),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 46*/ GIMT_Encode4(167003),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 47*/ GIMT_Encode4(167167),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 48*/ GIMT_Encode4(167324),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 49*/ GIMT_Encode4(167587),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 50*/ GIMT_Encode4(167850),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 51*/ GIMT_Encode4(168097), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 52*/ GIMT_Encode4(168344),
     /*    626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 53*/ GIMT_Encode4(168636), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 54*/ GIMT_Encode4(168952),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 55*/ GIMT_Encode4(169032),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 56*/ GIMT_Encode4(169112),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 57*/ GIMT_Encode4(169694), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 58*/ GIMT_Encode4(170276),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 59*/ GIMT_Encode4(170456),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 60*/ GIMT_Encode4(170636),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 61*/ GIMT_Encode4(170816), GIMT_Encode4(0),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 62*/ GIMT_Encode4(170996),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 63*/ GIMT_Encode4(171298),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 64*/ GIMT_Encode4(171463), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 65*/ GIMT_Encode4(171479), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 66*/ GIMT_Encode4(171597), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 67*/ GIMT_Encode4(171775), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 68*/ GIMT_Encode4(171947),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 69*/ GIMT_Encode4(172119),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 70*/ GIMT_Encode4(172383),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 71*/ GIMT_Encode4(208389), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 72*/ GIMT_Encode4(208664),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 73*/ GIMT_Encode4(208881),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 74*/ GIMT_Encode4(209156),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 75*/ GIMT_Encode4(209368), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 76*/ GIMT_Encode4(209605),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 77*/ GIMT_Encode4(209875),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 78*/ GIMT_Encode4(210145),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 79*/ GIMT_Encode4(210415), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 80*/ GIMT_Encode4(210685),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 81*/ GIMT_Encode4(211243), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 82*/ GIMT_Encode4(211460),
     /*    954 */ // Label 0: @954
     /*    954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 92*/ GIMT_Encode4(1362),
     /*    965 */ /*GILLT_s1*//*Label 84*/ GIMT_Encode4(997),
     /*    969 */ /*GILLT_s32*//*Label 85*/ GIMT_Encode4(1020),
     /*    973 */ /*GILLT_s64*//*Label 86*/ GIMT_Encode4(1080),
     /*    977 */ /*GILLT_s128*//*Label 87*/ GIMT_Encode4(1140),
     /*    981 */ /*GILLT_v2s64*//*Label 88*/ GIMT_Encode4(1166),
     /*    985 */ /*GILLT_v4s32*//*Label 89*/ GIMT_Encode4(1192),
     /*    989 */ /*GILLT_v8s16*//*Label 90*/ GIMT_Encode4(1218),
     /*    993 */ /*GILLT_v16s8*//*Label 91*/ GIMT_Encode4(1336),
     /*    997 */ // Label 84: @997
     /*    997 */ GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1019), // Rule ID 3669 //
     /*   1002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1012 */   // (add:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1017 */   GIR_RootConstrainSelectedInstOperands,
     /*   1018 */   // GIR_Coverage, 3669,
     /*   1018 */   GIR_Done,
     /*   1019 */ // Label 93: @1019
     /*   1019 */ GIM_Reject,
     /*   1020 */ // Label 85: @1020
     /*   1020 */ GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1079),
     /*   1025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1035 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1066), // Rule ID 107 //
     /*   1040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1052 */     // MIs[1] Operand 1
     /*   1052 */     // No operand predicates
     /*   1052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1054 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (ADDI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*   1057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1059 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1064 */     GIR_RootConstrainSelectedInstOperands,
     /*   1065 */     // GIR_Coverage, 107,
     /*   1065 */     GIR_EraseRootFromParent_Done,
     /*   1066 */   // Label 95: @1066
     /*   1066 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1078), // Rule ID 199 //
     /*   1071 */     // (add:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADD4:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1071 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD4),
     /*   1076 */     GIR_RootConstrainSelectedInstOperands,
     /*   1077 */     // GIR_Coverage, 199,
     /*   1077 */     GIR_Done,
     /*   1078 */   // Label 96: @1078
     /*   1078 */   GIM_Reject,
     /*   1079 */ // Label 94: @1079
     /*   1079 */ GIM_Reject,
     /*   1080 */ // Label 86: @1080
     /*   1080 */ GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1139),
     /*   1085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1095 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1126), // Rule ID 663 //
     /*   1100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1112 */     // MIs[1] Operand 1
     /*   1112 */     // No operand predicates
     /*   1112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1114 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (ADDI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*   1117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1119 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1124 */     GIR_RootConstrainSelectedInstOperands,
     /*   1125 */     // GIR_Coverage, 663,
     /*   1125 */     GIR_EraseRootFromParent_Done,
     /*   1126 */   // Label 98: @1126
     /*   1126 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1138), // Rule ID 659 //
     /*   1131 */     // (add:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADD8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1131 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ADD8),
     /*   1136 */     GIR_RootConstrainSelectedInstOperands,
     /*   1137 */     // GIR_Coverage, 659,
     /*   1137 */     GIR_Done,
     /*   1138 */   // Label 99: @1138
     /*   1138 */   GIM_Reject,
     /*   1139 */ // Label 97: @1139
     /*   1139 */ GIM_Reject,
     /*   1140 */ // Label 87: @1140
     /*   1140 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1165), // Rule ID 470 //
     /*   1145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1158 */   // (add:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUQM),
     /*   1163 */   GIR_RootConstrainSelectedInstOperands,
     /*   1164 */   // GIR_Coverage, 470,
     /*   1164 */   GIR_Done,
     /*   1165 */ // Label 100: @1165
     /*   1165 */ GIM_Reject,
     /*   1166 */ // Label 88: @1166
     /*   1166 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1191), // Rule ID 469 //
     /*   1171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1184 */   // (add:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VADDUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUDM),
     /*   1189 */   GIR_RootConstrainSelectedInstOperands,
     /*   1190 */   // GIR_Coverage, 469,
     /*   1190 */   GIR_Done,
     /*   1191 */ // Label 101: @1191
     /*   1191 */ GIM_Reject,
     /*   1192 */ // Label 89: @1192
     /*   1192 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1217), // Rule ID 303 //
     /*   1197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1210 */   // (add:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWM),
     /*   1215 */   GIR_RootConstrainSelectedInstOperands,
     /*   1216 */   // GIR_Coverage, 303,
     /*   1216 */   GIR_Done,
     /*   1217 */ // Label 102: @1217
     /*   1217 */ GIM_Reject,
     /*   1218 */ // Label 90: @1218
     /*   1218 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1335),
     /*   1223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1233 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1276), // Rule ID 1296 //
     /*   1238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1259 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB), v8i16:{ *:[v8i16] }:$vC)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1272 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   1274 */     GIR_RootConstrainSelectedInstOperands,
     /*   1275 */     // GIR_Coverage, 1296,
     /*   1275 */     GIR_EraseRootFromParent_Done,
     /*   1276 */   // Label 104: @1276
     /*   1276 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1319), // Rule ID 4947 //
     /*   1281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   1292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1302 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vC, (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB))  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vC)
     /*   1302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   1305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   1311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   1317 */     GIR_RootConstrainSelectedInstOperands,
     /*   1318 */     // GIR_Coverage, 4947,
     /*   1318 */     GIR_EraseRootFromParent_Done,
     /*   1319 */   // Label 105: @1319
     /*   1319 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1334), // Rule ID 302 //
     /*   1324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1327 */     // (add:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHM),
     /*   1332 */     GIR_RootConstrainSelectedInstOperands,
     /*   1333 */     // GIR_Coverage, 302,
     /*   1333 */     GIR_Done,
     /*   1334 */   // Label 106: @1334
     /*   1334 */   GIM_Reject,
     /*   1335 */ // Label 103: @1335
     /*   1335 */ GIM_Reject,
     /*   1336 */ // Label 91: @1336
     /*   1336 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1361), // Rule ID 301 //
     /*   1341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1354 */   // (add:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1354 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBM),
     /*   1359 */   GIR_RootConstrainSelectedInstOperands,
     /*   1360 */   // GIR_Coverage, 301,
     /*   1360 */   GIR_Done,
     /*   1361 */ // Label 107: @1361
     /*   1361 */ GIM_Reject,
     /*   1362 */ // Label 92: @1362
     /*   1362 */ GIM_Reject,
     /*   1363 */ // Label 1: @1363
     /*   1363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 116*/ GIMT_Encode4(1803),
     /*   1374 */ /*GILLT_s1*//*Label 108*/ GIMT_Encode4(1406),
     /*   1378 */ /*GILLT_s32*//*Label 109*/ GIMT_Encode4(1429),
     /*   1382 */ /*GILLT_s64*//*Label 110*/ GIMT_Encode4(1514),
     /*   1386 */ /*GILLT_s128*//*Label 111*/ GIMT_Encode4(1599),
     /*   1390 */ /*GILLT_v2s64*//*Label 112*/ GIMT_Encode4(1625),
     /*   1394 */ /*GILLT_v4s32*//*Label 113*/ GIMT_Encode4(1688),
     /*   1398 */ /*GILLT_v8s16*//*Label 114*/ GIMT_Encode4(1751),
     /*   1402 */ /*GILLT_v16s8*//*Label 115*/ GIMT_Encode4(1777),
     /*   1406 */ // Label 108: @1406
     /*   1406 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(1428), // Rule ID 3670 //
     /*   1411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1421 */   // (sub:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*   1426 */   GIR_RootConstrainSelectedInstOperands,
     /*   1427 */   // GIR_Coverage, 3670,
     /*   1427 */   GIR_Done,
     /*   1428 */ // Label 117: @1428
     /*   1428 */ GIM_Reject,
     /*   1429 */ // Label 109: @1429
     /*   1429 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(1513),
     /*   1434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1444 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(1462), // Rule ID 211 //
     /*   1449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1453 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$RA)  =>  (NEG:{ *:[i32] } i32:{ *:[i32] }:$RA)
     /*   1453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*   1456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1458 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1460 */     GIR_RootConstrainSelectedInstOperands,
     /*   1461 */     // GIR_Coverage, 211,
     /*   1461 */     GIR_EraseRootFromParent_Done,
     /*   1462 */   // Label 119: @1462
     /*   1462 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(1496), // Rule ID 1217 //
     /*   1467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1479 */     // MIs[1] Operand 1
     /*   1479 */     // No operand predicates
     /*   1479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1481 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, i32:{ *:[i32] }:$in)  =>  (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)
     /*   1481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*   1484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1486 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1494 */     GIR_RootConstrainSelectedInstOperands,
     /*   1495 */     // GIR_Coverage, 1217,
     /*   1495 */     GIR_EraseRootFromParent_Done,
     /*   1496 */   // Label 120: @1496
     /*   1496 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(1512), // Rule ID 209 //
     /*   1501 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$RB, i32:{ *:[i32] }:$RA)  =>  (SUBF:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF),
     /*   1504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1506 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1508 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1510 */     GIR_RootConstrainSelectedInstOperands,
     /*   1511 */     // GIR_Coverage, 209,
     /*   1511 */     GIR_EraseRootFromParent_Done,
     /*   1512 */   // Label 121: @1512
     /*   1512 */   GIM_Reject,
     /*   1513 */ // Label 118: @1513
     /*   1513 */ GIM_Reject,
     /*   1514 */ // Label 110: @1514
     /*   1514 */ GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(1598),
     /*   1519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1529 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(1547), // Rule ID 669 //
     /*   1534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   1538 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$RA)  =>  (NEG8:{ *:[i64] } i64:{ *:[i64] }:$RA)
     /*   1538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*   1541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1543 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1545 */     GIR_RootConstrainSelectedInstOperands,
     /*   1546 */     // GIR_Coverage, 669,
     /*   1546 */     GIR_EraseRootFromParent_Done,
     /*   1547 */   // Label 123: @1547
     /*   1547 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(1581), // Rule ID 1539 //
     /*   1552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1564 */     // MIs[1] Operand 1
     /*   1564 */     // No operand predicates
     /*   1564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1566 */     // (sub:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, i64:{ *:[i64] }:$in)  =>  (SUBFIC8:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$in, (imm:{ *:[i64] }):$imm)
     /*   1566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBFIC8),
     /*   1569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1571 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*   1573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   1576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /*   1579 */     GIR_RootConstrainSelectedInstOperands,
     /*   1580 */     // GIR_Coverage, 1539,
     /*   1580 */     GIR_EraseRootFromParent_Done,
     /*   1581 */   // Label 124: @1581
     /*   1581 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(1597), // Rule ID 668 //
     /*   1586 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$RB, i64:{ *:[i64] }:$RA)  =>  (SUBF8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SUBF8),
     /*   1589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   1591 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*   1593 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*   1595 */     GIR_RootConstrainSelectedInstOperands,
     /*   1596 */     // GIR_Coverage, 668,
     /*   1596 */     GIR_EraseRootFromParent_Done,
     /*   1597 */   // Label 125: @1597
     /*   1597 */   GIM_Reject,
     /*   1598 */ // Label 122: @1598
     /*   1598 */ GIM_Reject,
     /*   1599 */ // Label 111: @1599
     /*   1599 */ GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(1624), // Rule ID 475 //
     /*   1604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   1610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   1613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1617 */   // (sub:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   1617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUQM),
     /*   1622 */   GIR_RootConstrainSelectedInstOperands,
     /*   1623 */   // GIR_Coverage, 475,
     /*   1623 */   GIR_Done,
     /*   1624 */ // Label 126: @1624
     /*   1624 */ GIM_Reject,
     /*   1625 */ // Label 112: @1625
     /*   1625 */ GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(1687),
     /*   1630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   1636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1640 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(1671), // Rule ID 542 //
     /*   1645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1662 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VNEGD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*   1662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGD),
     /*   1665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1667 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1669 */     GIR_RootConstrainSelectedInstOperands,
     /*   1670 */     // GIR_Coverage, 542,
     /*   1670 */     GIR_EraseRootFromParent_Done,
     /*   1671 */   // Label 128: @1671
     /*   1671 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(1686), // Rule ID 474 //
     /*   1676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   1679 */     // (sub:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VSUBUDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   1679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUDM),
     /*   1684 */     GIR_RootConstrainSelectedInstOperands,
     /*   1685 */     // GIR_Coverage, 474,
     /*   1685 */     GIR_Done,
     /*   1686 */   // Label 129: @1686
     /*   1686 */   GIM_Reject,
     /*   1687 */ // Label 127: @1687
     /*   1687 */ GIM_Reject,
     /*   1688 */ // Label 113: @1688
     /*   1688 */ GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(1750),
     /*   1693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   1696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   1699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1703 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(1734), // Rule ID 541 //
     /*   1708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*   1711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   1721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*   1723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1725 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VNEGW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*   1725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNEGW),
     /*   1728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   1730 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*   1732 */     GIR_RootConstrainSelectedInstOperands,
     /*   1733 */     // GIR_Coverage, 541,
     /*   1733 */     GIR_EraseRootFromParent_Done,
     /*   1734 */   // Label 131: @1734
     /*   1734 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(1749), // Rule ID 373 //
     /*   1739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1742 */     // (sub:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   1742 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWM),
     /*   1747 */     GIR_RootConstrainSelectedInstOperands,
     /*   1748 */     // GIR_Coverage, 373,
     /*   1748 */     GIR_Done,
     /*   1749 */   // Label 132: @1749
     /*   1749 */   GIM_Reject,
     /*   1750 */ // Label 130: @1750
     /*   1750 */ GIM_Reject,
     /*   1751 */ // Label 114: @1751
     /*   1751 */ GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(1776), // Rule ID 372 //
     /*   1756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   1762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   1765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1769 */   // (sub:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*   1769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHM),
     /*   1774 */   GIR_RootConstrainSelectedInstOperands,
     /*   1775 */   // GIR_Coverage, 372,
     /*   1775 */   GIR_Done,
     /*   1776 */ // Label 133: @1776
     /*   1776 */ GIM_Reject,
     /*   1777 */ // Label 115: @1777
     /*   1777 */ GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(1802), // Rule ID 371 //
     /*   1782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   1785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   1788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   1791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   1795 */   // (sub:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*   1795 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBM),
     /*   1800 */   GIR_RootConstrainSelectedInstOperands,
     /*   1801 */   // GIR_Coverage, 371,
     /*   1801 */   GIR_Done,
     /*   1802 */ // Label 134: @1802
     /*   1802 */ GIM_Reject,
     /*   1803 */ // Label 116: @1803
     /*   1803 */ GIM_Reject,
     /*   1804 */ // Label 2: @1804
     /*   1804 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(7), /*)*//*default:*//*Label 141*/ GIMT_Encode4(2085),
     /*   1815 */ /*GILLT_s1*//*Label 135*/ GIMT_Encode4(1843),
     /*   1819 */ /*GILLT_s32*//*Label 136*/ GIMT_Encode4(1866),
     /*   1823 */ /*GILLT_s64*//*Label 137*/ GIMT_Encode4(1926), GIMT_Encode4(0),
     /*   1831 */ /*GILLT_v2s64*//*Label 138*/ GIMT_Encode4(1986),
     /*   1835 */ /*GILLT_v4s32*//*Label 139*/ GIMT_Encode4(2012),
     /*   1839 */ /*GILLT_v8s16*//*Label 140*/ GIMT_Encode4(2038),
     /*   1843 */ // Label 135: @1843
     /*   1843 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(1865), // Rule ID 3671 //
     /*   1848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   1851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   1854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   1858 */   // (mul:{ *:[i1] } i1:{ *:[i1] }:$a, i1:{ *:[i1] }:$b)  =>  (CRAND:{ *:[i1] } ?:{ *:[i1] }:$a, ?:{ *:[i1] }:$b)
     /*   1858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   1863 */   GIR_RootConstrainSelectedInstOperands,
     /*   1864 */   // GIR_Coverage, 3671,
     /*   1864 */   GIR_Done,
     /*   1865 */ // Label 142: @1865
     /*   1865 */ GIM_Reject,
     /*   1866 */ // Label 136: @1866
     /*   1866 */ GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(1925),
     /*   1871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   1881 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(1912), // Rule ID 111 //
     /*   1886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*   1898 */     // MIs[1] Operand 1
     /*   1898 */     // No operand predicates
     /*   1898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1900 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D)  =>  (MULLI:{ *:[i32] } i32:{ *:[i32] }:$RA, (imm:{ *:[i32] }):$D)
     /*   1900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI),
     /*   1903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1905 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1910 */     GIR_RootConstrainSelectedInstOperands,
     /*   1911 */     // GIR_Coverage, 111,
     /*   1911 */     GIR_EraseRootFromParent_Done,
     /*   1912 */   // Label 144: @1912
     /*   1912 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(1924), // Rule ID 208 //
     /*   1917 */     // (mul:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULLW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   1917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLW),
     /*   1922 */     GIR_RootConstrainSelectedInstOperands,
     /*   1923 */     // GIR_Coverage, 208,
     /*   1923 */     GIR_Done,
     /*   1924 */   // Label 145: @1924
     /*   1924 */   GIM_Reject,
     /*   1925 */ // Label 143: @1925
     /*   1925 */ GIM_Reject,
     /*   1926 */ // Label 137: @1926
     /*   1926 */ GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(1985),
     /*   1931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   1934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   1937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   1941 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(1972), // Rule ID 706 //
     /*   1946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   1954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*   1958 */     // MIs[1] Operand 1
     /*   1958 */     // No operand predicates
     /*   1958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1960 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D)  =>  (MULLI8:{ *:[i64] } i64:{ *:[i64] }:$RA, (imm:{ *:[i64] }):$D)
     /*   1960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULLI8),
     /*   1963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*   1965 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*   1967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*   1970 */     GIR_RootConstrainSelectedInstOperands,
     /*   1971 */     // GIR_Coverage, 706,
     /*   1971 */     GIR_EraseRootFromParent_Done,
     /*   1972 */   // Label 147: @1972
     /*   1972 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(1984), // Rule ID 705 //
     /*   1977 */     // (mul:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULLD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   1977 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULLD),
     /*   1982 */     GIR_RootConstrainSelectedInstOperands,
     /*   1983 */     // GIR_Coverage, 705,
     /*   1983 */     GIR_Done,
     /*   1984 */   // Label 148: @1984
     /*   1984 */   GIM_Reject,
     /*   1985 */ // Label 146: @1985
     /*   1985 */ GIM_Reject,
     /*   1986 */ // Label 138: @1986
     /*   1986 */ GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2011), // Rule ID 1124 //
     /*   1991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   1994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   1997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2004 */   // (mul:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULLD),
     /*   2009 */   GIR_RootConstrainSelectedInstOperands,
     /*   2010 */   // GIR_Coverage, 1124,
     /*   2010 */   GIR_Done,
     /*   2011 */ // Label 149: @2011
     /*   2011 */ GIM_Reject,
     /*   2012 */ // Label 139: @2012
     /*   2012 */ GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2037), // Rule ID 461 //
     /*   2017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*   2020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2030 */   // (mul:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULUWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULUWM),
     /*   2035 */   GIR_RootConstrainSelectedInstOperands,
     /*   2036 */   // GIR_Coverage, 461,
     /*   2036 */   GIR_Done,
     /*   2037 */ // Label 150: @2037
     /*   2037 */ GIM_Reject,
     /*   2038 */ // Label 140: @2038
     /*   2038 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2084), // Rule ID 1295 //
     /*   2043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   2046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   2049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   2052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2056 */   // (mul:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VMLADDUHM:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB, (V_SET0H:{ *:[v8i16] }))
     /*   2056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*   2059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::V_SET0H),
     /*   2063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   2068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   2070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*   2073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*   2075 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   2077 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /*   2079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   2082 */   GIR_RootConstrainSelectedInstOperands,
     /*   2083 */   // GIR_Coverage, 1295,
     /*   2083 */   GIR_EraseRootFromParent_Done,
     /*   2084 */ // Label 151: @2084
     /*   2084 */ GIM_Reject,
     /*   2085 */ // Label 141: @2085
     /*   2085 */ GIM_Reject,
     /*   2086 */ // Label 3: @2086
     /*   2086 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 157*/ GIMT_Encode4(2241),
     /*   2097 */ /*GILLT_s32*//*Label 152*/ GIMT_Encode4(2117),
     /*   2101 */ /*GILLT_s64*//*Label 153*/ GIMT_Encode4(2140),
     /*   2105 */ /*GILLT_s128*//*Label 154*/ GIMT_Encode4(2163),
     /*   2109 */ /*GILLT_v2s64*//*Label 155*/ GIMT_Encode4(2189),
     /*   2113 */ /*GILLT_v4s32*//*Label 156*/ GIMT_Encode4(2215),
     /*   2117 */ // Label 152: @2117
     /*   2117 */ GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(2139), // Rule ID 202 //
     /*   2122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2132 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVW),
     /*   2137 */   GIR_RootConstrainSelectedInstOperands,
     /*   2138 */   // GIR_Coverage, 202,
     /*   2138 */   GIR_Done,
     /*   2139 */ // Label 158: @2139
     /*   2139 */ GIM_Reject,
     /*   2140 */ // Label 153: @2140
     /*   2140 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(2162), // Rule ID 697 //
     /*   2145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2155 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2155 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVD),
     /*   2160 */   GIR_RootConstrainSelectedInstOperands,
     /*   2161 */   // GIR_Coverage, 697,
     /*   2161 */   GIR_Done,
     /*   2162 */ // Label 159: @2162
     /*   2162 */ GIM_Reject,
     /*   2163 */ // Label 154: @2163
     /*   2163 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(2188), // Rule ID 1148 //
     /*   2168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2181 */   // (sdiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSQ),
     /*   2186 */   GIR_RootConstrainSelectedInstOperands,
     /*   2187 */   // GIR_Coverage, 1148,
     /*   2187 */   GIR_Done,
     /*   2188 */ // Label 160: @2188
     /*   2188 */ GIM_Reject,
     /*   2189 */ // Label 155: @2189
     /*   2189 */ GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(2214), // Rule ID 1135 //
     /*   2194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2207 */   // (sdiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSD),
     /*   2212 */   GIR_RootConstrainSelectedInstOperands,
     /*   2213 */   // GIR_Coverage, 1135,
     /*   2213 */   GIR_Done,
     /*   2214 */ // Label 161: @2214
     /*   2214 */ GIM_Reject,
     /*   2215 */ // Label 156: @2215
     /*   2215 */ GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(2240), // Rule ID 1133 //
     /*   2220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2233 */   // (sdiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVSW),
     /*   2238 */   GIR_RootConstrainSelectedInstOperands,
     /*   2239 */   // GIR_Coverage, 1133,
     /*   2239 */   GIR_Done,
     /*   2240 */ // Label 162: @2240
     /*   2240 */ GIM_Reject,
     /*   2241 */ // Label 157: @2241
     /*   2241 */ GIM_Reject,
     /*   2242 */ // Label 4: @2242
     /*   2242 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 168*/ GIMT_Encode4(2397),
     /*   2253 */ /*GILLT_s32*//*Label 163*/ GIMT_Encode4(2273),
     /*   2257 */ /*GILLT_s64*//*Label 164*/ GIMT_Encode4(2296),
     /*   2261 */ /*GILLT_s128*//*Label 165*/ GIMT_Encode4(2319),
     /*   2265 */ /*GILLT_v2s64*//*Label 166*/ GIMT_Encode4(2345),
     /*   2269 */ /*GILLT_v4s32*//*Label 167*/ GIMT_Encode4(2371),
     /*   2273 */ // Label 163: @2273
     /*   2273 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2295), // Rule ID 203 //
     /*   2278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2288 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (DIVWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2288 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVWU),
     /*   2293 */   GIR_RootConstrainSelectedInstOperands,
     /*   2294 */   // GIR_Coverage, 203,
     /*   2294 */   GIR_Done,
     /*   2295 */ // Label 169: @2295
     /*   2295 */ GIM_Reject,
     /*   2296 */ // Label 164: @2296
     /*   2296 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2318), // Rule ID 698 //
     /*   2301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2311 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (DIVDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2311 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::DIVDU),
     /*   2316 */   GIR_RootConstrainSelectedInstOperands,
     /*   2317 */   // GIR_Coverage, 698,
     /*   2317 */   GIR_Done,
     /*   2318 */ // Label 170: @2318
     /*   2318 */ GIM_Reject,
     /*   2319 */ // Label 165: @2319
     /*   2319 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2344), // Rule ID 1149 //
     /*   2324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2337 */   // (udiv:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2337 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUQ),
     /*   2342 */   GIR_RootConstrainSelectedInstOperands,
     /*   2343 */   // GIR_Coverage, 1149,
     /*   2343 */   GIR_Done,
     /*   2344 */ // Label 171: @2344
     /*   2344 */ GIM_Reject,
     /*   2345 */ // Label 166: @2345
     /*   2345 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2370), // Rule ID 1136 //
     /*   2350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2363 */   // (udiv:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2363 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUD),
     /*   2368 */   GIR_RootConstrainSelectedInstOperands,
     /*   2369 */   // GIR_Coverage, 1136,
     /*   2369 */   GIR_Done,
     /*   2370 */ // Label 172: @2370
     /*   2370 */ GIM_Reject,
     /*   2371 */ // Label 167: @2371
     /*   2371 */ GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2396), // Rule ID 1134 //
     /*   2376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2389 */   // (udiv:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VDIVUW),
     /*   2394 */   GIR_RootConstrainSelectedInstOperands,
     /*   2395 */   // GIR_Coverage, 1134,
     /*   2395 */   GIR_Done,
     /*   2396 */ // Label 173: @2396
     /*   2396 */ GIM_Reject,
     /*   2397 */ // Label 168: @2397
     /*   2397 */ GIM_Reject,
     /*   2398 */ // Label 5: @2398
     /*   2398 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 179*/ GIMT_Encode4(2559),
     /*   2409 */ /*GILLT_s32*//*Label 174*/ GIMT_Encode4(2429),
     /*   2413 */ /*GILLT_s64*//*Label 175*/ GIMT_Encode4(2455),
     /*   2417 */ /*GILLT_s128*//*Label 176*/ GIMT_Encode4(2481),
     /*   2421 */ /*GILLT_v2s64*//*Label 177*/ GIMT_Encode4(2507),
     /*   2425 */ /*GILLT_v4s32*//*Label 178*/ GIMT_Encode4(2533),
     /*   2429 */ // Label 174: @2429
     /*   2429 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(2454), // Rule ID 197 //
     /*   2434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2447 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODSW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSW),
     /*   2452 */   GIR_RootConstrainSelectedInstOperands,
     /*   2453 */   // GIR_Coverage, 197,
     /*   2453 */   GIR_Done,
     /*   2454 */ // Label 180: @2454
     /*   2454 */ GIM_Reject,
     /*   2455 */ // Label 175: @2455
     /*   2455 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2480), // Rule ID 702 //
     /*   2460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2473 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODSD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODSD),
     /*   2478 */   GIR_RootConstrainSelectedInstOperands,
     /*   2479 */   // GIR_Coverage, 702,
     /*   2479 */   GIR_Done,
     /*   2480 */ // Label 181: @2480
     /*   2480 */ GIM_Reject,
     /*   2481 */ // Label 176: @2481
     /*   2481 */ GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(2506), // Rule ID 1158 //
     /*   2486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2499 */   // (srem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODSQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSQ),
     /*   2504 */   GIR_RootConstrainSelectedInstOperands,
     /*   2505 */   // GIR_Coverage, 1158,
     /*   2505 */   GIR_Done,
     /*   2506 */ // Label 182: @2506
     /*   2506 */ GIM_Reject,
     /*   2507 */ // Label 177: @2507
     /*   2507 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(2532), // Rule ID 1131 //
     /*   2512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2525 */   // (srem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSD),
     /*   2530 */   GIR_RootConstrainSelectedInstOperands,
     /*   2531 */   // GIR_Coverage, 1131,
     /*   2531 */   GIR_Done,
     /*   2532 */ // Label 183: @2532
     /*   2532 */ GIM_Reject,
     /*   2533 */ // Label 178: @2533
     /*   2533 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(2558), // Rule ID 1129 //
     /*   2538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2551 */   // (srem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODSW),
     /*   2556 */   GIR_RootConstrainSelectedInstOperands,
     /*   2557 */   // GIR_Coverage, 1129,
     /*   2557 */   GIR_Done,
     /*   2558 */ // Label 184: @2558
     /*   2558 */ GIM_Reject,
     /*   2559 */ // Label 179: @2559
     /*   2559 */ GIM_Reject,
     /*   2560 */ // Label 6: @2560
     /*   2560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 190*/ GIMT_Encode4(2721),
     /*   2571 */ /*GILLT_s32*//*Label 185*/ GIMT_Encode4(2591),
     /*   2575 */ /*GILLT_s64*//*Label 186*/ GIMT_Encode4(2617),
     /*   2579 */ /*GILLT_s128*//*Label 187*/ GIMT_Encode4(2643),
     /*   2583 */ /*GILLT_v2s64*//*Label 188*/ GIMT_Encode4(2669),
     /*   2587 */ /*GILLT_v4s32*//*Label 189*/ GIMT_Encode4(2695),
     /*   2591 */ // Label 185: @2591
     /*   2591 */ GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(2616), // Rule ID 198 //
     /*   2596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2609 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MODUW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*   2609 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUW),
     /*   2614 */   GIR_RootConstrainSelectedInstOperands,
     /*   2615 */   // GIR_Coverage, 198,
     /*   2615 */   GIR_Done,
     /*   2616 */ // Label 191: @2616
     /*   2616 */ GIM_Reject,
     /*   2617 */ // Label 186: @2617
     /*   2617 */ GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(2642), // Rule ID 703 //
     /*   2622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*   2625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2635 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MODUD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*   2635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MODUD),
     /*   2640 */   GIR_RootConstrainSelectedInstOperands,
     /*   2641 */   // GIR_Coverage, 703,
     /*   2641 */   GIR_Done,
     /*   2642 */ // Label 192: @2642
     /*   2642 */ GIM_Reject,
     /*   2643 */ // Label 187: @2643
     /*   2643 */ GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(2668), // Rule ID 1159 //
     /*   2648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*   2654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*   2657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2661 */   // (urem:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VMODUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*   2661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUQ),
     /*   2666 */   GIR_RootConstrainSelectedInstOperands,
     /*   2667 */   // GIR_Coverage, 1159,
     /*   2667 */   GIR_Done,
     /*   2668 */ // Label 193: @2668
     /*   2668 */ GIM_Reject,
     /*   2669 */ // Label 188: @2669
     /*   2669 */ GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(2694), // Rule ID 1132 //
     /*   2674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   2680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   2683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2687 */   // (urem:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMODUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*   2687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUD),
     /*   2692 */   GIR_RootConstrainSelectedInstOperands,
     /*   2693 */   // GIR_Coverage, 1132,
     /*   2693 */   GIR_Done,
     /*   2694 */ // Label 194: @2694
     /*   2694 */ GIM_Reject,
     /*   2695 */ // Label 189: @2695
     /*   2695 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(2720), // Rule ID 1130 //
     /*   2700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*   2703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   2706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   2709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   2713 */   // (urem:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMODUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   2713 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMODUW),
     /*   2718 */   GIR_RootConstrainSelectedInstOperands,
     /*   2719 */   // GIR_Coverage, 1130,
     /*   2719 */   GIR_Done,
     /*   2720 */ // Label 195: @2720
     /*   2720 */ GIM_Reject,
     /*   2721 */ // Label 190: @2721
     /*   2721 */ GIM_Reject,
     /*   2722 */ // Label 7: @2722
     /*   2722 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 200*/ GIMT_Encode4(5282),
     /*   2733 */ /*GILLT_s1*//*Label 196*/ GIMT_Encode4(2757),
     /*   2737 */ /*GILLT_s32*//*Label 197*/ GIMT_Encode4(2866),
     /*   2741 */ /*GILLT_s64*//*Label 198*/ GIMT_Encode4(2975), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   2753 */ /*GILLT_v4s32*//*Label 199*/ GIMT_Encode4(3084),
     /*   2757 */ // Label 196: @2757
     /*   2757 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(2865),
     /*   2762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   2765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   2768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   2772 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(2812), // Rule ID 4924 //
     /*   2777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2799 */     // (and:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2804 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   2806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2810 */     GIR_RootConstrainSelectedInstOperands,
     /*   2811 */     // GIR_Coverage, 4924,
     /*   2811 */     GIR_EraseRootFromParent_Done,
     /*   2812 */   // Label 202: @2812
     /*   2812 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(2852), // Rule ID 182 //
     /*   2817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   2829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   2833 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2839 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRANDC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /*   2842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   2844 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   2846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   2850 */     GIR_RootConstrainSelectedInstOperands,
     /*   2851 */     // GIR_Coverage, 182,
     /*   2851 */     GIR_EraseRootFromParent_Done,
     /*   2852 */   // Label 203: @2852
     /*   2852 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(2864), // Rule ID 175 //
     /*   2857 */     // (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   2857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /*   2862 */     GIR_RootConstrainSelectedInstOperands,
     /*   2863 */     // GIR_Coverage, 175,
     /*   2863 */     GIR_Done,
     /*   2864 */   // Label 204: @2864
     /*   2864 */   GIM_Reject,
     /*   2865 */ // Label 201: @2865
     /*   2865 */ GIM_Reject,
     /*   2866 */ // Label 197: @2866
     /*   2866 */ GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(2974),
     /*   2871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   2874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   2877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   2881 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(2921), // Rule ID 4918 //
     /*   2886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2902 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2908 */     // (and:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2913 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   2915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2919 */     GIR_RootConstrainSelectedInstOperands,
     /*   2920 */     // GIR_Coverage, 4918,
     /*   2920 */     GIR_EraseRootFromParent_Done,
     /*   2921 */   // Label 206: @2921
     /*   2921 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(2961), // Rule ID 123 //
     /*   2926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   2934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2942 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   2946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   2948 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ANDC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*   2951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   2953 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   2955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   2959 */     GIR_RootConstrainSelectedInstOperands,
     /*   2960 */     // GIR_Coverage, 123,
     /*   2960 */     GIR_EraseRootFromParent_Done,
     /*   2961 */   // Label 207: @2961
     /*   2961 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(2973), // Rule ID 122 //
     /*   2966 */     // (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (AND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   2966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*   2971 */     GIR_RootConstrainSelectedInstOperands,
     /*   2972 */     // GIR_Coverage, 122,
     /*   2972 */     GIR_Done,
     /*   2973 */   // Label 208: @2973
     /*   2973 */   GIM_Reject,
     /*   2974 */ // Label 205: @2974
     /*   2974 */ GIM_Reject,
     /*   2975 */ // Label 198: @2975
     /*   2975 */ GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(3083),
     /*   2980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   2983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   2986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   2990 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(3030), // Rule ID 4931 //
     /*   2995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3017 */     // (and:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3022 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   3024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3028 */     GIR_RootConstrainSelectedInstOperands,
     /*   3029 */     // GIR_Coverage, 4931,
     /*   3029 */     GIR_EraseRootFromParent_Done,
     /*   3030 */   // Label 210: @3030
     /*   3030 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(3070), // Rule ID 647 //
     /*   3035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   3051 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   3055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   3057 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ANDC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*   3060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   3062 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   3064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   3068 */     GIR_RootConstrainSelectedInstOperands,
     /*   3069 */     // GIR_Coverage, 647,
     /*   3069 */     GIR_EraseRootFromParent_Done,
     /*   3070 */   // Label 211: @3070
     /*   3070 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(3082), // Rule ID 646 //
     /*   3075 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (AND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   3075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*   3080 */     GIR_RootConstrainSelectedInstOperands,
     /*   3081 */     // GIR_Coverage, 646,
     /*   3081 */     GIR_Done,
     /*   3082 */   // Label 212: @3082
     /*   3082 */   GIM_Reject,
     /*   3083 */ // Label 209: @3083
     /*   3083 */ GIM_Reject,
     /*   3084 */ // Label 199: @3084
     /*   3084 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5281),
     /*   3089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3095 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(3173), // Rule ID 5279 //
     /*   3100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3143 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3153 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   3166 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3171 */     GIR_RootConstrainSelectedInstOperands,
     /*   3172 */     // GIR_Coverage, 5279,
     /*   3172 */     GIR_EraseRootFromParent_Done,
     /*   3173 */   // Label 214: @3173
     /*   3173 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(3251), // Rule ID 5280 //
     /*   3178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3221 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3227 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3229 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3231 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3244 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   3246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3249 */     GIR_RootConstrainSelectedInstOperands,
     /*   3250 */     // GIR_Coverage, 5280,
     /*   3250 */     GIR_EraseRootFromParent_Done,
     /*   3251 */   // Label 215: @3251
     /*   3251 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(3331), // Rule ID 5281 //
     /*   3256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3299 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3309 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3329 */     GIR_RootConstrainSelectedInstOperands,
     /*   3330 */     // GIR_Coverage, 5281,
     /*   3330 */     GIR_EraseRootFromParent_Done,
     /*   3331 */   // Label 216: @3331
     /*   3331 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(3411), // Rule ID 5284 //
     /*   3336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   3363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3379 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3389 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   3398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   3402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3409 */     GIR_RootConstrainSelectedInstOperands,
     /*   3410 */     // GIR_Coverage, 5284,
     /*   3410 */     GIR_EraseRootFromParent_Done,
     /*   3411 */   // Label 217: @3411
     /*   3411 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(3489), // Rule ID 4968 //
     /*   3416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3451 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3459 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3467 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3469 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   3469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3474 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3487 */     GIR_RootConstrainSelectedInstOperands,
     /*   3488 */     // GIR_Coverage, 4968,
     /*   3488 */     GIR_EraseRootFromParent_Done,
     /*   3489 */   // Label 218: @3489
     /*   3489 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(3567), // Rule ID 4962 //
     /*   3494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3537 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3547 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   3547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3552 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   3565 */     GIR_RootConstrainSelectedInstOperands,
     /*   3566 */     // GIR_Coverage, 4962,
     /*   3566 */     GIR_EraseRootFromParent_Done,
     /*   3567 */   // Label 219: @3567
     /*   3567 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(3645), // Rule ID 4966 //
     /*   3572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3623 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3625 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3630 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   3640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3643 */     GIR_RootConstrainSelectedInstOperands,
     /*   3644 */     // GIR_Coverage, 4966,
     /*   3644 */     GIR_EraseRootFromParent_Done,
     /*   3645 */   // Label 220: @3645
     /*   3645 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(3723), // Rule ID 4965 //
     /*   3650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3693 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3701 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3703 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3708 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   3718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3721 */     GIR_RootConstrainSelectedInstOperands,
     /*   3722 */     // GIR_Coverage, 4965,
     /*   3722 */     GIR_EraseRootFromParent_Done,
     /*   3723 */   // Label 221: @3723
     /*   3723 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(3801), // Rule ID 4967 //
     /*   3728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   3771 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   3779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3781 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   3781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3786 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   3788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   3792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   3796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   3799 */     GIR_RootConstrainSelectedInstOperands,
     /*   3800 */     // GIR_Coverage, 4967,
     /*   3800 */     GIR_EraseRootFromParent_Done,
     /*   3801 */   // Label 222: @3801
     /*   3801 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(3881), // Rule ID 3405 //
     /*   3806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3833 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*   3849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3853 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3859 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   3859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   3879 */     GIR_RootConstrainSelectedInstOperands,
     /*   3880 */     // GIR_Coverage, 3405,
     /*   3880 */     GIR_EraseRootFromParent_Done,
     /*   3881 */   // Label 223: @3881
     /*   3881 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(3961), // Rule ID 3406 //
     /*   3886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3913 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   3921 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   3925 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*   3929 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3933 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3939 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 112:{ *:[i32] })
     /*   3939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   3942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   3944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   3948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   3952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   3956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/112,
     /*   3959 */     GIR_RootConstrainSelectedInstOperands,
     /*   3960 */     // GIR_Coverage, 3406,
     /*   3960 */     GIR_EraseRootFromParent_Done,
     /*   3961 */   // Label 224: @3961
     /*   3961 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4041), // Rule ID 3404 //
     /*   3966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   3969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   3973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   3981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   3985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   3989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   3993 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   3999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   4005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4019 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*   4032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*   4036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4039 */     GIR_RootConstrainSelectedInstOperands,
     /*   4040 */     // GIR_Coverage, 3404,
     /*   4040 */     GIR_EraseRootFromParent_Done,
     /*   4041 */   // Label 225: @4041
     /*   4041 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4121), // Rule ID 5278 //
     /*   4046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   4073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4081 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4089 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4095 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4099 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 96:{ *:[i32] })
     /*   4099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/96,
     /*   4119 */     GIR_RootConstrainSelectedInstOperands,
     /*   4120 */     // GIR_Coverage, 5278,
     /*   4120 */     GIR_EraseRootFromParent_Done,
     /*   4121 */   // Label 226: @4121
     /*   4121 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4199), // Rule ID 5282 //
     /*   4126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4169 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4175 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4179 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4192 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4197 */     GIR_RootConstrainSelectedInstOperands,
     /*   4198 */     // GIR_Coverage, 5282,
     /*   4198 */     GIR_EraseRootFromParent_Done,
     /*   4199 */   // Label 227: @4199
     /*   4199 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4277), // Rule ID 5283 //
     /*   4204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4247 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4253 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4255 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4257 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 16:{ *:[i32] })
     /*   4257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   4266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4270 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*   4272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*   4275 */     GIR_RootConstrainSelectedInstOperands,
     /*   4276 */     // GIR_Coverage, 5283,
     /*   4276 */     GIR_EraseRootFromParent_Done,
     /*   4277 */   // Label 228: @4277
     /*   4277 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4355), // Rule ID 3392 //
     /*   4282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4333 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4335 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 14:{ *:[i32] })
     /*   4335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4340 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4353 */     GIR_RootConstrainSelectedInstOperands,
     /*   4354 */     // GIR_Coverage, 3392,
     /*   4354 */     GIR_EraseRootFromParent_Done,
     /*   4355 */   // Label 229: @4355
     /*   4355 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4433), // Rule ID 3390 //
     /*   4360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4403 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4409 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4413 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 8:{ *:[i32] })
     /*   4413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4418 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*   4431 */     GIR_RootConstrainSelectedInstOperands,
     /*   4432 */     // GIR_Coverage, 3390,
     /*   4432 */     GIR_EraseRootFromParent_Done,
     /*   4433 */   // Label 230: @4433
     /*   4433 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4511), // Rule ID 4963 //
     /*   4438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4477 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4481 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4487 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4491 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4496 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4509 */     GIR_RootConstrainSelectedInstOperands,
     /*   4510 */     // GIR_Coverage, 4963,
     /*   4510 */     GIR_EraseRootFromParent_Done,
     /*   4511 */   // Label 231: @4511
     /*   4511 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4589), // Rule ID 3391 //
     /*   4516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4559 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4569 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4574 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   4584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4587 */     GIR_RootConstrainSelectedInstOperands,
     /*   4588 */     // GIR_Coverage, 3391,
     /*   4588 */     GIR_EraseRootFromParent_Done,
     /*   4589 */   // Label 232: @4589
     /*   4589 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(4667), // Rule ID 4964 //
     /*   4594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*   4637 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4643 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*   4645 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4647 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 9:{ *:[i32] })
     /*   4647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4652 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   4658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*   4662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /*   4665 */     GIR_RootConstrainSelectedInstOperands,
     /*   4666 */     // GIR_Coverage, 4964,
     /*   4666 */     GIR_EraseRootFromParent_Done,
     /*   4667 */   // Label 233: @4667
     /*   4667 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(4722), // Rule ID 4939 //
     /*   4672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4699 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4709 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4714 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*   4716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4720 */     GIR_RootConstrainSelectedInstOperands,
     /*   4721 */     // GIR_Coverage, 4939,
     /*   4721 */     GIR_EraseRootFromParent_Done,
     /*   4722 */   // Label 234: @4722
     /*   4722 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(4777), // Rule ID 933 //
     /*   4727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   4730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   4754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   4760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   4762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4764 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   4764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLANDC),
     /*   4767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4769 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*   4771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*   4775 */     GIR_RootConstrainSelectedInstOperands,
     /*   4776 */     // GIR_Coverage, 933,
     /*   4776 */     GIR_EraseRootFromParent_Done,
     /*   4777 */   // Label 235: @4777
     /*   4777 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(4827), // Rule ID 4959 //
     /*   4782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4807 */     // (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*   4816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   4820 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*   4822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4825 */     GIR_RootConstrainSelectedInstOperands,
     /*   4826 */     // GIR_Coverage, 4959,
     /*   4826 */     GIR_EraseRootFromParent_Done,
     /*   4827 */   // Label 236: @4827
     /*   4827 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(4877), // Rule ID 4961 //
     /*   4832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4857 */     // (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   4857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4862 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   4875 */     GIR_RootConstrainSelectedInstOperands,
     /*   4876 */     // GIR_Coverage, 4961,
     /*   4876 */     GIR_EraseRootFromParent_Done,
     /*   4877 */   // Label 237: @4877
     /*   4877 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(4927), // Rule ID 4960 //
     /*   4882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   4897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4907 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   4907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4912 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*   4914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   4925 */     GIR_RootConstrainSelectedInstOperands,
     /*   4926 */     // GIR_Coverage, 4960,
     /*   4926 */     GIR_EraseRootFromParent_Done,
     /*   4927 */   // Label 238: @4927
     /*   4927 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(4977), // Rule ID 3387 //
     /*   4932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   4947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4957 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 1:{ *:[i32] })
     /*   4957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   4960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   4962 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   4964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   4968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   4972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   4975 */     GIR_RootConstrainSelectedInstOperands,
     /*   4976 */     // GIR_Coverage, 3387,
     /*   4976 */     GIR_EraseRootFromParent_Done,
     /*   4977 */   // Label 239: @4977
     /*   4977 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(5027), // Rule ID 3389 //
     /*   4982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   4985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   4989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*   4997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5007 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 7:{ *:[i32] })
     /*   5007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5012 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*   5025 */     GIR_RootConstrainSelectedInstOperands,
     /*   5026 */     // GIR_Coverage, 3389,
     /*   5026 */     GIR_EraseRootFromParent_Done,
     /*   5027 */   // Label 240: @5027
     /*   5027 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(5077), // Rule ID 3388 //
     /*   5032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5057 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 6:{ *:[i32] })
     /*   5057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5062 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*   5064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*   5068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   5075 */     GIR_RootConstrainSelectedInstOperands,
     /*   5076 */     // GIR_Coverage, 3388,
     /*   5076 */     GIR_EraseRootFromParent_Done,
     /*   5077 */   // Label 241: @5077
     /*   5077 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(5096), // Rule ID 932 //
     /*   5082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*   5085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5089 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*   5089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLAND),
     /*   5094 */     GIR_RootConstrainSelectedInstOperands,
     /*   5095 */     // GIR_Coverage, 932,
     /*   5095 */     GIR_Done,
     /*   5096 */   // Label 242: @5096
     /*   5096 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(5151), // Rule ID 4927 //
     /*   5101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5128 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5134 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5138 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5143 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*   5145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5149 */     GIR_RootConstrainSelectedInstOperands,
     /*   5150 */     // GIR_Coverage, 4927,
     /*   5150 */     GIR_EraseRootFromParent_Done,
     /*   5151 */   // Label 243: @5151
     /*   5151 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(5206), // Rule ID 312 //
     /*   5156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5183 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5193 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5198 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*   5200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*   5204 */     GIR_RootConstrainSelectedInstOperands,
     /*   5205 */     // GIR_Coverage, 312,
     /*   5205 */     GIR_EraseRootFromParent_Done,
     /*   5206 */   // Label 244: @5206
     /*   5206 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(5261), // Rule ID 1384 //
     /*   5211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   5238 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*   5246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5248 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, immAllOnesV:{ *:[v4i32] }))  =>  (VANDC:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*   5248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VANDC),
     /*   5251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*   5255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*   5259 */     GIR_RootConstrainSelectedInstOperands,
     /*   5260 */     // GIR_Coverage, 1384,
     /*   5260 */     GIR_EraseRootFromParent_Done,
     /*   5261 */   // Label 245: @5261
     /*   5261 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(5280), // Rule ID 311 //
     /*   5266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*   5269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*   5273 */     // (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*   5273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VAND),
     /*   5278 */     GIR_RootConstrainSelectedInstOperands,
     /*   5279 */     // GIR_Coverage, 311,
     /*   5279 */     GIR_Done,
     /*   5280 */   // Label 246: @5280
     /*   5280 */   GIM_Reject,
     /*   5281 */ // Label 213: @5281
     /*   5281 */ GIM_Reject,
     /*   5282 */ // Label 200: @5282
     /*   5282 */ GIM_Reject,
     /*   5283 */ // Label 8: @5283
     /*   5283 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 251*/ GIMT_Encode4(48424),
     /*   5294 */ /*GILLT_s1*//*Label 247*/ GIMT_Encode4(5318),
     /*   5298 */ /*GILLT_s32*//*Label 248*/ GIMT_Encode4(5427),
     /*   5302 */ /*GILLT_s64*//*Label 249*/ GIMT_Encode4(5536), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   5314 */ /*GILLT_v4s32*//*Label 250*/ GIMT_Encode4(5645),
     /*   5318 */ // Label 247: @5318
     /*   5318 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(5426),
     /*   5323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*   5326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*   5329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*   5333 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(5373), // Rule ID 4925 //
     /*   5338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5354 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (or:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRA)  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRA
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5371 */     GIR_RootConstrainSelectedInstOperands,
     /*   5372 */     // GIR_Coverage, 4925,
     /*   5372 */     GIR_EraseRootFromParent_Done,
     /*   5373 */   // Label 253: @5373
     /*   5373 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5413), // Rule ID 183 //
     /*   5378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*   5390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*   5394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5400 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, -1:{ *:[i1] }))  =>  (CRORC:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /*   5403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*   5405 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*   5407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRB
     /*   5411 */     GIR_RootConstrainSelectedInstOperands,
     /*   5412 */     // GIR_Coverage, 183,
     /*   5412 */     GIR_EraseRootFromParent_Done,
     /*   5413 */   // Label 254: @5413
     /*   5413 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5425), // Rule ID 177 //
     /*   5418 */     // (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CROR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*   5418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /*   5423 */     GIR_RootConstrainSelectedInstOperands,
     /*   5424 */     // GIR_Coverage, 177,
     /*   5424 */     GIR_Done,
     /*   5425 */   // Label 255: @5425
     /*   5425 */   GIM_Reject,
     /*   5426 */ // Label 252: @5426
     /*   5426 */ GIM_Reject,
     /*   5427 */ // Label 248: @5427
     /*   5427 */ GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(5535),
     /*   5432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   5435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   5438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*   5442 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(5482), // Rule ID 4919 //
     /*   5447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5469 */     // (or:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }), i32:{ *:[i32] }:$RST)  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5474 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5480 */     GIR_RootConstrainSelectedInstOperands,
     /*   5481 */     // GIR_Coverage, 4919,
     /*   5481 */     GIR_EraseRootFromParent_Done,
     /*   5482 */   // Label 257: @5482
     /*   5482 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(5522), // Rule ID 126 //
     /*   5487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5509 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, -1:{ *:[i32] }))  =>  (ORC:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*   5512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5514 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5520 */     GIR_RootConstrainSelectedInstOperands,
     /*   5521 */     // GIR_Coverage, 126,
     /*   5521 */     GIR_EraseRootFromParent_Done,
     /*   5522 */   // Label 258: @5522
     /*   5522 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(5534), // Rule ID 124 //
     /*   5527 */     // (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (OR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*   5527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR),
     /*   5532 */     GIR_RootConstrainSelectedInstOperands,
     /*   5533 */     // GIR_Coverage, 124,
     /*   5533 */     GIR_Done,
     /*   5534 */   // Label 259: @5534
     /*   5534 */   GIM_Reject,
     /*   5535 */ // Label 256: @5535
     /*   5535 */ GIM_Reject,
     /*   5536 */ // Label 249: @5536
     /*   5536 */ GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(5644),
     /*   5541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   5544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   5547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*   5551 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(5591), // Rule ID 4932 //
     /*   5556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5572 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5578 */     // (or:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }), i64:{ *:[i64] }:$RST)  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5583 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*   5585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5589 */     GIR_RootConstrainSelectedInstOperands,
     /*   5590 */     // GIR_Coverage, 4932,
     /*   5590 */     GIR_EraseRootFromParent_Done,
     /*   5591 */   // Label 261: @5591
     /*   5591 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(5631), // Rule ID 650 //
     /*   5596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   5612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*   5616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5618 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, -1:{ *:[i64] }))  =>  (ORC8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*   5621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*   5623 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*   5625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /*   5629 */     GIR_RootConstrainSelectedInstOperands,
     /*   5630 */     // GIR_Coverage, 650,
     /*   5630 */     GIR_EraseRootFromParent_Done,
     /*   5631 */   // Label 262: @5631
     /*   5631 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5643), // Rule ID 648 //
     /*   5636 */     // (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (OR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*   5636 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /*   5641 */     GIR_RootConstrainSelectedInstOperands,
     /*   5642 */     // GIR_Coverage, 648,
     /*   5642 */     GIR_Done,
     /*   5643 */   // Label 263: @5643
     /*   5643 */   GIM_Reject,
     /*   5644 */ // Label 260: @5644
     /*   5644 */ GIM_Reject,
     /*   5645 */ // Label 250: @5645
     /*   5645 */ GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(48423),
     /*   5650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5656 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5794), // Rule ID 4979 //
     /*   5661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5712 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5716 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5720 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5724 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5728 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5732 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5736 */     // MIs[5] vA
     /*   5736 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5741 */     // MIs[5] vB
     /*   5741 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5746 */     // MIs[4] vC
     /*   5746 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5751 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5755 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5761 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5765 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5782 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5792 */     GIR_RootConstrainSelectedInstOperands,
     /*   5793 */     // GIR_Coverage, 4979,
     /*   5793 */     GIR_EraseRootFromParent_Done,
     /*   5794 */   // Label 265: @5794
     /*   5794 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5932), // Rule ID 4980 //
     /*   5799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5842 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5846 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5850 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5854 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5858 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5862 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5866 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   5870 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   5874 */     // MIs[5] vB
     /*   5874 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5879 */     // MIs[5] vA
     /*   5879 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   5884 */     // MIs[4] vC
     /*   5884 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   5889 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   5893 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   5899 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   5901 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   5903 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   5903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   5906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   5908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   5912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   5916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   5920 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 4980,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 266: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(6070), // Rule ID 4981 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   5944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   5968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   5980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   5984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5988 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   5992 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   5996 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6000 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6004 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6008 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6012 */     // MIs[5] vA
     /*   6012 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6017 */     // MIs[5] vC
     /*   6017 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6022 */     // MIs[4] vB
     /*   6022 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6031 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6041 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6058 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6068 */     GIR_RootConstrainSelectedInstOperands,
     /*   6069 */     // GIR_Coverage, 4981,
     /*   6069 */     GIR_EraseRootFromParent_Done,
     /*   6070 */   // Label 267: @6070
     /*   6070 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(6208), // Rule ID 4982 //
     /*   6075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6126 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6130 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6134 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6138 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6142 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6146 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6150 */     // MIs[5] vC
     /*   6150 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6155 */     // MIs[5] vA
     /*   6155 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6160 */     // MIs[4] vB
     /*   6160 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6169 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6175 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6177 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6179 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6196 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6206 */     GIR_RootConstrainSelectedInstOperands,
     /*   6207 */     // GIR_Coverage, 4982,
     /*   6207 */     GIR_EraseRootFromParent_Done,
     /*   6208 */   // Label 268: @6208
     /*   6208 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(6346), // Rule ID 4983 //
     /*   6213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6252 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6256 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6260 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6264 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6272 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6276 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6280 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6284 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6288 */     // MIs[5] vB
     /*   6288 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6293 */     // MIs[5] vC
     /*   6293 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6298 */     // MIs[4] vA
     /*   6298 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6303 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6307 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6315 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6317 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6334 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6344 */     GIR_RootConstrainSelectedInstOperands,
     /*   6345 */     // GIR_Coverage, 4983,
     /*   6345 */     GIR_EraseRootFromParent_Done,
     /*   6346 */   // Label 269: @6346
     /*   6346 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(6484), // Rule ID 4984 //
     /*   6351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6390 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6394 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6398 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6402 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6410 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6414 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6418 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6422 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6426 */     // MIs[5] vC
     /*   6426 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6431 */     // MIs[5] vB
     /*   6431 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6436 */     // MIs[4] vA
     /*   6436 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6441 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6445 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6453 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6455 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   6464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   6468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6472 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6482 */     GIR_RootConstrainSelectedInstOperands,
     /*   6483 */     // GIR_Coverage, 4984,
     /*   6483 */     GIR_EraseRootFromParent_Done,
     /*   6484 */   // Label 270: @6484
     /*   6484 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(6622), // Rule ID 4991 //
     /*   6489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6528 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6532 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6536 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6540 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6552 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6556 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6560 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6564 */     // MIs[5] vA
     /*   6564 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6569 */     // MIs[5] vB
     /*   6569 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6574 */     // MIs[4] vC
     /*   6574 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6579 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6583 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6589 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6591 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6593 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6610 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6620 */     GIR_RootConstrainSelectedInstOperands,
     /*   6621 */     // GIR_Coverage, 4991,
     /*   6621 */     GIR_EraseRootFromParent_Done,
     /*   6622 */   // Label 271: @6622
     /*   6622 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(6760), // Rule ID 4992 //
     /*   6627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6690 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6694 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6698 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6702 */     // MIs[5] vB
     /*   6702 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6707 */     // MIs[5] vA
     /*   6707 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6712 */     // MIs[4] vC
     /*   6712 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6717 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6721 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6729 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6731 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6748 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6758 */     GIR_RootConstrainSelectedInstOperands,
     /*   6759 */     // GIR_Coverage, 4992,
     /*   6759 */     GIR_EraseRootFromParent_Done,
     /*   6760 */   // Label 272: @6760
     /*   6760 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(6898), // Rule ID 4993 //
     /*   6765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6816 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6828 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6832 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6836 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6840 */     // MIs[5] vA
     /*   6840 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6845 */     // MIs[5] vC
     /*   6845 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6850 */     // MIs[4] vB
     /*   6850 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6855 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6859 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   6865 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   6867 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   6869 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   6869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   6872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   6874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   6878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   6882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   6886 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   6896 */     GIR_RootConstrainSelectedInstOperands,
     /*   6897 */     // GIR_Coverage, 4993,
     /*   6897 */     GIR_EraseRootFromParent_Done,
     /*   6898 */   // Label 273: @6898
     /*   6898 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(7036), // Rule ID 4994 //
     /*   6903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   6906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   6910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   6934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6938 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   6950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6954 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   6958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6966 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6970 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   6974 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   6978 */     // MIs[5] vC
     /*   6978 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   6983 */     // MIs[5] vA
     /*   6983 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   6988 */     // MIs[4] vB
     /*   6988 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   6993 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   6997 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7003 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7005 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7007 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7024 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7034 */     GIR_RootConstrainSelectedInstOperands,
     /*   7035 */     // GIR_Coverage, 4994,
     /*   7035 */     GIR_EraseRootFromParent_Done,
     /*   7036 */   // Label 274: @7036
     /*   7036 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(7174), // Rule ID 4995 //
     /*   7041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7092 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7096 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7100 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7104 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7108 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7112 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7116 */     // MIs[5] vB
     /*   7116 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7121 */     // MIs[5] vC
     /*   7121 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7126 */     // MIs[4] vA
     /*   7126 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7131 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7135 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7141 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7143 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7162 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7172 */     GIR_RootConstrainSelectedInstOperands,
     /*   7173 */     // GIR_Coverage, 4995,
     /*   7173 */     GIR_EraseRootFromParent_Done,
     /*   7174 */   // Label 275: @7174
     /*   7174 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(7312), // Rule ID 4996 //
     /*   7179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7234 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7238 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7242 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7246 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7250 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7254 */     // MIs[5] vC
     /*   7254 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7259 */     // MIs[5] vB
     /*   7259 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7264 */     // MIs[4] vA
     /*   7264 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7269 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7273 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7281 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7283 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   7292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   7296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*   7300 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7310 */     GIR_RootConstrainSelectedInstOperands,
     /*   7311 */     // GIR_Coverage, 4996,
     /*   7311 */     GIR_EraseRootFromParent_Done,
     /*   7312 */   // Label 276: @7312
     /*   7312 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(7450), // Rule ID 5003 //
     /*   7317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7372 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7376 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7380 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7384 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7388 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7392 */     // MIs[5] vA
     /*   7392 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7397 */     // MIs[5] vB
     /*   7397 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7402 */     // MIs[4] vC
     /*   7402 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7407 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7411 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7417 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7419 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7421 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7438 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7448 */     GIR_RootConstrainSelectedInstOperands,
     /*   7449 */     // GIR_Coverage, 5003,
     /*   7449 */     GIR_EraseRootFromParent_Done,
     /*   7450 */   // Label 277: @7450
     /*   7450 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(7588), // Rule ID 5004 //
     /*   7455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7510 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7514 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7518 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7522 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7526 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7530 */     // MIs[5] vB
     /*   7530 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7535 */     // MIs[5] vA
     /*   7535 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7540 */     // MIs[4] vC
     /*   7540 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7545 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7549 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7555 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7557 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7559 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7576 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7586 */     GIR_RootConstrainSelectedInstOperands,
     /*   7587 */     // GIR_Coverage, 5004,
     /*   7587 */     GIR_EraseRootFromParent_Done,
     /*   7588 */   // Label 278: @7588
     /*   7588 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(7726), // Rule ID 5005 //
     /*   7593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7644 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7648 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7652 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7656 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7660 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7664 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7668 */     // MIs[5] vA
     /*   7668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7673 */     // MIs[5] vC
     /*   7673 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7678 */     // MIs[4] vB
     /*   7678 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7687 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7693 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7697 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7714 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7724 */     GIR_RootConstrainSelectedInstOperands,
     /*   7725 */     // GIR_Coverage, 5005,
     /*   7725 */     GIR_EraseRootFromParent_Done,
     /*   7726 */   // Label 279: @7726
     /*   7726 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(7864), // Rule ID 5006 //
     /*   7731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7778 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7782 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7790 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7794 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7798 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7802 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7806 */     // MIs[5] vC
     /*   7806 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7811 */     // MIs[5] vA
     /*   7811 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7816 */     // MIs[4] vB
     /*   7816 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7821 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7825 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7831 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7833 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7835 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   7862 */     GIR_RootConstrainSelectedInstOperands,
     /*   7863 */     // GIR_Coverage, 5006,
     /*   7863 */     GIR_EraseRootFromParent_Done,
     /*   7864 */   // Label 280: @7864
     /*   7864 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(8002), // Rule ID 5007 //
     /*   7869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   7872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   7876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   7900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   7912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   7916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   7924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   7928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7932 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   7936 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   7940 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   7944 */     // MIs[5] vB
     /*   7944 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   7949 */     // MIs[5] vC
     /*   7949 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   7954 */     // MIs[4] vA
     /*   7954 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   7959 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   7963 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   7969 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   7971 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   7973 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   7973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   7976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   7978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   7982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   7986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   7990 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8000 */     GIR_RootConstrainSelectedInstOperands,
     /*   8001 */     // GIR_Coverage, 5007,
     /*   8001 */     GIR_EraseRootFromParent_Done,
     /*   8002 */   // Label 281: @8002
     /*   8002 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(8140), // Rule ID 5008 //
     /*   8007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8046 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8050 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8054 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8058 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8062 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8066 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8070 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8074 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8078 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8082 */     // MIs[5] vC
     /*   8082 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8087 */     // MIs[5] vB
     /*   8087 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8092 */     // MIs[4] vA
     /*   8092 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8097 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8101 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8107 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8109 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8111 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*   8120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   8128 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8138 */     GIR_RootConstrainSelectedInstOperands,
     /*   8139 */     // GIR_Coverage, 5008,
     /*   8139 */     GIR_EraseRootFromParent_Done,
     /*   8140 */   // Label 282: @8140
     /*   8140 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(8278), // Rule ID 5015 //
     /*   8145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8184 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8188 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8192 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8196 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8208 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8212 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8216 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8220 */     // MIs[5] vA
     /*   8220 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8225 */     // MIs[5] vB
     /*   8225 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8230 */     // MIs[4] vC
     /*   8230 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8235 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8239 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8247 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8249 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8266 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8276 */     GIR_RootConstrainSelectedInstOperands,
     /*   8277 */     // GIR_Coverage, 5015,
     /*   8277 */     GIR_EraseRootFromParent_Done,
     /*   8278 */   // Label 283: @8278
     /*   8278 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(8416), // Rule ID 5016 //
     /*   8283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8330 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8334 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8346 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8350 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8354 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8358 */     // MIs[5] vB
     /*   8358 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8363 */     // MIs[5] vA
     /*   8363 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8368 */     // MIs[4] vC
     /*   8368 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8373 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8377 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8383 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8385 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8387 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8404 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8414 */     GIR_RootConstrainSelectedInstOperands,
     /*   8415 */     // GIR_Coverage, 5016,
     /*   8415 */     GIR_EraseRootFromParent_Done,
     /*   8416 */   // Label 284: @8416
     /*   8416 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(8554), // Rule ID 5017 //
     /*   8421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8472 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8476 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8480 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8484 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8488 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8492 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8496 */     // MIs[5] vA
     /*   8496 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8501 */     // MIs[5] vC
     /*   8501 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8506 */     // MIs[4] vB
     /*   8506 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8511 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8515 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8523 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8525 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8542 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8552 */     GIR_RootConstrainSelectedInstOperands,
     /*   8553 */     // GIR_Coverage, 5017,
     /*   8553 */     GIR_EraseRootFromParent_Done,
     /*   8554 */   // Label 285: @8554
     /*   8554 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(8692), // Rule ID 5018 //
     /*   8559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8594 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8606 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8610 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8622 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8626 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8630 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8634 */     // MIs[5] vC
     /*   8634 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8639 */     // MIs[5] vA
     /*   8639 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8644 */     // MIs[4] vB
     /*   8644 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8649 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8653 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8661 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8663 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8680 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8690 */     GIR_RootConstrainSelectedInstOperands,
     /*   8691 */     // GIR_Coverage, 5018,
     /*   8691 */     GIR_EraseRootFromParent_Done,
     /*   8692 */   // Label 286: @8692
     /*   8692 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(8830), // Rule ID 5019 //
     /*   8697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8740 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8744 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8748 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8756 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8760 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8764 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8768 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8772 */     // MIs[5] vB
     /*   8772 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8777 */     // MIs[5] vC
     /*   8777 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8782 */     // MIs[4] vA
     /*   8782 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8787 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8791 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8799 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8801 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8818 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8828 */     GIR_RootConstrainSelectedInstOperands,
     /*   8829 */     // GIR_Coverage, 5019,
     /*   8829 */     GIR_EraseRootFromParent_Done,
     /*   8830 */   // Label 287: @8830
     /*   8830 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(8968), // Rule ID 5020 //
     /*   8835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8866 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8870 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   8878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   8882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   8894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8898 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8902 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   8906 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   8910 */     // MIs[5] vC
     /*   8910 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   8915 */     // MIs[5] vB
     /*   8915 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   8920 */     // MIs[4] vA
     /*   8920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   8925 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   8929 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   8935 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   8937 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   8939 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   8939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   8942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   8944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*   8948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*   8952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   8956 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   8966 */     GIR_RootConstrainSelectedInstOperands,
     /*   8967 */     // GIR_Coverage, 5020,
     /*   8967 */     GIR_EraseRootFromParent_Done,
     /*   8968 */   // Label 288: @8968
     /*   8968 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(9106), // Rule ID 5027 //
     /*   8973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   8976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   8980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   8988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9028 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9032 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9036 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9040 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9044 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9048 */     // MIs[5] vA
     /*   9048 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9053 */     // MIs[5] vB
     /*   9053 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9058 */     // MIs[4] vC
     /*   9058 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9063 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9067 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9075 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9077 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9104 */     GIR_RootConstrainSelectedInstOperands,
     /*   9105 */     // GIR_Coverage, 5027,
     /*   9105 */     GIR_EraseRootFromParent_Done,
     /*   9106 */   // Label 289: @9106
     /*   9106 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(9244), // Rule ID 5028 //
     /*   9111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9162 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9174 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9178 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9182 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9186 */     // MIs[5] vB
     /*   9186 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9191 */     // MIs[5] vA
     /*   9191 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9196 */     // MIs[4] vC
     /*   9196 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9201 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9205 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9211 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9213 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9215 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9232 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9242 */     GIR_RootConstrainSelectedInstOperands,
     /*   9243 */     // GIR_Coverage, 5028,
     /*   9243 */     GIR_EraseRootFromParent_Done,
     /*   9244 */   // Label 290: @9244
     /*   9244 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(9382), // Rule ID 5029 //
     /*   9249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9280 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9284 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9288 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9292 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9296 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9300 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9312 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9316 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9320 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9324 */     // MIs[5] vA
     /*   9324 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9329 */     // MIs[5] vC
     /*   9329 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9334 */     // MIs[4] vB
     /*   9334 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9339 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9343 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9349 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9351 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9353 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9370 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9380 */     GIR_RootConstrainSelectedInstOperands,
     /*   9381 */     // GIR_Coverage, 5029,
     /*   9381 */     GIR_EraseRootFromParent_Done,
     /*   9382 */   // Label 291: @9382
     /*   9382 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(9520), // Rule ID 5030 //
     /*   9387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9422 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9434 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9438 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9446 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9450 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9454 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9458 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9462 */     // MIs[5] vC
     /*   9462 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9467 */     // MIs[5] vA
     /*   9467 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9472 */     // MIs[4] vB
     /*   9472 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9477 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9481 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9487 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9489 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9491 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9508 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9518 */     GIR_RootConstrainSelectedInstOperands,
     /*   9519 */     // GIR_Coverage, 5030,
     /*   9519 */     GIR_EraseRootFromParent_Done,
     /*   9520 */   // Label 292: @9520
     /*   9520 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(9658), // Rule ID 5031 //
     /*   9525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9560 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9576 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9580 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9584 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9588 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9592 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9596 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9600 */     // MIs[5] vB
     /*   9600 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9605 */     // MIs[5] vC
     /*   9605 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9610 */     // MIs[4] vA
     /*   9610 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9615 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9619 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9625 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9627 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9629 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9646 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9656 */     GIR_RootConstrainSelectedInstOperands,
     /*   9657 */     // GIR_Coverage, 5031,
     /*   9657 */     GIR_EraseRootFromParent_Done,
     /*   9658 */   // Label 293: @9658
     /*   9658 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(9796), // Rule ID 5032 //
     /*   9663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9702 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9706 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9710 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9714 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9718 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9722 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9726 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9730 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9734 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9738 */     // MIs[5] vC
     /*   9738 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9743 */     // MIs[5] vB
     /*   9743 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9748 */     // MIs[4] vA
     /*   9748 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9753 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9757 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9765 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9767 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*   9780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*   9784 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9794 */     GIR_RootConstrainSelectedInstOperands,
     /*   9795 */     // GIR_Coverage, 5032,
     /*   9795 */     GIR_EraseRootFromParent_Done,
     /*   9796 */   // Label 294: @9796
     /*   9796 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(9934), // Rule ID 5039 //
     /*   9801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9860 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9864 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9868 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*   9872 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*   9876 */     // MIs[5] vA
     /*   9876 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*   9881 */     // MIs[5] vB
     /*   9881 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   9886 */     // MIs[4] vC
     /*   9886 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*   9891 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*   9895 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*   9901 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*   9903 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*   9905 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*   9905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*   9908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*   9910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*   9914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*   9918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*   9922 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*   9932 */     GIR_RootConstrainSelectedInstOperands,
     /*   9933 */     // GIR_Coverage, 5039,
     /*   9933 */     GIR_EraseRootFromParent_Done,
     /*   9934 */   // Label 295: @9934
     /*   9934 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(10072), // Rule ID 5040 //
     /*   9939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*   9942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*   9946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9958 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   9970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9978 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   9982 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*   9986 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   9990 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   9994 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   9998 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10002 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10006 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10010 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10014 */     // MIs[5] vB
     /*  10014 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10019 */     // MIs[5] vA
     /*  10019 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10024 */     // MIs[4] vC
     /*  10024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10029 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10033 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10041 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10043 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10060 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10070 */     GIR_RootConstrainSelectedInstOperands,
     /*  10071 */     // GIR_Coverage, 5040,
     /*  10071 */     GIR_EraseRootFromParent_Done,
     /*  10072 */   // Label 296: @10072
     /*  10072 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(10210), // Rule ID 5041 //
     /*  10077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10132 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10136 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10140 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10144 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10148 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10152 */     // MIs[5] vA
     /*  10152 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10157 */     // MIs[5] vC
     /*  10157 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10162 */     // MIs[4] vB
     /*  10162 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10167 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10171 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10177 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10179 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10181 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10198 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10208 */     GIR_RootConstrainSelectedInstOperands,
     /*  10209 */     // GIR_Coverage, 5041,
     /*  10209 */     GIR_EraseRootFromParent_Done,
     /*  10210 */   // Label 297: @10210
     /*  10210 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(10348), // Rule ID 5042 //
     /*  10215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10274 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10278 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10282 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10286 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10290 */     // MIs[5] vC
     /*  10290 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10295 */     // MIs[5] vA
     /*  10295 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10300 */     // MIs[4] vB
     /*  10300 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10305 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10309 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10315 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10317 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10319 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10336 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10346 */     GIR_RootConstrainSelectedInstOperands,
     /*  10347 */     // GIR_Coverage, 5042,
     /*  10347 */     GIR_EraseRootFromParent_Done,
     /*  10348 */   // Label 298: @10348
     /*  10348 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(10486), // Rule ID 5043 //
     /*  10353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10412 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10416 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10428 */     // MIs[5] vB
     /*  10428 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10433 */     // MIs[5] vC
     /*  10433 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10438 */     // MIs[4] vA
     /*  10438 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10443 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10447 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10453 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10455 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10457 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10474 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10484 */     GIR_RootConstrainSelectedInstOperands,
     /*  10485 */     // GIR_Coverage, 5043,
     /*  10485 */     GIR_EraseRootFromParent_Done,
     /*  10486 */   // Label 299: @10486
     /*  10486 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(10624), // Rule ID 5044 //
     /*  10491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10542 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10550 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10554 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  10562 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10566 */     // MIs[5] vC
     /*  10566 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10571 */     // MIs[5] vB
     /*  10571 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10576 */     // MIs[4] vA
     /*  10576 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10581 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10585 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10593 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10595 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  10604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  10612 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10622 */     GIR_RootConstrainSelectedInstOperands,
     /*  10623 */     // GIR_Coverage, 5044,
     /*  10623 */     GIR_EraseRootFromParent_Done,
     /*  10624 */   // Label 300: @10624
     /*  10624 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(10762), // Rule ID 4985 //
     /*  10629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10676 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10680 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10692 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10696 */     // MIs[4] vC
     /*  10696 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10701 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10705 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10709 */     // MIs[5] vA
     /*  10709 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10714 */     // MIs[5] vB
     /*  10714 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10719 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10723 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10729 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10731 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10733 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10750 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 4985,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 301: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(10900), // Rule ID 4986 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10798 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10802 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10818 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10822 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10826 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10830 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10834 */     // MIs[4] vC
     /*  10834 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10839 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10843 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10847 */     // MIs[5] vB
     /*  10847 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10852 */     // MIs[5] vA
     /*  10852 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10857 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10861 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  10867 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  10869 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  10871 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  10871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  10874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  10876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  10880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  10884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  10888 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  10898 */     GIR_RootConstrainSelectedInstOperands,
     /*  10899 */     // GIR_Coverage, 4986,
     /*  10899 */     GIR_EraseRootFromParent_Done,
     /*  10900 */   // Label 302: @10900
     /*  10900 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11038), // Rule ID 4987 //
     /*  10905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  10908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  10912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  10936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  10948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  10952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  10956 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  10964 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10968 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  10972 */     // MIs[4] vB
     /*  10972 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  10977 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  10981 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  10985 */     // MIs[5] vA
     /*  10985 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  10990 */     // MIs[5] vC
     /*  10990 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10995 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  10999 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11009 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11026 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11036 */     GIR_RootConstrainSelectedInstOperands,
     /*  11037 */     // GIR_Coverage, 4987,
     /*  11037 */     GIR_EraseRootFromParent_Done,
     /*  11038 */   // Label 303: @11038
     /*  11038 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(11176), // Rule ID 4988 //
     /*  11043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11078 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11082 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11086 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11090 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11094 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11102 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11106 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11110 */     // MIs[4] vB
     /*  11110 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11115 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11119 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11123 */     // MIs[5] vC
     /*  11123 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11128 */     // MIs[5] vA
     /*  11128 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11133 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11137 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11145 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11147 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11164 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11174 */     GIR_RootConstrainSelectedInstOperands,
     /*  11175 */     // GIR_Coverage, 4988,
     /*  11175 */     GIR_EraseRootFromParent_Done,
     /*  11176 */   // Label 304: @11176
     /*  11176 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(11314), // Rule ID 4989 //
     /*  11181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11212 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11216 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11228 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11232 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11236 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11240 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11244 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11248 */     // MIs[4] vA
     /*  11248 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11253 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11257 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11261 */     // MIs[5] vB
     /*  11261 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11266 */     // MIs[5] vC
     /*  11266 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11271 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11275 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11281 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11283 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11285 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11302 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11312 */     GIR_RootConstrainSelectedInstOperands,
     /*  11313 */     // GIR_Coverage, 4989,
     /*  11313 */     GIR_EraseRootFromParent_Done,
     /*  11314 */   // Label 305: @11314
     /*  11314 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(11452), // Rule ID 4990 //
     /*  11319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11354 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11358 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11362 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11366 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11370 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11378 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11382 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11386 */     // MIs[4] vA
     /*  11386 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11391 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11395 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11399 */     // MIs[5] vC
     /*  11399 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11404 */     // MIs[5] vB
     /*  11404 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11409 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11413 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11419 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11421 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11423 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  11432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  11436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11440 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11450 */     GIR_RootConstrainSelectedInstOperands,
     /*  11451 */     // GIR_Coverage, 4990,
     /*  11451 */     GIR_EraseRootFromParent_Done,
     /*  11452 */   // Label 306: @11452
     /*  11452 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(11590), // Rule ID 4997 //
     /*  11457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11492 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11496 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11500 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11504 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11508 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11516 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11520 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11524 */     // MIs[4] vC
     /*  11524 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11529 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11533 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11537 */     // MIs[5] vA
     /*  11537 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11542 */     // MIs[5] vB
     /*  11542 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11547 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11551 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11559 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11561 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11578 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11588 */     GIR_RootConstrainSelectedInstOperands,
     /*  11589 */     // GIR_Coverage, 4997,
     /*  11589 */     GIR_EraseRootFromParent_Done,
     /*  11590 */   // Label 307: @11590
     /*  11590 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(11728), // Rule ID 4998 //
     /*  11595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11646 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11650 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11654 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11658 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11662 */     // MIs[4] vC
     /*  11662 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11667 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11671 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11675 */     // MIs[5] vB
     /*  11675 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11680 */     // MIs[5] vA
     /*  11680 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11685 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11689 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11695 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11697 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11699 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11716 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11726 */     GIR_RootConstrainSelectedInstOperands,
     /*  11727 */     // GIR_Coverage, 4998,
     /*  11727 */     GIR_EraseRootFromParent_Done,
     /*  11728 */   // Label 308: @11728
     /*  11728 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(11866), // Rule ID 4999 //
     /*  11733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11768 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11784 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11788 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11792 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11796 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11800 */     // MIs[4] vB
     /*  11800 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11805 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11809 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11813 */     // MIs[5] vA
     /*  11813 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11818 */     // MIs[5] vC
     /*  11818 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11823 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11827 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11835 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11837 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11854 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  11864 */     GIR_RootConstrainSelectedInstOperands,
     /*  11865 */     // GIR_Coverage, 4999,
     /*  11865 */     GIR_EraseRootFromParent_Done,
     /*  11866 */   // Label 309: @11866
     /*  11866 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12004), // Rule ID 5000 //
     /*  11871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  11874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  11878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  11902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11906 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  11914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  11918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11926 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  11930 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11934 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11938 */     // MIs[4] vB
     /*  11938 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11943 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  11947 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  11951 */     // MIs[5] vC
     /*  11951 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11956 */     // MIs[5] vA
     /*  11956 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  11961 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  11965 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  11971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  11973 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11975 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  11975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  11978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  11980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  11984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  11988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  11992 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12002 */     GIR_RootConstrainSelectedInstOperands,
     /*  12003 */     // GIR_Coverage, 5000,
     /*  12003 */     GIR_EraseRootFromParent_Done,
     /*  12004 */   // Label 310: @12004
     /*  12004 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12142), // Rule ID 5001 //
     /*  12009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12068 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12072 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12076 */     // MIs[4] vA
     /*  12076 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12081 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12085 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12089 */     // MIs[5] vB
     /*  12089 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12094 */     // MIs[5] vC
     /*  12094 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12099 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12103 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12109 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12111 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12113 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12130 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12140 */     GIR_RootConstrainSelectedInstOperands,
     /*  12141 */     // GIR_Coverage, 5001,
     /*  12141 */     GIR_EraseRootFromParent_Done,
     /*  12142 */   // Label 311: @12142
     /*  12142 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12280), // Rule ID 5002 //
     /*  12147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12210 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12214 */     // MIs[4] vA
     /*  12214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12219 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12223 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12227 */     // MIs[5] vC
     /*  12227 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12232 */     // MIs[5] vB
     /*  12232 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12237 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12241 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12249 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12251 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  12260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  12264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  12268 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12278 */     GIR_RootConstrainSelectedInstOperands,
     /*  12279 */     // GIR_Coverage, 5002,
     /*  12279 */     GIR_EraseRootFromParent_Done,
     /*  12280 */   // Label 312: @12280
     /*  12280 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12418), // Rule ID 5009 //
     /*  12285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12336 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12348 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12352 */     // MIs[4] vC
     /*  12352 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12357 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12361 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12365 */     // MIs[5] vA
     /*  12365 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12370 */     // MIs[5] vB
     /*  12370 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12375 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12379 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12387 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12389 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12406 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12416 */     GIR_RootConstrainSelectedInstOperands,
     /*  12417 */     // GIR_Coverage, 5009,
     /*  12417 */     GIR_EraseRootFromParent_Done,
     /*  12418 */   // Label 313: @12418
     /*  12418 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12556), // Rule ID 5010 //
     /*  12423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12470 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12474 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12478 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12482 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12486 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12490 */     // MIs[4] vC
     /*  12490 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12495 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12499 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12503 */     // MIs[5] vB
     /*  12503 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12508 */     // MIs[5] vA
     /*  12508 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12513 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12517 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12523 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12525 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12527 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12544 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12554 */     GIR_RootConstrainSelectedInstOperands,
     /*  12555 */     // GIR_Coverage, 5010,
     /*  12555 */     GIR_EraseRootFromParent_Done,
     /*  12556 */   // Label 314: @12556
     /*  12556 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12694), // Rule ID 5011 //
     /*  12561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12612 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12616 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12620 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12624 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12628 */     // MIs[4] vB
     /*  12628 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12633 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12637 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12641 */     // MIs[5] vA
     /*  12641 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12646 */     // MIs[5] vC
     /*  12646 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12651 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12655 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12663 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12665 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12692 */     GIR_RootConstrainSelectedInstOperands,
     /*  12693 */     // GIR_Coverage, 5011,
     /*  12693 */     GIR_EraseRootFromParent_Done,
     /*  12694 */   // Label 315: @12694
     /*  12694 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(12832), // Rule ID 5012 //
     /*  12699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12754 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12758 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12762 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12766 */     // MIs[4] vB
     /*  12766 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12771 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12775 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12779 */     // MIs[5] vC
     /*  12779 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12784 */     // MIs[5] vA
     /*  12784 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12789 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12793 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12799 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12801 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12803 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12820 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12830 */     GIR_RootConstrainSelectedInstOperands,
     /*  12831 */     // GIR_Coverage, 5012,
     /*  12831 */     GIR_EraseRootFromParent_Done,
     /*  12832 */   // Label 316: @12832
     /*  12832 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(12970), // Rule ID 5013 //
     /*  12837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12868 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12872 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12876 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12880 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  12884 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12888 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12896 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12900 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12904 */     // MIs[4] vA
     /*  12904 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12909 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  12913 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  12917 */     // MIs[5] vB
     /*  12917 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  12922 */     // MIs[5] vC
     /*  12922 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  12927 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  12931 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  12937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  12939 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12941 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  12941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  12944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  12946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  12950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  12954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  12958 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  12968 */     GIR_RootConstrainSelectedInstOperands,
     /*  12969 */     // GIR_Coverage, 5013,
     /*  12969 */     GIR_EraseRootFromParent_Done,
     /*  12970 */   // Label 317: @12970
     /*  12970 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(13108), // Rule ID 5014 //
     /*  12975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  12978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  12982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  12990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13010 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13014 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13018 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13022 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13026 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13038 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13042 */     // MIs[4] vA
     /*  13042 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13047 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13051 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13055 */     // MIs[5] vC
     /*  13055 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13060 */     // MIs[5] vB
     /*  13060 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13065 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13069 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13077 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13079 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  13088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  13096 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13106 */     GIR_RootConstrainSelectedInstOperands,
     /*  13107 */     // GIR_Coverage, 5014,
     /*  13107 */     GIR_EraseRootFromParent_Done,
     /*  13108 */   // Label 318: @13108
     /*  13108 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13246), // Rule ID 5021 //
     /*  13113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13164 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13172 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13176 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13180 */     // MIs[4] vC
     /*  13180 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13185 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13189 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13193 */     // MIs[5] vA
     /*  13193 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13198 */     // MIs[5] vB
     /*  13198 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13203 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13207 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13213 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13215 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13217 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13234 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13244 */     GIR_RootConstrainSelectedInstOperands,
     /*  13245 */     // GIR_Coverage, 5021,
     /*  13245 */     GIR_EraseRootFromParent_Done,
     /*  13246 */   // Label 319: @13246
     /*  13246 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13384), // Rule ID 5022 //
     /*  13251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13286 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13290 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13294 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13298 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13302 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13314 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13318 */     // MIs[4] vC
     /*  13318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13323 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13327 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13331 */     // MIs[5] vB
     /*  13331 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13336 */     // MIs[5] vA
     /*  13336 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13341 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13345 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13353 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13355 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13372 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13382 */     GIR_RootConstrainSelectedInstOperands,
     /*  13383 */     // GIR_Coverage, 5022,
     /*  13383 */     GIR_EraseRootFromParent_Done,
     /*  13384 */   // Label 320: @13384
     /*  13384 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13522), // Rule ID 5023 //
     /*  13389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13440 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13444 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13448 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13452 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13456 */     // MIs[4] vB
     /*  13456 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13461 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13465 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13469 */     // MIs[5] vA
     /*  13469 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13474 */     // MIs[5] vC
     /*  13474 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13479 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13483 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13489 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13491 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13493 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13510 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13520 */     GIR_RootConstrainSelectedInstOperands,
     /*  13521 */     // GIR_Coverage, 5023,
     /*  13521 */     GIR_EraseRootFromParent_Done,
     /*  13522 */   // Label 321: @13522
     /*  13522 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13660), // Rule ID 5024 //
     /*  13527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13574 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13578 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13582 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13586 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13590 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13594 */     // MIs[4] vB
     /*  13594 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13599 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13603 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13607 */     // MIs[5] vC
     /*  13607 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13612 */     // MIs[5] vA
     /*  13612 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13617 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13621 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13629 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13631 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13648 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13658 */     GIR_RootConstrainSelectedInstOperands,
     /*  13659 */     // GIR_Coverage, 5024,
     /*  13659 */     GIR_EraseRootFromParent_Done,
     /*  13660 */   // Label 322: @13660
     /*  13660 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13798), // Rule ID 5025 //
     /*  13665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13704 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13708 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13712 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13716 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13728 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13732 */     // MIs[4] vA
     /*  13732 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13737 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13741 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13745 */     // MIs[5] vB
     /*  13745 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13750 */     // MIs[5] vC
     /*  13750 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13755 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13759 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13765 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13767 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13769 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13786 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13796 */     GIR_RootConstrainSelectedInstOperands,
     /*  13797 */     // GIR_Coverage, 5025,
     /*  13797 */     GIR_EraseRootFromParent_Done,
     /*  13798 */   // Label 323: @13798
     /*  13798 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13936), // Rule ID 5026 //
     /*  13803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13838 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13854 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13858 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13862 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13866 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13870 */     // MIs[4] vA
     /*  13870 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  13875 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  13879 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  13883 */     // MIs[5] vC
     /*  13883 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  13888 */     // MIs[5] vB
     /*  13888 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  13893 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  13897 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  13903 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  13905 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  13907 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  13907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  13910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  13912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  13916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  13920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  13924 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  13934 */     GIR_RootConstrainSelectedInstOperands,
     /*  13935 */     // GIR_Coverage, 5026,
     /*  13935 */     GIR_EraseRootFromParent_Done,
     /*  13936 */   // Label 324: @13936
     /*  13936 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(14074), // Rule ID 5033 //
     /*  13941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  13944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  13948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  13972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13976 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  13988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13992 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  13996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14004 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14008 */     // MIs[4] vC
     /*  14008 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14013 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14017 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14021 */     // MIs[5] vA
     /*  14021 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14026 */     // MIs[5] vB
     /*  14026 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14031 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14035 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14041 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14043 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14045 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14062 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14072 */     GIR_RootConstrainSelectedInstOperands,
     /*  14073 */     // GIR_Coverage, 5033,
     /*  14073 */     GIR_EraseRootFromParent_Done,
     /*  14074 */   // Label 325: @14074
     /*  14074 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(14212), // Rule ID 5034 //
     /*  14079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14114 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14122 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14126 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14130 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14134 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14138 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14142 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14146 */     // MIs[4] vC
     /*  14146 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14151 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14155 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14159 */     // MIs[5] vB
     /*  14159 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14164 */     // MIs[5] vA
     /*  14164 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14169 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14173 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14179 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14181 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14183 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14200 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14210 */     GIR_RootConstrainSelectedInstOperands,
     /*  14211 */     // GIR_Coverage, 5034,
     /*  14211 */     GIR_EraseRootFromParent_Done,
     /*  14212 */   // Label 326: @14212
     /*  14212 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(14350), // Rule ID 5035 //
     /*  14217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14264 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14268 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14272 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14276 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14280 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14284 */     // MIs[4] vB
     /*  14284 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14289 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14293 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14297 */     // MIs[5] vA
     /*  14297 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14302 */     // MIs[5] vC
     /*  14302 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14307 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14311 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14317 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14319 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14321 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14338 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14348 */     GIR_RootConstrainSelectedInstOperands,
     /*  14349 */     // GIR_Coverage, 5035,
     /*  14349 */     GIR_EraseRootFromParent_Done,
     /*  14350 */   // Label 327: @14350
     /*  14350 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(14488), // Rule ID 5036 //
     /*  14355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14414 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14418 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14422 */     // MIs[4] vB
     /*  14422 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14427 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14431 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14435 */     // MIs[5] vC
     /*  14435 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14440 */     // MIs[5] vA
     /*  14440 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14445 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14449 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14455 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14457 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14459 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14476 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14486 */     GIR_RootConstrainSelectedInstOperands,
     /*  14487 */     // GIR_Coverage, 5036,
     /*  14487 */     GIR_EraseRootFromParent_Done,
     /*  14488 */   // Label 328: @14488
     /*  14488 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(14626), // Rule ID 5037 //
     /*  14493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14540 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14544 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14552 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14556 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14560 */     // MIs[4] vA
     /*  14560 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14565 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14569 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14573 */     // MIs[5] vB
     /*  14573 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14578 */     // MIs[5] vC
     /*  14578 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14583 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14587 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14595 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14597 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14614 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14624 */     GIR_RootConstrainSelectedInstOperands,
     /*  14625 */     // GIR_Coverage, 5037,
     /*  14625 */     GIR_EraseRootFromParent_Done,
     /*  14626 */   // Label 329: @14626
     /*  14626 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(14764), // Rule ID 5038 //
     /*  14631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14682 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14686 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14690 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14694 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14698 */     // MIs[4] vA
     /*  14698 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14703 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14707 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14711 */     // MIs[5] vC
     /*  14711 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14716 */     // MIs[5] vB
     /*  14716 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14721 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14725 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14731 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14733 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14735 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  14748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  14752 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14762 */     GIR_RootConstrainSelectedInstOperands,
     /*  14763 */     // GIR_Coverage, 5038,
     /*  14763 */     GIR_EraseRootFromParent_Done,
     /*  14764 */   // Label 330: @14764
     /*  14764 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(14902), // Rule ID 5045 //
     /*  14769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14804 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14820 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14824 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14828 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14832 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14836 */     // MIs[4] vC
     /*  14836 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14841 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14845 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14849 */     // MIs[5] vA
     /*  14849 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14854 */     // MIs[5] vB
     /*  14854 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14859 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  14863 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  14869 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  14871 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  14873 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  14873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  14876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  14878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  14882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  14886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  14890 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  14900 */     GIR_RootConstrainSelectedInstOperands,
     /*  14901 */     // GIR_Coverage, 5045,
     /*  14901 */     GIR_EraseRootFromParent_Done,
     /*  14902 */   // Label 331: @14902
     /*  14902 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15040), // Rule ID 5046 //
     /*  14907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  14910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  14914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  14938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  14950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  14954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  14966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14970 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14974 */     // MIs[4] vC
     /*  14974 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  14979 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  14983 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  14987 */     // MIs[5] vB
     /*  14987 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  14992 */     // MIs[5] vA
     /*  14992 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  14997 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15001 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15007 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15009 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15011 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15028 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15038 */     GIR_RootConstrainSelectedInstOperands,
     /*  15039 */     // GIR_Coverage, 5046,
     /*  15039 */     GIR_EraseRootFromParent_Done,
     /*  15040 */   // Label 332: @15040
     /*  15040 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(15178), // Rule ID 5047 //
     /*  15045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15084 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15088 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15092 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15096 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15100 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15104 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15108 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15112 */     // MIs[4] vB
     /*  15112 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15117 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15121 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15125 */     // MIs[5] vA
     /*  15125 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15130 */     // MIs[5] vC
     /*  15130 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15135 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15139 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15145 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15147 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15149 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15166 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15176 */     GIR_RootConstrainSelectedInstOperands,
     /*  15177 */     // GIR_Coverage, 5047,
     /*  15177 */     GIR_EraseRootFromParent_Done,
     /*  15178 */   // Label 333: @15178
     /*  15178 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(15316), // Rule ID 5048 //
     /*  15183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15230 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15234 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15238 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15242 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15246 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15250 */     // MIs[4] vB
     /*  15250 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15255 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15259 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15263 */     // MIs[5] vC
     /*  15263 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15268 */     // MIs[5] vA
     /*  15268 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15273 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15277 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15285 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15287 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15304 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15314 */     GIR_RootConstrainSelectedInstOperands,
     /*  15315 */     // GIR_Coverage, 5048,
     /*  15315 */     GIR_EraseRootFromParent_Done,
     /*  15316 */   // Label 334: @15316
     /*  15316 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(15454), // Rule ID 5049 //
     /*  15321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15380 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15384 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15388 */     // MIs[4] vA
     /*  15388 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15393 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15397 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15401 */     // MIs[5] vB
     /*  15401 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15406 */     // MIs[5] vC
     /*  15406 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15411 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15415 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15423 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15425 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15442 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15452 */     GIR_RootConstrainSelectedInstOperands,
     /*  15453 */     // GIR_Coverage, 5049,
     /*  15453 */     GIR_EraseRootFromParent_Done,
     /*  15454 */   // Label 335: @15454
     /*  15454 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(15592), // Rule ID 5050 //
     /*  15459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15506 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15510 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15514 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15518 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15522 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15526 */     // MIs[4] vA
     /*  15526 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  15531 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  15535 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15539 */     // MIs[5] vC
     /*  15539 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15544 */     // MIs[5] vB
     /*  15544 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15549 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15553 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15561 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15563 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  15572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  15580 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15590 */     GIR_RootConstrainSelectedInstOperands,
     /*  15591 */     // GIR_Coverage, 5050,
     /*  15591 */     GIR_EraseRootFromParent_Done,
     /*  15592 */   // Label 336: @15592
     /*  15592 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(15730), // Rule ID 5051 //
     /*  15597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15640 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15644 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15648 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15660 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15668 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15672 */     // MIs[5] vA
     /*  15672 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15677 */     // MIs[5] vB
     /*  15677 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15682 */     // MIs[4] vC
     /*  15682 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15687 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15691 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15699 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15701 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15718 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15728 */     GIR_RootConstrainSelectedInstOperands,
     /*  15729 */     // GIR_Coverage, 5051,
     /*  15729 */     GIR_EraseRootFromParent_Done,
     /*  15730 */   // Label 337: @15730
     /*  15730 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(15868), // Rule ID 5052 //
     /*  15735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15782 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15786 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15790 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15794 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15798 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15802 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15806 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15810 */     // MIs[5] vB
     /*  15810 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15815 */     // MIs[5] vA
     /*  15815 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15820 */     // MIs[4] vC
     /*  15820 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15825 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15829 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15835 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15837 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15839 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15856 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  15866 */     GIR_RootConstrainSelectedInstOperands,
     /*  15867 */     // GIR_Coverage, 5052,
     /*  15867 */     GIR_EraseRootFromParent_Done,
     /*  15868 */   // Label 338: @15868
     /*  15868 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(16006), // Rule ID 5053 //
     /*  15873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  15876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  15880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  15904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15908 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  15916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  15920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  15928 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  15932 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15936 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15940 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  15944 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  15948 */     // MIs[5] vA
     /*  15948 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  15953 */     // MIs[5] vC
     /*  15953 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  15958 */     // MIs[4] vB
     /*  15958 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  15963 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  15967 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  15973 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  15975 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  15977 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  15977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  15980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  15982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  15986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  15990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  15994 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16004 */     GIR_RootConstrainSelectedInstOperands,
     /*  16005 */     // GIR_Coverage, 5053,
     /*  16005 */     GIR_EraseRootFromParent_Done,
     /*  16006 */   // Label 339: @16006
     /*  16006 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(16144), // Rule ID 5054 //
     /*  16011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16030 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16066 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16070 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16074 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16078 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16082 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16086 */     // MIs[5] vC
     /*  16086 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16091 */     // MIs[5] vA
     /*  16091 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16096 */     // MIs[4] vB
     /*  16096 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16101 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16105 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16111 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16113 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16115 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16132 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16142 */     GIR_RootConstrainSelectedInstOperands,
     /*  16143 */     // GIR_Coverage, 5054,
     /*  16143 */     GIR_EraseRootFromParent_Done,
     /*  16144 */   // Label 340: @16144
     /*  16144 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(16282), // Rule ID 5055 //
     /*  16149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16200 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16204 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16208 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16212 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16216 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16220 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16224 */     // MIs[5] vB
     /*  16224 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16229 */     // MIs[5] vC
     /*  16229 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16234 */     // MIs[4] vA
     /*  16234 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16239 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16243 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16249 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16251 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16253 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16270 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16280 */     GIR_RootConstrainSelectedInstOperands,
     /*  16281 */     // GIR_Coverage, 5055,
     /*  16281 */     GIR_EraseRootFromParent_Done,
     /*  16282 */   // Label 341: @16282
     /*  16282 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(16420), // Rule ID 5056 //
     /*  16287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16334 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16338 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16342 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16346 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16350 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16354 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16358 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16362 */     // MIs[5] vC
     /*  16362 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16367 */     // MIs[5] vB
     /*  16367 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16372 */     // MIs[4] vA
     /*  16372 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16377 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16381 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16389 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16391 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  16400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  16404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16408 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16418 */     GIR_RootConstrainSelectedInstOperands,
     /*  16419 */     // GIR_Coverage, 5056,
     /*  16419 */     GIR_EraseRootFromParent_Done,
     /*  16420 */   // Label 342: @16420
     /*  16420 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(16558), // Rule ID 5063 //
     /*  16425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16460 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16472 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16476 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16480 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16484 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16488 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16492 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16496 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16500 */     // MIs[5] vA
     /*  16500 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16505 */     // MIs[5] vB
     /*  16505 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16510 */     // MIs[4] vC
     /*  16510 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16515 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16519 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16527 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16529 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16546 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16556 */     GIR_RootConstrainSelectedInstOperands,
     /*  16557 */     // GIR_Coverage, 5063,
     /*  16557 */     GIR_EraseRootFromParent_Done,
     /*  16558 */   // Label 343: @16558
     /*  16558 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(16696), // Rule ID 5064 //
     /*  16563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16606 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16610 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16614 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16622 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16626 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16630 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16634 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16638 */     // MIs[5] vB
     /*  16638 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16643 */     // MIs[5] vA
     /*  16643 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16648 */     // MIs[4] vC
     /*  16648 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16653 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16657 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16665 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16667 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16684 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16694 */     GIR_RootConstrainSelectedInstOperands,
     /*  16695 */     // GIR_Coverage, 5064,
     /*  16695 */     GIR_EraseRootFromParent_Done,
     /*  16696 */   // Label 344: @16696
     /*  16696 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(16834), // Rule ID 5065 //
     /*  16701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16748 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16756 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16760 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16764 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16768 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16772 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16776 */     // MIs[5] vA
     /*  16776 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16781 */     // MIs[5] vC
     /*  16781 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16786 */     // MIs[4] vB
     /*  16786 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16791 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16795 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16803 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16805 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16822 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16832 */     GIR_RootConstrainSelectedInstOperands,
     /*  16833 */     // GIR_Coverage, 5065,
     /*  16833 */     GIR_EraseRootFromParent_Done,
     /*  16834 */   // Label 345: @16834
     /*  16834 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(16972), // Rule ID 5066 //
     /*  16839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16874 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  16882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16890 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  16894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  16898 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16902 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16906 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  16910 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  16914 */     // MIs[5] vC
     /*  16914 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  16919 */     // MIs[5] vA
     /*  16919 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  16924 */     // MIs[4] vB
     /*  16924 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  16933 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  16939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  16941 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  16943 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  16943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  16946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  16948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  16952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  16956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  16960 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  16970 */     GIR_RootConstrainSelectedInstOperands,
     /*  16971 */     // GIR_Coverage, 5066,
     /*  16971 */     GIR_EraseRootFromParent_Done,
     /*  16972 */   // Label 346: @16972
     /*  16972 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17110), // Rule ID 5067 //
     /*  16977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  16980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  16984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  16992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17036 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17040 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17044 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17048 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17052 */     // MIs[5] vB
     /*  17052 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17057 */     // MIs[5] vC
     /*  17057 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17062 */     // MIs[4] vA
     /*  17062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17067 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17071 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17077 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17079 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17081 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17098 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17108 */     GIR_RootConstrainSelectedInstOperands,
     /*  17109 */     // GIR_Coverage, 5067,
     /*  17109 */     GIR_EraseRootFromParent_Done,
     /*  17110 */   // Label 347: @17110
     /*  17110 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(17248), // Rule ID 5068 //
     /*  17115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17154 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17158 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17162 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17166 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17170 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17174 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17178 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17182 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17186 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17190 */     // MIs[5] vC
     /*  17190 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17195 */     // MIs[5] vB
     /*  17195 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17200 */     // MIs[4] vA
     /*  17200 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17205 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17209 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17217 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17219 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  17228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  17232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  17236 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17246 */     GIR_RootConstrainSelectedInstOperands,
     /*  17247 */     // GIR_Coverage, 5068,
     /*  17247 */     GIR_EraseRootFromParent_Done,
     /*  17248 */   // Label 348: @17248
     /*  17248 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(17386), // Rule ID 5075 //
     /*  17253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17304 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17316 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17324 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17328 */     // MIs[5] vA
     /*  17328 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17333 */     // MIs[5] vB
     /*  17333 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17338 */     // MIs[4] vC
     /*  17338 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17343 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17347 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17355 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17357 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17374 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17384 */     GIR_RootConstrainSelectedInstOperands,
     /*  17385 */     // GIR_Coverage, 5075,
     /*  17385 */     GIR_EraseRootFromParent_Done,
     /*  17386 */   // Label 349: @17386
     /*  17386 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(17524), // Rule ID 5076 //
     /*  17391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17446 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17450 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17454 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17458 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17462 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17466 */     // MIs[5] vB
     /*  17466 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17471 */     // MIs[5] vA
     /*  17471 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17476 */     // MIs[4] vC
     /*  17476 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17481 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17485 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17491 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17493 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17495 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17512 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17522 */     GIR_RootConstrainSelectedInstOperands,
     /*  17523 */     // GIR_Coverage, 5076,
     /*  17523 */     GIR_EraseRootFromParent_Done,
     /*  17524 */   // Label 350: @17524
     /*  17524 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(17662), // Rule ID 5077 //
     /*  17529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17572 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17576 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17580 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17584 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17588 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17592 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17596 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17600 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17604 */     // MIs[5] vA
     /*  17604 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17609 */     // MIs[5] vC
     /*  17609 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17614 */     // MIs[4] vB
     /*  17614 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17619 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17623 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17629 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17631 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17633 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17650 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17660 */     GIR_RootConstrainSelectedInstOperands,
     /*  17661 */     // GIR_Coverage, 5077,
     /*  17661 */     GIR_EraseRootFromParent_Done,
     /*  17662 */   // Label 351: @17662
     /*  17662 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(17800), // Rule ID 5078 //
     /*  17667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17722 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17726 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17730 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17734 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17738 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17742 */     // MIs[5] vC
     /*  17742 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17747 */     // MIs[5] vA
     /*  17747 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17752 */     // MIs[4] vB
     /*  17752 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17757 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17761 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17767 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17769 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17771 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17788 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17798 */     GIR_RootConstrainSelectedInstOperands,
     /*  17799 */     // GIR_Coverage, 5078,
     /*  17799 */     GIR_EraseRootFromParent_Done,
     /*  17800 */   // Label 352: @17800
     /*  17800 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(17938), // Rule ID 5079 //
     /*  17805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17840 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17856 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17860 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  17864 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17868 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17872 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  17876 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  17880 */     // MIs[5] vB
     /*  17880 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  17885 */     // MIs[5] vC
     /*  17885 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  17890 */     // MIs[4] vA
     /*  17890 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  17895 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  17899 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  17905 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  17907 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  17909 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  17909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  17912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  17914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  17918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  17922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  17926 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  17936 */     GIR_RootConstrainSelectedInstOperands,
     /*  17937 */     // GIR_Coverage, 5079,
     /*  17937 */     GIR_EraseRootFromParent_Done,
     /*  17938 */   // Label 353: @17938
     /*  17938 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(18076), // Rule ID 5080 //
     /*  17943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  17946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  17950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  17974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  17986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  17998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18006 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18010 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18014 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18018 */     // MIs[5] vC
     /*  18018 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18023 */     // MIs[5] vB
     /*  18023 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18028 */     // MIs[4] vA
     /*  18028 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18033 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18037 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18045 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18047 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  18056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  18064 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18074 */     GIR_RootConstrainSelectedInstOperands,
     /*  18075 */     // GIR_Coverage, 5080,
     /*  18075 */     GIR_EraseRootFromParent_Done,
     /*  18076 */   // Label 354: @18076
     /*  18076 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(18214), // Rule ID 5087 //
     /*  18081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18116 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18140 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18144 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18148 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18152 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18156 */     // MIs[5] vA
     /*  18156 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18161 */     // MIs[5] vB
     /*  18161 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18166 */     // MIs[4] vC
     /*  18166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18171 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18175 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18181 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18183 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18185 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18202 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18212 */     GIR_RootConstrainSelectedInstOperands,
     /*  18213 */     // GIR_Coverage, 5087,
     /*  18213 */     GIR_EraseRootFromParent_Done,
     /*  18214 */   // Label 355: @18214
     /*  18214 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(18352), // Rule ID 5088 //
     /*  18219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18274 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18278 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18282 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18286 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18290 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18294 */     // MIs[5] vB
     /*  18294 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18299 */     // MIs[5] vA
     /*  18299 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18304 */     // MIs[4] vC
     /*  18304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18309 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18313 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18319 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18321 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18323 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18340 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18350 */     GIR_RootConstrainSelectedInstOperands,
     /*  18351 */     // GIR_Coverage, 5088,
     /*  18351 */     GIR_EraseRootFromParent_Done,
     /*  18352 */   // Label 356: @18352
     /*  18352 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(18490), // Rule ID 5089 //
     /*  18357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18392 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18408 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18420 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18424 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18428 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18432 */     // MIs[5] vA
     /*  18432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18437 */     // MIs[5] vC
     /*  18437 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18442 */     // MIs[4] vB
     /*  18442 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18447 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18451 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18457 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18459 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18461 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18478 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18488 */     GIR_RootConstrainSelectedInstOperands,
     /*  18489 */     // GIR_Coverage, 5089,
     /*  18489 */     GIR_EraseRootFromParent_Done,
     /*  18490 */   // Label 357: @18490
     /*  18490 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(18628), // Rule ID 5090 //
     /*  18495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18530 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18546 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18558 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18562 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18566 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18570 */     // MIs[5] vC
     /*  18570 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18575 */     // MIs[5] vA
     /*  18575 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18580 */     // MIs[4] vB
     /*  18580 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18585 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18589 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18595 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18597 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18599 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18616 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18626 */     GIR_RootConstrainSelectedInstOperands,
     /*  18627 */     // GIR_Coverage, 5090,
     /*  18627 */     GIR_EraseRootFromParent_Done,
     /*  18628 */   // Label 358: @18628
     /*  18628 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(18766), // Rule ID 5091 //
     /*  18633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18660 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18664 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18668 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18684 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18688 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18692 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18696 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18700 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18704 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18708 */     // MIs[5] vB
     /*  18708 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18713 */     // MIs[5] vC
     /*  18713 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18718 */     // MIs[4] vA
     /*  18718 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18723 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18727 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18735 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18737 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18754 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18764 */     GIR_RootConstrainSelectedInstOperands,
     /*  18765 */     // GIR_Coverage, 5091,
     /*  18765 */     GIR_EraseRootFromParent_Done,
     /*  18766 */   // Label 359: @18766
     /*  18766 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(18904), // Rule ID 5092 //
     /*  18771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18814 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18818 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18822 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18826 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18830 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18834 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18838 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18842 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18846 */     // MIs[5] vC
     /*  18846 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18851 */     // MIs[5] vB
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18856 */     // MIs[4] vA
     /*  18856 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18861 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  18865 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  18871 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  18873 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  18875 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  18875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  18878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  18880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  18884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  18888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  18892 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  18902 */     GIR_RootConstrainSelectedInstOperands,
     /*  18903 */     // GIR_Coverage, 5092,
     /*  18903 */     GIR_EraseRootFromParent_Done,
     /*  18904 */   // Label 360: @18904
     /*  18904 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(19042), // Rule ID 5099 //
     /*  18909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  18912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  18916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18944 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  18956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18960 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18964 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18968 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18972 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18976 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  18980 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  18984 */     // MIs[5] vA
     /*  18984 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  18989 */     // MIs[5] vB
     /*  18989 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18994 */     // MIs[4] vC
     /*  18994 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  18999 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19003 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19009 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19011 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19013 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19030 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19040 */     GIR_RootConstrainSelectedInstOperands,
     /*  19041 */     // GIR_Coverage, 5099,
     /*  19041 */     GIR_EraseRootFromParent_Done,
     /*  19042 */   // Label 361: @19042
     /*  19042 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(19180), // Rule ID 5100 //
     /*  19047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19082 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19090 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19094 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19098 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19102 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19106 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19110 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19114 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19118 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19122 */     // MIs[5] vB
     /*  19122 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19127 */     // MIs[5] vA
     /*  19127 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19132 */     // MIs[4] vC
     /*  19132 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19137 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19141 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19147 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19149 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19151 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19168 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19178 */     GIR_RootConstrainSelectedInstOperands,
     /*  19179 */     // GIR_Coverage, 5100,
     /*  19179 */     GIR_EraseRootFromParent_Done,
     /*  19180 */   // Label 362: @19180
     /*  19180 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(19318), // Rule ID 5101 //
     /*  19185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19224 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19228 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19232 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19236 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19240 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19244 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19248 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19252 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19256 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19260 */     // MIs[5] vA
     /*  19260 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19265 */     // MIs[5] vC
     /*  19265 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19270 */     // MIs[4] vB
     /*  19270 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19275 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19279 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19285 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19287 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19289 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19306 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19316 */     GIR_RootConstrainSelectedInstOperands,
     /*  19317 */     // GIR_Coverage, 5101,
     /*  19317 */     GIR_EraseRootFromParent_Done,
     /*  19318 */   // Label 363: @19318
     /*  19318 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(19456), // Rule ID 5102 //
     /*  19323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19370 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19374 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19378 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19382 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19386 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19390 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19394 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19398 */     // MIs[5] vC
     /*  19398 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19403 */     // MIs[5] vA
     /*  19403 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19408 */     // MIs[4] vB
     /*  19408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19413 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19417 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19423 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19425 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19427 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19444 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19454 */     GIR_RootConstrainSelectedInstOperands,
     /*  19455 */     // GIR_Coverage, 5102,
     /*  19455 */     GIR_EraseRootFromParent_Done,
     /*  19456 */   // Label 364: @19456
     /*  19456 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(19594), // Rule ID 5103 //
     /*  19461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19512 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19516 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19520 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19524 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19528 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19532 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19536 */     // MIs[5] vB
     /*  19536 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19541 */     // MIs[5] vC
     /*  19541 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19546 */     // MIs[4] vA
     /*  19546 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19551 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19555 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19561 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19563 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19565 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19582 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19592 */     GIR_RootConstrainSelectedInstOperands,
     /*  19593 */     // GIR_Coverage, 5103,
     /*  19593 */     GIR_EraseRootFromParent_Done,
     /*  19594 */   // Label 365: @19594
     /*  19594 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(19732), // Rule ID 5104 //
     /*  19599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19646 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19650 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19654 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19658 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19662 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19666 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19670 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19674 */     // MIs[5] vC
     /*  19674 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19679 */     // MIs[5] vB
     /*  19679 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19684 */     // MIs[4] vA
     /*  19684 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19689 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19693 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19699 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19701 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19703 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  19716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  19720 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19730 */     GIR_RootConstrainSelectedInstOperands,
     /*  19731 */     // GIR_Coverage, 5104,
     /*  19731 */     GIR_EraseRootFromParent_Done,
     /*  19732 */   // Label 366: @19732
     /*  19732 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(19870), // Rule ID 5110 //
     /*  19737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19776 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19780 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19784 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19788 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19792 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19796 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19800 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19804 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19808 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19812 */     // MIs[5] vA
     /*  19812 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19817 */     // MIs[5] vB
     /*  19817 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19822 */     // MIs[4] vC
     /*  19822 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19831 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19837 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19839 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19841 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19858 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  19868 */     GIR_RootConstrainSelectedInstOperands,
     /*  19869 */     // GIR_Coverage, 5110,
     /*  19869 */     GIR_EraseRootFromParent_Done,
     /*  19870 */   // Label 367: @19870
     /*  19870 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20008), // Rule ID 5111 //
     /*  19875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  19878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  19882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  19922 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19926 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19930 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19934 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19938 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19942 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  19946 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  19950 */     // MIs[5] vB
     /*  19950 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  19955 */     // MIs[5] vA
     /*  19955 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  19960 */     // MIs[4] vC
     /*  19960 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19965 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  19969 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  19975 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  19977 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  19979 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  19979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  19982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  19984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  19988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  19992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  19996 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20006 */     GIR_RootConstrainSelectedInstOperands,
     /*  20007 */     // GIR_Coverage, 5111,
     /*  20007 */     GIR_EraseRootFromParent_Done,
     /*  20008 */   // Label 368: @20008
     /*  20008 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20146), // Rule ID 5112 //
     /*  20013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20060 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20064 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20072 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20076 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20080 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20084 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20088 */     // MIs[5] vA
     /*  20088 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20093 */     // MIs[5] vC
     /*  20093 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20098 */     // MIs[4] vB
     /*  20098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20103 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20107 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20113 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20115 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20117 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20134 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20144 */     GIR_RootConstrainSelectedInstOperands,
     /*  20145 */     // GIR_Coverage, 5112,
     /*  20145 */     GIR_EraseRootFromParent_Done,
     /*  20146 */   // Label 369: @20146
     /*  20146 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20284), // Rule ID 5113 //
     /*  20151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20170 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20186 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20198 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20202 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20206 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20210 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20214 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20226 */     // MIs[5] vC
     /*  20226 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20231 */     // MIs[5] vA
     /*  20231 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20236 */     // MIs[4] vB
     /*  20236 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20241 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20245 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20253 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20255 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20272 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20282 */     GIR_RootConstrainSelectedInstOperands,
     /*  20283 */     // GIR_Coverage, 5113,
     /*  20283 */     GIR_EraseRootFromParent_Done,
     /*  20284 */   // Label 370: @20284
     /*  20284 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20422), // Rule ID 5114 //
     /*  20289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20340 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20348 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20352 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20356 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20360 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20364 */     // MIs[5] vB
     /*  20364 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20369 */     // MIs[5] vC
     /*  20369 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20374 */     // MIs[4] vA
     /*  20374 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20379 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20383 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20391 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20393 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20410 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20420 */     GIR_RootConstrainSelectedInstOperands,
     /*  20421 */     // GIR_Coverage, 5114,
     /*  20421 */     GIR_EraseRootFromParent_Done,
     /*  20422 */   // Label 371: @20422
     /*  20422 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20560), // Rule ID 5115 //
     /*  20427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20466 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20470 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20474 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20478 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20482 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20486 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20490 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20494 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  20498 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20502 */     // MIs[5] vC
     /*  20502 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20507 */     // MIs[5] vB
     /*  20507 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20512 */     // MIs[4] vA
     /*  20512 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20517 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20521 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20529 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20531 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  20548 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20558 */     GIR_RootConstrainSelectedInstOperands,
     /*  20559 */     // GIR_Coverage, 5115,
     /*  20559 */     GIR_EraseRootFromParent_Done,
     /*  20560 */   // Label 372: @20560
     /*  20560 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(20698), // Rule ID 3399 //
     /*  20565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20616 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20628 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20632 */     // MIs[4] vA
     /*  20632 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20637 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20641 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20645 */     // MIs[5] vB
     /*  20645 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20650 */     // MIs[5] vC
     /*  20650 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20655 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20659 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20665 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20667 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20669 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  20678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  20682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  20686 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20696 */     GIR_RootConstrainSelectedInstOperands,
     /*  20697 */     // GIR_Coverage, 3399,
     /*  20697 */     GIR_EraseRootFromParent_Done,
     /*  20698 */   // Label 373: @20698
     /*  20698 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(20836), // Rule ID 5057 //
     /*  20703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20738 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20750 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20754 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20758 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20762 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20766 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20770 */     // MIs[4] vC
     /*  20770 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20775 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20779 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20783 */     // MIs[5] vA
     /*  20783 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20788 */     // MIs[5] vB
     /*  20788 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20793 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20797 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20803 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20805 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20807 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20824 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20834 */     GIR_RootConstrainSelectedInstOperands,
     /*  20835 */     // GIR_Coverage, 5057,
     /*  20835 */     GIR_EraseRootFromParent_Done,
     /*  20836 */   // Label 374: @20836
     /*  20836 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(20974), // Rule ID 5058 //
     /*  20841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  20884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  20888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20896 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  20900 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20904 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20908 */     // MIs[4] vC
     /*  20908 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20913 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  20917 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  20921 */     // MIs[5] vB
     /*  20921 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  20926 */     // MIs[5] vA
     /*  20926 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  20931 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  20935 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  20941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  20943 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  20945 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  20945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  20948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  20954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  20958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  20962 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  20972 */     GIR_RootConstrainSelectedInstOperands,
     /*  20973 */     // GIR_Coverage, 5058,
     /*  20973 */     GIR_EraseRootFromParent_Done,
     /*  20974 */   // Label 375: @20974
     /*  20974 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21112), // Rule ID 5059 //
     /*  20979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  20982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  20986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21014 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21030 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21038 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21042 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21046 */     // MIs[4] vB
     /*  21046 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21051 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21055 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21059 */     // MIs[5] vA
     /*  21059 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21064 */     // MIs[5] vC
     /*  21064 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21069 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21073 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21081 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21083 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21100 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21110 */     GIR_RootConstrainSelectedInstOperands,
     /*  21111 */     // GIR_Coverage, 5059,
     /*  21111 */     GIR_EraseRootFromParent_Done,
     /*  21112 */   // Label 376: @21112
     /*  21112 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21250), // Rule ID 5060 //
     /*  21117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21156 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21160 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21164 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21168 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21172 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21176 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21180 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21184 */     // MIs[4] vB
     /*  21184 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21189 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21193 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21197 */     // MIs[5] vC
     /*  21197 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21202 */     // MIs[5] vA
     /*  21202 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21207 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21211 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21219 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21221 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21238 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21248 */     GIR_RootConstrainSelectedInstOperands,
     /*  21249 */     // GIR_Coverage, 5060,
     /*  21249 */     GIR_EraseRootFromParent_Done,
     /*  21250 */   // Label 377: @21250
     /*  21250 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21388), // Rule ID 5061 //
     /*  21255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21290 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21298 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21302 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21306 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21310 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21314 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21318 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21322 */     // MIs[4] vA
     /*  21322 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21331 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21335 */     // MIs[5] vB
     /*  21335 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21340 */     // MIs[5] vC
     /*  21340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21345 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21349 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21355 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21357 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21359 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21376 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21386 */     GIR_RootConstrainSelectedInstOperands,
     /*  21387 */     // GIR_Coverage, 5061,
     /*  21387 */     GIR_EraseRootFromParent_Done,
     /*  21388 */   // Label 378: @21388
     /*  21388 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21526), // Rule ID 5062 //
     /*  21393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21432 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21436 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21440 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21448 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21452 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21456 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21460 */     // MIs[4] vA
     /*  21460 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21465 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21469 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21473 */     // MIs[5] vC
     /*  21473 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21478 */     // MIs[5] vB
     /*  21478 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21487 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21495 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21497 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  21506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  21510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21514 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21524 */     GIR_RootConstrainSelectedInstOperands,
     /*  21525 */     // GIR_Coverage, 5062,
     /*  21525 */     GIR_EraseRootFromParent_Done,
     /*  21526 */   // Label 379: @21526
     /*  21526 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21664), // Rule ID 5069 //
     /*  21531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21566 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21578 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21582 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21590 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21594 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21598 */     // MIs[4] vC
     /*  21598 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21603 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21607 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21611 */     // MIs[5] vA
     /*  21611 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21616 */     // MIs[5] vB
     /*  21616 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21621 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21625 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21631 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21633 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21635 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21652 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21662 */     GIR_RootConstrainSelectedInstOperands,
     /*  21663 */     // GIR_Coverage, 5069,
     /*  21663 */     GIR_EraseRootFromParent_Done,
     /*  21664 */   // Label 380: @21664
     /*  21664 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21802), // Rule ID 5070 //
     /*  21669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21720 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21724 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21728 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21732 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21736 */     // MIs[4] vC
     /*  21736 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21741 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21745 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21749 */     // MIs[5] vB
     /*  21749 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21754 */     // MIs[5] vA
     /*  21754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21763 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21771 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21773 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21790 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21800 */     GIR_RootConstrainSelectedInstOperands,
     /*  21801 */     // GIR_Coverage, 5070,
     /*  21801 */     GIR_EraseRootFromParent_Done,
     /*  21802 */   // Label 381: @21802
     /*  21802 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21940), // Rule ID 5071 //
     /*  21807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21846 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21850 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21854 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21858 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21870 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21874 */     // MIs[4] vB
     /*  21874 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  21879 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  21883 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  21887 */     // MIs[5] vA
     /*  21887 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  21892 */     // MIs[5] vC
     /*  21892 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  21897 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  21901 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  21907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  21909 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  21911 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  21911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  21914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  21916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  21920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  21924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  21928 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  21938 */     GIR_RootConstrainSelectedInstOperands,
     /*  21939 */     // GIR_Coverage, 5071,
     /*  21939 */     GIR_EraseRootFromParent_Done,
     /*  21940 */   // Label 382: @21940
     /*  21940 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22078), // Rule ID 5072 //
     /*  21945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  21948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  21984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21988 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  21992 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21996 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22000 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22004 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22012 */     // MIs[4] vB
     /*  22012 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22017 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22021 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22025 */     // MIs[5] vC
     /*  22025 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22030 */     // MIs[5] vA
     /*  22030 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22035 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22039 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22045 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22047 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22049 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22066 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22076 */     GIR_RootConstrainSelectedInstOperands,
     /*  22077 */     // GIR_Coverage, 5072,
     /*  22077 */     GIR_EraseRootFromParent_Done,
     /*  22078 */   // Label 383: @22078
     /*  22078 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22216), // Rule ID 5073 //
     /*  22083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22122 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22126 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22130 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22134 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22146 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22150 */     // MIs[4] vA
     /*  22150 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22155 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22159 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22163 */     // MIs[5] vB
     /*  22163 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22168 */     // MIs[5] vC
     /*  22168 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22173 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22177 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22183 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22185 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22187 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22204 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22214 */     GIR_RootConstrainSelectedInstOperands,
     /*  22215 */     // GIR_Coverage, 5073,
     /*  22215 */     GIR_EraseRootFromParent_Done,
     /*  22216 */   // Label 384: @22216
     /*  22216 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22354), // Rule ID 5074 //
     /*  22221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22260 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22264 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22268 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22272 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22276 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22280 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22284 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22288 */     // MIs[4] vA
     /*  22288 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22293 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22297 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22301 */     // MIs[5] vC
     /*  22301 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22306 */     // MIs[5] vB
     /*  22306 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22315 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22321 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22323 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22325 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  22334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  22338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  22342 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22352 */     GIR_RootConstrainSelectedInstOperands,
     /*  22353 */     // GIR_Coverage, 5074,
     /*  22353 */     GIR_EraseRootFromParent_Done,
     /*  22354 */   // Label 385: @22354
     /*  22354 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22492), // Rule ID 5081 //
     /*  22359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22410 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22414 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22418 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22422 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22426 */     // MIs[4] vC
     /*  22426 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22431 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22435 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22439 */     // MIs[5] vA
     /*  22439 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22444 */     // MIs[5] vB
     /*  22444 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22449 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22453 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22461 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22463 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22480 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22490 */     GIR_RootConstrainSelectedInstOperands,
     /*  22491 */     // GIR_Coverage, 5081,
     /*  22491 */     GIR_EraseRootFromParent_Done,
     /*  22492 */   // Label 386: @22492
     /*  22492 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22630), // Rule ID 5082 //
     /*  22497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22528 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22548 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22556 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22560 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22564 */     // MIs[4] vC
     /*  22564 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22569 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22573 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22577 */     // MIs[5] vB
     /*  22577 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22582 */     // MIs[5] vA
     /*  22582 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22591 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22597 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22599 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22601 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22618 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22628 */     GIR_RootConstrainSelectedInstOperands,
     /*  22629 */     // GIR_Coverage, 5082,
     /*  22629 */     GIR_EraseRootFromParent_Done,
     /*  22630 */   // Label 387: @22630
     /*  22630 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22768), // Rule ID 5083 //
     /*  22635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22674 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22678 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22682 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22686 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22690 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22694 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22698 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22702 */     // MIs[4] vB
     /*  22702 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22707 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22711 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22715 */     // MIs[5] vA
     /*  22715 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22720 */     // MIs[5] vC
     /*  22720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22729 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22737 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22739 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22756 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22766 */     GIR_RootConstrainSelectedInstOperands,
     /*  22767 */     // GIR_Coverage, 5083,
     /*  22767 */     GIR_EraseRootFromParent_Done,
     /*  22768 */   // Label 388: @22768
     /*  22768 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22906), // Rule ID 5084 //
     /*  22773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22820 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22824 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22832 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22836 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22840 */     // MIs[4] vB
     /*  22840 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22853 */     // MIs[5] vC
     /*  22853 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  22858 */     // MIs[5] vA
     /*  22858 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22863 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  22867 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  22873 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  22875 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  22877 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  22877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  22880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  22882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  22886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  22890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  22894 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  22904 */     GIR_RootConstrainSelectedInstOperands,
     /*  22905 */     // GIR_Coverage, 5084,
     /*  22905 */     GIR_EraseRootFromParent_Done,
     /*  22906 */   // Label 389: @22906
     /*  22906 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23044), // Rule ID 5085 //
     /*  22911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  22914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  22918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  22978 */     // MIs[4] vA
     /*  22978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22987 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  22991 */     // MIs[5] vB
     /*  22991 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  22996 */     // MIs[5] vC
     /*  22996 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23005 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23011 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23013 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23015 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23032 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23042 */     GIR_RootConstrainSelectedInstOperands,
     /*  23043 */     // GIR_Coverage, 5085,
     /*  23043 */     GIR_EraseRootFromParent_Done,
     /*  23044 */   // Label 390: @23044
     /*  23044 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23182), // Rule ID 5086 //
     /*  23049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23096 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23100 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23112 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23116 */     // MIs[4] vA
     /*  23116 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23121 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23125 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23129 */     // MIs[5] vC
     /*  23129 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23134 */     // MIs[5] vB
     /*  23134 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23139 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23143 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23151 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23153 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  23162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  23170 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23180 */     GIR_RootConstrainSelectedInstOperands,
     /*  23181 */     // GIR_Coverage, 5086,
     /*  23181 */     GIR_EraseRootFromParent_Done,
     /*  23182 */   // Label 391: @23182
     /*  23182 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23320), // Rule ID 5093 //
     /*  23187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23230 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23234 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23242 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23246 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23250 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23254 */     // MIs[4] vC
     /*  23254 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23259 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23263 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23267 */     // MIs[5] vA
     /*  23267 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23272 */     // MIs[5] vB
     /*  23272 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23277 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23281 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23289 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23291 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23308 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23318 */     GIR_RootConstrainSelectedInstOperands,
     /*  23319 */     // GIR_Coverage, 5093,
     /*  23319 */     GIR_EraseRootFromParent_Done,
     /*  23320 */   // Label 392: @23320
     /*  23320 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23458), // Rule ID 5094 //
     /*  23325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23376 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23380 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23384 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23388 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23392 */     // MIs[4] vC
     /*  23392 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23397 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23401 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23405 */     // MIs[5] vB
     /*  23405 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23410 */     // MIs[5] vA
     /*  23410 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23415 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23419 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23427 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23429 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23446 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23456 */     GIR_RootConstrainSelectedInstOperands,
     /*  23457 */     // GIR_Coverage, 5094,
     /*  23457 */     GIR_EraseRootFromParent_Done,
     /*  23458 */   // Label 393: @23458
     /*  23458 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23596), // Rule ID 5095 //
     /*  23463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23498 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23506 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23510 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23514 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23518 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23522 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23526 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23530 */     // MIs[4] vB
     /*  23530 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23535 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23539 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23543 */     // MIs[5] vA
     /*  23543 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23548 */     // MIs[5] vC
     /*  23548 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23553 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23557 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23563 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23565 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23567 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23584 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23594 */     GIR_RootConstrainSelectedInstOperands,
     /*  23595 */     // GIR_Coverage, 5095,
     /*  23595 */     GIR_EraseRootFromParent_Done,
     /*  23596 */   // Label 394: @23596
     /*  23596 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23734), // Rule ID 5096 //
     /*  23601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23644 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23648 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23652 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23656 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23660 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23664 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23668 */     // MIs[4] vB
     /*  23668 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23673 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23677 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23681 */     // MIs[5] vC
     /*  23681 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23686 */     // MIs[5] vA
     /*  23686 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23691 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23695 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23701 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23703 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23705 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23722 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23732 */     GIR_RootConstrainSelectedInstOperands,
     /*  23733 */     // GIR_Coverage, 5096,
     /*  23733 */     GIR_EraseRootFromParent_Done,
     /*  23734 */   // Label 395: @23734
     /*  23734 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23872), // Rule ID 5097 //
     /*  23739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23774 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23786 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23794 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23798 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23802 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23806 */     // MIs[4] vA
     /*  23806 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23811 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23815 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23819 */     // MIs[5] vB
     /*  23819 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23824 */     // MIs[5] vC
     /*  23824 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23829 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23833 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23841 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23843 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23860 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  23870 */     GIR_RootConstrainSelectedInstOperands,
     /*  23871 */     // GIR_Coverage, 5097,
     /*  23871 */     GIR_EraseRootFromParent_Done,
     /*  23872 */   // Label 396: @23872
     /*  23872 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24010), // Rule ID 5098 //
     /*  23877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  23880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  23884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  23904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  23908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  23920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  23924 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23928 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23932 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  23936 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23940 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23944 */     // MIs[4] vA
     /*  23944 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  23949 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  23953 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  23957 */     // MIs[5] vC
     /*  23957 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  23962 */     // MIs[5] vB
     /*  23962 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  23967 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  23971 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  23977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  23979 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  23981 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  23981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  23984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  23986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  23990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  23994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  23998 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24008 */     GIR_RootConstrainSelectedInstOperands,
     /*  24009 */     // GIR_Coverage, 5098,
     /*  24009 */     GIR_EraseRootFromParent_Done,
     /*  24010 */   // Label 397: @24010
     /*  24010 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24148), // Rule ID 5105 //
     /*  24015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24050 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24070 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24074 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24078 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24082 */     // MIs[4] vC
     /*  24082 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24087 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24091 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24095 */     // MIs[5] vA
     /*  24095 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24100 */     // MIs[5] vB
     /*  24100 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24105 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24109 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24115 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24117 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24119 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24136 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24146 */     GIR_RootConstrainSelectedInstOperands,
     /*  24147 */     // GIR_Coverage, 5105,
     /*  24147 */     GIR_EraseRootFromParent_Done,
     /*  24148 */   // Label 398: @24148
     /*  24148 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24286), // Rule ID 5106 //
     /*  24153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24200 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24204 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24216 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24220 */     // MIs[4] vC
     /*  24220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24229 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24233 */     // MIs[5] vB
     /*  24233 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24238 */     // MIs[5] vA
     /*  24238 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24243 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24247 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24253 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24255 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24257 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24274 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24284 */     GIR_RootConstrainSelectedInstOperands,
     /*  24285 */     // GIR_Coverage, 5106,
     /*  24285 */     GIR_EraseRootFromParent_Done,
     /*  24286 */   // Label 399: @24286
     /*  24286 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24424), // Rule ID 5107 //
     /*  24291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24338 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24342 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24346 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24350 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24354 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24358 */     // MIs[4] vB
     /*  24358 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24363 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24367 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24371 */     // MIs[5] vA
     /*  24371 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24376 */     // MIs[5] vC
     /*  24376 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24381 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24385 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24393 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24395 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24412 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24422 */     GIR_RootConstrainSelectedInstOperands,
     /*  24423 */     // GIR_Coverage, 5107,
     /*  24423 */     GIR_EraseRootFromParent_Done,
     /*  24424 */   // Label 400: @24424
     /*  24424 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24562), // Rule ID 5108 //
     /*  24429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24480 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24484 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24488 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24492 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24496 */     // MIs[4] vB
     /*  24496 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24501 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24505 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24509 */     // MIs[5] vC
     /*  24509 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24514 */     // MIs[5] vA
     /*  24514 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24519 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24523 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24529 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24531 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24533 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24550 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24560 */     GIR_RootConstrainSelectedInstOperands,
     /*  24561 */     // GIR_Coverage, 5108,
     /*  24561 */     GIR_EraseRootFromParent_Done,
     /*  24562 */   // Label 401: @24562
     /*  24562 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24700), // Rule ID 5109 //
     /*  24567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24614 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24618 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24626 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24630 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24634 */     // MIs[4] vA
     /*  24634 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24639 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24643 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24647 */     // MIs[5] vC
     /*  24647 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24652 */     // MIs[5] vB
     /*  24652 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24657 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24661 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24667 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24669 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24671 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  24684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  24688 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 5109,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 402: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24838), // Rule ID 5116 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24760 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24764 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24768 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24772 */     // MIs[4] vC
     /*  24772 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24777 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24781 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24785 */     // MIs[5] vA
     /*  24785 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24790 */     // MIs[5] vB
     /*  24790 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24795 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24799 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24807 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24809 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24826 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24836 */     GIR_RootConstrainSelectedInstOperands,
     /*  24837 */     // GIR_Coverage, 5116,
     /*  24837 */     GIR_EraseRootFromParent_Done,
     /*  24838 */   // Label 403: @24838
     /*  24838 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24976), // Rule ID 5117 //
     /*  24843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  24886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  24890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24894 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24898 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  24902 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24906 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24910 */     // MIs[4] vC
     /*  24910 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  24915 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  24919 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  24923 */     // MIs[5] vB
     /*  24923 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  24928 */     // MIs[5] vA
     /*  24928 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  24933 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  24937 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  24943 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  24945 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  24947 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  24947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  24950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  24952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  24956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  24960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  24964 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  24974 */     GIR_RootConstrainSelectedInstOperands,
     /*  24975 */     // GIR_Coverage, 5117,
     /*  24975 */     GIR_EraseRootFromParent_Done,
     /*  24976 */   // Label 404: @24976
     /*  24976 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(25114), // Rule ID 5118 //
     /*  24981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  24984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  24988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  24996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25020 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25024 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25028 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25032 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25040 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25044 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25048 */     // MIs[4] vB
     /*  25048 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25053 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25057 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25061 */     // MIs[5] vA
     /*  25061 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25066 */     // MIs[5] vC
     /*  25066 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25071 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25075 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25083 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25085 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25102 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25112 */     GIR_RootConstrainSelectedInstOperands,
     /*  25113 */     // GIR_Coverage, 5118,
     /*  25113 */     GIR_EraseRootFromParent_Done,
     /*  25114 */   // Label 405: @25114
     /*  25114 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(25252), // Rule ID 5119 //
     /*  25119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25170 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25178 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25182 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25186 */     // MIs[4] vB
     /*  25186 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25191 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25195 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25199 */     // MIs[5] vC
     /*  25199 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25204 */     // MIs[5] vA
     /*  25204 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25209 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25213 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25219 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25221 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25223 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25240 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25250 */     GIR_RootConstrainSelectedInstOperands,
     /*  25251 */     // GIR_Coverage, 5119,
     /*  25251 */     GIR_EraseRootFromParent_Done,
     /*  25252 */   // Label 406: @25252
     /*  25252 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(25390), // Rule ID 5120 //
     /*  25257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25292 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25296 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25300 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25304 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25308 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25312 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25316 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25320 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25324 */     // MIs[4] vA
     /*  25324 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25329 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25333 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25337 */     // MIs[5] vB
     /*  25337 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25342 */     // MIs[5] vC
     /*  25342 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25347 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25351 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25357 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25359 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25361 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25378 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25388 */     GIR_RootConstrainSelectedInstOperands,
     /*  25389 */     // GIR_Coverage, 5120,
     /*  25389 */     GIR_EraseRootFromParent_Done,
     /*  25390 */   // Label 407: @25390
     /*  25390 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(25528), // Rule ID 5121 //
     /*  25395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  25438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25442 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25446 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25450 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  25454 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25458 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25462 */     // MIs[4] vA
     /*  25462 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  25467 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  25471 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25475 */     // MIs[5] vC
     /*  25475 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  25480 */     // MIs[5] vB
     /*  25480 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25485 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/3, /*OpIdx*/2, // MIs[6]
     /*  25489 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  25497 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25499 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  25508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  25512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  25516 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25526 */     GIR_RootConstrainSelectedInstOperands,
     /*  25527 */     // GIR_Coverage, 5121,
     /*  25527 */     GIR_EraseRootFromParent_Done,
     /*  25528 */   // Label 408: @25528
     /*  25528 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25666), // Rule ID 5122 //
     /*  25533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25584 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25588 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25592 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25598 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25600 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25604 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25608 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25612 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25616 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25620 */     // MIs[6] vA
     /*  25620 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25625 */     // MIs[6] vB
     /*  25625 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25630 */     // MIs[5] vC
     /*  25630 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25635 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25637 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25654 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25664 */     GIR_RootConstrainSelectedInstOperands,
     /*  25665 */     // GIR_Coverage, 5122,
     /*  25665 */     GIR_EraseRootFromParent_Done,
     /*  25666 */   // Label 409: @25666
     /*  25666 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25804), // Rule ID 5123 //
     /*  25671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25714 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25718 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25722 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25730 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25738 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25742 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25746 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25750 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25754 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25758 */     // MIs[6] vB
     /*  25758 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25763 */     // MIs[6] vA
     /*  25763 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25768 */     // MIs[5] vC
     /*  25768 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25773 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25775 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25792 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25802 */     GIR_RootConstrainSelectedInstOperands,
     /*  25803 */     // GIR_Coverage, 5123,
     /*  25803 */     GIR_EraseRootFromParent_Done,
     /*  25804 */   // Label 410: @25804
     /*  25804 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25942), // Rule ID 5124 //
     /*  25809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25844 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25860 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25864 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  25868 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  25874 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  25876 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  25880 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25884 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25888 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  25892 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  25896 */     // MIs[6] vA
     /*  25896 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  25901 */     // MIs[6] vC
     /*  25901 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  25906 */     // MIs[5] vB
     /*  25906 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  25911 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  25913 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  25913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  25916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  25918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  25922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  25926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  25930 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  25940 */     GIR_RootConstrainSelectedInstOperands,
     /*  25941 */     // GIR_Coverage, 5124,
     /*  25941 */     GIR_EraseRootFromParent_Done,
     /*  25942 */   // Label 411: @25942
     /*  25942 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(26080), // Rule ID 5125 //
     /*  25947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  25950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  25954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  25962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  25994 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25998 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26006 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26022 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26026 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26030 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26034 */     // MIs[6] vC
     /*  26034 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26039 */     // MIs[6] vA
     /*  26039 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26044 */     // MIs[5] vB
     /*  26044 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26049 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26051 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26068 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26078 */     GIR_RootConstrainSelectedInstOperands,
     /*  26079 */     // GIR_Coverage, 5125,
     /*  26079 */     GIR_EraseRootFromParent_Done,
     /*  26080 */   // Label 412: @26080
     /*  26080 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(26218), // Rule ID 5126 //
     /*  26085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26124 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26128 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26132 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26140 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26144 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26150 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26152 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26156 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26160 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26164 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26168 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26172 */     // MIs[6] vB
     /*  26172 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26177 */     // MIs[6] vC
     /*  26177 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26182 */     // MIs[5] vA
     /*  26182 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26187 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26189 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26206 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26216 */     GIR_RootConstrainSelectedInstOperands,
     /*  26217 */     // GIR_Coverage, 5126,
     /*  26217 */     GIR_EraseRootFromParent_Done,
     /*  26218 */   // Label 413: @26218
     /*  26218 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(26356), // Rule ID 5127 //
     /*  26223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26270 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26274 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26278 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26282 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26290 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26294 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26298 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26302 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26306 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26310 */     // MIs[6] vC
     /*  26310 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26315 */     // MIs[6] vB
     /*  26315 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26320 */     // MIs[5] vA
     /*  26320 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26325 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26327 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  26336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  26340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26344 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26354 */     GIR_RootConstrainSelectedInstOperands,
     /*  26355 */     // GIR_Coverage, 5127,
     /*  26355 */     GIR_EraseRootFromParent_Done,
     /*  26356 */   // Label 414: @26356
     /*  26356 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(26494), // Rule ID 5134 //
     /*  26361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26412 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26416 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26420 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26426 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26428 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26432 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26436 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26440 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26444 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26448 */     // MIs[6] vA
     /*  26448 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26453 */     // MIs[6] vB
     /*  26453 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26458 */     // MIs[5] vC
     /*  26458 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26463 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26465 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26482 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26492 */     GIR_RootConstrainSelectedInstOperands,
     /*  26493 */     // GIR_Coverage, 5134,
     /*  26493 */     GIR_EraseRootFromParent_Done,
     /*  26494 */   // Label 415: @26494
     /*  26494 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(26632), // Rule ID 5135 //
     /*  26499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26550 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26554 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26558 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26566 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26570 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26574 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26578 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26582 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26586 */     // MIs[6] vB
     /*  26586 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26591 */     // MIs[6] vA
     /*  26591 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26596 */     // MIs[5] vC
     /*  26596 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26601 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26603 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26620 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26630 */     GIR_RootConstrainSelectedInstOperands,
     /*  26631 */     // GIR_Coverage, 5135,
     /*  26631 */     GIR_EraseRootFromParent_Done,
     /*  26632 */   // Label 416: @26632
     /*  26632 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(26770), // Rule ID 5136 //
     /*  26637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26684 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26688 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26696 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26702 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26704 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26708 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26712 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26716 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26720 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26724 */     // MIs[6] vA
     /*  26724 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26729 */     // MIs[6] vC
     /*  26729 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26734 */     // MIs[5] vB
     /*  26734 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26739 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26741 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26758 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26768 */     GIR_RootConstrainSelectedInstOperands,
     /*  26769 */     // GIR_Coverage, 5136,
     /*  26769 */     GIR_EraseRootFromParent_Done,
     /*  26770 */   // Label 417: @26770
     /*  26770 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(26908), // Rule ID 5137 //
     /*  26775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26834 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26840 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26842 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26846 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26850 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26854 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26858 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26862 */     // MIs[6] vC
     /*  26862 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  26867 */     // MIs[6] vA
     /*  26867 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  26872 */     // MIs[5] vB
     /*  26872 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  26877 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  26879 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  26879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  26882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  26884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  26888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  26892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  26896 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  26906 */     GIR_RootConstrainSelectedInstOperands,
     /*  26907 */     // GIR_Coverage, 5137,
     /*  26907 */     GIR_EraseRootFromParent_Done,
     /*  26908 */   // Label 418: @26908
     /*  26908 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(27046), // Rule ID 5138 //
     /*  26913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  26916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  26920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  26928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26948 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  26960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  26968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  26972 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  26978 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  26980 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  26984 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  26988 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  26992 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  26996 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27000 */     // MIs[6] vB
     /*  27000 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27005 */     // MIs[6] vC
     /*  27005 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27010 */     // MIs[5] vA
     /*  27010 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27015 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27017 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27034 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27044 */     GIR_RootConstrainSelectedInstOperands,
     /*  27045 */     // GIR_Coverage, 5138,
     /*  27045 */     GIR_EraseRootFromParent_Done,
     /*  27046 */   // Label 419: @27046
     /*  27046 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(27184), // Rule ID 5139 //
     /*  27051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27086 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27106 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27110 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27118 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27122 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27126 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27130 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27134 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27138 */     // MIs[6] vC
     /*  27138 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27143 */     // MIs[6] vB
     /*  27143 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27148 */     // MIs[5] vA
     /*  27148 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27153 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27155 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  27164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  27168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  27172 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27182 */     GIR_RootConstrainSelectedInstOperands,
     /*  27183 */     // GIR_Coverage, 5139,
     /*  27183 */     GIR_EraseRootFromParent_Done,
     /*  27184 */   // Label 420: @27184
     /*  27184 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(27322), // Rule ID 5146 //
     /*  27189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27236 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27240 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27244 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27248 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27254 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27256 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27260 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27264 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27268 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27272 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27276 */     // MIs[6] vA
     /*  27276 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27281 */     // MIs[6] vB
     /*  27281 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27286 */     // MIs[5] vC
     /*  27286 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27291 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27293 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27310 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27320 */     GIR_RootConstrainSelectedInstOperands,
     /*  27321 */     // GIR_Coverage, 5146,
     /*  27321 */     GIR_EraseRootFromParent_Done,
     /*  27322 */   // Label 421: @27322
     /*  27322 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(27460), // Rule ID 5147 //
     /*  27327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27362 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27382 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27386 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27392 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27394 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27398 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27402 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27406 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27410 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27414 */     // MIs[6] vB
     /*  27414 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27419 */     // MIs[6] vA
     /*  27419 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27424 */     // MIs[5] vC
     /*  27424 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27429 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27431 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27448 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27458 */     GIR_RootConstrainSelectedInstOperands,
     /*  27459 */     // GIR_Coverage, 5147,
     /*  27459 */     GIR_EraseRootFromParent_Done,
     /*  27460 */   // Label 422: @27460
     /*  27460 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(27598), // Rule ID 5148 //
     /*  27465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27512 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27516 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27524 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27532 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27536 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27540 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27544 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27548 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27552 */     // MIs[6] vA
     /*  27552 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27557 */     // MIs[6] vC
     /*  27557 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27562 */     // MIs[5] vB
     /*  27562 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27567 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27569 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27586 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27596 */     GIR_RootConstrainSelectedInstOperands,
     /*  27597 */     // GIR_Coverage, 5148,
     /*  27597 */     GIR_EraseRootFromParent_Done,
     /*  27598 */   // Label 423: @27598
     /*  27598 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(27736), // Rule ID 5149 //
     /*  27603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27638 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27642 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27646 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27650 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27654 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27658 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27662 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27670 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27674 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27678 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27682 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27686 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27690 */     // MIs[6] vC
     /*  27690 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27695 */     // MIs[6] vA
     /*  27695 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27700 */     // MIs[5] vB
     /*  27700 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27705 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27707 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27724 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27734 */     GIR_RootConstrainSelectedInstOperands,
     /*  27735 */     // GIR_Coverage, 5149,
     /*  27735 */     GIR_EraseRootFromParent_Done,
     /*  27736 */   // Label 424: @27736
     /*  27736 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(27874), // Rule ID 5150 //
     /*  27741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27776 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27792 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27796 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27800 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27806 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27808 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27812 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27816 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27820 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27824 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27828 */     // MIs[6] vB
     /*  27828 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27833 */     // MIs[6] vC
     /*  27833 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27838 */     // MIs[5] vA
     /*  27838 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27843 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27845 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  27862 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  27872 */     GIR_RootConstrainSelectedInstOperands,
     /*  27873 */     // GIR_Coverage, 5150,
     /*  27873 */     GIR_EraseRootFromParent_Done,
     /*  27874 */   // Label 425: @27874
     /*  27874 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(28012), // Rule ID 5151 //
     /*  27879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  27882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  27886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  27894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27922 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  27926 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27930 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  27934 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  27938 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  27944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  27946 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  27950 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27954 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  27958 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  27962 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  27966 */     // MIs[6] vC
     /*  27966 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  27971 */     // MIs[6] vB
     /*  27971 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  27976 */     // MIs[5] vA
     /*  27976 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  27981 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  27983 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  27983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  27986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  27988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  27992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  27996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28000 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28010 */     GIR_RootConstrainSelectedInstOperands,
     /*  28011 */     // GIR_Coverage, 5151,
     /*  28011 */     GIR_EraseRootFromParent_Done,
     /*  28012 */   // Label 426: @28012
     /*  28012 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(28150), // Rule ID 5158 //
     /*  28017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28068 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28076 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28084 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28088 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28092 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28096 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28100 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28104 */     // MIs[6] vA
     /*  28104 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28109 */     // MIs[6] vB
     /*  28109 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28114 */     // MIs[5] vC
     /*  28114 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28119 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28121 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28138 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28148 */     GIR_RootConstrainSelectedInstOperands,
     /*  28149 */     // GIR_Coverage, 5158,
     /*  28149 */     GIR_EraseRootFromParent_Done,
     /*  28150 */   // Label 427: @28150
     /*  28150 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(28288), // Rule ID 5159 //
     /*  28155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28210 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28214 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28220 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28222 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28226 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28230 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28234 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28238 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28242 */     // MIs[6] vB
     /*  28242 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28247 */     // MIs[6] vA
     /*  28247 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28252 */     // MIs[5] vC
     /*  28252 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28257 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28259 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28286 */     GIR_RootConstrainSelectedInstOperands,
     /*  28287 */     // GIR_Coverage, 5159,
     /*  28287 */     GIR_EraseRootFromParent_Done,
     /*  28288 */   // Label 428: @28288
     /*  28288 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(28426), // Rule ID 5160 //
     /*  28293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28336 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28340 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28344 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28348 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28352 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28358 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28360 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28364 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28368 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28376 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28380 */     // MIs[6] vA
     /*  28380 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28385 */     // MIs[6] vC
     /*  28385 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28390 */     // MIs[5] vB
     /*  28390 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28395 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28397 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28414 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28424 */     GIR_RootConstrainSelectedInstOperands,
     /*  28425 */     // GIR_Coverage, 5160,
     /*  28425 */     GIR_EraseRootFromParent_Done,
     /*  28426 */   // Label 429: @28426
     /*  28426 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(28564), // Rule ID 5161 //
     /*  28431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28478 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28490 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28496 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28498 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28502 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28506 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28510 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28514 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28518 */     // MIs[6] vC
     /*  28518 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28523 */     // MIs[6] vA
     /*  28523 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28528 */     // MIs[5] vB
     /*  28528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28533 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28535 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28552 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28562 */     GIR_RootConstrainSelectedInstOperands,
     /*  28563 */     // GIR_Coverage, 5161,
     /*  28563 */     GIR_EraseRootFromParent_Done,
     /*  28564 */   // Label 430: @28564
     /*  28564 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(28702), // Rule ID 5162 //
     /*  28569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28620 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28624 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28628 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28634 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28636 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28640 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28644 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28648 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28652 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28656 */     // MIs[6] vB
     /*  28656 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28661 */     // MIs[6] vC
     /*  28661 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28666 */     // MIs[5] vA
     /*  28666 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28671 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28673 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28690 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28700 */     GIR_RootConstrainSelectedInstOperands,
     /*  28701 */     // GIR_Coverage, 5162,
     /*  28701 */     GIR_EraseRootFromParent_Done,
     /*  28702 */   // Label 431: @28702
     /*  28702 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(28840), // Rule ID 5163 //
     /*  28707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28766 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28774 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28778 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28782 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28786 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28790 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28794 */     // MIs[6] vC
     /*  28794 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28799 */     // MIs[6] vB
     /*  28799 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28804 */     // MIs[5] vA
     /*  28804 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28809 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28811 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  28820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  28824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  28828 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28838 */     GIR_RootConstrainSelectedInstOperands,
     /*  28839 */     // GIR_Coverage, 5163,
     /*  28839 */     GIR_EraseRootFromParent_Done,
     /*  28840 */   // Label 432: @28840
     /*  28840 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(28978), // Rule ID 5170 //
     /*  28845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28880 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  28888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  28892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28896 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  28900 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  28904 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  28910 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  28912 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  28916 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28920 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28924 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  28928 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  28932 */     // MIs[6] vA
     /*  28932 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  28937 */     // MIs[6] vB
     /*  28937 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  28942 */     // MIs[5] vC
     /*  28942 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  28947 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  28949 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  28949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  28952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  28954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  28958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  28962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  28966 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  28976 */     GIR_RootConstrainSelectedInstOperands,
     /*  28977 */     // GIR_Coverage, 5170,
     /*  28977 */     GIR_EraseRootFromParent_Done,
     /*  28978 */   // Label 433: @28978
     /*  28978 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(29116), // Rule ID 5171 //
     /*  28983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  28986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  28990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  28998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29018 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29034 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29038 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29042 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29048 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29050 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29054 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29058 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29062 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29066 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29070 */     // MIs[6] vB
     /*  29070 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29075 */     // MIs[6] vA
     /*  29075 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29080 */     // MIs[5] vC
     /*  29080 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29085 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29087 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29104 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29114 */     GIR_RootConstrainSelectedInstOperands,
     /*  29115 */     // GIR_Coverage, 5171,
     /*  29115 */     GIR_EraseRootFromParent_Done,
     /*  29116 */   // Label 434: @29116
     /*  29116 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(29254), // Rule ID 5172 //
     /*  29121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29172 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29176 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29180 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29186 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29188 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29192 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29196 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29200 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29204 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29208 */     // MIs[6] vA
     /*  29208 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29213 */     // MIs[6] vC
     /*  29213 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29218 */     // MIs[5] vB
     /*  29218 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29223 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29225 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29242 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29252 */     GIR_RootConstrainSelectedInstOperands,
     /*  29253 */     // GIR_Coverage, 5172,
     /*  29253 */     GIR_EraseRootFromParent_Done,
     /*  29254 */   // Label 435: @29254
     /*  29254 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(29392), // Rule ID 5173 //
     /*  29259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29306 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29310 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29314 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29318 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29324 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29326 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29330 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29334 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29338 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29342 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29346 */     // MIs[6] vC
     /*  29346 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29351 */     // MIs[6] vA
     /*  29351 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29356 */     // MIs[5] vB
     /*  29356 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29361 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29363 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29380 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29390 */     GIR_RootConstrainSelectedInstOperands,
     /*  29391 */     // GIR_Coverage, 5173,
     /*  29391 */     GIR_EraseRootFromParent_Done,
     /*  29392 */   // Label 436: @29392
     /*  29392 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(29530), // Rule ID 5174 //
     /*  29397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29444 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29448 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29452 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29456 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29464 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29468 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29472 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29476 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29480 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29484 */     // MIs[6] vB
     /*  29484 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29489 */     // MIs[6] vC
     /*  29489 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29494 */     // MIs[5] vA
     /*  29494 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29499 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29501 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29518 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29528 */     GIR_RootConstrainSelectedInstOperands,
     /*  29529 */     // GIR_Coverage, 5174,
     /*  29529 */     GIR_EraseRootFromParent_Done,
     /*  29530 */   // Label 437: @29530
     /*  29530 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(29668), // Rule ID 5175 //
     /*  29535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29570 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29582 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29586 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29590 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29594 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29602 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29606 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29610 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29614 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29618 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29622 */     // MIs[6] vC
     /*  29622 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29627 */     // MIs[6] vB
     /*  29627 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29632 */     // MIs[5] vA
     /*  29632 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29637 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29639 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  29652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  29656 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29666 */     GIR_RootConstrainSelectedInstOperands,
     /*  29667 */     // GIR_Coverage, 5175,
     /*  29667 */     GIR_EraseRootFromParent_Done,
     /*  29668 */   // Label 438: @29668
     /*  29668 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(29806), // Rule ID 5182 //
     /*  29673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29712 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29716 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29720 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29724 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29740 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29744 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29748 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29752 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29756 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29760 */     // MIs[6] vA
     /*  29760 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29765 */     // MIs[6] vB
     /*  29765 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29770 */     // MIs[5] vC
     /*  29770 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29775 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29777 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29794 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29804 */     GIR_RootConstrainSelectedInstOperands,
     /*  29805 */     // GIR_Coverage, 5182,
     /*  29805 */     GIR_EraseRootFromParent_Done,
     /*  29806 */   // Label 439: @29806
     /*  29806 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(29944), // Rule ID 5183 //
     /*  29811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29854 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29858 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29862 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29866 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  29870 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  29876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  29878 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  29882 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29886 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29890 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  29894 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  29898 */     // MIs[6] vB
     /*  29898 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  29903 */     // MIs[6] vA
     /*  29903 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  29908 */     // MIs[5] vC
     /*  29908 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  29913 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  29915 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  29915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  29918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  29920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  29924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  29928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  29932 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  29942 */     GIR_RootConstrainSelectedInstOperands,
     /*  29943 */     // GIR_Coverage, 5183,
     /*  29943 */     GIR_EraseRootFromParent_Done,
     /*  29944 */   // Label 440: @29944
     /*  29944 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(30082), // Rule ID 5184 //
     /*  29949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  29952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  29956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  29964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  29976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  29992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  29996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30008 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30014 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30016 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30020 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30024 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30028 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30032 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30036 */     // MIs[6] vA
     /*  30036 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30041 */     // MIs[6] vC
     /*  30041 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30046 */     // MIs[5] vB
     /*  30046 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30051 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30053 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30070 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30080 */     GIR_RootConstrainSelectedInstOperands,
     /*  30081 */     // GIR_Coverage, 5184,
     /*  30081 */     GIR_EraseRootFromParent_Done,
     /*  30082 */   // Label 441: @30082
     /*  30082 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(30220), // Rule ID 5185 //
     /*  30087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30122 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30130 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30134 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30138 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30142 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30146 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30154 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30158 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30162 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30166 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30170 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30174 */     // MIs[6] vC
     /*  30174 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30179 */     // MIs[6] vA
     /*  30179 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30184 */     // MIs[5] vB
     /*  30184 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30189 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30191 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30208 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30218 */     GIR_RootConstrainSelectedInstOperands,
     /*  30219 */     // GIR_Coverage, 5185,
     /*  30219 */     GIR_EraseRootFromParent_Done,
     /*  30220 */   // Label 442: @30220
     /*  30220 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(30358), // Rule ID 5186 //
     /*  30225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30276 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30280 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30284 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30290 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30292 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30296 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30300 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30304 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30308 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30312 */     // MIs[6] vB
     /*  30312 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30317 */     // MIs[6] vC
     /*  30317 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30322 */     // MIs[5] vA
     /*  30322 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30327 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30329 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30346 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30356 */     GIR_RootConstrainSelectedInstOperands,
     /*  30357 */     // GIR_Coverage, 5186,
     /*  30357 */     GIR_EraseRootFromParent_Done,
     /*  30358 */   // Label 443: @30358
     /*  30358 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(30496), // Rule ID 5187 //
     /*  30363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30418 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30422 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30430 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30434 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30438 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30442 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  30446 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30450 */     // MIs[6] vC
     /*  30450 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30455 */     // MIs[6] vB
     /*  30455 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30460 */     // MIs[5] vA
     /*  30460 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30465 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30467 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  30476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  30484 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30494 */     GIR_RootConstrainSelectedInstOperands,
     /*  30495 */     // GIR_Coverage, 5187,
     /*  30495 */     GIR_EraseRootFromParent_Done,
     /*  30496 */   // Label 444: @30496
     /*  30496 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(30634), // Rule ID 5128 //
     /*  30501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30552 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30556 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30560 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30568 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30572 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30576 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30580 */     // MIs[5] vC
     /*  30580 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30585 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30589 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30593 */     // MIs[6] vA
     /*  30593 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30598 */     // MIs[6] vB
     /*  30598 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30603 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30605 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30622 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30632 */     GIR_RootConstrainSelectedInstOperands,
     /*  30633 */     // GIR_Coverage, 5128,
     /*  30633 */     GIR_EraseRootFromParent_Done,
     /*  30634 */   // Label 445: @30634
     /*  30634 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(30772), // Rule ID 5129 //
     /*  30639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30674 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30690 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30694 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30698 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30706 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30710 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30714 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30718 */     // MIs[5] vC
     /*  30718 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30723 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30727 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30731 */     // MIs[6] vB
     /*  30731 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30736 */     // MIs[6] vA
     /*  30736 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30741 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30743 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30760 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30770 */     GIR_RootConstrainSelectedInstOperands,
     /*  30771 */     // GIR_Coverage, 5129,
     /*  30771 */     GIR_EraseRootFromParent_Done,
     /*  30772 */   // Label 446: @30772
     /*  30772 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(30910), // Rule ID 5130 //
     /*  30777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30816 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30820 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30824 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30832 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30836 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30844 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30848 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30852 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30856 */     // MIs[5] vB
     /*  30856 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30861 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  30865 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30869 */     // MIs[6] vA
     /*  30869 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  30874 */     // MIs[6] vC
     /*  30874 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  30879 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  30881 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  30881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  30884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  30886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  30890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  30894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  30898 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  30908 */     GIR_RootConstrainSelectedInstOperands,
     /*  30909 */     // GIR_Coverage, 5130,
     /*  30909 */     GIR_EraseRootFromParent_Done,
     /*  30910 */   // Label 447: @30910
     /*  30910 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(31048), // Rule ID 5131 //
     /*  30915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  30918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  30922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  30930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  30942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30950 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  30958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  30962 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30966 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30970 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  30974 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  30980 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  30982 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  30986 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  30990 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30994 */     // MIs[5] vB
     /*  30994 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  30999 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31003 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31007 */     // MIs[6] vC
     /*  31007 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31012 */     // MIs[6] vA
     /*  31012 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31017 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31019 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31036 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31046 */     GIR_RootConstrainSelectedInstOperands,
     /*  31047 */     // GIR_Coverage, 5131,
     /*  31047 */     GIR_EraseRootFromParent_Done,
     /*  31048 */   // Label 448: @31048
     /*  31048 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(31186), // Rule ID 5132 //
     /*  31053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31108 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31112 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31118 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31120 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31124 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31128 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31132 */     // MIs[5] vA
     /*  31132 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31137 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31141 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31145 */     // MIs[6] vB
     /*  31145 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31150 */     // MIs[6] vC
     /*  31150 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31155 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31157 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31174 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31184 */     GIR_RootConstrainSelectedInstOperands,
     /*  31185 */     // GIR_Coverage, 5132,
     /*  31185 */     GIR_EraseRootFromParent_Done,
     /*  31186 */   // Label 449: @31186
     /*  31186 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(31324), // Rule ID 5133 //
     /*  31191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31238 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31242 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31246 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31250 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31256 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31258 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31262 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31266 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31270 */     // MIs[5] vA
     /*  31270 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31275 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31279 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31283 */     // MIs[6] vC
     /*  31283 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31288 */     // MIs[6] vB
     /*  31288 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31293 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31295 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  31304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  31308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31312 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31322 */     GIR_RootConstrainSelectedInstOperands,
     /*  31323 */     // GIR_Coverage, 5133,
     /*  31323 */     GIR_EraseRootFromParent_Done,
     /*  31324 */   // Label 450: @31324
     /*  31324 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(31462), // Rule ID 5140 //
     /*  31329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31388 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31396 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31400 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31404 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31408 */     // MIs[5] vC
     /*  31408 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31413 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31417 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31421 */     // MIs[6] vA
     /*  31421 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31426 */     // MIs[6] vB
     /*  31426 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31431 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31433 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31450 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31460 */     GIR_RootConstrainSelectedInstOperands,
     /*  31461 */     // GIR_Coverage, 5140,
     /*  31461 */     GIR_EraseRootFromParent_Done,
     /*  31462 */   // Label 451: @31462
     /*  31462 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(31600), // Rule ID 5141 //
     /*  31467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31518 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31534 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31538 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31542 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31546 */     // MIs[5] vC
     /*  31546 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31551 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31555 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31559 */     // MIs[6] vB
     /*  31559 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31564 */     // MIs[6] vA
     /*  31564 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31569 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31571 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31588 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31598 */     GIR_RootConstrainSelectedInstOperands,
     /*  31599 */     // GIR_Coverage, 5141,
     /*  31599 */     GIR_EraseRootFromParent_Done,
     /*  31600 */   // Label 452: @31600
     /*  31600 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(31738), // Rule ID 5142 //
     /*  31605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31640 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31652 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31656 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31660 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31664 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31670 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31672 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31676 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31680 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31684 */     // MIs[5] vB
     /*  31684 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31689 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31693 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31697 */     // MIs[6] vA
     /*  31697 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31702 */     // MIs[6] vC
     /*  31702 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31707 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31709 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31726 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31736 */     GIR_RootConstrainSelectedInstOperands,
     /*  31737 */     // GIR_Coverage, 5142,
     /*  31737 */     GIR_EraseRootFromParent_Done,
     /*  31738 */   // Label 453: @31738
     /*  31738 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(31876), // Rule ID 5143 //
     /*  31743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31802 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31810 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31814 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31818 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31822 */     // MIs[5] vB
     /*  31822 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31827 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31831 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31835 */     // MIs[6] vC
     /*  31835 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31840 */     // MIs[6] vA
     /*  31840 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31845 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31847 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  31864 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  31874 */     GIR_RootConstrainSelectedInstOperands,
     /*  31875 */     // GIR_Coverage, 5143,
     /*  31875 */     GIR_EraseRootFromParent_Done,
     /*  31876 */   // Label 454: @31876
     /*  31876 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(32014), // Rule ID 5144 //
     /*  31881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  31884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  31888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  31896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31916 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  31924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  31928 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31932 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  31940 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  31946 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  31948 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  31952 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31956 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  31960 */     // MIs[5] vA
     /*  31960 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  31965 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  31969 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  31973 */     // MIs[6] vB
     /*  31973 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  31978 */     // MIs[6] vC
     /*  31978 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  31983 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  31985 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  31985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  31988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  31990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  31994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  31998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32002 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32012 */     GIR_RootConstrainSelectedInstOperands,
     /*  32013 */     // GIR_Coverage, 5144,
     /*  32013 */     GIR_EraseRootFromParent_Done,
     /*  32014 */   // Label 455: @32014
     /*  32014 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(32152), // Rule ID 5145 //
     /*  32019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32058 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32062 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32066 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32070 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32078 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32086 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32090 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32094 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32098 */     // MIs[5] vA
     /*  32098 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32103 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32107 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32111 */     // MIs[6] vC
     /*  32111 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32116 */     // MIs[6] vB
     /*  32116 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32121 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32123 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  32132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  32136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  32140 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32150 */     GIR_RootConstrainSelectedInstOperands,
     /*  32151 */     // GIR_Coverage, 5145,
     /*  32151 */     GIR_EraseRootFromParent_Done,
     /*  32152 */   // Label 456: @32152
     /*  32152 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(32290), // Rule ID 5152 //
     /*  32157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32208 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32216 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32222 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32224 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32228 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32232 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32236 */     // MIs[5] vC
     /*  32236 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32241 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32245 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32249 */     // MIs[6] vA
     /*  32249 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32254 */     // MIs[6] vB
     /*  32254 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32259 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32261 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32278 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32288 */     GIR_RootConstrainSelectedInstOperands,
     /*  32289 */     // GIR_Coverage, 5152,
     /*  32289 */     GIR_EraseRootFromParent_Done,
     /*  32290 */   // Label 457: @32290
     /*  32290 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(32428), // Rule ID 5153 //
     /*  32295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32334 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32338 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32342 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32346 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32350 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32354 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32360 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32362 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32366 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32370 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32374 */     // MIs[5] vC
     /*  32374 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32379 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32383 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32387 */     // MIs[6] vB
     /*  32387 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32392 */     // MIs[6] vA
     /*  32392 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32397 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32399 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32416 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32426 */     GIR_RootConstrainSelectedInstOperands,
     /*  32427 */     // GIR_Coverage, 5153,
     /*  32427 */     GIR_EraseRootFromParent_Done,
     /*  32428 */   // Label 458: @32428
     /*  32428 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(32566), // Rule ID 5154 //
     /*  32433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32480 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32484 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32488 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32492 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32498 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32500 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32504 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32508 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32512 */     // MIs[5] vB
     /*  32512 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32517 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32521 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32525 */     // MIs[6] vA
     /*  32525 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32530 */     // MIs[6] vC
     /*  32530 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32535 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32537 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32554 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32564 */     GIR_RootConstrainSelectedInstOperands,
     /*  32565 */     // GIR_Coverage, 5154,
     /*  32565 */     GIR_EraseRootFromParent_Done,
     /*  32566 */   // Label 459: @32566
     /*  32566 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(32704), // Rule ID 5155 //
     /*  32571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32618 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32622 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32630 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32638 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32642 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32646 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32650 */     // MIs[5] vB
     /*  32650 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32655 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32659 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32663 */     // MIs[6] vC
     /*  32663 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32668 */     // MIs[6] vA
     /*  32668 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32673 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32675 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32692 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32702 */     GIR_RootConstrainSelectedInstOperands,
     /*  32703 */     // GIR_Coverage, 5155,
     /*  32703 */     GIR_EraseRootFromParent_Done,
     /*  32704 */   // Label 460: @32704
     /*  32704 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(32842), // Rule ID 5156 //
     /*  32709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32728 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32748 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32752 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32756 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32760 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32768 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32776 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32780 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32784 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32788 */     // MIs[5] vA
     /*  32788 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32793 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32797 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32801 */     // MIs[6] vB
     /*  32801 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32806 */     // MIs[6] vC
     /*  32806 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32811 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32813 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32830 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32840 */     GIR_RootConstrainSelectedInstOperands,
     /*  32841 */     // GIR_Coverage, 5156,
     /*  32841 */     GIR_EraseRootFromParent_Done,
     /*  32842 */   // Label 461: @32842
     /*  32842 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(32980), // Rule ID 5157 //
     /*  32847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  32862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  32890 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  32894 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  32898 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  32906 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  32912 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  32914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  32918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32922 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  32926 */     // MIs[5] vA
     /*  32926 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  32931 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  32935 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  32939 */     // MIs[6] vC
     /*  32939 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  32944 */     // MIs[6] vB
     /*  32944 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  32949 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  32951 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  32951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  32954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  32956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  32960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  32964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  32968 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  32978 */     GIR_RootConstrainSelectedInstOperands,
     /*  32979 */     // GIR_Coverage, 5157,
     /*  32979 */     GIR_EraseRootFromParent_Done,
     /*  32980 */   // Label 462: @32980
     /*  32980 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(33118), // Rule ID 5164 //
     /*  32985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  32988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  32992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33032 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33036 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33040 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33044 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33050 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33052 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33056 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33060 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33064 */     // MIs[5] vC
     /*  33064 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33069 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33073 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33077 */     // MIs[6] vA
     /*  33077 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33082 */     // MIs[6] vB
     /*  33082 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33087 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33089 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33106 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33116 */     GIR_RootConstrainSelectedInstOperands,
     /*  33117 */     // GIR_Coverage, 5164,
     /*  33117 */     GIR_EraseRootFromParent_Done,
     /*  33118 */   // Label 463: @33118
     /*  33118 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(33256), // Rule ID 5165 //
     /*  33123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33170 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33178 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33182 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33188 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33190 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33194 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33198 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33202 */     // MIs[5] vC
     /*  33202 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33207 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33211 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33215 */     // MIs[6] vB
     /*  33215 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33220 */     // MIs[6] vA
     /*  33220 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33225 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33227 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33244 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33254 */     GIR_RootConstrainSelectedInstOperands,
     /*  33255 */     // GIR_Coverage, 5165,
     /*  33255 */     GIR_EraseRootFromParent_Done,
     /*  33256 */   // Label 464: @33256
     /*  33256 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(33394), // Rule ID 5166 //
     /*  33261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33296 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33312 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33320 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33326 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33328 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33332 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33336 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33340 */     // MIs[5] vB
     /*  33340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33345 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33349 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33353 */     // MIs[6] vA
     /*  33353 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33358 */     // MIs[6] vC
     /*  33358 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33363 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33365 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33382 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33392 */     GIR_RootConstrainSelectedInstOperands,
     /*  33393 */     // GIR_Coverage, 5166,
     /*  33393 */     GIR_EraseRootFromParent_Done,
     /*  33394 */   // Label 465: @33394
     /*  33394 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(33532), // Rule ID 5167 //
     /*  33399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33450 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33454 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33458 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33464 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33466 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33470 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33474 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33478 */     // MIs[5] vB
     /*  33478 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33483 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33487 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33491 */     // MIs[6] vC
     /*  33491 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33496 */     // MIs[6] vA
     /*  33496 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33501 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33503 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33520 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33530 */     GIR_RootConstrainSelectedInstOperands,
     /*  33531 */     // GIR_Coverage, 5167,
     /*  33531 */     GIR_EraseRootFromParent_Done,
     /*  33532 */   // Label 466: @33532
     /*  33532 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(33670), // Rule ID 5168 //
     /*  33537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33588 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33596 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33602 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33604 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33608 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33612 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33616 */     // MIs[5] vA
     /*  33616 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33621 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33625 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33629 */     // MIs[6] vB
     /*  33629 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33634 */     // MIs[6] vC
     /*  33634 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33639 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33641 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33658 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33668 */     GIR_RootConstrainSelectedInstOperands,
     /*  33669 */     // GIR_Coverage, 5168,
     /*  33669 */     GIR_EraseRootFromParent_Done,
     /*  33670 */   // Label 467: @33670
     /*  33670 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(33808), // Rule ID 5169 //
     /*  33675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33734 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33742 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33746 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33750 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33754 */     // MIs[5] vA
     /*  33754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33763 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33767 */     // MIs[6] vC
     /*  33767 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33772 */     // MIs[6] vB
     /*  33772 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33777 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33779 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  33788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  33792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  33796 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33806 */     GIR_RootConstrainSelectedInstOperands,
     /*  33807 */     // GIR_Coverage, 5169,
     /*  33807 */     GIR_EraseRootFromParent_Done,
     /*  33808 */   // Label 468: @33808
     /*  33808 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(33946), // Rule ID 5176 //
     /*  33813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33856 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33860 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33864 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33868 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  33872 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  33878 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  33880 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  33884 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33888 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33892 */     // MIs[5] vC
     /*  33892 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  33897 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  33901 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  33905 */     // MIs[6] vA
     /*  33905 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  33910 */     // MIs[6] vB
     /*  33910 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  33915 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  33917 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  33917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  33920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  33922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  33926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  33930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  33934 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  33944 */     GIR_RootConstrainSelectedInstOperands,
     /*  33945 */     // GIR_Coverage, 5176,
     /*  33945 */     GIR_EraseRootFromParent_Done,
     /*  33946 */   // Label 469: @33946
     /*  33946 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(34084), // Rule ID 5177 //
     /*  33951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  33954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  33958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  33966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  33990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  33994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  33998 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34002 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34006 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34010 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34016 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34018 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34022 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34026 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34030 */     // MIs[5] vC
     /*  34030 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34035 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34039 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34043 */     // MIs[6] vB
     /*  34043 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34048 */     // MIs[6] vA
     /*  34048 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34053 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34055 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34072 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34082 */     GIR_RootConstrainSelectedInstOperands,
     /*  34083 */     // GIR_Coverage, 5177,
     /*  34083 */     GIR_EraseRootFromParent_Done,
     /*  34084 */   // Label 470: @34084
     /*  34084 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(34222), // Rule ID 5178 //
     /*  34089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34136 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34140 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34148 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34154 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34156 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34160 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34164 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34168 */     // MIs[5] vB
     /*  34168 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34173 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34177 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34181 */     // MIs[6] vA
     /*  34181 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34186 */     // MIs[6] vC
     /*  34186 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34191 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34193 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34210 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34220 */     GIR_RootConstrainSelectedInstOperands,
     /*  34221 */     // GIR_Coverage, 5178,
     /*  34221 */     GIR_EraseRootFromParent_Done,
     /*  34222 */   // Label 471: @34222
     /*  34222 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(34360), // Rule ID 5179 //
     /*  34227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34262 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34266 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34270 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34274 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34278 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34282 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34286 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34292 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34294 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34298 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34302 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34306 */     // MIs[5] vB
     /*  34306 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34311 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34315 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34319 */     // MIs[6] vC
     /*  34319 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34324 */     // MIs[6] vA
     /*  34324 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34329 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34331 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34348 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34358 */     GIR_RootConstrainSelectedInstOperands,
     /*  34359 */     // GIR_Coverage, 5179,
     /*  34359 */     GIR_EraseRootFromParent_Done,
     /*  34360 */   // Label 472: @34360
     /*  34360 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(34498), // Rule ID 5180 //
     /*  34365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34416 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34424 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34432 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34436 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34440 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34444 */     // MIs[5] vA
     /*  34444 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34449 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34453 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34457 */     // MIs[6] vB
     /*  34457 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34462 */     // MIs[6] vC
     /*  34462 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34467 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34469 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34486 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34496 */     GIR_RootConstrainSelectedInstOperands,
     /*  34497 */     // GIR_Coverage, 5180,
     /*  34497 */     GIR_EraseRootFromParent_Done,
     /*  34498 */   // Label 473: @34498
     /*  34498 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(34636), // Rule ID 5181 //
     /*  34503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34550 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34554 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34558 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34562 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34570 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34574 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34578 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34582 */     // MIs[5] vA
     /*  34582 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34587 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34591 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34595 */     // MIs[6] vC
     /*  34595 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34600 */     // MIs[6] vB
     /*  34600 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34605 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34607 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  34620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  34624 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34634 */     GIR_RootConstrainSelectedInstOperands,
     /*  34635 */     // GIR_Coverage, 5181,
     /*  34635 */     GIR_EraseRootFromParent_Done,
     /*  34636 */   // Label 474: @34636
     /*  34636 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(34774), // Rule ID 5188 //
     /*  34641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34684 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34688 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34692 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34696 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34700 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34706 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34708 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34712 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34716 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34720 */     // MIs[5] vC
     /*  34720 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34725 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34729 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34733 */     // MIs[6] vA
     /*  34733 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34738 */     // MIs[6] vB
     /*  34738 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34743 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34745 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34762 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34772 */     GIR_RootConstrainSelectedInstOperands,
     /*  34773 */     // GIR_Coverage, 5188,
     /*  34773 */     GIR_EraseRootFromParent_Done,
     /*  34774 */   // Label 475: @34774
     /*  34774 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(34912), // Rule ID 5189 //
     /*  34779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34838 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34846 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34850 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34854 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34858 */     // MIs[5] vC
     /*  34858 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  34863 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  34867 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34871 */     // MIs[6] vB
     /*  34871 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  34876 */     // MIs[6] vA
     /*  34876 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  34881 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  34883 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  34883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  34886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  34888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  34892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  34896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  34900 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  34910 */     GIR_RootConstrainSelectedInstOperands,
     /*  34911 */     // GIR_Coverage, 5189,
     /*  34911 */     GIR_EraseRootFromParent_Done,
     /*  34912 */   // Label 476: @34912
     /*  34912 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(35050), // Rule ID 5190 //
     /*  34917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  34920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  34924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  34932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  34944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  34960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  34964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34968 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  34976 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  34982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  34984 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  34988 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  34992 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  34996 */     // MIs[5] vB
     /*  34996 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35005 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35009 */     // MIs[6] vA
     /*  35009 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35014 */     // MIs[6] vC
     /*  35014 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35019 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35021 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35038 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35048 */     GIR_RootConstrainSelectedInstOperands,
     /*  35049 */     // GIR_Coverage, 5190,
     /*  35049 */     GIR_EraseRootFromParent_Done,
     /*  35050 */   // Label 477: @35050
     /*  35050 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(35188), // Rule ID 5191 //
     /*  35055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35086 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35102 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35106 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35114 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35122 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35126 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35130 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35134 */     // MIs[5] vB
     /*  35134 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35139 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35143 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35147 */     // MIs[6] vC
     /*  35147 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35152 */     // MIs[6] vA
     /*  35152 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35157 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35159 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35176 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35186 */     GIR_RootConstrainSelectedInstOperands,
     /*  35187 */     // GIR_Coverage, 5191,
     /*  35187 */     GIR_EraseRootFromParent_Done,
     /*  35188 */   // Label 478: @35188
     /*  35188 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(35326), // Rule ID 5192 //
     /*  35193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35228 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35260 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35264 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35268 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35272 */     // MIs[5] vA
     /*  35272 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35277 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35281 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35285 */     // MIs[6] vB
     /*  35285 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35290 */     // MIs[6] vC
     /*  35290 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35295 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35297 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35314 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35324 */     GIR_RootConstrainSelectedInstOperands,
     /*  35325 */     // GIR_Coverage, 5192,
     /*  35325 */     GIR_EraseRootFromParent_Done,
     /*  35326 */   // Label 479: @35326
     /*  35326 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(35464), // Rule ID 5193 //
     /*  35331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  35374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35378 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35382 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35386 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35390 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35398 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35402 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35406 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35410 */     // MIs[5] vA
     /*  35410 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  35415 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  35419 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35423 */     // MIs[6] vC
     /*  35423 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35428 */     // MIs[6] vB
     /*  35428 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35433 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35435 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vA
     /*  35444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  35452 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35462 */     GIR_RootConstrainSelectedInstOperands,
     /*  35463 */     // GIR_Coverage, 5193,
     /*  35463 */     GIR_EraseRootFromParent_Done,
     /*  35464 */   // Label 480: @35464
     /*  35464 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(35602), // Rule ID 5194 //
     /*  35469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35524 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35528 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35534 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35536 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35540 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35544 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35548 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35552 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35556 */     // MIs[6] vA
     /*  35556 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35561 */     // MIs[6] vB
     /*  35561 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35566 */     // MIs[5] vC
     /*  35566 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35571 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35573 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35590 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35600 */     GIR_RootConstrainSelectedInstOperands,
     /*  35601 */     // GIR_Coverage, 5194,
     /*  35601 */     GIR_EraseRootFromParent_Done,
     /*  35602 */   // Label 481: @35602
     /*  35602 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(35740), // Rule ID 5195 //
     /*  35607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35646 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35650 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35654 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35658 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35666 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35672 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35674 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35678 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35682 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35686 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35690 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35694 */     // MIs[6] vB
     /*  35694 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35699 */     // MIs[6] vA
     /*  35699 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35704 */     // MIs[5] vC
     /*  35704 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35709 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35711 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35728 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35738 */     GIR_RootConstrainSelectedInstOperands,
     /*  35739 */     // GIR_Coverage, 5195,
     /*  35739 */     GIR_EraseRootFromParent_Done,
     /*  35740 */   // Label 482: @35740
     /*  35740 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(35878), // Rule ID 5196 //
     /*  35745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35784 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35788 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35792 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35796 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35804 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35810 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35812 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35816 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35820 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35824 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35828 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35832 */     // MIs[6] vA
     /*  35832 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35837 */     // MIs[6] vC
     /*  35837 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35842 */     // MIs[5] vB
     /*  35842 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35847 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35849 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  35862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  35866 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  35876 */     GIR_RootConstrainSelectedInstOperands,
     /*  35877 */     // GIR_Coverage, 5196,
     /*  35877 */     GIR_EraseRootFromParent_Done,
     /*  35878 */   // Label 483: @35878
     /*  35878 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(36016), // Rule ID 5197 //
     /*  35883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  35886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  35890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  35898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  35910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  35926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  35930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35934 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  35938 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  35942 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  35948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  35950 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  35954 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35958 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35962 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  35966 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  35970 */     // MIs[6] vC
     /*  35970 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  35975 */     // MIs[6] vA
     /*  35975 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  35980 */     // MIs[5] vB
     /*  35980 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  35985 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  35987 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  35987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  35990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  35992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  35996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36004 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36014 */     GIR_RootConstrainSelectedInstOperands,
     /*  36015 */     // GIR_Coverage, 5197,
     /*  36015 */     GIR_EraseRootFromParent_Done,
     /*  36016 */   // Label 484: @36016
     /*  36016 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(36154), // Rule ID 5198 //
     /*  36021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36076 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36080 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36086 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36088 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36092 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36096 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36100 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36104 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36108 */     // MIs[6] vB
     /*  36108 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36113 */     // MIs[6] vC
     /*  36113 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36118 */     // MIs[5] vA
     /*  36118 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36123 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36125 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36142 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36152 */     GIR_RootConstrainSelectedInstOperands,
     /*  36153 */     // GIR_Coverage, 5198,
     /*  36153 */     GIR_EraseRootFromParent_Done,
     /*  36154 */   // Label 485: @36154
     /*  36154 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(36292), // Rule ID 5199 //
     /*  36159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36190 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36194 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36206 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36210 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36218 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36224 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36226 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36230 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36234 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36238 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36242 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36246 */     // MIs[6] vC
     /*  36246 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36251 */     // MIs[6] vB
     /*  36251 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36256 */     // MIs[5] vA
     /*  36256 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36261 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36263 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  36272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  36276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36280 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36290 */     GIR_RootConstrainSelectedInstOperands,
     /*  36291 */     // GIR_Coverage, 5199,
     /*  36291 */     GIR_EraseRootFromParent_Done,
     /*  36292 */   // Label 486: @36292
     /*  36292 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(36430), // Rule ID 5206 //
     /*  36297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36344 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36348 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36352 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36356 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36362 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36364 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36368 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36372 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36376 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36380 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36384 */     // MIs[6] vA
     /*  36384 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36389 */     // MIs[6] vB
     /*  36389 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36394 */     // MIs[5] vC
     /*  36394 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36399 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36401 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36418 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36428 */     GIR_RootConstrainSelectedInstOperands,
     /*  36429 */     // GIR_Coverage, 5206,
     /*  36429 */     GIR_EraseRootFromParent_Done,
     /*  36430 */   // Label 487: @36430
     /*  36430 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(36568), // Rule ID 5207 //
     /*  36435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36482 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36486 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36494 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36500 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36502 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36506 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36510 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36514 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36518 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36522 */     // MIs[6] vB
     /*  36522 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36527 */     // MIs[6] vA
     /*  36527 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36532 */     // MIs[5] vC
     /*  36532 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36537 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36539 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36556 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36566 */     GIR_RootConstrainSelectedInstOperands,
     /*  36567 */     // GIR_Coverage, 5207,
     /*  36567 */     GIR_EraseRootFromParent_Done,
     /*  36568 */   // Label 488: @36568
     /*  36568 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(36706), // Rule ID 5208 //
     /*  36573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36612 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36616 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36620 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36624 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36632 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36638 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36640 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36644 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36648 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36652 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36656 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36660 */     // MIs[6] vA
     /*  36660 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36665 */     // MIs[6] vC
     /*  36665 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36670 */     // MIs[5] vB
     /*  36670 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36675 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36677 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36694 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36704 */     GIR_RootConstrainSelectedInstOperands,
     /*  36705 */     // GIR_Coverage, 5208,
     /*  36705 */     GIR_EraseRootFromParent_Done,
     /*  36706 */   // Label 489: @36706
     /*  36706 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(36844), // Rule ID 5209 //
     /*  36711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36750 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36754 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36758 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36762 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36770 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36778 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36782 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36786 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36790 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36794 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36798 */     // MIs[6] vC
     /*  36798 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36803 */     // MIs[6] vA
     /*  36803 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36808 */     // MIs[5] vB
     /*  36808 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36813 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36815 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36832 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36842 */     GIR_RootConstrainSelectedInstOperands,
     /*  36843 */     // GIR_Coverage, 5209,
     /*  36843 */     GIR_EraseRootFromParent_Done,
     /*  36844 */   // Label 490: @36844
     /*  36844 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(36982), // Rule ID 5210 //
     /*  36849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  36864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  36892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  36896 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36900 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  36908 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  36914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  36916 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  36920 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36924 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36928 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  36932 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36936 */     // MIs[6] vB
     /*  36936 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  36941 */     // MIs[6] vC
     /*  36941 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  36946 */     // MIs[5] vA
     /*  36946 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  36951 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  36953 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  36953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  36956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  36958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  36962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  36966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  36970 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  36980 */     GIR_RootConstrainSelectedInstOperands,
     /*  36981 */     // GIR_Coverage, 5210,
     /*  36981 */     GIR_EraseRootFromParent_Done,
     /*  36982 */   // Label 491: @36982
     /*  36982 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(37120), // Rule ID 5211 //
     /*  36987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  36990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  36994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37018 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37022 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37046 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37052 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37054 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37058 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37062 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37066 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37070 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37074 */     // MIs[6] vC
     /*  37074 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37079 */     // MIs[6] vB
     /*  37079 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37084 */     // MIs[5] vA
     /*  37084 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37089 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37091 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  37100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  37104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  37108 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37118 */     GIR_RootConstrainSelectedInstOperands,
     /*  37119 */     // GIR_Coverage, 5211,
     /*  37119 */     GIR_EraseRootFromParent_Done,
     /*  37120 */   // Label 492: @37120
     /*  37120 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(37258), // Rule ID 5218 //
     /*  37125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37180 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37184 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37190 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37192 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37196 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37200 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37204 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37208 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37212 */     // MIs[6] vA
     /*  37212 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37217 */     // MIs[6] vB
     /*  37217 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37222 */     // MIs[5] vC
     /*  37222 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37227 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37229 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37246 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37256 */     GIR_RootConstrainSelectedInstOperands,
     /*  37257 */     // GIR_Coverage, 5218,
     /*  37257 */     GIR_EraseRootFromParent_Done,
     /*  37258 */   // Label 493: @37258
     /*  37258 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(37396), // Rule ID 5219 //
     /*  37263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37302 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37306 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37310 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37314 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37318 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37322 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37330 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37334 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37338 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37342 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37346 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37350 */     // MIs[6] vB
     /*  37350 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37355 */     // MIs[6] vA
     /*  37355 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37360 */     // MIs[5] vC
     /*  37360 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37365 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37367 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37384 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37394 */     GIR_RootConstrainSelectedInstOperands,
     /*  37395 */     // GIR_Coverage, 5219,
     /*  37395 */     GIR_EraseRootFromParent_Done,
     /*  37396 */   // Label 494: @37396
     /*  37396 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(37534), // Rule ID 5220 //
     /*  37401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37452 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37460 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37466 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37468 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37472 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37476 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37480 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37484 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37488 */     // MIs[6] vA
     /*  37488 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37493 */     // MIs[6] vC
     /*  37493 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37498 */     // MIs[5] vB
     /*  37498 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37503 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37505 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37522 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37532 */     GIR_RootConstrainSelectedInstOperands,
     /*  37533 */     // GIR_Coverage, 5220,
     /*  37533 */     GIR_EraseRootFromParent_Done,
     /*  37534 */   // Label 495: @37534
     /*  37534 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(37672), // Rule ID 5221 //
     /*  37539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37558 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37586 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37590 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37594 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37598 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37604 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37606 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37610 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37614 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37618 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37622 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37626 */     // MIs[6] vC
     /*  37626 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37631 */     // MIs[6] vA
     /*  37631 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37636 */     // MIs[5] vB
     /*  37636 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37641 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37643 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37660 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37670 */     GIR_RootConstrainSelectedInstOperands,
     /*  37671 */     // GIR_Coverage, 5221,
     /*  37671 */     GIR_EraseRootFromParent_Done,
     /*  37672 */   // Label 496: @37672
     /*  37672 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(37810), // Rule ID 5222 //
     /*  37677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37724 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37728 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37732 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37736 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37742 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37744 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37748 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37752 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37756 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37760 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37764 */     // MIs[6] vB
     /*  37764 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37769 */     // MIs[6] vC
     /*  37769 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37774 */     // MIs[5] vA
     /*  37774 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37779 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37781 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37798 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37808 */     GIR_RootConstrainSelectedInstOperands,
     /*  37809 */     // GIR_Coverage, 5222,
     /*  37809 */     GIR_EraseRootFromParent_Done,
     /*  37810 */   // Label 497: @37810
     /*  37810 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(37948), // Rule ID 5223 //
     /*  37815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37850 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37858 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37862 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37870 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  37874 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  37880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  37882 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  37886 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37890 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37894 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  37898 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  37902 */     // MIs[6] vC
     /*  37902 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  37907 */     // MIs[6] vB
     /*  37907 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  37912 */     // MIs[5] vA
     /*  37912 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  37917 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  37919 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  37919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  37922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  37924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  37928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  37932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  37936 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  37946 */     GIR_RootConstrainSelectedInstOperands,
     /*  37947 */     // GIR_Coverage, 5223,
     /*  37947 */     GIR_EraseRootFromParent_Done,
     /*  37948 */   // Label 498: @37948
     /*  37948 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(38086), // Rule ID 5230 //
     /*  37953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  37956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  37960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  37964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  37968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  37984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  37988 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  37996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38004 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38008 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38012 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38018 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38020 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38024 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38028 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38032 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38036 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38040 */     // MIs[6] vA
     /*  38040 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38045 */     // MIs[6] vB
     /*  38045 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38050 */     // MIs[5] vC
     /*  38050 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38055 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38057 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38074 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38084 */     GIR_RootConstrainSelectedInstOperands,
     /*  38085 */     // GIR_Coverage, 5230,
     /*  38085 */     GIR_EraseRootFromParent_Done,
     /*  38086 */   // Label 499: @38086
     /*  38086 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(38224), // Rule ID 5231 //
     /*  38091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38138 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38142 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38150 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38156 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38158 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38162 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38166 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38170 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38174 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38178 */     // MIs[6] vB
     /*  38178 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38183 */     // MIs[6] vA
     /*  38183 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38188 */     // MIs[5] vC
     /*  38188 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38193 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38195 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38212 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38222 */     GIR_RootConstrainSelectedInstOperands,
     /*  38223 */     // GIR_Coverage, 5231,
     /*  38223 */     GIR_EraseRootFromParent_Done,
     /*  38224 */   // Label 500: @38224
     /*  38224 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(38362), // Rule ID 5232 //
     /*  38229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38280 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38288 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38296 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38300 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38304 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38308 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38312 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38316 */     // MIs[6] vA
     /*  38316 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38321 */     // MIs[6] vC
     /*  38321 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38326 */     // MIs[5] vB
     /*  38326 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38331 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38333 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38350 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38360 */     GIR_RootConstrainSelectedInstOperands,
     /*  38361 */     // GIR_Coverage, 5232,
     /*  38361 */     GIR_EraseRootFromParent_Done,
     /*  38362 */   // Label 501: @38362
     /*  38362 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(38500), // Rule ID 5233 //
     /*  38367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38406 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38410 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38414 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38418 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38422 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38426 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38434 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38438 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38442 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38446 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38450 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38454 */     // MIs[6] vC
     /*  38454 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38459 */     // MIs[6] vA
     /*  38459 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38464 */     // MIs[5] vB
     /*  38464 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38469 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38471 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38488 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38498 */     GIR_RootConstrainSelectedInstOperands,
     /*  38499 */     // GIR_Coverage, 5233,
     /*  38499 */     GIR_EraseRootFromParent_Done,
     /*  38500 */   // Label 502: @38500
     /*  38500 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(38638), // Rule ID 5234 //
     /*  38505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38544 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38548 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38552 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38556 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38560 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38564 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38570 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38572 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38576 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38580 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38584 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38588 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38592 */     // MIs[6] vB
     /*  38592 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38597 */     // MIs[6] vC
     /*  38597 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38602 */     // MIs[5] vA
     /*  38602 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38607 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38609 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38626 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38636 */     GIR_RootConstrainSelectedInstOperands,
     /*  38637 */     // GIR_Coverage, 5234,
     /*  38637 */     GIR_EraseRootFromParent_Done,
     /*  38638 */   // Label 503: @38638
     /*  38638 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(38776), // Rule ID 5235 //
     /*  38643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38682 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38686 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38690 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38694 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38698 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38702 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38708 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38710 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38714 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38718 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38722 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38726 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38730 */     // MIs[6] vC
     /*  38730 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38735 */     // MIs[6] vB
     /*  38735 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38740 */     // MIs[5] vA
     /*  38740 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38745 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38747 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  38756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  38760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  38764 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38774 */     GIR_RootConstrainSelectedInstOperands,
     /*  38775 */     // GIR_Coverage, 5235,
     /*  38775 */     GIR_EraseRootFromParent_Done,
     /*  38776 */   // Label 504: @38776
     /*  38776 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(38914), // Rule ID 5242 //
     /*  38781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38840 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38846 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38848 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38852 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38856 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38860 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  38864 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38868 */     // MIs[6] vA
     /*  38868 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  38873 */     // MIs[6] vB
     /*  38873 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  38878 */     // MIs[5] vC
     /*  38878 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  38883 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  38885 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  38885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  38888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  38890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  38894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  38898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  38902 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  38912 */     GIR_RootConstrainSelectedInstOperands,
     /*  38913 */     // GIR_Coverage, 5242,
     /*  38913 */     GIR_EraseRootFromParent_Done,
     /*  38914 */   // Label 505: @38914
     /*  38914 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(39052), // Rule ID 5243 //
     /*  38919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  38922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  38926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  38934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  38962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  38966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38970 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38974 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  38978 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  38984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  38986 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  38990 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  38994 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  38998 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39002 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39006 */     // MIs[6] vB
     /*  39006 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39011 */     // MIs[6] vA
     /*  39011 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39016 */     // MIs[5] vC
     /*  39016 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39021 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39023 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39040 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39050 */     GIR_RootConstrainSelectedInstOperands,
     /*  39051 */     // GIR_Coverage, 5243,
     /*  39051 */     GIR_EraseRootFromParent_Done,
     /*  39052 */   // Label 506: @39052
     /*  39052 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(39190), // Rule ID 5244 //
     /*  39057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39104 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39108 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39116 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39122 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39124 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39128 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39132 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39136 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39140 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39144 */     // MIs[6] vA
     /*  39144 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39149 */     // MIs[6] vC
     /*  39149 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39154 */     // MIs[5] vB
     /*  39154 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39159 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39161 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39178 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39188 */     GIR_RootConstrainSelectedInstOperands,
     /*  39189 */     // GIR_Coverage, 5244,
     /*  39189 */     GIR_EraseRootFromParent_Done,
     /*  39190 */   // Label 507: @39190
     /*  39190 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(39328), // Rule ID 5245 //
     /*  39195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39230 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39242 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39246 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39254 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39262 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39266 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39270 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39274 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39278 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39282 */     // MIs[6] vC
     /*  39282 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39287 */     // MIs[6] vA
     /*  39287 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39292 */     // MIs[5] vB
     /*  39292 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39297 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39299 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39316 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39326 */     GIR_RootConstrainSelectedInstOperands,
     /*  39327 */     // GIR_Coverage, 5245,
     /*  39327 */     GIR_EraseRootFromParent_Done,
     /*  39328 */   // Label 508: @39328
     /*  39328 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(39466), // Rule ID 5246 //
     /*  39333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39380 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39384 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39388 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39392 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39398 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39400 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39404 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39408 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39412 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39416 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39420 */     // MIs[6] vB
     /*  39420 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39425 */     // MIs[6] vC
     /*  39425 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39430 */     // MIs[5] vA
     /*  39430 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39435 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39437 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39454 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39464 */     GIR_RootConstrainSelectedInstOperands,
     /*  39465 */     // GIR_Coverage, 5246,
     /*  39465 */     GIR_EraseRootFromParent_Done,
     /*  39466 */   // Label 509: @39466
     /*  39466 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(39604), // Rule ID 5247 //
     /*  39471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39522 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39530 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39538 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39542 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39546 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39550 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39554 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39558 */     // MIs[6] vC
     /*  39558 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39563 */     // MIs[6] vB
     /*  39563 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39568 */     // MIs[5] vA
     /*  39568 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39573 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39575 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  39588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  39592 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39602 */     GIR_RootConstrainSelectedInstOperands,
     /*  39603 */     // GIR_Coverage, 5247,
     /*  39603 */     GIR_EraseRootFromParent_Done,
     /*  39604 */   // Label 510: @39604
     /*  39604 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(39742), // Rule ID 5254 //
     /*  39609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39664 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39668 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39674 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39676 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39680 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39684 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39692 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39696 */     // MIs[6] vA
     /*  39696 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39701 */     // MIs[6] vB
     /*  39701 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39706 */     // MIs[5] vC
     /*  39706 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39711 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39713 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39730 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39740 */     GIR_RootConstrainSelectedInstOperands,
     /*  39741 */     // GIR_Coverage, 5254,
     /*  39741 */     GIR_EraseRootFromParent_Done,
     /*  39742 */   // Label 511: @39742
     /*  39742 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(39880), // Rule ID 5255 //
     /*  39747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39798 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39806 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39814 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39818 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39822 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39826 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39830 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39834 */     // MIs[6] vB
     /*  39834 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39839 */     // MIs[6] vA
     /*  39839 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39844 */     // MIs[5] vC
     /*  39844 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39849 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39851 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  39864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  39868 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  39878 */     GIR_RootConstrainSelectedInstOperands,
     /*  39879 */     // GIR_Coverage, 5255,
     /*  39879 */     GIR_EraseRootFromParent_Done,
     /*  39880 */   // Label 512: @39880
     /*  39880 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(40018), // Rule ID 5256 //
     /*  39885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  39888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  39892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  39900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39920 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39924 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  39928 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  39932 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39936 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39940 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  39944 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  39950 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  39952 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  39956 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39960 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  39964 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  39968 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  39972 */     // MIs[6] vA
     /*  39972 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  39977 */     // MIs[6] vC
     /*  39977 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  39982 */     // MIs[5] vB
     /*  39982 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  39987 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  39989 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  39989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  39992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  39994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  39998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40006 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40016 */     GIR_RootConstrainSelectedInstOperands,
     /*  40017 */     // GIR_Coverage, 5256,
     /*  40017 */     GIR_EraseRootFromParent_Done,
     /*  40018 */   // Label 513: @40018
     /*  40018 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(40156), // Rule ID 5257 //
     /*  40023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40082 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40090 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40094 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40098 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40102 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40106 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40110 */     // MIs[6] vC
     /*  40110 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40115 */     // MIs[6] vA
     /*  40115 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40120 */     // MIs[5] vB
     /*  40120 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40125 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40127 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40144 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40154 */     GIR_RootConstrainSelectedInstOperands,
     /*  40155 */     // GIR_Coverage, 5257,
     /*  40155 */     GIR_EraseRootFromParent_Done,
     /*  40156 */   // Label 514: @40156
     /*  40156 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(40294), // Rule ID 5258 //
     /*  40161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40196 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40212 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40216 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40220 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40228 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40232 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40236 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40240 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40244 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40248 */     // MIs[6] vB
     /*  40248 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40253 */     // MIs[6] vC
     /*  40253 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40258 */     // MIs[5] vA
     /*  40258 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40263 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40265 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40282 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40292 */     GIR_RootConstrainSelectedInstOperands,
     /*  40293 */     // GIR_Coverage, 5258,
     /*  40293 */     GIR_EraseRootFromParent_Done,
     /*  40294 */   // Label 515: @40294
     /*  40294 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(40432), // Rule ID 5259 //
     /*  40299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40318 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40334 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40358 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40366 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40370 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40374 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40378 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/1, // MIs[6]
     /*  40382 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40386 */     // MIs[6] vC
     /*  40386 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40391 */     // MIs[6] vB
     /*  40391 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40396 */     // MIs[5] vA
     /*  40396 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40401 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40403 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vA))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  40412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  40420 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40430 */     GIR_RootConstrainSelectedInstOperands,
     /*  40431 */     // GIR_Coverage, 5259,
     /*  40431 */     GIR_EraseRootFromParent_Done,
     /*  40432 */   // Label 516: @40432
     /*  40432 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(40570), // Rule ID 5200 //
     /*  40437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40456 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40488 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40492 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40496 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40502 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40504 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40508 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40512 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40516 */     // MIs[5] vC
     /*  40516 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40521 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40525 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40529 */     // MIs[6] vA
     /*  40529 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40534 */     // MIs[6] vB
     /*  40534 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40539 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40541 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40558 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40568 */     GIR_RootConstrainSelectedInstOperands,
     /*  40569 */     // GIR_Coverage, 5200,
     /*  40569 */     GIR_EraseRootFromParent_Done,
     /*  40570 */   // Label 517: @40570
     /*  40570 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(40708), // Rule ID 5201 //
     /*  40575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40610 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40618 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40622 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40626 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40630 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40634 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40640 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40642 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40646 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40650 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40654 */     // MIs[5] vC
     /*  40654 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40659 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40663 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40667 */     // MIs[6] vB
     /*  40667 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40672 */     // MIs[6] vA
     /*  40672 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40677 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40679 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40696 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40706 */     GIR_RootConstrainSelectedInstOperands,
     /*  40707 */     // GIR_Coverage, 5201,
     /*  40707 */     GIR_EraseRootFromParent_Done,
     /*  40708 */   // Label 518: @40708
     /*  40708 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(40846), // Rule ID 5202 //
     /*  40713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40772 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40778 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40780 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40784 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40788 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40792 */     // MIs[5] vB
     /*  40792 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40797 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40801 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40805 */     // MIs[6] vA
     /*  40805 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40810 */     // MIs[6] vC
     /*  40810 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40815 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40817 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40834 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40844 */     GIR_RootConstrainSelectedInstOperands,
     /*  40845 */     // GIR_Coverage, 5202,
     /*  40845 */     GIR_EraseRootFromParent_Done,
     /*  40846 */   // Label 519: @40846
     /*  40846 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(40984), // Rule ID 5203 //
     /*  40851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  40862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  40866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40890 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  40894 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  40898 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  40902 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40906 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  40910 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  40916 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  40918 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  40922 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40926 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40930 */     // MIs[5] vB
     /*  40930 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  40935 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  40939 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  40943 */     // MIs[6] vC
     /*  40943 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  40948 */     // MIs[6] vA
     /*  40948 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  40953 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  40955 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  40955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  40958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  40960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  40964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  40968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  40972 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  40982 */     GIR_RootConstrainSelectedInstOperands,
     /*  40983 */     // GIR_Coverage, 5203,
     /*  40983 */     GIR_EraseRootFromParent_Done,
     /*  40984 */   // Label 520: @40984
     /*  40984 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(41122), // Rule ID 5204 //
     /*  40989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  40992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  40996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41036 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41040 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41044 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41048 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41054 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41056 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41060 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41064 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41068 */     // MIs[5] vA
     /*  41068 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41073 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41077 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41081 */     // MIs[6] vB
     /*  41081 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41086 */     // MIs[6] vC
     /*  41086 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41091 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41093 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41110 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41120 */     GIR_RootConstrainSelectedInstOperands,
     /*  41121 */     // GIR_Coverage, 5204,
     /*  41121 */     GIR_EraseRootFromParent_Done,
     /*  41122 */   // Label 521: @41122
     /*  41122 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(41260), // Rule ID 5205 //
     /*  41127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41162 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41178 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41182 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41186 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41192 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41194 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41198 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41202 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41206 */     // MIs[5] vA
     /*  41206 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41211 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41215 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41219 */     // MIs[6] vC
     /*  41219 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41224 */     // MIs[6] vB
     /*  41224 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41229 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41231 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  41240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  41244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41248 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41258 */     GIR_RootConstrainSelectedInstOperands,
     /*  41259 */     // GIR_Coverage, 5205,
     /*  41259 */     GIR_EraseRootFromParent_Done,
     /*  41260 */   // Label 522: @41260
     /*  41260 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(41398), // Rule ID 5212 //
     /*  41265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41308 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41312 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41316 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41324 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41330 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41332 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41336 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41340 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41344 */     // MIs[5] vC
     /*  41344 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41349 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41353 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41357 */     // MIs[6] vA
     /*  41357 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41362 */     // MIs[6] vB
     /*  41362 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41367 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41369 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41386 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41396 */     GIR_RootConstrainSelectedInstOperands,
     /*  41397 */     // GIR_Coverage, 5212,
     /*  41397 */     GIR_EraseRootFromParent_Done,
     /*  41398 */   // Label 523: @41398
     /*  41398 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(41536), // Rule ID 5213 //
     /*  41403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41438 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41450 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41454 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41462 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41470 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41474 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41478 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41482 */     // MIs[5] vC
     /*  41482 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41487 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41491 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41495 */     // MIs[6] vB
     /*  41495 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41500 */     // MIs[6] vA
     /*  41500 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41505 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41507 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41524 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41534 */     GIR_RootConstrainSelectedInstOperands,
     /*  41535 */     // GIR_Coverage, 5213,
     /*  41535 */     GIR_EraseRootFromParent_Done,
     /*  41536 */   // Label 524: @41536
     /*  41536 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(41674), // Rule ID 5214 //
     /*  41541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41592 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41596 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41600 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41606 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41608 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41612 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41616 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41620 */     // MIs[5] vB
     /*  41620 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41625 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41629 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41633 */     // MIs[6] vA
     /*  41633 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41638 */     // MIs[6] vC
     /*  41638 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41643 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41645 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41662 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41672 */     GIR_RootConstrainSelectedInstOperands,
     /*  41673 */     // GIR_Coverage, 5214,
     /*  41673 */     GIR_EraseRootFromParent_Done,
     /*  41674 */   // Label 525: @41674
     /*  41674 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(41812), // Rule ID 5215 //
     /*  41679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41714 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41726 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41730 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41734 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41738 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41744 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41746 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41750 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41754 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41758 */     // MIs[5] vB
     /*  41758 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41763 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41767 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41771 */     // MIs[6] vC
     /*  41771 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41776 */     // MIs[6] vA
     /*  41776 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41781 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41783 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41800 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41810 */     GIR_RootConstrainSelectedInstOperands,
     /*  41811 */     // GIR_Coverage, 5215,
     /*  41811 */     GIR_EraseRootFromParent_Done,
     /*  41812 */   // Label 526: @41812
     /*  41812 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(41950), // Rule ID 5216 //
     /*  41817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41852 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41856 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41860 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41864 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41868 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41872 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  41876 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41882 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  41884 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  41888 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41892 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41896 */     // MIs[5] vA
     /*  41896 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  41901 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  41905 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  41909 */     // MIs[6] vB
     /*  41909 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  41914 */     // MIs[6] vC
     /*  41914 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  41919 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  41921 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  41921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  41924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  41926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  41930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  41934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  41938 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  41948 */     GIR_RootConstrainSelectedInstOperands,
     /*  41949 */     // GIR_Coverage, 5216,
     /*  41949 */     GIR_EraseRootFromParent_Done,
     /*  41950 */   // Label 527: @41950
     /*  41950 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(42088), // Rule ID 5217 //
     /*  41955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  41958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  41962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  41970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  41986 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41990 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  41998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42002 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42006 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42010 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42014 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42022 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42026 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42030 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42034 */     // MIs[5] vA
     /*  42034 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42039 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42043 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42047 */     // MIs[6] vC
     /*  42047 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42052 */     // MIs[6] vB
     /*  42052 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42057 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42059 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  42068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  42072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vC
     /*  42076 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42086 */     GIR_RootConstrainSelectedInstOperands,
     /*  42087 */     // GIR_Coverage, 5217,
     /*  42087 */     GIR_EraseRootFromParent_Done,
     /*  42088 */   // Label 528: @42088
     /*  42088 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(42226), // Rule ID 5224 //
     /*  42093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42144 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42148 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42152 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42158 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42160 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42164 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42168 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42172 */     // MIs[5] vC
     /*  42172 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42177 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42181 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42185 */     // MIs[6] vA
     /*  42185 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42190 */     // MIs[6] vB
     /*  42190 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42195 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42197 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42214 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42224 */     GIR_RootConstrainSelectedInstOperands,
     /*  42225 */     // GIR_Coverage, 5224,
     /*  42225 */     GIR_EraseRootFromParent_Done,
     /*  42226 */   // Label 529: @42226
     /*  42226 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(42364), // Rule ID 5225 //
     /*  42231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42282 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42290 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42296 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42298 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42302 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42306 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42310 */     // MIs[5] vC
     /*  42310 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42315 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42319 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42323 */     // MIs[6] vB
     /*  42323 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42328 */     // MIs[6] vA
     /*  42328 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42333 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42335 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42352 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42362 */     GIR_RootConstrainSelectedInstOperands,
     /*  42363 */     // GIR_Coverage, 5225,
     /*  42363 */     GIR_EraseRootFromParent_Done,
     /*  42364 */   // Label 530: @42364
     /*  42364 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(42502), // Rule ID 5226 //
     /*  42369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42404 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42416 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42420 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42424 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42428 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42434 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42436 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42440 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42444 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42448 */     // MIs[5] vB
     /*  42448 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42453 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42457 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42461 */     // MIs[6] vA
     /*  42461 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42466 */     // MIs[6] vC
     /*  42466 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42471 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42473 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42490 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42500 */     GIR_RootConstrainSelectedInstOperands,
     /*  42501 */     // GIR_Coverage, 5226,
     /*  42501 */     GIR_EraseRootFromParent_Done,
     /*  42502 */   // Label 531: @42502
     /*  42502 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(42640), // Rule ID 5227 //
     /*  42507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42542 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42546 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42550 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42554 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42566 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42574 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42578 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42582 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42586 */     // MIs[5] vB
     /*  42586 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42591 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42595 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42599 */     // MIs[6] vC
     /*  42599 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42604 */     // MIs[6] vA
     /*  42604 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42609 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42611 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42628 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42638 */     GIR_RootConstrainSelectedInstOperands,
     /*  42639 */     // GIR_Coverage, 5227,
     /*  42639 */     GIR_EraseRootFromParent_Done,
     /*  42640 */   // Label 532: @42640
     /*  42640 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(42778), // Rule ID 5228 //
     /*  42645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42684 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42688 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42692 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42696 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42700 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42704 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42710 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42712 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42716 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42720 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42724 */     // MIs[5] vA
     /*  42724 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42729 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42733 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42737 */     // MIs[6] vB
     /*  42737 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42742 */     // MIs[6] vC
     /*  42742 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42747 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42749 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42766 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42776 */     GIR_RootConstrainSelectedInstOperands,
     /*  42777 */     // GIR_Coverage, 5228,
     /*  42777 */     GIR_EraseRootFromParent_Done,
     /*  42778 */   // Label 533: @42778
     /*  42778 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(42916), // Rule ID 5229 //
     /*  42783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42818 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42834 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42838 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42842 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42850 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42854 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42858 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42862 */     // MIs[5] vA
     /*  42862 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  42867 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  42871 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42875 */     // MIs[6] vC
     /*  42875 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  42880 */     // MIs[6] vB
     /*  42880 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  42885 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  42887 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  42887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  42890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  42892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vA
     /*  42896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  42900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  42904 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  42914 */     GIR_RootConstrainSelectedInstOperands,
     /*  42915 */     // GIR_Coverage, 5229,
     /*  42915 */     GIR_EraseRootFromParent_Done,
     /*  42916 */   // Label 534: @42916
     /*  42916 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(43054), // Rule ID 5236 //
     /*  42921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  42924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  42928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  42936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42956 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  42964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  42968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42972 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  42976 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  42980 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42986 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  42988 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  42992 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  42996 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43000 */     // MIs[5] vC
     /*  43000 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43005 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43009 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43013 */     // MIs[6] vA
     /*  43013 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43018 */     // MIs[6] vB
     /*  43018 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43023 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43025 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43042 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43052 */     GIR_RootConstrainSelectedInstOperands,
     /*  43053 */     // GIR_Coverage, 5236,
     /*  43053 */     GIR_EraseRootFromParent_Done,
     /*  43054 */   // Label 535: @43054
     /*  43054 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(43192), // Rule ID 5237 //
     /*  43059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43094 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43106 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43118 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43126 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43130 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43134 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43138 */     // MIs[5] vC
     /*  43138 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43143 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43147 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43151 */     // MIs[6] vB
     /*  43151 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43156 */     // MIs[6] vA
     /*  43156 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43161 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43163 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43180 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43190 */     GIR_RootConstrainSelectedInstOperands,
     /*  43191 */     // GIR_Coverage, 5237,
     /*  43191 */     GIR_EraseRootFromParent_Done,
     /*  43192 */   // Label 536: @43192
     /*  43192 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(43330), // Rule ID 5238 //
     /*  43197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43232 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43236 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43240 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43244 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43248 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43252 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43256 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43262 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43264 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43268 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43272 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43276 */     // MIs[5] vB
     /*  43276 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43281 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43285 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43289 */     // MIs[6] vA
     /*  43289 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43294 */     // MIs[6] vC
     /*  43294 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43299 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43301 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43318 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43328 */     GIR_RootConstrainSelectedInstOperands,
     /*  43329 */     // GIR_Coverage, 5238,
     /*  43329 */     GIR_EraseRootFromParent_Done,
     /*  43330 */   // Label 537: @43330
     /*  43330 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(43468), // Rule ID 5239 //
     /*  43335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43374 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43378 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43382 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43386 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43390 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43394 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43400 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43402 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43406 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43410 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43414 */     // MIs[5] vB
     /*  43414 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43419 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43423 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43427 */     // MIs[6] vC
     /*  43427 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43432 */     // MIs[6] vA
     /*  43432 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43437 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43439 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43456 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43466 */     GIR_RootConstrainSelectedInstOperands,
     /*  43467 */     // GIR_Coverage, 5239,
     /*  43467 */     GIR_EraseRootFromParent_Done,
     /*  43468 */   // Label 538: @43468
     /*  43468 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(43606), // Rule ID 5240 //
     /*  43473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43520 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43524 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43528 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43532 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43538 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43540 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43544 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43548 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43552 */     // MIs[5] vA
     /*  43552 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43557 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43561 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43565 */     // MIs[6] vB
     /*  43565 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43570 */     // MIs[6] vC
     /*  43570 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43575 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43577 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43594 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43604 */     GIR_RootConstrainSelectedInstOperands,
     /*  43605 */     // GIR_Coverage, 5240,
     /*  43605 */     GIR_EraseRootFromParent_Done,
     /*  43606 */   // Label 539: @43606
     /*  43606 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(43744), // Rule ID 5241 //
     /*  43611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43650 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43654 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43658 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43662 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43666 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43670 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43676 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43678 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43682 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43686 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43690 */     // MIs[5] vA
     /*  43690 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43695 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43699 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43703 */     // MIs[6] vC
     /*  43703 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43708 */     // MIs[6] vB
     /*  43708 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43713 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43715 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vA
     /*  43724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  43728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  43732 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43742 */     GIR_RootConstrainSelectedInstOperands,
     /*  43743 */     // GIR_Coverage, 5241,
     /*  43743 */     GIR_EraseRootFromParent_Done,
     /*  43744 */   // Label 540: @43744
     /*  43744 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(43882), // Rule ID 5248 //
     /*  43749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43800 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43804 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43808 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43814 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43816 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43820 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43824 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43828 */     // MIs[5] vC
     /*  43828 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43833 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43837 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43841 */     // MIs[6] vA
     /*  43841 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43846 */     // MIs[6] vB
     /*  43846 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43851 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43853 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  43862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  43866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  43870 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  43880 */     GIR_RootConstrainSelectedInstOperands,
     /*  43881 */     // GIR_Coverage, 5248,
     /*  43881 */     GIR_EraseRootFromParent_Done,
     /*  43882 */   // Label 541: @43882
     /*  43882 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(44020), // Rule ID 5249 //
     /*  43887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  43890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  43894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  43902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43922 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  43930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  43934 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43938 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  43946 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43952 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  43954 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  43958 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43962 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  43966 */     // MIs[5] vC
     /*  43966 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  43971 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  43975 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  43979 */     // MIs[6] vB
     /*  43979 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  43984 */     // MIs[6] vA
     /*  43984 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  43989 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  43991 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  43991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  43994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  43996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44008 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44018 */     GIR_RootConstrainSelectedInstOperands,
     /*  44019 */     // GIR_Coverage, 5249,
     /*  44019 */     GIR_EraseRootFromParent_Done,
     /*  44020 */   // Label 542: @44020
     /*  44020 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(44158), // Rule ID 5250 //
     /*  44025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44076 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44084 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44090 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44092 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44096 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44100 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44104 */     // MIs[5] vB
     /*  44104 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44109 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44113 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44117 */     // MIs[6] vA
     /*  44117 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44122 */     // MIs[6] vC
     /*  44122 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44127 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44129 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44146 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44156 */     GIR_RootConstrainSelectedInstOperands,
     /*  44157 */     // GIR_Coverage, 5250,
     /*  44157 */     GIR_EraseRootFromParent_Done,
     /*  44158 */   // Label 543: @44158
     /*  44158 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(44296), // Rule ID 5251 //
     /*  44163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44214 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44222 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44230 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44234 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44238 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44242 */     // MIs[5] vB
     /*  44242 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44247 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44251 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44255 */     // MIs[6] vC
     /*  44255 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44260 */     // MIs[6] vA
     /*  44260 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44265 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44267 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44284 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44294 */     GIR_RootConstrainSelectedInstOperands,
     /*  44295 */     // GIR_Coverage, 5251,
     /*  44295 */     GIR_EraseRootFromParent_Done,
     /*  44296 */   // Label 544: @44296
     /*  44296 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(44434), // Rule ID 5252 //
     /*  44301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44336 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44348 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44352 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44356 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44360 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44366 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44368 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44372 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44376 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44380 */     // MIs[5] vA
     /*  44380 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44385 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44389 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44393 */     // MIs[6] vB
     /*  44393 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44398 */     // MIs[6] vC
     /*  44398 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44403 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44405 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44414 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44422 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44432 */     GIR_RootConstrainSelectedInstOperands,
     /*  44433 */     // GIR_Coverage, 5252,
     /*  44433 */     GIR_EraseRootFromParent_Done,
     /*  44434 */   // Label 545: @44434
     /*  44434 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(44572), // Rule ID 5253 //
     /*  44439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44498 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44514 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44518 */     // MIs[5] vA
     /*  44518 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44523 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44527 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44531 */     // MIs[6] vC
     /*  44531 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44536 */     // MIs[6] vB
     /*  44536 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44541 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44543 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  44556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  44560 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44570 */     GIR_RootConstrainSelectedInstOperands,
     /*  44571 */     // GIR_Coverage, 5253,
     /*  44571 */     GIR_EraseRootFromParent_Done,
     /*  44572 */   // Label 546: @44572
     /*  44572 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(44710), // Rule ID 5260 //
     /*  44577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44624 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44628 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44636 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44642 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44644 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44648 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44652 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44656 */     // MIs[5] vC
     /*  44656 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44661 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44665 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44669 */     // MIs[6] vA
     /*  44669 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44674 */     // MIs[6] vB
     /*  44674 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44679 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44681 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44698 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44708 */     GIR_RootConstrainSelectedInstOperands,
     /*  44709 */     // GIR_Coverage, 5260,
     /*  44709 */     GIR_EraseRootFromParent_Done,
     /*  44710 */   // Label 547: @44710
     /*  44710 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(44848), // Rule ID 5261 //
     /*  44715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44750 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44754 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44758 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44762 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44766 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44770 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44774 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44782 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44786 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44790 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44794 */     // MIs[5] vC
     /*  44794 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44799 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44803 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44807 */     // MIs[6] vB
     /*  44807 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44812 */     // MIs[6] vA
     /*  44812 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44817 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44819 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44836 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44846 */     GIR_RootConstrainSelectedInstOperands,
     /*  44847 */     // GIR_Coverage, 5261,
     /*  44847 */     GIR_EraseRootFromParent_Done,
     /*  44848 */   // Label 548: @44848
     /*  44848 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(44986), // Rule ID 5262 //
     /*  44853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  44868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  44900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  44912 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  44918 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  44920 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  44924 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44932 */     // MIs[5] vB
     /*  44932 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  44937 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  44941 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  44945 */     // MIs[6] vA
     /*  44945 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  44950 */     // MIs[6] vC
     /*  44950 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  44955 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  44957 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  44957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  44960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  44962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  44966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  44970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  44974 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  44984 */     GIR_RootConstrainSelectedInstOperands,
     /*  44985 */     // GIR_Coverage, 5262,
     /*  44985 */     GIR_EraseRootFromParent_Done,
     /*  44986 */   // Label 549: @44986
     /*  44986 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(45124), // Rule ID 5263 //
     /*  44991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  44994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  44998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45042 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45046 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45050 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45056 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45058 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45062 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45066 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45070 */     // MIs[5] vB
     /*  45070 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45075 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45079 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45083 */     // MIs[6] vC
     /*  45083 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45088 */     // MIs[6] vA
     /*  45088 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45093 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45095 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vA)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45112 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45122 */     GIR_RootConstrainSelectedInstOperands,
     /*  45123 */     // GIR_Coverage, 5263,
     /*  45123 */     GIR_EraseRootFromParent_Done,
     /*  45124 */   // Label 550: @45124
     /*  45124 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(45262), // Rule ID 5264 //
     /*  45129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45184 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45188 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45196 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45200 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45204 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45208 */     // MIs[5] vA
     /*  45208 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45213 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45217 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45221 */     // MIs[6] vB
     /*  45221 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45226 */     // MIs[6] vC
     /*  45226 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45231 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45233 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45250 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45260 */     GIR_RootConstrainSelectedInstOperands,
     /*  45261 */     // GIR_Coverage, 5264,
     /*  45261 */     GIR_EraseRootFromParent_Done,
     /*  45262 */   // Label 551: @45262
     /*  45262 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(45400), // Rule ID 5265 //
     /*  45267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  45270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45302 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  45314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45318 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  45326 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45334 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/0, /*OpIdx*/2, // MIs[5]
     /*  45338 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45342 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45346 */     // MIs[5] vA
     /*  45346 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45351 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  45355 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45359 */     // MIs[6] vC
     /*  45359 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  45364 */     // MIs[6] vB
     /*  45364 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/2,
     /*  45369 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  45371 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)), immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, v4i32:{ *:[v4i32] }:$vB)))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 150:{ *:[i32] })
     /*  45371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  45374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  45380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vB
     /*  45384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vC
     /*  45388 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(150),
     /*  45398 */     GIR_RootConstrainSelectedInstOperands,
     /*  45399 */     // GIR_Coverage, 5265,
     /*  45399 */     GIR_EraseRootFromParent_Done,
     /*  45400 */   // Label 552: @45400
     /*  45400 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(45494), // Rule ID 4952 //
     /*  45405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45444 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45448 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45454 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45456 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45460 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45464 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45468 */     // MIs[4] C
     /*  45468 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45473 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45475 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45492 */     GIR_RootConstrainSelectedInstOperands,
     /*  45493 */     // GIR_Coverage, 4952,
     /*  45493 */     GIR_EraseRootFromParent_Done,
     /*  45494 */   // Label 553: @45494
     /*  45494 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(45588), // Rule ID 1588 //
     /*  45499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45542 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45558 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45562 */     // MIs[4] C
     /*  45562 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45567 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45569 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // A
     /*  45578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45586 */     GIR_RootConstrainSelectedInstOperands,
     /*  45587 */     // GIR_Coverage, 1588,
     /*  45587 */     GIR_EraseRootFromParent_Done,
     /*  45588 */   // Label 554: @45588
     /*  45588 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(45682), // Rule ID 4954 //
     /*  45593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45628 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45636 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45642 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45648 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45652 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45656 */     // MIs[4] C
     /*  45656 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45661 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45663 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // B
     /*  45676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45680 */     GIR_RootConstrainSelectedInstOperands,
     /*  45681 */     // GIR_Coverage, 4954,
     /*  45681 */     GIR_EraseRootFromParent_Done,
     /*  45682 */   // Label 555: @45682
     /*  45682 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(45776), // Rule ID 4953 //
     /*  45687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45722 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45730 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45736 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  45738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  45742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45750 */     // MIs[4] C
     /*  45750 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  45755 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45757 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  45766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // B
     /*  45770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // C
     /*  45774 */     GIR_RootConstrainSelectedInstOperands,
     /*  45775 */     // GIR_Coverage, 4953,
     /*  45775 */     GIR_EraseRootFromParent_Done,
     /*  45776 */   // Label 556: @45776
     /*  45776 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(45870), // Rule ID 4955 //
     /*  45781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45832 */     // MIs[3] C
     /*  45832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  45837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45851 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  45864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  45868 */     GIR_RootConstrainSelectedInstOperands,
     /*  45869 */     // GIR_Coverage, 4955,
     /*  45869 */     GIR_EraseRootFromParent_Done,
     /*  45870 */   // Label 557: @45870
     /*  45870 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(45964), // Rule ID 4957 //
     /*  45875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  45922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45926 */     // MIs[3] C
     /*  45926 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  45931 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45935 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45941 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  45943 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45945 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$A))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  45945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  45948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  45950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // A
     /*  45954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  45958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  45962 */     GIR_RootConstrainSelectedInstOperands,
     /*  45963 */     // GIR_Coverage, 4957,
     /*  45963 */     GIR_EraseRootFromParent_Done,
     /*  45964 */   // Label 558: @45964
     /*  45964 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(46058), // Rule ID 4956 //
     /*  45969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  45972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  45976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  45984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46020 */     // MIs[3] C
     /*  46020 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  46025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46029 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46035 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46039 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /*  46052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // C
     /*  46056 */     GIR_RootConstrainSelectedInstOperands,
     /*  46057 */     // GIR_Coverage, 4956,
     /*  46057 */     GIR_EraseRootFromParent_Done,
     /*  46058 */   // Label 559: @46058
     /*  46058 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(46152), // Rule ID 4958 //
     /*  46063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  46066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46098 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46110 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46114 */     // MIs[3] C
     /*  46114 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  46119 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  46123 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  46131 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46133 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, v4i32:{ *:[v4i32] }:$B), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$C, immAllOnesV:{ *:[v4i32] })))  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  46133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /*  46136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // A
     /*  46142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  46146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // C
     /*  46150 */     GIR_RootConstrainSelectedInstOperands,
     /*  46151 */     // GIR_Coverage, 4958,
     /*  46151 */     GIR_EraseRootFromParent_Done,
     /*  46152 */   // Label 560: @46152
     /*  46152 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(46239), // Rule ID 4978 //
     /*  46157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46200 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46206 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46210 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46227 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  46237 */     GIR_RootConstrainSelectedInstOperands,
     /*  46238 */     // GIR_Coverage, 4978,
     /*  46238 */     GIR_EraseRootFromParent_Done,
     /*  46239 */   // Label 561: @46239
     /*  46239 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(46324), // Rule ID 4972 //
     /*  46244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46283 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46287 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46293 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46297 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  46310 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46312 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46322 */     GIR_RootConstrainSelectedInstOperands,
     /*  46323 */     // GIR_Coverage, 4972,
     /*  46323 */     GIR_EraseRootFromParent_Done,
     /*  46324 */   // Label 562: @46324
     /*  46324 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(46409), // Rule ID 4973 //
     /*  46329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46372 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46382 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46395 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  46397 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46407 */     GIR_RootConstrainSelectedInstOperands,
     /*  46408 */     // GIR_Coverage, 4973,
     /*  46408 */     GIR_EraseRootFromParent_Done,
     /*  46409 */   // Label 563: @46409
     /*  46409 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(46496), // Rule ID 4974 //
     /*  46414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46449 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46457 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46467 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  46467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  46476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  46480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46484 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  46494 */     GIR_RootConstrainSelectedInstOperands,
     /*  46495 */     // GIR_Coverage, 4974,
     /*  46495 */     GIR_EraseRootFromParent_Done,
     /*  46496 */   // Label 564: @46496
     /*  46496 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(46581), // Rule ID 5293 //
     /*  46501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46544 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46552 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46554 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  46554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46559 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46569 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  46579 */     GIR_RootConstrainSelectedInstOperands,
     /*  46580 */     // GIR_Coverage, 5293,
     /*  46580 */     GIR_EraseRootFromParent_Done,
     /*  46581 */   // Label 565: @46581
     /*  46581 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(46666), // Rule ID 5294 //
     /*  46586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  46617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46629 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46635 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46639 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  46639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46644 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46654 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  46664 */     GIR_RootConstrainSelectedInstOperands,
     /*  46665 */     // GIR_Coverage, 5294,
     /*  46665 */     GIR_EraseRootFromParent_Done,
     /*  46666 */   // Label 566: @46666
     /*  46666 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(46751), // Rule ID 5291 //
     /*  46671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46710 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46714 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46720 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46724 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46729 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  46739 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46749 */     GIR_RootConstrainSelectedInstOperands,
     /*  46750 */     // GIR_Coverage, 5291,
     /*  46750 */     GIR_EraseRootFromParent_Done,
     /*  46751 */   // Label 567: @46751
     /*  46751 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(46836), // Rule ID 5290 //
     /*  46756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  46799 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46805 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46809 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46814 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  46824 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46834 */     GIR_RootConstrainSelectedInstOperands,
     /*  46835 */     // GIR_Coverage, 5290,
     /*  46835 */     GIR_EraseRootFromParent_Done,
     /*  46836 */   // Label 568: @46836
     /*  46836 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(46921), // Rule ID 5292 //
     /*  46841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  46884 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46890 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  46892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46894 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  46894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46899 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  46901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  46905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  46909 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  46919 */     GIR_RootConstrainSelectedInstOperands,
     /*  46920 */     // GIR_Coverage, 5292,
     /*  46920 */     GIR_EraseRootFromParent_Done,
     /*  46921 */   // Label 569: @46921
     /*  46921 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(47008), // Rule ID 3398 //
     /*  46926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  46929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  46933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  46941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46953 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46959 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  46961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  46969 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46973 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46977 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  46979 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 241:{ *:[i32] })
     /*  46979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  46982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  46984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  46988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  46992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  46996 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(241),
     /*  47006 */     GIR_RootConstrainSelectedInstOperands,
     /*  47007 */     // GIR_Coverage, 3398,
     /*  47007 */     GIR_EraseRootFromParent_Done,
     /*  47008 */   // Label 570: @47008
     /*  47008 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(47095), // Rule ID 3396 //
     /*  47013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47040 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47048 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47052 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47056 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47066 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47083 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47093 */     GIR_RootConstrainSelectedInstOperands,
     /*  47094 */     // GIR_Coverage, 3396,
     /*  47094 */     GIR_EraseRootFromParent_Done,
     /*  47095 */   // Label 571: @47095
     /*  47095 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(47182), // Rule ID 3397 //
     /*  47100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47127 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47133 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47143 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47147 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47153 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  47162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  47166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  47170 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47180 */     GIR_RootConstrainSelectedInstOperands,
     /*  47181 */     // GIR_Coverage, 3397,
     /*  47181 */     GIR_EraseRootFromParent_Done,
     /*  47182 */   // Label 572: @47182
     /*  47182 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(47269), // Rule ID 4977 //
     /*  47187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47226 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47230 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47240 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 246:{ *:[i32] })
     /*  47240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47257 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(246),
     /*  47267 */     GIR_RootConstrainSelectedInstOperands,
     /*  47268 */     // GIR_Coverage, 4977,
     /*  47268 */     GIR_EraseRootFromParent_Done,
     /*  47269 */   // Label 573: @47269
     /*  47269 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(47354), // Rule ID 4975 //
     /*  47274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47317 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47323 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47325 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47327 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vB))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  47340 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47342 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47352 */     GIR_RootConstrainSelectedInstOperands,
     /*  47353 */     // GIR_Coverage, 4975,
     /*  47353 */     GIR_EraseRootFromParent_Done,
     /*  47354 */   // Label 574: @47354
     /*  47354 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(47439), // Rule ID 4976 //
     /*  47359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47402 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47408 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47410 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47412 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 247:{ *:[i32] })
     /*  47412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  47421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  47425 */     GIR_RootToRootCopy, /*OpIdx*/1, // vC
     /*  47427 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(247),
     /*  47437 */     GIR_RootConstrainSelectedInstOperands,
     /*  47438 */     // GIR_Coverage, 4976,
     /*  47438 */     GIR_EraseRootFromParent_Done,
     /*  47439 */   // Label 575: @47439
     /*  47439 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(47524), // Rule ID 3411 //
     /*  47444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47479 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47487 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47493 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47495 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47497 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 239:{ *:[i32] })
     /*  47497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47502 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47512 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(239),
     /*  47522 */     GIR_RootConstrainSelectedInstOperands,
     /*  47523 */     // GIR_Coverage, 3411,
     /*  47523 */     GIR_EraseRootFromParent_Done,
     /*  47524 */   // Label 576: @47524
     /*  47524 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(47609), // Rule ID 3412 //
     /*  47529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  47560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47568 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47572 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47578 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47580 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47582 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 143:{ *:[i32] })
     /*  47582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47587 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47597 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(143),
     /*  47607 */     GIR_RootConstrainSelectedInstOperands,
     /*  47608 */     // GIR_Coverage, 3412,
     /*  47608 */     GIR_EraseRootFromParent_Done,
     /*  47609 */   // Label 577: @47609
     /*  47609 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(47694), // Rule ID 5288 //
     /*  47614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47657 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47663 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47665 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47667 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47672 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  47682 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47692 */     GIR_RootConstrainSelectedInstOperands,
     /*  47693 */     // GIR_Coverage, 5288,
     /*  47693 */     GIR_EraseRootFromParent_Done,
     /*  47694 */   // Label 578: @47694
     /*  47694 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(47779), // Rule ID 3410 //
     /*  47699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  47742 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47750 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47752 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47757 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  47767 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47777 */     GIR_RootConstrainSelectedInstOperands,
     /*  47778 */     // GIR_Coverage, 3410,
     /*  47778 */     GIR_EraseRootFromParent_Done,
     /*  47779 */   // Label 579: @47779
     /*  47779 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(47864), // Rule ID 5289 //
     /*  47784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47819 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  47827 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47833 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  47835 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  47837 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vC, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, immAllOnesV:{ *:[v4i32] })))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 159:{ *:[i32] })
     /*  47837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  47840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47842 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  47844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  47848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vC
     /*  47852 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(159),
     /*  47862 */     GIR_RootConstrainSelectedInstOperands,
     /*  47863 */     // GIR_Coverage, 5289,
     /*  47863 */     GIR_EraseRootFromParent_Done,
     /*  47864 */   // Label 580: @47864
     /*  47864 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(47919), // Rule ID 4942 //
     /*  47869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47896 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47906 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XA)  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47911 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  47913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47917 */     GIR_RootConstrainSelectedInstOperands,
     /*  47918 */     // GIR_Coverage, 4942,
     /*  47918 */     GIR_EraseRootFromParent_Done,
     /*  47919 */   // Label 581: @47919
     /*  47919 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(47974), // Rule ID 946 //
     /*  47924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  47927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  47939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47951 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47957 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  47959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47961 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, immAllOnesV:{ *:[v4i32] }))  =>  (XXLORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  47961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLORC),
     /*  47964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  47966 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /*  47968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /*  47972 */     GIR_RootConstrainSelectedInstOperands,
     /*  47973 */     // GIR_Coverage, 946,
     /*  47973 */     GIR_EraseRootFromParent_Done,
     /*  47974 */   // Label 582: @47974
     /*  47974 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(48024), // Rule ID 5287 //
     /*  47979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  47982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  47986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  47994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48004 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48009 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48022 */     GIR_RootConstrainSelectedInstOperands,
     /*  48023 */     // GIR_Coverage, 5287,
     /*  48023 */     GIR_EraseRootFromParent_Done,
     /*  48024 */   // Label 583: @48024
     /*  48024 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(48074), // Rule ID 5286 //
     /*  48029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48054 */     // (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  48063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  48067 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  48069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48072 */     GIR_RootConstrainSelectedInstOperands,
     /*  48073 */     // GIR_Coverage, 5286,
     /*  48073 */     GIR_EraseRootFromParent_Done,
     /*  48074 */   // Label 584: @48074
     /*  48074 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(48124), // Rule ID 5295 //
     /*  48079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48104 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48109 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  48111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48122 */     GIR_RootConstrainSelectedInstOperands,
     /*  48123 */     // GIR_Coverage, 5295,
     /*  48123 */     GIR_EraseRootFromParent_Done,
     /*  48124 */   // Label 585: @48124
     /*  48124 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(48174), // Rule ID 3409 //
     /*  48129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  48144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48154 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 31:{ *:[i32] })
     /*  48154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48159 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  48172 */     GIR_RootConstrainSelectedInstOperands,
     /*  48173 */     // GIR_Coverage, 3409,
     /*  48173 */     GIR_EraseRootFromParent_Done,
     /*  48174 */   // Label 586: @48174
     /*  48174 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(48224), // Rule ID 3408 //
     /*  48179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  48194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48204 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 127:{ *:[i32] })
     /*  48204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/127,
     /*  48222 */     GIR_RootConstrainSelectedInstOperands,
     /*  48223 */     // GIR_Coverage, 3408,
     /*  48223 */     GIR_EraseRootFromParent_Done,
     /*  48224 */   // Label 587: @48224
     /*  48224 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(48274), // Rule ID 3413 //
     /*  48229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  48232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48254 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 111:{ *:[i32] })
     /*  48254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  48257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  48259 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  48261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  48265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  48269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/111,
     /*  48272 */     GIR_RootConstrainSelectedInstOperands,
     /*  48273 */     // GIR_Coverage, 3413,
     /*  48273 */     GIR_EraseRootFromParent_Done,
     /*  48274 */   // Label 588: @48274
     /*  48274 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(48293), // Rule ID 935 //
     /*  48279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  48282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  48286 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  48286 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLOR),
     /*  48291 */     GIR_RootConstrainSelectedInstOperands,
     /*  48292 */     // GIR_Coverage, 935,
     /*  48292 */     GIR_Done,
     /*  48293 */   // Label 589: @48293
     /*  48293 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(48348), // Rule ID 4930 //
     /*  48298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48325 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48335 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VA)  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48340 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  48342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48346 */     GIR_RootConstrainSelectedInstOperands,
     /*  48347 */     // GIR_Coverage, 4930,
     /*  48347 */     GIR_EraseRootFromParent_Done,
     /*  48348 */   // Label 590: @48348
     /*  48348 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(48403), // Rule ID 489 //
     /*  48353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  48356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  48368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  48372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  48376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48380 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  48386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  48388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48390 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, immAllOnesV:{ *:[v4i32] }))  =>  (VORC:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VORC),
     /*  48393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  48395 */     GIR_RootToRootCopy, /*OpIdx*/1, // VA
     /*  48397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VB
     /*  48401 */     GIR_RootConstrainSelectedInstOperands,
     /*  48402 */     // GIR_Coverage, 489,
     /*  48402 */     GIR_EraseRootFromParent_Done,
     /*  48403 */   // Label 591: @48403
     /*  48403 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(48422), // Rule ID 386 //
     /*  48408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  48411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  48415 */     // (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  48415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VOR),
     /*  48420 */     GIR_RootConstrainSelectedInstOperands,
     /*  48421 */     // GIR_Coverage, 386,
     /*  48421 */     GIR_Done,
     /*  48422 */   // Label 592: @48422
     /*  48422 */   GIM_Reject,
     /*  48423 */ // Label 264: @48423
     /*  48423 */ GIM_Reject,
     /*  48424 */ // Label 251: @48424
     /*  48424 */ GIM_Reject,
     /*  48425 */ // Label 9: @48425
     /*  48425 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(6), /*)*//*default:*//*Label 597*/ GIMT_Encode4(57531),
     /*  48436 */ /*GILLT_s1*//*Label 593*/ GIMT_Encode4(48460),
     /*  48440 */ /*GILLT_s32*//*Label 594*/ GIMT_Encode4(53897),
     /*  48444 */ /*GILLT_s64*//*Label 595*/ GIMT_Encode4(54152), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  48456 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(54407),
     /*  48460 */ // Label 593: @48460
     /*  48460 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(53896),
     /*  48465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  48468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /*  48471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48475 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(48566), // Rule ID 3035 //
     /*  48480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48499 */     // MIs[1] Operand 1
     /*  48499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48512 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48516 */     // MIs[2] Operand 1
     /*  48516 */     // No operand predicates
     /*  48516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48522 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  48522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48548 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48565 */     // GIR_Coverage, 3035,
     /*  48565 */     GIR_EraseRootFromParent_Done,
     /*  48566 */   // Label 599: @48566
     /*  48566 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(48657), // Rule ID 3051 //
     /*  48571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48586 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48590 */     // MIs[1] Operand 1
     /*  48590 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48603 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48607 */     // MIs[2] Operand 1
     /*  48607 */     // No operand predicates
     /*  48607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48613 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  48613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48639 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48656 */     // GIR_Coverage, 3051,
     /*  48656 */     GIR_EraseRootFromParent_Done,
     /*  48657 */   // Label 600: @48657
     /*  48657 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(48748), // Rule ID 3059 //
     /*  48662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  48677 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  48681 */     // MIs[1] Operand 1
     /*  48681 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  48698 */     // MIs[2] Operand 1
     /*  48698 */     // No operand predicates
     /*  48698 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48704 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  48704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  48711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48730 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  48737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48747 */     // GIR_Coverage, 3059,
     /*  48747 */     GIR_EraseRootFromParent_Done,
     /*  48748 */   // Label 601: @48748
     /*  48748 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(48839), // Rule ID 3131 //
     /*  48753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48768 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48772 */     // MIs[1] Operand 1
     /*  48772 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  48777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48785 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48789 */     // MIs[2] Operand 1
     /*  48789 */     // No operand predicates
     /*  48789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48795 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  48795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48807 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48821 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  48828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48838 */     // GIR_Coverage, 3131,
     /*  48838 */     GIR_EraseRootFromParent_Done,
     /*  48839 */   // Label 602: @48839
     /*  48839 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(48930), // Rule ID 3147 //
     /*  48844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48863 */     // MIs[1] Operand 1
     /*  48863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  48868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48876 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48880 */     // MIs[2] Operand 1
     /*  48880 */     // No operand predicates
     /*  48880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48886 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  48886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  48910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  48919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  48924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  48929 */     // GIR_Coverage, 3147,
     /*  48929 */     GIR_EraseRootFromParent_Done,
     /*  48930 */   // Label 603: @48930
     /*  48930 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(49021), // Rule ID 3155 //
     /*  48935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  48938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  48946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  48950 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  48954 */     // MIs[1] Operand 1
     /*  48954 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  48959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  48963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  48971 */     // MIs[2] Operand 1
     /*  48971 */     // No operand predicates
     /*  48971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  48975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48977 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  48977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  48980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  48984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  48989 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  48993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  48996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  48998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49020 */     // GIR_Coverage, 3155,
     /*  49020 */     GIR_EraseRootFromParent_Done,
     /*  49021 */   // Label 604: @49021
     /*  49021 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(49112), // Rule ID 3818 //
     /*  49026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49041 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49045 */     // MIs[1] Operand 1
     /*  49045 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49062 */     // MIs[2] Operand 1
     /*  49062 */     // No operand predicates
     /*  49062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49068 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /*  49068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49094 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49101 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49106 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49111 */     // GIR_Coverage, 3818,
     /*  49111 */     GIR_EraseRootFromParent_Done,
     /*  49112 */   // Label 605: @49112
     /*  49112 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(49203), // Rule ID 3834 //
     /*  49117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49132 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49136 */     // MIs[1] Operand 1
     /*  49136 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49149 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49153 */     // MIs[2] Operand 1
     /*  49153 */     // No operand predicates
     /*  49153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49159 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /*  49159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49185 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49197 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49202 */     // GIR_Coverage, 3834,
     /*  49202 */     GIR_EraseRootFromParent_Done,
     /*  49203 */   // Label 606: @49203
     /*  49203 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(49294), // Rule ID 3842 //
     /*  49208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49223 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49227 */     // MIs[1] Operand 1
     /*  49227 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49240 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  49244 */     // MIs[2] Operand 1
     /*  49244 */     // No operand predicates
     /*  49244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49250 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /*  49250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  49257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49276 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49293 */     // GIR_Coverage, 3842,
     /*  49293 */     GIR_EraseRootFromParent_Done,
     /*  49294 */   // Label 607: @49294
     /*  49294 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(49385), // Rule ID 3914 //
     /*  49299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49314 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49318 */     // MIs[1] Operand 1
     /*  49318 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  49323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49331 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49335 */     // MIs[2] Operand 1
     /*  49335 */     // No operand predicates
     /*  49335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49341 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /*  49341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49367 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49379 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49384 */     // GIR_Coverage, 3914,
     /*  49384 */     GIR_EraseRootFromParent_Done,
     /*  49385 */   // Label 608: @49385
     /*  49385 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(49476), // Rule ID 3930 //
     /*  49390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49405 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49409 */     // MIs[1] Operand 1
     /*  49409 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  49414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49422 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49426 */     // MIs[2] Operand 1
     /*  49426 */     // No operand predicates
     /*  49426 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49432 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /*  49432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49458 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49475 */     // GIR_Coverage, 3930,
     /*  49475 */     GIR_EraseRootFromParent_Done,
     /*  49476 */   // Label 609: @49476
     /*  49476 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(49567), // Rule ID 3938 //
     /*  49481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  49484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  49492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49496 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49500 */     // MIs[1] Operand 1
     /*  49500 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  49505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  49509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  49517 */     // MIs[2] Operand 1
     /*  49517 */     // No operand predicates
     /*  49517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49523 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /*  49523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  49530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49535 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /*  49542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49566 */     // GIR_Coverage, 3938,
     /*  49566 */     GIR_EraseRootFromParent_Done,
     /*  49567 */   // Label 610: @49567
     /*  49567 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(49647), // Rule ID 3179 //
     /*  49572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49591 */     // MIs[1] Operand 1
     /*  49591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49602 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  49602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49646 */     // GIR_Coverage, 3179,
     /*  49646 */     GIR_EraseRootFromParent_Done,
     /*  49647 */   // Label 611: @49647
     /*  49647 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(49727), // Rule ID 3195 //
     /*  49652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49671 */     // MIs[1] Operand 1
     /*  49671 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49682 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  49682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  49716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49726 */     // GIR_Coverage, 3195,
     /*  49726 */     GIR_EraseRootFromParent_Done,
     /*  49727 */   // Label 612: @49727
     /*  49727 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(49807), // Rule ID 3211 //
     /*  49732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49751 */     // MIs[1] Operand 1
     /*  49751 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  49756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49762 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  49762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  49796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49806 */     // GIR_Coverage, 3211,
     /*  49806 */     GIR_EraseRootFromParent_Done,
     /*  49807 */   // Label 613: @49807
     /*  49807 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(49887), // Rule ID 3227 //
     /*  49812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  49827 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  49831 */     // MIs[1] Operand 1
     /*  49831 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  49836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49842 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  49842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  49849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  49876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49886 */     // GIR_Coverage, 3227,
     /*  49886 */     GIR_EraseRootFromParent_Done,
     /*  49887 */   // Label 614: @49887
     /*  49887 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(49967), // Rule ID 3235 //
     /*  49892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49907 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49911 */     // MIs[1] Operand 1
     /*  49911 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  49916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  49920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49922 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  49922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  49925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  49929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  49934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  49938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  49942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  49944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  49947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49949 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  49956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  49961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  49966 */     // GIR_Coverage, 3235,
     /*  49966 */     GIR_EraseRootFromParent_Done,
     /*  49967 */   // Label 615: @49967
     /*  49967 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(50047), // Rule ID 3251 //
     /*  49972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  49975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  49983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  49987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  49991 */     // MIs[1] Operand 1
     /*  49991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  49996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50002 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50046 */     // GIR_Coverage, 3251,
     /*  50046 */     GIR_EraseRootFromParent_Done,
     /*  50047 */   // Label 616: @50047
     /*  50047 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(50127), // Rule ID 3267 //
     /*  50052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50071 */     // MIs[1] Operand 1
     /*  50071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50082 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  50082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50126 */     // GIR_Coverage, 3267,
     /*  50126 */     GIR_EraseRootFromParent_Done,
     /*  50127 */   // Label 617: @50127
     /*  50127 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(50207), // Rule ID 3283 //
     /*  50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50151 */     // MIs[1] Operand 1
     /*  50151 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50162 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  50162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50206 */     // GIR_Coverage, 3283,
     /*  50206 */     GIR_EraseRootFromParent_Done,
     /*  50207 */   // Label 618: @50207
     /*  50207 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(50287), // Rule ID 3291 //
     /*  50212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50231 */     // MIs[1] Operand 1
     /*  50231 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50242 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  50242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50269 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50286 */     // GIR_Coverage, 3291,
     /*  50286 */     GIR_EraseRootFromParent_Done,
     /*  50287 */   // Label 619: @50287
     /*  50287 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(50367), // Rule ID 3307 //
     /*  50292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50311 */     // MIs[1] Operand 1
     /*  50311 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50322 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  50322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50366 */     // GIR_Coverage, 3307,
     /*  50366 */     GIR_EraseRootFromParent_Done,
     /*  50367 */   // Label 620: @50367
     /*  50367 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(50447), // Rule ID 3323 //
     /*  50372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50391 */     // MIs[1] Operand 1
     /*  50391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50402 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  50402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50446 */     // GIR_Coverage, 3323,
     /*  50446 */     GIR_EraseRootFromParent_Done,
     /*  50447 */   // Label 621: @50447
     /*  50447 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(50527), // Rule ID 3339 //
     /*  50452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  50455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  50467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  50471 */     // MIs[1] Operand 1
     /*  50471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50482 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  50482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  50489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50526 */     // GIR_Coverage, 3339,
     /*  50526 */     GIR_EraseRootFromParent_Done,
     /*  50527 */   // Label 622: @50527
     /*  50527 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(50607), // Rule ID 4018 //
     /*  50532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50547 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50551 */     // MIs[1] Operand 1
     /*  50551 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50562 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /*  50562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50606 */     // GIR_Coverage, 4018,
     /*  50606 */     GIR_EraseRootFromParent_Done,
     /*  50607 */   // Label 623: @50607
     /*  50607 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(50687), // Rule ID 4050 //
     /*  50612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50631 */     // MIs[1] Operand 1
     /*  50631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50642 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  50642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50686 */     // GIR_Coverage, 4050,
     /*  50686 */     GIR_EraseRootFromParent_Done,
     /*  50687 */   // Label 624: @50687
     /*  50687 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(50767), // Rule ID 4082 //
     /*  50692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50711 */     // MIs[1] Operand 1
     /*  50711 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  50716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50722 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /*  50722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  50756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50766 */     // GIR_Coverage, 4082,
     /*  50766 */     GIR_EraseRootFromParent_Done,
     /*  50767 */   // Label 625: @50767
     /*  50767 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(50847), // Rule ID 4114 //
     /*  50772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  50791 */     // MIs[1] Operand 1
     /*  50791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  50796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50802 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /*  50802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  50809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  50836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50846 */     // GIR_Coverage, 4114,
     /*  50846 */     GIR_EraseRootFromParent_Done,
     /*  50847 */   // Label 626: @50847
     /*  50847 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(50927), // Rule ID 4130 //
     /*  50852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50871 */     // MIs[1] Operand 1
     /*  50871 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  50876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50882 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /*  50882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  50916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  50921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  50926 */     // GIR_Coverage, 4130,
     /*  50926 */     GIR_EraseRootFromParent_Done,
     /*  50927 */   // Label 627: @50927
     /*  50927 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(51007), // Rule ID 4162 //
     /*  50932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  50935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  50943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  50947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  50951 */     // MIs[1] Operand 1
     /*  50951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  50956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  50960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50962 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  50962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  50965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  50969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  50974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  50978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  50982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  50984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  50987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50989 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  50996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51006 */     // GIR_Coverage, 4162,
     /*  51006 */     GIR_EraseRootFromParent_Done,
     /*  51007 */   // Label 628: @51007
     /*  51007 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(51087), // Rule ID 4194 //
     /*  51012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51031 */     // MIs[1] Operand 1
     /*  51031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51042 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /*  51042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51069 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51086 */     // GIR_Coverage, 4194,
     /*  51086 */     GIR_EraseRootFromParent_Done,
     /*  51087 */   // Label 629: @51087
     /*  51087 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(51167), // Rule ID 4226 //
     /*  51092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51111 */     // MIs[1] Operand 1
     /*  51111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51122 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /*  51122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  51129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51149 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51166 */     // GIR_Coverage, 4226,
     /*  51166 */     GIR_EraseRootFromParent_Done,
     /*  51167 */   // Label 630: @51167
     /*  51167 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(51247), // Rule ID 4256 //
     /*  51172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51191 */     // MIs[1] Operand 1
     /*  51191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51202 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /*  51202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  51236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51246 */     // GIR_Coverage, 4256,
     /*  51246 */     GIR_EraseRootFromParent_Done,
     /*  51247 */   // Label 631: @51247
     /*  51247 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(51327), // Rule ID 4288 //
     /*  51252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51271 */     // MIs[1] Operand 1
     /*  51271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51282 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /*  51282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51326 */     // GIR_Coverage, 4288,
     /*  51326 */     GIR_EraseRootFromParent_Done,
     /*  51327 */   // Label 632: @51327
     /*  51327 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(51407), // Rule ID 4320 //
     /*  51332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51351 */     // MIs[1] Operand 1
     /*  51351 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51362 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /*  51362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  51396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51406 */     // GIR_Coverage, 4320,
     /*  51406 */     GIR_EraseRootFromParent_Done,
     /*  51407 */   // Label 633: @51407
     /*  51407 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(51487), // Rule ID 4352 //
     /*  51412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  51415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  51427 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  51431 */     // MIs[1] Operand 1
     /*  51431 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  51436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51442 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /*  51442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  51449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  51476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51486 */     // GIR_Coverage, 4352,
     /*  51486 */     GIR_EraseRootFromParent_Done,
     /*  51487 */   // Label 634: @51487
     /*  51487 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(51567), // Rule ID 4583 //
     /*  51492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51511 */     // MIs[1] Operand 1
     /*  51511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51522 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /*  51529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51566 */     // GIR_Coverage, 4583,
     /*  51566 */     GIR_EraseRootFromParent_Done,
     /*  51567 */   // Label 635: @51567
     /*  51567 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(51647), // Rule ID 4615 //
     /*  51572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51587 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51591 */     // MIs[1] Operand 1
     /*  51591 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51602 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /*  51609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51629 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51646 */     // GIR_Coverage, 4615,
     /*  51646 */     GIR_EraseRootFromParent_Done,
     /*  51647 */   // Label 636: @51647
     /*  51647 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(51727), // Rule ID 4647 //
     /*  51652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51671 */     // MIs[1] Operand 1
     /*  51671 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51682 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /*  51682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /*  51689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51709 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51726 */     // GIR_Coverage, 4647,
     /*  51726 */     GIR_EraseRootFromParent_Done,
     /*  51727 */   // Label 637: @51727
     /*  51727 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(51807), // Rule ID 4691 //
     /*  51732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51747 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51751 */     // MIs[1] Operand 1
     /*  51751 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  51756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51762 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /*  51769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51789 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51806 */     // GIR_Coverage, 4691,
     /*  51806 */     GIR_EraseRootFromParent_Done,
     /*  51807 */   // Label 638: @51807
     /*  51807 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(51887), // Rule ID 4723 //
     /*  51812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51827 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51831 */     // MIs[1] Operand 1
     /*  51831 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  51836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51842 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /*  51849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51886 */     // GIR_Coverage, 4723,
     /*  51886 */     GIR_EraseRootFromParent_Done,
     /*  51887 */   // Label 639: @51887
     /*  51887 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(51967), // Rule ID 4755 //
     /*  51892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /*  51895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  51903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51907 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  51911 */     // MIs[1] Operand 1
     /*  51911 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  51916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  51920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51922 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /*  51922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /*  51929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  51938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  51942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51949 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  51956 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  51961 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  51966 */     // GIR_Coverage, 4755,
     /*  51966 */     GIR_EraseRootFromParent_Done,
     /*  51967 */   // Label 640: @51967
     /*  51967 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(52047), // Rule ID 2981 //
     /*  51972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  51975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  51983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51987 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  51991 */     // MIs[1] Operand 1
     /*  51991 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  51996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52002 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52046 */     // GIR_Coverage, 2981,
     /*  52046 */     GIR_EraseRootFromParent_Done,
     /*  52047 */   // Label 641: @52047
     /*  52047 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(52127), // Rule ID 2995 //
     /*  52052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52071 */     // MIs[1] Operand 1
     /*  52071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52082 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52094 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52126 */     // GIR_Coverage, 2995,
     /*  52126 */     GIR_EraseRootFromParent_Done,
     /*  52127 */   // Label 642: @52127
     /*  52127 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(52207), // Rule ID 3003 //
     /*  52132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52151 */     // MIs[1] Operand 1
     /*  52151 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52162 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52174 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52178 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52189 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52196 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52201 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52206 */     // GIR_Coverage, 3003,
     /*  52206 */     GIR_EraseRootFromParent_Done,
     /*  52207 */   // Label 643: @52207
     /*  52207 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(52287), // Rule ID 3011 //
     /*  52212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52231 */     // MIs[1] Operand 1
     /*  52231 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52242 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52269 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52281 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52286 */     // GIR_Coverage, 3011,
     /*  52286 */     GIR_EraseRootFromParent_Done,
     /*  52287 */   // Label 644: @52287
     /*  52287 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(52367), // Rule ID 3019 //
     /*  52292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52311 */     // MIs[1] Operand 1
     /*  52311 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52316 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52322 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  52322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52334 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52349 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52366 */     // GIR_Coverage, 3019,
     /*  52366 */     GIR_EraseRootFromParent_Done,
     /*  52367 */   // Label 645: @52367
     /*  52367 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(52447), // Rule ID 3083 //
     /*  52372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52391 */     // MIs[1] Operand 1
     /*  52391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52396 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52402 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52446 */     // GIR_Coverage, 3083,
     /*  52446 */     GIR_EraseRootFromParent_Done,
     /*  52447 */   // Label 646: @52447
     /*  52447 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(52527), // Rule ID 3091 //
     /*  52452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52471 */     // MIs[1] Operand 1
     /*  52471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52476 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52482 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  52482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52498 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52509 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52526 */     // GIR_Coverage, 3091,
     /*  52526 */     GIR_EraseRootFromParent_Done,
     /*  52527 */   // Label 647: @52527
     /*  52527 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(52607), // Rule ID 3099 //
     /*  52532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52547 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52551 */     // MIs[1] Operand 1
     /*  52551 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52556 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52562 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  52569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52574 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52589 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52606 */     // GIR_Coverage, 3099,
     /*  52606 */     GIR_EraseRootFromParent_Done,
     /*  52607 */   // Label 648: @52607
     /*  52607 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(52687), // Rule ID 3107 //
     /*  52612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52631 */     // MIs[1] Operand 1
     /*  52631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  52636 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52642 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  52642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52654 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52669 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52686 */     // GIR_Coverage, 3107,
     /*  52686 */     GIR_EraseRootFromParent_Done,
     /*  52687 */   // Label 649: @52687
     /*  52687 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(52767), // Rule ID 3115 //
     /*  52692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  52695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  52711 */     // MIs[1] Operand 1
     /*  52711 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  52716 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52722 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  52722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  52729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52749 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  52756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52766 */     // GIR_Coverage, 3115,
     /*  52766 */     GIR_EraseRootFromParent_Done,
     /*  52767 */   // Label 650: @52767
     /*  52767 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(52847), // Rule ID 3866 //
     /*  52772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52791 */     // MIs[1] Operand 1
     /*  52791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  52796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52802 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52846 */     // GIR_Coverage, 3866,
     /*  52846 */     GIR_EraseRootFromParent_Done,
     /*  52847 */   // Label 651: @52847
     /*  52847 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(52927), // Rule ID 3874 //
     /*  52852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52871 */     // MIs[1] Operand 1
     /*  52871 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  52876 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52882 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /*  52882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  52889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52909 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  52916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  52921 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  52926 */     // GIR_Coverage, 3874,
     /*  52926 */     GIR_EraseRootFromParent_Done,
     /*  52927 */   // Label 652: @52927
     /*  52927 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(53007), // Rule ID 3882 //
     /*  52932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  52935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  52943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52947 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  52951 */     // MIs[1] Operand 1
     /*  52951 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  52956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  52960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52962 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  52962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /*  52969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52974 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  52978 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  52982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  52989 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  52996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53006 */     // GIR_Coverage, 3882,
     /*  53006 */     GIR_EraseRootFromParent_Done,
     /*  53007 */   // Label 653: @53007
     /*  53007 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(53087), // Rule ID 3890 //
     /*  53012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53031 */     // MIs[1] Operand 1
     /*  53031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53042 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /*  53042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53069 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53086 */     // GIR_Coverage, 3890,
     /*  53086 */     GIR_EraseRootFromParent_Done,
     /*  53087 */   // Label 654: @53087
     /*  53087 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(53167), // Rule ID 3898 //
     /*  53092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  53111 */     // MIs[1] Operand 1
     /*  53111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53122 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /*  53122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /*  53129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53138 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53149 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53166 */     // GIR_Coverage, 3898,
     /*  53166 */     GIR_EraseRootFromParent_Done,
     /*  53167 */   // Label 655: @53167
     /*  53167 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(53247), // Rule ID 3962 //
     /*  53172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53191 */     // MIs[1] Operand 1
     /*  53191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /*  53196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53202 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53246 */     // GIR_Coverage, 3962,
     /*  53246 */     GIR_EraseRootFromParent_Done,
     /*  53247 */   // Label 656: @53247
     /*  53247 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(53327), // Rule ID 3970 //
     /*  53252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53271 */     // MIs[1] Operand 1
     /*  53271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  53276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53282 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /*  53282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53298 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53309 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  53316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53326 */     // GIR_Coverage, 3970,
     /*  53326 */     GIR_EraseRootFromParent_Done,
     /*  53327 */   // Label 657: @53327
     /*  53327 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(53407), // Rule ID 3978 //
     /*  53332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53351 */     // MIs[1] Operand 1
     /*  53351 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /*  53356 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53362 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /*  53369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53389 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53406 */     // GIR_Coverage, 3978,
     /*  53406 */     GIR_EraseRootFromParent_Done,
     /*  53407 */   // Label 658: @53407
     /*  53407 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(53487), // Rule ID 3986 //
     /*  53412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53427 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53431 */     // MIs[1] Operand 1
     /*  53431 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  53436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53442 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /*  53442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  53476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53486 */     // GIR_Coverage, 3986,
     /*  53486 */     GIR_EraseRootFromParent_Done,
     /*  53487 */   // Label 659: @53487
     /*  53487 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(53567), // Rule ID 3994 //
     /*  53492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  53495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  53503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53507 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  53511 */     // MIs[1] Operand 1
     /*  53511 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  53516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53522 */     // (xor:{ *:[i1] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }), -1:{ *:[i1] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /*  53522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  53529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  53538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  53542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53549 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  53556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  53561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  53566 */     // GIR_Coverage, 3994,
     /*  53566 */     GIR_EraseRootFromParent_Done,
     /*  53567 */   // Label 660: @53567
     /*  53567 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(53609), // Rule ID 176 //
     /*  53572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53594 */     // (xor:{ *:[i1] } (and:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNAND:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNAND),
     /*  53597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53607 */     GIR_RootConstrainSelectedInstOperands,
     /*  53608 */     // GIR_Coverage, 176,
     /*  53608 */     GIR_EraseRootFromParent_Done,
     /*  53609 */   // Label 661: @53609
     /*  53609 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(53651), // Rule ID 179 //
     /*  53614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53636 */     // (xor:{ *:[i1] } (or:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CRNOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOR),
     /*  53639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53649 */     GIR_RootConstrainSelectedInstOperands,
     /*  53650 */     // GIR_Coverage, 179,
     /*  53650 */     GIR_EraseRootFromParent_Done,
     /*  53651 */   // Label 662: @53651
     /*  53651 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(53691), // Rule ID 4922 //
     /*  53656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53678 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }), i1:{ *:[i1] }:$CRB)  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53687 */     GIR_RootToRootCopy, /*OpIdx*/2, // CRB
     /*  53689 */     GIR_RootConstrainSelectedInstOperands,
     /*  53690 */     // GIR_Coverage, 4922,
     /*  53690 */     GIR_EraseRootFromParent_Done,
     /*  53691 */   // Label 663: @53691
     /*  53691 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(53733), // Rule ID 180 //
     /*  53696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53712 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53718 */     // (xor:{ *:[i1] } (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB), -1:{ *:[i1] })  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // CRB
     /*  53731 */     GIR_RootConstrainSelectedInstOperands,
     /*  53732 */     // GIR_Coverage, 180,
     /*  53732 */     GIR_EraseRootFromParent_Done,
     /*  53733 */   // Label 664: @53733
     /*  53733 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(53770), // Rule ID 4855 //
     /*  53738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53756 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i32:{ *:[i32] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } ?:{ *:[i32] }:$in)
     /*  53756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /*  53759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53768 */     GIR_RootConstrainSelectedInstOperands,
     /*  53769 */     // GIR_Coverage, 4855,
     /*  53769 */     GIR_EraseRootFromParent_Done,
     /*  53770 */   // Label 665: @53770
     /*  53770 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(53807), // Rule ID 4856 //
     /*  53775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  53783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53793 */     // (xor:{ *:[i1] } (trunc:{ *:[i1] } i64:{ *:[i64] }:$in), -1:{ *:[i1] })  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } ?:{ *:[i64] }:$in)
     /*  53793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /*  53802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  53805 */     GIR_RootConstrainSelectedInstOperands,
     /*  53806 */     // GIR_Coverage, 4856,
     /*  53806 */     GIR_EraseRootFromParent_Done,
     /*  53807 */   // Label 666: @53807
     /*  53807 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(53847), // Rule ID 4923 //
     /*  53812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  53824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  53828 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53834 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRB, (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] }))  =>  (CREQV:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /*  53837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // CRA
     /*  53843 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRB
     /*  53845 */     GIR_RootConstrainSelectedInstOperands,
     /*  53846 */     // GIR_Coverage, 4923,
     /*  53846 */     GIR_EraseRootFromParent_Done,
     /*  53847 */   // Label 667: @53847
     /*  53847 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(53865), // Rule ID 181 //
     /*  53852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53856 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } i1:{ *:[i1] }:$CRA)
     /*  53856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53861 */     GIR_RootToRootCopy, /*OpIdx*/1, // CRA
     /*  53863 */     GIR_RootConstrainSelectedInstOperands,
     /*  53864 */     // GIR_Coverage, 181,
     /*  53864 */     GIR_EraseRootFromParent_Done,
     /*  53865 */   // Label 668: @53865
     /*  53865 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(53883), // Rule ID 2909 //
     /*  53870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53874 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$in, -1:{ *:[i1] })  =>  (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$in)
     /*  53874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /*  53877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /*  53879 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  53881 */     GIR_RootConstrainSelectedInstOperands,
     /*  53882 */     // GIR_Coverage, 2909,
     /*  53882 */     GIR_EraseRootFromParent_Done,
     /*  53883 */   // Label 669: @53883
     /*  53883 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(53895), // Rule ID 178 //
     /*  53888 */     // (xor:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)  =>  (CRXOR:{ *:[i1] } i1:{ *:[i1] }:$CRA, i1:{ *:[i1] }:$CRB)
     /*  53888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /*  53893 */     GIR_RootConstrainSelectedInstOperands,
     /*  53894 */     // GIR_Coverage, 178,
     /*  53894 */     GIR_Done,
     /*  53895 */   // Label 670: @53895
     /*  53895 */   GIM_Reject,
     /*  53896 */ // Label 598: @53896
     /*  53896 */ GIM_Reject,
     /*  53897 */ // Label 594: @53897
     /*  53897 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(54151),
     /*  53902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  53905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  53908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  53912 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(53954), // Rule ID 121 //
     /*  53917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  53925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53939 */     // (xor:{ *:[i32] } (and:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NAND:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  53942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53952 */     GIR_RootConstrainSelectedInstOperands,
     /*  53953 */     // GIR_Coverage, 121,
     /*  53953 */     GIR_EraseRootFromParent_Done,
     /*  53954 */   // Label 672: @53954
     /*  53954 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(53996), // Rule ID 125 //
     /*  53959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  53967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  53979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53981 */     // (xor:{ *:[i32] } (or:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  53981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  53984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  53986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  53990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  53994 */     GIR_RootConstrainSelectedInstOperands,
     /*  53995 */     // GIR_Coverage, 125,
     /*  53995 */     GIR_EraseRootFromParent_Done,
     /*  53996 */   // Label 673: @53996
     /*  53996 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(54036), // Rule ID 4920 //
     /*  54001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54017 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54023 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }), i32:{ *:[i32] }:$RB)  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54032 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54034 */     GIR_RootConstrainSelectedInstOperands,
     /*  54035 */     // GIR_Coverage, 4920,
     /*  54035 */     GIR_EraseRootFromParent_Done,
     /*  54036 */   // Label 674: @54036
     /*  54036 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(54078), // Rule ID 127 //
     /*  54041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54063 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB), -1:{ *:[i32] })  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54076 */     GIR_RootConstrainSelectedInstOperands,
     /*  54077 */     // GIR_Coverage, 127,
     /*  54077 */     GIR_EraseRootFromParent_Done,
     /*  54078 */   // Label 675: @54078
     /*  54078 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(54118), // Rule ID 4921 //
     /*  54083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54105 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RB, (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, -1:{ *:[i32] }))  =>  (EQV:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV),
     /*  54108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54114 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54116 */     GIR_RootConstrainSelectedInstOperands,
     /*  54117 */     // GIR_Coverage, 4921,
     /*  54117 */     GIR_EraseRootFromParent_Done,
     /*  54118 */   // Label 676: @54118
     /*  54118 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(54138), // Rule ID 1213 //
     /*  54123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54127 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$in)
     /*  54127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  54130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54132 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54134 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54136 */     GIR_RootConstrainSelectedInstOperands,
     /*  54137 */     // GIR_Coverage, 1213,
     /*  54137 */     GIR_EraseRootFromParent_Done,
     /*  54138 */   // Label 677: @54138
     /*  54138 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(54150), // Rule ID 128 //
     /*  54143 */     // (xor:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)  =>  (XOR:{ *:[i32] } i32:{ *:[i32] }:$RST, i32:{ *:[i32] }:$RB)
     /*  54143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR),
     /*  54148 */     GIR_RootConstrainSelectedInstOperands,
     /*  54149 */     // GIR_Coverage, 128,
     /*  54149 */     GIR_Done,
     /*  54150 */   // Label 678: @54150
     /*  54150 */   GIM_Reject,
     /*  54151 */ // Label 671: @54151
     /*  54151 */ GIM_Reject,
     /*  54152 */ // Label 595: @54152
     /*  54152 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(54406),
     /*  54157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  54167 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(54209), // Rule ID 645 //
     /*  54172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54194 */     // (xor:{ *:[i64] } (and:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NAND8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  54197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54207 */     GIR_RootConstrainSelectedInstOperands,
     /*  54208 */     // GIR_Coverage, 645,
     /*  54208 */     GIR_EraseRootFromParent_Done,
     /*  54209 */   // Label 680: @54209
     /*  54209 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(54251), // Rule ID 649 //
     /*  54214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54230 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54236 */     // (xor:{ *:[i64] } (or:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54249 */     GIR_RootConstrainSelectedInstOperands,
     /*  54250 */     // GIR_Coverage, 649,
     /*  54250 */     GIR_EraseRootFromParent_Done,
     /*  54251 */   // Label 681: @54251
     /*  54251 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(54291), // Rule ID 4933 //
     /*  54256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54272 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54278 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }), i64:{ *:[i64] }:$RB)  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54287 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  54289 */     GIR_RootConstrainSelectedInstOperands,
     /*  54290 */     // GIR_Coverage, 4933,
     /*  54290 */     GIR_EraseRootFromParent_Done,
     /*  54291 */   // Label 682: @54291
     /*  54291 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(54333), // Rule ID 651 //
     /*  54296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54318 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB), -1:{ *:[i64] })  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /*  54331 */     GIR_RootConstrainSelectedInstOperands,
     /*  54332 */     // GIR_Coverage, 651,
     /*  54332 */     GIR_EraseRootFromParent_Done,
     /*  54333 */   // Label 683: @54333
     /*  54333 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(54373), // Rule ID 4934 //
     /*  54338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54354 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54360 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RB, (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, -1:{ *:[i64] }))  =>  (EQV8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EQV8),
     /*  54363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RST
     /*  54369 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /*  54371 */     GIR_RootConstrainSelectedInstOperands,
     /*  54372 */     // GIR_Coverage, 4934,
     /*  54372 */     GIR_EraseRootFromParent_Done,
     /*  54373 */   // Label 684: @54373
     /*  54373 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(54393), // Rule ID 1525 //
     /*  54378 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  54382 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] })  =>  (NOR8:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i64] }:$in)
     /*  54382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  54385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  54387 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54389 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  54391 */     GIR_RootConstrainSelectedInstOperands,
     /*  54392 */     // GIR_Coverage, 1525,
     /*  54392 */     GIR_EraseRootFromParent_Done,
     /*  54393 */   // Label 685: @54393
     /*  54393 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(54405), // Rule ID 652 //
     /*  54398 */     // (xor:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (XOR8:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  54398 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XOR8),
     /*  54403 */     GIR_RootConstrainSelectedInstOperands,
     /*  54404 */     // GIR_Coverage, 652,
     /*  54404 */     GIR_Done,
     /*  54405 */   // Label 686: @54405
     /*  54405 */   GIM_Reject,
     /*  54406 */ // Label 679: @54406
     /*  54406 */ GIM_Reject,
     /*  54407 */ // Label 596: @54407
     /*  54407 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(57530),
     /*  54412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54418 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(54505), // Rule ID 4969 //
     /*  54423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54466 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54474 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54476 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  54485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  54489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  54493 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54503 */     GIR_RootConstrainSelectedInstOperands,
     /*  54504 */     // GIR_Coverage, 4969,
     /*  54504 */     GIR_EraseRootFromParent_Done,
     /*  54505 */   // Label 688: @54505
     /*  54505 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(54592), // Rule ID 4971 //
     /*  54510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54545 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54553 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54563 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54580 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54590 */     GIR_RootConstrainSelectedInstOperands,
     /*  54591 */     // GIR_Coverage, 4971,
     /*  54591 */     GIR_EraseRootFromParent_Done,
     /*  54592 */   // Label 689: @54592
     /*  54592 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(54679), // Rule ID 4970 //
     /*  54597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54628 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54632 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54636 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54640 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54646 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54648 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54650 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  54659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54667 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54677 */     GIR_RootConstrainSelectedInstOperands,
     /*  54678 */     // GIR_Coverage, 4970,
     /*  54678 */     GIR_EraseRootFromParent_Done,
     /*  54679 */   // Label 690: @54679
     /*  54679 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(54766), // Rule ID 3393 //
     /*  54684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54715 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54719 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54727 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54733 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54735 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54737 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 254:{ *:[i32] })
     /*  54737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54754 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /*  54764 */     GIR_RootConstrainSelectedInstOperands,
     /*  54765 */     // GIR_Coverage, 3393,
     /*  54765 */     GIR_EraseRootFromParent_Done,
     /*  54766 */   // Label 691: @54766
     /*  54766 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(54853), // Rule ID 3395 //
     /*  54771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  54802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54824 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 248:{ *:[i32] })
     /*  54824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54841 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(248),
     /*  54851 */     GIR_RootConstrainSelectedInstOperands,
     /*  54852 */     // GIR_Coverage, 3395,
     /*  54852 */     GIR_EraseRootFromParent_Done,
     /*  54853 */   // Label 692: @54853
     /*  54853 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(54940), // Rule ID 3394 //
     /*  54858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54893 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  54901 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54911 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 249:{ *:[i32] })
     /*  54911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  54914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  54916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  54920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  54924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  54928 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(249),
     /*  54938 */     GIR_RootConstrainSelectedInstOperands,
     /*  54939 */     // GIR_Coverage, 3394,
     /*  54939 */     GIR_EraseRootFromParent_Done,
     /*  54940 */   // Label 693: @54940
     /*  54940 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(55027), // Rule ID 5269 //
     /*  54945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  54948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  54952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  54960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  54972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54980 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54984 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54988 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  54996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54998 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  54998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55015 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55025 */     GIR_RootConstrainSelectedInstOperands,
     /*  55026 */     // GIR_Coverage, 5269,
     /*  55026 */     GIR_EraseRootFromParent_Done,
     /*  55027 */   // Label 694: @55027
     /*  55027 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(55114), // Rule ID 5277 //
     /*  55032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55083 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55085 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55102 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55112 */     GIR_RootConstrainSelectedInstOperands,
     /*  55113 */     // GIR_Coverage, 5277,
     /*  55113 */     GIR_EraseRootFromParent_Done,
     /*  55114 */   // Label 695: @55114
     /*  55114 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(55201), // Rule ID 5276 //
     /*  55119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55150 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55154 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55162 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55170 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55172 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vB
     /*  55185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55189 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55199 */     GIR_RootConstrainSelectedInstOperands,
     /*  55200 */     // GIR_Coverage, 5276,
     /*  55200 */     GIR_EraseRootFromParent_Done,
     /*  55201 */   // Label 696: @55201
     /*  55201 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(55288), // Rule ID 5285 //
     /*  55206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55257 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55259 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55276 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55286 */     GIR_RootConstrainSelectedInstOperands,
     /*  55287 */     // GIR_Coverage, 5285,
     /*  55287 */     GIR_EraseRootFromParent_Done,
     /*  55288 */   // Label 697: @55288
     /*  55288 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(55375), // Rule ID 3403 //
     /*  55293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55332 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55336 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55342 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55344 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55346 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 224:{ *:[i32] })
     /*  55346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55363 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(224),
     /*  55373 */     GIR_RootConstrainSelectedInstOperands,
     /*  55374 */     // GIR_Coverage, 3403,
     /*  55374 */     GIR_EraseRootFromParent_Done,
     /*  55375 */   // Label 698: @55375
     /*  55375 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(55462), // Rule ID 3402 //
     /*  55380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55423 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55429 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55433 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 128:{ *:[i32] })
     /*  55433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55450 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  55460 */     GIR_RootConstrainSelectedInstOperands,
     /*  55461 */     // GIR_Coverage, 3402,
     /*  55461 */     GIR_EraseRootFromParent_Done,
     /*  55462 */   // Label 699: @55462
     /*  55462 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(55549), // Rule ID 3407 //
     /*  55467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55510 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55516 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55520 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 144:{ *:[i32] })
     /*  55520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  55529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55537 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(144),
     /*  55547 */     GIR_RootConstrainSelectedInstOperands,
     /*  55548 */     // GIR_Coverage, 3407,
     /*  55548 */     GIR_EraseRootFromParent_Done,
     /*  55549 */   // Label 700: @55549
     /*  55549 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(55636), // Rule ID 5274 //
     /*  55554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  55581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55597 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55603 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55607 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vA
     /*  55616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  55620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  55624 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55634 */     GIR_RootConstrainSelectedInstOperands,
     /*  55635 */     // GIR_Coverage, 5274,
     /*  55635 */     GIR_EraseRootFromParent_Done,
     /*  55636 */   // Label 701: @55636
     /*  55636 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(55721), // Rule ID 5268 //
     /*  55641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55694 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55699 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55709 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55719 */     GIR_RootConstrainSelectedInstOperands,
     /*  55720 */     // GIR_Coverage, 5268,
     /*  55720 */     GIR_EraseRootFromParent_Done,
     /*  55721 */   // Label 702: @55721
     /*  55721 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(55808), // Rule ID 5266 //
     /*  55726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  55757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55769 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55775 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55777 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55779 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  55779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55796 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  55806 */     GIR_RootConstrainSelectedInstOperands,
     /*  55807 */     // GIR_Coverage, 5266,
     /*  55807 */     GIR_EraseRootFromParent_Done,
     /*  55808 */   // Label 703: @55808
     /*  55808 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(55893), // Rule ID 5273 //
     /*  55813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55852 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  55856 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55862 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55866 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55871 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  55873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55881 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55891 */     GIR_RootConstrainSelectedInstOperands,
     /*  55892 */     // GIR_Coverage, 5273,
     /*  55892 */     GIR_EraseRootFromParent_Done,
     /*  55893 */   // Label 704: @55893
     /*  55893 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(55980), // Rule ID 5271 //
     /*  55898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  55929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55933 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  55941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  55949 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55951 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  55951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  55954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  55956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vA
     /*  55960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  55964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  55968 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  55978 */     GIR_RootConstrainSelectedInstOperands,
     /*  55979 */     // GIR_Coverage, 5271,
     /*  55979 */     GIR_EraseRootFromParent_Done,
     /*  55980 */   // Label 705: @55980
     /*  55980 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(56067), // Rule ID 3400 //
     /*  55985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  55988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  55992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56028 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56034 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56038 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56055 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56065 */     GIR_RootConstrainSelectedInstOperands,
     /*  56066 */     // GIR_Coverage, 3400,
     /*  56066 */     GIR_EraseRootFromParent_Done,
     /*  56067 */   // Label 706: @56067
     /*  56067 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(56154), // Rule ID 3401 //
     /*  56072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56091 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56107 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56111 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56115 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56121 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56123 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56125 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)), immAllOnesV:{ *:[v4i32] })  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56142 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56152 */     GIR_RootConstrainSelectedInstOperands,
     /*  56153 */     // GIR_Coverage, 3401,
     /*  56153 */     GIR_EraseRootFromParent_Done,
     /*  56154 */   // Label 707: @56154
     /*  56154 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(56241), // Rule ID 5267 //
     /*  56159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56186 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56192 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56202 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56206 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56210 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56212 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56229 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56239 */     GIR_RootConstrainSelectedInstOperands,
     /*  56240 */     // GIR_Coverage, 5267,
     /*  56240 */     GIR_EraseRootFromParent_Done,
     /*  56241 */   // Label 708: @56241
     /*  56241 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(56328), // Rule ID 5272 //
     /*  56246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56273 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56279 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  56285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56289 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56293 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56299 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] }), (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // vB
     /*  56312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // vC
     /*  56316 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56326 */     GIR_RootConstrainSelectedInstOperands,
     /*  56327 */     // GIR_Coverage, 5272,
     /*  56327 */     GIR_EraseRootFromParent_Done,
     /*  56328 */   // Label 709: @56328
     /*  56328 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(56413), // Rule ID 5270 //
     /*  56333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56376 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56382 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56386 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 225:{ *:[i32] })
     /*  56386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56391 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56401 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(225),
     /*  56411 */     GIR_RootConstrainSelectedInstOperands,
     /*  56412 */     // GIR_Coverage, 5270,
     /*  56412 */     GIR_EraseRootFromParent_Done,
     /*  56413 */   // Label 710: @56413
     /*  56413 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(56498), // Rule ID 5275 //
     /*  56418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  56461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  56469 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  56471 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), immAllOnesV:{ *:[v4i32] }))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 135:{ *:[i32] })
     /*  56471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56476 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  56478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vB
     /*  56482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // vC
     /*  56486 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(135),
     /*  56496 */     GIR_RootConstrainSelectedInstOperands,
     /*  56497 */     // GIR_Coverage, 5275,
     /*  56497 */     GIR_EraseRootFromParent_Done,
     /*  56498 */   // Label 711: @56498
     /*  56498 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(56555), // Rule ID 944 //
     /*  56503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56530 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56540 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNAND),
     /*  56543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56553 */     GIR_RootConstrainSelectedInstOperands,
     /*  56554 */     // GIR_Coverage, 944,
     /*  56554 */     GIR_EraseRootFromParent_Done,
     /*  56555 */   // Label 712: @56555
     /*  56555 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(56612), // Rule ID 934 //
     /*  56560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56587 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56593 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56597 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56610 */     GIR_RootConstrainSelectedInstOperands,
     /*  56611 */     // GIR_Coverage, 934,
     /*  56611 */     GIR_EraseRootFromParent_Done,
     /*  56612 */   // Label 713: @56612
     /*  56612 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(56667), // Rule ID 4940 //
     /*  56617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56644 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56654 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$XB)  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56663 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  56665 */     GIR_RootConstrainSelectedInstOperands,
     /*  56666 */     // GIR_Coverage, 4940,
     /*  56666 */     GIR_EraseRootFromParent_Done,
     /*  56667 */   // Label 714: @56667
     /*  56667 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(56724), // Rule ID 943 //
     /*  56672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  56699 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56705 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56709 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB), immAllOnesV:{ *:[v4i32] })  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /*  56722 */     GIR_RootConstrainSelectedInstOperands,
     /*  56723 */     // GIR_Coverage, 943,
     /*  56723 */     GIR_EraseRootFromParent_Done,
     /*  56724 */   // Label 715: @56724
     /*  56724 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(56779), // Rule ID 4941 //
     /*  56729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  56732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56756 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56766 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, immAllOnesV:{ *:[v4i32] }))  =>  (XXLEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  56766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  56769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /*  56775 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /*  56777 */     GIR_RootConstrainSelectedInstOperands,
     /*  56778 */     // GIR_Coverage, 4941,
     /*  56778 */     GIR_EraseRootFromParent_Done,
     /*  56779 */   // Label 716: @56779
     /*  56779 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(56816), // Rule ID 1587 //
     /*  56784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  56787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56795 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  56803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56805 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, immAllOnesV:{ *:[v4i32] })  =>  (XXLNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$A)
     /*  56805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  56808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56810 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56812 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  56814 */     GIR_RootConstrainSelectedInstOperands,
     /*  56815 */     // GIR_Coverage, 1587,
     /*  56815 */     GIR_EraseRootFromParent_Done,
     /*  56816 */   // Label 717: @56816
     /*  56816 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(56866), // Rule ID 5297 //
     /*  56821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56846 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56851 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  56864 */     GIR_RootConstrainSelectedInstOperands,
     /*  56865 */     // GIR_Coverage, 5297,
     /*  56865 */     GIR_EraseRootFromParent_Done,
     /*  56866 */   // Label 718: @56866
     /*  56866 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(56916), // Rule ID 5298 //
     /*  56871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  56886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56896 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC), v4i32:{ *:[v4i32] }:$vA)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  56896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56901 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  56903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  56907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  56911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  56914 */     GIR_RootConstrainSelectedInstOperands,
     /*  56915 */     // GIR_Coverage, 5298,
     /*  56915 */     GIR_EraseRootFromParent_Done,
     /*  56916 */   // Label 719: @56916
     /*  56916 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(56966), // Rule ID 5296 //
     /*  56921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56946 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB), v4i32:{ *:[v4i32] }:$vC)  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  56946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  56951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vA
     /*  56955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vB
     /*  56959 */     GIR_RootToRootCopy, /*OpIdx*/2, // vC
     /*  56961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  56964 */     GIR_RootConstrainSelectedInstOperands,
     /*  56965 */     // GIR_Coverage, 5296,
     /*  56965 */     GIR_EraseRootFromParent_Done,
     /*  56966 */   // Label 720: @56966
     /*  56966 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(57016), // Rule ID 3415 //
     /*  56971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  56974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  56978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  56986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  56990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56996 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 30:{ *:[i32] })
     /*  56996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  56999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57001 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/30,
     /*  57014 */     GIR_RootConstrainSelectedInstOperands,
     /*  57015 */     // GIR_Coverage, 3415,
     /*  57015 */     GIR_EraseRootFromParent_Done,
     /*  57016 */   // Label 721: @57016
     /*  57016 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(57066), // Rule ID 3416 //
     /*  57021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57046 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 120:{ *:[i32] })
     /*  57046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/120,
     /*  57064 */     GIR_RootConstrainSelectedInstOperands,
     /*  57065 */     // GIR_Coverage, 3416,
     /*  57065 */     GIR_EraseRootFromParent_Done,
     /*  57066 */   // Label 722: @57066
     /*  57066 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(57116), // Rule ID 3414 //
     /*  57071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57096 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC))  =>  (XXEVAL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vC, 105:{ *:[i32] })
     /*  57096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  57099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57101 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vB
     /*  57107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // vC
     /*  57111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/105,
     /*  57114 */     GIR_RootConstrainSelectedInstOperands,
     /*  57115 */     // GIR_Coverage, 3414,
     /*  57115 */     GIR_EraseRootFromParent_Done,
     /*  57116 */   // Label 723: @57116
     /*  57116 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(57135), // Rule ID 936 //
     /*  57121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57128 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XXLXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  57128 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXLXOR),
     /*  57133 */     GIR_RootConstrainSelectedInstOperands,
     /*  57134 */     // GIR_Coverage, 936,
     /*  57134 */     GIR_Done,
     /*  57135 */   // Label 724: @57135
     /*  57135 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(57192), // Rule ID 488 //
     /*  57140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  57155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57167 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57173 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57177 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNAND:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNAND),
     /*  57180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57190 */     GIR_RootConstrainSelectedInstOperands,
     /*  57191 */     // GIR_Coverage, 488,
     /*  57191 */     GIR_EraseRootFromParent_Done,
     /*  57192 */   // Label 725: @57192
     /*  57192 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(57249), // Rule ID 385 //
     /*  57197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57224 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57230 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57234 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57247 */     GIR_RootConstrainSelectedInstOperands,
     /*  57248 */     // GIR_Coverage, 385,
     /*  57248 */     GIR_EraseRootFromParent_Done,
     /*  57249 */   // Label 726: @57249
     /*  57249 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(57306), // Rule ID 1383 //
     /*  57254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  57269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57281 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57291 */     // (xor:{ *:[v4i32] } (or:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B), immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  57291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  57300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // B
     /*  57304 */     GIR_RootConstrainSelectedInstOperands,
     /*  57305 */     // GIR_Coverage, 1383,
     /*  57305 */     GIR_EraseRootFromParent_Done,
     /*  57306 */   // Label 727: @57306
     /*  57306 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(57361), // Rule ID 4928 //
     /*  57311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57338 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57348 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }), v4i32:{ *:[v4i32] }:$VB)  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57357 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  57359 */     GIR_RootConstrainSelectedInstOperands,
     /*  57360 */     // GIR_Coverage, 4928,
     /*  57360 */     GIR_EraseRootFromParent_Done,
     /*  57361 */   // Label 728: @57361
     /*  57361 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(57418), // Rule ID 487 //
     /*  57366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57393 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57399 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57403 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB), immAllOnesV:{ *:[v4i32] })  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // VB
     /*  57416 */     GIR_RootConstrainSelectedInstOperands,
     /*  57417 */     // GIR_Coverage, 487,
     /*  57417 */     GIR_EraseRootFromParent_Done,
     /*  57418 */   // Label 729: @57418
     /*  57418 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(57473), // Rule ID 4929 //
     /*  57423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  57426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57450 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57460 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB, (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, immAllOnesV:{ *:[v4i32] }))  =>  (VEQV:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEQV),
     /*  57463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // VA
     /*  57469 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  57471 */     GIR_RootConstrainSelectedInstOperands,
     /*  57472 */     // GIR_Coverage, 4929,
     /*  57472 */     GIR_EraseRootFromParent_Done,
     /*  57473 */   // Label 730: @57473
     /*  57473 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(57510), // Rule ID 1382 //
     /*  57478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  57497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57499 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, immAllOnesV:{ *:[v4i32] })  =>  (VNOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vA)
     /*  57499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNOR),
     /*  57502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57504 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57506 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /*  57508 */     GIR_RootConstrainSelectedInstOperands,
     /*  57509 */     // GIR_Coverage, 1382,
     /*  57509 */     GIR_EraseRootFromParent_Done,
     /*  57510 */   // Label 731: @57510
     /*  57510 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(57529), // Rule ID 387 //
     /*  57515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  57518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57522 */     // (xor:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VXOR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  57522 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VXOR),
     /*  57527 */     GIR_RootConstrainSelectedInstOperands,
     /*  57528 */     // GIR_Coverage, 387,
     /*  57528 */     GIR_Done,
     /*  57529 */   // Label 732: @57529
     /*  57529 */   GIM_Reject,
     /*  57530 */ // Label 687: @57530
     /*  57530 */ GIM_Reject,
     /*  57531 */ // Label 597: @57531
     /*  57531 */ GIM_Reject,
     /*  57532 */ // Label 10: @57532
     /*  57532 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(57832),
     /*  57537 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  57540 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  57546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57553 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(57675), // Rule ID 2131 //
     /*  57558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  57561 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57561 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57564 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57568 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57573 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57579 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57582 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57586 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57591 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57594 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57597 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57600 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57605 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57640 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57643 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57646 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57673 */     GIR_RootConstrainSelectedInstOperands,
     /*  57674 */     // GIR_Coverage, 2131,
     /*  57674 */     GIR_EraseRootFromParent_Done,
     /*  57675 */   // Label 734: @57675
     /*  57675 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(57797), // Rule ID 2134 //
     /*  57680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  57683 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$A, i64:{ *:[i64] }:$B)  =>  (XXPERMDI:{ *:[v2i64] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$B), sub_64:{ *:[i32] }), (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  57683 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  57686 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57690 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57695 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  57699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  57701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  57704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57713 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  57716 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  57719 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  57722 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57727 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57732 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  57735 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  57739 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57744 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // B
     /*  57748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  57750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  57753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  57757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  57765 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  57768 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  57771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  57781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /*  57784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  57792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  57795 */     GIR_RootConstrainSelectedInstOperands,
     /*  57796 */     // GIR_Coverage, 2134,
     /*  57796 */     GIR_EraseRootFromParent_Done,
     /*  57797 */   // Label 735: @57797
     /*  57797 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(57812), // Rule ID 2879 //
     /*  57802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsISA3_0_IsPPC64),
     /*  57805 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rB, i64:{ *:[i64] }:$rA)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57810 */     GIR_RootConstrainSelectedInstOperands,
     /*  57811 */     // GIR_Coverage, 2879,
     /*  57811 */     GIR_Done,
     /*  57812 */   // Label 736: @57812
     /*  57812 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(57831), // Rule ID 2883 //
     /*  57817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsISA3_0_IsLittleEndian),
     /*  57820 */     // (build_vector:{ *:[v2i64] } i64:{ *:[i64] }:$rA, i64:{ *:[i64] }:$rB)  =>  (MTVSRDD:{ *:[v2i64] } ?:{ *:[i64] }:$rB, ?:{ *:[i64] }:$rA)
     /*  57820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDD),
     /*  57823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rB
     /*  57827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rA
     /*  57829 */     GIR_RootConstrainSelectedInstOperands,
     /*  57830 */     // GIR_Coverage, 2883,
     /*  57830 */     GIR_EraseRootFromParent_Done,
     /*  57831 */   // Label 737: @57831
     /*  57831 */   GIM_Reject,
     /*  57832 */ // Label 733: @57832
     /*  57832 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(58357),
     /*  57837 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  57840 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  57846 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(57897), // Rule ID 2045 //
     /*  57851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  57854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  57858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt5NonZero),
     /*  57870 */     // MIs[1] Operand 1
     /*  57870 */     // No operand predicates
     /*  57870 */     // MIs[0] A
     /*  57870 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57875 */     // MIs[0] A
     /*  57875 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57880 */     // MIs[0] A
     /*  57880 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57887 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_immSExt5NonZero>>:$A)  =>  (VSPLTISW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSPLTISW),
     /*  57890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  57892 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57895 */     GIR_RootConstrainSelectedInstOperands,
     /*  57896 */     // GIR_Coverage, 2045,
     /*  57896 */     GIR_EraseRootFromParent_Done,
     /*  57897 */   // Label 739: @57897
     /*  57897 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(57948), // Rule ID 3382 //
     /*  57902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  57905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  57917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i32immNonAllOneNonZero),
     /*  57921 */     // MIs[1] Operand 1
     /*  57921 */     // No operand predicates
     /*  57921 */     // MIs[0] A
     /*  57921 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57926 */     // MIs[0] A
     /*  57926 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57931 */     // MIs[0] A
     /*  57931 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  57936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  57938 */     // (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A, (imm:{ *:[i32] })<<P:Predicate_i32immNonAllOneNonZero>>:$A)  =>  (XXSPLTIW:{ *:[v4i32] } (imm:{ *:[i32] }):$A)
     /*  57938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIW),
     /*  57941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  57943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // A
     /*  57946 */     GIR_RootConstrainSelectedInstOperands,
     /*  57947 */     // GIR_Coverage, 3382,
     /*  57947 */     GIR_EraseRootFromParent_Done,
     /*  57948 */   // Label 740: @57948
     /*  57948 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(58084), // Rule ID 1735 //
     /*  57953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  57956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  57959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  57962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  57965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  57969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  57981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  57985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  57989 */     // MIs[2] A
     /*  57989 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  57994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  57998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58002 */     // MIs[3] A
     /*  58002 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58007 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/4, // MIs[4]
     /*  58011 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  58015 */     // MIs[4] A
     /*  58015 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  58020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  58022 */     // (build_vector:{ *:[v4f32] } (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A), (fpround:{ *:[f32] } f64:{ *:[f64] }:$A))  =>  (XXSPLTW:{ *:[v4f32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (XSCVDPSP:{ *:[f64] } f64:{ *:[f64] }:$A), sub_64:{ *:[i32] }), 0:{ *:[i32] })
     /*  58022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSP),
     /*  58029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58034 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /*  58038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58052 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58082 */     GIR_RootConstrainSelectedInstOperands,
     /*  58083 */     // GIR_Coverage, 1735,
     /*  58083 */     GIR_EraseRootFromParent_Done,
     /*  58084 */   // Label 741: @58084
     /*  58084 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(58142), // Rule ID 1736 //
     /*  58089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58096 */     // MIs[0] A
     /*  58096 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58101 */     // MIs[0] A
     /*  58101 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58106 */     // MIs[0] A
     /*  58106 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58111 */     // (build_vector:{ *:[v4f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$A)  =>  (XXSPLTW:{ *:[v4f32] } (XSCVDPSPN:{ *:[v4f32] } ?:{ *:[f32] }:$A), 0:{ *:[i32] })
     /*  58111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58127 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  58140 */     GIR_RootConstrainSelectedInstOperands,
     /*  58141 */     // GIR_Coverage, 1736,
     /*  58141 */     GIR_EraseRootFromParent_Done,
     /*  58142 */   // Label 742: @58142
     /*  58142 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(58231), // Rule ID 2133 //
     /*  58147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsBigEndian_IsPPC64_NoP9Vector),
     /*  58150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58154 */     // MIs[0] A
     /*  58154 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58159 */     // MIs[0] A
     /*  58159 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58164 */     // MIs[0] A
     /*  58164 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58169 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58169 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58172 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58176 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58205 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58208 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58213 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58229 */     GIR_RootConstrainSelectedInstOperands,
     /*  58230 */     // GIR_Coverage, 2133,
     /*  58230 */     GIR_EraseRootFromParent_Done,
     /*  58231 */   // Label 743: @58231
     /*  58231 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(58320), // Rule ID 2136 //
     /*  58236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX_IsLittleEndian_NoP9Vector),
     /*  58239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58243 */     // MIs[0] A
     /*  58243 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58248 */     // MIs[0] A
     /*  58248 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58253 */     // MIs[0] A
     /*  58253 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58258 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (XXSPLTW:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[v4i32] } 1:{ *:[i64] }, (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$A), sub_64:{ *:[i32] }), 1:{ *:[i32] })
     /*  58258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  58261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /*  58265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  58283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58288 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  58291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  58294 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  58297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSPLTW),
     /*  58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  58318 */     GIR_RootConstrainSelectedInstOperands,
     /*  58319 */     // GIR_Coverage, 2136,
     /*  58319 */     GIR_EraseRootFromParent_Done,
     /*  58320 */   // Label 744: @58320
     /*  58320 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(58356), // Rule ID 2269 //
     /*  58325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58332 */     // MIs[0] A
     /*  58332 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58337 */     // MIs[0] A
     /*  58337 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58342 */     // MIs[0] A
     /*  58342 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58347 */     // (build_vector:{ *:[v4i32] } i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A, i32:{ *:[i32] }:$A)  =>  (MTVSRWS:{ *:[v4i32] } ?:{ *:[i32] }:$A)
     /*  58347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWS),
     /*  58350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  58352 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /*  58354 */     GIR_RootConstrainSelectedInstOperands,
     /*  58355 */     // GIR_Coverage, 2269,
     /*  58355 */     GIR_EraseRootFromParent_Done,
     /*  58356 */   // Label 745: @58356
     /*  58356 */   GIM_Reject,
     /*  58357 */ // Label 738: @58357
     /*  58357 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(58498), // Rule ID 2270 //
     /*  58362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  58365 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  58368 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58378 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58382 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  58386 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immNonAllOneAnyExt8),
     /*  58390 */   // MIs[1] Operand 1
     /*  58390 */   // No operand predicates
     /*  58390 */   // MIs[0] A
     /*  58390 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58395 */   // MIs[0] A
     /*  58395 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58400 */   // MIs[0] A
     /*  58400 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58405 */   // MIs[0] A
     /*  58405 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58410 */   // MIs[0] A
     /*  58410 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58415 */   // MIs[0] A
     /*  58415 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58420 */   // MIs[0] A
     /*  58420 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58425 */   // MIs[0] A
     /*  58425 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58430 */   // MIs[0] A
     /*  58430 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58435 */   // MIs[0] A
     /*  58435 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58440 */   // MIs[0] A
     /*  58440 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58445 */   // MIs[0] A
     /*  58445 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58450 */   // MIs[0] A
     /*  58450 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58455 */   // MIs[0] A
     /*  58455 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58460 */   // MIs[0] A
     /*  58460 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  58465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58467 */   // (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A, (imm:{ *:[i32] })<<P:Predicate_immNonAllOneAnyExt8>>:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSPLTIB:{ *:[v4i32] } (imm:{ *:[i32] }):$A), VSRC:{ *:[i32] })
     /*  58467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSPLTIB),
     /*  58474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58479 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // A
     /*  58482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58492 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58497 */   // GIR_Coverage, 2270,
     /*  58497 */   GIR_EraseRootFromParent_Done,
     /*  58498 */ // Label 746: @58498
     /*  58498 */ GIM_Reject,
     /*  58499 */ // Label 11: @58499
     /*  58499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 754*/ GIMT_Encode4(60775),
     /*  58510 */ /*GILLT_s32*//*Label 747*/ GIMT_Encode4(58538),
     /*  58514 */ /*GILLT_s64*//*Label 748*/ GIMT_Encode4(58611),
     /*  58518 */ /*GILLT_s128*//*Label 749*/ GIMT_Encode4(58659),
     /*  58522 */ /*GILLT_v2s64*//*Label 750*/ GIMT_Encode4(59063),
     /*  58526 */ /*GILLT_v4s32*//*Label 751*/ GIMT_Encode4(59625),
     /*  58530 */ /*GILLT_v8s16*//*Label 752*/ GIMT_Encode4(60176),
     /*  58534 */ /*GILLT_v16s8*//*Label 753*/ GIMT_Encode4(60504),
     /*  58538 */ // Label 747: @58538
     /*  58538 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(58610), // Rule ID 2029 //
     /*  58543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  58549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  58553 */   // (bitconvert:{ *:[i32] } f32:{ *:[f32] }:$A)  =>  (MFVSRWZ:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f64] } (XSCVDPSPN:{ *:[v4i32] } ?:{ *:[f32] }:$A), sub_64:{ *:[i32] }))
     /*  58553 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  58556 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSPN),
     /*  58560 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58565 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /*  58569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  58571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  58574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58583 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  58590 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  58595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /*  58603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  58605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58608 */   GIR_RootConstrainSelectedInstOperands,
     /*  58609 */   // GIR_Coverage, 2029,
     /*  58609 */   GIR_EraseRootFromParent_Done,
     /*  58610 */ // Label 755: @58610
     /*  58610 */ GIM_Reject,
     /*  58611 */ // Label 748: @58611
     /*  58611 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(58658),
     /*  58616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  58619 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(58638), // Rule ID 2031 //
     /*  58624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  58631 */     // (bitconvert:{ *:[i64] } f64:{ *:[f64] }:$A)  =>  (MFVSRD:{ *:[i64] } ?:{ *:[f64] }:$A)
     /*  58631 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  58636 */     GIR_RootConstrainSelectedInstOperands,
     /*  58637 */     // GIR_Coverage, 2031,
     /*  58637 */     GIR_Done,
     /*  58638 */   // Label 757: @58638
     /*  58638 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(58657), // Rule ID 2032 //
     /*  58643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  58646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  58650 */     // (bitconvert:{ *:[f64] } i64:{ *:[i64] }:$S)  =>  (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$S)
     /*  58650 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  58655 */     GIR_RootConstrainSelectedInstOperands,
     /*  58656 */     // GIR_Coverage, 2032,
     /*  58656 */     GIR_Done,
     /*  58657 */   // Label 758: @58657
     /*  58657 */   GIM_Reject,
     /*  58658 */ // Label 756: @58658
     /*  58658 */ GIM_Reject,
     /*  58659 */ // Label 749: @58659
     /*  58659 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(58716), // Rule ID 1935 //
     /*  58664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  58667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58678 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  58684 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  58686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  58688 */   // (bitconvert:{ *:[v1i128] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  58688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  58691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  58695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  58707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  58715 */   // GIR_Coverage, 1935,
     /*  58715 */   GIR_EraseRootFromParent_Done,
     /*  58716 */ // Label 759: @58716
     /*  58716 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(58742), // Rule ID 1622 //
     /*  58721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  58724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58731 */   // (bitconvert:{ *:[v1i128] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  58731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58741 */   // GIR_Coverage, 1622,
     /*  58741 */   GIR_Done,
     /*  58742 */ // Label 760: @58742
     /*  58742 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(58774), // Rule ID 1336 //
     /*  58747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58761 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58773 */   // GIR_Coverage, 1336,
     /*  58773 */   GIR_EraseRootFromParent_Done,
     /*  58774 */ // Label 761: @58774
     /*  58774 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(58806), // Rule ID 1337 //
     /*  58779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58793 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58796 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58798 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58800 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58805 */   // GIR_Coverage, 1337,
     /*  58805 */   GIR_EraseRootFromParent_Done,
     /*  58806 */ // Label 762: @58806
     /*  58806 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(58838), // Rule ID 1338 //
     /*  58811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58825 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58828 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58830 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58837 */   // GIR_Coverage, 1338,
     /*  58837 */   GIR_EraseRootFromParent_Done,
     /*  58838 */ // Label 763: @58838
     /*  58838 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(58870), // Rule ID 1339 //
     /*  58843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58857 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58860 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58862 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58864 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58869 */   // GIR_Coverage, 1339,
     /*  58869 */   GIR_EraseRootFromParent_Done,
     /*  58870 */ // Label 764: @58870
     /*  58870 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(58902), // Rule ID 1340 //
     /*  58875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  58881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58889 */   // (bitconvert:{ *:[v1i128] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v1i128] }:$src
     /*  58889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58892 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58894 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58896 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58901 */   // GIR_Coverage, 1340,
     /*  58901 */   GIR_EraseRootFromParent_Done,
     /*  58902 */ // Label 765: @58902
     /*  58902 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(58934), // Rule ID 1341 //
     /*  58907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  58913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58921 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58924 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58926 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58928 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58933 */   // GIR_Coverage, 1341,
     /*  58933 */   GIR_EraseRootFromParent_Done,
     /*  58934 */ // Label 766: @58934
     /*  58934 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(58966), // Rule ID 1342 //
     /*  58939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  58945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58953 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58953 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58956 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58958 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58965 */   // GIR_Coverage, 1342,
     /*  58965 */   GIR_EraseRootFromParent_Done,
     /*  58966 */ // Label 767: @58966
     /*  58966 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(58998), // Rule ID 1343 //
     /*  58971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  58974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  58977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58985 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  58985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  58988 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  58990 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  58992 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  58997 */   // GIR_Coverage, 1343,
     /*  58997 */   GIR_EraseRootFromParent_Done,
     /*  58998 */ // Label 768: @58998
     /*  58998 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(59030), // Rule ID 1344 //
     /*  59003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59017 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59020 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59022 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59024 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59029 */   // GIR_Coverage, 1344,
     /*  59029 */   GIR_EraseRootFromParent_Done,
     /*  59030 */ // Label 769: @59030
     /*  59030 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(59062), // Rule ID 1345 //
     /*  59035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59049 */   // (bitconvert:{ *:[f128] } VRRC:{ *:[v2f64] }:$src)  =>  VRRC:{ *:[f128] }:$src
     /*  59049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59052 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59061 */   // GIR_Coverage, 1345,
     /*  59061 */   GIR_EraseRootFromParent_Done,
     /*  59062 */ // Label 770: @59062
     /*  59062 */ GIM_Reject,
     /*  59063 */ // Label 750: @59063
     /*  59063 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(59120), // Rule ID 1936 //
     /*  59068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59078 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59082 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59088 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59090 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59092 */   // (bitconvert:{ *:[v2i64] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  59092 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  59095 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59099 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  59111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59119 */   // GIR_Coverage, 1936,
     /*  59119 */   GIR_EraseRootFromParent_Done,
     /*  59120 */ // Label 771: @59120
     /*  59120 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(59146), // Rule ID 1603 //
     /*  59125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59135 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59145 */   // GIR_Coverage, 1603,
     /*  59145 */   GIR_Done,
     /*  59146 */ // Label 772: @59146
     /*  59146 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(59172), // Rule ID 1604 //
     /*  59151 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59161 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59161 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59171 */   // GIR_Coverage, 1604,
     /*  59171 */   GIR_Done,
     /*  59172 */ // Label 773: @59172
     /*  59172 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(59198), // Rule ID 1605 //
     /*  59177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59187 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59197 */   // GIR_Coverage, 1605,
     /*  59197 */   GIR_Done,
     /*  59198 */ // Label 774: @59198
     /*  59198 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(59224), // Rule ID 1606 //
     /*  59203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59213 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59213 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59218 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59223 */   // GIR_Coverage, 1606,
     /*  59223 */   GIR_Done,
     /*  59224 */ // Label 775: @59224
     /*  59224 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(59250), // Rule ID 1611 //
     /*  59229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59239 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4f32] }:$A, VSRC:{ *:[i32] })
     /*  59239 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59244 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59249 */   // GIR_Coverage, 1611,
     /*  59249 */   GIR_Done,
     /*  59250 */ // Label 776: @59250
     /*  59250 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(59276), // Rule ID 1612 //
     /*  59255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59265 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v4i32] }:$A, VSRC:{ *:[i32] })
     /*  59265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59270 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59275 */   // GIR_Coverage, 1612,
     /*  59275 */   GIR_Done,
     /*  59276 */ // Label 777: @59276
     /*  59276 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(59302), // Rule ID 1613 //
     /*  59281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59291 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })
     /*  59291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59296 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59301 */   // GIR_Coverage, 1613,
     /*  59301 */   GIR_Done,
     /*  59302 */ // Label 778: @59302
     /*  59302 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(59328), // Rule ID 1614 //
     /*  59307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59317 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] })
     /*  59317 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59327 */   // GIR_Coverage, 1614,
     /*  59327 */   GIR_Done,
     /*  59328 */ // Label 779: @59328
     /*  59328 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(59354), // Rule ID 1619 //
     /*  59333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59343 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59353 */   // GIR_Coverage, 1619,
     /*  59353 */   GIR_Done,
     /*  59354 */ // Label 780: @59354
     /*  59354 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(59380), // Rule ID 1620 //
     /*  59359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59369 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59369 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59379 */   // GIR_Coverage, 1620,
     /*  59379 */   GIR_Done,
     /*  59380 */ // Label 781: @59380
     /*  59380 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(59406), // Rule ID 1621 //
     /*  59385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59395 */   // (bitconvert:{ *:[v2f64] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } ?:{ *:[v1i128] }:$A, VRRC:{ *:[i32] })
     /*  59395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59400 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59405 */   // GIR_Coverage, 1621,
     /*  59405 */   GIR_Done,
     /*  59406 */ // Label 782: @59406
     /*  59406 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(59432), // Rule ID 1623 //
     /*  59411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59421 */   // (bitconvert:{ *:[v2i64] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59431 */   // GIR_Coverage, 1623,
     /*  59431 */   GIR_Done,
     /*  59432 */ // Label 783: @59432
     /*  59432 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(59464), // Rule ID 1331 //
     /*  59437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59451 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59463 */   // GIR_Coverage, 1331,
     /*  59463 */   GIR_EraseRootFromParent_Done,
     /*  59464 */ // Label 784: @59464
     /*  59464 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(59496), // Rule ID 1332 //
     /*  59469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59483 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59486 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59488 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59495 */   // GIR_Coverage, 1332,
     /*  59495 */   GIR_EraseRootFromParent_Done,
     /*  59496 */ // Label 785: @59496
     /*  59496 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(59528), // Rule ID 1333 //
     /*  59501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59515 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59518 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59522 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59527 */   // GIR_Coverage, 1333,
     /*  59527 */   GIR_EraseRootFromParent_Done,
     /*  59528 */ // Label 786: @59528
     /*  59528 */ GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(59560), // Rule ID 1334 //
     /*  59533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59547 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59550 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59552 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59554 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59559 */   // GIR_Coverage, 1334,
     /*  59559 */   GIR_EraseRootFromParent_Done,
     /*  59560 */ // Label 787: @59560
     /*  59560 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(59592), // Rule ID 1335 //
     /*  59565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59579 */   // (bitconvert:{ *:[v2i64] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v2i64] }:$src
     /*  59579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59582 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59584 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59586 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59591 */   // GIR_Coverage, 1335,
     /*  59591 */   GIR_EraseRootFromParent_Done,
     /*  59592 */ // Label 788: @59592
     /*  59592 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(59624), // Rule ID 1350 //
     /*  59597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59611 */   // (bitconvert:{ *:[v2f64] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v2f64] }:$src
     /*  59611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59614 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59616 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59623 */   // GIR_Coverage, 1350,
     /*  59623 */   GIR_EraseRootFromParent_Done,
     /*  59624 */ // Label 789: @59624
     /*  59624 */ GIM_Reject,
     /*  59625 */ // Label 751: @59625
     /*  59625 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(59661), // Rule ID 945 //
     /*  59630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  59633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  59640 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59644 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  59650 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  59652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  59654 */   // (bitconvert:{ *:[v4i32] } immAllOnesV:{ *:[v16i8] })  =>  (XXLEQVOnes:{ *:[v4i32] })
     /*  59654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  59657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  59659 */   GIR_RootConstrainSelectedInstOperands,
     /*  59660 */   // GIR_Coverage, 945,
     /*  59660 */   GIR_EraseRootFromParent_Done,
     /*  59661 */ // Label 790: @59661
     /*  59661 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(59687), // Rule ID 1607 //
     /*  59666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59676 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59681 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59686 */   // GIR_Coverage, 1607,
     /*  59686 */   GIR_Done,
     /*  59687 */ // Label 791: @59687
     /*  59687 */ GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(59713), // Rule ID 1608 //
     /*  59692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59702 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  59702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59707 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59712 */   // GIR_Coverage, 1608,
     /*  59712 */   GIR_Done,
     /*  59713 */ // Label 792: @59713
     /*  59713 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(59739), // Rule ID 1615 //
     /*  59718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59728 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59738 */   // GIR_Coverage, 1615,
     /*  59738 */   GIR_Done,
     /*  59739 */ // Label 793: @59739
     /*  59739 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(59765), // Rule ID 1616 //
     /*  59744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59754 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  59754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59764 */   // GIR_Coverage, 1616,
     /*  59764 */   GIR_Done,
     /*  59765 */ // Label 794: @59765
     /*  59765 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(59791), // Rule ID 1624 //
     /*  59770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  59773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59780 */   // (bitconvert:{ *:[v4i32] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  59780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59785 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59790 */   // GIR_Coverage, 1624,
     /*  59790 */   GIR_Done,
     /*  59791 */ // Label 795: @59791
     /*  59791 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(59823), // Rule ID 1321 //
     /*  59796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59810 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59813 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59815 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59822 */   // GIR_Coverage, 1321,
     /*  59822 */   GIR_EraseRootFromParent_Done,
     /*  59823 */ // Label 796: @59823
     /*  59823 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(59855), // Rule ID 1322 //
     /*  59828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59842 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59845 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59847 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59849 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59854 */   // GIR_Coverage, 1322,
     /*  59854 */   GIR_EraseRootFromParent_Done,
     /*  59855 */ // Label 797: @59855
     /*  59855 */ GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(59887), // Rule ID 1323 //
     /*  59860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  59866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59874 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59874 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59877 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59879 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59881 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59886 */   // GIR_Coverage, 1323,
     /*  59886 */   GIR_EraseRootFromParent_Done,
     /*  59887 */ // Label 798: @59887
     /*  59887 */ GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(59919), // Rule ID 1324 //
     /*  59892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  59898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59906 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59906 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59909 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59911 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59913 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59918 */   // GIR_Coverage, 1324,
     /*  59918 */   GIR_EraseRootFromParent_Done,
     /*  59919 */ // Label 799: @59919
     /*  59919 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(59951), // Rule ID 1325 //
     /*  59924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  59930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59938 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  59938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59941 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59943 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59950 */   // GIR_Coverage, 1325,
     /*  59950 */   GIR_EraseRootFromParent_Done,
     /*  59951 */ // Label 800: @59951
     /*  59951 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(59983), // Rule ID 1326 //
     /*  59956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  59962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59970 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  59970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  59973 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  59975 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  59977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59982 */   // GIR_Coverage, 1326,
     /*  59982 */   GIR_EraseRootFromParent_Done,
     /*  59983 */ // Label 801: @59983
     /*  59983 */ GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(60015), // Rule ID 1327 //
     /*  59988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  59991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  59994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  59998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60002 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60005 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60007 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60009 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60014 */   // GIR_Coverage, 1327,
     /*  60014 */   GIR_EraseRootFromParent_Done,
     /*  60015 */ // Label 802: @60015
     /*  60015 */ GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(60047), // Rule ID 1328 //
     /*  60020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60034 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60046 */   // GIR_Coverage, 1328,
     /*  60046 */   GIR_EraseRootFromParent_Done,
     /*  60047 */ // Label 803: @60047
     /*  60047 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(60079), // Rule ID 1329 //
     /*  60052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60066 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60078 */   // GIR_Coverage, 1329,
     /*  60078 */   GIR_EraseRootFromParent_Done,
     /*  60079 */ // Label 804: @60079
     /*  60079 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(60111), // Rule ID 1330 //
     /*  60084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60098 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60110 */   // GIR_Coverage, 1330,
     /*  60110 */   GIR_EraseRootFromParent_Done,
     /*  60111 */ // Label 805: @60111
     /*  60111 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(60143), // Rule ID 1348 //
     /*  60116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60130 */   // (bitconvert:{ *:[v4i32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4i32] }:$src
     /*  60130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60142 */   // GIR_Coverage, 1348,
     /*  60142 */   GIR_EraseRootFromParent_Done,
     /*  60143 */ // Label 806: @60143
     /*  60143 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(60175), // Rule ID 1349 //
     /*  60148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60162 */   // (bitconvert:{ *:[v4f32] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v4f32] }:$src
     /*  60162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60174 */   // GIR_Coverage, 1349,
     /*  60174 */   GIR_EraseRootFromParent_Done,
     /*  60175 */ // Label 807: @60175
     /*  60175 */ GIM_Reject,
     /*  60176 */ // Label 752: @60176
     /*  60176 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(60233), // Rule ID 1937 //
     /*  60181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  60184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60191 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60195 */   GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  60201 */   GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  60203 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60205 */   // (bitconvert:{ *:[v8i16] } immAllOnesV:{ *:[v16i8] })  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXLEQVOnes:{ *:[v4i32] }), VSRC:{ *:[i32] })
     /*  60205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  60208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLEQVOnes),
     /*  60212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60232 */   // GIR_Coverage, 1937,
     /*  60232 */   GIR_EraseRootFromParent_Done,
     /*  60233 */ // Label 808: @60233
     /*  60233 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(60259), // Rule ID 1609 //
     /*  60238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60248 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60258 */   // GIR_Coverage, 1609,
     /*  60258 */   GIR_Done,
     /*  60259 */ // Label 809: @60259
     /*  60259 */ GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(60285), // Rule ID 1617 //
     /*  60264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60274 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60284 */   // GIR_Coverage, 1617,
     /*  60284 */   GIR_Done,
     /*  60285 */ // Label 810: @60285
     /*  60285 */ GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(60311), // Rule ID 1625 //
     /*  60290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60300 */   // (bitconvert:{ *:[v8i16] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60310 */   // GIR_Coverage, 1625,
     /*  60310 */   GIR_Done,
     /*  60311 */ // Label 811: @60311
     /*  60311 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(60343), // Rule ID 1316 //
     /*  60316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  60322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60330 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v16i8] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60333 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60335 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60337 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60342 */   // GIR_Coverage, 1316,
     /*  60342 */   GIR_EraseRootFromParent_Done,
     /*  60343 */ // Label 812: @60343
     /*  60343 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(60375), // Rule ID 1317 //
     /*  60348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60362 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60365 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60367 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60369 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60374 */   // GIR_Coverage, 1317,
     /*  60374 */   GIR_EraseRootFromParent_Done,
     /*  60375 */ // Label 813: @60375
     /*  60375 */ GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(60407), // Rule ID 1318 //
     /*  60380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60394 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60397 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60399 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60406 */   // GIR_Coverage, 1318,
     /*  60406 */   GIR_EraseRootFromParent_Done,
     /*  60407 */ // Label 814: @60407
     /*  60407 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(60439), // Rule ID 1319 //
     /*  60412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60426 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60429 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60431 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60433 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60438 */   // GIR_Coverage, 1319,
     /*  60438 */   GIR_EraseRootFromParent_Done,
     /*  60439 */ // Label 815: @60439
     /*  60439 */ GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(60471), // Rule ID 1320 //
     /*  60444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60458 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60461 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60463 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60465 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60470 */   // GIR_Coverage, 1320,
     /*  60470 */   GIR_EraseRootFromParent_Done,
     /*  60471 */ // Label 816: @60471
     /*  60471 */ GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(60503), // Rule ID 1347 //
     /*  60476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60490 */   // (bitconvert:{ *:[v8i16] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v8i16] }:$src
     /*  60490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60493 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60495 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60502 */   // GIR_Coverage, 1347,
     /*  60502 */   GIR_EraseRootFromParent_Done,
     /*  60503 */ // Label 817: @60503
     /*  60503 */ GIM_Reject,
     /*  60504 */ // Label 753: @60504
     /*  60504 */ GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(60530), // Rule ID 1610 //
     /*  60509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60519 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2f64] }:$A, VRRC:{ *:[i32] })
     /*  60519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60529 */   // GIR_Coverage, 1610,
     /*  60529 */   GIR_Done,
     /*  60530 */ // Label 818: @60530
     /*  60530 */ GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(60556), // Rule ID 1618 //
     /*  60535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60545 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[v2i64] }:$A, VRRC:{ *:[i32] })
     /*  60545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60550 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60555 */   // GIR_Coverage, 1618,
     /*  60555 */   GIR_Done,
     /*  60556 */ // Label 819: @60556
     /*  60556 */ GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(60582), // Rule ID 1626 //
     /*  60561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60571 */   // (bitconvert:{ *:[v16i8] } f128:{ *:[f128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } ?:{ *:[f128] }:$A, VRRC:{ *:[i32] })
     /*  60571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60581 */   // GIR_Coverage, 1626,
     /*  60581 */   GIR_Done,
     /*  60582 */ // Label 820: @60582
     /*  60582 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(60614), // Rule ID 1311 //
     /*  60587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  60593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60601 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v8i16] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60604 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60606 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60613 */   // GIR_Coverage, 1311,
     /*  60613 */   GIR_EraseRootFromParent_Done,
     /*  60614 */ // Label 821: @60614
     /*  60614 */ GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(60646), // Rule ID 1312 //
     /*  60619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60633 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4i32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60645 */   // GIR_Coverage, 1312,
     /*  60645 */   GIR_EraseRootFromParent_Done,
     /*  60646 */ // Label 822: @60646
     /*  60646 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(60678), // Rule ID 1313 //
     /*  60651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  60657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60665 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v4f32] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60677 */   // GIR_Coverage, 1313,
     /*  60677 */   GIR_EraseRootFromParent_Done,
     /*  60678 */ // Label 823: @60678
     /*  60678 */ GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(60710), // Rule ID 1314 //
     /*  60683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60697 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v2i64] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60709 */   // GIR_Coverage, 1314,
     /*  60709 */   GIR_EraseRootFromParent_Done,
     /*  60710 */ // Label 824: @60710
     /*  60710 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(60742), // Rule ID 1315 //
     /*  60715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60729 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[v1i128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60741 */   // GIR_Coverage, 1315,
     /*  60741 */   GIR_EraseRootFromParent_Done,
     /*  60742 */ // Label 825: @60742
     /*  60742 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(60774), // Rule ID 1346 //
     /*  60747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  60750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60761 */   // (bitconvert:{ *:[v16i8] } VRRC:{ *:[f128] }:$src)  =>  VRRC:{ *:[v16i8] }:$src
     /*  60761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60764 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  60766 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  60768 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60773 */   // GIR_Coverage, 1346,
     /*  60773 */   GIR_EraseRootFromParent_Done,
     /*  60774 */ // Label 826: @60774
     /*  60774 */ GIM_Reject,
     /*  60775 */ // Label 754: @60775
     /*  60775 */ GIM_Reject,
     /*  60776 */ // Label 12: @60776
     /*  60776 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 832*/ GIMT_Encode4(61050),
     /*  60787 */ /*GILLT_s32*//*Label 827*/ GIMT_Encode4(60807),
     /*  60791 */ /*GILLT_s64*//*Label 828*/ GIMT_Encode4(60900),
     /*  60795 */ /*GILLT_s128*//*Label 829*/ GIMT_Encode4(60948),
     /*  60799 */ /*GILLT_v2s64*//*Label 830*/ GIMT_Encode4(60979),
     /*  60803 */ /*GILLT_v4s32*//*Label 831*/ GIMT_Encode4(61002),
     /*  60807 */ // Label 827: @60807
     /*  60807 */ GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(60899),
     /*  60812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60815 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(60879), // Rule ID 1713 //
     /*  60820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60827 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIZ:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  60827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  60830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  60843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  60851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60860 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  60878 */     // GIR_Coverage, 1713,
     /*  60878 */     GIR_EraseRootFromParent_Done,
     /*  60879 */   // Label 834: @60879
     /*  60879 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(60898), // Rule ID 150 //
     /*  60884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  60891 */     // (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIZS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  60891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZS),
     /*  60896 */     GIR_RootConstrainSelectedInstOperands,
     /*  60897 */     // GIR_Coverage, 150,
     /*  60897 */     GIR_Done,
     /*  60898 */   // Label 835: @60898
     /*  60898 */   GIM_Reject,
     /*  60899 */ // Label 833: @60899
     /*  60899 */ GIM_Reject,
     /*  60900 */ // Label 828: @60900
     /*  60900 */ GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(60947),
     /*  60905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  60908 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(60927), // Rule ID 915 //
     /*  60913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  60920 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIZ:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  60920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIZ),
     /*  60925 */     GIR_RootConstrainSelectedInstOperands,
     /*  60926 */     // GIR_Coverage, 915,
     /*  60926 */     GIR_Done,
     /*  60927 */   // Label 837: @60927
     /*  60927 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(60946), // Rule ID 148 //
     /*  60932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  60935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  60939 */     // (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIZD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  60939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIZD),
     /*  60944 */     GIR_RootConstrainSelectedInstOperands,
     /*  60945 */     // GIR_Coverage, 148,
     /*  60945 */     GIR_Done,
     /*  60946 */   // Label 838: @60946
     /*  60946 */   GIM_Reject,
     /*  60947 */ // Label 836: @60947
     /*  60947 */ GIM_Reject,
     /*  60948 */ // Label 829: @60948
     /*  60948 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(60978), // Rule ID 2164 //
     /*  60953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  60956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  60959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  60963 */   // (ftrunc:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 1:{ *:[i32] })
     /*  60963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  60966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  60968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60971 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  60973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60976 */   GIR_RootConstrainSelectedInstOperands,
     /*  60977 */   // GIR_Coverage, 2164,
     /*  60977 */   GIR_EraseRootFromParent_Done,
     /*  60978 */ // Label 839: @60978
     /*  60978 */ GIM_Reject,
     /*  60979 */ // Label 830: @60979
     /*  60979 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(61001), // Rule ID 923 //
     /*  60984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  60987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  60990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  60994 */   // (ftrunc:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIZ:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  60994 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIZ),
     /*  60999 */   GIR_RootConstrainSelectedInstOperands,
     /*  61000 */   // GIR_Coverage, 923,
     /*  61000 */   GIR_Done,
     /*  61001 */ // Label 840: @61001
     /*  61001 */ GIM_Reject,
     /*  61002 */ // Label 831: @61002
     /*  61002 */ GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(61049),
     /*  61007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61010 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(61029), // Rule ID 931 //
     /*  61015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61022 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIZ),
     /*  61027 */     GIR_RootConstrainSelectedInstOperands,
     /*  61028 */     // GIR_Coverage, 931,
     /*  61028 */     GIR_Done,
     /*  61029 */   // Label 842: @61029
     /*  61029 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(61048), // Rule ID 1421 //
     /*  61034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  61037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61041 */     // (ftrunc:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIZ:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /*  61041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  61046 */     GIR_RootConstrainSelectedInstOperands,
     /*  61047 */     // GIR_Coverage, 1421,
     /*  61047 */     GIR_Done,
     /*  61048 */   // Label 843: @61048
     /*  61048 */   GIM_Reject,
     /*  61049 */ // Label 841: @61049
     /*  61049 */ GIM_Reject,
     /*  61050 */ // Label 832: @61050
     /*  61050 */ GIM_Reject,
     /*  61051 */ // Label 13: @61051
     /*  61051 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 849*/ GIMT_Encode4(61300),
     /*  61062 */ /*GILLT_s32*//*Label 844*/ GIMT_Encode4(61082),
     /*  61066 */ /*GILLT_s64*//*Label 845*/ GIMT_Encode4(61175),
     /*  61070 */ /*GILLT_s128*//*Label 846*/ GIMT_Encode4(61223),
     /*  61074 */ /*GILLT_v2s64*//*Label 847*/ GIMT_Encode4(61254),
     /*  61078 */ /*GILLT_v4s32*//*Label 848*/ GIMT_Encode4(61277),
     /*  61082 */ // Label 844: @61082
     /*  61082 */ GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(61174),
     /*  61087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  61090 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(61154), // Rule ID 1707 //
     /*  61095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61102 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /*  61102 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61105 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61109 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61118 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61135 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61153 */     // GIR_Coverage, 1707,
     /*  61153 */     GIR_EraseRootFromParent_Done,
     /*  61154 */   // Label 851: @61154
     /*  61154 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(61173), // Rule ID 142 //
     /*  61159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  61166 */     // (fround:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRINS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /*  61166 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRINS),
     /*  61171 */     GIR_RootConstrainSelectedInstOperands,
     /*  61172 */     // GIR_Coverage, 142,
     /*  61172 */     GIR_Done,
     /*  61173 */   // Label 852: @61173
     /*  61173 */   GIM_Reject,
     /*  61174 */ // Label 850: @61174
     /*  61174 */ GIM_Reject,
     /*  61175 */ // Label 845: @61175
     /*  61175 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(61222),
     /*  61180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61183 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(61202), // Rule ID 909 //
     /*  61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61195 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPI:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /*  61195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /*  61200 */     GIR_RootConstrainSelectedInstOperands,
     /*  61201 */     // GIR_Coverage, 909,
     /*  61201 */     GIR_Done,
     /*  61202 */   // Label 854: @61202
     /*  61202 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(61221), // Rule ID 140 //
     /*  61207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  61210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61214 */     // (fround:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIND:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /*  61214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIND),
     /*  61219 */     GIR_RootConstrainSelectedInstOperands,
     /*  61220 */     // GIR_Coverage, 140,
     /*  61220 */     GIR_Done,
     /*  61221 */   // Label 855: @61221
     /*  61221 */   GIM_Reject,
     /*  61222 */ // Label 853: @61222
     /*  61222 */ GIM_Reject,
     /*  61223 */ // Label 846: @61223
     /*  61223 */ GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(61253), // Rule ID 2162 //
     /*  61228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  61231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  61234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  61238 */   // (fround:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 0:{ *:[i32] })
     /*  61238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /*  61241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  61243 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61246 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /*  61248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61251 */   GIR_RootConstrainSelectedInstOperands,
     /*  61252 */   // GIR_Coverage, 2162,
     /*  61252 */   GIR_EraseRootFromParent_Done,
     /*  61253 */ // Label 856: @61253
     /*  61253 */ GIM_Reject,
     /*  61254 */ // Label 847: @61254
     /*  61254 */ GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(61276), // Rule ID 917 //
     /*  61259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  61265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61269 */   // (fround:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPI:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /*  61269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPI),
     /*  61274 */   GIR_RootConstrainSelectedInstOperands,
     /*  61275 */   // GIR_Coverage, 917,
     /*  61275 */   GIR_Done,
     /*  61276 */ // Label 857: @61276
     /*  61276 */ GIM_Reject,
     /*  61277 */ // Label 848: @61277
     /*  61277 */ GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(61299), // Rule ID 925 //
     /*  61282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  61288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  61292 */   // (fround:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPI:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  61292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPI),
     /*  61297 */   GIR_RootConstrainSelectedInstOperands,
     /*  61298 */   // GIR_Coverage, 925,
     /*  61298 */   GIR_Done,
     /*  61299 */ // Label 858: @61299
     /*  61299 */ GIM_Reject,
     /*  61300 */ // Label 849: @61300
     /*  61300 */ GIM_Reject,
     /*  61301 */ // Label 14: @61301
     /*  61301 */ GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(61431),
     /*  61306 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61309 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 862*/ GIMT_Encode4(61430),
     /*  61320 */   /*GILLT_s32*//*Label 860*/ GIMT_Encode4(61328),
     /*  61324 */   /*GILLT_s64*//*Label 861*/ GIMT_Encode4(61389),
     /*  61328 */   // Label 860: @61328
     /*  61328 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(61388), // Rule ID 2034 //
     /*  61333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61340 */     // (lrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61340 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61343 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61347 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61352 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61356 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61386 */     GIR_RootConstrainSelectedInstOperands,
     /*  61387 */     // GIR_Coverage, 2034,
     /*  61387 */     GIR_EraseRootFromParent_Done,
     /*  61388 */   // Label 863: @61388
     /*  61388 */   GIM_Reject,
     /*  61389 */   // Label 861: @61389
     /*  61389 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(61429), // Rule ID 2033 //
     /*  61394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61401 */     // (lrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61427 */     GIR_RootConstrainSelectedInstOperands,
     /*  61428 */     // GIR_Coverage, 2033,
     /*  61428 */     GIR_EraseRootFromParent_Done,
     /*  61429 */   // Label 864: @61429
     /*  61429 */   GIM_Reject,
     /*  61430 */   // Label 862: @61430
     /*  61430 */   GIM_Reject,
     /*  61431 */ // Label 859: @61431
     /*  61431 */ GIM_Reject,
     /*  61432 */ // Label 15: @61432
     /*  61432 */ GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(61562),
     /*  61437 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61440 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 868*/ GIMT_Encode4(61561),
     /*  61451 */   /*GILLT_s32*//*Label 866*/ GIMT_Encode4(61459),
     /*  61455 */   /*GILLT_s64*//*Label 867*/ GIMT_Encode4(61520),
     /*  61459 */   // Label 866: @61459
     /*  61459 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(61519), // Rule ID 2036 //
     /*  61464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61471 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, F8RC:{ *:[i32] })))
     /*  61471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  61474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  61492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61504 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61517 */     GIR_RootConstrainSelectedInstOperands,
     /*  61518 */     // GIR_Coverage, 2036,
     /*  61518 */     GIR_EraseRootFromParent_Done,
     /*  61519 */   // Label 869: @61519
     /*  61519 */   GIM_Reject,
     /*  61520 */   // Label 867: @61520
     /*  61520 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(61560), // Rule ID 2035 //
     /*  61525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /*  61528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61532 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } ?:{ *:[f64] }:$S))
     /*  61532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  61535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  61539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61544 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // S
     /*  61548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  61553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  61555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61558 */     GIR_RootConstrainSelectedInstOperands,
     /*  61559 */     // GIR_Coverage, 2035,
     /*  61559 */     GIR_EraseRootFromParent_Done,
     /*  61560 */   // Label 870: @61560
     /*  61560 */   GIM_Reject,
     /*  61561 */   // Label 868: @61561
     /*  61561 */   GIM_Reject,
     /*  61562 */ // Label 865: @61562
     /*  61562 */ GIM_Reject,
     /*  61563 */ // Label 16: @61563
     /*  61563 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(61582), // Rule ID 639 //
     /*  61568 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  61575 */   // (readcyclecounter:{ *:[i64] })  =>  (MFTB8:{ *:[i64] })
     /*  61575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MFTB8),
     /*  61580 */   GIR_RootConstrainSelectedInstOperands,
     /*  61581 */   // GIR_Coverage, 639,
     /*  61581 */   GIR_Done,
     /*  61582 */ // Label 871: @61582
     /*  61582 */ GIM_Reject,
     /*  61583 */ // Label 17: @61583
     /*  61583 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 874*/ GIMT_Encode4(61658),
     /*  61594 */ /*GILLT_s32*//*Label 872*/ GIMT_Encode4(61602),
     /*  61598 */ /*GILLT_s64*//*Label 873*/ GIMT_Encode4(61630),
     /*  61602 */ // Label 872: @61602
     /*  61602 */ GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(61629), // Rule ID 1271 //
     /*  61607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61610 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61614 */   // MIs[0] Operand 1
     /*  61614 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61617 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61627 */   GIR_RootConstrainSelectedInstOperands,
     /*  61628 */   // GIR_Coverage, 1271,
     /*  61628 */   GIR_EraseRootFromParent_Done,
     /*  61629 */ // Label 875: @61629
     /*  61629 */ GIM_Reject,
     /*  61630 */ // Label 873: @61630
     /*  61630 */ GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(61657), // Rule ID 1270 //
     /*  61635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61638 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  61642 */   // MIs[0] Operand 1
     /*  61642 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61645 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (SYNC 0:{ *:[i32] })
     /*  61645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61651 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61655 */   GIR_RootConstrainSelectedInstOperands,
     /*  61656 */   // GIR_Coverage, 1270,
     /*  61656 */   GIR_EraseRootFromParent_Done,
     /*  61657 */ // Label 876: @61657
     /*  61657 */ GIM_Reject,
     /*  61658 */ // Label 874: @61658
     /*  61658 */ GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(61707),
     /*  61663 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  61666 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  61669 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(61689), // Rule ID 1272 //
     /*  61674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  61677 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (SYNC 1:{ *:[i32] })
     /*  61677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  61680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  61683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61687 */     GIR_RootConstrainSelectedInstOperands,
     /*  61688 */     // GIR_Coverage, 1272,
     /*  61688 */     GIR_EraseRootFromParent_Done,
     /*  61689 */   // Label 878: @61689
     /*  61689 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(61706), // Rule ID 1273 //
     /*  61694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  61697 */     // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (MSYNC)
     /*  61697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  61700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  61704 */     GIR_RootConstrainSelectedInstOperands,
     /*  61705 */     // GIR_Coverage, 1273,
     /*  61705 */     GIR_EraseRootFromParent_Done,
     /*  61706 */   // Label 879: @61706
     /*  61706 */   GIM_Reject,
     /*  61707 */ // Label 877: @61707
     /*  61707 */ GIM_Reject,
     /*  61708 */ // Label 18: @61708
     /*  61708 */ GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(61770),
     /*  61713 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  61716 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /*  61719 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(61757), // Rule ID 17 //
     /*  61724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /*  61728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s1,
     /*  61736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s1,
     /*  61740 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61746 */     // (brcond (xor:{ *:[i1] } i1:{ *:[i1] }:$BI, -1:{ *:[i1] }), (bb:{ *:[Other] }):$BD)  =>  (BCn i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCn),
     /*  61749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // BI
     /*  61753 */     GIR_RootToRootCopy, /*OpIdx*/1, // BD
     /*  61755 */     GIR_RootConstrainSelectedInstOperands,
     /*  61756 */     // GIR_Coverage, 17,
     /*  61756 */     GIR_EraseRootFromParent_Done,
     /*  61757 */   // Label 881: @61757
     /*  61757 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(61769), // Rule ID 16 //
     /*  61762 */     // (brcond i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)  =>  (BC i1:{ *:[i1] }:$BI, (bb:{ *:[Other] }):$BD)
     /*  61762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BC),
     /*  61767 */     GIR_RootConstrainSelectedInstOperands,
     /*  61768 */     // GIR_Coverage, 16,
     /*  61768 */     GIR_Done,
     /*  61769 */   // Label 882: @61769
     /*  61769 */   GIM_Reject,
     /*  61770 */ // Label 880: @61770
     /*  61770 */ GIM_Reject,
     /*  61771 */ // Label 19: @61771
     /*  61771 */ GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(61919),
     /*  61776 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  61779 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(61806), // Rule ID 1167 //
     /*  61784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  61787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsetdmrz),
     /*  61792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  61795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  61799 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10678:{ *:[iPTR] })  =>  (DMSETDMRZ:{ *:[v1024i1] })
     /*  61799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSETDMRZ),
     /*  61802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61804 */     GIR_RootConstrainSelectedInstOperands,
     /*  61805 */     // GIR_Coverage, 1167,
     /*  61805 */     GIR_EraseRootFromParent_Done,
     /*  61806 */   // Label 884: @61806
     /*  61806 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(61833), // Rule ID 1172 //
     /*  61811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  61814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  61826 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10773:{ *:[iPTR] })  =>  (XXSETACCZ:{ *:[v512i1] })
     /*  61826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSETACCZ),
     /*  61829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61831 */     GIR_RootConstrainSelectedInstOperands,
     /*  61832 */     // GIR_Coverage, 1172,
     /*  61832 */     GIR_EraseRootFromParent_Done,
     /*  61833 */   // Label 885: @61833
     /*  61833 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(61860), // Rule ID 1173 //
     /*  61838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  61841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxsetaccz),
     /*  61846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  61849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  61853 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10773:{ *:[iPTR] })  =>  (DMXXSETACCZ:{ *:[v512i1] })
     /*  61853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXXSETACCZ),
     /*  61856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  61858 */     GIR_RootConstrainSelectedInstOperands,
     /*  61859 */     // GIR_Coverage, 1173,
     /*  61859 */     GIR_EraseRootFromParent_Done,
     /*  61860 */   // Label 886: @61860
     /*  61860 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(61884), // Rule ID 4906 //
     /*  61865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfmsr),
     /*  61870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61877 */     // (intrinsic_wo_chain:{ *:[i32] } 10669:{ *:[iPTR] })  =>  (MFMSR:{ *:[i32] })
     /*  61877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFMSR),
     /*  61880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61882 */     GIR_RootConstrainSelectedInstOperands,
     /*  61883 */     // GIR_Coverage, 4906,
     /*  61883 */     GIR_EraseRootFromParent_Done,
     /*  61884 */   // Label 887: @61884
     /*  61884 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(61918), // Rule ID 4907 //
     /*  61889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mftbu),
     /*  61894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  61901 */     // (intrinsic_wo_chain:{ *:[i32] } 10671:{ *:[iPTR] })  =>  (MFTB:{ *:[i32] } 269:{ *:[i32] })
     /*  61901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFTB),
     /*  61904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  61906 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(269),
     /*  61916 */     GIR_RootConstrainSelectedInstOperands,
     /*  61917 */     // GIR_Coverage, 4907,
     /*  61917 */     GIR_EraseRootFromParent_Done,
     /*  61918 */   // Label 888: @61918
     /*  61918 */   GIM_Reject,
     /*  61919 */ // Label 883: @61919
     /*  61919 */ GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(65630),
     /*  61924 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  61927 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(61963), // Rule ID 1755 //
     /*  61932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  61935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  61940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  61943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  61954 */     // (intrinsic_wo_chain:{ *:[f64] } 10640:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XB)  =>  (XSRSQRTEDP:{ *:[f64] } ?:{ *:[f64] }:$XB)
     /*  61954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTEDP),
     /*  61957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61959 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61961 */     GIR_RootConstrainSelectedInstOperands,
     /*  61962 */     // GIR_Coverage, 1755,
     /*  61962 */     GIR_EraseRootFromParent_Done,
     /*  61963 */   // Label 890: @61963
     /*  61963 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(61999), // Rule ID 1946 //
     /*  61968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  61971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  61976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  61990 */     // (intrinsic_wo_chain:{ *:[f32] } 10641:{ *:[iPTR] }, vssrc:{ *:[f32] }:$XB)  =>  (XSRSQRTESP:{ *:[f32] } ?:{ *:[f32] }:$XB)
     /*  61990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSQRTESP),
     /*  61993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  61995 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  61997 */     GIR_RootConstrainSelectedInstOperands,
     /*  61998 */     // GIR_Coverage, 1946,
     /*  61998 */     GIR_EraseRootFromParent_Done,
     /*  61999 */   // Label 891: @61999
     /*  61999 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(62031), // Rule ID 876 //
     /*  62004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsp),
     /*  62012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62022 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10869:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSP:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSP),
     /*  62025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62027 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62029 */     GIR_RootConstrainSelectedInstOperands,
     /*  62030 */     // GIR_Coverage, 876,
     /*  62030 */     GIR_EraseRootFromParent_Done,
     /*  62031 */   // Label 892: @62031
     /*  62031 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(62063), // Rule ID 879 //
     /*  62036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpsxws),
     /*  62044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62054 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10870:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXWS),
     /*  62057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62059 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62061 */     GIR_RootConstrainSelectedInstOperands,
     /*  62062 */     // GIR_Coverage, 879,
     /*  62062 */     GIR_EraseRootFromParent_Done,
     /*  62063 */   // Label 893: @62063
     /*  62063 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(62095), // Rule ID 882 //
     /*  62068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvdpuxws),
     /*  62076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10871:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXWS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$XB)
     /*  62086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXWS),
     /*  62089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62091 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62093 */     GIR_RootConstrainSelectedInstOperands,
     /*  62094 */     // GIR_Coverage, 882,
     /*  62094 */     GIR_EraseRootFromParent_Done,
     /*  62095 */   // Label 894: @62095
     /*  62095 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(62127), // Rule ID 883 //
     /*  62100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspdp),
     /*  62108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62118 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10874:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPDP:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPDP),
     /*  62121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62123 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62125 */     GIR_RootConstrainSelectedInstOperands,
     /*  62126 */     // GIR_Coverage, 883,
     /*  62126 */     GIR_EraseRootFromParent_Done,
     /*  62127 */   // Label 895: @62127
     /*  62127 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(62159), // Rule ID 884 //
     /*  62132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspsxds),
     /*  62140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62150 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10876:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXDS),
     /*  62153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62155 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62157 */     GIR_RootConstrainSelectedInstOperands,
     /*  62158 */     // GIR_Coverage, 884,
     /*  62158 */     GIR_EraseRootFromParent_Done,
     /*  62159 */   // Label 896: @62159
     /*  62159 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(62191), // Rule ID 887 //
     /*  62164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspuxds),
     /*  62172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62182 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10877:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXDS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$XB)
     /*  62182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXDS),
     /*  62185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62187 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62189 */     GIR_RootConstrainSelectedInstOperands,
     /*  62190 */     // GIR_Coverage, 887,
     /*  62190 */     GIR_EraseRootFromParent_Done,
     /*  62191 */   // Label 897: @62191
     /*  62191 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(62223), // Rule ID 892 //
     /*  62196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxdsp),
     /*  62204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62214 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10878:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDSP),
     /*  62217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62219 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62221 */     GIR_RootConstrainSelectedInstOperands,
     /*  62222 */     // GIR_Coverage, 892,
     /*  62222 */     GIR_EraseRootFromParent_Done,
     /*  62223 */   // Label 898: @62223
     /*  62223 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(62255), // Rule ID 897 //
     /*  62228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxdsp),
     /*  62236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62246 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10880:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDSP:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$XB)
     /*  62246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDSP),
     /*  62249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62251 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62253 */     GIR_RootConstrainSelectedInstOperands,
     /*  62254 */     // GIR_Coverage, 897,
     /*  62254 */     GIR_EraseRootFromParent_Done,
     /*  62255 */   // Label 899: @62255
     /*  62255 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(62287), // Rule ID 900 //
     /*  62260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsxwdp),
     /*  62268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62278 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10879:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWDP),
     /*  62281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62283 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62285 */     GIR_RootConstrainSelectedInstOperands,
     /*  62286 */     // GIR_Coverage, 900,
     /*  62286 */     GIR_EraseRootFromParent_Done,
     /*  62287 */   // Label 900: @62287
     /*  62287 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(62319), // Rule ID 901 //
     /*  62292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvuxwdp),
     /*  62300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62310 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10881:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWDP:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$XB)
     /*  62310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWDP),
     /*  62313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62315 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62317 */     GIR_RootConstrainSelectedInstOperands,
     /*  62318 */     // GIR_Coverage, 901,
     /*  62318 */     GIR_EraseRootFromParent_Done,
     /*  62319 */   // Label 901: @62319
     /*  62319 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(62351), // Rule ID 1009 //
     /*  62324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_sqrtf128_round_to_odd),
     /*  62332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  62335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  62342 */     // (intrinsic_wo_chain:{ *:[f128] } 10805:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSSQRTQPO:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /*  62342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQPO),
     /*  62345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62347 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62349 */     GIR_RootConstrainSelectedInstOperands,
     /*  62350 */     // GIR_Coverage, 1009,
     /*  62350 */     GIR_EraseRootFromParent_Done,
     /*  62351 */   // Label 902: @62351
     /*  62351 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(62383), // Rule ID 1016 //
     /*  62356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_truncf128_round_to_odd),
     /*  62364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  62370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /*  62374 */     // (intrinsic_wo_chain:{ *:[f64] } 10832:{ *:[iPTR] }, f128:{ *:[f128] }:$RB)  =>  (XSCVQPDPO:{ *:[f64] } f128:{ *:[f128] }:$RB)
     /*  62374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /*  62377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  62379 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  62381 */     GIR_RootConstrainSelectedInstOperands,
     /*  62382 */     // GIR_Coverage, 1016,
     /*  62382 */     GIR_EraseRootFromParent_Done,
     /*  62383 */   // Label 903: @62383
     /*  62383 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(62415), // Rule ID 1025 //
     /*  62388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvsphp),
     /*  62396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62406 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10875:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPHP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVSPHP),
     /*  62409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62411 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62413 */     GIR_RootConstrainSelectedInstOperands,
     /*  62414 */     // GIR_Coverage, 1025,
     /*  62414 */     GIR_EraseRootFromParent_Done,
     /*  62415 */   // Label 904: @62415
     /*  62415 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(62447), // Rule ID 1029 //
     /*  62420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpdp),
     /*  62428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62438 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10903:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXEXPDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPDP),
     /*  62441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62443 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62445 */     GIR_RootConstrainSelectedInstOperands,
     /*  62446 */     // GIR_Coverage, 1029,
     /*  62446 */     GIR_EraseRootFromParent_Done,
     /*  62447 */   // Label 905: @62447
     /*  62447 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(62479), // Rule ID 1030 //
     /*  62452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxexpsp),
     /*  62460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62470 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10904:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXEXPSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXEXPSP),
     /*  62473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62475 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62477 */     GIR_RootConstrainSelectedInstOperands,
     /*  62478 */     // GIR_Coverage, 1030,
     /*  62478 */     GIR_EraseRootFromParent_Done,
     /*  62479 */   // Label 906: @62479
     /*  62479 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(62511), // Rule ID 1031 //
     /*  62484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigdp),
     /*  62492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62502 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10905:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB)  =>  (XVXSIGDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /*  62502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGDP),
     /*  62505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62507 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62509 */     GIR_RootConstrainSelectedInstOperands,
     /*  62510 */     // GIR_Coverage, 1031,
     /*  62510 */     GIR_EraseRootFromParent_Done,
     /*  62511 */   // Label 907: @62511
     /*  62511 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(62543), // Rule ID 1032 //
     /*  62516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  62519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvxsigsp),
     /*  62524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62534 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10906:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB)  =>  (XVXSIGSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /*  62534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVXSIGSP),
     /*  62537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62539 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  62541 */     GIR_RootConstrainSelectedInstOperands,
     /*  62542 */     // GIR_Coverage, 1032,
     /*  62542 */     GIR_EraseRootFromParent_Done,
     /*  62543 */   // Label 908: @62543
     /*  62543 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(62598), // Rule ID 1663 //
     /*  62548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtdp),
     /*  62556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62566 */     // (intrinsic_wo_chain:{ *:[i32] } 10899:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTDP:{ *:[i32] } ?:{ *:[v2f64] }:$A), GPRC:{ *:[i32] })
     /*  62566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTDP),
     /*  62573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62597 */     // GIR_Coverage, 1663,
     /*  62597 */     GIR_EraseRootFromParent_Done,
     /*  62598 */   // Label 909: @62598
     /*  62598 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(62653), // Rule ID 1664 //
     /*  62603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtsqrtsp),
     /*  62611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62621 */     // (intrinsic_wo_chain:{ *:[i32] } 10900:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTSQRTSP:{ *:[i32] } ?:{ *:[v4f32] }:$A), GPRC:{ *:[i32] })
     /*  62621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  62624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTSQRTSP),
     /*  62628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62652 */     // GIR_Coverage, 1664,
     /*  62652 */     GIR_EraseRootFromParent_Done,
     /*  62653 */   // Label 910: @62653
     /*  62653 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(62685), // Rule ID 1665 //
     /*  62658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvresp),
     /*  62666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62676 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10892:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRESP),
     /*  62679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62681 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62683 */     GIR_RootConstrainSelectedInstOperands,
     /*  62684 */     // GIR_Coverage, 1665,
     /*  62684 */     GIR_EraseRootFromParent_Done,
     /*  62685 */   // Label 911: @62685
     /*  62685 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(62717), // Rule ID 1666 //
     /*  62690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvredp),
     /*  62698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62708 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10891:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVREDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVREDP),
     /*  62711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62713 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62715 */     GIR_RootConstrainSelectedInstOperands,
     /*  62716 */     // GIR_Coverage, 1666,
     /*  62716 */     GIR_EraseRootFromParent_Done,
     /*  62717 */   // Label 912: @62717
     /*  62717 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(62749), // Rule ID 1667 //
     /*  62722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtesp),
     /*  62730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62740 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10895:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A)  =>  (XVRSQRTESP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A)
     /*  62740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTESP),
     /*  62743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62745 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62747 */     GIR_RootConstrainSelectedInstOperands,
     /*  62748 */     // GIR_Coverage, 1667,
     /*  62748 */     GIR_EraseRootFromParent_Done,
     /*  62749 */   // Label 913: @62749
     /*  62749 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(62781), // Rule ID 1668 //
     /*  62754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvrsqrtedp),
     /*  62762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  62765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  62768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  62772 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10894:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A)  =>  (XVRSQRTEDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A)
     /*  62772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVRSQRTEDP),
     /*  62775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62777 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62779 */     GIR_RootConstrainSelectedInstOperands,
     /*  62780 */     // GIR_Coverage, 1668,
     /*  62780 */     GIR_EraseRootFromParent_Done,
     /*  62781 */   // Label 914: @62781
     /*  62781 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(62813), // Rule ID 1754 //
     /*  62786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  62794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62804 */     // (intrinsic_wo_chain:{ *:[f64] } 10638:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSREDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSREDP),
     /*  62807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62809 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62811 */     GIR_RootConstrainSelectedInstOperands,
     /*  62812 */     // GIR_Coverage, 1754,
     /*  62812 */     GIR_EraseRootFromParent_Done,
     /*  62813 */   // Label 915: @62813
     /*  62813 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(62845), // Rule ID 1756 //
     /*  62818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  62826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  62829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62836 */     // (intrinsic_wo_chain:{ *:[f64] } 10633:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSNABSDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  62836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /*  62839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62841 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62843 */     GIR_RootConstrainSelectedInstOperands,
     /*  62844 */     // GIR_Coverage, 1756,
     /*  62844 */     GIR_EraseRootFromParent_Done,
     /*  62845 */   // Label 916: @62845
     /*  62845 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(62877), // Rule ID 1757 //
     /*  62850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  62853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  62858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62868 */     // (intrinsic_wo_chain:{ *:[f32] } 10634:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSNABSDPs:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /*  62871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62873 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62875 */     GIR_RootConstrainSelectedInstOperands,
     /*  62876 */     // GIR_Coverage, 1757,
     /*  62876 */     GIR_EraseRootFromParent_Done,
     /*  62877 */   // Label 917: @62877
     /*  62877 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(62909), // Rule ID 1941 //
     /*  62882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  62890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  62900 */     // (intrinsic_wo_chain:{ *:[f32] } 10639:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (XSRESP:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  62900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRESP),
     /*  62903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  62905 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  62907 */     GIR_RootConstrainSelectedInstOperands,
     /*  62908 */     // GIR_Coverage, 1941,
     /*  62908 */     GIR_EraseRootFromParent_Done,
     /*  62909 */   // Label 918: @62909
     /*  62909 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(62993), // Rule ID 1942 //
     /*  62914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  62917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_exp),
     /*  62922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  62925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  62928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62932 */     // (intrinsic_wo_chain:{ *:[i32] } 10618:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (EXTRACT_SUBREG:{ *:[i32] } (XSXEXPDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  62932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  62935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  62948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  62953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  62956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSXEXPDP),
     /*  62960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  62968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  62973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62975 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  62982 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  62987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  62992 */     // GIR_Coverage, 1942,
     /*  62992 */     GIR_EraseRootFromParent_Done,
     /*  62993 */   // Label 919: @62993
     /*  62993 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(63047), // Rule ID 1943 //
     /*  62998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  63001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_extract_sig),
     /*  63006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63016 */     // (intrinsic_wo_chain:{ *:[i64] } 10619:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSXSIGDP:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f64] }:$A, VSFRC:{ *:[i32] }))
     /*  63016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  63037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSXSIGDP),
     /*  63040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63045 */     GIR_RootConstrainSelectedInstOperands,
     /*  63046 */     // GIR_Coverage, 1943,
     /*  63046 */     GIR_EraseRootFromParent_Done,
     /*  63047 */   // Label 920: @63047
     /*  63047 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(63101), // Rule ID 2158 //
     /*  63052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvhpsp),
     /*  63060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63070 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10872:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A)  =>  (XVCVHPSP:{ *:[v4f32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }))
     /*  63070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63082 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  63086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  63091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCVHPSP),
     /*  63094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  63096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63099 */     GIR_RootConstrainSelectedInstOperands,
     /*  63100 */     // GIR_Coverage, 2158,
     /*  63100 */     GIR_EraseRootFromParent_Done,
     /*  63101 */   // Label 921: @63101
     /*  63101 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(63181), // Rule ID 2172 //
     /*  63106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  63109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_extract_expq),
     /*  63114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  63120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  63124 */     // (intrinsic_wo_chain:{ *:[i64] } 10796:{ *:[iPTR] }, f128:{ *:[f128] }:$vA)  =>  (MFVSRD:{ *:[i64] } (EXTRACT_SUBREG:{ *:[f64] } (XSXEXPQP:{ *:[v2i64] } ?:{ *:[f128] }:$vA), sub_64:{ *:[i32] }))
     /*  63124 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  63127 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSXEXPQP),
     /*  63131 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63136 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vA
     /*  63140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  63142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  63145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  63149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63154 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_64),
     /*  63161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /*  63166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /*  63174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63179 */     GIR_RootConstrainSelectedInstOperands,
     /*  63180 */     // GIR_Coverage, 2172,
     /*  63180 */     GIR_EraseRootFromParent_Done,
     /*  63181 */   // Label 922: @63181
     /*  63181 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(63224), // Rule ID 1097 //
     /*  63186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  63189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  63194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63212 */     // MIs[1] Operand 1
     /*  63212 */     // No operand predicates
     /*  63212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63214 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10283:{ *:[iPTR] }, (imm:{ *:[i64] }):$D)  =>  (MTVSRBMI:{ *:[v16i8] } (imm:{ *:[i64] }):$D)
     /*  63214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBMI),
     /*  63217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  63219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // D
     /*  63222 */     GIR_RootConstrainSelectedInstOperands,
     /*  63223 */     // GIR_Coverage, 1097,
     /*  63223 */     GIR_EraseRootFromParent_Done,
     /*  63224 */   // Label 923: @63224
     /*  63224 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(63257), // Rule ID 4858 //
     /*  63229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrte),
     /*  63234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  63237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  63248 */     // (intrinsic_wo_chain:{ *:[f64] } 10640:{ *:[iPTR] }, f8rc:{ *:[f64] }:$frB)  =>  (FRSQRTE:{ *:[f64] } ?:{ *:[f64] }:$frB)
     /*  63248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTE),
     /*  63251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63253 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63255 */     GIR_RootConstrainSelectedInstOperands,
     /*  63256 */     // GIR_Coverage, 4858,
     /*  63256 */     GIR_EraseRootFromParent_Done,
     /*  63257 */   // Label 924: @63257
     /*  63257 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(63290), // Rule ID 4859 //
     /*  63262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_frsqrtes),
     /*  63267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  63281 */     // (intrinsic_wo_chain:{ *:[f32] } 10641:{ *:[iPTR] }, f4rc:{ *:[f32] }:$frB)  =>  (FRSQRTES:{ *:[f32] } ?:{ *:[f32] }:$frB)
     /*  63281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRSQRTES),
     /*  63284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  63286 */     GIR_RootToRootCopy, /*OpIdx*/2, // frB
     /*  63288 */     GIR_RootConstrainSelectedInstOperands,
     /*  63289 */     // GIR_Coverage, 4859,
     /*  63289 */     GIR_EraseRootFromParent_Done,
     /*  63290 */   // Label 925: @63290
     /*  63290 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(63319), // Rule ID 73 //
     /*  63295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  63300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63310 */     // (intrinsic_wo_chain:{ *:[i32] } 10791:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (POPCNTB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB),
     /*  63313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63315 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63317 */     GIR_RootConstrainSelectedInstOperands,
     /*  63318 */     // GIR_Coverage, 73,
     /*  63318 */     GIR_EraseRootFromParent_Done,
     /*  63319 */   // Label 926: @63319
     /*  63319 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(63348), // Rule ID 74 //
     /*  63324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcd),
     /*  63329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63339 */     // (intrinsic_wo_chain:{ *:[i32] } 10577:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CDTBCD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD),
     /*  63342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63344 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63346 */     GIR_RootConstrainSelectedInstOperands,
     /*  63347 */     // GIR_Coverage, 74,
     /*  63347 */     GIR_EraseRootFromParent_Done,
     /*  63348 */   // Label 927: @63348
     /*  63348 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(63377), // Rule ID 75 //
     /*  63353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtd),
     /*  63358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63368 */     // (intrinsic_wo_chain:{ *:[i32] } 10575:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (CBCDTD:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  63368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD),
     /*  63371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  63373 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  63375 */     GIR_RootConstrainSelectedInstOperands,
     /*  63376 */     // GIR_Coverage, 75,
     /*  63376 */     GIR_EraseRootFromParent_Done,
     /*  63377 */   // Label 928: @63377
     /*  63377 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(63409), // Rule ID 321 //
     /*  63382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexptefp),
     /*  63390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63400 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10390:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VEXPTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPTEFP),
     /*  63403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63405 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63407 */     GIR_RootConstrainSelectedInstOperands,
     /*  63408 */     // GIR_Coverage, 321,
     /*  63408 */     GIR_EraseRootFromParent_Done,
     /*  63409 */   // Label 929: @63409
     /*  63409 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(63441), // Rule ID 322 //
     /*  63414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vlogefp),
     /*  63422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63432 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10428:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VLOGEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VLOGEFP),
     /*  63435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63437 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63439 */     GIR_RootConstrainSelectedInstOperands,
     /*  63440 */     // GIR_Coverage, 322,
     /*  63440 */     GIR_EraseRootFromParent_Done,
     /*  63441 */   // Label 930: @63441
     /*  63441 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(63473), // Rule ID 363 //
     /*  63446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrefp),
     /*  63454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63464 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10496:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VREFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VREFP),
     /*  63467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63469 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63471 */     GIR_RootConstrainSelectedInstOperands,
     /*  63472 */     // GIR_Coverage, 363,
     /*  63472 */     GIR_EraseRootFromParent_Done,
     /*  63473 */   // Label 931: @63473
     /*  63473 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(63505), // Rule ID 364 //
     /*  63478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfim),
     /*  63486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63496 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10497:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /*  63499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63501 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63503 */     GIR_RootConstrainSelectedInstOperands,
     /*  63504 */     // GIR_Coverage, 364,
     /*  63504 */     GIR_EraseRootFromParent_Done,
     /*  63505 */   // Label 932: @63505
     /*  63505 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(63537), // Rule ID 365 //
     /*  63510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfin),
     /*  63518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63528 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10498:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIN:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /*  63531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63533 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63535 */     GIR_RootConstrainSelectedInstOperands,
     /*  63536 */     // GIR_Coverage, 365,
     /*  63536 */     GIR_EraseRootFromParent_Done,
     /*  63537 */   // Label 933: @63537
     /*  63537 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(63569), // Rule ID 366 //
     /*  63542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfip),
     /*  63550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63560 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10499:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /*  63563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63565 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63567 */     GIR_RootConstrainSelectedInstOperands,
     /*  63568 */     // GIR_Coverage, 366,
     /*  63568 */     GIR_EraseRootFromParent_Done,
     /*  63569 */   // Label 934: @63569
     /*  63569 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(63601), // Rule ID 367 //
     /*  63574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrfiz),
     /*  63582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63592 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10500:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRFIZ:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRFIZ),
     /*  63595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63597 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63599 */     GIR_RootConstrainSelectedInstOperands,
     /*  63600 */     // GIR_Coverage, 367,
     /*  63600 */     GIR_EraseRootFromParent_Done,
     /*  63601 */   // Label 935: @63601
     /*  63601 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(63633), // Rule ID 368 //
     /*  63606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrsqrtefp),
     /*  63614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63624 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10511:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB)  =>  (VRSQRTEFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VB)
     /*  63624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRSQRTEFP),
     /*  63627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63629 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63631 */     GIR_RootConstrainSelectedInstOperands,
     /*  63632 */     // GIR_Coverage, 368,
     /*  63632 */     GIR_EraseRootFromParent_Done,
     /*  63633 */   // Label 936: @63633
     /*  63633 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(63665), // Rule ID 419 //
     /*  63638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhpx),
     /*  63646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10553:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHPX),
     /*  63659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63661 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63663 */     GIR_RootConstrainSelectedInstOperands,
     /*  63664 */     // GIR_Coverage, 419,
     /*  63664 */     GIR_EraseRootFromParent_Done,
     /*  63665 */   // Label 937: @63665
     /*  63665 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(63697), // Rule ID 420 //
     /*  63670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsb),
     /*  63678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63688 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10554:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKHSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSB),
     /*  63691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63693 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63695 */     GIR_RootConstrainSelectedInstOperands,
     /*  63696 */     // GIR_Coverage, 420,
     /*  63696 */     GIR_EraseRootFromParent_Done,
     /*  63697 */   // Label 938: @63697
     /*  63697 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(63729), // Rule ID 421 //
     /*  63702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsh),
     /*  63710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63720 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10555:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKHSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSH),
     /*  63723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63725 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63727 */     GIR_RootConstrainSelectedInstOperands,
     /*  63728 */     // GIR_Coverage, 421,
     /*  63728 */     GIR_EraseRootFromParent_Done,
     /*  63729 */   // Label 939: @63729
     /*  63729 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(63761), // Rule ID 422 //
     /*  63734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklpx),
     /*  63742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63752 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10557:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLPX:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLPX),
     /*  63755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63757 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63759 */     GIR_RootConstrainSelectedInstOperands,
     /*  63760 */     // GIR_Coverage, 422,
     /*  63760 */     GIR_EraseRootFromParent_Done,
     /*  63761 */   // Label 940: @63761
     /*  63761 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(63793), // Rule ID 423 //
     /*  63766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsb),
     /*  63774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63784 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10558:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VUPKLSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VB)
     /*  63784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSB),
     /*  63787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63789 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63791 */     GIR_RootConstrainSelectedInstOperands,
     /*  63792 */     // GIR_Coverage, 423,
     /*  63792 */     GIR_EraseRootFromParent_Done,
     /*  63793 */   // Label 941: @63793
     /*  63793 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(63825), // Rule ID 424 //
     /*  63798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  63801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsh),
     /*  63806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63816 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10559:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VUPKLSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  63816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSH),
     /*  63819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63821 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63823 */     GIR_RootConstrainSelectedInstOperands,
     /*  63824 */     // GIR_Coverage, 424,
     /*  63824 */     GIR_EraseRootFromParent_Done,
     /*  63825 */   // Label 942: @63825
     /*  63825 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(63857), // Rule ID 504 //
     /*  63830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupkhsw),
     /*  63838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63848 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10556:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKHSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKHSW),
     /*  63851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63853 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63855 */     GIR_RootConstrainSelectedInstOperands,
     /*  63856 */     // GIR_Coverage, 504,
     /*  63856 */     GIR_EraseRootFromParent_Done,
     /*  63857 */   // Label 943: @63857
     /*  63857 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(63889), // Rule ID 505 //
     /*  63862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vupklsw),
     /*  63870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10560:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VUPKLSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  63880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VUPKLSW),
     /*  63883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63885 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63887 */     GIR_RootConstrainSelectedInstOperands,
     /*  63888 */     // GIR_Coverage, 505,
     /*  63888 */     GIR_EraseRootFromParent_Done,
     /*  63889 */   // Label 944: @63889
     /*  63889 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(63921), // Rule ID 506 //
     /*  63894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  63897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgbbd),
     /*  63902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63912 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10410:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VGBBD:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  63912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGBBD),
     /*  63915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63917 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63919 */     GIR_RootConstrainSelectedInstOperands,
     /*  63920 */     // GIR_Coverage, 506,
     /*  63920 */     GIR_EraseRootFromParent_Done,
     /*  63921 */   // Label 945: @63921
     /*  63921 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(63953), // Rule ID 514 //
     /*  63926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  63929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vsbox),
     /*  63934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  63937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  63940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  63944 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10265:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA)  =>  (VSBOX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA)
     /*  63944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSBOX),
     /*  63947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63949 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  63951 */     GIR_RootConstrainSelectedInstOperands,
     /*  63952 */     // GIR_Coverage, 514,
     /*  63952 */     GIR_EraseRootFromParent_Done,
     /*  63953 */   // Label 946: @63953
     /*  63953 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(63985), // Rule ID 530 //
     /*  63958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzlsbb),
     /*  63966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  63969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  63976 */     // (intrinsic_wo_chain:{ *:[i32] } 10320:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  63976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZLSBB),
     /*  63979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  63981 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  63983 */     GIR_RootConstrainSelectedInstOperands,
     /*  63984 */     // GIR_Coverage, 530,
     /*  63984 */     GIR_EraseRootFromParent_Done,
     /*  63985 */   // Label 947: @63985
     /*  63985 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(64017), // Rule ID 531 //
     /*  63990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  63993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzlsbb),
     /*  63998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64008 */     // (intrinsic_wo_chain:{ *:[i32] } 10378:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZLSBB:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZLSBB),
     /*  64011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64013 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64015 */     GIR_RootConstrainSelectedInstOperands,
     /*  64016 */     // GIR_Coverage, 531,
     /*  64016 */     GIR_EraseRootFromParent_Done,
     /*  64017 */   // Label 948: @64017
     /*  64017 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(64049), // Rule ID 536 //
     /*  64022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2w),
     /*  64030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64040 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10405:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2W:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /*  64043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64045 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64047 */     GIR_RootConstrainSelectedInstOperands,
     /*  64048 */     // GIR_Coverage, 536,
     /*  64048 */     GIR_EraseRootFromParent_Done,
     /*  64049 */   // Label 949: @64049
     /*  64049 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(64081), // Rule ID 537 //
     /*  64054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2w),
     /*  64062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64072 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10408:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2W:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /*  64075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64077 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64079 */     GIR_RootConstrainSelectedInstOperands,
     /*  64080 */     // GIR_Coverage, 537,
     /*  64080 */     GIR_EraseRootFromParent_Done,
     /*  64081 */   // Label 950: @64081
     /*  64081 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(64113), // Rule ID 538 //
     /*  64086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsb2d),
     /*  64094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64104 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10404:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTSB2D:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VB)
     /*  64104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /*  64107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64109 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64111 */     GIR_RootConstrainSelectedInstOperands,
     /*  64112 */     // GIR_Coverage, 538,
     /*  64112 */     GIR_EraseRootFromParent_Done,
     /*  64113 */   // Label 951: @64113
     /*  64113 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(64145), // Rule ID 539 //
     /*  64118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsh2d),
     /*  64126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64136 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10407:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTSH2D:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$VB)
     /*  64136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /*  64139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64141 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64143 */     GIR_RootConstrainSelectedInstOperands,
     /*  64144 */     // GIR_Coverage, 539,
     /*  64144 */     GIR_EraseRootFromParent_Done,
     /*  64145 */   // Label 952: @64145
     /*  64145 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(64177), // Rule ID 540 //
     /*  64150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsw2d),
     /*  64158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64168 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10409:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTSW2D:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VB)
     /*  64168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /*  64171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64173 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64175 */     GIR_RootConstrainSelectedInstOperands,
     /*  64176 */     // GIR_Coverage, 540,
     /*  64176 */     GIR_EraseRootFromParent_Done,
     /*  64177 */   // Label 953: @64177
     /*  64177 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(64209), // Rule ID 543 //
     /*  64182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybw),
     /*  64190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10495:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VPRTYBW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBW),
     /*  64203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64205 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64207 */     GIR_RootConstrainSelectedInstOperands,
     /*  64208 */     // GIR_Coverage, 543,
     /*  64208 */     GIR_EraseRootFromParent_Done,
     /*  64209 */   // Label 954: @64209
     /*  64209 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(64241), // Rule ID 544 //
     /*  64214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybd),
     /*  64222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64232 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10493:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VPRTYBD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBD),
     /*  64235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64237 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64239 */     GIR_RootConstrainSelectedInstOperands,
     /*  64240 */     // GIR_Coverage, 544,
     /*  64240 */     GIR_EraseRootFromParent_Done,
     /*  64241 */   // Label 955: @64241
     /*  64241 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(64273), // Rule ID 545 //
     /*  64246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vprtybq),
     /*  64254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64264 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10494:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VPRTYBQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPRTYBQ),
     /*  64267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64269 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64271 */     GIR_RootConstrainSelectedInstOperands,
     /*  64272 */     // GIR_Coverage, 545,
     /*  64272 */     GIR_EraseRootFromParent_Done,
     /*  64273 */   // Label 956: @64273
     /*  64273 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(64308), // Rule ID 555 //
     /*  64278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  64281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_packed2national),
     /*  64286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64296 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10787:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (BCDCTN_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCTN_rec),
     /*  64299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64301 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  64306 */     GIR_RootConstrainSelectedInstOperands,
     /*  64307 */     // GIR_Coverage, 555,
     /*  64307 */     GIR_EraseRootFromParent_Done,
     /*  64308 */   // Label 957: @64308
     /*  64308 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(64337), // Rule ID 693 //
     /*  64313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_popcntb),
     /*  64318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64328 */     // (intrinsic_wo_chain:{ *:[i64] } 10791:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (POPCNTB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::POPCNTB8),
     /*  64331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64333 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64335 */     GIR_RootConstrainSelectedInstOperands,
     /*  64336 */     // GIR_Coverage, 693,
     /*  64336 */     GIR_EraseRootFromParent_Done,
     /*  64337 */   // Label 958: @64337
     /*  64337 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(64366), // Rule ID 694 //
     /*  64342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cdtbcdd),
     /*  64347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64357 */     // (intrinsic_wo_chain:{ *:[i64] } 10578:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CDTBCD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CDTBCD8),
     /*  64360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64362 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64364 */     GIR_RootConstrainSelectedInstOperands,
     /*  64365 */     // GIR_Coverage, 694,
     /*  64365 */     GIR_EraseRootFromParent_Done,
     /*  64366 */   // Label 959: @64366
     /*  64366 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(64395), // Rule ID 695 //
     /*  64371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cbcdtdd),
     /*  64376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  64379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  64386 */     // (intrinsic_wo_chain:{ *:[i64] } 10576:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (CBCDTD8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  64386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CBCDTD8),
     /*  64389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  64391 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  64393 */     GIR_RootConstrainSelectedInstOperands,
     /*  64394 */     // GIR_Coverage, 695,
     /*  64394 */     GIR_EraseRootFromParent_Done,
     /*  64395 */   // Label 960: @64395
     /*  64395 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(64427), // Rule ID 1062 //
     /*  64400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribr),
     /*  64408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64418 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10532:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBR:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBR),
     /*  64421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64423 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64425 */     GIR_RootConstrainSelectedInstOperands,
     /*  64426 */     // GIR_Coverage, 1062,
     /*  64426 */     GIR_EraseRootFromParent_Done,
     /*  64427 */   // Label 961: @64427
     /*  64427 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(64459), // Rule ID 1063 //
     /*  64432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstribl),
     /*  64440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64450 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10530:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VSTRIBL:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIBL),
     /*  64453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64455 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64457 */     GIR_RootConstrainSelectedInstOperands,
     /*  64458 */     // GIR_Coverage, 1063,
     /*  64458 */     GIR_EraseRootFromParent_Done,
     /*  64459 */   // Label 962: @64459
     /*  64459 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(64491), // Rule ID 1064 //
     /*  64464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihr),
     /*  64472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64482 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10536:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHR:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHR),
     /*  64485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64487 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64489 */     GIR_RootConstrainSelectedInstOperands,
     /*  64490 */     // GIR_Coverage, 1064,
     /*  64490 */     GIR_EraseRootFromParent_Done,
     /*  64491 */   // Label 963: @64491
     /*  64491 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(64523), // Rule ID 1065 //
     /*  64496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vstrihl),
     /*  64504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64514 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10534:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VSTRIHL:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSTRIHL),
     /*  64517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VT]
     /*  64519 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64521 */     GIR_RootConstrainSelectedInstOperands,
     /*  64522 */     // GIR_Coverage, 1065,
     /*  64522 */     GIR_EraseRootFromParent_Done,
     /*  64523 */   // Label 964: @64523
     /*  64523 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(64555), // Rule ID 1082 //
     /*  64528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractbm),
     /*  64536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64546 */     // (intrinsic_wo_chain:{ *:[i32] } 10399:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXTRACTBM:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB)
     /*  64546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTBM),
     /*  64549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64551 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64553 */     GIR_RootConstrainSelectedInstOperands,
     /*  64554 */     // GIR_Coverage, 1082,
     /*  64554 */     GIR_EraseRootFromParent_Done,
     /*  64555 */   // Label 965: @64555
     /*  64555 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(64587), // Rule ID 1083 //
     /*  64560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextracthm),
     /*  64568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64578 */     // (intrinsic_wo_chain:{ *:[i32] } 10401:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXTRACTHM:{ *:[i32] } v8i16:{ *:[v8i16] }:$VB)
     /*  64578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTHM),
     /*  64581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64583 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64585 */     GIR_RootConstrainSelectedInstOperands,
     /*  64586 */     // GIR_Coverage, 1083,
     /*  64586 */     GIR_EraseRootFromParent_Done,
     /*  64587 */   // Label 966: @64587
     /*  64587 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(64619), // Rule ID 1084 //
     /*  64592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractwm),
     /*  64600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64610 */     // (intrinsic_wo_chain:{ *:[i32] } 10403:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXTRACTWM:{ *:[i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTWM),
     /*  64613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64615 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64617 */     GIR_RootConstrainSelectedInstOperands,
     /*  64618 */     // GIR_Coverage, 1084,
     /*  64618 */     GIR_EraseRootFromParent_Done,
     /*  64619 */   // Label 967: @64619
     /*  64619 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(64651), // Rule ID 1085 //
     /*  64624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractdm),
     /*  64632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64642 */     // (intrinsic_wo_chain:{ *:[i32] } 10400:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTRACTDM:{ *:[i32] } v2i64:{ *:[v2i64] }:$VB)
     /*  64642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTDM),
     /*  64645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64647 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64649 */     GIR_RootConstrainSelectedInstOperands,
     /*  64650 */     // GIR_Coverage, 1085,
     /*  64650 */     GIR_EraseRootFromParent_Done,
     /*  64651 */   // Label 968: @64651
     /*  64651 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(64683), // Rule ID 1086 //
     /*  64656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextractqm),
     /*  64664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  64674 */     // (intrinsic_wo_chain:{ *:[i32] } 10402:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXTRACTQM:{ *:[i32] } v1i128:{ *:[v1i128] }:$VB)
     /*  64674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTRACTQM),
     /*  64677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64679 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64681 */     GIR_RootConstrainSelectedInstOperands,
     /*  64682 */     // GIR_Coverage, 1086,
     /*  64682 */     GIR_EraseRootFromParent_Done,
     /*  64683 */   // Label 969: @64683
     /*  64683 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(64715), // Rule ID 1087 //
     /*  64688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandbm),
     /*  64696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  64702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64706 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10385:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB)  =>  (VEXPANDBM:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /*  64706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDBM),
     /*  64709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64711 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64713 */     GIR_RootConstrainSelectedInstOperands,
     /*  64714 */     // GIR_Coverage, 1087,
     /*  64714 */     GIR_EraseRootFromParent_Done,
     /*  64715 */   // Label 970: @64715
     /*  64715 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(64747), // Rule ID 1088 //
     /*  64720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandhm),
     /*  64728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  64734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64738 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10387:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB)  =>  (VEXPANDHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /*  64738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDHM),
     /*  64741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64743 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64745 */     GIR_RootConstrainSelectedInstOperands,
     /*  64746 */     // GIR_Coverage, 1088,
     /*  64746 */     GIR_EraseRootFromParent_Done,
     /*  64747 */   // Label 971: @64747
     /*  64747 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(64779), // Rule ID 1089 //
     /*  64752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandwm),
     /*  64760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  64766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64770 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10389:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (VEXPANDWM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /*  64770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDWM),
     /*  64773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64775 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64777 */     GIR_RootConstrainSelectedInstOperands,
     /*  64778 */     // GIR_Coverage, 1089,
     /*  64778 */     GIR_EraseRootFromParent_Done,
     /*  64779 */   // Label 972: @64779
     /*  64779 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(64811), // Rule ID 1090 //
     /*  64784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpanddm),
     /*  64792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64802 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10386:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXPANDDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /*  64802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDDM),
     /*  64805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64807 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64809 */     GIR_RootConstrainSelectedInstOperands,
     /*  64810 */     // GIR_Coverage, 1090,
     /*  64810 */     GIR_EraseRootFromParent_Done,
     /*  64811 */   // Label 973: @64811
     /*  64811 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(64843), // Rule ID 1091 //
     /*  64816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vexpandqm),
     /*  64824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  64830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64834 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10388:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB)  =>  (VEXPANDQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VB)
     /*  64834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXPANDQM),
     /*  64837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64839 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64841 */     GIR_RootConstrainSelectedInstOperands,
     /*  64842 */     // GIR_Coverage, 1091,
     /*  64842 */     GIR_EraseRootFromParent_Done,
     /*  64843 */   // Label 974: @64843
     /*  64843 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(64875), // Rule ID 1092 //
     /*  64848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrbm),
     /*  64856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  64859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64866 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10283:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRBM:{ *:[v16i8] } i64:{ *:[i64] }:$VB)
     /*  64866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRBM),
     /*  64869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64871 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64873 */     GIR_RootConstrainSelectedInstOperands,
     /*  64874 */     // GIR_Coverage, 1092,
     /*  64874 */     GIR_EraseRootFromParent_Done,
     /*  64875 */   // Label 975: @64875
     /*  64875 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(64907), // Rule ID 1093 //
     /*  64880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrhm),
     /*  64888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64898 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10285:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRHM:{ *:[v8i16] } i64:{ *:[i64] }:$VB)
     /*  64898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRHM),
     /*  64901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64903 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64905 */     GIR_RootConstrainSelectedInstOperands,
     /*  64906 */     // GIR_Coverage, 1093,
     /*  64906 */     GIR_EraseRootFromParent_Done,
     /*  64907 */   // Label 976: @64907
     /*  64907 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(64939), // Rule ID 1094 //
     /*  64912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrwm),
     /*  64920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64930 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10287:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRWM:{ *:[v4i32] } i64:{ *:[i64] }:$VB)
     /*  64930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRWM),
     /*  64933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64935 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64937 */     GIR_RootConstrainSelectedInstOperands,
     /*  64938 */     // GIR_Coverage, 1094,
     /*  64938 */     GIR_EraseRootFromParent_Done,
     /*  64939 */   // Label 977: @64939
     /*  64939 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(64971), // Rule ID 1095 //
     /*  64944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrdm),
     /*  64952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  64955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64962 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10284:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRDM:{ *:[v2i64] } i64:{ *:[i64] }:$VB)
     /*  64962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRDM),
     /*  64965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64967 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  64969 */     GIR_RootConstrainSelectedInstOperands,
     /*  64970 */     // GIR_Coverage, 1095,
     /*  64970 */     GIR_EraseRootFromParent_Done,
     /*  64971 */   // Label 978: @64971
     /*  64971 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(65003), // Rule ID 1096 //
     /*  64976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  64979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mtvsrqm),
     /*  64984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  64987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  64990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  64994 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10286:{ *:[iPTR] }, i64:{ *:[i64] }:$VB)  =>  (MTVSRQM:{ *:[v1i128] } i64:{ *:[i64] }:$VB)
     /*  64994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSRQM),
     /*  64997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  64999 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  65001 */     GIR_RootConstrainSelectedInstOperands,
     /*  65002 */     // GIR_Coverage, 1096,
     /*  65002 */     GIR_EraseRootFromParent_Done,
     /*  65003 */   // Label 979: @65003
     /*  65003 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(65035), // Rule ID 1160 //
     /*  65008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  65011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextsd2q),
     /*  65016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  65019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65026 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10406:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB)  =>  (VEXTSD2Q:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VB)
     /*  65026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSD2Q),
     /*  65029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  65031 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  65033 */     GIR_RootConstrainSelectedInstOperands,
     /*  65034 */     // GIR_Coverage, 1160,
     /*  65034 */     GIR_EraseRootFromParent_Done,
     /*  65035 */   // Label 980: @65035
     /*  65035 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(65067), // Rule ID 1165 //
     /*  65040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  65043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmmr),
     /*  65048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  65051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  65054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  65058 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10677:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMMR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$AB)
     /*  65058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMMR),
     /*  65061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65063 */     GIR_RootToRootCopy, /*OpIdx*/2, // AB
     /*  65065 */     GIR_RootConstrainSelectedInstOperands,
     /*  65066 */     // GIR_Coverage, 1165,
     /*  65066 */     GIR_EraseRootFromParent_Done,
     /*  65067 */   // Label 981: @65067
     /*  65067 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(65099), // Rule ID 1170 //
     /*  65072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmfacc),
     /*  65080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65090 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10771:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$AT)  =>  (XXMFACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$AT)
     /*  65090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMFACC),
     /*  65093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATo]
     /*  65095 */     GIR_RootToRootCopy, /*OpIdx*/2, // AT
     /*  65097 */     GIR_RootConstrainSelectedInstOperands,
     /*  65098 */     // GIR_Coverage, 1170,
     /*  65098 */     GIR_EraseRootFromParent_Done,
     /*  65099 */   // Label 982: @65099
     /*  65099 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(65131), // Rule ID 1171 //
     /*  65104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  65107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xxmtacc),
     /*  65112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  65115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  65118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  65122 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10772:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi)  =>  (XXMTACC:{ *:[v512i1] } v512i1:{ *:[v512i1] }:$ATi)
     /*  65122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXMTACC),
     /*  65125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  65127 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  65129 */     GIR_RootConstrainSelectedInstOperands,
     /*  65130 */     // GIR_Coverage, 1171,
     /*  65130 */     GIR_EraseRootFromParent_Done,
     /*  65131 */   // Label 983: @65131
     /*  65131 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(65160), // Rule ID 1286 //
     /*  65136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fre),
     /*  65141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65151 */     // (intrinsic_wo_chain:{ *:[f64] } 10638:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FRE:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRE),
     /*  65154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65156 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65158 */     GIR_RootConstrainSelectedInstOperands,
     /*  65159 */     // GIR_Coverage, 1286,
     /*  65159 */     GIR_EraseRootFromParent_Done,
     /*  65160 */   // Label 984: @65160
     /*  65160 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(65189), // Rule ID 1287 //
     /*  65165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fres),
     /*  65170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65180 */     // (intrinsic_wo_chain:{ *:[f32] } 10639:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FRES:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FRES),
     /*  65183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65185 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65187 */     GIR_RootConstrainSelectedInstOperands,
     /*  65188 */     // GIR_Coverage, 1287,
     /*  65188 */     GIR_EraseRootFromParent_Done,
     /*  65189 */   // Label 985: @65189
     /*  65189 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(65218), // Rule ID 1288 //
     /*  65194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabs),
     /*  65199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65209 */     // (intrinsic_wo_chain:{ *:[f64] } 10633:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FNABSD:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /*  65212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65214 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65216 */     GIR_RootConstrainSelectedInstOperands,
     /*  65217 */     // GIR_Coverage, 1288,
     /*  65217 */     GIR_EraseRootFromParent_Done,
     /*  65218 */   // Label 986: @65218
     /*  65218 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(65247), // Rule ID 1289 //
     /*  65223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnabss),
     /*  65228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  65238 */     // (intrinsic_wo_chain:{ *:[f32] } 10634:{ *:[iPTR] }, f32:{ *:[f32] }:$A)  =>  (FNABSS:{ *:[f32] } ?:{ *:[f32] }:$A)
     /*  65238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /*  65241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65243 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65245 */     GIR_RootConstrainSelectedInstOperands,
     /*  65246 */     // GIR_Coverage, 1289,
     /*  65246 */     GIR_EraseRootFromParent_Done,
     /*  65247 */   // Label 987: @65247
     /*  65247 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(65322), // Rule ID 3364 //
     /*  65252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvspbf16),
     /*  65260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65270 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10873:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVSPBF16:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65286 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVSPBF16),
     /*  65298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65303 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65321 */     // GIR_Coverage, 3364,
     /*  65321 */     GIR_EraseRootFromParent_Done,
     /*  65322 */   // Label 988: @65322
     /*  65322 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(65397), // Rule ID 3365 //
     /*  65327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /*  65330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcvbf16spn),
     /*  65335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65345 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10868:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XVCVBF16SPN:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /*  65345 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  65348 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65352 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65357 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  65361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVCVBF16SPN),
     /*  65373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  65381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  65396 */     // GIR_Coverage, 3365,
     /*  65396 */     GIR_EraseRootFromParent_Done,
     /*  65397 */   // Label 989: @65397
     /*  65397 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(65426), // Rule ID 4898 //
     /*  65402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfid),
     /*  65407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65417 */     // (intrinsic_wo_chain:{ *:[f64] } 10620:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVSXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSXDDP),
     /*  65420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65422 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65424 */     GIR_RootConstrainSelectedInstOperands,
     /*  65425 */     // GIR_Coverage, 4898,
     /*  65425 */     GIR_EraseRootFromParent_Done,
     /*  65426 */   // Label 990: @65426
     /*  65426 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(65455), // Rule ID 4899 //
     /*  65431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fcfud),
     /*  65436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65446 */     // (intrinsic_wo_chain:{ *:[f64] } 10621:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVUXDDP:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUXDDP),
     /*  65449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65451 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65453 */     GIR_RootConstrainSelectedInstOperands,
     /*  65454 */     // GIR_Coverage, 4899,
     /*  65454 */     GIR_EraseRootFromParent_Done,
     /*  65455 */   // Label 991: @65455
     /*  65455 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(65484), // Rule ID 4900 //
     /*  65460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctid),
     /*  65465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65475 */     // (intrinsic_wo_chain:{ *:[f64] } 10622:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTID:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /*  65478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65480 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65482 */     GIR_RootConstrainSelectedInstOperands,
     /*  65483 */     // GIR_Coverage, 4900,
     /*  65483 */     GIR_EraseRootFromParent_Done,
     /*  65484 */   // Label 992: @65484
     /*  65484 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(65513), // Rule ID 4901 //
     /*  65489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctidz),
     /*  65494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65504 */     // (intrinsic_wo_chain:{ *:[f64] } 10623:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXDS),
     /*  65507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65509 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65511 */     GIR_RootConstrainSelectedInstOperands,
     /*  65512 */     // GIR_Coverage, 4901,
     /*  65512 */     GIR_EraseRootFromParent_Done,
     /*  65513 */   // Label 993: @65513
     /*  65513 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(65542), // Rule ID 4902 //
     /*  65518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiw),
     /*  65523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  65533 */     // (intrinsic_wo_chain:{ *:[f64] } 10624:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (FCTIW:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /*  65536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  65538 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65540 */     GIR_RootConstrainSelectedInstOperands,
     /*  65541 */     // GIR_Coverage, 4902,
     /*  65541 */     GIR_EraseRootFromParent_Done,
     /*  65542 */   // Label 994: @65542
     /*  65542 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(65571), // Rule ID 4903 //
     /*  65547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctiwz),
     /*  65552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65562 */     // (intrinsic_wo_chain:{ *:[f64] } 10625:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPSXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPSXWS),
     /*  65565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65567 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65569 */     GIR_RootConstrainSelectedInstOperands,
     /*  65570 */     // GIR_Coverage, 4903,
     /*  65570 */     GIR_EraseRootFromParent_Done,
     /*  65571 */   // Label 995: @65571
     /*  65571 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(65600), // Rule ID 4904 //
     /*  65576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctudz),
     /*  65581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65591 */     // (intrinsic_wo_chain:{ *:[f64] } 10626:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXDS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXDS),
     /*  65594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65596 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65598 */     GIR_RootConstrainSelectedInstOperands,
     /*  65599 */     // GIR_Coverage, 4904,
     /*  65599 */     GIR_EraseRootFromParent_Done,
     /*  65600 */   // Label 996: @65600
     /*  65600 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(65629), // Rule ID 4905 //
     /*  65605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fctuwz),
     /*  65610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65620 */     // (intrinsic_wo_chain:{ *:[f64] } 10627:{ *:[iPTR] }, f64:{ *:[f64] }:$A)  =>  (XSCVDPUXWS:{ *:[f64] } ?:{ *:[f64] }:$A)
     /*  65620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPUXWS),
     /*  65623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65625 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  65627 */     GIR_RootConstrainSelectedInstOperands,
     /*  65628 */     // GIR_Coverage, 4905,
     /*  65628 */     GIR_EraseRootFromParent_Done,
     /*  65629 */   // Label 997: @65629
     /*  65629 */   GIM_Reject,
     /*  65630 */ // Label 889: @65630
     /*  65630 */ GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(74423),
     /*  65635 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  65638 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(65709), // Rule ID 2174 //
     /*  65643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxextractuw),
     /*  65651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  65660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  65668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65672 */     // MIs[1] Operand 1
     /*  65672 */     // No operand predicates
     /*  65672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  65674 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10912:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXEXTRACTUW:{ *:[f64] } ?:{ *:[v2i64] }:$A, (imm:{ *:[i32] }):$IMM), VSRC:{ *:[i32] })
     /*  65674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  65677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXEXTRACTUW),
     /*  65681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  65690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  65693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  65695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  65698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65703 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65708 */     // GIR_Coverage, 2174,
     /*  65708 */     GIR_EraseRootFromParent_Done,
     /*  65709 */   // Label 999: @65709
     /*  65709 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(65746), // Rule ID 1033 //
     /*  65714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcsp),
     /*  65722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65732 */     // MIs[0] DCMX
     /*  65732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10902:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCSP:{ *:[v4i32] } (timm:{ *:[i32] }):$DCMX, v4f32:{ *:[v4f32] }:$XB)
     /*  65735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCSP),
     /*  65738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65740 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65742 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65744 */     GIR_RootConstrainSelectedInstOperands,
     /*  65745 */     // GIR_Coverage, 1033,
     /*  65745 */     GIR_EraseRootFromParent_Done,
     /*  65746 */   // Label 1000: @65746
     /*  65746 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(65783), // Rule ID 1034 //
     /*  65751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  65754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtstdcdp),
     /*  65759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65769 */     // MIs[0] DCMX
     /*  65769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  65772 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10901:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XB, (timm:{ *:[i32] }):$DCMX)  =>  (XVTSTDCDP:{ *:[v2i64] } (timm:{ *:[i32] }):$DCMX, v2f64:{ *:[v2f64] }:$XB)
     /*  65772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVTSTDCDP),
     /*  65775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65777 */     GIR_RootToRootCopy, /*OpIdx*/3, // DCMX
     /*  65779 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /*  65781 */     GIR_RootConstrainSelectedInstOperands,
     /*  65782 */     // GIR_Coverage, 1034,
     /*  65782 */     GIR_EraseRootFromParent_Done,
     /*  65783 */   // Label 1001: @65783
     /*  65783 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(65828), // Rule ID 902 //
     /*  65788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmaxdp),
     /*  65796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65817 */     // (intrinsic_wo_chain:{ *:[f64] } 10854:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMAXDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /*  65820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65822 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65824 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65826 */     GIR_RootConstrainSelectedInstOperands,
     /*  65827 */     // GIR_Coverage, 902,
     /*  65827 */     GIR_EraseRootFromParent_Done,
     /*  65828 */   // Label 1002: @65828
     /*  65828 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(65873), // Rule ID 903 //
     /*  65833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xsmindp),
     /*  65841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  65844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  65847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  65850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  65862 */     // (intrinsic_wo_chain:{ *:[f64] } 10855:{ *:[iPTR] }, vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)  =>  (XSMINDP:{ *:[f64] } vsfrc:{ *:[f64] }:$XA, vsfrc:{ *:[f64] }:$XB)
     /*  65862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /*  65865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65867 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65869 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65871 */     GIR_RootConstrainSelectedInstOperands,
     /*  65872 */     // GIR_Coverage, 903,
     /*  65872 */     GIR_EraseRootFromParent_Done,
     /*  65873 */   // Label 1003: @65873
     /*  65873 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(65918), // Rule ID 904 //
     /*  65878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxdp),
     /*  65886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65907 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10886:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMAXDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /*  65910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65912 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65914 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65916 */     GIR_RootConstrainSelectedInstOperands,
     /*  65917 */     // GIR_Coverage, 904,
     /*  65917 */     GIR_EraseRootFromParent_Done,
     /*  65918 */   // Label 1004: @65918
     /*  65918 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(65963), // Rule ID 905 //
     /*  65923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmindp),
     /*  65931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  65934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  65940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65952 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10888:{ *:[iPTR] }, vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)  =>  (XVMINDP:{ *:[v2f64] } vsrc:{ *:[v2f64] }:$XA, vsrc:{ *:[v2f64] }:$XB)
     /*  65952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /*  65955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  65957 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  65959 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  65961 */     GIR_RootConstrainSelectedInstOperands,
     /*  65962 */     // GIR_Coverage, 905,
     /*  65962 */     GIR_EraseRootFromParent_Done,
     /*  65963 */   // Label 1005: @65963
     /*  65963 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(66008), // Rule ID 906 //
     /*  65968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  65971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvmaxsp),
     /*  65976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  65997 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10887:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMAXSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  65997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /*  66000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66002 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66004 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66006 */     GIR_RootConstrainSelectedInstOperands,
     /*  66007 */     // GIR_Coverage, 906,
     /*  66007 */     GIR_EraseRootFromParent_Done,
     /*  66008 */   // Label 1006: @66008
     /*  66008 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(66053), // Rule ID 907 //
     /*  66013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvminsp),
     /*  66021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66042 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10889:{ *:[iPTR] }, vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)  =>  (XVMINSP:{ *:[v4f32] } vsrc:{ *:[v4f32] }:$XA, vsrc:{ *:[v4f32] }:$XB)
     /*  66042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /*  66045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66047 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66049 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66051 */     GIR_RootConstrainSelectedInstOperands,
     /*  66052 */     // GIR_Coverage, 907,
     /*  66052 */     GIR_EraseRootFromParent_Done,
     /*  66053 */   // Label 1007: @66053
     /*  66053 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(66090), // Rule ID 831 //
     /*  66058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqdp),
     /*  66066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66079 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10856:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPEQDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQDP),
     /*  66082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66084 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66086 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66088 */     GIR_RootConstrainSelectedInstOperands,
     /*  66089 */     // GIR_Coverage, 831,
     /*  66089 */     GIR_EraseRootFromParent_Done,
     /*  66090 */   // Label 1008: @66090
     /*  66090 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(66127), // Rule ID 833 //
     /*  66095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpeqsp),
     /*  66103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66116 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10858:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPEQSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPEQSP),
     /*  66119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66121 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66123 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66125 */     GIR_RootConstrainSelectedInstOperands,
     /*  66126 */     // GIR_Coverage, 833,
     /*  66126 */     GIR_EraseRootFromParent_Done,
     /*  66127 */   // Label 1009: @66127
     /*  66127 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(66164), // Rule ID 835 //
     /*  66132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgedp),
     /*  66140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66153 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10860:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGEDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGEDP),
     /*  66156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66158 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66160 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66162 */     GIR_RootConstrainSelectedInstOperands,
     /*  66163 */     // GIR_Coverage, 835,
     /*  66163 */     GIR_EraseRootFromParent_Done,
     /*  66164 */   // Label 1010: @66164
     /*  66164 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(66201), // Rule ID 837 //
     /*  66169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgesp),
     /*  66177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66190 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10862:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGESP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGESP),
     /*  66193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66195 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66197 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66199 */     GIR_RootConstrainSelectedInstOperands,
     /*  66200 */     // GIR_Coverage, 837,
     /*  66200 */     GIR_EraseRootFromParent_Done,
     /*  66201 */   // Label 1011: @66201
     /*  66201 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(66238), // Rule ID 839 //
     /*  66206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtdp),
     /*  66214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66227 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10864:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVCMPGTDP:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /*  66227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTDP),
     /*  66230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66232 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66234 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66236 */     GIR_RootConstrainSelectedInstOperands,
     /*  66237 */     // GIR_Coverage, 839,
     /*  66237 */     GIR_EraseRootFromParent_Done,
     /*  66238 */   // Label 1012: @66238
     /*  66238 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(66275), // Rule ID 841 //
     /*  66243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvcmpgtsp),
     /*  66251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10866:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVCMPGTSP:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /*  66264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCMPGTSP),
     /*  66267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66269 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66271 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66273 */     GIR_RootConstrainSelectedInstOperands,
     /*  66274 */     // GIR_Coverage, 841,
     /*  66274 */     GIR_EraseRootFromParent_Done,
     /*  66275 */   // Label 1013: @66275
     /*  66275 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(66312), // Rule ID 1005 //
     /*  66280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addf128_round_to_odd),
     /*  66288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66301 */     // (intrinsic_wo_chain:{ *:[f128] } 10252:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSADDQPO),
     /*  66304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66306 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66308 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66310 */     GIR_RootConstrainSelectedInstOperands,
     /*  66311 */     // GIR_Coverage, 1005,
     /*  66311 */     GIR_EraseRootFromParent_Done,
     /*  66312 */   // Label 1014: @66312
     /*  66312 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(66349), // Rule ID 1006 //
     /*  66317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulf128_round_to_odd),
     /*  66325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66338 */     // (intrinsic_wo_chain:{ *:[f128] } 10780:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMULQPO),
     /*  66341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66343 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66345 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66347 */     GIR_RootConstrainSelectedInstOperands,
     /*  66348 */     // GIR_Coverage, 1006,
     /*  66348 */     GIR_EraseRootFromParent_Done,
     /*  66349 */   // Label 1015: @66349
     /*  66349 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(66386), // Rule ID 1007 //
     /*  66354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_subf128_round_to_odd),
     /*  66362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66375 */     // (intrinsic_wo_chain:{ *:[f128] } 10814:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSSUBQPO),
     /*  66378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66380 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66382 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66384 */     GIR_RootConstrainSelectedInstOperands,
     /*  66385 */     // GIR_Coverage, 1007,
     /*  66385 */     GIR_EraseRootFromParent_Done,
     /*  66386 */   // Label 1016: @66386
     /*  66386 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(66423), // Rule ID 1008 //
     /*  66391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divf128_round_to_odd),
     /*  66399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  66408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66412 */     // (intrinsic_wo_chain:{ *:[f128] } 10614:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQPO:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  66412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSDIVQPO),
     /*  66415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  66417 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  66419 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  66421 */     GIR_RootConstrainSelectedInstOperands,
     /*  66422 */     // GIR_Coverage, 1008,
     /*  66422 */     GIR_EraseRootFromParent_Done,
     /*  66423 */   // Label 1017: @66423
     /*  66423 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(66460), // Rule ID 1027 //
     /*  66428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpdp),
     /*  66436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66449 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10884:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)  =>  (XVIEXPDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB)
     /*  66449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPDP),
     /*  66452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66454 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66456 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66458 */     GIR_RootConstrainSelectedInstOperands,
     /*  66459 */     // GIR_Coverage, 1027,
     /*  66459 */     GIR_EraseRootFromParent_Done,
     /*  66460 */   // Label 1018: @66460
     /*  66460 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(66497), // Rule ID 1028 //
     /*  66465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xviexpsp),
     /*  66473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66486 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10885:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)  =>  (XVIEXPSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XA, v4i32:{ *:[v4i32] }:$XB)
     /*  66486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVIEXPSP),
     /*  66489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66491 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  66493 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  66495 */     GIR_RootConstrainSelectedInstOperands,
     /*  66496 */     // GIR_Coverage, 1028,
     /*  66496 */     GIR_EraseRootFromParent_Done,
     /*  66497 */   // Label 1019: @66497
     /*  66497 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(66534), // Rule ID 1659 //
     /*  66502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivsp),
     /*  66510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66523 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10883:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (XVDIVSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B)
     /*  66523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /*  66526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66528 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66530 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66532 */     GIR_RootConstrainSelectedInstOperands,
     /*  66533 */     // GIR_Coverage, 1659,
     /*  66533 */     GIR_EraseRootFromParent_Done,
     /*  66534 */   // Label 1020: @66534
     /*  66534 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(66571), // Rule ID 1660 //
     /*  66539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvdivdp),
     /*  66547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  66550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66560 */     // (intrinsic_wo_chain:{ *:[v2f64] } 10882:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (XVDIVDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B)
     /*  66560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /*  66563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66565 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66567 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66569 */     GIR_RootConstrainSelectedInstOperands,
     /*  66570 */     // GIR_Coverage, 1660,
     /*  66570 */     GIR_EraseRootFromParent_Done,
     /*  66571 */   // Label 1021: @66571
     /*  66571 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(66633), // Rule ID 1661 //
     /*  66576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivdp),
     /*  66584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  66593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66597 */     // (intrinsic_wo_chain:{ *:[i32] } 10896:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$A, v2f64:{ *:[v2f64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVDP:{ *:[i32] } ?:{ *:[v2f64] }:$A, ?:{ *:[v2f64] }:$B), GPRC:{ *:[i32] })
     /*  66597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVDP),
     /*  66604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66609 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66613 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66632 */     // GIR_Coverage, 1661,
     /*  66632 */     GIR_EraseRootFromParent_Done,
     /*  66633 */   // Label 1022: @66633
     /*  66633 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(66695), // Rule ID 1662 //
     /*  66638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  66641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtdivsp),
     /*  66646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66659 */     // (intrinsic_wo_chain:{ *:[i32] } 10897:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (XVTDIVSP:{ *:[i32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B), GPRC:{ *:[i32] })
     /*  66659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTDIVSP),
     /*  66666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66671 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66675 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  66694 */     // GIR_Coverage, 1662,
     /*  66694 */     GIR_EraseRootFromParent_Done,
     /*  66695 */   // Label 1023: @66695
     /*  66695 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(66732), // Rule ID 1906 //
     /*  66700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxleqv),
     /*  66708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66721 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10918:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B)  =>  (XXLEQV:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B)
     /*  66721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXLEQV),
     /*  66724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  66726 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  66728 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  66730 */     GIR_RootConstrainSelectedInstOperands,
     /*  66731 */     // GIR_Coverage, 1906,
     /*  66731 */     GIR_EraseRootFromParent_Done,
     /*  66732 */   // Label 1024: @66732
     /*  66732 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(66814), // Rule ID 1944 //
     /*  66737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  66740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_insert_exp),
     /*  66745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  66748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  66751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66758 */     // (intrinsic_wo_chain:{ *:[f64] } 10649:{ *:[iPTR] }, f64:{ *:[f64] }:$A, i64:{ *:[i64] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f64] } (XSIEXPDP:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[i64] } ?:{ *:[f64] }:$A, G8RC:{ *:[i32] }), ?:{ *:[i64] }:$B), F8RC:{ *:[i32] })
     /*  66758 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  66761 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66765 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66770 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  66774 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  66779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSIEXPDP),
     /*  66786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66791 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  66798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66808 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /*  66813 */     // GIR_Coverage, 1944,
     /*  66813 */     GIR_EraseRootFromParent_Done,
     /*  66814 */   // Label 1025: @66814
     /*  66814 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(66870), // Rule ID 2171 //
     /*  66819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  66822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_scalar_insert_exp_qp),
     /*  66827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  66830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  66833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  66836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  66840 */     // (intrinsic_wo_chain:{ *:[f128] } 10797:{ *:[iPTR] }, f128:{ *:[f128] }:$vA, i64:{ *:[i64] }:$vB)  =>  (XSIEXPQP:{ *:[f128] } ?:{ *:[f128] }:$vA, (MTVSRD:{ *:[f64] } ?:{ *:[i64] }:$vB))
     /*  66840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  66843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRD),
     /*  66847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vB
     /*  66856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSIEXPQP),
     /*  66861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  66863 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  66865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66868 */     GIR_RootConstrainSelectedInstOperands,
     /*  66869 */     // GIR_Coverage, 2171,
     /*  66869 */     GIR_EraseRootFromParent_Done,
     /*  66870 */   // Label 1026: @66870
     /*  66870 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(66961), // Rule ID 3354 //
     /*  66875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  66900 */     // (intrinsic_wo_chain:{ *:[i32] } 10898:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 1:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_lt:{ *:[i32] })
     /*  66900 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66903 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66907 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66912 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  66916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  66921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  66924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  66928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  66936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  66938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66943 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  66950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  66960 */     // GIR_Coverage, 3354,
     /*  66960 */     GIR_EraseRootFromParent_Done,
     /*  66961 */   // Label 1027: @66961
     /*  66961 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(67052), // Rule ID 3355 //
     /*  66966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  66969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xvtlsbb),
     /*  66974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  66977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  66983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  66987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  66991 */     // (intrinsic_wo_chain:{ *:[i32] } 10898:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XB, 0:{ *:[i32] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (XVTLSBB:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] })), sub_eq:{ *:[i32] })
     /*  66991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  66994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  66998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // XB
     /*  67007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  67012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  67015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XVTLSBB),
     /*  67019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  67027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67034 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  67041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  67046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  67051 */     // GIR_Coverage, 3355,
     /*  67051 */     GIR_EraseRootFromParent_Done,
     /*  67052 */   // Label 1028: @67052
     /*  67052 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(67095), // Rule ID 317 //
     /*  67057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67075 */     // MIs[0] Operand 3
     /*  67075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67086 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10314:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFSX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /*  67089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67091 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67093 */     GIR_RootConstrainSelectedInstOperands,
     /*  67094 */     // GIR_Coverage, 317,
     /*  67094 */     GIR_EraseRootFromParent_Done,
     /*  67095 */   // Label 1029: @67095
     /*  67095 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(67138), // Rule ID 318 //
     /*  67100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67118 */     // MIs[0] Operand 3
     /*  67118 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10376:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTUXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /*  67132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67134 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67136 */     GIR_RootConstrainSelectedInstOperands,
     /*  67137 */     // GIR_Coverage, 318,
     /*  67137 */     GIR_EraseRootFromParent_Done,
     /*  67138 */   // Label 1030: @67138
     /*  67138 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(67181), // Rule ID 319 //
     /*  67143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67161 */     // MIs[0] Operand 3
     /*  67161 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67172 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10316:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, 0:{ *:[i32] })  =>  (VCFUX_0:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$VB)
     /*  67172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /*  67175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67177 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67179 */     GIR_RootConstrainSelectedInstOperands,
     /*  67180 */     // GIR_Coverage, 319,
     /*  67180 */     GIR_EraseRootFromParent_Done,
     /*  67181 */   // Label 1031: @67181
     /*  67181 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(67224), // Rule ID 320 //
     /*  67186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67204 */     // MIs[0] Operand 3
     /*  67204 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /*  67215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10375:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, 0:{ *:[i32] })  =>  (VCTSXS_0:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$VB)
     /*  67215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /*  67218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67220 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67222 */     GIR_RootConstrainSelectedInstOperands,
     /*  67223 */     // GIR_Coverage, 320,
     /*  67223 */     GIR_EraseRootFromParent_Done,
     /*  67224 */   // Label 1032: @67224
     /*  67224 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(67295), // Rule ID 3350 //
     /*  67229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvbm),
     /*  67237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67258 */     // MIs[1] Operand 1
     /*  67258 */     // No operand predicates
     /*  67258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67260 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10913:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXGENPCVBM:{ *:[v4i32] } ?:{ *:[v16i8] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVBM),
     /*  67267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67294 */     // GIR_Coverage, 3350,
     /*  67294 */     GIR_EraseRootFromParent_Done,
     /*  67295 */   // Label 1033: @67295
     /*  67295 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(67366), // Rule ID 3351 //
     /*  67300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvhm),
     /*  67308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67329 */     // MIs[1] Operand 1
     /*  67329 */     // No operand predicates
     /*  67329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67331 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10915:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXGENPCVHM:{ *:[v4i32] } ?:{ *:[v8i16] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVHM),
     /*  67338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67343 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67365 */     // GIR_Coverage, 3351,
     /*  67365 */     GIR_EraseRootFromParent_Done,
     /*  67366 */   // Label 1034: @67366
     /*  67366 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(67437), // Rule ID 3352 //
     /*  67371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvwm),
     /*  67379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67400 */     // MIs[1] Operand 1
     /*  67400 */     // No operand predicates
     /*  67400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67402 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10916:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (XXGENPCVWM:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVWM),
     /*  67409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67436 */     // GIR_Coverage, 3352,
     /*  67436 */     GIR_EraseRootFromParent_Done,
     /*  67437 */   // Label 1035: @67437
     /*  67437 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(67508), // Rule ID 3353 //
     /*  67442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxgenpcvdm),
     /*  67450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  67453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  67459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  67467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67471 */     // MIs[1] Operand 1
     /*  67471 */     // No operand predicates
     /*  67471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  67473 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10914:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (XXGENPCVDM:{ *:[v4i32] } ?:{ *:[v2i64] }:$VRB, (imm:{ *:[i32] }):$IMM), VRRC:{ *:[i32] })
     /*  67473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXGENPCVDM),
     /*  67480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /*  67489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // IMM
     /*  67492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  67494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  67497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67502 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67507 */     // GIR_Coverage, 3353,
     /*  67507 */     GIR_EraseRootFromParent_Done,
     /*  67508 */   // Label 1036: @67508
     /*  67508 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(67545), // Rule ID 313 //
     /*  67513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfsx),
     /*  67521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67531 */     // MIs[0] VA
     /*  67531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67534 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10314:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFSX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFSX),
     /*  67537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67539 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67541 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67543 */     GIR_RootConstrainSelectedInstOperands,
     /*  67544 */     // GIR_Coverage, 313,
     /*  67544 */     GIR_EraseRootFromParent_Done,
     /*  67545 */   // Label 1037: @67545
     /*  67545 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(67582), // Rule ID 314 //
     /*  67550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfux),
     /*  67558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67568 */     // MIs[0] VA
     /*  67568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67571 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10316:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCFUX:{ *:[v4f32] } (timm:{ *:[i32] }):$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  67571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUX),
     /*  67574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67576 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67578 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67580 */     GIR_RootConstrainSelectedInstOperands,
     /*  67581 */     // GIR_Coverage, 314,
     /*  67581 */     GIR_EraseRootFromParent_Done,
     /*  67582 */   // Label 1038: @67582
     /*  67582 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(67619), // Rule ID 315 //
     /*  67587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctsxs),
     /*  67595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67605 */     // MIs[0] VA
     /*  67605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67608 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10375:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTSXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTSXS),
     /*  67611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67613 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67615 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67617 */     GIR_RootConstrainSelectedInstOperands,
     /*  67618 */     // GIR_Coverage, 315,
     /*  67618 */     GIR_EraseRootFromParent_Done,
     /*  67619 */   // Label 1039: @67619
     /*  67619 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(67656), // Rule ID 316 //
     /*  67624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  67627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctuxs),
     /*  67632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67642 */     // MIs[0] VA
     /*  67642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67645 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10376:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VCTUXS:{ *:[v4i32] } (timm:{ *:[i32] }):$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  67645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTUXS),
     /*  67648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67650 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  67652 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67654 */     GIR_RootConstrainSelectedInstOperands,
     /*  67655 */     // GIR_Coverage, 316,
     /*  67655 */     GIR_EraseRootFromParent_Done,
     /*  67656 */   // Label 1040: @67656
     /*  67656 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(67696), // Rule ID 553 //
     /*  67661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  67664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_national2packed),
     /*  67669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67679 */     // MIs[0] PS
     /*  67679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67682 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10785:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)  =>  (BCDCFN_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)
     /*  67682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCFN_rec),
     /*  67685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67687 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67689 */     GIR_RootToRootCopy, /*OpIdx*/3, // PS
     /*  67691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  67694 */     GIR_RootConstrainSelectedInstOperands,
     /*  67695 */     // GIR_Coverage, 553,
     /*  67695 */     GIR_EraseRootFromParent_Done,
     /*  67696 */   // Label 1041: @67696
     /*  67696 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(67736), // Rule ID 554 //
     /*  67701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  67704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_zoned2packed),
     /*  67709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67719 */     // MIs[0] PS
     /*  67719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67722 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10920:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)  =>  (BCDCFZ_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)
     /*  67722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCFZ_rec),
     /*  67725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67727 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67729 */     GIR_RootToRootCopy, /*OpIdx*/3, // PS
     /*  67731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  67734 */     GIR_RootConstrainSelectedInstOperands,
     /*  67735 */     // GIR_Coverage, 554,
     /*  67735 */     GIR_EraseRootFromParent_Done,
     /*  67736 */   // Label 1042: @67736
     /*  67736 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(67776), // Rule ID 556 //
     /*  67741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  67744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_packed2zoned),
     /*  67749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  67759 */     // MIs[0] PS
     /*  67759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67762 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10788:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)  =>  (BCDCTZ_rec:{ *:[v16i8] }:{ *:[i32] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$PS)
     /*  67762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDCTZ_rec),
     /*  67765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  67767 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67769 */     GIR_RootToRootCopy, /*OpIdx*/3, // PS
     /*  67771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  67774 */     GIR_RootConstrainSelectedInstOperands,
     /*  67775 */     // GIR_Coverage, 556,
     /*  67775 */     GIR_EraseRootFromParent_Done,
     /*  67776 */   // Label 1043: @67776
     /*  67776 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(67813), // Rule ID 1098 //
     /*  67781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbb),
     /*  67789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67799 */     // MIs[0] MP
     /*  67799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67802 */     // (intrinsic_wo_chain:{ *:[i64] } 10371:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBB:{ *:[i64] } v16i8:{ *:[v16i8] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBB),
     /*  67805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67807 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67809 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67811 */     GIR_RootConstrainSelectedInstOperands,
     /*  67812 */     // GIR_Coverage, 1098,
     /*  67812 */     GIR_EraseRootFromParent_Done,
     /*  67813 */   // Label 1044: @67813
     /*  67813 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(67850), // Rule ID 1099 //
     /*  67818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbh),
     /*  67826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67836 */     // MIs[0] MP
     /*  67836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67839 */     // (intrinsic_wo_chain:{ *:[i64] } 10373:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBH:{ *:[i64] } v8i16:{ *:[v8i16] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBH),
     /*  67842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67844 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67846 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67848 */     GIR_RootConstrainSelectedInstOperands,
     /*  67849 */     // GIR_Coverage, 1099,
     /*  67849 */     GIR_EraseRootFromParent_Done,
     /*  67850 */   // Label 1045: @67850
     /*  67850 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(67887), // Rule ID 1100 //
     /*  67855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbw),
     /*  67863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67873 */     // MIs[0] MP
     /*  67873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67876 */     // (intrinsic_wo_chain:{ *:[i64] } 10374:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBW:{ *:[i64] } v4i32:{ *:[v4i32] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBW),
     /*  67879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67881 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67883 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67885 */     GIR_RootConstrainSelectedInstOperands,
     /*  67886 */     // GIR_Coverage, 1100,
     /*  67886 */     GIR_EraseRootFromParent_Done,
     /*  67887 */   // Label 1046: @67887
     /*  67887 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(67924), // Rule ID 1101 //
     /*  67892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcntmbd),
     /*  67900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67910 */     // MIs[0] MP
     /*  67910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67913 */     // (intrinsic_wo_chain:{ *:[i64] } 10372:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)  =>  (VCNTMBD:{ *:[i64] } v2i64:{ *:[v2i64] }:$VB, (timm:{ *:[i32] }):$MP)
     /*  67913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCNTMBD),
     /*  67916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67918 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67920 */     GIR_RootToRootCopy, /*OpIdx*/3, // MP
     /*  67922 */     GIR_RootConstrainSelectedInstOperands,
     /*  67923 */     // GIR_Coverage, 1101,
     /*  67923 */     GIR_EraseRootFromParent_Done,
     /*  67924 */   // Label 1047: @67924
     /*  67924 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(67961), // Rule ID 1115 //
     /*  67929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  67932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vgnb),
     /*  67937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  67940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  67943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  67947 */     // MIs[0] N
     /*  67947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67950 */     // (intrinsic_wo_chain:{ *:[i64] } 10411:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)  =>  (VGNB:{ *:[i64] } v1i128:{ *:[v1i128] }:$VB, (timm:{ *:[i32] }):$N)
     /*  67950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VGNB),
     /*  67953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RD]
     /*  67955 */     GIR_RootToRootCopy, /*OpIdx*/2, // VB
     /*  67957 */     GIR_RootToRootCopy, /*OpIdx*/3, // N
     /*  67959 */     GIR_RootConstrainSelectedInstOperands,
     /*  67960 */     // GIR_Coverage, 1115,
     /*  67960 */     GIR_EraseRootFromParent_Done,
     /*  67961 */   // Label 1048: @67961
     /*  67961 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(67998), // Rule ID 1169 //
     /*  67966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  67969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsha3hash),
     /*  67974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2048s1,
     /*  67977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2048s1,
     /*  67980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRpRCRegClassID),
     /*  67984 */     // MIs[0] SR
     /*  67984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  67987 */     // (intrinsic_wo_chain:{ *:[v2048i1] } 10680:{ *:[iPTR] }, v2048i1:{ *:[v2048i1] }:$ATpi, (timm:{ *:[i32] }):$SR)  =>  (DMSHA3HASH:{ *:[v2048i1] } v2048i1:{ *:[v2048i1] }:$ATpi, (timm:{ *:[i32] }):$SR)
     /*  67987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSHA3HASH),
     /*  67990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[ATp]
     /*  67992 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATpi
     /*  67994 */     GIR_RootToRootCopy, /*OpIdx*/3, // SR
     /*  67996 */     GIR_RootConstrainSelectedInstOperands,
     /*  67997 */     // GIR_Coverage, 1169,
     /*  67997 */     GIR_EraseRootFromParent_Done,
     /*  67998 */   // Label 1049: @67998
     /*  67998 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(68043), // Rule ID 204 //
     /*  68003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divwe),
     /*  68011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68032 */     // (intrinsic_wo_chain:{ *:[i32] } 10615:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWE:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  68032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWE),
     /*  68035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68037 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68039 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68041 */     GIR_RootConstrainSelectedInstOperands,
     /*  68042 */     // GIR_Coverage, 204,
     /*  68042 */     GIR_EraseRootFromParent_Done,
     /*  68043 */   // Label 1050: @68043
     /*  68043 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(68088), // Rule ID 205 //
     /*  68048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divweu),
     /*  68056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68077 */     // (intrinsic_wo_chain:{ *:[i32] } 10616:{ *:[iPTR] }, gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)  =>  (DIVWEU:{ *:[i32] } gprc:{ *:[i32] }:$RA, gprc:{ *:[i32] }:$RB)
     /*  68077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVWEU),
     /*  68080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68082 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68084 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68086 */     GIR_RootConstrainSelectedInstOperands,
     /*  68087 */     // GIR_Coverage, 205,
     /*  68087 */     GIR_EraseRootFromParent_Done,
     /*  68088 */   // Label 1051: @68088
     /*  68088 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(68133), // Rule ID 690 //
     /*  68093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasBPERMD),
     /*  68096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bpermd),
     /*  68101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68122 */     // (intrinsic_wo_chain:{ *:[i64] } 10574:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)  =>  (BPERMD:{ *:[i64] } g8rc:{ *:[i64] }:$RST, g8rc:{ *:[i64] }:$RB)
     /*  68122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BPERMD),
     /*  68125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68127 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  68129 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68131 */     GIR_RootConstrainSelectedInstOperands,
     /*  68132 */     // GIR_Coverage, 690,
     /*  68132 */     GIR_EraseRootFromParent_Done,
     /*  68133 */   // Label 1052: @68133
     /*  68133 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(68178), // Rule ID 699 //
     /*  68138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divde),
     /*  68146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68167 */     // (intrinsic_wo_chain:{ *:[i64] } 10612:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDE:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDE),
     /*  68170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68172 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68174 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68176 */     GIR_RootConstrainSelectedInstOperands,
     /*  68177 */     // GIR_Coverage, 699,
     /*  68177 */     GIR_EraseRootFromParent_Done,
     /*  68178 */   // Label 1053: @68178
     /*  68178 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(68223), // Rule ID 704 //
     /*  68183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasExtDiv),
     /*  68186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_divdeu),
     /*  68191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68212 */     // (intrinsic_wo_chain:{ *:[i64] } 10613:{ *:[iPTR] }, g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)  =>  (DIVDEU:{ *:[i64] } g8rc:{ *:[i64] }:$RA, g8rc:{ *:[i64] }:$RB)
     /*  68212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DIVDEU),
     /*  68215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68217 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68219 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68221 */     GIR_RootConstrainSelectedInstOperands,
     /*  68222 */     // GIR_Coverage, 704,
     /*  68222 */     GIR_EraseRootFromParent_Done,
     /*  68223 */   // Label 1054: @68223
     /*  68223 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(68289), // Rule ID 1564 //
     /*  68228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpeqb),
     /*  68236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68257 */     // (intrinsic_wo_chain:{ *:[i64] } 10582:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPEQB:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPEQB),
     /*  68264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68273 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68287 */     GIR_RootConstrainSelectedInstOperands,
     /*  68288 */     // GIR_Coverage, 1564,
     /*  68288 */     GIR_EraseRootFromParent_Done,
     /*  68289 */   // Label 1055: @68289
     /*  68289 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(68355), // Rule ID 1565 //
     /*  68294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  68297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setb),
     /*  68302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68323 */     // (intrinsic_wo_chain:{ *:[i64] } 10802:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (SETB8:{ *:[i64] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b))
     /*  68323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  68326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /*  68330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // a
     /*  68339 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // b
     /*  68343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  68345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETB8),
     /*  68348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68353 */     GIR_RootConstrainSelectedInstOperands,
     /*  68354 */     // GIR_Coverage, 1565,
     /*  68354 */     GIR_EraseRootFromParent_Done,
     /*  68355 */   // Label 1056: @68355
     /*  68355 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(68400), // Rule ID 1569 //
     /*  68360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhd),
     /*  68368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68389 */     // (intrinsic_wo_chain:{ *:[i64] } 10781:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /*  68392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68394 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68396 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68398 */     GIR_RootConstrainSelectedInstOperands,
     /*  68399 */     // GIR_Coverage, 1569,
     /*  68399 */     GIR_EraseRootFromParent_Done,
     /*  68400 */   // Label 1057: @68400
     /*  68400 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(68445), // Rule ID 1570 //
     /*  68405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /*  68408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhdu),
     /*  68413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68434 */     // (intrinsic_wo_chain:{ *:[i64] } 10782:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (MULHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /*  68437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68439 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68441 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68443 */     GIR_RootConstrainSelectedInstOperands,
     /*  68444 */     // GIR_Coverage, 1570,
     /*  68444 */     GIR_EraseRootFromParent_Done,
     /*  68445 */   // Label 1058: @68445
     /*  68445 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(68487), // Rule ID 1573 //
     /*  68450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  68458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  68461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  68464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  68476 */     // (intrinsic_wo_chain:{ *:[i64] } 10581:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b)  =>  (CMPB8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b)
     /*  68476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB8),
     /*  68479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68481 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68483 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68485 */     GIR_RootConstrainSelectedInstOperands,
     /*  68486 */     // GIR_Coverage, 1573,
     /*  68486 */     GIR_EraseRootFromParent_Done,
     /*  68487 */   // Label 1059: @68487
     /*  68487 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(68529), // Rule ID 4882 //
     /*  68492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhw),
     /*  68497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68518 */     // (intrinsic_wo_chain:{ *:[i32] } 10783:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHW:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /*  68521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68523 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68525 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68527 */     GIR_RootConstrainSelectedInstOperands,
     /*  68528 */     // GIR_Coverage, 4882,
     /*  68528 */     GIR_EraseRootFromParent_Done,
     /*  68529 */   // Label 1060: @68529
     /*  68529 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(68571), // Rule ID 4883 //
     /*  68534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mulhwu),
     /*  68539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68560 */     // (intrinsic_wo_chain:{ *:[i32] } 10784:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (MULHWU:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /*  68563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68565 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68567 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68569 */     GIR_RootConstrainSelectedInstOperands,
     /*  68570 */     // GIR_Coverage, 4883,
     /*  68570 */     GIR_EraseRootFromParent_Done,
     /*  68571 */   // Label 1061: @68571
     /*  68571 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(68613), // Rule ID 4884 //
     /*  68576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cmpb),
     /*  68581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68602 */     // (intrinsic_wo_chain:{ *:[i32] } 10581:{ *:[iPTR] }, gprc:{ *:[i32] }:$a, gprc:{ *:[i32] }:$b)  =>  (CMPB:{ *:[i32] } ?:{ *:[i32] }:$a, ?:{ *:[i32] }:$b)
     /*  68602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CMPB),
     /*  68605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  68607 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  68609 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  68611 */     GIR_RootConstrainSelectedInstOperands,
     /*  68612 */     // GIR_Coverage, 4884,
     /*  68612 */     GIR_EraseRootFromParent_Done,
     /*  68613 */   // Label 1062: @68613
     /*  68613 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(68647), // Rule ID 76 //
     /*  68618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6s),
     /*  68623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  68626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  68629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  68632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  68636 */     // (intrinsic_wo_chain:{ *:[i32] } 10253:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (ADDG6S:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  68636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S),
     /*  68639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  68641 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  68643 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  68645 */     GIR_RootConstrainSelectedInstOperands,
     /*  68646 */     // GIR_Coverage, 76,
     /*  68646 */     GIR_EraseRootFromParent_Done,
     /*  68647 */   // Label 1063: @68647
     /*  68647 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(68684), // Rule ID 304 //
     /*  68652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuw),
     /*  68660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68673 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10297:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUW),
     /*  68676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68678 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68680 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68682 */     GIR_RootConstrainSelectedInstOperands,
     /*  68683 */     // GIR_Coverage, 304,
     /*  68683 */     GIR_EraseRootFromParent_Done,
     /*  68684 */   // Label 1064: @68684
     /*  68684 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(68721), // Rule ID 305 //
     /*  68689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsbs),
     /*  68697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68710 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10300:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /*  68713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68715 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68717 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68719 */     GIR_RootConstrainSelectedInstOperands,
     /*  68720 */     // GIR_Coverage, 305,
     /*  68720 */     GIR_EraseRootFromParent_Done,
     /*  68721 */   // Label 1065: @68721
     /*  68721 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(68758), // Rule ID 306 //
     /*  68726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddshs),
     /*  68734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68747 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10301:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /*  68750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68752 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68754 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68756 */     GIR_RootConstrainSelectedInstOperands,
     /*  68757 */     // GIR_Coverage, 306,
     /*  68757 */     GIR_EraseRootFromParent_Done,
     /*  68758 */   // Label 1066: @68758
     /*  68758 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(68795), // Rule ID 307 //
     /*  68763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddsws),
     /*  68771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68784 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10302:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /*  68787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68789 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68791 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68793 */     GIR_RootConstrainSelectedInstOperands,
     /*  68794 */     // GIR_Coverage, 307,
     /*  68794 */     GIR_EraseRootFromParent_Done,
     /*  68795 */   // Label 1067: @68795
     /*  68795 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(68832), // Rule ID 308 //
     /*  68800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddubs),
     /*  68808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68821 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10303:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VADDUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /*  68824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68826 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68828 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68830 */     GIR_RootConstrainSelectedInstOperands,
     /*  68831 */     // GIR_Coverage, 308,
     /*  68831 */     GIR_EraseRootFromParent_Done,
     /*  68832 */   // Label 1068: @68832
     /*  68832 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(68869), // Rule ID 309 //
     /*  68837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduhs),
     /*  68845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68858 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10304:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VADDUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /*  68861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68863 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68865 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68867 */     GIR_RootConstrainSelectedInstOperands,
     /*  68868 */     // GIR_Coverage, 309,
     /*  68868 */     GIR_EraseRootFromParent_Done,
     /*  68869 */   // Label 1069: @68869
     /*  68869 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(68906), // Rule ID 310 //
     /*  68874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vadduws),
     /*  68882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68895 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10305:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VADDUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  68895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /*  68898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68900 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68902 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68904 */     GIR_RootConstrainSelectedInstOperands,
     /*  68905 */     // GIR_Coverage, 310,
     /*  68905 */     GIR_EraseRootFromParent_Done,
     /*  68906 */   // Label 1070: @68906
     /*  68906 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(68943), // Rule ID 323 //
     /*  68911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsb),
     /*  68919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68932 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10306:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  68932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSB),
     /*  68935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68937 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68939 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68941 */     GIR_RootConstrainSelectedInstOperands,
     /*  68942 */     // GIR_Coverage, 323,
     /*  68942 */     GIR_EraseRootFromParent_Done,
     /*  68943 */   // Label 1071: @68943
     /*  68943 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(68980), // Rule ID 324 //
     /*  68948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsh),
     /*  68956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  68969 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10307:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  68969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSH),
     /*  68972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  68974 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  68976 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  68978 */     GIR_RootConstrainSelectedInstOperands,
     /*  68979 */     // GIR_Coverage, 324,
     /*  68979 */     GIR_EraseRootFromParent_Done,
     /*  68980 */   // Label 1072: @68980
     /*  68980 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(69017), // Rule ID 325 //
     /*  68985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  68988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgsw),
     /*  68993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69006 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10308:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGSW),
     /*  69009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69011 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69013 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69015 */     GIR_RootConstrainSelectedInstOperands,
     /*  69016 */     // GIR_Coverage, 325,
     /*  69016 */     GIR_EraseRootFromParent_Done,
     /*  69017 */   // Label 1073: @69017
     /*  69017 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(69054), // Rule ID 326 //
     /*  69022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavgub),
     /*  69030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69043 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10309:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VAVGUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUB),
     /*  69046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69048 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69050 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69052 */     GIR_RootConstrainSelectedInstOperands,
     /*  69053 */     // GIR_Coverage, 326,
     /*  69053 */     GIR_EraseRootFromParent_Done,
     /*  69054 */   // Label 1074: @69054
     /*  69054 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(69091), // Rule ID 327 //
     /*  69059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguh),
     /*  69067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69080 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10310:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VAVGUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUH),
     /*  69083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69085 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69087 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69089 */     GIR_RootConstrainSelectedInstOperands,
     /*  69090 */     // GIR_Coverage, 327,
     /*  69090 */     GIR_EraseRootFromParent_Done,
     /*  69091 */   // Label 1075: @69091
     /*  69091 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(69128), // Rule ID 328 //
     /*  69096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vavguw),
     /*  69104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69117 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10311:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VAVGUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VAVGUW),
     /*  69120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69122 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69124 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69126 */     GIR_RootConstrainSelectedInstOperands,
     /*  69127 */     // GIR_Coverage, 328,
     /*  69127 */     GIR_EraseRootFromParent_Done,
     /*  69128 */   // Label 1076: @69128
     /*  69128 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(69165), // Rule ID 329 //
     /*  69133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxfp),
     /*  69141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69154 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10430:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMAXFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXFP),
     /*  69157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69159 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69161 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69163 */     GIR_RootConstrainSelectedInstOperands,
     /*  69164 */     // GIR_Coverage, 329,
     /*  69164 */     GIR_EraseRootFromParent_Done,
     /*  69165 */   // Label 1077: @69165
     /*  69165 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(69202), // Rule ID 330 //
     /*  69170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsb),
     /*  69178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69191 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10431:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /*  69194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69196 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69198 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69200 */     GIR_RootConstrainSelectedInstOperands,
     /*  69201 */     // GIR_Coverage, 330,
     /*  69201 */     GIR_EraseRootFromParent_Done,
     /*  69202 */   // Label 1078: @69202
     /*  69202 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(69239), // Rule ID 331 //
     /*  69207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsh),
     /*  69215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69228 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10433:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /*  69231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69233 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69235 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69237 */     GIR_RootConstrainSelectedInstOperands,
     /*  69238 */     // GIR_Coverage, 331,
     /*  69238 */     GIR_EraseRootFromParent_Done,
     /*  69239 */   // Label 1079: @69239
     /*  69239 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(69276), // Rule ID 332 //
     /*  69244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsw),
     /*  69252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69265 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10434:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /*  69268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69270 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69272 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69274 */     GIR_RootConstrainSelectedInstOperands,
     /*  69275 */     // GIR_Coverage, 332,
     /*  69275 */     GIR_EraseRootFromParent_Done,
     /*  69276 */   // Label 1080: @69276
     /*  69276 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(69313), // Rule ID 333 //
     /*  69281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxub),
     /*  69289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69302 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10435:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMAXUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /*  69305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69307 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69309 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69311 */     GIR_RootConstrainSelectedInstOperands,
     /*  69312 */     // GIR_Coverage, 333,
     /*  69312 */     GIR_EraseRootFromParent_Done,
     /*  69313 */   // Label 1081: @69313
     /*  69313 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(69350), // Rule ID 334 //
     /*  69318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuh),
     /*  69326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69339 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10437:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMAXUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /*  69342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69344 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69346 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69348 */     GIR_RootConstrainSelectedInstOperands,
     /*  69349 */     // GIR_Coverage, 334,
     /*  69349 */     GIR_EraseRootFromParent_Done,
     /*  69350 */   // Label 1082: @69350
     /*  69350 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(69387), // Rule ID 335 //
     /*  69355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxuw),
     /*  69363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69376 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10438:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMAXUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /*  69379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69381 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69383 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69385 */     GIR_RootConstrainSelectedInstOperands,
     /*  69386 */     // GIR_Coverage, 335,
     /*  69386 */     GIR_EraseRootFromParent_Done,
     /*  69387 */   // Label 1083: @69387
     /*  69387 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(69424), // Rule ID 336 //
     /*  69392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminfp),
     /*  69400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69413 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10441:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VMINFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /*  69413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINFP),
     /*  69416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69418 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69420 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69422 */     GIR_RootConstrainSelectedInstOperands,
     /*  69423 */     // GIR_Coverage, 336,
     /*  69423 */     GIR_EraseRootFromParent_Done,
     /*  69424 */   // Label 1084: @69424
     /*  69424 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(69461), // Rule ID 337 //
     /*  69429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsb),
     /*  69437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69450 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10442:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINSB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /*  69453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69455 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69457 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69459 */     GIR_RootConstrainSelectedInstOperands,
     /*  69460 */     // GIR_Coverage, 337,
     /*  69460 */     GIR_EraseRootFromParent_Done,
     /*  69461 */   // Label 1085: @69461
     /*  69461 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(69498), // Rule ID 338 //
     /*  69466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsh),
     /*  69474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69487 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10444:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINSH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /*  69490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69492 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69494 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69496 */     GIR_RootConstrainSelectedInstOperands,
     /*  69497 */     // GIR_Coverage, 338,
     /*  69497 */     GIR_EraseRootFromParent_Done,
     /*  69498 */   // Label 1086: @69498
     /*  69498 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(69535), // Rule ID 339 //
     /*  69503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsw),
     /*  69511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69524 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10445:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /*  69527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69529 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69531 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69533 */     GIR_RootConstrainSelectedInstOperands,
     /*  69534 */     // GIR_Coverage, 339,
     /*  69534 */     GIR_EraseRootFromParent_Done,
     /*  69535 */   // Label 1087: @69535
     /*  69535 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(69572), // Rule ID 340 //
     /*  69540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminub),
     /*  69548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69561 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10446:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMINUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /*  69564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69566 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69568 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69570 */     GIR_RootConstrainSelectedInstOperands,
     /*  69571 */     // GIR_Coverage, 340,
     /*  69571 */     GIR_EraseRootFromParent_Done,
     /*  69572 */   // Label 1088: @69572
     /*  69572 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(69609), // Rule ID 341 //
     /*  69577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuh),
     /*  69585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69598 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10448:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMINUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /*  69601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69603 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69605 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69607 */     GIR_RootConstrainSelectedInstOperands,
     /*  69608 */     // GIR_Coverage, 341,
     /*  69608 */     GIR_EraseRootFromParent_Done,
     /*  69609 */   // Label 1089: @69609
     /*  69609 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(69646), // Rule ID 342 //
     /*  69614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminuw),
     /*  69622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69635 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10449:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMINUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /*  69638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69640 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69642 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69644 */     GIR_RootConstrainSelectedInstOperands,
     /*  69645 */     // GIR_Coverage, 342,
     /*  69645 */     GIR_EraseRootFromParent_Done,
     /*  69646 */   // Label 1090: @69646
     /*  69646 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(69683), // Rule ID 355 //
     /*  69651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesb),
     /*  69659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10459:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULESB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESB),
     /*  69675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69677 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69679 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69681 */     GIR_RootConstrainSelectedInstOperands,
     /*  69682 */     // GIR_Coverage, 355,
     /*  69682 */     GIR_EraseRootFromParent_Done,
     /*  69683 */   // Label 1091: @69683
     /*  69683 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(69720), // Rule ID 356 //
     /*  69688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesh),
     /*  69696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69709 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10461:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULESH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESH),
     /*  69712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69714 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69716 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69718 */     GIR_RootConstrainSelectedInstOperands,
     /*  69719 */     // GIR_Coverage, 356,
     /*  69719 */     GIR_EraseRootFromParent_Done,
     /*  69720 */   // Label 1092: @69720
     /*  69720 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(69757), // Rule ID 357 //
     /*  69725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleub),
     /*  69733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69746 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10463:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULEUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUB),
     /*  69749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69751 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69753 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69755 */     GIR_RootConstrainSelectedInstOperands,
     /*  69756 */     // GIR_Coverage, 357,
     /*  69756 */     GIR_EraseRootFromParent_Done,
     /*  69757 */   // Label 1093: @69757
     /*  69757 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(69794), // Rule ID 358 //
     /*  69762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuh),
     /*  69770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69783 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10465:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULEUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUH),
     /*  69786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69788 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69790 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69792 */     GIR_RootConstrainSelectedInstOperands,
     /*  69793 */     // GIR_Coverage, 358,
     /*  69793 */     GIR_EraseRootFromParent_Done,
     /*  69794 */   // Label 1094: @69794
     /*  69794 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(69831), // Rule ID 359 //
     /*  69799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosb),
     /*  69807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10471:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOSB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSB),
     /*  69823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69825 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69827 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69829 */     GIR_RootConstrainSelectedInstOperands,
     /*  69830 */     // GIR_Coverage, 359,
     /*  69830 */     GIR_EraseRootFromParent_Done,
     /*  69831 */   // Label 1095: @69831
     /*  69831 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(69868), // Rule ID 360 //
     /*  69836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosh),
     /*  69844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69857 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10473:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOSH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSH),
     /*  69860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69862 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69864 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69866 */     GIR_RootConstrainSelectedInstOperands,
     /*  69867 */     // GIR_Coverage, 360,
     /*  69867 */     GIR_EraseRootFromParent_Done,
     /*  69868 */   // Label 1096: @69868
     /*  69868 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(69905), // Rule ID 361 //
     /*  69873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloub),
     /*  69881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69894 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10475:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VMULOUB:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  69894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUB),
     /*  69897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69899 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69901 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69903 */     GIR_RootConstrainSelectedInstOperands,
     /*  69904 */     // GIR_Coverage, 361,
     /*  69904 */     GIR_EraseRootFromParent_Done,
     /*  69905 */   // Label 1097: @69905
     /*  69905 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(69942), // Rule ID 362 //
     /*  69910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouh),
     /*  69918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69931 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10477:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VMULOUH:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  69931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUH),
     /*  69934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69936 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69938 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69940 */     GIR_RootConstrainSelectedInstOperands,
     /*  69941 */     // GIR_Coverage, 362,
     /*  69941 */     GIR_EraseRootFromParent_Done,
     /*  69942 */   // Label 1098: @69942
     /*  69942 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(69979), // Rule ID 369 //
     /*  69947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuw),
     /*  69955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  69968 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10539:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBCUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  69968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUW),
     /*  69971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  69973 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  69975 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  69977 */     GIR_RootConstrainSelectedInstOperands,
     /*  69978 */     // GIR_Coverage, 369,
     /*  69978 */     GIR_EraseRootFromParent_Done,
     /*  69979 */   // Label 1099: @69979
     /*  69979 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(70016), // Rule ID 374 //
     /*  69984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  69987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsbs),
     /*  69992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70005 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10542:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBSBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /*  70008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70010 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70012 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70014 */     GIR_RootConstrainSelectedInstOperands,
     /*  70015 */     // GIR_Coverage, 374,
     /*  70015 */     GIR_EraseRootFromParent_Done,
     /*  70016 */   // Label 1100: @70016
     /*  70016 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(70053), // Rule ID 375 //
     /*  70021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubshs),
     /*  70029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70042 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10543:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /*  70045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70047 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70049 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70051 */     GIR_RootConstrainSelectedInstOperands,
     /*  70052 */     // GIR_Coverage, 375,
     /*  70052 */     GIR_EraseRootFromParent_Done,
     /*  70053 */   // Label 1101: @70053
     /*  70053 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(70090), // Rule ID 376 //
     /*  70058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubsws),
     /*  70066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70079 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10544:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /*  70082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70084 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70086 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70088 */     GIR_RootConstrainSelectedInstOperands,
     /*  70089 */     // GIR_Coverage, 376,
     /*  70089 */     GIR_EraseRootFromParent_Done,
     /*  70090 */   // Label 1102: @70090
     /*  70090 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(70127), // Rule ID 377 //
     /*  70095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsububs),
     /*  70103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70116 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10545:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSUBUBS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /*  70119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70121 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70123 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70125 */     GIR_RootConstrainSelectedInstOperands,
     /*  70126 */     // GIR_Coverage, 377,
     /*  70126 */     GIR_EraseRootFromParent_Done,
     /*  70127 */   // Label 1103: @70127
     /*  70127 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(70164), // Rule ID 378 //
     /*  70132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuhs),
     /*  70140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70153 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10546:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSUBUHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /*  70156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70158 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70160 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70162 */     GIR_RootConstrainSelectedInstOperands,
     /*  70163 */     // GIR_Coverage, 378,
     /*  70163 */     GIR_EraseRootFromParent_Done,
     /*  70164 */   // Label 1104: @70164
     /*  70164 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(70201), // Rule ID 379 //
     /*  70169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubuws),
     /*  70177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70190 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10547:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUBUWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /*  70193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70195 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70197 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70199 */     GIR_RootConstrainSelectedInstOperands,
     /*  70200 */     // GIR_Coverage, 379,
     /*  70200 */     GIR_EraseRootFromParent_Done,
     /*  70201 */   // Label 1105: @70201
     /*  70201 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(70238), // Rule ID 388 //
     /*  70206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlb),
     /*  70214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70227 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10501:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /*  70230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70232 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70234 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70236 */     GIR_RootConstrainSelectedInstOperands,
     /*  70237 */     // GIR_Coverage, 388,
     /*  70237 */     GIR_EraseRootFromParent_Done,
     /*  70238 */   // Label 1106: @70238
     /*  70238 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(70275), // Rule ID 389 //
     /*  70243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlh),
     /*  70251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70264 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10505:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /*  70267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70269 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70271 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70273 */     GIR_RootConstrainSelectedInstOperands,
     /*  70274 */     // GIR_Coverage, 389,
     /*  70274 */     GIR_EraseRootFromParent_Done,
     /*  70275 */   // Label 1107: @70275
     /*  70275 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(70312), // Rule ID 390 //
     /*  70280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlw),
     /*  70288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70301 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10508:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /*  70304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70306 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70308 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70310 */     GIR_RootConstrainSelectedInstOperands,
     /*  70311 */     // GIR_Coverage, 390,
     /*  70311 */     GIR_EraseRootFromParent_Done,
     /*  70312 */   // Label 1108: @70312
     /*  70312 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(70349), // Rule ID 391 //
     /*  70317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsl),
     /*  70325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70338 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10513:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /*  70341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70343 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70345 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70347 */     GIR_RootConstrainSelectedInstOperands,
     /*  70348 */     // GIR_Coverage, 391,
     /*  70348 */     GIR_EraseRootFromParent_Done,
     /*  70349 */   // Label 1109: @70349
     /*  70349 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(70386), // Rule ID 392 //
     /*  70354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslo),
     /*  70362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70375 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10517:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /*  70378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70380 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70382 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70384 */     GIR_RootConstrainSelectedInstOperands,
     /*  70385 */     // GIR_Coverage, 392,
     /*  70385 */     GIR_EraseRootFromParent_Done,
     /*  70386 */   // Label 1110: @70386
     /*  70386 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(70423), // Rule ID 393 //
     /*  70391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslb),
     /*  70399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70412 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10514:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /*  70415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70417 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70419 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70421 */     GIR_RootConstrainSelectedInstOperands,
     /*  70422 */     // GIR_Coverage, 393,
     /*  70422 */     GIR_EraseRootFromParent_Done,
     /*  70423 */   // Label 1111: @70423
     /*  70423 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(70460), // Rule ID 394 //
     /*  70428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslh),
     /*  70436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70449 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10516:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /*  70452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70454 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70456 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70458 */     GIR_RootConstrainSelectedInstOperands,
     /*  70459 */     // GIR_Coverage, 394,
     /*  70459 */     GIR_EraseRootFromParent_Done,
     /*  70460 */   // Label 1112: @70460
     /*  70460 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(70497), // Rule ID 395 //
     /*  70465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslw),
     /*  70473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70486 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10519:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /*  70489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70491 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70493 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70495 */     GIR_RootConstrainSelectedInstOperands,
     /*  70496 */     // GIR_Coverage, 395,
     /*  70496 */     GIR_EraseRootFromParent_Done,
     /*  70497 */   // Label 1113: @70497
     /*  70497 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(70534), // Rule ID 399 //
     /*  70502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsr),
     /*  70510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70523 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10520:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSR:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /*  70526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70528 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70530 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70532 */     GIR_RootConstrainSelectedInstOperands,
     /*  70533 */     // GIR_Coverage, 399,
     /*  70533 */     GIR_EraseRootFromParent_Done,
     /*  70534 */   // Label 1114: @70534
     /*  70534 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(70571), // Rule ID 400 //
     /*  70539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsro),
     /*  70547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70560 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10527:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRO:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /*  70563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70565 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70567 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70569 */     GIR_RootConstrainSelectedInstOperands,
     /*  70570 */     // GIR_Coverage, 400,
     /*  70570 */     GIR_EraseRootFromParent_Done,
     /*  70571 */   // Label 1115: @70571
     /*  70571 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(70608), // Rule ID 401 //
     /*  70576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrab),
     /*  70584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70597 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10521:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRAB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /*  70600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70602 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70604 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70606 */     GIR_RootConstrainSelectedInstOperands,
     /*  70607 */     // GIR_Coverage, 401,
     /*  70607 */     GIR_EraseRootFromParent_Done,
     /*  70608 */   // Label 1116: @70608
     /*  70608 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(70645), // Rule ID 402 //
     /*  70613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrah),
     /*  70621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70634 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10522:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRAH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /*  70637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70639 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70641 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70643 */     GIR_RootConstrainSelectedInstOperands,
     /*  70644 */     // GIR_Coverage, 402,
     /*  70644 */     GIR_EraseRootFromParent_Done,
     /*  70645 */   // Label 1117: @70645
     /*  70645 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(70682), // Rule ID 403 //
     /*  70650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsraw),
     /*  70658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70671 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10523:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /*  70674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70676 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70678 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70680 */     GIR_RootConstrainSelectedInstOperands,
     /*  70681 */     // GIR_Coverage, 403,
     /*  70681 */     GIR_EraseRootFromParent_Done,
     /*  70682 */   // Label 1118: @70682
     /*  70682 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(70719), // Rule ID 404 //
     /*  70687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrb),
     /*  70695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  70698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  70701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70708 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10524:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  70708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /*  70711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70713 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70715 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70717 */     GIR_RootConstrainSelectedInstOperands,
     /*  70718 */     // GIR_Coverage, 404,
     /*  70718 */     GIR_EraseRootFromParent_Done,
     /*  70719 */   // Label 1119: @70719
     /*  70719 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(70756), // Rule ID 405 //
     /*  70724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrh),
     /*  70732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  70741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70745 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10526:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VSRH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  70745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /*  70748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70750 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70752 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70754 */     GIR_RootConstrainSelectedInstOperands,
     /*  70755 */     // GIR_Coverage, 405,
     /*  70755 */     GIR_EraseRootFromParent_Done,
     /*  70756 */   // Label 1120: @70756
     /*  70756 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(70793), // Rule ID 406 //
     /*  70761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrw),
     /*  70769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70782 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10529:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /*  70785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70787 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70789 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70791 */     GIR_RootConstrainSelectedInstOperands,
     /*  70792 */     // GIR_Coverage, 406,
     /*  70792 */     GIR_EraseRootFromParent_Done,
     /*  70793 */   // Label 1121: @70793
     /*  70793 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(70830), // Rule ID 410 //
     /*  70798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  70801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkpx),
     /*  70806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  70809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70819 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10483:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKPX:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKPX),
     /*  70822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70824 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70826 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70828 */     GIR_RootConstrainSelectedInstOperands,
     /*  70829 */     // GIR_Coverage, 410,
     /*  70829 */     GIR_EraseRootFromParent_Done,
     /*  70830 */   // Label 1122: @70830
     /*  70830 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(70867), // Rule ID 457 //
     /*  70835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesw),
     /*  70843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70856 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10462:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULESW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESW),
     /*  70859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70861 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70863 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70865 */     GIR_RootConstrainSelectedInstOperands,
     /*  70866 */     // GIR_Coverage, 457,
     /*  70866 */     GIR_EraseRootFromParent_Done,
     /*  70867 */   // Label 1123: @70867
     /*  70867 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(70904), // Rule ID 458 //
     /*  70872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleuw),
     /*  70880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70893 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10466:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULEUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUW),
     /*  70896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70898 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70900 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70902 */     GIR_RootConstrainSelectedInstOperands,
     /*  70903 */     // GIR_Coverage, 458,
     /*  70903 */     GIR_EraseRootFromParent_Done,
     /*  70904 */   // Label 1124: @70904
     /*  70904 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(70941), // Rule ID 459 //
     /*  70909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosw),
     /*  70917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70930 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10474:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOSW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSW),
     /*  70933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70935 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70937 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70939 */     GIR_RootConstrainSelectedInstOperands,
     /*  70940 */     // GIR_Coverage, 459,
     /*  70940 */     GIR_EraseRootFromParent_Done,
     /*  70941 */   // Label 1125: @70941
     /*  70941 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(70978), // Rule ID 460 //
     /*  70946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulouw),
     /*  70954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  70967 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10478:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULOUW:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  70967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUW),
     /*  70970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  70972 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  70974 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  70976 */     GIR_RootConstrainSelectedInstOperands,
     /*  70977 */     // GIR_Coverage, 460,
     /*  70977 */     GIR_EraseRootFromParent_Done,
     /*  70978 */   // Label 1126: @70978
     /*  70978 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(71015), // Rule ID 462 //
     /*  70983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  70986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxsd),
     /*  70991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  70994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  70997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71004 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10432:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /*  71007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71009 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71011 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71013 */     GIR_RootConstrainSelectedInstOperands,
     /*  71014 */     // GIR_Coverage, 462,
     /*  71014 */     GIR_EraseRootFromParent_Done,
     /*  71015 */   // Label 1127: @71015
     /*  71015 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(71052), // Rule ID 463 //
     /*  71020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaxud),
     /*  71028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71041 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10436:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMAXUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /*  71044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71046 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71048 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71050 */     GIR_RootConstrainSelectedInstOperands,
     /*  71051 */     // GIR_Coverage, 463,
     /*  71051 */     GIR_EraseRootFromParent_Done,
     /*  71052 */   // Label 1128: @71052
     /*  71052 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(71089), // Rule ID 464 //
     /*  71057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminsd),
     /*  71065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71078 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10443:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /*  71081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71083 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71085 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71087 */     GIR_RootConstrainSelectedInstOperands,
     /*  71088 */     // GIR_Coverage, 464,
     /*  71088 */     GIR_EraseRootFromParent_Done,
     /*  71089 */   // Label 1129: @71089
     /*  71089 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(71126), // Rule ID 465 //
     /*  71094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vminud),
     /*  71102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71115 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10447:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMINUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /*  71118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71120 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71122 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71124 */     GIR_RootConstrainSelectedInstOperands,
     /*  71125 */     // GIR_Coverage, 465,
     /*  71125 */     GIR_EraseRootFromParent_Done,
     /*  71126 */   // Label 1130: @71126
     /*  71126 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(71163), // Rule ID 468 //
     /*  71131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrld),
     /*  71139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71152 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10502:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /*  71155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71157 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71159 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71161 */     GIR_RootConstrainSelectedInstOperands,
     /*  71162 */     // GIR_Coverage, 468,
     /*  71162 */     GIR_EraseRootFromParent_Done,
     /*  71163 */   // Label 1131: @71163
     /*  71163 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(71200), // Rule ID 472 //
     /*  71168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddcuq),
     /*  71176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71189 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10296:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VADDCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDCUQ),
     /*  71192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71194 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71196 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71198 */     GIR_RootConstrainSelectedInstOperands,
     /*  71199 */     // GIR_Coverage, 472,
     /*  71199 */     GIR_EraseRootFromParent_Done,
     /*  71200 */   // Label 1132: @71200
     /*  71200 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(71237), // Rule ID 477 //
     /*  71205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubcuq),
     /*  71213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  71216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  71219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  71222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71226 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10538:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VSUBCUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  71226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBCUQ),
     /*  71229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71231 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71233 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71235 */     GIR_RootConstrainSelectedInstOperands,
     /*  71236 */     // GIR_Coverage, 477,
     /*  71236 */     GIR_EraseRootFromParent_Done,
     /*  71237 */   // Label 1133: @71237
     /*  71237 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(71274), // Rule ID 496 //
     /*  71242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumb),
     /*  71250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71263 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10261:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VPMSUMB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMB),
     /*  71266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71268 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71270 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71272 */     GIR_RootConstrainSelectedInstOperands,
     /*  71273 */     // GIR_Coverage, 496,
     /*  71273 */     GIR_EraseRootFromParent_Done,
     /*  71274 */   // Label 1134: @71274
     /*  71274 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(71311), // Rule ID 497 //
     /*  71279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumh),
     /*  71287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71300 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10263:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPMSUMH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMH),
     /*  71303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71305 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71307 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71309 */     GIR_RootConstrainSelectedInstOperands,
     /*  71310 */     // GIR_Coverage, 497,
     /*  71310 */     GIR_EraseRootFromParent_Done,
     /*  71311 */   // Label 1135: @71311
     /*  71311 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(71348), // Rule ID 498 //
     /*  71316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumw),
     /*  71324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71337 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10264:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPMSUMW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMW),
     /*  71340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71342 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71344 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71346 */     GIR_RootConstrainSelectedInstOperands,
     /*  71347 */     // GIR_Coverage, 498,
     /*  71347 */     GIR_EraseRootFromParent_Done,
     /*  71348 */   // Label 1136: @71348
     /*  71348 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(71385), // Rule ID 499 //
     /*  71353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpmsumd),
     /*  71361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71374 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10262:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPMSUMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPMSUMD),
     /*  71377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71379 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71381 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71383 */     GIR_RootConstrainSelectedInstOperands,
     /*  71384 */     // GIR_Coverage, 499,
     /*  71384 */     GIR_EraseRootFromParent_Done,
     /*  71385 */   // Label 1137: @71385
     /*  71385 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(71422), // Rule ID 507 //
     /*  71390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  71393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermq),
     /*  71398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71411 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10313:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMQ:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMQ),
     /*  71414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71416 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71418 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71420 */     GIR_RootConstrainSelectedInstOperands,
     /*  71421 */     // GIR_Coverage, 507,
     /*  71421 */     GIR_EraseRootFromParent_Done,
     /*  71422 */   // Label 1138: @71422
     /*  71422 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(71459), // Rule ID 510 //
     /*  71427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipher),
     /*  71435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71448 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10255:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHER),
     /*  71451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71453 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71455 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71457 */     GIR_RootConstrainSelectedInstOperands,
     /*  71458 */     // GIR_Coverage, 510,
     /*  71458 */     GIR_EraseRootFromParent_Done,
     /*  71459 */   // Label 1139: @71459
     /*  71459 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(71496), // Rule ID 511 //
     /*  71464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vcipherlast),
     /*  71472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71485 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10256:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCIPHERLAST),
     /*  71488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71490 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71492 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71494 */     GIR_RootConstrainSelectedInstOperands,
     /*  71495 */     // GIR_Coverage, 511,
     /*  71495 */     GIR_EraseRootFromParent_Done,
     /*  71496 */   // Label 1140: @71496
     /*  71496 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(71533), // Rule ID 512 //
     /*  71501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipher),
     /*  71509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71522 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10257:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHER:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHER),
     /*  71525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71527 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71529 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71531 */     GIR_RootConstrainSelectedInstOperands,
     /*  71532 */     // GIR_Coverage, 512,
     /*  71532 */     GIR_EraseRootFromParent_Done,
     /*  71533 */   // Label 1141: @71533
     /*  71533 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(71570), // Rule ID 513 //
     /*  71538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  71541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vncipherlast),
     /*  71546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71559 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10258:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VNCIPHERLAST:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNCIPHERLAST),
     /*  71562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71564 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71566 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71568 */     GIR_RootConstrainSelectedInstOperands,
     /*  71569 */     // GIR_Coverage, 513,
     /*  71569 */     GIR_EraseRootFromParent_Done,
     /*  71570 */   // Label 1142: @71570
     /*  71570 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(71607), // Rule ID 546 //
     /*  71575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vbpermd),
     /*  71583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10312:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VBPERMD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VBPERMD),
     /*  71599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71601 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71603 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71605 */     GIR_RootConstrainSelectedInstOperands,
     /*  71606 */     // GIR_Coverage, 546,
     /*  71606 */     GIR_EraseRootFromParent_Done,
     /*  71607 */   // Label 1143: @71607
     /*  71607 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(71644), // Rule ID 547 //
     /*  71612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwnm),
     /*  71620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10510:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VRLWNM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWNM),
     /*  71636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71638 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71640 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71642 */     GIR_RootConstrainSelectedInstOperands,
     /*  71643 */     // GIR_Coverage, 547,
     /*  71643 */     GIR_EraseRootFromParent_Done,
     /*  71644 */   // Label 1144: @71644
     /*  71644 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(71681), // Rule ID 549 //
     /*  71649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldnm),
     /*  71657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71670 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10504:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VRLDNM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDNM),
     /*  71673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71675 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71677 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71679 */     GIR_RootConstrainSelectedInstOperands,
     /*  71680 */     // GIR_Coverage, 549,
     /*  71680 */     GIR_EraseRootFromParent_Done,
     /*  71681 */   // Label 1145: @71681
     /*  71681 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(71718), // Rule ID 551 //
     /*  71686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vslv),
     /*  71694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71707 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10518:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSLV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLV),
     /*  71710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71712 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71714 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71716 */     GIR_RootConstrainSelectedInstOperands,
     /*  71717 */     // GIR_Coverage, 551,
     /*  71717 */     GIR_EraseRootFromParent_Done,
     /*  71718 */   // Label 1146: @71718
     /*  71718 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71755), // Rule ID 552 //
     /*  71723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrv),
     /*  71731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71744 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10528:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VSRV:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRV),
     /*  71747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71749 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71751 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71753 */     GIR_RootConstrainSelectedInstOperands,
     /*  71754 */     // GIR_Coverage, 552,
     /*  71754 */     GIR_EraseRootFromParent_Done,
     /*  71755 */   // Label 1147: @71755
     /*  71755 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(71792), // Rule ID 557 //
     /*  71760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsdub),
     /*  71768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  71771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  71777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71781 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10293:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VABSDUB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  71781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUB),
     /*  71784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71786 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71788 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71790 */     GIR_RootConstrainSelectedInstOperands,
     /*  71791 */     // GIR_Coverage, 557,
     /*  71791 */     GIR_EraseRootFromParent_Done,
     /*  71792 */   // Label 1148: @71792
     /*  71792 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(71829), // Rule ID 558 //
     /*  71797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduh),
     /*  71805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  71808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  71814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71818 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10294:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VABSDUH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  71818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUH),
     /*  71821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71823 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71825 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71827 */     GIR_RootConstrainSelectedInstOperands,
     /*  71828 */     // GIR_Coverage, 558,
     /*  71828 */     GIR_EraseRootFromParent_Done,
     /*  71829 */   // Label 1149: @71829
     /*  71829 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(71866), // Rule ID 559 //
     /*  71834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  71837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vabsduw),
     /*  71842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  71845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  71848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  71851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71855 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10295:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VABSDUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  71855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VABSDUW),
     /*  71858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71860 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71862 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71864 */     GIR_RootConstrainSelectedInstOperands,
     /*  71865 */     // GIR_Coverage, 559,
     /*  71865 */     GIR_EraseRootFromParent_Done,
     /*  71866 */   // Label 1150: @71866
     /*  71866 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(71900), // Rule ID 696 //
     /*  71871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addg6sd),
     /*  71876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  71889 */     // (intrinsic_wo_chain:{ *:[i64] } 10254:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (ADDG6S8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /*  71889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDG6S8),
     /*  71892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  71894 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  71896 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  71898 */     GIR_RootConstrainSelectedInstOperands,
     /*  71899 */     // GIR_Coverage, 696,
     /*  71899 */     GIR_EraseRootFromParent_Done,
     /*  71900 */   // Label 1151: @71900
     /*  71900 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71937), // Rule ID 1110 //
     /*  71905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpdepd),
     /*  71913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71926 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10480:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPDEPD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPDEPD),
     /*  71929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71931 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71933 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71935 */     GIR_RootConstrainSelectedInstOperands,
     /*  71936 */     // GIR_Coverage, 1110,
     /*  71936 */     GIR_EraseRootFromParent_Done,
     /*  71937 */   // Label 1152: @71937
     /*  71937 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71974), // Rule ID 1111 //
     /*  71942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpextd),
     /*  71950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  71953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  71956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  71959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  71963 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10482:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPEXTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  71963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPEXTD),
     /*  71966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  71968 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  71970 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  71972 */     GIR_RootConstrainSelectedInstOperands,
     /*  71973 */     // GIR_Coverage, 1111,
     /*  71973 */     GIR_EraseRootFromParent_Done,
     /*  71974 */   // Label 1153: @71974
     /*  71974 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(72011), // Rule ID 1112 //
     /*  71979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  71982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pdepd),
     /*  71987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  71990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  71993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  71996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72000 */     // (intrinsic_wo_chain:{ *:[i64] } 10789:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PDEPD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PDEPD),
     /*  72003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72005 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72007 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72009 */     GIR_RootConstrainSelectedInstOperands,
     /*  72010 */     // GIR_Coverage, 1112,
     /*  72010 */     GIR_EraseRootFromParent_Done,
     /*  72011 */   // Label 1154: @72011
     /*  72011 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(72048), // Rule ID 1113 //
     /*  72016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_pextd),
     /*  72024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72037 */     // (intrinsic_wo_chain:{ *:[i64] } 10790:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (PEXTD:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PEXTD),
     /*  72040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72042 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72044 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72046 */     GIR_RootConstrainSelectedInstOperands,
     /*  72047 */     // GIR_Coverage, 1113,
     /*  72047 */     GIR_EraseRootFromParent_Done,
     /*  72048 */   // Label 1155: @72048
     /*  72048 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(72085), // Rule ID 1114 //
     /*  72053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vcfuged),
     /*  72061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72074 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10315:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCFUGED:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCFUGED),
     /*  72077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72079 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72081 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72083 */     GIR_RootConstrainSelectedInstOperands,
     /*  72084 */     // GIR_Coverage, 1114,
     /*  72084 */     GIR_EraseRootFromParent_Done,
     /*  72085 */   // Label 1156: @72085
     /*  72085 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(72122), // Rule ID 1116 //
     /*  72090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cfuged),
     /*  72098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72111 */     // (intrinsic_wo_chain:{ *:[i64] } 10580:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CFUGED:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CFUGED),
     /*  72114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72116 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72118 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72120 */     GIR_RootConstrainSelectedInstOperands,
     /*  72121 */     // GIR_Coverage, 1116,
     /*  72121 */     GIR_EraseRootFromParent_Done,
     /*  72122 */   // Label 1157: @72122
     /*  72122 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(72159), // Rule ID 1118 //
     /*  72127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclzdm),
     /*  72135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72148 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10319:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLZDM),
     /*  72151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72153 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72155 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72157 */     GIR_RootConstrainSelectedInstOperands,
     /*  72158 */     // GIR_Coverage, 1118,
     /*  72158 */     GIR_EraseRootFromParent_Done,
     /*  72159 */   // Label 1158: @72159
     /*  72159 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(72196), // Rule ID 1119 //
     /*  72164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vctzdm),
     /*  72172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72185 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10377:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZDM:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCTZDM),
     /*  72188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72190 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72192 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72194 */     GIR_RootConstrainSelectedInstOperands,
     /*  72195 */     // GIR_Coverage, 1119,
     /*  72195 */     GIR_EraseRootFromParent_Done,
     /*  72196 */   // Label 1159: @72196
     /*  72196 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(72233), // Rule ID 1120 //
     /*  72201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cntlzdm),
     /*  72209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72222 */     // (intrinsic_wo_chain:{ *:[i64] } 10585:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTLZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTLZDM),
     /*  72225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72227 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72229 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72231 */     GIR_RootConstrainSelectedInstOperands,
     /*  72232 */     // GIR_Coverage, 1120,
     /*  72232 */     GIR_EraseRootFromParent_Done,
     /*  72233 */   // Label 1160: @72233
     /*  72233 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(72270), // Rule ID 1121 //
     /*  72238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_cnttzdm),
     /*  72246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  72249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  72252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  72255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  72259 */     // (intrinsic_wo_chain:{ *:[i64] } 10586:{ *:[iPTR] }, i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)  =>  (CNTTZDM:{ *:[i64] } i64:{ *:[i64] }:$RST, i64:{ *:[i64] }:$RB)
     /*  72259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CNTTZDM),
     /*  72262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  72264 */     GIR_RootToRootCopy, /*OpIdx*/2, // RST
     /*  72266 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  72268 */     GIR_RootConstrainSelectedInstOperands,
     /*  72269 */     // GIR_Coverage, 1121,
     /*  72269 */     GIR_EraseRootFromParent_Done,
     /*  72270 */   // Label 1161: @72270
     /*  72270 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(72307), // Rule ID 1122 //
     /*  72275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrlb),
     /*  72283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72296 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10317:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRLB),
     /*  72299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72301 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72303 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72305 */     GIR_RootConstrainSelectedInstOperands,
     /*  72306 */     // GIR_Coverage, 1122,
     /*  72306 */     GIR_EraseRootFromParent_Done,
     /*  72307 */   // Label 1162: @72307
     /*  72307 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72344), // Rule ID 1123 //
     /*  72312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vclrrb),
     /*  72320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  72329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72333 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10318:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VCLRRB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VA, i32:{ *:[i32] }:$VB)
     /*  72333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VCLRRB),
     /*  72336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72338 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72340 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72342 */     GIR_RootConstrainSelectedInstOperands,
     /*  72343 */     // GIR_Coverage, 1123,
     /*  72343 */     GIR_EraseRootFromParent_Done,
     /*  72344 */   // Label 1163: @72344
     /*  72344 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(72381), // Rule ID 1137 //
     /*  72349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesw),
     /*  72357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72370 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10381:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVESW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESW),
     /*  72373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72375 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72377 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72379 */     GIR_RootConstrainSelectedInstOperands,
     /*  72380 */     // GIR_Coverage, 1137,
     /*  72380 */     GIR_EraseRootFromParent_Done,
     /*  72381 */   // Label 1164: @72381
     /*  72381 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(72418), // Rule ID 1138 //
     /*  72386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuw),
     /*  72394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72407 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10384:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VDIVEUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  72407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUW),
     /*  72410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72412 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72414 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72416 */     GIR_RootConstrainSelectedInstOperands,
     /*  72417 */     // GIR_Coverage, 1138,
     /*  72417 */     GIR_EraseRootFromParent_Done,
     /*  72418 */   // Label 1165: @72418
     /*  72418 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72455), // Rule ID 1139 //
     /*  72423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesd),
     /*  72431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10379:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVESD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESD),
     /*  72447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72449 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72451 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72453 */     GIR_RootConstrainSelectedInstOperands,
     /*  72454 */     // GIR_Coverage, 1139,
     /*  72454 */     GIR_EraseRootFromParent_Done,
     /*  72455 */   // Label 1166: @72455
     /*  72455 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72492), // Rule ID 1140 //
     /*  72460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveud),
     /*  72468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72481 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10382:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VDIVEUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUD),
     /*  72484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72486 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72488 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72490 */     GIR_RootConstrainSelectedInstOperands,
     /*  72491 */     // GIR_Coverage, 1140,
     /*  72491 */     GIR_EraseRootFromParent_Done,
     /*  72492 */   // Label 1167: @72492
     /*  72492 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72529), // Rule ID 1143 //
     /*  72497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulesd),
     /*  72505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72518 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10460:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULESD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULESD),
     /*  72521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72523 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72525 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72527 */     GIR_RootConstrainSelectedInstOperands,
     /*  72528 */     // GIR_Coverage, 1143,
     /*  72528 */     GIR_EraseRootFromParent_Done,
     /*  72529 */   // Label 1168: @72529
     /*  72529 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72566), // Rule ID 1144 //
     /*  72534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuleud),
     /*  72542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72555 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10464:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULEUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULEUD),
     /*  72558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72560 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72562 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72564 */     GIR_RootConstrainSelectedInstOperands,
     /*  72565 */     // GIR_Coverage, 1144,
     /*  72565 */     GIR_EraseRootFromParent_Done,
     /*  72566 */   // Label 1169: @72566
     /*  72566 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72603), // Rule ID 1145 //
     /*  72571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulosd),
     /*  72579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72592 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10472:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOSD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOSD),
     /*  72595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72597 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72599 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72601 */     GIR_RootConstrainSelectedInstOperands,
     /*  72602 */     // GIR_Coverage, 1145,
     /*  72602 */     GIR_EraseRootFromParent_Done,
     /*  72603 */   // Label 1170: @72603
     /*  72603 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72640), // Rule ID 1146 //
     /*  72608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmuloud),
     /*  72616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72629 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10476:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULOUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  72629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULOUD),
     /*  72632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72634 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72636 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72638 */     GIR_RootConstrainSelectedInstOperands,
     /*  72639 */     // GIR_Coverage, 1146,
     /*  72639 */     GIR_EraseRootFromParent_Done,
     /*  72640 */   // Label 1171: @72640
     /*  72640 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72677), // Rule ID 1150 //
     /*  72645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdivesq),
     /*  72653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72666 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10380:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVESQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVESQ),
     /*  72669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72671 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72673 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72675 */     GIR_RootConstrainSelectedInstOperands,
     /*  72676 */     // GIR_Coverage, 1150,
     /*  72676 */     GIR_EraseRootFromParent_Done,
     /*  72677 */   // Label 1172: @72677
     /*  72677 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72714), // Rule ID 1151 //
     /*  72682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vdiveuq),
     /*  72690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72703 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10383:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VDIVEUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VDIVEUQ),
     /*  72706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72708 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72710 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72712 */     GIR_RootConstrainSelectedInstOperands,
     /*  72713 */     // GIR_Coverage, 1151,
     /*  72713 */     GIR_EraseRootFromParent_Done,
     /*  72714 */   // Label 1173: @72714
     /*  72714 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72751), // Rule ID 1161 //
     /*  72719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqnm),
     /*  72727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  72730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  72733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  72736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72740 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10507:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)  =>  (VRLQNM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB)
     /*  72740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQNM),
     /*  72743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72745 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  72747 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  72749 */     GIR_RootConstrainSelectedInstOperands,
     /*  72750 */     // GIR_Coverage, 1161,
     /*  72750 */     GIR_EraseRootFromParent_Done,
     /*  72751 */   // Label 1174: @72751
     /*  72751 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72788), // Rule ID 1166 //
     /*  72756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  72759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxor),
     /*  72764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  72767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  72770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  72773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  72777 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10681:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)  =>  (DMXOR:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB)
     /*  72777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXOR),
     /*  72780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  72782 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  72784 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  72786 */     GIR_RootConstrainSelectedInstOperands,
     /*  72787 */     // GIR_Coverage, 1166,
     /*  72787 */     GIR_EraseRootFromParent_Done,
     /*  72788 */   // Label 1175: @72788
     /*  72788 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72845), // Rule ID 2911 //
     /*  72793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_PairedVectorMemops),
     /*  72796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_assemble_pair),
     /*  72801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v256s1,
     /*  72804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72814 */     // (intrinsic_wo_chain:{ *:[v256i1] } 10838:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vs1, v16i8:{ *:[v16i8] }:$vs0)  =>  (REG_SEQUENCE:{ *:[v256i1] } VSRpRC:{ *:[i32] }, ?:{ *:[v16i8] }:$vs0, sub_vsx1:{ *:[i32] }, ?:{ *:[v16i8] }:$vs1, sub_vsx0:{ *:[i32] })
     /*  72814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  72817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72819 */     GIR_RootToRootCopy, /*OpIdx*/3, // vs0
     /*  72821 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/22,
     /*  72824 */     GIR_RootToRootCopy, /*OpIdx*/2, // vs1
     /*  72826 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/21,
     /*  72829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRpRCRegClassID),
     /*  72834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  72844 */     // GIR_Coverage, 2911,
     /*  72844 */     GIR_EraseRootFromParent_Done,
     /*  72845 */   // Label 1176: @72845
     /*  72845 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72882), // Rule ID 3346 //
     /*  72850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsw),
     /*  72858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10468:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /*  72874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72876 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72878 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72880 */     GIR_RootConstrainSelectedInstOperands,
     /*  72881 */     // GIR_Coverage, 3346,
     /*  72881 */     GIR_EraseRootFromParent_Done,
     /*  72882 */   // Label 1177: @72882
     /*  72882 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72919), // Rule ID 3347 //
     /*  72887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhuw),
     /*  72895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72908 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10470:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VMULHUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /*  72908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /*  72911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72913 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72915 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72917 */     GIR_RootConstrainSelectedInstOperands,
     /*  72918 */     // GIR_Coverage, 3347,
     /*  72918 */     GIR_EraseRootFromParent_Done,
     /*  72919 */   // Label 1178: @72919
     /*  72919 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72956), // Rule ID 3348 //
     /*  72924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhsd),
     /*  72932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72945 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10467:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHSD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /*  72948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72950 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72952 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72954 */     GIR_RootConstrainSelectedInstOperands,
     /*  72955 */     // GIR_Coverage, 3348,
     /*  72955 */     GIR_EraseRootFromParent_Done,
     /*  72956 */   // Label 1179: @72956
     /*  72956 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72993), // Rule ID 3349 //
     /*  72961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  72964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmulhud),
     /*  72969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  72972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  72975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  72978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  72982 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10469:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VMULHUD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /*  72982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /*  72985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  72987 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  72989 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  72991 */     GIR_RootConstrainSelectedInstOperands,
     /*  72992 */     // GIR_Coverage, 3349,
     /*  72992 */     GIR_EraseRootFromParent_Done,
     /*  72993 */   // Label 1180: @72993
     /*  72993 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73052), // Rule ID 3516 //
     /*  72998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4),
     /*  73006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  73009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  73019 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10692:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73035 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4),
     /*  73043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73045 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  73047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73050 */     GIR_RootConstrainSelectedInstOperands,
     /*  73051 */     // GIR_Coverage, 3516,
     /*  73051 */     GIR_EraseRootFromParent_Done,
     /*  73052 */   // Label 1181: @73052
     /*  73052 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73111), // Rule ID 3519 //
     /*  73057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2),
     /*  73065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  73068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  73078 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10682:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2),
     /*  73102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73104 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  73106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73109 */     GIR_RootConstrainSelectedInstOperands,
     /*  73110 */     // GIR_Coverage, 3519,
     /*  73110 */     GIR_EraseRootFromParent_Done,
     /*  73111 */   // Label 1182: @73111
     /*  73111 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73170), // Rule ID 3524 //
     /*  73116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2),
     /*  73124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  73127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  73137 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10687:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2),
     /*  73161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73163 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  73165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73168 */     GIR_RootConstrainSelectedInstOperands,
     /*  73169 */     // GIR_Coverage, 3524,
     /*  73169 */     GIR_EraseRootFromParent_Done,
     /*  73170 */   // Label 1183: @73170
     /*  73170 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73251), // Rule ID 3543 //
     /*  73175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  73183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73196 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10766:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73196 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73199 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73203 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73208 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73229 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8),
     /*  73241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73249 */     GIR_RootConstrainSelectedInstOperands,
     /*  73250 */     // GIR_Coverage, 3543,
     /*  73250 */     GIR_EraseRootFromParent_Done,
     /*  73251 */   // Label 1184: @73251
     /*  73251 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73332), // Rule ID 3545 //
     /*  73256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73277 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73277 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73280 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73284 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73289 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4),
     /*  73322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73330 */     GIR_RootConstrainSelectedInstOperands,
     /*  73331 */     // GIR_Coverage, 3545,
     /*  73331 */     GIR_EraseRootFromParent_Done,
     /*  73332 */   // Label 1185: @73332
     /*  73332 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73413), // Rule ID 3547 //
     /*  73337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73358 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10764:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2S),
     /*  73403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73411 */     GIR_RootConstrainSelectedInstOperands,
     /*  73412 */     // GIR_Coverage, 3547,
     /*  73412 */     GIR_EraseRootFromParent_Done,
     /*  73413 */   // Label 1186: @73413
     /*  73413 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73494), // Rule ID 3549 //
     /*  73418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8),
     /*  73426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73439 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10766:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73439 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73442 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73446 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73451 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73455 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73472 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8W),
     /*  73484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73492 */     GIR_RootConstrainSelectedInstOperands,
     /*  73493 */     // GIR_Coverage, 3549,
     /*  73493 */     GIR_EraseRootFromParent_Done,
     /*  73494 */   // Label 1187: @73494
     /*  73494 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73575), // Rule ID 3551 //
     /*  73499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4),
     /*  73507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73520 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73520 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73523 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73527 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73532 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73536 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73553 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4W),
     /*  73565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73573 */     GIR_RootConstrainSelectedInstOperands,
     /*  73574 */     // GIR_Coverage, 3551,
     /*  73574 */     GIR_EraseRootFromParent_Done,
     /*  73575 */   // Label 1188: @73575
     /*  73575 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73656), // Rule ID 3553 //
     /*  73580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2s),
     /*  73588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73601 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10764:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73601 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73604 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73608 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73613 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SW),
     /*  73646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73654 */     GIR_RootConstrainSelectedInstOperands,
     /*  73655 */     // GIR_Coverage, 3553,
     /*  73655 */     GIR_EraseRootFromParent_Done,
     /*  73656 */   // Label 1189: @73656
     /*  73656 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73737), // Rule ID 3555 //
     /*  73661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73682 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10747:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73719 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2),
     /*  73727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73735 */     GIR_RootConstrainSelectedInstOperands,
     /*  73736 */     // GIR_Coverage, 3555,
     /*  73736 */     GIR_EraseRootFromParent_Done,
     /*  73737 */   // Label 1190: @73737
     /*  73737 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73818), // Rule ID 3560 //
     /*  73742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  73745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2),
     /*  73750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  73763 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10747:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73779 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73796 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2W),
     /*  73808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73816 */     GIR_RootConstrainSelectedInstOperands,
     /*  73817 */     // GIR_Coverage, 3560,
     /*  73817 */     GIR_EraseRootFromParent_Done,
     /*  73818 */   // Label 1191: @73818
     /*  73818 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73899), // Rule ID 3565 //
     /*  73823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  73831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73844 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10752:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73856 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73860 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73877 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  73881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GER),
     /*  73889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  73897 */     GIR_RootConstrainSelectedInstOperands,
     /*  73898 */     // GIR_Coverage, 3565,
     /*  73898 */     GIR_EraseRootFromParent_Done,
     /*  73899 */   // Label 1192: @73899
     /*  73899 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73958), // Rule ID 3570 //
     /*  73904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  73912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  73918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73925 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10757:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73937 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  73941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  73946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GER),
     /*  73949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  73951 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  73953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73956 */     GIR_RootConstrainSelectedInstOperands,
     /*  73957 */     // GIR_Coverage, 3570,
     /*  73957 */     GIR_EraseRootFromParent_Done,
     /*  73958 */   // Label 1193: @73958
     /*  73958 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74039), // Rule ID 3575 //
     /*  73963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  73966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  73971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  73974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  73984 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10742:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  73984 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  73987 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73991 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73996 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74017 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2),
     /*  74029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74037 */     GIR_RootConstrainSelectedInstOperands,
     /*  74038 */     // GIR_Coverage, 3575,
     /*  74038 */     GIR_EraseRootFromParent_Done,
     /*  74039 */   // Label 1194: @74039
     /*  74039 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74120), // Rule ID 3580 //
     /*  74044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  74047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  74052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  74065 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10762:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74065 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74068 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74072 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74081 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74098 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2),
     /*  74110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74118 */     GIR_RootConstrainSelectedInstOperands,
     /*  74119 */     // GIR_Coverage, 3580,
     /*  74119 */     GIR_EraseRootFromParent_Done,
     /*  74120 */   // Label 1195: @74120
     /*  74120 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74201), // Rule ID 3583 //
     /*  74125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32ger),
     /*  74133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74146 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10752:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74162 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74179 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERW),
     /*  74191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74199 */     GIR_RootConstrainSelectedInstOperands,
     /*  74200 */     // GIR_Coverage, 3583,
     /*  74200 */     GIR_EraseRootFromParent_Done,
     /*  74201 */   // Label 1196: @74201
     /*  74201 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74260), // Rule ID 3588 //
     /*  74206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64ger),
     /*  74214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  74220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74227 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10757:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERW),
     /*  74251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74253 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  74255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74258 */     GIR_RootConstrainSelectedInstOperands,
     /*  74259 */     // GIR_Coverage, 3588,
     /*  74259 */     GIR_EraseRootFromParent_Done,
     /*  74260 */   // Label 1197: @74260
     /*  74260 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74341), // Rule ID 3593 //
     /*  74265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2),
     /*  74273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74286 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10742:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74302 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74319 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2W),
     /*  74331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74339 */     GIR_RootConstrainSelectedInstOperands,
     /*  74340 */     // GIR_Coverage, 3593,
     /*  74340 */     GIR_EraseRootFromParent_Done,
     /*  74341 */   // Label 1198: @74341
     /*  74341 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74422), // Rule ID 3598 //
     /*  74346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  74349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2),
     /*  74354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  74357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  74367 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10762:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  74367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  74370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  74383 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  74395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  74404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2W),
     /*  74412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  74414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  74420 */     GIR_RootConstrainSelectedInstOperands,
     /*  74421 */     // GIR_Coverage, 3598,
     /*  74421 */     GIR_EraseRootFromParent_Done,
     /*  74422 */   // Label 1199: @74422
     /*  74422 */   GIM_Reject,
     /*  74423 */ // Label 998: @74423
     /*  74423 */ GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(81793),
     /*  74428 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  74431 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74489), // Rule ID 1011 //
     /*  74436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /*  74468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /*  74472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74474 */     // (intrinsic_wo_chain:{ *:[f128] } 10630:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQPO),
     /*  74477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /*  74483 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74485 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74487 */     GIR_RootConstrainSelectedInstOperands,
     /*  74488 */     // GIR_Coverage, 1011,
     /*  74488 */     GIR_EraseRootFromParent_Done,
     /*  74489 */   // Label 1201: @74489
     /*  74489 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74542), // Rule ID 2173 //
     /*  74494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxinsertw),
     /*  74502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  74518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  74522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  74526 */     // MIs[1] Operand 1
     /*  74526 */     // No operand predicates
     /*  74526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74528 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10917:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v2i64:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)  =>  (XXINSERTW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v2i64] }:$B, (imm:{ *:[i32] }):$IMM)
     /*  74528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXINSERTW),
     /*  74531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74533 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74535 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // IMM
     /*  74540 */     GIR_RootConstrainSelectedInstOperands,
     /*  74541 */     // GIR_Coverage, 2173,
     /*  74541 */     GIR_EraseRootFromParent_Done,
     /*  74542 */   // Label 1202: @74542
     /*  74542 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74584), // Rule ID 1010 //
     /*  74547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /*  74550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /*  74555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  74558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  74561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  74564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  74567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74571 */     // (intrinsic_wo_chain:{ *:[f128] } 10630:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /*  74571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQPO),
     /*  74574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  74576 */     GIR_RootToRootCopy, /*OpIdx*/4, // RSTi
     /*  74578 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  74580 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  74582 */     GIR_RootConstrainSelectedInstOperands,
     /*  74583 */     // GIR_Coverage, 1010,
     /*  74583 */     GIR_EraseRootFromParent_Done,
     /*  74584 */   // Label 1203: @74584
     /*  74584 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74626), // Rule ID 1752 //
     /*  74589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  74597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74613 */     // (intrinsic_wo_chain:{ *:[f64] } 10631:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSMSUBMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMDP),
     /*  74616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74618 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74620 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74622 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74624 */     GIR_RootConstrainSelectedInstOperands,
     /*  74625 */     // GIR_Coverage, 1752,
     /*  74625 */     GIR_EraseRootFromParent_Done,
     /*  74626 */   // Label 1204: @74626
     /*  74626 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74668), // Rule ID 1753 //
     /*  74631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /*  74634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  74639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  74642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  74645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  74651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /*  74655 */     // (intrinsic_wo_chain:{ *:[f64] } 10635:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (XSNMADDMDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  74655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMDP),
     /*  74658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74660 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74662 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74664 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74666 */     GIR_RootConstrainSelectedInstOperands,
     /*  74667 */     // GIR_Coverage, 1753,
     /*  74667 */     GIR_EraseRootFromParent_Done,
     /*  74668 */   // Label 1205: @74668
     /*  74668 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(74710), // Rule ID 1939 //
     /*  74673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  74681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74697 */     // (intrinsic_wo_chain:{ *:[f32] } 10632:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSMSUBMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBMSP),
     /*  74700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74702 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74704 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74706 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74708 */     GIR_RootConstrainSelectedInstOperands,
     /*  74709 */     // GIR_Coverage, 1939,
     /*  74709 */     GIR_EraseRootFromParent_Done,
     /*  74710 */   // Label 1206: @74710
     /*  74710 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(74752), // Rule ID 1940 //
     /*  74715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /*  74718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  74723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  74726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  74729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /*  74739 */     // (intrinsic_wo_chain:{ *:[f32] } 10636:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (XSNMADDMSP:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  74739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDMSP),
     /*  74742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  74744 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  74746 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  74748 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  74750 */     GIR_RootConstrainSelectedInstOperands,
     /*  74751 */     // GIR_Coverage, 1940,
     /*  74751 */     GIR_EraseRootFromParent_Done,
     /*  74752 */   // Label 1207: @74752
     /*  74752 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(74794), // Rule ID 508 //
     /*  74757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmaw),
     /*  74765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74775 */     // MIs[0] ST
     /*  74775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74778 */     // MIs[0] SIX
     /*  74778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74781 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10267:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAW),
     /*  74784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74786 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74788 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74790 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74792 */     GIR_RootConstrainSelectedInstOperands,
     /*  74793 */     // GIR_Coverage, 508,
     /*  74793 */     GIR_EraseRootFromParent_Done,
     /*  74794 */   // Label 1208: @74794
     /*  74794 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(74836), // Rule ID 509 //
     /*  74799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Crypto),
     /*  74802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vshasigmad),
     /*  74807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74817 */     // MIs[0] ST
     /*  74817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  74820 */     // MIs[0] SIX
     /*  74820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74823 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10266:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)  =>  (VSHASIGMAD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, (timm:{ *:[i32] }):$ST, (timm:{ *:[i32] }):$SIX)
     /*  74823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSHASIGMAD),
     /*  74826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74828 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  74830 */     GIR_RootToRootCopy, /*OpIdx*/3, // ST
     /*  74832 */     GIR_RootToRootCopy, /*OpIdx*/4, // SIX
     /*  74834 */     GIR_RootConstrainSelectedInstOperands,
     /*  74835 */     // GIR_Coverage, 509,
     /*  74835 */     GIR_EraseRootFromParent_Done,
     /*  74836 */   // Label 1209: @74836
     /*  74836 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(74878), // Rule ID 1060 //
     /*  74841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsldbi),
     /*  74849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74862 */     // MIs[0] SD
     /*  74862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74865 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10515:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSLDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLDBI),
     /*  74868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74870 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74872 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74874 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74876 */     GIR_RootConstrainSelectedInstOperands,
     /*  74877 */     // GIR_Coverage, 1060,
     /*  74877 */     GIR_EraseRootFromParent_Done,
     /*  74878 */   // Label 1210: @74878
     /*  74878 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(74920), // Rule ID 1061 //
     /*  74883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsrdbi),
     /*  74891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  74894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74904 */     // MIs[0] SD
     /*  74904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74907 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10525:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)  =>  (VSRDBI:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VRA, v16i8:{ *:[v16i8] }:$VRB, (timm:{ *:[i32] }):$SD)
     /*  74907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRDBI),
     /*  74910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /*  74912 */     GIR_RootToRootCopy, /*OpIdx*/2, // VRA
     /*  74914 */     GIR_RootToRootCopy, /*OpIdx*/3, // VRB
     /*  74916 */     GIR_RootToRootCopy, /*OpIdx*/4, // SD
     /*  74918 */     GIR_RootConstrainSelectedInstOperands,
     /*  74919 */     // GIR_Coverage, 1061,
     /*  74919 */     GIR_EraseRootFromParent_Done,
     /*  74920 */   // Label 1211: @74920
     /*  74920 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(74962), // Rule ID 1066 //
     /*  74925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsw),
     /*  74933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74946 */     // MIs[0] VA
     /*  74946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74949 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10423:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, (timm:{ *:[i32] }):$VA, i32:{ *:[i32] }:$VB)
     /*  74949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSW),
     /*  74952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74954 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74956 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  74958 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  74960 */     GIR_RootConstrainSelectedInstOperands,
     /*  74961 */     // GIR_Coverage, 1066,
     /*  74961 */     GIR_EraseRootFromParent_Done,
     /*  74962 */   // Label 1212: @74962
     /*  74962 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(75004), // Rule ID 1067 //
     /*  74967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  74970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsd),
     /*  74975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  74984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  74988 */     // MIs[0] VA
     /*  74988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  74991 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10416:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VB, (timm:{ *:[i32] }):$VA)  =>  (VINSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, (timm:{ *:[i32] }):$VA, i64:{ *:[i64] }:$VB)
     /*  74991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSD),
     /*  74994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  74996 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  74998 */     GIR_RootToRootCopy, /*OpIdx*/4, // VA
     /*  75000 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75002 */     GIR_RootConstrainSelectedInstOperands,
     /*  75003 */     // GIR_Coverage, 1067,
     /*  75003 */     GIR_EraseRootFromParent_Done,
     /*  75004 */   // Label 1213: @75004
     /*  75004 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75046), // Rule ID 1168 //
     /*  75009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  75012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmsha2hash),
     /*  75017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  75020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  75023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v1024s1,
     /*  75026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  75030 */     // MIs[0] T
     /*  75030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75033 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10679:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB, (timm:{ *:[i32] }):$T)  =>  (DMSHA2HASH:{ *:[v1024i1] } v1024i1:{ *:[v1024i1] }:$ATi, v1024i1:{ *:[v1024i1] }:$AB, (timm:{ *:[i32] }):$T)
     /*  75033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMSHA2HASH),
     /*  75036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  75038 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  75040 */     GIR_RootToRootCopy, /*OpIdx*/3, // AB
     /*  75042 */     GIR_RootToRootCopy, /*OpIdx*/4, // T
     /*  75044 */     GIR_RootConstrainSelectedInstOperands,
     /*  75045 */     // GIR_Coverage, 1168,
     /*  75045 */     GIR_EraseRootFromParent_Done,
     /*  75046 */   // Label 1214: @75046
     /*  75046 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75091), // Rule ID 1450 //
     /*  75051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdadd),
     /*  75059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75072 */     // MIs[0] PS
     /*  75072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75075 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10570:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDADD_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  75075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDADD_rec),
     /*  75078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75080 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  75082 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  75084 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  75086 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  75089 */     GIR_RootConstrainSelectedInstOperands,
     /*  75090 */     // GIR_Coverage, 1450,
     /*  75090 */     GIR_EraseRootFromParent_Done,
     /*  75091 */   // Label 1215: @75091
     /*  75091 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75136), // Rule ID 1451 //
     /*  75096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_bcdsub),
     /*  75104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75117 */     // MIs[0] PS
     /*  75117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  75120 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10572:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, (timm:{ *:[i32] }):$PS)  =>  (BCDSUB_rec:{ *:[v16i8] }:{ *:[i32] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB, ?:{ *:[i32] }:$PS)
     /*  75120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::BCDSUB_rec),
     /*  75123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75125 */     GIR_RootToRootCopy, /*OpIdx*/2, // vA
     /*  75127 */     GIR_RootToRootCopy, /*OpIdx*/3, // vB
     /*  75129 */     GIR_RootToRootCopy, /*OpIdx*/4, // PS
     /*  75131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR6*/0,
     /*  75134 */     GIR_RootConstrainSelectedInstOperands,
     /*  75135 */     // GIR_Coverage, 1451,
     /*  75135 */     GIR_EraseRootFromParent_Done,
     /*  75136 */   // Label 1216: @75136
     /*  75136 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75190), // Rule ID 1566 //
     /*  75141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhd),
     /*  75149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75177 */     // (intrinsic_wo_chain:{ *:[i64] } 10662:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHD:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHD),
     /*  75180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75182 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75184 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75186 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75188 */     GIR_RootConstrainSelectedInstOperands,
     /*  75189 */     // GIR_Coverage, 1566,
     /*  75189 */     GIR_EraseRootFromParent_Done,
     /*  75190 */   // Label 1217: @75190
     /*  75190 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75244), // Rule ID 1567 //
     /*  75195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddhdu),
     /*  75203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75231 */     // (intrinsic_wo_chain:{ *:[i64] } 10663:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDHDU:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDHDU),
     /*  75234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75236 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75238 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75240 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75242 */     GIR_RootConstrainSelectedInstOperands,
     /*  75243 */     // GIR_Coverage, 1567,
     /*  75243 */     GIR_EraseRootFromParent_Done,
     /*  75244 */   // Label 1218: @75244
     /*  75244 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75298), // Rule ID 1568 //
     /*  75249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode_IsISA3_0),
     /*  75252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_maddld),
     /*  75257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  75285 */     // (intrinsic_wo_chain:{ *:[i64] } 10664:{ *:[iPTR] }, g8rc:{ *:[i64] }:$a, g8rc:{ *:[i64] }:$b, g8rc:{ *:[i64] }:$c)  =>  (MADDLD8:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c)
     /*  75285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MADDLD8),
     /*  75288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75290 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  75292 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  75294 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  75296 */     GIR_RootConstrainSelectedInstOperands,
     /*  75297 */     // GIR_Coverage, 1568,
     /*  75297 */     GIR_EraseRootFromParent_Done,
     /*  75298 */   // Label 1219: @75298
     /*  75298 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(75349), // Rule ID 4857 //
     /*  75303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fsel),
     /*  75308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  75311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  75314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  75317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  75320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  75336 */     // (intrinsic_wo_chain:{ *:[f64] } 10642:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FRA, f8rc:{ *:[f64] }:$FRC, f8rc:{ *:[f64] }:$FRB)  =>  (FSELD:{ *:[f64] } ?:{ *:[f64] }:$FRA, ?:{ *:[f64] }:$FRC, ?:{ *:[f64] }:$FRB)
     /*  75336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FSELD),
     /*  75339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  75341 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRA
     /*  75343 */     GIR_RootToRootCopy, /*OpIdx*/3, // FRC
     /*  75345 */     GIR_RootToRootCopy, /*OpIdx*/4, // FRB
     /*  75347 */     GIR_RootConstrainSelectedInstOperands,
     /*  75348 */     // GIR_Coverage, 4857,
     /*  75348 */     GIR_EraseRootFromParent_Done,
     /*  75349 */   // Label 1220: @75349
     /*  75349 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(75391), // Rule ID 296 //
     /*  75354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmladduhm),
     /*  75362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75378 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10450:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMLADDUHM:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  75378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMLADDUHM),
     /*  75381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75383 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75385 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75387 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75389 */     GIR_RootConstrainSelectedInstOperands,
     /*  75390 */     // GIR_Coverage, 296,
     /*  75390 */     GIR_EraseRootFromParent_Done,
     /*  75391 */   // Label 1221: @75391
     /*  75391 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(75433), // Rule ID 297 //
     /*  75396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vperm),
     /*  75404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75420 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10481:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)  =>  (VPERM:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v16i8:{ *:[v16i8] }:$RC)
     /*  75420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERM),
     /*  75423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75425 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75427 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75429 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75431 */     GIR_RootConstrainSelectedInstOperands,
     /*  75432 */     // GIR_Coverage, 297,
     /*  75432 */     GIR_EraseRootFromParent_Done,
     /*  75433 */   // Label 1222: @75433
     /*  75433 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(75475), // Rule ID 298 //
     /*  75438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsel),
     /*  75446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75462 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10512:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VSEL:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /*  75465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75467 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75469 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75471 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75473 */     GIR_RootConstrainSelectedInstOperands,
     /*  75474 */     // GIR_Coverage, 298,
     /*  75474 */     GIR_EraseRootFromParent_Done,
     /*  75475 */   // Label 1223: @75475
     /*  75475 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(75517), // Rule ID 349 //
     /*  75480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsummbm),
     /*  75488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75504 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10452:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMMBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMMBM),
     /*  75507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75509 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75511 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75513 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75515 */     GIR_RootConstrainSelectedInstOperands,
     /*  75516 */     // GIR_Coverage, 349,
     /*  75516 */     GIR_EraseRootFromParent_Done,
     /*  75517 */   // Label 1224: @75517
     /*  75517 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(75559), // Rule ID 350 //
     /*  75522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshm),
     /*  75530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75546 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10453:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHM),
     /*  75549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75551 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75553 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75555 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75557 */     GIR_RootConstrainSelectedInstOperands,
     /*  75558 */     // GIR_Coverage, 350,
     /*  75558 */     GIR_EraseRootFromParent_Done,
     /*  75559 */   // Label 1225: @75559
     /*  75559 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(75601), // Rule ID 351 //
     /*  75564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumubm),
     /*  75572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  75581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10455:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUBM:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUBM),
     /*  75591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75593 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75595 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75597 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75599 */     GIR_RootConstrainSelectedInstOperands,
     /*  75600 */     // GIR_Coverage, 351,
     /*  75600 */     GIR_EraseRootFromParent_Done,
     /*  75601 */   // Label 1226: @75601
     /*  75601 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(75643), // Rule ID 352 //
     /*  75606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  75609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhm),
     /*  75614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75630 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10457:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHM:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  75630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHM),
     /*  75633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75635 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75637 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75639 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75641 */     GIR_RootConstrainSelectedInstOperands,
     /*  75642 */     // GIR_Coverage, 352,
     /*  75642 */     GIR_EraseRootFromParent_Done,
     /*  75643 */   // Label 1227: @75643
     /*  75643 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(75685), // Rule ID 471 //
     /*  75648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddeuqm),
     /*  75656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75672 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10299:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDEUQM),
     /*  75675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75677 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75679 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75681 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75683 */     GIR_RootConstrainSelectedInstOperands,
     /*  75684 */     // GIR_Coverage, 471,
     /*  75684 */     GIR_EraseRootFromParent_Done,
     /*  75685 */   // Label 1228: @75685
     /*  75685 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(75727), // Rule ID 473 //
     /*  75690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vaddecuq),
     /*  75698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75714 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10298:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VADDECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VADDECUQ),
     /*  75717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75719 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75721 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75723 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75725 */     GIR_RootConstrainSelectedInstOperands,
     /*  75726 */     // GIR_Coverage, 473,
     /*  75726 */     GIR_EraseRootFromParent_Done,
     /*  75727 */   // Label 1229: @75727
     /*  75727 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(75769), // Rule ID 476 //
     /*  75732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubeuqm),
     /*  75740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75756 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10541:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBEUQM:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBEUQM),
     /*  75759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75761 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75763 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75765 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75767 */     GIR_RootConstrainSelectedInstOperands,
     /*  75768 */     // GIR_Coverage, 476,
     /*  75768 */     GIR_EraseRootFromParent_Done,
     /*  75769 */   // Label 1230: @75769
     /*  75769 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(75811), // Rule ID 478 //
     /*  75774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  75777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsubecuq),
     /*  75782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  75788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  75791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75798 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10540:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VSUBECUQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$RA, v1i128:{ *:[v1i128] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUBECUQ),
     /*  75801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75803 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75805 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75807 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75809 */     GIR_RootConstrainSelectedInstOperands,
     /*  75810 */     // GIR_Coverage, 478,
     /*  75810 */     GIR_EraseRootFromParent_Done,
     /*  75811 */   // Label 1231: @75811
     /*  75811 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(75853), // Rule ID 515 //
     /*  75816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumudm),
     /*  75824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  75827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  75836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75840 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10456:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMUDM:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  75840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUDM),
     /*  75843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  75845 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  75847 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  75849 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  75851 */     GIR_RootConstrainSelectedInstOperands,
     /*  75852 */     // GIR_Coverage, 515,
     /*  75852 */     GIR_EraseRootFromParent_Done,
     /*  75853 */   // Label 1232: @75853
     /*  75853 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(75895), // Rule ID 548 //
     /*  75858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlwmi),
     /*  75866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75882 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10509:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)  =>  (VRLWMI:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB, v4i32:{ *:[v4i32] }:$VDi)
     /*  75882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLWMI),
     /*  75885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75887 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75889 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75891 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75893 */     GIR_RootConstrainSelectedInstOperands,
     /*  75894 */     // GIR_Coverage, 548,
     /*  75894 */     GIR_EraseRootFromParent_Done,
     /*  75895 */   // Label 1233: @75895
     /*  75895 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(75937), // Rule ID 550 //
     /*  75900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /*  75903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrldmi),
     /*  75908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  75917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  75920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75924 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10503:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)  =>  (VRLDMI:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB, v2i64:{ *:[v2i64] }:$VDi)
     /*  75924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLDMI),
     /*  75927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75929 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  75931 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  75933 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  75935 */     GIR_RootConstrainSelectedInstOperands,
     /*  75936 */     // GIR_Coverage, 550,
     /*  75936 */     GIR_EraseRootFromParent_Done,
     /*  75937 */   // Label 1234: @75937
     /*  75937 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(75979), // Rule ID 1068 //
     /*  75942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvlx),
     /*  75950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  75966 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10414:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  75966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVLX),
     /*  75969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  75971 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  75973 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  75975 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  75977 */     GIR_RootConstrainSelectedInstOperands,
     /*  75978 */     // GIR_Coverage, 1068,
     /*  75978 */     GIR_EraseRootFromParent_Done,
     /*  75979 */   // Label 1235: @75979
     /*  75979 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(76021), // Rule ID 1069 //
     /*  75984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  75987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbvrx),
     /*  75992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  75998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76008 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10415:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)  =>  (VINSBVRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, v16i8:{ *:[v16i8] }:$VB)
     /*  76008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBVRX),
     /*  76011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76013 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76015 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76017 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76019 */     GIR_RootConstrainSelectedInstOperands,
     /*  76020 */     // GIR_Coverage, 1069,
     /*  76020 */     GIR_EraseRootFromParent_Done,
     /*  76021 */   // Label 1236: @76021
     /*  76021 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(76063), // Rule ID 1070 //
     /*  76026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvlx),
     /*  76034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76050 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10421:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  76050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVLX),
     /*  76053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76055 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76057 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76059 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76061 */     GIR_RootConstrainSelectedInstOperands,
     /*  76062 */     // GIR_Coverage, 1070,
     /*  76062 */     GIR_EraseRootFromParent_Done,
     /*  76063 */   // Label 1237: @76063
     /*  76063 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(76105), // Rule ID 1071 //
     /*  76068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshvrx),
     /*  76076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76092 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10422:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VINSHVRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  76092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHVRX),
     /*  76095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76097 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76099 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76101 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76103 */     GIR_RootConstrainSelectedInstOperands,
     /*  76104 */     // GIR_Coverage, 1071,
     /*  76104 */     GIR_EraseRootFromParent_Done,
     /*  76105 */   // Label 1238: @76105
     /*  76105 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(76147), // Rule ID 1072 //
     /*  76110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvlx),
     /*  76118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76134 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10426:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  76134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVLX),
     /*  76137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76139 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76141 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76143 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76145 */     GIR_RootConstrainSelectedInstOperands,
     /*  76146 */     // GIR_Coverage, 1072,
     /*  76146 */     GIR_EraseRootFromParent_Done,
     /*  76147 */   // Label 1239: @76147
     /*  76147 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(76189), // Rule ID 1073 //
     /*  76152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswvrx),
     /*  76160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76176 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10427:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VINSWVRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  76176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWVRX),
     /*  76179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76181 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76183 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76185 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76187 */     GIR_RootConstrainSelectedInstOperands,
     /*  76188 */     // GIR_Coverage, 1073,
     /*  76188 */     GIR_EraseRootFromParent_Done,
     /*  76189 */   // Label 1240: @76189
     /*  76189 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(76231), // Rule ID 1074 //
     /*  76194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsblx),
     /*  76202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76218 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10412:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBLX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /*  76221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76223 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76225 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76227 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76229 */     GIR_RootConstrainSelectedInstOperands,
     /*  76230 */     // GIR_Coverage, 1074,
     /*  76230 */     GIR_EraseRootFromParent_Done,
     /*  76231 */   // Label 1241: @76231
     /*  76231 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(76273), // Rule ID 1075 //
     /*  76236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsbrx),
     /*  76244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  76247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76260 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10413:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSBRX:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBRX),
     /*  76263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76265 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76267 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76269 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76271 */     GIR_RootConstrainSelectedInstOperands,
     /*  76272 */     // GIR_Coverage, 1075,
     /*  76272 */     GIR_EraseRootFromParent_Done,
     /*  76273 */   // Label 1242: @76273
     /*  76273 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(76315), // Rule ID 1076 //
     /*  76278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshlx),
     /*  76286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76302 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10419:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHLX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /*  76305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76307 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76309 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76311 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76313 */     GIR_RootConstrainSelectedInstOperands,
     /*  76314 */     // GIR_Coverage, 1076,
     /*  76314 */     GIR_EraseRootFromParent_Done,
     /*  76315 */   // Label 1243: @76315
     /*  76315 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(76357), // Rule ID 1077 //
     /*  76320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinshrx),
     /*  76328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76344 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10420:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSHRX:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHRX),
     /*  76347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76349 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76351 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76353 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76355 */     GIR_RootConstrainSelectedInstOperands,
     /*  76356 */     // GIR_Coverage, 1077,
     /*  76356 */     GIR_EraseRootFromParent_Done,
     /*  76357 */   // Label 1244: @76357
     /*  76357 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(76399), // Rule ID 1078 //
     /*  76362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswlx),
     /*  76370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76386 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10424:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWLX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWLX),
     /*  76389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76391 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76393 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76395 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76397 */     GIR_RootConstrainSelectedInstOperands,
     /*  76398 */     // GIR_Coverage, 1078,
     /*  76398 */     GIR_EraseRootFromParent_Done,
     /*  76399 */   // Label 1245: @76399
     /*  76399 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(76441), // Rule ID 1079 //
     /*  76404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinswrx),
     /*  76412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76428 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10425:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)  =>  (VINSWRX:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VDi, i32:{ *:[i32] }:$VA, i32:{ *:[i32] }:$VB)
     /*  76428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSWRX),
     /*  76431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76433 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76435 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76437 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76439 */     GIR_RootConstrainSelectedInstOperands,
     /*  76440 */     // GIR_Coverage, 1079,
     /*  76440 */     GIR_EraseRootFromParent_Done,
     /*  76441 */   // Label 1246: @76441
     /*  76441 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(76483), // Rule ID 1080 //
     /*  76446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdlx),
     /*  76454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76470 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10417:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDLX),
     /*  76473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76475 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76477 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76479 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76481 */     GIR_RootConstrainSelectedInstOperands,
     /*  76482 */     // GIR_Coverage, 1080,
     /*  76482 */     GIR_EraseRootFromParent_Done,
     /*  76483 */   // Label 1247: @76483
     /*  76483 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(76525), // Rule ID 1081 //
     /*  76488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vinsdrx),
     /*  76496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76512 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10418:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)  =>  (VINSDRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VDi, i64:{ *:[i64] }:$VA, i64:{ *:[i64] }:$VB)
     /*  76512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSDRX),
     /*  76515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76517 */     GIR_RootToRootCopy, /*OpIdx*/2, // VDi
     /*  76519 */     GIR_RootToRootCopy, /*OpIdx*/3, // VA
     /*  76521 */     GIR_RootToRootCopy, /*OpIdx*/4, // VB
     /*  76523 */     GIR_RootConstrainSelectedInstOperands,
     /*  76524 */     // GIR_Coverage, 1081,
     /*  76524 */     GIR_EraseRootFromParent_Done,
     /*  76525 */   // Label 1248: @76525
     /*  76525 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(76567), // Rule ID 1102 //
     /*  76530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvlx),
     /*  76538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76554 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10393:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVLX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVLX),
     /*  76557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76559 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76561 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76563 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76565 */     GIR_RootConstrainSelectedInstOperands,
     /*  76566 */     // GIR_Coverage, 1102,
     /*  76566 */     GIR_EraseRootFromParent_Done,
     /*  76567 */   // Label 1249: @76567
     /*  76567 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(76609), // Rule ID 1103 //
     /*  76572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextdubvrx),
     /*  76580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  76586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  76589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10394:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUBVRX:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$RA, v16i8:{ *:[v16i8] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUBVRX),
     /*  76599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76601 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76603 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76605 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76607 */     GIR_RootConstrainSelectedInstOperands,
     /*  76608 */     // GIR_Coverage, 1103,
     /*  76608 */     GIR_EraseRootFromParent_Done,
     /*  76609 */   // Label 1250: @76609
     /*  76609 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(76651), // Rule ID 1104 //
     /*  76614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvlx),
     /*  76622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76638 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10395:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVLX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVLX),
     /*  76641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76643 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76645 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76647 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76649 */     GIR_RootConstrainSelectedInstOperands,
     /*  76650 */     // GIR_Coverage, 1104,
     /*  76650 */     GIR_EraseRootFromParent_Done,
     /*  76651 */   // Label 1251: @76651
     /*  76651 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(76693), // Rule ID 1105 //
     /*  76656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduhvrx),
     /*  76664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76680 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10396:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUHVRX:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUHVRX),
     /*  76683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76685 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76687 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76689 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76691 */     GIR_RootConstrainSelectedInstOperands,
     /*  76692 */     // GIR_Coverage, 1105,
     /*  76692 */     GIR_EraseRootFromParent_Done,
     /*  76693 */   // Label 1252: @76693
     /*  76693 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(76735), // Rule ID 1106 //
     /*  76698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvlx),
     /*  76706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76722 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10397:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVLX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVLX),
     /*  76725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76727 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76729 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76731 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76733 */     GIR_RootConstrainSelectedInstOperands,
     /*  76734 */     // GIR_Coverage, 1106,
     /*  76734 */     GIR_EraseRootFromParent_Done,
     /*  76735 */   // Label 1253: @76735
     /*  76735 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(76777), // Rule ID 1107 //
     /*  76740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextduwvrx),
     /*  76748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76764 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10398:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDUWVRX:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$RA, v4i32:{ *:[v4i32] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDUWVRX),
     /*  76767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76769 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76771 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76773 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76775 */     GIR_RootConstrainSelectedInstOperands,
     /*  76776 */     // GIR_Coverage, 1107,
     /*  76776 */     GIR_EraseRootFromParent_Done,
     /*  76777 */   // Label 1254: @76777
     /*  76777 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(76819), // Rule ID 1108 //
     /*  76782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvlx),
     /*  76790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76806 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10391:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVLX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVLX),
     /*  76809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76811 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76813 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76815 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76817 */     GIR_RootConstrainSelectedInstOperands,
     /*  76818 */     // GIR_Coverage, 1108,
     /*  76818 */     GIR_EraseRootFromParent_Done,
     /*  76819 */   // Label 1255: @76819
     /*  76819 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(76861), // Rule ID 1109 //
     /*  76824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vextddvrx),
     /*  76832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  76835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  76844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76848 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10392:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)  =>  (VEXTDDVRX:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, i32:{ *:[i32] }:$RC)
     /*  76848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTDDVRX),
     /*  76851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76853 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76855 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76857 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76859 */     GIR_RootConstrainSelectedInstOperands,
     /*  76860 */     // GIR_Coverage, 1109,
     /*  76860 */     GIR_EraseRootFromParent_Done,
     /*  76861 */   // Label 1256: @76861
     /*  76861 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(76903), // Rule ID 1147 //
     /*  76866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumcud),
     /*  76874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  76880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  76883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76890 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10451:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)  =>  (VMSUMCUD:{ *:[v1i128] } v2i64:{ *:[v2i64] }:$RA, v2i64:{ *:[v2i64] }:$RB, v1i128:{ *:[v1i128] }:$RC)
     /*  76890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMCUD),
     /*  76893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  76895 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  76897 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  76899 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  76901 */     GIR_RootConstrainSelectedInstOperands,
     /*  76902 */     // GIR_Coverage, 1147,
     /*  76902 */     GIR_EraseRootFromParent_Done,
     /*  76903 */   // Label 1257: @76903
     /*  76903 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(76945), // Rule ID 1162 //
     /*  76908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  76911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vrlqmi),
     /*  76916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s128,
     /*  76919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /*  76922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /*  76925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s128,
     /*  76928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  76932 */     // (intrinsic_wo_chain:{ *:[v1i128] } 10506:{ *:[iPTR] }, v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)  =>  (VRLQMI:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VA, v1i128:{ *:[v1i128] }:$VB, v1i128:{ *:[v1i128] }:$VDi)
     /*  76932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VRLQMI),
     /*  76935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  76937 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  76939 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  76941 */     GIR_RootToRootCopy, /*OpIdx*/4, // VDi
     /*  76943 */     GIR_RootConstrainSelectedInstOperands,
     /*  76944 */     // GIR_Coverage, 1162,
     /*  76944 */     GIR_EraseRootFromParent_Done,
     /*  76945 */   // Label 1258: @76945
     /*  76945 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(76984), // Rule ID 1282 //
     /*  76950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsub),
     /*  76955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  76958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  76961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  76964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  76967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  76971 */     // (intrinsic_wo_chain:{ *:[f64] } 10631:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FMSUB:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  76971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /*  76974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  76976 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  76978 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  76980 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  76982 */     GIR_RootConstrainSelectedInstOperands,
     /*  76983 */     // GIR_Coverage, 1282,
     /*  76983 */     GIR_EraseRootFromParent_Done,
     /*  76984 */   // Label 1259: @76984
     /*  76984 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(77023), // Rule ID 1283 //
     /*  76989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmsubs),
     /*  76994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  77000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  77003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  77010 */     // (intrinsic_wo_chain:{ *:[f32] } 10632:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FMSUBS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  77010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /*  77013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  77015 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77017 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77019 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77021 */     GIR_RootConstrainSelectedInstOperands,
     /*  77022 */     // GIR_Coverage, 1283,
     /*  77022 */     GIR_EraseRootFromParent_Done,
     /*  77023 */   // Label 1260: @77023
     /*  77023 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(77062), // Rule ID 1284 //
     /*  77028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadd),
     /*  77033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  77036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  77039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  77042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  77045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  77049 */     // (intrinsic_wo_chain:{ *:[f64] } 10635:{ *:[iPTR] }, f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B, f64:{ *:[f64] }:$C)  =>  (FNMADD:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B, ?:{ *:[f64] }:$C)
     /*  77049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /*  77052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  77054 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77056 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77058 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77060 */     GIR_RootConstrainSelectedInstOperands,
     /*  77061 */     // GIR_Coverage, 1284,
     /*  77061 */     GIR_EraseRootFromParent_Done,
     /*  77062 */   // Label 1261: @77062
     /*  77062 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(77101), // Rule ID 1285 //
     /*  77067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fnmadds),
     /*  77072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  77075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  77078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  77081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /*  77088 */     // (intrinsic_wo_chain:{ *:[f32] } 10636:{ *:[iPTR] }, f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B, f32:{ *:[f32] }:$C)  =>  (FNMADDS:{ *:[f32] } ?:{ *:[f32] }:$A, ?:{ *:[f32] }:$B, ?:{ *:[f32] }:$C)
     /*  77088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /*  77091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  77093 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77095 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77097 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77099 */     GIR_RootConstrainSelectedInstOperands,
     /*  77100 */     // GIR_Coverage, 1285,
     /*  77100 */     GIR_EraseRootFromParent_Done,
     /*  77101 */   // Label 1262: @77101
     /*  77101 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(77143), // Rule ID 1387 //
     /*  77106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  77109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmaddfp),
     /*  77114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77130 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10429:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  77130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /*  77133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77135 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77137 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77139 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77141 */     GIR_RootConstrainSelectedInstOperands,
     /*  77142 */     // GIR_Coverage, 1387,
     /*  77142 */     GIR_EraseRootFromParent_Done,
     /*  77143 */   // Label 1263: @77143
     /*  77143 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(77185), // Rule ID 1388 //
     /*  77148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  77151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vnmsubfp),
     /*  77156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77172 */     // (intrinsic_wo_chain:{ *:[v4f32] } 10479:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$A, v4f32:{ *:[v4f32] }:$B, v4f32:{ *:[v4f32] }:$C)  =>  (VNMSUBFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$A, ?:{ *:[v4f32] }:$B, ?:{ *:[v4f32] }:$C)
     /*  77172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /*  77175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77177 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77179 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77181 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77183 */     GIR_RootConstrainSelectedInstOperands,
     /*  77184 */     // GIR_Coverage, 1388,
     /*  77184 */     GIR_EraseRootFromParent_Done,
     /*  77185 */   // Label 1264: @77185
     /*  77185 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(77290), // Rule ID 1584 //
     /*  77190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsLittleEndian),
     /*  77193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  77198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77214 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10259:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, (XXLNOR:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$c, VSRC:{ *:[i32] })))
     /*  77214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77226 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  77230 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // c
     /*  77251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXLNOR),
     /*  77263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77271 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77281 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77283 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77288 */     GIR_RootConstrainSelectedInstOperands,
     /*  77289 */     // GIR_Coverage, 1584,
     /*  77289 */     GIR_EraseRootFromParent_Done,
     /*  77290 */   // Label 1265: @77290
     /*  77290 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(77332), // Rule ID 1585 //
     /*  77295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX_IsBigEndian),
     /*  77298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor),
     /*  77303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77319 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10259:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77324 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77326 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77328 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77330 */     GIR_RootConstrainSelectedInstOperands,
     /*  77331 */     // GIR_Coverage, 1585,
     /*  77331 */     GIR_EraseRootFromParent_Done,
     /*  77332 */   // Label 1266: @77332
     /*  77332 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(77374), // Rule ID 1586 //
     /*  77337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec_HasVSX),
     /*  77340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_crypto_vpermxor_be),
     /*  77345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  77361 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10260:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$a, v16i8:{ *:[v16i8] }:$b, v16i8:{ *:[v16i8] }:$c)  =>  (VPERMXOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$a, ?:{ *:[v16i8] }:$b, ?:{ *:[v16i8] }:$c)
     /*  77361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPERMXOR),
     /*  77364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  77366 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  77368 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  77370 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  77372 */     GIR_RootConstrainSelectedInstOperands,
     /*  77373 */     // GIR_Coverage, 1586,
     /*  77373 */     GIR_EraseRootFromParent_Done,
     /*  77374 */   // Label 1267: @77374
     /*  77374 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(77503), // Rule ID 3432 //
     /*  77379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvb),
     /*  77387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77403 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10907:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXBLENDVB:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77403 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77406 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77410 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77415 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77419 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77424 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77427 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77431 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77436 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77440 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77445 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77448 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77452 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77457 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77461 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVB),
     /*  77473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77478 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77502 */     // GIR_Coverage, 3432,
     /*  77502 */     GIR_EraseRootFromParent_Done,
     /*  77503 */   // Label 1268: @77503
     /*  77503 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(77632), // Rule ID 3433 //
     /*  77508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvh),
     /*  77516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  77528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 10909:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$A, v8i16:{ *:[v8i16] }:$B, v8i16:{ *:[v8i16] }:$C)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBLENDVH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$C, VSRC:{ *:[i32] })), VSRC:{ *:[i32] })
     /*  77532 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  77535 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77539 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77544 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  77548 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  77556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77565 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  77569 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  77577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77586 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  77590 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVH),
     /*  77602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77607 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  77610 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  77613 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  77616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  77623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77631 */     // GIR_Coverage, 3433,
     /*  77631 */     GIR_EraseRootFromParent_Done,
     /*  77632 */   // Label 1269: @77632
     /*  77632 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(77674), // Rule ID 3434 //
     /*  77637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvw),
     /*  77645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  77657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77661 */     // (intrinsic_wo_chain:{ *:[v4i32] } 10910:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$A, v4i32:{ *:[v4i32] }:$B, v4i32:{ *:[v4i32] }:$C)  =>  (XXBLENDVW:{ *:[v4i32] } ?:{ *:[v4i32] }:$A, ?:{ *:[v4i32] }:$B, ?:{ *:[v4i32] }:$C)
     /*  77661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVW),
     /*  77664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77666 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77668 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77670 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77672 */     GIR_RootConstrainSelectedInstOperands,
     /*  77673 */     // GIR_Coverage, 3434,
     /*  77673 */     GIR_EraseRootFromParent_Done,
     /*  77674 */   // Label 1270: @77674
     /*  77674 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(77716), // Rule ID 3435 //
     /*  77679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  77682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxblendvd),
     /*  77687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  77690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  77693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  77696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  77699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77703 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10908:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$A, v2i64:{ *:[v2i64] }:$B, v2i64:{ *:[v2i64] }:$C)  =>  (XXBLENDVD:{ *:[v2i64] } ?:{ *:[v2i64] }:$A, ?:{ *:[v2i64] }:$B, ?:{ *:[v2i64] }:$C)
     /*  77703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXBLENDVD),
     /*  77706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  77708 */     GIR_RootToRootCopy, /*OpIdx*/2, // A
     /*  77710 */     GIR_RootToRootCopy, /*OpIdx*/3, // B
     /*  77712 */     GIR_RootToRootCopy, /*OpIdx*/4, // C
     /*  77714 */     GIR_RootConstrainSelectedInstOperands,
     /*  77715 */     // GIR_Coverage, 3435,
     /*  77715 */     GIR_EraseRootFromParent_Done,
     /*  77716 */   // Label 1271: @77716
     /*  77716 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(77780), // Rule ID 3517 //
     /*  77721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4pp),
     /*  77729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77745 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10693:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4PP),
     /*  77769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77771 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77773 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77778 */     GIR_RootConstrainSelectedInstOperands,
     /*  77779 */     // GIR_Coverage, 3517,
     /*  77779 */     GIR_EraseRootFromParent_Done,
     /*  77780 */   // Label 1272: @77780
     /*  77780 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(77844), // Rule ID 3518 //
     /*  77785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvi8gerx4spp),
     /*  77793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77809 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10694:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77821 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVI8GERX4SPP),
     /*  77833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77835 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77837 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77842 */     GIR_RootConstrainSelectedInstOperands,
     /*  77843 */     // GIR_Coverage, 3518,
     /*  77843 */     GIR_EraseRootFromParent_Done,
     /*  77844 */   // Label 1273: @77844
     /*  77844 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(77908), // Rule ID 3520 //
     /*  77849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pp),
     /*  77857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77873 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10686:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77885 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PP),
     /*  77897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77899 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77901 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77906 */     GIR_RootConstrainSelectedInstOperands,
     /*  77907 */     // GIR_Coverage, 3520,
     /*  77907 */     GIR_EraseRootFromParent_Done,
     /*  77908 */   // Label 1274: @77908
     /*  77908 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(77972), // Rule ID 3521 //
     /*  77913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2pn),
     /*  77921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  77937 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10685:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  77937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  77944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  77953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  77958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2PN),
     /*  77961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  77963 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  77965 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  77967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77970 */     GIR_RootConstrainSelectedInstOperands,
     /*  77971 */     // GIR_Coverage, 3521,
     /*  77971 */     GIR_EraseRootFromParent_Done,
     /*  77972 */   // Label 1275: @77972
     /*  77972 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(78036), // Rule ID 3522 //
     /*  77977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  77980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2np),
     /*  77985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  77988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  77991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  77994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  77997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78001 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10684:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NP),
     /*  78025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78027 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78029 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78034 */     GIR_RootConstrainSelectedInstOperands,
     /*  78035 */     // GIR_Coverage, 3522,
     /*  78035 */     GIR_EraseRootFromParent_Done,
     /*  78036 */   // Label 1276: @78036
     /*  78036 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(78100), // Rule ID 3523 //
     /*  78041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvbf16gerx2nn),
     /*  78049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78065 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10683:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVBF16GERX2NN),
     /*  78089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78091 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78093 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78098 */     GIR_RootConstrainSelectedInstOperands,
     /*  78099 */     // GIR_Coverage, 3523,
     /*  78099 */     GIR_EraseRootFromParent_Done,
     /*  78100 */   // Label 1277: @78100
     /*  78100 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(78164), // Rule ID 3525 //
     /*  78105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pp),
     /*  78113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78129 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10691:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78145 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PP),
     /*  78153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78155 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78157 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78162 */     GIR_RootConstrainSelectedInstOperands,
     /*  78163 */     // GIR_Coverage, 3525,
     /*  78163 */     GIR_EraseRootFromParent_Done,
     /*  78164 */   // Label 1278: @78164
     /*  78164 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(78228), // Rule ID 3526 //
     /*  78169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2pn),
     /*  78177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78193 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10690:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2PN),
     /*  78217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78219 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78221 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78226 */     GIR_RootConstrainSelectedInstOperands,
     /*  78227 */     // GIR_Coverage, 3526,
     /*  78227 */     GIR_EraseRootFromParent_Done,
     /*  78228 */   // Label 1279: @78228
     /*  78228 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(78292), // Rule ID 3527 //
     /*  78233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2np),
     /*  78241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78257 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10689:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78269 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NP),
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78283 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78285 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78290 */     GIR_RootConstrainSelectedInstOperands,
     /*  78291 */     // GIR_Coverage, 3527,
     /*  78291 */     GIR_EraseRootFromParent_Done,
     /*  78292 */   // Label 1280: @78292
     /*  78292 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(78356), // Rule ID 3528 //
     /*  78297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxvf16gerx2nn),
     /*  78305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  78308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  78311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  78314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  78321 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10688:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB)  =>  (DMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXVF16GERX2NN),
     /*  78345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78347 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78349 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  78351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78354 */     GIR_RootConstrainSelectedInstOperands,
     /*  78355 */     // GIR_Coverage, 3528,
     /*  78355 */     GIR_EraseRootFromParent_Done,
     /*  78356 */   // Label 1281: @78356
     /*  78356 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(78442), // Rule ID 3544 //
     /*  78361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78385 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10767:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78401 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8PP),
     /*  78430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78432 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78440 */     GIR_RootConstrainSelectedInstOperands,
     /*  78441 */     // GIR_Coverage, 3544,
     /*  78441 */     GIR_EraseRootFromParent_Done,
     /*  78442 */   // Label 1282: @78442
     /*  78442 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(78528), // Rule ID 3546 //
     /*  78447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78471 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10769:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78471 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78474 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78478 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78487 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4PP),
     /*  78516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78518 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78526 */     GIR_RootConstrainSelectedInstOperands,
     /*  78527 */     // GIR_Coverage, 3546,
     /*  78527 */     GIR_EraseRootFromParent_Done,
     /*  78528 */   // Label 1283: @78528
     /*  78528 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(78614), // Rule ID 3548 //
     /*  78533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78557 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10765:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78557 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78560 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78564 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SPP),
     /*  78602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78604 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78612 */     GIR_RootConstrainSelectedInstOperands,
     /*  78613 */     // GIR_Coverage, 3548,
     /*  78613 */     GIR_EraseRootFromParent_Done,
     /*  78614 */   // Label 1284: @78614
     /*  78614 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(78700), // Rule ID 3550 //
     /*  78619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi4ger8pp),
     /*  78627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78643 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10767:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78659 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78676 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI4GER8WPP),
     /*  78688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78690 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78698 */     GIR_RootConstrainSelectedInstOperands,
     /*  78699 */     // GIR_Coverage, 3550,
     /*  78699 */     GIR_EraseRootFromParent_Done,
     /*  78700 */   // Label 1285: @78700
     /*  78700 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(78786), // Rule ID 3552 //
     /*  78705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4pp),
     /*  78713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78729 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10769:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78729 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78732 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78736 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78741 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WPP),
     /*  78774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78776 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78784 */     GIR_RootConstrainSelectedInstOperands,
     /*  78785 */     // GIR_Coverage, 3552,
     /*  78785 */     GIR_EraseRootFromParent_Done,
     /*  78786 */   // Label 1286: @78786
     /*  78786 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(78872), // Rule ID 3554 //
     /*  78791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  78794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2spp),
     /*  78799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  78815 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10765:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2SWPP),
     /*  78860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78862 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78870 */     GIR_RootConstrainSelectedInstOperands,
     /*  78871 */     // GIR_Coverage, 3554,
     /*  78871 */     GIR_EraseRootFromParent_Done,
     /*  78872 */   // Label 1287: @78872
     /*  78872 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(78958), // Rule ID 3556 //
     /*  78877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  78885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78901 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10751:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78913 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  78917 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  78938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  78943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PP),
     /*  78946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  78948 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  78950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  78956 */     GIR_RootConstrainSelectedInstOperands,
     /*  78957 */     // GIR_Coverage, 3556,
     /*  78957 */     GIR_EraseRootFromParent_Done,
     /*  78958 */   // Label 1288: @78958
     /*  78958 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(79044), // Rule ID 3557 //
     /*  78963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  78966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  78971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  78974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  78977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  78983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  78987 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10750:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  78987 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  78990 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  78994 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78999 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2PN),
     /*  79032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79034 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79042 */     GIR_RootConstrainSelectedInstOperands,
     /*  79043 */     // GIR_Coverage, 3557,
     /*  79043 */     GIR_EraseRootFromParent_Done,
     /*  79044 */   // Label 1289: @79044
     /*  79044 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(79130), // Rule ID 3558 //
     /*  79049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  79057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79073 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10749:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79073 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79076 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79080 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79085 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79089 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79106 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NP),
     /*  79118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79120 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79128 */     GIR_RootConstrainSelectedInstOperands,
     /*  79129 */     // GIR_Coverage, 3558,
     /*  79129 */     GIR_EraseRootFromParent_Done,
     /*  79130 */   // Label 1290: @79130
     /*  79130 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(79216), // Rule ID 3559 //
     /*  79135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  79143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79159 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10748:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79175 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2NN),
     /*  79204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79206 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79214 */     GIR_RootConstrainSelectedInstOperands,
     /*  79215 */     // GIR_Coverage, 3559,
     /*  79215 */     GIR_EraseRootFromParent_Done,
     /*  79216 */   // Label 1291: @79216
     /*  79216 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(79302), // Rule ID 3561 //
     /*  79221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pp),
     /*  79229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79245 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10751:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79245 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79248 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79252 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79257 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79278 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79282 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPP),
     /*  79290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79292 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79300 */     GIR_RootConstrainSelectedInstOperands,
     /*  79301 */     // GIR_Coverage, 3561,
     /*  79301 */     GIR_EraseRootFromParent_Done,
     /*  79302 */   // Label 1292: @79302
     /*  79302 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(79388), // Rule ID 3562 //
     /*  79307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2pn),
     /*  79315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79331 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10750:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79347 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WPN),
     /*  79376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79378 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79386 */     GIR_RootConstrainSelectedInstOperands,
     /*  79387 */     // GIR_Coverage, 3562,
     /*  79387 */     GIR_EraseRootFromParent_Done,
     /*  79388 */   // Label 1293: @79388
     /*  79388 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(79474), // Rule ID 3563 //
     /*  79393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2np),
     /*  79401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79417 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10749:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79433 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79450 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNP),
     /*  79462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79464 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79472 */     GIR_RootConstrainSelectedInstOperands,
     /*  79473 */     // GIR_Coverage, 3563,
     /*  79473 */     GIR_EraseRootFromParent_Done,
     /*  79474 */   // Label 1294: @79474
     /*  79474 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(79560), // Rule ID 3564 //
     /*  79479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  79482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf16ger2nn),
     /*  79487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  79503 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10748:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79503 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79506 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79510 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79519 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF16GER2WNN),
     /*  79548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79550 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79558 */     GIR_RootConstrainSelectedInstOperands,
     /*  79559 */     // GIR_Coverage, 3564,
     /*  79559 */     GIR_EraseRootFromParent_Done,
     /*  79560 */   // Label 1295: @79560
     /*  79560 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(79646), // Rule ID 3566 //
     /*  79565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  79573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79589 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10756:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79601 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPP),
     /*  79634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79636 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79644 */     GIR_RootConstrainSelectedInstOperands,
     /*  79645 */     // GIR_Coverage, 3566,
     /*  79645 */     GIR_EraseRootFromParent_Done,
     /*  79646 */   // Label 1296: @79646
     /*  79646 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(79732), // Rule ID 3567 //
     /*  79651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  79659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79675 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10755:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERPN),
     /*  79720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79722 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79730 */     GIR_RootConstrainSelectedInstOperands,
     /*  79731 */     // GIR_Coverage, 3567,
     /*  79731 */     GIR_EraseRootFromParent_Done,
     /*  79732 */   // Label 1297: @79732
     /*  79732 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(79818), // Rule ID 3568 //
     /*  79737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  79745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79761 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10754:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79761 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79764 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79768 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79773 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79777 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79794 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNP),
     /*  79806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79808 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79816 */     GIR_RootConstrainSelectedInstOperands,
     /*  79817 */     // GIR_Coverage, 3568,
     /*  79817 */     GIR_EraseRootFromParent_Done,
     /*  79818 */   // Label 1298: @79818
     /*  79818 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(79904), // Rule ID 3569 //
     /*  79823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  79831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  79840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79847 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10753:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  79850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  79884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERNN),
     /*  79892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79894 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  79902 */     GIR_RootConstrainSelectedInstOperands,
     /*  79903 */     // GIR_Coverage, 3569,
     /*  79903 */     GIR_EraseRootFromParent_Done,
     /*  79904 */   // Label 1299: @79904
     /*  79904 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(79968), // Rule ID 3571 //
     /*  79909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  79917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79933 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10761:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  79940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  79949 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  79954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPP),
     /*  79957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  79959 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  79961 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  79963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79966 */     GIR_RootConstrainSelectedInstOperands,
     /*  79967 */     // GIR_Coverage, 3571,
     /*  79967 */     GIR_EraseRootFromParent_Done,
     /*  79968 */   // Label 1300: @79968
     /*  79968 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(80032), // Rule ID 3572 //
     /*  79973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  79976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  79981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  79984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  79987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  79990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  79993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  79997 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10760:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  79997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERPN),
     /*  80021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80023 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80025 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80030 */     GIR_RootConstrainSelectedInstOperands,
     /*  80031 */     // GIR_Coverage, 3572,
     /*  80031 */     GIR_EraseRootFromParent_Done,
     /*  80032 */   // Label 1301: @80032
     /*  80032 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(80096), // Rule ID 3573 //
     /*  80037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  80045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80061 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10759:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  80085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80087 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80089 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80094 */     GIR_RootConstrainSelectedInstOperands,
     /*  80095 */     // GIR_Coverage, 3573,
     /*  80095 */     GIR_EraseRootFromParent_Done,
     /*  80096 */   // Label 1302: @80096
     /*  80096 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(80160), // Rule ID 3574 //
     /*  80101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  80109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  80118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80125 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10758:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNN),
     /*  80149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80151 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80153 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  80155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80158 */     GIR_RootConstrainSelectedInstOperands,
     /*  80159 */     // GIR_Coverage, 3574,
     /*  80159 */     GIR_EraseRootFromParent_Done,
     /*  80160 */   // Label 1303: @80160
     /*  80160 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(80246), // Rule ID 3576 //
     /*  80165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  80173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80189 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10746:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80189 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80192 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80196 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80201 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80222 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PP),
     /*  80234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80236 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80244 */     GIR_RootConstrainSelectedInstOperands,
     /*  80245 */     // GIR_Coverage, 3576,
     /*  80245 */     GIR_EraseRootFromParent_Done,
     /*  80246 */   // Label 1304: @80246
     /*  80246 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(80332), // Rule ID 3577 //
     /*  80251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  80259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80275 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10745:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80291 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2PN),
     /*  80320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80322 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80330 */     GIR_RootConstrainSelectedInstOperands,
     /*  80331 */     // GIR_Coverage, 3577,
     /*  80331 */     GIR_EraseRootFromParent_Done,
     /*  80332 */   // Label 1305: @80332
     /*  80332 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(80418), // Rule ID 3578 //
     /*  80337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  80345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80361 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10744:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80361 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80364 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80368 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80373 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80377 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NP),
     /*  80406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80408 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80416 */     GIR_RootConstrainSelectedInstOperands,
     /*  80417 */     // GIR_Coverage, 3578,
     /*  80417 */     GIR_EraseRootFromParent_Done,
     /*  80418 */   // Label 1306: @80418
     /*  80418 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(80504), // Rule ID 3579 //
     /*  80423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  80431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80447 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10743:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80447 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80450 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80454 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80459 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80463 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2NN),
     /*  80492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80494 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80502 */     GIR_RootConstrainSelectedInstOperands,
     /*  80503 */     // GIR_Coverage, 3579,
     /*  80503 */     GIR_EraseRootFromParent_Done,
     /*  80504 */   // Label 1307: @80504
     /*  80504 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(80590), // Rule ID 3581 //
     /*  80509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  80517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80533 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10763:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80545 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80549 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80566 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2PP),
     /*  80578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80580 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80588 */     GIR_RootConstrainSelectedInstOperands,
     /*  80589 */     // GIR_Coverage, 3581,
     /*  80589 */     GIR_EraseRootFromParent_Done,
     /*  80590 */   // Label 1308: @80590
     /*  80590 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(80676), // Rule ID 3582 //
     /*  80595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA),
     /*  80598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  80603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  80619 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10770:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80619 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80622 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80626 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80656 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4SPP),
     /*  80664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80666 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80674 */     GIR_RootConstrainSelectedInstOperands,
     /*  80675 */     // GIR_Coverage, 3582,
     /*  80675 */     GIR_EraseRootFromParent_Done,
     /*  80676 */   // Label 1309: @80676
     /*  80676 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(80762), // Rule ID 3584 //
     /*  80681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpp),
     /*  80689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80705 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10756:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPP),
     /*  80750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80752 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80760 */     GIR_RootConstrainSelectedInstOperands,
     /*  80761 */     // GIR_Coverage, 3584,
     /*  80761 */     GIR_EraseRootFromParent_Done,
     /*  80762 */   // Label 1310: @80762
     /*  80762 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(80848), // Rule ID 3585 //
     /*  80767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gerpn),
     /*  80775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80791 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10755:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80791 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80794 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80798 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWPN),
     /*  80836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80838 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80846 */     GIR_RootConstrainSelectedInstOperands,
     /*  80847 */     // GIR_Coverage, 3585,
     /*  80847 */     GIR_EraseRootFromParent_Done,
     /*  80848 */   // Label 1311: @80848
     /*  80848 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(80934), // Rule ID 3586 //
     /*  80853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernp),
     /*  80861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80877 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10754:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80889 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  80914 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNP),
     /*  80922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  80924 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  80926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  80932 */     GIR_RootConstrainSelectedInstOperands,
     /*  80933 */     // GIR_Coverage, 3586,
     /*  80933 */     GIR_EraseRootFromParent_Done,
     /*  80934 */   // Label 1312: @80934
     /*  80934 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(81020), // Rule ID 3587 //
     /*  80939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  80942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf32gernn),
     /*  80947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  80950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  80953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  80956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  80959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  80963 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10753:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  80963 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  80966 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80970 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  80979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  80984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  80987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  80991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF32GERWNN),
     /*  81008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81010 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81018 */     GIR_RootConstrainSelectedInstOperands,
     /*  81019 */     // GIR_Coverage, 3587,
     /*  81019 */     GIR_EraseRootFromParent_Done,
     /*  81020 */   // Label 1313: @81020
     /*  81020 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(81084), // Rule ID 3589 //
     /*  81025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpp),
     /*  81033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81049 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10761:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81061 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPP),
     /*  81073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81075 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81077 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81082 */     GIR_RootConstrainSelectedInstOperands,
     /*  81083 */     // GIR_Coverage, 3589,
     /*  81083 */     GIR_EraseRootFromParent_Done,
     /*  81084 */   // Label 1314: @81084
     /*  81084 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(81148), // Rule ID 3590 //
     /*  81089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gerpn),
     /*  81097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81113 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10760:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWPN),
     /*  81137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81139 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81141 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81146 */     GIR_RootConstrainSelectedInstOperands,
     /*  81147 */     // GIR_Coverage, 3590,
     /*  81147 */     GIR_EraseRootFromParent_Done,
     /*  81148 */   // Label 1315: @81148
     /*  81148 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(81212), // Rule ID 3591 //
     /*  81153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernp),
     /*  81161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81177 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10759:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERNP),
     /*  81201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81203 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81205 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81210 */     GIR_RootConstrainSelectedInstOperands,
     /*  81211 */     // GIR_Coverage, 3591,
     /*  81211 */     GIR_EraseRootFromParent_Done,
     /*  81212 */   // Label 1316: @81212
     /*  81212 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(81276), // Rule ID 3592 //
     /*  81217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvf64gernn),
     /*  81225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  81234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81241 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10758:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVF64GERWNN),
     /*  81265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81267 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81269 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  81271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81274 */     GIR_RootConstrainSelectedInstOperands,
     /*  81275 */     // GIR_Coverage, 3592,
     /*  81275 */     GIR_EraseRootFromParent_Done,
     /*  81276 */   // Label 1317: @81276
     /*  81276 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(81362), // Rule ID 3594 //
     /*  81281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pp),
     /*  81289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81305 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10746:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81305 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81308 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81312 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81317 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPP),
     /*  81350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81352 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81360 */     GIR_RootConstrainSelectedInstOperands,
     /*  81361 */     // GIR_Coverage, 3594,
     /*  81361 */     GIR_EraseRootFromParent_Done,
     /*  81362 */   // Label 1318: @81362
     /*  81362 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(81448), // Rule ID 3595 //
     /*  81367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2pn),
     /*  81375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81391 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10745:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WPN),
     /*  81436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81438 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81446 */     GIR_RootConstrainSelectedInstOperands,
     /*  81447 */     // GIR_Coverage, 3595,
     /*  81447 */     GIR_EraseRootFromParent_Done,
     /*  81448 */   // Label 1319: @81448
     /*  81448 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(81534), // Rule ID 3596 //
     /*  81453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2np),
     /*  81461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81477 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10744:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81489 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNP),
     /*  81522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81524 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81532 */     GIR_RootConstrainSelectedInstOperands,
     /*  81533 */     // GIR_Coverage, 3596,
     /*  81533 */     GIR_EraseRootFromParent_Done,
     /*  81534 */   // Label 1320: @81534
     /*  81534 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(81620), // Rule ID 3597 //
     /*  81539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvbf16ger2nn),
     /*  81547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81563 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10743:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVBF16GER2WNN),
     /*  81608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81610 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81618 */     GIR_RootConstrainSelectedInstOperands,
     /*  81619 */     // GIR_Coverage, 3597,
     /*  81619 */     GIR_EraseRootFromParent_Done,
     /*  81620 */   // Label 1321: @81620
     /*  81620 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81706), // Rule ID 3599 //
     /*  81625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi16ger2pp),
     /*  81633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81649 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10763:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81649 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81652 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81656 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81661 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81665 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI16GER2WPP),
     /*  81694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81696 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81704 */     GIR_RootConstrainSelectedInstOperands,
     /*  81705 */     // GIR_Coverage, 3599,
     /*  81705 */     GIR_EraseRootFromParent_Done,
     /*  81706 */   // Label 1322: @81706
     /*  81706 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(81792), // Rule ID 3600 //
     /*  81711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA),
     /*  81714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_xvi8ger4spp),
     /*  81719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  81725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  81731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  81735 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10770:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB)  =>  (XVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }))
     /*  81735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  81751 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  81772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVI8GER4WSPP),
     /*  81780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81782 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  81784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81790 */     GIR_RootConstrainSelectedInstOperands,
     /*  81791 */     // GIR_Coverage, 3600,
     /*  81791 */     GIR_EraseRootFromParent_Done,
     /*  81792 */   // Label 1323: @81792
     /*  81792 */   GIM_Reject,
     /*  81793 */ // Label 1200: @81793
     /*  81793 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(82417),
     /*  81798 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  81801 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(81920), // Rule ID 3612 //
     /*  81806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  81814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81845 */     // MIs[1] Operand 1
     /*  81845 */     // No operand predicates
     /*  81845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81857 */     // MIs[2] Operand 1
     /*  81857 */     // No operand predicates
     /*  81857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81859 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10723:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GER:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  81859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  81862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  81896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GER),
     /*  81904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  81906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  81912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  81915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  81918 */     GIR_RootConstrainSelectedInstOperands,
     /*  81919 */     // GIR_Coverage, 3612,
     /*  81919 */     GIR_EraseRootFromParent_Done,
     /*  81920 */   // Label 1325: @81920
     /*  81920 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(82017), // Rule ID 3617 //
     /*  81925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  81928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  81933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  81936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  81939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  81942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  81952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  81956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81960 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  81964 */     // MIs[1] Operand 1
     /*  81964 */     // No operand predicates
     /*  81964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  81968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  81976 */     // MIs[2] Operand 1
     /*  81976 */     // No operand predicates
     /*  81976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81978 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10728:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GER:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  81978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  81981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  81985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  81994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  81999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GER),
     /*  82002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82004 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82015 */     GIR_RootConstrainSelectedInstOperands,
     /*  82016 */     // GIR_Coverage, 3617,
     /*  82016 */     GIR_EraseRootFromParent_Done,
     /*  82017 */   // Label 1326: @82017
     /*  82017 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(82136), // Rule ID 3641 //
     /*  82022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32ger),
     /*  82030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82061 */     // MIs[1] Operand 1
     /*  82061 */     // No operand predicates
     /*  82061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82073 */     // MIs[2] Operand 1
     /*  82073 */     // No operand predicates
     /*  82073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82075 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10723:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  82075 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82078 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82082 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82091 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82108 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERW),
     /*  82120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82134 */     GIR_RootConstrainSelectedInstOperands,
     /*  82135 */     // GIR_Coverage, 3641,
     /*  82135 */     GIR_EraseRootFromParent_Done,
     /*  82136 */   // Label 1327: @82136
     /*  82136 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(82233), // Rule ID 3646 //
     /*  82141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64ger),
     /*  82149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  82168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82180 */     // MIs[1] Operand 1
     /*  82180 */     // No operand predicates
     /*  82180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82188 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82192 */     // MIs[2] Operand 1
     /*  82192 */     // No operand predicates
     /*  82192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82194 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10728:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERW:{ *:[v512i1] } ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  82194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERW),
     /*  82218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82220 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82231 */     GIR_RootConstrainSelectedInstOperands,
     /*  82232 */     // GIR_Coverage, 3646,
     /*  82232 */     GIR_EraseRootFromParent_Done,
     /*  82233 */   // Label 1328: @82233
     /*  82233 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(82280), // Rule ID 1117 //
     /*  82238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  82241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxeval),
     /*  82246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  82249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  82255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  82258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82262 */     // MIs[0] IMM
     /*  82262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82265 */     // (intrinsic_wo_chain:{ *:[v2i64] } 10911:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)  =>  (XXEVAL:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XA, v2i64:{ *:[v2i64] }:$XB, v2i64:{ *:[v2i64] }:$XC, (timm:{ *:[i32] }):$IMM)
     /*  82265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXEVAL),
     /*  82268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /*  82270 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /*  82272 */     GIR_RootToRootCopy, /*OpIdx*/3, // XB
     /*  82274 */     GIR_RootToRootCopy, /*OpIdx*/4, // XC
     /*  82276 */     GIR_RootToRootCopy, /*OpIdx*/5, // IMM
     /*  82278 */     GIR_RootConstrainSelectedInstOperands,
     /*  82279 */     // GIR_Coverage, 1117,
     /*  82279 */     GIR_EraseRootFromParent_Done,
     /*  82280 */   // Label 1329: @82280
     /*  82280 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(82416), // Rule ID 3431 //
     /*  82285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP10Vector_PrefixInstrs),
     /*  82288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_vsx_xxpermx),
     /*  82293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  82296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  82305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82309 */     // MIs[0] D
     /*  82309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  82312 */     // (intrinsic_wo_chain:{ *:[v16i8] } 10919:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$A, v16i8:{ *:[v16i8] }:$B, v16i8:{ *:[v16i8] }:$C, (timm:{ *:[i32] }):$D)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXPERMX:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$A, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$B, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$C, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$D), VSRC:{ *:[i32] })
     /*  82312 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  82315 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82319 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82324 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/4, // C
     /*  82328 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  82336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82345 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // B
     /*  82349 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82354 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82357 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82361 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82366 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // A
     /*  82370 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMX),
     /*  82382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82390 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  82393 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /*  82396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // D
     /*  82400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82415 */     // GIR_Coverage, 3431,
     /*  82415 */     GIR_EraseRootFromParent_Done,
     /*  82416 */   // Label 1330: @82416
     /*  82416 */   GIM_Reject,
     /*  82417 */ // Label 1324: @82417
     /*  82417 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(86297),
     /*  82422 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  82425 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(82540), // Rule ID 3529 //
     /*  82430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4),
     /*  82438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82472 */     // MIs[1] Operand 1
     /*  82472 */     // No operand predicates
     /*  82472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82480 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82484 */     // MIs[2] Operand 1
     /*  82484 */     // No operand predicates
     /*  82484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82492 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82496 */     // MIs[3] Operand 1
     /*  82496 */     // No operand predicates
     /*  82496 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82498 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10710:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82510 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4),
     /*  82522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82524 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82538 */     GIR_RootConstrainSelectedInstOperands,
     /*  82539 */     // GIR_Coverage, 3529,
     /*  82539 */     GIR_EraseRootFromParent_Done,
     /*  82540 */   // Label 1332: @82540
     /*  82540 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(82655), // Rule ID 3532 //
     /*  82545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2),
     /*  82553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82587 */     // MIs[1] Operand 1
     /*  82587 */     // No operand predicates
     /*  82587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82599 */     // MIs[2] Operand 1
     /*  82599 */     // No operand predicates
     /*  82599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82607 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82611 */     // MIs[3] Operand 1
     /*  82611 */     // No operand predicates
     /*  82611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82613 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10700:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82625 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2),
     /*  82637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82639 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82653 */     GIR_RootConstrainSelectedInstOperands,
     /*  82654 */     // GIR_Coverage, 3532,
     /*  82654 */     GIR_EraseRootFromParent_Done,
     /*  82655 */   // Label 1333: @82655
     /*  82655 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(82770), // Rule ID 3537 //
     /*  82660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  82663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2),
     /*  82668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  82671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v256s1,
     /*  82674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  82690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82702 */     // MIs[1] Operand 1
     /*  82702 */     // No operand predicates
     /*  82702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82710 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82714 */     // MIs[2] Operand 1
     /*  82714 */     // No operand predicates
     /*  82714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  82726 */     // MIs[3] Operand 1
     /*  82726 */     // No operand predicates
     /*  82726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82728 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10705:{ *:[iPTR] }, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2:{ *:[v1024i1] } ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  82728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82740 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2),
     /*  82752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82754 */     GIR_RootToRootCopy, /*OpIdx*/2, // XAp
     /*  82756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82768 */     GIR_RootConstrainSelectedInstOperands,
     /*  82769 */     // GIR_Coverage, 3537,
     /*  82769 */     GIR_EraseRootFromParent_Done,
     /*  82770 */   // Label 1334: @82770
     /*  82770 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(82907), // Rule ID 3601 //
     /*  82775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  82783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82817 */     // MIs[1] Operand 1
     /*  82817 */     // No operand predicates
     /*  82817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82825 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82829 */     // MIs[2] Operand 1
     /*  82829 */     // No operand predicates
     /*  82829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  82841 */     // MIs[3] Operand 1
     /*  82841 */     // No operand predicates
     /*  82841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82843 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10737:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  82843 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82846 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82850 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82859 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82876 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  82880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  82885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8),
     /*  82888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  82890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  82896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  82899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  82902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  82905 */     GIR_RootConstrainSelectedInstOperands,
     /*  82906 */     // GIR_Coverage, 3601,
     /*  82906 */     GIR_EraseRootFromParent_Done,
     /*  82907 */   // Label 1335: @82907
     /*  82907 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(83044), // Rule ID 3603 //
     /*  82912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  82915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  82920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  82923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  82926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  82929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  82938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  82942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  82946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82950 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82954 */     // MIs[1] Operand 1
     /*  82954 */     // No operand predicates
     /*  82954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  82958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82962 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82966 */     // MIs[2] Operand 1
     /*  82966 */     // No operand predicates
     /*  82966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  82970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  82974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  82978 */     // MIs[3] Operand 1
     /*  82978 */     // No operand predicates
     /*  82978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  82980 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10739:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  82980 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  82983 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  82987 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  82996 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83017 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4),
     /*  83025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83042 */     GIR_RootConstrainSelectedInstOperands,
     /*  83043 */     // GIR_Coverage, 3603,
     /*  83043 */     GIR_EraseRootFromParent_Done,
     /*  83044 */   // Label 1336: @83044
     /*  83044 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(83181), // Rule ID 3605 //
     /*  83049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  83057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83091 */     // MIs[1] Operand 1
     /*  83091 */     // No operand predicates
     /*  83091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83099 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83103 */     // MIs[2] Operand 1
     /*  83103 */     // No operand predicates
     /*  83103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83111 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83115 */     // MIs[3] Operand 1
     /*  83115 */     // No operand predicates
     /*  83115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83117 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10735:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2S:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83117 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83120 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83124 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83129 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83133 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2S),
     /*  83162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83179 */     GIR_RootConstrainSelectedInstOperands,
     /*  83180 */     // GIR_Coverage, 3605,
     /*  83180 */     GIR_EraseRootFromParent_Done,
     /*  83181 */   // Label 1337: @83181
     /*  83181 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(83318), // Rule ID 3607 //
     /*  83186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  83194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83228 */     // MIs[1] Operand 1
     /*  83228 */     // No operand predicates
     /*  83228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83236 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83240 */     // MIs[2] Operand 1
     /*  83240 */     // No operand predicates
     /*  83240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83252 */     // MIs[3] Operand 1
     /*  83252 */     // No operand predicates
     /*  83252 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83254 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10718:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83254 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83257 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83261 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83291 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2),
     /*  83299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83316 */     GIR_RootConstrainSelectedInstOperands,
     /*  83317 */     // GIR_Coverage, 3607,
     /*  83317 */     GIR_EraseRootFromParent_Done,
     /*  83318 */   // Label 1338: @83318
     /*  83318 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(83455), // Rule ID 3622 //
     /*  83323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  83331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83365 */     // MIs[1] Operand 1
     /*  83365 */     // No operand predicates
     /*  83365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83373 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83377 */     // MIs[2] Operand 1
     /*  83377 */     // No operand predicates
     /*  83377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83389 */     // MIs[3] Operand 1
     /*  83389 */     // No operand predicates
     /*  83389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83391 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10713:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83407 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2),
     /*  83436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83453 */     GIR_RootConstrainSelectedInstOperands,
     /*  83454 */     // GIR_Coverage, 3622,
     /*  83454 */     GIR_EraseRootFromParent_Done,
     /*  83455 */   // Label 1339: @83455
     /*  83455 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(83592), // Rule ID 3627 //
     /*  83460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  83463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  83468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  83490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83502 */     // MIs[1] Operand 1
     /*  83502 */     // No operand predicates
     /*  83502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83510 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83514 */     // MIs[2] Operand 1
     /*  83514 */     // No operand predicates
     /*  83514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83526 */     // MIs[3] Operand 1
     /*  83526 */     // No operand predicates
     /*  83526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83528 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10733:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83528 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83531 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83535 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83540 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83544 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83561 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2),
     /*  83573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83590 */     GIR_RootConstrainSelectedInstOperands,
     /*  83591 */     // GIR_Coverage, 3627,
     /*  83591 */     GIR_EraseRootFromParent_Done,
     /*  83592 */   // Label 1340: @83592
     /*  83592 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(83729), // Rule ID 3630 //
     /*  83597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8),
     /*  83605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83639 */     // MIs[1] Operand 1
     /*  83639 */     // No operand predicates
     /*  83639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83651 */     // MIs[2] Operand 1
     /*  83651 */     // No operand predicates
     /*  83651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83659 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  83663 */     // MIs[3] Operand 1
     /*  83663 */     // No operand predicates
     /*  83663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83665 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10737:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  83665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83677 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8W),
     /*  83710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83727 */     GIR_RootConstrainSelectedInstOperands,
     /*  83728 */     // GIR_Coverage, 3630,
     /*  83728 */     GIR_EraseRootFromParent_Done,
     /*  83729 */   // Label 1341: @83729
     /*  83729 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(83866), // Rule ID 3632 //
     /*  83734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4),
     /*  83742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83776 */     // MIs[1] Operand 1
     /*  83776 */     // No operand predicates
     /*  83776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83784 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83788 */     // MIs[2] Operand 1
     /*  83788 */     // No operand predicates
     /*  83788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83800 */     // MIs[3] Operand 1
     /*  83800 */     // No operand predicates
     /*  83800 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83802 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10739:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  83802 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83805 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83809 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83814 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83818 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4W),
     /*  83847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  83864 */     GIR_RootConstrainSelectedInstOperands,
     /*  83865 */     // GIR_Coverage, 3632,
     /*  83865 */     GIR_EraseRootFromParent_Done,
     /*  83866 */   // Label 1342: @83866
     /*  83866 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(84003), // Rule ID 3634 //
     /*  83871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  83874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2s),
     /*  83879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  83882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  83885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  83888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  83897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  83901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  83905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83913 */     // MIs[1] Operand 1
     /*  83913 */     // No operand predicates
     /*  83913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  83917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83921 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  83925 */     // MIs[2] Operand 1
     /*  83925 */     // No operand predicates
     /*  83925 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  83929 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83933 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  83937 */     // MIs[3] Operand 1
     /*  83937 */     // No operand predicates
     /*  83937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83939 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10735:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SW:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  83939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  83942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  83955 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  83963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  83967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83972 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  83976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  83981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SW),
     /*  83984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  83986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  83992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  83995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  83998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84001 */     GIR_RootConstrainSelectedInstOperands,
     /*  84002 */     // GIR_Coverage, 3634,
     /*  84002 */     GIR_EraseRootFromParent_Done,
     /*  84003 */   // Label 1343: @84003
     /*  84003 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(84140), // Rule ID 3636 //
     /*  84008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2),
     /*  84016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84050 */     // MIs[1] Operand 1
     /*  84050 */     // No operand predicates
     /*  84050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84062 */     // MIs[2] Operand 1
     /*  84062 */     // No operand predicates
     /*  84062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84074 */     // MIs[3] Operand 1
     /*  84074 */     // No operand predicates
     /*  84074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84076 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10718:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84076 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84079 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84083 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84088 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84092 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2W),
     /*  84121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84138 */     GIR_RootConstrainSelectedInstOperands,
     /*  84139 */     // GIR_Coverage, 3636,
     /*  84139 */     GIR_EraseRootFromParent_Done,
     /*  84140 */   // Label 1344: @84140
     /*  84140 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(84277), // Rule ID 3651 //
     /*  84145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2),
     /*  84153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84187 */     // MIs[1] Operand 1
     /*  84187 */     // No operand predicates
     /*  84187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84199 */     // MIs[2] Operand 1
     /*  84199 */     // No operand predicates
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84207 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84211 */     // MIs[3] Operand 1
     /*  84211 */     // No operand predicates
     /*  84211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84213 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10713:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84229 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2W),
     /*  84258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84266 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84275 */     GIR_RootConstrainSelectedInstOperands,
     /*  84276 */     // GIR_Coverage, 3651,
     /*  84276 */     GIR_EraseRootFromParent_Done,
     /*  84277 */   // Label 1345: @84277
     /*  84277 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(84414), // Rule ID 3656 //
     /*  84282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  84285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2),
     /*  84290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  84312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  84316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84324 */     // MIs[1] Operand 1
     /*  84324 */     // No operand predicates
     /*  84324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /*  84328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84332 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84336 */     // MIs[2] Operand 1
     /*  84336 */     // No operand predicates
     /*  84336 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/6, // MIs[3]
     /*  84340 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84344 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  84348 */     // MIs[3] Operand 1
     /*  84348 */     // No operand predicates
     /*  84348 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  84350 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10733:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2W:{ *:[v512i1] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  84350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // XA
     /*  84387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2W),
     /*  84395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  84412 */     GIR_RootConstrainSelectedInstOperands,
     /*  84413 */     // GIR_Coverage, 3656,
     /*  84413 */     GIR_EraseRootFromParent_Done,
     /*  84414 */   // Label 1346: @84414
     /*  84414 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(84488), // Rule ID 3542 //
     /*  84419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture),
     /*  84422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_dmxxshapad),
     /*  84427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  84430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  84433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  84440 */     // MIs[0] ID
     /*  84440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  84443 */     // MIs[0] E
     /*  84443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  84446 */     // MIs[0] BL
     /*  84446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  84449 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10699:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v16i8:{ *:[v16i8] }:$XB, (timm:{ *:[i32] }):$ID, (timm:{ *:[i32] }):$E, (timm:{ *:[i32] }):$BL)  =>  (DMXXSHAPAD:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), ?:{ *:[i32] }:$ID, ?:{ *:[i32] }:$E, ?:{ *:[i32] }:$BL)
     /*  84449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84461 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XB
     /*  84465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DMXXSHAPAD),
     /*  84473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84475 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84480 */     GIR_RootToRootCopy, /*OpIdx*/4, // ID
     /*  84482 */     GIR_RootToRootCopy, /*OpIdx*/5, // E
     /*  84484 */     GIR_RootToRootCopy, /*OpIdx*/6, // BL
     /*  84486 */     GIR_RootConstrainSelectedInstOperands,
     /*  84487 */     // GIR_Coverage, 3542,
     /*  84487 */     GIR_EraseRootFromParent_Done,
     /*  84488 */   // Label 1347: @84488
     /*  84488 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(84612), // Rule ID 3613 //
     /*  84493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  84501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84535 */     // MIs[1] Operand 1
     /*  84535 */     // No operand predicates
     /*  84535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84543 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84547 */     // MIs[2] Operand 1
     /*  84547 */     // No operand predicates
     /*  84547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84549 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10727:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84561 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPP),
     /*  84594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84596 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84610 */     GIR_RootConstrainSelectedInstOperands,
     /*  84611 */     // GIR_Coverage, 3613,
     /*  84611 */     GIR_EraseRootFromParent_Done,
     /*  84612 */   // Label 1348: @84612
     /*  84612 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(84736), // Rule ID 3614 //
     /*  84617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  84625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84659 */     // MIs[1] Operand 1
     /*  84659 */     // No operand predicates
     /*  84659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84667 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84671 */     // MIs[2] Operand 1
     /*  84671 */     // No operand predicates
     /*  84671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84673 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10726:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84685 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84706 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84710 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERPN),
     /*  84718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84720 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84734 */     GIR_RootConstrainSelectedInstOperands,
     /*  84735 */     // GIR_Coverage, 3614,
     /*  84735 */     GIR_EraseRootFromParent_Done,
     /*  84736 */   // Label 1349: @84736
     /*  84736 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(84860), // Rule ID 3615 //
     /*  84741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  84749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84783 */     // MIs[1] Operand 1
     /*  84783 */     // No operand predicates
     /*  84783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84791 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84795 */     // MIs[2] Operand 1
     /*  84795 */     // No operand predicates
     /*  84795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84797 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10725:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84809 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNP),
     /*  84842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84844 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84858 */     GIR_RootConstrainSelectedInstOperands,
     /*  84859 */     // GIR_Coverage, 3615,
     /*  84859 */     GIR_EraseRootFromParent_Done,
     /*  84860 */   // Label 1350: @84860
     /*  84860 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(84984), // Rule ID 3616 //
     /*  84865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  84873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  84876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  84879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  84891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  84895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  84899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84907 */     // MIs[1] Operand 1
     /*  84907 */     // No operand predicates
     /*  84907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  84911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  84915 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  84919 */     // MIs[2] Operand 1
     /*  84919 */     // No operand predicates
     /*  84919 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84921 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10724:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  84921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  84924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84933 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  84937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  84945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  84949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84954 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  84958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  84963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERNN),
     /*  84966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  84968 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  84970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  84976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  84979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  84982 */     GIR_RootConstrainSelectedInstOperands,
     /*  84983 */     // GIR_Coverage, 3616,
     /*  84983 */     GIR_EraseRootFromParent_Done,
     /*  84984 */   // Label 1351: @84984
     /*  84984 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(85086), // Rule ID 3618 //
     /*  84989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  84992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  84997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85031 */     // MIs[1] Operand 1
     /*  85031 */     // No operand predicates
     /*  85031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85043 */     // MIs[2] Operand 1
     /*  85043 */     // No operand predicates
     /*  85043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85045 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10732:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85057 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPP),
     /*  85069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85071 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85073 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85084 */     GIR_RootConstrainSelectedInstOperands,
     /*  85085 */     // GIR_Coverage, 3618,
     /*  85085 */     GIR_EraseRootFromParent_Done,
     /*  85086 */   // Label 1352: @85086
     /*  85086 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(85188), // Rule ID 3619 //
     /*  85091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  85099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85133 */     // MIs[1] Operand 1
     /*  85133 */     // No operand predicates
     /*  85133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85145 */     // MIs[2] Operand 1
     /*  85145 */     // No operand predicates
     /*  85145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85147 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10731:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERPN),
     /*  85171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85173 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85175 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85186 */     GIR_RootConstrainSelectedInstOperands,
     /*  85187 */     // GIR_Coverage, 3619,
     /*  85187 */     GIR_EraseRootFromParent_Done,
     /*  85188 */   // Label 1353: @85188
     /*  85188 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(85290), // Rule ID 3620 //
     /*  85193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  85201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85235 */     // MIs[1] Operand 1
     /*  85235 */     // No operand predicates
     /*  85235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85243 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85247 */     // MIs[2] Operand 1
     /*  85247 */     // No operand predicates
     /*  85247 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85249 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10730:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNP),
     /*  85273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85275 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85277 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85282 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85288 */     GIR_RootConstrainSelectedInstOperands,
     /*  85289 */     // GIR_Coverage, 3620,
     /*  85289 */     GIR_EraseRootFromParent_Done,
     /*  85290 */   // Label 1354: @85290
     /*  85290 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(85392), // Rule ID 3621 //
     /*  85295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  85298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  85303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  85325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85337 */     // MIs[1] Operand 1
     /*  85337 */     // No operand predicates
     /*  85337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85345 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85349 */     // MIs[2] Operand 1
     /*  85349 */     // No operand predicates
     /*  85349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85351 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10729:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85363 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERNN),
     /*  85375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85377 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85379 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85390 */     GIR_RootConstrainSelectedInstOperands,
     /*  85391 */     // GIR_Coverage, 3621,
     /*  85391 */     GIR_EraseRootFromParent_Done,
     /*  85392 */   // Label 1355: @85392
     /*  85392 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(85516), // Rule ID 3642 //
     /*  85397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpp),
     /*  85405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85439 */     // MIs[1] Operand 1
     /*  85439 */     // No operand predicates
     /*  85439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85451 */     // MIs[2] Operand 1
     /*  85451 */     // No operand predicates
     /*  85451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85453 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10727:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85453 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85456 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85460 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPP),
     /*  85498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85500 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85514 */     GIR_RootConstrainSelectedInstOperands,
     /*  85515 */     // GIR_Coverage, 3642,
     /*  85515 */     GIR_EraseRootFromParent_Done,
     /*  85516 */   // Label 1356: @85516
     /*  85516 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(85640), // Rule ID 3643 //
     /*  85521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gerpn),
     /*  85529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85563 */     // MIs[1] Operand 1
     /*  85563 */     // No operand predicates
     /*  85563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85571 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85575 */     // MIs[2] Operand 1
     /*  85575 */     // No operand predicates
     /*  85575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85577 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10726:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85577 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85580 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85584 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85589 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85610 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWPN),
     /*  85622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85624 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85638 */     GIR_RootConstrainSelectedInstOperands,
     /*  85639 */     // GIR_Coverage, 3643,
     /*  85639 */     GIR_EraseRootFromParent_Done,
     /*  85640 */   // Label 1357: @85640
     /*  85640 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(85764), // Rule ID 3644 //
     /*  85645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernp),
     /*  85653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85687 */     // MIs[1] Operand 1
     /*  85687 */     // No operand predicates
     /*  85687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85699 */     // MIs[2] Operand 1
     /*  85699 */     // No operand predicates
     /*  85699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85701 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10725:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85701 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85704 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85708 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85713 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85734 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85738 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNP),
     /*  85746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85748 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85762 */     GIR_RootConstrainSelectedInstOperands,
     /*  85763 */     // GIR_Coverage, 3644,
     /*  85763 */     GIR_EraseRootFromParent_Done,
     /*  85764 */   // Label 1358: @85764
     /*  85764 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(85888), // Rule ID 3645 //
     /*  85769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf32gernn),
     /*  85777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85811 */     // MIs[1] Operand 1
     /*  85811 */     // No operand predicates
     /*  85811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85819 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85823 */     // MIs[2] Operand 1
     /*  85823 */     // No operand predicates
     /*  85823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85825 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10724:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)  =>  (PMXVF32GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK)
     /*  85825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  85828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  85862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF32GERWNN),
     /*  85870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85872 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  85880 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85886 */     GIR_RootConstrainSelectedInstOperands,
     /*  85887 */     // GIR_Coverage, 3645,
     /*  85887 */     GIR_EraseRootFromParent_Done,
     /*  85888 */   // Label 1359: @85888
     /*  85888 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(85990), // Rule ID 3647 //
     /*  85893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpp),
     /*  85901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  85904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  85907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  85910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  85923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  85927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  85935 */     // MIs[1] Operand 1
     /*  85935 */     // No operand predicates
     /*  85935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  85939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85943 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  85947 */     // MIs[2] Operand 1
     /*  85947 */     // No operand predicates
     /*  85947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85949 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10732:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  85949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  85952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  85956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  85965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  85970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPP),
     /*  85973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  85975 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  85977 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  85979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85982 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  85985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  85988 */     GIR_RootConstrainSelectedInstOperands,
     /*  85989 */     // GIR_Coverage, 3647,
     /*  85989 */     GIR_EraseRootFromParent_Done,
     /*  85990 */   // Label 1360: @85990
     /*  85990 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(86092), // Rule ID 3648 //
     /*  85995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  85998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gerpn),
     /*  86003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86037 */     // MIs[1] Operand 1
     /*  86037 */     // No operand predicates
     /*  86037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86049 */     // MIs[2] Operand 1
     /*  86049 */     // No operand predicates
     /*  86049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86051 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10731:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  86051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86063 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWPN),
     /*  86075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86077 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86079 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  86081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86090 */     GIR_RootConstrainSelectedInstOperands,
     /*  86091 */     // GIR_Coverage, 3648,
     /*  86091 */     GIR_EraseRootFromParent_Done,
     /*  86092 */   // Label 1361: @86092
     /*  86092 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(86194), // Rule ID 3649 //
     /*  86097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernp),
     /*  86105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86139 */     // MIs[1] Operand 1
     /*  86139 */     // No operand predicates
     /*  86139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86147 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86151 */     // MIs[2] Operand 1
     /*  86151 */     // No operand predicates
     /*  86151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86153 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10730:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  86153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86165 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNP),
     /*  86177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86179 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86181 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  86183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86192 */     GIR_RootConstrainSelectedInstOperands,
     /*  86193 */     // GIR_Coverage, 3649,
     /*  86193 */     GIR_EraseRootFromParent_Done,
     /*  86194 */   // Label 1362: @86194
     /*  86194 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(86296), // Rule ID 3650 //
     /*  86199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf64gernn),
     /*  86207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  86210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  86213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  86229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86241 */     // MIs[1] Operand 1
     /*  86241 */     // No operand predicates
     /*  86241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86253 */     // MIs[2] Operand 1
     /*  86253 */     // No operand predicates
     /*  86253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86255 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10729:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v256i1:{ *:[v256i1] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)  =>  (PMXVF64GERWNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, ?:{ *:[v256i1] }:$XA, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$YMSK)
     /*  86255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF64GERWNN),
     /*  86279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86281 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86283 */     GIR_RootToRootCopy, /*OpIdx*/3, // XA
     /*  86285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86294 */     GIR_RootConstrainSelectedInstOperands,
     /*  86295 */     // GIR_Coverage, 3650,
     /*  86295 */     GIR_EraseRootFromParent_Done,
     /*  86296 */   // Label 1363: @86296
     /*  86296 */   GIM_Reject,
     /*  86297 */ // Label 1331: @86297
     /*  86297 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(91198),
     /*  86302 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  86305 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(86425), // Rule ID 3530 //
     /*  86310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4pp),
     /*  86318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86355 */     // MIs[1] Operand 1
     /*  86355 */     // No operand predicates
     /*  86355 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86359 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86363 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86367 */     // MIs[2] Operand 1
     /*  86367 */     // No operand predicates
     /*  86367 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86371 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86375 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86379 */     // MIs[3] Operand 1
     /*  86379 */     // No operand predicates
     /*  86379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86381 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10711:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4PP),
     /*  86405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86407 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86409 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86423 */     GIR_RootConstrainSelectedInstOperands,
     /*  86424 */     // GIR_Coverage, 3530,
     /*  86424 */     GIR_EraseRootFromParent_Done,
     /*  86425 */   // Label 1365: @86425
     /*  86425 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(86545), // Rule ID 3531 //
     /*  86430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvi8gerx4spp),
     /*  86438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86475 */     // MIs[1] Operand 1
     /*  86475 */     // No operand predicates
     /*  86475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86483 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86487 */     // MIs[2] Operand 1
     /*  86487 */     // No operand predicates
     /*  86487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86495 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86499 */     // MIs[3] Operand 1
     /*  86499 */     // No operand predicates
     /*  86499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86501 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10712:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMDMXVI8GERX4SPP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  86501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86513 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVI8GERX4SPP),
     /*  86525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86527 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86529 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86543 */     GIR_RootConstrainSelectedInstOperands,
     /*  86544 */     // GIR_Coverage, 3531,
     /*  86544 */     GIR_EraseRootFromParent_Done,
     /*  86545 */   // Label 1366: @86545
     /*  86545 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(86665), // Rule ID 3533 //
     /*  86550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pp),
     /*  86558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86595 */     // MIs[1] Operand 1
     /*  86595 */     // No operand predicates
     /*  86595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86603 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86607 */     // MIs[2] Operand 1
     /*  86607 */     // No operand predicates
     /*  86607 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86611 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86615 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86619 */     // MIs[3] Operand 1
     /*  86619 */     // No operand predicates
     /*  86619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86621 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10704:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86621 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86624 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86628 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86633 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86637 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PP),
     /*  86645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86647 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86649 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86663 */     GIR_RootConstrainSelectedInstOperands,
     /*  86664 */     // GIR_Coverage, 3533,
     /*  86664 */     GIR_EraseRootFromParent_Done,
     /*  86665 */   // Label 1367: @86665
     /*  86665 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(86785), // Rule ID 3534 //
     /*  86670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2pn),
     /*  86678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86715 */     // MIs[1] Operand 1
     /*  86715 */     // No operand predicates
     /*  86715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86723 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86727 */     // MIs[2] Operand 1
     /*  86727 */     // No operand predicates
     /*  86727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86731 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86735 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86739 */     // MIs[3] Operand 1
     /*  86739 */     // No operand predicates
     /*  86739 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86741 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10703:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2PN),
     /*  86765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86767 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86769 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86783 */     GIR_RootConstrainSelectedInstOperands,
     /*  86784 */     // GIR_Coverage, 3534,
     /*  86784 */     GIR_EraseRootFromParent_Done,
     /*  86785 */   // Label 1368: @86785
     /*  86785 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(86905), // Rule ID 3535 //
     /*  86790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2np),
     /*  86798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86835 */     // MIs[1] Operand 1
     /*  86835 */     // No operand predicates
     /*  86835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86843 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86847 */     // MIs[2] Operand 1
     /*  86847 */     // No operand predicates
     /*  86847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86855 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86859 */     // MIs[3] Operand 1
     /*  86859 */     // No operand predicates
     /*  86859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86861 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10702:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86873 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  86882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NP),
     /*  86885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  86887 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  86889 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  86891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  86897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  86900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  86903 */     GIR_RootConstrainSelectedInstOperands,
     /*  86904 */     // GIR_Coverage, 3535,
     /*  86904 */     GIR_EraseRootFromParent_Done,
     /*  86905 */   // Label 1369: @86905
     /*  86905 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(87025), // Rule ID 3536 //
     /*  86910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  86913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvbf16gerx2nn),
     /*  86918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  86921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  86924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  86927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  86943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  86947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  86955 */     // MIs[1] Operand 1
     /*  86955 */     // No operand predicates
     /*  86955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  86959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86963 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  86967 */     // MIs[2] Operand 1
     /*  86967 */     // No operand predicates
     /*  86967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  86971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86975 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  86979 */     // MIs[3] Operand 1
     /*  86979 */     // No operand predicates
     /*  86979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86981 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10701:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVBF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  86981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  86984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  86988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  86997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVBF16GERX2NN),
     /*  87005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87007 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87009 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87023 */     GIR_RootConstrainSelectedInstOperands,
     /*  87024 */     // GIR_Coverage, 3536,
     /*  87024 */     GIR_EraseRootFromParent_Done,
     /*  87025 */   // Label 1370: @87025
     /*  87025 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(87145), // Rule ID 3538 //
     /*  87030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pp),
     /*  87038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87075 */     // MIs[1] Operand 1
     /*  87075 */     // No operand predicates
     /*  87075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87083 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87087 */     // MIs[2] Operand 1
     /*  87087 */     // No operand predicates
     /*  87087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87099 */     // MIs[3] Operand 1
     /*  87099 */     // No operand predicates
     /*  87099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87101 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10709:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87113 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PP),
     /*  87125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87127 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87129 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87143 */     GIR_RootConstrainSelectedInstOperands,
     /*  87144 */     // GIR_Coverage, 3538,
     /*  87144 */     GIR_EraseRootFromParent_Done,
     /*  87145 */   // Label 1371: @87145
     /*  87145 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(87265), // Rule ID 3539 //
     /*  87150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2pn),
     /*  87158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87195 */     // MIs[1] Operand 1
     /*  87195 */     // No operand predicates
     /*  87195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87207 */     // MIs[2] Operand 1
     /*  87207 */     // No operand predicates
     /*  87207 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87211 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87215 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87219 */     // MIs[3] Operand 1
     /*  87219 */     // No operand predicates
     /*  87219 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87221 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10708:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2PN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2PN),
     /*  87245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87247 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87249 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87263 */     GIR_RootConstrainSelectedInstOperands,
     /*  87264 */     // GIR_Coverage, 3539,
     /*  87264 */     GIR_EraseRootFromParent_Done,
     /*  87265 */   // Label 1372: @87265
     /*  87265 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(87385), // Rule ID 3540 //
     /*  87270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2np),
     /*  87278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87315 */     // MIs[1] Operand 1
     /*  87315 */     // No operand predicates
     /*  87315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87327 */     // MIs[2] Operand 1
     /*  87327 */     // No operand predicates
     /*  87327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87335 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87339 */     // MIs[3] Operand 1
     /*  87339 */     // No operand predicates
     /*  87339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87341 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10707:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NP:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NP),
     /*  87365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87367 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87369 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87383 */     GIR_RootConstrainSelectedInstOperands,
     /*  87384 */     // GIR_Coverage, 3540,
     /*  87384 */     GIR_EraseRootFromParent_Done,
     /*  87385 */   // Label 1373: @87385
     /*  87385 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(87505), // Rule ID 3541 //
     /*  87390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  87393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmdmxvf16gerx2nn),
     /*  87398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v1024s1,
     /*  87401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v1024s1,
     /*  87404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v256s1,
     /*  87407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::DMRRCRegClassID),
     /*  87423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87435 */     // MIs[1] Operand 1
     /*  87435 */     // No operand predicates
     /*  87435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87443 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87447 */     // MIs[2] Operand 1
     /*  87447 */     // No operand predicates
     /*  87447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87455 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87459 */     // MIs[3] Operand 1
     /*  87459 */     // No operand predicates
     /*  87459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87461 */     // (intrinsic_wo_chain:{ *:[v1024i1] } 10706:{ *:[iPTR] }, v1024i1:{ *:[v1024i1] }:$ATi, v256i1:{ *:[v256i1] }:$XAp, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMDMXVF16GERX2NN:{ *:[v1024i1] } ?:{ *:[v1024i1] }:$ATi, ?:{ *:[v256i1] }:$XAp, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMDMXVF16GERX2NN),
     /*  87485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87487 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87489 */     GIR_RootToRootCopy, /*OpIdx*/3, // XAp
     /*  87491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87503 */     GIR_RootConstrainSelectedInstOperands,
     /*  87504 */     // GIR_Coverage, 3541,
     /*  87504 */     GIR_EraseRootFromParent_Done,
     /*  87505 */   // Label 1374: @87505
     /*  87505 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87647), // Rule ID 3602 //
     /*  87510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  87518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87555 */     // MIs[1] Operand 1
     /*  87555 */     // No operand predicates
     /*  87555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87567 */     // MIs[2] Operand 1
     /*  87567 */     // No operand predicates
     /*  87567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87575 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  87579 */     // MIs[3] Operand 1
     /*  87579 */     // No operand predicates
     /*  87579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87581 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10738:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  87581 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87584 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87588 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87593 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8PP),
     /*  87626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87628 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87645 */     GIR_RootConstrainSelectedInstOperands,
     /*  87646 */     // GIR_Coverage, 3602,
     /*  87646 */     GIR_EraseRootFromParent_Done,
     /*  87647 */   // Label 1375: @87647
     /*  87647 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(87789), // Rule ID 3604 //
     /*  87652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  87660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87697 */     // MIs[1] Operand 1
     /*  87697 */     // No operand predicates
     /*  87697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87705 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87709 */     // MIs[2] Operand 1
     /*  87709 */     // No operand predicates
     /*  87709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87717 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87721 */     // MIs[3] Operand 1
     /*  87721 */     // No operand predicates
     /*  87721 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87723 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10740:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  87723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87756 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4PP),
     /*  87768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87770 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87787 */     GIR_RootConstrainSelectedInstOperands,
     /*  87788 */     // GIR_Coverage, 3604,
     /*  87788 */     GIR_EraseRootFromParent_Done,
     /*  87789 */   // Label 1376: @87789
     /*  87789 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(87931), // Rule ID 3606 //
     /*  87794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  87802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87839 */     // MIs[1] Operand 1
     /*  87839 */     // No operand predicates
     /*  87839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87851 */     // MIs[2] Operand 1
     /*  87851 */     // No operand predicates
     /*  87851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  87863 */     // MIs[3] Operand 1
     /*  87863 */     // No operand predicates
     /*  87863 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  87865 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10736:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  87865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  87868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  87881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  87889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87898 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  87902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  87907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SPP),
     /*  87910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  87912 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  87914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  87920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  87923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  87926 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  87929 */     GIR_RootConstrainSelectedInstOperands,
     /*  87930 */     // GIR_Coverage, 3606,
     /*  87930 */     GIR_EraseRootFromParent_Done,
     /*  87931 */   // Label 1377: @87931
     /*  87931 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88073), // Rule ID 3608 //
     /*  87936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  87939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  87944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  87947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  87950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  87953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  87956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  87969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  87973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87981 */     // MIs[1] Operand 1
     /*  87981 */     // No operand predicates
     /*  87981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  87985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  87993 */     // MIs[2] Operand 1
     /*  87993 */     // No operand predicates
     /*  87993 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  87997 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88001 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88005 */     // MIs[3] Operand 1
     /*  88005 */     // No operand predicates
     /*  88005 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88007 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10722:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88040 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PP),
     /*  88052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88054 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88071 */     GIR_RootConstrainSelectedInstOperands,
     /*  88072 */     // GIR_Coverage, 3608,
     /*  88072 */     GIR_EraseRootFromParent_Done,
     /*  88073 */   // Label 1378: @88073
     /*  88073 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88215), // Rule ID 3609 //
     /*  88078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  88086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88123 */     // MIs[1] Operand 1
     /*  88123 */     // No operand predicates
     /*  88123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88135 */     // MIs[2] Operand 1
     /*  88135 */     // No operand predicates
     /*  88135 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88139 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88143 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88147 */     // MIs[3] Operand 1
     /*  88147 */     // No operand predicates
     /*  88147 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88149 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10721:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88161 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88165 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88186 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2PN),
     /*  88194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88196 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88213 */     GIR_RootConstrainSelectedInstOperands,
     /*  88214 */     // GIR_Coverage, 3609,
     /*  88214 */     GIR_EraseRootFromParent_Done,
     /*  88215 */   // Label 1379: @88215
     /*  88215 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88357), // Rule ID 3610 //
     /*  88220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  88228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88265 */     // MIs[1] Operand 1
     /*  88265 */     // No operand predicates
     /*  88265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88277 */     // MIs[2] Operand 1
     /*  88277 */     // No operand predicates
     /*  88277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88285 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88289 */     // MIs[3] Operand 1
     /*  88289 */     // No operand predicates
     /*  88289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88291 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10720:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88291 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88294 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88298 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88303 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88307 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88324 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NP),
     /*  88336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88338 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88355 */     GIR_RootConstrainSelectedInstOperands,
     /*  88356 */     // GIR_Coverage, 3610,
     /*  88356 */     GIR_EraseRootFromParent_Done,
     /*  88357 */   // Label 1380: @88357
     /*  88357 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(88499), // Rule ID 3611 //
     /*  88362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  88370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88407 */     // MIs[1] Operand 1
     /*  88407 */     // No operand predicates
     /*  88407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88419 */     // MIs[2] Operand 1
     /*  88419 */     // No operand predicates
     /*  88419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88431 */     // MIs[3] Operand 1
     /*  88431 */     // No operand predicates
     /*  88431 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88433 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10719:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88433 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88436 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88440 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88445 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88470 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2NN),
     /*  88478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88480 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88497 */     GIR_RootConstrainSelectedInstOperands,
     /*  88498 */     // GIR_Coverage, 3611,
     /*  88498 */     GIR_EraseRootFromParent_Done,
     /*  88499 */   // Label 1381: @88499
     /*  88499 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(88641), // Rule ID 3623 //
     /*  88504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  88512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88549 */     // MIs[1] Operand 1
     /*  88549 */     // No operand predicates
     /*  88549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88561 */     // MIs[2] Operand 1
     /*  88561 */     // No operand predicates
     /*  88561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88573 */     // MIs[3] Operand 1
     /*  88573 */     // No operand predicates
     /*  88573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88575 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10717:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88591 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88608 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PP),
     /*  88620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88622 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88639 */     GIR_RootConstrainSelectedInstOperands,
     /*  88640 */     // GIR_Coverage, 3623,
     /*  88640 */     GIR_EraseRootFromParent_Done,
     /*  88641 */   // Label 1382: @88641
     /*  88641 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(88783), // Rule ID 3624 //
     /*  88646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  88654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88687 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88691 */     // MIs[1] Operand 1
     /*  88691 */     // No operand predicates
     /*  88691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88703 */     // MIs[2] Operand 1
     /*  88703 */     // No operand predicates
     /*  88703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88715 */     // MIs[3] Operand 1
     /*  88715 */     // No operand predicates
     /*  88715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88717 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10716:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2PN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88729 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88733 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2PN),
     /*  88762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88764 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88781 */     GIR_RootConstrainSelectedInstOperands,
     /*  88782 */     // GIR_Coverage, 3624,
     /*  88782 */     GIR_EraseRootFromParent_Done,
     /*  88783 */   // Label 1383: @88783
     /*  88783 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(88925), // Rule ID 3625 //
     /*  88788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  88796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88833 */     // MIs[1] Operand 1
     /*  88833 */     // No operand predicates
     /*  88833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88841 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88845 */     // MIs[2] Operand 1
     /*  88845 */     // No operand predicates
     /*  88845 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88849 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88853 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88857 */     // MIs[3] Operand 1
     /*  88857 */     // No operand predicates
     /*  88857 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  88859 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10715:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  88859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  88862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88871 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  88875 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  88883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  88896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  88901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NP),
     /*  88904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  88906 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  88908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  88914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  88917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  88920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  88923 */     GIR_RootConstrainSelectedInstOperands,
     /*  88924 */     // GIR_Coverage, 3625,
     /*  88924 */     GIR_EraseRootFromParent_Done,
     /*  88925 */   // Label 1384: @88925
     /*  88925 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89067), // Rule ID 3626 //
     /*  88930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  88933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  88938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  88941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  88944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  88947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  88950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  88963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  88967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88975 */     // MIs[1] Operand 1
     /*  88975 */     // No operand predicates
     /*  88975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  88979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  88987 */     // MIs[2] Operand 1
     /*  88987 */     // No operand predicates
     /*  88987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  88991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88995 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  88999 */     // MIs[3] Operand 1
     /*  88999 */     // No operand predicates
     /*  88999 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89001 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10714:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2NN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89013 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89034 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2NN),
     /*  89046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89048 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89065 */     GIR_RootConstrainSelectedInstOperands,
     /*  89066 */     // GIR_Coverage, 3626,
     /*  89066 */     GIR_EraseRootFromParent_Done,
     /*  89067 */   // Label 1385: @89067
     /*  89067 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89209), // Rule ID 3628 //
     /*  89072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  89075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  89080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  89105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89117 */     // MIs[1] Operand 1
     /*  89117 */     // No operand predicates
     /*  89117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89129 */     // MIs[2] Operand 1
     /*  89129 */     // No operand predicates
     /*  89129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89137 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89141 */     // MIs[3] Operand 1
     /*  89141 */     // No operand predicates
     /*  89141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89143 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10741:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4SPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89176 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4SPP),
     /*  89188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89190 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89207 */     GIR_RootConstrainSelectedInstOperands,
     /*  89208 */     // GIR_Coverage, 3628,
     /*  89208 */     GIR_EraseRootFromParent_Done,
     /*  89209 */   // Label 1386: @89209
     /*  89209 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(89351), // Rule ID 3629 //
     /*  89214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISAFuture_MMA_PrefixInstrs),
     /*  89217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  89222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  89247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89259 */     // MIs[1] Operand 1
     /*  89259 */     // No operand predicates
     /*  89259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89267 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89271 */     // MIs[2] Operand 1
     /*  89271 */     // No operand predicates
     /*  89271 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89275 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89279 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89283 */     // MIs[3] Operand 1
     /*  89283 */     // No operand predicates
     /*  89283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89285 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10734:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2PP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89285 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89288 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89292 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89297 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89301 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2PP),
     /*  89330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89332 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89349 */     GIR_RootConstrainSelectedInstOperands,
     /*  89350 */     // GIR_Coverage, 3629,
     /*  89350 */     GIR_EraseRootFromParent_Done,
     /*  89351 */   // Label 1387: @89351
     /*  89351 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(89493), // Rule ID 3631 //
     /*  89356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi4ger8pp),
     /*  89364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89401 */     // MIs[1] Operand 1
     /*  89401 */     // No operand predicates
     /*  89401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89413 */     // MIs[2] Operand 1
     /*  89413 */     // No operand predicates
     /*  89413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89421 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk8Imm),
     /*  89425 */     // MIs[3] Operand 1
     /*  89425 */     // No operand predicates
     /*  89425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89427 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10738:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)  =>  (PMXVI4GER8WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk8Imm>>:$PMSK)
     /*  89427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89460 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI4GER8WPP),
     /*  89472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89474 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89491 */     GIR_RootConstrainSelectedInstOperands,
     /*  89492 */     // GIR_Coverage, 3631,
     /*  89492 */     GIR_EraseRootFromParent_Done,
     /*  89493 */   // Label 1388: @89493
     /*  89493 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(89635), // Rule ID 3633 //
     /*  89498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4pp),
     /*  89506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89543 */     // MIs[1] Operand 1
     /*  89543 */     // No operand predicates
     /*  89543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89551 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89555 */     // MIs[2] Operand 1
     /*  89555 */     // No operand predicates
     /*  89555 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89559 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89563 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89567 */     // MIs[3] Operand 1
     /*  89567 */     // No operand predicates
     /*  89567 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89569 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10740:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)  =>  (PMXVI8GER4WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$PMSK)
     /*  89569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89585 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89602 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WPP),
     /*  89614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89616 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89633 */     GIR_RootConstrainSelectedInstOperands,
     /*  89634 */     // GIR_Coverage, 3633,
     /*  89634 */     GIR_EraseRootFromParent_Done,
     /*  89635 */   // Label 1389: @89635
     /*  89635 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89777), // Rule ID 3635 //
     /*  89640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2spp),
     /*  89648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89685 */     // MIs[1] Operand 1
     /*  89685 */     // No operand predicates
     /*  89685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89693 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89697 */     // MIs[2] Operand 1
     /*  89697 */     // No operand predicates
     /*  89697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89705 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89709 */     // MIs[3] Operand 1
     /*  89709 */     // No operand predicates
     /*  89709 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89711 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10736:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2SWPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89711 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89714 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89718 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89727 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2SWPP),
     /*  89756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89758 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89775 */     GIR_RootConstrainSelectedInstOperands,
     /*  89776 */     // GIR_Coverage, 3635,
     /*  89776 */     GIR_EraseRootFromParent_Done,
     /*  89777 */   // Label 1390: @89777
     /*  89777 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89919), // Rule ID 3637 //
     /*  89782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pp),
     /*  89790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89827 */     // MIs[1] Operand 1
     /*  89827 */     // No operand predicates
     /*  89827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89835 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89839 */     // MIs[2] Operand 1
     /*  89839 */     // No operand predicates
     /*  89839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89847 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89851 */     // MIs[3] Operand 1
     /*  89851 */     // No operand predicates
     /*  89851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89853 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10722:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89865 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  89869 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  89877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  89886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  89890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  89895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPP),
     /*  89898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  89900 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  89902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  89905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  89908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  89911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  89914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  89917 */     GIR_RootConstrainSelectedInstOperands,
     /*  89918 */     // GIR_Coverage, 3637,
     /*  89918 */     GIR_EraseRootFromParent_Done,
     /*  89919 */   // Label 1391: @89919
     /*  89919 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(90061), // Rule ID 3638 //
     /*  89924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  89927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2pn),
     /*  89932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  89935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  89938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  89941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  89944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  89957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  89961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89969 */     // MIs[1] Operand 1
     /*  89969 */     // No operand predicates
     /*  89969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  89973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89977 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  89981 */     // MIs[2] Operand 1
     /*  89981 */     // No operand predicates
     /*  89981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  89985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  89993 */     // MIs[3] Operand 1
     /*  89993 */     // No operand predicates
     /*  89993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89995 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10721:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  89995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  89998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WPN),
     /*  90040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90042 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90059 */     GIR_RootConstrainSelectedInstOperands,
     /*  90060 */     // GIR_Coverage, 3638,
     /*  90060 */     GIR_EraseRootFromParent_Done,
     /*  90061 */   // Label 1392: @90061
     /*  90061 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(90203), // Rule ID 3639 //
     /*  90066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2np),
     /*  90074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90111 */     // MIs[1] Operand 1
     /*  90111 */     // No operand predicates
     /*  90111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90123 */     // MIs[2] Operand 1
     /*  90123 */     // No operand predicates
     /*  90123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90131 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90135 */     // MIs[3] Operand 1
     /*  90135 */     // No operand predicates
     /*  90135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90137 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10720:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90149 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNP),
     /*  90182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90184 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90201 */     GIR_RootConstrainSelectedInstOperands,
     /*  90202 */     // GIR_Coverage, 3639,
     /*  90202 */     GIR_EraseRootFromParent_Done,
     /*  90203 */   // Label 1393: @90203
     /*  90203 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(90345), // Rule ID 3640 //
     /*  90208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvf16ger2nn),
     /*  90216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90253 */     // MIs[1] Operand 1
     /*  90253 */     // No operand predicates
     /*  90253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90261 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90265 */     // MIs[2] Operand 1
     /*  90265 */     // No operand predicates
     /*  90265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90273 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90277 */     // MIs[3] Operand 1
     /*  90277 */     // No operand predicates
     /*  90277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90279 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10719:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90279 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90282 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90286 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVF16GER2WNN),
     /*  90324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90326 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90343 */     GIR_RootConstrainSelectedInstOperands,
     /*  90344 */     // GIR_Coverage, 3640,
     /*  90344 */     GIR_EraseRootFromParent_Done,
     /*  90345 */   // Label 1394: @90345
     /*  90345 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(90487), // Rule ID 3652 //
     /*  90350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pp),
     /*  90358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90395 */     // MIs[1] Operand 1
     /*  90395 */     // No operand predicates
     /*  90395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90407 */     // MIs[2] Operand 1
     /*  90407 */     // No operand predicates
     /*  90407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90415 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90419 */     // MIs[3] Operand 1
     /*  90419 */     // No operand predicates
     /*  90419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90421 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10717:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90437 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPP),
     /*  90466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90468 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90485 */     GIR_RootConstrainSelectedInstOperands,
     /*  90486 */     // GIR_Coverage, 3652,
     /*  90486 */     GIR_EraseRootFromParent_Done,
     /*  90487 */   // Label 1395: @90487
     /*  90487 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(90629), // Rule ID 3653 //
     /*  90492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2pn),
     /*  90500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90537 */     // MIs[1] Operand 1
     /*  90537 */     // No operand predicates
     /*  90537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90545 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90549 */     // MIs[2] Operand 1
     /*  90549 */     // No operand predicates
     /*  90549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90557 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90561 */     // MIs[3] Operand 1
     /*  90561 */     // No operand predicates
     /*  90561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90563 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10716:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WPN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90563 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90566 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90570 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90575 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WPN),
     /*  90608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90610 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90627 */     GIR_RootConstrainSelectedInstOperands,
     /*  90628 */     // GIR_Coverage, 3653,
     /*  90628 */     GIR_EraseRootFromParent_Done,
     /*  90629 */   // Label 1396: @90629
     /*  90629 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(90771), // Rule ID 3654 //
     /*  90634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2np),
     /*  90642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90679 */     // MIs[1] Operand 1
     /*  90679 */     // No operand predicates
     /*  90679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90687 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90691 */     // MIs[2] Operand 1
     /*  90691 */     // No operand predicates
     /*  90691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90699 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90703 */     // MIs[3] Operand 1
     /*  90703 */     // No operand predicates
     /*  90703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90705 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10715:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90705 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90708 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90712 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90721 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90738 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNP),
     /*  90750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90752 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90769 */     GIR_RootConstrainSelectedInstOperands,
     /*  90770 */     // GIR_Coverage, 3654,
     /*  90770 */     GIR_EraseRootFromParent_Done,
     /*  90771 */   // Label 1397: @90771
     /*  90771 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(90913), // Rule ID 3655 //
     /*  90776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvbf16ger2nn),
     /*  90784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90821 */     // MIs[1] Operand 1
     /*  90821 */     // No operand predicates
     /*  90821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90829 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90833 */     // MIs[2] Operand 1
     /*  90833 */     // No operand predicates
     /*  90833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90845 */     // MIs[3] Operand 1
     /*  90845 */     // No operand predicates
     /*  90845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90847 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10714:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVBF16GER2WNN:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  90863 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  90871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  90884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  90889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVBF16GER2WNN),
     /*  90892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  90894 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  90896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  90905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  90908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  90911 */     GIR_RootConstrainSelectedInstOperands,
     /*  90912 */     // GIR_Coverage, 3655,
     /*  90912 */     GIR_EraseRootFromParent_Done,
     /*  90913 */   // Label 1398: @90913
     /*  90913 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(91055), // Rule ID 3657 //
     /*  90918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  90921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi8ger4spp),
     /*  90926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  90929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  90932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  90935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  90938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::WACCRCRegClassID),
     /*  90951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  90955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90963 */     // MIs[1] Operand 1
     /*  90963 */     // No operand predicates
     /*  90963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  90967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  90975 */     // MIs[2] Operand 1
     /*  90975 */     // No operand predicates
     /*  90975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  90979 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90983 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  90987 */     // MIs[3] Operand 1
     /*  90987 */     // No operand predicates
     /*  90987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90989 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10741:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI8GER4WSPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  90989 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  90992 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90996 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91001 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  91005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  91013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  91026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI8GER4WSPP),
     /*  91034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  91036 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  91038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  91047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  91050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  91053 */     GIR_RootConstrainSelectedInstOperands,
     /*  91054 */     // GIR_Coverage, 3657,
     /*  91054 */     GIR_EraseRootFromParent_Done,
     /*  91055 */   // Label 1399: @91055
     /*  91055 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(91197), // Rule ID 3658 //
     /*  91060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISAFuture_MMA_PrefixInstrs),
     /*  91063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mma_pmxvi16ger2pp),
     /*  91068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v512s1,
     /*  91071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v512s1,
     /*  91074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  91077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  91080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::ACCRCRegClassID),
     /*  91093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/5, // MIs[1]
     /*  91097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  91105 */     // MIs[1] Operand 1
     /*  91105 */     // No operand predicates
     /*  91105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/6, // MIs[2]
     /*  91109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk4Imm),
     /*  91117 */     // MIs[2] Operand 1
     /*  91117 */     // No operand predicates
     /*  91117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/7, // MIs[3]
     /*  91121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91125 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_Msk2Imm),
     /*  91129 */     // MIs[3] Operand 1
     /*  91129 */     // No operand predicates
     /*  91129 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91131 */     // (intrinsic_wo_chain:{ *:[v512i1] } 10734:{ *:[iPTR] }, v512i1:{ *:[v512i1] }:$ATi, v16i8:{ *:[v16i8] }:$XA, v16i8:{ *:[v16i8] }:$XB, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)  =>  (PMXVI16GER2WPP:{ *:[v512i1] } ?:{ *:[v512i1] }:$ATi, (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XA, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$XB, VSRC:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$XMSK, (imm:{ *:[i32] })<<P:Predicate_Msk4Imm>>:$YMSK, (imm:{ *:[i32] })<<P:Predicate_Msk2Imm>>:$PMSK)
     /*  91131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  91134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91143 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/4, // XB
     /*  91147 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  91155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // XA
     /*  91168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /*  91173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PMXVI16GER2WPP),
     /*  91176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[AT]
     /*  91178 */     GIR_RootToRootCopy, /*OpIdx*/2, // ATi
     /*  91180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  91183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  91186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // XMSK
     /*  91189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // YMSK
     /*  91192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // PMSK
     /*  91195 */     GIR_RootConstrainSelectedInstOperands,
     /*  91196 */     // GIR_Coverage, 3658,
     /*  91196 */     GIR_EraseRootFromParent_Done,
     /*  91197 */   // Label 1400: @91197
     /*  91197 */   GIM_Reject,
     /*  91198 */ // Label 1364: @91198
     /*  91198 */ GIM_Reject,
     /*  91199 */ // Label 20: @91199
     /*  91199 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(91538),
     /*  91204 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91207 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(91226), // Rule ID 106 //
     /*  91212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  91217 */     // (intrinsic_void 10617:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91220 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91224 */     GIR_RootConstrainSelectedInstOperands,
     /*  91225 */     // GIR_Coverage, 106,
     /*  91225 */     GIR_EraseRootFromParent_Done,
     /*  91226 */   // Label 1402: @91226
     /*  91226 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(91251), // Rule ID 1201 //
     /*  91231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  91239 */     // (intrinsic_void 10815:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  91239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91249 */     GIR_RootConstrainSelectedInstOperands,
     /*  91250 */     // GIR_Coverage, 1201,
     /*  91250 */     GIR_EraseRootFromParent_Done,
     /*  91251 */   // Label 1403: @91251
     /*  91251 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(91276), // Rule ID 1202 //
     /*  91256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  91264 */     // (intrinsic_void 10652:{ *:[iPTR] })  =>  (SYNC 0:{ *:[i32] })
     /*  91264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91274 */     GIR_RootConstrainSelectedInstOperands,
     /*  91275 */     // GIR_Coverage, 1202,
     /*  91275 */     GIR_EraseRootFromParent_Done,
     /*  91276 */   // Label 1404: @91276
     /*  91276 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(91301), // Rule ID 1203 //
     /*  91281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  91289 */     // (intrinsic_void 10661:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  91289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91299 */     GIR_RootConstrainSelectedInstOperands,
     /*  91300 */     // GIR_Coverage, 1203,
     /*  91300 */     GIR_EraseRootFromParent_Done,
     /*  91301 */   // Label 1405: @91301
     /*  91301 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(91326), // Rule ID 1204 //
     /*  91306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSYNC),
     /*  91309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91314 */     // (intrinsic_void 10651:{ *:[iPTR] })  =>  (SYNC 1:{ *:[i32] })
     /*  91314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SYNC),
     /*  91317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91324 */     GIR_RootConstrainSelectedInstOperands,
     /*  91325 */     // GIR_Coverage, 1204,
     /*  91325 */     GIR_EraseRootFromParent_Done,
     /*  91326 */   // Label 1406: @91326
     /*  91326 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(91348), // Rule ID 1205 //
     /*  91331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_sync),
     /*  91339 */     // (intrinsic_void 10815:{ *:[iPTR] })  =>  (MSYNC)
     /*  91339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91342 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91346 */     GIR_RootConstrainSelectedInstOperands,
     /*  91347 */     // GIR_Coverage, 1205,
     /*  91347 */     GIR_EraseRootFromParent_Done,
     /*  91348 */   // Label 1407: @91348
     /*  91348 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(91370), // Rule ID 1206 //
     /*  91353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_sync),
     /*  91361 */     // (intrinsic_void 10652:{ *:[iPTR] })  =>  (MSYNC)
     /*  91361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91368 */     GIR_RootConstrainSelectedInstOperands,
     /*  91369 */     // GIR_Coverage, 1206,
     /*  91369 */     GIR_EraseRootFromParent_Done,
     /*  91370 */   // Label 1408: @91370
     /*  91370 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(91392), // Rule ID 1207 //
     /*  91375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_lwsync),
     /*  91383 */     // (intrinsic_void 10661:{ *:[iPTR] })  =>  (MSYNC)
     /*  91383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91390 */     GIR_RootConstrainSelectedInstOperands,
     /*  91391 */     // GIR_Coverage, 1207,
     /*  91391 */     GIR_EraseRootFromParent_Done,
     /*  91392 */   // Label 1409: @91392
     /*  91392 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(91414), // Rule ID 1208 //
     /*  91397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasOnlyMSYNC),
     /*  91400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_lwsync),
     /*  91405 */     // (intrinsic_void 10651:{ *:[iPTR] })  =>  (MSYNC)
     /*  91405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MSYNC),
     /*  91408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91412 */     GIR_RootConstrainSelectedInstOperands,
     /*  91413 */     // GIR_Coverage, 1208,
     /*  91413 */     GIR_EraseRootFromParent_Done,
     /*  91414 */   // Label 1410: @91414
     /*  91414 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(91433), // Rule ID 1209 //
     /*  91419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_eieio),
     /*  91424 */     // (intrinsic_void 10617:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91431 */     GIR_RootConstrainSelectedInstOperands,
     /*  91432 */     // GIR_Coverage, 1209,
     /*  91432 */     GIR_EraseRootFromParent_Done,
     /*  91433 */   // Label 1411: @91433
     /*  91433 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(91452), // Rule ID 1210 //
     /*  91438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_iospace_eieio),
     /*  91443 */     // (intrinsic_void 10650:{ *:[iPTR] })  =>  (PseudoEIEIO)
     /*  91443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PseudoEIEIO),
     /*  91446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91450 */     GIR_RootConstrainSelectedInstOperands,
     /*  91451 */     // GIR_Coverage, 1210,
     /*  91451 */     GIR_EraseRootFromParent_Done,
     /*  91452 */   // Label 1412: @91452
     /*  91452 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(91474), // Rule ID 1236 //
     /*  91457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_fence),
     /*  91462 */     // (intrinsic_void 10628:{ *:[iPTR] })  =>  (FENCE)
     /*  91462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FENCE),
     /*  91465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91472 */     GIR_RootConstrainSelectedInstOperands,
     /*  91473 */     // GIR_Coverage, 1236,
     /*  91473 */     GIR_EraseRootFromParent_Done,
     /*  91474 */   // Label 1413: @91474
     /*  91474 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(91496), // Rule ID 1290 //
     /*  91479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsAIX),
     /*  91482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91487 */     // (intrinsic_void 10269:{ *:[iPTR] })  =>  (NOP)
     /*  91487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::NOP),
     /*  91490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91494 */     GIR_RootConstrainSelectedInstOperands,
     /*  91495 */     // GIR_Coverage, 1290,
     /*  91495 */     GIR_EraseRootFromParent_Done,
     /*  91496 */   // Label 1414: @91496
     /*  91496 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(91518), // Rule ID 1291 //
     /*  91501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotAIX),
     /*  91504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dssall),
     /*  91509 */     // (intrinsic_void 10269:{ *:[iPTR] })  =>  (DSSALL)
     /*  91509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSSALL),
     /*  91512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91516 */     GIR_RootConstrainSelectedInstOperands,
     /*  91517 */     // GIR_Coverage, 1291,
     /*  91517 */     GIR_EraseRootFromParent_Done,
     /*  91518 */   // Label 1415: @91518
     /*  91518 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(91537), // Rule ID 4860 //
     /*  91523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_isync),
     /*  91528 */     // (intrinsic_void 10653:{ *:[iPTR] })  =>  (ISYNC)
     /*  91528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ISYNC),
     /*  91531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91535 */     GIR_RootConstrainSelectedInstOperands,
     /*  91536 */     // GIR_Coverage, 4860,
     /*  91536 */     GIR_EraseRootFromParent_Done,
     /*  91537 */   // Label 1416: @91537
     /*  91537 */   GIM_Reject,
     /*  91538 */ // Label 1401: @91538
     /*  91538 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(92421),
     /*  91543 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91546 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91585), // Rule ID 269 //
     /*  91551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dss),
     /*  91559 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91570 */     // MIs[1] Operand 1
     /*  91570 */     // No operand predicates
     /*  91570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91572 */     // (intrinsic_void 10268:{ *:[iPTR] }, (imm:{ *:[i32] }):$STRM)  =>  (DSS (imm:{ *:[i32] }):$STRM)
     /*  91572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSS),
     /*  91575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  91578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91583 */     GIR_RootConstrainSelectedInstOperands,
     /*  91584 */     // GIR_Coverage, 269,
     /*  91584 */     GIR_EraseRootFromParent_Done,
     /*  91585 */   // Label 1418: @91585
     /*  91585 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91611), // Rule ID 193 //
     /*  91590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb0),
     /*  91598 */     // MIs[0] FM
     /*  91598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91601 */     // (intrinsic_void 10774:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB0 (timm:{ *:[i32] }):$FM)
     /*  91601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB0),
     /*  91604 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91609 */     GIR_RootConstrainSelectedInstOperands,
     /*  91610 */     // GIR_Coverage, 193,
     /*  91610 */     GIR_EraseRootFromParent_Done,
     /*  91611 */   // Label 1419: @91611
     /*  91611 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91637), // Rule ID 194 //
     /*  91616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  91619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsb1),
     /*  91624 */     // MIs[0] FM
     /*  91624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  91627 */     // (intrinsic_void 10775:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM)  =>  (MTFSB1 (timm:{ *:[i32] }):$FM)
     /*  91627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSB1),
     /*  91630 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  91632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  91635 */     GIR_RootConstrainSelectedInstOperands,
     /*  91636 */     // GIR_Coverage, 194,
     /*  91636 */     GIR_EraseRootFromParent_Done,
     /*  91637 */   // Label 1420: @91637
     /*  91637 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91664), // Rule ID 278 //
     /*  91642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  91645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_mfvscr),
     /*  91650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  91657 */     // (intrinsic_w_chain:{ *:[v8i16] } 10281:{ *:[iPTR] })  =>  (MFVSCR:{ *:[v8i16] })
     /*  91657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSCR),
     /*  91660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  91662 */     GIR_RootConstrainSelectedInstOperands,
     /*  91663 */     // GIR_Coverage, 278,
     /*  91663 */     GIR_EraseRootFromParent_Done,
     /*  91664 */   // Label 1421: @91664
     /*  91664 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91688), // Rule ID 1237 //
     /*  91669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_readflm),
     /*  91674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91681 */     // (intrinsic_w_chain:{ *:[f64] } 10792:{ *:[iPTR] })  =>  (MFFS:{ *:[f64] })
     /*  91681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFS),
     /*  91684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91686 */     GIR_RootConstrainSelectedInstOperands,
     /*  91687 */     // GIR_Coverage, 1237,
     /*  91687 */     GIR_EraseRootFromParent_Done,
     /*  91688 */   // Label 1422: @91688
     /*  91688 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91716), // Rule ID 1238 //
     /*  91693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mffsl),
     /*  91698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  91705 */     // (intrinsic_w_chain:{ *:[f64] } 10668:{ *:[iPTR] })  =>  (MFFSL:{ *:[f64] })
     /*  91705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFFSL),
     /*  91708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91714 */     GIR_RootConstrainSelectedInstOperands,
     /*  91715 */     // GIR_Coverage, 1238,
     /*  91715 */     GIR_EraseRootFromParent_Done,
     /*  91716 */   // Label 1423: @91716
     /*  91716 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91780), // Rule ID 1574 //
     /*  91721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn32),
     /*  91729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91736 */     // (intrinsic_w_chain:{ *:[i32] } 10594:{ *:[iPTR] })  =>  (EXTRACT_SUBREG:{ *:[i32] } (DARN:{ *:[i64] } 0:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  91736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  91739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  91748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  91751 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  91757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  91762 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  91769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91779 */     // GIR_Coverage, 1574,
     /*  91779 */     GIR_EraseRootFromParent_Done,
     /*  91780 */   // Label 1424: @91780
     /*  91780 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(91814), // Rule ID 1575 //
     /*  91785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darn),
     /*  91793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91800 */     // (intrinsic_w_chain:{ *:[i64] } 10593:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 1:{ *:[i32] })
     /*  91800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  91808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91812 */     GIR_RootConstrainSelectedInstOperands,
     /*  91813 */     // GIR_Coverage, 1575,
     /*  91813 */     GIR_EraseRootFromParent_Done,
     /*  91814 */   // Label 1425: @91814
     /*  91814 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91848), // Rule ID 1576 //
     /*  91819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /*  91822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_darnraw),
     /*  91827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91834 */     // (intrinsic_w_chain:{ *:[i64] } 10595:{ *:[iPTR] })  =>  (DARN:{ *:[i64] } 2:{ *:[i32] })
     /*  91834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DARN),
     /*  91837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  91839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  91842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91846 */     GIR_RootConstrainSelectedInstOperands,
     /*  91847 */     // GIR_Coverage, 1576,
     /*  91847 */     GIR_EraseRootFromParent_Done,
     /*  91848 */   // Label 1426: @91848
     /*  91848 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91879), // Rule ID 2893 //
     /*  91853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tcheck),
     /*  91861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  91864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  91868 */     // (intrinsic_w_chain:{ *:[i32] } 10822:{ *:[iPTR] })  =>  (TCHECK_RET:{ *:[i32] })
     /*  91868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TCHECK_RET),
     /*  91871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /*  91873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91877 */     GIR_RootConstrainSelectedInstOperands,
     /*  91878 */     // GIR_Coverage, 2893,
     /*  91878 */     GIR_EraseRootFromParent_Done,
     /*  91879 */   // Label 1427: @91879
     /*  91879 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91920), // Rule ID 2897 //
     /*  91884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasr),
     /*  91892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91899 */     // (intrinsic_w_chain:{ *:[i64] } 10644:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 130:{ *:[i32] })
     /*  91899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91904 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  91914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91918 */     GIR_RootConstrainSelectedInstOperands,
     /*  91919 */     // GIR_Coverage, 2897,
     /*  91919 */     GIR_EraseRootFromParent_Done,
     /*  91920 */   // Label 1428: @91920
     /*  91920 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91961), // Rule ID 2898 //
     /*  91925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_texasru),
     /*  91933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91940 */     // (intrinsic_w_chain:{ *:[i64] } 10645:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 131:{ *:[i32] })
     /*  91940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91945 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  91955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91959 */     GIR_RootConstrainSelectedInstOperands,
     /*  91960 */     // GIR_Coverage, 2898,
     /*  91960 */     GIR_EraseRootFromParent_Done,
     /*  91961 */   // Label 1429: @91961
     /*  91961 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(92002), // Rule ID 2899 //
     /*  91966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  91969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfhar),
     /*  91974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  91977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  91981 */     // (intrinsic_w_chain:{ *:[i64] } 10646:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 128:{ *:[i32] })
     /*  91981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  91984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  91986 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  91996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92000 */     GIR_RootConstrainSelectedInstOperands,
     /*  92001 */     // GIR_Coverage, 2899,
     /*  92001 */     GIR_EraseRootFromParent_Done,
     /*  92002 */   // Label 1430: @92002
     /*  92002 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(92043), // Rule ID 2900 //
     /*  92007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_get_tfiar),
     /*  92015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92022 */     // (intrinsic_w_chain:{ *:[i64] } 10647:{ *:[iPTR] })  =>  (MFSPR8:{ *:[i64] } 129:{ *:[i32] })
     /*  92022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  92025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92027 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  92037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92041 */     GIR_RootConstrainSelectedInstOperands,
     /*  92042 */     // GIR_Coverage, 2900,
     /*  92042 */     GIR_EraseRootFromParent_Done,
     /*  92043 */   // Label 1431: @92043
     /*  92043 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(92074), // Rule ID 4910 //
     /*  92048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtmsr),
     /*  92053 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92060 */     // (intrinsic_void 10778:{ *:[iPTR] }, gprc:{ *:[i32] }:$RS)  =>  (MTMSR ?:{ *:[i32] }:$RS, 0:{ *:[i32] })
     /*  92060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTMSR),
     /*  92063 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /*  92065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92072 */     GIR_RootConstrainSelectedInstOperands,
     /*  92073 */     // GIR_Coverage, 4910,
     /*  92073 */     GIR_EraseRootFromParent_Done,
     /*  92074 */   // Label 1432: @92074
     /*  92074 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(92101), // Rule ID 189 //
     /*  92079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  92084 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92087 */     // (intrinsic_void 326:{ *:[iPTR] }, i32:{ *:[i32] }:$RST)  =>  (MTCTRloop:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /*  92087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTRloop),
     /*  92090 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  92092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  92095 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92099 */     GIR_RootConstrainSelectedInstOperands,
     /*  92100 */     // GIR_Coverage, 189,
     /*  92100 */     GIR_EraseRootFromParent_Done,
     /*  92101 */   // Label 1433: @92101
     /*  92101 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92124), // Rule ID 279 //
     /*  92106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_mtvscr),
     /*  92114 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92117 */     // (intrinsic_void 10282:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VB)  =>  (MTVSCR v4i32:{ *:[v4i32] }:$VB)
     /*  92117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTVSCR),
     /*  92120 */     GIR_RootToRootCopy, /*OpIdx*/1, // VB
     /*  92122 */     GIR_RootConstrainSelectedInstOperands,
     /*  92123 */     // GIR_Coverage, 279,
     /*  92123 */     GIR_EraseRootFromParent_Done,
     /*  92124 */   // Label 1434: @92124
     /*  92124 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92151), // Rule ID 637 //
     /*  92129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::set_loop_iterations),
     /*  92134 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92137 */     // (intrinsic_void 326:{ *:[iPTR] }, i64:{ *:[i64] }:$RST)  =>  (MTCTR8loop:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /*  92137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTCTR8loop),
     /*  92140 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /*  92142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  92145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92149 */     GIR_RootConstrainSelectedInstOperands,
     /*  92150 */     // GIR_Coverage, 637,
     /*  92150 */     GIR_EraseRootFromParent_Done,
     /*  92151 */   // Label 1435: @92151
     /*  92151 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92188), // Rule ID 2901 //
     /*  92156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasr),
     /*  92164 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92167 */     // (intrinsic_void 10798:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 130:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92170 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(130),
     /*  92180 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92186 */     GIR_RootConstrainSelectedInstOperands,
     /*  92187 */     // GIR_Coverage, 2901,
     /*  92187 */     GIR_EraseRootFromParent_Done,
     /*  92188 */   // Label 1436: @92188
     /*  92188 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92225), // Rule ID 2902 //
     /*  92193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_texasru),
     /*  92201 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92204 */     // (intrinsic_void 10799:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 131:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92207 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(131),
     /*  92217 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92223 */     GIR_RootConstrainSelectedInstOperands,
     /*  92224 */     // GIR_Coverage, 2902,
     /*  92224 */     GIR_EraseRootFromParent_Done,
     /*  92225 */   // Label 1437: @92225
     /*  92225 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92262), // Rule ID 2903 //
     /*  92230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfhar),
     /*  92238 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92241 */     // (intrinsic_void 10800:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 128:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92244 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /*  92254 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92260 */     GIR_RootConstrainSelectedInstOperands,
     /*  92261 */     // GIR_Coverage, 2903,
     /*  92261 */     GIR_EraseRootFromParent_Done,
     /*  92262 */   // Label 1438: @92262
     /*  92262 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92299), // Rule ID 2904 //
     /*  92267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_set_tfiar),
     /*  92275 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92278 */     // (intrinsic_void 10801:{ *:[iPTR] }, i64:{ *:[i64] }:$V)  =>  (MTSPR8 129:{ *:[i32] }, ?:{ *:[i64] }:$V)
     /*  92278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92281 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(129),
     /*  92291 */     GIR_RootToRootCopy, /*OpIdx*/1, // V
     /*  92293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92297 */     GIR_RootConstrainSelectedInstOperands,
     /*  92298 */     // GIR_Coverage, 2904,
     /*  92298 */     GIR_EraseRootFromParent_Done,
     /*  92299 */   // Label 1439: @92299
     /*  92299 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92327), // Rule ID 2895 //
     /*  92304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_trechkpt),
     /*  92312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92315 */     // (intrinsic_w_chain:{ *:[i32] } 10829:{ *:[iPTR] })  =>  (TRECHKPT:{ *:[i32] })
     /*  92315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECHKPT),
     /*  92318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92325 */     GIR_RootConstrainSelectedInstOperands,
     /*  92326 */     // GIR_Coverage, 2895,
     /*  92326 */     GIR_EraseRootFromParent_Done,
     /*  92327 */   // Label 1440: @92327
     /*  92327 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92358), // Rule ID 2905 //
     /*  92332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tendall),
     /*  92340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92343 */     // (intrinsic_w_chain:{ *:[i32] } 10825:{ *:[iPTR] })  =>  (TEND:{ *:[i32] } 1:{ *:[i32] })
     /*  92343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TEND),
     /*  92346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92352 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92356 */     GIR_RootConstrainSelectedInstOperands,
     /*  92357 */     // GIR_Coverage, 2905,
     /*  92357 */     GIR_EraseRootFromParent_Done,
     /*  92358 */   // Label 1441: @92358
     /*  92358 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92389), // Rule ID 2906 //
     /*  92363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tresume),
     /*  92371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92374 */     // (intrinsic_w_chain:{ *:[i32] } 10831:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 1:{ *:[i32] })
     /*  92374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  92380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92387 */     GIR_RootConstrainSelectedInstOperands,
     /*  92388 */     // GIR_Coverage, 2906,
     /*  92388 */     GIR_EraseRootFromParent_Done,
     /*  92389 */   // Label 1442: @92389
     /*  92389 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92420), // Rule ID 2907 //
     /*  92394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tsuspend),
     /*  92402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92405 */     // (intrinsic_w_chain:{ *:[i32] } 10834:{ *:[iPTR] })  =>  (TSR:{ *:[i32] } 0:{ *:[i32] })
     /*  92405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TSR),
     /*  92408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  92411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92418 */     GIR_RootConstrainSelectedInstOperands,
     /*  92419 */     // GIR_Coverage, 2907,
     /*  92419 */     GIR_EraseRootFromParent_Done,
     /*  92420 */   // Label 1443: @92420
     /*  92420 */   GIM_Reject,
     /*  92421 */ // Label 1417: @92421
     /*  92421 */ GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92947),
     /*  92426 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92429 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92460), // Rule ID 1178 //
     /*  92434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsfi),
     /*  92442 */     // MIs[0] BF
     /*  92442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92445 */     // MIs[0] U
     /*  92445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92448 */     // (intrinsic_void 10777:{ *:[iPTR] }, (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)  =>  (MTFSFIb (timm:{ *:[i32] }):$BF, (timm:{ *:[i32] }):$U)
     /*  92448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFIb),
     /*  92451 */     GIR_RootToRootCopy, /*OpIdx*/1, // BF
     /*  92453 */     GIR_RootToRootCopy, /*OpIdx*/2, // U
     /*  92455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92458 */     GIR_RootConstrainSelectedInstOperands,
     /*  92459 */     // GIR_Coverage, 1178,
     /*  92459 */     GIR_EraseRootFromParent_Done,
     /*  92460 */   // Label 1445: @92460
     /*  92460 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92508), // Rule ID 12 //
     /*  92465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92488 */     // MIs[1] Operand 1
     /*  92488 */     // No operand predicates
     /*  92488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92490 */     // (intrinsic_w_chain:{ *:[f64] } 10804:{ *:[iPTR] }, (imm:{ *:[i32] }):$RND)  =>  (SETRNDi:{ *:[f64] } (imm:{ *:[i32] }):$RND)
     /*  92490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRNDi),
     /*  92493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RND
     /*  92498 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92506 */     GIR_RootConstrainSelectedInstOperands,
     /*  92507 */     // GIR_Coverage, 12,
     /*  92507 */     GIR_EraseRootFromParent_Done,
     /*  92508 */   // Label 1446: @92508
     /*  92508 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92556), // Rule ID 190 //
     /*  92513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92536 */     // MIs[1] Operand 1
     /*  92536 */     // No operand predicates
     /*  92536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92538 */     // (intrinsic_w_chain:{ *:[i1] } 224:{ *:[iPTR] }, (imm:{ *:[i32] }):$stride)  =>  (DecreaseCTRloop:{ *:[i1] }:{ *:[i32] } (imm:{ *:[i32] }):$stride)
     /*  92538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTRloop),
     /*  92541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR*/0,
     /*  92549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92554 */     GIR_RootConstrainSelectedInstOperands,
     /*  92555 */     // GIR_Coverage, 190,
     /*  92555 */     GIR_EraseRootFromParent_Done,
     /*  92556 */   // Label 1447: @92556
     /*  92556 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92604), // Rule ID 638 //
     /*  92561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::loop_decrement),
     /*  92566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /*  92569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  92576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92584 */     // MIs[1] Operand 1
     /*  92584 */     // No operand predicates
     /*  92584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92586 */     // (intrinsic_w_chain:{ *:[i1] } 224:{ *:[iPTR] }, (imm:{ *:[i64] }):$stride)  =>  (DecreaseCTR8loop:{ *:[i1] }:{ *:[i64] } (imm:{ *:[i64] }):$stride)
     /*  92586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DecreaseCTR8loop),
     /*  92589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // stride
     /*  92594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CTR8*/0,
     /*  92597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92602 */     GIR_RootConstrainSelectedInstOperands,
     /*  92603 */     // GIR_Coverage, 638,
     /*  92603 */     GIR_EraseRootFromParent_Done,
     /*  92604 */   // Label 1448: @92604
     /*  92604 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(92637), // Rule ID 1179 //
     /*  92609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fixed_addr_ld),
     /*  92614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92621 */     // MIs[0] imm
     /*  92621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92624 */     // (intrinsic_w_chain:{ *:[i32] } 10629:{ *:[iPTR] }, (timm:{ *:[i32] }):$imm)  =>  (PPCLdFixedAddr:{ *:[i32] } (timm:{ *:[i32] }):$imm)
     /*  92624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::PPCLdFixedAddr),
     /*  92627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rT]
     /*  92629 */     GIR_RootToRootCopy, /*OpIdx*/2, // imm
     /*  92631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92635 */     GIR_RootConstrainSelectedInstOperands,
     /*  92636 */     // GIR_Coverage, 1179,
     /*  92636 */     GIR_EraseRootFromParent_Done,
     /*  92637 */   // Label 1449: @92637
     /*  92637 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92670), // Rule ID 1580 //
     /*  92642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92654 */     // MIs[0] SPR
     /*  92654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92657 */     // (intrinsic_w_chain:{ *:[i64] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR8:{ *:[i64] } ?:{ *:[i32] }:$SPR)
     /*  92657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR8),
     /*  92660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92662 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92668 */     GIR_RootConstrainSelectedInstOperands,
     /*  92669 */     // GIR_Coverage, 1580,
     /*  92669 */     GIR_EraseRootFromParent_Done,
     /*  92670 */   // Label 1450: @92670
     /*  92670 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(92703), // Rule ID 4908 //
     /*  92675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_mfspr),
     /*  92680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92687 */     // MIs[0] SPR
     /*  92687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92690 */     // (intrinsic_w_chain:{ *:[i32] } 10670:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR)  =>  (MFSPR:{ *:[i32] } ?:{ *:[i32] }:$SPR)
     /*  92690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFSPR),
     /*  92693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  92695 */     GIR_RootToRootCopy, /*OpIdx*/2, // SPR
     /*  92697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92701 */     GIR_RootConstrainSelectedInstOperands,
     /*  92702 */     // GIR_Coverage, 4908,
     /*  92702 */     GIR_EraseRootFromParent_Done,
     /*  92703 */   // Label 1451: @92703
     /*  92703 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(92736), // Rule ID 1581 //
     /*  92708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92716 */     // MIs[0] SPR
     /*  92716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  92723 */     // (intrinsic_void 10779:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, g8rc:{ *:[i64] }:$RT)  =>  (MTSPR8 ?:{ *:[i32] }:$SPR, ?:{ *:[i64] }:$RT)
     /*  92723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR8),
     /*  92726 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92728 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92734 */     GIR_RootConstrainSelectedInstOperands,
     /*  92735 */     // GIR_Coverage, 1581,
     /*  92735 */     GIR_EraseRootFromParent_Done,
     /*  92736 */   // Label 1452: @92736
     /*  92736 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(92769), // Rule ID 4909 //
     /*  92741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtspr),
     /*  92746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92749 */     // MIs[0] SPR
     /*  92749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92756 */     // (intrinsic_void 10779:{ *:[iPTR] }, (timm:{ *:[i32] }):$SPR, gprc:{ *:[i32] }:$RT)  =>  (MTSPR ?:{ *:[i32] }:$SPR, ?:{ *:[i32] }:$RT)
     /*  92756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTSPR),
     /*  92759 */     GIR_RootToRootCopy, /*OpIdx*/1, // SPR
     /*  92761 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92767 */     GIR_RootConstrainSelectedInstOperands,
     /*  92768 */     // GIR_Coverage, 4909,
     /*  92768 */     GIR_EraseRootFromParent_Done,
     /*  92769 */   // Label 1453: @92769
     /*  92769 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(92800), // Rule ID 195 //
     /*  92774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  92777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_mtfsf),
     /*  92782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92785 */     // MIs[0] FM
     /*  92785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  92788 */     // (intrinsic_void 10776:{ *:[iPTR] }, (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)  =>  (MTFSFb (timm:{ *:[i32] }):$FM, f64:{ *:[f64] }:$RT)
     /*  92788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MTFSFb),
     /*  92791 */     GIR_RootToRootCopy, /*OpIdx*/1, // FM
     /*  92793 */     GIR_RootToRootCopy, /*OpIdx*/2, // RT
     /*  92795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92798 */     GIR_RootConstrainSelectedInstOperands,
     /*  92799 */     // GIR_Coverage, 195,
     /*  92799 */     GIR_EraseRootFromParent_Done,
     /*  92800 */   // Label 1454: @92800
     /*  92800 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(92840), // Rule ID 13 //
     /*  92805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setrnd),
     /*  92810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  92824 */     // (intrinsic_w_chain:{ *:[f64] } 10804:{ *:[iPTR] }, gprc:{ *:[i32] }:$in)  =>  (SETRND:{ *:[f64] } gprc:{ *:[i32] }:$in)
     /*  92824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETRND),
     /*  92827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92829 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  92831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92838 */     GIR_RootConstrainSelectedInstOperands,
     /*  92839 */     // GIR_Coverage, 13,
     /*  92839 */     GIR_EraseRootFromParent_Done,
     /*  92840 */   // Label 1455: @92840
     /*  92840 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(92880), // Rule ID 14 //
     /*  92845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_setflm),
     /*  92850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  92853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  92856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /*  92864 */     // (intrinsic_w_chain:{ *:[f64] } 10803:{ *:[iPTR] }, f8rc:{ *:[f64] }:$FLM)  =>  (SETFLM:{ *:[f64] } f8rc:{ *:[f64] }:$FLM)
     /*  92864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETFLM),
     /*  92867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /*  92869 */     GIR_RootToRootCopy, /*OpIdx*/2, // FLM
     /*  92871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::RM*/0,
     /*  92874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92878 */     GIR_RootConstrainSelectedInstOperands,
     /*  92879 */     // GIR_Coverage, 14,
     /*  92879 */     GIR_EraseRootFromParent_Done,
     /*  92880 */   // Label 1456: @92880
     /*  92880 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(92913), // Rule ID 2888 //
     /*  92885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_tabort),
     /*  92893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92899 */     // (intrinsic_w_chain:{ *:[i32] } 10816:{ *:[iPTR] }, i32:{ *:[i32] }:$R)  =>  (TABORT:{ *:[i32] } ?:{ *:[i32] }:$R)
     /*  92899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TABORT),
     /*  92902 */     GIR_RootToRootCopy, /*OpIdx*/2, // R
     /*  92904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92911 */     GIR_RootConstrainSelectedInstOperands,
     /*  92912 */     // GIR_Coverage, 2888,
     /*  92912 */     GIR_EraseRootFromParent_Done,
     /*  92913 */   // Label 1457: @92913
     /*  92913 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(92946), // Rule ID 2894 //
     /*  92918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasHTM),
     /*  92921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_treclaim),
     /*  92926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92932 */     // (intrinsic_w_chain:{ *:[i32] } 10830:{ *:[iPTR] }, i32:{ *:[i32] }:$RA)  =>  (TRECLAIM:{ *:[i32] } ?:{ *:[i32] }:$RA)
     /*  92932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::TRECLAIM),
     /*  92935 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  92937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /*  92940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92944 */     GIR_RootConstrainSelectedInstOperands,
     /*  92945 */     // GIR_Coverage, 2894,
     /*  92945 */     GIR_EraseRootFromParent_Done,
     /*  92946 */   // Label 1458: @92946
     /*  92946 */   GIM_Reject,
     /*  92947 */ // Label 1444: @92947
     /*  92947 */ GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93874),
     /*  92952 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92955 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(93005), // Rule ID 270 //
     /*  92960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  92963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  92968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92974 */     // MIs[0] RA
     /*  92974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  92978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92986 */     // MIs[1] Operand 1
     /*  92986 */     // No operand predicates
     /*  92986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92988 */     // (intrinsic_void 10270:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  92988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST),
     /*  92991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  92994 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  92996 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  92998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93003 */     GIR_RootConstrainSelectedInstOperands,
     /*  93004 */     // GIR_Coverage, 270,
     /*  93004 */     GIR_EraseRootFromParent_Done,
     /*  93005 */   // Label 1460: @93005
     /*  93005 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(93055), // Rule ID 271 //
     /*  93010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  93018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93024 */     // MIs[0] RA
     /*  93024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  93028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93036 */     // MIs[1] Operand 1
     /*  93036 */     // No operand predicates
     /*  93036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93038 */     // (intrinsic_void 10273:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT),
     /*  93041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93044 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93046 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93053 */     GIR_RootConstrainSelectedInstOperands,
     /*  93054 */     // GIR_Coverage, 271,
     /*  93054 */     GIR_EraseRootFromParent_Done,
     /*  93055 */   // Label 1461: @93055
     /*  93055 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(93105), // Rule ID 272 //
     /*  93060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  93068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93074 */     // MIs[0] RA
     /*  93074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  93078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93086 */     // MIs[1] Operand 1
     /*  93086 */     // No operand predicates
     /*  93086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93088 */     // (intrinsic_void 10271:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST),
     /*  93091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93094 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93096 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93103 */     GIR_RootConstrainSelectedInstOperands,
     /*  93104 */     // GIR_Coverage, 272,
     /*  93104 */     GIR_EraseRootFromParent_Done,
     /*  93105 */   // Label 1462: @93105
     /*  93105 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(93155), // Rule ID 273 //
     /*  93110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  93118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93124 */     // MIs[0] RA
     /*  93124 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  93128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93136 */     // MIs[1] Operand 1
     /*  93136 */     // No operand predicates
     /*  93136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93138 */     // (intrinsic_void 10272:{ *:[iPTR] }, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT (imm:{ *:[i32] }):$STRM, i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT),
     /*  93141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93144 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93146 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93153 */     GIR_RootConstrainSelectedInstOperands,
     /*  93154 */     // GIR_Coverage, 273,
     /*  93154 */     GIR_EraseRootFromParent_Done,
     /*  93155 */   // Label 1463: @93155
     /*  93155 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(93205), // Rule ID 274 //
     /*  93160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dst),
     /*  93168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93174 */     // MIs[0] RA
     /*  93174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93186 */     // MIs[1] Operand 1
     /*  93186 */     // No operand predicates
     /*  93186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93188 */     // (intrinsic_void 10270:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DST64),
     /*  93191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93194 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93196 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93203 */     GIR_RootConstrainSelectedInstOperands,
     /*  93204 */     // GIR_Coverage, 274,
     /*  93204 */     GIR_EraseRootFromParent_Done,
     /*  93205 */   // Label 1464: @93205
     /*  93205 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(93255), // Rule ID 275 //
     /*  93210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstt),
     /*  93218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93224 */     // MIs[0] RA
     /*  93224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93236 */     // MIs[1] Operand 1
     /*  93236 */     // No operand predicates
     /*  93236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93238 */     // (intrinsic_void 10273:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTT64),
     /*  93241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93244 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93246 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93253 */     GIR_RootConstrainSelectedInstOperands,
     /*  93254 */     // GIR_Coverage, 275,
     /*  93254 */     GIR_EraseRootFromParent_Done,
     /*  93255 */   // Label 1465: @93255
     /*  93255 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(93305), // Rule ID 276 //
     /*  93260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dstst),
     /*  93268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93274 */     // MIs[0] RA
     /*  93274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93286 */     // MIs[1] Operand 1
     /*  93286 */     // No operand predicates
     /*  93286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93288 */     // (intrinsic_void 10271:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTST64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTST64),
     /*  93291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93294 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93296 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93303 */     GIR_RootConstrainSelectedInstOperands,
     /*  93304 */     // GIR_Coverage, 276,
     /*  93304 */     GIR_EraseRootFromParent_Done,
     /*  93305 */   // Label 1466: @93305
     /*  93305 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(93355), // Rule ID 277 //
     /*  93310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::ppc_altivec_dststt),
     /*  93318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93324 */     // MIs[0] RA
     /*  93324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  93328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  93332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  93336 */     // MIs[1] Operand 1
     /*  93336 */     // No operand predicates
     /*  93336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93338 */     // (intrinsic_void 10272:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB, (imm:{ *:[i32] }):$STRM)  =>  (DSTSTT64 (imm:{ *:[i32] }):$STRM, i64:{ *:[i64] }:$RA, i32:{ *:[i32] }:$RB)
     /*  93338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::DSTSTT64),
     /*  93341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // STRM
     /*  93344 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /*  93346 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /*  93348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  93353 */     GIR_RootConstrainSelectedInstOperands,
     /*  93354 */     // GIR_Coverage, 277,
     /*  93354 */     GIR_EraseRootFromParent_Done,
     /*  93355 */   // Label 1467: @93355
     /*  93355 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(93392), // Rule ID 380 //
     /*  93360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsumsws),
     /*  93368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93381 */     // (intrinsic_w_chain:{ *:[v4i32] } 10552:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUMSWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUMSWS),
     /*  93384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93386 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93388 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93390 */     GIR_RootConstrainSelectedInstOperands,
     /*  93391 */     // GIR_Coverage, 380,
     /*  93391 */     GIR_EraseRootFromParent_Done,
     /*  93392 */   // Label 1468: @93392
     /*  93392 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(93429), // Rule ID 381 //
     /*  93397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum2sws),
     /*  93405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93418 */     // (intrinsic_w_chain:{ *:[v4i32] } 10548:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM2SWS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM2SWS),
     /*  93421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93423 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93425 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93427 */     GIR_RootConstrainSelectedInstOperands,
     /*  93428 */     // GIR_Coverage, 381,
     /*  93428 */     GIR_EraseRootFromParent_Done,
     /*  93429 */   // Label 1469: @93429
     /*  93429 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(93466), // Rule ID 382 //
     /*  93434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4sbs),
     /*  93442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93455 */     // (intrinsic_w_chain:{ *:[v4i32] } 10549:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SBS),
     /*  93458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93460 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93462 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93464 */     GIR_RootConstrainSelectedInstOperands,
     /*  93465 */     // GIR_Coverage, 382,
     /*  93465 */     GIR_EraseRootFromParent_Done,
     /*  93466 */   // Label 1470: @93466
     /*  93466 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(93503), // Rule ID 383 //
     /*  93471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4shs),
     /*  93479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93492 */     // (intrinsic_w_chain:{ *:[v4i32] } 10550:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4SHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4SHS),
     /*  93495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93497 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93499 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93501 */     GIR_RootConstrainSelectedInstOperands,
     /*  93502 */     // GIR_Coverage, 383,
     /*  93502 */     GIR_EraseRootFromParent_Done,
     /*  93503 */   // Label 1471: @93503
     /*  93503 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(93540), // Rule ID 384 //
     /*  93508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vsum4ubs),
     /*  93516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  93522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93529 */     // (intrinsic_w_chain:{ *:[v4i32] } 10551:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VSUM4UBS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSUM4UBS),
     /*  93532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93534 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93536 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93538 */     GIR_RootConstrainSelectedInstOperands,
     /*  93539 */     // GIR_Coverage, 384,
     /*  93539 */     GIR_EraseRootFromParent_Done,
     /*  93540 */   // Label 1472: @93540
     /*  93540 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93577), // Rule ID 411 //
     /*  93545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshss),
     /*  93553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93566 */     // (intrinsic_w_chain:{ *:[v16i8] } 10486:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHSS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHSS),
     /*  93569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93571 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93573 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93575 */     GIR_RootConstrainSelectedInstOperands,
     /*  93576 */     // GIR_Coverage, 411,
     /*  93576 */     GIR_EraseRootFromParent_Done,
     /*  93577 */   // Label 1473: @93577
     /*  93577 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93614), // Rule ID 412 //
     /*  93582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkshus),
     /*  93590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93603 */     // (intrinsic_w_chain:{ *:[v16i8] } 10487:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKSHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSHUS),
     /*  93606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93608 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93610 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93612 */     GIR_RootConstrainSelectedInstOperands,
     /*  93613 */     // GIR_Coverage, 412,
     /*  93613 */     GIR_EraseRootFromParent_Done,
     /*  93614 */   // Label 1474: @93614
     /*  93614 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93651), // Rule ID 413 //
     /*  93619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswss),
     /*  93627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93640 */     // (intrinsic_w_chain:{ *:[v8i16] } 10488:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWSS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWSS),
     /*  93643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93645 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93647 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93649 */     GIR_RootConstrainSelectedInstOperands,
     /*  93650 */     // GIR_Coverage, 413,
     /*  93650 */     GIR_EraseRootFromParent_Done,
     /*  93651 */   // Label 1475: @93651
     /*  93651 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93688), // Rule ID 414 //
     /*  93656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkswus),
     /*  93664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93677 */     // (intrinsic_w_chain:{ *:[v8i16] } 10489:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKSWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSWUS),
     /*  93680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93682 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93684 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93686 */     GIR_RootConstrainSelectedInstOperands,
     /*  93687 */     // GIR_Coverage, 414,
     /*  93687 */     GIR_EraseRootFromParent_Done,
     /*  93688 */   // Label 1476: @93688
     /*  93688 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93725), // Rule ID 415 //
     /*  93693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuhus),
     /*  93701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  93704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93714 */     // (intrinsic_w_chain:{ *:[v16i8] } 10491:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)  =>  (VPKUHUS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$VA, v8i16:{ *:[v8i16] }:$VB)
     /*  93714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUHUS),
     /*  93717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93719 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93721 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93723 */     GIR_RootConstrainSelectedInstOperands,
     /*  93724 */     // GIR_Coverage, 415,
     /*  93724 */     GIR_EraseRootFromParent_Done,
     /*  93725 */   // Label 1477: @93725
     /*  93725 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93762), // Rule ID 416 //
     /*  93730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkuwus),
     /*  93738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  93744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  93747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93751 */     // (intrinsic_w_chain:{ *:[v8i16] } 10492:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VPKUWUS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /*  93751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUWUS),
     /*  93754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93756 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93758 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93760 */     GIR_RootConstrainSelectedInstOperands,
     /*  93761 */     // GIR_Coverage, 416,
     /*  93761 */     GIR_EraseRootFromParent_Done,
     /*  93762 */   // Label 1478: @93762
     /*  93762 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93799), // Rule ID 500 //
     /*  93767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdss),
     /*  93775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93788 */     // (intrinsic_w_chain:{ *:[v4i32] } 10484:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDSS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDSS),
     /*  93791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93793 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93795 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93797 */     GIR_RootConstrainSelectedInstOperands,
     /*  93798 */     // GIR_Coverage, 500,
     /*  93798 */     GIR_EraseRootFromParent_Done,
     /*  93799 */   // Label 1479: @93799
     /*  93799 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93836), // Rule ID 501 //
     /*  93804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpksdus),
     /*  93812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93825 */     // (intrinsic_w_chain:{ *:[v4i32] } 10485:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKSDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKSDUS),
     /*  93828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93830 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93832 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93834 */     GIR_RootConstrainSelectedInstOperands,
     /*  93835 */     // GIR_Coverage, 501,
     /*  93835 */     GIR_EraseRootFromParent_Done,
     /*  93836 */   // Label 1480: @93836
     /*  93836 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93873), // Rule ID 502 //
     /*  93841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /*  93844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vpkudus),
     /*  93849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  93852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  93855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  93858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93862 */     // (intrinsic_w_chain:{ *:[v4i32] } 10490:{ *:[iPTR] }, v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VPKUDUS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /*  93862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VPKUDUS),
     /*  93865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /*  93867 */     GIR_RootToRootCopy, /*OpIdx*/2, // VA
     /*  93869 */     GIR_RootToRootCopy, /*OpIdx*/3, // VB
     /*  93871 */     GIR_RootConstrainSelectedInstOperands,
     /*  93872 */     // GIR_Coverage, 502,
     /*  93872 */     GIR_EraseRootFromParent_Done,
     /*  93873 */   // Label 1481: @93873
     /*  93873 */   GIM_Reject,
     /*  93874 */ // Label 1459: @93874
     /*  93874 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(94090),
     /*  93879 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  93882 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(93921), // Rule ID 766 //
     /*  93887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_addex),
     /*  93892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  93895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  93898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  93901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /*  93905 */     // MIs[0] CY
     /*  93905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  93908 */     // (intrinsic_w_chain:{ *:[i64] } 10251:{ *:[iPTR] }, i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)  =>  (ADDEX8:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB, (timm:{ *:[i32] }):$CY)
     /*  93908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ADDEX8),
     /*  93911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93913 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93915 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93917 */     GIR_RootToRootCopy, /*OpIdx*/4, // CY
     /*  93919 */     GIR_RootConstrainSelectedInstOperands,
     /*  93920 */     // GIR_Coverage, 766,
     /*  93920 */     GIR_EraseRootFromParent_Done,
     /*  93921 */   // Label 1483: @93921
     /*  93921 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(93963), // Rule ID 294 //
     /*  93926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhaddshs),
     /*  93934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93950 */     // (intrinsic_w_chain:{ *:[v8i16] } 10439:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHADDSHS),
     /*  93953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93955 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93957 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  93959 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  93961 */     GIR_RootConstrainSelectedInstOperands,
     /*  93962 */     // GIR_Coverage, 294,
     /*  93962 */     GIR_EraseRootFromParent_Done,
     /*  93963 */   // Label 1484: @93963
     /*  93963 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(94005), // Rule ID 295 //
     /*  93968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  93971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmhraddshs),
     /*  93976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  93979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  93982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  93985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  93988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  93992 */     // (intrinsic_w_chain:{ *:[v8i16] } 10440:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)  =>  (VMHRADDSHS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v8i16:{ *:[v8i16] }:$RC)
     /*  93992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMHRADDSHS),
     /*  93995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  93997 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  93999 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  94001 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  94003 */     GIR_RootConstrainSelectedInstOperands,
     /*  94004 */     // GIR_Coverage, 295,
     /*  94004 */     GIR_EraseRootFromParent_Done,
     /*  94005 */   // Label 1485: @94005
     /*  94005 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(94047), // Rule ID 353 //
     /*  94010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  94013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumshs),
     /*  94018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  94034 */     // (intrinsic_w_chain:{ *:[v4i32] } 10454:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMSHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  94034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMSHS),
     /*  94037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  94039 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  94041 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  94043 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  94045 */     GIR_RootConstrainSelectedInstOperands,
     /*  94046 */     // GIR_Coverage, 353,
     /*  94046 */     GIR_EraseRootFromParent_Done,
     /*  94047 */   // Label 1486: @94047
     /*  94047 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94089), // Rule ID 354 //
     /*  94052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /*  94055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_altivec_vmsumuhs),
     /*  94060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /*  94076 */     // (intrinsic_w_chain:{ *:[v4i32] } 10458:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)  =>  (VMSUMUHS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$RA, v8i16:{ *:[v8i16] }:$RB, v4i32:{ *:[v4i32] }:$RC)
     /*  94076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMSUMUHS),
     /*  94079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /*  94081 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /*  94083 */     GIR_RootToRootCopy, /*OpIdx*/3, // RB
     /*  94085 */     GIR_RootToRootCopy, /*OpIdx*/4, // RC
     /*  94087 */     GIR_RootConstrainSelectedInstOperands,
     /*  94088 */     // GIR_Coverage, 354,
     /*  94088 */     GIR_EraseRootFromParent_Done,
     /*  94089 */   // Label 1487: @94089
     /*  94089 */   GIM_Reject,
     /*  94090 */ // Label 1482: @94090
     /*  94090 */ GIM_Reject,
     /*  94091 */ // Label 21: @94091
     /*  94091 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1490*/ GIMT_Encode4(114846),
     /*  94102 */ /*GILLT_s32*//*Label 1488*/ GIMT_Encode4(94110),
     /*  94106 */ /*GILLT_s64*//*Label 1489*/ GIMT_Encode4(104331),
     /*  94110 */ // Label 1488: @94110
     /*  94110 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(104330),
     /*  94115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /*  94118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94122 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94234), // Rule ID 5303 //
     /*  94127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94143 */     // MIs[1] Operand 1
     /*  94143 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94180 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94184 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94190 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  94209 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  94212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94232 */     GIR_RootConstrainSelectedInstOperands,
     /*  94233 */     // GIR_Coverage, 5303,
     /*  94233 */     GIR_EraseRootFromParent_Done,
     /*  94234 */   // Label 1492: @94234
     /*  94234 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94373), // Rule ID 5306 //
     /*  94239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94251 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94255 */     // MIs[1] Operand 1
     /*  94255 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94284 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94288 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94292 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94296 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94302 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94318 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94321 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94342 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94345 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94355 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94362 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94372 */     // GIR_Coverage, 5306,
     /*  94372 */     GIR_EraseRootFromParent_Done,
     /*  94373 */   // Label 1493: @94373
     /*  94373 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(94506), // Rule ID 5311 //
     /*  94378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94390 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94394 */     // MIs[1] Operand 1
     /*  94394 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94419 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94423 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94427 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94431 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94435 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94441 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94453 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94457 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  94460 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  94472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94477 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94504 */     GIR_RootConstrainSelectedInstOperands,
     /*  94505 */     // GIR_Coverage, 5311,
     /*  94505 */     GIR_EraseRootFromParent_Done,
     /*  94506 */   // Label 1494: @94506
     /*  94506 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(94666), // Rule ID 5314 //
     /*  94511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94527 */     // MIs[1] Operand 1
     /*  94527 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94556 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94560 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94564 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94568 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94574 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94574 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  94577 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94581 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94586 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94590 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  94593 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  94596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  94598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  94601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  94605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94610 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /*  94618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94632 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94635 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  94638 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94648 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94665 */     // GIR_Coverage, 5314,
     /*  94665 */     GIR_EraseRootFromParent_Done,
     /*  94666 */   // Label 1495: @94666
     /*  94666 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(94778), // Rule ID 3781 //
     /*  94671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94687 */     // MIs[1] Operand 1
     /*  94687 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94720 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94724 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94728 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94734 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  94737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  94753 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /*  94756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  94761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  94763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  94776 */     GIR_RootConstrainSelectedInstOperands,
     /*  94777 */     // GIR_Coverage, 3781,
     /*  94777 */     GIR_EraseRootFromParent_Done,
     /*  94778 */   // Label 1496: @94778
     /*  94778 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(94917), // Rule ID 3784 //
     /*  94783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  94795 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  94799 */     // MIs[1] Operand 1
     /*  94799 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  94804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  94816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  94820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94828 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  94832 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94836 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94840 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94846 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  94846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  94862 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /*  94865 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  94868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  94877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  94886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  94889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  94892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  94899 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  94906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  94911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  94916 */     // GIR_Coverage, 3784,
     /*  94916 */     GIR_EraseRootFromParent_Done,
     /*  94917 */   // Label 1497: @94917
     /*  94917 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95050), // Rule ID 3789 //
     /*  94922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  94930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  94934 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  94938 */     // MIs[1] Operand 1
     /*  94938 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  94943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  94955 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  94959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  94967 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  94971 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  94975 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  94979 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  94983 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94985 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  94985 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  94988 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  94992 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94997 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  95001 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*  95004 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /*  95007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95021 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95029 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /*  95034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95048 */     GIR_RootConstrainSelectedInstOperands,
     /*  95049 */     // GIR_Coverage, 3789,
     /*  95049 */     GIR_EraseRootFromParent_Done,
     /*  95050 */   // Label 1498: @95050
     /*  95050 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95210), // Rule ID 3792 //
     /*  95055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95071 */     // MIs[1] Operand 1
     /*  95071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  95076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  95088 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  95092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  95100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  95104 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  95108 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /*  95112 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95116 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95118 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95118 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95121 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /*  95125 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95130 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /*  95134 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /*  95137 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /*  95140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /*  95162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /*  95171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95179 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95192 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95209 */     // GIR_Coverage, 3792,
     /*  95209 */     GIR_EraseRootFromParent_Done,
     /*  95210 */   // Label 1499: @95210
     /*  95210 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95279), // Rule ID 3701 //
     /*  95215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95227 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95231 */     // MIs[1] Operand 1
     /*  95231 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  95236 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95242 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  95271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95277 */     GIR_RootConstrainSelectedInstOperands,
     /*  95278 */     // GIR_Coverage, 3701,
     /*  95278 */     GIR_EraseRootFromParent_Done,
     /*  95279 */   // Label 1500: @95279
     /*  95279 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95375), // Rule ID 3704 //
     /*  95284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95300 */     // MIs[1] Operand 1
     /*  95300 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  95305 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95311 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95347 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95357 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95364 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95374 */     // GIR_Coverage, 3704,
     /*  95374 */     GIR_EraseRootFromParent_Done,
     /*  95375 */   // Label 1501: @95375
     /*  95375 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95482), // Rule ID 3709 //
     /*  95380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95396 */     // MIs[1] Operand 1
     /*  95396 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95401 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95407 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95407 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  95410 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95414 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95419 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /*  95432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  95461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /*  95474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95480 */     GIR_RootConstrainSelectedInstOperands,
     /*  95481 */     // GIR_Coverage, 3709,
     /*  95481 */     GIR_EraseRootFromParent_Done,
     /*  95482 */   // Label 1502: @95482
     /*  95482 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95616), // Rule ID 3712 //
     /*  95487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95503 */     // MIs[1] Operand 1
     /*  95503 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  95508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95514 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95514 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /*  95517 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95521 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95526 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  95532 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  95535 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /*  95539 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95544 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  95550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95562 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  95565 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /*  95568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95582 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95585 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /*  95588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95598 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95615 */     // GIR_Coverage, 3712,
     /*  95615 */     GIR_EraseRootFromParent_Done,
     /*  95616 */   // Label 1503: @95616
     /*  95616 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95668), // Rule ID 3717 //
     /*  95621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95633 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95637 */     // MIs[1] Operand 1
     /*  95637 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95642 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95648 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95666 */     GIR_RootConstrainSelectedInstOperands,
     /*  95667 */     // GIR_Coverage, 3717,
     /*  95667 */     GIR_EraseRootFromParent_Done,
     /*  95668 */   // Label 1504: @95668
     /*  95668 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95747), // Rule ID 3720 //
     /*  95673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95685 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95689 */     // MIs[1] Operand 1
     /*  95689 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  95694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95700 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95716 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95729 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95746 */     // GIR_Coverage, 3720,
     /*  95746 */     GIR_EraseRootFromParent_Done,
     /*  95747 */   // Label 1505: @95747
     /*  95747 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(95820), // Rule ID 3725 //
     /*  95752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95768 */     // MIs[1] Operand 1
     /*  95768 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95773 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95779 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  95786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95791 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95795 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  95812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  95818 */     GIR_RootConstrainSelectedInstOperands,
     /*  95819 */     // GIR_Coverage, 3725,
     /*  95819 */     GIR_EraseRootFromParent_Done,
     /*  95820 */   // Label 1506: @95820
     /*  95820 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(95920), // Rule ID 3728 //
     /*  95825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  95837 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  95841 */     // MIs[1] Operand 1
     /*  95841 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  95846 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95852 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  95852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  95855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  95859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95864 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95868 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  95877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  95881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  95892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  95895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  95902 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  95909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  95914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  95919 */     // GIR_Coverage, 3728,
     /*  95919 */     GIR_EraseRootFromParent_Done,
     /*  95920 */   // Label 1507: @95920
     /*  95920 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(96010), // Rule ID 3733 //
     /*  95925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  95933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  95937 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  95941 */     // MIs[1] Operand 1
     /*  95941 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  95946 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  95950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95952 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  95952 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  95955 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  95959 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95964 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  95973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /*  95977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  95985 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  95989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  95994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  95996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96008 */     GIR_RootConstrainSelectedInstOperands,
     /*  96009 */     // GIR_Coverage, 3733,
     /*  96009 */     GIR_EraseRootFromParent_Done,
     /*  96010 */   // Label 1508: @96010
     /*  96010 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(96127), // Rule ID 3736 //
     /*  96015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96031 */     // MIs[1] Operand 1
     /*  96031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96036 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  96040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96042 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  96049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96054 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96060 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96063 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /*  96067 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96072 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96093 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96096 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96109 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96116 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96121 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96126 */     // GIR_Coverage, 3736,
     /*  96126 */     GIR_EraseRootFromParent_Done,
     /*  96127 */   // Label 1509: @96127
     /*  96127 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(96217), // Rule ID 3741 //
     /*  96132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96148 */     // MIs[1] Operand 1
     /*  96148 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96153 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  96157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96159 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /*  96166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /*  96184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96189 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96193 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96215 */     GIR_RootConstrainSelectedInstOperands,
     /*  96216 */     // GIR_Coverage, 3741,
     /*  96216 */     GIR_EraseRootFromParent_Done,
     /*  96217 */   // Label 1510: @96217
     /*  96217 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96334), // Rule ID 3744 //
     /*  96222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96234 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96238 */     // MIs[1] Operand 1
     /*  96238 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /*  96247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96249 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96249 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96252 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /*  96256 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96261 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96267 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96270 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /*  96274 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96279 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96283 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96306 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96316 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96333 */     // GIR_Coverage, 3744,
     /*  96333 */     GIR_EraseRootFromParent_Done,
     /*  96334 */   // Label 1511: @96334
     /*  96334 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96427), // Rule ID 3749 //
     /*  96339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96351 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96355 */     // MIs[1] Operand 1
     /*  96355 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96360 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96366 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /*  96394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96403 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96425 */     GIR_RootConstrainSelectedInstOperands,
     /*  96426 */     // GIR_Coverage, 3749,
     /*  96426 */     GIR_EraseRootFromParent_Done,
     /*  96427 */   // Label 1512: @96427
     /*  96427 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96547), // Rule ID 3752 //
     /*  96432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96444 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96448 */     // MIs[1] Operand 1
     /*  96448 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /*  96453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96459 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96471 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96475 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /*  96487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96492 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96496 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96513 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96516 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96546 */     // GIR_Coverage, 3752,
     /*  96546 */     GIR_EraseRootFromParent_Done,
     /*  96547 */   // Label 1513: @96547
     /*  96547 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96640), // Rule ID 3757 //
     /*  96552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96560 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96564 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96568 */     // MIs[1] Operand 1
     /*  96568 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96573 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96579 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  96582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /*  96586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96595 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /*  96598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /*  96607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96612 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96616 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96638 */     GIR_RootConstrainSelectedInstOperands,
     /*  96639 */     // GIR_Coverage, 3757,
     /*  96639 */     GIR_EraseRootFromParent_Done,
     /*  96640 */   // Label 1514: @96640
     /*  96640 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96760), // Rule ID 3760 //
     /*  96645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96657 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96661 */     // MIs[1] Operand 1
     /*  96661 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  96666 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96672 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96672 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  96675 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /*  96679 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96684 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96688 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /*  96691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  96693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /*  96700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96709 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  96712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96726 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96742 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96759 */     // GIR_Coverage, 3760,
     /*  96759 */     GIR_EraseRootFromParent_Done,
     /*  96760 */   // Label 1515: @96760
     /*  96760 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96833), // Rule ID 3765 //
     /*  96765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96781 */     // MIs[1] Operand 1
     /*  96781 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96786 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96792 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  96795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /*  96799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96804 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96808 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  96822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96831 */     GIR_RootConstrainSelectedInstOperands,
     /*  96832 */     // GIR_Coverage, 3765,
     /*  96832 */     GIR_EraseRootFromParent_Done,
     /*  96833 */   // Label 1516: @96833
     /*  96833 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96933), // Rule ID 3768 //
     /*  96838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  96850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  96854 */     // MIs[1] Operand 1
     /*  96854 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /*  96859 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96865 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  96865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  96868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /*  96872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96877 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  96887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  96890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  96894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  96899 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  96902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  96905 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  96908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  96910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  96915 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  96922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  96927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  96932 */     // GIR_Coverage, 3768,
     /*  96932 */     GIR_EraseRootFromParent_Done,
     /*  96933 */   // Label 1517: @96933
     /*  96933 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96985), // Rule ID 3773 //
     /*  96938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  96950 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  96954 */     // MIs[1] Operand 1
     /*  96954 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  96959 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  96963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  96965 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /*  96965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /*  96968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /*  96970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  96974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  96977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*  96983 */     GIR_RootConstrainSelectedInstOperands,
     /*  96984 */     // GIR_Coverage, 3773,
     /*  96984 */     GIR_EraseRootFromParent_Done,
     /*  96985 */   // Label 1518: @96985
     /*  96985 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97064), // Rule ID 3776 //
     /*  96990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  96998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97002 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97006 */     // MIs[1] Operand 1
     /*  97006 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97011 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /*  97015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97017 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  97017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  97020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /*  97024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  97036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*  97039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97046 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /*  97053 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /*  97058 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /*  97063 */     // GIR_Coverage, 3776,
     /*  97063 */     GIR_EraseRootFromParent_Done,
     /*  97064 */   // Label 1519: @97064
     /*  97064 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97167), // Rule ID 3040 //
     /*  97069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97084 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97088 */     // MIs[1] Operand 1
     /*  97088 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97101 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97105 */     // MIs[2] Operand 1
     /*  97105 */     // No operand predicates
     /*  97105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97107 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /*  97107 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97110 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97114 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97140 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97165 */     GIR_RootConstrainSelectedInstOperands,
     /*  97166 */     // GIR_Coverage, 3040,
     /*  97166 */     GIR_EraseRootFromParent_Done,
     /*  97167 */   // Label 1520: @97167
     /*  97167 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97270), // Rule ID 3056 //
     /*  97172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97187 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97191 */     // MIs[1] Operand 1
     /*  97191 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97204 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97208 */     // MIs[2] Operand 1
     /*  97208 */     // No operand predicates
     /*  97208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97210 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /*  97210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97222 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97243 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97268 */     GIR_RootConstrainSelectedInstOperands,
     /*  97269 */     // GIR_Coverage, 3056,
     /*  97269 */     GIR_EraseRootFromParent_Done,
     /*  97270 */   // Label 1521: @97270
     /*  97270 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97373), // Rule ID 3064 //
     /*  97275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97290 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97294 */     // MIs[1] Operand 1
     /*  97294 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97311 */     // MIs[2] Operand 1
     /*  97311 */     // No operand predicates
     /*  97311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97313 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /*  97313 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97316 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97320 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97325 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97346 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97371 */     GIR_RootConstrainSelectedInstOperands,
     /*  97372 */     // GIR_Coverage, 3064,
     /*  97372 */     GIR_EraseRootFromParent_Done,
     /*  97373 */   // Label 1522: @97373
     /*  97373 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97476), // Rule ID 3136 //
     /*  97378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97393 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97397 */     // MIs[1] Operand 1
     /*  97397 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97414 */     // MIs[2] Operand 1
     /*  97414 */     // No operand predicates
     /*  97414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97416 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /*  97416 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97419 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97423 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97428 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97449 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97474 */     GIR_RootConstrainSelectedInstOperands,
     /*  97475 */     // GIR_Coverage, 3136,
     /*  97475 */     GIR_EraseRootFromParent_Done,
     /*  97476 */   // Label 1523: @97476
     /*  97476 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97579), // Rule ID 3152 //
     /*  97481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97496 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97500 */     // MIs[1] Operand 1
     /*  97500 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97517 */     // MIs[2] Operand 1
     /*  97517 */     // No operand predicates
     /*  97517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97519 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /*  97519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97531 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97552 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97559 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97577 */     GIR_RootConstrainSelectedInstOperands,
     /*  97578 */     // GIR_Coverage, 3152,
     /*  97578 */     GIR_EraseRootFromParent_Done,
     /*  97579 */   // Label 1524: @97579
     /*  97579 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97682), // Rule ID 3160 //
     /*  97584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /*  97587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  97599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  97603 */     // MIs[1] Operand 1
     /*  97603 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97616 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  97620 */     // MIs[2] Operand 1
     /*  97620 */     // No operand predicates
     /*  97620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97622 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /*  97622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  97629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97655 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  97662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  97675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  97677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97680 */     GIR_RootConstrainSelectedInstOperands,
     /*  97681 */     // GIR_Coverage, 3160,
     /*  97681 */     GIR_EraseRootFromParent_Done,
     /*  97682 */   // Label 1525: @97682
     /*  97682 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97825), // Rule ID 3823 //
     /*  97687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97702 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97706 */     // MIs[1] Operand 1
     /*  97706 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  97711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97719 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97723 */     // MIs[2] Operand 1
     /*  97723 */     // No operand predicates
     /*  97723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97725 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97746 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97749 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97753 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97758 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97763 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97766 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97770 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97775 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97792 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  97799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97823 */     GIR_RootConstrainSelectedInstOperands,
     /*  97824 */     // GIR_Coverage, 3823,
     /*  97824 */     GIR_EraseRootFromParent_Done,
     /*  97825 */   // Label 1526: @97825
     /*  97825 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97968), // Rule ID 3839 //
     /*  97830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97845 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97849 */     // MIs[1] Operand 1
     /*  97849 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  97854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  97858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  97862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  97866 */     // MIs[2] Operand 1
     /*  97866 */     // No operand predicates
     /*  97866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97868 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  97868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  97871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  97875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97880 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  97884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  97887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97889 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  97892 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97896 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97901 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  97904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97906 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  97909 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  97913 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97918 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  97921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  97926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97935 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  97942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  97947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  97952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  97955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  97963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  97966 */     GIR_RootConstrainSelectedInstOperands,
     /*  97967 */     // GIR_Coverage, 3839,
     /*  97967 */     GIR_EraseRootFromParent_Done,
     /*  97968 */   // Label 1527: @97968
     /*  97968 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(98111), // Rule ID 3847 //
     /*  97973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  97976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  97984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  97988 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  97992 */     // MIs[1] Operand 1
     /*  97992 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  97997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98005 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /*  98009 */     // MIs[2] Operand 1
     /*  98009 */     // No operand predicates
     /*  98009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98011 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /*  98018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98023 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98032 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98035 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98039 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98044 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98049 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98052 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98056 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98061 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98078 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98109 */     GIR_RootConstrainSelectedInstOperands,
     /*  98110 */     // GIR_Coverage, 3847,
     /*  98110 */     GIR_EraseRootFromParent_Done,
     /*  98111 */   // Label 1528: @98111
     /*  98111 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(98254), // Rule ID 3919 //
     /*  98116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98135 */     // MIs[1] Operand 1
     /*  98135 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /*  98140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98148 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98152 */     // MIs[2] Operand 1
     /*  98152 */     // No operand predicates
     /*  98152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98154 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98166 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98175 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98178 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98182 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98187 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98204 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98221 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98233 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98252 */     GIR_RootConstrainSelectedInstOperands,
     /*  98253 */     // GIR_Coverage, 3919,
     /*  98253 */     GIR_EraseRootFromParent_Done,
     /*  98254 */   // Label 1529: @98254
     /*  98254 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(98397), // Rule ID 3935 //
     /*  98259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98274 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98278 */     // MIs[1] Operand 1
     /*  98278 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /*  98283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98291 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98295 */     // MIs[2] Operand 1
     /*  98295 */     // No operand predicates
     /*  98295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98297 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98297 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98300 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98304 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98309 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98318 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98321 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98325 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98330 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98347 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98364 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98395 */     GIR_RootConstrainSelectedInstOperands,
     /*  98396 */     // GIR_Coverage, 3935,
     /*  98396 */     GIR_EraseRootFromParent_Done,
     /*  98397 */   // Label 1530: @98397
     /*  98397 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(98540), // Rule ID 3943 //
     /*  98402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /*  98405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  98413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98417 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98421 */     // MIs[1] Operand 1
     /*  98421 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /*  98426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  98430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  98434 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /*  98438 */     // MIs[2] Operand 1
     /*  98438 */     // No operand predicates
     /*  98438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98440 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  98440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /*  98447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /*  98459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98461 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  98464 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98468 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98473 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  98476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98478 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  98481 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  98485 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98490 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  98493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98507 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  98527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  98535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  98538 */     GIR_RootConstrainSelectedInstOperands,
     /*  98539 */     // GIR_Coverage, 3943,
     /*  98539 */     GIR_EraseRootFromParent_Done,
     /*  98540 */   // Label 1531: @98540
     /*  98540 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(98632), // Rule ID 3184 //
     /*  98545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98560 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98564 */     // MIs[1] Operand 1
     /*  98564 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98571 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /*  98571 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98574 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98578 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98605 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98630 */     GIR_RootConstrainSelectedInstOperands,
     /*  98631 */     // GIR_Coverage, 3184,
     /*  98631 */     GIR_EraseRootFromParent_Done,
     /*  98632 */   // Label 1532: @98632
     /*  98632 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98724), // Rule ID 3200 //
     /*  98637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98652 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98656 */     // MIs[1] Operand 1
     /*  98656 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  98661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98663 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /*  98663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98697 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  98704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98722 */     GIR_RootConstrainSelectedInstOperands,
     /*  98723 */     // GIR_Coverage, 3200,
     /*  98723 */     GIR_EraseRootFromParent_Done,
     /*  98724 */   // Label 1533: @98724
     /*  98724 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98816), // Rule ID 3216 //
     /*  98729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98748 */     // MIs[1] Operand 1
     /*  98748 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  98753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98755 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /*  98755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98771 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98789 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  98796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98814 */     GIR_RootConstrainSelectedInstOperands,
     /*  98815 */     // GIR_Coverage, 3216,
     /*  98815 */     GIR_EraseRootFromParent_Done,
     /*  98816 */   // Label 1534: @98816
     /*  98816 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98908), // Rule ID 3232 //
     /*  98821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  98836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  98840 */     // MIs[1] Operand 1
     /*  98840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  98845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98847 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /*  98847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  98854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98881 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  98888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98906 */     GIR_RootConstrainSelectedInstOperands,
     /*  98907 */     // GIR_Coverage, 3232,
     /*  98907 */     GIR_EraseRootFromParent_Done,
     /*  98908 */   // Label 1535: @98908
     /*  98908 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(99000), // Rule ID 3240 //
     /*  98913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  98916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  98924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  98928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  98932 */     // MIs[1] Operand 1
     /*  98932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  98937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98939 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /*  98939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  98942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  98946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  98955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  98959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  98964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98973 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  98980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  98985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  98990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  98993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  98995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98998 */     GIR_RootConstrainSelectedInstOperands,
     /*  98999 */     // GIR_Coverage, 3240,
     /*  98999 */     GIR_EraseRootFromParent_Done,
     /*  99000 */   // Label 1536: @99000
     /*  99000 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(99092), // Rule ID 3256 //
     /*  99005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99020 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99024 */     // MIs[1] Operand 1
     /*  99024 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99031 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /*  99031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99065 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99090 */     GIR_RootConstrainSelectedInstOperands,
     /*  99091 */     // GIR_Coverage, 3256,
     /*  99091 */     GIR_EraseRootFromParent_Done,
     /*  99092 */   // Label 1537: @99092
     /*  99092 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99184), // Rule ID 3272 //
     /*  99097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99112 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99116 */     // MIs[1] Operand 1
     /*  99116 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99123 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /*  99123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99135 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99139 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99157 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99182 */     GIR_RootConstrainSelectedInstOperands,
     /*  99183 */     // GIR_Coverage, 3272,
     /*  99183 */     GIR_EraseRootFromParent_Done,
     /*  99184 */   // Label 1538: @99184
     /*  99184 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99276), // Rule ID 3288 //
     /*  99189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  99204 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  99208 */     // MIs[1] Operand 1
     /*  99208 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99215 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /*  99215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /*  99222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99227 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99249 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99274 */     GIR_RootConstrainSelectedInstOperands,
     /*  99275 */     // GIR_Coverage, 3288,
     /*  99275 */     GIR_EraseRootFromParent_Done,
     /*  99276 */   // Label 1539: @99276
     /*  99276 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(99368), // Rule ID 3296 //
     /*  99281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99300 */     // MIs[1] Operand 1
     /*  99300 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99307 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /*  99307 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99310 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99314 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99319 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99341 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99366 */     GIR_RootConstrainSelectedInstOperands,
     /*  99367 */     // GIR_Coverage, 3296,
     /*  99367 */     GIR_EraseRootFromParent_Done,
     /*  99368 */   // Label 1540: @99368
     /*  99368 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99460), // Rule ID 3312 //
     /*  99373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99388 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99392 */     // MIs[1] Operand 1
     /*  99392 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99399 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /*  99399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99411 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99415 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99433 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99458 */     GIR_RootConstrainSelectedInstOperands,
     /*  99459 */     // GIR_Coverage, 3312,
     /*  99459 */     GIR_EraseRootFromParent_Done,
     /*  99460 */   // Label 1541: @99460
     /*  99460 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99552), // Rule ID 3328 //
     /*  99465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99484 */     // MIs[1] Operand 1
     /*  99484 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99491 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /*  99491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99507 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99525 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /*  99532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99550 */     GIR_RootConstrainSelectedInstOperands,
     /*  99551 */     // GIR_Coverage, 3328,
     /*  99551 */     GIR_EraseRootFromParent_Done,
     /*  99552 */   // Label 1542: @99552
     /*  99552 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99644), // Rule ID 3344 //
     /*  99557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /*  99560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /*  99572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /*  99576 */     // MIs[1] Operand 1
     /*  99576 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /*  99581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99583 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /*  99583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /*  99590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99599 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99617 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /*  99624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /*  99637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /*  99639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99642 */     GIR_RootConstrainSelectedInstOperands,
     /*  99643 */     // GIR_Coverage, 3344,
     /*  99643 */     GIR_EraseRootFromParent_Done,
     /*  99644 */   // Label 1543: @99644
     /*  99644 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99776), // Rule ID 4028 //
     /*  99649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99668 */     // MIs[1] Operand 1
     /*  99668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /*  99673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99675 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99697 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99700 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99704 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99709 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99726 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99743 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /*  99750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99774 */     GIR_RootConstrainSelectedInstOperands,
     /*  99775 */     // GIR_Coverage, 4028,
     /*  99775 */     GIR_EraseRootFromParent_Done,
     /*  99776 */   // Label 1544: @99776
     /*  99776 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99908), // Rule ID 4060 //
     /*  99781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99796 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99800 */     // MIs[1] Operand 1
     /*  99800 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /*  99805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99807 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99829 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99832 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99836 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99841 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99858 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99875 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /*  99882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /*  99887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /*  99892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /*  99895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /*  99906 */     GIR_RootConstrainSelectedInstOperands,
     /*  99907 */     // GIR_Coverage, 4060,
     /*  99907 */     GIR_EraseRootFromParent_Done,
     /*  99908 */   // Label 1545: @99908
     /*  99908 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(100040), // Rule ID 4092 //
     /*  99913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /*  99916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /*  99924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  99928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99932 */     // MIs[1] Operand 1
     /*  99932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /*  99937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99939 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /*  99939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  99942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /*  99946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /*  99955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /*  99959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99961 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  99964 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99968 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99973 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /*  99976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  99981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /*  99985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99990 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /*  99998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100007 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100038 */     GIR_RootConstrainSelectedInstOperands,
     /* 100039 */     // GIR_Coverage, 4092,
     /* 100039 */     GIR_EraseRootFromParent_Done,
     /* 100040 */   // Label 1546: @100040
     /* 100040 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(100172), // Rule ID 4124 //
     /* 100045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 100060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 100064 */     // MIs[1] Operand 1
     /* 100064 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100071 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 100078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100093 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100096 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100100 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100105 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100110 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100113 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100117 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100139 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100170 */     GIR_RootConstrainSelectedInstOperands,
     /* 100171 */     // GIR_Coverage, 4124,
     /* 100171 */     GIR_EraseRootFromParent_Done,
     /* 100172 */   // Label 1547: @100172
     /* 100172 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100304), // Rule ID 4140 //
     /* 100177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100196 */     // MIs[1] Operand 1
     /* 100196 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100203 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100225 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100228 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100232 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100237 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100242 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100245 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100249 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100254 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100271 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100302 */     GIR_RootConstrainSelectedInstOperands,
     /* 100303 */     // GIR_Coverage, 4140,
     /* 100303 */     GIR_EraseRootFromParent_Done,
     /* 100304 */   // Label 1548: @100304
     /* 100304 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100436), // Rule ID 4172 //
     /* 100309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100328 */     // MIs[1] Operand 1
     /* 100328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100335 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100351 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100357 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100360 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100364 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100369 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100386 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100403 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100434 */     GIR_RootConstrainSelectedInstOperands,
     /* 100435 */     // GIR_Coverage, 4172,
     /* 100435 */     GIR_EraseRootFromParent_Done,
     /* 100436 */   // Label 1549: @100436
     /* 100436 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(100568), // Rule ID 4204 //
     /* 100441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100456 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100460 */     // MIs[1] Operand 1
     /* 100460 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100467 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100479 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100483 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100489 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100492 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100496 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100501 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100506 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100509 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100513 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100518 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100535 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 100542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100547 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100566 */     GIR_RootConstrainSelectedInstOperands,
     /* 100567 */     // GIR_Coverage, 4204,
     /* 100567 */     GIR_EraseRootFromParent_Done,
     /* 100568 */   // Label 1550: @100568
     /* 100568 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100700), // Rule ID 4236 //
     /* 100573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 100588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 100592 */     // MIs[1] Operand 1
     /* 100592 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 100597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100599 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100599 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100602 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 100606 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100611 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100621 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100624 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100628 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100633 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100638 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100641 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100645 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100650 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100667 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 100674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100698 */     GIR_RootConstrainSelectedInstOperands,
     /* 100699 */     // GIR_Coverage, 4236,
     /* 100699 */     GIR_EraseRootFromParent_Done,
     /* 100700 */   // Label 1551: @100700
     /* 100700 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100832), // Rule ID 4266 //
     /* 100705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100724 */     // MIs[1] Operand 1
     /* 100724 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 100729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100731 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100731 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100734 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100738 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100743 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100753 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100756 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100760 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100765 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100782 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100799 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 100806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100830 */     GIR_RootConstrainSelectedInstOperands,
     /* 100831 */     // GIR_Coverage, 4266,
     /* 100831 */     GIR_EraseRootFromParent_Done,
     /* 100832 */   // Label 1552: @100832
     /* 100832 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100964), // Rule ID 4298 //
     /* 100837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100852 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100856 */     // MIs[1] Operand 1
     /* 100856 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 100861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100863 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100863 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100866 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 100870 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100875 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 100879 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 100883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100885 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 100888 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100892 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100897 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 100900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 100902 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 100905 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 100909 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100914 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 100917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 100919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 100922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 100926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100931 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 100938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 100943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 100948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 100951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 100962 */     GIR_RootConstrainSelectedInstOperands,
     /* 100963 */     // GIR_Coverage, 4298,
     /* 100963 */     GIR_EraseRootFromParent_Done,
     /* 100964 */   // Label 1553: @100964
     /* 100964 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(101096), // Rule ID 4330 //
     /* 100969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 100972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 100980 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 100984 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 100988 */     // MIs[1] Operand 1
     /* 100988 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 100993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100995 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 100995 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 100998 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 101002 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101007 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101029 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101034 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101037 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101041 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101046 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101063 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 101070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101094 */     GIR_RootConstrainSelectedInstOperands,
     /* 101095 */     // GIR_Coverage, 4330,
     /* 101095 */     GIR_EraseRootFromParent_Done,
     /* 101096 */   // Label 1554: @101096
     /* 101096 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(101228), // Rule ID 4362 //
     /* 101101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 101104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 101116 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 101120 */     // MIs[1] Operand 1
     /* 101120 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 101125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101127 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101127 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101130 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 101134 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101139 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101143 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101149 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101152 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101156 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101161 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101166 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101169 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101173 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101178 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101195 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 101202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101226 */     GIR_RootConstrainSelectedInstOperands,
     /* 101227 */     // GIR_Coverage, 4362,
     /* 101227 */     GIR_EraseRootFromParent_Done,
     /* 101228 */   // Label 1555: @101228
     /* 101228 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(101360), // Rule ID 4593 //
     /* 101233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101248 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101252 */     // MIs[1] Operand 1
     /* 101252 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 101257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101259 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 101266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101275 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101281 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101284 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101288 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101293 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101310 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101327 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101358 */     GIR_RootConstrainSelectedInstOperands,
     /* 101359 */     // GIR_Coverage, 4593,
     /* 101359 */     GIR_EraseRootFromParent_Done,
     /* 101360 */   // Label 1556: @101360
     /* 101360 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(101492), // Rule ID 4625 //
     /* 101365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101380 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101384 */     // MIs[1] Operand 1
     /* 101384 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101391 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101391 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101394 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 101398 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101407 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101413 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101416 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101420 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101425 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101442 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101459 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101490 */     GIR_RootConstrainSelectedInstOperands,
     /* 101491 */     // GIR_Coverage, 4625,
     /* 101491 */     GIR_EraseRootFromParent_Done,
     /* 101492 */   // Label 1557: @101492
     /* 101492 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(101624), // Rule ID 4657 //
     /* 101497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 101512 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 101516 */     // MIs[1] Operand 1
     /* 101516 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101523 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101523 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101526 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 101530 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101535 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101539 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101545 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101548 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101552 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101557 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101562 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101565 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101569 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101574 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101591 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101622 */     GIR_RootConstrainSelectedInstOperands,
     /* 101623 */     // GIR_Coverage, 4657,
     /* 101623 */     GIR_EraseRootFromParent_Done,
     /* 101624 */   // Label 1558: @101624
     /* 101624 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101756), // Rule ID 4701 //
     /* 101629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101648 */     // MIs[1] Operand 1
     /* 101648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 101653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101655 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 101662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101671 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101677 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101680 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101684 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101689 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101706 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101723 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101730 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101754 */     GIR_RootConstrainSelectedInstOperands,
     /* 101755 */     // GIR_Coverage, 4701,
     /* 101755 */     GIR_EraseRootFromParent_Done,
     /* 101756 */   // Label 1559: @101756
     /* 101756 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101888), // Rule ID 4733 //
     /* 101761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101776 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101780 */     // MIs[1] Operand 1
     /* 101780 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 101785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101787 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 101794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101809 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101812 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101816 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101821 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101838 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101855 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 101872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 101875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 101886 */     GIR_RootConstrainSelectedInstOperands,
     /* 101887 */     // GIR_Coverage, 4733,
     /* 101887 */     GIR_EraseRootFromParent_Done,
     /* 101888 */   // Label 1560: @101888
     /* 101888 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(102020), // Rule ID 4765 //
     /* 101893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 101896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 101904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 101908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 101912 */     // MIs[1] Operand 1
     /* 101912 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 101917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101919 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 101919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 101922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 101926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 101935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 101939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101941 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 101944 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101948 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101953 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 101956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101958 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 101961 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 101965 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101970 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 101973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 101975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 101978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 101982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101987 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 101994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 101999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 102007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 102018 */     GIR_RootConstrainSelectedInstOperands,
     /* 102019 */     // GIR_Coverage, 4765,
     /* 102019 */     GIR_EraseRootFromParent_Done,
     /* 102020 */   // Label 1561: @102020
     /* 102020 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(102112), // Rule ID 2986 //
     /* 102025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102040 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102044 */     // MIs[1] Operand 1
     /* 102044 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102051 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 102051 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102054 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102058 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102067 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102085 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102092 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102110 */     GIR_RootConstrainSelectedInstOperands,
     /* 102111 */     // GIR_Coverage, 2986,
     /* 102111 */     GIR_EraseRootFromParent_Done,
     /* 102112 */   // Label 1562: @102112
     /* 102112 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(102204), // Rule ID 3000 //
     /* 102117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102132 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102136 */     // MIs[1] Operand 1
     /* 102136 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102143 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 102143 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102146 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102150 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102155 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102159 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102177 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102202 */     GIR_RootConstrainSelectedInstOperands,
     /* 102203 */     // GIR_Coverage, 3000,
     /* 102203 */     GIR_EraseRootFromParent_Done,
     /* 102204 */   // Label 1563: @102204
     /* 102204 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(102296), // Rule ID 3008 //
     /* 102209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102228 */     // MIs[1] Operand 1
     /* 102228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102235 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 102235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102269 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102294 */     GIR_RootConstrainSelectedInstOperands,
     /* 102295 */     // GIR_Coverage, 3008,
     /* 102295 */     GIR_EraseRootFromParent_Done,
     /* 102296 */   // Label 1564: @102296
     /* 102296 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(102388), // Rule ID 3016 //
     /* 102301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102320 */     // MIs[1] Operand 1
     /* 102320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102327 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 102327 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102330 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102334 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102339 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102361 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102386 */     GIR_RootConstrainSelectedInstOperands,
     /* 102387 */     // GIR_Coverage, 3016,
     /* 102387 */     GIR_EraseRootFromParent_Done,
     /* 102388 */   // Label 1565: @102388
     /* 102388 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(102480), // Rule ID 3024 //
     /* 102393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102408 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102412 */     // MIs[1] Operand 1
     /* 102412 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102419 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 102419 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102422 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 102426 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102431 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102435 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102453 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102478 */     GIR_RootConstrainSelectedInstOperands,
     /* 102479 */     // GIR_Coverage, 3024,
     /* 102479 */     GIR_EraseRootFromParent_Done,
     /* 102480 */   // Label 1566: @102480
     /* 102480 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(102572), // Rule ID 3088 //
     /* 102485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102500 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102504 */     // MIs[1] Operand 1
     /* 102504 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102511 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102511 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102514 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102518 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102523 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102527 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102545 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102552 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102570 */     GIR_RootConstrainSelectedInstOperands,
     /* 102571 */     // GIR_Coverage, 3088,
     /* 102571 */     GIR_EraseRootFromParent_Done,
     /* 102572 */   // Label 1567: @102572
     /* 102572 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(102664), // Rule ID 3096 //
     /* 102577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102588 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102592 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102596 */     // MIs[1] Operand 1
     /* 102596 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 102601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102603 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 102603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102615 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102619 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102637 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 102644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102649 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102662 */     GIR_RootConstrainSelectedInstOperands,
     /* 102663 */     // GIR_Coverage, 3096,
     /* 102663 */     GIR_EraseRootFromParent_Done,
     /* 102664 */   // Label 1568: @102664
     /* 102664 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102756), // Rule ID 3104 //
     /* 102669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102688 */     // MIs[1] Operand 1
     /* 102688 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 102693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102695 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 102702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102707 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102711 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102729 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102754 */     GIR_RootConstrainSelectedInstOperands,
     /* 102755 */     // GIR_Coverage, 3104,
     /* 102755 */     GIR_EraseRootFromParent_Done,
     /* 102756 */   // Label 1569: @102756
     /* 102756 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102848), // Rule ID 3112 //
     /* 102761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102776 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102780 */     // MIs[1] Operand 1
     /* 102780 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 102785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102787 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 102787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102803 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102821 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 102828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102846 */     GIR_RootConstrainSelectedInstOperands,
     /* 102847 */     // GIR_Coverage, 3112,
     /* 102847 */     GIR_EraseRootFromParent_Done,
     /* 102848 */   // Label 1570: @102848
     /* 102848 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102940), // Rule ID 3120 //
     /* 102853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 102856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 102868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 102872 */     // MIs[1] Operand 1
     /* 102872 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 102877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102879 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 102879 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102882 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 102886 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102891 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102895 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 102904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 102908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102913 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 102920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 102925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 102930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 102933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 102935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102938 */     GIR_RootConstrainSelectedInstOperands,
     /* 102939 */     // GIR_Coverage, 3120,
     /* 102939 */     GIR_EraseRootFromParent_Done,
     /* 102940 */   // Label 1571: @102940
     /* 102940 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(103072), // Rule ID 3871 //
     /* 102945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 102948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 102956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 102960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102964 */     // MIs[1] Operand 1
     /* 102964 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 102969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102971 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 102971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 102974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 102978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102983 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 102987 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 102991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 102996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103005 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103022 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103039 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103046 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103070 */     GIR_RootConstrainSelectedInstOperands,
     /* 103071 */     // GIR_Coverage, 3871,
     /* 103071 */     GIR_EraseRootFromParent_Done,
     /* 103072 */   // Label 1572: @103072
     /* 103072 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(103204), // Rule ID 3879 //
     /* 103077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103092 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103096 */     // MIs[1] Operand 1
     /* 103096 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103103 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103103 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103106 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103110 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103115 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103119 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103125 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103128 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103132 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103137 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103154 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103171 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103202 */     GIR_RootConstrainSelectedInstOperands,
     /* 103203 */     // GIR_Coverage, 3879,
     /* 103203 */     GIR_EraseRootFromParent_Done,
     /* 103204 */   // Label 1573: @103204
     /* 103204 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(103336), // Rule ID 3887 //
     /* 103209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103224 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103228 */     // MIs[1] Operand 1
     /* 103228 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 103233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103235 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103235 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103238 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 103242 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103247 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103257 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103260 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103264 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103269 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103274 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103277 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103281 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103286 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103303 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103334 */     GIR_RootConstrainSelectedInstOperands,
     /* 103335 */     // GIR_Coverage, 3887,
     /* 103335 */     GIR_EraseRootFromParent_Done,
     /* 103336 */   // Label 1574: @103336
     /* 103336 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(103468), // Rule ID 3895 //
     /* 103341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103360 */     // MIs[1] Operand 1
     /* 103360 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 103365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103367 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103389 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103392 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103396 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103401 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103406 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103409 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103413 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103418 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103435 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103442 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103466 */     GIR_RootConstrainSelectedInstOperands,
     /* 103467 */     // GIR_Coverage, 3895,
     /* 103467 */     GIR_EraseRootFromParent_Done,
     /* 103468 */   // Label 1575: @103468
     /* 103468 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(103600), // Rule ID 3903 //
     /* 103473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 103488 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 103492 */     // MIs[1] Operand 1
     /* 103492 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 103497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103499 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 103506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103511 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103521 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103524 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103528 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103533 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103550 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103567 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 103574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103592 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103598 */     GIR_RootConstrainSelectedInstOperands,
     /* 103599 */     // GIR_Coverage, 3903,
     /* 103599 */     GIR_EraseRootFromParent_Done,
     /* 103600 */   // Label 1576: @103600
     /* 103600 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(103732), // Rule ID 3967 //
     /* 103605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103620 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103624 */     // MIs[1] Operand 1
     /* 103624 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 103629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103631 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103643 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103647 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103653 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103656 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103660 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103665 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103682 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103699 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103730 */     GIR_RootConstrainSelectedInstOperands,
     /* 103731 */     // GIR_Coverage, 3967,
     /* 103731 */     GIR_EraseRootFromParent_Done,
     /* 103732 */   // Label 1577: @103732
     /* 103732 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(103864), // Rule ID 3975 //
     /* 103737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103756 */     // MIs[1] Operand 1
     /* 103756 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 103761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103763 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 103770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103785 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103788 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103792 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103797 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103802 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103805 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103809 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103814 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103831 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 103838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103862 */     GIR_RootConstrainSelectedInstOperands,
     /* 103863 */     // GIR_Coverage, 3975,
     /* 103863 */     GIR_EraseRootFromParent_Done,
     /* 103864 */   // Label 1578: @103864
     /* 103864 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103996), // Rule ID 3983 //
     /* 103869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 103872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 103880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 103884 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 103888 */     // MIs[1] Operand 1
     /* 103888 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 103893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103895 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 103895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 103898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 103902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 103911 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 103915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103917 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 103920 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103924 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103929 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 103932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103934 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 103937 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 103941 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103946 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 103949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 103951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 103954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 103958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103963 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 103970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 103975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 103980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 103983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 103994 */     GIR_RootConstrainSelectedInstOperands,
     /* 103995 */     // GIR_Coverage, 3983,
     /* 103995 */     GIR_EraseRootFromParent_Done,
     /* 103996 */   // Label 1579: @103996
     /* 103996 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(104128), // Rule ID 3991 //
     /* 104001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 104004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104020 */     // MIs[1] Operand 1
     /* 104020 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 104025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104027 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 104027 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104030 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 104034 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 104047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104049 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104052 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104056 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104061 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 104064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104066 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104069 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104073 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104078 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 104086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 104090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104095 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 104102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 104107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 104112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 104126 */     GIR_RootConstrainSelectedInstOperands,
     /* 104127 */     // GIR_Coverage, 3991,
     /* 104127 */     GIR_EraseRootFromParent_Done,
     /* 104128 */   // Label 1580: @104128
     /* 104128 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(104260), // Rule ID 3999 //
     /* 104133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 104136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104148 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104152 */     // MIs[1] Operand 1
     /* 104152 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104159 */     // (anyext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 104159 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104162 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 104166 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104171 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 104175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 104179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104181 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104184 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104188 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104193 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 104196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104198 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104201 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104205 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104210 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 104218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 104222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104227 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 104234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 104239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 104244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 104258 */     GIR_RootConstrainSelectedInstOperands,
     /* 104259 */     // GIR_Coverage, 3999,
     /* 104259 */     GIR_EraseRootFromParent_Done,
     /* 104260 */   // Label 1581: @104260
     /* 104260 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(104275), // Rule ID 2992 //
     /* 104265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 104268 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 104268 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 104273 */     GIR_RootConstrainSelectedInstOperands,
     /* 104274 */     // GIR_Coverage, 2992,
     /* 104274 */     GIR_Done,
     /* 104275 */   // Label 1582: @104275
     /* 104275 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(104329), // Rule ID 3677 //
     /* 104280 */     // (anyext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 104280 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104283 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104287 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104292 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 104295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 104304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 104312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 104317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104319 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 104321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104327 */     GIR_RootConstrainSelectedInstOperands,
     /* 104328 */     // GIR_Coverage, 3677,
     /* 104328 */     GIR_EraseRootFromParent_Done,
     /* 104329 */   // Label 1583: @104329
     /* 104329 */   GIM_Reject,
     /* 104330 */ // Label 1491: @104330
     /* 104330 */ GIM_Reject,
     /* 104331 */ // Label 1489: @104331
     /* 104331 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(114845),
     /* 104336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 104339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104343 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(104452), // Rule ID 5304 //
     /* 104348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104364 */     // MIs[1] Operand 1
     /* 104364 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104377 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104381 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104385 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104389 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104393 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104401 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104405 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104411 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104423 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 104430 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 104433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104450 */     GIR_RootConstrainSelectedInstOperands,
     /* 104451 */     // GIR_Coverage, 5304,
     /* 104451 */     GIR_EraseRootFromParent_Done,
     /* 104452 */   // Label 1585: @104452
     /* 104452 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(104615), // Rule ID 5305 //
     /* 104457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104469 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104473 */     // MIs[1] Operand 1
     /* 104473 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104490 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104510 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104514 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104520 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104520 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104523 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104527 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104532 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104536 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 104539 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 104542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104544 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104547 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104551 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104556 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104560 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104563 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104566 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104614 */     // GIR_Coverage, 5305,
     /* 104614 */     GIR_EraseRootFromParent_Done,
     /* 104615 */   // Label 1586: @104615
     /* 104615 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(104745), // Rule ID 5312 //
     /* 104620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104632 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104636 */     // MIs[1] Operand 1
     /* 104636 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104673 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104677 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104681 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104683 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104695 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104699 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 104702 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 104705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 104714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104719 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 104732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 104734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 104743 */     GIR_RootConstrainSelectedInstOperands,
     /* 104744 */     // GIR_Coverage, 5312,
     /* 104744 */     GIR_EraseRootFromParent_Done,
     /* 104745 */   // Label 1587: @104745
     /* 104745 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(104929), // Rule ID 5313 //
     /* 104750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 104762 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104766 */     // MIs[1] Operand 1
     /* 104766 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 104771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 104783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 104787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104795 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 104799 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104803 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104807 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104813 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 104813 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 104816 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 104820 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104825 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 104829 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 104832 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 104835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 104837 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 104840 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 104844 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104849 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104853 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 104857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104859 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 104862 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 104866 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104871 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 104874 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 104877 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104880 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 104883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 104888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 104910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 104923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 104928 */     // GIR_Coverage, 5313,
     /* 104928 */     GIR_EraseRootFromParent_Done,
     /* 104929 */   // Label 1588: @104929
     /* 104929 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(105038), // Rule ID 3782 //
     /* 104934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 104942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 104946 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 104950 */     // MIs[1] Operand 1
     /* 104950 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 104955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 104959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 104963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 104967 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 104971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 104979 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 104983 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 104987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 104991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 104995 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104997 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 104997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 105000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105013 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 105016 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 105019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 105024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105036 */     GIR_RootConstrainSelectedInstOperands,
     /* 105037 */     // GIR_Coverage, 3782,
     /* 105037 */     GIR_EraseRootFromParent_Done,
     /* 105038 */   // Label 1589: @105038
     /* 105038 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(105201), // Rule ID 3783 //
     /* 105043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105055 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105059 */     // MIs[1] Operand 1
     /* 105059 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 105076 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 105080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105088 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 105092 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105096 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105100 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105106 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105106 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105109 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105113 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105118 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 105125 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 105128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105130 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105133 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 105137 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105142 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105146 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105149 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105152 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105190 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105200 */     // GIR_Coverage, 3783,
     /* 105200 */     GIR_EraseRootFromParent_Done,
     /* 105201 */   // Label 1590: @105201
     /* 105201 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(105331), // Rule ID 3790 //
     /* 105206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105218 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105222 */     // MIs[1] Operand 1
     /* 105222 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 105239 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 105243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105251 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 105255 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105259 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105269 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 105269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105281 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105285 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 105288 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 105291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 105318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105329 */     GIR_RootConstrainSelectedInstOperands,
     /* 105330 */     // GIR_Coverage, 3790,
     /* 105330 */     GIR_EraseRootFromParent_Done,
     /* 105331 */   // Label 1591: @105331
     /* 105331 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(105515), // Rule ID 3791 //
     /* 105336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105352 */     // MIs[1] Operand 1
     /* 105352 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 105361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 105365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 105369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 105373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 105381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 105385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 105389 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 105393 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105397 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105399 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105399 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105402 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 105406 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105411 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 105415 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 105418 */     GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 105421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105423 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105426 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105430 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105435 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105439 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 105443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105445 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105448 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 105452 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105457 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105460 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 105463 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105466 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105499 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105514 */     // GIR_Coverage, 3791,
     /* 105514 */     GIR_EraseRootFromParent_Done,
     /* 105515 */   // Label 1592: @105515
     /* 105515 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(105581), // Rule ID 3702 //
     /* 105520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105536 */     // MIs[1] Operand 1
     /* 105536 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105541 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105547 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105559 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105579 */     GIR_RootConstrainSelectedInstOperands,
     /* 105580 */     // GIR_Coverage, 3702,
     /* 105580 */     GIR_EraseRootFromParent_Done,
     /* 105581 */   // Label 1593: @105581
     /* 105581 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(105701), // Rule ID 3703 //
     /* 105586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105594 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105598 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105602 */     // MIs[1] Operand 1
     /* 105602 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 105607 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105613 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105613 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105616 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105620 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105625 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105631 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105634 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105638 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105643 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105646 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105652 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105695 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105700 */     // GIR_Coverage, 3703,
     /* 105700 */     GIR_EraseRootFromParent_Done,
     /* 105701 */   // Label 1594: @105701
     /* 105701 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(105805), // Rule ID 3710 //
     /* 105706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105718 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105722 */     // MIs[1] Operand 1
     /* 105722 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105733 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 105733 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 105736 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105740 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105745 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105751 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 105754 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 105758 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105763 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 105776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105781 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105784 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 105787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 105794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 105800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 105803 */     GIR_RootConstrainSelectedInstOperands,
     /* 105804 */     // GIR_Coverage, 3710,
     /* 105804 */     GIR_EraseRootFromParent_Done,
     /* 105805 */   // Label 1595: @105805
     /* 105805 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(105963), // Rule ID 3711 //
     /* 105810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 105822 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 105826 */     // MIs[1] Operand 1
     /* 105826 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 105831 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105837 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 105837 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 105840 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105844 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105849 */     GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 105855 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 105858 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 105862 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105867 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 105871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105873 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 105876 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 105880 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105885 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105888 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 105891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 105893 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 105896 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 105900 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105905 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 105908 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 105911 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105914 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 105917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105931 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 105944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 105957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 105962 */     // GIR_Coverage, 3711,
     /* 105962 */     GIR_EraseRootFromParent_Done,
     /* 105963 */   // Label 1596: @105963
     /* 105963 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(106012), // Rule ID 3718 //
     /* 105968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 105976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 105980 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 105984 */     // MIs[1] Operand 1
     /* 105984 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 105989 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 105993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105995 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 105995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 105998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106010 */     GIR_RootConstrainSelectedInstOperands,
     /* 106011 */     // GIR_Coverage, 3718,
     /* 106011 */     GIR_EraseRootFromParent_Done,
     /* 106012 */   // Label 1597: @106012
     /* 106012 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(106115), // Rule ID 3719 //
     /* 106017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106029 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106033 */     // MIs[1] Operand 1
     /* 106033 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106038 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106044 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106056 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106060 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106063 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106066 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106114 */     // GIR_Coverage, 3719,
     /* 106114 */     GIR_EraseRootFromParent_Done,
     /* 106115 */   // Label 1598: @106115
     /* 106115 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(106185), // Rule ID 3726 //
     /* 106120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106132 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106136 */     // MIs[1] Operand 1
     /* 106136 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106147 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 106154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106183 */     GIR_RootConstrainSelectedInstOperands,
     /* 106184 */     // GIR_Coverage, 3726,
     /* 106184 */     GIR_EraseRootFromParent_Done,
     /* 106185 */   // Label 1599: @106185
     /* 106185 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(106309), // Rule ID 3727 //
     /* 106190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106202 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106206 */     // MIs[1] Operand 1
     /* 106206 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 106211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106217 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106217 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106220 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 106224 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106229 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106233 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106239 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106242 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106246 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106251 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106254 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106257 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106260 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106308 */     // GIR_Coverage, 3727,
     /* 106308 */     GIR_EraseRootFromParent_Done,
     /* 106309 */   // Label 1600: @106309
     /* 106309 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(106396), // Rule ID 3734 //
     /* 106314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106326 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106330 */     // MIs[1] Operand 1
     /* 106330 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106335 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106341 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106341 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106344 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106348 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106353 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 106366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106374 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106394 */     GIR_RootConstrainSelectedInstOperands,
     /* 106395 */     // GIR_Coverage, 3734,
     /* 106395 */     GIR_EraseRootFromParent_Done,
     /* 106396 */   // Label 1601: @106396
     /* 106396 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(106537), // Rule ID 3735 //
     /* 106401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106413 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106417 */     // MIs[1] Operand 1
     /* 106417 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 106422 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106428 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106428 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106431 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106435 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106440 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106446 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106449 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 106453 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106458 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106461 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106479 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106482 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106488 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106521 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106536 */     // GIR_Coverage, 3735,
     /* 106536 */     GIR_EraseRootFromParent_Done,
     /* 106537 */   // Label 1602: @106537
     /* 106537 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(106624), // Rule ID 3742 //
     /* 106542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106554 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106558 */     // MIs[1] Operand 1
     /* 106558 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106563 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106569 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106569 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106572 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 106576 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 106594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106599 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106603 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106622 */     GIR_RootConstrainSelectedInstOperands,
     /* 106623 */     // GIR_Coverage, 3742,
     /* 106623 */     GIR_EraseRootFromParent_Done,
     /* 106624 */   // Label 1603: @106624
     /* 106624 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(106765), // Rule ID 3743 //
     /* 106629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106641 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106645 */     // MIs[1] Operand 1
     /* 106645 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 106650 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 106654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106656 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106656 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106659 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 106663 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106668 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106674 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106677 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 106681 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106686 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106690 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106695 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106698 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106702 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106707 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106710 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106713 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106716 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106749 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106764 */     // GIR_Coverage, 3743,
     /* 106764 */     GIR_EraseRootFromParent_Done,
     /* 106765 */   // Label 1604: @106765
     /* 106765 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(106855), // Rule ID 3750 //
     /* 106770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106782 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 106786 */     // MIs[1] Operand 1
     /* 106786 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106791 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106797 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 106797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 106804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106809 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106813 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 106825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106830 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106834 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 106842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 106844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 106853 */     GIR_RootConstrainSelectedInstOperands,
     /* 106854 */     // GIR_Coverage, 3750,
     /* 106854 */     GIR_EraseRootFromParent_Done,
     /* 106855 */   // Label 1605: @106855
     /* 106855 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(106999), // Rule ID 3751 //
     /* 106860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 106868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 106876 */     // MIs[1] Operand 1
     /* 106876 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 106881 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 106885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106887 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 106887 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 106890 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 106894 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106899 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106903 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 106906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 106908 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 106911 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 106915 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106920 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 106924 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 106929 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 106932 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 106936 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106941 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 106947 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106950 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 106953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 106958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 106969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 106977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 106980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 106983 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 106993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 106998 */     // GIR_Coverage, 3751,
     /* 106998 */     GIR_EraseRootFromParent_Done,
     /* 106999 */   // Label 1606: @106999
     /* 106999 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(107089), // Rule ID 3758 //
     /* 107004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107016 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107020 */     // MIs[1] Operand 1
     /* 107020 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107031 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 107038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107047 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 107059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107068 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107087 */     GIR_RootConstrainSelectedInstOperands,
     /* 107088 */     // GIR_Coverage, 3758,
     /* 107088 */     GIR_EraseRootFromParent_Done,
     /* 107089 */   // Label 1607: @107089
     /* 107089 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(107233), // Rule ID 3759 //
     /* 107094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107106 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107110 */     // MIs[1] Operand 1
     /* 107110 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107115 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107121 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107121 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 107124 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 107128 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107133 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107137 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 107140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 107142 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 107145 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 107149 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107154 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107158 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107175 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107178 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107181 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107184 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107232 */     // GIR_Coverage, 3759,
     /* 107232 */     GIR_EraseRootFromParent_Done,
     /* 107233 */   // Label 1608: @107233
     /* 107233 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(107303), // Rule ID 3766 //
     /* 107238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107250 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107254 */     // MIs[1] Operand 1
     /* 107254 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 107259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107265 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 107272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107277 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107301 */     GIR_RootConstrainSelectedInstOperands,
     /* 107302 */     // GIR_Coverage, 3766,
     /* 107302 */     GIR_EraseRootFromParent_Done,
     /* 107303 */   // Label 1609: @107303
     /* 107303 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(107427), // Rule ID 3767 //
     /* 107308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107320 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107324 */     // MIs[1] Operand 1
     /* 107324 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 107329 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107335 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 107338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 107342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107347 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107351 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 107357 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107360 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107364 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107369 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107372 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107375 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107378 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107426 */     // GIR_Coverage, 3767,
     /* 107426 */     GIR_EraseRootFromParent_Done,
     /* 107427 */   // Label 1610: @107427
     /* 107427 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(107476), // Rule ID 3774 //
     /* 107432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107444 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107448 */     // MIs[1] Operand 1
     /* 107448 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107453 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107459 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 107459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 107462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 107464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 107474 */     GIR_RootConstrainSelectedInstOperands,
     /* 107475 */     // GIR_Coverage, 3774,
     /* 107475 */     GIR_EraseRootFromParent_Done,
     /* 107476 */   // Label 1611: @107476
     /* 107476 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(107579), // Rule ID 3775 //
     /* 107481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107489 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107493 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107497 */     // MIs[1] Operand 1
     /* 107497 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107502 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 107506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107508 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 107508 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107511 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 107515 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107520 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107524 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 107527 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107530 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 107533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 107560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 107563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 107573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 107578 */     // GIR_Coverage, 3775,
     /* 107578 */     GIR_EraseRootFromParent_Done,
     /* 107579 */   // Label 1612: @107579
     /* 107579 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(107682), // Rule ID 3041 //
     /* 107584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107603 */     // MIs[1] Operand 1
     /* 107603 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107616 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107620 */     // MIs[2] Operand 1
     /* 107620 */     // No operand predicates
     /* 107620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107622 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 107622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107655 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107680 */     GIR_RootConstrainSelectedInstOperands,
     /* 107681 */     // GIR_Coverage, 3041,
     /* 107681 */     GIR_EraseRootFromParent_Done,
     /* 107682 */   // Label 1613: @107682
     /* 107682 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(107785), // Rule ID 3057 //
     /* 107687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107702 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107706 */     // MIs[1] Operand 1
     /* 107706 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 107711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107719 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107723 */     // MIs[2] Operand 1
     /* 107723 */     // No operand predicates
     /* 107723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107725 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 107725 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107728 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107732 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107758 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 107765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107783 */     GIR_RootConstrainSelectedInstOperands,
     /* 107784 */     // GIR_Coverage, 3057,
     /* 107784 */     GIR_EraseRootFromParent_Done,
     /* 107785 */   // Label 1614: @107785
     /* 107785 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(107888), // Rule ID 3065 //
     /* 107790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107805 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 107809 */     // MIs[1] Operand 1
     /* 107809 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 107814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 107826 */     // MIs[2] Operand 1
     /* 107826 */     // No operand predicates
     /* 107826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107828 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 107828 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107831 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 107835 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107840 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107861 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 107868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107886 */     GIR_RootConstrainSelectedInstOperands,
     /* 107887 */     // GIR_Coverage, 3065,
     /* 107887 */     GIR_EraseRootFromParent_Done,
     /* 107888 */   // Label 1615: @107888
     /* 107888 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(107991), // Rule ID 3137 //
     /* 107893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 107904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107908 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 107912 */     // MIs[1] Operand 1
     /* 107912 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 107917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 107921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 107925 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 107929 */     // MIs[2] Operand 1
     /* 107929 */     // No operand predicates
     /* 107929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 107931 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 107931 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 107934 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 107938 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107943 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 107947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 107950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 107955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107964 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 107971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 107976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 107981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 107984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 107986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107989 */     GIR_RootConstrainSelectedInstOperands,
     /* 107990 */     // GIR_Coverage, 3137,
     /* 107990 */     GIR_EraseRootFromParent_Done,
     /* 107991 */   // Label 1616: @107991
     /* 107991 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(108094), // Rule ID 3153 //
     /* 107996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 107999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108011 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108015 */     // MIs[1] Operand 1
     /* 108015 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108032 */     // MIs[2] Operand 1
     /* 108032 */     // No operand predicates
     /* 108032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108034 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 108034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108046 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108067 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108092 */     GIR_RootConstrainSelectedInstOperands,
     /* 108093 */     // GIR_Coverage, 3153,
     /* 108093 */     GIR_EraseRootFromParent_Done,
     /* 108094 */   // Label 1617: @108094
     /* 108094 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(108197), // Rule ID 3161 //
     /* 108099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 108102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108114 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108118 */     // MIs[1] Operand 1
     /* 108118 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108135 */     // MIs[2] Operand 1
     /* 108135 */     // No operand predicates
     /* 108135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108137 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 108137 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108140 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108144 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108149 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108170 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 108190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 108192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108195 */     GIR_RootConstrainSelectedInstOperands,
     /* 108196 */     // GIR_Coverage, 3161,
     /* 108196 */     GIR_EraseRootFromParent_Done,
     /* 108197 */   // Label 1618: @108197
     /* 108197 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(108340), // Rule ID 3824 //
     /* 108202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108217 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108221 */     // MIs[1] Operand 1
     /* 108221 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 108226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108234 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108238 */     // MIs[2] Operand 1
     /* 108238 */     // No operand predicates
     /* 108238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108240 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108252 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108261 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108264 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108268 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108273 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108290 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108307 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108338 */     GIR_RootConstrainSelectedInstOperands,
     /* 108339 */     // GIR_Coverage, 3824,
     /* 108339 */     GIR_EraseRootFromParent_Done,
     /* 108340 */   // Label 1619: @108340
     /* 108340 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(108483), // Rule ID 3840 //
     /* 108345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108364 */     // MIs[1] Operand 1
     /* 108364 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108381 */     // MIs[2] Operand 1
     /* 108381 */     // No operand predicates
     /* 108381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108383 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108383 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108386 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108390 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108395 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108404 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108407 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108411 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108416 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108421 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108424 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108428 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108433 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108450 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108481 */     GIR_RootConstrainSelectedInstOperands,
     /* 108482 */     // GIR_Coverage, 3840,
     /* 108482 */     GIR_EraseRootFromParent_Done,
     /* 108483 */   // Label 1620: @108483
     /* 108483 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(108626), // Rule ID 3848 //
     /* 108488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108503 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 108507 */     // MIs[1] Operand 1
     /* 108507 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108520 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 108524 */     // MIs[2] Operand 1
     /* 108524 */     // No operand predicates
     /* 108524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108526 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108526 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108529 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 108533 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108538 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108547 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108550 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108554 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108559 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108564 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108567 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108571 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108576 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108593 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 108600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108624 */     GIR_RootConstrainSelectedInstOperands,
     /* 108625 */     // GIR_Coverage, 3848,
     /* 108625 */     GIR_EraseRootFromParent_Done,
     /* 108626 */   // Label 1621: @108626
     /* 108626 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(108769), // Rule ID 3920 //
     /* 108631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108646 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108650 */     // MIs[1] Operand 1
     /* 108650 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 108655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108663 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108667 */     // MIs[2] Operand 1
     /* 108667 */     // No operand predicates
     /* 108667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108669 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108690 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108693 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108697 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108702 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108707 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108710 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108714 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108719 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108736 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 108743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108767 */     GIR_RootConstrainSelectedInstOperands,
     /* 108768 */     // GIR_Coverage, 3920,
     /* 108768 */     GIR_EraseRootFromParent_Done,
     /* 108769 */   // Label 1622: @108769
     /* 108769 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(108912), // Rule ID 3936 //
     /* 108774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108789 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108793 */     // MIs[1] Operand 1
     /* 108793 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 108798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108806 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108810 */     // MIs[2] Operand 1
     /* 108810 */     // No operand predicates
     /* 108810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108812 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108812 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108815 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108819 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108824 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108833 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108836 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108840 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108845 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108850 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108853 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108857 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108862 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 108865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 108867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 108870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108879 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 108886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 108891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 108896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 108899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 108907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 108910 */     GIR_RootConstrainSelectedInstOperands,
     /* 108911 */     // GIR_Coverage, 3936,
     /* 108911 */     GIR_EraseRootFromParent_Done,
     /* 108912 */   // Label 1623: @108912
     /* 108912 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(109055), // Rule ID 3944 //
     /* 108917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 108920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 108928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 108932 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 108936 */     // MIs[1] Operand 1
     /* 108936 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 108941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 108945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 108949 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 108953 */     // MIs[2] Operand 1
     /* 108953 */     // No operand predicates
     /* 108953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 108955 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 108955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 108958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 108962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108967 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 108971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 108974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108976 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 108979 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 108983 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108988 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 108991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 108993 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 108996 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 109000 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109005 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 109008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 109010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109022 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109029 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 109042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 109050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 109053 */     GIR_RootConstrainSelectedInstOperands,
     /* 109054 */     // GIR_Coverage, 3944,
     /* 109054 */     GIR_EraseRootFromParent_Done,
     /* 109055 */   // Label 1624: @109055
     /* 109055 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(109147), // Rule ID 3185 //
     /* 109060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109075 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109079 */     // MIs[1] Operand 1
     /* 109079 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109086 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 109086 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109089 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109093 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109120 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109145 */     GIR_RootConstrainSelectedInstOperands,
     /* 109146 */     // GIR_Coverage, 3185,
     /* 109146 */     GIR_EraseRootFromParent_Done,
     /* 109147 */   // Label 1625: @109147
     /* 109147 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(109239), // Rule ID 3201 //
     /* 109152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109167 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109171 */     // MIs[1] Operand 1
     /* 109171 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109178 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 109178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109194 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109212 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109237 */     GIR_RootConstrainSelectedInstOperands,
     /* 109238 */     // GIR_Coverage, 3201,
     /* 109238 */     GIR_EraseRootFromParent_Done,
     /* 109239 */   // Label 1626: @109239
     /* 109239 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(109331), // Rule ID 3217 //
     /* 109244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109259 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109263 */     // MIs[1] Operand 1
     /* 109263 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109270 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 109270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109286 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109304 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109329 */     GIR_RootConstrainSelectedInstOperands,
     /* 109330 */     // GIR_Coverage, 3217,
     /* 109330 */     GIR_EraseRootFromParent_Done,
     /* 109331 */   // Label 1627: @109331
     /* 109331 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(109423), // Rule ID 3233 //
     /* 109336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 109351 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 109355 */     // MIs[1] Operand 1
     /* 109355 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109362 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 109362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 109369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109396 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109403 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109421 */     GIR_RootConstrainSelectedInstOperands,
     /* 109422 */     // GIR_Coverage, 3233,
     /* 109422 */     GIR_EraseRootFromParent_Done,
     /* 109423 */   // Label 1628: @109423
     /* 109423 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(109515), // Rule ID 3241 //
     /* 109428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109443 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109447 */     // MIs[1] Operand 1
     /* 109447 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109454 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 109454 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109457 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109461 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109466 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109470 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109488 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109513 */     GIR_RootConstrainSelectedInstOperands,
     /* 109514 */     // GIR_Coverage, 3241,
     /* 109514 */     GIR_EraseRootFromParent_Done,
     /* 109515 */   // Label 1629: @109515
     /* 109515 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(109607), // Rule ID 3257 //
     /* 109520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109535 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109539 */     // MIs[1] Operand 1
     /* 109539 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109546 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 109546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109558 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109562 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109580 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109605 */     GIR_RootConstrainSelectedInstOperands,
     /* 109606 */     // GIR_Coverage, 3257,
     /* 109606 */     GIR_EraseRootFromParent_Done,
     /* 109607 */   // Label 1630: @109607
     /* 109607 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(109699), // Rule ID 3273 //
     /* 109612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109631 */     // MIs[1] Operand 1
     /* 109631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 109636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109638 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 109638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109654 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109672 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 109679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109697 */     GIR_RootConstrainSelectedInstOperands,
     /* 109698 */     // GIR_Coverage, 3273,
     /* 109698 */     GIR_EraseRootFromParent_Done,
     /* 109699 */   // Label 1631: @109699
     /* 109699 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(109791), // Rule ID 3289 //
     /* 109704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 109719 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 109723 */     // MIs[1] Operand 1
     /* 109723 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 109728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109730 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 109730 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109733 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 109737 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109746 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109764 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 109771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109789 */     GIR_RootConstrainSelectedInstOperands,
     /* 109790 */     // GIR_Coverage, 3289,
     /* 109790 */     GIR_EraseRootFromParent_Done,
     /* 109791 */   // Label 1632: @109791
     /* 109791 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(109883), // Rule ID 3297 //
     /* 109796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109811 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109815 */     // MIs[1] Operand 1
     /* 109815 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 109820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109822 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 109822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109834 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109838 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109856 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 109863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109881 */     GIR_RootConstrainSelectedInstOperands,
     /* 109882 */     // GIR_Coverage, 3297,
     /* 109882 */     GIR_EraseRootFromParent_Done,
     /* 109883 */   // Label 1633: @109883
     /* 109883 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(109975), // Rule ID 3313 //
     /* 109888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109903 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109907 */     // MIs[1] Operand 1
     /* 109907 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 109912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109914 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 109914 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 109917 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 109921 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109926 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 109930 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 109934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 109939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109948 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 109955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 109960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 109965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 109968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 109970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109973 */     GIR_RootConstrainSelectedInstOperands,
     /* 109974 */     // GIR_Coverage, 3313,
     /* 109974 */     GIR_EraseRootFromParent_Done,
     /* 109975 */   // Label 1634: @109975
     /* 109975 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(110067), // Rule ID 3329 //
     /* 109980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 109983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 109987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 109991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 109995 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 109999 */     // MIs[1] Operand 1
     /* 109999 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110006 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 110006 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110009 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 110013 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110018 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110022 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110040 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110065 */     GIR_RootConstrainSelectedInstOperands,
     /* 110066 */     // GIR_Coverage, 3329,
     /* 110066 */     GIR_EraseRootFromParent_Done,
     /* 110067 */   // Label 1635: @110067
     /* 110067 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(110159), // Rule ID 3345 //
     /* 110072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 110075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 110087 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 110091 */     // MIs[1] Operand 1
     /* 110091 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110098 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 110098 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110101 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 110105 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110110 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110132 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 110152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 110154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110157 */     GIR_RootConstrainSelectedInstOperands,
     /* 110158 */     // GIR_Coverage, 3345,
     /* 110158 */     GIR_EraseRootFromParent_Done,
     /* 110159 */   // Label 1636: @110159
     /* 110159 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(110291), // Rule ID 4030 //
     /* 110164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110183 */     // MIs[1] Operand 1
     /* 110183 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110190 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110190 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110193 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110197 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110206 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110212 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110215 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110219 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110224 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110229 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110232 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110236 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110241 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110258 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110289 */     GIR_RootConstrainSelectedInstOperands,
     /* 110290 */     // GIR_Coverage, 4030,
     /* 110290 */     GIR_EraseRootFromParent_Done,
     /* 110291 */   // Label 1637: @110291
     /* 110291 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(110423), // Rule ID 4062 //
     /* 110296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110311 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110315 */     // MIs[1] Operand 1
     /* 110315 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110322 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110344 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110347 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110351 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110356 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110361 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110364 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110368 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110373 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110390 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110421 */     GIR_RootConstrainSelectedInstOperands,
     /* 110422 */     // GIR_Coverage, 4062,
     /* 110422 */     GIR_EraseRootFromParent_Done,
     /* 110423 */   // Label 1638: @110423
     /* 110423 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(110555), // Rule ID 4094 //
     /* 110428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110443 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110447 */     // MIs[1] Operand 1
     /* 110447 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110454 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110454 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110457 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110461 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110466 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110470 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110476 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110479 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110483 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110488 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110493 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110496 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110500 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110505 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110522 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 110529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110553 */     GIR_RootConstrainSelectedInstOperands,
     /* 110554 */     // GIR_Coverage, 4094,
     /* 110554 */     GIR_EraseRootFromParent_Done,
     /* 110555 */   // Label 1639: @110555
     /* 110555 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(110687), // Rule ID 4126 //
     /* 110560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 110575 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 110579 */     // MIs[1] Operand 1
     /* 110579 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 110584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110586 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 110593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110602 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110608 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110611 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110615 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110620 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110625 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110628 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110632 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110637 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110654 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 110661 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110685 */     GIR_RootConstrainSelectedInstOperands,
     /* 110686 */     // GIR_Coverage, 4126,
     /* 110686 */     GIR_EraseRootFromParent_Done,
     /* 110687 */   // Label 1640: @110687
     /* 110687 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(110819), // Rule ID 4142 //
     /* 110692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110711 */     // MIs[1] Operand 1
     /* 110711 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 110716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110718 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110734 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110740 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110743 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110747 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110752 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110757 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110760 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110764 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110769 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110786 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 110793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110817 */     GIR_RootConstrainSelectedInstOperands,
     /* 110818 */     // GIR_Coverage, 4142,
     /* 110818 */     GIR_EraseRootFromParent_Done,
     /* 110819 */   // Label 1641: @110819
     /* 110819 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(110951), // Rule ID 4174 //
     /* 110824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110839 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110843 */     // MIs[1] Operand 1
     /* 110843 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 110848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110850 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110862 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110866 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 110870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110872 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 110875 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110879 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110884 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 110887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 110889 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 110892 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 110896 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110901 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 110904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 110906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 110909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110918 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 110925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 110930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 110935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 110938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 110946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 110949 */     GIR_RootConstrainSelectedInstOperands,
     /* 110950 */     // GIR_Coverage, 4174,
     /* 110950 */     GIR_EraseRootFromParent_Done,
     /* 110951 */   // Label 1642: @110951
     /* 110951 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(111083), // Rule ID 4206 //
     /* 110956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 110959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 110967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 110971 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 110975 */     // MIs[1] Operand 1
     /* 110975 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 110980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110982 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 110982 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 110985 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 110989 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 110998 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111004 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111007 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111011 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111016 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111033 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111050 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111081 */     GIR_RootConstrainSelectedInstOperands,
     /* 111082 */     // GIR_Coverage, 4206,
     /* 111082 */     GIR_EraseRootFromParent_Done,
     /* 111083 */   // Label 1643: @111083
     /* 111083 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(111215), // Rule ID 4238 //
     /* 111088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 111103 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 111107 */     // MIs[1] Operand 1
     /* 111107 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 111112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111114 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111114 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111117 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 111121 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111130 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111136 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111139 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111143 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111148 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111153 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111156 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111160 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111165 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111182 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 111189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111213 */     GIR_RootConstrainSelectedInstOperands,
     /* 111214 */     // GIR_Coverage, 4238,
     /* 111214 */     GIR_EraseRootFromParent_Done,
     /* 111215 */   // Label 1644: @111215
     /* 111215 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(111347), // Rule ID 4268 //
     /* 111220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111235 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111239 */     // MIs[1] Operand 1
     /* 111239 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111246 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111246 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111249 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111253 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111262 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111268 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111271 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111275 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111280 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111285 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111288 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111292 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111297 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111314 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 111321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111345 */     GIR_RootConstrainSelectedInstOperands,
     /* 111346 */     // GIR_Coverage, 4268,
     /* 111346 */     GIR_EraseRootFromParent_Done,
     /* 111347 */   // Label 1645: @111347
     /* 111347 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(111479), // Rule ID 4300 //
     /* 111352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111367 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111371 */     // MIs[1] Operand 1
     /* 111371 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111378 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111378 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111381 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111385 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111394 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111400 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111403 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111407 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111412 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111417 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111420 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111424 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111429 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111446 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111477 */     GIR_RootConstrainSelectedInstOperands,
     /* 111478 */     // GIR_Coverage, 4300,
     /* 111478 */     GIR_EraseRootFromParent_Done,
     /* 111479 */   // Label 1646: @111479
     /* 111479 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(111611), // Rule ID 4332 //
     /* 111484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111503 */     // MIs[1] Operand 1
     /* 111503 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 111508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111510 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111526 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111532 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111535 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111539 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111544 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111549 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111552 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111556 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111561 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111578 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 111585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111609 */     GIR_RootConstrainSelectedInstOperands,
     /* 111610 */     // GIR_Coverage, 4332,
     /* 111610 */     GIR_EraseRootFromParent_Done,
     /* 111611 */   // Label 1647: @111611
     /* 111611 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(111743), // Rule ID 4364 //
     /* 111616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 111619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 111631 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 111635 */     // MIs[1] Operand 1
     /* 111635 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 111640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111642 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111642 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111645 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 111649 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111654 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111658 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111664 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111667 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111671 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111676 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111681 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111684 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111688 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111693 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111710 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 111717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111741 */     GIR_RootConstrainSelectedInstOperands,
     /* 111742 */     // GIR_Coverage, 4364,
     /* 111742 */     GIR_EraseRootFromParent_Done,
     /* 111743 */   // Label 1648: @111743
     /* 111743 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(111875), // Rule ID 4595 //
     /* 111748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111763 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111767 */     // MIs[1] Operand 1
     /* 111767 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 111772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111774 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 111781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111790 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111796 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111799 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111803 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111808 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111813 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111816 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111820 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111825 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111842 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 111870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 111873 */     GIR_RootConstrainSelectedInstOperands,
     /* 111874 */     // GIR_Coverage, 4595,
     /* 111874 */     GIR_EraseRootFromParent_Done,
     /* 111875 */   // Label 1649: @111875
     /* 111875 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(112007), // Rule ID 4627 //
     /* 111880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 111883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 111891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 111895 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 111899 */     // MIs[1] Operand 1
     /* 111899 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 111904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111906 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 111906 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 111909 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 111913 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111918 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 111922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 111926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 111928 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 111931 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111935 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111940 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 111943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 111945 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 111948 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 111952 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111957 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 111960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 111962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 111965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111974 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 111981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 111986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 111991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 111994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112005 */     GIR_RootConstrainSelectedInstOperands,
     /* 112006 */     // GIR_Coverage, 4627,
     /* 112006 */     GIR_EraseRootFromParent_Done,
     /* 112007 */   // Label 1650: @112007
     /* 112007 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(112139), // Rule ID 4659 //
     /* 112012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112027 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112031 */     // MIs[1] Operand 1
     /* 112031 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 112036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112038 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112038 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112041 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 112045 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112054 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112060 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112063 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112067 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112072 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112077 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112080 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112084 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112089 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112106 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112137 */     GIR_RootConstrainSelectedInstOperands,
     /* 112138 */     // GIR_Coverage, 4659,
     /* 112138 */     GIR_EraseRootFromParent_Done,
     /* 112139 */   // Label 1651: @112139
     /* 112139 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(112271), // Rule ID 4703 //
     /* 112144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112159 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112163 */     // MIs[1] Operand 1
     /* 112163 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 112168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112170 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 112177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112192 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112195 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112199 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112204 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112209 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112212 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112216 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112221 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112226 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112229 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112233 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112238 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112269 */     GIR_RootConstrainSelectedInstOperands,
     /* 112270 */     // GIR_Coverage, 4703,
     /* 112270 */     GIR_EraseRootFromParent_Done,
     /* 112271 */   // Label 1652: @112271
     /* 112271 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(112403), // Rule ID 4735 //
     /* 112276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112295 */     // MIs[1] Operand 1
     /* 112295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 112300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112302 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 112309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112324 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112327 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112331 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112336 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112341 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112344 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112348 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112353 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112370 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112401 */     GIR_RootConstrainSelectedInstOperands,
     /* 112402 */     // GIR_Coverage, 4735,
     /* 112402 */     GIR_EraseRootFromParent_Done,
     /* 112403 */   // Label 1653: @112403
     /* 112403 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(112535), // Rule ID 4767 //
     /* 112408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 112411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 112419 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112423 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 112427 */     // MIs[1] Operand 1
     /* 112427 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 112432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112434 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 112434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 112441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112446 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112450 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112456 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 112459 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112463 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112468 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 112471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 112473 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 112476 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 112480 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112485 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 112488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 112490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112502 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 112522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 112530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 112533 */     GIR_RootConstrainSelectedInstOperands,
     /* 112534 */     // GIR_Coverage, 4767,
     /* 112534 */     GIR_EraseRootFromParent_Done,
     /* 112535 */   // Label 1654: @112535
     /* 112535 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(112627), // Rule ID 2987 //
     /* 112540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112559 */     // MIs[1] Operand 1
     /* 112559 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 112564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112566 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112578 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112582 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112600 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112625 */     GIR_RootConstrainSelectedInstOperands,
     /* 112626 */     // GIR_Coverage, 2987,
     /* 112626 */     GIR_EraseRootFromParent_Done,
     /* 112627 */   // Label 1655: @112627
     /* 112627 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(112719), // Rule ID 3001 //
     /* 112632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112647 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112651 */     // MIs[1] Operand 1
     /* 112651 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 112656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112658 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 112658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112670 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112692 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 112699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112717 */     GIR_RootConstrainSelectedInstOperands,
     /* 112718 */     // GIR_Coverage, 3001,
     /* 112718 */     GIR_EraseRootFromParent_Done,
     /* 112719 */   // Label 1656: @112719
     /* 112719 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(112811), // Rule ID 3009 //
     /* 112724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112743 */     // MIs[1] Operand 1
     /* 112743 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 112748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112750 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 112757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112762 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112784 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112809 */     GIR_RootConstrainSelectedInstOperands,
     /* 112810 */     // GIR_Coverage, 3009,
     /* 112810 */     GIR_EraseRootFromParent_Done,
     /* 112811 */   // Label 1657: @112811
     /* 112811 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(112903), // Rule ID 3017 //
     /* 112816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112831 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112835 */     // MIs[1] Operand 1
     /* 112835 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 112840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112842 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 112842 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112845 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112849 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112854 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112876 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 112883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112901 */     GIR_RootConstrainSelectedInstOperands,
     /* 112902 */     // GIR_Coverage, 3017,
     /* 112902 */     GIR_EraseRootFromParent_Done,
     /* 112903 */   // Label 1658: @112903
     /* 112903 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(112995), // Rule ID 3025 //
     /* 112908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 112911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 112919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 112923 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 112927 */     // MIs[1] Operand 1
     /* 112927 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 112932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112934 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 112934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 112937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 112941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 112950 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 112954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 112959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112968 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 112975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 112980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 112985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 112988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 112990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112993 */     GIR_RootConstrainSelectedInstOperands,
     /* 112994 */     // GIR_Coverage, 3025,
     /* 112994 */     GIR_EraseRootFromParent_Done,
     /* 112995 */   // Label 1659: @112995
     /* 112995 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(113087), // Rule ID 3089 //
     /* 113000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113015 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113019 */     // MIs[1] Operand 1
     /* 113019 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113026 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 113026 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113029 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 113033 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113038 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113042 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113060 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113085 */     GIR_RootConstrainSelectedInstOperands,
     /* 113086 */     // GIR_Coverage, 3089,
     /* 113086 */     GIR_EraseRootFromParent_Done,
     /* 113087 */   // Label 1660: @113087
     /* 113087 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(113179), // Rule ID 3097 //
     /* 113092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113107 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113111 */     // MIs[1] Operand 1
     /* 113111 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113118 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 113118 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113121 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113125 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113130 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113134 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113152 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113177 */     GIR_RootConstrainSelectedInstOperands,
     /* 113178 */     // GIR_Coverage, 3097,
     /* 113178 */     GIR_EraseRootFromParent_Done,
     /* 113179 */   // Label 1661: @113179
     /* 113179 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(113271), // Rule ID 3105 //
     /* 113184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113199 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113203 */     // MIs[1] Operand 1
     /* 113203 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 113208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113210 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 113210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 113217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113222 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113244 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113269 */     GIR_RootConstrainSelectedInstOperands,
     /* 113270 */     // GIR_Coverage, 3105,
     /* 113270 */     GIR_EraseRootFromParent_Done,
     /* 113271 */   // Label 1662: @113271
     /* 113271 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(113363), // Rule ID 3113 //
     /* 113276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113295 */     // MIs[1] Operand 1
     /* 113295 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113302 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 113302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113314 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113336 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113361 */     GIR_RootConstrainSelectedInstOperands,
     /* 113362 */     // GIR_Coverage, 3113,
     /* 113362 */     GIR_EraseRootFromParent_Done,
     /* 113363 */   // Label 1663: @113363
     /* 113363 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(113455), // Rule ID 3121 //
     /* 113368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 113371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113383 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 113387 */     // MIs[1] Operand 1
     /* 113387 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 113392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113394 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 113394 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113397 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 113401 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113406 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113410 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113428 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 113435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 113448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 113450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113453 */     GIR_RootConstrainSelectedInstOperands,
     /* 113454 */     // GIR_Coverage, 3121,
     /* 113454 */     GIR_EraseRootFromParent_Done,
     /* 113455 */   // Label 1664: @113455
     /* 113455 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(113587), // Rule ID 3872 //
     /* 113460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113479 */     // MIs[1] Operand 1
     /* 113479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 113484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113486 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113486 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113493 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113498 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113502 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113508 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113511 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113515 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113520 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113523 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113525 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113528 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113532 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113537 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113554 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113585 */     GIR_RootConstrainSelectedInstOperands,
     /* 113586 */     // GIR_Coverage, 3872,
     /* 113586 */     GIR_EraseRootFromParent_Done,
     /* 113587 */   // Label 1665: @113587
     /* 113587 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(113719), // Rule ID 3880 //
     /* 113592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113607 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113611 */     // MIs[1] Operand 1
     /* 113611 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 113616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113618 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113618 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113621 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113625 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113630 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113640 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113643 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113647 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113652 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113657 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113660 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113664 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113669 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113686 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 113693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113717 */     GIR_RootConstrainSelectedInstOperands,
     /* 113718 */     // GIR_Coverage, 3880,
     /* 113718 */     GIR_EraseRootFromParent_Done,
     /* 113719 */   // Label 1666: @113719
     /* 113719 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(113851), // Rule ID 3888 //
     /* 113724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113739 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113743 */     // MIs[1] Operand 1
     /* 113743 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 113748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113750 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113750 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113753 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 113757 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113762 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113766 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113772 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113775 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113779 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113784 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113789 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113792 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113796 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113801 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113818 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113825 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113849 */     GIR_RootConstrainSelectedInstOperands,
     /* 113850 */     // GIR_Coverage, 3888,
     /* 113850 */     GIR_EraseRootFromParent_Done,
     /* 113851 */   // Label 1667: @113851
     /* 113851 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(113983), // Rule ID 3896 //
     /* 113856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113875 */     // MIs[1] Operand 1
     /* 113875 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 113880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113882 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 113882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 113885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 113889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 113898 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 113902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113904 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 113907 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113911 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113916 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 113919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 113921 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 113924 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 113928 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113933 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 113936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 113938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 113941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113950 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 113957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 113962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 113967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 113970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 113972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 113978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 113981 */     GIR_RootConstrainSelectedInstOperands,
     /* 113982 */     // GIR_Coverage, 3896,
     /* 113982 */     GIR_EraseRootFromParent_Done,
     /* 113983 */   // Label 1668: @113983
     /* 113983 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(114115), // Rule ID 3904 //
     /* 113988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 113991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 113999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114003 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 114007 */     // MIs[1] Operand 1
     /* 114007 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 114012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114014 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 114021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114026 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114030 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114036 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114039 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114043 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114048 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114053 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114056 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114060 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114065 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114082 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114113 */     GIR_RootConstrainSelectedInstOperands,
     /* 114114 */     // GIR_Coverage, 3904,
     /* 114114 */     GIR_EraseRootFromParent_Done,
     /* 114115 */   // Label 1669: @114115
     /* 114115 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(114247), // Rule ID 3968 //
     /* 114120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114135 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114139 */     // MIs[1] Operand 1
     /* 114139 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 114144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114146 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114146 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114149 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 114153 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114162 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114168 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114171 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114175 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114180 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114185 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114188 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114192 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114197 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114214 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114245 */     GIR_RootConstrainSelectedInstOperands,
     /* 114246 */     // GIR_Coverage, 3968,
     /* 114246 */     GIR_EraseRootFromParent_Done,
     /* 114247 */   // Label 1670: @114247
     /* 114247 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(114379), // Rule ID 3976 //
     /* 114252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114271 */     // MIs[1] Operand 1
     /* 114271 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 114276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114278 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114278 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114281 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114285 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114290 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114294 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114300 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114303 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114307 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114312 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114317 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114320 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114324 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114329 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114346 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 114353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114377 */     GIR_RootConstrainSelectedInstOperands,
     /* 114378 */     // GIR_Coverage, 3976,
     /* 114378 */     GIR_EraseRootFromParent_Done,
     /* 114379 */   // Label 1671: @114379
     /* 114379 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(114511), // Rule ID 3984 //
     /* 114384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114399 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114403 */     // MIs[1] Operand 1
     /* 114403 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 114408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114410 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114410 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114413 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 114417 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114422 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114426 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114432 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114435 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114439 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114444 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114449 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114452 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114456 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114461 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114478 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114509 */     GIR_RootConstrainSelectedInstOperands,
     /* 114510 */     // GIR_Coverage, 3984,
     /* 114510 */     GIR_EraseRootFromParent_Done,
     /* 114511 */   // Label 1672: @114511
     /* 114511 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(114643), // Rule ID 3992 //
     /* 114516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114531 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114535 */     // MIs[1] Operand 1
     /* 114535 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 114540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114542 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114542 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114545 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114549 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114558 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114564 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114567 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114571 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114576 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114581 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114584 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114588 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114593 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114610 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 114617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114622 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114641 */     GIR_RootConstrainSelectedInstOperands,
     /* 114642 */     // GIR_Coverage, 3992,
     /* 114642 */     GIR_EraseRootFromParent_Done,
     /* 114643 */   // Label 1673: @114643
     /* 114643 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(114775), // Rule ID 4000 //
     /* 114648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 114651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 114659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114663 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114667 */     // MIs[1] Operand 1
     /* 114667 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 114672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114674 */     // (anyext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 114674 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 114677 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 114681 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114686 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 114690 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 114694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114696 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 114699 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114703 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114708 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 114711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 114713 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 114716 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114720 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114725 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 114728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 114730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 114733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114742 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 114749 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114754 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 114759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 114770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 114773 */     GIR_RootConstrainSelectedInstOperands,
     /* 114774 */     // GIR_Coverage, 4000,
     /* 114774 */     GIR_EraseRootFromParent_Done,
     /* 114775 */   // Label 1674: @114775
     /* 114775 */   GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(114790), // Rule ID 2993 //
     /* 114780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 114783 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 114783 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 114788 */     GIR_RootConstrainSelectedInstOperands,
     /* 114789 */     // GIR_Coverage, 2993,
     /* 114789 */     GIR_Done,
     /* 114790 */   // Label 1675: @114790
     /* 114790 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(114844), // Rule ID 3678 //
     /* 114795 */     // (anyext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 114795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114807 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 114810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 114815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 114819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 114827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 114832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114834 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 114836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114842 */     GIR_RootConstrainSelectedInstOperands,
     /* 114843 */     // GIR_Coverage, 3678,
     /* 114843 */     GIR_EraseRootFromParent_Done,
     /* 114844 */   // Label 1676: @114844
     /* 114844 */   GIM_Reject,
     /* 114845 */ // Label 1584: @114845
     /* 114845 */ GIM_Reject,
     /* 114846 */ // Label 1490: @114846
     /* 114846 */ GIM_Reject,
     /* 114847 */ // Label 22: @114847
     /* 114847 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(115032),
     /* 114852 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 114855 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1680*/ GIMT_Encode4(114966),
     /* 114866 */   /*GILLT_s32*//*Label 1678*/ GIMT_Encode4(114874),
     /* 114870 */   /*GILLT_s64*//*Label 1679*/ GIMT_Encode4(114920),
     /* 114874 */   // Label 1678: @114874
     /* 114874 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(114919), // Rule ID 1174 //
     /* 114879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 114895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 114899 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114905 */     // (trunc:{ *:[i1] } (xor:{ *:[i32] } i32:{ *:[i32] }:$in, -1:{ *:[i32] }))  =>  (ANDI_rec_1_EQ_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT),
     /* 114908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114917 */     GIR_RootConstrainSelectedInstOperands,
     /* 114918 */     // GIR_Coverage, 1174,
     /* 114918 */     GIR_EraseRootFromParent_Done,
     /* 114919 */   // Label 1681: @114919
     /* 114919 */   GIM_Reject,
     /* 114920 */   // Label 1679: @114920
     /* 114920 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(114965), // Rule ID 1176 //
     /* 114925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 114937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114945 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 114949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114951 */     // (trunc:{ *:[i1] } (xor:{ *:[i64] } i64:{ *:[i64] }:$in, -1:{ *:[i64] }))  =>  (ANDI_rec_1_EQ_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 114951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_EQ_BIT8),
     /* 114954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // in
     /* 114960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CR0*/0,
     /* 114963 */     GIR_RootConstrainSelectedInstOperands,
     /* 114964 */     // GIR_Coverage, 1176,
     /* 114964 */     GIR_EraseRootFromParent_Done,
     /* 114965 */   // Label 1682: @114965
     /* 114965 */   GIM_Reject,
     /* 114966 */   // Label 1680: @114966
     /* 114966 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1685*/ GIMT_Encode4(115031),
     /* 114977 */   /*GILLT_s32*//*Label 1683*/ GIMT_Encode4(114985),
     /* 114981 */   /*GILLT_s64*//*Label 1684*/ GIMT_Encode4(115008),
     /* 114985 */   // Label 1683: @114985
     /* 114985 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(115007), // Rule ID 1175 //
     /* 114990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 114994 */     // (trunc:{ *:[i1] } i32:{ *:[i32] }:$in)  =>  (ANDI_rec_1_GT_BIT:{ *:[i1] }:{ *:[i32] } i32:{ *:[i32] }:$in)
     /* 114994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT),
     /* 114999 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 115005 */     GIR_RootConstrainSelectedInstOperands,
     /* 115006 */     // GIR_Coverage, 1175,
     /* 115006 */     GIR_Done,
     /* 115007 */   // Label 1686: @115007
     /* 115007 */   GIM_Reject,
     /* 115008 */   // Label 1684: @115008
     /* 115008 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(115030), // Rule ID 1177 //
     /* 115013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115017 */     // (trunc:{ *:[i1] } i64:{ *:[i64] }:$in)  =>  (ANDI_rec_1_GT_BIT8:{ *:[i1] }:{ *:[i32] } i64:{ *:[i64] }:$in)
     /* 115017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::ANDI_rec_1_GT_BIT8),
     /* 115022 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CR0), GIMT_Encode2(RegState::Dead),
     /* 115028 */     GIR_RootConstrainSelectedInstOperands,
     /* 115029 */     // GIR_Coverage, 1177,
     /* 115029 */     GIR_Done,
     /* 115030 */   // Label 1687: @115030
     /* 115030 */   GIM_Reject,
     /* 115031 */   // Label 1685: @115031
     /* 115031 */   GIM_Reject,
     /* 115032 */ // Label 1677: @115032
     /* 115032 */ GIM_Reject,
     /* 115033 */ // Label 23: @115033
     /* 115033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 1691*/ GIMT_Encode4(115184),
     /* 115044 */ /*GILLT_s1*//*Label 1688*/ GIMT_Encode4(115056),
     /* 115048 */ /*GILLT_s32*//*Label 1689*/ GIMT_Encode4(115136),
     /* 115052 */ /*GILLT_s64*//*Label 1690*/ GIMT_Encode4(115160),
     /* 115056 */ // Label 1688: @115056
     /* 115056 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(115135),
     /* 115061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115065 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(115088), // Rule ID 184 //
     /* 115070 */     // MIs[0] Operand 1
     /* 115070 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(1),
     /* 115081 */     // 1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 115081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 115084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 115086 */     GIR_RootConstrainSelectedInstOperands,
     /* 115087 */     // GIR_Coverage, 184,
     /* 115087 */     GIR_EraseRootFromParent_Done,
     /* 115088 */   // Label 1693: @115088
     /* 115088 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(115111), // Rule ID 185 //
     /* 115093 */     // MIs[0] Operand 1
     /* 115093 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(0),
     /* 115104 */     // 0:{ *:[i1] }  =>  (CRUNSET:{ *:[i1] })
     /* 115104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRUNSET),
     /* 115107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 115109 */     GIR_RootConstrainSelectedInstOperands,
     /* 115110 */     // GIR_Coverage, 185,
     /* 115110 */     GIR_EraseRootFromParent_Done,
     /* 115111 */   // Label 1694: @115111
     /* 115111 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(115134), // Rule ID 3672 //
     /* 115116 */     // MIs[0] Operand 1
     /* 115116 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/1, GIMT_Encode8(-1),
     /* 115127 */     // -1:{ *:[i1] }  =>  (CRSET:{ *:[i1] })
     /* 115127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRSET),
     /* 115130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 115132 */     GIR_RootConstrainSelectedInstOperands,
     /* 115133 */     // GIR_Coverage, 3672,
     /* 115133 */     GIR_EraseRootFromParent_Done,
     /* 115134 */   // Label 1695: @115134
     /* 115134 */   GIM_Reject,
     /* 115135 */ // Label 1692: @115135
     /* 115135 */ GIM_Reject,
     /* 115136 */ // Label 1689: @115136
     /* 115136 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(115159), // Rule ID 113 //
     /* 115141 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 115149 */   // MIs[0] Operand 1
     /* 115149 */   // No operand predicates
     /* 115149 */   // (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$D  =>  (LI:{ *:[i32] } (imm:{ *:[i32] }):$D)
     /* 115149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115154 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 115157 */   GIR_RootConstrainSelectedInstOperands,
     /* 115158 */   // GIR_Coverage, 113,
     /* 115158 */   GIR_EraseRootFromParent_Done,
     /* 115159 */ // Label 1696: @115159
     /* 115159 */ GIM_Reject,
     /* 115160 */ // Label 1690: @115160
     /* 115160 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(115183), // Rule ID 643 //
     /* 115165 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 115173 */   // MIs[0] Operand 1
     /* 115173 */   // No operand predicates
     /* 115173 */   // (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$D  =>  (LI8:{ *:[i64] } (imm:{ *:[i64] }):$D)
     /* 115173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 115176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115178 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // D
     /* 115181 */   GIR_RootConstrainSelectedInstOperands,
     /* 115182 */   // GIR_Coverage, 643,
     /* 115182 */   GIR_EraseRootFromParent_Done,
     /* 115183 */ // Label 1697: @115183
     /* 115183 */ GIM_Reject,
     /* 115184 */ // Label 1691: @115184
     /* 115184 */ GIM_Reject,
     /* 115185 */ // Label 24: @115185
     /* 115185 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1700*/ GIMT_Encode4(130216),
     /* 115196 */ /*GILLT_s32*//*Label 1698*/ GIMT_Encode4(115204),
     /* 115200 */ /*GILLT_s64*//*Label 1699*/ GIMT_Encode4(122483),
     /* 115204 */ // Label 1698: @115204
     /* 115204 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(122482),
     /* 115209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 115212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 115216 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(115319), // Rule ID 3038 //
     /* 115221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115236 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115240 */     // MIs[1] Operand 1
     /* 115240 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115245 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115249 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115253 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115257 */     // MIs[2] Operand 1
     /* 115257 */     // No operand predicates
     /* 115257 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115259 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 115259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115292 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115304 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115317 */     GIR_RootConstrainSelectedInstOperands,
     /* 115318 */     // GIR_Coverage, 3038,
     /* 115318 */     GIR_EraseRootFromParent_Done,
     /* 115319 */   // Label 1702: @115319
     /* 115319 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(115422), // Rule ID 3054 //
     /* 115324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115339 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115343 */     // MIs[1] Operand 1
     /* 115343 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115360 */     // MIs[2] Operand 1
     /* 115360 */     // No operand predicates
     /* 115360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115362 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 115362 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115365 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115369 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115395 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115420 */     GIR_RootConstrainSelectedInstOperands,
     /* 115421 */     // GIR_Coverage, 3054,
     /* 115421 */     GIR_EraseRootFromParent_Done,
     /* 115422 */   // Label 1703: @115422
     /* 115422 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(115525), // Rule ID 3062 //
     /* 115427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115442 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115446 */     // MIs[1] Operand 1
     /* 115446 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115459 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115463 */     // MIs[2] Operand 1
     /* 115463 */     // No operand predicates
     /* 115463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115465 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 115465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115477 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115498 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115523 */     GIR_RootConstrainSelectedInstOperands,
     /* 115524 */     // GIR_Coverage, 3062,
     /* 115524 */     GIR_EraseRootFromParent_Done,
     /* 115525 */   // Label 1704: @115525
     /* 115525 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(115628), // Rule ID 3134 //
     /* 115530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115545 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115549 */     // MIs[1] Operand 1
     /* 115549 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115562 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115566 */     // MIs[2] Operand 1
     /* 115566 */     // No operand predicates
     /* 115566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115568 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 115568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115601 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115626 */     GIR_RootConstrainSelectedInstOperands,
     /* 115627 */     // GIR_Coverage, 3134,
     /* 115627 */     GIR_EraseRootFromParent_Done,
     /* 115628 */   // Label 1705: @115628
     /* 115628 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(115731), // Rule ID 3150 //
     /* 115633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115644 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115648 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115652 */     // MIs[1] Operand 1
     /* 115652 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 115657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115665 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115669 */     // MIs[2] Operand 1
     /* 115669 */     // No operand predicates
     /* 115669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115671 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 115671 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115674 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115678 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115683 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115704 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 115711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115716 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115729 */     GIR_RootConstrainSelectedInstOperands,
     /* 115730 */     // GIR_Coverage, 3150,
     /* 115730 */     GIR_EraseRootFromParent_Done,
     /* 115731 */   // Label 1706: @115731
     /* 115731 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(115834), // Rule ID 3158 //
     /* 115736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 115739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115751 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 115755 */     // MIs[1] Operand 1
     /* 115755 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 115760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115768 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 115772 */     // MIs[2] Operand 1
     /* 115772 */     // No operand predicates
     /* 115772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115774 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 115774 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115777 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 115781 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115786 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115807 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 115814 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 115827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 115829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115832 */     GIR_RootConstrainSelectedInstOperands,
     /* 115833 */     // GIR_Coverage, 3158,
     /* 115833 */     GIR_EraseRootFromParent_Done,
     /* 115834 */   // Label 1707: @115834
     /* 115834 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(115977), // Rule ID 3820 //
     /* 115839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115854 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 115858 */     // MIs[1] Operand 1
     /* 115858 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 115863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 115867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115871 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 115875 */     // MIs[2] Operand 1
     /* 115875 */     // No operand predicates
     /* 115875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115877 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 115877 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115880 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 115884 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115889 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 115893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 115896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115898 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 115901 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115905 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115910 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 115913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 115915 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 115918 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 115922 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115927 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 115930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 115932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 115935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115944 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 115951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 115956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 115961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 115964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 115972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 115975 */     GIR_RootConstrainSelectedInstOperands,
     /* 115976 */     // GIR_Coverage, 3820,
     /* 115976 */     GIR_EraseRootFromParent_Done,
     /* 115977 */   // Label 1708: @115977
     /* 115977 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(116120), // Rule ID 3836 //
     /* 115982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 115985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 115993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 115997 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116001 */     // MIs[1] Operand 1
     /* 116001 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 116006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 116018 */     // MIs[2] Operand 1
     /* 116018 */     // No operand predicates
     /* 116018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116020 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116020 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116023 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 116027 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116032 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116041 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116044 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116048 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116053 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116058 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116061 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116065 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116070 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116087 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116099 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116118 */     GIR_RootConstrainSelectedInstOperands,
     /* 116119 */     // GIR_Coverage, 3836,
     /* 116119 */     GIR_EraseRootFromParent_Done,
     /* 116120 */   // Label 1709: @116120
     /* 116120 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(116263), // Rule ID 3844 //
     /* 116125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116140 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116144 */     // MIs[1] Operand 1
     /* 116144 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 116149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116157 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 116161 */     // MIs[2] Operand 1
     /* 116161 */     // No operand predicates
     /* 116161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116163 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 116170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116175 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116184 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116187 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116191 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116196 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116201 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116204 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116208 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116213 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116230 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116237 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116261 */     GIR_RootConstrainSelectedInstOperands,
     /* 116262 */     // GIR_Coverage, 3844,
     /* 116262 */     GIR_EraseRootFromParent_Done,
     /* 116263 */   // Label 1710: @116263
     /* 116263 */   GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(116406), // Rule ID 3916 //
     /* 116268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116283 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116287 */     // MIs[1] Operand 1
     /* 116287 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 116292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116300 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116304 */     // MIs[2] Operand 1
     /* 116304 */     // No operand predicates
     /* 116304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116306 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116318 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116327 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116330 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116334 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116339 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116344 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116347 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116351 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116356 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116373 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116404 */     GIR_RootConstrainSelectedInstOperands,
     /* 116405 */     // GIR_Coverage, 3916,
     /* 116405 */     GIR_EraseRootFromParent_Done,
     /* 116406 */   // Label 1711: @116406
     /* 116406 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(116549), // Rule ID 3932 //
     /* 116411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116426 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116430 */     // MIs[1] Operand 1
     /* 116430 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 116435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116443 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116447 */     // MIs[2] Operand 1
     /* 116447 */     // No operand predicates
     /* 116447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116449 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116449 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116452 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116456 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116461 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116470 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116473 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116477 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116482 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116487 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116490 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116494 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116499 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116516 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116547 */     GIR_RootConstrainSelectedInstOperands,
     /* 116548 */     // GIR_Coverage, 3932,
     /* 116548 */     GIR_EraseRootFromParent_Done,
     /* 116549 */   // Label 1712: @116549
     /* 116549 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(116692), // Rule ID 3940 //
     /* 116554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 116557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 116565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116569 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 116573 */     // MIs[1] Operand 1
     /* 116573 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 116578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 116582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116586 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 116590 */     // MIs[2] Operand 1
     /* 116590 */     // No operand predicates
     /* 116590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116592 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 116592 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116595 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 116599 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116604 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 116611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116613 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 116616 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116620 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116625 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 116628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 116633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 116637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116642 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 116645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116659 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 116679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 116687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 116690 */     GIR_RootConstrainSelectedInstOperands,
     /* 116691 */     // GIR_Coverage, 3940,
     /* 116691 */     GIR_EraseRootFromParent_Done,
     /* 116692 */   // Label 1713: @116692
     /* 116692 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(116784), // Rule ID 3182 //
     /* 116697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116712 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116716 */     // MIs[1] Operand 1
     /* 116716 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 116721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116723 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 116723 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116726 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116730 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116735 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116739 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116757 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 116764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116782 */     GIR_RootConstrainSelectedInstOperands,
     /* 116783 */     // GIR_Coverage, 3182,
     /* 116783 */     GIR_EraseRootFromParent_Done,
     /* 116784 */   // Label 1714: @116784
     /* 116784 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(116876), // Rule ID 3198 //
     /* 116789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116804 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116808 */     // MIs[1] Operand 1
     /* 116808 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 116813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116815 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 116815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116827 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116831 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116849 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 116856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116874 */     GIR_RootConstrainSelectedInstOperands,
     /* 116875 */     // GIR_Coverage, 3198,
     /* 116875 */     GIR_EraseRootFromParent_Done,
     /* 116876 */   // Label 1715: @116876
     /* 116876 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(116968), // Rule ID 3214 //
     /* 116881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116900 */     // MIs[1] Operand 1
     /* 116900 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 116905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116907 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 116907 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 116910 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 116914 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116919 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 116923 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 116927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 116932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116941 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 116948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 116953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 116958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 116961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 116963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116966 */     GIR_RootConstrainSelectedInstOperands,
     /* 116967 */     // GIR_Coverage, 3214,
     /* 116967 */     GIR_EraseRootFromParent_Done,
     /* 116968 */   // Label 1716: @116968
     /* 116968 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(117060), // Rule ID 3230 //
     /* 116973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 116976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 116984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 116988 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 116992 */     // MIs[1] Operand 1
     /* 116992 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 116997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116999 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 116999 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117002 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117006 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117011 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117015 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117033 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117058 */     GIR_RootConstrainSelectedInstOperands,
     /* 117059 */     // GIR_Coverage, 3230,
     /* 117059 */     GIR_EraseRootFromParent_Done,
     /* 117060 */   // Label 1717: @117060
     /* 117060 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(117152), // Rule ID 3238 //
     /* 117065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117080 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117084 */     // MIs[1] Operand 1
     /* 117084 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117091 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 117091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117103 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117125 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117150 */     GIR_RootConstrainSelectedInstOperands,
     /* 117151 */     // GIR_Coverage, 3238,
     /* 117151 */     GIR_EraseRootFromParent_Done,
     /* 117152 */   // Label 1718: @117152
     /* 117152 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(117244), // Rule ID 3254 //
     /* 117157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117172 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117176 */     // MIs[1] Operand 1
     /* 117176 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117183 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 117183 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117186 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117190 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117199 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117217 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117242 */     GIR_RootConstrainSelectedInstOperands,
     /* 117243 */     // GIR_Coverage, 3254,
     /* 117243 */     GIR_EraseRootFromParent_Done,
     /* 117244 */   // Label 1719: @117244
     /* 117244 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(117336), // Rule ID 3270 //
     /* 117249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117264 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117268 */     // MIs[1] Operand 1
     /* 117268 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117275 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 117275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117287 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117309 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117321 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117334 */     GIR_RootConstrainSelectedInstOperands,
     /* 117335 */     // GIR_Coverage, 3270,
     /* 117335 */     GIR_EraseRootFromParent_Done,
     /* 117336 */   // Label 1720: @117336
     /* 117336 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(117428), // Rule ID 3286 //
     /* 117341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 117356 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 117360 */     // MIs[1] Operand 1
     /* 117360 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117367 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 117367 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117370 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 117374 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117383 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117401 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117426 */     GIR_RootConstrainSelectedInstOperands,
     /* 117427 */     // GIR_Coverage, 3286,
     /* 117427 */     GIR_EraseRootFromParent_Done,
     /* 117428 */   // Label 1721: @117428
     /* 117428 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(117520), // Rule ID 3294 //
     /* 117433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117448 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117452 */     // MIs[1] Operand 1
     /* 117452 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117459 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 117459 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117462 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117466 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117471 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117475 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117479 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117493 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117505 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117518 */     GIR_RootConstrainSelectedInstOperands,
     /* 117519 */     // GIR_Coverage, 3294,
     /* 117519 */     GIR_EraseRootFromParent_Done,
     /* 117520 */   // Label 1722: @117520
     /* 117520 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(117612), // Rule ID 3310 //
     /* 117525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117540 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117544 */     // MIs[1] Operand 1
     /* 117544 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117551 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 117551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117563 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117585 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 117592 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117610 */     GIR_RootConstrainSelectedInstOperands,
     /* 117611 */     // GIR_Coverage, 3310,
     /* 117611 */     GIR_EraseRootFromParent_Done,
     /* 117612 */   // Label 1723: @117612
     /* 117612 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(117704), // Rule ID 3326 //
     /* 117617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117628 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117632 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117636 */     // MIs[1] Operand 1
     /* 117636 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 117641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117643 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 117643 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117646 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117650 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117655 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117659 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117677 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 117684 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117689 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117702 */     GIR_RootConstrainSelectedInstOperands,
     /* 117703 */     // GIR_Coverage, 3326,
     /* 117703 */     GIR_EraseRootFromParent_Done,
     /* 117704 */   // Label 1724: @117704
     /* 117704 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(117796), // Rule ID 3342 //
     /* 117709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 117712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 117724 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 117728 */     // MIs[1] Operand 1
     /* 117728 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 117733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117735 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 117735 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117738 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 117742 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117747 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117751 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117769 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 117776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 117789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 117791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117794 */     GIR_RootConstrainSelectedInstOperands,
     /* 117795 */     // GIR_Coverage, 3342,
     /* 117795 */     GIR_EraseRootFromParent_Done,
     /* 117796 */   // Label 1725: @117796
     /* 117796 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(117928), // Rule ID 4022 //
     /* 117801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117816 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117820 */     // MIs[1] Operand 1
     /* 117820 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 117825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117827 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117827 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117830 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117834 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117839 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117843 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117849 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117852 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117856 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117861 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117866 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 117869 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117873 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117878 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 117881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 117886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117895 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 117902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 117907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 117912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 117915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 117923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 117926 */     GIR_RootConstrainSelectedInstOperands,
     /* 117927 */     // GIR_Coverage, 4022,
     /* 117927 */     GIR_EraseRootFromParent_Done,
     /* 117928 */   // Label 1726: @117928
     /* 117928 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(118060), // Rule ID 4054 //
     /* 117933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 117936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 117944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 117948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 117952 */     // MIs[1] Operand 1
     /* 117952 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 117957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117959 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 117959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 117962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 117966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 117975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 117979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117981 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 117984 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 117988 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117993 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 117996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117998 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118001 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118005 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118010 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118027 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118034 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118058 */     GIR_RootConstrainSelectedInstOperands,
     /* 118059 */     // GIR_Coverage, 4054,
     /* 118059 */     GIR_EraseRootFromParent_Done,
     /* 118060 */   // Label 1727: @118060
     /* 118060 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(118192), // Rule ID 4086 //
     /* 118065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118080 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118084 */     // MIs[1] Operand 1
     /* 118084 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118091 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118091 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118094 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 118098 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118103 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118107 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118113 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118116 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118120 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118125 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118130 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118133 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118137 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118142 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118159 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118190 */     GIR_RootConstrainSelectedInstOperands,
     /* 118191 */     // GIR_Coverage, 4086,
     /* 118191 */     GIR_EraseRootFromParent_Done,
     /* 118192 */   // Label 1728: @118192
     /* 118192 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(118324), // Rule ID 4118 //
     /* 118197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 118212 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 118216 */     // MIs[1] Operand 1
     /* 118216 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118223 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 118230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118235 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118239 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118245 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118248 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118252 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118257 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118262 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118265 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118269 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118274 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118291 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 118298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118322 */     GIR_RootConstrainSelectedInstOperands,
     /* 118323 */     // GIR_Coverage, 4118,
     /* 118323 */     GIR_EraseRootFromParent_Done,
     /* 118324 */   // Label 1729: @118324
     /* 118324 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(118456), // Rule ID 4134 //
     /* 118329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118344 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118348 */     // MIs[1] Operand 1
     /* 118348 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118355 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118355 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118358 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118362 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118371 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118377 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118380 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118384 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118389 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118394 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118397 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118401 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118406 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118423 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118454 */     GIR_RootConstrainSelectedInstOperands,
     /* 118455 */     // GIR_Coverage, 4134,
     /* 118455 */     GIR_EraseRootFromParent_Done,
     /* 118456 */   // Label 1730: @118456
     /* 118456 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(118588), // Rule ID 4166 //
     /* 118461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118476 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118480 */     // MIs[1] Operand 1
     /* 118480 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 118485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118487 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118487 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118490 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118494 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118503 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118509 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118512 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118516 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118521 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118526 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118529 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118533 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118538 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118555 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 118562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118586 */     GIR_RootConstrainSelectedInstOperands,
     /* 118587 */     // GIR_Coverage, 4166,
     /* 118587 */     GIR_EraseRootFromParent_Done,
     /* 118588 */   // Label 1731: @118588
     /* 118588 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(118720), // Rule ID 4198 //
     /* 118593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118608 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118612 */     // MIs[1] Operand 1
     /* 118612 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 118617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118619 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118619 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118622 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118626 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118635 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118641 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118644 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118648 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118653 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118658 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118661 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118665 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118670 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118687 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 118694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118718 */     GIR_RootConstrainSelectedInstOperands,
     /* 118719 */     // GIR_Coverage, 4198,
     /* 118719 */     GIR_EraseRootFromParent_Done,
     /* 118720 */   // Label 1732: @118720
     /* 118720 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(118852), // Rule ID 4230 //
     /* 118725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118740 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 118744 */     // MIs[1] Operand 1
     /* 118744 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 118749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118751 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118751 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118754 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 118758 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118763 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118773 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118776 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118780 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118785 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118802 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118819 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 118826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118850 */     GIR_RootConstrainSelectedInstOperands,
     /* 118851 */     // GIR_Coverage, 4230,
     /* 118851 */     GIR_EraseRootFromParent_Done,
     /* 118852 */   // Label 1733: @118852
     /* 118852 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(118984), // Rule ID 4260 //
     /* 118857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 118868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 118872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 118876 */     // MIs[1] Operand 1
     /* 118876 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 118881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118883 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 118883 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 118886 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 118890 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118895 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 118899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 118903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118905 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118908 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118912 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118917 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 118920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118922 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 118925 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 118929 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118934 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 118937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 118942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118951 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 118958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 118963 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 118968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 118971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 118979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 118982 */     GIR_RootConstrainSelectedInstOperands,
     /* 118983 */     // GIR_Coverage, 4260,
     /* 118983 */     GIR_EraseRootFromParent_Done,
     /* 118984 */   // Label 1734: @118984
     /* 118984 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(119116), // Rule ID 4292 //
     /* 118989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 118992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 118996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 119004 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 119008 */     // MIs[1] Operand 1
     /* 119008 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119015 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 119022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119037 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119040 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119044 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119049 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119054 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119057 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119061 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119066 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119083 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119114 */     GIR_RootConstrainSelectedInstOperands,
     /* 119115 */     // GIR_Coverage, 4292,
     /* 119115 */     GIR_EraseRootFromParent_Done,
     /* 119116 */   // Label 1735: @119116
     /* 119116 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(119248), // Rule ID 4324 //
     /* 119121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 119124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 119136 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 119140 */     // MIs[1] Operand 1
     /* 119140 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119147 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119147 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119150 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 119154 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119159 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119163 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119169 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119172 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119176 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119181 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119186 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119189 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119193 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119198 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119215 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 119222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119246 */     GIR_RootConstrainSelectedInstOperands,
     /* 119247 */     // GIR_Coverage, 4324,
     /* 119247 */     GIR_EraseRootFromParent_Done,
     /* 119248 */   // Label 1736: @119248
     /* 119248 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(119380), // Rule ID 4356 //
     /* 119253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 119256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 119268 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 119272 */     // MIs[1] Operand 1
     /* 119272 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 119277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119279 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119279 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119282 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 119286 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119291 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119295 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119301 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119304 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119308 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119313 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119330 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119347 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 119354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119359 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119378 */     GIR_RootConstrainSelectedInstOperands,
     /* 119379 */     // GIR_Coverage, 4356,
     /* 119379 */     GIR_EraseRootFromParent_Done,
     /* 119380 */   // Label 1737: @119380
     /* 119380 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(119512), // Rule ID 4587 //
     /* 119385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119400 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119404 */     // MIs[1] Operand 1
     /* 119404 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119411 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119411 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119414 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 119418 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119423 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119433 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119436 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119440 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119445 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119450 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119453 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119457 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119462 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119479 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119486 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119491 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119510 */     GIR_RootConstrainSelectedInstOperands,
     /* 119511 */     // GIR_Coverage, 4587,
     /* 119511 */     GIR_EraseRootFromParent_Done,
     /* 119512 */   // Label 1738: @119512
     /* 119512 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(119644), // Rule ID 4619 //
     /* 119517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119532 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119536 */     // MIs[1] Operand 1
     /* 119536 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119543 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 119550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119555 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119559 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119565 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119568 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119572 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119577 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119582 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119585 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119589 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119594 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119611 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119642 */     GIR_RootConstrainSelectedInstOperands,
     /* 119643 */     // GIR_Coverage, 4619,
     /* 119643 */     GIR_EraseRootFromParent_Done,
     /* 119644 */   // Label 1739: @119644
     /* 119644 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(119776), // Rule ID 4651 //
     /* 119649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 119664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 119668 */     // MIs[1] Operand 1
     /* 119668 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 119673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119675 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119675 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119678 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 119682 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119687 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119691 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119697 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119700 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119704 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119709 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119714 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119717 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119721 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119726 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119743 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119750 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119774 */     GIR_RootConstrainSelectedInstOperands,
     /* 119775 */     // GIR_Coverage, 4651,
     /* 119775 */     GIR_EraseRootFromParent_Done,
     /* 119776 */   // Label 1740: @119776
     /* 119776 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(119908), // Rule ID 4695 //
     /* 119781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119796 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119800 */     // MIs[1] Operand 1
     /* 119800 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 119805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119807 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119807 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119810 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 119814 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119823 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119829 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119832 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119836 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119841 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119846 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119849 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119853 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119858 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119875 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 119882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 119887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 119892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 119895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 119903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 119906 */     GIR_RootConstrainSelectedInstOperands,
     /* 119907 */     // GIR_Coverage, 4695,
     /* 119907 */     GIR_EraseRootFromParent_Done,
     /* 119908 */   // Label 1741: @119908
     /* 119908 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(120040), // Rule ID 4727 //
     /* 119913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 119916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 119924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 119932 */     // MIs[1] Operand 1
     /* 119932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 119937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119939 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 119939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 119942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 119946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 119955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 119959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119961 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 119964 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119968 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119973 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 119976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 119978 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 119981 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 119985 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119990 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 119993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 119995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 119998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120007 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120014 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 120027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120038 */     GIR_RootConstrainSelectedInstOperands,
     /* 120039 */     // GIR_Coverage, 4727,
     /* 120039 */     GIR_EraseRootFromParent_Done,
     /* 120040 */   // Label 1742: @120040
     /* 120040 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(120172), // Rule ID 4759 //
     /* 120045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 120048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 120056 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120060 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120064 */     // MIs[1] Operand 1
     /* 120064 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 120069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120071 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 120071 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120074 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 120078 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120083 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120087 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120093 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 120096 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120100 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120105 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 120108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 120110 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 120113 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 120117 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120122 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 120125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 120127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120139 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 120159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 120161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 120167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 120170 */     GIR_RootConstrainSelectedInstOperands,
     /* 120171 */     // GIR_Coverage, 4759,
     /* 120171 */     GIR_EraseRootFromParent_Done,
     /* 120172 */   // Label 1743: @120172
     /* 120172 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(120264), // Rule ID 2984 //
     /* 120177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120192 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120196 */     // MIs[1] Operand 1
     /* 120196 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120203 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 120203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120237 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120244 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120249 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120262 */     GIR_RootConstrainSelectedInstOperands,
     /* 120263 */     // GIR_Coverage, 2984,
     /* 120263 */     GIR_EraseRootFromParent_Done,
     /* 120264 */   // Label 1744: @120264
     /* 120264 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(120356), // Rule ID 2998 //
     /* 120269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120280 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120284 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120288 */     // MIs[1] Operand 1
     /* 120288 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120295 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 120295 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120298 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120302 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120307 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120329 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120354 */     GIR_RootConstrainSelectedInstOperands,
     /* 120355 */     // GIR_Coverage, 2998,
     /* 120355 */     GIR_EraseRootFromParent_Done,
     /* 120356 */   // Label 1745: @120356
     /* 120356 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(120448), // Rule ID 3006 //
     /* 120361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120380 */     // MIs[1] Operand 1
     /* 120380 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120387 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 120394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120399 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120421 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120446 */     GIR_RootConstrainSelectedInstOperands,
     /* 120447 */     // GIR_Coverage, 3006,
     /* 120447 */     GIR_EraseRootFromParent_Done,
     /* 120448 */   // Label 1746: @120448
     /* 120448 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(120540), // Rule ID 3014 //
     /* 120453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120468 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120472 */     // MIs[1] Operand 1
     /* 120472 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120479 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 120479 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120482 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120486 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120491 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120495 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120513 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120538 */     GIR_RootConstrainSelectedInstOperands,
     /* 120539 */     // GIR_Coverage, 3014,
     /* 120539 */     GIR_EraseRootFromParent_Done,
     /* 120540 */   // Label 1747: @120540
     /* 120540 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(120632), // Rule ID 3022 //
     /* 120545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120556 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 120560 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 120564 */     // MIs[1] Operand 1
     /* 120564 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 120569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120571 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 120571 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120574 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 120578 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120583 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120605 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 120612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120630 */     GIR_RootConstrainSelectedInstOperands,
     /* 120631 */     // GIR_Coverage, 3022,
     /* 120631 */     GIR_EraseRootFromParent_Done,
     /* 120632 */   // Label 1748: @120632
     /* 120632 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(120724), // Rule ID 3086 //
     /* 120637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120652 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120656 */     // MIs[1] Operand 1
     /* 120656 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 120661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120663 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120679 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120697 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120709 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120722 */     GIR_RootConstrainSelectedInstOperands,
     /* 120723 */     // GIR_Coverage, 3086,
     /* 120723 */     GIR_EraseRootFromParent_Done,
     /* 120724 */   // Label 1749: @120724
     /* 120724 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(120816), // Rule ID 3094 //
     /* 120729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120744 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120748 */     // MIs[1] Operand 1
     /* 120748 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 120753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120755 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 120755 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120758 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120762 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120767 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120771 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120789 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 120796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120814 */     GIR_RootConstrainSelectedInstOperands,
     /* 120815 */     // GIR_Coverage, 3094,
     /* 120815 */     GIR_EraseRootFromParent_Done,
     /* 120816 */   // Label 1750: @120816
     /* 120816 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(120908), // Rule ID 3102 //
     /* 120821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120836 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120840 */     // MIs[1] Operand 1
     /* 120840 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 120845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120847 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120847 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120850 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 120854 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120863 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120881 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120906 */     GIR_RootConstrainSelectedInstOperands,
     /* 120907 */     // GIR_Coverage, 3102,
     /* 120907 */     GIR_EraseRootFromParent_Done,
     /* 120908 */   // Label 1751: @120908
     /* 120908 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(121000), // Rule ID 3110 //
     /* 120913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 120916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 120924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 120928 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 120932 */     // MIs[1] Operand 1
     /* 120932 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 120937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120939 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 120939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 120942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 120946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 120955 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 120959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 120961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 120964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120973 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 120980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 120985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 120990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 120993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 120995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120998 */     GIR_RootConstrainSelectedInstOperands,
     /* 120999 */     // GIR_Coverage, 3110,
     /* 120999 */     GIR_EraseRootFromParent_Done,
     /* 121000 */   // Label 1752: @121000
     /* 121000 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(121092), // Rule ID 3118 //
     /* 121005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 121008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121020 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121024 */     // MIs[1] Operand 1
     /* 121024 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121031 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 121031 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121034 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121038 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121043 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121047 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121065 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR),
     /* 121085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 121087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121090 */     GIR_RootConstrainSelectedInstOperands,
     /* 121091 */     // GIR_Coverage, 3118,
     /* 121091 */     GIR_EraseRootFromParent_Done,
     /* 121092 */   // Label 1753: @121092
     /* 121092 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(121224), // Rule ID 3868 //
     /* 121097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121112 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121116 */     // MIs[1] Operand 1
     /* 121116 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 121121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121123 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 121130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121135 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121139 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121145 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121148 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121152 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121157 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121162 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121165 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121169 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121174 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121191 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121222 */     GIR_RootConstrainSelectedInstOperands,
     /* 121223 */     // GIR_Coverage, 3868,
     /* 121223 */     GIR_EraseRootFromParent_Done,
     /* 121224 */   // Label 1754: @121224
     /* 121224 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(121356), // Rule ID 3876 //
     /* 121229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121244 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121248 */     // MIs[1] Operand 1
     /* 121248 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 121253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121255 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121267 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121271 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121277 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121280 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121284 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121289 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121294 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121297 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121301 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121306 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121323 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121354 */     GIR_RootConstrainSelectedInstOperands,
     /* 121355 */     // GIR_Coverage, 3876,
     /* 121355 */     GIR_EraseRootFromParent_Done,
     /* 121356 */   // Label 1755: @121356
     /* 121356 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(121488), // Rule ID 3884 //
     /* 121361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121380 */     // MIs[1] Operand 1
     /* 121380 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 121385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121387 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121387 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121390 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 121394 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121399 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121409 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121412 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121416 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121421 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121438 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121455 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121486 */     GIR_RootConstrainSelectedInstOperands,
     /* 121487 */     // GIR_Coverage, 3884,
     /* 121487 */     GIR_EraseRootFromParent_Done,
     /* 121488 */   // Label 1756: @121488
     /* 121488 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(121620), // Rule ID 3892 //
     /* 121493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121508 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121512 */     // MIs[1] Operand 1
     /* 121512 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 121517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121519 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121531 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121535 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121541 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121544 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121548 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121553 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121570 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121587 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 121594 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121599 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121618 */     GIR_RootConstrainSelectedInstOperands,
     /* 121619 */     // GIR_Coverage, 3892,
     /* 121619 */     GIR_EraseRootFromParent_Done,
     /* 121620 */   // Label 1757: @121620
     /* 121620 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(121752), // Rule ID 3900 //
     /* 121625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 121640 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 121644 */     // MIs[1] Operand 1
     /* 121644 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 121649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121651 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 121658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121663 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121667 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121673 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121676 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121680 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121685 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121690 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121693 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121697 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121702 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121719 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 121726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121750 */     GIR_RootConstrainSelectedInstOperands,
     /* 121751 */     // GIR_Coverage, 3900,
     /* 121751 */     GIR_EraseRootFromParent_Done,
     /* 121752 */   // Label 1758: @121752
     /* 121752 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(121884), // Rule ID 3964 //
     /* 121757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121772 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121776 */     // MIs[1] Operand 1
     /* 121776 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 121781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121783 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 121790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121805 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121808 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121812 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121817 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121822 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121825 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121829 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121834 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121851 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121858 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121863 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 121868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 121871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 121879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 121882 */     GIR_RootConstrainSelectedInstOperands,
     /* 121883 */     // GIR_Coverage, 3964,
     /* 121883 */     GIR_EraseRootFromParent_Done,
     /* 121884 */   // Label 1759: @121884
     /* 121884 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(122016), // Rule ID 3972 //
     /* 121889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 121892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 121900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121904 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 121908 */     // MIs[1] Operand 1
     /* 121908 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 121913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121915 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 121915 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 121918 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 121922 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 121931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 121935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121937 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 121940 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121944 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121949 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 121952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 121954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 121957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 121961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121966 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 121969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 121971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 121974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121983 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 121990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 121995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122014 */     GIR_RootConstrainSelectedInstOperands,
     /* 122015 */     // GIR_Coverage, 3972,
     /* 122015 */     GIR_EraseRootFromParent_Done,
     /* 122016 */   // Label 1760: @122016
     /* 122016 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(122148), // Rule ID 3980 //
     /* 122021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122036 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122040 */     // MIs[1] Operand 1
     /* 122040 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 122045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122047 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122047 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122050 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 122054 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122063 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122069 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122072 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122076 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122081 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122086 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122089 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122093 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122098 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122115 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122146 */     GIR_RootConstrainSelectedInstOperands,
     /* 122147 */     // GIR_Coverage, 3980,
     /* 122147 */     GIR_EraseRootFromParent_Done,
     /* 122148 */   // Label 1761: @122148
     /* 122148 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(122280), // Rule ID 3988 //
     /* 122153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122168 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122172 */     // MIs[1] Operand 1
     /* 122172 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122179 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122179 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122182 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 122186 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122191 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122201 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122204 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122208 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122213 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122218 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122221 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122225 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122230 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122247 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122254 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122278 */     GIR_RootConstrainSelectedInstOperands,
     /* 122279 */     // GIR_Coverage, 3988,
     /* 122279 */     GIR_EraseRootFromParent_Done,
     /* 122280 */   // Label 1762: @122280
     /* 122280 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(122412), // Rule ID 3996 //
     /* 122285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 122288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122300 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122304 */     // MIs[1] Operand 1
     /* 122304 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 122311 */     // (sext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } -1:{ *:[i32] }))
     /* 122311 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122314 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 122318 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122323 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 122331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122333 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 122336 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122340 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122345 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 122348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 122350 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 122353 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122357 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122362 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 122365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 122367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122379 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122386 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 122407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 122410 */     GIR_RootConstrainSelectedInstOperands,
     /* 122411 */     // GIR_Coverage, 3996,
     /* 122411 */     GIR_EraseRootFromParent_Done,
     /* 122412 */   // Label 1763: @122412
     /* 122412 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(122427), // Rule ID 2990 //
     /* 122417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122420 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETNBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 122420 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC),
     /* 122425 */     GIR_RootConstrainSelectedInstOperands,
     /* 122426 */     // GIR_Coverage, 2990,
     /* 122426 */     GIR_Done,
     /* 122427 */   // Label 1764: @122427
     /* 122427 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(122481), // Rule ID 3674 //
     /* 122432 */     // (sext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } -1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 122432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122444 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 122447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 122456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 122464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 122469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122471 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 122473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 122479 */     GIR_RootConstrainSelectedInstOperands,
     /* 122480 */     // GIR_Coverage, 3674,
     /* 122480 */     GIR_EraseRootFromParent_Done,
     /* 122481 */   // Label 1765: @122481
     /* 122481 */   GIM_Reject,
     /* 122482 */ // Label 1701: @122482
     /* 122482 */ GIM_Reject,
     /* 122483 */ // Label 1699: @122483
     /* 122483 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(122593), // Rule ID 3039 //
     /* 122488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122506 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122510 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122514 */   // MIs[1] Operand 1
     /* 122514 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122519 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122523 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122527 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122531 */   // MIs[2] Operand 1
     /* 122531 */   // No operand predicates
     /* 122531 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122533 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 122533 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122536 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122540 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122545 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122549 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122554 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122557 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122561 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122566 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122578 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122591 */   GIR_RootConstrainSelectedInstOperands,
     /* 122592 */   // GIR_Coverage, 3039,
     /* 122592 */   GIR_EraseRootFromParent_Done,
     /* 122593 */ // Label 1766: @122593
     /* 122593 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(122703), // Rule ID 3055 //
     /* 122598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122608 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122620 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122624 */   // MIs[1] Operand 1
     /* 122624 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122629 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122633 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122637 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122641 */   // MIs[2] Operand 1
     /* 122641 */   // No operand predicates
     /* 122641 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122643 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 122643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122655 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122659 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122676 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 122683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122688 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122701 */   GIR_RootConstrainSelectedInstOperands,
     /* 122702 */   // GIR_Coverage, 3055,
     /* 122702 */   GIR_EraseRootFromParent_Done,
     /* 122703 */ // Label 1767: @122703
     /* 122703 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(122813), // Rule ID 3063 //
     /* 122708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122718 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122722 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122726 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 122730 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 122734 */   // MIs[1] Operand 1
     /* 122734 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 122739 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122743 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122747 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 122751 */   // MIs[2] Operand 1
     /* 122751 */   // No operand predicates
     /* 122751 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122753 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 122753 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122756 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 122760 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122765 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122769 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122786 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 122793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122798 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122811 */   GIR_RootConstrainSelectedInstOperands,
     /* 122812 */   // GIR_Coverage, 3063,
     /* 122812 */   GIR_EraseRootFromParent_Done,
     /* 122813 */ // Label 1768: @122813
     /* 122813 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(122923), // Rule ID 3135 //
     /* 122818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122840 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122844 */   // MIs[1] Operand 1
     /* 122844 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 122849 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122853 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122857 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122861 */   // MIs[2] Operand 1
     /* 122861 */   // No operand predicates
     /* 122861 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122863 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 122863 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122866 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122870 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122875 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122879 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122884 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122887 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122891 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122896 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 122903 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 122908 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 122913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 122916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 122918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122921 */   GIR_RootConstrainSelectedInstOperands,
     /* 122922 */   // GIR_Coverage, 3135,
     /* 122922 */   GIR_EraseRootFromParent_Done,
     /* 122923 */ // Label 1769: @122923
     /* 122923 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(123033), // Rule ID 3151 //
     /* 122928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 122931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 122934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 122938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 122942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 122946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 122950 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 122954 */   // MIs[1] Operand 1
     /* 122954 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 122959 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 122963 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 122967 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 122971 */   // MIs[2] Operand 1
     /* 122971 */   // No operand predicates
     /* 122971 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 122973 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 122973 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 122976 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 122980 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122985 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 122989 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 122992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 122997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123006 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123031 */   GIR_RootConstrainSelectedInstOperands,
     /* 123032 */   // GIR_Coverage, 3151,
     /* 123032 */   GIR_EraseRootFromParent_Done,
     /* 123033 */ // Label 1770: @123033
     /* 123033 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(123143), // Rule ID 3159 //
     /* 123038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 123041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123056 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123060 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123064 */   // MIs[1] Operand 1
     /* 123064 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123077 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123081 */   // MIs[2] Operand 1
     /* 123081 */   // No operand predicates
     /* 123081 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123083 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 123083 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123086 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123090 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123095 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123099 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123116 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123123 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 123136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 123138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123141 */   GIR_RootConstrainSelectedInstOperands,
     /* 123142 */   // GIR_Coverage, 3159,
     /* 123142 */   GIR_EraseRootFromParent_Done,
     /* 123143 */ // Label 1771: @123143
     /* 123143 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(123293), // Rule ID 3822 //
     /* 123148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123158 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123166 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123170 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123174 */   // MIs[1] Operand 1
     /* 123174 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 123179 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123183 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123187 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123191 */   // MIs[2] Operand 1
     /* 123191 */   // No operand predicates
     /* 123191 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123193 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123193 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123196 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123200 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123205 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123209 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123214 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123217 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123221 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123226 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123231 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123234 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123238 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123243 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123260 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123267 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123291 */   GIR_RootConstrainSelectedInstOperands,
     /* 123292 */   // GIR_Coverage, 3822,
     /* 123292 */   GIR_EraseRootFromParent_Done,
     /* 123293 */ // Label 1772: @123293
     /* 123293 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(123443), // Rule ID 3838 //
     /* 123298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123316 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123320 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123324 */   // MIs[1] Operand 1
     /* 123324 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123329 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123333 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123337 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123341 */   // MIs[2] Operand 1
     /* 123341 */   // No operand predicates
     /* 123341 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123343 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123355 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123359 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123364 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123367 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123371 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123376 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123379 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123381 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123384 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123388 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123393 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123410 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123435 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123438 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123441 */   GIR_RootConstrainSelectedInstOperands,
     /* 123442 */   // GIR_Coverage, 3838,
     /* 123442 */   GIR_EraseRootFromParent_Done,
     /* 123443 */ // Label 1773: @123443
     /* 123443 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(123593), // Rule ID 3846 //
     /* 123448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123458 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123466 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 123470 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 123474 */   // MIs[1] Operand 1
     /* 123474 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123479 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123483 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123487 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 123491 */   // MIs[2] Operand 1
     /* 123491 */   // No operand predicates
     /* 123491 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123493 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123493 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123496 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 123500 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123505 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123509 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123514 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123517 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123521 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123526 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123531 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123534 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123538 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123543 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123560 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 123567 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123572 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123588 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123591 */   GIR_RootConstrainSelectedInstOperands,
     /* 123592 */   // GIR_Coverage, 3846,
     /* 123592 */   GIR_EraseRootFromParent_Done,
     /* 123593 */ // Label 1774: @123593
     /* 123593 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(123743), // Rule ID 3918 //
     /* 123598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123608 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123620 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123624 */   // MIs[1] Operand 1
     /* 123624 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 123629 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123633 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123637 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123641 */   // MIs[2] Operand 1
     /* 123641 */   // No operand predicates
     /* 123641 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123643 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123655 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123659 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123664 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123667 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123671 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123676 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123681 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123684 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123688 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123693 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123710 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 123717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123732 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123735 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123741 */   GIR_RootConstrainSelectedInstOperands,
     /* 123742 */   // GIR_Coverage, 3918,
     /* 123742 */   GIR_EraseRootFromParent_Done,
     /* 123743 */ // Label 1775: @123743
     /* 123743 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(123893), // Rule ID 3934 //
     /* 123748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123758 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123766 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123770 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123774 */   // MIs[1] Operand 1
     /* 123774 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 123779 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123783 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123787 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123791 */   // MIs[2] Operand 1
     /* 123791 */   // No operand predicates
     /* 123791 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123793 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123793 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123796 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123800 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123805 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123809 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123814 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123817 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123821 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123826 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123831 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123834 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123838 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123843 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123846 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 123851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 123855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123860 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 123867 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 123872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 123877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 123880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123882 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 123888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 123891 */   GIR_RootConstrainSelectedInstOperands,
     /* 123892 */   // GIR_Coverage, 3934,
     /* 123892 */   GIR_EraseRootFromParent_Done,
     /* 123893 */ // Label 1776: @123893
     /* 123893 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(124043), // Rule ID 3942 //
     /* 123898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 123901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 123904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 123908 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 123912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 123916 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 123920 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 123924 */   // MIs[1] Operand 1
     /* 123924 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 123929 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 123933 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 123937 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 123941 */   // MIs[2] Operand 1
     /* 123941 */   // No operand predicates
     /* 123941 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 123943 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 123943 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 123946 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 123950 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123955 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 123959 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 123962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 123964 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 123967 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123971 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123976 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 123979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 123981 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 123984 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 123988 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123993 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 123996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 123998 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124001 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124005 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124010 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 124030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 124032 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 124038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 124041 */   GIR_RootConstrainSelectedInstOperands,
     /* 124042 */   // GIR_Coverage, 3942,
     /* 124042 */   GIR_EraseRootFromParent_Done,
     /* 124043 */ // Label 1777: @124043
     /* 124043 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(124142), // Rule ID 3183 //
     /* 124048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124058 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124066 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124070 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124074 */   // MIs[1] Operand 1
     /* 124074 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124079 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124081 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 124081 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124084 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124088 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124093 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124097 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124115 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124140 */   GIR_RootConstrainSelectedInstOperands,
     /* 124141 */   // GIR_Coverage, 3183,
     /* 124141 */   GIR_EraseRootFromParent_Done,
     /* 124142 */ // Label 1778: @124142
     /* 124142 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(124241), // Rule ID 3199 //
     /* 124147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124165 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124169 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124173 */   // MIs[1] Operand 1
     /* 124173 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124180 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 124180 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124183 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124187 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124192 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124196 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124214 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124221 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124226 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124236 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124239 */   GIR_RootConstrainSelectedInstOperands,
     /* 124240 */   // GIR_Coverage, 3199,
     /* 124240 */   GIR_EraseRootFromParent_Done,
     /* 124241 */ // Label 1779: @124241
     /* 124241 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(124340), // Rule ID 3215 //
     /* 124246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124256 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124260 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124268 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124272 */   // MIs[1] Operand 1
     /* 124272 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124277 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124279 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 124279 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124282 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124286 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124291 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124295 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124313 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124338 */   GIR_RootConstrainSelectedInstOperands,
     /* 124339 */   // GIR_Coverage, 3215,
     /* 124339 */   GIR_EraseRootFromParent_Done,
     /* 124340 */ // Label 1780: @124340
     /* 124340 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(124439), // Rule ID 3231 //
     /* 124345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124355 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124359 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124363 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 124367 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 124371 */   // MIs[1] Operand 1
     /* 124371 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124376 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124378 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 124378 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124381 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 124385 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124390 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124394 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124400 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124403 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124407 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124412 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124437 */   GIR_RootConstrainSelectedInstOperands,
     /* 124438 */   // GIR_Coverage, 3231,
     /* 124438 */   GIR_EraseRootFromParent_Done,
     /* 124439 */ // Label 1781: @124439
     /* 124439 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(124538), // Rule ID 3239 //
     /* 124444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124454 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124458 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124462 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124466 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124470 */   // MIs[1] Operand 1
     /* 124470 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124477 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 124477 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124480 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124484 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124489 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124493 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124511 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124536 */   GIR_RootConstrainSelectedInstOperands,
     /* 124537 */   // GIR_Coverage, 3239,
     /* 124537 */   GIR_EraseRootFromParent_Done,
     /* 124538 */ // Label 1782: @124538
     /* 124538 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(124637), // Rule ID 3255 //
     /* 124543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124561 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124565 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124569 */   // MIs[1] Operand 1
     /* 124569 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124576 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 124576 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124579 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124583 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124588 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124592 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124598 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124601 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124605 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124610 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 124617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124630 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124632 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124635 */   GIR_RootConstrainSelectedInstOperands,
     /* 124636 */   // GIR_Coverage, 3255,
     /* 124636 */   GIR_EraseRootFromParent_Done,
     /* 124637 */ // Label 1783: @124637
     /* 124637 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(124736), // Rule ID 3271 //
     /* 124642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124664 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124668 */   // MIs[1] Operand 1
     /* 124668 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 124673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124675 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 124675 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124678 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124682 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124687 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124691 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124697 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124700 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124704 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124709 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 124716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124734 */   GIR_RootConstrainSelectedInstOperands,
     /* 124735 */   // GIR_Coverage, 3271,
     /* 124735 */   GIR_EraseRootFromParent_Done,
     /* 124736 */ // Label 1784: @124736
     /* 124736 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(124835), // Rule ID 3287 //
     /* 124741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 124763 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 124767 */   // MIs[1] Operand 1
     /* 124767 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 124772 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124774 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 124774 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124777 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 124781 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124786 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124790 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124796 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124799 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124803 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124808 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 124815 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124820 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124833 */   GIR_RootConstrainSelectedInstOperands,
     /* 124834 */   // GIR_Coverage, 3287,
     /* 124834 */   GIR_EraseRootFromParent_Done,
     /* 124835 */ // Label 1785: @124835
     /* 124835 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(124934), // Rule ID 3295 //
     /* 124840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124858 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124862 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124866 */   // MIs[1] Operand 1
     /* 124866 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 124871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124873 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 124873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124885 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124889 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124895 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124898 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 124902 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124907 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 124914 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 124919 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 124924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 124927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 124929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124932 */   GIR_RootConstrainSelectedInstOperands,
     /* 124933 */   // GIR_Coverage, 3295,
     /* 124933 */   GIR_EraseRootFromParent_Done,
     /* 124934 */ // Label 1786: @124934
     /* 124934 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(125033), // Rule ID 3311 //
     /* 124939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 124942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 124945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 124949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 124957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 124961 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 124965 */   // MIs[1] Operand 1
     /* 124965 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 124970 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124972 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 124972 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 124975 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 124979 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124984 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 124988 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 124992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 124994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 124997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125006 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125013 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125018 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125028 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125031 */   GIR_RootConstrainSelectedInstOperands,
     /* 125032 */   // GIR_Coverage, 3311,
     /* 125032 */   GIR_EraseRootFromParent_Done,
     /* 125033 */ // Label 1787: @125033
     /* 125033 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(125132), // Rule ID 3327 //
     /* 125038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 125041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125048 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125052 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125056 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 125060 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 125064 */   // MIs[1] Operand 1
     /* 125064 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125071 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 125071 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125074 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 125078 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125083 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125087 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125105 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125117 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125130 */   GIR_RootConstrainSelectedInstOperands,
     /* 125131 */   // GIR_Coverage, 3327,
     /* 125131 */   GIR_EraseRootFromParent_Done,
     /* 125132 */ // Label 1788: @125132
     /* 125132 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(125231), // Rule ID 3343 //
     /* 125137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 125140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125155 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 125159 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 125163 */   // MIs[1] Operand 1
     /* 125163 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125170 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 125170 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125173 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 125177 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125182 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125186 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125190 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125204 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 125211 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125216 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 125224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 125226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125229 */   GIR_RootConstrainSelectedInstOperands,
     /* 125230 */   // GIR_Coverage, 3343,
     /* 125230 */   GIR_EraseRootFromParent_Done,
     /* 125231 */ // Label 1789: @125231
     /* 125231 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(125370), // Rule ID 4026 //
     /* 125236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125246 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125250 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125258 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125262 */   // MIs[1] Operand 1
     /* 125262 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 125267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125269 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125269 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125272 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125276 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125281 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125285 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125291 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125294 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125298 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125303 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125308 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125311 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125315 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125320 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125337 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125344 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125349 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125368 */   GIR_RootConstrainSelectedInstOperands,
     /* 125369 */   // GIR_Coverage, 4026,
     /* 125369 */   GIR_EraseRootFromParent_Done,
     /* 125370 */ // Label 1790: @125370
     /* 125370 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(125509), // Rule ID 4058 //
     /* 125375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125385 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125389 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125393 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125397 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125401 */   // MIs[1] Operand 1
     /* 125401 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125408 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125408 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125411 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125415 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125420 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125424 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125428 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125430 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125433 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125437 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125442 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125447 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125450 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125454 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125459 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125476 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 125483 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125488 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125507 */   GIR_RootConstrainSelectedInstOperands,
     /* 125508 */   // GIR_Coverage, 4058,
     /* 125508 */   GIR_EraseRootFromParent_Done,
     /* 125509 */ // Label 1791: @125509
     /* 125509 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(125648), // Rule ID 4090 //
     /* 125514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125524 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125528 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125536 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125540 */   // MIs[1] Operand 1
     /* 125540 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 125545 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125547 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125547 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125550 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125554 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125559 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125563 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125569 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125572 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125576 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125581 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125586 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125589 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125593 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125598 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125615 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 125622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125640 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125646 */   GIR_RootConstrainSelectedInstOperands,
     /* 125647 */   // GIR_Coverage, 4090,
     /* 125647 */   GIR_EraseRootFromParent_Done,
     /* 125648 */ // Label 1792: @125648
     /* 125648 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(125787), // Rule ID 4122 //
     /* 125653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125671 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 125675 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 125679 */   // MIs[1] Operand 1
     /* 125679 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 125684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125686 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125686 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125689 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 125693 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125698 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125702 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125706 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125708 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125711 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125715 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125720 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125725 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125728 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125732 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125737 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125754 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 125761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125766 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125774 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125779 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125782 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125785 */   GIR_RootConstrainSelectedInstOperands,
     /* 125786 */   // GIR_Coverage, 4122,
     /* 125786 */   GIR_EraseRootFromParent_Done,
     /* 125787 */ // Label 1793: @125787
     /* 125787 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(125926), // Rule ID 4138 //
     /* 125792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125802 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125806 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125810 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125814 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125818 */   // MIs[1] Operand 1
     /* 125818 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 125823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125825 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125825 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125828 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125832 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125837 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125841 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125847 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125850 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125854 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125859 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 125862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 125864 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 125867 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125871 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125876 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 125879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 125881 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 125884 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 125888 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125893 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 125900 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 125905 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 125910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 125913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 125915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 125921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 125924 */   GIR_RootConstrainSelectedInstOperands,
     /* 125925 */   // GIR_Coverage, 4138,
     /* 125925 */   GIR_EraseRootFromParent_Done,
     /* 125926 */ // Label 1794: @125926
     /* 125926 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(126065), // Rule ID 4170 //
     /* 125931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 125934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 125937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 125941 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125945 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 125949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 125953 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 125957 */   // MIs[1] Operand 1
     /* 125957 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 125962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125964 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 125964 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 125967 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 125971 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125976 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 125980 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 125984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 125986 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 125989 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 125993 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125998 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126003 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126006 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126010 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126015 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126018 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126032 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126039 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126057 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126063 */   GIR_RootConstrainSelectedInstOperands,
     /* 126064 */   // GIR_Coverage, 4170,
     /* 126064 */   GIR_EraseRootFromParent_Done,
     /* 126065 */ // Label 1795: @126065
     /* 126065 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(126204), // Rule ID 4202 //
     /* 126070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126088 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126092 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126096 */   // MIs[1] Operand 1
     /* 126096 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126101 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126103 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126103 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126106 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 126110 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126115 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126119 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126125 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126128 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126132 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126137 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126142 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126145 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126149 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126154 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126159 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126162 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126166 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126171 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126178 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126183 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126196 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126199 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126202 */   GIR_RootConstrainSelectedInstOperands,
     /* 126203 */   // GIR_Coverage, 4202,
     /* 126203 */   GIR_EraseRootFromParent_Done,
     /* 126204 */ // Label 1796: @126204
     /* 126204 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(126343), // Rule ID 4234 //
     /* 126209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126227 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 126231 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 126235 */   // MIs[1] Operand 1
     /* 126235 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 126240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126242 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126242 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126245 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 126249 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126254 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126258 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126264 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126267 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126271 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126276 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126281 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126284 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126288 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126293 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126310 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126335 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126341 */   GIR_RootConstrainSelectedInstOperands,
     /* 126342 */   // GIR_Coverage, 4234,
     /* 126342 */   GIR_EraseRootFromParent_Done,
     /* 126343 */ // Label 1797: @126343
     /* 126343 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(126482), // Rule ID 4264 //
     /* 126348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126374 */   // MIs[1] Operand 1
     /* 126374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126379 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126381 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126381 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126384 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126388 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126393 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126397 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126403 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126406 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126410 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126415 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126420 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126423 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126427 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126432 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126449 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 126456 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126461 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126480 */   GIR_RootConstrainSelectedInstOperands,
     /* 126481 */   // GIR_Coverage, 4264,
     /* 126481 */   GIR_EraseRootFromParent_Done,
     /* 126482 */ // Label 1798: @126482
     /* 126482 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(126621), // Rule ID 4296 //
     /* 126487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126497 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126501 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126505 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126509 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126513 */   // MIs[1] Operand 1
     /* 126513 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 126518 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126520 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126520 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126523 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126527 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126532 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126536 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126542 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126545 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126549 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126554 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126559 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126562 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126566 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126571 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126588 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 126595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126616 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126619 */   GIR_RootConstrainSelectedInstOperands,
     /* 126620 */   // GIR_Coverage, 4296,
     /* 126620 */   GIR_EraseRootFromParent_Done,
     /* 126621 */ // Label 1799: @126621
     /* 126621 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(126760), // Rule ID 4328 //
     /* 126626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126636 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126640 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126644 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126648 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126652 */   // MIs[1] Operand 1
     /* 126652 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 126657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126659 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126659 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126662 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126666 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126671 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126675 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126681 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126684 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126688 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126693 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126710 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126727 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 126734 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126749 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126758 */   GIR_RootConstrainSelectedInstOperands,
     /* 126759 */   // GIR_Coverage, 4328,
     /* 126759 */   GIR_EraseRootFromParent_Done,
     /* 126760 */ // Label 1800: @126760
     /* 126760 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(126899), // Rule ID 4360 //
     /* 126765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 126768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126775 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126783 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 126787 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 126791 */   // MIs[1] Operand 1
     /* 126791 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 126796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126798 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126798 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126801 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 126805 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126810 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126814 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126818 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126820 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126823 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126827 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126832 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126837 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126840 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126844 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126849 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 126861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126866 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 126873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 126878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 126883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 126886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 126888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 126894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 126897 */   GIR_RootConstrainSelectedInstOperands,
     /* 126898 */   // GIR_Coverage, 4360,
     /* 126898 */   GIR_EraseRootFromParent_Done,
     /* 126899 */ // Label 1801: @126899
     /* 126899 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(127038), // Rule ID 4591 //
     /* 126904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 126907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 126910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 126914 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 126918 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 126922 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 126926 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 126930 */   // MIs[1] Operand 1
     /* 126930 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 126935 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126937 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 126937 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 126940 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 126944 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126949 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 126953 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 126957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 126959 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 126962 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126966 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126971 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 126974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 126976 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 126979 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 126983 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126988 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 126991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 126993 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 126996 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127000 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127005 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127036 */   GIR_RootConstrainSelectedInstOperands,
     /* 127037 */   // GIR_Coverage, 4591,
     /* 127037 */   GIR_EraseRootFromParent_Done,
     /* 127038 */ // Label 1802: @127038
     /* 127038 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(127177), // Rule ID 4623 //
     /* 127043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127061 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127065 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127069 */   // MIs[1] Operand 1
     /* 127069 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 127074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127076 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127076 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127079 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 127083 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127088 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127092 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127098 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127101 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127105 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127110 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127115 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127118 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127122 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127127 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127144 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127172 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127175 */   GIR_RootConstrainSelectedInstOperands,
     /* 127176 */   // GIR_Coverage, 4623,
     /* 127176 */   GIR_EraseRootFromParent_Done,
     /* 127177 */ // Label 1803: @127177
     /* 127177 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(127316), // Rule ID 4655 //
     /* 127182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127192 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127196 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127200 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127204 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127208 */   // MIs[1] Operand 1
     /* 127208 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 127213 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127215 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127215 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127218 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 127222 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127227 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127231 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127237 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127240 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127244 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127249 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127254 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127257 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127261 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127266 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127283 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127314 */   GIR_RootConstrainSelectedInstOperands,
     /* 127315 */   // GIR_Coverage, 4655,
     /* 127315 */   GIR_EraseRootFromParent_Done,
     /* 127316 */ // Label 1804: @127316
     /* 127316 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(127455), // Rule ID 4699 //
     /* 127321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127339 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127343 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127347 */   // MIs[1] Operand 1
     /* 127347 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 127352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127354 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127354 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127357 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 127361 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127366 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127370 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127376 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127379 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127383 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127388 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127391 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127393 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127396 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127400 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127405 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127422 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127434 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127453 */   GIR_RootConstrainSelectedInstOperands,
     /* 127454 */   // GIR_Coverage, 4699,
     /* 127454 */   GIR_EraseRootFromParent_Done,
     /* 127455 */ // Label 1805: @127455
     /* 127455 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(127594), // Rule ID 4731 //
     /* 127460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127470 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127474 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127478 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127482 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127486 */   // MIs[1] Operand 1
     /* 127486 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 127491 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127493 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127493 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127496 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 127500 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127505 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127509 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127515 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127518 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127522 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127527 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127532 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127535 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127539 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127544 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127561 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127586 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127592 */   GIR_RootConstrainSelectedInstOperands,
     /* 127593 */   // GIR_Coverage, 4731,
     /* 127593 */   GIR_EraseRootFromParent_Done,
     /* 127594 */ // Label 1806: @127594
     /* 127594 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(127733), // Rule ID 4763 //
     /* 127599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 127602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 127617 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 127621 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 127625 */   // MIs[1] Operand 1
     /* 127625 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 127630 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127632 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 127632 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127635 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 127639 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127644 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127648 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127654 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 127657 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127661 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127666 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 127669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 127671 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 127674 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 127678 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127683 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 127686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 127688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127700 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 127707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 127720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 127722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127725 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 127728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 127731 */   GIR_RootConstrainSelectedInstOperands,
     /* 127732 */   // GIR_Coverage, 4763,
     /* 127732 */   GIR_EraseRootFromParent_Done,
     /* 127733 */ // Label 1807: @127733
     /* 127733 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(127832), // Rule ID 2985 //
     /* 127738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127748 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127752 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127756 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127760 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127764 */   // MIs[1] Operand 1
     /* 127764 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 127769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127771 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127771 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127774 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127778 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127783 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127787 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127805 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127812 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127830 */   GIR_RootConstrainSelectedInstOperands,
     /* 127831 */   // GIR_Coverage, 2985,
     /* 127831 */   GIR_EraseRootFromParent_Done,
     /* 127832 */ // Label 1808: @127832
     /* 127832 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(127931), // Rule ID 2999 //
     /* 127837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127855 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127859 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127863 */   // MIs[1] Operand 1
     /* 127863 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 127868 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127870 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 127870 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127873 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 127877 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127882 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127886 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127904 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 127911 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 127916 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 127921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 127924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 127926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127929 */   GIR_RootConstrainSelectedInstOperands,
     /* 127930 */   // GIR_Coverage, 2999,
     /* 127930 */   GIR_EraseRootFromParent_Done,
     /* 127931 */ // Label 1809: @127931
     /* 127931 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(128030), // Rule ID 3007 //
     /* 127936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 127939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 127942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 127946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 127950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 127954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 127958 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 127962 */   // MIs[1] Operand 1
     /* 127962 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 127967 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 127969 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 127969 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 127972 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 127976 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127981 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 127985 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 127989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 127991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 127994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 127998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128003 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128015 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128025 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128028 */   GIR_RootConstrainSelectedInstOperands,
     /* 128029 */   // GIR_Coverage, 3007,
     /* 128029 */   GIR_EraseRootFromParent_Done,
     /* 128030 */ // Label 1810: @128030
     /* 128030 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(128129), // Rule ID 3015 //
     /* 128035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128053 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128057 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128061 */   // MIs[1] Operand 1
     /* 128061 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128066 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128068 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 128068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128080 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128084 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128102 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128109 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128127 */   GIR_RootConstrainSelectedInstOperands,
     /* 128128 */   // GIR_Coverage, 3015,
     /* 128128 */   GIR_EraseRootFromParent_Done,
     /* 128129 */ // Label 1811: @128129
     /* 128129 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(128228), // Rule ID 3023 //
     /* 128134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128144 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128148 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128152 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128156 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128160 */   // MIs[1] Operand 1
     /* 128160 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128165 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128167 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 128167 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128170 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128174 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128179 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128183 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128201 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 128208 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128226 */   GIR_RootConstrainSelectedInstOperands,
     /* 128227 */   // GIR_Coverage, 3023,
     /* 128227 */   GIR_EraseRootFromParent_Done,
     /* 128228 */ // Label 1812: @128228
     /* 128228 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(128327), // Rule ID 3087 //
     /* 128233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128243 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128251 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128255 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128259 */   // MIs[1] Operand 1
     /* 128259 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 128264 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128266 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 128266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 128273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128282 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128288 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128291 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128295 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128300 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128307 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128312 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128322 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128325 */   GIR_RootConstrainSelectedInstOperands,
     /* 128326 */   // GIR_Coverage, 3087,
     /* 128326 */   GIR_EraseRootFromParent_Done,
     /* 128327 */ // Label 1813: @128327
     /* 128327 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(128426), // Rule ID 3095 //
     /* 128332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128342 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128346 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128350 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128354 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128358 */   // MIs[1] Operand 1
     /* 128358 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128363 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128365 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 128365 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128368 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128372 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128377 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128381 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128399 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128406 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128411 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128424 */   GIR_RootConstrainSelectedInstOperands,
     /* 128425 */   // GIR_Coverage, 3095,
     /* 128425 */   GIR_EraseRootFromParent_Done,
     /* 128426 */ // Label 1814: @128426
     /* 128426 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(128525), // Rule ID 3103 //
     /* 128431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128441 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128445 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128449 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128453 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128457 */   // MIs[1] Operand 1
     /* 128457 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 128462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128464 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 128471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128476 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128480 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128498 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128510 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128523 */   GIR_RootConstrainSelectedInstOperands,
     /* 128524 */   // GIR_Coverage, 3103,
     /* 128524 */   GIR_EraseRootFromParent_Done,
     /* 128525 */ // Label 1815: @128525
     /* 128525 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(128624), // Rule ID 3111 //
     /* 128530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128548 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128552 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128556 */   // MIs[1] Operand 1
     /* 128556 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 128561 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128563 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 128563 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128566 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128570 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128575 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128579 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128597 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 128604 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128609 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128619 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128622 */   GIR_RootConstrainSelectedInstOperands,
     /* 128623 */   // GIR_Coverage, 3111,
     /* 128623 */   GIR_EraseRootFromParent_Done,
     /* 128624 */ // Label 1816: @128624
     /* 128624 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(128723), // Rule ID 3119 //
     /* 128629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 128632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128647 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 128651 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 128655 */   // MIs[1] Operand 1
     /* 128655 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 128660 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128662 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETNBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 128662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 128669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128674 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128678 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128684 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128687 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128691 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128696 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 128703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETNBCR8),
     /* 128716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 128718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128721 */   GIR_RootConstrainSelectedInstOperands,
     /* 128722 */   // GIR_Coverage, 3119,
     /* 128722 */   GIR_EraseRootFromParent_Done,
     /* 128723 */ // Label 1817: @128723
     /* 128723 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(128862), // Rule ID 3870 //
     /* 128728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128746 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128750 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128754 */   // MIs[1] Operand 1
     /* 128754 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 128759 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128761 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128761 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128764 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 128768 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128773 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128777 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128783 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128786 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128790 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128795 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128800 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128803 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128807 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128812 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128817 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128820 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128824 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128829 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128836 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128841 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128857 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128860 */   GIR_RootConstrainSelectedInstOperands,
     /* 128861 */   // GIR_Coverage, 3870,
     /* 128861 */   GIR_EraseRootFromParent_Done,
     /* 128862 */ // Label 1818: @128862
     /* 128862 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(129001), // Rule ID 3878 //
     /* 128867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 128870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 128873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 128877 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 128881 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 128885 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 128889 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 128893 */   // MIs[1] Operand 1
     /* 128893 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 128898 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 128900 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 128900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 128903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 128907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128912 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 128916 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 128920 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 128922 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 128925 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128929 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128934 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 128937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 128939 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 128942 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 128946 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128951 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 128954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 128956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 128959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 128963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128968 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 128975 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 128980 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 128985 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 128988 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 128990 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 128996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 128999 */   GIR_RootConstrainSelectedInstOperands,
     /* 129000 */   // GIR_Coverage, 3878,
     /* 129000 */   GIR_EraseRootFromParent_Done,
     /* 129001 */ // Label 1819: @129001
     /* 129001 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(129140), // Rule ID 3886 //
     /* 129006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129024 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129028 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129032 */   // MIs[1] Operand 1
     /* 129032 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 129037 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129039 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129039 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129042 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 129046 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129051 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129055 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129059 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129061 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129064 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129068 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129073 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129078 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129081 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129085 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129090 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129107 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129119 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129138 */   GIR_RootConstrainSelectedInstOperands,
     /* 129139 */   // GIR_Coverage, 3886,
     /* 129139 */   GIR_EraseRootFromParent_Done,
     /* 129140 */ // Label 1820: @129140
     /* 129140 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(129279), // Rule ID 3894 //
     /* 129145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129155 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129159 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129163 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129167 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129171 */   // MIs[1] Operand 1
     /* 129171 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129176 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129178 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129178 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129181 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 129185 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129190 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129194 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129200 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129203 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129207 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129212 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129217 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129220 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129224 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129229 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129246 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129258 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129268 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129277 */   GIR_RootConstrainSelectedInstOperands,
     /* 129278 */   // GIR_Coverage, 3894,
     /* 129278 */   GIR_EraseRootFromParent_Done,
     /* 129279 */ // Label 1821: @129279
     /* 129279 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(129418), // Rule ID 3902 //
     /* 129284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129302 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 129306 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 129310 */   // MIs[1] Operand 1
     /* 129310 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 129315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129317 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129317 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129320 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 129324 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129329 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129333 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129339 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129342 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129346 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129351 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129356 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129359 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129363 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129368 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129385 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 129392 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129397 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129407 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129416 */   GIR_RootConstrainSelectedInstOperands,
     /* 129417 */   // GIR_Coverage, 3902,
     /* 129417 */   GIR_EraseRootFromParent_Done,
     /* 129418 */ // Label 1822: @129418
     /* 129418 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(129557), // Rule ID 3966 //
     /* 129423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129433 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129437 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129441 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129445 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129449 */   // MIs[1] Operand 1
     /* 129449 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 129454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129456 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129456 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129459 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129463 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129468 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129472 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129478 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129481 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129485 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129490 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129493 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129495 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129498 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129502 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129507 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129524 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129531 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129536 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129549 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129555 */   GIR_RootConstrainSelectedInstOperands,
     /* 129556 */   // GIR_Coverage, 3966,
     /* 129556 */   GIR_EraseRootFromParent_Done,
     /* 129557 */ // Label 1823: @129557
     /* 129557 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(129696), // Rule ID 3974 //
     /* 129562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129580 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129584 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129588 */   // MIs[1] Operand 1
     /* 129588 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 129593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129595 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129607 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129611 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129617 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129620 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129624 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129629 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129634 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129637 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129641 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129646 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129663 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 129670 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129675 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129694 */   GIR_RootConstrainSelectedInstOperands,
     /* 129695 */   // GIR_Coverage, 3974,
     /* 129695 */   GIR_EraseRootFromParent_Done,
     /* 129696 */ // Label 1824: @129696
     /* 129696 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(129835), // Rule ID 3982 //
     /* 129701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129723 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129727 */   // MIs[1] Operand 1
     /* 129727 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 129732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129734 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129734 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129737 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 129741 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129746 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129750 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129754 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129756 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129759 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129763 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129768 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129773 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129776 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129780 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129785 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129802 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129809 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129814 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129833 */   GIR_RootConstrainSelectedInstOperands,
     /* 129834 */   // GIR_Coverage, 3982,
     /* 129834 */   GIR_EraseRootFromParent_Done,
     /* 129835 */ // Label 1825: @129835
     /* 129835 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(129974), // Rule ID 3990 //
     /* 129840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129850 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129854 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129858 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 129862 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 129866 */   // MIs[1] Operand 1
     /* 129866 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 129871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129873 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 129873 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 129876 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 129880 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129885 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 129889 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 129893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 129895 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 129898 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129902 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129907 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 129910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 129912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 129915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 129919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129924 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 129927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 129929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 129932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 129936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129941 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 129948 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 129953 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 129958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 129961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 129969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 129972 */   GIR_RootConstrainSelectedInstOperands,
     /* 129973 */   // GIR_Coverage, 3990,
     /* 129973 */   GIR_EraseRootFromParent_Done,
     /* 129974 */ // Label 1826: @129974
     /* 129974 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(130113), // Rule ID 3998 //
     /* 129979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 129982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 129985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 129989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 129997 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130001 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130005 */   // MIs[1] Operand 1
     /* 130005 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 130012 */   // (sext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } -1:{ *:[i64] }))
     /* 130012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 130019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130024 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 130028 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 130032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130034 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 130037 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130041 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130046 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/uint8_t(-1),
     /* 130049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 130051 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 130054 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130058 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130063 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 130066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 130068 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 130071 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130075 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130080 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 130087 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 130092 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 130097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 130100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130102 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130105 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 130108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 130111 */   GIR_RootConstrainSelectedInstOperands,
     /* 130112 */   // GIR_Coverage, 3998,
     /* 130112 */   GIR_EraseRootFromParent_Done,
     /* 130113 */ // Label 1827: @130113
     /* 130113 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(130132), // Rule ID 684 //
     /* 130118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 130121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130125 */   // (sext:{ *:[i64] } i32:{ *:[i32] }:$RST)  =>  (EXTSW_32_64:{ *:[i64] } i32:{ *:[i32] }:$RST)
     /* 130125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EXTSW_32_64),
     /* 130130 */   GIR_RootConstrainSelectedInstOperands,
     /* 130131 */   // GIR_Coverage, 684,
     /* 130131 */   GIR_Done,
     /* 130132 */ // Label 1828: @130132
     /* 130132 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(130154), // Rule ID 2991 //
     /* 130137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 130140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130147 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETNBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 130147 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETNBC8),
     /* 130152 */   GIR_RootConstrainSelectedInstOperands,
     /* 130153 */   // GIR_Coverage, 2991,
     /* 130153 */   GIR_Done,
     /* 130154 */ // Label 1829: @130154
     /* 130154 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(130215), // Rule ID 3676 //
     /* 130159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130166 */   // (sext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } -1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 130166 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 130169 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130173 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130178 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 130181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 130190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130195 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/uint8_t(-1),
     /* 130198 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130200 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 130203 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130205 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 130207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 130213 */   GIR_RootConstrainSelectedInstOperands,
     /* 130214 */   // GIR_Coverage, 3676,
     /* 130214 */   GIR_EraseRootFromParent_Done,
     /* 130215 */ // Label 1830: @130215
     /* 130215 */ GIM_Reject,
     /* 130216 */ // Label 1700: @130216
     /* 130216 */ GIM_Reject,
     /* 130217 */ // Label 25: @130217
     /* 130217 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 1835*/ GIMT_Encode4(130569),
     /* 130228 */ /*GILLT_s32*//*Label 1831*/ GIMT_Encode4(130248),
     /* 130232 */ /*GILLT_s64*//*Label 1832*/ GIMT_Encode4(130312), GIMT_Encode4(0),
     /* 130240 */ /*GILLT_v2s64*//*Label 1833*/ GIMT_Encode4(130401),
     /* 130244 */ /*GILLT_v4s32*//*Label 1834*/ GIMT_Encode4(130499),
     /* 130248 */ // Label 1831: @130248
     /* 130248 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(130311),
     /* 130253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 130256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130260 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(130285), // Rule ID 135 //
     /* 130265 */     // MIs[0] Operand 2
     /* 130265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130276 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i8:{ *:[Other] })  =>  (EXTSB:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 130276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB),
     /* 130279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130281 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130283 */     GIR_RootConstrainSelectedInstOperands,
     /* 130284 */     // GIR_Coverage, 135,
     /* 130284 */     GIR_EraseRootFromParent_Done,
     /* 130285 */   // Label 1837: @130285
     /* 130285 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(130310), // Rule ID 136 //
     /* 130290 */     // MIs[0] Operand 2
     /* 130290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130301 */     // (sext_inreg:{ *:[i32] } i32:{ *:[i32] }:$RST, i16:{ *:[Other] })  =>  (EXTSH:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 130301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH),
     /* 130304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130306 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130308 */     GIR_RootConstrainSelectedInstOperands,
     /* 130309 */     // GIR_Coverage, 136,
     /* 130309 */     GIR_EraseRootFromParent_Done,
     /* 130310 */   // Label 1838: @130310
     /* 130310 */   GIM_Reject,
     /* 130311 */ // Label 1836: @130311
     /* 130311 */ GIM_Reject,
     /* 130312 */ // Label 1832: @130312
     /* 130312 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(130400),
     /* 130317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 130320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130324 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(130349), // Rule ID 681 //
     /* 130329 */     // MIs[0] Operand 2
     /* 130329 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130340 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i8:{ *:[Other] })  =>  (EXTSB8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSB8),
     /* 130343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130345 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130347 */     GIR_RootConstrainSelectedInstOperands,
     /* 130348 */     // GIR_Coverage, 681,
     /* 130348 */     GIR_EraseRootFromParent_Done,
     /* 130349 */   // Label 1840: @130349
     /* 130349 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(130374), // Rule ID 682 //
     /* 130354 */     // MIs[0] Operand 2
     /* 130354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130365 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i16:{ *:[Other] })  =>  (EXTSH8:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSH8),
     /* 130368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130370 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130372 */     GIR_RootConstrainSelectedInstOperands,
     /* 130373 */     // GIR_Coverage, 682,
     /* 130373 */     GIR_EraseRootFromParent_Done,
     /* 130374 */   // Label 1841: @130374
     /* 130374 */   GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(130399), // Rule ID 683 //
     /* 130379 */     // MIs[0] Operand 2
     /* 130379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130390 */     // (sext_inreg:{ *:[i64] } i64:{ *:[i64] }:$RST, i32:{ *:[Other] })  =>  (EXTSW:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 130390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EXTSW),
     /* 130393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130395 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 130397 */     GIR_RootConstrainSelectedInstOperands,
     /* 130398 */     // GIR_Coverage, 683,
     /* 130398 */     GIR_EraseRootFromParent_Done,
     /* 130399 */   // Label 1842: @130399
     /* 130399 */   GIM_Reject,
     /* 130400 */ // Label 1839: @130400
     /* 130400 */ GIM_Reject,
     /* 130401 */ // Label 1833: @130401
     /* 130401 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(130498),
     /* 130406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 130409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130413 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(130441), // Rule ID 1456 //
     /* 130418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130421 */     // MIs[0] Operand 2
     /* 130421 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130432 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i8:{ *:[Other] })  =>  (VEXTSB2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2D),
     /* 130435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130437 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130439 */     GIR_RootConstrainSelectedInstOperands,
     /* 130440 */     // GIR_Coverage, 1456,
     /* 130440 */     GIR_EraseRootFromParent_Done,
     /* 130441 */   // Label 1844: @130441
     /* 130441 */   GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(130469), // Rule ID 1457 //
     /* 130446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130449 */     // MIs[0] Operand 2
     /* 130449 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130460 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i16:{ *:[Other] })  =>  (VEXTSH2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2D),
     /* 130463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130465 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130467 */     GIR_RootConstrainSelectedInstOperands,
     /* 130468 */     // GIR_Coverage, 1457,
     /* 130468 */     GIR_EraseRootFromParent_Done,
     /* 130469 */   // Label 1845: @130469
     /* 130469 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(130497), // Rule ID 1458 //
     /* 130474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130477 */     // MIs[0] Operand 2
     /* 130477 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 130488 */     // (sext_inreg:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VRB, v2i32:{ *:[Other] })  =>  (VEXTSW2D:{ *:[v2i64] } ?:{ *:[v2i64] }:$VRB)
     /* 130488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSW2D),
     /* 130491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130493 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130495 */     GIR_RootConstrainSelectedInstOperands,
     /* 130496 */     // GIR_Coverage, 1458,
     /* 130496 */     GIR_EraseRootFromParent_Done,
     /* 130497 */   // Label 1846: @130497
     /* 130497 */   GIM_Reject,
     /* 130498 */ // Label 1843: @130498
     /* 130498 */ GIM_Reject,
     /* 130499 */ // Label 1834: @130499
     /* 130499 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(130568),
     /* 130504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 130507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 130511 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(130539), // Rule ID 1454 //
     /* 130516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130519 */     // MIs[0] Operand 2
     /* 130519 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 130530 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i8:{ *:[Other] })  =>  (VEXTSB2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSB2W),
     /* 130533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130535 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130537 */     GIR_RootConstrainSelectedInstOperands,
     /* 130538 */     // GIR_Coverage, 1454,
     /* 130538 */     GIR_EraseRootFromParent_Done,
     /* 130539 */   // Label 1848: @130539
     /* 130539 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(130567), // Rule ID 1455 //
     /* 130544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 130547 */     // MIs[0] Operand 2
     /* 130547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 130558 */     // (sext_inreg:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VRB, v4i16:{ *:[Other] })  =>  (VEXTSH2W:{ *:[v4i32] } ?:{ *:[v4i32] }:$VRB)
     /* 130558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VEXTSH2W),
     /* 130561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 130563 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRB
     /* 130565 */     GIR_RootConstrainSelectedInstOperands,
     /* 130566 */     // GIR_Coverage, 1455,
     /* 130566 */     GIR_EraseRootFromParent_Done,
     /* 130567 */   // Label 1849: @130567
     /* 130567 */   GIM_Reject,
     /* 130568 */ // Label 1847: @130568
     /* 130568 */ GIM_Reject,
     /* 130569 */ // Label 1835: @130569
     /* 130569 */ GIM_Reject,
     /* 130570 */ // Label 26: @130570
     /* 130570 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1852*/ GIMT_Encode4(152039),
     /* 130581 */ /*GILLT_s32*//*Label 1850*/ GIMT_Encode4(130589),
     /* 130585 */ /*GILLT_s64*//*Label 1851*/ GIMT_Encode4(140810),
     /* 130589 */ // Label 1850: @130589
     /* 130589 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(140809),
     /* 130594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 130597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130601 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(130713), // Rule ID 5299 //
     /* 130606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130622 */     // MIs[1] Operand 1
     /* 130622 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130659 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130663 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130669 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130685 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 130688 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 130691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130711 */     GIR_RootConstrainSelectedInstOperands,
     /* 130712 */     // GIR_Coverage, 5299,
     /* 130712 */     GIR_EraseRootFromParent_Done,
     /* 130713 */   // Label 1854: @130713
     /* 130713 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(130852), // Rule ID 5302 //
     /* 130718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 130730 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 130734 */     // MIs[1] Operand 1
     /* 130734 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 130739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 130751 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 130755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 130767 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130771 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130775 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130781 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 130781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130793 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130797 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 130800 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 130812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130821 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 130824 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 130827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 130832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130834 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 130841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 130846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 130851 */     // GIR_Coverage, 5302,
     /* 130851 */     GIR_EraseRootFromParent_Done,
     /* 130852 */   // Label 1855: @130852
     /* 130852 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(130985), // Rule ID 5307 //
     /* 130857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 130869 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 130873 */     // MIs[1] Operand 1
     /* 130873 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 130878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 130882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 130886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 130890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 130894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 130898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 130902 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 130906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 130910 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 130914 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 130918 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 130920 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 130920 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 130923 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 130927 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130932 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 130936 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 130939 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 130942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 130944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 130951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130956 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 130964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 130969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 130971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 130977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 130983 */     GIR_RootConstrainSelectedInstOperands,
     /* 130984 */     // GIR_Coverage, 5307,
     /* 130984 */     GIR_EraseRootFromParent_Done,
     /* 130985 */   // Label 1856: @130985
     /* 130985 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(131145), // Rule ID 5310 //
     /* 130990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 130994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 130998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131002 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131006 */     // MIs[1] Operand 1
     /* 131006 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131023 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 131031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131035 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131039 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131043 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131047 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131051 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131053 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131053 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131056 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131060 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131065 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131069 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 131072 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 131075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131089 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 131093 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 131097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131111 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131114 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131117 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131127 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131134 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131144 */     // GIR_Coverage, 5310,
     /* 131144 */     GIR_EraseRootFromParent_Done,
     /* 131145 */   // Label 1857: @131145
     /* 131145 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(131257), // Rule ID 3777 //
     /* 131150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131162 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131166 */     // MIs[1] Operand 1
     /* 131166 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 131183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 131187 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131191 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131195 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 131199 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131203 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131213 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131225 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 131232 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 131235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 131240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131255 */     GIR_RootConstrainSelectedInstOperands,
     /* 131256 */     // GIR_Coverage, 3777,
     /* 131256 */     GIR_EraseRootFromParent_Done,
     /* 131257 */   // Label 1858: @131257
     /* 131257 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(131396), // Rule ID 3780 //
     /* 131262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131274 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131278 */     // MIs[1] Operand 1
     /* 131278 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131315 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131319 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131323 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131325 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131325 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131328 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131332 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131337 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131341 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 131344 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131361 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131378 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131395 */     // GIR_Coverage, 3780,
     /* 131395 */     GIR_EraseRootFromParent_Done,
     /* 131396 */   // Label 1859: @131396
     /* 131396 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(131529), // Rule ID 3785 //
     /* 131401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131413 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131417 */     // MIs[1] Operand 1
     /* 131417 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 131434 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 131438 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131442 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131446 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 131450 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131454 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131458 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131462 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131464 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131464 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131467 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131471 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131476 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131480 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /* 131483 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 131486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131500 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 131513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 131521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131527 */     GIR_RootConstrainSelectedInstOperands,
     /* 131528 */     // GIR_Coverage, 3785,
     /* 131528 */     GIR_EraseRootFromParent_Done,
     /* 131529 */   // Label 1860: @131529
     /* 131529 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(131689), // Rule ID 3788 //
     /* 131534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131550 */     // MIs[1] Operand 1
     /* 131550 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 131563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 131567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 131571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 131575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 131579 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 131583 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 131587 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 131591 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 131597 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131597 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131600 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 131604 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131609 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 131613 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/64,
     /* 131616 */     GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 131619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 131628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131633 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131637 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 131641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 131650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131671 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131688 */     // GIR_Coverage, 3788,
     /* 131688 */     GIR_EraseRootFromParent_Done,
     /* 131689 */   // Label 1861: @131689
     /* 131689 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(131758), // Rule ID 3697 //
     /* 131694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131706 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131710 */     // MIs[1] Operand 1
     /* 131710 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131715 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131721 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131733 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131737 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131756 */     GIR_RootConstrainSelectedInstOperands,
     /* 131757 */     // GIR_Coverage, 3697,
     /* 131757 */     GIR_EraseRootFromParent_Done,
     /* 131758 */   // Label 1862: @131758
     /* 131758 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(131854), // Rule ID 3700 //
     /* 131763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131775 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131779 */     // MIs[1] Operand 1
     /* 131779 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 131784 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131790 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 131793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 131797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 131815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131820 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131823 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 131826 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 131829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131836 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 131843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 131848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 131853 */     // GIR_Coverage, 3700,
     /* 131853 */     GIR_EraseRootFromParent_Done,
     /* 131854 */   // Label 1863: @131854
     /* 131854 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(131961), // Rule ID 3705 //
     /* 131859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 131871 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 131875 */     // MIs[1] Operand 1
     /* 131875 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131880 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131886 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 131886 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 131889 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131893 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131898 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 131904 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 131907 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 131911 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131916 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 131920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 131922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 131929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131934 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 131937 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 131940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 131945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 131947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/27,
     /* 131953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 131959 */     GIR_RootConstrainSelectedInstOperands,
     /* 131960 */     // GIR_Coverage, 3705,
     /* 131960 */     GIR_EraseRootFromParent_Done,
     /* 131961 */   // Label 1864: @131961
     /* 131961 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(132095), // Rule ID 3708 //
     /* 131966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 131970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 131974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131978 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 131982 */     // MIs[1] Operand 1
     /* 131982 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 131987 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 131991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131993 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 131993 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 131996 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 132000 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132005 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 132011 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132014 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 132018 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132023 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132029 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 132036 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132041 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132044 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 132047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132061 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132064 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/58,
     /* 132067 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132077 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132094 */     // GIR_Coverage, 3708,
     /* 132094 */     GIR_EraseRootFromParent_Done,
     /* 132095 */   // Label 1865: @132095
     /* 132095 */   GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(132147), // Rule ID 3713 //
     /* 132100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132112 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132116 */     // MIs[1] Operand 1
     /* 132116 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132121 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132127 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132145 */     GIR_RootConstrainSelectedInstOperands,
     /* 132146 */     // GIR_Coverage, 3713,
     /* 132146 */     GIR_EraseRootFromParent_Done,
     /* 132147 */   // Label 1866: @132147
     /* 132147 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(132226), // Rule ID 3716 //
     /* 132152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132168 */     // MIs[1] Operand 1
     /* 132168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132173 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132179 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132208 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132225 */     // GIR_Coverage, 3716,
     /* 132225 */     GIR_EraseRootFromParent_Done,
     /* 132226 */   // Label 1867: @132226
     /* 132226 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(132299), // Rule ID 3721 //
     /* 132231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132243 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132247 */     // MIs[1] Operand 1
     /* 132247 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132252 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132258 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 132265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132274 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132297 */     GIR_RootConstrainSelectedInstOperands,
     /* 132298 */     // GIR_Coverage, 3721,
     /* 132298 */     GIR_EraseRootFromParent_Done,
     /* 132299 */   // Label 1868: @132299
     /* 132299 */   GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(132399), // Rule ID 3724 //
     /* 132304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132320 */     // MIs[1] Operand 1
     /* 132320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 132325 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132331 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 132338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132347 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132371 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132381 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132388 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132398 */     // GIR_Coverage, 3724,
     /* 132398 */     GIR_EraseRootFromParent_Done,
     /* 132399 */   // Label 1869: @132399
     /* 132399 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(132489), // Rule ID 3729 //
     /* 132404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132416 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132420 */     // MIs[1] Operand 1
     /* 132420 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132425 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132431 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132431 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132434 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132438 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132443 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 132456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132487 */     GIR_RootConstrainSelectedInstOperands,
     /* 132488 */     // GIR_Coverage, 3729,
     /* 132488 */     GIR_EraseRootFromParent_Done,
     /* 132489 */   // Label 1870: @132489
     /* 132489 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(132606), // Rule ID 3732 //
     /* 132494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132510 */     // MIs[1] Operand 1
     /* 132510 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 132515 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132521 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132521 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132524 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132528 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132533 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132539 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132542 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 132546 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132551 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132554 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132578 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132588 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132595 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132600 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132605 */     // GIR_Coverage, 3732,
     /* 132605 */     GIR_EraseRootFromParent_Done,
     /* 132606 */   // Label 1871: @132606
     /* 132606 */   GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(132696), // Rule ID 3737 //
     /* 132611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132619 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132623 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132627 */     // MIs[1] Operand 1
     /* 132627 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132638 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 132645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 132663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132672 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132694 */     GIR_RootConstrainSelectedInstOperands,
     /* 132695 */     // GIR_Coverage, 3737,
     /* 132695 */     GIR_EraseRootFromParent_Done,
     /* 132696 */   // Label 1872: @132696
     /* 132696 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(132813), // Rule ID 3740 //
     /* 132701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132713 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132717 */     // MIs[1] Operand 1
     /* 132717 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 132722 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 132726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132728 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132728 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132731 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 132735 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132740 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132746 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132749 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 132753 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132758 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132762 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132779 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132785 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 132788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 132795 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 132802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 132807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 132812 */     // GIR_Coverage, 3740,
     /* 132812 */     GIR_EraseRootFromParent_Done,
     /* 132813 */   // Label 1873: @132813
     /* 132813 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(132906), // Rule ID 3745 //
     /* 132818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 132830 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 132834 */     // MIs[1] Operand 1
     /* 132834 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132839 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132845 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 132845 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 132848 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 132852 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132857 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132861 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 132864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 132869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 132873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132882 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 132887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 132890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 132892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 132898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 132904 */     GIR_RootConstrainSelectedInstOperands,
     /* 132905 */     // GIR_Coverage, 3745,
     /* 132905 */     GIR_EraseRootFromParent_Done,
     /* 132906 */   // Label 1874: @132906
     /* 132906 */   GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(133026), // Rule ID 3748 //
     /* 132911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 132915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 132919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132923 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 132927 */     // MIs[1] Operand 1
     /* 132927 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 132932 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 132936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132938 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 132938 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 132941 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 132945 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132950 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132954 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 132957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 132959 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 132962 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 132966 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132971 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 132975 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 132978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 132980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 132983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 132987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132992 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 132995 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 132998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133008 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133025 */     // GIR_Coverage, 3748,
     /* 133025 */     GIR_EraseRootFromParent_Done,
     /* 133026 */   // Label 1875: @133026
     /* 133026 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(133119), // Rule ID 3753 //
     /* 133031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133043 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133047 */     // MIs[1] Operand 1
     /* 133047 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133052 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133058 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 133065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133070 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133074 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 133077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 133086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133091 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133095 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133117 */     GIR_RootConstrainSelectedInstOperands,
     /* 133118 */     // GIR_Coverage, 3753,
     /* 133118 */     GIR_EraseRootFromParent_Done,
     /* 133119 */   // Label 1876: @133119
     /* 133119 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(133239), // Rule ID 3756 //
     /* 133124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133136 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133140 */     // MIs[1] Operand 1
     /* 133140 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133145 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133151 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133151 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 133154 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 133158 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133163 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133167 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 133170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 133172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 133175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 133179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133184 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133188 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 133191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133211 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133221 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133238 */     // GIR_Coverage, 3756,
     /* 133238 */     GIR_EraseRootFromParent_Done,
     /* 133239 */   // Label 1877: @133239
     /* 133239 */   GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(133312), // Rule ID 3761 //
     /* 133244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133256 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133260 */     // MIs[1] Operand 1
     /* 133260 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 133265 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133271 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 133278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133310 */     GIR_RootConstrainSelectedInstOperands,
     /* 133311 */     // GIR_Coverage, 3761,
     /* 133311 */     GIR_EraseRootFromParent_Done,
     /* 133312 */   // Label 1878: @133312
     /* 133312 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(133412), // Rule ID 3764 //
     /* 133317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133329 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133333 */     // MIs[1] Operand 1
     /* 133333 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 133338 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133344 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 133347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 133351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133356 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133360 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133378 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 133381 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133411 */     // GIR_Coverage, 3764,
     /* 133411 */     GIR_EraseRootFromParent_Done,
     /* 133412 */   // Label 1879: @133412
     /* 133412 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(133464), // Rule ID 3769 //
     /* 133417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133425 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133429 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133433 */     // MIs[1] Operand 1
     /* 133433 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133438 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133444 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] })
     /* 133444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 133447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 133449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 133456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 133462 */     GIR_RootConstrainSelectedInstOperands,
     /* 133463 */     // GIR_Coverage, 3769,
     /* 133463 */     GIR_EraseRootFromParent_Done,
     /* 133464 */   // Label 1880: @133464
     /* 133464 */   GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(133543), // Rule ID 3772 //
     /* 133469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133481 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133485 */     // MIs[1] Operand 1
     /* 133485 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133490 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 133494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133496 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 133496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 133499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 133503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133508 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133512 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 133515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /* 133518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 133520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 133525 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 133532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 133537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 133542 */     // GIR_Coverage, 3772,
     /* 133542 */     GIR_EraseRootFromParent_Done,
     /* 133543 */   // Label 1881: @133543
     /* 133543 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(133646), // Rule ID 3036 //
     /* 133548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133563 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133567 */     // MIs[1] Operand 1
     /* 133567 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133580 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133584 */     // MIs[2] Operand 1
     /* 133584 */     // No operand predicates
     /* 133584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133586 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 133586 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133589 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133593 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133619 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133644 */     GIR_RootConstrainSelectedInstOperands,
     /* 133645 */     // GIR_Coverage, 3036,
     /* 133645 */     GIR_EraseRootFromParent_Done,
     /* 133646 */   // Label 1882: @133646
     /* 133646 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(133749), // Rule ID 3052 //
     /* 133651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133666 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133670 */     // MIs[1] Operand 1
     /* 133670 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133683 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133687 */     // MIs[2] Operand 1
     /* 133687 */     // No operand predicates
     /* 133687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133689 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 133689 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133692 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133696 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133701 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133722 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 133729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133734 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133747 */     GIR_RootConstrainSelectedInstOperands,
     /* 133748 */     // GIR_Coverage, 3052,
     /* 133748 */     GIR_EraseRootFromParent_Done,
     /* 133749 */   // Label 1883: @133749
     /* 133749 */   GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(133852), // Rule ID 3060 //
     /* 133754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 133769 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 133773 */     // MIs[1] Operand 1
     /* 133773 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 133778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133786 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 133790 */     // MIs[2] Operand 1
     /* 133790 */     // No operand predicates
     /* 133790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133792 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 133792 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133795 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 133799 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133804 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133825 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 133832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133837 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133850 */     GIR_RootConstrainSelectedInstOperands,
     /* 133851 */     // GIR_Coverage, 3060,
     /* 133851 */     GIR_EraseRootFromParent_Done,
     /* 133852 */   // Label 1884: @133852
     /* 133852 */   GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(133955), // Rule ID 3132 //
     /* 133857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133872 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133876 */     // MIs[1] Operand 1
     /* 133876 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 133881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133893 */     // MIs[2] Operand 1
     /* 133893 */     // No operand predicates
     /* 133893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133895 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 133895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 133898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 133902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133907 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 133911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 133914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 133916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 133919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133928 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 133935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 133940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 133945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 133948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 133950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133953 */     GIR_RootConstrainSelectedInstOperands,
     /* 133954 */     // GIR_Coverage, 3132,
     /* 133954 */     GIR_EraseRootFromParent_Done,
     /* 133955 */   // Label 1885: @133955
     /* 133955 */   GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(134058), // Rule ID 3148 //
     /* 133960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 133963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 133967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 133971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133975 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 133979 */     // MIs[1] Operand 1
     /* 133979 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 133984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 133988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 133992 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 133996 */     // MIs[2] Operand 1
     /* 133996 */     // No operand predicates
     /* 133996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 133998 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 133998 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134001 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134005 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134010 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134031 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134056 */     GIR_RootConstrainSelectedInstOperands,
     /* 134057 */     // GIR_Coverage, 3148,
     /* 134057 */     GIR_EraseRootFromParent_Done,
     /* 134058 */   // Label 1886: @134058
     /* 134058 */   GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(134161), // Rule ID 3156 //
     /* 134063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 134066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134074 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134078 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134082 */     // MIs[1] Operand 1
     /* 134082 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134099 */     // MIs[2] Operand 1
     /* 134099 */     // No operand predicates
     /* 134099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134101 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 134101 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134104 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134108 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134113 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134134 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 134154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 134156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134159 */     GIR_RootConstrainSelectedInstOperands,
     /* 134160 */     // GIR_Coverage, 3156,
     /* 134160 */     GIR_EraseRootFromParent_Done,
     /* 134161 */   // Label 1887: @134161
     /* 134161 */   GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(134304), // Rule ID 3819 //
     /* 134166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134181 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134185 */     // MIs[1] Operand 1
     /* 134185 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 134190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134202 */     // MIs[2] Operand 1
     /* 134202 */     // No operand predicates
     /* 134202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134204 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134204 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134207 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134211 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134216 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134225 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134228 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134232 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134237 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134242 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134245 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134249 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134254 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134271 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134278 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134283 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134302 */     GIR_RootConstrainSelectedInstOperands,
     /* 134303 */     // GIR_Coverage, 3819,
     /* 134303 */     GIR_EraseRootFromParent_Done,
     /* 134304 */   // Label 1888: @134304
     /* 134304 */   GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(134447), // Rule ID 3835 //
     /* 134309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134320 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134324 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134328 */     // MIs[1] Operand 1
     /* 134328 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134345 */     // MIs[2] Operand 1
     /* 134345 */     // No operand predicates
     /* 134345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134347 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134368 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134371 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134375 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134380 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134385 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134388 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134392 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134397 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134414 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134445 */     GIR_RootConstrainSelectedInstOperands,
     /* 134446 */     // GIR_Coverage, 3835,
     /* 134446 */     GIR_EraseRootFromParent_Done,
     /* 134447 */   // Label 1889: @134447
     /* 134447 */   GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(134590), // Rule ID 3843 //
     /* 134452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 134467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 134471 */     // MIs[1] Operand 1
     /* 134471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134484 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 134488 */     // MIs[2] Operand 1
     /* 134488 */     // No operand predicates
     /* 134488 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134490 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134490 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134493 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 134497 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134502 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134511 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134514 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134518 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134523 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134528 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134531 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134535 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134540 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134557 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134564 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134588 */     GIR_RootConstrainSelectedInstOperands,
     /* 134589 */     // GIR_Coverage, 3843,
     /* 134589 */     GIR_EraseRootFromParent_Done,
     /* 134590 */   // Label 1890: @134590
     /* 134590 */   GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(134733), // Rule ID 3915 //
     /* 134595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134610 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134614 */     // MIs[1] Operand 1
     /* 134614 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 134619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134627 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134631 */     // MIs[2] Operand 1
     /* 134631 */     // No operand predicates
     /* 134631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134633 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134633 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134636 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134640 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134654 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134657 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134661 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134666 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134671 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134674 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134678 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134683 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134700 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 134707 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134731 */     GIR_RootConstrainSelectedInstOperands,
     /* 134732 */     // GIR_Coverage, 3915,
     /* 134732 */     GIR_EraseRootFromParent_Done,
     /* 134733 */   // Label 1891: @134733
     /* 134733 */   GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(134876), // Rule ID 3931 //
     /* 134738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134753 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134757 */     // MIs[1] Operand 1
     /* 134757 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 134762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134770 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134774 */     // MIs[2] Operand 1
     /* 134774 */     // No operand predicates
     /* 134774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134776 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134797 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134800 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134804 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134809 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134814 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134817 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134821 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134826 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134843 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 134850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 134860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 134863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 134865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 134871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 134874 */     GIR_RootConstrainSelectedInstOperands,
     /* 134875 */     // GIR_Coverage, 3931,
     /* 134875 */     GIR_EraseRootFromParent_Done,
     /* 134876 */   // Label 1892: @134876
     /* 134876 */   GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(135019), // Rule ID 3939 //
     /* 134881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 134884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 134888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 134892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134896 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 134900 */     // MIs[1] Operand 1
     /* 134900 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 134905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 134909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 134917 */     // MIs[2] Operand 1
     /* 134917 */     // No operand predicates
     /* 134917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134919 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 134919 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 134922 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 134926 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134931 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 134935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 134938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 134940 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 134943 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134947 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134952 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 134955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 134957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 134960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 134964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134969 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 134972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 134974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 134977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134986 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 134993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 134998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 135006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 135008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 135014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 135017 */     GIR_RootConstrainSelectedInstOperands,
     /* 135018 */     // GIR_Coverage, 3939,
     /* 135018 */     GIR_EraseRootFromParent_Done,
     /* 135019 */   // Label 1893: @135019
     /* 135019 */   GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(135111), // Rule ID 3180 //
     /* 135024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135039 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135043 */     // MIs[1] Operand 1
     /* 135043 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135050 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 135050 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135053 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135057 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135062 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135066 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135084 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135109 */     GIR_RootConstrainSelectedInstOperands,
     /* 135110 */     // GIR_Coverage, 3180,
     /* 135110 */     GIR_EraseRootFromParent_Done,
     /* 135111 */   // Label 1894: @135111
     /* 135111 */   GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(135203), // Rule ID 3196 //
     /* 135116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135131 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135135 */     // MIs[1] Operand 1
     /* 135135 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135142 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 135142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135154 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135158 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135176 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135201 */     GIR_RootConstrainSelectedInstOperands,
     /* 135202 */     // GIR_Coverage, 3196,
     /* 135202 */     GIR_EraseRootFromParent_Done,
     /* 135203 */   // Label 1895: @135203
     /* 135203 */   GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(135295), // Rule ID 3212 //
     /* 135208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135223 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135227 */     // MIs[1] Operand 1
     /* 135227 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135234 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 135234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135246 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135250 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135268 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135293 */     GIR_RootConstrainSelectedInstOperands,
     /* 135294 */     // GIR_Coverage, 3212,
     /* 135294 */     GIR_EraseRootFromParent_Done,
     /* 135295 */   // Label 1896: @135295
     /* 135295 */   GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(135387), // Rule ID 3228 //
     /* 135300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 135315 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 135319 */     // MIs[1] Operand 1
     /* 135319 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135326 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 135326 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135329 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 135333 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135338 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135360 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135372 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135385 */     GIR_RootConstrainSelectedInstOperands,
     /* 135386 */     // GIR_Coverage, 3228,
     /* 135386 */     GIR_EraseRootFromParent_Done,
     /* 135387 */   // Label 1897: @135387
     /* 135387 */   GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(135479), // Rule ID 3236 //
     /* 135392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135407 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135411 */     // MIs[1] Operand 1
     /* 135411 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135418 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 135418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135430 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135452 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135477 */     GIR_RootConstrainSelectedInstOperands,
     /* 135478 */     // GIR_Coverage, 3236,
     /* 135478 */     GIR_EraseRootFromParent_Done,
     /* 135479 */   // Label 1898: @135479
     /* 135479 */   GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(135571), // Rule ID 3252 //
     /* 135484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135499 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135503 */     // MIs[1] Operand 1
     /* 135503 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135510 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 135510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135526 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135544 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135551 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135569 */     GIR_RootConstrainSelectedInstOperands,
     /* 135570 */     // GIR_Coverage, 3252,
     /* 135570 */     GIR_EraseRootFromParent_Done,
     /* 135571 */   // Label 1899: @135571
     /* 135571 */   GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(135663), // Rule ID 3268 //
     /* 135576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135591 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135595 */     // MIs[1] Operand 1
     /* 135595 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135602 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 135602 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135605 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135609 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135614 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135636 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 135643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135661 */     GIR_RootConstrainSelectedInstOperands,
     /* 135662 */     // GIR_Coverage, 3268,
     /* 135662 */     GIR_EraseRootFromParent_Done,
     /* 135663 */   // Label 1900: @135663
     /* 135663 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(135755), // Rule ID 3284 //
     /* 135668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 135687 */     // MIs[1] Operand 1
     /* 135687 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 135692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135694 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 135694 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135697 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 135701 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135706 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135710 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135728 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 135735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135753 */     GIR_RootConstrainSelectedInstOperands,
     /* 135754 */     // GIR_Coverage, 3284,
     /* 135754 */     GIR_EraseRootFromParent_Done,
     /* 135755 */   // Label 1901: @135755
     /* 135755 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(135847), // Rule ID 3292 //
     /* 135760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135775 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135779 */     // MIs[1] Operand 1
     /* 135779 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 135784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135786 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 135786 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135789 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135793 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135798 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135820 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 135827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135845 */     GIR_RootConstrainSelectedInstOperands,
     /* 135846 */     // GIR_Coverage, 3292,
     /* 135846 */     GIR_EraseRootFromParent_Done,
     /* 135847 */   // Label 1902: @135847
     /* 135847 */   GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(135939), // Rule ID 3308 //
     /* 135852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135871 */     // MIs[1] Operand 1
     /* 135871 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 135876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135878 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 135878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135890 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135912 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 135919 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 135924 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 135929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 135932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 135934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135937 */     GIR_RootConstrainSelectedInstOperands,
     /* 135938 */     // GIR_Coverage, 3308,
     /* 135938 */     GIR_EraseRootFromParent_Done,
     /* 135939 */   // Label 1903: @135939
     /* 135939 */   GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(136031), // Rule ID 3324 //
     /* 135944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 135947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 135951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 135955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 135959 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 135963 */     // MIs[1] Operand 1
     /* 135963 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 135968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135970 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 135970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 135973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 135977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135982 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 135986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 135990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 135992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 135995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 135999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136004 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136029 */     GIR_RootConstrainSelectedInstOperands,
     /* 136030 */     // GIR_Coverage, 3324,
     /* 136030 */     GIR_EraseRootFromParent_Done,
     /* 136031 */   // Label 1904: @136031
     /* 136031 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(136123), // Rule ID 3340 //
     /* 136036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 136039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 136051 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 136055 */     // MIs[1] Operand 1
     /* 136055 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136062 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 136062 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136065 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 136069 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136074 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136078 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136096 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136108 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 136116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 136118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136121 */     GIR_RootConstrainSelectedInstOperands,
     /* 136122 */     // GIR_Coverage, 3340,
     /* 136122 */     GIR_EraseRootFromParent_Done,
     /* 136123 */   // Label 1905: @136123
     /* 136123 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(136255), // Rule ID 4020 //
     /* 136128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136143 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136147 */     // MIs[1] Operand 1
     /* 136147 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136154 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136154 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136157 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136161 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136166 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136170 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136176 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136179 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136183 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136188 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136193 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136196 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136200 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136205 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136222 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136253 */     GIR_RootConstrainSelectedInstOperands,
     /* 136254 */     // GIR_Coverage, 4020,
     /* 136254 */     GIR_EraseRootFromParent_Done,
     /* 136255 */   // Label 1906: @136255
     /* 136255 */   GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(136387), // Rule ID 4052 //
     /* 136260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136275 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136279 */     // MIs[1] Operand 1
     /* 136279 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 136284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136286 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136298 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136302 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136308 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136311 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136315 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136320 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136337 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136354 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136385 */     GIR_RootConstrainSelectedInstOperands,
     /* 136386 */     // GIR_Coverage, 4052,
     /* 136386 */     GIR_EraseRootFromParent_Done,
     /* 136387 */   // Label 1907: @136387
     /* 136387 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(136519), // Rule ID 4084 //
     /* 136392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136407 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136411 */     // MIs[1] Operand 1
     /* 136411 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136418 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136430 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136434 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136440 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136443 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136447 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136452 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136457 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136460 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136464 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136469 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136486 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 136493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136517 */     GIR_RootConstrainSelectedInstOperands,
     /* 136518 */     // GIR_Coverage, 4084,
     /* 136518 */     GIR_EraseRootFromParent_Done,
     /* 136519 */   // Label 1908: @136519
     /* 136519 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(136651), // Rule ID 4116 //
     /* 136524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 136539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 136543 */     // MIs[1] Operand 1
     /* 136543 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 136548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136550 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 136557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136562 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136566 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136572 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136575 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136579 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136584 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136589 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136592 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136596 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136601 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136618 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 136625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136649 */     GIR_RootConstrainSelectedInstOperands,
     /* 136650 */     // GIR_Coverage, 4116,
     /* 136650 */     GIR_EraseRootFromParent_Done,
     /* 136651 */   // Label 1909: @136651
     /* 136651 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(136783), // Rule ID 4132 //
     /* 136656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136671 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136675 */     // MIs[1] Operand 1
     /* 136675 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 136680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136682 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136682 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136685 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136689 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136698 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136704 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136707 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136711 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136716 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136721 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136724 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136728 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136733 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136750 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 136757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136781 */     GIR_RootConstrainSelectedInstOperands,
     /* 136782 */     // GIR_Coverage, 4132,
     /* 136782 */     GIR_EraseRootFromParent_Done,
     /* 136783 */   // Label 1910: @136783
     /* 136783 */   GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(136915), // Rule ID 4164 //
     /* 136788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136803 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136807 */     // MIs[1] Operand 1
     /* 136807 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 136812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136814 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136814 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136817 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136821 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136826 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136830 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136836 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136839 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136843 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136848 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136853 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136856 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136860 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136865 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 136868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 136870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 136873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 136877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136882 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 136889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 136894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 136899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 136902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 136904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 136907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 136910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 136913 */     GIR_RootConstrainSelectedInstOperands,
     /* 136914 */     // GIR_Coverage, 4164,
     /* 136914 */     GIR_EraseRootFromParent_Done,
     /* 136915 */   // Label 1911: @136915
     /* 136915 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(137047), // Rule ID 4196 //
     /* 136920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 136923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 136927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 136931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 136935 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 136939 */     // MIs[1] Operand 1
     /* 136939 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 136944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136946 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 136946 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 136949 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 136953 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136958 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 136962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 136966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 136968 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 136971 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136975 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136980 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 136983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 136985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 136988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 136992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 136997 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137014 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137045 */     GIR_RootConstrainSelectedInstOperands,
     /* 137046 */     // GIR_Coverage, 4196,
     /* 137046 */     GIR_EraseRootFromParent_Done,
     /* 137047 */   // Label 1912: @137047
     /* 137047 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(137179), // Rule ID 4228 //
     /* 137052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137067 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 137071 */     // MIs[1] Operand 1
     /* 137071 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 137076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137078 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137078 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137081 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 137085 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137090 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137094 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137100 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137103 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137107 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137112 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137117 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137120 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137124 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137129 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137146 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 137153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137177 */     GIR_RootConstrainSelectedInstOperands,
     /* 137178 */     // GIR_Coverage, 4228,
     /* 137178 */     GIR_EraseRootFromParent_Done,
     /* 137179 */   // Label 1913: @137179
     /* 137179 */   GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(137311), // Rule ID 4258 //
     /* 137184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137199 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137203 */     // MIs[1] Operand 1
     /* 137203 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137210 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137222 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137226 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137232 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137235 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137239 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137244 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137249 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137252 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137256 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137261 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137278 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 137285 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137309 */     GIR_RootConstrainSelectedInstOperands,
     /* 137310 */     // GIR_Coverage, 4258,
     /* 137310 */     GIR_EraseRootFromParent_Done,
     /* 137311 */   // Label 1914: @137311
     /* 137311 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(137443), // Rule ID 4290 //
     /* 137316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137331 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137335 */     // MIs[1] Operand 1
     /* 137335 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137342 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137358 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137364 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137367 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137371 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137376 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137381 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137384 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137388 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137393 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137410 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137422 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137441 */     GIR_RootConstrainSelectedInstOperands,
     /* 137442 */     // GIR_Coverage, 4290,
     /* 137442 */     GIR_EraseRootFromParent_Done,
     /* 137443 */   // Label 1915: @137443
     /* 137443 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(137575), // Rule ID 4322 //
     /* 137448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137463 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137467 */     // MIs[1] Operand 1
     /* 137467 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 137472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137474 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137474 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137477 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137481 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137486 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137490 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137496 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137499 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137503 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137508 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137513 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137516 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137520 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137525 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137542 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 137549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137554 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137573 */     GIR_RootConstrainSelectedInstOperands,
     /* 137574 */     // GIR_Coverage, 4322,
     /* 137574 */     GIR_EraseRootFromParent_Done,
     /* 137575 */   // Label 1916: @137575
     /* 137575 */   GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(137707), // Rule ID 4354 //
     /* 137580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 137583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 137595 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 137599 */     // MIs[1] Operand 1
     /* 137599 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 137604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137606 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137606 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137609 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 137613 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137618 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137628 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137631 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137635 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137640 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137657 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137674 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 137681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137705 */     GIR_RootConstrainSelectedInstOperands,
     /* 137706 */     // GIR_Coverage, 4354,
     /* 137706 */     GIR_EraseRootFromParent_Done,
     /* 137707 */   // Label 1917: @137707
     /* 137707 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(137839), // Rule ID 4585 //
     /* 137712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137727 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137731 */     // MIs[1] Operand 1
     /* 137731 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 137736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137738 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137738 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137741 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 137745 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137750 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137754 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137760 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137763 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137767 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137772 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137777 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137780 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137784 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137789 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137806 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137837 */     GIR_RootConstrainSelectedInstOperands,
     /* 137838 */     // GIR_Coverage, 4585,
     /* 137838 */     GIR_EraseRootFromParent_Done,
     /* 137839 */   // Label 1918: @137839
     /* 137839 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(137971), // Rule ID 4617 //
     /* 137844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137859 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137863 */     // MIs[1] Operand 1
     /* 137863 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 137868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137870 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 137870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 137873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 137877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 137886 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 137890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 137892 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 137895 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137899 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137904 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 137907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 137909 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 137912 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 137916 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137921 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 137924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 137926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 137929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137938 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 137945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 137950 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 137955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 137958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 137960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 137966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 137969 */     GIR_RootConstrainSelectedInstOperands,
     /* 137970 */     // GIR_Coverage, 4617,
     /* 137970 */     GIR_EraseRootFromParent_Done,
     /* 137971 */   // Label 1919: @137971
     /* 137971 */   GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(138103), // Rule ID 4649 //
     /* 137976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 137979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 137983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 137987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 137991 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 137995 */     // MIs[1] Operand 1
     /* 137995 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 138000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138002 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 138009 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138014 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138018 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138024 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138027 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138031 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138036 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138053 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138070 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138101 */     GIR_RootConstrainSelectedInstOperands,
     /* 138102 */     // GIR_Coverage, 4649,
     /* 138102 */     GIR_EraseRootFromParent_Done,
     /* 138103 */   // Label 1920: @138103
     /* 138103 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(138235), // Rule ID 4693 //
     /* 138108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138123 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138127 */     // MIs[1] Operand 1
     /* 138127 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 138132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138134 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138134 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138137 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 138141 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138150 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138156 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138159 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138163 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138168 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138173 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138176 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138180 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138185 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138202 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138233 */     GIR_RootConstrainSelectedInstOperands,
     /* 138234 */     // GIR_Coverage, 4693,
     /* 138234 */     GIR_EraseRootFromParent_Done,
     /* 138235 */   // Label 1921: @138235
     /* 138235 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(138367), // Rule ID 4725 //
     /* 138240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138255 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138259 */     // MIs[1] Operand 1
     /* 138259 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 138264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138266 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 138273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138288 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138291 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138295 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138300 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138305 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138308 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138312 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138317 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138334 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138365 */     GIR_RootConstrainSelectedInstOperands,
     /* 138366 */     // GIR_Coverage, 4725,
     /* 138366 */     GIR_EraseRootFromParent_Done,
     /* 138367 */   // Label 1922: @138367
     /* 138367 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(138499), // Rule ID 4757 //
     /* 138372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 138375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 138383 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138387 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138391 */     // MIs[1] Operand 1
     /* 138391 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 138396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138398 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 138398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 138405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138410 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138414 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138420 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 138423 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138427 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138432 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 138435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 138437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 138440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 138444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138449 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 138452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 138454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138466 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 138486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 138488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 138494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 138497 */     GIR_RootConstrainSelectedInstOperands,
     /* 138498 */     // GIR_Coverage, 4757,
     /* 138498 */     GIR_EraseRootFromParent_Done,
     /* 138499 */   // Label 1923: @138499
     /* 138499 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(138591), // Rule ID 2982 //
     /* 138504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138519 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138523 */     // MIs[1] Operand 1
     /* 138523 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138530 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138533 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138537 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138542 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138546 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138564 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138589 */     GIR_RootConstrainSelectedInstOperands,
     /* 138590 */     // GIR_Coverage, 2982,
     /* 138590 */     GIR_EraseRootFromParent_Done,
     /* 138591 */   // Label 1924: @138591
     /* 138591 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(138683), // Rule ID 2996 //
     /* 138596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138611 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138615 */     // MIs[1] Operand 1
     /* 138615 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 138620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138622 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 138622 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138625 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138629 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138634 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138638 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138656 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 138663 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138681 */     GIR_RootConstrainSelectedInstOperands,
     /* 138682 */     // GIR_Coverage, 2996,
     /* 138682 */     GIR_EraseRootFromParent_Done,
     /* 138683 */   // Label 1925: @138683
     /* 138683 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(138775), // Rule ID 3004 //
     /* 138688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138703 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138707 */     // MIs[1] Operand 1
     /* 138707 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 138712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138714 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138714 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138717 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 138721 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138726 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138748 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138755 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138773 */     GIR_RootConstrainSelectedInstOperands,
     /* 138774 */     // GIR_Coverage, 3004,
     /* 138774 */     GIR_EraseRootFromParent_Done,
     /* 138775 */   // Label 1926: @138775
     /* 138775 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(138867), // Rule ID 3012 //
     /* 138780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138795 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138799 */     // MIs[1] Operand 1
     /* 138799 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 138804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138806 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 138806 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138809 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138813 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138818 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138822 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138840 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 138847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138852 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138865 */     GIR_RootConstrainSelectedInstOperands,
     /* 138866 */     // GIR_Coverage, 3012,
     /* 138866 */     GIR_EraseRootFromParent_Done,
     /* 138867 */   // Label 1927: @138867
     /* 138867 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(138959), // Rule ID 3020 //
     /* 138872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 138887 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 138891 */     // MIs[1] Operand 1
     /* 138891 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 138896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138898 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 138898 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138901 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 138905 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138910 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 138914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 138918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 138920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 138923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138932 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 138939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 138944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 138949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 138952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 138954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138957 */     GIR_RootConstrainSelectedInstOperands,
     /* 138958 */     // GIR_Coverage, 3020,
     /* 138958 */     GIR_EraseRootFromParent_Done,
     /* 138959 */   // Label 1928: @138959
     /* 138959 */   GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(139051), // Rule ID 3084 //
     /* 138964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 138967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 138971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 138975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138979 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 138983 */     // MIs[1] Operand 1
     /* 138983 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 138988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138990 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 138990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 138993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 138997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139002 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139006 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139024 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139031 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139049 */     GIR_RootConstrainSelectedInstOperands,
     /* 139050 */     // GIR_Coverage, 3084,
     /* 139050 */     GIR_EraseRootFromParent_Done,
     /* 139051 */   // Label 1929: @139051
     /* 139051 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(139143), // Rule ID 3092 //
     /* 139056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139071 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139075 */     // MIs[1] Operand 1
     /* 139075 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139082 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 139082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139085 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139089 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139094 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139098 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139116 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139141 */     GIR_RootConstrainSelectedInstOperands,
     /* 139142 */     // GIR_Coverage, 3092,
     /* 139142 */     GIR_EraseRootFromParent_Done,
     /* 139143 */   // Label 1930: @139143
     /* 139143 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(139235), // Rule ID 3100 //
     /* 139148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139163 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139167 */     // MIs[1] Operand 1
     /* 139167 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 139172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139174 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 139174 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139177 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 139181 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139190 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139208 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139233 */     GIR_RootConstrainSelectedInstOperands,
     /* 139234 */     // GIR_Coverage, 3100,
     /* 139234 */     GIR_EraseRootFromParent_Done,
     /* 139235 */   // Label 1931: @139235
     /* 139235 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(139327), // Rule ID 3108 //
     /* 139240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139255 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139259 */     // MIs[1] Operand 1
     /* 139259 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 139264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139266 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 139266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139300 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139307 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139325 */     GIR_RootConstrainSelectedInstOperands,
     /* 139326 */     // GIR_Coverage, 3108,
     /* 139326 */     GIR_EraseRootFromParent_Done,
     /* 139327 */   // Label 1932: @139327
     /* 139327 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(139419), // Rule ID 3116 //
     /* 139332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 139335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 139347 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 139351 */     // MIs[1] Operand 1
     /* 139351 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139358 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 139358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 139365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139374 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139392 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 139399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR),
     /* 139412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 139414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139417 */     GIR_RootConstrainSelectedInstOperands,
     /* 139418 */     // GIR_Coverage, 3116,
     /* 139418 */     GIR_EraseRootFromParent_Done,
     /* 139419 */   // Label 1933: @139419
     /* 139419 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(139551), // Rule ID 3867 //
     /* 139424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139439 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139443 */     // MIs[1] Operand 1
     /* 139443 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 139448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139450 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139462 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139466 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139472 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139475 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139479 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139484 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139489 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139492 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139496 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139501 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139518 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139549 */     GIR_RootConstrainSelectedInstOperands,
     /* 139550 */     // GIR_Coverage, 3867,
     /* 139550 */     GIR_EraseRootFromParent_Done,
     /* 139551 */   // Label 1934: @139551
     /* 139551 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(139683), // Rule ID 3875 //
     /* 139556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139571 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139575 */     // MIs[1] Operand 1
     /* 139575 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 139580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139582 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139594 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139598 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139604 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139607 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139611 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139616 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139633 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139650 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 139657 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139681 */     GIR_RootConstrainSelectedInstOperands,
     /* 139682 */     // GIR_Coverage, 3875,
     /* 139682 */     GIR_EraseRootFromParent_Done,
     /* 139683 */   // Label 1935: @139683
     /* 139683 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(139815), // Rule ID 3883 //
     /* 139688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139703 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139707 */     // MIs[1] Operand 1
     /* 139707 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 139712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139714 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139714 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139717 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 139721 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139726 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139736 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139739 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139743 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139748 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139753 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139756 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139760 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139765 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139782 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139813 */     GIR_RootConstrainSelectedInstOperands,
     /* 139814 */     // GIR_Coverage, 3883,
     /* 139814 */     GIR_EraseRootFromParent_Done,
     /* 139815 */   // Label 1936: @139815
     /* 139815 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(139947), // Rule ID 3891 //
     /* 139820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139835 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139839 */     // MIs[1] Operand 1
     /* 139839 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 139844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139846 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139858 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139862 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 139868 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 139871 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139875 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139880 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 139883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 139885 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 139888 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 139892 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139897 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 139900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 139902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 139905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139914 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 139921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 139926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 139931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 139934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 139936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 139942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 139945 */     GIR_RootConstrainSelectedInstOperands,
     /* 139946 */     // GIR_Coverage, 3891,
     /* 139946 */     GIR_EraseRootFromParent_Done,
     /* 139947 */   // Label 1937: @139947
     /* 139947 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(140079), // Rule ID 3899 //
     /* 139952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 139955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 139959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 139963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 139967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 139971 */     // MIs[1] Operand 1
     /* 139971 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 139976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139978 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 139978 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 139981 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 139985 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139990 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 139994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 139998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140000 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140003 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140007 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140012 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140017 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140020 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140024 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140029 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140046 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 140053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140077 */     GIR_RootConstrainSelectedInstOperands,
     /* 140078 */     // GIR_Coverage, 3899,
     /* 140078 */     GIR_EraseRootFromParent_Done,
     /* 140079 */   // Label 1938: @140079
     /* 140079 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(140211), // Rule ID 3963 //
     /* 140084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140103 */     // MIs[1] Operand 1
     /* 140103 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 140108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140110 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140110 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140113 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 140117 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140122 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140126 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140132 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140135 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140139 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140144 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140149 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140152 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140156 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140161 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140178 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 140185 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140190 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140209 */     GIR_RootConstrainSelectedInstOperands,
     /* 140210 */     // GIR_Coverage, 3963,
     /* 140210 */     GIR_EraseRootFromParent_Done,
     /* 140211 */   // Label 1939: @140211
     /* 140211 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(140343), // Rule ID 3971 //
     /* 140216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140231 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140235 */     // MIs[1] Operand 1
     /* 140235 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 140240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140242 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140242 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140245 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140249 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140254 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140258 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140264 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140267 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140271 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140276 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140281 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140284 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140288 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140293 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140310 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 140317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140341 */     GIR_RootConstrainSelectedInstOperands,
     /* 140342 */     // GIR_Coverage, 3971,
     /* 140342 */     GIR_EraseRootFromParent_Done,
     /* 140343 */   // Label 1940: @140343
     /* 140343 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(140475), // Rule ID 3979 //
     /* 140348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140363 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140367 */     // MIs[1] Operand 1
     /* 140367 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 140372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140374 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 140381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140396 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140399 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140403 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140408 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140413 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140416 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140420 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140425 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140442 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140454 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140473 */     GIR_RootConstrainSelectedInstOperands,
     /* 140474 */     // GIR_Coverage, 3979,
     /* 140474 */     GIR_EraseRootFromParent_Done,
     /* 140475 */   // Label 1941: @140475
     /* 140475 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(140607), // Rule ID 3987 //
     /* 140480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140499 */     // MIs[1] Operand 1
     /* 140499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 140504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140506 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140518 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140522 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140528 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140531 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140535 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140540 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140557 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140574 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 140581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140605 */     GIR_RootConstrainSelectedInstOperands,
     /* 140606 */     // GIR_Coverage, 3987,
     /* 140606 */     GIR_EraseRootFromParent_Done,
     /* 140607 */   // Label 1942: @140607
     /* 140607 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(140739), // Rule ID 3995 //
     /* 140612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 140615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140627 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140631 */     // MIs[1] Operand 1
     /* 140631 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140638 */     // (zext:{ *:[i32] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I4:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }), (LI:{ *:[i32] } 1:{ *:[i32] }))
     /* 140638 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140641 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 140645 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 140654 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 140658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140660 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 140663 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140667 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140672 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 140675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 140677 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 140680 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140684 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140689 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 140692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 140694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 140697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140706 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 140713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 140718 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 140723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 140734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 140737 */     GIR_RootConstrainSelectedInstOperands,
     /* 140738 */     // GIR_Coverage, 3995,
     /* 140738 */     GIR_EraseRootFromParent_Done,
     /* 140739 */   // Label 1943: @140739
     /* 140739 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(140754), // Rule ID 2988 //
     /* 140744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 140747 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SETBC:{ *:[i32] } ?:{ *:[i1] }:$in)
     /* 140747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC),
     /* 140752 */     GIR_RootConstrainSelectedInstOperands,
     /* 140753 */     // GIR_Coverage, 2988,
     /* 140753 */     GIR_Done,
     /* 140754 */   // Label 1944: @140754
     /* 140754 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(140808), // Rule ID 3673 //
     /* 140759 */     // (zext:{ *:[i32] } i1:{ *:[i1] }:$in)  =>  (SELECT_I4:{ *:[i32] } ?:{ *:[i1] }:$in, (LI:{ *:[i32] } 1:{ *:[i32] }), (LI:{ *:[i32] } 0:{ *:[i32] }))
     /* 140759 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 140762 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140766 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140771 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 140774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 140776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI),
     /* 140783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 140791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 140796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 140798 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 140800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 140806 */     GIR_RootConstrainSelectedInstOperands,
     /* 140807 */     // GIR_Coverage, 3673,
     /* 140807 */     GIR_EraseRootFromParent_Done,
     /* 140808 */   // Label 1945: @140808
     /* 140808 */   GIM_Reject,
     /* 140809 */ // Label 1853: @140809
     /* 140809 */ GIM_Reject,
     /* 140810 */ // Label 1851: @140810
     /* 140810 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(140926), // Rule ID 5300 //
     /* 140815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140822 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140826 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140830 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140834 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 140838 */   // MIs[1] Operand 1
     /* 140838 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140843 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140847 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140851 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 140855 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140859 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140863 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140867 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 140871 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140875 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140879 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140883 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140885 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 140885 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140888 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 140892 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140897 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 140901 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 140904 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 140907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 140912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 140914 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 140918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 140924 */   GIR_RootConstrainSelectedInstOperands,
     /* 140925 */   // GIR_Coverage, 5300,
     /* 140925 */   GIR_EraseRootFromParent_Done,
     /* 140926 */ // Label 1946: @140926
     /* 140926 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(141096), // Rule ID 5301 //
     /* 140931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 140934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 140938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 140942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 140946 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 140950 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 140954 */   // MIs[1] Operand 1
     /* 140954 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 140959 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140963 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 140967 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 140971 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 140975 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 140979 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 140983 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 140987 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 140991 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 140995 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 140999 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141001 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141001 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141004 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141008 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141013 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141017 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 141020 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 141023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141025 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141028 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141032 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141037 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141041 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141044 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141047 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141071 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141080 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141095 */   // GIR_Coverage, 5301,
     /* 141095 */   GIR_EraseRootFromParent_Done,
     /* 141096 */ // Label 1947: @141096
     /* 141096 */ GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(141233), // Rule ID 5308 //
     /* 141101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141116 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141120 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141124 */   // MIs[1] Operand 1
     /* 141124 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141129 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141133 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141137 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141141 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141145 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 141149 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141153 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141157 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141161 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141165 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141169 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141171 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa), i64:{ *:[i64] }:$s1), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141183 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141187 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 141190 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 141193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141211 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141225 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141231 */   GIR_RootConstrainSelectedInstOperands,
     /* 141232 */   // GIR_Coverage, 5308,
     /* 141232 */   GIR_EraseRootFromParent_Done,
     /* 141233 */ // Label 1948: @141233
     /* 141233 */ GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(141424), // Rule ID 5309 //
     /* 141238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141245 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141249 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141253 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141257 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141261 */   // MIs[1] Operand 1
     /* 141261 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141266 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141270 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141274 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141278 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141282 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 141286 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141290 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141294 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141298 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141302 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141306 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141308 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa), i32:{ *:[i32] }:$s1), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141308 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141311 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141315 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141320 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141324 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141327 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141332 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141335 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141339 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141344 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141348 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/2, // s1
     /* 141352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141354 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141357 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141361 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141366 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141369 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141372 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141375 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141394 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141397 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141408 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141413 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141423 */   // GIR_Coverage, 5309,
     /* 141423 */   GIR_EraseRootFromParent_Done,
     /* 141424 */ // Label 1949: @141424
     /* 141424 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(141540), // Rule ID 3778 //
     /* 141429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141448 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141452 */   // MIs[1] Operand 1
     /* 141452 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141457 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141461 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141465 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141469 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141473 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141477 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141481 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141485 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141489 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141493 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141497 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141499 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141499 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 141502 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141506 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141511 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141515 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/64,
     /* 141518 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for PPC::CARRY*/0,
     /* 141521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141528 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141538 */   GIR_RootConstrainSelectedInstOperands,
     /* 141539 */   // GIR_Coverage, 3778,
     /* 141539 */   GIR_EraseRootFromParent_Done,
     /* 141540 */ // Label 1950: @141540
     /* 141540 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(141710), // Rule ID 3779 //
     /* 141545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141552 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141556 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141560 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141564 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141568 */   // MIs[1] Operand 1
     /* 141568 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 141573 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141577 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141581 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141585 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141589 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141593 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141597 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141601 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141605 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141609 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141613 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141615 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$s1, (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141615 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141618 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141622 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141627 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141631 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/32,
     /* 141634 */   GIR_SetImplicitDefDead, /*InsnID*/3, /*OpIdx for PPC::CARRY*/0,
     /* 141637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141651 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141655 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141658 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141661 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 141673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 141683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 141685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 141694 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 141709 */   // GIR_Coverage, 3779,
     /* 141709 */   GIR_EraseRootFromParent_Done,
     /* 141710 */ // Label 1951: @141710
     /* 141710 */ GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(141847), // Rule ID 3786 //
     /* 141715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141722 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141726 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141730 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 141734 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 141738 */   // MIs[1] Operand 1
     /* 141738 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141743 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141747 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141751 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 141755 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 141759 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141763 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141767 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 141771 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141775 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141779 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141783 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141785 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i64] } i64:{ *:[i64] }:$s1, (shl:{ *:[i64] } 1:{ *:[i64] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDCL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 64:{ *:[i32] }), 63:{ *:[i32] })
     /* 141785 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141788 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141792 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141797 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141801 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/64,
     /* 141804 */   GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for PPC::CARRY*/0,
     /* 141807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 141816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141821 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141825 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 141831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 141834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 141836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141839 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 141842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 141845 */   GIR_RootConstrainSelectedInstOperands,
     /* 141846 */   // GIR_Coverage, 3786,
     /* 141846 */   GIR_EraseRootFromParent_Done,
     /* 141847 */ // Label 1952: @141847
     /* 141847 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(142038), // Rule ID 3787 //
     /* 141852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 141855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 141859 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 141863 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 141867 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 141871 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 141875 */   // MIs[1] Operand 1
     /* 141875 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 141880 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 141884 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 141888 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 141892 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 141896 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 141900 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 141904 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 141908 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 141912 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 141916 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 141920 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 141922 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } (and:{ *:[i32] } i32:{ *:[i32] }:$s1, (shl:{ *:[i32] } 1:{ *:[i32] }, i32:{ *:[i32] }:$sa)), 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWNM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), (SUBFIC:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$sa, 32:{ *:[i32] }), 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 141922 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 141925 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::SUBFIC),
     /* 141929 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141934 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/3, /*OpIdx*/2, // sa
     /* 141938 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/32,
     /* 141941 */   GIR_SetImplicitDefDead, /*InsnID*/4, /*OpIdx for PPC::CARRY*/0,
     /* 141944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 141946 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 141949 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 141953 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141958 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141962 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // s1
     /* 141966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 141968 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 141971 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 141975 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141980 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 141983 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 141986 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141989 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 141992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 141994 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 141997 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142001 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142013 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142022 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142037 */   // GIR_Coverage, 3787,
     /* 142037 */   GIR_EraseRootFromParent_Done,
     /* 142038 */ // Label 1953: @142038
     /* 142038 */ GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(142121), // Rule ID 3357 //
     /* 142043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 142046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 142049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 142061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 142065 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142069 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 142073 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 142077 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 142081 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 142085 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 142087 */   // (zext:{ *:[i64] } (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] }))  =>  (RLDICL_32_64:{ *:[i64] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 142087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 142090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 142094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142099 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // RS
     /* 142103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32_64),
     /* 142108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 142116 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 142119 */   GIR_RootConstrainSelectedInstOperands,
     /* 142120 */   // GIR_Coverage, 3357,
     /* 142120 */   GIR_EraseRootFromParent_Done,
     /* 142121 */ // Label 1954: @142121
     /* 142121 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(142194), // Rule ID 3698 //
     /* 142126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142133 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142137 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142141 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142145 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142149 */   // MIs[1] Operand 1
     /* 142149 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 142154 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142158 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142160 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETEQ:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 142160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142172 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 142189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142192 */   GIR_RootConstrainSelectedInstOperands,
     /* 142193 */   // GIR_Coverage, 3698,
     /* 142193 */   GIR_EraseRootFromParent_Done,
     /* 142194 */ // Label 1955: @142194
     /* 142194 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(142321), // Rule ID 3699 //
     /* 142199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142206 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142210 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142214 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142218 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142222 */   // MIs[1] Operand 1
     /* 142222 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 142227 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142231 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142233 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETEQ:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142233 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142236 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142240 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142245 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142249 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142251 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142254 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142258 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142263 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142266 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 142269 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142272 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142305 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142310 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142320 */   // GIR_Coverage, 3699,
     /* 142320 */   GIR_EraseRootFromParent_Done,
     /* 142321 */ // Label 1956: @142321
     /* 142321 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(142432), // Rule ID 3706 //
     /* 142326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142333 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142337 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142341 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142345 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142349 */   // MIs[1] Operand 1
     /* 142349 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142354 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142360 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETNE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1), (CNTLZD:{ *:[i64] } ?:{ *:[i64] }:$s1)), 58:{ *:[i32] }, 63:{ *:[i32] })
     /* 142360 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 142363 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142367 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142372 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142378 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 142381 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 142385 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142390 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142408 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 142411 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 142414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/58,
     /* 142427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142430 */   GIR_RootConstrainSelectedInstOperands,
     /* 142431 */   // GIR_Coverage, 3706,
     /* 142431 */   GIR_EraseRootFromParent_Done,
     /* 142432 */ // Label 1957: @142432
     /* 142432 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(142597), // Rule ID 3707 //
     /* 142437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142452 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142456 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142460 */   // MIs[1] Operand 1
     /* 142460 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 142465 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142471 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETNE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1), (CNTLZW:{ *:[i32] } ?:{ *:[i32] }:$s1)), 27:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142471 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 142474 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142478 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142483 */   GIR_Copy, /*NewInsnID*/5, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 142489 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 142492 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 142496 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142501 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 142507 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142510 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142514 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142519 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 142522 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 142525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142527 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142530 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142534 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142539 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142542 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/27,
     /* 142545 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142548 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142572 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142586 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142596 */   // GIR_Coverage, 3707,
     /* 142596 */   GIR_EraseRootFromParent_Done,
     /* 142597 */ // Label 1958: @142597
     /* 142597 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(142653), // Rule ID 3714 //
     /* 142602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142617 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142621 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142625 */   // MIs[1] Operand 1
     /* 142625 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142630 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142634 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142636 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142641 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142651 */   GIR_RootConstrainSelectedInstOperands,
     /* 142652 */   // GIR_Coverage, 3714,
     /* 142652 */   GIR_EraseRootFromParent_Done,
     /* 142653 */ // Label 1959: @142653
     /* 142653 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(142763), // Rule ID 3715 //
     /* 142658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142665 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142669 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142673 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142677 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142681 */   // MIs[1] Operand 1
     /* 142681 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 142686 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142692 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142692 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142695 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142699 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142704 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142708 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142711 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142714 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142762 */   // GIR_Coverage, 3715,
     /* 142762 */   GIR_EraseRootFromParent_Done,
     /* 142763 */ // Label 1960: @142763
     /* 142763 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(142840), // Rule ID 3722 //
     /* 142768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142775 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142779 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142783 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142787 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142791 */   // MIs[1] Operand 1
     /* 142791 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142796 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142800 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142802 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 142802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 142809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142814 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142818 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142822 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 142827 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 142829 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 142838 */   GIR_RootConstrainSelectedInstOperands,
     /* 142839 */   // GIR_Coverage, 3722,
     /* 142839 */   GIR_EraseRootFromParent_Done,
     /* 142840 */ // Label 1961: @142840
     /* 142840 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(142971), // Rule ID 3723 //
     /* 142845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142852 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142856 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142860 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 142864 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 142868 */   // MIs[1] Operand 1
     /* 142868 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 142873 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 142877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 142879 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 142879 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 142882 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 142886 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142891 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142895 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 142899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 142901 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 142904 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 142908 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142913 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 142916 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 142919 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142922 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 142925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 142927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 142930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 142934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 142939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 142941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 142944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 142946 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 142949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 142952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 142955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 142970 */   // GIR_Coverage, 3723,
     /* 142970 */   GIR_EraseRootFromParent_Done,
     /* 142971 */ // Label 1962: @142971
     /* 142971 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(143065), // Rule ID 3730 //
     /* 142976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 142979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 142983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 142987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 142991 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 142995 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 142999 */   // MIs[1] Operand 1
     /* 142999 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143004 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143008 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143010 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ANDC8:{ *:[i64] } (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1), ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 143017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143022 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ANDC8),
     /* 143035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143043 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143054 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143063 */   GIR_RootConstrainSelectedInstOperands,
     /* 143064 */   // GIR_Coverage, 3730,
     /* 143064 */   GIR_EraseRootFromParent_Done,
     /* 143065 */ // Label 1963: @143065
     /* 143065 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(143213), // Rule ID 3731 //
     /* 143070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143085 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143089 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143093 */   // MIs[1] Operand 1
     /* 143093 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143098 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143104 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ANDC:{ *:[i32] } (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1), ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143104 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143107 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 143111 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143116 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143122 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143125 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ANDC),
     /* 143129 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143134 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143137 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143143 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143146 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143150 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143155 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143158 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143161 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143164 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143169 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143172 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143176 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143207 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143212 */   // GIR_Coverage, 3731,
     /* 143212 */   GIR_EraseRootFromParent_Done,
     /* 143213 */ // Label 1964: @143213
     /* 143213 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(143307), // Rule ID 3738 //
     /* 143218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143233 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143237 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143241 */   // MIs[1] Operand 1
     /* 143241 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143246 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143250 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143252 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, 0:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (ORC8:{ *:[i64] } ?:{ *:[i64] }:$s1, (NEG8:{ *:[i64] } ?:{ *:[i64] }:$s1)), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143252 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143255 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::NEG8),
     /* 143259 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143264 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::ORC8),
     /* 143277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143282 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143286 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143305 */   GIR_RootConstrainSelectedInstOperands,
     /* 143306 */   // GIR_Coverage, 3738,
     /* 143306 */   GIR_EraseRootFromParent_Done,
     /* 143307 */ // Label 1965: @143307
     /* 143307 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(143455), // Rule ID 3739 //
     /* 143312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143327 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143331 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143335 */   // MIs[1] Operand 1
     /* 143335 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 143340 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 143344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143346 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, 0:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (ORC:{ *:[i32] } ?:{ *:[i32] }:$s1, (NEG:{ *:[i32] } ?:{ *:[i32] }:$s1)), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::NEG),
     /* 143353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143358 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143364 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143367 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::ORC),
     /* 143371 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143376 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143380 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143385 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143388 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143392 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143397 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143400 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143403 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143406 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143423 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143439 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143454 */   // GIR_Coverage, 3739,
     /* 143454 */   GIR_EraseRootFromParent_Done,
     /* 143455 */ // Label 1966: @143455
     /* 143455 */ GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(143552), // Rule ID 3746 //
     /* 143460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143483 */   // MIs[1] Operand 1
     /* 143483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143488 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143492 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143494 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (AND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143494 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143497 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143501 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143506 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143510 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143515 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143518 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 143522 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143527 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143531 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143550 */   GIR_RootConstrainSelectedInstOperands,
     /* 143551 */   // GIR_Coverage, 3746,
     /* 143551 */   GIR_EraseRootFromParent_Done,
     /* 143552 */ // Label 1967: @143552
     /* 143552 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(143703), // Rule ID 3747 //
     /* 143557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143564 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143568 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143572 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143576 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143580 */   // MIs[1] Operand 1
     /* 143580 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 143585 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143589 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143591 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (AND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143591 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143594 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143598 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143603 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143607 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143612 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143615 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 143619 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143624 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143628 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143633 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143636 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143640 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143645 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143648 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143651 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143654 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143678 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143684 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143692 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143702 */   // GIR_Coverage, 3747,
     /* 143702 */   GIR_EraseRootFromParent_Done,
     /* 143703 */ // Label 1968: @143703
     /* 143703 */ GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(143800), // Rule ID 3754 //
     /* 143708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143715 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143719 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143723 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143727 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143731 */   // MIs[1] Operand 1
     /* 143731 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143736 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143742 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NAND8:{ *:[i64] } ?:{ *:[i64] }:$s1, (ADDI8:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i64] })), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 143745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::ADDI8),
     /* 143749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143758 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143761 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NAND8),
     /* 143770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143775 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143779 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 143782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 143787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 143789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 143798 */   GIR_RootConstrainSelectedInstOperands,
     /* 143799 */   // GIR_Coverage, 3754,
     /* 143799 */   GIR_EraseRootFromParent_Done,
     /* 143800 */ // Label 1969: @143800
     /* 143800 */ GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(143951), // Rule ID 3755 //
     /* 143805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143820 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 143824 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 143828 */   // MIs[1] Operand 1
     /* 143828 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 143833 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143837 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143839 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NAND:{ *:[i32] } ?:{ *:[i32] }:$s1, (ADDI:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] })), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 143839 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 143842 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::ADDI),
     /* 143846 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143851 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143855 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 143858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 143860 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 143863 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NAND),
     /* 143867 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143872 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 143876 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 143879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 143881 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 143884 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 143888 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143893 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 143896 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 143899 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143902 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 143905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 143907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 143914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 143924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 143926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 143932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 143935 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143940 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143945 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 143950 */   // GIR_Coverage, 3755,
     /* 143950 */   GIR_EraseRootFromParent_Done,
     /* 143951 */ // Label 1970: @143951
     /* 143951 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(144028), // Rule ID 3762 //
     /* 143956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 143959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 143963 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 143967 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 143971 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 143975 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 143979 */   // MIs[1] Operand 1
     /* 143979 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 143984 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 143988 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 143990 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETGT:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } (NOR8:{ *:[i64] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s1), 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 143990 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 143993 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::NOR8),
     /* 143997 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144002 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144006 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144010 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 144015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 144017 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 144026 */   GIR_RootConstrainSelectedInstOperands,
     /* 144027 */   // GIR_Coverage, 3762,
     /* 144027 */   GIR_EraseRootFromParent_Done,
     /* 144028 */ // Label 1971: @144028
     /* 144028 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(144159), // Rule ID 3763 //
     /* 144033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144048 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144052 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144056 */   // MIs[1] Operand 1
     /* 144056 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 144061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144067 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETGT:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } (NOR:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s1), 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 144067 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 144070 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::NOR),
     /* 144074 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144079 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144083 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 144089 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144092 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 144096 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144101 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 144104 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 144107 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144110 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144115 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 144118 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144122 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144127 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144132 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 144140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144148 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144153 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 144158 */   // GIR_Coverage, 3763,
     /* 144158 */   GIR_EraseRootFromParent_Done,
     /* 144159 */ // Label 1972: @144159
     /* 144159 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(144215), // Rule ID 3770 //
     /* 144164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144171 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144175 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144179 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144183 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144187 */   // MIs[1] Operand 1
     /* 144187 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144192 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144198 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, -1:{ *:[i64] }, SETLE:{ *:[Other] }))  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$s1, 1:{ *:[i32] }, 63:{ *:[i32] })
     /* 144198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 144201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 144203 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144207 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 144213 */   GIR_RootConstrainSelectedInstOperands,
     /* 144214 */   // GIR_Coverage, 3770,
     /* 144214 */   GIR_EraseRootFromParent_Done,
     /* 144215 */ // Label 1973: @144215
     /* 144215 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(144325), // Rule ID 3771 //
     /* 144220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144239 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144243 */   // MIs[1] Operand 1
     /* 144243 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144248 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 144252 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 144254 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, -1:{ *:[i32] }, SETLE:{ *:[Other] }))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$s1, 1:{ *:[i32] }, 31:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] })
     /* 144254 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144257 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 144261 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144266 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144270 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 144273 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144276 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 144279 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 144284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 144288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144293 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 144298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 144300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 144306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 144309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144319 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 144324 */   // GIR_Coverage, 3771,
     /* 144324 */   GIR_EraseRootFromParent_Done,
     /* 144325 */ // Label 1974: @144325
     /* 144325 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(144435), // Rule ID 3037 //
     /* 144330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144340 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144344 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144348 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144352 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144356 */   // MIs[1] Operand 1
     /* 144356 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144361 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144365 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144369 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144373 */   // MIs[2] Operand 1
     /* 144373 */   // No operand predicates
     /* 144373 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144375 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 144375 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144378 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144382 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144387 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144391 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144396 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144399 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144403 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144408 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144433 */   GIR_RootConstrainSelectedInstOperands,
     /* 144434 */   // GIR_Coverage, 3037,
     /* 144434 */   GIR_EraseRootFromParent_Done,
     /* 144435 */ // Label 1975: @144435
     /* 144435 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(144545), // Rule ID 3053 //
     /* 144440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144450 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144462 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144466 */   // MIs[1] Operand 1
     /* 144466 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144471 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144475 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144479 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144483 */   // MIs[2] Operand 1
     /* 144483 */   // No operand predicates
     /* 144483 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144485 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 144485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144497 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144518 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144543 */   GIR_RootConstrainSelectedInstOperands,
     /* 144544 */   // GIR_Coverage, 3053,
     /* 144544 */   GIR_EraseRootFromParent_Done,
     /* 144545 */ // Label 1976: @144545
     /* 144545 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(144655), // Rule ID 3061 //
     /* 144550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144560 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144564 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144568 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 144572 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 144576 */   // MIs[1] Operand 1
     /* 144576 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144581 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144585 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144589 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 144593 */   // MIs[2] Operand 1
     /* 144593 */   // No operand predicates
     /* 144593 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144595 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 144595 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144598 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 144602 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144607 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144611 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144628 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144635 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144640 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144653 */   GIR_RootConstrainSelectedInstOperands,
     /* 144654 */   // GIR_Coverage, 3061,
     /* 144654 */   GIR_EraseRootFromParent_Done,
     /* 144655 */ // Label 1977: @144655
     /* 144655 */ GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(144765), // Rule ID 3133 //
     /* 144660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144670 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144674 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144678 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144682 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144686 */   // MIs[1] Operand 1
     /* 144686 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 144691 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144695 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144699 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144703 */   // MIs[2] Operand 1
     /* 144703 */   // No operand predicates
     /* 144703 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144705 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 144705 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144708 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144712 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144717 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144738 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 144745 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144750 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144763 */   GIR_RootConstrainSelectedInstOperands,
     /* 144764 */   // GIR_Coverage, 3133,
     /* 144764 */   GIR_EraseRootFromParent_Done,
     /* 144765 */ // Label 1978: @144765
     /* 144765 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(144875), // Rule ID 3149 //
     /* 144770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144780 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144784 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144788 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144792 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144796 */   // MIs[1] Operand 1
     /* 144796 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 144801 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144805 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144809 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144813 */   // MIs[2] Operand 1
     /* 144813 */   // No operand predicates
     /* 144813 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144815 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 144815 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144818 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144822 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144827 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144831 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144848 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 144855 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144873 */   GIR_RootConstrainSelectedInstOperands,
     /* 144874 */   // GIR_Coverage, 3149,
     /* 144874 */   GIR_EraseRootFromParent_Done,
     /* 144875 */ // Label 1979: @144875
     /* 144875 */ GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(144985), // Rule ID 3157 //
     /* 144880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 144883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 144890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 144894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 144898 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 144902 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 144906 */   // MIs[1] Operand 1
     /* 144906 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 144911 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 144915 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 144919 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 144923 */   // MIs[2] Operand 1
     /* 144923 */   // No operand predicates
     /* 144923 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 144925 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 144925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 144928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 144932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144937 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 144941 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 144944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 144946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 144949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 144953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144958 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 144965 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 144970 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 144975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 144978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 144980 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144983 */   GIR_RootConstrainSelectedInstOperands,
     /* 144984 */   // GIR_Coverage, 3157,
     /* 144984 */   GIR_EraseRootFromParent_Done,
     /* 144985 */ // Label 1980: @144985
     /* 144985 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(145135), // Rule ID 3821 //
     /* 144990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 144993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 144996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145000 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145008 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145012 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145016 */   // MIs[1] Operand 1
     /* 145016 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 145021 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145025 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145029 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145033 */   // MIs[2] Operand 1
     /* 145033 */   // No operand predicates
     /* 145033 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145035 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145047 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145051 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145056 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145059 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145063 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145068 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145073 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145076 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145080 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145085 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145102 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145109 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145114 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145133 */   GIR_RootConstrainSelectedInstOperands,
     /* 145134 */   // GIR_Coverage, 3821,
     /* 145134 */   GIR_EraseRootFromParent_Done,
     /* 145135 */ // Label 1981: @145135
     /* 145135 */ GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(145285), // Rule ID 3837 //
     /* 145140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145150 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145154 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145158 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145162 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145166 */   // MIs[1] Operand 1
     /* 145166 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 145171 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145175 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145179 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145183 */   // MIs[2] Operand 1
     /* 145183 */   // No operand predicates
     /* 145183 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145185 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145185 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145188 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145192 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145197 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145201 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145206 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145209 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145213 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145218 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145223 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145226 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145230 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145235 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145240 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145243 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145247 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145252 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145259 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145264 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145277 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145283 */   GIR_RootConstrainSelectedInstOperands,
     /* 145284 */   // GIR_Coverage, 3837,
     /* 145284 */   GIR_EraseRootFromParent_Done,
     /* 145285 */ // Label 1982: @145285
     /* 145285 */ GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(145435), // Rule ID 3845 //
     /* 145290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145300 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145304 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145308 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145312 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145316 */   // MIs[1] Operand 1
     /* 145316 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145321 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145325 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145329 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 145333 */   // MIs[2] Operand 1
     /* 145333 */   // No operand predicates
     /* 145333 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145335 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145335 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145338 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 145342 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145347 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145351 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145356 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145359 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145363 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145368 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145373 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145376 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145380 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145385 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145388 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145402 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145409 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145414 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145424 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145433 */   GIR_RootConstrainSelectedInstOperands,
     /* 145434 */   // GIR_Coverage, 3845,
     /* 145434 */   GIR_EraseRootFromParent_Done,
     /* 145435 */ // Label 1983: @145435
     /* 145435 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(145585), // Rule ID 3917 //
     /* 145440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145450 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145458 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145462 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145466 */   // MIs[1] Operand 1
     /* 145466 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 145471 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145475 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145479 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145483 */   // MIs[2] Operand 1
     /* 145483 */   // No operand predicates
     /* 145483 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145485 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145497 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145501 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145506 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145509 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145513 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145518 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145523 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145526 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145530 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145535 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145552 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145559 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145564 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145583 */   GIR_RootConstrainSelectedInstOperands,
     /* 145584 */   // GIR_Coverage, 3917,
     /* 145584 */   GIR_EraseRootFromParent_Done,
     /* 145585 */ // Label 1984: @145585
     /* 145585 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(145735), // Rule ID 3933 //
     /* 145590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145612 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145616 */   // MIs[1] Operand 1
     /* 145616 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 145621 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145625 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145629 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145633 */   // MIs[2] Operand 1
     /* 145633 */   // No operand predicates
     /* 145633 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145635 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145635 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145638 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145642 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145647 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145651 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145656 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145659 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145663 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145668 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145673 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145676 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145680 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145685 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145690 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145693 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145697 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145702 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 145709 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145714 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145733 */   GIR_RootConstrainSelectedInstOperands,
     /* 145734 */   // GIR_Coverage, 3933,
     /* 145734 */   GIR_EraseRootFromParent_Done,
     /* 145735 */ // Label 1985: @145735
     /* 145735 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(145885), // Rule ID 3941 //
     /* 145740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 145743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 145758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 145762 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 145766 */   // MIs[1] Operand 1
     /* 145766 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 145771 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 145775 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 145779 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 145783 */   // MIs[2] Operand 1
     /* 145783 */   // No operand predicates
     /* 145783 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 145785 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 145785 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145788 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 145792 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145797 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145801 */   GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm
     /* 145804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145806 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 145809 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145813 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145818 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 145821 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 145823 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 145826 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 145830 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145835 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 145838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 145840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145852 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 145859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 145872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 145874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145877 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 145880 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 145883 */   GIR_RootConstrainSelectedInstOperands,
     /* 145884 */   // GIR_Coverage, 3941,
     /* 145884 */   GIR_EraseRootFromParent_Done,
     /* 145885 */ // Label 1986: @145885
     /* 145885 */ GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(145984), // Rule ID 3181 //
     /* 145890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145900 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 145904 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 145908 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 145912 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 145916 */   // MIs[1] Operand 1
     /* 145916 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 145921 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 145923 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 145923 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 145926 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 145930 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145935 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 145939 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 145943 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 145945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 145948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 145952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 145957 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 145964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 145969 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 145974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 145977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 145979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 145982 */   GIR_RootConstrainSelectedInstOperands,
     /* 145983 */   // GIR_Coverage, 3181,
     /* 145983 */   GIR_EraseRootFromParent_Done,
     /* 145984 */ // Label 1987: @145984
     /* 145984 */ GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(146083), // Rule ID 3197 //
     /* 145989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 145992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 145995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 145999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146007 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146011 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146015 */   // MIs[1] Operand 1
     /* 146015 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146022 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 146022 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146025 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146029 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146034 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146038 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146056 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146063 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146068 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146081 */   GIR_RootConstrainSelectedInstOperands,
     /* 146082 */   // GIR_Coverage, 3197,
     /* 146082 */   GIR_EraseRootFromParent_Done,
     /* 146083 */ // Label 1988: @146083
     /* 146083 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(146182), // Rule ID 3213 //
     /* 146088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146098 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146102 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146106 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146110 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146114 */   // MIs[1] Operand 1
     /* 146114 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146119 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146121 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 146121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146133 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146137 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146143 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146146 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146150 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146155 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146162 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146167 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146180 */   GIR_RootConstrainSelectedInstOperands,
     /* 146181 */   // GIR_Coverage, 3213,
     /* 146181 */   GIR_EraseRootFromParent_Done,
     /* 146182 */ // Label 1989: @146182
     /* 146182 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(146281), // Rule ID 3229 //
     /* 146187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146197 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146201 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146205 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 146209 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 146213 */   // MIs[1] Operand 1
     /* 146213 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146220 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 146220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 146227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146232 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146236 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146254 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146261 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146266 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146279 */   GIR_RootConstrainSelectedInstOperands,
     /* 146280 */   // GIR_Coverage, 3229,
     /* 146280 */   GIR_EraseRootFromParent_Done,
     /* 146281 */ // Label 1990: @146281
     /* 146281 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(146380), // Rule ID 3237 //
     /* 146286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146296 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146300 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146304 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146308 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146312 */   // MIs[1] Operand 1
     /* 146312 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146317 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146319 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 146319 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146322 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146326 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146331 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146335 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146341 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146344 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146348 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146353 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146360 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146365 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146378 */   GIR_RootConstrainSelectedInstOperands,
     /* 146379 */   // GIR_Coverage, 3237,
     /* 146379 */   GIR_EraseRootFromParent_Done,
     /* 146380 */ // Label 1991: @146380
     /* 146380 */ GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(146479), // Rule ID 3253 //
     /* 146385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146395 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146399 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146403 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146407 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146411 */   // MIs[1] Operand 1
     /* 146411 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146418 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 146418 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146421 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146425 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146430 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146434 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146452 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146459 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146464 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146474 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146477 */   GIR_RootConstrainSelectedInstOperands,
     /* 146478 */   // GIR_Coverage, 3253,
     /* 146478 */   GIR_EraseRootFromParent_Done,
     /* 146479 */ // Label 1992: @146479
     /* 146479 */ GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(146578), // Rule ID 3269 //
     /* 146484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146494 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146498 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146502 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146506 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146510 */   // MIs[1] Operand 1
     /* 146510 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146517 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 146517 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146520 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146524 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146529 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146533 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146551 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146558 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146563 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146576 */   GIR_RootConstrainSelectedInstOperands,
     /* 146577 */   // GIR_Coverage, 3269,
     /* 146577 */   GIR_EraseRootFromParent_Done,
     /* 146578 */ // Label 1993: @146578
     /* 146578 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(146677), // Rule ID 3285 //
     /* 146583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 146605 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 146609 */   // MIs[1] Operand 1
     /* 146609 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 146614 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146616 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 146616 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146619 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 146623 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146628 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146632 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146650 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 146657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146675 */   GIR_RootConstrainSelectedInstOperands,
     /* 146676 */   // GIR_Coverage, 3285,
     /* 146676 */   GIR_EraseRootFromParent_Done,
     /* 146677 */ // Label 1994: @146677
     /* 146677 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(146776), // Rule ID 3293 //
     /* 146682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146704 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146708 */   // MIs[1] Operand 1
     /* 146708 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 146713 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146715 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 146715 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146718 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146722 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146727 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146731 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146749 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 146756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146761 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146771 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146774 */   GIR_RootConstrainSelectedInstOperands,
     /* 146775 */   // GIR_Coverage, 3293,
     /* 146775 */   GIR_EraseRootFromParent_Done,
     /* 146776 */ // Label 1995: @146776
     /* 146776 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(146875), // Rule ID 3309 //
     /* 146781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146791 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146795 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146799 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146803 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146807 */   // MIs[1] Operand 1
     /* 146807 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 146812 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146814 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 146814 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146817 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146821 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146826 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146830 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146848 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 146855 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146860 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146870 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146873 */   GIR_RootConstrainSelectedInstOperands,
     /* 146874 */   // GIR_Coverage, 3309,
     /* 146874 */   GIR_EraseRootFromParent_Done,
     /* 146875 */ // Label 1996: @146875
     /* 146875 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(146974), // Rule ID 3325 //
     /* 146880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146898 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 146902 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 146906 */   // MIs[1] Operand 1
     /* 146906 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 146911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 146913 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 146913 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 146916 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 146920 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146925 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 146929 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 146933 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 146935 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 146938 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 146942 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 146947 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 146954 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 146959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 146964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 146967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 146969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 146972 */   GIR_RootConstrainSelectedInstOperands,
     /* 146973 */   // GIR_Coverage, 3325,
     /* 146973 */   GIR_EraseRootFromParent_Done,
     /* 146974 */ // Label 1997: @146974
     /* 146974 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(147073), // Rule ID 3341 //
     /* 146979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 146982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 146985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 146989 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 146993 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 146997 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 147001 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 147005 */   // MIs[1] Operand 1
     /* 147005 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147012 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 147012 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147015 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 147019 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147024 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147028 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147046 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147053 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147058 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 147066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 147068 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147071 */   GIR_RootConstrainSelectedInstOperands,
     /* 147072 */   // GIR_Coverage, 3341,
     /* 147072 */   GIR_EraseRootFromParent_Done,
     /* 147073 */ // Label 1998: @147073
     /* 147073 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(147212), // Rule ID 4024 //
     /* 147078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147096 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147100 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147104 */   // MIs[1] Operand 1
     /* 147104 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147109 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147111 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147123 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147127 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147133 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147136 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147140 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147145 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147150 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147153 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147157 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147162 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147179 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147186 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147191 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147210 */   GIR_RootConstrainSelectedInstOperands,
     /* 147211 */   // GIR_Coverage, 4024,
     /* 147211 */   GIR_EraseRootFromParent_Done,
     /* 147212 */ // Label 1999: @147212
     /* 147212 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(147351), // Rule ID 4056 //
     /* 147217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147235 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147239 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147243 */   // MIs[1] Operand 1
     /* 147243 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 147248 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147250 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147250 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147253 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147257 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147262 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147266 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147272 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147275 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147279 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147284 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147289 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147292 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147296 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147301 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147318 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147330 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147343 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147349 */   GIR_RootConstrainSelectedInstOperands,
     /* 147350 */   // GIR_Coverage, 4056,
     /* 147350 */   GIR_EraseRootFromParent_Done,
     /* 147351 */ // Label 2000: @147351
     /* 147351 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(147490), // Rule ID 4088 //
     /* 147356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147366 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147370 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147374 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147378 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147382 */   // MIs[1] Operand 1
     /* 147382 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147389 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147389 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147392 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147396 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147401 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147405 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147411 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147414 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147418 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147423 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147428 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147431 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147435 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147440 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147457 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 147464 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147469 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147479 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147485 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147488 */   GIR_RootConstrainSelectedInstOperands,
     /* 147489 */   // GIR_Coverage, 4088,
     /* 147489 */   GIR_EraseRootFromParent_Done,
     /* 147490 */ // Label 2001: @147490
     /* 147490 */ GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(147629), // Rule ID 4120 //
     /* 147495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147505 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147509 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147513 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 147517 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 147521 */   // MIs[1] Operand 1
     /* 147521 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 147526 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147528 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 147535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147540 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147544 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147550 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147553 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147557 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147562 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147567 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147570 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147574 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147579 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147596 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 147603 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147608 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147627 */   GIR_RootConstrainSelectedInstOperands,
     /* 147628 */   // GIR_Coverage, 4120,
     /* 147628 */   GIR_EraseRootFromParent_Done,
     /* 147629 */ // Label 2002: @147629
     /* 147629 */ GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(147768), // Rule ID 4136 //
     /* 147634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147652 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147656 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147660 */   // MIs[1] Operand 1
     /* 147660 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 147665 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147667 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147667 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147670 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147674 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147679 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147683 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147687 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147689 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147692 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147696 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147701 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147706 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147709 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147713 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147718 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147723 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147726 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147730 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147735 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 147742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147766 */   GIR_RootConstrainSelectedInstOperands,
     /* 147767 */   // GIR_Coverage, 4136,
     /* 147767 */   GIR_EraseRootFromParent_Done,
     /* 147768 */ // Label 2003: @147768
     /* 147768 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(147907), // Rule ID 4168 //
     /* 147773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147783 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147787 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147791 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147795 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147799 */   // MIs[1] Operand 1
     /* 147799 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 147804 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147806 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147806 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147809 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147813 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147818 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147822 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147828 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147831 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147835 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147840 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147845 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147848 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147852 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147857 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 147862 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 147865 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147869 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147874 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 147881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 147886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 147891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 147894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 147902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 147905 */   GIR_RootConstrainSelectedInstOperands,
     /* 147906 */   // GIR_Coverage, 4168,
     /* 147906 */   GIR_EraseRootFromParent_Done,
     /* 147907 */ // Label 2004: @147907
     /* 147907 */ GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(148046), // Rule ID 4200 //
     /* 147912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 147915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 147918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 147922 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 147926 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 147930 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 147934 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 147938 */   // MIs[1] Operand 1
     /* 147938 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 147943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 147945 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 147945 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 147948 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 147952 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147957 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 147961 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 147965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 147967 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 147970 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147974 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147979 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 147982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 147984 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 147987 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 147991 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147996 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 147999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148013 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148020 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148025 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148035 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148044 */   GIR_RootConstrainSelectedInstOperands,
     /* 148045 */   // GIR_Coverage, 4200,
     /* 148045 */   GIR_EraseRootFromParent_Done,
     /* 148046 */ // Label 2005: @148046
     /* 148046 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(148185), // Rule ID 4232 //
     /* 148051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148069 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 148073 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 148077 */   // MIs[1] Operand 1
     /* 148077 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 148082 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148084 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148084 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148087 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 148091 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148096 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148100 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148106 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148109 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148113 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148118 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148121 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148123 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148126 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148130 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148135 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148152 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 148159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148183 */   GIR_RootConstrainSelectedInstOperands,
     /* 148184 */   // GIR_Coverage, 4232,
     /* 148184 */   GIR_EraseRootFromParent_Done,
     /* 148185 */ // Label 2006: @148185
     /* 148185 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(148324), // Rule ID 4262 //
     /* 148190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148208 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148212 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148216 */   // MIs[1] Operand 1
     /* 148216 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148221 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148223 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148223 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148226 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148230 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148235 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148239 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148245 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148248 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148252 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148257 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148262 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148265 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148269 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148274 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148291 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 148298 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148303 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148322 */   GIR_RootConstrainSelectedInstOperands,
     /* 148323 */   // GIR_Coverage, 4262,
     /* 148323 */   GIR_EraseRootFromParent_Done,
     /* 148324 */ // Label 2007: @148324
     /* 148324 */ GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(148463), // Rule ID 4294 //
     /* 148329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148347 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148351 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148355 */   // MIs[1] Operand 1
     /* 148355 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148360 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148362 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148362 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148365 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148369 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148374 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148378 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148384 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148387 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148391 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148396 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148401 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148404 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148408 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148413 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148430 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148437 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148442 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148452 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148461 */   GIR_RootConstrainSelectedInstOperands,
     /* 148462 */   // GIR_Coverage, 4294,
     /* 148462 */   GIR_EraseRootFromParent_Done,
     /* 148463 */ // Label 2008: @148463
     /* 148463 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(148602), // Rule ID 4326 //
     /* 148468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148490 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148494 */   // MIs[1] Operand 1
     /* 148494 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 148499 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148501 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148501 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148504 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148508 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148513 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148517 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148523 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148526 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148530 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148535 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148540 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148543 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148547 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148552 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148555 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148569 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 148576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148594 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148600 */   GIR_RootConstrainSelectedInstOperands,
     /* 148601 */   // GIR_Coverage, 4326,
     /* 148601 */   GIR_EraseRootFromParent_Done,
     /* 148602 */ // Label 2009: @148602
     /* 148602 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(148741), // Rule ID 4358 //
     /* 148607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 148610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148617 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148621 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148625 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 148629 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 148633 */   // MIs[1] Operand 1
     /* 148633 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 148638 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148640 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148640 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148643 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 148647 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148652 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148656 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148662 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148665 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148669 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148674 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148679 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148682 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148686 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148691 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148708 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 148715 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148720 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148730 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148736 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148739 */   GIR_RootConstrainSelectedInstOperands,
     /* 148740 */   // GIR_Coverage, 4358,
     /* 148740 */   GIR_EraseRootFromParent_Done,
     /* 148741 */ // Label 2010: @148741
     /* 148741 */ GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(148880), // Rule ID 4589 //
     /* 148746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148764 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148768 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148772 */   // MIs[1] Operand 1
     /* 148772 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 148777 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148779 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148779 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148782 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 148786 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148791 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148795 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148801 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148804 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148808 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148813 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148818 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148821 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148825 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148830 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148847 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148854 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 148864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 148867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 148875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 148878 */   GIR_RootConstrainSelectedInstOperands,
     /* 148879 */   // GIR_Coverage, 4589,
     /* 148879 */   GIR_EraseRootFromParent_Done,
     /* 148880 */ // Label 2011: @148880
     /* 148880 */ GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(149019), // Rule ID 4621 //
     /* 148885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 148888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 148891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 148895 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 148899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 148903 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 148907 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 148911 */   // MIs[1] Operand 1
     /* 148911 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 148916 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 148918 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 148918 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 148921 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 148925 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148930 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 148934 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 148938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148940 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 148943 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148947 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148952 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 148955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 148957 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 148960 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 148964 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148969 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 148972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 148977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148986 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 148993 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 148998 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149006 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149014 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149017 */   GIR_RootConstrainSelectedInstOperands,
     /* 149018 */   // GIR_Coverage, 4621,
     /* 149018 */   GIR_EraseRootFromParent_Done,
     /* 149019 */ // Label 2012: @149019
     /* 149019 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(149158), // Rule ID 4653 //
     /* 149024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149034 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149038 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149046 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149050 */   // MIs[1] Operand 1
     /* 149050 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 149055 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149057 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149057 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149060 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 149064 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149069 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149073 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149079 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149082 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149086 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149091 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149096 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149099 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149103 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149108 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149125 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149137 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149156 */   GIR_RootConstrainSelectedInstOperands,
     /* 149157 */   // GIR_Coverage, 4653,
     /* 149157 */   GIR_EraseRootFromParent_Done,
     /* 149158 */ // Label 2013: @149158
     /* 149158 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(149297), // Rule ID 4697 //
     /* 149163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149173 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149177 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149181 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149185 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149189 */   // MIs[1] Operand 1
     /* 149189 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 149194 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149196 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149196 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149199 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 149203 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149208 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149212 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149218 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149221 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149225 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149230 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149235 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149238 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149242 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149247 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149252 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149255 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149259 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149264 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149271 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149276 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149289 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149295 */   GIR_RootConstrainSelectedInstOperands,
     /* 149296 */   // GIR_Coverage, 4697,
     /* 149296 */   GIR_EraseRootFromParent_Done,
     /* 149297 */ // Label 2014: @149297
     /* 149297 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(149436), // Rule ID 4729 //
     /* 149302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149312 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149316 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149320 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149324 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149328 */   // MIs[1] Operand 1
     /* 149328 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 149333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149335 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149335 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149338 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 149342 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149347 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149351 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149357 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149360 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149364 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149369 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149372 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149374 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149377 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149381 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149386 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149403 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149410 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149415 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149425 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149434 */   GIR_RootConstrainSelectedInstOperands,
     /* 149435 */   // GIR_Coverage, 4729,
     /* 149435 */   GIR_EraseRootFromParent_Done,
     /* 149436 */ // Label 2015: @149436
     /* 149436 */ GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(149575), // Rule ID 4761 //
     /* 149441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 149444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149451 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149455 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCMP),
     /* 149459 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 149463 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 149467 */   // MIs[1] Operand 1
     /* 149467 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 149472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149474 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 149474 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149477 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 149481 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149486 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149490 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149496 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 149499 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149503 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149508 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 149511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 149513 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149516 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 149520 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149525 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 149528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149530 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149533 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149537 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149542 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149549 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149554 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 149562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 149570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 149573 */   GIR_RootConstrainSelectedInstOperands,
     /* 149574 */   // GIR_Coverage, 4761,
     /* 149574 */   GIR_EraseRootFromParent_Done,
     /* 149575 */ // Label 2016: @149575
     /* 149575 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(149674), // Rule ID 2983 //
     /* 149580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149590 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149594 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149598 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149602 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149606 */   // MIs[1] Operand 1
     /* 149606 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 149611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149613 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149613 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149616 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149620 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149625 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149629 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149633 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149647 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149654 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149659 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149672 */   GIR_RootConstrainSelectedInstOperands,
     /* 149673 */   // GIR_Coverage, 2983,
     /* 149673 */   GIR_EraseRootFromParent_Done,
     /* 149674 */ // Label 2017: @149674
     /* 149674 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(149773), // Rule ID 2997 //
     /* 149679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149697 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149701 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149705 */   // MIs[1] Operand 1
     /* 149705 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 149710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149712 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 149712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149724 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149746 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 149753 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149758 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149766 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149768 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149771 */   GIR_RootConstrainSelectedInstOperands,
     /* 149772 */   // GIR_Coverage, 2997,
     /* 149772 */   GIR_EraseRootFromParent_Done,
     /* 149773 */ // Label 2018: @149773
     /* 149773 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(149872), // Rule ID 3005 //
     /* 149778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149788 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149792 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149796 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149800 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149804 */   // MIs[1] Operand 1
     /* 149804 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 149809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149811 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149811 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149814 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 149818 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149823 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149827 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149845 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149857 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149870 */   GIR_RootConstrainSelectedInstOperands,
     /* 149871 */   // GIR_Coverage, 3005,
     /* 149871 */   GIR_EraseRootFromParent_Done,
     /* 149872 */ // Label 2019: @149872
     /* 149872 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(149971), // Rule ID 3013 //
     /* 149877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149887 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149899 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 149903 */   // MIs[1] Operand 1
     /* 149903 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 149908 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 149910 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 149910 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 149913 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 149917 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149922 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 149926 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 149930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149932 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 149935 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149939 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149944 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 149951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 149956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 149961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 149964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 149966 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149969 */   GIR_RootConstrainSelectedInstOperands,
     /* 149970 */   // GIR_Coverage, 3013,
     /* 149970 */   GIR_EraseRootFromParent_Done,
     /* 149971 */ // Label 2020: @149971
     /* 149971 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(150070), // Rule ID 3021 //
     /* 149976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 149979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 149982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 149986 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 149990 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 149994 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 149998 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150002 */   // MIs[1] Operand 1
     /* 150002 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150007 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150009 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 150009 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150012 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150016 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150021 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150025 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150043 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150050 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150068 */   GIR_RootConstrainSelectedInstOperands,
     /* 150069 */   // GIR_Coverage, 3021,
     /* 150069 */   GIR_EraseRootFromParent_Done,
     /* 150070 */ // Label 2021: @150070
     /* 150070 */ GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(150169), // Rule ID 3085 //
     /* 150075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150093 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150097 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150101 */   // MIs[1] Operand 1
     /* 150101 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150108 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 150108 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150111 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150115 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150120 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150124 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150130 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150133 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150137 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150142 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150167 */   GIR_RootConstrainSelectedInstOperands,
     /* 150168 */   // GIR_Coverage, 3085,
     /* 150168 */   GIR_EraseRootFromParent_Done,
     /* 150169 */ // Label 2022: @150169
     /* 150169 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(150268), // Rule ID 3093 //
     /* 150174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150192 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150196 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150200 */   // MIs[1] Operand 1
     /* 150200 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150207 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 150207 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150210 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150214 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150219 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150223 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150227 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150229 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150232 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150236 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150241 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150248 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150253 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150266 */   GIR_RootConstrainSelectedInstOperands,
     /* 150267 */   // GIR_Coverage, 3093,
     /* 150267 */   GIR_EraseRootFromParent_Done,
     /* 150268 */ // Label 2023: @150268
     /* 150268 */ GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(150367), // Rule ID 3101 //
     /* 150273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150283 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150287 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150291 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150295 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150299 */   // MIs[1] Operand 1
     /* 150299 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 150304 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150306 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 150306 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150309 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 150313 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150318 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150322 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150340 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150347 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150352 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150365 */   GIR_RootConstrainSelectedInstOperands,
     /* 150366 */   // GIR_Coverage, 3101,
     /* 150366 */   GIR_EraseRootFromParent_Done,
     /* 150367 */ // Label 2024: @150367
     /* 150367 */ GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(150466), // Rule ID 3109 //
     /* 150372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150382 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150386 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150390 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150394 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150398 */   // MIs[1] Operand 1
     /* 150398 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 150403 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150405 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 150405 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150408 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150412 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150417 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150421 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150439 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150446 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150451 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150464 */   GIR_RootConstrainSelectedInstOperands,
     /* 150465 */   // GIR_Coverage, 3109,
     /* 150465 */   GIR_EraseRootFromParent_Done,
     /* 150466 */ // Label 2025: @150466
     /* 150466 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(150565), // Rule ID 3117 //
     /* 150471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 150474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150489 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 150493 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 150497 */   // MIs[1] Operand 1
     /* 150497 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 150502 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150504 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SETBCR8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 150504 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150507 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 150511 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150516 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150520 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150538 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 150545 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SETBCR8),
     /* 150558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 150560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150563 */   GIR_RootConstrainSelectedInstOperands,
     /* 150564 */   // GIR_Coverage, 3117,
     /* 150564 */   GIR_EraseRootFromParent_Done,
     /* 150565 */ // Label 2026: @150565
     /* 150565 */ GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(150704), // Rule ID 3869 //
     /* 150570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150580 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150584 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150588 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150592 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150596 */   // MIs[1] Operand 1
     /* 150596 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 150601 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150603 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150603 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150606 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150610 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150615 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150619 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150625 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150628 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150632 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150637 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150642 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150645 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150649 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150654 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150671 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150702 */   GIR_RootConstrainSelectedInstOperands,
     /* 150703 */   // GIR_Coverage, 3869,
     /* 150703 */   GIR_EraseRootFromParent_Done,
     /* 150704 */ // Label 2027: @150704
     /* 150704 */ GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(150843), // Rule ID 3877 //
     /* 150709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150727 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150731 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150735 */   // MIs[1] Operand 1
     /* 150735 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 150740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150742 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 150749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150758 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150764 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150767 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150771 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150776 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150781 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150784 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150788 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150793 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150810 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 150817 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150822 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150841 */   GIR_RootConstrainSelectedInstOperands,
     /* 150842 */   // GIR_Coverage, 3877,
     /* 150842 */   GIR_EraseRootFromParent_Done,
     /* 150843 */ // Label 2028: @150843
     /* 150843 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(150982), // Rule ID 3885 //
     /* 150848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 150862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 150866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 150870 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 150874 */   // MIs[1] Operand 1
     /* 150874 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 150879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 150881 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 150881 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 150884 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 150888 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150893 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 150897 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 150901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150903 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 150906 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150910 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150915 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 150918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 150920 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150923 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 150927 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150932 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 150935 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 150940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150949 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 150956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 150961 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 150966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 150969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150974 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 150977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 150980 */   GIR_RootConstrainSelectedInstOperands,
     /* 150981 */   // GIR_Coverage, 3885,
     /* 150981 */   GIR_EraseRootFromParent_Done,
     /* 150982 */ // Label 2029: @150982
     /* 150982 */ GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(151121), // Rule ID 3893 //
     /* 150987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 150990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 150993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 150997 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151001 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151005 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151009 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 151013 */   // MIs[1] Operand 1
     /* 151013 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151020 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151020 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151023 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 151027 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151032 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151036 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151042 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151045 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151049 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151054 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151059 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151062 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151066 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151071 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151088 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151113 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151119 */   GIR_RootConstrainSelectedInstOperands,
     /* 151120 */   // GIR_Coverage, 3893,
     /* 151120 */   GIR_EraseRootFromParent_Done,
     /* 151121 */ // Label 2030: @151121
     /* 151121 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(151260), // Rule ID 3901 //
     /* 151126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151144 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 151148 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 151152 */   // MIs[1] Operand 1
     /* 151152 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151159 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151159 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151162 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 151166 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151171 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151175 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151181 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151184 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151188 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151193 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151198 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151201 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151205 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151210 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151215 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151218 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151222 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151227 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151234 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151239 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151258 */   GIR_RootConstrainSelectedInstOperands,
     /* 151259 */   // GIR_Coverage, 3901,
     /* 151259 */   GIR_EraseRootFromParent_Done,
     /* 151260 */ // Label 2031: @151260
     /* 151260 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(151399), // Rule ID 3965 //
     /* 151265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151275 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151279 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151283 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151287 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151291 */   // MIs[1] Operand 1
     /* 151291 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 151296 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151298 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151298 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151301 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 151305 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151310 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151314 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151320 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151323 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151327 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151332 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151337 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151340 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151344 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151349 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151366 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151394 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151397 */   GIR_RootConstrainSelectedInstOperands,
     /* 151398 */   // GIR_Coverage, 3965,
     /* 151398 */   GIR_EraseRootFromParent_Done,
     /* 151399 */ // Label 2032: @151399
     /* 151399 */ GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(151538), // Rule ID 3973 //
     /* 151404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151422 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151426 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151430 */   // MIs[1] Operand 1
     /* 151430 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 151435 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151437 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151453 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151457 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151459 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151462 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151466 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151471 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151476 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151479 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151483 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151488 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151505 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 151512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151517 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151536 */   GIR_RootConstrainSelectedInstOperands,
     /* 151537 */   // GIR_Coverage, 3973,
     /* 151537 */   GIR_EraseRootFromParent_Done,
     /* 151538 */ // Label 2033: @151538
     /* 151538 */ GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(151677), // Rule ID 3981 //
     /* 151543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151553 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151557 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151561 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151565 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151569 */   // MIs[1] Operand 1
     /* 151569 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 151574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151576 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151576 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151579 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 151583 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151588 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151592 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151598 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151601 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151605 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151610 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151615 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151618 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151622 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151627 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151644 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151656 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151669 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151675 */   GIR_RootConstrainSelectedInstOperands,
     /* 151676 */   // GIR_Coverage, 3981,
     /* 151676 */   GIR_EraseRootFromParent_Done,
     /* 151677 */ // Label 2034: @151677
     /* 151677 */ GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(151816), // Rule ID 3989 //
     /* 151682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151692 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151696 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151704 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151708 */   // MIs[1] Operand 1
     /* 151708 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 151713 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151715 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151715 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151718 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151722 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151727 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151731 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151737 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151740 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151744 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151749 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151754 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151757 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151761 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151766 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151769 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151783 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 151790 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151795 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151805 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151808 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151814 */   GIR_RootConstrainSelectedInstOperands,
     /* 151815 */   // GIR_Coverage, 3989,
     /* 151815 */   GIR_EraseRootFromParent_Done,
     /* 151816 */ // Label 2035: @151816
     /* 151816 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(151955), // Rule ID 3997 //
     /* 151821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 151824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 151835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 151839 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 151843 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 151847 */   // MIs[1] Operand 1
     /* 151847 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 151852 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 151854 */   // (zext:{ *:[i64] } (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] }))  =>  (SELECT_I8:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }), (LI8:{ *:[i64] } 0:{ *:[i64] }), (LI8:{ *:[i64] } 1:{ *:[i64] }))
     /* 151854 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 151857 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 151861 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151866 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // s1
     /* 151870 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/3, // s2
     /* 151874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151876 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 151879 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151883 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151888 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 151891 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 151893 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151896 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151900 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151905 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 151908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 151913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151922 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 151929 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 151934 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 151939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 151942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 151950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 151953 */   GIR_RootConstrainSelectedInstOperands,
     /* 151954 */   // GIR_Coverage, 3997,
     /* 151954 */   GIR_EraseRootFromParent_Done,
     /* 151955 */ // Label 2036: @151955
     /* 151955 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(151977), // Rule ID 2989 //
     /* 151960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 151963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151970 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SETBC8:{ *:[i64] } ?:{ *:[i1] }:$in)
     /* 151970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SETBC8),
     /* 151975 */   GIR_RootConstrainSelectedInstOperands,
     /* 151976 */   // GIR_Coverage, 2989,
     /* 151976 */   GIR_Done,
     /* 151977 */ // Label 2037: @151977
     /* 151977 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(152038), // Rule ID 3675 //
     /* 151982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 151985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 151989 */   // (zext:{ *:[i64] } i1:{ *:[i1] }:$in)  =>  (SELECT_I8:{ *:[i64] } ?:{ *:[i1] }:$in, (LI8:{ *:[i64] } 1:{ *:[i64] }), (LI8:{ *:[i64] } 0:{ *:[i64] }))
     /* 151989 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 151992 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 151996 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152001 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 152004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152006 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 152009 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::LI8),
     /* 152013 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 152021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 152026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152028 */   GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 152030 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152036 */   GIR_RootConstrainSelectedInstOperands,
     /* 152037 */   // GIR_Coverage, 3675,
     /* 152037 */   GIR_EraseRootFromParent_Done,
     /* 152038 */ // Label 2038: @152038
     /* 152038 */ GIM_Reject,
     /* 152039 */ // Label 1852: @152039
     /* 152039 */ GIM_Reject,
     /* 152040 */ // Label 27: @152040
     /* 152040 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2046*/ GIMT_Encode4(152395),
     /* 152051 */ /*GILLT_s32*//*Label 2039*/ GIMT_Encode4(152079),
     /* 152055 */ /*GILLT_s64*//*Label 2040*/ GIMT_Encode4(152102),
     /* 152059 */ /*GILLT_s128*//*Label 2041*/ GIMT_Encode4(152125),
     /* 152063 */ /*GILLT_v2s64*//*Label 2042*/ GIMT_Encode4(152291),
     /* 152067 */ /*GILLT_v4s32*//*Label 2043*/ GIMT_Encode4(152317),
     /* 152071 */ /*GILLT_v8s16*//*Label 2044*/ GIMT_Encode4(152343),
     /* 152075 */ /*GILLT_v16s8*//*Label 2045*/ GIMT_Encode4(152369),
     /* 152079 */ // Label 2039: @152079
     /* 152079 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(152101), // Rule ID 1257 //
     /* 152084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152094 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLW),
     /* 152099 */   GIR_RootConstrainSelectedInstOperands,
     /* 152100 */   // GIR_Coverage, 1257,
     /* 152100 */   GIR_Done,
     /* 152101 */ // Label 2047: @152101
     /* 152101 */ GIM_Reject,
     /* 152102 */ // Label 2040: @152102
     /* 152102 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(152124), // Rule ID 1538 //
     /* 152107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152117 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SLD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152117 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SLD),
     /* 152122 */   GIR_RootConstrainSelectedInstOperands,
     /* 152123 */   // GIR_Coverage, 1538,
     /* 152123 */   GIR_Done,
     /* 152124 */ // Label 2048: @152124
     /* 152124 */ GIM_Reject,
     /* 152125 */ // Label 2041: @152125
     /* 152125 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(152290),
     /* 152130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152140 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(152225), // Rule ID 3376 //
     /* 152145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152148 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152148 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152151 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152155 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152160 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152164 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152169 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152172 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152176 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152185 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152205 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152208 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSLQ),
     /* 152216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152218 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152223 */     GIR_RootConstrainSelectedInstOperands,
     /* 152224 */     // GIR_Coverage, 3376,
     /* 152224 */     GIR_EraseRootFromParent_Done,
     /* 152225 */   // Label 2050: @152225
     /* 152225 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(152289), // Rule ID 1396 //
     /* 152230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152233 */     // (shl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSL:{ *:[v1i128] } (VSLO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 152233 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152236 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 152240 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152245 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 152248 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLO),
     /* 152261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 152270 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSL),
     /* 152279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152287 */     GIR_RootConstrainSelectedInstOperands,
     /* 152288 */     // GIR_Coverage, 1396,
     /* 152288 */     GIR_EraseRootFromParent_Done,
     /* 152289 */   // Label 2051: @152289
     /* 152289 */   GIM_Reject,
     /* 152290 */ // Label 2049: @152290
     /* 152290 */ GIM_Reject,
     /* 152291 */ // Label 2042: @152291
     /* 152291 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(152316), // Rule ID 1444 //
     /* 152296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152309 */   // (shl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSLD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLD),
     /* 152314 */   GIR_RootConstrainSelectedInstOperands,
     /* 152315 */   // GIR_Coverage, 1444,
     /* 152315 */   GIR_Done,
     /* 152316 */ // Label 2052: @152316
     /* 152316 */ GIM_Reject,
     /* 152317 */ // Label 2043: @152317
     /* 152317 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(152342), // Rule ID 1395 //
     /* 152322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152335 */   // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSLW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 152340 */   GIR_RootConstrainSelectedInstOperands,
     /* 152341 */   // GIR_Coverage, 1395,
     /* 152341 */   GIR_Done,
     /* 152342 */ // Label 2053: @152342
     /* 152342 */ GIM_Reject,
     /* 152343 */ // Label 2044: @152343
     /* 152343 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(152368), // Rule ID 1394 //
     /* 152348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152354 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152361 */   // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSLH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLH),
     /* 152366 */   GIR_RootConstrainSelectedInstOperands,
     /* 152367 */   // GIR_Coverage, 1394,
     /* 152367 */   GIR_Done,
     /* 152368 */ // Label 2054: @152368
     /* 152368 */ GIM_Reject,
     /* 152369 */ // Label 2045: @152369
     /* 152369 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(152394), // Rule ID 1393 //
     /* 152374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152387 */   // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSLB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSLB),
     /* 152392 */   GIR_RootConstrainSelectedInstOperands,
     /* 152393 */   // GIR_Coverage, 1393,
     /* 152393 */   GIR_Done,
     /* 152394 */ // Label 2055: @152394
     /* 152394 */ GIM_Reject,
     /* 152395 */ // Label 2046: @152395
     /* 152395 */ GIM_Reject,
     /* 152396 */ // Label 28: @152396
     /* 152396 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2063*/ GIMT_Encode4(152817),
     /* 152407 */ /*GILLT_s32*//*Label 2056*/ GIMT_Encode4(152435),
     /* 152411 */ /*GILLT_s64*//*Label 2057*/ GIMT_Encode4(152524),
     /* 152415 */ /*GILLT_s128*//*Label 2058*/ GIMT_Encode4(152547),
     /* 152419 */ /*GILLT_v2s64*//*Label 2059*/ GIMT_Encode4(152713),
     /* 152423 */ /*GILLT_v4s32*//*Label 2060*/ GIMT_Encode4(152739),
     /* 152427 */ /*GILLT_v8s16*//*Label 2061*/ GIMT_Encode4(152765),
     /* 152431 */ /*GILLT_v16s8*//*Label 2062*/ GIMT_Encode4(152791),
     /* 152435 */ // Label 2056: @152435
     /* 152435 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(152523),
     /* 152440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152450 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(152510), // Rule ID 3356 //
     /* 152455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 152458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 152462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 152466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 152470 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 152474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152476 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } i32:{ *:[i32] }:$RS), 16:{ *:[i32] })  =>  (RLDICL_32:{ *:[i32] } (BRH:{ *:[i32] } ?:{ *:[i32] }:$RS), 0:{ *:[i32] }, 48:{ *:[i32] })
     /* 152476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 152479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::BRH),
     /* 152483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152488 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // RS
     /* 152492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 152497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 152505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 152508 */     GIR_RootConstrainSelectedInstOperands,
     /* 152509 */     // GIR_Coverage, 3356,
     /* 152509 */     GIR_EraseRootFromParent_Done,
     /* 152510 */   // Label 2065: @152510
     /* 152510 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(152522), // Rule ID 1256 //
     /* 152515 */     // (srl:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRW:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152515 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRW),
     /* 152520 */     GIR_RootConstrainSelectedInstOperands,
     /* 152521 */     // GIR_Coverage, 1256,
     /* 152521 */     GIR_Done,
     /* 152522 */   // Label 2066: @152522
     /* 152522 */   GIM_Reject,
     /* 152523 */ // Label 2064: @152523
     /* 152523 */ GIM_Reject,
     /* 152524 */ // Label 2057: @152524
     /* 152524 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(152546), // Rule ID 1537 //
     /* 152529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152539 */   // (srl:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRD:{ *:[i64] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRD),
     /* 152544 */   GIR_RootConstrainSelectedInstOperands,
     /* 152545 */   // GIR_Coverage, 1537,
     /* 152545 */   GIR_Done,
     /* 152546 */ // Label 2067: @152546
     /* 152546 */ GIM_Reject,
     /* 152547 */ // Label 2058: @152547
     /* 152547 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(152712),
     /* 152552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 152558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152562 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(152647), // Rule ID 3378 //
     /* 152567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152570 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 152570 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 152573 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152577 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152582 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152586 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152591 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 152594 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152598 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152603 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 152607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 152612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 152615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 152619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 152627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 152630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 152633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRQ),
     /* 152638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152640 */     GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 152642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152645 */     GIR_RootConstrainSelectedInstOperands,
     /* 152646 */     // GIR_Coverage, 3378,
     /* 152646 */     GIR_EraseRootFromParent_Done,
     /* 152647 */   // Label 2069: @152647
     /* 152647 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(152711), // Rule ID 1404 //
     /* 152652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152655 */     // (srl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VSR:{ *:[v1i128] } (VSRO:{ *:[v16i8] } ?:{ *:[v1i128] }:$vA, ?:{ *:[v1i128] }:$vB), (VSPLTB:{ *:[v16i8] } 15:{ *:[i32] }, ?:{ *:[v1i128] }:$vB))
     /* 152655 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 152658 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::VSPLTB),
     /* 152662 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152667 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 152670 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 152676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 152679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSRO),
     /* 152683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152688 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 152692 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 152696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 152698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSR),
     /* 152701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 152703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 152709 */     GIR_RootConstrainSelectedInstOperands,
     /* 152710 */     // GIR_Coverage, 1404,
     /* 152710 */     GIR_EraseRootFromParent_Done,
     /* 152711 */   // Label 2070: @152711
     /* 152711 */   GIM_Reject,
     /* 152712 */ // Label 2068: @152712
     /* 152712 */ GIM_Reject,
     /* 152713 */ // Label 2059: @152713
     /* 152713 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(152738), // Rule ID 1446 //
     /* 152718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 152721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 152724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152731 */   // (srl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 152731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRD),
     /* 152736 */   GIR_RootConstrainSelectedInstOperands,
     /* 152737 */   // GIR_Coverage, 1446,
     /* 152737 */   GIR_Done,
     /* 152738 */ // Label 2071: @152738
     /* 152738 */ GIM_Reject,
     /* 152739 */ // Label 2060: @152739
     /* 152739 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(152764), // Rule ID 1403 //
     /* 152744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152757 */   // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 152757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRW),
     /* 152762 */   GIR_RootConstrainSelectedInstOperands,
     /* 152763 */   // GIR_Coverage, 1403,
     /* 152763 */   GIR_Done,
     /* 152764 */ // Label 2072: @152764
     /* 152764 */ GIM_Reject,
     /* 152765 */ // Label 2061: @152765
     /* 152765 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(152790), // Rule ID 1402 //
     /* 152770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152783 */   // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 152783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRH),
     /* 152788 */   GIR_RootConstrainSelectedInstOperands,
     /* 152789 */   // GIR_Coverage, 1402,
     /* 152789 */   GIR_Done,
     /* 152790 */ // Label 2073: @152790
     /* 152790 */ GIM_Reject,
     /* 152791 */ // Label 2062: @152791
     /* 152791 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(152816), // Rule ID 1401 //
     /* 152796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 152799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 152802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 152805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 152809 */   // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 152809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRB),
     /* 152814 */   GIR_RootConstrainSelectedInstOperands,
     /* 152815 */   // GIR_Coverage, 1401,
     /* 152815 */   GIR_Done,
     /* 152816 */ // Label 2074: @152816
     /* 152816 */ GIM_Reject,
     /* 152817 */ // Label 2063: @152817
     /* 152817 */ GIM_Reject,
     /* 152818 */ // Label 29: @152818
     /* 152818 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2082*/ GIMT_Encode4(153187),
     /* 152829 */ /*GILLT_s32*//*Label 2075*/ GIMT_Encode4(152857),
     /* 152833 */ /*GILLT_s64*//*Label 2076*/ GIMT_Encode4(152922),
     /* 152837 */ /*GILLT_s128*//*Label 2077*/ GIMT_Encode4(152987),
     /* 152841 */ /*GILLT_v2s64*//*Label 2078*/ GIMT_Encode4(153083),
     /* 152845 */ /*GILLT_v4s32*//*Label 2079*/ GIMT_Encode4(153109),
     /* 152849 */ /*GILLT_v8s16*//*Label 2080*/ GIMT_Encode4(153135),
     /* 152853 */ /*GILLT_v16s8*//*Label 2081*/ GIMT_Encode4(153161),
     /* 152857 */ // Label 2075: @152857
     /* 152857 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(152921),
     /* 152862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 152865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 152872 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(152902), // Rule ID 132 //
     /* 152877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152885 */     // MIs[1] Operand 1
     /* 152885 */     // No operand predicates
     /* 152885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152887 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)  =>  (SRAWI:{ *:[i32] }:{ *:[i32] } i32:{ *:[i32] }:$RST, (imm:{ *:[i32] }):$RB)
     /* 152887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRAWI),
     /* 152890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152892 */     GIR_RootToRootCopy, /*OpIdx*/1, // RST
     /* 152894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // RB
     /* 152897 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152900 */     GIR_RootConstrainSelectedInstOperands,
     /* 152901 */     // GIR_Coverage, 132,
     /* 152901 */     GIR_EraseRootFromParent_Done,
     /* 152902 */   // Label 2084: @152902
     /* 152902 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(152920), // Rule ID 1255 //
     /* 152907 */     // (sra:{ *:[i32] } i32:{ *:[i32] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAW:{ *:[i32] }:{ *:[i32] } ?:{ *:[i32] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAW),
     /* 152912 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152918 */     GIR_RootConstrainSelectedInstOperands,
     /* 152919 */     // GIR_Coverage, 1255,
     /* 152919 */     GIR_Done,
     /* 152920 */   // Label 2085: @152920
     /* 152920 */   GIM_Reject,
     /* 152921 */ // Label 2083: @152921
     /* 152921 */ GIM_Reject,
     /* 152922 */ // Label 2076: @152922
     /* 152922 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(152986),
     /* 152927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 152930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 152937 */   GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(152967), // Rule ID 685 //
     /* 152942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 152946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152950 */     // MIs[1] Operand 1
     /* 152950 */     // No operand predicates
     /* 152950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 152952 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)  =>  (SRADI:{ *:[i64] }:{ *:[i32] } i64:{ *:[i64] }:$RS, (imm:{ *:[i32] }):$SH)
     /* 152952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::SRADI),
     /* 152955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 152957 */     GIR_RootToRootCopy, /*OpIdx*/1, // RS
     /* 152959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SH
     /* 152962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for PPC::CARRY*/0,
     /* 152965 */     GIR_RootConstrainSelectedInstOperands,
     /* 152966 */     // GIR_Coverage, 685,
     /* 152966 */     GIR_EraseRootFromParent_Done,
     /* 152967 */   // Label 2087: @152967
     /* 152967 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(152985), // Rule ID 1536 //
     /* 152972 */     // (sra:{ *:[i64] } i64:{ *:[i64] }:$rS, i32:{ *:[i32] }:$rB)  =>  (SRAD:{ *:[i64] }:{ *:[i32] } ?:{ *:[i64] }:$rS, ?:{ *:[i32] }:$rB)
     /* 152972 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SRAD),
     /* 152977 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(PPC::CARRY), GIMT_Encode2(RegState::Dead),
     /* 152983 */     GIR_RootConstrainSelectedInstOperands,
     /* 152984 */     // GIR_Coverage, 1536,
     /* 152984 */     GIR_Done,
     /* 152985 */   // Label 2088: @152985
     /* 152985 */   GIM_Reject,
     /* 152986 */ // Label 2086: @152986
     /* 152986 */ GIM_Reject,
     /* 152987 */ // Label 2077: @152987
     /* 152987 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(153082), // Rule ID 3380 //
     /* 152992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsISA3_1),
     /* 152995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 152998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 153001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153005 */   // (sra:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, v1i128:{ *:[v1i128] }:$VRB)  =>  (VSRAQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$VRA, (XXPERMDI:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$VRB, VSRC:{ *:[i32] }), 2:{ *:[i32] }))
     /* 153005 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 153008 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153012 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153017 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 153021 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 153026 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 153029 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153033 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153038 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // VRB
     /* 153042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 153047 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 153050 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXPERMDI),
     /* 153054 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153059 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 153062 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 153065 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /* 153068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 153070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSRAQ),
     /* 153073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 153075 */   GIR_RootToRootCopy, /*OpIdx*/1, // VRA
     /* 153077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153080 */   GIR_RootConstrainSelectedInstOperands,
     /* 153081 */   // GIR_Coverage, 3380,
     /* 153081 */   GIR_EraseRootFromParent_Done,
     /* 153082 */ // Label 2089: @153082
     /* 153082 */ GIM_Reject,
     /* 153083 */ // Label 2078: @153083
     /* 153083 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(153108), // Rule ID 1448 //
     /* 153088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 153091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153101 */   // (sra:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VSRAD:{ *:[v2i64] } ?:{ *:[v2i64] }:$vA, ?:{ *:[v2i64] }:$vB)
     /* 153101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAD),
     /* 153106 */   GIR_RootConstrainSelectedInstOperands,
     /* 153107 */   // GIR_Coverage, 1448,
     /* 153107 */   GIR_Done,
     /* 153108 */ // Label 2090: @153108
     /* 153108 */ GIM_Reject,
     /* 153109 */ // Label 2079: @153109
     /* 153109 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(153134), // Rule ID 1411 //
     /* 153114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153127 */   // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSRAW:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 153127 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAW),
     /* 153132 */   GIR_RootConstrainSelectedInstOperands,
     /* 153133 */   // GIR_Coverage, 1411,
     /* 153133 */   GIR_Done,
     /* 153134 */ // Label 2091: @153134
     /* 153134 */ GIM_Reject,
     /* 153135 */ // Label 2080: @153135
     /* 153135 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(153160), // Rule ID 1410 //
     /* 153140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153153 */   // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSRAH:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 153153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAH),
     /* 153158 */   GIR_RootConstrainSelectedInstOperands,
     /* 153159 */   // GIR_Coverage, 1410,
     /* 153159 */   GIR_Done,
     /* 153160 */ // Label 2092: @153160
     /* 153160 */ GIM_Reject,
     /* 153161 */ // Label 2081: @153161
     /* 153161 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(153186), // Rule ID 1409 //
     /* 153166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 153175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153179 */   // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSRAB:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 153179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSRAB),
     /* 153184 */   GIR_RootConstrainSelectedInstOperands,
     /* 153185 */   // GIR_Coverage, 1409,
     /* 153185 */   GIR_Done,
     /* 153186 */ // Label 2093: @153186
     /* 153186 */ GIM_Reject,
     /* 153187 */ // Label 2082: @153187
     /* 153187 */ GIM_Reject,
     /* 153188 */ // Label 30: @153188
     /* 153188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2101*/ GIMT_Encode4(153495),
     /* 153199 */ /*GILLT_s32*//*Label 2094*/ GIMT_Encode4(153227),
     /* 153203 */ /*GILLT_s64*//*Label 2095*/ GIMT_Encode4(153299),
     /* 153207 */ /*GILLT_s128*//*Label 2096*/ GIMT_Encode4(153365),
     /* 153211 */ /*GILLT_v2s64*//*Label 2097*/ GIMT_Encode4(153391),
     /* 153215 */ /*GILLT_v4s32*//*Label 2098*/ GIMT_Encode4(153417),
     /* 153219 */ /*GILLT_v8s16*//*Label 2099*/ GIMT_Encode4(153443),
     /* 153223 */ /*GILLT_v16s8*//*Label 2100*/ GIMT_Encode4(153469),
     /* 153227 */ // Label 2094: @153227
     /* 153227 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(153298),
     /* 153232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 153235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 153242 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(153275), // Rule ID 1221 //
     /* 153247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153255 */     // MIs[1] Operand 1
     /* 153255 */     // No operand predicates
     /* 153255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153257 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 153257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 153260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153262 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 153267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 153273 */     GIR_RootConstrainSelectedInstOperands,
     /* 153274 */     // GIR_Coverage, 1221,
     /* 153274 */     GIR_EraseRootFromParent_Done,
     /* 153275 */   // Label 2103: @153275
     /* 153275 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(153297), // Rule ID 1220 //
     /* 153280 */     // (rotl:{ *:[i32] } i32:{ *:[i32] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLWNM:{ *:[i32] } ?:{ *:[i32] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] }, 31:{ *:[i32] })
     /* 153280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWNM),
     /* 153283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 153289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 153295 */     GIR_RootConstrainSelectedInstOperands,
     /* 153296 */     // GIR_Coverage, 1220,
     /* 153296 */     GIR_EraseRootFromParent_Done,
     /* 153297 */   // Label 2104: @153297
     /* 153297 */   GIM_Reject,
     /* 153298 */ // Label 2102: @153298
     /* 153298 */ GIM_Reject,
     /* 153299 */ // Label 2095: @153299
     /* 153299 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(153364),
     /* 153304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 153307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 153314 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(153344), // Rule ID 1543 //
     /* 153319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 153323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153327 */     // MIs[1] Operand 1
     /* 153327 */     // No operand predicates
     /* 153327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153329 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm)  =>  (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$in, (imm:{ *:[i32] }):$imm, 0:{ *:[i32] })
     /* 153329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 153332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153334 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 153339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153342 */     GIR_RootConstrainSelectedInstOperands,
     /* 153343 */     // GIR_Coverage, 1543,
     /* 153343 */     GIR_EraseRootFromParent_Done,
     /* 153344 */   // Label 2106: @153344
     /* 153344 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(153363), // Rule ID 1542 //
     /* 153349 */     // (rotl:{ *:[i64] } i64:{ *:[i64] }:$in, i32:{ *:[i32] }:$sh)  =>  (RLDCL:{ *:[i64] } ?:{ *:[i64] }:$in, ?:{ *:[i32] }:$sh, 0:{ *:[i32] })
     /* 153349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDCL),
     /* 153352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 153354 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 153356 */     GIR_RootToRootCopy, /*OpIdx*/2, // sh
     /* 153358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 153361 */     GIR_RootConstrainSelectedInstOperands,
     /* 153362 */     // GIR_Coverage, 1542,
     /* 153362 */     GIR_EraseRootFromParent_Done,
     /* 153363 */   // Label 2107: @153363
     /* 153363 */   GIM_Reject,
     /* 153364 */ // Label 2105: @153364
     /* 153364 */ GIM_Reject,
     /* 153365 */ // Label 2096: @153365
     /* 153365 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(153390), // Rule ID 3362 //
     /* 153370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 153376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 153379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153383 */   // (rotl:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)  =>  (VRLQ:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB)
     /* 153383 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLQ),
     /* 153388 */   GIR_RootConstrainSelectedInstOperands,
     /* 153389 */   // GIR_Coverage, 3362,
     /* 153389 */   GIR_Done,
     /* 153390 */ // Label 2108: @153390
     /* 153390 */ GIM_Reject,
     /* 153391 */ // Label 2097: @153391
     /* 153391 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(153416), // Rule ID 1443 //
     /* 153396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 153399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 153402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153409 */   // (rotl:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)  =>  (VRLD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB)
     /* 153409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLD),
     /* 153414 */   GIR_RootConstrainSelectedInstOperands,
     /* 153415 */   // GIR_Coverage, 1443,
     /* 153415 */   GIR_Done,
     /* 153416 */ // Label 2109: @153416
     /* 153416 */ GIM_Reject,
     /* 153417 */ // Label 2098: @153417
     /* 153417 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(153442), // Rule ID 1294 //
     /* 153422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153435 */   // (rotl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VRLW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)
     /* 153435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLW),
     /* 153440 */   GIR_RootConstrainSelectedInstOperands,
     /* 153441 */   // GIR_Coverage, 1294,
     /* 153441 */   GIR_Done,
     /* 153442 */ // Label 2110: @153442
     /* 153442 */ GIM_Reject,
     /* 153443 */ // Label 2099: @153443
     /* 153443 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(153468), // Rule ID 1293 //
     /* 153448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 153457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153461 */   // (rotl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VRLH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)
     /* 153461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLH),
     /* 153466 */   GIR_RootConstrainSelectedInstOperands,
     /* 153467 */   // GIR_Coverage, 1293,
     /* 153467 */   GIR_Done,
     /* 153468 */ // Label 2111: @153468
     /* 153468 */ GIM_Reject,
     /* 153469 */ // Label 2100: @153469
     /* 153469 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(153494), // Rule ID 1292 //
     /* 153474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 153477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 153480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 153483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 153487 */   // (rotl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VRLB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)
     /* 153487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRLB),
     /* 153492 */   GIR_RootConstrainSelectedInstOperands,
     /* 153493 */   // GIR_Coverage, 1292,
     /* 153493 */   GIR_Done,
     /* 153494 */ // Label 2112: @153494
     /* 153494 */ GIM_Reject,
     /* 153495 */ // Label 2101: @153495
     /* 153495 */ GIM_Reject,
     /* 153496 */ // Label 31: @153496
     /* 153496 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(157497),
     /* 153501 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 153504 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2116*/ GIMT_Encode4(154073),
     /* 153515 */   /*GILLT_s32*//*Label 2114*/ GIMT_Encode4(153523),
     /* 153519 */   /*GILLT_s64*//*Label 2115*/ GIMT_Encode4(153798),
     /* 153523 */   // Label 2114: @153523
     /* 153523 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(153797),
     /* 153528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 153531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153535 */     GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(153622), // Rule ID 3034 //
     /* 153540 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153543 */       // MIs[0] Operand 1
     /* 153543 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153548 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153552 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153556 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153560 */       // MIs[1] Operand 1
     /* 153560 */       // No operand predicates
     /* 153560 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153562 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 153562 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153565 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153569 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153574 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153578 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153581 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153583 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153586 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153590 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153595 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153602 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153607 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153612 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153615 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153617 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153620 */       GIR_RootConstrainSelectedInstOperands,
     /* 153621 */       // GIR_Coverage, 3034,
     /* 153621 */       GIR_EraseRootFromParent_Done,
     /* 153622 */     // Label 2118: @153622
     /* 153622 */     GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(153709), // Rule ID 3050 //
     /* 153627 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153630 */       // MIs[0] Operand 1
     /* 153630 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153635 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153639 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153643 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153647 */       // MIs[1] Operand 1
     /* 153647 */       // No operand predicates
     /* 153647 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153649 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 153649 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153652 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153656 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153661 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153665 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153668 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153670 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153673 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153677 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153682 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153689 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153704 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153707 */       GIR_RootConstrainSelectedInstOperands,
     /* 153708 */       // GIR_Coverage, 3050,
     /* 153708 */       GIR_EraseRootFromParent_Done,
     /* 153709 */     // Label 2119: @153709
     /* 153709 */     GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(153796), // Rule ID 3058 //
     /* 153714 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153717 */       // MIs[0] Operand 1
     /* 153717 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153722 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153726 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153730 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 153734 */       // MIs[1] Operand 1
     /* 153734 */       // No operand predicates
     /* 153734 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153736 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 153736 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153739 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 153743 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153748 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153752 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153757 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153760 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153764 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153769 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 153776 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153781 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153786 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153789 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153791 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153794 */       GIR_RootConstrainSelectedInstOperands,
     /* 153795 */       // GIR_Coverage, 3058,
     /* 153795 */       GIR_EraseRootFromParent_Done,
     /* 153796 */     // Label 2120: @153796
     /* 153796 */     GIM_Reject,
     /* 153797 */   // Label 2117: @153797
     /* 153797 */   GIM_Reject,
     /* 153798 */   // Label 2115: @153798
     /* 153798 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(154072),
     /* 153803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 153806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153810 */     GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(153897), // Rule ID 3130 //
     /* 153815 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153818 */       // MIs[0] Operand 1
     /* 153818 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 153823 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153827 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153831 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153835 */       // MIs[1] Operand 1
     /* 153835 */       // No operand predicates
     /* 153835 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153837 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 153837 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153840 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153844 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153849 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153853 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153858 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153861 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153865 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153870 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 153877 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153882 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153887 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153890 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153892 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153895 */       GIR_RootConstrainSelectedInstOperands,
     /* 153896 */       // GIR_Coverage, 3130,
     /* 153896 */       GIR_EraseRootFromParent_Done,
     /* 153897 */     // Label 2122: @153897
     /* 153897 */     GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(153984), // Rule ID 3146 //
     /* 153902 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153905 */       // MIs[0] Operand 1
     /* 153905 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 153910 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153914 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153918 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 153922 */       // MIs[1] Operand 1
     /* 153922 */       // No operand predicates
     /* 153922 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 153924 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 153924 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 153927 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 153931 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153936 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 153940 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 153943 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 153945 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 153948 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 153952 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 153957 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 153964 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 153969 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 153974 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 153977 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 153979 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 153982 */       GIR_RootConstrainSelectedInstOperands,
     /* 153983 */       // GIR_Coverage, 3146,
     /* 153983 */       GIR_EraseRootFromParent_Done,
     /* 153984 */     // Label 2123: @153984
     /* 153984 */     GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(154071), // Rule ID 3154 //
     /* 153989 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 153992 */       // MIs[0] Operand 1
     /* 153992 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 153997 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154001 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154005 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154009 */       // MIs[1] Operand 1
     /* 154009 */       // No operand predicates
     /* 154009 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154011 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 154011 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154014 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154018 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154023 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154027 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154030 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154032 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154035 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154039 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154044 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154061 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154064 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154066 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154069 */       GIR_RootConstrainSelectedInstOperands,
     /* 154070 */       // GIR_Coverage, 3154,
     /* 154070 */       GIR_EraseRootFromParent_Done,
     /* 154071 */     // Label 2124: @154071
     /* 154071 */     GIM_Reject,
     /* 154072 */   // Label 2121: @154072
     /* 154072 */   GIM_Reject,
     /* 154073 */   // Label 2116: @154073
     /* 154073 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2127*/ GIMT_Encode4(154528),
     /* 154084 */   /*GILLT_s32*//*Label 2125*/ GIMT_Encode4(154092),
     /* 154088 */   /*GILLT_s64*//*Label 2126*/ GIMT_Encode4(154310),
     /* 154092 */   // Label 2125: @154092
     /* 154092 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(154309),
     /* 154097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154104 */     GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(154172), // Rule ID 3794 //
     /* 154109 */       // MIs[0] Operand 1
     /* 154109 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154114 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154118 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154122 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154126 */       // MIs[1] Operand 1
     /* 154126 */       // No operand predicates
     /* 154126 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154128 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] })
     /* 154128 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154131 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154135 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154140 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154144 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154147 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154149 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154152 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154154 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154161 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154166 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154171 */       // GIR_Coverage, 3794,
     /* 154171 */       GIR_EraseRootFromParent_Done,
     /* 154172 */     // Label 2129: @154172
     /* 154172 */     GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(154240), // Rule ID 3796 //
     /* 154177 */       // MIs[0] Operand 1
     /* 154177 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154182 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154186 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154190 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154194 */       // MIs[1] Operand 1
     /* 154194 */       // No operand predicates
     /* 154194 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154196 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] })
     /* 154196 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154199 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154203 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154208 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154212 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154215 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154217 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154220 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154222 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154229 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154234 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154239 */       // GIR_Coverage, 3796,
     /* 154239 */       GIR_EraseRootFromParent_Done,
     /* 154240 */     // Label 2130: @154240
     /* 154240 */     GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(154308), // Rule ID 3797 //
     /* 154245 */       // MIs[0] Operand 1
     /* 154245 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154250 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154254 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154258 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154262 */       // MIs[1] Operand 1
     /* 154262 */       // No operand predicates
     /* 154262 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154264 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] })
     /* 154264 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154267 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154271 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154276 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154280 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154283 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154290 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154297 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154302 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154307 */       // GIR_Coverage, 3797,
     /* 154307 */       GIR_EraseRootFromParent_Done,
     /* 154308 */     // Label 2131: @154308
     /* 154308 */     GIM_Reject,
     /* 154309 */   // Label 2128: @154309
     /* 154309 */   GIM_Reject,
     /* 154310 */   // Label 2126: @154310
     /* 154310 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(154527),
     /* 154315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154322 */     GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(154390), // Rule ID 3806 //
     /* 154327 */       // MIs[0] Operand 1
     /* 154327 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 154332 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154336 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154340 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154344 */       // MIs[1] Operand 1
     /* 154344 */       // No operand predicates
     /* 154344 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154346 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] })
     /* 154346 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154349 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154353 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154358 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154362 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154365 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154367 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154370 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154372 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154379 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154384 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154389 */       // GIR_Coverage, 3806,
     /* 154389 */       GIR_EraseRootFromParent_Done,
     /* 154390 */     // Label 2133: @154390
     /* 154390 */     GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(154458), // Rule ID 3808 //
     /* 154395 */       // MIs[0] Operand 1
     /* 154395 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 154400 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154404 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154408 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154412 */       // MIs[1] Operand 1
     /* 154412 */       // No operand predicates
     /* 154412 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154414 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] })
     /* 154414 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154417 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154421 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154426 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154430 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154433 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154440 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154447 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154452 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154457 */       // GIR_Coverage, 3808,
     /* 154457 */       GIR_EraseRootFromParent_Done,
     /* 154458 */     // Label 2134: @154458
     /* 154458 */     GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(154526), // Rule ID 3809 //
     /* 154463 */       // MIs[0] Operand 1
     /* 154463 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 154468 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154472 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154476 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154480 */       // MIs[1] Operand 1
     /* 154480 */       // No operand predicates
     /* 154480 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154482 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] })
     /* 154482 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 154485 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154489 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154494 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154498 */       GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 154501 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 154503 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154506 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154508 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154515 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154520 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154525 */       // GIR_Coverage, 3809,
     /* 154525 */       GIR_EraseRootFromParent_Done,
     /* 154526 */     // Label 2135: @154526
     /* 154526 */     GIM_Reject,
     /* 154527 */   // Label 2132: @154527
     /* 154527 */   GIM_Reject,
     /* 154528 */   // Label 2127: @154528
     /* 154528 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2138*/ GIMT_Encode4(155097),
     /* 154539 */   /*GILLT_s32*//*Label 2136*/ GIMT_Encode4(154547),
     /* 154543 */   /*GILLT_s64*//*Label 2137*/ GIMT_Encode4(154822),
     /* 154547 */   // Label 2136: @154547
     /* 154547 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(154821),
     /* 154552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154559 */     GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(154646), // Rule ID 3817 //
     /* 154564 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154567 */       // MIs[0] Operand 1
     /* 154567 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154572 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154576 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154580 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154584 */       // MIs[1] Operand 1
     /* 154584 */       // No operand predicates
     /* 154584 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154586 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_lt:{ *:[i32] }))
     /* 154586 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154589 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154593 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154598 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154602 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154619 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154626 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154631 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154636 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154639 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154641 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154644 */       GIR_RootConstrainSelectedInstOperands,
     /* 154645 */       // GIR_Coverage, 3817,
     /* 154645 */       GIR_EraseRootFromParent_Done,
     /* 154646 */     // Label 2140: @154646
     /* 154646 */     GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(154733), // Rule ID 3833 //
     /* 154651 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154654 */       // MIs[0] Operand 1
     /* 154654 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154659 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154663 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154667 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154671 */       // MIs[1] Operand 1
     /* 154671 */       // No operand predicates
     /* 154671 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154673 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_gt:{ *:[i32] }))
     /* 154673 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154676 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154680 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154685 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154689 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154692 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154694 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154697 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154701 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154706 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154713 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154718 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154723 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154726 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154728 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154731 */       GIR_RootConstrainSelectedInstOperands,
     /* 154732 */       // GIR_Coverage, 3833,
     /* 154732 */       GIR_EraseRootFromParent_Done,
     /* 154733 */     // Label 2141: @154733
     /* 154733 */     GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(154820), // Rule ID 3841 //
     /* 154738 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154741 */       // MIs[0] Operand 1
     /* 154741 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 154746 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154750 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154754 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32SExt16),
     /* 154758 */       // MIs[1] Operand 1
     /* 154758 */       // No operand predicates
     /* 154758 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154760 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPWI:{ *:[i32] } ?:{ *:[i32] }:$s1, (imm:{ *:[i32] }):$imm), sub_eq:{ *:[i32] }))
     /* 154760 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154763 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPWI),
     /* 154767 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154772 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154776 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154779 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154781 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154784 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154788 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154793 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 154800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154810 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154813 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154815 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154818 */       GIR_RootConstrainSelectedInstOperands,
     /* 154819 */       // GIR_Coverage, 3841,
     /* 154819 */       GIR_EraseRootFromParent_Done,
     /* 154820 */     // Label 2142: @154820
     /* 154820 */     GIM_Reject,
     /* 154821 */   // Label 2139: @154821
     /* 154821 */   GIM_Reject,
     /* 154822 */   // Label 2137: @154822
     /* 154822 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(155096),
     /* 154827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 154830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154834 */     GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(154921), // Rule ID 3913 //
     /* 154839 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154842 */       // MIs[0] Operand 1
     /* 154842 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 154847 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154851 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154855 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154859 */       // MIs[1] Operand 1
     /* 154859 */       // No operand predicates
     /* 154859 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154861 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_lt:{ *:[i32] }))
     /* 154861 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154864 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154868 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154873 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154877 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154880 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154882 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154885 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154889 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154894 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 154901 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154906 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154911 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 154914 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 154916 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154919 */       GIR_RootConstrainSelectedInstOperands,
     /* 154920 */       // GIR_Coverage, 3913,
     /* 154920 */       GIR_EraseRootFromParent_Done,
     /* 154921 */     // Label 2144: @154921
     /* 154921 */     GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(155008), // Rule ID 3929 //
     /* 154926 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 154929 */       // MIs[0] Operand 1
     /* 154929 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 154934 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154938 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154942 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 154946 */       // MIs[1] Operand 1
     /* 154946 */       // No operand predicates
     /* 154946 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154948 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_gt:{ *:[i32] }))
     /* 154948 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 154951 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 154955 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154960 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 154964 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 154967 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 154969 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 154972 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154976 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154981 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 154988 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 154993 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 154998 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155001 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155003 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155006 */       GIR_RootConstrainSelectedInstOperands,
     /* 155007 */       // GIR_Coverage, 3929,
     /* 155007 */       GIR_EraseRootFromParent_Done,
     /* 155008 */     // Label 2145: @155008
     /* 155008 */     GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(155095), // Rule ID 3937 //
     /* 155013 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 155016 */       // MIs[0] Operand 1
     /* 155016 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155021 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155025 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155029 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64SExt16),
     /* 155033 */       // MIs[1] Operand 1
     /* 155033 */       // No operand predicates
     /* 155033 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 155035 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, (imm:{ *:[i64] })<<P:Predicate_imm64SExt16>>:$imm, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPDI:{ *:[i32] } ?:{ *:[i64] }:$s1, (imm:{ *:[i64] }):$imm), sub_eq:{ *:[i32] }))
     /* 155035 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155038 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPDI),
     /* 155042 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155047 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155051 */       GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 155054 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155056 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155059 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155063 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155068 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155075 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155080 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155085 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155088 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155090 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155093 */       GIR_RootConstrainSelectedInstOperands,
     /* 155094 */       // GIR_Coverage, 3937,
     /* 155094 */       GIR_EraseRootFromParent_Done,
     /* 155095 */     // Label 2146: @155095
     /* 155095 */     GIM_Reject,
     /* 155096 */   // Label 2143: @155096
     /* 155096 */   GIM_Reject,
     /* 155097 */   // Label 2138: @155097
     /* 155097 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2150*/ GIMT_Encode4(156112),
     /* 155108 */   /*GILLT_s1*//*Label 2147*/ GIMT_Encode4(155120),
     /* 155112 */   /*GILLT_s32*//*Label 2148*/ GIMT_Encode4(155344),
     /* 155116 */   /*GILLT_s64*//*Label 2149*/ GIMT_Encode4(155728),
     /* 155120 */   // Label 2147: @155120
     /* 155120 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(155343),
     /* 155125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 155128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155132 */     GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(155153), // Rule ID 3679 //
     /* 155137 */       // MIs[0] Operand 1
     /* 155137 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 155142 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155142 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155145 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155147 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155149 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155151 */       GIR_RootConstrainSelectedInstOperands,
     /* 155152 */       // GIR_Coverage, 3679,
     /* 155152 */       GIR_EraseRootFromParent_Done,
     /* 155153 */     // Label 2152: @155153
     /* 155153 */     GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(155174), // Rule ID 3680 //
     /* 155158 */       // MIs[0] Operand 1
     /* 155158 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 155163 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155163 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155166 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155168 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155170 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155172 */       GIR_RootConstrainSelectedInstOperands,
     /* 155173 */       // GIR_Coverage, 3680,
     /* 155173 */       GIR_EraseRootFromParent_Done,
     /* 155174 */     // Label 2153: @155174
     /* 155174 */     GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(155195), // Rule ID 3681 //
     /* 155179 */       // MIs[0] Operand 1
     /* 155179 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155184 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETLE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155184 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155187 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155189 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155191 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155193 */       GIR_RootConstrainSelectedInstOperands,
     /* 155194 */       // GIR_Coverage, 3681,
     /* 155194 */       GIR_EraseRootFromParent_Done,
     /* 155195 */     // Label 2154: @155195
     /* 155195 */     GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(155216), // Rule ID 3682 //
     /* 155200 */       // MIs[0] Operand 1
     /* 155200 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155205 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETULE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155205 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155208 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155210 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155212 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155214 */       GIR_RootConstrainSelectedInstOperands,
     /* 155215 */       // GIR_Coverage, 3682,
     /* 155215 */       GIR_EraseRootFromParent_Done,
     /* 155216 */     // Label 2155: @155216
     /* 155216 */     GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(155237), // Rule ID 3683 //
     /* 155221 */       // MIs[0] Operand 1
     /* 155221 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 155226 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETEQ:{ *:[Other] })  =>  (CREQV:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155226 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CREQV),
     /* 155229 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155231 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155233 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155235 */       GIR_RootConstrainSelectedInstOperands,
     /* 155236 */       // GIR_Coverage, 3683,
     /* 155236 */       GIR_EraseRootFromParent_Done,
     /* 155237 */     // Label 2156: @155237
     /* 155237 */     GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(155258), // Rule ID 3684 //
     /* 155242 */       // MIs[0] Operand 1
     /* 155242 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155247 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155247 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155250 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155252 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155254 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155256 */       GIR_RootConstrainSelectedInstOperands,
     /* 155257 */       // GIR_Coverage, 3684,
     /* 155257 */       GIR_EraseRootFromParent_Done,
     /* 155258 */     // Label 2157: @155258
     /* 155258 */     GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(155279), // Rule ID 3685 //
     /* 155263 */       // MIs[0] Operand 1
     /* 155263 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155268 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGE:{ *:[Other] })  =>  (CRORC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155268 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRORC),
     /* 155271 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155273 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155275 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155277 */       GIR_RootConstrainSelectedInstOperands,
     /* 155278 */       // GIR_Coverage, 3685,
     /* 155278 */       GIR_EraseRootFromParent_Done,
     /* 155279 */     // Label 2158: @155279
     /* 155279 */     GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(155300), // Rule ID 3686 //
     /* 155284 */       // MIs[0] Operand 1
     /* 155284 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 155289 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s2, ?:{ *:[i1] }:$s1)
     /* 155289 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155292 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155294 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155296 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155298 */       GIR_RootConstrainSelectedInstOperands,
     /* 155299 */       // GIR_Coverage, 3686,
     /* 155299 */       GIR_EraseRootFromParent_Done,
     /* 155300 */     // Label 2159: @155300
     /* 155300 */     GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(155321), // Rule ID 3687 //
     /* 155305 */       // MIs[0] Operand 1
     /* 155305 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 155310 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETUGT:{ *:[Other] })  =>  (CRANDC:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155310 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRANDC),
     /* 155313 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155315 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155317 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155319 */       GIR_RootConstrainSelectedInstOperands,
     /* 155320 */       // GIR_Coverage, 3687,
     /* 155320 */       GIR_EraseRootFromParent_Done,
     /* 155321 */     // Label 2160: @155321
     /* 155321 */     GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(155342), // Rule ID 3688 //
     /* 155326 */       // MIs[0] Operand 1
     /* 155326 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155331 */       // (setcc:{ *:[i1] } i1:{ *:[i1] }:$s1, i1:{ *:[i1] }:$s2, SETNE:{ *:[Other] })  =>  (CRXOR:{ *:[i1] } ?:{ *:[i1] }:$s1, ?:{ *:[i1] }:$s2)
     /* 155331 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRXOR),
     /* 155334 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155336 */       GIR_RootToRootCopy, /*OpIdx*/2, // s1
     /* 155338 */       GIR_RootToRootCopy, /*OpIdx*/3, // s2
     /* 155340 */       GIR_RootConstrainSelectedInstOperands,
     /* 155341 */       // GIR_Coverage, 3688,
     /* 155341 */       GIR_EraseRootFromParent_Done,
     /* 155342 */     // Label 2161: @155342
     /* 155342 */     GIM_Reject,
     /* 155343 */   // Label 2151: @155343
     /* 155343 */   GIM_Reject,
     /* 155344 */   // Label 2148: @155344
     /* 155344 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(155727),
     /* 155349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155356 */     GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(155430), // Rule ID 2980 //
     /* 155361 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155364 */       // MIs[0] Operand 1
     /* 155364 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155369 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155369 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155372 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155376 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155381 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155385 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155389 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155391 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155394 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155398 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155403 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155410 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155415 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155420 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155423 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155425 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155428 */       GIR_RootConstrainSelectedInstOperands,
     /* 155429 */       // GIR_Coverage, 2980,
     /* 155429 */       GIR_EraseRootFromParent_Done,
     /* 155430 */     // Label 2163: @155430
     /* 155430 */     GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(155504), // Rule ID 2994 //
     /* 155435 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155438 */       // MIs[0] Operand 1
     /* 155438 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155443 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 155443 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155446 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155450 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155455 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155459 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155463 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155465 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155468 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155472 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155477 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155484 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155489 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155494 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155497 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155499 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155502 */       GIR_RootConstrainSelectedInstOperands,
     /* 155503 */       // GIR_Coverage, 2994,
     /* 155503 */       GIR_EraseRootFromParent_Done,
     /* 155504 */     // Label 2164: @155504
     /* 155504 */     GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(155578), // Rule ID 3002 //
     /* 155509 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155512 */       // MIs[0] Operand 1
     /* 155512 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155517 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155517 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155520 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 155524 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155529 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155533 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155537 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155539 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155542 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155546 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155551 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155558 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155563 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155568 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155571 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155573 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155576 */       GIR_RootConstrainSelectedInstOperands,
     /* 155577 */       // GIR_Coverage, 3002,
     /* 155577 */       GIR_EraseRootFromParent_Done,
     /* 155578 */     // Label 2165: @155578
     /* 155578 */     GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(155652), // Rule ID 3010 //
     /* 155583 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155586 */       // MIs[0] Operand 1
     /* 155586 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155591 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 155591 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155594 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155598 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155603 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155607 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155611 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155613 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155616 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155620 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155625 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155647 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155650 */       GIR_RootConstrainSelectedInstOperands,
     /* 155651 */       // GIR_Coverage, 3010,
     /* 155651 */       GIR_EraseRootFromParent_Done,
     /* 155652 */     // Label 2166: @155652
     /* 155652 */     GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(155726), // Rule ID 3018 //
     /* 155657 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155660 */       // MIs[0] Operand 1
     /* 155660 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 155665 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 155665 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155668 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 155672 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155677 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155681 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155685 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155687 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155690 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155694 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155699 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 155706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155724 */       GIR_RootConstrainSelectedInstOperands,
     /* 155725 */       // GIR_Coverage, 3018,
     /* 155725 */       GIR_EraseRootFromParent_Done,
     /* 155726 */     // Label 2167: @155726
     /* 155726 */     GIM_Reject,
     /* 155727 */   // Label 2162: @155727
     /* 155727 */   GIM_Reject,
     /* 155728 */   // Label 2149: @155728
     /* 155728 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(156111),
     /* 155733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 155736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155740 */     GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(155814), // Rule ID 3082 //
     /* 155745 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155748 */       // MIs[0] Operand 1
     /* 155748 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 155753 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155753 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155756 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155760 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155765 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155769 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155773 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155775 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155778 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155782 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155787 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155794 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155799 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155804 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155807 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155809 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155812 */       GIR_RootConstrainSelectedInstOperands,
     /* 155813 */       // GIR_Coverage, 3082,
     /* 155813 */       GIR_EraseRootFromParent_Done,
     /* 155814 */     // Label 2169: @155814
     /* 155814 */     GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(155888), // Rule ID 3090 //
     /* 155819 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155822 */       // MIs[0] Operand 1
     /* 155822 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 155827 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 155827 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155830 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155834 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155839 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155843 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155847 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155849 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155852 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155856 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155861 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 155868 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155873 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155878 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155881 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155883 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155886 */       GIR_RootConstrainSelectedInstOperands,
     /* 155887 */       // GIR_Coverage, 3090,
     /* 155887 */       GIR_EraseRootFromParent_Done,
     /* 155888 */     // Label 2170: @155888
     /* 155888 */     GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(155962), // Rule ID 3098 //
     /* 155893 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155896 */       // MIs[0] Operand 1
     /* 155896 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 155901 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155901 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155904 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 155908 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155913 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155917 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155921 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155923 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 155926 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155930 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155935 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 155942 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 155947 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 155952 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 155955 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 155957 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155960 */       GIR_RootConstrainSelectedInstOperands,
     /* 155961 */       // GIR_Coverage, 3098,
     /* 155961 */       GIR_EraseRootFromParent_Done,
     /* 155962 */     // Label 2171: @155962
     /* 155962 */     GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(156036), // Rule ID 3106 //
     /* 155967 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 155970 */       // MIs[0] Operand 1
     /* 155970 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 155975 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 155975 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 155978 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 155982 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155987 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 155991 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 155995 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 155997 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156000 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156004 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156009 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156016 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156021 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156031 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156034 */       GIR_RootConstrainSelectedInstOperands,
     /* 156035 */       // GIR_Coverage, 3106,
     /* 156035 */       GIR_EraseRootFromParent_Done,
     /* 156036 */     // Label 2172: @156036
     /* 156036 */     GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(156110), // Rule ID 3114 //
     /* 156041 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 156044 */       // MIs[0] Operand 1
     /* 156044 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 156049 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 156049 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156052 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156056 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156061 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156065 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156069 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156071 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156074 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156078 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156083 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156090 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156095 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156100 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156103 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156105 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156108 */       GIR_RootConstrainSelectedInstOperands,
     /* 156109 */       // GIR_Coverage, 3114,
     /* 156109 */       GIR_EraseRootFromParent_Done,
     /* 156110 */     // Label 2173: @156110
     /* 156110 */     GIM_Reject,
     /* 156111 */   // Label 2168: @156111
     /* 156111 */   GIM_Reject,
     /* 156112 */   // Label 2150: @156112
     /* 156112 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2176*/ GIMT_Encode4(156709),
     /* 156123 */   /*GILLT_s32*//*Label 2174*/ GIMT_Encode4(156131),
     /* 156127 */   /*GILLT_s64*//*Label 2175*/ GIMT_Encode4(156420),
     /* 156131 */   // Label 2174: @156131
     /* 156131 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(156419),
     /* 156136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156143 */     GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(156198), // Rule ID 3800 //
     /* 156148 */       // MIs[0] Operand 1
     /* 156148 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 156153 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 156153 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156156 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156160 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156165 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156169 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156173 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156175 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156178 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156180 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156187 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156192 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156197 */       // GIR_Coverage, 3800,
     /* 156197 */       GIR_EraseRootFromParent_Done,
     /* 156198 */     // Label 2178: @156198
     /* 156198 */     GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(156253), // Rule ID 3801 //
     /* 156203 */       // MIs[0] Operand 1
     /* 156203 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 156208 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] })
     /* 156208 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156211 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156215 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156220 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156224 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156228 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156230 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156233 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156235 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156242 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156247 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156252 */       // GIR_Coverage, 3801,
     /* 156252 */       GIR_EraseRootFromParent_Done,
     /* 156253 */     // Label 2179: @156253
     /* 156253 */     GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(156308), // Rule ID 3802 //
     /* 156258 */       // MIs[0] Operand 1
     /* 156258 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 156263 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 156263 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156266 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156270 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156275 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156279 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156283 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156290 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156297 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156302 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156307 */       // GIR_Coverage, 3802,
     /* 156307 */       GIR_EraseRootFromParent_Done,
     /* 156308 */     // Label 2180: @156308
     /* 156308 */     GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(156363), // Rule ID 3803 //
     /* 156313 */       // MIs[0] Operand 1
     /* 156313 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156318 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] })
     /* 156318 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156321 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156325 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156330 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156334 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156338 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156340 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156343 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156345 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156352 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156357 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156362 */       // GIR_Coverage, 3803,
     /* 156362 */       GIR_EraseRootFromParent_Done,
     /* 156363 */     // Label 2181: @156363
     /* 156363 */     GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(156418), // Rule ID 3804 //
     /* 156368 */       // MIs[0] Operand 1
     /* 156368 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156373 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] })
     /* 156373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156385 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156389 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156393 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156395 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156398 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156400 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156407 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156412 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156417 */       // GIR_Coverage, 3804,
     /* 156417 */       GIR_EraseRootFromParent_Done,
     /* 156418 */     // Label 2182: @156418
     /* 156418 */     GIM_Reject,
     /* 156419 */   // Label 2177: @156419
     /* 156419 */   GIM_Reject,
     /* 156420 */   // Label 2175: @156420
     /* 156420 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(156708),
     /* 156425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156432 */     GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(156487), // Rule ID 3812 //
     /* 156437 */       // MIs[0] Operand 1
     /* 156437 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 156442 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156442 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156445 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156449 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156454 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156458 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156462 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156464 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156467 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156469 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156476 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156481 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156486 */       // GIR_Coverage, 3812,
     /* 156486 */       GIR_EraseRootFromParent_Done,
     /* 156487 */     // Label 2184: @156487
     /* 156487 */     GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(156542), // Rule ID 3813 //
     /* 156492 */       // MIs[0] Operand 1
     /* 156492 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 156497 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] })
     /* 156497 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156500 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156504 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156509 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156513 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156517 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156519 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156522 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156524 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156531 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156536 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156541 */       // GIR_Coverage, 3813,
     /* 156541 */       GIR_EraseRootFromParent_Done,
     /* 156542 */     // Label 2185: @156542
     /* 156542 */     GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(156597), // Rule ID 3814 //
     /* 156547 */       // MIs[0] Operand 1
     /* 156547 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 156552 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156552 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156555 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 156559 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156564 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156568 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156572 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156574 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156577 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156579 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156586 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156591 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156596 */       // GIR_Coverage, 3814,
     /* 156596 */       GIR_EraseRootFromParent_Done,
     /* 156597 */     // Label 2186: @156597
     /* 156597 */     GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(156652), // Rule ID 3815 //
     /* 156602 */       // MIs[0] Operand 1
     /* 156602 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 156607 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] })
     /* 156607 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156610 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156614 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156619 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156623 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156627 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156629 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156632 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156634 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156641 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156646 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156651 */       // GIR_Coverage, 3815,
     /* 156651 */       GIR_EraseRootFromParent_Done,
     /* 156652 */     // Label 2187: @156652
     /* 156652 */     GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(156707), // Rule ID 3816 //
     /* 156657 */       // MIs[0] Operand 1
     /* 156657 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 156662 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] })
     /* 156662 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156665 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 156669 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156674 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156678 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156682 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 156684 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156687 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156689 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 156696 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156701 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156706 */       // GIR_Coverage, 3816,
     /* 156706 */       GIR_EraseRootFromParent_Done,
     /* 156707 */     // Label 2188: @156707
     /* 156707 */     GIM_Reject,
     /* 156708 */   // Label 2183: @156708
     /* 156708 */   GIM_Reject,
     /* 156709 */   // Label 2176: @156709
     /* 156709 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2191*/ GIMT_Encode4(157496),
     /* 156720 */   /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(156728),
     /* 156724 */   /*GILLT_s64*//*Label 2190*/ GIMT_Encode4(157112),
     /* 156728 */   // Label 2189: @156728
     /* 156728 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(157111),
     /* 156733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156740 */     GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(156814), // Rule ID 3865 //
     /* 156745 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156748 */       // MIs[0] Operand 1
     /* 156748 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 156753 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156753 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156756 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156760 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156765 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156769 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156773 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156775 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156778 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156782 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156787 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156794 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156799 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156804 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156807 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156809 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156812 */       GIR_RootConstrainSelectedInstOperands,
     /* 156813 */       // GIR_Coverage, 3865,
     /* 156813 */       GIR_EraseRootFromParent_Done,
     /* 156814 */     // Label 2193: @156814
     /* 156814 */     GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(156888), // Rule ID 3873 //
     /* 156819 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156822 */       // MIs[0] Operand 1
     /* 156822 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 156827 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_lt:{ *:[i32] }))
     /* 156827 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156830 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156834 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156839 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156843 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156847 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156849 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156852 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156856 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156861 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 156868 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156873 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156878 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156881 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156883 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156886 */       GIR_RootConstrainSelectedInstOperands,
     /* 156887 */       // GIR_Coverage, 3873,
     /* 156887 */       GIR_EraseRootFromParent_Done,
     /* 156888 */     // Label 2194: @156888
     /* 156888 */     GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(156962), // Rule ID 3881 //
     /* 156893 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156896 */       // MIs[0] Operand 1
     /* 156896 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 156901 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156901 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156904 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLW),
     /* 156908 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156913 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156917 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156921 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156923 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 156926 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156930 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156935 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 156942 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 156947 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 156952 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 156955 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 156957 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156960 */       GIR_RootConstrainSelectedInstOperands,
     /* 156961 */       // GIR_Coverage, 3881,
     /* 156961 */       GIR_EraseRootFromParent_Done,
     /* 156962 */     // Label 2195: @156962
     /* 156962 */     GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(157036), // Rule ID 3889 //
     /* 156967 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 156970 */       // MIs[0] Operand 1
     /* 156970 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 156975 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_gt:{ *:[i32] }))
     /* 156975 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 156978 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 156982 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156987 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 156991 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 156995 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 156997 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157000 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157004 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157009 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157016 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157021 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157026 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157029 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157031 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157034 */       GIR_RootConstrainSelectedInstOperands,
     /* 157035 */       // GIR_Coverage, 3889,
     /* 157035 */       GIR_EraseRootFromParent_Done,
     /* 157036 */     // Label 2196: @157036
     /* 157036 */     GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(157110), // Rule ID 3897 //
     /* 157041 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157044 */       // MIs[0] Operand 1
     /* 157044 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 157049 */       // (setcc:{ *:[i1] } i32:{ *:[i32] }:$s1, i32:{ *:[i32] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPW:{ *:[i32] } ?:{ *:[i32] }:$s1, ?:{ *:[i32] }:$s2), sub_eq:{ *:[i32] }))
     /* 157049 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157052 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPW),
     /* 157056 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157061 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157065 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157069 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157071 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157074 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157078 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157083 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157090 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157095 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157100 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157103 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157105 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157108 */       GIR_RootConstrainSelectedInstOperands,
     /* 157109 */       // GIR_Coverage, 3897,
     /* 157109 */       GIR_EraseRootFromParent_Done,
     /* 157110 */     // Label 2197: @157110
     /* 157110 */     GIM_Reject,
     /* 157111 */   // Label 2192: @157111
     /* 157111 */   GIM_Reject,
     /* 157112 */   // Label 2190: @157112
     /* 157112 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(157495),
     /* 157117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157124 */     GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(157198), // Rule ID 3961 //
     /* 157129 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157132 */       // MIs[0] Operand 1
     /* 157132 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 157137 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157137 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157140 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 157144 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157149 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157153 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157157 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157159 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157162 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157166 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157171 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157178 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157183 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157188 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157191 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157193 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157196 */       GIR_RootConstrainSelectedInstOperands,
     /* 157197 */       // GIR_Coverage, 3961,
     /* 157197 */       GIR_EraseRootFromParent_Done,
     /* 157198 */     // Label 2199: @157198
     /* 157198 */     GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(157272), // Rule ID 3969 //
     /* 157203 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157206 */       // MIs[0] Operand 1
     /* 157206 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 157211 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157211 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157214 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157218 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157223 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157227 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157231 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157233 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157236 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157240 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157245 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157252 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157257 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157262 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157265 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157267 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157270 */       GIR_RootConstrainSelectedInstOperands,
     /* 157271 */       // GIR_Coverage, 3969,
     /* 157271 */       GIR_EraseRootFromParent_Done,
     /* 157272 */     // Label 2200: @157272
     /* 157272 */     GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(157346), // Rule ID 3977 //
     /* 157277 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157280 */       // MIs[0] Operand 1
     /* 157280 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 157285 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPLD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157285 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157288 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPLD),
     /* 157292 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157297 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157301 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157305 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157307 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157310 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157314 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157319 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157326 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157331 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157336 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157339 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157341 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157344 */       GIR_RootConstrainSelectedInstOperands,
     /* 157345 */       // GIR_Coverage, 3977,
     /* 157345 */       GIR_EraseRootFromParent_Done,
     /* 157346 */     // Label 2201: @157346
     /* 157346 */     GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(157420), // Rule ID 3985 //
     /* 157351 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157354 */       // MIs[0] Operand 1
     /* 157354 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 157359 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETLE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157359 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157362 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157366 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157371 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157375 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157379 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157381 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157384 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157388 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157393 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157400 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157410 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157413 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157415 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157418 */       GIR_RootConstrainSelectedInstOperands,
     /* 157419 */       // GIR_Coverage, 3985,
     /* 157419 */       GIR_EraseRootFromParent_Done,
     /* 157420 */     // Label 2202: @157420
     /* 157420 */     GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(157494), // Rule ID 3993 //
     /* 157425 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotISA3_1),
     /* 157428 */       // MIs[0] Operand 1
     /* 157428 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 157433 */       // (setcc:{ *:[i1] } i64:{ *:[i64] }:$s1, i64:{ *:[i64] }:$s2, SETNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (CMPD:{ *:[i32] } ?:{ *:[i64] }:$s1, ?:{ *:[i64] }:$s2), sub_eq:{ *:[i32] }))
     /* 157433 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157436 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CMPD),
     /* 157440 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157445 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157449 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157453 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157455 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157458 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157462 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157467 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157474 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157479 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157484 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157487 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157489 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157492 */       GIR_RootConstrainSelectedInstOperands,
     /* 157493 */       // GIR_Coverage, 3993,
     /* 157493 */       GIR_EraseRootFromParent_Done,
     /* 157494 */     // Label 2203: @157494
     /* 157494 */     GIM_Reject,
     /* 157495 */   // Label 2198: @157495
     /* 157495 */   GIM_Reject,
     /* 157496 */   // Label 2191: @157496
     /* 157496 */   GIM_Reject,
     /* 157497 */ // Label 2113: @157497
     /* 157497 */ GIM_Reject,
     /* 157498 */ // Label 32: @157498
     /* 157498 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(160948),
     /* 157503 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s1,
     /* 157506 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2208*/ GIMT_Encode4(158459),
     /* 157517 */   /*GILLT_s32*//*Label 2205*/ GIMT_Encode4(157529),
     /* 157521 */   /*GILLT_s64*//*Label 2206*/ GIMT_Encode4(157839),
     /* 157525 */   /*GILLT_s128*//*Label 2207*/ GIMT_Encode4(158149),
     /* 157529 */   // Label 2205: @157529
     /* 157529 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(157838),
     /* 157534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 157537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157541 */     GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(157615), // Rule ID 3178 //
     /* 157546 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157549 */       // MIs[0] Operand 1
     /* 157549 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157554 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 157554 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157557 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157561 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157566 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157570 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157574 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157576 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157579 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157583 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157588 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157595 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157600 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157605 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157608 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157610 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157613 */       GIR_RootConstrainSelectedInstOperands,
     /* 157614 */       // GIR_Coverage, 3178,
     /* 157614 */       GIR_EraseRootFromParent_Done,
     /* 157615 */     // Label 2210: @157615
     /* 157615 */     GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(157689), // Rule ID 3194 //
     /* 157620 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157623 */       // MIs[0] Operand 1
     /* 157623 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157628 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 157628 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157631 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157635 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157640 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157644 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157648 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157650 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157653 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157657 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157662 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157669 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157674 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157679 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157682 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157684 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157687 */       GIR_RootConstrainSelectedInstOperands,
     /* 157688 */       // GIR_Coverage, 3194,
     /* 157688 */       GIR_EraseRootFromParent_Done,
     /* 157689 */     // Label 2211: @157689
     /* 157689 */     GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(157763), // Rule ID 3210 //
     /* 157694 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157697 */       // MIs[0] Operand 1
     /* 157697 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 157702 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 157702 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157705 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157709 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157714 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157718 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157722 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157724 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157727 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157731 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157736 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 157743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157748 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157753 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157756 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157758 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157761 */       GIR_RootConstrainSelectedInstOperands,
     /* 157762 */       // GIR_Coverage, 3210,
     /* 157762 */       GIR_EraseRootFromParent_Done,
     /* 157763 */     // Label 2212: @157763
     /* 157763 */     GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(157837), // Rule ID 3226 //
     /* 157768 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157771 */       // MIs[0] Operand 1
     /* 157771 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 157776 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 157776 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157779 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 157783 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157788 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157792 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157796 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157798 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157801 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157805 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157810 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 157817 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157822 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157827 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157830 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157832 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157835 */       GIR_RootConstrainSelectedInstOperands,
     /* 157836 */       // GIR_Coverage, 3226,
     /* 157836 */       GIR_EraseRootFromParent_Done,
     /* 157837 */     // Label 2213: @157837
     /* 157837 */     GIM_Reject,
     /* 157838 */   // Label 2209: @157838
     /* 157838 */   GIM_Reject,
     /* 157839 */   // Label 2206: @157839
     /* 157839 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(158148),
     /* 157844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157851 */     GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(157925), // Rule ID 3234 //
     /* 157856 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157859 */       // MIs[0] Operand 1
     /* 157859 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 157864 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 157864 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157867 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157871 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157876 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157880 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157886 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157889 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157893 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157898 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 157905 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157910 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157915 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157918 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157920 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157923 */       GIR_RootConstrainSelectedInstOperands,
     /* 157924 */       // GIR_Coverage, 3234,
     /* 157924 */       GIR_EraseRootFromParent_Done,
     /* 157925 */     // Label 2215: @157925
     /* 157925 */     GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(157999), // Rule ID 3250 //
     /* 157930 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 157933 */       // MIs[0] Operand 1
     /* 157933 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 157938 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 157938 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 157941 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 157945 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157950 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 157954 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 157958 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 157960 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 157963 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 157967 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 157972 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 157979 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 157984 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 157989 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 157992 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 157994 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 157997 */       GIR_RootConstrainSelectedInstOperands,
     /* 157998 */       // GIR_Coverage, 3250,
     /* 157998 */       GIR_EraseRootFromParent_Done,
     /* 157999 */     // Label 2216: @157999
     /* 157999 */     GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(158073), // Rule ID 3266 //
     /* 158004 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158007 */       // MIs[0] Operand 1
     /* 158007 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158012 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 158012 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158015 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158019 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158024 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158028 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158032 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158034 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158037 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158041 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158046 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158053 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158058 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158063 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158066 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158068 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158071 */       GIR_RootConstrainSelectedInstOperands,
     /* 158072 */       // GIR_Coverage, 3266,
     /* 158072 */       GIR_EraseRootFromParent_Done,
     /* 158073 */     // Label 2217: @158073
     /* 158073 */     GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(158147), // Rule ID 3282 //
     /* 158078 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158081 */       // MIs[0] Operand 1
     /* 158081 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158086 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 158086 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158089 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 158093 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158098 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158102 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158106 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158108 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158111 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158115 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158120 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158127 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158132 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158137 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158140 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158142 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158145 */       GIR_RootConstrainSelectedInstOperands,
     /* 158146 */       // GIR_Coverage, 3282,
     /* 158146 */       GIR_EraseRootFromParent_Done,
     /* 158147 */     // Label 2218: @158147
     /* 158147 */     GIM_Reject,
     /* 158148 */   // Label 2214: @158148
     /* 158148 */   GIM_Reject,
     /* 158149 */   // Label 2207: @158149
     /* 158149 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(158458),
     /* 158154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 158157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158161 */     GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(158235), // Rule ID 3290 //
     /* 158166 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158169 */       // MIs[0] Operand 1
     /* 158169 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158174 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 158174 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158177 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158181 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158186 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158190 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158194 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158196 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158199 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158203 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158208 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158215 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158220 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158225 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158228 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158230 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158233 */       GIR_RootConstrainSelectedInstOperands,
     /* 158234 */       // GIR_Coverage, 3290,
     /* 158234 */       GIR_EraseRootFromParent_Done,
     /* 158235 */     // Label 2220: @158235
     /* 158235 */     GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(158309), // Rule ID 3306 //
     /* 158240 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158243 */       // MIs[0] Operand 1
     /* 158243 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158248 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 158248 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158251 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158255 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158260 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158264 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158268 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158270 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158273 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158277 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158282 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158289 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158304 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158307 */       GIR_RootConstrainSelectedInstOperands,
     /* 158308 */       // GIR_Coverage, 3306,
     /* 158308 */       GIR_EraseRootFromParent_Done,
     /* 158309 */     // Label 2221: @158309
     /* 158309 */     GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(158383), // Rule ID 3322 //
     /* 158314 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158317 */       // MIs[0] Operand 1
     /* 158317 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158322 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 158322 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158325 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158329 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158334 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158338 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158342 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158344 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158347 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158351 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158356 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158363 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158368 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158373 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158376 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158378 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158381 */       GIR_RootConstrainSelectedInstOperands,
     /* 158382 */       // GIR_Coverage, 3322,
     /* 158382 */       GIR_EraseRootFromParent_Done,
     /* 158383 */     // Label 2222: @158383
     /* 158383 */     GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(158457), // Rule ID 3338 //
     /* 158388 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU_IsISA3_1),
     /* 158391 */       // MIs[0] Operand 1
     /* 158391 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158396 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 158396 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158399 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 158403 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158408 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158412 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158416 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158418 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158421 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158425 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158430 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158437 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158442 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158447 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158450 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158452 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158455 */       GIR_RootConstrainSelectedInstOperands,
     /* 158456 */       // GIR_Coverage, 3338,
     /* 158456 */       GIR_EraseRootFromParent_Done,
     /* 158457 */     // Label 2223: @158457
     /* 158457 */     GIM_Reject,
     /* 158458 */   // Label 2219: @158458
     /* 158458 */   GIM_Reject,
     /* 158459 */   // Label 2208: @158459
     /* 158459 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2227*/ GIMT_Encode4(160108),
     /* 158470 */   /*GILLT_s32*//*Label 2224*/ GIMT_Encode4(158482),
     /* 158474 */   /*GILLT_s64*//*Label 2225*/ GIMT_Encode4(159024),
     /* 158478 */   /*GILLT_s128*//*Label 2226*/ GIMT_Encode4(159566),
     /* 158482 */   // Label 2224: @158482
     /* 158482 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(159023),
     /* 158487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158494 */     GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(158552), // Rule ID 4002 //
     /* 158499 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158502 */       // MIs[0] Operand 1
     /* 158502 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 158507 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] })
     /* 158507 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158510 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158514 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158519 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158523 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158527 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158529 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158532 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158534 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158541 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158546 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158551 */       // GIR_Coverage, 4002,
     /* 158551 */       GIR_EraseRootFromParent_Done,
     /* 158552 */     // Label 2229: @158552
     /* 158552 */     GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(158610), // Rule ID 4006 //
     /* 158557 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158560 */       // MIs[0] Operand 1
     /* 158560 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 158565 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 158565 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158568 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158572 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158577 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158581 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158585 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158587 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158590 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158592 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158599 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158604 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158609 */       // GIR_Coverage, 4006,
     /* 158609 */       GIR_EraseRootFromParent_Done,
     /* 158610 */     // Label 2230: @158610
     /* 158610 */     GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(158668), // Rule ID 4010 //
     /* 158615 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158618 */       // MIs[0] Operand 1
     /* 158618 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 158623 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] })
     /* 158623 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158626 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158630 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158635 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158639 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158643 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158645 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158648 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158650 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158657 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158662 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158667 */       // GIR_Coverage, 4010,
     /* 158667 */       GIR_EraseRootFromParent_Done,
     /* 158668 */     // Label 2231: @158668
     /* 158668 */     GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(158726), // Rule ID 4014 //
     /* 158673 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158676 */       // MIs[0] Operand 1
     /* 158676 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 158681 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] })
     /* 158681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158693 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158697 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158701 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 158703 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158706 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158708 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 158715 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158720 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158725 */       // GIR_Coverage, 4014,
     /* 158725 */       GIR_EraseRootFromParent_Done,
     /* 158726 */     // Label 2232: @158726
     /* 158726 */     GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(158800), // Rule ID 4016 //
     /* 158731 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158734 */       // MIs[0] Operand 1
     /* 158734 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 158739 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_lt:{ *:[i32] }))
     /* 158739 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158742 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158746 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158751 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158755 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158759 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158761 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158764 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158768 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158773 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 158780 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158785 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158790 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158793 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158795 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158798 */       GIR_RootConstrainSelectedInstOperands,
     /* 158799 */       // GIR_Coverage, 4016,
     /* 158799 */       GIR_EraseRootFromParent_Done,
     /* 158800 */     // Label 2233: @158800
     /* 158800 */     GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(158874), // Rule ID 4048 //
     /* 158805 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158808 */       // MIs[0] Operand 1
     /* 158808 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 158813 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 158813 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158816 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158820 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158825 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158829 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158833 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158835 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158838 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158842 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158847 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 158854 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158859 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158864 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158867 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158869 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158872 */       GIR_RootConstrainSelectedInstOperands,
     /* 158873 */       // GIR_Coverage, 4048,
     /* 158873 */       GIR_EraseRootFromParent_Done,
     /* 158874 */     // Label 2234: @158874
     /* 158874 */     GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(158948), // Rule ID 4080 //
     /* 158879 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158882 */       // MIs[0] Operand 1
     /* 158882 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 158887 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_eq:{ *:[i32] }))
     /* 158887 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158890 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158894 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158899 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158903 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158921 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 158928 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 158933 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 158938 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 158941 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 158943 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158946 */       GIR_RootConstrainSelectedInstOperands,
     /* 158947 */       // GIR_Coverage, 4080,
     /* 158947 */       GIR_EraseRootFromParent_Done,
     /* 158948 */     // Label 2235: @158948
     /* 158948 */     GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(159022), // Rule ID 4112 //
     /* 158953 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 158956 */       // MIs[0] Operand 1
     /* 158956 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 158961 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUS:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_un:{ *:[i32] }))
     /* 158961 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 158964 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUS),
     /* 158968 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158973 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 158977 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 158981 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 158983 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 158986 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158990 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158995 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159002 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159012 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159015 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159017 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159020 */       GIR_RootConstrainSelectedInstOperands,
     /* 159021 */       // GIR_Coverage, 4112,
     /* 159021 */       GIR_EraseRootFromParent_Done,
     /* 159022 */     // Label 2236: @159022
     /* 159022 */     GIM_Reject,
     /* 159023 */   // Label 2228: @159023
     /* 159023 */   GIM_Reject,
     /* 159024 */   // Label 2225: @159024
     /* 159024 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(159565),
     /* 159029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159036 */     GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(159110), // Rule ID 4128 //
     /* 159041 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159044 */       // MIs[0] Operand 1
     /* 159044 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 159049 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] }))
     /* 159049 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159052 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159056 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159061 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159065 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159069 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159071 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159074 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159078 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159083 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159090 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159095 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159100 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159103 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159105 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159108 */       GIR_RootConstrainSelectedInstOperands,
     /* 159109 */       // GIR_Coverage, 4128,
     /* 159109 */       GIR_EraseRootFromParent_Done,
     /* 159110 */     // Label 2238: @159110
     /* 159110 */     GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(159184), // Rule ID 4160 //
     /* 159115 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159118 */       // MIs[0] Operand 1
     /* 159118 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 159123 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 159123 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159126 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159130 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159135 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159139 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159143 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159145 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159148 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159152 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159157 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159164 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159169 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159174 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159177 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159179 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159182 */       GIR_RootConstrainSelectedInstOperands,
     /* 159183 */       // GIR_Coverage, 4160,
     /* 159183 */       GIR_EraseRootFromParent_Done,
     /* 159184 */     // Label 2239: @159184
     /* 159184 */     GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(159258), // Rule ID 4192 //
     /* 159189 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159192 */       // MIs[0] Operand 1
     /* 159192 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 159197 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] }))
     /* 159197 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159200 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159204 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159209 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159213 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159217 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159219 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159222 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159226 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159231 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159238 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159243 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159248 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159251 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159253 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159256 */       GIR_RootConstrainSelectedInstOperands,
     /* 159257 */       // GIR_Coverage, 4192,
     /* 159257 */       GIR_EraseRootFromParent_Done,
     /* 159258 */     // Label 2240: @159258
     /* 159258 */     GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(159332), // Rule ID 4224 //
     /* 159263 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159266 */       // MIs[0] Operand 1
     /* 159266 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 159271 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] }))
     /* 159271 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159274 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159278 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159283 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159287 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159291 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159293 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159296 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159300 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159305 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159312 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159317 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159322 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159325 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159327 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159330 */       GIR_RootConstrainSelectedInstOperands,
     /* 159331 */       // GIR_Coverage, 4224,
     /* 159331 */       GIR_EraseRootFromParent_Done,
     /* 159332 */     // Label 2241: @159332
     /* 159332 */     GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(159390), // Rule ID 4240 //
     /* 159337 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159340 */       // MIs[0] Operand 1
     /* 159340 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159345 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_lt:{ *:[i32] })
     /* 159345 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159348 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159352 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159357 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159361 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159365 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159367 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159370 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159372 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159379 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159384 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159389 */       // GIR_Coverage, 4240,
     /* 159389 */       GIR_EraseRootFromParent_Done,
     /* 159390 */     // Label 2242: @159390
     /* 159390 */     GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(159448), // Rule ID 4244 //
     /* 159395 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159398 */       // MIs[0] Operand 1
     /* 159398 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159403 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 159403 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159406 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159410 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159415 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159419 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159423 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159425 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159428 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159430 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159437 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159442 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159447 */       // GIR_Coverage, 4244,
     /* 159447 */       GIR_EraseRootFromParent_Done,
     /* 159448 */     // Label 2243: @159448
     /* 159448 */     GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(159506), // Rule ID 4248 //
     /* 159453 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159456 */       // MIs[0] Operand 1
     /* 159456 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 159461 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_eq:{ *:[i32] })
     /* 159461 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159464 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159468 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159473 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159477 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159481 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159488 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159505 */       // GIR_Coverage, 4248,
     /* 159505 */       GIR_EraseRootFromParent_Done,
     /* 159506 */     // Label 2244: @159506
     /* 159506 */     GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(159564), // Rule ID 4252 //
     /* 159511 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159514 */       // MIs[0] Operand 1
     /* 159514 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 159519 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (FCMPUD:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_un:{ *:[i32] })
     /* 159519 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159522 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCMPUD),
     /* 159526 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159531 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159535 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159539 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159541 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159544 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159546 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159553 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159558 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159563 */       // GIR_Coverage, 4252,
     /* 159563 */       GIR_EraseRootFromParent_Done,
     /* 159564 */     // Label 2245: @159564
     /* 159564 */     GIM_Reject,
     /* 159565 */   // Label 2237: @159565
     /* 159565 */   GIM_Reject,
     /* 159566 */   // Label 2226: @159566
     /* 159566 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(160107),
     /* 159571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 159574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159578 */     GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(159652), // Rule ID 4254 //
     /* 159583 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159586 */       // MIs[0] Operand 1
     /* 159586 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 159591 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] }))
     /* 159591 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159594 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159598 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159603 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159607 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159611 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159613 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159616 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159620 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159625 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159647 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159650 */       GIR_RootConstrainSelectedInstOperands,
     /* 159651 */       // GIR_Coverage, 4254,
     /* 159651 */       GIR_EraseRootFromParent_Done,
     /* 159652 */     // Label 2247: @159652
     /* 159652 */     GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(159726), // Rule ID 4286 //
     /* 159657 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159660 */       // MIs[0] Operand 1
     /* 159660 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 159665 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] }))
     /* 159665 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159668 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159672 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159677 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159681 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159685 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159687 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159690 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159694 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159699 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159724 */       GIR_RootConstrainSelectedInstOperands,
     /* 159725 */       // GIR_Coverage, 4286,
     /* 159725 */       GIR_EraseRootFromParent_Done,
     /* 159726 */     // Label 2248: @159726
     /* 159726 */     GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(159800), // Rule ID 4318 //
     /* 159731 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159734 */       // MIs[0] Operand 1
     /* 159734 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 159739 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] }))
     /* 159739 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159742 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159746 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159751 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159755 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159759 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159761 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159764 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159768 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159773 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 159780 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159785 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159790 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159793 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159795 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159798 */       GIR_RootConstrainSelectedInstOperands,
     /* 159799 */       // GIR_Coverage, 4318,
     /* 159799 */       GIR_EraseRootFromParent_Done,
     /* 159800 */     // Label 2249: @159800
     /* 159800 */     GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(159874), // Rule ID 4350 //
     /* 159805 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159808 */       // MIs[0] Operand 1
     /* 159808 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 159813 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETO:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] }))
     /* 159813 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 159816 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159820 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159825 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159829 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159833 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 159835 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 159838 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159842 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159847 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 159854 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159859 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159864 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 159867 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 159869 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159872 */       GIR_RootConstrainSelectedInstOperands,
     /* 159873 */       // GIR_Coverage, 4350,
     /* 159873 */       GIR_EraseRootFromParent_Done,
     /* 159874 */     // Label 2250: @159874
     /* 159874 */     GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(159932), // Rule ID 4366 //
     /* 159879 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159882 */       // MIs[0] Operand 1
     /* 159882 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 159887 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_lt:{ *:[i32] })
     /* 159887 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159890 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159894 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159899 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159903 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159909 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159912 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159914 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_lt),
     /* 159921 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159926 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159931 */       // GIR_Coverage, 4366,
     /* 159931 */       GIR_EraseRootFromParent_Done,
     /* 159932 */     // Label 2251: @159932
     /* 159932 */     GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(159990), // Rule ID 4370 //
     /* 159937 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159940 */       // MIs[0] Operand 1
     /* 159940 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 159945 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_gt:{ *:[i32] })
     /* 159945 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159948 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 159952 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159957 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 159961 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 159965 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 159967 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159970 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159972 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 159979 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 159984 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 159989 */       // GIR_Coverage, 4370,
     /* 159989 */       GIR_EraseRootFromParent_Done,
     /* 159990 */     // Label 2252: @159990
     /* 159990 */     GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(160048), // Rule ID 4374 //
     /* 159995 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 159998 */       // MIs[0] Operand 1
     /* 159998 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160003 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_eq:{ *:[i32] })
     /* 160003 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160006 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 160010 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160015 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160019 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160023 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160025 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160028 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160030 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_eq),
     /* 160037 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160042 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160047 */       // GIR_Coverage, 4374,
     /* 160047 */       GIR_EraseRootFromParent_Done,
     /* 160048 */     // Label 2253: @160048
     /* 160048 */     GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(160106), // Rule ID 4378 //
     /* 160053 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 160056 */       // MIs[0] Operand 1
     /* 160056 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 160061 */       // (setcc:{ *:[i1] } f128:{ *:[f128] }:$s1, f128:{ *:[f128] }:$s2, SETUO:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (XSCMPUQP:{ *:[i32] } ?:{ *:[f128] }:$s1, ?:{ *:[f128] }:$s2), sub_un:{ *:[i32] })
     /* 160061 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160064 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCMPUQP),
     /* 160068 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160073 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160077 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160081 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160083 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160086 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160088 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_un),
     /* 160095 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160100 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160105 */       // GIR_Coverage, 4378,
     /* 160105 */       GIR_EraseRootFromParent_Done,
     /* 160106 */     // Label 2254: @160106
     /* 160106 */     GIM_Reject,
     /* 160107 */   // Label 2246: @160107
     /* 160107 */   GIM_Reject,
     /* 160108 */   // Label 2227: @160108
     /* 160108 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2257*/ GIMT_Encode4(160947),
     /* 160119 */   /*GILLT_s32*//*Label 2255*/ GIMT_Encode4(160127),
     /* 160123 */   /*GILLT_s64*//*Label 2256*/ GIMT_Encode4(160537),
     /* 160127 */   // Label 2255: @160127
     /* 160127 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(160536),
     /* 160132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160139 */     GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(160197), // Rule ID 4569 //
     /* 160144 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160147 */       // MIs[0] Operand 1
     /* 160147 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 160152 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 160152 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160155 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 160159 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160164 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160168 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160172 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160174 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160177 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160179 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160186 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160191 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160196 */       // GIR_Coverage, 4569,
     /* 160196 */       GIR_EraseRootFromParent_Done,
     /* 160197 */     // Label 2259: @160197
     /* 160197 */     GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(160255), // Rule ID 4573 //
     /* 160202 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160205 */       // MIs[0] Operand 1
     /* 160205 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 160210 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 160210 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160213 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 160217 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160222 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160226 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160230 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160232 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160235 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160237 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160244 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160249 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160254 */       // GIR_Coverage, 4573,
     /* 160254 */       GIR_EraseRootFromParent_Done,
     /* 160255 */     // Label 2260: @160255
     /* 160255 */     GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(160313), // Rule ID 4577 //
     /* 160260 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160263 */       // MIs[0] Operand 1
     /* 160263 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160268 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] })
     /* 160268 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160271 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 160275 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160280 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160284 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160288 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160290 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160293 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160295 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160302 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160307 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160312 */       // GIR_Coverage, 4577,
     /* 160312 */       GIR_EraseRootFromParent_Done,
     /* 160313 */     // Label 2261: @160313
     /* 160313 */     GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(160387), // Rule ID 4581 //
     /* 160318 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160321 */       // MIs[0] Operand 1
     /* 160321 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160326 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPLT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160326 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160329 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPLT),
     /* 160333 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160338 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160342 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160346 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160348 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160351 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160355 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160360 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160367 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160372 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160377 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160380 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160382 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160385 */       GIR_RootConstrainSelectedInstOperands,
     /* 160386 */       // GIR_Coverage, 4581,
     /* 160386 */       GIR_EraseRootFromParent_Done,
     /* 160387 */     // Label 2262: @160387
     /* 160387 */     GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(160461), // Rule ID 4613 //
     /* 160392 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160395 */       // MIs[0] Operand 1
     /* 160395 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160400 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPGT:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160400 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160403 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPGT),
     /* 160407 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160412 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160416 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160420 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160422 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160425 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160429 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160434 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160441 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160451 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160454 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160456 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160459 */       GIR_RootConstrainSelectedInstOperands,
     /* 160460 */       // GIR_Coverage, 4613,
     /* 160460 */       GIR_EraseRootFromParent_Done,
     /* 160461 */     // Label 2263: @160461
     /* 160461 */     GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(160535), // Rule ID 4645 //
     /* 160466 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160469 */       // MIs[0] Operand 1
     /* 160469 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160474 */       // (setcc:{ *:[i1] } f32:{ *:[f32] }:$s1, f32:{ *:[f32] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFSCMPEQ:{ *:[i32] } ?:{ *:[f32] }:$s1, ?:{ *:[f32] }:$s2), sub_gt:{ *:[i32] }))
     /* 160474 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160477 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFSCMPEQ),
     /* 160481 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160486 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160490 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160494 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160496 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160499 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160503 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160508 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160515 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160520 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160525 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160528 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160530 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160533 */       GIR_RootConstrainSelectedInstOperands,
     /* 160534 */       // GIR_Coverage, 4645,
     /* 160534 */       GIR_EraseRootFromParent_Done,
     /* 160535 */     // Label 2264: @160535
     /* 160535 */     GIM_Reject,
     /* 160536 */   // Label 2258: @160536
     /* 160536 */   GIM_Reject,
     /* 160537 */   // Label 2256: @160537
     /* 160537 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(160946),
     /* 160542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160549 */     GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(160607), // Rule ID 4677 //
     /* 160554 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160557 */       // MIs[0] Operand 1
     /* 160557 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 160562 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOLT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160562 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160565 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160569 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160574 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160578 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160582 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160584 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160587 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160589 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160596 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160601 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160606 */       // GIR_Coverage, 4677,
     /* 160606 */       GIR_EraseRootFromParent_Done,
     /* 160607 */     // Label 2266: @160607
     /* 160607 */     GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(160665), // Rule ID 4681 //
     /* 160612 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160615 */       // MIs[0] Operand 1
     /* 160615 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OGT),
     /* 160620 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOGT:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160620 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160623 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160627 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160632 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160636 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160640 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160642 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160645 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160647 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160654 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160659 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160664 */       // GIR_Coverage, 4681,
     /* 160664 */       GIR_EraseRootFromParent_Done,
     /* 160665 */     // Label 2267: @160665
     /* 160665 */     GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(160723), // Rule ID 4685 //
     /* 160670 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160673 */       // MIs[0] Operand 1
     /* 160673 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 160678 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETOEQ:{ *:[Other] })  =>  (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] })
     /* 160678 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 160681 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160685 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160690 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160694 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160698 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160700 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160703 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 160705 */       GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160712 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160717 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160722 */       // GIR_Coverage, 4685,
     /* 160722 */       GIR_EraseRootFromParent_Done,
     /* 160723 */     // Label 2268: @160723
     /* 160723 */     GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(160797), // Rule ID 4689 //
     /* 160728 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160731 */       // MIs[0] Operand 1
     /* 160731 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UGE),
     /* 160736 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUGE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPLT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160736 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160739 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPLT),
     /* 160743 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160748 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160752 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160756 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160758 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160761 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160765 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160770 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160777 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160782 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160787 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160790 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160792 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160795 */       GIR_RootConstrainSelectedInstOperands,
     /* 160796 */       // GIR_Coverage, 4689,
     /* 160796 */       GIR_EraseRootFromParent_Done,
     /* 160797 */     // Label 2269: @160797
     /* 160797 */     GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(160871), // Rule ID 4721 //
     /* 160802 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160805 */       // MIs[0] Operand 1
     /* 160805 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 160810 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETULE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPGT:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160810 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160813 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPGT),
     /* 160817 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160822 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160826 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160830 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160832 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160835 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160839 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160844 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160851 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160856 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160861 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160864 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160866 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160869 */       GIR_RootConstrainSelectedInstOperands,
     /* 160870 */       // GIR_Coverage, 4721,
     /* 160870 */       GIR_EraseRootFromParent_Done,
     /* 160871 */     // Label 2270: @160871
     /* 160871 */     GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(160945), // Rule ID 4753 //
     /* 160876 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 160879 */       // MIs[0] Operand 1
     /* 160879 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 160884 */       // (setcc:{ *:[i1] } f64:{ *:[f64] }:$s1, f64:{ *:[f64] }:$s2, SETUNE:{ *:[Other] })  =>  (CRNOT:{ *:[i1] } (EXTRACT_SUBREG:{ *:[i1] } (EFDCMPEQ:{ *:[i32] } ?:{ *:[f64] }:$s1, ?:{ *:[f64] }:$s2), sub_gt:{ *:[i32] }))
     /* 160884 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 160887 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::EFDCMPEQ),
     /* 160891 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160896 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // s1
     /* 160900 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // s2
     /* 160904 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 160906 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 160909 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160913 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160918 */       GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_gt),
     /* 160925 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 160930 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(PPC::CRRCRegClassID),
     /* 160935 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 160938 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 160940 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160943 */       GIR_RootConstrainSelectedInstOperands,
     /* 160944 */       // GIR_Coverage, 4753,
     /* 160944 */       GIR_EraseRootFromParent_Done,
     /* 160945 */     // Label 2271: @160945
     /* 160945 */     GIM_Reject,
     /* 160946 */   // Label 2265: @160946
     /* 160946 */   GIM_Reject,
     /* 160947 */   // Label 2257: @160947
     /* 160947 */   GIM_Reject,
     /* 160948 */ // Label 2204: @160948
     /* 160948 */ GIM_Reject,
     /* 160949 */ // Label 33: @160949
     /* 160949 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2280*/ GIMT_Encode4(162072),
     /* 160960 */ /*GILLT_s1*//*Label 2272*/ GIMT_Encode4(160992),
     /* 160964 */ /*GILLT_s32*//*Label 2273*/ GIMT_Encode4(161085),
     /* 160968 */ /*GILLT_s64*//*Label 2274*/ GIMT_Encode4(161174),
     /* 160972 */ /*GILLT_s128*//*Label 2275*/ GIMT_Encode4(161263),
     /* 160976 */ /*GILLT_v2s64*//*Label 2276*/ GIMT_Encode4(161447),
     /* 160980 */ /*GILLT_v4s32*//*Label 2277*/ GIMT_Encode4(161612),
     /* 160984 */ /*GILLT_v8s16*//*Label 2278*/ GIMT_Encode4(161774),
     /* 160988 */ /*GILLT_v16s8*//*Label 2279*/ GIMT_Encode4(161923),
     /* 160992 */ // Label 2272: @160992
     /* 160992 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(161084), // Rule ID 4784 //
     /* 160997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s1,
     /* 161003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s1,
     /* 161006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::CRBITRCRegClassID),
     /* 161010 */   // (select:{ *:[i1] } i1:{ *:[i1] }:$cond, i1:{ *:[i1] }:$tval, i1:{ *:[i1] }:$fval)  =>  (CROR:{ *:[i1] } (CRAND:{ *:[i1] } ?:{ *:[i1] }:$cond, ?:{ *:[i1] }:$tval), (CRAND:{ *:[i1] } (CRNOT:{ *:[i1] } ?:{ *:[i1] }:$cond), ?:{ *:[i1] }:$fval))
     /* 161010 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s1,
     /* 161013 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::CRNOT),
     /* 161017 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161022 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 161026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 161028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s1,
     /* 161031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 161035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161040 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 161043 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // fval
     /* 161047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 161049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s1,
     /* 161052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::CRAND),
     /* 161056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161061 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 161065 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // tval
     /* 161069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::CROR),
     /* 161074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[CRD]
     /* 161076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 161082 */   GIR_RootConstrainSelectedInstOperands,
     /* 161083 */   // GIR_Coverage, 4784,
     /* 161083 */   GIR_EraseRootFromParent_Done,
     /* 161084 */ // Label 2281: @161084
     /* 161084 */ GIM_Reject,
     /* 161085 */ // Label 2273: @161085
     /* 161085 */ GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(161173),
     /* 161090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161099 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(161118), // Rule ID 1055 //
     /* 161104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161111 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_VSSRC:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 161111 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSSRC),
     /* 161116 */     GIR_RootConstrainSelectedInstOperands,
     /* 161117 */     // GIR_Coverage, 1055,
     /* 161117 */     GIR_Done,
     /* 161118 */   // Label 2283: @161118
     /* 161118 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(161134), // Rule ID 5 //
     /* 161123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161127 */     // (select:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)  =>  (SELECT_I4:{ *:[i32] } i1:{ *:[i1] }:$cond, i32:{ *:[i32] }:$T, i32:{ *:[i32] }:$F)
     /* 161127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I4),
     /* 161132 */     GIR_RootConstrainSelectedInstOperands,
     /* 161133 */     // GIR_Coverage, 5,
     /* 161133 */     GIR_Done,
     /* 161134 */   // Label 2284: @161134
     /* 161134 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(161153), // Rule ID 7 //
     /* 161139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 161146 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_F4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 161146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F4),
     /* 161151 */     GIR_RootConstrainSelectedInstOperands,
     /* 161152 */     // GIR_Coverage, 7,
     /* 161152 */     GIR_Done,
     /* 161153 */   // Label 2285: @161153
     /* 161153 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(161172), // Rule ID 610 //
     /* 161158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 161161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 161165 */     // (select:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)  =>  (SELECT_SPE4:{ *:[f32] } i1:{ *:[i1] }:$cond, f32:{ *:[f32] }:$T, f32:{ *:[f32] }:$F)
     /* 161165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE4),
     /* 161170 */     GIR_RootConstrainSelectedInstOperands,
     /* 161171 */     // GIR_Coverage, 610,
     /* 161171 */     GIR_Done,
     /* 161172 */   // Label 2286: @161172
     /* 161172 */   GIM_Reject,
     /* 161173 */ // Label 2282: @161173
     /* 161173 */ GIM_Reject,
     /* 161174 */ // Label 2274: @161174
     /* 161174 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(161262),
     /* 161179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161188 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(161207), // Rule ID 1054 //
     /* 161193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161200 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_VSFRC:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 161200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSFRC),
     /* 161205 */     GIR_RootConstrainSelectedInstOperands,
     /* 161206 */     // GIR_Coverage, 1054,
     /* 161206 */     GIR_Done,
     /* 161207 */   // Label 2288: @161207
     /* 161207 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(161223), // Rule ID 6 //
     /* 161212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 161216 */     // (select:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)  =>  (SELECT_I8:{ *:[i64] } i1:{ *:[i1] }:$cond, i64:{ *:[i64] }:$T, i64:{ *:[i64] }:$F)
     /* 161216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_I8),
     /* 161221 */     GIR_RootConstrainSelectedInstOperands,
     /* 161222 */     // GIR_Coverage, 6,
     /* 161222 */     GIR_Done,
     /* 161223 */   // Label 2289: @161223
     /* 161223 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(161242), // Rule ID 8 //
     /* 161228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 161235 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_F8:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 161235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F8),
     /* 161240 */     GIR_RootConstrainSelectedInstOperands,
     /* 161241 */     // GIR_Coverage, 8,
     /* 161241 */     GIR_Done,
     /* 161242 */   // Label 2290: @161242
     /* 161242 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(161261), // Rule ID 611 //
     /* 161247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 161250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 161254 */     // (select:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)  =>  (SELECT_SPE:{ *:[f64] } i1:{ *:[i1] }:$cond, f64:{ *:[f64] }:$T, f64:{ *:[f64] }:$F)
     /* 161254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_SPE),
     /* 161259 */     GIR_RootConstrainSelectedInstOperands,
     /* 161260 */     // GIR_Coverage, 611,
     /* 161260 */     GIR_Done,
     /* 161261 */   // Label 2291: @161261
     /* 161261 */   GIM_Reject,
     /* 161262 */ // Label 2287: @161262
     /* 161262 */ GIM_Reject,
     /* 161263 */ // Label 2275: @161263
     /* 161263 */ GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(161384), // Rule ID 1675 //
     /* 161268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161284 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161284 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161287 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161291 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161296 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161300 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161305 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161308 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161312 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161317 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161321 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161326 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161329 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161333 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161338 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161342 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161359 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161365 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161383 */   // GIR_Coverage, 1675,
     /* 161383 */   GIR_EraseRootFromParent_Done,
     /* 161384 */ // Label 2292: @161384
     /* 161384 */ GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(161412), // Rule ID 9 //
     /* 161389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 161392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161405 */   // (select:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)  =>  (SELECT_F16:{ *:[f128] } i1:{ *:[i1] }:$cond, f128:{ *:[f128] }:$T, f128:{ *:[f128] }:$F)
     /* 161405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_F16),
     /* 161410 */   GIR_RootConstrainSelectedInstOperands,
     /* 161411 */   // GIR_Coverage, 9,
     /* 161411 */   GIR_Done,
     /* 161412 */ // Label 2293: @161412
     /* 161412 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(161446), // Rule ID 1429 //
     /* 161417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 161423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 161426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 161429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161433 */   // (vselect:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$vA, v1i128:{ *:[v1i128] }:$vB, v1i128:{ *:[v1i128] }:$vC)  =>  (VSEL:{ *:[v1i128] } ?:{ *:[v1i128] }:$vC, ?:{ *:[v1i128] }:$vB, ?:{ *:[v1i128] }:$vA)
     /* 161433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161438 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161440 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161442 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161444 */   GIR_RootConstrainSelectedInstOperands,
     /* 161445 */   // GIR_Coverage, 1429,
     /* 161445 */   GIR_EraseRootFromParent_Done,
     /* 161446 */ // Label 2294: @161446
     /* 161446 */ GIM_Reject,
     /* 161447 */ // Label 2276: @161447
     /* 161447 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(161475), // Rule ID 1053 //
     /* 161452 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161468 */   // (select:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)  =>  (SELECT_VSRC:{ *:[v2f64] } i1:{ *:[i1] }:$cond, v2f64:{ *:[v2f64] }:$T, v2f64:{ *:[v2f64] }:$F)
     /* 161468 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VSRC),
     /* 161473 */   GIR_RootConstrainSelectedInstOperands,
     /* 161474 */   // GIR_Coverage, 1053,
     /* 161474 */   GIR_Done,
     /* 161475 */ // Label 2295: @161475
     /* 161475 */ GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(161509), // Rule ID 1672 //
     /* 161480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161496 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (XXSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161501 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161503 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161505 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161507 */   GIR_RootConstrainSelectedInstOperands,
     /* 161508 */   // GIR_Coverage, 1672,
     /* 161508 */   GIR_EraseRootFromParent_Done,
     /* 161509 */ // Label 2296: @161509
     /* 161509 */ GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(161543), // Rule ID 1674 //
     /* 161514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161530 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (XXSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161535 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161537 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161539 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161541 */   GIR_RootConstrainSelectedInstOperands,
     /* 161542 */   // GIR_Coverage, 1674,
     /* 161542 */   GIR_EraseRootFromParent_Done,
     /* 161543 */ // Label 2297: @161543
     /* 161543 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(161577), // Rule ID 1426 //
     /* 161548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161564 */   // (vselect:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$vA, v2i64:{ *:[v2i64] }:$vB, v2i64:{ *:[v2i64] }:$vC)  =>  (VSEL:{ *:[v2i64] } ?:{ *:[v2i64] }:$vC, ?:{ *:[v2i64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161569 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161571 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161573 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161575 */   GIR_RootConstrainSelectedInstOperands,
     /* 161576 */   // GIR_Coverage, 1426,
     /* 161576 */   GIR_EraseRootFromParent_Done,
     /* 161577 */ // Label 2298: @161577
     /* 161577 */ GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(161611), // Rule ID 1428 //
     /* 161582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161598 */   // (vselect:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$vA, v2f64:{ *:[v2f64] }:$vB, v2f64:{ *:[v2f64] }:$vC)  =>  (VSEL:{ *:[v2f64] } ?:{ *:[v2f64] }:$vC, ?:{ *:[v2f64] }:$vB, ?:{ *:[v2i64] }:$vA)
     /* 161598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161603 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161605 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161607 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161609 */   GIR_RootConstrainSelectedInstOperands,
     /* 161610 */   // GIR_Coverage, 1428,
     /* 161610 */   GIR_EraseRootFromParent_Done,
     /* 161611 */ // Label 2299: @161611
     /* 161611 */ GIM_Reject,
     /* 161612 */ // Label 2277: @161612
     /* 161612 */ GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(161646), // Rule ID 1671 //
     /* 161617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161633 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (XXSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161638 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161640 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161642 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161644 */   GIR_RootConstrainSelectedInstOperands,
     /* 161645 */   // GIR_Coverage, 1671,
     /* 161645 */   GIR_EraseRootFromParent_Done,
     /* 161646 */ // Label 2300: @161646
     /* 161646 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(161680), // Rule ID 1673 //
     /* 161651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161660 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161667 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (XXSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 161672 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161674 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161676 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161678 */   GIR_RootConstrainSelectedInstOperands,
     /* 161679 */   // GIR_Coverage, 1673,
     /* 161679 */   GIR_EraseRootFromParent_Done,
     /* 161680 */ // Label 2301: @161680
     /* 161680 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(161705), // Rule ID 10 //
     /* 161685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s1,
     /* 161688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161698 */   // (select:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)  =>  (SELECT_VRRC:{ *:[v4i32] } i1:{ *:[i1] }:$cond, v4i32:{ *:[v4i32] }:$T, v4i32:{ *:[v4i32] }:$F)
     /* 161698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::SELECT_VRRC),
     /* 161703 */   GIR_RootConstrainSelectedInstOperands,
     /* 161704 */   // GIR_Coverage, 10,
     /* 161704 */   GIR_Done,
     /* 161705 */ // Label 2302: @161705
     /* 161705 */ GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(161739), // Rule ID 1425 //
     /* 161710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161719 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161726 */   // (vselect:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB, v4i32:{ *:[v4i32] }:$vC)  =>  (VSEL:{ *:[v4i32] } ?:{ *:[v4i32] }:$vC, ?:{ *:[v4i32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161731 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161733 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161735 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161737 */   GIR_RootConstrainSelectedInstOperands,
     /* 161738 */   // GIR_Coverage, 1425,
     /* 161738 */   GIR_EraseRootFromParent_Done,
     /* 161739 */ // Label 2303: @161739
     /* 161739 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(161773), // Rule ID 1427 //
     /* 161744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161760 */   // (vselect:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA, v4f32:{ *:[v4f32] }:$vB, v4f32:{ *:[v4f32] }:$vC)  =>  (VSEL:{ *:[v4f32] } ?:{ *:[v4f32] }:$vC, ?:{ *:[v4f32] }:$vB, ?:{ *:[v4i32] }:$vA)
     /* 161760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161765 */   GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161767 */   GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161769 */   GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161771 */   GIR_RootConstrainSelectedInstOperands,
     /* 161772 */   // GIR_Coverage, 1427,
     /* 161772 */   GIR_EraseRootFromParent_Done,
     /* 161773 */ // Label 2304: @161773
     /* 161773 */ GIM_Reject,
     /* 161774 */ // Label 2278: @161774
     /* 161774 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(161922),
     /* 161779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 161785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 161788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161792 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(161900), // Rule ID 1670 //
     /* 161797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161800 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161800 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161803 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161807 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161812 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161816 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161821 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161824 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161828 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161833 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161837 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161842 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161845 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161849 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161854 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 161858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 161866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 161870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 161878 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 161881 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 161884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 161886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 161891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 161894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161899 */     // GIR_Coverage, 1670,
     /* 161899 */     GIR_EraseRootFromParent_Done,
     /* 161900 */   // Label 2306: @161900
     /* 161900 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(161921), // Rule ID 1424 //
     /* 161905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 161908 */     // (vselect:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB, v8i16:{ *:[v8i16] }:$vC)  =>  (VSEL:{ *:[v8i16] } ?:{ *:[v8i16] }:$vC, ?:{ *:[v8i16] }:$vB, ?:{ *:[v8i16] }:$vA)
     /* 161908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 161911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 161913 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 161915 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 161917 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 161919 */     GIR_RootConstrainSelectedInstOperands,
     /* 161920 */     // GIR_Coverage, 1424,
     /* 161920 */     GIR_EraseRootFromParent_Done,
     /* 161921 */   // Label 2307: @161921
     /* 161921 */   GIM_Reject,
     /* 161922 */ // Label 2305: @161922
     /* 161922 */ GIM_Reject,
     /* 161923 */ // Label 2279: @161923
     /* 161923 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(162071),
     /* 161928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 161931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 161934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 161937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 161941 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(162049), // Rule ID 1669 //
     /* 161946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 161949 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (XXSEL:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vC, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vB, VSRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v16i8] }:$vA, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 161949 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 161952 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161956 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161961 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // vA
     /* 161965 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161970 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 161973 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161977 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 161982 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // vB
     /* 161986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 161991 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 161994 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 161998 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162003 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // vC
     /* 162007 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 162015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXSEL),
     /* 162019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162024 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 162027 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 162030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 162033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 162038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 162040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162048 */     // GIR_Coverage, 1669,
     /* 162048 */     GIR_EraseRootFromParent_Done,
     /* 162049 */   // Label 2309: @162049
     /* 162049 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(162070), // Rule ID 1423 //
     /* 162054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162057 */     // (vselect:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB, v16i8:{ *:[v16i8] }:$vC)  =>  (VSEL:{ *:[v16i8] } ?:{ *:[v16i8] }:$vC, ?:{ *:[v16i8] }:$vB, ?:{ *:[v16i8] }:$vA)
     /* 162057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VSEL),
     /* 162060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 162062 */     GIR_RootToRootCopy, /*OpIdx*/3, // vC
     /* 162064 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 162066 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 162068 */     GIR_RootConstrainSelectedInstOperands,
     /* 162069 */     // GIR_Coverage, 1423,
     /* 162069 */     GIR_EraseRootFromParent_Done,
     /* 162070 */   // Label 2310: @162070
     /* 162070 */   GIM_Reject,
     /* 162071 */ // Label 2308: @162071
     /* 162071 */ GIM_Reject,
     /* 162072 */ // Label 2280: @162072
     /* 162072 */ GIM_Reject,
     /* 162073 */ // Label 34: @162073
     /* 162073 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2315*/ GIMT_Encode4(162202),
     /* 162084 */ /*GILLT_s32*//*Label 2311*/ GIMT_Encode4(162104),
     /* 162088 */ /*GILLT_s64*//*Label 2312*/ GIMT_Encode4(162127), GIMT_Encode4(0),
     /* 162096 */ /*GILLT_v2s64*//*Label 2313*/ GIMT_Encode4(162150),
     /* 162100 */ /*GILLT_v4s32*//*Label 2314*/ GIMT_Encode4(162176),
     /* 162104 */ // Label 2311: @162104
     /* 162104 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(162126), // Rule ID 207 //
     /* 162109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162119 */   // (mulhu:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHWU:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 162119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHWU),
     /* 162124 */   GIR_RootConstrainSelectedInstOperands,
     /* 162125 */   // GIR_Coverage, 207,
     /* 162125 */   GIR_Done,
     /* 162126 */ // Label 2316: @162126
     /* 162126 */ GIM_Reject,
     /* 162127 */ // Label 2312: @162127
     /* 162127 */ GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(162149), // Rule ID 677 //
     /* 162132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 162142 */   // (mulhu:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHDU:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 162142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHDU),
     /* 162147 */   GIR_RootConstrainSelectedInstOperands,
     /* 162148 */   // GIR_Coverage, 677,
     /* 162148 */   GIR_Done,
     /* 162149 */ // Label 2317: @162149
     /* 162149 */ GIM_Reject,
     /* 162150 */ // Label 2313: @162150
     /* 162150 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(162175), // Rule ID 1128 //
     /* 162155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162168 */   // (mulhu:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHUD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 162168 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUD),
     /* 162173 */   GIR_RootConstrainSelectedInstOperands,
     /* 162174 */   // GIR_Coverage, 1128,
     /* 162174 */   GIR_Done,
     /* 162175 */ // Label 2318: @162175
     /* 162175 */ GIM_Reject,
     /* 162176 */ // Label 2314: @162176
     /* 162176 */ GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(162201), // Rule ID 1126 //
     /* 162181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162194 */   // (mulhu:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHUW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 162194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHUW),
     /* 162199 */   GIR_RootConstrainSelectedInstOperands,
     /* 162200 */   // GIR_Coverage, 1126,
     /* 162200 */   GIR_Done,
     /* 162201 */ // Label 2319: @162201
     /* 162201 */ GIM_Reject,
     /* 162202 */ // Label 2315: @162202
     /* 162202 */ GIM_Reject,
     /* 162203 */ // Label 35: @162203
     /* 162203 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2324*/ GIMT_Encode4(162332),
     /* 162214 */ /*GILLT_s32*//*Label 2320*/ GIMT_Encode4(162234),
     /* 162218 */ /*GILLT_s64*//*Label 2321*/ GIMT_Encode4(162257), GIMT_Encode4(0),
     /* 162226 */ /*GILLT_v2s64*//*Label 2322*/ GIMT_Encode4(162280),
     /* 162230 */ /*GILLT_v4s32*//*Label 2323*/ GIMT_Encode4(162306),
     /* 162234 */ // Label 2320: @162234
     /* 162234 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(162256), // Rule ID 206 //
     /* 162239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162249 */   // (mulhs:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)  =>  (MULHW:{ *:[i32] } i32:{ *:[i32] }:$RA, i32:{ *:[i32] }:$RB)
     /* 162249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHW),
     /* 162254 */   GIR_RootConstrainSelectedInstOperands,
     /* 162255 */   // GIR_Coverage, 206,
     /* 162255 */   GIR_Done,
     /* 162256 */ // Label 2325: @162256
     /* 162256 */ GIM_Reject,
     /* 162257 */ // Label 2321: @162257
     /* 162257 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(162279), // Rule ID 676 //
     /* 162262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 162272 */   // (mulhs:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)  =>  (MULHD:{ *:[i64] } i64:{ *:[i64] }:$RA, i64:{ *:[i64] }:$RB)
     /* 162272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::MULHD),
     /* 162277 */   GIR_RootConstrainSelectedInstOperands,
     /* 162278 */   // GIR_Coverage, 676,
     /* 162278 */   GIR_Done,
     /* 162279 */ // Label 2326: @162279
     /* 162279 */ GIM_Reject,
     /* 162280 */ // Label 2322: @162280
     /* 162280 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(162305), // Rule ID 1127 //
     /* 162285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162298 */   // (mulhs:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)  =>  (VMULHSD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VA, v2i64:{ *:[v2i64] }:$VB)
     /* 162298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSD),
     /* 162303 */   GIR_RootConstrainSelectedInstOperands,
     /* 162304 */   // GIR_Coverage, 1127,
     /* 162304 */   GIR_Done,
     /* 162305 */ // Label 2327: @162305
     /* 162305 */ GIM_Reject,
     /* 162306 */ // Label 2323: @162306
     /* 162306 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(162331), // Rule ID 1125 //
     /* 162311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 162314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162324 */   // (mulhs:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)  =>  (VMULHSW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VA, v4i32:{ *:[v4i32] }:$VB)
     /* 162324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMULHSW),
     /* 162329 */   GIR_RootConstrainSelectedInstOperands,
     /* 162330 */   // GIR_Coverage, 1125,
     /* 162330 */   GIR_Done,
     /* 162331 */ // Label 2328: @162331
     /* 162331 */ GIM_Reject,
     /* 162332 */ // Label 2324: @162332
     /* 162332 */ GIM_Reject,
     /* 162333 */ // Label 36: @162333
     /* 162333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2332*/ GIMT_Encode4(162434),
     /* 162344 */ /*GILLT_v4s32*//*Label 2329*/ GIMT_Encode4(162356),
     /* 162348 */ /*GILLT_v8s16*//*Label 2330*/ GIMT_Encode4(162382),
     /* 162352 */ /*GILLT_v16s8*//*Label 2331*/ GIMT_Encode4(162408),
     /* 162356 */ // Label 2329: @162356
     /* 162356 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(162381), // Rule ID 1302 //
     /* 162361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162374 */   // (uaddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUWS),
     /* 162379 */   GIR_RootConstrainSelectedInstOperands,
     /* 162380 */   // GIR_Coverage, 1302,
     /* 162380 */   GIR_Done,
     /* 162381 */ // Label 2333: @162381
     /* 162381 */ GIM_Reject,
     /* 162382 */ // Label 2330: @162382
     /* 162382 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(162407), // Rule ID 1300 //
     /* 162387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162400 */   // (uaddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUHS),
     /* 162405 */   GIR_RootConstrainSelectedInstOperands,
     /* 162406 */   // GIR_Coverage, 1300,
     /* 162406 */   GIR_Done,
     /* 162407 */ // Label 2334: @162407
     /* 162407 */ GIM_Reject,
     /* 162408 */ // Label 2331: @162408
     /* 162408 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(162433), // Rule ID 1298 //
     /* 162413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162426 */   // (uaddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162426 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDUBS),
     /* 162431 */   GIR_RootConstrainSelectedInstOperands,
     /* 162432 */   // GIR_Coverage, 1298,
     /* 162432 */   GIR_Done,
     /* 162433 */ // Label 2335: @162433
     /* 162433 */ GIM_Reject,
     /* 162434 */ // Label 2332: @162434
     /* 162434 */ GIM_Reject,
     /* 162435 */ // Label 37: @162435
     /* 162435 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2339*/ GIMT_Encode4(162536),
     /* 162446 */ /*GILLT_v4s32*//*Label 2336*/ GIMT_Encode4(162458),
     /* 162450 */ /*GILLT_v8s16*//*Label 2337*/ GIMT_Encode4(162484),
     /* 162454 */ /*GILLT_v16s8*//*Label 2338*/ GIMT_Encode4(162510),
     /* 162458 */ // Label 2336: @162458
     /* 162458 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(162483), // Rule ID 1301 //
     /* 162463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162476 */   // (saddsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VADDSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSWS),
     /* 162481 */   GIR_RootConstrainSelectedInstOperands,
     /* 162482 */   // GIR_Coverage, 1301,
     /* 162482 */   GIR_Done,
     /* 162483 */ // Label 2340: @162483
     /* 162483 */ GIM_Reject,
     /* 162484 */ // Label 2337: @162484
     /* 162484 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(162509), // Rule ID 1299 //
     /* 162489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162502 */   // (saddsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VADDSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSHS),
     /* 162507 */   GIR_RootConstrainSelectedInstOperands,
     /* 162508 */   // GIR_Coverage, 1299,
     /* 162508 */   GIR_Done,
     /* 162509 */ // Label 2341: @162509
     /* 162509 */ GIM_Reject,
     /* 162510 */ // Label 2338: @162510
     /* 162510 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(162535), // Rule ID 1297 //
     /* 162515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162528 */   // (saddsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VADDSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDSBS),
     /* 162533 */   GIR_RootConstrainSelectedInstOperands,
     /* 162534 */   // GIR_Coverage, 1297,
     /* 162534 */   GIR_Done,
     /* 162535 */ // Label 2342: @162535
     /* 162535 */ GIM_Reject,
     /* 162536 */ // Label 2339: @162536
     /* 162536 */ GIM_Reject,
     /* 162537 */ // Label 38: @162537
     /* 162537 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2346*/ GIMT_Encode4(162638),
     /* 162548 */ /*GILLT_v4s32*//*Label 2343*/ GIMT_Encode4(162560),
     /* 162552 */ /*GILLT_v8s16*//*Label 2344*/ GIMT_Encode4(162586),
     /* 162556 */ /*GILLT_v16s8*//*Label 2345*/ GIMT_Encode4(162612),
     /* 162560 */ // Label 2343: @162560
     /* 162560 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(162585), // Rule ID 1308 //
     /* 162565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162578 */   // (usubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBUWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162578 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUWS),
     /* 162583 */   GIR_RootConstrainSelectedInstOperands,
     /* 162584 */   // GIR_Coverage, 1308,
     /* 162584 */   GIR_Done,
     /* 162585 */ // Label 2347: @162585
     /* 162585 */ GIM_Reject,
     /* 162586 */ // Label 2344: @162586
     /* 162586 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(162611), // Rule ID 1306 //
     /* 162591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162604 */   // (usubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBUHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUHS),
     /* 162609 */   GIR_RootConstrainSelectedInstOperands,
     /* 162610 */   // GIR_Coverage, 1306,
     /* 162610 */   GIR_Done,
     /* 162611 */ // Label 2348: @162611
     /* 162611 */ GIM_Reject,
     /* 162612 */ // Label 2345: @162612
     /* 162612 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(162637), // Rule ID 1304 //
     /* 162617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162630 */   // (usubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBUBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBUBS),
     /* 162635 */   GIR_RootConstrainSelectedInstOperands,
     /* 162636 */   // GIR_Coverage, 1304,
     /* 162636 */   GIR_Done,
     /* 162637 */ // Label 2349: @162637
     /* 162637 */ GIM_Reject,
     /* 162638 */ // Label 2346: @162638
     /* 162638 */ GIM_Reject,
     /* 162639 */ // Label 39: @162639
     /* 162639 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(8), /*)*//*default:*//*Label 2353*/ GIMT_Encode4(162740),
     /* 162650 */ /*GILLT_v4s32*//*Label 2350*/ GIMT_Encode4(162662),
     /* 162654 */ /*GILLT_v8s16*//*Label 2351*/ GIMT_Encode4(162688),
     /* 162658 */ /*GILLT_v16s8*//*Label 2352*/ GIMT_Encode4(162714),
     /* 162662 */ // Label 2350: @162662
     /* 162662 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(162687), // Rule ID 1307 //
     /* 162667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162680 */   // (ssubsat:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$vA, v4i32:{ *:[v4i32] }:$vB)  =>  (VSUBSWS:{ *:[v4i32] } ?:{ *:[v4i32] }:$vA, ?:{ *:[v4i32] }:$vB)
     /* 162680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSWS),
     /* 162685 */   GIR_RootConstrainSelectedInstOperands,
     /* 162686 */   // GIR_Coverage, 1307,
     /* 162686 */   GIR_Done,
     /* 162687 */ // Label 2354: @162687
     /* 162687 */ GIM_Reject,
     /* 162688 */ // Label 2351: @162688
     /* 162688 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(162713), // Rule ID 1305 //
     /* 162693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 162699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162706 */   // (ssubsat:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vA, v8i16:{ *:[v8i16] }:$vB)  =>  (VSUBSHS:{ *:[v8i16] } ?:{ *:[v8i16] }:$vA, ?:{ *:[v8i16] }:$vB)
     /* 162706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSHS),
     /* 162711 */   GIR_RootConstrainSelectedInstOperands,
     /* 162712 */   // GIR_Coverage, 1305,
     /* 162712 */   GIR_Done,
     /* 162713 */ // Label 2355: @162713
     /* 162713 */ GIM_Reject,
     /* 162714 */ // Label 2352: @162714
     /* 162714 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(162739), // Rule ID 1303 //
     /* 162719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 162722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 162725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 162728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162732 */   // (ssubsat:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vA, v16i8:{ *:[v16i8] }:$vB)  =>  (VSUBSBS:{ *:[v16i8] } ?:{ *:[v16i8] }:$vA, ?:{ *:[v16i8] }:$vB)
     /* 162732 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBSBS),
     /* 162737 */   GIR_RootConstrainSelectedInstOperands,
     /* 162738 */   // GIR_Coverage, 1303,
     /* 162738 */   GIR_Done,
     /* 162739 */ // Label 2356: @162739
     /* 162739 */ GIM_Reject,
     /* 162740 */ // Label 2353: @162740
     /* 162740 */ GIM_Reject,
     /* 162741 */ // Label 40: @162741
     /* 162741 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2362*/ GIMT_Encode4(163035),
     /* 162752 */ /*GILLT_s32*//*Label 2357*/ GIMT_Encode4(162772),
     /* 162756 */ /*GILLT_s64*//*Label 2358*/ GIMT_Encode4(162846),
     /* 162760 */ /*GILLT_s128*//*Label 2359*/ GIMT_Encode4(162924),
     /* 162764 */ /*GILLT_v2s64*//*Label 2360*/ GIMT_Encode4(162950),
     /* 162768 */ /*GILLT_v4s32*//*Label 2361*/ GIMT_Encode4(162980),
     /* 162772 */ // Label 2357: @162772
     /* 162772 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(162845),
     /* 162777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 162780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162783 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(162802), // Rule ID 953 //
     /* 162788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 162791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 162795 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 162795 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 162800 */     GIR_RootConstrainSelectedInstOperands,
     /* 162801 */     // GIR_Coverage, 953,
     /* 162801 */     GIR_Done,
     /* 162802 */   // Label 2364: @162802
     /* 162802 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(162825), // Rule ID 239 //
     /* 162807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 162814 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 162814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 162819 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162823 */     GIR_RootConstrainSelectedInstOperands,
     /* 162824 */     // GIR_Coverage, 239,
     /* 162824 */     GIR_Done,
     /* 162825 */   // Label 2365: @162825
     /* 162825 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(162844), // Rule ID 583 //
     /* 162830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 162837 */     // (fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 162837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 162842 */     GIR_RootConstrainSelectedInstOperands,
     /* 162843 */     // GIR_Coverage, 583,
     /* 162843 */     GIR_Done,
     /* 162844 */   // Label 2366: @162844
     /* 162844 */   GIM_Reject,
     /* 162845 */ // Label 2363: @162845
     /* 162845 */ GIM_Reject,
     /* 162846 */ // Label 2358: @162846
     /* 162846 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(162923),
     /* 162851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 162854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162857 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(162880), // Rule ID 770 //
     /* 162862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 162869 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 162869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 162874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162878 */     GIR_RootConstrainSelectedInstOperands,
     /* 162879 */     // GIR_Coverage, 770,
     /* 162879 */     GIR_Done,
     /* 162880 */   // Label 2368: @162880
     /* 162880 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(162903), // Rule ID 237 //
     /* 162885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 162888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 162892 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 162892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 162897 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162901 */     GIR_RootConstrainSelectedInstOperands,
     /* 162902 */     // GIR_Coverage, 237,
     /* 162902 */     GIR_Done,
     /* 162903 */   // Label 2369: @162903
     /* 162903 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(162922), // Rule ID 562 //
     /* 162908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 162911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 162915 */     // (fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 162915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 162920 */     GIR_RootConstrainSelectedInstOperands,
     /* 162921 */     // GIR_Coverage, 562,
     /* 162921 */     GIR_Done,
     /* 162922 */   // Label 2370: @162922
     /* 162922 */   GIM_Reject,
     /* 162923 */ // Label 2367: @162923
     /* 162923 */ GIM_Reject,
     /* 162924 */ // Label 2359: @162924
     /* 162924 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(162949), // Rule ID 988 //
     /* 162929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 162932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 162935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 162938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 162942 */   // (fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 162942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 162947 */   GIR_RootConstrainSelectedInstOperands,
     /* 162948 */   // GIR_Coverage, 988,
     /* 162948 */   GIR_Done,
     /* 162949 */ // Label 2371: @162949
     /* 162949 */ GIM_Reject,
     /* 162950 */ // Label 2360: @162950
     /* 162950 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(162979), // Rule ID 774 //
     /* 162955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 162961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 162968 */   // (fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 162968 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 162973 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 162977 */   GIR_RootConstrainSelectedInstOperands,
     /* 162978 */   // GIR_Coverage, 774,
     /* 162978 */   GIR_Done,
     /* 162979 */ // Label 2372: @162979
     /* 162979 */ GIM_Reject,
     /* 162980 */ // Label 2361: @162980
     /* 162980 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(163034),
     /* 162985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162991 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(163014), // Rule ID 776 //
     /* 162996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 162999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163003 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 163008 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163012 */     GIR_RootConstrainSelectedInstOperands,
     /* 163013 */     // GIR_Coverage, 776,
     /* 163013 */     GIR_Done,
     /* 163014 */   // Label 2374: @163014
     /* 163014 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(163033), // Rule ID 300 //
     /* 163019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163026 */     // (fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 163026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VADDFP),
     /* 163031 */     GIR_RootConstrainSelectedInstOperands,
     /* 163032 */     // GIR_Coverage, 300,
     /* 163032 */     GIR_Done,
     /* 163033 */   // Label 2375: @163033
     /* 163033 */   GIM_Reject,
     /* 163034 */ // Label 2373: @163034
     /* 163034 */ GIM_Reject,
     /* 163035 */ // Label 2362: @163035
     /* 163035 */ GIM_Reject,
     /* 163036 */ // Label 41: @163036
     /* 163036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2381*/ GIMT_Encode4(163330),
     /* 163047 */ /*GILLT_s32*//*Label 2376*/ GIMT_Encode4(163067),
     /* 163051 */ /*GILLT_s64*//*Label 2377*/ GIMT_Encode4(163141),
     /* 163055 */ /*GILLT_s128*//*Label 2378*/ GIMT_Encode4(163219),
     /* 163059 */ /*GILLT_v2s64*//*Label 2379*/ GIMT_Encode4(163245),
     /* 163063 */ /*GILLT_v4s32*//*Label 2380*/ GIMT_Encode4(163275),
     /* 163067 */ // Label 2376: @163067
     /* 163067 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(163140),
     /* 163072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163078 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(163097), // Rule ID 957 //
     /* 163083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163090 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163090 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 163095 */     GIR_RootConstrainSelectedInstOperands,
     /* 163096 */     // GIR_Coverage, 957,
     /* 163096 */     GIR_Done,
     /* 163097 */   // Label 2383: @163097
     /* 163097 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(163120), // Rule ID 251 //
     /* 163102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163109 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 163109 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 163114 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163118 */     GIR_RootConstrainSelectedInstOperands,
     /* 163119 */     // GIR_Coverage, 251,
     /* 163119 */     GIR_Done,
     /* 163120 */   // Label 2384: @163120
     /* 163120 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(163139), // Rule ID 601 //
     /* 163125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 163132 */     // (fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 163132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 163137 */     GIR_RootConstrainSelectedInstOperands,
     /* 163138 */     // GIR_Coverage, 601,
     /* 163138 */     GIR_Done,
     /* 163139 */   // Label 2385: @163139
     /* 163139 */   GIM_Reject,
     /* 163140 */ // Label 2382: @163140
     /* 163140 */ GIM_Reject,
     /* 163141 */ // Label 2377: @163141
     /* 163141 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(163218),
     /* 163146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163152 */   GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(163175), // Rule ID 782 //
     /* 163157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163164 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 163169 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163173 */     GIR_RootConstrainSelectedInstOperands,
     /* 163174 */     // GIR_Coverage, 782,
     /* 163174 */     GIR_Done,
     /* 163175 */   // Label 2387: @163175
     /* 163175 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(163198), // Rule ID 249 //
     /* 163180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163187 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 163187 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 163192 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163196 */     GIR_RootConstrainSelectedInstOperands,
     /* 163197 */     // GIR_Coverage, 249,
     /* 163197 */     GIR_Done,
     /* 163198 */   // Label 2388: @163198
     /* 163198 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(163217), // Rule ID 580 //
     /* 163203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163210 */     // (fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 163210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 163215 */     GIR_RootConstrainSelectedInstOperands,
     /* 163216 */     // GIR_Coverage, 580,
     /* 163216 */     GIR_Done,
     /* 163217 */   // Label 2389: @163217
     /* 163217 */   GIM_Reject,
     /* 163218 */ // Label 2386: @163218
     /* 163218 */ GIM_Reject,
     /* 163219 */ // Label 2378: @163219
     /* 163219 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(163244), // Rule ID 992 //
     /* 163224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163237 */   // (fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 163242 */   GIR_RootConstrainSelectedInstOperands,
     /* 163243 */   // GIR_Coverage, 992,
     /* 163243 */   GIR_Done,
     /* 163244 */ // Label 2390: @163244
     /* 163244 */ GIM_Reject,
     /* 163245 */ // Label 2379: @163245
     /* 163245 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(163274), // Rule ID 784 //
     /* 163250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163263 */   // (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163263 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 163268 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163272 */   GIR_RootConstrainSelectedInstOperands,
     /* 163273 */   // GIR_Coverage, 784,
     /* 163273 */   GIR_Done,
     /* 163274 */ // Label 2391: @163274
     /* 163274 */ GIM_Reject,
     /* 163275 */ // Label 2380: @163275
     /* 163275 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(163329),
     /* 163280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163286 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(163309), // Rule ID 786 //
     /* 163291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163298 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 163303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163307 */     GIR_RootConstrainSelectedInstOperands,
     /* 163308 */     // GIR_Coverage, 786,
     /* 163308 */     GIR_Done,
     /* 163309 */   // Label 2393: @163309
     /* 163309 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(163328), // Rule ID 370 //
     /* 163314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163321 */     // (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)  =>  (VSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$VA, v4f32:{ *:[v4f32] }:$VB)
     /* 163321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VSUBFP),
     /* 163326 */     GIR_RootConstrainSelectedInstOperands,
     /* 163327 */     // GIR_Coverage, 370,
     /* 163327 */     GIR_Done,
     /* 163328 */   // Label 2394: @163328
     /* 163328 */   GIM_Reject,
     /* 163329 */ // Label 2392: @163329
     /* 163329 */ GIM_Reject,
     /* 163330 */ // Label 2381: @163330
     /* 163330 */ GIM_Reject,
     /* 163331 */ // Label 42: @163331
     /* 163331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2400*/ GIMT_Encode4(163680),
     /* 163342 */ /*GILLT_s32*//*Label 2395*/ GIMT_Encode4(163362),
     /* 163346 */ /*GILLT_s64*//*Label 2396*/ GIMT_Encode4(163436),
     /* 163350 */ /*GILLT_s128*//*Label 2397*/ GIMT_Encode4(163514),
     /* 163354 */ /*GILLT_v2s64*//*Label 2398*/ GIMT_Encode4(163540),
     /* 163358 */ /*GILLT_v4s32*//*Label 2399*/ GIMT_Encode4(163570),
     /* 163362 */ // Label 2395: @163362
     /* 163362 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(163435),
     /* 163367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163373 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(163392), // Rule ID 955 //
     /* 163378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163385 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163385 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 163390 */     GIR_RootConstrainSelectedInstOperands,
     /* 163391 */     // GIR_Coverage, 955,
     /* 163391 */     GIR_Done,
     /* 163392 */   // Label 2402: @163392
     /* 163392 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(163415), // Rule ID 247 //
     /* 163397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163404 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 163404 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 163409 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163413 */     GIR_RootConstrainSelectedInstOperands,
     /* 163414 */     // GIR_Coverage, 247,
     /* 163414 */     GIR_Done,
     /* 163415 */   // Label 2403: @163415
     /* 163415 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(163434), // Rule ID 597 //
     /* 163420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 163427 */     // (fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 163427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 163432 */     GIR_RootConstrainSelectedInstOperands,
     /* 163433 */     // GIR_Coverage, 597,
     /* 163433 */     GIR_Done,
     /* 163434 */   // Label 2404: @163434
     /* 163434 */   GIM_Reject,
     /* 163435 */ // Label 2401: @163435
     /* 163435 */ GIM_Reject,
     /* 163436 */ // Label 2396: @163436
     /* 163436 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(163513),
     /* 163441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163447 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(163470), // Rule ID 772 //
     /* 163452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163459 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 163464 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163468 */     GIR_RootConstrainSelectedInstOperands,
     /* 163469 */     // GIR_Coverage, 772,
     /* 163469 */     GIR_Done,
     /* 163470 */   // Label 2406: @163470
     /* 163470 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(163493), // Rule ID 245 //
     /* 163475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163482 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 163482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 163487 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163491 */     GIR_RootConstrainSelectedInstOperands,
     /* 163492 */     // GIR_Coverage, 245,
     /* 163492 */     GIR_Done,
     /* 163493 */   // Label 2407: @163493
     /* 163493 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(163512), // Rule ID 576 //
     /* 163498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 163501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 163505 */     // (fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 163505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 163510 */     GIR_RootConstrainSelectedInstOperands,
     /* 163511 */     // GIR_Coverage, 576,
     /* 163511 */     GIR_Done,
     /* 163512 */   // Label 2408: @163512
     /* 163512 */   GIM_Reject,
     /* 163513 */ // Label 2405: @163513
     /* 163513 */ GIM_Reject,
     /* 163514 */ // Label 2397: @163514
     /* 163514 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(163539), // Rule ID 990 //
     /* 163519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 163522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 163525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 163528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163532 */   // (fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 163532 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 163537 */   GIR_RootConstrainSelectedInstOperands,
     /* 163538 */   // GIR_Coverage, 990,
     /* 163538 */   GIR_Done,
     /* 163539 */ // Label 2409: @163539
     /* 163539 */ GIM_Reject,
     /* 163540 */ // Label 2398: @163540
     /* 163540 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(163569), // Rule ID 778 //
     /* 163545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 163551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163558 */   // (fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 163558 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 163563 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163567 */   GIR_RootConstrainSelectedInstOperands,
     /* 163568 */   // GIR_Coverage, 778,
     /* 163568 */   GIR_Done,
     /* 163569 */ // Label 2410: @163569
     /* 163569 */ GIM_Reject,
     /* 163570 */ // Label 2399: @163570
     /* 163570 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(163679),
     /* 163575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 163578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163581 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(163604), // Rule ID 780 //
     /* 163586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 163593 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 163593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 163598 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163602 */     GIR_RootConstrainSelectedInstOperands,
     /* 163603 */     // GIR_Coverage, 780,
     /* 163603 */     GIR_Done,
     /* 163604 */   // Label 2412: @163604
     /* 163604 */   GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(163678), // Rule ID 1385 //
     /* 163609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 163612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 163616 */     // (fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA, v4f32:{ *:[v4f32] }:$vB)  =>  (VMADDFP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA, ?:{ *:[v4f32] }:$vB, (VSLW:{ *:[v4i32] } (V_SETALLONES:{ *:[v4i32] }), (V_SETALLONES:{ *:[v4i32] })))
     /* 163616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 163619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 163630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 163633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::V_SETALLONES),
     /* 163637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 163644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 163647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::VSLW),
     /* 163651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163656 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 163659 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 163662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 163664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 163667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 163669 */     GIR_RootToRootCopy, /*OpIdx*/1, // vA
     /* 163671 */     GIR_RootToRootCopy, /*OpIdx*/2, // vB
     /* 163673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163676 */     GIR_RootConstrainSelectedInstOperands,
     /* 163677 */     // GIR_Coverage, 1385,
     /* 163677 */     GIR_EraseRootFromParent_Done,
     /* 163678 */   // Label 2413: @163678
     /* 163678 */   GIM_Reject,
     /* 163679 */ // Label 2411: @163679
     /* 163679 */ GIM_Reject,
     /* 163680 */ // Label 2400: @163680
     /* 163680 */ GIM_Reject,
     /* 163681 */ // Label 43: @163681
     /* 163681 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2419*/ GIMT_Encode4(164261),
     /* 163692 */ /*GILLT_s32*//*Label 2414*/ GIMT_Encode4(163712),
     /* 163696 */ /*GILLT_s64*//*Label 2415*/ GIMT_Encode4(163858),
     /* 163700 */ /*GILLT_s128*//*Label 2416*/ GIMT_Encode4(164004),
     /* 163704 */ /*GILLT_v2s64*//*Label 2417*/ GIMT_Encode4(164082),
     /* 163708 */ /*GILLT_v4s32*//*Label 2418*/ GIMT_Encode4(164160),
     /* 163712 */ // Label 2414: @163712
     /* 163712 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(163857),
     /* 163717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 163720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163726 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(163767), // Rule ID 969 //
     /* 163731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163752 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 163755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163761 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163763 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163765 */     GIR_RootConstrainSelectedInstOperands,
     /* 163766 */     // GIR_Coverage, 969,
     /* 163766 */     GIR_EraseRootFromParent_Done,
     /* 163767 */   // Label 2421: @163767
     /* 163767 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(163792), // Rule ID 967 //
     /* 163772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 163775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 163779 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 163779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 163782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163784 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163786 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163788 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163790 */     GIR_RootConstrainSelectedInstOperands,
     /* 163791 */     // GIR_Coverage, 967,
     /* 163791 */     GIR_EraseRootFromParent_Done,
     /* 163792 */   // Label 2422: @163792
     /* 163792 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(163833), // Rule ID 225 //
     /* 163797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 163816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163818 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 163821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163823 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163825 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163831 */     GIR_RootConstrainSelectedInstOperands,
     /* 163832 */     // GIR_Coverage, 225,
     /* 163832 */     GIR_EraseRootFromParent_Done,
     /* 163833 */   // Label 2423: @163833
     /* 163833 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(163856), // Rule ID 221 //
     /* 163838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 163845 */     // (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 163845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 163850 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 163854 */     GIR_RootConstrainSelectedInstOperands,
     /* 163855 */     // GIR_Coverage, 221,
     /* 163855 */     GIR_Done,
     /* 163856 */   // Label 2424: @163856
     /* 163856 */   GIM_Reject,
     /* 163857 */ // Label 2420: @163857
     /* 163857 */ GIM_Reject,
     /* 163858 */ // Label 2415: @163858
     /* 163858 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(164003),
     /* 163863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 163866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163869 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 163872 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(163913), // Rule ID 790 //
     /* 163877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163898 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 163901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 163907 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163909 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163911 */     GIR_RootConstrainSelectedInstOperands,
     /* 163912 */     // GIR_Coverage, 790,
     /* 163912 */     GIR_EraseRootFromParent_Done,
     /* 163913 */   // Label 2426: @163913
     /* 163913 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(163938), // Rule ID 788 //
     /* 163918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 163921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 163925 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 163925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 163928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 163930 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 163932 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 163934 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 163936 */     GIR_RootConstrainSelectedInstOperands,
     /* 163937 */     // GIR_Coverage, 788,
     /* 163937 */     GIR_EraseRootFromParent_Done,
     /* 163938 */   // Label 2427: @163938
     /* 163938 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(163979), // Rule ID 223 //
     /* 163943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 163958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 163962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163964 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 163967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 163969 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 163971 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 163973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 163977 */     GIR_RootConstrainSelectedInstOperands,
     /* 163978 */     // GIR_Coverage, 223,
     /* 163978 */     GIR_EraseRootFromParent_Done,
     /* 163979 */   // Label 2428: @163979
     /* 163979 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(164002), // Rule ID 219 //
     /* 163984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 163987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 163991 */     // (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 163991 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 163996 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164000 */     GIR_RootConstrainSelectedInstOperands,
     /* 164001 */     // GIR_Coverage, 219,
     /* 164001 */     GIR_Done,
     /* 164002 */   // Label 2429: @164002
     /* 164002 */   GIM_Reject,
     /* 164003 */ // Label 2425: @164003
     /* 164003 */ GIM_Reject,
     /* 164004 */ // Label 2416: @164004
     /* 164004 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(164081),
     /* 164009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 164015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 164018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164022 */   GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(164059), // Rule ID 1000 //
     /* 164027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 164042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164044 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 164047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 164053 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 164055 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 164057 */     GIR_RootConstrainSelectedInstOperands,
     /* 164058 */     // GIR_Coverage, 1000,
     /* 164058 */     GIR_EraseRootFromParent_Done,
     /* 164059 */   // Label 2431: @164059
     /* 164059 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(164080), // Rule ID 998 //
     /* 164064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164067 */     // (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 164070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 164072 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 164074 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 164076 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 164078 */     GIR_RootConstrainSelectedInstOperands,
     /* 164079 */     // GIR_Coverage, 998,
     /* 164079 */     GIR_EraseRootFromParent_Done,
     /* 164080 */   // Label 2432: @164080
     /* 164080 */   GIM_Reject,
     /* 164081 */ // Label 2430: @164081
     /* 164081 */ GIM_Reject,
     /* 164082 */ // Label 2417: @164082
     /* 164082 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(164159),
     /* 164087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 164096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164100 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(164137), // Rule ID 800 //
     /* 164105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164122 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 164125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 164131 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164133 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164135 */     GIR_RootConstrainSelectedInstOperands,
     /* 164136 */     // GIR_Coverage, 800,
     /* 164136 */     GIR_EraseRootFromParent_Done,
     /* 164137 */   // Label 2434: @164137
     /* 164137 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(164158), // Rule ID 796 //
     /* 164142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164145 */     // (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 164148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164150 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 164152 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164154 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164156 */     GIR_RootConstrainSelectedInstOperands,
     /* 164157 */     // GIR_Coverage, 796,
     /* 164157 */     GIR_EraseRootFromParent_Done,
     /* 164158 */   // Label 2435: @164158
     /* 164158 */   GIM_Reject,
     /* 164159 */ // Label 2433: @164159
     /* 164159 */ GIM_Reject,
     /* 164160 */ // Label 2418: @164160
     /* 164160 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(164260),
     /* 164165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 164174 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(164215), // Rule ID 802 //
     /* 164179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164200 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 164203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 164209 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164211 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164213 */     GIR_RootConstrainSelectedInstOperands,
     /* 164214 */     // GIR_Coverage, 802,
     /* 164214 */     GIR_EraseRootFromParent_Done,
     /* 164215 */   // Label 2437: @164215
     /* 164215 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(164240), // Rule ID 798 //
     /* 164220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164227 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 164230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164232 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 164234 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 164236 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 164238 */     GIR_RootConstrainSelectedInstOperands,
     /* 164239 */     // GIR_Coverage, 798,
     /* 164239 */     GIR_EraseRootFromParent_Done,
     /* 164240 */   // Label 2438: @164240
     /* 164240 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(164259), // Rule ID 292 //
     /* 164245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 164248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164252 */     // (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)  =>  (VMADDFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 164252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMADDFP),
     /* 164257 */     GIR_RootConstrainSelectedInstOperands,
     /* 164258 */     // GIR_Coverage, 292,
     /* 164258 */     GIR_Done,
     /* 164259 */   // Label 2439: @164259
     /* 164259 */   GIM_Reject,
     /* 164260 */ // Label 2436: @164260
     /* 164260 */ GIM_Reject,
     /* 164261 */ // Label 2419: @164261
     /* 164261 */ GIM_Reject,
     /* 164262 */ // Label 44: @164262
     /* 164262 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2445*/ GIMT_Encode4(164531),
     /* 164273 */ /*GILLT_s32*//*Label 2440*/ GIMT_Encode4(164293),
     /* 164277 */ /*GILLT_s64*//*Label 2441*/ GIMT_Encode4(164367),
     /* 164281 */ /*GILLT_s128*//*Label 2442*/ GIMT_Encode4(164445),
     /* 164285 */ /*GILLT_v2s64*//*Label 2443*/ GIMT_Encode4(164471),
     /* 164289 */ /*GILLT_v4s32*//*Label 2444*/ GIMT_Encode4(164501),
     /* 164293 */ // Label 2440: @164293
     /* 164293 */ GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(164366),
     /* 164298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164304 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(164323), // Rule ID 959 //
     /* 164309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164316 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164316 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 164321 */     GIR_RootConstrainSelectedInstOperands,
     /* 164322 */     // GIR_Coverage, 959,
     /* 164322 */     GIR_Done,
     /* 164323 */   // Label 2447: @164323
     /* 164323 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(164346), // Rule ID 243 //
     /* 164328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164335 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 164335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 164340 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164344 */     GIR_RootConstrainSelectedInstOperands,
     /* 164345 */     // GIR_Coverage, 243,
     /* 164345 */     GIR_Done,
     /* 164346 */   // Label 2448: @164346
     /* 164346 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(164365), // Rule ID 595 //
     /* 164351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 164358 */     // (fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 164358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 164363 */     GIR_RootConstrainSelectedInstOperands,
     /* 164364 */     // GIR_Coverage, 595,
     /* 164364 */     GIR_Done,
     /* 164365 */   // Label 2449: @164365
     /* 164365 */   GIM_Reject,
     /* 164366 */ // Label 2446: @164366
     /* 164366 */ GIM_Reject,
     /* 164367 */ // Label 2441: @164367
     /* 164367 */ GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(164444),
     /* 164372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 164375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164378 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(164401), // Rule ID 811 //
     /* 164383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164390 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 164390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 164395 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164399 */     GIR_RootConstrainSelectedInstOperands,
     /* 164400 */     // GIR_Coverage, 811,
     /* 164400 */     GIR_Done,
     /* 164401 */   // Label 2451: @164401
     /* 164401 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(164424), // Rule ID 241 //
     /* 164406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 164413 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 164413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 164418 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164422 */     GIR_RootConstrainSelectedInstOperands,
     /* 164423 */     // GIR_Coverage, 241,
     /* 164423 */     GIR_Done,
     /* 164424 */   // Label 2452: @164424
     /* 164424 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(164443), // Rule ID 574 //
     /* 164429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 164432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 164436 */     // (fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 164436 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 164441 */     GIR_RootConstrainSelectedInstOperands,
     /* 164442 */     // GIR_Coverage, 574,
     /* 164442 */     GIR_Done,
     /* 164443 */   // Label 2453: @164443
     /* 164443 */   GIM_Reject,
     /* 164444 */ // Label 2450: @164444
     /* 164444 */ GIM_Reject,
     /* 164445 */ // Label 2442: @164445
     /* 164445 */ GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(164470), // Rule ID 994 //
     /* 164450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 164453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 164456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 164459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 164463 */   // (fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 164463 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 164468 */   GIR_RootConstrainSelectedInstOperands,
     /* 164469 */   // GIR_Coverage, 994,
     /* 164469 */   GIR_Done,
     /* 164470 */ // Label 2454: @164470
     /* 164470 */ GIM_Reject,
     /* 164471 */ // Label 2443: @164471
     /* 164471 */ GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(164500), // Rule ID 820 //
     /* 164476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 164482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164489 */   // (fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 164489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 164494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164498 */   GIR_RootConstrainSelectedInstOperands,
     /* 164499 */   // GIR_Coverage, 820,
     /* 164499 */   GIR_Done,
     /* 164500 */ // Label 2455: @164500
     /* 164500 */ GIM_Reject,
     /* 164501 */ // Label 2444: @164501
     /* 164501 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(164530), // Rule ID 822 //
     /* 164506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 164512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 164519 */   // (fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 164519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 164524 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 164528 */   GIR_RootConstrainSelectedInstOperands,
     /* 164529 */   // GIR_Coverage, 822,
     /* 164529 */   GIR_Done,
     /* 164530 */ // Label 2456: @164530
     /* 164530 */ GIM_Reject,
     /* 164531 */ // Label 2445: @164531
     /* 164531 */ GIM_Reject,
     /* 164532 */ // Label 45: @164532
     /* 164532 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2462*/ GIMT_Encode4(167002),
     /* 164543 */ /*GILLT_s32*//*Label 2457*/ GIMT_Encode4(164563),
     /* 164547 */ /*GILLT_s64*//*Label 2458*/ GIMT_Encode4(165336),
     /* 164551 */ /*GILLT_s128*//*Label 2459*/ GIMT_Encode4(165990),
     /* 164555 */ /*GILLT_v2s64*//*Label 2460*/ GIMT_Encode4(166398),
     /* 164559 */ /*GILLT_v4s32*//*Label 2461*/ GIMT_Encode4(166684),
     /* 164563 */ // Label 2457: @164563
     /* 164563 */ GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(165335),
     /* 164568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 164571 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(164636), // Rule ID 973 //
     /* 164576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164617 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164634 */     GIR_RootConstrainSelectedInstOperands,
     /* 164635 */     // GIR_Coverage, 973,
     /* 164635 */     GIR_EraseRootFromParent_Done,
     /* 164636 */   // Label 2464: @164636
     /* 164636 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(164701), // Rule ID 972 //
     /* 164641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164664 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 164672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 164676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 164680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 164682 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi)))  =>  (XSNMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBASP),
     /* 164685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 164691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164699 */     GIR_RootConstrainSelectedInstOperands,
     /* 164700 */     // GIR_Coverage, 972,
     /* 164700 */     GIR_EraseRootFromParent_Done,
     /* 164701 */   // Label 2465: @164701
     /* 164701 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(164754), // Rule ID 971 //
     /* 164706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 164721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164729 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164735 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164752 */     GIR_RootConstrainSelectedInstOperands,
     /* 164753 */     // GIR_Coverage, 971,
     /* 164753 */     GIR_EraseRootFromParent_Done,
     /* 164754 */   // Label 2466: @164754
     /* 164754 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(164807), // Rule ID 970 //
     /* 164759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 164774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 164782 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 164786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164788 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi))  =>  (XSNMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 164788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDASP),
     /* 164791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 164797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 164801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 164805 */     GIR_RootConstrainSelectedInstOperands,
     /* 164806 */     // GIR_Coverage, 970,
     /* 164806 */     GIR_EraseRootFromParent_Done,
     /* 164807 */   // Label 2467: @164807
     /* 164807 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(164844), // Rule ID 845 //
     /* 164812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164833 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$XB))  =>  (XSNABSDPs:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 164833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDPs),
     /* 164836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 164838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 164842 */     GIR_RootConstrainSelectedInstOperands,
     /* 164843 */     // GIR_Coverage, 845,
     /* 164843 */     GIR_EraseRootFromParent_Done,
     /* 164844 */   // Label 2468: @164844
     /* 164844 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(164922), // Rule ID 1685 //
     /* 164849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 164860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 164864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 164868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164870 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$S))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164870 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164873 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164877 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164882 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // S
     /* 164886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 164898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164921 */     // GIR_Coverage, 1685,
     /* 164921 */     GIR_EraseRootFromParent_Done,
     /* 164922 */   // Label 2469: @164922
     /* 164922 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(164986), // Rule ID 1926 //
     /* 164927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 164930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164934 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSNEGDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 164934 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 164937 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164941 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164946 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 164950 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 164955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 164962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164967 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 164970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 164985 */     // GIR_Coverage, 1926,
     /* 164985 */     GIR_EraseRootFromParent_Done,
     /* 164986 */   // Label 2470: @164986
     /* 164986 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(165051), // Rule ID 233 //
     /* 164991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 164994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 164998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165014 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 165030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165032 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 165035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165049 */     GIR_RootConstrainSelectedInstOperands,
     /* 165050 */     // GIR_Coverage, 233,
     /* 165050 */     GIR_EraseRootFromParent_Done,
     /* 165051 */   // Label 2471: @165051
     /* 165051 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(165116), // Rule ID 232 //
     /* 165056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165079 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 165095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165097 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB)))  =>  (FNMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUBS),
     /* 165100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165114 */     GIR_RootConstrainSelectedInstOperands,
     /* 165115 */     // GIR_Coverage, 232,
     /* 165115 */     GIR_EraseRootFromParent_Done,
     /* 165116 */   // Label 2472: @165116
     /* 165116 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(165169), // Rule ID 229 //
     /* 165121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165144 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165150 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 165153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165167 */     GIR_RootConstrainSelectedInstOperands,
     /* 165168 */     // GIR_Coverage, 229,
     /* 165168 */     GIR_EraseRootFromParent_Done,
     /* 165169 */   // Label 2473: @165169
     /* 165169 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(165222), // Rule ID 228 //
     /* 165174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 165197 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 165201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165203 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB))  =>  (FNMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 165203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADDS),
     /* 165206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165220 */     GIR_RootConstrainSelectedInstOperands,
     /* 165221 */     // GIR_Coverage, 228,
     /* 165221 */     GIR_EraseRootFromParent_Done,
     /* 165222 */   // Label 2474: @165222
     /* 165222 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(165259), // Rule ID 165 //
     /* 165227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165248 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB))  =>  (FNABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 165248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSS),
     /* 165251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 165257 */     GIR_RootConstrainSelectedInstOperands,
     /* 165258 */     // GIR_Coverage, 165,
     /* 165258 */     GIR_EraseRootFromParent_Done,
     /* 165259 */   // Label 2475: @165259
     /* 165259 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(165296), // Rule ID 598 //
     /* 165264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 165283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165285 */     // (fneg:{ *:[f32] } (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA))  =>  (EFSNABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFSNABS),
     /* 165288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 165290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165294 */     GIR_RootConstrainSelectedInstOperands,
     /* 165295 */     // GIR_Coverage, 598,
     /* 165295 */     GIR_EraseRootFromParent_Done,
     /* 165296 */   // Label 2476: @165296
     /* 165296 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(165315), // Rule ID 167 //
     /* 165301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 165308 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FNEGS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 165308 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGS),
     /* 165313 */     GIR_RootConstrainSelectedInstOperands,
     /* 165314 */     // GIR_Coverage, 167,
     /* 165314 */     GIR_Done,
     /* 165315 */   // Label 2477: @165315
     /* 165315 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(165334), // Rule ID 599 //
     /* 165320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 165327 */     // (fneg:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSNEG:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 165327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSNEG),
     /* 165332 */     GIR_RootConstrainSelectedInstOperands,
     /* 165333 */     // GIR_Coverage, 599,
     /* 165333 */     GIR_Done,
     /* 165334 */   // Label 2478: @165334
     /* 165334 */   GIM_Reject,
     /* 165335 */ // Label 2463: @165335
     /* 165335 */ GIM_Reject,
     /* 165336 */ // Label 2458: @165336
     /* 165336 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(165989),
     /* 165341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 165344 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(165409), // Rule ID 794 //
     /* 165349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165372 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165390 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165407 */     GIR_RootConstrainSelectedInstOperands,
     /* 165408 */     // GIR_Coverage, 794,
     /* 165408 */     GIR_EraseRootFromParent_Done,
     /* 165409 */   // Label 2480: @165409
     /* 165409 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(165474), // Rule ID 793 //
     /* 165414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165455 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi)))  =>  (XSNMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBADP),
     /* 165458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 165464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165472 */     GIR_RootConstrainSelectedInstOperands,
     /* 165473 */     // GIR_Coverage, 793,
     /* 165473 */     GIR_EraseRootFromParent_Done,
     /* 165474 */   // Label 2481: @165474
     /* 165474 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(165527), // Rule ID 792 //
     /* 165479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165502 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165508 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165525 */     GIR_RootConstrainSelectedInstOperands,
     /* 165526 */     // GIR_Coverage, 792,
     /* 165526 */     GIR_EraseRootFromParent_Done,
     /* 165527 */   // Label 2482: @165527
     /* 165527 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(165580), // Rule ID 791 //
     /* 165532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165555 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165561 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi))  =>  (XSNMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 165561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDADP),
     /* 165564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 165570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 165574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 165578 */     GIR_RootConstrainSelectedInstOperands,
     /* 165579 */     // GIR_Coverage, 791,
     /* 165579 */     GIR_EraseRootFromParent_Done,
     /* 165580 */   // Label 2483: @165580
     /* 165580 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(165617), // Rule ID 844 //
     /* 165585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165606 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB))  =>  (XSNABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSDP),
     /* 165609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 165611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 165615 */     GIR_RootConstrainSelectedInstOperands,
     /* 165616 */     // GIR_Coverage, 844,
     /* 165616 */     GIR_EraseRootFromParent_Done,
     /* 165617 */   // Label 2484: @165617
     /* 165617 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(165640), // Rule ID 846 //
     /* 165622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 165625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 165629 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSNEGDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 165629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGDP),
     /* 165634 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 165638 */     GIR_RootConstrainSelectedInstOperands,
     /* 165639 */     // GIR_Coverage, 846,
     /* 165639 */     GIR_Done,
     /* 165640 */   // Label 2485: @165640
     /* 165640 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(165705), // Rule ID 231 //
     /* 165645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165686 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165703 */     GIR_RootConstrainSelectedInstOperands,
     /* 165704 */     // GIR_Coverage, 231,
     /* 165704 */     GIR_EraseRootFromParent_Done,
     /* 165705 */   // Label 2486: @165705
     /* 165705 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(165770), // Rule ID 230 //
     /* 165710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165733 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 165741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 165745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 165749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 165751 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB)))  =>  (FNMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMSUB),
     /* 165754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // FRB
     /* 165768 */     GIR_RootConstrainSelectedInstOperands,
     /* 165769 */     // GIR_Coverage, 230,
     /* 165769 */     GIR_EraseRootFromParent_Done,
     /* 165770 */   // Label 2487: @165770
     /* 165770 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(165823), // Rule ID 227 //
     /* 165775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 165790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165798 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165804 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165821 */     GIR_RootConstrainSelectedInstOperands,
     /* 165822 */     // GIR_Coverage, 227,
     /* 165822 */     GIR_EraseRootFromParent_Done,
     /* 165823 */   // Label 2488: @165823
     /* 165823 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(165876), // Rule ID 226 //
     /* 165828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 165843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 165851 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 165855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165857 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB))  =>  (FNMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 165857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNMADD),
     /* 165860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 165862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRA
     /* 165866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // FRC
     /* 165870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // FRB
     /* 165874 */     GIR_RootConstrainSelectedInstOperands,
     /* 165875 */     // GIR_Coverage, 226,
     /* 165875 */     GIR_EraseRootFromParent_Done,
     /* 165876 */   // Label 2489: @165876
     /* 165876 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(165913), // Rule ID 166 //
     /* 165881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165902 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB))  =>  (FNABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FNABSD),
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 165907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 165911 */     GIR_RootConstrainSelectedInstOperands,
     /* 165912 */     // GIR_Coverage, 166,
     /* 165912 */     GIR_EraseRootFromParent_Done,
     /* 165913 */   // Label 2490: @165913
     /* 165913 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(165950), // Rule ID 577 //
     /* 165918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 165929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 165933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 165937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 165939 */     // (fneg:{ *:[f64] } (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA))  =>  (EFDNABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::EFDNABS),
     /* 165942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 165944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 165948 */     GIR_RootConstrainSelectedInstOperands,
     /* 165949 */     // GIR_Coverage, 577,
     /* 165949 */     GIR_EraseRootFromParent_Done,
     /* 165950 */   // Label 2491: @165950
     /* 165950 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(165969), // Rule ID 168 //
     /* 165955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 165958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 165962 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FNEGD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 165962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FNEGD),
     /* 165967 */     GIR_RootConstrainSelectedInstOperands,
     /* 165968 */     // GIR_Coverage, 168,
     /* 165968 */     GIR_Done,
     /* 165969 */   // Label 2492: @165969
     /* 165969 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(165988), // Rule ID 578 //
     /* 165974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 165977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 165981 */     // (fneg:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDNEG:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 165981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDNEG),
     /* 165986 */     GIR_RootConstrainSelectedInstOperands,
     /* 165987 */     // GIR_Coverage, 578,
     /* 165987 */     GIR_Done,
     /* 165988 */   // Label 2493: @165988
     /* 165988 */   GIM_Reject,
     /* 165989 */ // Label 2479: @165989
     /* 165989 */ GIM_Reject,
     /* 165990 */ // Label 2459: @165990
     /* 165990 */ GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(166397),
     /* 165995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 165998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166002 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(166071), // Rule ID 1013 //
     /* 166007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 166018 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 166021 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 166026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166030 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166034 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 166038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/4, // MIs[2]
     /* 166042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 166050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166052 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10630:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQPO),
     /* 166055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 166061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 166065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 166069 */     GIR_RootConstrainSelectedInstOperands,
     /* 166070 */     // GIR_Coverage, 1013,
     /* 166070 */     GIR_EraseRootFromParent_Done,
     /* 166071 */   // Label 2495: @166071
     /* 166071 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(166128), // Rule ID 1012 //
     /* 166076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 166087 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/5,
     /* 166090 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::ppc_fmaf128_round_to_odd),
     /* 166095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166099 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166103 */     GIM_CheckType, /*MI*/1, /*Op*/4, /*Type*/GILLT_s128,
     /* 166107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166109 */     // (fneg:{ *:[f128] } (intrinsic_wo_chain:{ *:[f128] } 10630:{ *:[iPTR] }, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQPO:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQPO),
     /* 166112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/4, // RSTi
     /* 166118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RA
     /* 166122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RB
     /* 166126 */     GIR_RootConstrainSelectedInstOperands,
     /* 166127 */     // GIR_Coverage, 1012,
     /* 166127 */     GIR_EraseRootFromParent_Done,
     /* 166128 */   // Label 2496: @166128
     /* 166128 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(166189), // Rule ID 1004 //
     /* 166133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166152 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 166168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166170 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 166173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 166179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166187 */     GIR_RootConstrainSelectedInstOperands,
     /* 166188 */     // GIR_Coverage, 1004,
     /* 166188 */     GIR_EraseRootFromParent_Done,
     /* 166189 */   // Label 2497: @166189
     /* 166189 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(166250), // Rule ID 1003 //
     /* 166194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166213 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s128,
     /* 166229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166231 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi)))  =>  (XSNMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMSUBQP),
     /* 166234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RSTi
     /* 166240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166248 */     GIR_RootConstrainSelectedInstOperands,
     /* 166249 */     // GIR_Coverage, 1003,
     /* 166249 */     GIR_EraseRootFromParent_Done,
     /* 166250 */   // Label 2498: @166250
     /* 166250 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(166299), // Rule ID 1002 //
     /* 166255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166274 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166280 */     // (fneg:{ *:[f128] } (fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 166283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 166289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166297 */     GIR_RootConstrainSelectedInstOperands,
     /* 166298 */     // GIR_Coverage, 1002,
     /* 166298 */     GIR_EraseRootFromParent_Done,
     /* 166299 */   // Label 2499: @166299
     /* 166299 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(166348), // Rule ID 1001 //
     /* 166304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s128,
     /* 166323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s128,
     /* 166327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166329 */     // (fneg:{ *:[f128] } (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi))  =>  (XSNMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 166329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNMADDQP),
     /* 166332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // RSTi
     /* 166338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RB
     /* 166346 */     GIR_RootConstrainSelectedInstOperands,
     /* 166347 */     // GIR_Coverage, 1001,
     /* 166347 */     GIR_EraseRootFromParent_Done,
     /* 166348 */   // Label 2500: @166348
     /* 166348 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(166381), // Rule ID 985 //
     /* 166353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 166368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166370 */     // (fneg:{ *:[f128] } (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB))  =>  (XSNABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSNABSQP),
     /* 166373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 166375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RB
     /* 166379 */     GIR_RootConstrainSelectedInstOperands,
     /* 166380 */     // GIR_Coverage, 985,
     /* 166380 */     GIR_EraseRootFromParent_Done,
     /* 166381 */   // Label 2501: @166381
     /* 166381 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(166396), // Rule ID 986 //
     /* 166386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 166389 */     // (fneg:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSNEGQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 166389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSNEGQP),
     /* 166394 */     GIR_RootConstrainSelectedInstOperands,
     /* 166395 */     // GIR_Coverage, 986,
     /* 166395 */     GIR_Done,
     /* 166396 */   // Label 2502: @166396
     /* 166396 */   GIM_Reject,
     /* 166397 */ // Label 2494: @166397
     /* 166397 */ GIM_Reject,
     /* 166398 */ // Label 2460: @166398
     /* 166398 */ GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(166683),
     /* 166403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166410 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(166471), // Rule ID 807 //
     /* 166415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166434 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166452 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166469 */     GIR_RootConstrainSelectedInstOperands,
     /* 166470 */     // GIR_Coverage, 807,
     /* 166470 */     GIR_EraseRootFromParent_Done,
     /* 166471 */   // Label 2504: @166471
     /* 166471 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(166532), // Rule ID 806 //
     /* 166476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166513 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi)))  =>  (XVNMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBADP),
     /* 166516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166530 */     GIR_RootConstrainSelectedInstOperands,
     /* 166531 */     // GIR_Coverage, 806,
     /* 166531 */     GIR_EraseRootFromParent_Done,
     /* 166532 */   // Label 2505: @166532
     /* 166532 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(166581), // Rule ID 804 //
     /* 166537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166562 */     // (fneg:{ *:[v2f64] } (fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166579 */     GIR_RootConstrainSelectedInstOperands,
     /* 166580 */     // GIR_Coverage, 804,
     /* 166580 */     GIR_EraseRootFromParent_Done,
     /* 166581 */   // Label 2506: @166581
     /* 166581 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(166630), // Rule ID 803 //
     /* 166586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166605 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 166609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166611 */     // (fneg:{ *:[v2f64] } (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi))  =>  (XVNMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 166611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDADP),
     /* 166614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166628 */     GIR_RootConstrainSelectedInstOperands,
     /* 166629 */     // GIR_Coverage, 803,
     /* 166629 */     GIR_EraseRootFromParent_Done,
     /* 166630 */   // Label 2507: @166630
     /* 166630 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(166663), // Rule ID 852 //
     /* 166635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 166650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166652 */     // (fneg:{ *:[v2f64] } (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB))  =>  (XVNABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSDP),
     /* 166655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166661 */     GIR_RootConstrainSelectedInstOperands,
     /* 166662 */     // GIR_Coverage, 852,
     /* 166662 */     GIR_EraseRootFromParent_Done,
     /* 166663 */   // Label 2508: @166663
     /* 166663 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(166682), // Rule ID 854 //
     /* 166668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166671 */     // (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVNEGDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 166671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGDP),
     /* 166676 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166680 */     GIR_RootConstrainSelectedInstOperands,
     /* 166681 */     // GIR_Coverage, 854,
     /* 166681 */     GIR_Done,
     /* 166682 */   // Label 2509: @166682
     /* 166682 */   GIM_Reject,
     /* 166683 */ // Label 2503: @166683
     /* 166683 */ GIM_Reject,
     /* 166684 */ // Label 2461: @166684
     /* 166684 */ GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(167001),
     /* 166689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166692 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(166757), // Rule ID 809 //
     /* 166697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166738 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166755 */     GIR_RootConstrainSelectedInstOperands,
     /* 166756 */     // GIR_Coverage, 809,
     /* 166756 */     GIR_EraseRootFromParent_Done,
     /* 166757 */   // Label 2511: @166757
     /* 166757 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(166822), // Rule ID 808 //
     /* 166762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 166777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166785 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166801 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166803 */     // (fneg:{ *:[v4f32] } (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi)))  =>  (XVNMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMSUBASP),
     /* 166806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // XTi
     /* 166812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166820 */     GIR_RootConstrainSelectedInstOperands,
     /* 166821 */     // GIR_Coverage, 808,
     /* 166821 */     GIR_EraseRootFromParent_Done,
     /* 166822 */   // Label 2512: @166822
     /* 166822 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(166875), // Rule ID 805 //
     /* 166827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166856 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi))  =>  (XVNMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 166856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNMADDASP),
     /* 166859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // XTi
     /* 166865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XA
     /* 166869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // XB
     /* 166873 */     GIR_RootConstrainSelectedInstOperands,
     /* 166874 */     // GIR_Coverage, 805,
     /* 166874 */     GIR_EraseRootFromParent_Done,
     /* 166875 */   // Label 2513: @166875
     /* 166875 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(166912), // Rule ID 853 //
     /* 166880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 166895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166901 */     // (fneg:{ *:[v4f32] } (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB))  =>  (XVNABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVNABSSP),
     /* 166904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 166906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XB
     /* 166910 */     GIR_RootConstrainSelectedInstOperands,
     /* 166911 */     // GIR_Coverage, 853,
     /* 166911 */     GIR_EraseRootFromParent_Done,
     /* 166912 */   // Label 2514: @166912
     /* 166912 */   GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(166935), // Rule ID 855 //
     /* 166917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 166920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 166924 */     // (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVNEGSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 166924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVNEGSP),
     /* 166929 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 166933 */     GIR_RootConstrainSelectedInstOperands,
     /* 166934 */     // GIR_Coverage, 855,
     /* 166934 */     GIR_Done,
     /* 166935 */   // Label 2515: @166935
     /* 166935 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(167000), // Rule ID 293 //
     /* 166940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 166943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 166947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 166951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 166955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166963 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 166967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 166971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 166975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 166979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 166981 */     // (fneg:{ *:[v4f32] } (fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RB)))  =>  (VNMSUBFP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$RA, v4f32:{ *:[v4f32] }:$RC, v4f32:{ *:[v4f32] }:$RB)
     /* 166981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VNMSUBFP),
     /* 166984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RT]
     /* 166986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RA
     /* 166990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RC
     /* 166994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RB
     /* 166998 */     GIR_RootConstrainSelectedInstOperands,
     /* 166999 */     // GIR_Coverage, 293,
     /* 166999 */     GIR_EraseRootFromParent_Done,
     /* 167000 */   // Label 2516: @167000
     /* 167000 */   GIM_Reject,
     /* 167001 */ // Label 2510: @167001
     /* 167001 */ GIM_Reject,
     /* 167002 */ // Label 2462: @167002
     /* 167002 */ GIM_Reject,
     /* 167003 */ // Label 46: @167003
     /* 167003 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2519*/ GIMT_Encode4(167166),
     /* 167014 */ /*GILLT_s64*//*Label 2517*/ GIMT_Encode4(167022),
     /* 167018 */ /*GILLT_s128*//*Label 2518*/ GIMT_Encode4(167097),
     /* 167022 */ // Label 2517: @167022
     /* 167022 */ GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(167096),
     /* 167027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167030 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(167053), // Rule ID 1910 //
     /* 167035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167042 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VSFRC:{ *:[i32] })
     /* 167042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 167052 */     // GIR_Coverage, 1910,
     /* 167052 */     GIR_Done,
     /* 167053 */   // Label 2521: @167053
     /* 167053 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(167072), // Rule ID 564 //
     /* 167058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167065 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$RB)  =>  (EFDCFS:{ *:[f64] } f32:{ *:[f32] }:$RB)
     /* 167065 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFS),
     /* 167070 */     GIR_RootConstrainSelectedInstOperands,
     /* 167071 */     // GIR_Coverage, 564,
     /* 167071 */     GIR_Done,
     /* 167072 */   // Label 2522: @167072
     /* 167072 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(167095), // Rule ID 1269 //
     /* 167077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 167080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 167084 */     // (fpextend:{ *:[f64] } f32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, F8RC:{ *:[i32] })
     /* 167084 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 167094 */     // GIR_Coverage, 1269,
     /* 167094 */     GIR_Done,
     /* 167095 */   // Label 2523: @167095
     /* 167095 */   GIM_Reject,
     /* 167096 */ // Label 2520: @167096
     /* 167096 */ GIM_Reject,
     /* 167097 */ // Label 2518: @167097
     /* 167097 */ GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(167119), // Rule ID 1015 //
     /* 167102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167112 */   // (fpextend:{ *:[f128] } f64:{ *:[f64] }:$RB)  =>  (XSCVDPQP:{ *:[f128] } f64:{ *:[f64] }:$RB)
     /* 167112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 167117 */   GIR_RootConstrainSelectedInstOperands,
     /* 167118 */   // GIR_Coverage, 1015,
     /* 167118 */   GIR_Done,
     /* 167119 */ // Label 2524: @167119
     /* 167119 */ GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(167165), // Rule ID 2264 //
     /* 167124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167134 */   // (fpextend:{ *:[f128] } f32:{ *:[f32] }:$src)  =>  (XSCVDPQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$src, VFRC:{ *:[i32] }))
     /* 167134 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167137 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167141 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167146 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167150 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVDPQP),
     /* 167158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167163 */   GIR_RootConstrainSelectedInstOperands,
     /* 167164 */   // GIR_Coverage, 2264,
     /* 167164 */   GIR_EraseRootFromParent_Done,
     /* 167165 */ // Label 2525: @167165
     /* 167165 */ GIM_Reject,
     /* 167166 */ // Label 2519: @167166
     /* 167166 */ GIM_Reject,
     /* 167167 */ // Label 47: @167167
     /* 167167 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2528*/ GIMT_Encode4(167323),
     /* 167178 */ /*GILLT_s32*//*Label 2526*/ GIMT_Encode4(167186),
     /* 167182 */ /*GILLT_s64*//*Label 2527*/ GIMT_Encode4(167300),
     /* 167186 */ // Label 2526: @167186
     /* 167186 */ GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(167208), // Rule ID 962 //
     /* 167191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 167194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167201 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$XB)  =>  (XSRSP:{ *:[f32] } f64:{ *:[f64] }:$XB)
     /* 167201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 167206 */   GIR_RootConstrainSelectedInstOperands,
     /* 167207 */   // GIR_Coverage, 962,
     /* 167207 */   GIR_Done,
     /* 167208 */ // Label 2529: @167208
     /* 167208 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(167251), // Rule ID 2262 //
     /* 167213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 167223 */   // (fpround:{ *:[f32] } f128:{ *:[f128] }:$src)  =>  (XSRSP:{ *:[f32] } (XSCVQPDPO:{ *:[f64] } ?:{ *:[f128] }:$src))
     /* 167223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDPO),
     /* 167230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167235 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167239 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRSP),
     /* 167244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 167246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167249 */   GIR_RootConstrainSelectedInstOperands,
     /* 167250 */   // GIR_Coverage, 2262,
     /* 167250 */   GIR_EraseRootFromParent_Done,
     /* 167251 */ // Label 2530: @167251
     /* 167251 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(167277), // Rule ID 158 //
     /* 167256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 167259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 167266 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (FRSP:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 167266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRSP),
     /* 167271 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167275 */   GIR_RootConstrainSelectedInstOperands,
     /* 167276 */   // GIR_Coverage, 158,
     /* 167276 */   GIR_Done,
     /* 167277 */ // Label 2531: @167277
     /* 167277 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(167299), // Rule ID 585 //
     /* 167282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167292 */   // (fpround:{ *:[f32] } f64:{ *:[f64] }:$RB)  =>  (EFSCFD:{ *:[f32] } f64:{ *:[f64] }:$RB)
     /* 167292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFD),
     /* 167297 */   GIR_RootConstrainSelectedInstOperands,
     /* 167298 */   // GIR_Coverage, 585,
     /* 167298 */   GIR_Done,
     /* 167299 */ // Label 2532: @167299
     /* 167299 */ GIM_Reject,
     /* 167300 */ // Label 2527: @167300
     /* 167300 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(167322), // Rule ID 2260 //
     /* 167305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167315 */   // (fpround:{ *:[f64] } f128:{ *:[f128] }:$src)  =>  (XSCVQPDP:{ *:[f64] } ?:{ *:[f128] }:$src)
     /* 167315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSCVQPDP),
     /* 167320 */   GIR_RootConstrainSelectedInstOperands,
     /* 167321 */   // GIR_Coverage, 2260,
     /* 167321 */   GIR_Done,
     /* 167322 */ // Label 2533: @167322
     /* 167322 */ GIM_Reject,
     /* 167323 */ // Label 2528: @167323
     /* 167323 */ GIM_Reject,
     /* 167324 */ // Label 48: @167324
     /* 167324 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2538*/ GIMT_Encode4(167586),
     /* 167335 */ /*GILLT_s32*//*Label 2534*/ GIMT_Encode4(167355),
     /* 167339 */ /*GILLT_s64*//*Label 2535*/ GIMT_Encode4(167463), GIMT_Encode4(0),
     /* 167347 */ /*GILLT_v2s64*//*Label 2536*/ GIMT_Encode4(167507),
     /* 167351 */ /*GILLT_v4s32*//*Label 2537*/ GIMT_Encode4(167534),
     /* 167355 */ // Label 2534: @167355
     /* 167355 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(167418), // Rule ID 2250 //
     /* 167360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167370 */   // (fp_to_sint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPSWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167370 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167373 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSWZ),
     /* 167377 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167382 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167388 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167391 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167395 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167400 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167403 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167413 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167416 */   GIR_RootConstrainSelectedInstOperands,
     /* 167417 */   // GIR_Coverage, 2250,
     /* 167417 */   GIR_EraseRootFromParent_Done,
     /* 167418 */ // Label 2539: @167418
     /* 167418 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(167440), // Rule ID 570 //
     /* 167423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167433 */   // (fp_to_sint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTSIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTSIZ),
     /* 167438 */   GIR_RootConstrainSelectedInstOperands,
     /* 167439 */   // GIR_Coverage, 570,
     /* 167439 */   GIR_Done,
     /* 167440 */ // Label 2540: @167440
     /* 167440 */ GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(167462), // Rule ID 591 //
     /* 167445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167455 */   // (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTSIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167455 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTSIZ),
     /* 167460 */   GIR_RootConstrainSelectedInstOperands,
     /* 167461 */   // GIR_Coverage, 591,
     /* 167461 */   GIR_Done,
     /* 167462 */ // Label 2541: @167462
     /* 167462 */ GIM_Reject,
     /* 167463 */ // Label 2535: @167463
     /* 167463 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(167506), // Rule ID 2246 //
     /* 167468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167478 */   // (fp_to_sint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPSDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPSDZ),
     /* 167485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167504 */   GIR_RootConstrainSelectedInstOperands,
     /* 167505 */   // GIR_Coverage, 2246,
     /* 167505 */   GIR_EraseRootFromParent_Done,
     /* 167506 */ // Label 2542: @167506
     /* 167506 */ GIM_Reject,
     /* 167507 */ // Label 2536: @167507
     /* 167507 */ GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(167533), // Rule ID 878 //
     /* 167512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167522 */   // (fp_to_sint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPSXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167522 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPSXDS),
     /* 167527 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167531 */   GIR_RootConstrainSelectedInstOperands,
     /* 167532 */   // GIR_Coverage, 878,
     /* 167532 */   GIR_Done,
     /* 167533 */ // Label 2543: @167533
     /* 167533 */ GIM_Reject,
     /* 167534 */ // Label 2537: @167534
     /* 167534 */ GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(167585),
     /* 167539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167542 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(167565), // Rule ID 886 //
     /* 167547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167554 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPSXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPSXWS),
     /* 167559 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167563 */     GIR_RootConstrainSelectedInstOperands,
     /* 167564 */     // GIR_Coverage, 886,
     /* 167564 */     GIR_Done,
     /* 167565 */   // Label 2545: @167565
     /* 167565 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(167584), // Rule ID 1415 //
     /* 167570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167577 */     // (fp_to_sint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTSXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTSXS_0),
     /* 167582 */     GIR_RootConstrainSelectedInstOperands,
     /* 167583 */     // GIR_Coverage, 1415,
     /* 167583 */     GIR_Done,
     /* 167584 */   // Label 2546: @167584
     /* 167584 */   GIM_Reject,
     /* 167585 */ // Label 2544: @167585
     /* 167585 */ GIM_Reject,
     /* 167586 */ // Label 2538: @167586
     /* 167586 */ GIM_Reject,
     /* 167587 */ // Label 49: @167587
     /* 167587 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2551*/ GIMT_Encode4(167849),
     /* 167598 */ /*GILLT_s32*//*Label 2547*/ GIMT_Encode4(167618),
     /* 167602 */ /*GILLT_s64*//*Label 2548*/ GIMT_Encode4(167726), GIMT_Encode4(0),
     /* 167610 */ /*GILLT_v2s64*//*Label 2549*/ GIMT_Encode4(167770),
     /* 167614 */ /*GILLT_v4s32*//*Label 2550*/ GIMT_Encode4(167797),
     /* 167618 */ // Label 2547: @167618
     /* 167618 */ GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(167681), // Rule ID 2252 //
     /* 167623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167633 */   // (fp_to_uint:{ *:[i32] } f128:{ *:[f128] }:$src)  =>  (MFVSRWZ:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[f64] } (XSCVQPUWZ:{ *:[f128] } ?:{ *:[f128] }:$src), VFRC:{ *:[i32] }))
     /* 167633 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 167636 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUWZ),
     /* 167640 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167645 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 167651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167663 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 167666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 167674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167676 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167679 */   GIR_RootConstrainSelectedInstOperands,
     /* 167680 */   // GIR_Coverage, 2252,
     /* 167680 */   GIR_EraseRootFromParent_Done,
     /* 167681 */ // Label 2552: @167681
     /* 167681 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(167703), // Rule ID 572 //
     /* 167686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167696 */   // (fp_to_uint:{ *:[i32] } f64:{ *:[f64] }:$RB)  =>  (EFDCTUIZ:{ *:[i32] } f64:{ *:[f64] }:$RB)
     /* 167696 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCTUIZ),
     /* 167701 */   GIR_RootConstrainSelectedInstOperands,
     /* 167702 */   // GIR_Coverage, 572,
     /* 167702 */   GIR_Done,
     /* 167703 */ // Label 2553: @167703
     /* 167703 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(167725), // Rule ID 593 //
     /* 167708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167718 */   // (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$RB)  =>  (EFSCTUIZ:{ *:[i32] } f32:{ *:[f32] }:$RB)
     /* 167718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCTUIZ),
     /* 167723 */   GIR_RootConstrainSelectedInstOperands,
     /* 167724 */   // GIR_Coverage, 593,
     /* 167724 */   GIR_Done,
     /* 167725 */ // Label 2554: @167725
     /* 167725 */ GIM_Reject,
     /* 167726 */ // Label 2548: @167726
     /* 167726 */ GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(167769), // Rule ID 2248 //
     /* 167731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 167737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 167741 */   // (fp_to_uint:{ *:[i64] } f128:{ *:[f128] }:$src)  =>  (MFVRD:{ *:[i64] } (XSCVQPUDZ:{ *:[v4i32] } ?:{ *:[f128] }:$src))
     /* 167741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 167744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSCVQPUDZ),
     /* 167748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVRD),
     /* 167762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 167764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167767 */   GIR_RootConstrainSelectedInstOperands,
     /* 167768 */   // GIR_Coverage, 2248,
     /* 167768 */   GIR_EraseRootFromParent_Done,
     /* 167769 */ // Label 2555: @167769
     /* 167769 */ GIM_Reject,
     /* 167770 */ // Label 2549: @167770
     /* 167770 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(167796), // Rule ID 881 //
     /* 167775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 167781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167785 */   // (fp_to_uint:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVCVDPUXDS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$XB)
     /* 167785 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVDPUXDS),
     /* 167790 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167794 */   GIR_RootConstrainSelectedInstOperands,
     /* 167795 */   // GIR_Coverage, 881,
     /* 167795 */   GIR_Done,
     /* 167796 */ // Label 2556: @167796
     /* 167796 */ GIM_Reject,
     /* 167797 */ // Label 2550: @167797
     /* 167797 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(167848),
     /* 167802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 167805 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(167828), // Rule ID 889 //
     /* 167810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 167813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 167817 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVCVSPUXWS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$XB)
     /* 167817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSPUXWS),
     /* 167822 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 167826 */     GIR_RootConstrainSelectedInstOperands,
     /* 167827 */     // GIR_Coverage, 889,
     /* 167827 */     GIR_Done,
     /* 167828 */   // Label 2558: @167828
     /* 167828 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(167847), // Rule ID 1416 //
     /* 167833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 167836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167840 */     // (fp_to_uint:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VCTUXS_0:{ *:[v4i32] } ?:{ *:[v4f32] }:$vA)
     /* 167840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTUXS_0),
     /* 167845 */     GIR_RootConstrainSelectedInstOperands,
     /* 167846 */     // GIR_Coverage, 1416,
     /* 167846 */     GIR_Done,
     /* 167847 */   // Label 2559: @167847
     /* 167847 */   GIM_Reject,
     /* 167848 */ // Label 2557: @167848
     /* 167848 */ GIM_Reject,
     /* 167849 */ // Label 2551: @167849
     /* 167849 */ GIM_Reject,
     /* 167850 */ // Label 50: @167850
     /* 167850 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2565*/ GIMT_Encode4(168096),
     /* 167861 */ /*GILLT_s32*//*Label 2560*/ GIMT_Encode4(167881),
     /* 167865 */ /*GILLT_s64*//*Label 2561*/ GIMT_Encode4(167904),
     /* 167869 */ /*GILLT_s128*//*Label 2562*/ GIMT_Encode4(167927),
     /* 167873 */ /*GILLT_v2s64*//*Label 2563*/ GIMT_Encode4(168017),
     /* 167877 */ /*GILLT_v4s32*//*Label 2564*/ GIMT_Encode4(168044),
     /* 167881 */ // Label 2560: @167881
     /* 167881 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(167903), // Rule ID 587 //
     /* 167886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 167896 */   // (sint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFSI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 167896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFSI),
     /* 167901 */   GIR_RootConstrainSelectedInstOperands,
     /* 167902 */   // GIR_Coverage, 587,
     /* 167902 */   GIR_Done,
     /* 167903 */ // Label 2566: @167903
     /* 167903 */ GIM_Reject,
     /* 167904 */ // Label 2561: @167904
     /* 167904 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(167926), // Rule ID 566 //
     /* 167909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 167912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 167919 */   // (sint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFSI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 167919 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFSI),
     /* 167924 */   GIR_RootConstrainSelectedInstOperands,
     /* 167925 */   // GIR_Coverage, 566,
     /* 167925 */   GIR_Done,
     /* 167926 */ // Label 2567: @167926
     /* 167926 */ GIM_Reject,
     /* 167927 */ // Label 2562: @167927
     /* 167927 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(167973), // Rule ID 2141 //
     /* 167932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 167938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167942 */   // (sint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 167942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167954 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 167958 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 167963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 167966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 167968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167971 */   GIR_RootConstrainSelectedInstOperands,
     /* 167972 */   // GIR_Coverage, 2141,
     /* 167972 */   GIR_EraseRootFromParent_Done,
     /* 167973 */ // Label 2568: @167973
     /* 167973 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(168016), // Rule ID 2151 //
     /* 167978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 167981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 167984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 167988 */   // (sint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVSDQP:{ *:[f128] } (MTVSRWA:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 167988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWA),
     /* 167995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168000 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 168004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVSDQP),
     /* 168009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168014 */   GIR_RootConstrainSelectedInstOperands,
     /* 168015 */   // GIR_Coverage, 2151,
     /* 168015 */   GIR_EraseRootFromParent_Done,
     /* 168016 */ // Label 2569: @168016
     /* 168016 */ GIM_Reject,
     /* 168017 */ // Label 2563: @168017
     /* 168017 */ GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(168043), // Rule ID 891 //
     /* 168022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168032 */   // (sint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVSXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 168032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXDDP),
     /* 168037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168041 */   GIR_RootConstrainSelectedInstOperands,
     /* 168042 */   // GIR_Coverage, 891,
     /* 168042 */   GIR_Done,
     /* 168043 */ // Label 2570: @168043
     /* 168043 */ GIM_Reject,
     /* 168044 */ // Label 2564: @168044
     /* 168044 */ GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(168095),
     /* 168049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168052 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(168075), // Rule ID 894 //
     /* 168057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168064 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVSXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 168064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVSXWSP),
     /* 168069 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168073 */     GIR_RootConstrainSelectedInstOperands,
     /* 168074 */     // GIR_Coverage, 894,
     /* 168074 */     GIR_Done,
     /* 168075 */   // Label 2572: @168075
     /* 168075 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(168094), // Rule ID 1417 //
     /* 168080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168087 */     // (sint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFSX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 168087 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFSX_0),
     /* 168092 */     GIR_RootConstrainSelectedInstOperands,
     /* 168093 */     // GIR_Coverage, 1417,
     /* 168093 */     GIR_Done,
     /* 168094 */   // Label 2573: @168094
     /* 168094 */   GIM_Reject,
     /* 168095 */ // Label 2571: @168095
     /* 168095 */ GIM_Reject,
     /* 168096 */ // Label 2565: @168096
     /* 168096 */ GIM_Reject,
     /* 168097 */ // Label 51: @168097
     /* 168097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2579*/ GIMT_Encode4(168343),
     /* 168108 */ /*GILLT_s32*//*Label 2574*/ GIMT_Encode4(168128),
     /* 168112 */ /*GILLT_s64*//*Label 2575*/ GIMT_Encode4(168151),
     /* 168116 */ /*GILLT_s128*//*Label 2576*/ GIMT_Encode4(168174),
     /* 168120 */ /*GILLT_v2s64*//*Label 2577*/ GIMT_Encode4(168264),
     /* 168124 */ /*GILLT_v4s32*//*Label 2578*/ GIMT_Encode4(168291),
     /* 168128 */ // Label 2574: @168128
     /* 168128 */ GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(168150), // Rule ID 589 //
     /* 168133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168143 */   // (uint_to_fp:{ *:[f32] } i32:{ *:[i32] }:$RB)  =>  (EFSCFUI:{ *:[f32] } i32:{ *:[i32] }:$RB)
     /* 168143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSCFUI),
     /* 168148 */   GIR_RootConstrainSelectedInstOperands,
     /* 168149 */   // GIR_Coverage, 589,
     /* 168149 */   GIR_Done,
     /* 168150 */ // Label 2580: @168150
     /* 168150 */ GIM_Reject,
     /* 168151 */ // Label 2575: @168151
     /* 168151 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(168173), // Rule ID 568 //
     /* 168156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 168166 */   // (uint_to_fp:{ *:[f64] } i32:{ *:[i32] }:$RB)  =>  (EFDCFUI:{ *:[f64] } i32:{ *:[i32] }:$RB)
     /* 168166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDCFUI),
     /* 168171 */   GIR_RootConstrainSelectedInstOperands,
     /* 168172 */   // GIR_Coverage, 568,
     /* 168172 */   GIR_Done,
     /* 168173 */ // Label 2581: @168173
     /* 168173 */ GIM_Reject,
     /* 168174 */ // Label 2576: @168174
     /* 168174 */ GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(168220), // Rule ID 2147 //
     /* 168179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168189 */   // (uint_to_fp:{ *:[f128] } i64:{ *:[i64] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[i64] }:$src, VFRC:{ *:[i32] }))
     /* 168189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168201 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 168205 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VFRCRegClassID),
     /* 168210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 168213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168218 */   GIR_RootConstrainSelectedInstOperands,
     /* 168219 */   // GIR_Coverage, 2147,
     /* 168219 */   GIR_EraseRootFromParent_Done,
     /* 168220 */ // Label 2582: @168220
     /* 168220 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(168263), // Rule ID 2155 //
     /* 168225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168235 */   // (uint_to_fp:{ *:[f128] } i32:{ *:[i32] }:$src)  =>  (XSCVUDQP:{ *:[f128] } (MTVSRWZ:{ *:[f64] } ?:{ *:[i32] }:$src))
     /* 168235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::MTVSRWZ),
     /* 168242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168247 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 168251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCVUDQP),
     /* 168256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168261 */   GIR_RootConstrainSelectedInstOperands,
     /* 168262 */   // GIR_Coverage, 2155,
     /* 168262 */   GIR_EraseRootFromParent_Done,
     /* 168263 */ // Label 2583: @168263
     /* 168263 */ GIM_Reject,
     /* 168264 */ // Label 2577: @168264
     /* 168264 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(168290), // Rule ID 896 //
     /* 168269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168279 */   // (uint_to_fp:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XVCVUXDDP:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$XB)
     /* 168279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXDDP),
     /* 168284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168288 */   GIR_RootConstrainSelectedInstOperands,
     /* 168289 */   // GIR_Coverage, 896,
     /* 168289 */   GIR_Done,
     /* 168290 */ // Label 2584: @168290
     /* 168290 */ GIM_Reject,
     /* 168291 */ // Label 2578: @168291
     /* 168291 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(168342),
     /* 168296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168299 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(168322), // Rule ID 899 //
     /* 168304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168311 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XVCVUXWSP:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$XB)
     /* 168311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVCVUXWSP),
     /* 168316 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168320 */     GIR_RootConstrainSelectedInstOperands,
     /* 168321 */     // GIR_Coverage, 899,
     /* 168321 */     GIR_Done,
     /* 168322 */   // Label 2586: @168322
     /* 168322 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(168341), // Rule ID 1418 //
     /* 168327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 168330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168334 */     // (uint_to_fp:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$vA)  =>  (VCFUX_0:{ *:[v4f32] } ?:{ *:[v4i32] }:$vA)
     /* 168334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCFUX_0),
     /* 168339 */     GIR_RootConstrainSelectedInstOperands,
     /* 168340 */     // GIR_Coverage, 1418,
     /* 168340 */     GIR_Done,
     /* 168341 */   // Label 2587: @168341
     /* 168341 */   GIM_Reject,
     /* 168342 */ // Label 2585: @168342
     /* 168342 */ GIM_Reject,
     /* 168343 */ // Label 2579: @168343
     /* 168343 */ GIM_Reject,
     /* 168344 */ // Label 52: @168344
     /* 168344 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2593*/ GIMT_Encode4(168635),
     /* 168355 */ /*GILLT_s32*//*Label 2588*/ GIMT_Encode4(168375),
     /* 168359 */ /*GILLT_s64*//*Label 2589*/ GIMT_Encode4(168487),
     /* 168363 */ /*GILLT_s128*//*Label 2590*/ GIMT_Encode4(168558),
     /* 168367 */ /*GILLT_v2s64*//*Label 2591*/ GIMT_Encode4(168581),
     /* 168371 */ /*GILLT_v4s32*//*Label 2592*/ GIMT_Encode4(168608),
     /* 168375 */ // Label 2588: @168375
     /* 168375 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(168486),
     /* 168380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168383 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(168447), // Rule ID 1684 //
     /* 168388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168395 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSABSDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 168395 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 168398 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168402 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168407 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 168411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 168431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 168433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 168446 */     // GIR_Coverage, 1684,
     /* 168446 */     GIR_EraseRootFromParent_Done,
     /* 168447 */   // Label 2595: @168447
     /* 168447 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(168466), // Rule ID 163 //
     /* 168452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168459 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FABSS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 168459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSS),
     /* 168464 */     GIR_RootConstrainSelectedInstOperands,
     /* 168465 */     // GIR_Coverage, 163,
     /* 168465 */     GIR_Done,
     /* 168466 */   // Label 2596: @168466
     /* 168466 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(168485), // Rule ID 581 //
     /* 168471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 168478 */     // (fabs:{ *:[f32] } f32:{ *:[f32] }:$RA)  =>  (EFSABS:{ *:[f32] } f32:{ *:[f32] }:$RA)
     /* 168478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSABS),
     /* 168483 */     GIR_RootConstrainSelectedInstOperands,
     /* 168484 */     // GIR_Coverage, 581,
     /* 168484 */     GIR_Done,
     /* 168485 */   // Label 2597: @168485
     /* 168485 */   GIM_Reject,
     /* 168486 */ // Label 2594: @168486
     /* 168486 */ GIM_Reject,
     /* 168487 */ // Label 2589: @168487
     /* 168487 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(168557),
     /* 168492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168495 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(168518), // Rule ID 843 //
     /* 168500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168507 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSABSDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 168507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSDP),
     /* 168512 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168516 */     GIR_RootConstrainSelectedInstOperands,
     /* 168517 */     // GIR_Coverage, 843,
     /* 168517 */     GIR_Done,
     /* 168518 */   // Label 2599: @168518
     /* 168518 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(168537), // Rule ID 164 //
     /* 168523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168530 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FABSD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 168530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FABSD),
     /* 168535 */     GIR_RootConstrainSelectedInstOperands,
     /* 168536 */     // GIR_Coverage, 164,
     /* 168536 */     GIR_Done,
     /* 168537 */   // Label 2600: @168537
     /* 168537 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(168556), // Rule ID 560 //
     /* 168542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 168545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 168549 */     // (fabs:{ *:[f64] } f64:{ *:[f64] }:$RA)  =>  (EFDABS:{ *:[f64] } f64:{ *:[f64] }:$RA)
     /* 168549 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDABS),
     /* 168554 */     GIR_RootConstrainSelectedInstOperands,
     /* 168555 */     // GIR_Coverage, 560,
     /* 168555 */     GIR_Done,
     /* 168556 */   // Label 2601: @168556
     /* 168556 */   GIM_Reject,
     /* 168557 */ // Label 2598: @168557
     /* 168557 */ GIM_Reject,
     /* 168558 */ // Label 2590: @168558
     /* 168558 */ GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(168580), // Rule ID 984 //
     /* 168563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168573 */   // (fabs:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSABSQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 168573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSABSQP),
     /* 168578 */   GIR_RootConstrainSelectedInstOperands,
     /* 168579 */   // GIR_Coverage, 984,
     /* 168579 */   GIR_Done,
     /* 168580 */ // Label 2602: @168580
     /* 168580 */ GIM_Reject,
     /* 168581 */ // Label 2591: @168581
     /* 168581 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(168607), // Rule ID 848 //
     /* 168586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168596 */   // (fabs:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVABSDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 168596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSDP),
     /* 168601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168605 */   GIR_RootConstrainSelectedInstOperands,
     /* 168606 */   // GIR_Coverage, 848,
     /* 168606 */   GIR_Done,
     /* 168607 */ // Label 2603: @168607
     /* 168607 */ GIM_Reject,
     /* 168608 */ // Label 2592: @168608
     /* 168608 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(168634), // Rule ID 849 //
     /* 168613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168623 */   // (fabs:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVABSSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 168623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVABSSP),
     /* 168628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168632 */   GIR_RootConstrainSelectedInstOperands,
     /* 168633 */   // GIR_Coverage, 849,
     /* 168633 */   GIR_Done,
     /* 168634 */ // Label 2604: @168634
     /* 168634 */ GIM_Reject,
     /* 168635 */ // Label 2593: @168635
     /* 168635 */ GIM_Reject,
     /* 168636 */ // Label 53: @168636
     /* 168636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2610*/ GIMT_Encode4(168951),
     /* 168647 */ /*GILLT_s32*//*Label 2605*/ GIMT_Encode4(168667),
     /* 168651 */ /*GILLT_s64*//*Label 2606*/ GIMT_Encode4(168751),
     /* 168655 */ /*GILLT_s128*//*Label 2607*/ GIMT_Encode4(168861),
     /* 168659 */ /*GILLT_v2s64*//*Label 2608*/ GIMT_Encode4(168891),
     /* 168663 */ /*GILLT_v4s32*//*Label 2609*/ GIMT_Encode4(168921),
     /* 168667 */ // Label 2605: @168667
     /* 168667 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(168750),
     /* 168672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 168675 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(168701), // Rule ID 169 //
     /* 168680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168690 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$RB, f32:{ *:[f32] }:$RA)  =>  (FCPSGNS:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 168690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168695 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168697 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168699 */     GIR_RootConstrainSelectedInstOperands,
     /* 168700 */     // GIR_Coverage, 169,
     /* 168700 */     GIR_EraseRootFromParent_Done,
     /* 168701 */   // Label 2612: @168701
     /* 168701 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(168749), // Rule ID 1281 //
     /* 168706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168716 */     // (fcopysign:{ *:[f32] } f32:{ *:[f32] }:$frB, f64:{ *:[f64] }:$frA)  =>  (FCPSGNS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } ?:{ *:[f64] }:$frA, F4RC:{ *:[i32] }), ?:{ *:[f32] }:$frB)
     /* 168716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 168719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F4RCRegClassID),
     /* 168737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGNS),
     /* 168740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168745 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168747 */     GIR_RootConstrainSelectedInstOperands,
     /* 168748 */     // GIR_Coverage, 1281,
     /* 168748 */     GIR_EraseRootFromParent_Done,
     /* 168749 */   // Label 2613: @168749
     /* 168749 */   GIM_Reject,
     /* 168750 */ // Label 2611: @168750
     /* 168750 */ GIM_Reject,
     /* 168751 */ // Label 2606: @168751
     /* 168751 */ GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(168860),
     /* 168756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 168759 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(168785), // Rule ID 847 //
     /* 168764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 168774 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XA)  =>  (XSCPSGNDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 168774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNDP),
     /* 168777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168779 */     GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168781 */     GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168783 */     GIR_RootConstrainSelectedInstOperands,
     /* 168784 */     // GIR_Coverage, 847,
     /* 168784 */     GIR_EraseRootFromParent_Done,
     /* 168785 */   // Label 2615: @168785
     /* 168785 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(168811), // Rule ID 170 //
     /* 168790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168800 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$RB, f64:{ *:[f64] }:$RA)  =>  (FCPSGND:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 168800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168805 */     GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168807 */     GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168809 */     GIR_RootConstrainSelectedInstOperands,
     /* 168810 */     // GIR_Coverage, 170,
     /* 168810 */     GIR_EraseRootFromParent_Done,
     /* 168811 */   // Label 2616: @168811
     /* 168811 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(168859), // Rule ID 1280 //
     /* 168816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 168819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168826 */     // (fcopysign:{ *:[f64] } f64:{ *:[f64] }:$frB, f32:{ *:[f32] }:$frA)  =>  (FCPSGND:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$frA, F8RC:{ *:[i32] }), ?:{ *:[f64] }:$frB)
     /* 168826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168838 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // frA
     /* 168842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::F8RCRegClassID),
     /* 168847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FCPSGND),
     /* 168850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168855 */     GIR_RootToRootCopy, /*OpIdx*/1, // frB
     /* 168857 */     GIR_RootConstrainSelectedInstOperands,
     /* 168858 */     // GIR_Coverage, 1280,
     /* 168858 */     GIR_EraseRootFromParent_Done,
     /* 168859 */   // Label 2617: @168859
     /* 168859 */   GIM_Reject,
     /* 168860 */ // Label 2614: @168860
     /* 168860 */ GIM_Reject,
     /* 168861 */ // Label 2607: @168861
     /* 168861 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(168890), // Rule ID 983 //
     /* 168866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 168869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 168872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 168875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 168879 */   // (fcopysign:{ *:[f128] } f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RA)  =>  (XSCPSGNQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 168879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSCPSGNQP),
     /* 168882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 168884 */   GIR_RootToRootCopy, /*OpIdx*/2, // RA
     /* 168886 */   GIR_RootToRootCopy, /*OpIdx*/1, // RB
     /* 168888 */   GIR_RootConstrainSelectedInstOperands,
     /* 168889 */   // GIR_Coverage, 983,
     /* 168889 */   GIR_EraseRootFromParent_Done,
     /* 168890 */ // Label 2618: @168890
     /* 168890 */ GIM_Reject,
     /* 168891 */ // Label 2608: @168891
     /* 168891 */ GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(168920), // Rule ID 850 //
     /* 168896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168909 */   // (fcopysign:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XA)  =>  (XVCPSGNDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 168909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNDP),
     /* 168912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168914 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168916 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168918 */   GIR_RootConstrainSelectedInstOperands,
     /* 168919 */   // GIR_Coverage, 850,
     /* 168919 */   GIR_EraseRootFromParent_Done,
     /* 168920 */ // Label 2619: @168920
     /* 168920 */ GIM_Reject,
     /* 168921 */ // Label 2609: @168921
     /* 168921 */ GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(168950), // Rule ID 851 //
     /* 168926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 168932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168939 */   // (fcopysign:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XA)  =>  (XVCPSGNSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 168939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVCPSGNSP),
     /* 168942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 168944 */   GIR_RootToRootCopy, /*OpIdx*/2, // XA
     /* 168946 */   GIR_RootToRootCopy, /*OpIdx*/1, // XB
     /* 168948 */   GIR_RootConstrainSelectedInstOperands,
     /* 168949 */   // GIR_Coverage, 851,
     /* 168949 */   GIR_EraseRootFromParent_Done,
     /* 168950 */ // Label 2620: @168950
     /* 168950 */ GIM_Reject,
     /* 168951 */ // Label 2610: @168951
     /* 168951 */ GIM_Reject,
     /* 168952 */ // Label 54: @168952
     /* 168952 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2623*/ GIMT_Encode4(169031),
     /* 168963 */ /*GILLT_v2s64*//*Label 2621*/ GIMT_Encode4(168971),
     /* 168967 */ /*GILLT_v4s32*//*Label 2622*/ GIMT_Encode4(169001),
     /* 168971 */ // Label 2621: @168971
     /* 168971 */ GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(169000), // Rule ID 1683 //
     /* 168976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 168979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 168982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 168989 */   // (fminnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMINDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 168989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINDP),
     /* 168994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 168998 */   GIR_RootConstrainSelectedInstOperands,
     /* 168999 */   // GIR_Coverage, 1683,
     /* 168999 */   GIR_Done,
     /* 169000 */ // Label 2624: @169000
     /* 169000 */ GIM_Reject,
     /* 169001 */ // Label 2622: @169001
     /* 169001 */ GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(169030), // Rule ID 1679 //
     /* 169006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169019 */   // (fminnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMINSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 169019 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMINSP),
     /* 169024 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169028 */   GIR_RootConstrainSelectedInstOperands,
     /* 169029 */   // GIR_Coverage, 1679,
     /* 169029 */   GIR_Done,
     /* 169030 */ // Label 2625: @169030
     /* 169030 */ GIM_Reject,
     /* 169031 */ // Label 2623: @169031
     /* 169031 */ GIM_Reject,
     /* 169032 */ // Label 55: @169032
     /* 169032 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(6), /*)*//*default:*//*Label 2628*/ GIMT_Encode4(169111),
     /* 169043 */ /*GILLT_v2s64*//*Label 2626*/ GIMT_Encode4(169051),
     /* 169047 */ /*GILLT_v4s32*//*Label 2627*/ GIMT_Encode4(169081),
     /* 169051 */ // Label 2626: @169051
     /* 169051 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(169080), // Rule ID 1681 //
     /* 169056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 169062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169069 */   // (fmaxnum:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$src1, v2f64:{ *:[v2f64] }:$src2)  =>  (XVMAXDP:{ *:[v2f64] } ?:{ *:[v2f64] }:$src1, ?:{ *:[v2f64] }:$src2)
     /* 169069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXDP),
     /* 169074 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169078 */   GIR_RootConstrainSelectedInstOperands,
     /* 169079 */   // GIR_Coverage, 1681,
     /* 169079 */   GIR_Done,
     /* 169080 */ // Label 2629: @169080
     /* 169080 */ GIM_Reject,
     /* 169081 */ // Label 2627: @169081
     /* 169081 */ GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(169110), // Rule ID 1677 //
     /* 169086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 169092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 169099 */   // (fmaxnum:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$src1, v4f32:{ *:[v4f32] }:$src2)  =>  (XVMAXSP:{ *:[v4f32] } ?:{ *:[v4f32] }:$src1, ?:{ *:[v4f32] }:$src2)
     /* 169099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMAXSP),
     /* 169104 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169108 */   GIR_RootConstrainSelectedInstOperands,
     /* 169109 */   // GIR_Coverage, 1677,
     /* 169109 */   GIR_Done,
     /* 169110 */ // Label 2630: @169110
     /* 169110 */ GIM_Reject,
     /* 169111 */ // Label 2628: @169111
     /* 169111 */ GIM_Reject,
     /* 169112 */ // Label 56: @169112
     /* 169112 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2633*/ GIMT_Encode4(169693),
     /* 169123 */ /*GILLT_s32*//*Label 2631*/ GIMT_Encode4(169131),
     /* 169127 */ /*GILLT_s64*//*Label 2632*/ GIMT_Encode4(169538),
     /* 169131 */ // Label 2631: @169131
     /* 169131 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(169537),
     /* 169136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169146 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(169256), // Rule ID 1689 //
     /* 169151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 169178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169180 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169180 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169183 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169187 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169192 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169196 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169201 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169204 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169208 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169234 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169237 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169255 */     // GIR_Coverage, 1689,
     /* 169255 */     GIR_EraseRootFromParent_Done,
     /* 169256 */   // Label 2635: @169256
     /* 169256 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(169354), // Rule ID 1687 //
     /* 169261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169278 */     // (fminnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169278 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169281 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169285 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169290 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169294 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169299 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169302 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169306 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169311 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169335 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169353 */     // GIR_Coverage, 1687,
     /* 169353 */     GIR_EraseRootFromParent_Done,
     /* 169354 */   // Label 2636: @169354
     /* 169354 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(169452), // Rule ID 1688 //
     /* 169359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169376 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169376 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169379 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169383 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169388 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169392 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169397 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169400 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169404 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169409 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169433 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169451 */     // GIR_Coverage, 1688,
     /* 169451 */     GIR_EraseRootFromParent_Done,
     /* 169452 */   // Label 2637: @169452
     /* 169452 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(169536), // Rule ID 1686 //
     /* 169457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169460 */     // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMINDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169460 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169463 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169467 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169472 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169476 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169481 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169484 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169488 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169497 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169514 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169517 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169535 */     // GIR_Coverage, 1686,
     /* 169535 */     GIR_EraseRootFromParent_Done,
     /* 169536 */   // Label 2638: @169536
     /* 169536 */   GIM_Reject,
     /* 169537 */ // Label 2634: @169537
     /* 169537 */ GIM_Reject,
     /* 169538 */ // Label 2632: @169538
     /* 169538 */ GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(169692),
     /* 169543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 169546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 169549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169553 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(169602), // Rule ID 1697 //
     /* 169558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 169585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169587 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169600 */     GIR_RootConstrainSelectedInstOperands,
     /* 169601 */     // GIR_Coverage, 1697,
     /* 169601 */     GIR_EraseRootFromParent_Done,
     /* 169602 */   // Label 2640: @169602
     /* 169602 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(169637), // Rule ID 1695 //
     /* 169607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169624 */     // (fminnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169633 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 169635 */     GIR_RootConstrainSelectedInstOperands,
     /* 169636 */     // GIR_Coverage, 1695,
     /* 169636 */     GIR_EraseRootFromParent_Done,
     /* 169637 */   // Label 2641: @169637
     /* 169637 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(169672), // Rule ID 1696 //
     /* 169642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 169657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169659 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 169664 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 169666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169670 */     GIR_RootConstrainSelectedInstOperands,
     /* 169671 */     // GIR_Coverage, 1696,
     /* 169671 */     GIR_EraseRootFromParent_Done,
     /* 169672 */   // Label 2642: @169672
     /* 169672 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(169691), // Rule ID 1694 //
     /* 169677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169680 */     // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMINDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 169680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMINDP),
     /* 169685 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 169689 */     GIR_RootConstrainSelectedInstOperands,
     /* 169690 */     // GIR_Coverage, 1694,
     /* 169690 */     GIR_Done,
     /* 169691 */   // Label 2643: @169691
     /* 169691 */   GIM_Reject,
     /* 169692 */ // Label 2639: @169692
     /* 169692 */ GIM_Reject,
     /* 169693 */ // Label 2633: @169693
     /* 169693 */ GIM_Reject,
     /* 169694 */ // Label 57: @169694
     /* 169694 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2646*/ GIMT_Encode4(170275),
     /* 169705 */ /*GILLT_s32*//*Label 2644*/ GIMT_Encode4(169713),
     /* 169709 */ /*GILLT_s64*//*Label 2645*/ GIMT_Encode4(170120),
     /* 169713 */ // Label 2644: @169713
     /* 169713 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(170119),
     /* 169718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 169721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 169724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169728 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(169838), // Rule ID 1693 //
     /* 169733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169744 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 169752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 169760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 169762 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169762 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169765 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169769 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169774 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 169778 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169837 */     // GIR_Coverage, 1693,
     /* 169837 */     GIR_EraseRootFromParent_Done,
     /* 169838 */   // Label 2648: @169838
     /* 169838 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(169936), // Rule ID 1691 //
     /* 169843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 169850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169860 */     // (fmaxnum_ieee:{ *:[f32] } (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$A), f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169860 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169863 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169867 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169872 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 169876 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169881 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169884 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169888 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 169897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 169905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 169909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169914 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169917 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 169922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169927 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 169930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 169935 */     // GIR_Coverage, 1691,
     /* 169935 */     GIR_EraseRootFromParent_Done,
     /* 169936 */   // Label 2649: @169936
     /* 169936 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(170034), // Rule ID 1692 //
     /* 169941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 169944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 169948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 169952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 169956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 169958 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$B))  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 169958 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169961 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169965 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169970 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 169974 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 169979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 169982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169991 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 169995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170012 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170015 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 170033 */     // GIR_Coverage, 1692,
     /* 170033 */     GIR_EraseRootFromParent_Done,
     /* 170034 */   // Label 2650: @170034
     /* 170034 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(170118), // Rule ID 1690 //
     /* 170039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170042 */     // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$A, f32:{ *:[f32] }:$B)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSMAXDP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$A, VSFRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$B, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 170042 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170045 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170049 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170054 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // B
     /* 170058 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170063 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 170066 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170070 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170075 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 170079 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 170087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170096 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170099 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 170104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170112 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 170117 */     // GIR_Coverage, 1690,
     /* 170117 */     GIR_EraseRootFromParent_Done,
     /* 170118 */   // Label 2651: @170118
     /* 170118 */   GIM_Reject,
     /* 170119 */ // Label 2647: @170119
     /* 170119 */ GIM_Reject,
     /* 170120 */ // Label 2645: @170120
     /* 170120 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(170274),
     /* 170125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 170128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 170131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 170135 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(170184), // Rule ID 1701 //
     /* 170140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 170159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 170167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 170169 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 170174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 170178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // B
     /* 170182 */     GIR_RootConstrainSelectedInstOperands,
     /* 170183 */     // GIR_Coverage, 1701,
     /* 170183 */     GIR_EraseRootFromParent_Done,
     /* 170184 */   // Label 2653: @170184
     /* 170184 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(170219), // Rule ID 1699 //
     /* 170189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 170196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170206 */     // (fmaxnum_ieee:{ *:[f64] } (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$A), f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 170211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // A
     /* 170215 */     GIR_RootToRootCopy, /*OpIdx*/2, // B
     /* 170217 */     GIR_RootConstrainSelectedInstOperands,
     /* 170218 */     // GIR_Coverage, 1699,
     /* 170218 */     GIR_EraseRootFromParent_Done,
     /* 170219 */   // Label 2654: @170219
     /* 170219 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(170254), // Rule ID 1700 //
     /* 170224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 170231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCANONICALIZE),
     /* 170235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 170239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 170241 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$B))  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 170246 */     GIR_RootToRootCopy, /*OpIdx*/1, // A
     /* 170248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // B
     /* 170252 */     GIR_RootConstrainSelectedInstOperands,
     /* 170253 */     // GIR_Coverage, 1700,
     /* 170253 */     GIR_EraseRootFromParent_Done,
     /* 170254 */   // Label 2655: @170254
     /* 170254 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(170273), // Rule ID 1698 //
     /* 170259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 170262 */     // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$A, f64:{ *:[f64] }:$B)  =>  (XSMAXDP:{ *:[f64] } ?:{ *:[f64] }:$A, ?:{ *:[f64] }:$B)
     /* 170262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMAXDP),
     /* 170267 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 170271 */     GIR_RootConstrainSelectedInstOperands,
     /* 170272 */     // GIR_Coverage, 1698,
     /* 170272 */     GIR_Done,
     /* 170273 */   // Label 2656: @170273
     /* 170273 */   GIM_Reject,
     /* 170274 */ // Label 2652: @170274
     /* 170274 */ GIM_Reject,
     /* 170275 */ // Label 2646: @170275
     /* 170275 */ GIM_Reject,
     /* 170276 */ // Label 58: @170276
     /* 170276 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2661*/ GIMT_Encode4(170455),
     /* 170287 */ /*GILLT_v2s64*//*Label 2657*/ GIMT_Encode4(170303),
     /* 170291 */ /*GILLT_v4s32*//*Label 2658*/ GIMT_Encode4(170377),
     /* 170295 */ /*GILLT_v8s16*//*Label 2659*/ GIMT_Encode4(170403),
     /* 170299 */ /*GILLT_v16s8*//*Label 2660*/ GIMT_Encode4(170429),
     /* 170303 */ // Label 2657: @170303
     /* 170303 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(170376), // Rule ID 1933 //
     /* 170308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170321 */   // (smin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170321 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170324 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170328 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170333 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170337 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170358 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINSD),
     /* 170366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170374 */   GIR_RootConstrainSelectedInstOperands,
     /* 170375 */   // GIR_Coverage, 1933,
     /* 170375 */   GIR_EraseRootFromParent_Done,
     /* 170376 */ // Label 2662: @170376
     /* 170376 */ GIM_Reject,
     /* 170377 */ // Label 2658: @170377
     /* 170377 */ GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(170402), // Rule ID 1362 //
     /* 170382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170395 */   // (smin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSW),
     /* 170400 */   GIR_RootConstrainSelectedInstOperands,
     /* 170401 */   // GIR_Coverage, 1362,
     /* 170401 */   GIR_Done,
     /* 170402 */ // Label 2663: @170402
     /* 170402 */ GIM_Reject,
     /* 170403 */ // Label 2659: @170403
     /* 170403 */ GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(170428), // Rule ID 1360 //
     /* 170408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170421 */   // (smin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170421 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSH),
     /* 170426 */   GIR_RootConstrainSelectedInstOperands,
     /* 170427 */   // GIR_Coverage, 1360,
     /* 170427 */   GIR_Done,
     /* 170428 */ // Label 2664: @170428
     /* 170428 */ GIM_Reject,
     /* 170429 */ // Label 2660: @170429
     /* 170429 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(170454), // Rule ID 1358 //
     /* 170434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170447 */   // (smin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINSB),
     /* 170452 */   GIR_RootConstrainSelectedInstOperands,
     /* 170453 */   // GIR_Coverage, 1358,
     /* 170453 */   GIR_Done,
     /* 170454 */ // Label 2665: @170454
     /* 170454 */ GIM_Reject,
     /* 170455 */ // Label 2661: @170455
     /* 170455 */ GIM_Reject,
     /* 170456 */ // Label 59: @170456
     /* 170456 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2670*/ GIMT_Encode4(170635),
     /* 170467 */ /*GILLT_v2s64*//*Label 2666*/ GIMT_Encode4(170483),
     /* 170471 */ /*GILLT_v4s32*//*Label 2667*/ GIMT_Encode4(170557),
     /* 170475 */ /*GILLT_v8s16*//*Label 2668*/ GIMT_Encode4(170583),
     /* 170479 */ /*GILLT_v16s8*//*Label 2669*/ GIMT_Encode4(170609),
     /* 170483 */ // Label 2666: @170483
     /* 170483 */ GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(170556), // Rule ID 1931 //
     /* 170488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170501 */   // (smax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXSD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170501 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170504 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170508 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170513 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170517 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170534 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170538 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXSD),
     /* 170546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170548 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170551 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170554 */   GIR_RootConstrainSelectedInstOperands,
     /* 170555 */   // GIR_Coverage, 1931,
     /* 170555 */   GIR_EraseRootFromParent_Done,
     /* 170556 */ // Label 2671: @170556
     /* 170556 */ GIM_Reject,
     /* 170557 */ // Label 2667: @170557
     /* 170557 */ GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(170582), // Rule ID 1356 //
     /* 170562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170575 */   // (smax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXSW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSW),
     /* 170580 */   GIR_RootConstrainSelectedInstOperands,
     /* 170581 */   // GIR_Coverage, 1356,
     /* 170581 */   GIR_Done,
     /* 170582 */ // Label 2672: @170582
     /* 170582 */ GIM_Reject,
     /* 170583 */ // Label 2668: @170583
     /* 170583 */ GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(170608), // Rule ID 1354 //
     /* 170588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170601 */   // (smax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXSH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSH),
     /* 170606 */   GIR_RootConstrainSelectedInstOperands,
     /* 170607 */   // GIR_Coverage, 1354,
     /* 170607 */   GIR_Done,
     /* 170608 */ // Label 2673: @170608
     /* 170608 */ GIM_Reject,
     /* 170609 */ // Label 2669: @170609
     /* 170609 */ GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(170634), // Rule ID 1352 //
     /* 170614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170627 */   // (smax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXSB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXSB),
     /* 170632 */   GIR_RootConstrainSelectedInstOperands,
     /* 170633 */   // GIR_Coverage, 1352,
     /* 170633 */   GIR_Done,
     /* 170634 */ // Label 2674: @170634
     /* 170634 */ GIM_Reject,
     /* 170635 */ // Label 2670: @170635
     /* 170635 */ GIM_Reject,
     /* 170636 */ // Label 60: @170636
     /* 170636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2679*/ GIMT_Encode4(170815),
     /* 170647 */ /*GILLT_v2s64*//*Label 2675*/ GIMT_Encode4(170663),
     /* 170651 */ /*GILLT_v4s32*//*Label 2676*/ GIMT_Encode4(170737),
     /* 170655 */ /*GILLT_v8s16*//*Label 2677*/ GIMT_Encode4(170763),
     /* 170659 */ /*GILLT_v16s8*//*Label 2678*/ GIMT_Encode4(170789),
     /* 170663 */ // Label 2675: @170663
     /* 170663 */ GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(170736), // Rule ID 1934 //
     /* 170668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170681 */   // (umin:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMINUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170681 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170684 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170688 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170693 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170697 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170714 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170718 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMINUD),
     /* 170726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170734 */   GIR_RootConstrainSelectedInstOperands,
     /* 170735 */   // GIR_Coverage, 1934,
     /* 170735 */   GIR_EraseRootFromParent_Done,
     /* 170736 */ // Label 2680: @170736
     /* 170736 */ GIM_Reject,
     /* 170737 */ // Label 2676: @170737
     /* 170737 */ GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(170762), // Rule ID 1361 //
     /* 170742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170755 */   // (umin:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMINUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUW),
     /* 170760 */   GIR_RootConstrainSelectedInstOperands,
     /* 170761 */   // GIR_Coverage, 1361,
     /* 170761 */   GIR_Done,
     /* 170762 */ // Label 2681: @170762
     /* 170762 */ GIM_Reject,
     /* 170763 */ // Label 2677: @170763
     /* 170763 */ GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(170788), // Rule ID 1359 //
     /* 170768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170781 */   // (umin:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMINUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUH),
     /* 170786 */   GIR_RootConstrainSelectedInstOperands,
     /* 170787 */   // GIR_Coverage, 1359,
     /* 170787 */   GIR_Done,
     /* 170788 */ // Label 2682: @170788
     /* 170788 */ GIM_Reject,
     /* 170789 */ // Label 2678: @170789
     /* 170789 */ GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(170814), // Rule ID 1357 //
     /* 170794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170807 */   // (umin:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMINUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMINUB),
     /* 170812 */   GIR_RootConstrainSelectedInstOperands,
     /* 170813 */   // GIR_Coverage, 1357,
     /* 170813 */   GIR_Done,
     /* 170814 */ // Label 2683: @170814
     /* 170814 */ GIM_Reject,
     /* 170815 */ // Label 2679: @170815
     /* 170815 */ GIM_Reject,
     /* 170816 */ // Label 61: @170816
     /* 170816 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(8), /*)*//*default:*//*Label 2688*/ GIMT_Encode4(170995),
     /* 170827 */ /*GILLT_v2s64*//*Label 2684*/ GIMT_Encode4(170843),
     /* 170831 */ /*GILLT_v4s32*//*Label 2685*/ GIMT_Encode4(170917),
     /* 170835 */ /*GILLT_v8s16*//*Label 2686*/ GIMT_Encode4(170943),
     /* 170839 */ /*GILLT_v16s8*//*Label 2687*/ GIMT_Encode4(170969),
     /* 170843 */ // Label 2684: @170843
     /* 170843 */ GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(170916), // Rule ID 1932 //
     /* 170848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 170851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 170854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170861 */   // (umax:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src1, v2i64:{ *:[v2i64] }:$src2)  =>  (VMAXUD:{ *:[v2i64] } (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src1, VRRC:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[f128] } ?:{ *:[v2i64] }:$src2, VRRC:{ *:[i32] }))
     /* 170861 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 170864 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170868 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170873 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // src2
     /* 170877 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 170885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170894 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src1
     /* 170898 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VMAXUD),
     /* 170906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 170908 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 170911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 170914 */   GIR_RootConstrainSelectedInstOperands,
     /* 170915 */   // GIR_Coverage, 1932,
     /* 170915 */   GIR_EraseRootFromParent_Done,
     /* 170916 */ // Label 2689: @170916
     /* 170916 */ GIM_Reject,
     /* 170917 */ // Label 2685: @170917
     /* 170917 */ GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(170942), // Rule ID 1355 //
     /* 170922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 170928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170935 */   // (umax:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src1, v4i32:{ *:[v4i32] }:$src2)  =>  (VMAXUW:{ *:[v4i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 170935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUW),
     /* 170940 */   GIR_RootConstrainSelectedInstOperands,
     /* 170941 */   // GIR_Coverage, 1355,
     /* 170941 */   GIR_Done,
     /* 170942 */ // Label 2690: @170942
     /* 170942 */ GIM_Reject,
     /* 170943 */ // Label 2686: @170943
     /* 170943 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(170968), // Rule ID 1353 //
     /* 170948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 170954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170961 */   // (umax:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src1, v8i16:{ *:[v8i16] }:$src2)  =>  (VMAXUH:{ *:[v8i16] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 170961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUH),
     /* 170966 */   GIR_RootConstrainSelectedInstOperands,
     /* 170967 */   // GIR_Coverage, 1353,
     /* 170967 */   GIR_Done,
     /* 170968 */ // Label 2691: @170968
     /* 170968 */ GIM_Reject,
     /* 170969 */ // Label 2687: @170969
     /* 170969 */ GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(170994), // Rule ID 1351 //
     /* 170974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 170977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 170980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 170987 */   // (umax:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src1, v16i8:{ *:[v16i8] }:$src2)  =>  (VMAXUB:{ *:[v16i8] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 170987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VMAXUB),
     /* 170992 */   GIR_RootConstrainSelectedInstOperands,
     /* 170993 */   // GIR_Coverage, 1351,
     /* 170993 */   GIR_Done,
     /* 170994 */ // Label 2692: @170994
     /* 170994 */ GIM_Reject,
     /* 170995 */ // Label 2688: @170995
     /* 170995 */ GIM_Reject,
     /* 170996 */ // Label 62: @170996
     /* 170996 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2695*/ GIMT_Encode4(171297),
     /* 171007 */ /*GILLT_s32*//*Label 2693*/ GIMT_Encode4(171015),
     /* 171011 */ /*GILLT_s64*//*Label 2694*/ GIMT_Encode4(171156),
     /* 171015 */ // Label 2693: @171015
     /* 171015 */ GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(171075), // Rule ID 2039 //
     /* 171020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171030 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171030 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171033 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171037 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171042 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171048 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171051 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 171055 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171060 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 171068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171073 */   GIR_RootConstrainSelectedInstOperands,
     /* 171074 */   // GIR_Coverage, 2039,
     /* 171074 */   GIR_EraseRootFromParent_Done,
     /* 171075 */ // Label 2696: @171075
     /* 171075 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(171155), // Rule ID 2040 //
     /* 171080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171090 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$S)  =>  (MFVSRWZ:{ *:[i32] } (FCTIW:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171090 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171093 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171097 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171102 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171106 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171111 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171114 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171118 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171123 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTIW),
     /* 171135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRWZ),
     /* 171148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171153 */   GIR_RootConstrainSelectedInstOperands,
     /* 171154 */   // GIR_Coverage, 2040,
     /* 171154 */   GIR_EraseRootFromParent_Done,
     /* 171155 */ // Label 2697: @171155
     /* 171155 */ GIM_Reject,
     /* 171156 */ // Label 2694: @171156
     /* 171156 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(171216), // Rule ID 2037 //
     /* 171161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171171 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171183 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171201 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171214 */   GIR_RootConstrainSelectedInstOperands,
     /* 171215 */   // GIR_Coverage, 2037,
     /* 171215 */   GIR_EraseRootFromParent_Done,
     /* 171216 */ // Label 2698: @171216
     /* 171216 */ GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(171296), // Rule ID 2038 //
     /* 171221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171231 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171231 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171234 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171238 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171243 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171247 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171252 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171255 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171259 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171264 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171281 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171289 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171294 */   GIR_RootConstrainSelectedInstOperands,
     /* 171295 */   // GIR_Coverage, 2038,
     /* 171295 */   GIR_EraseRootFromParent_Done,
     /* 171296 */ // Label 2699: @171296
     /* 171296 */ GIM_Reject,
     /* 171297 */ // Label 2695: @171297
     /* 171297 */ GIM_Reject,
     /* 171298 */ // Label 63: @171298
     /* 171298 */ GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(171462),
     /* 171303 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 171306 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2703*/ GIMT_Encode4(171461),
     /* 171317 */   /*GILLT_s32*//*Label 2701*/ GIMT_Encode4(171325),
     /* 171321 */   /*GILLT_s64*//*Label 2702*/ GIMT_Encode4(171403),
     /* 171325 */   // Label 2701: @171325
     /* 171325 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(171402), // Rule ID 2042 //
     /* 171330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171337 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] }))))
     /* 171337 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171340 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171344 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171349 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171353 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 171358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171370 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 171373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171387 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171400 */     GIR_RootConstrainSelectedInstOperands,
     /* 171401 */     // GIR_Coverage, 2042,
     /* 171401 */     GIR_EraseRootFromParent_Done,
     /* 171402 */   // Label 2704: @171402
     /* 171402 */   GIM_Reject,
     /* 171403 */   // Label 2702: @171403
     /* 171403 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(171460), // Rule ID 2041 //
     /* 171408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDirectMove_HasVSX),
     /* 171411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171415 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$S)  =>  (MFVSRD:{ *:[i64] } (FCTID:{ *:[f64] } (XSRDPI:{ *:[f64] } ?:{ *:[f64] }:$S)))
     /* 171415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 171418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::XSRDPI),
     /* 171422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 171431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 171436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::FCTID),
     /* 171440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171445 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::MFVSRD),
     /* 171453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 171455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171458 */     GIR_RootConstrainSelectedInstOperands,
     /* 171459 */     // GIR_Coverage, 2041,
     /* 171459 */     GIR_EraseRootFromParent_Done,
     /* 171460 */   // Label 2705: @171460
     /* 171460 */   GIM_Reject,
     /* 171461 */   // Label 2703: @171461
     /* 171461 */   GIM_Reject,
     /* 171462 */ // Label 2700: @171462
     /* 171462 */ GIM_Reject,
     /* 171463 */ // Label 64: @171463
     /* 171463 */ GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(171478), // Rule ID 15 //
     /* 171468 */   // MIs[0] LI
     /* 171468 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 171471 */   // (br (bb:{ *:[Other] }):$LI)  =>  (B (bb:{ *:[Other] }):$LI)
     /* 171471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::B),
     /* 171476 */   GIR_RootConstrainSelectedInstOperands,
     /* 171477 */   // GIR_Coverage, 15,
     /* 171477 */   GIR_Done,
     /* 171478 */ // Label 2706: @171478
     /* 171478 */ GIM_Reject,
     /* 171479 */ // Label 65: @171479
     /* 171479 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(8), /*)*//*default:*//*Label 2709*/ GIMT_Encode4(171596),
     /* 171490 */ /*GILLT_v8s16*//*Label 2707*/ GIMT_Encode4(171498),
     /* 171494 */ /*GILLT_v16s8*//*Label 2708*/ GIMT_Encode4(171561),
     /* 171498 */ // Label 2707: @171498
     /* 171498 */ GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(171560), // Rule ID 3494 //
     /* 171503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171519 */   // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSHLX:{ *:[v8i16] } ?:{ *:[v8i16] }:$vDi, (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$rB, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), ?:{ *:[i32] }:$rA)
     /* 171519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 171522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 171526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rB
     /* 171535 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 171538 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 171541 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/30,
     /* 171544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 171546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSHLX),
     /* 171549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171551 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 171556 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171558 */   GIR_RootConstrainSelectedInstOperands,
     /* 171559 */   // GIR_Coverage, 3494,
     /* 171559 */   GIR_EraseRootFromParent_Done,
     /* 171560 */ // Label 2710: @171560
     /* 171560 */ GIM_Reject,
     /* 171561 */ // Label 2708: @171561
     /* 171561 */ GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(171595), // Rule ID 3493 //
     /* 171566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX_IsBigEndian_IsISA3_1_IsPPC32),
     /* 171569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 171575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 171578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171582 */   // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$vDi, i32:{ *:[i32] }:$rA, i32:{ *:[i32] }:$rB)  =>  (VINSBLX:{ *:[v16i8] } ?:{ *:[v16i8] }:$vDi, ?:{ *:[i32] }:$rB, ?:{ *:[i32] }:$rA)
     /* 171582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::VINSBLX),
     /* 171585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VD]
     /* 171587 */   GIR_RootToRootCopy, /*OpIdx*/1, // vDi
     /* 171589 */   GIR_RootToRootCopy, /*OpIdx*/3, // rB
     /* 171591 */   GIR_RootToRootCopy, /*OpIdx*/2, // rA
     /* 171593 */   GIR_RootConstrainSelectedInstOperands,
     /* 171594 */   // GIR_Coverage, 3493,
     /* 171594 */   GIR_EraseRootFromParent_Done,
     /* 171595 */ // Label 2711: @171595
     /* 171595 */ GIM_Reject,
     /* 171596 */ // Label 2709: @171596
     /* 171596 */ GIM_Reject,
     /* 171597 */ // Label 66: @171597
     /* 171597 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2718*/ GIMT_Encode4(171774),
     /* 171608 */ /*GILLT_s32*//*Label 2712*/ GIMT_Encode4(171636),
     /* 171612 */ /*GILLT_s64*//*Label 2713*/ GIMT_Encode4(171659), GIMT_Encode4(0),
     /* 171620 */ /*GILLT_v2s64*//*Label 2714*/ GIMT_Encode4(171682),
     /* 171624 */ /*GILLT_v4s32*//*Label 2715*/ GIMT_Encode4(171705),
     /* 171628 */ /*GILLT_v8s16*//*Label 2716*/ GIMT_Encode4(171728),
     /* 171632 */ /*GILLT_v16s8*//*Label 2717*/ GIMT_Encode4(171751),
     /* 171636 */ // Label 2712: @171636
     /* 171636 */ GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(171658), // Rule ID 134 //
     /* 171641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171651 */   // (cttz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTTZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171651 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZW),
     /* 171656 */   GIR_RootConstrainSelectedInstOperands,
     /* 171657 */   // GIR_Coverage, 134,
     /* 171657 */   GIR_Done,
     /* 171658 */ // Label 2719: @171658
     /* 171658 */ GIM_Reject,
     /* 171659 */ // Label 2713: @171659
     /* 171659 */ GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(171681), // Rule ID 688 //
     /* 171664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_0),
     /* 171667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171674 */   // (cttz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTTZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTTZD),
     /* 171679 */   GIR_RootConstrainSelectedInstOperands,
     /* 171680 */   // GIR_Coverage, 688,
     /* 171680 */   GIR_Done,
     /* 171681 */ // Label 2720: @171681
     /* 171681 */ GIM_Reject,
     /* 171682 */ // Label 2714: @171682
     /* 171682 */ GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(171704), // Rule ID 535 //
     /* 171687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171697 */   // (cttz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCTZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZD),
     /* 171702 */   GIR_RootConstrainSelectedInstOperands,
     /* 171703 */   // GIR_Coverage, 535,
     /* 171703 */   GIR_Done,
     /* 171704 */ // Label 2721: @171704
     /* 171704 */ GIM_Reject,
     /* 171705 */ // Label 2715: @171705
     /* 171705 */ GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(171727), // Rule ID 534 //
     /* 171710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171720 */   // (cttz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCTZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZW),
     /* 171725 */   GIR_RootConstrainSelectedInstOperands,
     /* 171726 */   // GIR_Coverage, 534,
     /* 171726 */   GIR_Done,
     /* 171727 */ // Label 2722: @171727
     /* 171727 */ GIM_Reject,
     /* 171728 */ // Label 2716: @171728
     /* 171728 */ GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(171750), // Rule ID 533 //
     /* 171733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171743 */   // (cttz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCTZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171743 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZH),
     /* 171748 */   GIR_RootConstrainSelectedInstOperands,
     /* 171749 */   // GIR_Coverage, 533,
     /* 171749 */   GIR_Done,
     /* 171750 */ // Label 2723: @171750
     /* 171750 */ GIM_Reject,
     /* 171751 */ // Label 2717: @171751
     /* 171751 */ GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(171773), // Rule ID 532 //
     /* 171756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Altivec),
     /* 171759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171766 */   // (cttz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCTZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCTZB),
     /* 171771 */   GIR_RootConstrainSelectedInstOperands,
     /* 171772 */   // GIR_Coverage, 532,
     /* 171772 */   GIR_Done,
     /* 171773 */ // Label 2724: @171773
     /* 171773 */ GIM_Reject,
     /* 171774 */ // Label 2718: @171774
     /* 171774 */ GIM_Reject,
     /* 171775 */ // Label 67: @171775
     /* 171775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2731*/ GIMT_Encode4(171946),
     /* 171786 */ /*GILLT_s32*//*Label 2725*/ GIMT_Encode4(171814),
     /* 171790 */ /*GILLT_s64*//*Label 2726*/ GIMT_Encode4(171834), GIMT_Encode4(0),
     /* 171798 */ /*GILLT_v2s64*//*Label 2727*/ GIMT_Encode4(171854),
     /* 171802 */ /*GILLT_v4s32*//*Label 2728*/ GIMT_Encode4(171877),
     /* 171806 */ /*GILLT_v8s16*//*Label 2729*/ GIMT_Encode4(171900),
     /* 171810 */ /*GILLT_v16s8*//*Label 2730*/ GIMT_Encode4(171923),
     /* 171814 */ // Label 2725: @171814
     /* 171814 */ GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(171833), // Rule ID 133 //
     /* 171819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171826 */   // (ctlz:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (CNTLZW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171826 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZW),
     /* 171831 */   GIR_RootConstrainSelectedInstOperands,
     /* 171832 */   // GIR_Coverage, 133,
     /* 171832 */   GIR_Done,
     /* 171833 */ // Label 2732: @171833
     /* 171833 */ GIM_Reject,
     /* 171834 */ // Label 2726: @171834
     /* 171834 */ GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(171853), // Rule ID 687 //
     /* 171839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 171842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 171846 */   // (ctlz:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (CNTLZD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 171846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::CNTLZD),
     /* 171851 */   GIR_RootConstrainSelectedInstOperands,
     /* 171852 */   // GIR_Coverage, 687,
     /* 171852 */   GIR_Done,
     /* 171853 */ // Label 2733: @171853
     /* 171853 */ GIM_Reject,
     /* 171854 */ // Label 2727: @171854
     /* 171854 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(171876), // Rule ID 482 //
     /* 171859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 171865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171869 */   // (ctlz:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VCLZD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 171869 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZD),
     /* 171874 */   GIR_RootConstrainSelectedInstOperands,
     /* 171875 */   // GIR_Coverage, 482,
     /* 171875 */   GIR_Done,
     /* 171876 */ // Label 2734: @171876
     /* 171876 */ GIM_Reject,
     /* 171877 */ // Label 2728: @171877
     /* 171877 */ GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(171899), // Rule ID 481 //
     /* 171882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 171888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171892 */   // (ctlz:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VCLZW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 171892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZW),
     /* 171897 */   GIR_RootConstrainSelectedInstOperands,
     /* 171898 */   // GIR_Coverage, 481,
     /* 171898 */   GIR_Done,
     /* 171899 */ // Label 2735: @171899
     /* 171899 */ GIM_Reject,
     /* 171900 */ // Label 2729: @171900
     /* 171900 */ GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(171922), // Rule ID 480 //
     /* 171905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 171911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171915 */   // (ctlz:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VCLZH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 171915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZH),
     /* 171920 */   GIR_RootConstrainSelectedInstOperands,
     /* 171921 */   // GIR_Coverage, 480,
     /* 171921 */   GIR_Done,
     /* 171922 */ // Label 2736: @171922
     /* 171922 */ GIM_Reject,
     /* 171923 */ // Label 2730: @171923
     /* 171923 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(171945), // Rule ID 479 //
     /* 171928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 171931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 171934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 171938 */   // (ctlz:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VCLZB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 171938 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VCLZB),
     /* 171943 */   GIR_RootConstrainSelectedInstOperands,
     /* 171944 */   // GIR_Coverage, 479,
     /* 171944 */   GIR_Done,
     /* 171945 */ // Label 2737: @171945
     /* 171945 */ GIM_Reject,
     /* 171946 */ // Label 2731: @171946
     /* 171946 */ GIM_Reject,
     /* 171947 */ // Label 68: @171947
     /* 171947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 2744*/ GIMT_Encode4(172118),
     /* 171958 */ /*GILLT_s32*//*Label 2738*/ GIMT_Encode4(171986),
     /* 171962 */ /*GILLT_s64*//*Label 2739*/ GIMT_Encode4(172006), GIMT_Encode4(0),
     /* 171970 */ /*GILLT_v2s64*//*Label 2740*/ GIMT_Encode4(172026),
     /* 171974 */ /*GILLT_v4s32*//*Label 2741*/ GIMT_Encode4(172049),
     /* 171978 */ /*GILLT_v8s16*//*Label 2742*/ GIMT_Encode4(172072),
     /* 171982 */ /*GILLT_v16s8*//*Label 2743*/ GIMT_Encode4(172095),
     /* 171986 */ // Label 2738: @171986
     /* 171986 */ GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(172005), // Rule ID 692 //
     /* 171991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 171994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 171998 */   // (ctpop:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (POPCNTW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 171998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTW),
     /* 172003 */   GIR_RootConstrainSelectedInstOperands,
     /* 172004 */   // GIR_Coverage, 692,
     /* 172004 */   GIR_Done,
     /* 172005 */ // Label 2745: @172005
     /* 172005 */ GIM_Reject,
     /* 172006 */ // Label 2739: @172006
     /* 172006 */ GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(172025), // Rule ID 689 //
     /* 172011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 172018 */   // (ctpop:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (POPCNTD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 172018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::POPCNTD),
     /* 172023 */   GIR_RootConstrainSelectedInstOperands,
     /* 172024 */   // GIR_Coverage, 689,
     /* 172024 */   GIR_Done,
     /* 172025 */ // Label 2746: @172025
     /* 172025 */ GIM_Reject,
     /* 172026 */ // Label 2740: @172026
     /* 172026 */ GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(172048), // Rule ID 486 //
     /* 172031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172041 */   // (ctpop:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)  =>  (VPOPCNTD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$VB)
     /* 172041 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTD),
     /* 172046 */   GIR_RootConstrainSelectedInstOperands,
     /* 172047 */   // GIR_Coverage, 486,
     /* 172047 */   GIR_Done,
     /* 172048 */ // Label 2747: @172048
     /* 172048 */ GIM_Reject,
     /* 172049 */ // Label 2741: @172049
     /* 172049 */ GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(172071), // Rule ID 485 //
     /* 172054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172064 */   // (ctpop:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)  =>  (VPOPCNTW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$VB)
     /* 172064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTW),
     /* 172069 */   GIR_RootConstrainSelectedInstOperands,
     /* 172070 */   // GIR_Coverage, 485,
     /* 172070 */   GIR_Done,
     /* 172071 */ // Label 2748: @172071
     /* 172071 */ GIM_Reject,
     /* 172072 */ // Label 2742: @172072
     /* 172072 */ GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(172094), // Rule ID 484 //
     /* 172077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172087 */   // (ctpop:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)  =>  (VPOPCNTH:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$VB)
     /* 172087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTH),
     /* 172092 */   GIR_RootConstrainSelectedInstOperands,
     /* 172093 */   // GIR_Coverage, 484,
     /* 172093 */   GIR_Done,
     /* 172094 */ // Label 2749: @172094
     /* 172094 */ GIM_Reject,
     /* 172095 */ // Label 2743: @172095
     /* 172095 */ GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(172117), // Rule ID 483 //
     /* 172100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Altivec),
     /* 172103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 172106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172110 */   // (ctpop:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)  =>  (VPOPCNTB:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$VB)
     /* 172110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VPOPCNTB),
     /* 172115 */   GIR_RootConstrainSelectedInstOperands,
     /* 172116 */   // GIR_Coverage, 483,
     /* 172116 */   GIR_Done,
     /* 172117 */ // Label 2750: @172117
     /* 172117 */ GIM_Reject,
     /* 172118 */ // Label 2744: @172118
     /* 172118 */ GIM_Reject,
     /* 172119 */ // Label 69: @172119
     /* 172119 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 2757*/ GIMT_Encode4(172382),
     /* 172130 */ /*GILLT_s32*//*Label 2751*/ GIMT_Encode4(172154),
     /* 172134 */ /*GILLT_s64*//*Label 2752*/ GIMT_Encode4(172177),
     /* 172138 */ /*GILLT_s128*//*Label 2753*/ GIMT_Encode4(172200),
     /* 172142 */ /*GILLT_v2s64*//*Label 2754*/ GIMT_Encode4(172268),
     /* 172146 */ /*GILLT_v4s32*//*Label 2755*/ GIMT_Encode4(172291),
     /* 172150 */ /*GILLT_v8s16*//*Label 2756*/ GIMT_Encode4(172314),
     /* 172154 */ // Label 2751: @172154
     /* 172154 */ GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(172176), // Rule ID 1141 //
     /* 172159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 172162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172169 */   // (bswap:{ *:[i32] } i32:{ *:[i32] }:$RST)  =>  (BRW:{ *:[i32] } i32:{ *:[i32] }:$RST)
     /* 172169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRW),
     /* 172174 */   GIR_RootConstrainSelectedInstOperands,
     /* 172175 */   // GIR_Coverage, 1141,
     /* 172175 */   GIR_Done,
     /* 172176 */ // Label 2758: @172176
     /* 172176 */ GIM_Reject,
     /* 172177 */ // Label 2752: @172177
     /* 172177 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(172199), // Rule ID 1142 //
     /* 172182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsISA3_1),
     /* 172185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 172188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 172192 */   // (bswap:{ *:[i64] } i64:{ *:[i64] }:$RST)  =>  (BRD:{ *:[i64] } i64:{ *:[i64] }:$RST)
     /* 172192 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::BRD),
     /* 172197 */   GIR_RootConstrainSelectedInstOperands,
     /* 172198 */   // GIR_Coverage, 1142,
     /* 172198 */   GIR_Done,
     /* 172199 */ // Label 2759: @172199
     /* 172199 */ GIM_Reject,
     /* 172200 */ // Label 2753: @172200
     /* 172200 */ GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(172267), // Rule ID 2176 //
     /* 172205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 172211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172215 */   // (bswap:{ *:[v1i128] } v1i128:{ *:[v1i128] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v1i128] } (XXBRQ:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v1i128] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 172215 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 172218 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172222 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172227 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172231 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 172239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRQ),
     /* 172243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172261 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172266 */   // GIR_Coverage, 2176,
     /* 172266 */   GIR_EraseRootFromParent_Done,
     /* 172267 */ // Label 2760: @172267
     /* 172267 */ GIM_Reject,
     /* 172268 */ // Label 2754: @172268
     /* 172268 */ GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(172290), // Rule ID 1038 //
     /* 172273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 172279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172283 */   // (bswap:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)  =>  (XXBRD:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$XB)
     /* 172283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRD),
     /* 172288 */   GIR_RootConstrainSelectedInstOperands,
     /* 172289 */   // GIR_Coverage, 1038,
     /* 172289 */   GIR_Done,
     /* 172290 */ // Label 2761: @172290
     /* 172290 */ GIM_Reject,
     /* 172291 */ // Label 2755: @172291
     /* 172291 */ GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(172313), // Rule ID 1037 //
     /* 172296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 172302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172306 */   // (bswap:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)  =>  (XXBRW:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$XB)
     /* 172306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XXBRW),
     /* 172311 */   GIR_RootConstrainSelectedInstOperands,
     /* 172312 */   // GIR_Coverage, 1037,
     /* 172312 */   GIR_Done,
     /* 172313 */ // Label 2762: @172313
     /* 172313 */ GIM_Reject,
     /* 172314 */ // Label 2756: @172314
     /* 172314 */ GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(172381), // Rule ID 2175 //
     /* 172319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 172322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 172325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172329 */   // (bswap:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$A)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (XXBRH:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } ?:{ *:[v8i16] }:$A, VSRC:{ *:[i32] })), VRRC:{ *:[i32] })
     /* 172329 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 172332 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172336 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172341 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172345 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSRCRegClassID),
     /* 172350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 172353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XXBRH),
     /* 172357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 172365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 172367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 172370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 172372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 172375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VRRCRegClassID),
     /* 172380 */   // GIR_Coverage, 2175,
     /* 172380 */   GIR_EraseRootFromParent_Done,
     /* 172381 */ // Label 2763: @172381
     /* 172381 */ GIM_Reject,
     /* 172382 */ // Label 2757: @172382
     /* 172382 */ GIM_Reject,
     /* 172383 */ // Label 70: @172383
     /* 172383 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 2766*/ GIMT_Encode4(208388),
     /* 172394 */ /*GILLT_s32*//*Label 2764*/ GIMT_Encode4(172402),
     /* 172398 */ /*GILLT_s64*//*Label 2765*/ GIMT_Encode4(182697),
     /* 172402 */ // Label 2764: @172402
     /* 172402 */ GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(182696),
     /* 172407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 172410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 172414 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(177570), // Rule ID 4889 //
     /* 172419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In64BitMode),
     /* 172422 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLDICL_32:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 172422 */     GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172426 */     GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172431 */     GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172438 */     GIR_AddImm, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 172452 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172456 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172461 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172468 */     GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172473 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 172484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 172487 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172491 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172496 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172503 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 172517 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172521 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172526 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172533 */     GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172538 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 172549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 172552 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172556 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172561 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172568 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172582 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172586 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172591 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172598 */     GIR_AddSimpleTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172603 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 172617 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172621 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172626 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172633 */     GIR_Copy, /*NewInsnID*//* 186(*/0xBA, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172638 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/1,
     /* 172642 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/0,
     /* 172646 */     GIR_AddImm8, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/30,
     /* 172650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172653 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172657 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172662 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172669 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172674 */     GIR_AddSimpleTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 172679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 172682 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172686 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172691 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172698 */     GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172712 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172716 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172721 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172728 */     GIR_AddSimpleTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172733 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 172744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 172747 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172751 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172756 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172763 */     GIR_Copy, /*NewInsnID*//* 182(*/0xB6, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 172768 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172772 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 172776 */     GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/31,
     /* 172780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172783 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172787 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172792 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172799 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172804 */     GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 172809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 172812 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172816 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 172821 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172828 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172833 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 172838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 172841 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172845 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 172850 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172857 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172862 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/2,
     /* 172866 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/0,
     /* 172870 */     GIR_AddImm8, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/29,
     /* 172874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 172877 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172881 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 172886 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172893 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172898 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 172903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 172906 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172910 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172915 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172922 */     GIR_AddImm, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 172936 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172940 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 172945 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172952 */     GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172957 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 172968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 172971 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 172975 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 172980 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 172987 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 172998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 173001 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173005 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173010 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173017 */     GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 173022 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 173036 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173040 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173045 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173052 */     GIR_Copy, /*NewInsnID*//* 173(*/0xAD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173057 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/1,
     /* 173061 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/0,
     /* 173065 */     GIR_AddImm8, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/30,
     /* 173069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 173072 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173076 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173081 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173088 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 173093 */     GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 173098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 173101 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173105 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173110 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173117 */     GIR_AddImm, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 173131 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173135 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173140 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173147 */     GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 173152 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 173166 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173170 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173175 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173182 */     GIR_Copy, /*NewInsnID*//* 169(*/0xA9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173187 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 173191 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/1,
     /* 173195 */     GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 173199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 173202 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173206 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173211 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173218 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 173223 */     GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 173228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 173231 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173235 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173240 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173247 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 173252 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 173257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 173260 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173264 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173269 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173276 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 173281 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/30,
     /* 173285 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/2,
     /* 173289 */     GIR_AddImm8, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/31,
     /* 173293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 173296 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173300 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173305 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173312 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173317 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 173322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 173325 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173329 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173334 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173341 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173346 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 173351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 173354 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173358 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173363 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173370 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173375 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/4,
     /* 173379 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/0,
     /* 173383 */     GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/27,
     /* 173387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 173390 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173394 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173399 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173406 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173411 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 173416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 173419 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173423 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173428 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173435 */     GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 173449 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173453 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173458 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173465 */     GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173470 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 173481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 173484 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173488 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173493 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173500 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 173514 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173518 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173523 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173530 */     GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173535 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 173546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 173549 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173553 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173558 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173565 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173579 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173583 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173588 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173595 */     GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173600 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 173614 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173618 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173623 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173630 */     GIR_Copy, /*NewInsnID*//* 155(*/0x9B, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173635 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/1,
     /* 173639 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/0,
     /* 173643 */     GIR_AddImm8, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/30,
     /* 173647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173650 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173654 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173659 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173666 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173671 */     GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 173676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 173679 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173683 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173688 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173695 */     GIR_AddImm, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 173709 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173713 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173718 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173725 */     GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 173730 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 173741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 173744 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173748 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173753 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173760 */     GIR_Copy, /*NewInsnID*//* 151(*/0x97, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 173765 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173769 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/1,
     /* 173773 */     GIR_AddImm8, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/31,
     /* 173777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 173780 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173784 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173789 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173796 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 173801 */     GIR_AddSimpleTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 173806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 173809 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173813 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 173818 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173825 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 173830 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 173835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 173838 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173842 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 173847 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173854 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 173859 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/2,
     /* 173863 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/0,
     /* 173867 */     GIR_AddImm8, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Imm*/29,
     /* 173871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 173874 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173878 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 173883 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173890 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 173895 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 173900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 173903 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173907 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173912 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173919 */     GIR_AddImm, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 173933 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173937 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 173942 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173949 */     GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 173954 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 173965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 173968 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 173972 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 173977 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173984 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 173995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 173998 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174002 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174007 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174014 */     GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 174019 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 174030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 174033 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174037 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174042 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174049 */     GIR_Copy, /*NewInsnID*//* 142(*/0x8E, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174054 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/1,
     /* 174058 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/0,
     /* 174062 */     GIR_AddImm8, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/30,
     /* 174066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 174069 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174073 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174078 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174085 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 174090 */     GIR_AddSimpleTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 174095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 174098 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174102 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174107 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174114 */     GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 174125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 174128 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174132 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174137 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174144 */     GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 174149 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 174160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 174163 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174167 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174172 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174179 */     GIR_Copy, /*NewInsnID*//* 138(*/0x8A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174184 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 174188 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/1,
     /* 174192 */     GIR_AddImm8, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/31,
     /* 174196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 174199 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174203 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174208 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174215 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 174220 */     GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 174225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 174228 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174232 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174237 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174244 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 174249 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 174254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 174257 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174261 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174266 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174273 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 174278 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/30,
     /* 174282 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/2,
     /* 174286 */     GIR_AddImm8, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/31,
     /* 174290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 174293 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174297 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174302 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174309 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 174314 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 174319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 174322 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174326 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174331 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174338 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 174343 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 174348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 174351 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174355 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174360 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174367 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 174372 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/28,
     /* 174376 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/4,
     /* 174380 */     GIR_AddImm8, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/31,
     /* 174384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 174387 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174391 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174396 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174403 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 174408 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 174413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 174416 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174420 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174425 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174432 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 174437 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 174442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 174445 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 174449 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174454 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174461 */     GIR_AddImm, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 174475 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 174478 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174483 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174489 */     GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 174494 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 174505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 174508 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 174511 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174515 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174520 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 174530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 174532 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 174535 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174539 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174544 */     GIR_AddSimpleTempRegister, /*InsnID*/126, /*TempRegID*/126,
     /* 174547 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 174557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 174559 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 174562 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174566 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174571 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 174581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 174583 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 174586 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174590 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174595 */     GIR_AddSimpleTempRegister, /*InsnID*/124, /*TempRegID*/124,
     /* 174598 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 174608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 174610 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 174613 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174617 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174622 */     GIR_Copy, /*NewInsnID*/123, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174626 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 174629 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/0,
     /* 174632 */     GIR_AddImm8, /*InsnID*/123, /*Imm*/30,
     /* 174635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 174637 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 174640 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174644 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174649 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 174652 */     GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/123,
     /* 174655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 174657 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 174660 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174664 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174669 */     GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(21845),
     /* 174679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 174681 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 174684 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174688 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174693 */     GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 174696 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 174706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 174708 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 174711 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174715 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174720 */     GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174724 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174727 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 174730 */     GIR_AddImm8, /*InsnID*/119, /*Imm*/31,
     /* 174733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 174735 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 174738 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174742 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174747 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 174750 */     GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 174753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 174755 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 174758 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 174762 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174767 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 174770 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/121,
     /* 174773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 174775 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 174778 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174782 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174787 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 174790 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/2,
     /* 174793 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/0,
     /* 174796 */     GIR_AddImm8, /*InsnID*/116, /*Imm*/29,
     /* 174799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 174801 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 174804 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174808 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174813 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 174816 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/125,
     /* 174819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 174821 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 174824 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174828 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174833 */     GIR_AddImm, /*InsnID*/114, /*Imm*/GIMT_Encode8(13107),
     /* 174843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 174845 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 174848 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174852 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174857 */     GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 174860 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 174870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 174872 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 174875 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174879 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174884 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(43690),
     /* 174894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 174896 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 174899 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 174903 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174908 */     GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 174911 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 174921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 174923 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 174926 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 174930 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174935 */     GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 174939 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 174942 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/0,
     /* 174945 */     GIR_AddImm8, /*InsnID*/110, /*Imm*/30,
     /* 174948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 174950 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 174953 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 174957 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174962 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 174965 */     GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 174968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 174970 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 174973 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 174977 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174982 */     GIR_AddImm, /*InsnID*/108, /*Imm*/GIMT_Encode8(21845),
     /* 174992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 174994 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 174997 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175001 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175006 */     GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 175009 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 175019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 175021 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 175024 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175028 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175033 */     GIR_Copy, /*NewInsnID*/106, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175037 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 175040 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/1,
     /* 175043 */     GIR_AddImm8, /*InsnID*/106, /*Imm*/31,
     /* 175046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 175048 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 175051 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175055 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175060 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/105,
     /* 175063 */     GIR_AddSimpleTempRegister, /*InsnID*/105, /*TempRegID*/106,
     /* 175066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 175068 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 175071 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175075 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175080 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 175083 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/108,
     /* 175086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 175088 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 175091 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175095 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175100 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 175103 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/30,
     /* 175106 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/2,
     /* 175109 */     GIR_AddImm8, /*InsnID*/103, /*Imm*/31,
     /* 175112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 175114 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 175117 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175121 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175126 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 175129 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/112,
     /* 175132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 175134 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 175137 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175141 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175146 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 175149 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/114,
     /* 175152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 175154 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 175157 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175161 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175166 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 175169 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/4,
     /* 175172 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/0,
     /* 175175 */     GIR_AddImm8, /*InsnID*/100, /*Imm*/27,
     /* 175178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 175180 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 175183 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175187 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175192 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 175195 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/127,
     /* 175198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 175200 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 175203 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175207 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175212 */     GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(3855),
     /* 175222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 175224 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 175227 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175231 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175236 */     GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 175239 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 175249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 175251 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 175254 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175258 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175263 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(52428),
     /* 175273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 175275 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 175278 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175282 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175287 */     GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 175290 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 175300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 175302 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 175305 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175309 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175314 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(43690),
     /* 175324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 175326 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 175329 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175333 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175338 */     GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 175341 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 175351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 175353 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 175356 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175360 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175365 */     GIR_Copy, /*NewInsnID*/92, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175369 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/1,
     /* 175372 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/0,
     /* 175375 */     GIR_AddImm8, /*InsnID*/92, /*Imm*/30,
     /* 175378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 175380 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 175383 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175387 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175392 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/91,
     /* 175395 */     GIR_AddSimpleTempRegister, /*InsnID*/91, /*TempRegID*/92,
     /* 175398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 175400 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 175403 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175407 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175412 */     GIR_AddImm, /*InsnID*/90, /*Imm*/GIMT_Encode8(21845),
     /* 175422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 175424 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 175427 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175431 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175436 */     GIR_AddSimpleTempRegister, /*InsnID*/89, /*TempRegID*/89,
     /* 175439 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 175449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 175451 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 175454 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175458 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175463 */     GIR_Copy, /*NewInsnID*/88, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175467 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175470 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/1,
     /* 175473 */     GIR_AddImm8, /*InsnID*/88, /*Imm*/31,
     /* 175476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 175478 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 175481 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175485 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175490 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/87,
     /* 175493 */     GIR_AddSimpleTempRegister, /*InsnID*/87, /*TempRegID*/88,
     /* 175496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 175498 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 175501 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175505 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175510 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 175513 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/90,
     /* 175516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 175518 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 175521 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175525 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175530 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 175533 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/2,
     /* 175536 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/0,
     /* 175539 */     GIR_AddImm8, /*InsnID*/85, /*Imm*/29,
     /* 175542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 175544 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 175547 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175551 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175556 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 175559 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/94,
     /* 175562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 175564 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 175567 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175571 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175576 */     GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(13107),
     /* 175586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 175588 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 175591 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175595 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175600 */     GIR_AddSimpleTempRegister, /*InsnID*/82, /*TempRegID*/82,
     /* 175603 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 175613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 175615 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 175618 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175622 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175627 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(43690),
     /* 175637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 175639 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 175642 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175646 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175651 */     GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 175654 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 175664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 175666 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 175669 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175673 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175678 */     GIR_Copy, /*NewInsnID*/79, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175682 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/1,
     /* 175685 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/0,
     /* 175688 */     GIR_AddImm8, /*InsnID*/79, /*Imm*/30,
     /* 175691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 175693 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 175696 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175700 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175705 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 175708 */     GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/79,
     /* 175711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 175713 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 175716 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175720 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175725 */     GIR_AddImm, /*InsnID*/77, /*Imm*/GIMT_Encode8(21845),
     /* 175735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 175737 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 175740 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175744 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175749 */     GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 175752 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 175762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 175764 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 175767 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175771 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175776 */     GIR_Copy, /*NewInsnID*/75, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 175780 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175783 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/1,
     /* 175786 */     GIR_AddImm8, /*InsnID*/75, /*Imm*/31,
     /* 175789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 175791 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 175794 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175798 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175803 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/74,
     /* 175806 */     GIR_AddSimpleTempRegister, /*InsnID*/74, /*TempRegID*/75,
     /* 175809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 175811 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 175814 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175818 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175823 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 175826 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/77,
     /* 175829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 175831 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 175834 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175838 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175843 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 175846 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/30,
     /* 175849 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/2,
     /* 175852 */     GIR_AddImm8, /*InsnID*/72, /*Imm*/31,
     /* 175855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 175857 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 175860 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175864 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175869 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 175872 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/81,
     /* 175875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 175877 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 175880 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175884 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175889 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 175892 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/83,
     /* 175895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 175897 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 175900 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 175904 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175909 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 175912 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/28,
     /* 175915 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/4,
     /* 175918 */     GIR_AddImm8, /*InsnID*/69, /*Imm*/31,
     /* 175921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 175923 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 175926 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 175930 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175935 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 175938 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/96,
     /* 175941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 175943 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 175946 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 175950 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175955 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 175958 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/98,
     /* 175961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 175963 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 175966 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 175970 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175975 */     GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(61680),
     /* 175985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 175987 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 175990 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 175994 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175999 */     GIR_AddSimpleTempRegister, /*InsnID*/65, /*TempRegID*/65,
     /* 176002 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 176012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 176014 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 176017 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176021 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176026 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(52428),
     /* 176036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 176038 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 176041 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176045 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176050 */     GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 176053 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 176063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 176065 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 176068 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176072 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176077 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(43690),
     /* 176087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 176089 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 176092 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176096 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176101 */     GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 176104 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 176114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 176116 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 176119 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176123 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176128 */     GIR_Copy, /*NewInsnID*/60, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176132 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/1,
     /* 176135 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/0,
     /* 176138 */     GIR_AddImm8, /*InsnID*/60, /*Imm*/30,
     /* 176141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 176143 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 176146 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176150 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176155 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 176158 */     GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/60,
     /* 176161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 176163 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 176166 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176170 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176175 */     GIR_AddImm, /*InsnID*/58, /*Imm*/GIMT_Encode8(21845),
     /* 176185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 176187 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 176190 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176194 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176199 */     GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 176202 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 176212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 176214 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 176217 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176221 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176226 */     GIR_Copy, /*NewInsnID*/56, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176230 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 176233 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/1,
     /* 176236 */     GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 176239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 176241 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 176244 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176248 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176253 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 176256 */     GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/56,
     /* 176259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 176261 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 176264 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176268 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176273 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 176276 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/58,
     /* 176279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 176281 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 176284 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176288 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176293 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 176296 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/2,
     /* 176299 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/0,
     /* 176302 */     GIR_AddImm8, /*InsnID*/53, /*Imm*/29,
     /* 176305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 176307 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 176310 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176314 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176319 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 176322 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/62,
     /* 176325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 176327 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 176330 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176334 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176339 */     GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(13107),
     /* 176349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 176351 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 176354 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176358 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176363 */     GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 176366 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 176376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 176378 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 176381 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176385 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176390 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(43690),
     /* 176400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 176402 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 176405 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176409 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176414 */     GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 176417 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 176427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 176429 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 176432 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176436 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176441 */     GIR_Copy, /*NewInsnID*/47, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176445 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/1,
     /* 176448 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/0,
     /* 176451 */     GIR_AddImm8, /*InsnID*/47, /*Imm*/30,
     /* 176454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 176456 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 176459 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176463 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176468 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 176471 */     GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/47,
     /* 176474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 176476 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 176479 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176483 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176488 */     GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 176498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 176500 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 176503 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176507 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176512 */     GIR_AddSimpleTempRegister, /*InsnID*/44, /*TempRegID*/44,
     /* 176515 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 176525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 176527 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 176530 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176534 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176539 */     GIR_Copy, /*NewInsnID*/43, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176543 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176546 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/1,
     /* 176549 */     GIR_AddImm8, /*InsnID*/43, /*Imm*/31,
     /* 176552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 176554 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 176557 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176561 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176566 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 176569 */     GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/43,
     /* 176572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 176574 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 176577 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176581 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176586 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 176589 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/45,
     /* 176592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 176594 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 176597 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176601 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176606 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 176609 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/30,
     /* 176612 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/2,
     /* 176615 */     GIR_AddImm8, /*InsnID*/40, /*Imm*/31,
     /* 176618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 176620 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 176623 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176627 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176632 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 176635 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/49,
     /* 176638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 176640 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 176643 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 176647 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176652 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 176655 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/51,
     /* 176658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 176660 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 176663 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176667 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176672 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 176675 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/4,
     /* 176678 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/0,
     /* 176681 */     GIR_AddImm8, /*InsnID*/37, /*Imm*/27,
     /* 176684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 176686 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 176689 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176693 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176698 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 176701 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/64,
     /* 176704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 176706 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 176709 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176713 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176718 */     GIR_AddImm, /*InsnID*/35, /*Imm*/GIMT_Encode8(3855),
     /* 176728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 176730 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 176733 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176737 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176742 */     GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 176745 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 176755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 176757 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 176760 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176764 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176769 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(52428),
     /* 176779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 176781 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 176784 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176788 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176793 */     GIR_AddSimpleTempRegister, /*InsnID*/32, /*TempRegID*/32,
     /* 176796 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 176806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 176808 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 176811 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176815 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176820 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 176830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 176832 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 176835 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176839 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176844 */     GIR_AddSimpleTempRegister, /*InsnID*/30, /*TempRegID*/30,
     /* 176847 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 176857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 176859 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 176862 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176866 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176871 */     GIR_Copy, /*NewInsnID*/29, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176875 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 176878 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/0,
     /* 176881 */     GIR_AddImm8, /*InsnID*/29, /*Imm*/30,
     /* 176884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 176886 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 176889 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176893 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176898 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 176901 */     GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/29,
     /* 176904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 176906 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 176909 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 176913 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176918 */     GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(21845),
     /* 176928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 176930 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 176933 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 176937 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176942 */     GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 176945 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 176955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 176957 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 176960 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 176964 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176969 */     GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 176973 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176976 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 176979 */     GIR_AddImm8, /*InsnID*/25, /*Imm*/31,
     /* 176982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 176984 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 176987 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 176991 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 176996 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 176999 */     GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 177002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 177004 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 177007 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177011 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177016 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 177019 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/27,
     /* 177022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 177024 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 177027 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177031 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177036 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 177039 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/2,
     /* 177042 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/0,
     /* 177045 */     GIR_AddImm8, /*InsnID*/22, /*Imm*/29,
     /* 177048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 177050 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 177053 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177057 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177062 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 177065 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/31,
     /* 177068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 177070 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 177073 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177077 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177082 */     GIR_AddImm, /*InsnID*/20, /*Imm*/GIMT_Encode8(13107),
     /* 177092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 177094 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 177097 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177101 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177106 */     GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 177109 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 177119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 177121 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 177124 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177128 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177133 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(43690),
     /* 177143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 177145 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 177148 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177152 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177157 */     GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 177160 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 177170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 177172 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 177175 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177179 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177184 */     GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177188 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 177191 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/0,
     /* 177194 */     GIR_AddImm8, /*InsnID*/16, /*Imm*/30,
     /* 177197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 177199 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 177202 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177206 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177211 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 177214 */     GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 177217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 177219 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 177222 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177226 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177231 */     GIR_AddImm, /*InsnID*/14, /*Imm*/GIMT_Encode8(21845),
     /* 177241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 177243 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 177246 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177250 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177255 */     GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 177258 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 177268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 177270 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 177273 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177277 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177282 */     GIR_Copy, /*NewInsnID*/12, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177286 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 177289 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/1,
     /* 177292 */     GIR_AddImm8, /*InsnID*/12, /*Imm*/31,
     /* 177295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 177297 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 177300 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177304 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177309 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 177312 */     GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/12,
     /* 177315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 177317 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 177320 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177324 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177329 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 177332 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/14,
     /* 177335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 177337 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 177340 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177344 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177349 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 177352 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/30,
     /* 177355 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/2,
     /* 177358 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/31,
     /* 177361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 177363 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 177366 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177370 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177375 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 177378 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/18,
     /* 177381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 177383 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 177386 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177390 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177395 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 177398 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/20,
     /* 177401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 177403 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 177406 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177410 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177415 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 177418 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/28,
     /* 177421 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/4,
     /* 177424 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 177427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 177429 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 177432 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177436 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177441 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 177444 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/33,
     /* 177447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 177449 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 177452 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177456 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177461 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 177464 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/35,
     /* 177467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 177469 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 177472 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177476 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177481 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 177484 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/24,
     /* 177487 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 177490 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/31,
     /* 177493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 177495 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 177498 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177502 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177507 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 177510 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/66,
     /* 177513 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177516 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/8,
     /* 177519 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/15,
     /* 177522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 177524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 177531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177536 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 177539 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 177543 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 177546 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 177549 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 177552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 177554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLDICL_32),
     /* 177557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 177559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 177565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 177568 */     GIR_RootConstrainSelectedInstOperands,
     /* 177569 */     // GIR_Coverage, 4889,
     /* 177569 */     GIR_EraseRootFromParent_Done,
     /* 177570 */   // Label 2768: @177570
     /* 177570 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(182695), // Rule ID 4890 //
     /* 177575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_In32BitMode),
     /* 177578 */     // (bitreverse:{ *:[i32] } i32:{ *:[i32] }:$A)  =>  (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 28:{ *:[i32] }, 4:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 30:{ *:[i32] }, 2:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } (OR:{ *:[i32] } (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 31:{ *:[i32] }, 1:{ *:[i32] }, 31:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] })), (AND:{ *:[i32] } (RLWINM:{ *:[i32] } ?:{ *:[i32] }:$A, 1:{ *:[i32] }, 0:{ *:[i32] }, 30:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }))), 2:{ *:[i32] }, 0:{ *:[i32] }, 29:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }))), 4:{ *:[i32] }, 0:{ *:[i32] }, 27:{ *:[i32] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }))), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] })
     /* 177578 */     GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177582 */     GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177587 */     GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177594 */     GIR_AddImm, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 191(*/0xBF, 0x01/*)*/,
     /* 177608 */     GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177612 */     GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177617 */     GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177624 */     GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177629 */     GIR_AddImm, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 177640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 177643 */     GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177647 */     GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177652 */     GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177659 */     GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 177673 */     GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177677 */     GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177682 */     GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177689 */     GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177694 */     GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 177705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 177708 */     GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177712 */     GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177717 */     GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177724 */     GIR_AddImm, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 177738 */     GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177742 */     GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177747 */     GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177754 */     GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177759 */     GIR_AddImm, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 177770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 177773 */     GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177777 */     GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177782 */     GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177789 */     GIR_Copy, /*NewInsnID*//* 185(*/0xB9, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177794 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/1,
     /* 177798 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/0,
     /* 177802 */     GIR_AddImm8, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/30,
     /* 177806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177809 */     GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177813 */     GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177818 */     GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177825 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177830 */     GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 177835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 177838 */     GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177842 */     GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 177847 */     GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177854 */     GIR_AddImm, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177868 */     GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177872 */     GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 177877 */     GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177884 */     GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177889 */     GIR_AddImm, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 177900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 182(*/0xB6, 0x01/*)*/,
     /* 177903 */     GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177907 */     GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 177912 */     GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177919 */     GIR_Copy, /*NewInsnID*//* 181(*/0xB5, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 177924 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177928 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/1,
     /* 177932 */     GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 177936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177939 */     GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177943 */     GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 177948 */     GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177955 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177960 */     GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 177965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 177968 */     GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 177972 */     GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 177977 */     GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177984 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 177989 */     GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 177994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 177997 */     GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178001 */     GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178006 */     GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178013 */     GIR_AddSimpleTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 178018 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/2,
     /* 178022 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/0,
     /* 178026 */     GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/29,
     /* 178030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 178033 */     GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178037 */     GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178042 */     GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178049 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 178054 */     GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 178059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 178062 */     GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178066 */     GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178071 */     GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178078 */     GIR_AddImm, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 178092 */     GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178096 */     GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178101 */     GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178108 */     GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 178113 */     GIR_AddImm, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 178124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 178127 */     GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178131 */     GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178136 */     GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178143 */     GIR_AddImm, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 178157 */     GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178161 */     GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178166 */     GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178173 */     GIR_AddSimpleTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 178178 */     GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 178192 */     GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178196 */     GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178201 */     GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178208 */     GIR_Copy, /*NewInsnID*//* 172(*/0xAC, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178213 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/1,
     /* 178217 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/0,
     /* 178221 */     GIR_AddImm8, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/30,
     /* 178225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 178228 */     GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178232 */     GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178237 */     GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178244 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 178249 */     GIR_AddSimpleTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 178254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 178257 */     GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178261 */     GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178266 */     GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178273 */     GIR_AddImm, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 170(*/0xAA, 0x01/*)*/,
     /* 178287 */     GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178291 */     GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178296 */     GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178303 */     GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178308 */     GIR_AddImm, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 178322 */     GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178326 */     GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178331 */     GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178338 */     GIR_Copy, /*NewInsnID*//* 168(*/0xA8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178343 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178347 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/1,
     /* 178351 */     GIR_AddImm8, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/31,
     /* 178355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178358 */     GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178362 */     GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178367 */     GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178374 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178379 */     GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 178384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 178387 */     GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178391 */     GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178396 */     GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178403 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178408 */     GIR_AddSimpleTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 178413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 178416 */     GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178420 */     GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178425 */     GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178432 */     GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178437 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/30,
     /* 178441 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/2,
     /* 178445 */     GIR_AddImm8, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/31,
     /* 178449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 178452 */     GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178456 */     GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178461 */     GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178468 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178473 */     GIR_AddSimpleTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 178478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 178481 */     GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178485 */     GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178490 */     GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178497 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178502 */     GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 178507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 163(*/0xA3, 0x01/*)*/,
     /* 178510 */     GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178514 */     GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178519 */     GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178526 */     GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178531 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/4,
     /* 178535 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/0,
     /* 178539 */     GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/27,
     /* 178543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 178546 */     GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178550 */     GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178555 */     GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178562 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178567 */     GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 178572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 178575 */     GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178579 */     GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178584 */     GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178591 */     GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 178605 */     GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178609 */     GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178614 */     GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178621 */     GIR_AddSimpleTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178626 */     GIR_AddImm, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 178637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 178640 */     GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178644 */     GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178649 */     GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178656 */     GIR_AddImm, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 178670 */     GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178674 */     GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178679 */     GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178686 */     GIR_AddSimpleTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178691 */     GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 178702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 178705 */     GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178709 */     GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178714 */     GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178721 */     GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 178735 */     GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178739 */     GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178744 */     GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178751 */     GIR_AddSimpleTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178756 */     GIR_AddImm, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 178767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 178770 */     GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178774 */     GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178779 */     GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178786 */     GIR_Copy, /*NewInsnID*//* 154(*/0x9A, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178791 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 178795 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/0,
     /* 178799 */     GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/30,
     /* 178803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178806 */     GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178810 */     GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178815 */     GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178822 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 178827 */     GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 178832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 178835 */     GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178839 */     GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 178844 */     GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178851 */     GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 178865 */     GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178869 */     GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 178874 */     GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178881 */     GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 178886 */     GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 178897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 178900 */     GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178904 */     GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 178909 */     GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178916 */     GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 178921 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178925 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 178929 */     GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/31,
     /* 178933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 178936 */     GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178940 */     GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 178945 */     GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178952 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 178957 */     GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 178962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 178965 */     GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178969 */     GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 178974 */     GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178981 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 178986 */     GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 178991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 178994 */     GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 178998 */     GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179003 */     GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179010 */     GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 179015 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 179019 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/0,
     /* 179023 */     GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/29,
     /* 179027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 179030 */     GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179034 */     GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179039 */     GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179046 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 179051 */     GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 179056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 179059 */     GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179063 */     GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179068 */     GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179075 */     GIR_AddImm, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 179086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 179089 */     GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179093 */     GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179098 */     GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179105 */     GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 179110 */     GIR_AddImm, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 179121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 179124 */     GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179128 */     GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179133 */     GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179140 */     GIR_AddImm, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 179151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 179154 */     GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179158 */     GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179163 */     GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179170 */     GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 179175 */     GIR_AddImm, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 179186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 179189 */     GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179193 */     GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179198 */     GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179205 */     GIR_Copy, /*NewInsnID*//* 141(*/0x8D, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179210 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/1,
     /* 179214 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/0,
     /* 179218 */     GIR_AddImm8, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Imm*/30,
     /* 179222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 141(*/0x8D, 0x01/*)*/,
     /* 179225 */     GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179229 */     GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179234 */     GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179241 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 179246 */     GIR_AddSimpleTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/,
     /* 179251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 179254 */     GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179258 */     GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179263 */     GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179270 */     GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 179281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 179284 */     GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179288 */     GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179293 */     GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179300 */     GIR_AddSimpleTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 179305 */     GIR_AddImm, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 179316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 179319 */     GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179323 */     GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179328 */     GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179335 */     GIR_Copy, /*NewInsnID*//* 137(*/0x89, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179340 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179344 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 179348 */     GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/31,
     /* 179352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 137(*/0x89, 0x01/*)*/,
     /* 179355 */     GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179359 */     GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179364 */     GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179371 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 179376 */     GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 179381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 179384 */     GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179388 */     GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179393 */     GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179400 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 179405 */     GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 179410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 179413 */     GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179417 */     GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179422 */     GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179429 */     GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 179434 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/30,
     /* 179438 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/2,
     /* 179442 */     GIR_AddImm8, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/31,
     /* 179446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 179449 */     GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179453 */     GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179458 */     GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179465 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 179470 */     GIR_AddSimpleTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 179475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 179478 */     GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179482 */     GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179487 */     GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179494 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 179499 */     GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 179504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 179507 */     GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179511 */     GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179516 */     GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179523 */     GIR_AddSimpleTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 179528 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/28,
     /* 179532 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/4,
     /* 179536 */     GIR_AddImm8, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Imm*/31,
     /* 179540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 179543 */     GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179547 */     GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179552 */     GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179559 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 179564 */     GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 179569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 130(*/0x82, 0x01/*)*/,
     /* 179572 */     GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 179576 */     GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179581 */     GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179588 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 179593 */     GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 179598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 179601 */     GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s32,
     /* 179604 */     GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179609 */     GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179615 */     GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 179626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 179629 */     GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s32,
     /* 179632 */     GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179636 */     GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179641 */     GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 179644 */     GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(61680),
     /* 179654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 179656 */     GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 179659 */     GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179663 */     GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179668 */     GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(52428),
     /* 179678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 179680 */     GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 179683 */     GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179687 */     GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179692 */     GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 179695 */     GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(52428),
     /* 179705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 179707 */     GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s32,
     /* 179710 */     GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179714 */     GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179719 */     GIR_AddImm, /*InsnID*/124, /*Imm*/GIMT_Encode8(43690),
     /* 179729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 179731 */     GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s32,
     /* 179734 */     GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179738 */     GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179743 */     GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 179746 */     GIR_AddImm, /*InsnID*/123, /*Imm*/GIMT_Encode8(43690),
     /* 179756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/123,
     /* 179758 */     GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s32,
     /* 179761 */     GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179765 */     GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179770 */     GIR_Copy, /*NewInsnID*/122, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179774 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/1,
     /* 179777 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/0,
     /* 179780 */     GIR_AddImm8, /*InsnID*/122, /*Imm*/30,
     /* 179783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 179785 */     GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s32,
     /* 179788 */     GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179792 */     GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179797 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 179800 */     GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/122,
     /* 179803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 179805 */     GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s32,
     /* 179808 */     GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179812 */     GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179817 */     GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(21845),
     /* 179827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 179829 */     GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s32,
     /* 179832 */     GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 179836 */     GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179841 */     GIR_AddSimpleTempRegister, /*InsnID*/119, /*TempRegID*/119,
     /* 179844 */     GIR_AddImm, /*InsnID*/119, /*Imm*/GIMT_Encode8(21845),
     /* 179854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 179856 */     GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s32,
     /* 179859 */     GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179863 */     GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179868 */     GIR_Copy, /*NewInsnID*/118, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 179872 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179875 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/1,
     /* 179878 */     GIR_AddImm8, /*InsnID*/118, /*Imm*/31,
     /* 179881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 179883 */     GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 179886 */     GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179890 */     GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179895 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/117,
     /* 179898 */     GIR_AddSimpleTempRegister, /*InsnID*/117, /*TempRegID*/118,
     /* 179901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 179903 */     GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 179906 */     GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 179910 */     GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179915 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 179918 */     GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/120,
     /* 179921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 179923 */     GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s32,
     /* 179926 */     GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 179930 */     GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179935 */     GIR_AddSimpleTempRegister, /*InsnID*/115, /*TempRegID*/115,
     /* 179938 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/2,
     /* 179941 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/0,
     /* 179944 */     GIR_AddImm8, /*InsnID*/115, /*Imm*/29,
     /* 179947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 179949 */     GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s32,
     /* 179952 */     GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 179956 */     GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179961 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 179964 */     GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/124,
     /* 179967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/114,
     /* 179969 */     GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s32,
     /* 179972 */     GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 179976 */     GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 179981 */     GIR_AddImm, /*InsnID*/113, /*Imm*/GIMT_Encode8(13107),
     /* 179991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 179993 */     GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s32,
     /* 179996 */     GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180000 */     GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180005 */     GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 180008 */     GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(13107),
     /* 180018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 180020 */     GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s32,
     /* 180023 */     GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180027 */     GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180032 */     GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(43690),
     /* 180042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 180044 */     GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s32,
     /* 180047 */     GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180051 */     GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180056 */     GIR_AddSimpleTempRegister, /*InsnID*/110, /*TempRegID*/110,
     /* 180059 */     GIR_AddImm, /*InsnID*/110, /*Imm*/GIMT_Encode8(43690),
     /* 180069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 180071 */     GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s32,
     /* 180074 */     GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180078 */     GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180083 */     GIR_Copy, /*NewInsnID*/109, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180087 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/1,
     /* 180090 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/0,
     /* 180093 */     GIR_AddImm8, /*InsnID*/109, /*Imm*/30,
     /* 180096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 180098 */     GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s32,
     /* 180101 */     GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180105 */     GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180110 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 180113 */     GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/109,
     /* 180116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 180118 */     GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s32,
     /* 180121 */     GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180125 */     GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180130 */     GIR_AddImm, /*InsnID*/107, /*Imm*/GIMT_Encode8(21845),
     /* 180140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 180142 */     GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s32,
     /* 180145 */     GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180149 */     GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180154 */     GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 180157 */     GIR_AddImm, /*InsnID*/106, /*Imm*/GIMT_Encode8(21845),
     /* 180167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 180169 */     GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 180172 */     GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180176 */     GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180181 */     GIR_Copy, /*NewInsnID*/105, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180185 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 180188 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/1,
     /* 180191 */     GIR_AddImm8, /*InsnID*/105, /*Imm*/31,
     /* 180194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 180196 */     GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 180199 */     GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180203 */     GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180208 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 180211 */     GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/105,
     /* 180214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 180216 */     GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s32,
     /* 180219 */     GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180223 */     GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180228 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/103,
     /* 180231 */     GIR_AddSimpleTempRegister, /*InsnID*/103, /*TempRegID*/107,
     /* 180234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 180236 */     GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s32,
     /* 180239 */     GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180243 */     GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180248 */     GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 180251 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/30,
     /* 180254 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/2,
     /* 180257 */     GIR_AddImm8, /*InsnID*/102, /*Imm*/31,
     /* 180260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/102,
     /* 180262 */     GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s32,
     /* 180265 */     GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180269 */     GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180274 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 180277 */     GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/111,
     /* 180280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 180282 */     GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s32,
     /* 180285 */     GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180289 */     GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180294 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 180297 */     GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/113,
     /* 180300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 180302 */     GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s32,
     /* 180305 */     GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180309 */     GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180314 */     GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 180317 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/4,
     /* 180320 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/0,
     /* 180323 */     GIR_AddImm8, /*InsnID*/99, /*Imm*/27,
     /* 180326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 180328 */     GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 180331 */     GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180335 */     GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180340 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/98,
     /* 180343 */     GIR_AddSimpleTempRegister, /*InsnID*/98, /*TempRegID*/126,
     /* 180346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 180348 */     GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 180351 */     GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180355 */     GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180360 */     GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(3855),
     /* 180370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 180372 */     GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s32,
     /* 180375 */     GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180379 */     GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180384 */     GIR_AddSimpleTempRegister, /*InsnID*/96, /*TempRegID*/96,
     /* 180387 */     GIR_AddImm, /*InsnID*/96, /*Imm*/GIMT_Encode8(3855),
     /* 180397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 180399 */     GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s32,
     /* 180402 */     GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180406 */     GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180411 */     GIR_AddImm, /*InsnID*/95, /*Imm*/GIMT_Encode8(52428),
     /* 180421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/95,
     /* 180423 */     GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s32,
     /* 180426 */     GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180430 */     GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180435 */     GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 180438 */     GIR_AddImm, /*InsnID*/94, /*Imm*/GIMT_Encode8(52428),
     /* 180448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 180450 */     GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s32,
     /* 180453 */     GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180457 */     GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180462 */     GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 180472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 180474 */     GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s32,
     /* 180477 */     GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180481 */     GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180486 */     GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 180489 */     GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 180499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 180501 */     GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s32,
     /* 180504 */     GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180508 */     GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180513 */     GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180517 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 180520 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/0,
     /* 180523 */     GIR_AddImm8, /*InsnID*/91, /*Imm*/30,
     /* 180526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 180528 */     GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s32,
     /* 180531 */     GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180535 */     GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180540 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 180543 */     GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 180546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 180548 */     GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 180551 */     GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180555 */     GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180560 */     GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 180570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 180572 */     GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 180575 */     GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180579 */     GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180584 */     GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 180587 */     GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 180597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 180599 */     GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s32,
     /* 180602 */     GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180606 */     GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180611 */     GIR_Copy, /*NewInsnID*/87, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180615 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180618 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/1,
     /* 180621 */     GIR_AddImm8, /*InsnID*/87, /*Imm*/31,
     /* 180624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 180626 */     GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s32,
     /* 180629 */     GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180633 */     GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180638 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 180641 */     GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 180644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/86,
     /* 180646 */     GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s32,
     /* 180649 */     GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180653 */     GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180658 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 180661 */     GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/89,
     /* 180664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 180666 */     GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s32,
     /* 180669 */     GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180673 */     GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180678 */     GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 180681 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/2,
     /* 180684 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/0,
     /* 180687 */     GIR_AddImm8, /*InsnID*/84, /*Imm*/29,
     /* 180690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 180692 */     GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s32,
     /* 180695 */     GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180699 */     GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180704 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 180707 */     GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/93,
     /* 180710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 180712 */     GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s32,
     /* 180715 */     GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180719 */     GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180724 */     GIR_AddImm, /*InsnID*/82, /*Imm*/GIMT_Encode8(13107),
     /* 180734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 180736 */     GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s32,
     /* 180739 */     GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180743 */     GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180748 */     GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 180751 */     GIR_AddImm, /*InsnID*/81, /*Imm*/GIMT_Encode8(13107),
     /* 180761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 180763 */     GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s32,
     /* 180766 */     GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180770 */     GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180775 */     GIR_AddImm, /*InsnID*/80, /*Imm*/GIMT_Encode8(43690),
     /* 180785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 180787 */     GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s32,
     /* 180790 */     GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180794 */     GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180799 */     GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 180802 */     GIR_AddImm, /*InsnID*/79, /*Imm*/GIMT_Encode8(43690),
     /* 180812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 180814 */     GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s32,
     /* 180817 */     GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180821 */     GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180826 */     GIR_Copy, /*NewInsnID*/78, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180830 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/1,
     /* 180833 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/0,
     /* 180836 */     GIR_AddImm8, /*InsnID*/78, /*Imm*/30,
     /* 180839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 180841 */     GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s32,
     /* 180844 */     GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180848 */     GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180853 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 180856 */     GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/78,
     /* 180859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 180861 */     GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s32,
     /* 180864 */     GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 180868 */     GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180873 */     GIR_AddImm, /*InsnID*/76, /*Imm*/GIMT_Encode8(21845),
     /* 180883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 180885 */     GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s32,
     /* 180888 */     GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 180892 */     GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180897 */     GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 180900 */     GIR_AddImm, /*InsnID*/75, /*Imm*/GIMT_Encode8(21845),
     /* 180910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 180912 */     GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 180915 */     GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180919 */     GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180924 */     GIR_Copy, /*NewInsnID*/74, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 180928 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180931 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/1,
     /* 180934 */     GIR_AddImm8, /*InsnID*/74, /*Imm*/31,
     /* 180937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 180939 */     GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 180942 */     GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 180946 */     GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180951 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 180954 */     GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/74,
     /* 180957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 180959 */     GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s32,
     /* 180962 */     GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 180966 */     GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180971 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/72,
     /* 180974 */     GIR_AddSimpleTempRegister, /*InsnID*/72, /*TempRegID*/76,
     /* 180977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 180979 */     GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s32,
     /* 180982 */     GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 180986 */     GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180991 */     GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 180994 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/30,
     /* 180997 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/2,
     /* 181000 */     GIR_AddImm8, /*InsnID*/71, /*Imm*/31,
     /* 181003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/71,
     /* 181005 */     GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s32,
     /* 181008 */     GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181012 */     GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181017 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 181020 */     GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/80,
     /* 181023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 181025 */     GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s32,
     /* 181028 */     GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181032 */     GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181037 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 181040 */     GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/82,
     /* 181043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 181045 */     GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s32,
     /* 181048 */     GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181052 */     GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181057 */     GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 181060 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/28,
     /* 181063 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/4,
     /* 181066 */     GIR_AddImm8, /*InsnID*/68, /*Imm*/31,
     /* 181069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 181071 */     GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 181074 */     GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181078 */     GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181083 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/67,
     /* 181086 */     GIR_AddSimpleTempRegister, /*InsnID*/67, /*TempRegID*/95,
     /* 181089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 181091 */     GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 181094 */     GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181098 */     GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181103 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 181106 */     GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/97,
     /* 181109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 181111 */     GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s32,
     /* 181114 */     GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181118 */     GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181123 */     GIR_AddImm, /*InsnID*/65, /*Imm*/GIMT_Encode8(61680),
     /* 181133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 181135 */     GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s32,
     /* 181138 */     GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181142 */     GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181147 */     GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 181150 */     GIR_AddImm, /*InsnID*/64, /*Imm*/GIMT_Encode8(61680),
     /* 181160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/64,
     /* 181162 */     GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s32,
     /* 181165 */     GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181169 */     GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181174 */     GIR_AddImm, /*InsnID*/63, /*Imm*/GIMT_Encode8(52428),
     /* 181184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 181186 */     GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s32,
     /* 181189 */     GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181193 */     GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181198 */     GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 181201 */     GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 181211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 181213 */     GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s32,
     /* 181216 */     GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181220 */     GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181225 */     GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(43690),
     /* 181235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 181237 */     GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 181240 */     GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181244 */     GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181249 */     GIR_AddSimpleTempRegister, /*InsnID*/60, /*TempRegID*/60,
     /* 181252 */     GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 181262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 181264 */     GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 181267 */     GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181271 */     GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181276 */     GIR_Copy, /*NewInsnID*/59, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181280 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/1,
     /* 181283 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/0,
     /* 181286 */     GIR_AddImm8, /*InsnID*/59, /*Imm*/30,
     /* 181289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 181291 */     GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s32,
     /* 181294 */     GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181298 */     GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181303 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/58,
     /* 181306 */     GIR_AddSimpleTempRegister, /*InsnID*/58, /*TempRegID*/59,
     /* 181309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 181311 */     GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s32,
     /* 181314 */     GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181318 */     GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181323 */     GIR_AddImm, /*InsnID*/57, /*Imm*/GIMT_Encode8(21845),
     /* 181333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/57,
     /* 181335 */     GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s32,
     /* 181338 */     GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181342 */     GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181347 */     GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 181350 */     GIR_AddImm, /*InsnID*/56, /*Imm*/GIMT_Encode8(21845),
     /* 181360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 181362 */     GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s32,
     /* 181365 */     GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181369 */     GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181374 */     GIR_Copy, /*NewInsnID*/55, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181378 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181381 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/1,
     /* 181384 */     GIR_AddImm8, /*InsnID*/55, /*Imm*/31,
     /* 181387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 181389 */     GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s32,
     /* 181392 */     GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181396 */     GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181401 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 181404 */     GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/55,
     /* 181407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 181409 */     GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s32,
     /* 181412 */     GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181416 */     GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181421 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/53,
     /* 181424 */     GIR_AddSimpleTempRegister, /*InsnID*/53, /*TempRegID*/57,
     /* 181427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 181429 */     GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s32,
     /* 181432 */     GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181436 */     GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181441 */     GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 181444 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/2,
     /* 181447 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/0,
     /* 181450 */     GIR_AddImm8, /*InsnID*/52, /*Imm*/29,
     /* 181453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 181455 */     GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 181458 */     GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181462 */     GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181467 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/51,
     /* 181470 */     GIR_AddSimpleTempRegister, /*InsnID*/51, /*TempRegID*/61,
     /* 181473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 181475 */     GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 181478 */     GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181482 */     GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181487 */     GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(13107),
     /* 181497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 181499 */     GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s32,
     /* 181502 */     GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181506 */     GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181511 */     GIR_AddSimpleTempRegister, /*InsnID*/49, /*TempRegID*/49,
     /* 181514 */     GIR_AddImm, /*InsnID*/49, /*Imm*/GIMT_Encode8(13107),
     /* 181524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 181526 */     GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s32,
     /* 181529 */     GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181533 */     GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181538 */     GIR_AddImm, /*InsnID*/48, /*Imm*/GIMT_Encode8(43690),
     /* 181548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/48,
     /* 181550 */     GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s32,
     /* 181553 */     GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181557 */     GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181562 */     GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 181565 */     GIR_AddImm, /*InsnID*/47, /*Imm*/GIMT_Encode8(43690),
     /* 181575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 181577 */     GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s32,
     /* 181580 */     GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181584 */     GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181589 */     GIR_Copy, /*NewInsnID*/46, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181593 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/1,
     /* 181596 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/0,
     /* 181599 */     GIR_AddImm8, /*InsnID*/46, /*Imm*/30,
     /* 181602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 181604 */     GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s32,
     /* 181607 */     GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181611 */     GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181616 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 181619 */     GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/46,
     /* 181622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 181624 */     GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s32,
     /* 181627 */     GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181631 */     GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181636 */     GIR_AddImm, /*InsnID*/44, /*Imm*/GIMT_Encode8(21845),
     /* 181646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 181648 */     GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s32,
     /* 181651 */     GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181655 */     GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181660 */     GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 181663 */     GIR_AddImm, /*InsnID*/43, /*Imm*/GIMT_Encode8(21845),
     /* 181673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 181675 */     GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s32,
     /* 181678 */     GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181682 */     GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181687 */     GIR_Copy, /*NewInsnID*/42, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 181691 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181694 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/1,
     /* 181697 */     GIR_AddImm8, /*InsnID*/42, /*Imm*/31,
     /* 181700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 181702 */     GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s32,
     /* 181705 */     GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181709 */     GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181714 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 181717 */     GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/42,
     /* 181720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 181722 */     GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s32,
     /* 181725 */     GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181729 */     GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181734 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 181737 */     GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/44,
     /* 181740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 181742 */     GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 181745 */     GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181749 */     GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181754 */     GIR_AddSimpleTempRegister, /*InsnID*/39, /*TempRegID*/39,
     /* 181757 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/30,
     /* 181760 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/2,
     /* 181763 */     GIR_AddImm8, /*InsnID*/39, /*Imm*/31,
     /* 181766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 181768 */     GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 181771 */     GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181775 */     GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181780 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 181783 */     GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/48,
     /* 181786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 181788 */     GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s32,
     /* 181791 */     GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 181795 */     GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181800 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/37,
     /* 181803 */     GIR_AddSimpleTempRegister, /*InsnID*/37, /*TempRegID*/50,
     /* 181806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 181808 */     GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s32,
     /* 181811 */     GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 181815 */     GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181820 */     GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 181823 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/4,
     /* 181826 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/0,
     /* 181829 */     GIR_AddImm8, /*InsnID*/36, /*Imm*/27,
     /* 181832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/36,
     /* 181834 */     GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s32,
     /* 181837 */     GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 181841 */     GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181846 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 181849 */     GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/63,
     /* 181852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 181854 */     GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s32,
     /* 181857 */     GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181861 */     GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181866 */     GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(3855),
     /* 181876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 181878 */     GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s32,
     /* 181881 */     GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181885 */     GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181890 */     GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 181893 */     GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(3855),
     /* 181903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 181905 */     GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 181908 */     GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181912 */     GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181917 */     GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(52428),
     /* 181927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 181929 */     GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 181932 */     GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181936 */     GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181941 */     GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 181944 */     GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(52428),
     /* 181954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 181956 */     GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s32,
     /* 181959 */     GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 181963 */     GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181968 */     GIR_AddImm, /*InsnID*/30, /*Imm*/GIMT_Encode8(43690),
     /* 181978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 181980 */     GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s32,
     /* 181983 */     GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 181987 */     GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 181992 */     GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 181995 */     GIR_AddImm, /*InsnID*/29, /*Imm*/GIMT_Encode8(43690),
     /* 182005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/29,
     /* 182007 */     GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s32,
     /* 182010 */     GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182014 */     GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182019 */     GIR_Copy, /*NewInsnID*/28, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182023 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/1,
     /* 182026 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/0,
     /* 182029 */     GIR_AddImm8, /*InsnID*/28, /*Imm*/30,
     /* 182032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 182034 */     GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s32,
     /* 182037 */     GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182041 */     GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182046 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 182049 */     GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/28,
     /* 182052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 182054 */     GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s32,
     /* 182057 */     GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182061 */     GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182066 */     GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(21845),
     /* 182076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 182078 */     GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s32,
     /* 182081 */     GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182085 */     GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182090 */     GIR_AddSimpleTempRegister, /*InsnID*/25, /*TempRegID*/25,
     /* 182093 */     GIR_AddImm, /*InsnID*/25, /*Imm*/GIMT_Encode8(21845),
     /* 182103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 182105 */     GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s32,
     /* 182108 */     GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182112 */     GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182117 */     GIR_Copy, /*NewInsnID*/24, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182121 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 182124 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/1,
     /* 182127 */     GIR_AddImm8, /*InsnID*/24, /*Imm*/31,
     /* 182130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 182132 */     GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 182135 */     GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182139 */     GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182144 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/23,
     /* 182147 */     GIR_AddSimpleTempRegister, /*InsnID*/23, /*TempRegID*/24,
     /* 182150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 182152 */     GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 182155 */     GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182159 */     GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182164 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 182167 */     GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/26,
     /* 182170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 182172 */     GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s32,
     /* 182175 */     GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182179 */     GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182184 */     GIR_AddSimpleTempRegister, /*InsnID*/21, /*TempRegID*/21,
     /* 182187 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/2,
     /* 182190 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/0,
     /* 182193 */     GIR_AddImm8, /*InsnID*/21, /*Imm*/29,
     /* 182196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 182198 */     GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s32,
     /* 182201 */     GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182205 */     GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182210 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 182213 */     GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/30,
     /* 182216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/20,
     /* 182218 */     GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s32,
     /* 182221 */     GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182225 */     GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182230 */     GIR_AddImm, /*InsnID*/19, /*Imm*/GIMT_Encode8(13107),
     /* 182240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 182242 */     GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s32,
     /* 182245 */     GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182249 */     GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182254 */     GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 182257 */     GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(13107),
     /* 182267 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 182269 */     GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s32,
     /* 182272 */     GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182276 */     GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182281 */     GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(43690),
     /* 182291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 182293 */     GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s32,
     /* 182296 */     GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182300 */     GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182305 */     GIR_AddSimpleTempRegister, /*InsnID*/16, /*TempRegID*/16,
     /* 182308 */     GIR_AddImm, /*InsnID*/16, /*Imm*/GIMT_Encode8(43690),
     /* 182318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 182320 */     GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s32,
     /* 182323 */     GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182327 */     GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182332 */     GIR_Copy, /*NewInsnID*/15, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182336 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/1,
     /* 182339 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/0,
     /* 182342 */     GIR_AddImm8, /*InsnID*/15, /*Imm*/30,
     /* 182345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 182347 */     GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s32,
     /* 182350 */     GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182354 */     GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182359 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 182362 */     GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/15,
     /* 182365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 182367 */     GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s32,
     /* 182370 */     GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182374 */     GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182379 */     GIR_AddImm, /*InsnID*/13, /*Imm*/GIMT_Encode8(21845),
     /* 182389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 182391 */     GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s32,
     /* 182394 */     GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182398 */     GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182403 */     GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 182406 */     GIR_AddImm, /*InsnID*/12, /*Imm*/GIMT_Encode8(21845),
     /* 182416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 182418 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s32,
     /* 182421 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182425 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182430 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 182434 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182437 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/1,
     /* 182440 */     GIR_AddImm8, /*InsnID*/11, /*Imm*/31,
     /* 182443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 182445 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s32,
     /* 182448 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182452 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182457 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 182460 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/11,
     /* 182463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 182465 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s32,
     /* 182468 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182472 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182477 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 182480 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/13,
     /* 182483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 182485 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s32,
     /* 182488 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182492 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182497 */     GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 182500 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/30,
     /* 182503 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/2,
     /* 182506 */     GIR_AddImm8, /*InsnID*/8, /*Imm*/31,
     /* 182509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 182511 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 182514 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182518 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182523 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 182526 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/17,
     /* 182529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 182531 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 182534 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182538 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182543 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 182546 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/19,
     /* 182549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 182551 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 182554 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182558 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182563 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 182566 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/28,
     /* 182569 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/4,
     /* 182572 */     GIR_AddImm8, /*InsnID*/5, /*Imm*/31,
     /* 182575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 182577 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 182580 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::AND),
     /* 182584 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182589 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 182592 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/32,
     /* 182595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 182597 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 182600 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(PPC::OR),
     /* 182604 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182609 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 182612 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/34,
     /* 182615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 182617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 182620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 182624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182629 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 182632 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/24,
     /* 182635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 182638 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 182641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182655 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 182658 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/65,
     /* 182661 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182664 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 182667 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/15,
     /* 182670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 182675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 182677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 182684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 182687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/24,
     /* 182690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 182693 */     GIR_RootConstrainSelectedInstOperands,
     /* 182694 */     // GIR_Coverage, 4890,
     /* 182694 */     GIR_EraseRootFromParent_Done,
     /* 182695 */   // Label 2769: @182695
     /* 182695 */   GIM_Reject,
     /* 182696 */ // Label 2767: @182696
     /* 182696 */ GIM_Reject,
     /* 182697 */ // Label 2765: @182697
     /* 182697 */ GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(208387), // Rule ID 4891 //
     /* 182702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 182705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182709 */   // (bitreverse:{ *:[i64] } i64:{ *:[i64] }:$A)  =>  (OR8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (RLWIMI:{ *:[i32] } (RLWIMI:{ *:[i32] } (RLWINM:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 24:{ *:[i32] }, 0:{ *:[i32] }, 31:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 8:{ *:[i32] }, 15:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 60:{ *:[i32] }, 4:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 3855:{ *:[i32] }), 3855:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 3855:{ *:[i64] }), 3855:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 62:{ *:[i32] }, 2:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 13107:{ *:[i32] }), 13107:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 13107:{ *:[i64] }), 13107:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } (OR8:{ *:[i64] } (AND8:{ *:[i64] } (RLDICL:{ *:[i64] } ?:{ *:[i64] }:$A, 63:{ *:[i32] }, 1:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 21845:{ *:[i32] }), 21845:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 21845:{ *:[i64] }), 21845:{ *:[i64] })), (AND8:{ *:[i64] } (RLDICR:{ *:[i64] } ?:{ *:[i64] }:$A, 1:{ *:[i32] }, 62:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 43690:{ *:[i32] }), 43690:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 43690:{ *:[i64] }), 43690:{ *:[i64] }))), 2:{ *:[i32] }, 61:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 52428:{ *:[i32] }), 52428:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 52428:{ *:[i64] }), 52428:{ *:[i64] }))), 4:{ *:[i32] }, 59:{ *:[i32] }), (ORI8:{ *:[i64] } (ORIS8:{ *:[i64] } (RLDICR:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ORI:{ *:[i32] } (LIS:{ *:[i32] } 61680:{ *:[i32] }), 61680:{ *:[i32] }), sub_32:{ *:[i32] }), 32:{ *:[i32] }, 31:{ *:[i32] }), 61680:{ *:[i64] }), 61680:{ *:[i64] }))), 32:{ *:[i32] }, 32:{ *:[i32] }), sub_32:{ *:[i32] }), 8:{ *:[i32] }, 24:{ *:[i32] }, 31:{ *:[i32] }), sub_32:{ *:[i32] }))
     /* 182709 */   GIR_MakeTempReg, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182713 */   GIR_BuildMI, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182718 */   GIR_AddTempRegister, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182725 */   GIR_AddImm, /*InsnID*//* 140(*/0x8C, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 140(*/0x8C, 0x01/*)*/,
     /* 182739 */   GIR_MakeTempReg, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182743 */   GIR_BuildMI, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182748 */   GIR_AddTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182755 */   GIR_AddSimpleTempRegister, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*TempRegID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182760 */   GIR_AddImm, /*InsnID*//* 139(*/0x8B, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 139(*/0x8B, 0x01/*)*/,
     /* 182774 */   GIR_MakeTempReg, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182778 */   GIR_BuildMI, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182783 */   GIR_AddTempRegister, /*InsnID*//* 138(*/0x8A, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182790 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182793 */   GIR_MakeTempReg, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182797 */   GIR_BuildMI, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182802 */   GIR_AddTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182809 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 137(*/0x89, 0x01/*)*/,
     /* 182814 */   GIR_AddSimpleTempRegister, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*TempRegID*//* 138(*/0x8A, 0x01/*)*/,
     /* 182819 */   GIR_AddImm8, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Imm*/1,
     /* 182823 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182829 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 182835 */   GIR_ConstrainOperandRC, /*InsnID*//* 137(*/0x89, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 182841 */   GIR_MakeTempReg, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182845 */   GIR_BuildMI, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 182850 */   GIR_AddTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182857 */   GIR_AddSimpleTempRegister, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*TempRegID*//* 136(*/0x88, 0x01/*)*/,
     /* 182862 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/32,
     /* 182866 */   GIR_AddImm8, /*InsnID*//* 136(*/0x88, 0x01/*)*/, /*Imm*/31,
     /* 182870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 136(*/0x88, 0x01/*)*/,
     /* 182873 */   GIR_MakeTempReg, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182877 */   GIR_BuildMI, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 182882 */   GIR_AddTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182889 */   GIR_AddSimpleTempRegister, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*TempRegID*//* 135(*/0x87, 0x01/*)*/,
     /* 182894 */   GIR_AddImm, /*InsnID*//* 135(*/0x87, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 135(*/0x87, 0x01/*)*/,
     /* 182908 */   GIR_MakeTempReg, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 182912 */   GIR_BuildMI, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 182917 */   GIR_AddTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 133(*/0x85, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182924 */   GIR_AddSimpleTempRegister, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*TempRegID*//* 134(*/0x86, 0x01/*)*/,
     /* 182929 */   GIR_AddImm, /*InsnID*//* 134(*/0x86, 0x01/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 182940 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 134(*/0x86, 0x01/*)*/,
     /* 182943 */   GIR_MakeTempReg, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182947 */   GIR_BuildMI, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 182952 */   GIR_AddTempRegister, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182959 */   GIR_AddImm, /*InsnID*//* 133(*/0x85, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 182970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 133(*/0x85, 0x01/*)*/,
     /* 182973 */   GIR_MakeTempReg, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 182977 */   GIR_BuildMI, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 182982 */   GIR_AddTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182989 */   GIR_AddSimpleTempRegister, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*TempRegID*//* 132(*/0x84, 0x01/*)*/,
     /* 182994 */   GIR_AddImm, /*InsnID*//* 132(*/0x84, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183005 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 132(*/0x84, 0x01/*)*/,
     /* 183008 */   GIR_MakeTempReg, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183012 */   GIR_BuildMI, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183017 */   GIR_AddTempRegister, /*InsnID*//* 131(*/0x83, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 131(*/0x83, 0x01/*)*/,
     /* 183027 */   GIR_MakeTempReg, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183031 */   GIR_BuildMI, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183036 */   GIR_AddTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183043 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 130(*/0x82, 0x01/*)*/,
     /* 183048 */   GIR_AddSimpleTempRegister, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*TempRegID*//* 131(*/0x83, 0x01/*)*/,
     /* 183053 */   GIR_AddImm8, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Imm*/1,
     /* 183057 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183063 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183069 */   GIR_ConstrainOperandRC, /*InsnID*//* 130(*/0x82, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183075 */   GIR_MakeTempReg, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 183079 */   GIR_BuildMI, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183084 */   GIR_AddTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183091 */   GIR_AddSimpleTempRegister, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*TempRegID*//* 129(*/0x81, 0x01/*)*/,
     /* 183096 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/32,
     /* 183100 */   GIR_AddImm8, /*InsnID*//* 129(*/0x81, 0x01/*)*/, /*Imm*/31,
     /* 183104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 129(*/0x81, 0x01/*)*/,
     /* 183107 */   GIR_MakeTempReg, /*TempRegID*/127, /*TypeID*/GILLT_s64,
     /* 183110 */   GIR_BuildMI, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183115 */   GIR_AddTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*/127, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183121 */   GIR_AddSimpleTempRegister, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*TempRegID*//* 128(*/0x80, 0x01/*)*/,
     /* 183126 */   GIR_AddImm, /*InsnID*//* 128(*/0x80, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 183137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 128(*/0x80, 0x01/*)*/,
     /* 183140 */   GIR_MakeTempReg, /*TempRegID*/126, /*TypeID*/GILLT_s64,
     /* 183143 */   GIR_BuildMI, /*InsnID*/127, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183147 */   GIR_AddTempRegister, /*InsnID*/127, /*TempRegID*/126, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183152 */   GIR_AddSimpleTempRegister, /*InsnID*/127, /*TempRegID*/127,
     /* 183155 */   GIR_AddImm, /*InsnID*/127, /*Imm*/GIMT_Encode8(52428),
     /* 183165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/127,
     /* 183167 */   GIR_MakeTempReg, /*TempRegID*/125, /*TypeID*/GILLT_s32,
     /* 183170 */   GIR_BuildMI, /*InsnID*/126, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183174 */   GIR_AddTempRegister, /*InsnID*/126, /*TempRegID*/125, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183179 */   GIR_AddImm, /*InsnID*/126, /*Imm*/GIMT_Encode8(43690),
     /* 183189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/126,
     /* 183191 */   GIR_MakeTempReg, /*TempRegID*/124, /*TypeID*/GILLT_s32,
     /* 183194 */   GIR_BuildMI, /*InsnID*/125, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183198 */   GIR_AddTempRegister, /*InsnID*/125, /*TempRegID*/124, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183203 */   GIR_AddSimpleTempRegister, /*InsnID*/125, /*TempRegID*/125,
     /* 183206 */   GIR_AddImm, /*InsnID*/125, /*Imm*/GIMT_Encode8(43690),
     /* 183216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/125,
     /* 183218 */   GIR_MakeTempReg, /*TempRegID*/123, /*TypeID*/GILLT_s64,
     /* 183221 */   GIR_BuildMI, /*InsnID*/124, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183225 */   GIR_AddTempRegister, /*InsnID*/124, /*TempRegID*/123, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/124,
     /* 183232 */   GIR_MakeTempReg, /*TempRegID*/122, /*TypeID*/GILLT_s64,
     /* 183235 */   GIR_BuildMI, /*InsnID*/123, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183239 */   GIR_AddTempRegister, /*InsnID*/123, /*TempRegID*/122, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183244 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/123,
     /* 183247 */   GIR_AddSimpleTempRegister, /*InsnID*/123, /*TempRegID*/124,
     /* 183250 */   GIR_AddImm8, /*InsnID*/123, /*Imm*/1,
     /* 183253 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183258 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183263 */   GIR_ConstrainOperandRC, /*InsnID*/123, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183268 */   GIR_MakeTempReg, /*TempRegID*/121, /*TypeID*/GILLT_s64,
     /* 183271 */   GIR_BuildMI, /*InsnID*/122, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183275 */   GIR_AddTempRegister, /*InsnID*/122, /*TempRegID*/121, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183280 */   GIR_AddSimpleTempRegister, /*InsnID*/122, /*TempRegID*/122,
     /* 183283 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/32,
     /* 183286 */   GIR_AddImm8, /*InsnID*/122, /*Imm*/31,
     /* 183289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/122,
     /* 183291 */   GIR_MakeTempReg, /*TempRegID*/120, /*TypeID*/GILLT_s64,
     /* 183294 */   GIR_BuildMI, /*InsnID*/121, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183298 */   GIR_AddTempRegister, /*InsnID*/121, /*TempRegID*/120, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183303 */   GIR_AddSimpleTempRegister, /*InsnID*/121, /*TempRegID*/121,
     /* 183306 */   GIR_AddImm, /*InsnID*/121, /*Imm*/GIMT_Encode8(43690),
     /* 183316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/121,
     /* 183318 */   GIR_MakeTempReg, /*TempRegID*/119, /*TypeID*/GILLT_s64,
     /* 183321 */   GIR_BuildMI, /*InsnID*/120, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183325 */   GIR_AddTempRegister, /*InsnID*/120, /*TempRegID*/119, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183330 */   GIR_AddSimpleTempRegister, /*InsnID*/120, /*TempRegID*/120,
     /* 183333 */   GIR_AddImm, /*InsnID*/120, /*Imm*/GIMT_Encode8(43690),
     /* 183343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/120,
     /* 183345 */   GIR_MakeTempReg, /*TempRegID*/118, /*TypeID*/GILLT_s64,
     /* 183348 */   GIR_BuildMI, /*InsnID*/119, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183352 */   GIR_AddTempRegister, /*InsnID*/119, /*TempRegID*/118, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183357 */   GIR_Copy, /*NewInsnID*/119, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183361 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/1,
     /* 183364 */   GIR_AddImm8, /*InsnID*/119, /*Imm*/62,
     /* 183367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/119,
     /* 183369 */   GIR_MakeTempReg, /*TempRegID*/117, /*TypeID*/GILLT_s64,
     /* 183372 */   GIR_BuildMI, /*InsnID*/118, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183376 */   GIR_AddTempRegister, /*InsnID*/118, /*TempRegID*/117, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183381 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/118,
     /* 183384 */   GIR_AddSimpleTempRegister, /*InsnID*/118, /*TempRegID*/119,
     /* 183387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/118,
     /* 183389 */   GIR_MakeTempReg, /*TempRegID*/116, /*TypeID*/GILLT_s32,
     /* 183392 */   GIR_BuildMI, /*InsnID*/117, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183396 */   GIR_AddTempRegister, /*InsnID*/117, /*TempRegID*/116, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183401 */   GIR_AddImm, /*InsnID*/117, /*Imm*/GIMT_Encode8(21845),
     /* 183411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/117,
     /* 183413 */   GIR_MakeTempReg, /*TempRegID*/115, /*TypeID*/GILLT_s32,
     /* 183416 */   GIR_BuildMI, /*InsnID*/116, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183420 */   GIR_AddTempRegister, /*InsnID*/116, /*TempRegID*/115, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183425 */   GIR_AddSimpleTempRegister, /*InsnID*/116, /*TempRegID*/116,
     /* 183428 */   GIR_AddImm, /*InsnID*/116, /*Imm*/GIMT_Encode8(21845),
     /* 183438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/116,
     /* 183440 */   GIR_MakeTempReg, /*TempRegID*/114, /*TypeID*/GILLT_s64,
     /* 183443 */   GIR_BuildMI, /*InsnID*/115, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183447 */   GIR_AddTempRegister, /*InsnID*/115, /*TempRegID*/114, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/115,
     /* 183454 */   GIR_MakeTempReg, /*TempRegID*/113, /*TypeID*/GILLT_s64,
     /* 183457 */   GIR_BuildMI, /*InsnID*/114, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183461 */   GIR_AddTempRegister, /*InsnID*/114, /*TempRegID*/113, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183466 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/114,
     /* 183469 */   GIR_AddSimpleTempRegister, /*InsnID*/114, /*TempRegID*/115,
     /* 183472 */   GIR_AddImm8, /*InsnID*/114, /*Imm*/1,
     /* 183475 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183480 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183485 */   GIR_ConstrainOperandRC, /*InsnID*/114, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183490 */   GIR_MakeTempReg, /*TempRegID*/112, /*TypeID*/GILLT_s64,
     /* 183493 */   GIR_BuildMI, /*InsnID*/113, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183497 */   GIR_AddTempRegister, /*InsnID*/113, /*TempRegID*/112, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183502 */   GIR_AddSimpleTempRegister, /*InsnID*/113, /*TempRegID*/113,
     /* 183505 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/32,
     /* 183508 */   GIR_AddImm8, /*InsnID*/113, /*Imm*/31,
     /* 183511 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/113,
     /* 183513 */   GIR_MakeTempReg, /*TempRegID*/111, /*TypeID*/GILLT_s64,
     /* 183516 */   GIR_BuildMI, /*InsnID*/112, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183520 */   GIR_AddTempRegister, /*InsnID*/112, /*TempRegID*/111, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183525 */   GIR_AddSimpleTempRegister, /*InsnID*/112, /*TempRegID*/112,
     /* 183528 */   GIR_AddImm, /*InsnID*/112, /*Imm*/GIMT_Encode8(21845),
     /* 183538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/112,
     /* 183540 */   GIR_MakeTempReg, /*TempRegID*/110, /*TypeID*/GILLT_s64,
     /* 183543 */   GIR_BuildMI, /*InsnID*/111, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183547 */   GIR_AddTempRegister, /*InsnID*/111, /*TempRegID*/110, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183552 */   GIR_AddSimpleTempRegister, /*InsnID*/111, /*TempRegID*/111,
     /* 183555 */   GIR_AddImm, /*InsnID*/111, /*Imm*/GIMT_Encode8(21845),
     /* 183565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/111,
     /* 183567 */   GIR_MakeTempReg, /*TempRegID*/109, /*TypeID*/GILLT_s64,
     /* 183570 */   GIR_BuildMI, /*InsnID*/110, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 183574 */   GIR_AddTempRegister, /*InsnID*/110, /*TempRegID*/109, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183579 */   GIR_Copy, /*NewInsnID*/110, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 183583 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/63,
     /* 183586 */   GIR_AddImm8, /*InsnID*/110, /*Imm*/1,
     /* 183589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/110,
     /* 183591 */   GIR_MakeTempReg, /*TempRegID*/108, /*TypeID*/GILLT_s64,
     /* 183594 */   GIR_BuildMI, /*InsnID*/109, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183598 */   GIR_AddTempRegister, /*InsnID*/109, /*TempRegID*/108, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183603 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/109,
     /* 183606 */   GIR_AddSimpleTempRegister, /*InsnID*/109, /*TempRegID*/110,
     /* 183609 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/109,
     /* 183611 */   GIR_MakeTempReg, /*TempRegID*/107, /*TypeID*/GILLT_s64,
     /* 183614 */   GIR_BuildMI, /*InsnID*/108, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 183618 */   GIR_AddTempRegister, /*InsnID*/108, /*TempRegID*/107, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183623 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/108,
     /* 183626 */   GIR_AddSimpleTempRegister, /*InsnID*/108, /*TempRegID*/117,
     /* 183629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/108,
     /* 183631 */   GIR_MakeTempReg, /*TempRegID*/106, /*TypeID*/GILLT_s64,
     /* 183634 */   GIR_BuildMI, /*InsnID*/107, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183638 */   GIR_AddTempRegister, /*InsnID*/107, /*TempRegID*/106, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183643 */   GIR_AddSimpleTempRegister, /*InsnID*/107, /*TempRegID*/107,
     /* 183646 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/2,
     /* 183649 */   GIR_AddImm8, /*InsnID*/107, /*Imm*/61,
     /* 183652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/107,
     /* 183654 */   GIR_MakeTempReg, /*TempRegID*/105, /*TypeID*/GILLT_s64,
     /* 183657 */   GIR_BuildMI, /*InsnID*/106, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 183661 */   GIR_AddTempRegister, /*InsnID*/106, /*TempRegID*/105, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183666 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/106,
     /* 183669 */   GIR_AddSimpleTempRegister, /*InsnID*/106, /*TempRegID*/126,
     /* 183672 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/106,
     /* 183674 */   GIR_MakeTempReg, /*TempRegID*/104, /*TypeID*/GILLT_s32,
     /* 183677 */   GIR_BuildMI, /*InsnID*/105, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183681 */   GIR_AddTempRegister, /*InsnID*/105, /*TempRegID*/104, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183686 */   GIR_AddImm, /*InsnID*/105, /*Imm*/GIMT_Encode8(13107),
     /* 183696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/105,
     /* 183698 */   GIR_MakeTempReg, /*TempRegID*/103, /*TypeID*/GILLT_s32,
     /* 183701 */   GIR_BuildMI, /*InsnID*/104, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183705 */   GIR_AddTempRegister, /*InsnID*/104, /*TempRegID*/103, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183710 */   GIR_AddSimpleTempRegister, /*InsnID*/104, /*TempRegID*/104,
     /* 183713 */   GIR_AddImm, /*InsnID*/104, /*Imm*/GIMT_Encode8(13107),
     /* 183723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/104,
     /* 183725 */   GIR_MakeTempReg, /*TempRegID*/102, /*TypeID*/GILLT_s64,
     /* 183728 */   GIR_BuildMI, /*InsnID*/103, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183732 */   GIR_AddTempRegister, /*InsnID*/103, /*TempRegID*/102, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/103,
     /* 183739 */   GIR_MakeTempReg, /*TempRegID*/101, /*TypeID*/GILLT_s64,
     /* 183742 */   GIR_BuildMI, /*InsnID*/102, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183746 */   GIR_AddTempRegister, /*InsnID*/102, /*TempRegID*/101, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183751 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/102,
     /* 183754 */   GIR_AddSimpleTempRegister, /*InsnID*/102, /*TempRegID*/103,
     /* 183757 */   GIR_AddImm8, /*InsnID*/102, /*Imm*/1,
     /* 183760 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183765 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183770 */   GIR_ConstrainOperandRC, /*InsnID*/102, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183775 */   GIR_MakeTempReg, /*TempRegID*/100, /*TypeID*/GILLT_s64,
     /* 183778 */   GIR_BuildMI, /*InsnID*/101, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183782 */   GIR_AddTempRegister, /*InsnID*/101, /*TempRegID*/100, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183787 */   GIR_AddSimpleTempRegister, /*InsnID*/101, /*TempRegID*/101,
     /* 183790 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/32,
     /* 183793 */   GIR_AddImm8, /*InsnID*/101, /*Imm*/31,
     /* 183796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/101,
     /* 183798 */   GIR_MakeTempReg, /*TempRegID*/99, /*TypeID*/GILLT_s64,
     /* 183801 */   GIR_BuildMI, /*InsnID*/100, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183805 */   GIR_AddTempRegister, /*InsnID*/100, /*TempRegID*/99, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183810 */   GIR_AddSimpleTempRegister, /*InsnID*/100, /*TempRegID*/100,
     /* 183813 */   GIR_AddImm, /*InsnID*/100, /*Imm*/GIMT_Encode8(13107),
     /* 183823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/100,
     /* 183825 */   GIR_MakeTempReg, /*TempRegID*/98, /*TypeID*/GILLT_s64,
     /* 183828 */   GIR_BuildMI, /*InsnID*/99, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 183832 */   GIR_AddTempRegister, /*InsnID*/99, /*TempRegID*/98, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183837 */   GIR_AddSimpleTempRegister, /*InsnID*/99, /*TempRegID*/99,
     /* 183840 */   GIR_AddImm, /*InsnID*/99, /*Imm*/GIMT_Encode8(13107),
     /* 183850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/99,
     /* 183852 */   GIR_MakeTempReg, /*TempRegID*/97, /*TypeID*/GILLT_s32,
     /* 183855 */   GIR_BuildMI, /*InsnID*/98, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 183859 */   GIR_AddTempRegister, /*InsnID*/98, /*TempRegID*/97, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183864 */   GIR_AddImm, /*InsnID*/98, /*Imm*/GIMT_Encode8(43690),
     /* 183874 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/98,
     /* 183876 */   GIR_MakeTempReg, /*TempRegID*/96, /*TypeID*/GILLT_s32,
     /* 183879 */   GIR_BuildMI, /*InsnID*/97, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 183883 */   GIR_AddTempRegister, /*InsnID*/97, /*TempRegID*/96, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183888 */   GIR_AddSimpleTempRegister, /*InsnID*/97, /*TempRegID*/97,
     /* 183891 */   GIR_AddImm, /*InsnID*/97, /*Imm*/GIMT_Encode8(43690),
     /* 183901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/97,
     /* 183903 */   GIR_MakeTempReg, /*TempRegID*/95, /*TypeID*/GILLT_s64,
     /* 183906 */   GIR_BuildMI, /*InsnID*/96, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183910 */   GIR_AddTempRegister, /*InsnID*/96, /*TempRegID*/95, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/96,
     /* 183917 */   GIR_MakeTempReg, /*TempRegID*/94, /*TypeID*/GILLT_s64,
     /* 183920 */   GIR_BuildMI, /*InsnID*/95, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183924 */   GIR_AddTempRegister, /*InsnID*/95, /*TempRegID*/94, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183929 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/95,
     /* 183932 */   GIR_AddSimpleTempRegister, /*InsnID*/95, /*TempRegID*/96,
     /* 183935 */   GIR_AddImm8, /*InsnID*/95, /*Imm*/1,
     /* 183938 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183943 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 183948 */   GIR_ConstrainOperandRC, /*InsnID*/95, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 183953 */   GIR_MakeTempReg, /*TempRegID*/93, /*TypeID*/GILLT_s64,
     /* 183956 */   GIR_BuildMI, /*InsnID*/94, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 183960 */   GIR_AddTempRegister, /*InsnID*/94, /*TempRegID*/93, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183965 */   GIR_AddSimpleTempRegister, /*InsnID*/94, /*TempRegID*/94,
     /* 183968 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/32,
     /* 183971 */   GIR_AddImm8, /*InsnID*/94, /*Imm*/31,
     /* 183974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/94,
     /* 183976 */   GIR_MakeTempReg, /*TempRegID*/92, /*TypeID*/GILLT_s64,
     /* 183979 */   GIR_BuildMI, /*InsnID*/93, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 183983 */   GIR_AddTempRegister, /*InsnID*/93, /*TempRegID*/92, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183988 */   GIR_AddSimpleTempRegister, /*InsnID*/93, /*TempRegID*/93,
     /* 183991 */   GIR_AddImm, /*InsnID*/93, /*Imm*/GIMT_Encode8(43690),
     /* 184001 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/93,
     /* 184003 */   GIR_MakeTempReg, /*TempRegID*/91, /*TypeID*/GILLT_s64,
     /* 184006 */   GIR_BuildMI, /*InsnID*/92, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184010 */   GIR_AddTempRegister, /*InsnID*/92, /*TempRegID*/91, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184015 */   GIR_AddSimpleTempRegister, /*InsnID*/92, /*TempRegID*/92,
     /* 184018 */   GIR_AddImm, /*InsnID*/92, /*Imm*/GIMT_Encode8(43690),
     /* 184028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/92,
     /* 184030 */   GIR_MakeTempReg, /*TempRegID*/90, /*TypeID*/GILLT_s64,
     /* 184033 */   GIR_BuildMI, /*InsnID*/91, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184037 */   GIR_AddTempRegister, /*InsnID*/91, /*TempRegID*/90, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184042 */   GIR_Copy, /*NewInsnID*/91, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184046 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/1,
     /* 184049 */   GIR_AddImm8, /*InsnID*/91, /*Imm*/62,
     /* 184052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/91,
     /* 184054 */   GIR_MakeTempReg, /*TempRegID*/89, /*TypeID*/GILLT_s64,
     /* 184057 */   GIR_BuildMI, /*InsnID*/90, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184061 */   GIR_AddTempRegister, /*InsnID*/90, /*TempRegID*/89, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184066 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/90,
     /* 184069 */   GIR_AddSimpleTempRegister, /*InsnID*/90, /*TempRegID*/91,
     /* 184072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/90,
     /* 184074 */   GIR_MakeTempReg, /*TempRegID*/88, /*TypeID*/GILLT_s32,
     /* 184077 */   GIR_BuildMI, /*InsnID*/89, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184081 */   GIR_AddTempRegister, /*InsnID*/89, /*TempRegID*/88, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184086 */   GIR_AddImm, /*InsnID*/89, /*Imm*/GIMT_Encode8(21845),
     /* 184096 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/89,
     /* 184098 */   GIR_MakeTempReg, /*TempRegID*/87, /*TypeID*/GILLT_s32,
     /* 184101 */   GIR_BuildMI, /*InsnID*/88, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184105 */   GIR_AddTempRegister, /*InsnID*/88, /*TempRegID*/87, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184110 */   GIR_AddSimpleTempRegister, /*InsnID*/88, /*TempRegID*/88,
     /* 184113 */   GIR_AddImm, /*InsnID*/88, /*Imm*/GIMT_Encode8(21845),
     /* 184123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/88,
     /* 184125 */   GIR_MakeTempReg, /*TempRegID*/86, /*TypeID*/GILLT_s64,
     /* 184128 */   GIR_BuildMI, /*InsnID*/87, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184132 */   GIR_AddTempRegister, /*InsnID*/87, /*TempRegID*/86, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/87,
     /* 184139 */   GIR_MakeTempReg, /*TempRegID*/85, /*TypeID*/GILLT_s64,
     /* 184142 */   GIR_BuildMI, /*InsnID*/86, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184146 */   GIR_AddTempRegister, /*InsnID*/86, /*TempRegID*/85, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184151 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/86,
     /* 184154 */   GIR_AddSimpleTempRegister, /*InsnID*/86, /*TempRegID*/87,
     /* 184157 */   GIR_AddImm8, /*InsnID*/86, /*Imm*/1,
     /* 184160 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184165 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184170 */   GIR_ConstrainOperandRC, /*InsnID*/86, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184175 */   GIR_MakeTempReg, /*TempRegID*/84, /*TypeID*/GILLT_s64,
     /* 184178 */   GIR_BuildMI, /*InsnID*/85, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184182 */   GIR_AddTempRegister, /*InsnID*/85, /*TempRegID*/84, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184187 */   GIR_AddSimpleTempRegister, /*InsnID*/85, /*TempRegID*/85,
     /* 184190 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/32,
     /* 184193 */   GIR_AddImm8, /*InsnID*/85, /*Imm*/31,
     /* 184196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/85,
     /* 184198 */   GIR_MakeTempReg, /*TempRegID*/83, /*TypeID*/GILLT_s64,
     /* 184201 */   GIR_BuildMI, /*InsnID*/84, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184205 */   GIR_AddTempRegister, /*InsnID*/84, /*TempRegID*/83, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184210 */   GIR_AddSimpleTempRegister, /*InsnID*/84, /*TempRegID*/84,
     /* 184213 */   GIR_AddImm, /*InsnID*/84, /*Imm*/GIMT_Encode8(21845),
     /* 184223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/84,
     /* 184225 */   GIR_MakeTempReg, /*TempRegID*/82, /*TypeID*/GILLT_s64,
     /* 184228 */   GIR_BuildMI, /*InsnID*/83, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184232 */   GIR_AddTempRegister, /*InsnID*/83, /*TempRegID*/82, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184237 */   GIR_AddSimpleTempRegister, /*InsnID*/83, /*TempRegID*/83,
     /* 184240 */   GIR_AddImm, /*InsnID*/83, /*Imm*/GIMT_Encode8(21845),
     /* 184250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/83,
     /* 184252 */   GIR_MakeTempReg, /*TempRegID*/81, /*TypeID*/GILLT_s64,
     /* 184255 */   GIR_BuildMI, /*InsnID*/82, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184259 */   GIR_AddTempRegister, /*InsnID*/82, /*TempRegID*/81, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184264 */   GIR_Copy, /*NewInsnID*/82, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184268 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/63,
     /* 184271 */   GIR_AddImm8, /*InsnID*/82, /*Imm*/1,
     /* 184274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/82,
     /* 184276 */   GIR_MakeTempReg, /*TempRegID*/80, /*TypeID*/GILLT_s64,
     /* 184279 */   GIR_BuildMI, /*InsnID*/81, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184283 */   GIR_AddTempRegister, /*InsnID*/81, /*TempRegID*/80, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184288 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/81,
     /* 184291 */   GIR_AddSimpleTempRegister, /*InsnID*/81, /*TempRegID*/82,
     /* 184294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/81,
     /* 184296 */   GIR_MakeTempReg, /*TempRegID*/79, /*TypeID*/GILLT_s64,
     /* 184299 */   GIR_BuildMI, /*InsnID*/80, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184303 */   GIR_AddTempRegister, /*InsnID*/80, /*TempRegID*/79, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184308 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/80,
     /* 184311 */   GIR_AddSimpleTempRegister, /*InsnID*/80, /*TempRegID*/89,
     /* 184314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/80,
     /* 184316 */   GIR_MakeTempReg, /*TempRegID*/78, /*TypeID*/GILLT_s64,
     /* 184319 */   GIR_BuildMI, /*InsnID*/79, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 184323 */   GIR_AddTempRegister, /*InsnID*/79, /*TempRegID*/78, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184328 */   GIR_AddSimpleTempRegister, /*InsnID*/79, /*TempRegID*/79,
     /* 184331 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/62,
     /* 184334 */   GIR_AddImm8, /*InsnID*/79, /*Imm*/2,
     /* 184337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/79,
     /* 184339 */   GIR_MakeTempReg, /*TempRegID*/77, /*TypeID*/GILLT_s64,
     /* 184342 */   GIR_BuildMI, /*InsnID*/78, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184346 */   GIR_AddTempRegister, /*InsnID*/78, /*TempRegID*/77, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184351 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/78,
     /* 184354 */   GIR_AddSimpleTempRegister, /*InsnID*/78, /*TempRegID*/98,
     /* 184357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/78,
     /* 184359 */   GIR_MakeTempReg, /*TempRegID*/76, /*TypeID*/GILLT_s64,
     /* 184362 */   GIR_BuildMI, /*InsnID*/77, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 184366 */   GIR_AddTempRegister, /*InsnID*/77, /*TempRegID*/76, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184371 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/77,
     /* 184374 */   GIR_AddSimpleTempRegister, /*InsnID*/77, /*TempRegID*/105,
     /* 184377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/77,
     /* 184379 */   GIR_MakeTempReg, /*TempRegID*/75, /*TypeID*/GILLT_s64,
     /* 184382 */   GIR_BuildMI, /*InsnID*/76, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184386 */   GIR_AddTempRegister, /*InsnID*/76, /*TempRegID*/75, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184391 */   GIR_AddSimpleTempRegister, /*InsnID*/76, /*TempRegID*/76,
     /* 184394 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/4,
     /* 184397 */   GIR_AddImm8, /*InsnID*/76, /*Imm*/59,
     /* 184400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/76,
     /* 184402 */   GIR_MakeTempReg, /*TempRegID*/74, /*TypeID*/GILLT_s64,
     /* 184405 */   GIR_BuildMI, /*InsnID*/75, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184409 */   GIR_AddTempRegister, /*InsnID*/75, /*TempRegID*/74, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184414 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*/75,
     /* 184417 */   GIR_AddSimpleTempRegister, /*InsnID*/75, /*TempRegID*//* 133(*/0x85, 0x01/*)*/,
     /* 184421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/75,
     /* 184423 */   GIR_MakeTempReg, /*TempRegID*/73, /*TypeID*/GILLT_s32,
     /* 184426 */   GIR_BuildMI, /*InsnID*/74, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184430 */   GIR_AddTempRegister, /*InsnID*/74, /*TempRegID*/73, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184435 */   GIR_AddImm, /*InsnID*/74, /*Imm*/GIMT_Encode8(3855),
     /* 184445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/74,
     /* 184447 */   GIR_MakeTempReg, /*TempRegID*/72, /*TypeID*/GILLT_s32,
     /* 184450 */   GIR_BuildMI, /*InsnID*/73, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184454 */   GIR_AddTempRegister, /*InsnID*/73, /*TempRegID*/72, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184459 */   GIR_AddSimpleTempRegister, /*InsnID*/73, /*TempRegID*/73,
     /* 184462 */   GIR_AddImm, /*InsnID*/73, /*Imm*/GIMT_Encode8(3855),
     /* 184472 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/73,
     /* 184474 */   GIR_MakeTempReg, /*TempRegID*/71, /*TypeID*/GILLT_s64,
     /* 184477 */   GIR_BuildMI, /*InsnID*/72, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184481 */   GIR_AddTempRegister, /*InsnID*/72, /*TempRegID*/71, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/72,
     /* 184488 */   GIR_MakeTempReg, /*TempRegID*/70, /*TypeID*/GILLT_s64,
     /* 184491 */   GIR_BuildMI, /*InsnID*/71, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184495 */   GIR_AddTempRegister, /*InsnID*/71, /*TempRegID*/70, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184500 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/71,
     /* 184503 */   GIR_AddSimpleTempRegister, /*InsnID*/71, /*TempRegID*/72,
     /* 184506 */   GIR_AddImm8, /*InsnID*/71, /*Imm*/1,
     /* 184509 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184514 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184519 */   GIR_ConstrainOperandRC, /*InsnID*/71, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184524 */   GIR_MakeTempReg, /*TempRegID*/69, /*TypeID*/GILLT_s64,
     /* 184527 */   GIR_BuildMI, /*InsnID*/70, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184531 */   GIR_AddTempRegister, /*InsnID*/70, /*TempRegID*/69, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184536 */   GIR_AddSimpleTempRegister, /*InsnID*/70, /*TempRegID*/70,
     /* 184539 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/32,
     /* 184542 */   GIR_AddImm8, /*InsnID*/70, /*Imm*/31,
     /* 184545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/70,
     /* 184547 */   GIR_MakeTempReg, /*TempRegID*/68, /*TypeID*/GILLT_s64,
     /* 184550 */   GIR_BuildMI, /*InsnID*/69, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184554 */   GIR_AddTempRegister, /*InsnID*/69, /*TempRegID*/68, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184559 */   GIR_AddSimpleTempRegister, /*InsnID*/69, /*TempRegID*/69,
     /* 184562 */   GIR_AddImm, /*InsnID*/69, /*Imm*/GIMT_Encode8(3855),
     /* 184572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/69,
     /* 184574 */   GIR_MakeTempReg, /*TempRegID*/67, /*TypeID*/GILLT_s64,
     /* 184577 */   GIR_BuildMI, /*InsnID*/68, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184581 */   GIR_AddTempRegister, /*InsnID*/68, /*TempRegID*/67, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184586 */   GIR_AddSimpleTempRegister, /*InsnID*/68, /*TempRegID*/68,
     /* 184589 */   GIR_AddImm, /*InsnID*/68, /*Imm*/GIMT_Encode8(3855),
     /* 184599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/68,
     /* 184601 */   GIR_MakeTempReg, /*TempRegID*/66, /*TypeID*/GILLT_s32,
     /* 184604 */   GIR_BuildMI, /*InsnID*/67, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184608 */   GIR_AddTempRegister, /*InsnID*/67, /*TempRegID*/66, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184613 */   GIR_AddImm, /*InsnID*/67, /*Imm*/GIMT_Encode8(52428),
     /* 184623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/67,
     /* 184625 */   GIR_MakeTempReg, /*TempRegID*/65, /*TypeID*/GILLT_s32,
     /* 184628 */   GIR_BuildMI, /*InsnID*/66, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184632 */   GIR_AddTempRegister, /*InsnID*/66, /*TempRegID*/65, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184637 */   GIR_AddSimpleTempRegister, /*InsnID*/66, /*TempRegID*/66,
     /* 184640 */   GIR_AddImm, /*InsnID*/66, /*Imm*/GIMT_Encode8(52428),
     /* 184650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/66,
     /* 184652 */   GIR_MakeTempReg, /*TempRegID*/64, /*TypeID*/GILLT_s64,
     /* 184655 */   GIR_BuildMI, /*InsnID*/65, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184659 */   GIR_AddTempRegister, /*InsnID*/65, /*TempRegID*/64, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/65,
     /* 184666 */   GIR_MakeTempReg, /*TempRegID*/63, /*TypeID*/GILLT_s64,
     /* 184669 */   GIR_BuildMI, /*InsnID*/64, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184673 */   GIR_AddTempRegister, /*InsnID*/64, /*TempRegID*/63, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184678 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/64,
     /* 184681 */   GIR_AddSimpleTempRegister, /*InsnID*/64, /*TempRegID*/65,
     /* 184684 */   GIR_AddImm8, /*InsnID*/64, /*Imm*/1,
     /* 184687 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184692 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184697 */   GIR_ConstrainOperandRC, /*InsnID*/64, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184702 */   GIR_MakeTempReg, /*TempRegID*/62, /*TypeID*/GILLT_s64,
     /* 184705 */   GIR_BuildMI, /*InsnID*/63, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184709 */   GIR_AddTempRegister, /*InsnID*/63, /*TempRegID*/62, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184714 */   GIR_AddSimpleTempRegister, /*InsnID*/63, /*TempRegID*/63,
     /* 184717 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/32,
     /* 184720 */   GIR_AddImm8, /*InsnID*/63, /*Imm*/31,
     /* 184723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/63,
     /* 184725 */   GIR_MakeTempReg, /*TempRegID*/61, /*TypeID*/GILLT_s64,
     /* 184728 */   GIR_BuildMI, /*InsnID*/62, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184732 */   GIR_AddTempRegister, /*InsnID*/62, /*TempRegID*/61, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184737 */   GIR_AddSimpleTempRegister, /*InsnID*/62, /*TempRegID*/62,
     /* 184740 */   GIR_AddImm, /*InsnID*/62, /*Imm*/GIMT_Encode8(52428),
     /* 184750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/62,
     /* 184752 */   GIR_MakeTempReg, /*TempRegID*/60, /*TypeID*/GILLT_s64,
     /* 184755 */   GIR_BuildMI, /*InsnID*/61, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184759 */   GIR_AddTempRegister, /*InsnID*/61, /*TempRegID*/60, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184764 */   GIR_AddSimpleTempRegister, /*InsnID*/61, /*TempRegID*/61,
     /* 184767 */   GIR_AddImm, /*InsnID*/61, /*Imm*/GIMT_Encode8(52428),
     /* 184777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/61,
     /* 184779 */   GIR_MakeTempReg, /*TempRegID*/59, /*TypeID*/GILLT_s32,
     /* 184782 */   GIR_BuildMI, /*InsnID*/60, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 184786 */   GIR_AddTempRegister, /*InsnID*/60, /*TempRegID*/59, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184791 */   GIR_AddImm, /*InsnID*/60, /*Imm*/GIMT_Encode8(43690),
     /* 184801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/60,
     /* 184803 */   GIR_MakeTempReg, /*TempRegID*/58, /*TypeID*/GILLT_s32,
     /* 184806 */   GIR_BuildMI, /*InsnID*/59, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 184810 */   GIR_AddTempRegister, /*InsnID*/59, /*TempRegID*/58, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184815 */   GIR_AddSimpleTempRegister, /*InsnID*/59, /*TempRegID*/59,
     /* 184818 */   GIR_AddImm, /*InsnID*/59, /*Imm*/GIMT_Encode8(43690),
     /* 184828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/59,
     /* 184830 */   GIR_MakeTempReg, /*TempRegID*/57, /*TypeID*/GILLT_s64,
     /* 184833 */   GIR_BuildMI, /*InsnID*/58, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 184837 */   GIR_AddTempRegister, /*InsnID*/58, /*TempRegID*/57, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184842 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/58,
     /* 184844 */   GIR_MakeTempReg, /*TempRegID*/56, /*TypeID*/GILLT_s64,
     /* 184847 */   GIR_BuildMI, /*InsnID*/57, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 184851 */   GIR_AddTempRegister, /*InsnID*/57, /*TempRegID*/56, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184856 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/57,
     /* 184859 */   GIR_AddSimpleTempRegister, /*InsnID*/57, /*TempRegID*/58,
     /* 184862 */   GIR_AddImm8, /*InsnID*/57, /*Imm*/1,
     /* 184865 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184870 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 184875 */   GIR_ConstrainOperandRC, /*InsnID*/57, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 184880 */   GIR_MakeTempReg, /*TempRegID*/55, /*TypeID*/GILLT_s64,
     /* 184883 */   GIR_BuildMI, /*InsnID*/56, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184887 */   GIR_AddTempRegister, /*InsnID*/56, /*TempRegID*/55, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184892 */   GIR_AddSimpleTempRegister, /*InsnID*/56, /*TempRegID*/56,
     /* 184895 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/32,
     /* 184898 */   GIR_AddImm8, /*InsnID*/56, /*Imm*/31,
     /* 184901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/56,
     /* 184903 */   GIR_MakeTempReg, /*TempRegID*/54, /*TypeID*/GILLT_s64,
     /* 184906 */   GIR_BuildMI, /*InsnID*/55, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 184910 */   GIR_AddTempRegister, /*InsnID*/55, /*TempRegID*/54, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184915 */   GIR_AddSimpleTempRegister, /*InsnID*/55, /*TempRegID*/55,
     /* 184918 */   GIR_AddImm, /*InsnID*/55, /*Imm*/GIMT_Encode8(43690),
     /* 184928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/55,
     /* 184930 */   GIR_MakeTempReg, /*TempRegID*/53, /*TypeID*/GILLT_s64,
     /* 184933 */   GIR_BuildMI, /*InsnID*/54, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 184937 */   GIR_AddTempRegister, /*InsnID*/54, /*TempRegID*/53, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184942 */   GIR_AddSimpleTempRegister, /*InsnID*/54, /*TempRegID*/54,
     /* 184945 */   GIR_AddImm, /*InsnID*/54, /*Imm*/GIMT_Encode8(43690),
     /* 184955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/54,
     /* 184957 */   GIR_MakeTempReg, /*TempRegID*/52, /*TypeID*/GILLT_s64,
     /* 184960 */   GIR_BuildMI, /*InsnID*/53, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 184964 */   GIR_AddTempRegister, /*InsnID*/53, /*TempRegID*/52, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184969 */   GIR_Copy, /*NewInsnID*/53, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 184973 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/1,
     /* 184976 */   GIR_AddImm8, /*InsnID*/53, /*Imm*/62,
     /* 184979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/53,
     /* 184981 */   GIR_MakeTempReg, /*TempRegID*/51, /*TypeID*/GILLT_s64,
     /* 184984 */   GIR_BuildMI, /*InsnID*/52, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 184988 */   GIR_AddTempRegister, /*InsnID*/52, /*TempRegID*/51, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 184993 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/52,
     /* 184996 */   GIR_AddSimpleTempRegister, /*InsnID*/52, /*TempRegID*/53,
     /* 184999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/52,
     /* 185001 */   GIR_MakeTempReg, /*TempRegID*/50, /*TypeID*/GILLT_s32,
     /* 185004 */   GIR_BuildMI, /*InsnID*/51, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185008 */   GIR_AddTempRegister, /*InsnID*/51, /*TempRegID*/50, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185013 */   GIR_AddImm, /*InsnID*/51, /*Imm*/GIMT_Encode8(21845),
     /* 185023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/51,
     /* 185025 */   GIR_MakeTempReg, /*TempRegID*/49, /*TypeID*/GILLT_s32,
     /* 185028 */   GIR_BuildMI, /*InsnID*/50, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185032 */   GIR_AddTempRegister, /*InsnID*/50, /*TempRegID*/49, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185037 */   GIR_AddSimpleTempRegister, /*InsnID*/50, /*TempRegID*/50,
     /* 185040 */   GIR_AddImm, /*InsnID*/50, /*Imm*/GIMT_Encode8(21845),
     /* 185050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/50,
     /* 185052 */   GIR_MakeTempReg, /*TempRegID*/48, /*TypeID*/GILLT_s64,
     /* 185055 */   GIR_BuildMI, /*InsnID*/49, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185059 */   GIR_AddTempRegister, /*InsnID*/49, /*TempRegID*/48, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/49,
     /* 185066 */   GIR_MakeTempReg, /*TempRegID*/47, /*TypeID*/GILLT_s64,
     /* 185069 */   GIR_BuildMI, /*InsnID*/48, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185073 */   GIR_AddTempRegister, /*InsnID*/48, /*TempRegID*/47, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185078 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/48,
     /* 185081 */   GIR_AddSimpleTempRegister, /*InsnID*/48, /*TempRegID*/49,
     /* 185084 */   GIR_AddImm8, /*InsnID*/48, /*Imm*/1,
     /* 185087 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185092 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185097 */   GIR_ConstrainOperandRC, /*InsnID*/48, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185102 */   GIR_MakeTempReg, /*TempRegID*/46, /*TypeID*/GILLT_s64,
     /* 185105 */   GIR_BuildMI, /*InsnID*/47, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185109 */   GIR_AddTempRegister, /*InsnID*/47, /*TempRegID*/46, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185114 */   GIR_AddSimpleTempRegister, /*InsnID*/47, /*TempRegID*/47,
     /* 185117 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/32,
     /* 185120 */   GIR_AddImm8, /*InsnID*/47, /*Imm*/31,
     /* 185123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/47,
     /* 185125 */   GIR_MakeTempReg, /*TempRegID*/45, /*TypeID*/GILLT_s64,
     /* 185128 */   GIR_BuildMI, /*InsnID*/46, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185132 */   GIR_AddTempRegister, /*InsnID*/46, /*TempRegID*/45, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185137 */   GIR_AddSimpleTempRegister, /*InsnID*/46, /*TempRegID*/46,
     /* 185140 */   GIR_AddImm, /*InsnID*/46, /*Imm*/GIMT_Encode8(21845),
     /* 185150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/46,
     /* 185152 */   GIR_MakeTempReg, /*TempRegID*/44, /*TypeID*/GILLT_s64,
     /* 185155 */   GIR_BuildMI, /*InsnID*/45, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185159 */   GIR_AddTempRegister, /*InsnID*/45, /*TempRegID*/44, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185164 */   GIR_AddSimpleTempRegister, /*InsnID*/45, /*TempRegID*/45,
     /* 185167 */   GIR_AddImm, /*InsnID*/45, /*Imm*/GIMT_Encode8(21845),
     /* 185177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/45,
     /* 185179 */   GIR_MakeTempReg, /*TempRegID*/43, /*TypeID*/GILLT_s64,
     /* 185182 */   GIR_BuildMI, /*InsnID*/44, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185186 */   GIR_AddTempRegister, /*InsnID*/44, /*TempRegID*/43, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185191 */   GIR_Copy, /*NewInsnID*/44, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185195 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/63,
     /* 185198 */   GIR_AddImm8, /*InsnID*/44, /*Imm*/1,
     /* 185201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/44,
     /* 185203 */   GIR_MakeTempReg, /*TempRegID*/42, /*TypeID*/GILLT_s64,
     /* 185206 */   GIR_BuildMI, /*InsnID*/43, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185210 */   GIR_AddTempRegister, /*InsnID*/43, /*TempRegID*/42, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185215 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/43,
     /* 185218 */   GIR_AddSimpleTempRegister, /*InsnID*/43, /*TempRegID*/44,
     /* 185221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/43,
     /* 185223 */   GIR_MakeTempReg, /*TempRegID*/41, /*TypeID*/GILLT_s64,
     /* 185226 */   GIR_BuildMI, /*InsnID*/42, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185230 */   GIR_AddTempRegister, /*InsnID*/42, /*TempRegID*/41, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185235 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/42,
     /* 185238 */   GIR_AddSimpleTempRegister, /*InsnID*/42, /*TempRegID*/51,
     /* 185241 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/42,
     /* 185243 */   GIR_MakeTempReg, /*TempRegID*/40, /*TypeID*/GILLT_s64,
     /* 185246 */   GIR_BuildMI, /*InsnID*/41, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185250 */   GIR_AddTempRegister, /*InsnID*/41, /*TempRegID*/40, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185255 */   GIR_AddSimpleTempRegister, /*InsnID*/41, /*TempRegID*/41,
     /* 185258 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/2,
     /* 185261 */   GIR_AddImm8, /*InsnID*/41, /*Imm*/61,
     /* 185264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/41,
     /* 185266 */   GIR_MakeTempReg, /*TempRegID*/39, /*TypeID*/GILLT_s64,
     /* 185269 */   GIR_BuildMI, /*InsnID*/40, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185273 */   GIR_AddTempRegister, /*InsnID*/40, /*TempRegID*/39, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185278 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/40,
     /* 185281 */   GIR_AddSimpleTempRegister, /*InsnID*/40, /*TempRegID*/60,
     /* 185284 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/40,
     /* 185286 */   GIR_MakeTempReg, /*TempRegID*/38, /*TypeID*/GILLT_s32,
     /* 185289 */   GIR_BuildMI, /*InsnID*/39, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185293 */   GIR_AddTempRegister, /*InsnID*/39, /*TempRegID*/38, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185298 */   GIR_AddImm, /*InsnID*/39, /*Imm*/GIMT_Encode8(13107),
     /* 185308 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/39,
     /* 185310 */   GIR_MakeTempReg, /*TempRegID*/37, /*TypeID*/GILLT_s32,
     /* 185313 */   GIR_BuildMI, /*InsnID*/38, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185317 */   GIR_AddTempRegister, /*InsnID*/38, /*TempRegID*/37, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185322 */   GIR_AddSimpleTempRegister, /*InsnID*/38, /*TempRegID*/38,
     /* 185325 */   GIR_AddImm, /*InsnID*/38, /*Imm*/GIMT_Encode8(13107),
     /* 185335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/38,
     /* 185337 */   GIR_MakeTempReg, /*TempRegID*/36, /*TypeID*/GILLT_s64,
     /* 185340 */   GIR_BuildMI, /*InsnID*/37, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185344 */   GIR_AddTempRegister, /*InsnID*/37, /*TempRegID*/36, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/37,
     /* 185351 */   GIR_MakeTempReg, /*TempRegID*/35, /*TypeID*/GILLT_s64,
     /* 185354 */   GIR_BuildMI, /*InsnID*/36, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185358 */   GIR_AddTempRegister, /*InsnID*/36, /*TempRegID*/35, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185363 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/36,
     /* 185366 */   GIR_AddSimpleTempRegister, /*InsnID*/36, /*TempRegID*/37,
     /* 185369 */   GIR_AddImm8, /*InsnID*/36, /*Imm*/1,
     /* 185372 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185377 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185382 */   GIR_ConstrainOperandRC, /*InsnID*/36, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185387 */   GIR_MakeTempReg, /*TempRegID*/34, /*TypeID*/GILLT_s64,
     /* 185390 */   GIR_BuildMI, /*InsnID*/35, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185394 */   GIR_AddTempRegister, /*InsnID*/35, /*TempRegID*/34, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185399 */   GIR_AddSimpleTempRegister, /*InsnID*/35, /*TempRegID*/35,
     /* 185402 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/32,
     /* 185405 */   GIR_AddImm8, /*InsnID*/35, /*Imm*/31,
     /* 185408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/35,
     /* 185410 */   GIR_MakeTempReg, /*TempRegID*/33, /*TypeID*/GILLT_s64,
     /* 185413 */   GIR_BuildMI, /*InsnID*/34, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185417 */   GIR_AddTempRegister, /*InsnID*/34, /*TempRegID*/33, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185422 */   GIR_AddSimpleTempRegister, /*InsnID*/34, /*TempRegID*/34,
     /* 185425 */   GIR_AddImm, /*InsnID*/34, /*Imm*/GIMT_Encode8(13107),
     /* 185435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/34,
     /* 185437 */   GIR_MakeTempReg, /*TempRegID*/32, /*TypeID*/GILLT_s64,
     /* 185440 */   GIR_BuildMI, /*InsnID*/33, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185444 */   GIR_AddTempRegister, /*InsnID*/33, /*TempRegID*/32, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185449 */   GIR_AddSimpleTempRegister, /*InsnID*/33, /*TempRegID*/33,
     /* 185452 */   GIR_AddImm, /*InsnID*/33, /*Imm*/GIMT_Encode8(13107),
     /* 185462 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/33,
     /* 185464 */   GIR_MakeTempReg, /*TempRegID*/31, /*TypeID*/GILLT_s32,
     /* 185467 */   GIR_BuildMI, /*InsnID*/32, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185471 */   GIR_AddTempRegister, /*InsnID*/32, /*TempRegID*/31, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185476 */   GIR_AddImm, /*InsnID*/32, /*Imm*/GIMT_Encode8(43690),
     /* 185486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/32,
     /* 185488 */   GIR_MakeTempReg, /*TempRegID*/30, /*TypeID*/GILLT_s32,
     /* 185491 */   GIR_BuildMI, /*InsnID*/31, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185495 */   GIR_AddTempRegister, /*InsnID*/31, /*TempRegID*/30, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185500 */   GIR_AddSimpleTempRegister, /*InsnID*/31, /*TempRegID*/31,
     /* 185503 */   GIR_AddImm, /*InsnID*/31, /*Imm*/GIMT_Encode8(43690),
     /* 185513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/31,
     /* 185515 */   GIR_MakeTempReg, /*TempRegID*/29, /*TypeID*/GILLT_s64,
     /* 185518 */   GIR_BuildMI, /*InsnID*/30, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185522 */   GIR_AddTempRegister, /*InsnID*/30, /*TempRegID*/29, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/30,
     /* 185529 */   GIR_MakeTempReg, /*TempRegID*/28, /*TypeID*/GILLT_s64,
     /* 185532 */   GIR_BuildMI, /*InsnID*/29, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185536 */   GIR_AddTempRegister, /*InsnID*/29, /*TempRegID*/28, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185541 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/29,
     /* 185544 */   GIR_AddSimpleTempRegister, /*InsnID*/29, /*TempRegID*/30,
     /* 185547 */   GIR_AddImm8, /*InsnID*/29, /*Imm*/1,
     /* 185550 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185555 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185560 */   GIR_ConstrainOperandRC, /*InsnID*/29, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185565 */   GIR_MakeTempReg, /*TempRegID*/27, /*TypeID*/GILLT_s64,
     /* 185568 */   GIR_BuildMI, /*InsnID*/28, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185572 */   GIR_AddTempRegister, /*InsnID*/28, /*TempRegID*/27, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185577 */   GIR_AddSimpleTempRegister, /*InsnID*/28, /*TempRegID*/28,
     /* 185580 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/32,
     /* 185583 */   GIR_AddImm8, /*InsnID*/28, /*Imm*/31,
     /* 185586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/28,
     /* 185588 */   GIR_MakeTempReg, /*TempRegID*/26, /*TypeID*/GILLT_s64,
     /* 185591 */   GIR_BuildMI, /*InsnID*/27, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185595 */   GIR_AddTempRegister, /*InsnID*/27, /*TempRegID*/26, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185600 */   GIR_AddSimpleTempRegister, /*InsnID*/27, /*TempRegID*/27,
     /* 185603 */   GIR_AddImm, /*InsnID*/27, /*Imm*/GIMT_Encode8(43690),
     /* 185613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/27,
     /* 185615 */   GIR_MakeTempReg, /*TempRegID*/25, /*TypeID*/GILLT_s64,
     /* 185618 */   GIR_BuildMI, /*InsnID*/26, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185622 */   GIR_AddTempRegister, /*InsnID*/26, /*TempRegID*/25, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185627 */   GIR_AddSimpleTempRegister, /*InsnID*/26, /*TempRegID*/26,
     /* 185630 */   GIR_AddImm, /*InsnID*/26, /*Imm*/GIMT_Encode8(43690),
     /* 185640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/26,
     /* 185642 */   GIR_MakeTempReg, /*TempRegID*/24, /*TypeID*/GILLT_s64,
     /* 185645 */   GIR_BuildMI, /*InsnID*/25, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185649 */   GIR_AddTempRegister, /*InsnID*/25, /*TempRegID*/24, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185654 */   GIR_Copy, /*NewInsnID*/25, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185658 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/1,
     /* 185661 */   GIR_AddImm8, /*InsnID*/25, /*Imm*/62,
     /* 185664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/25,
     /* 185666 */   GIR_MakeTempReg, /*TempRegID*/23, /*TypeID*/GILLT_s64,
     /* 185669 */   GIR_BuildMI, /*InsnID*/24, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185673 */   GIR_AddTempRegister, /*InsnID*/24, /*TempRegID*/23, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185678 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/24,
     /* 185681 */   GIR_AddSimpleTempRegister, /*InsnID*/24, /*TempRegID*/25,
     /* 185684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/24,
     /* 185686 */   GIR_MakeTempReg, /*TempRegID*/22, /*TypeID*/GILLT_s32,
     /* 185689 */   GIR_BuildMI, /*InsnID*/23, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 185693 */   GIR_AddTempRegister, /*InsnID*/23, /*TempRegID*/22, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185698 */   GIR_AddImm, /*InsnID*/23, /*Imm*/GIMT_Encode8(21845),
     /* 185708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/23,
     /* 185710 */   GIR_MakeTempReg, /*TempRegID*/21, /*TypeID*/GILLT_s32,
     /* 185713 */   GIR_BuildMI, /*InsnID*/22, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 185717 */   GIR_AddTempRegister, /*InsnID*/22, /*TempRegID*/21, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185722 */   GIR_AddSimpleTempRegister, /*InsnID*/22, /*TempRegID*/22,
     /* 185725 */   GIR_AddImm, /*InsnID*/22, /*Imm*/GIMT_Encode8(21845),
     /* 185735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/22,
     /* 185737 */   GIR_MakeTempReg, /*TempRegID*/20, /*TypeID*/GILLT_s64,
     /* 185740 */   GIR_BuildMI, /*InsnID*/21, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 185744 */   GIR_AddTempRegister, /*InsnID*/21, /*TempRegID*/20, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/21,
     /* 185751 */   GIR_MakeTempReg, /*TempRegID*/19, /*TypeID*/GILLT_s64,
     /* 185754 */   GIR_BuildMI, /*InsnID*/20, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 185758 */   GIR_AddTempRegister, /*InsnID*/20, /*TempRegID*/19, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185763 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/20,
     /* 185766 */   GIR_AddSimpleTempRegister, /*InsnID*/20, /*TempRegID*/21,
     /* 185769 */   GIR_AddImm8, /*InsnID*/20, /*Imm*/1,
     /* 185772 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185777 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 185782 */   GIR_ConstrainOperandRC, /*InsnID*/20, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 185787 */   GIR_MakeTempReg, /*TempRegID*/18, /*TypeID*/GILLT_s64,
     /* 185790 */   GIR_BuildMI, /*InsnID*/19, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 185794 */   GIR_AddTempRegister, /*InsnID*/19, /*TempRegID*/18, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185799 */   GIR_AddSimpleTempRegister, /*InsnID*/19, /*TempRegID*/19,
     /* 185802 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/32,
     /* 185805 */   GIR_AddImm8, /*InsnID*/19, /*Imm*/31,
     /* 185808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/19,
     /* 185810 */   GIR_MakeTempReg, /*TempRegID*/17, /*TypeID*/GILLT_s64,
     /* 185813 */   GIR_BuildMI, /*InsnID*/18, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 185817 */   GIR_AddTempRegister, /*InsnID*/18, /*TempRegID*/17, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185822 */   GIR_AddSimpleTempRegister, /*InsnID*/18, /*TempRegID*/18,
     /* 185825 */   GIR_AddImm, /*InsnID*/18, /*Imm*/GIMT_Encode8(21845),
     /* 185835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/18,
     /* 185837 */   GIR_MakeTempReg, /*TempRegID*/16, /*TypeID*/GILLT_s64,
     /* 185840 */   GIR_BuildMI, /*InsnID*/17, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 185844 */   GIR_AddTempRegister, /*InsnID*/17, /*TempRegID*/16, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185849 */   GIR_AddSimpleTempRegister, /*InsnID*/17, /*TempRegID*/17,
     /* 185852 */   GIR_AddImm, /*InsnID*/17, /*Imm*/GIMT_Encode8(21845),
     /* 185862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/17,
     /* 185864 */   GIR_MakeTempReg, /*TempRegID*/15, /*TypeID*/GILLT_s64,
     /* 185867 */   GIR_BuildMI, /*InsnID*/16, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185871 */   GIR_AddTempRegister, /*InsnID*/16, /*TempRegID*/15, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185876 */   GIR_Copy, /*NewInsnID*/16, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 185880 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/63,
     /* 185883 */   GIR_AddImm8, /*InsnID*/16, /*Imm*/1,
     /* 185886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/16,
     /* 185888 */   GIR_MakeTempReg, /*TempRegID*/14, /*TypeID*/GILLT_s64,
     /* 185891 */   GIR_BuildMI, /*InsnID*/15, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185895 */   GIR_AddTempRegister, /*InsnID*/15, /*TempRegID*/14, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185900 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/15,
     /* 185903 */   GIR_AddSimpleTempRegister, /*InsnID*/15, /*TempRegID*/16,
     /* 185906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/15,
     /* 185908 */   GIR_MakeTempReg, /*TempRegID*/13, /*TypeID*/GILLT_s64,
     /* 185911 */   GIR_BuildMI, /*InsnID*/14, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185915 */   GIR_AddTempRegister, /*InsnID*/14, /*TempRegID*/13, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185920 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/14,
     /* 185923 */   GIR_AddSimpleTempRegister, /*InsnID*/14, /*TempRegID*/23,
     /* 185926 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/14,
     /* 185928 */   GIR_MakeTempReg, /*TempRegID*/12, /*TypeID*/GILLT_s64,
     /* 185931 */   GIR_BuildMI, /*InsnID*/13, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185935 */   GIR_AddTempRegister, /*InsnID*/13, /*TempRegID*/12, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185940 */   GIR_AddSimpleTempRegister, /*InsnID*/13, /*TempRegID*/13,
     /* 185943 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/62,
     /* 185946 */   GIR_AddImm8, /*InsnID*/13, /*Imm*/2,
     /* 185949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/13,
     /* 185951 */   GIR_MakeTempReg, /*TempRegID*/11, /*TypeID*/GILLT_s64,
     /* 185954 */   GIR_BuildMI, /*InsnID*/12, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 185958 */   GIR_AddTempRegister, /*InsnID*/12, /*TempRegID*/11, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185963 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/12,
     /* 185966 */   GIR_AddSimpleTempRegister, /*InsnID*/12, /*TempRegID*/32,
     /* 185969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/12,
     /* 185971 */   GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_s64,
     /* 185974 */   GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 185978 */   GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 185983 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/11,
     /* 185986 */   GIR_AddSimpleTempRegister, /*InsnID*/11, /*TempRegID*/39,
     /* 185989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 185991 */   GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_s64,
     /* 185994 */   GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 185998 */   GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186003 */   GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 186006 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/60,
     /* 186009 */   GIR_AddImm8, /*InsnID*/10, /*Imm*/4,
     /* 186012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 186014 */   GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_s64,
     /* 186017 */   GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186021 */   GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186026 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 186029 */   GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/67,
     /* 186032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 186034 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_s64,
     /* 186037 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 186041 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186046 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/8,
     /* 186049 */   GIR_AddSimpleTempRegister, /*InsnID*/8, /*TempRegID*/74,
     /* 186052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 186054 */   GIR_MakeTempReg, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186058 */   GIR_BuildMI, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186063 */   GIR_AddTempRegister, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186070 */   GIR_AddImm, /*InsnID*//* 274(*/0x92, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 274(*/0x92, 0x02/*)*/,
     /* 186084 */   GIR_MakeTempReg, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186088 */   GIR_BuildMI, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186093 */   GIR_AddTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186100 */   GIR_AddSimpleTempRegister, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*TempRegID*//* 273(*/0x91, 0x02/*)*/,
     /* 186105 */   GIR_AddImm, /*InsnID*//* 273(*/0x91, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 273(*/0x91, 0x02/*)*/,
     /* 186119 */   GIR_MakeTempReg, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186123 */   GIR_BuildMI, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186128 */   GIR_AddTempRegister, /*InsnID*//* 272(*/0x90, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186135 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 272(*/0x90, 0x02/*)*/,
     /* 186138 */   GIR_MakeTempReg, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186142 */   GIR_BuildMI, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186147 */   GIR_AddTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186154 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 271(*/0x8F, 0x02/*)*/,
     /* 186159 */   GIR_AddSimpleTempRegister, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*TempRegID*//* 272(*/0x90, 0x02/*)*/,
     /* 186164 */   GIR_AddImm8, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Imm*/1,
     /* 186168 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186174 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186180 */   GIR_ConstrainOperandRC, /*InsnID*//* 271(*/0x8F, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186186 */   GIR_MakeTempReg, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186190 */   GIR_BuildMI, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186195 */   GIR_AddTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186202 */   GIR_AddSimpleTempRegister, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*TempRegID*//* 270(*/0x8E, 0x02/*)*/,
     /* 186207 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/32,
     /* 186211 */   GIR_AddImm8, /*InsnID*//* 270(*/0x8E, 0x02/*)*/, /*Imm*/31,
     /* 186215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 270(*/0x8E, 0x02/*)*/,
     /* 186218 */   GIR_MakeTempReg, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186222 */   GIR_BuildMI, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186227 */   GIR_AddTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186234 */   GIR_AddSimpleTempRegister, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*TempRegID*//* 269(*/0x8D, 0x02/*)*/,
     /* 186239 */   GIR_AddImm, /*InsnID*//* 269(*/0x8D, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 269(*/0x8D, 0x02/*)*/,
     /* 186253 */   GIR_MakeTempReg, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186257 */   GIR_BuildMI, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186262 */   GIR_AddTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186269 */   GIR_AddSimpleTempRegister, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*TempRegID*//* 268(*/0x8C, 0x02/*)*/,
     /* 186274 */   GIR_AddImm, /*InsnID*//* 268(*/0x8C, 0x02/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 186285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 268(*/0x8C, 0x02/*)*/,
     /* 186288 */   GIR_MakeTempReg, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186292 */   GIR_BuildMI, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186297 */   GIR_AddTempRegister, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186304 */   GIR_AddImm, /*InsnID*//* 267(*/0x8B, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186315 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 267(*/0x8B, 0x02/*)*/,
     /* 186318 */   GIR_MakeTempReg, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186322 */   GIR_BuildMI, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186327 */   GIR_AddTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186334 */   GIR_AddSimpleTempRegister, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*TempRegID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186339 */   GIR_AddImm, /*InsnID*//* 266(*/0x8A, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 266(*/0x8A, 0x02/*)*/,
     /* 186353 */   GIR_MakeTempReg, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186357 */   GIR_BuildMI, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186362 */   GIR_AddTempRegister, /*InsnID*//* 265(*/0x89, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 265(*/0x89, 0x02/*)*/,
     /* 186372 */   GIR_MakeTempReg, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186376 */   GIR_BuildMI, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186381 */   GIR_AddTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186388 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 264(*/0x88, 0x02/*)*/,
     /* 186393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*TempRegID*//* 265(*/0x89, 0x02/*)*/,
     /* 186398 */   GIR_AddImm8, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Imm*/1,
     /* 186402 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186408 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186414 */   GIR_ConstrainOperandRC, /*InsnID*//* 264(*/0x88, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186420 */   GIR_MakeTempReg, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186424 */   GIR_BuildMI, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186429 */   GIR_AddTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186436 */   GIR_AddSimpleTempRegister, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*TempRegID*//* 263(*/0x87, 0x02/*)*/,
     /* 186441 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/32,
     /* 186445 */   GIR_AddImm8, /*InsnID*//* 263(*/0x87, 0x02/*)*/, /*Imm*/31,
     /* 186449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 263(*/0x87, 0x02/*)*/,
     /* 186452 */   GIR_MakeTempReg, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186456 */   GIR_BuildMI, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186461 */   GIR_AddTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186468 */   GIR_AddSimpleTempRegister, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*TempRegID*//* 262(*/0x86, 0x02/*)*/,
     /* 186473 */   GIR_AddImm, /*InsnID*//* 262(*/0x86, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 262(*/0x86, 0x02/*)*/,
     /* 186487 */   GIR_MakeTempReg, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186491 */   GIR_BuildMI, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186496 */   GIR_AddTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186503 */   GIR_AddSimpleTempRegister, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*TempRegID*//* 261(*/0x85, 0x02/*)*/,
     /* 186508 */   GIR_AddImm, /*InsnID*//* 261(*/0x85, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 186519 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 261(*/0x85, 0x02/*)*/,
     /* 186522 */   GIR_MakeTempReg, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186526 */   GIR_BuildMI, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186531 */   GIR_AddTempRegister, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186538 */   GIR_AddImm, /*InsnID*//* 260(*/0x84, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 260(*/0x84, 0x02/*)*/,
     /* 186552 */   GIR_MakeTempReg, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 186556 */   GIR_BuildMI, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186561 */   GIR_AddTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186568 */   GIR_AddSimpleTempRegister, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*TempRegID*//* 259(*/0x83, 0x02/*)*/,
     /* 186573 */   GIR_AddImm, /*InsnID*//* 259(*/0x83, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 259(*/0x83, 0x02/*)*/,
     /* 186587 */   GIR_MakeTempReg, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186591 */   GIR_BuildMI, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186596 */   GIR_AddTempRegister, /*InsnID*//* 258(*/0x82, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 258(*/0x82, 0x02/*)*/,
     /* 186606 */   GIR_MakeTempReg, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 186610 */   GIR_BuildMI, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186615 */   GIR_AddTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186622 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 257(*/0x81, 0x02/*)*/,
     /* 186627 */   GIR_AddSimpleTempRegister, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*TempRegID*//* 258(*/0x82, 0x02/*)*/,
     /* 186632 */   GIR_AddImm8, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Imm*/1,
     /* 186636 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186642 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186648 */   GIR_ConstrainOperandRC, /*InsnID*//* 257(*/0x81, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186654 */   GIR_MakeTempReg, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186658 */   GIR_BuildMI, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186663 */   GIR_AddTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186670 */   GIR_AddSimpleTempRegister, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*TempRegID*//* 256(*/0x80, 0x02/*)*/,
     /* 186675 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/32,
     /* 186679 */   GIR_AddImm8, /*InsnID*//* 256(*/0x80, 0x02/*)*/, /*Imm*/31,
     /* 186683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 256(*/0x80, 0x02/*)*/,
     /* 186686 */   GIR_MakeTempReg, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186690 */   GIR_BuildMI, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186695 */   GIR_AddTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186702 */   GIR_AddSimpleTempRegister, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*TempRegID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186707 */   GIR_AddImm, /*InsnID*//* 255(*/0xFF, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 255(*/0xFF, 0x01/*)*/,
     /* 186721 */   GIR_MakeTempReg, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186725 */   GIR_BuildMI, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 186730 */   GIR_AddTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186737 */   GIR_AddSimpleTempRegister, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*TempRegID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186742 */   GIR_AddImm, /*InsnID*//* 254(*/0xFE, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 186753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 254(*/0xFE, 0x01/*)*/,
     /* 186756 */   GIR_MakeTempReg, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186760 */   GIR_BuildMI, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186765 */   GIR_AddTempRegister, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186772 */   GIR_Copy, /*NewInsnID*//* 253(*/0xFD, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 186777 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/1,
     /* 186781 */   GIR_AddImm8, /*InsnID*//* 253(*/0xFD, 0x01/*)*/, /*Imm*/62,
     /* 186785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186788 */   GIR_MakeTempReg, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186792 */   GIR_BuildMI, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 186797 */   GIR_AddTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186804 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186809 */   GIR_AddSimpleTempRegister, /*InsnID*//* 252(*/0xFC, 0x01/*)*/, /*TempRegID*//* 253(*/0xFD, 0x01/*)*/,
     /* 186814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 252(*/0xFC, 0x01/*)*/,
     /* 186817 */   GIR_MakeTempReg, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186821 */   GIR_BuildMI, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 186826 */   GIR_AddTempRegister, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186833 */   GIR_AddImm, /*InsnID*//* 251(*/0xFB, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 251(*/0xFB, 0x01/*)*/,
     /* 186847 */   GIR_MakeTempReg, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 186851 */   GIR_BuildMI, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 186856 */   GIR_AddTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186863 */   GIR_AddSimpleTempRegister, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*TempRegID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186868 */   GIR_AddImm, /*InsnID*//* 250(*/0xFA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 186879 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 250(*/0xFA, 0x01/*)*/,
     /* 186882 */   GIR_MakeTempReg, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186886 */   GIR_BuildMI, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 186891 */   GIR_AddTempRegister, /*InsnID*//* 249(*/0xF9, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186901 */   GIR_MakeTempReg, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186905 */   GIR_BuildMI, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 186910 */   GIR_AddTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186917 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 248(*/0xF8, 0x01/*)*/,
     /* 186922 */   GIR_AddSimpleTempRegister, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*TempRegID*//* 249(*/0xF9, 0x01/*)*/,
     /* 186927 */   GIR_AddImm8, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Imm*/1,
     /* 186931 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186937 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 186943 */   GIR_ConstrainOperandRC, /*InsnID*//* 248(*/0xF8, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 186949 */   GIR_MakeTempReg, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186953 */   GIR_BuildMI, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 186958 */   GIR_AddTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186965 */   GIR_AddSimpleTempRegister, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*TempRegID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186970 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/32,
     /* 186974 */   GIR_AddImm8, /*InsnID*//* 247(*/0xF7, 0x01/*)*/, /*Imm*/31,
     /* 186978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 247(*/0xF7, 0x01/*)*/,
     /* 186981 */   GIR_MakeTempReg, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 186985 */   GIR_BuildMI, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 186990 */   GIR_AddTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 186997 */   GIR_AddSimpleTempRegister, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*TempRegID*//* 246(*/0xF6, 0x01/*)*/,
     /* 187002 */   GIR_AddImm, /*InsnID*//* 246(*/0xF6, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187013 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 246(*/0xF6, 0x01/*)*/,
     /* 187016 */   GIR_MakeTempReg, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187020 */   GIR_BuildMI, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187025 */   GIR_AddTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187032 */   GIR_AddSimpleTempRegister, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*TempRegID*//* 245(*/0xF5, 0x01/*)*/,
     /* 187037 */   GIR_AddImm, /*InsnID*//* 245(*/0xF5, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 245(*/0xF5, 0x01/*)*/,
     /* 187051 */   GIR_MakeTempReg, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187055 */   GIR_BuildMI, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187060 */   GIR_AddTempRegister, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187067 */   GIR_Copy, /*NewInsnID*//* 244(*/0xF4, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187072 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/63,
     /* 187076 */   GIR_AddImm8, /*InsnID*//* 244(*/0xF4, 0x01/*)*/, /*Imm*/1,
     /* 187080 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 244(*/0xF4, 0x01/*)*/,
     /* 187083 */   GIR_MakeTempReg, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187087 */   GIR_BuildMI, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187092 */   GIR_AddTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187099 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 243(*/0xF3, 0x01/*)*/,
     /* 187104 */   GIR_AddSimpleTempRegister, /*InsnID*//* 243(*/0xF3, 0x01/*)*/, /*TempRegID*//* 244(*/0xF4, 0x01/*)*/,
     /* 187109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 243(*/0xF3, 0x01/*)*/,
     /* 187112 */   GIR_MakeTempReg, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187116 */   GIR_BuildMI, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 187121 */   GIR_AddTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187128 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 242(*/0xF2, 0x01/*)*/,
     /* 187133 */   GIR_AddSimpleTempRegister, /*InsnID*//* 242(*/0xF2, 0x01/*)*/, /*TempRegID*//* 251(*/0xFB, 0x01/*)*/,
     /* 187138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 242(*/0xF2, 0x01/*)*/,
     /* 187141 */   GIR_MakeTempReg, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187145 */   GIR_BuildMI, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187150 */   GIR_AddTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187157 */   GIR_AddSimpleTempRegister, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*TempRegID*//* 241(*/0xF1, 0x01/*)*/,
     /* 187162 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/2,
     /* 187166 */   GIR_AddImm8, /*InsnID*//* 241(*/0xF1, 0x01/*)*/, /*Imm*/61,
     /* 187170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 241(*/0xF1, 0x01/*)*/,
     /* 187173 */   GIR_MakeTempReg, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187177 */   GIR_BuildMI, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187182 */   GIR_AddTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187189 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 240(*/0xF0, 0x01/*)*/,
     /* 187194 */   GIR_AddSimpleTempRegister, /*InsnID*//* 240(*/0xF0, 0x01/*)*/, /*TempRegID*//* 260(*/0x84, 0x02/*)*/,
     /* 187199 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 240(*/0xF0, 0x01/*)*/,
     /* 187202 */   GIR_MakeTempReg, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187206 */   GIR_BuildMI, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187211 */   GIR_AddTempRegister, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187218 */   GIR_AddImm, /*InsnID*//* 239(*/0xEF, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187229 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 239(*/0xEF, 0x01/*)*/,
     /* 187232 */   GIR_MakeTempReg, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187236 */   GIR_BuildMI, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187241 */   GIR_AddTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187248 */   GIR_AddSimpleTempRegister, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*TempRegID*//* 238(*/0xEE, 0x01/*)*/,
     /* 187253 */   GIR_AddImm, /*InsnID*//* 238(*/0xEE, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 238(*/0xEE, 0x01/*)*/,
     /* 187267 */   GIR_MakeTempReg, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187271 */   GIR_BuildMI, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187276 */   GIR_AddTempRegister, /*InsnID*//* 237(*/0xED, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 237(*/0xED, 0x01/*)*/,
     /* 187286 */   GIR_MakeTempReg, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187290 */   GIR_BuildMI, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187295 */   GIR_AddTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187302 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 236(*/0xEC, 0x01/*)*/,
     /* 187307 */   GIR_AddSimpleTempRegister, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*TempRegID*//* 237(*/0xED, 0x01/*)*/,
     /* 187312 */   GIR_AddImm8, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Imm*/1,
     /* 187316 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187322 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187328 */   GIR_ConstrainOperandRC, /*InsnID*//* 236(*/0xEC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187334 */   GIR_MakeTempReg, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187338 */   GIR_BuildMI, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187343 */   GIR_AddTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187350 */   GIR_AddSimpleTempRegister, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*TempRegID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187355 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/32,
     /* 187359 */   GIR_AddImm8, /*InsnID*//* 235(*/0xEB, 0x01/*)*/, /*Imm*/31,
     /* 187363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 235(*/0xEB, 0x01/*)*/,
     /* 187366 */   GIR_MakeTempReg, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187370 */   GIR_BuildMI, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187375 */   GIR_AddTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187382 */   GIR_AddSimpleTempRegister, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*TempRegID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187387 */   GIR_AddImm, /*InsnID*//* 234(*/0xEA, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 234(*/0xEA, 0x01/*)*/,
     /* 187401 */   GIR_MakeTempReg, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187405 */   GIR_BuildMI, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187410 */   GIR_AddTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187417 */   GIR_AddSimpleTempRegister, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*TempRegID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187422 */   GIR_AddImm, /*InsnID*//* 233(*/0xE9, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 187433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 233(*/0xE9, 0x01/*)*/,
     /* 187436 */   GIR_MakeTempReg, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187440 */   GIR_BuildMI, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187445 */   GIR_AddTempRegister, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187452 */   GIR_AddImm, /*InsnID*//* 232(*/0xE8, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 232(*/0xE8, 0x01/*)*/,
     /* 187466 */   GIR_MakeTempReg, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187470 */   GIR_BuildMI, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187475 */   GIR_AddTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*TempRegID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187487 */   GIR_AddImm, /*InsnID*//* 231(*/0xE7, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 231(*/0xE7, 0x01/*)*/,
     /* 187501 */   GIR_MakeTempReg, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187505 */   GIR_BuildMI, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187510 */   GIR_AddTempRegister, /*InsnID*//* 230(*/0xE6, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187520 */   GIR_MakeTempReg, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187524 */   GIR_BuildMI, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187529 */   GIR_AddTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187536 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 229(*/0xE5, 0x01/*)*/,
     /* 187541 */   GIR_AddSimpleTempRegister, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*TempRegID*//* 230(*/0xE6, 0x01/*)*/,
     /* 187546 */   GIR_AddImm8, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Imm*/1,
     /* 187550 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187556 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187562 */   GIR_ConstrainOperandRC, /*InsnID*//* 229(*/0xE5, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187568 */   GIR_MakeTempReg, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187572 */   GIR_BuildMI, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187577 */   GIR_AddTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187584 */   GIR_AddSimpleTempRegister, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*TempRegID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187589 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/32,
     /* 187593 */   GIR_AddImm8, /*InsnID*//* 228(*/0xE4, 0x01/*)*/, /*Imm*/31,
     /* 187597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 228(*/0xE4, 0x01/*)*/,
     /* 187600 */   GIR_MakeTempReg, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187604 */   GIR_BuildMI, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187609 */   GIR_AddTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187616 */   GIR_AddSimpleTempRegister, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*TempRegID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187621 */   GIR_AddImm, /*InsnID*//* 227(*/0xE3, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 227(*/0xE3, 0x01/*)*/,
     /* 187635 */   GIR_MakeTempReg, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187639 */   GIR_BuildMI, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187644 */   GIR_AddTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187651 */   GIR_AddSimpleTempRegister, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*TempRegID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187656 */   GIR_AddImm, /*InsnID*//* 226(*/0xE2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 187667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 226(*/0xE2, 0x01/*)*/,
     /* 187670 */   GIR_MakeTempReg, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187674 */   GIR_BuildMI, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187679 */   GIR_AddTempRegister, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187686 */   GIR_Copy, /*NewInsnID*//* 225(*/0xE1, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187691 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/1,
     /* 187695 */   GIR_AddImm8, /*InsnID*//* 225(*/0xE1, 0x01/*)*/, /*Imm*/62,
     /* 187699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187702 */   GIR_MakeTempReg, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187706 */   GIR_BuildMI, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 187711 */   GIR_AddTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187718 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187723 */   GIR_AddSimpleTempRegister, /*InsnID*//* 224(*/0xE0, 0x01/*)*/, /*TempRegID*//* 225(*/0xE1, 0x01/*)*/,
     /* 187728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 224(*/0xE0, 0x01/*)*/,
     /* 187731 */   GIR_MakeTempReg, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187735 */   GIR_BuildMI, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 187740 */   GIR_AddTempRegister, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187747 */   GIR_AddImm, /*InsnID*//* 223(*/0xDF, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187758 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 223(*/0xDF, 0x01/*)*/,
     /* 187761 */   GIR_MakeTempReg, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 187765 */   GIR_BuildMI, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 187770 */   GIR_AddTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187777 */   GIR_AddSimpleTempRegister, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*TempRegID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187782 */   GIR_AddImm, /*InsnID*//* 222(*/0xDE, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187793 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 222(*/0xDE, 0x01/*)*/,
     /* 187796 */   GIR_MakeTempReg, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187800 */   GIR_BuildMI, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 187805 */   GIR_AddTempRegister, /*InsnID*//* 221(*/0xDD, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187815 */   GIR_MakeTempReg, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187819 */   GIR_BuildMI, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 187824 */   GIR_AddTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187831 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 220(*/0xDC, 0x01/*)*/,
     /* 187836 */   GIR_AddSimpleTempRegister, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*TempRegID*//* 221(*/0xDD, 0x01/*)*/,
     /* 187841 */   GIR_AddImm8, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Imm*/1,
     /* 187845 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187851 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 187857 */   GIR_ConstrainOperandRC, /*InsnID*//* 220(*/0xDC, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 187863 */   GIR_MakeTempReg, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187867 */   GIR_BuildMI, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 187872 */   GIR_AddTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187879 */   GIR_AddSimpleTempRegister, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*TempRegID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187884 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/32,
     /* 187888 */   GIR_AddImm8, /*InsnID*//* 219(*/0xDB, 0x01/*)*/, /*Imm*/31,
     /* 187892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 219(*/0xDB, 0x01/*)*/,
     /* 187895 */   GIR_MakeTempReg, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187899 */   GIR_BuildMI, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 187904 */   GIR_AddTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187911 */   GIR_AddSimpleTempRegister, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*TempRegID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187916 */   GIR_AddImm, /*InsnID*//* 218(*/0xDA, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 218(*/0xDA, 0x01/*)*/,
     /* 187930 */   GIR_MakeTempReg, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187934 */   GIR_BuildMI, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 187939 */   GIR_AddTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187946 */   GIR_AddSimpleTempRegister, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*TempRegID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187951 */   GIR_AddImm, /*InsnID*//* 217(*/0xD9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 187962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 217(*/0xD9, 0x01/*)*/,
     /* 187965 */   GIR_MakeTempReg, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 187969 */   GIR_BuildMI, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 187974 */   GIR_AddTempRegister, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 187981 */   GIR_Copy, /*NewInsnID*//* 216(*/0xD8, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 187986 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/63,
     /* 187990 */   GIR_AddImm8, /*InsnID*//* 216(*/0xD8, 0x01/*)*/, /*Imm*/1,
     /* 187994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 216(*/0xD8, 0x01/*)*/,
     /* 187997 */   GIR_MakeTempReg, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188001 */   GIR_BuildMI, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188006 */   GIR_AddTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188013 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 215(*/0xD7, 0x01/*)*/,
     /* 188018 */   GIR_AddSimpleTempRegister, /*InsnID*//* 215(*/0xD7, 0x01/*)*/, /*TempRegID*//* 216(*/0xD8, 0x01/*)*/,
     /* 188023 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 215(*/0xD7, 0x01/*)*/,
     /* 188026 */   GIR_MakeTempReg, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188030 */   GIR_BuildMI, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188035 */   GIR_AddTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188042 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 214(*/0xD6, 0x01/*)*/,
     /* 188047 */   GIR_AddSimpleTempRegister, /*InsnID*//* 214(*/0xD6, 0x01/*)*/, /*TempRegID*//* 223(*/0xDF, 0x01/*)*/,
     /* 188052 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 214(*/0xD6, 0x01/*)*/,
     /* 188055 */   GIR_MakeTempReg, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188059 */   GIR_BuildMI, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 188064 */   GIR_AddTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188071 */   GIR_AddSimpleTempRegister, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*TempRegID*//* 213(*/0xD5, 0x01/*)*/,
     /* 188076 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/62,
     /* 188080 */   GIR_AddImm8, /*InsnID*//* 213(*/0xD5, 0x01/*)*/, /*Imm*/2,
     /* 188084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 213(*/0xD5, 0x01/*)*/,
     /* 188087 */   GIR_MakeTempReg, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188091 */   GIR_BuildMI, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188096 */   GIR_AddTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188103 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 212(*/0xD4, 0x01/*)*/,
     /* 188108 */   GIR_AddSimpleTempRegister, /*InsnID*//* 212(*/0xD4, 0x01/*)*/, /*TempRegID*//* 232(*/0xE8, 0x01/*)*/,
     /* 188113 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 212(*/0xD4, 0x01/*)*/,
     /* 188116 */   GIR_MakeTempReg, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188120 */   GIR_BuildMI, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 188125 */   GIR_AddTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188132 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 211(*/0xD3, 0x01/*)*/,
     /* 188137 */   GIR_AddSimpleTempRegister, /*InsnID*//* 211(*/0xD3, 0x01/*)*/, /*TempRegID*//* 239(*/0xEF, 0x01/*)*/,
     /* 188142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 211(*/0xD3, 0x01/*)*/,
     /* 188145 */   GIR_MakeTempReg, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188149 */   GIR_BuildMI, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188154 */   GIR_AddTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188161 */   GIR_AddSimpleTempRegister, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*TempRegID*//* 210(*/0xD2, 0x01/*)*/,
     /* 188166 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/4,
     /* 188170 */   GIR_AddImm8, /*InsnID*//* 210(*/0xD2, 0x01/*)*/, /*Imm*/59,
     /* 188174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 210(*/0xD2, 0x01/*)*/,
     /* 188177 */   GIR_MakeTempReg, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188181 */   GIR_BuildMI, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188186 */   GIR_AddTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188193 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 209(*/0xD1, 0x01/*)*/,
     /* 188198 */   GIR_AddSimpleTempRegister, /*InsnID*//* 209(*/0xD1, 0x01/*)*/, /*TempRegID*//* 267(*/0x8B, 0x02/*)*/,
     /* 188203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 209(*/0xD1, 0x01/*)*/,
     /* 188206 */   GIR_MakeTempReg, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188210 */   GIR_BuildMI, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188215 */   GIR_AddTempRegister, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188222 */   GIR_AddImm, /*InsnID*//* 208(*/0xD0, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 208(*/0xD0, 0x01/*)*/,
     /* 188236 */   GIR_MakeTempReg, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188240 */   GIR_BuildMI, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188245 */   GIR_AddTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188252 */   GIR_AddSimpleTempRegister, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*TempRegID*//* 207(*/0xCF, 0x01/*)*/,
     /* 188257 */   GIR_AddImm, /*InsnID*//* 207(*/0xCF, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 207(*/0xCF, 0x01/*)*/,
     /* 188271 */   GIR_MakeTempReg, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188275 */   GIR_BuildMI, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188280 */   GIR_AddTempRegister, /*InsnID*//* 206(*/0xCE, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 206(*/0xCE, 0x01/*)*/,
     /* 188290 */   GIR_MakeTempReg, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188294 */   GIR_BuildMI, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188299 */   GIR_AddTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188306 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 205(*/0xCD, 0x01/*)*/,
     /* 188311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*TempRegID*//* 206(*/0xCE, 0x01/*)*/,
     /* 188316 */   GIR_AddImm8, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Imm*/1,
     /* 188320 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188326 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188332 */   GIR_ConstrainOperandRC, /*InsnID*//* 205(*/0xCD, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188338 */   GIR_MakeTempReg, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188342 */   GIR_BuildMI, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188347 */   GIR_AddTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188354 */   GIR_AddSimpleTempRegister, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*TempRegID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188359 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/32,
     /* 188363 */   GIR_AddImm8, /*InsnID*//* 204(*/0xCC, 0x01/*)*/, /*Imm*/31,
     /* 188367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 204(*/0xCC, 0x01/*)*/,
     /* 188370 */   GIR_MakeTempReg, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188374 */   GIR_BuildMI, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188379 */   GIR_AddTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188386 */   GIR_AddSimpleTempRegister, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*TempRegID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188391 */   GIR_AddImm, /*InsnID*//* 203(*/0xCB, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 203(*/0xCB, 0x01/*)*/,
     /* 188405 */   GIR_MakeTempReg, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188409 */   GIR_BuildMI, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188414 */   GIR_AddTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188421 */   GIR_AddSimpleTempRegister, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*TempRegID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188426 */   GIR_AddImm, /*InsnID*//* 202(*/0xCA, 0x01/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 188437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 202(*/0xCA, 0x01/*)*/,
     /* 188440 */   GIR_MakeTempReg, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188444 */   GIR_BuildMI, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188449 */   GIR_AddTempRegister, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188456 */   GIR_AddImm, /*InsnID*//* 201(*/0xC9, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 201(*/0xC9, 0x01/*)*/,
     /* 188470 */   GIR_MakeTempReg, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188474 */   GIR_BuildMI, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188479 */   GIR_AddTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188486 */   GIR_AddSimpleTempRegister, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*TempRegID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188491 */   GIR_AddImm, /*InsnID*//* 200(*/0xC8, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 200(*/0xC8, 0x01/*)*/,
     /* 188505 */   GIR_MakeTempReg, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188509 */   GIR_BuildMI, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188514 */   GIR_AddTempRegister, /*InsnID*//* 199(*/0xC7, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188521 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188524 */   GIR_MakeTempReg, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188528 */   GIR_BuildMI, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188533 */   GIR_AddTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188540 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 198(*/0xC6, 0x01/*)*/,
     /* 188545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*TempRegID*//* 199(*/0xC7, 0x01/*)*/,
     /* 188550 */   GIR_AddImm8, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Imm*/1,
     /* 188554 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188560 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188566 */   GIR_ConstrainOperandRC, /*InsnID*//* 198(*/0xC6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188572 */   GIR_MakeTempReg, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188576 */   GIR_BuildMI, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188581 */   GIR_AddTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188588 */   GIR_AddSimpleTempRegister, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*TempRegID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188593 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/32,
     /* 188597 */   GIR_AddImm8, /*InsnID*//* 197(*/0xC5, 0x01/*)*/, /*Imm*/31,
     /* 188601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 197(*/0xC5, 0x01/*)*/,
     /* 188604 */   GIR_MakeTempReg, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188608 */   GIR_BuildMI, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188613 */   GIR_AddTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188620 */   GIR_AddSimpleTempRegister, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*TempRegID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188625 */   GIR_AddImm, /*InsnID*//* 196(*/0xC4, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 196(*/0xC4, 0x01/*)*/,
     /* 188639 */   GIR_MakeTempReg, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188643 */   GIR_BuildMI, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188648 */   GIR_AddTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188655 */   GIR_AddSimpleTempRegister, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*TempRegID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188660 */   GIR_AddImm, /*InsnID*//* 195(*/0xC3, 0x01/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 188671 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 195(*/0xC3, 0x01/*)*/,
     /* 188674 */   GIR_MakeTempReg, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188678 */   GIR_BuildMI, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188683 */   GIR_AddTempRegister, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188690 */   GIR_AddImm, /*InsnID*//* 194(*/0xC2, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 194(*/0xC2, 0x01/*)*/,
     /* 188704 */   GIR_MakeTempReg, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188708 */   GIR_BuildMI, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 188713 */   GIR_AddTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188720 */   GIR_AddSimpleTempRegister, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*TempRegID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188725 */   GIR_AddImm, /*InsnID*//* 193(*/0xC1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 193(*/0xC1, 0x01/*)*/,
     /* 188739 */   GIR_MakeTempReg, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188743 */   GIR_BuildMI, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 188748 */   GIR_AddTempRegister, /*InsnID*//* 192(*/0xC0, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188758 */   GIR_MakeTempReg, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188762 */   GIR_BuildMI, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 188767 */   GIR_AddTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188774 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 191(*/0xBF, 0x01/*)*/,
     /* 188779 */   GIR_AddSimpleTempRegister, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*TempRegID*//* 192(*/0xC0, 0x01/*)*/,
     /* 188784 */   GIR_AddImm8, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Imm*/1,
     /* 188788 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188794 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 188800 */   GIR_ConstrainOperandRC, /*InsnID*//* 191(*/0xBF, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 188806 */   GIR_MakeTempReg, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188810 */   GIR_BuildMI, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188815 */   GIR_AddTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188822 */   GIR_AddSimpleTempRegister, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*TempRegID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188827 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/32,
     /* 188831 */   GIR_AddImm8, /*InsnID*//* 190(*/0xBE, 0x01/*)*/, /*Imm*/31,
     /* 188835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 190(*/0xBE, 0x01/*)*/,
     /* 188838 */   GIR_MakeTempReg, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188842 */   GIR_BuildMI, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 188847 */   GIR_AddTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188854 */   GIR_AddSimpleTempRegister, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*TempRegID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188859 */   GIR_AddImm, /*InsnID*//* 189(*/0xBD, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 189(*/0xBD, 0x01/*)*/,
     /* 188873 */   GIR_MakeTempReg, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188877 */   GIR_BuildMI, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 188882 */   GIR_AddTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188889 */   GIR_AddSimpleTempRegister, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*TempRegID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188894 */   GIR_AddImm, /*InsnID*//* 188(*/0xBC, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 188905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 188(*/0xBC, 0x01/*)*/,
     /* 188908 */   GIR_MakeTempReg, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188912 */   GIR_BuildMI, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 188917 */   GIR_AddTempRegister, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188924 */   GIR_Copy, /*NewInsnID*//* 187(*/0xBB, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 188929 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/1,
     /* 188933 */   GIR_AddImm8, /*InsnID*//* 187(*/0xBB, 0x01/*)*/, /*Imm*/62,
     /* 188937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188940 */   GIR_MakeTempReg, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 188944 */   GIR_BuildMI, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 188949 */   GIR_AddTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188956 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188961 */   GIR_AddSimpleTempRegister, /*InsnID*//* 186(*/0xBA, 0x01/*)*/, /*TempRegID*//* 187(*/0xBB, 0x01/*)*/,
     /* 188966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 186(*/0xBA, 0x01/*)*/,
     /* 188969 */   GIR_MakeTempReg, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 188973 */   GIR_BuildMI, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 188978 */   GIR_AddTempRegister, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 188985 */   GIR_AddImm, /*InsnID*//* 185(*/0xB9, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 188996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 185(*/0xB9, 0x01/*)*/,
     /* 188999 */   GIR_MakeTempReg, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189003 */   GIR_BuildMI, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189008 */   GIR_AddTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189015 */   GIR_AddSimpleTempRegister, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*TempRegID*//* 184(*/0xB8, 0x01/*)*/,
     /* 189020 */   GIR_AddImm, /*InsnID*//* 184(*/0xB8, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 184(*/0xB8, 0x01/*)*/,
     /* 189034 */   GIR_MakeTempReg, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189038 */   GIR_BuildMI, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189043 */   GIR_AddTempRegister, /*InsnID*//* 183(*/0xB7, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 183(*/0xB7, 0x01/*)*/,
     /* 189053 */   GIR_MakeTempReg, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189057 */   GIR_BuildMI, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189062 */   GIR_AddTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189069 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 182(*/0xB6, 0x01/*)*/,
     /* 189074 */   GIR_AddSimpleTempRegister, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*TempRegID*//* 183(*/0xB7, 0x01/*)*/,
     /* 189079 */   GIR_AddImm8, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Imm*/1,
     /* 189083 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189089 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189095 */   GIR_ConstrainOperandRC, /*InsnID*//* 182(*/0xB6, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189101 */   GIR_MakeTempReg, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189105 */   GIR_BuildMI, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189110 */   GIR_AddTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189117 */   GIR_AddSimpleTempRegister, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*TempRegID*//* 181(*/0xB5, 0x01/*)*/,
     /* 189122 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/32,
     /* 189126 */   GIR_AddImm8, /*InsnID*//* 181(*/0xB5, 0x01/*)*/, /*Imm*/31,
     /* 189130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 181(*/0xB5, 0x01/*)*/,
     /* 189133 */   GIR_MakeTempReg, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189137 */   GIR_BuildMI, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189142 */   GIR_AddTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189149 */   GIR_AddSimpleTempRegister, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*TempRegID*//* 180(*/0xB4, 0x01/*)*/,
     /* 189154 */   GIR_AddImm, /*InsnID*//* 180(*/0xB4, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 180(*/0xB4, 0x01/*)*/,
     /* 189168 */   GIR_MakeTempReg, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189172 */   GIR_BuildMI, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189177 */   GIR_AddTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189184 */   GIR_AddSimpleTempRegister, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*TempRegID*//* 179(*/0xB3, 0x01/*)*/,
     /* 189189 */   GIR_AddImm, /*InsnID*//* 179(*/0xB3, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 179(*/0xB3, 0x01/*)*/,
     /* 189203 */   GIR_MakeTempReg, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189207 */   GIR_BuildMI, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 189212 */   GIR_AddTempRegister, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189219 */   GIR_Copy, /*NewInsnID*//* 178(*/0xB2, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189224 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/63,
     /* 189228 */   GIR_AddImm8, /*InsnID*//* 178(*/0xB2, 0x01/*)*/, /*Imm*/1,
     /* 189232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 178(*/0xB2, 0x01/*)*/,
     /* 189235 */   GIR_MakeTempReg, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189239 */   GIR_BuildMI, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189244 */   GIR_AddTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189251 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 177(*/0xB1, 0x01/*)*/,
     /* 189256 */   GIR_AddSimpleTempRegister, /*InsnID*//* 177(*/0xB1, 0x01/*)*/, /*TempRegID*//* 178(*/0xB2, 0x01/*)*/,
     /* 189261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 177(*/0xB1, 0x01/*)*/,
     /* 189264 */   GIR_MakeTempReg, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189268 */   GIR_BuildMI, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 189273 */   GIR_AddTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189280 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 176(*/0xB0, 0x01/*)*/,
     /* 189285 */   GIR_AddSimpleTempRegister, /*InsnID*//* 176(*/0xB0, 0x01/*)*/, /*TempRegID*//* 185(*/0xB9, 0x01/*)*/,
     /* 189290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 176(*/0xB0, 0x01/*)*/,
     /* 189293 */   GIR_MakeTempReg, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189297 */   GIR_BuildMI, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189302 */   GIR_AddTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189309 */   GIR_AddSimpleTempRegister, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*TempRegID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189314 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/2,
     /* 189318 */   GIR_AddImm8, /*InsnID*//* 175(*/0xAF, 0x01/*)*/, /*Imm*/61,
     /* 189322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 175(*/0xAF, 0x01/*)*/,
     /* 189325 */   GIR_MakeTempReg, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189329 */   GIR_BuildMI, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189334 */   GIR_AddTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189341 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189346 */   GIR_AddSimpleTempRegister, /*InsnID*//* 174(*/0xAE, 0x01/*)*/, /*TempRegID*//* 194(*/0xC2, 0x01/*)*/,
     /* 189351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 174(*/0xAE, 0x01/*)*/,
     /* 189354 */   GIR_MakeTempReg, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189358 */   GIR_BuildMI, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189363 */   GIR_AddTempRegister, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189370 */   GIR_AddImm, /*InsnID*//* 173(*/0xAD, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 173(*/0xAD, 0x01/*)*/,
     /* 189384 */   GIR_MakeTempReg, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189388 */   GIR_BuildMI, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189393 */   GIR_AddTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189400 */   GIR_AddSimpleTempRegister, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*TempRegID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189405 */   GIR_AddImm, /*InsnID*//* 172(*/0xAC, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 172(*/0xAC, 0x01/*)*/,
     /* 189419 */   GIR_MakeTempReg, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189423 */   GIR_BuildMI, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189428 */   GIR_AddTempRegister, /*InsnID*//* 171(*/0xAB, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189438 */   GIR_MakeTempReg, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189442 */   GIR_BuildMI, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189447 */   GIR_AddTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189454 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 170(*/0xAA, 0x01/*)*/,
     /* 189459 */   GIR_AddSimpleTempRegister, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*TempRegID*//* 171(*/0xAB, 0x01/*)*/,
     /* 189464 */   GIR_AddImm8, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Imm*/1,
     /* 189468 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189474 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189480 */   GIR_ConstrainOperandRC, /*InsnID*//* 170(*/0xAA, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189486 */   GIR_MakeTempReg, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189490 */   GIR_BuildMI, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189495 */   GIR_AddTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189502 */   GIR_AddSimpleTempRegister, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*TempRegID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189507 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/32,
     /* 189511 */   GIR_AddImm8, /*InsnID*//* 169(*/0xA9, 0x01/*)*/, /*Imm*/31,
     /* 189515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 169(*/0xA9, 0x01/*)*/,
     /* 189518 */   GIR_MakeTempReg, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189522 */   GIR_BuildMI, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189527 */   GIR_AddTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189534 */   GIR_AddSimpleTempRegister, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*TempRegID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189539 */   GIR_AddImm, /*InsnID*//* 168(*/0xA8, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 168(*/0xA8, 0x01/*)*/,
     /* 189553 */   GIR_MakeTempReg, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189557 */   GIR_BuildMI, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189562 */   GIR_AddTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189569 */   GIR_AddSimpleTempRegister, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*TempRegID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189574 */   GIR_AddImm, /*InsnID*//* 167(*/0xA7, 0x01/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 189585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 167(*/0xA7, 0x01/*)*/,
     /* 189588 */   GIR_MakeTempReg, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189592 */   GIR_BuildMI, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189597 */   GIR_AddTempRegister, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189604 */   GIR_AddImm, /*InsnID*//* 166(*/0xA6, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 166(*/0xA6, 0x01/*)*/,
     /* 189618 */   GIR_MakeTempReg, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189622 */   GIR_BuildMI, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189627 */   GIR_AddTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189634 */   GIR_AddSimpleTempRegister, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*TempRegID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189639 */   GIR_AddImm, /*InsnID*//* 165(*/0xA5, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189650 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 165(*/0xA5, 0x01/*)*/,
     /* 189653 */   GIR_MakeTempReg, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189657 */   GIR_BuildMI, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189662 */   GIR_AddTempRegister, /*InsnID*//* 164(*/0xA4, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189672 */   GIR_MakeTempReg, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189676 */   GIR_BuildMI, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189681 */   GIR_AddTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189688 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 163(*/0xA3, 0x01/*)*/,
     /* 189693 */   GIR_AddSimpleTempRegister, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*TempRegID*//* 164(*/0xA4, 0x01/*)*/,
     /* 189698 */   GIR_AddImm8, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Imm*/1,
     /* 189702 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189708 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 189714 */   GIR_ConstrainOperandRC, /*InsnID*//* 163(*/0xA3, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 189720 */   GIR_MakeTempReg, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189724 */   GIR_BuildMI, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189729 */   GIR_AddTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189736 */   GIR_AddSimpleTempRegister, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*TempRegID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189741 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/32,
     /* 189745 */   GIR_AddImm8, /*InsnID*//* 162(*/0xA2, 0x01/*)*/, /*Imm*/31,
     /* 189749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 162(*/0xA2, 0x01/*)*/,
     /* 189752 */   GIR_MakeTempReg, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189756 */   GIR_BuildMI, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 189761 */   GIR_AddTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189768 */   GIR_AddSimpleTempRegister, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*TempRegID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189773 */   GIR_AddImm, /*InsnID*//* 161(*/0xA1, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 161(*/0xA1, 0x01/*)*/,
     /* 189787 */   GIR_MakeTempReg, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189791 */   GIR_BuildMI, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 189796 */   GIR_AddTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189803 */   GIR_AddSimpleTempRegister, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*TempRegID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189808 */   GIR_AddImm, /*InsnID*//* 160(*/0xA0, 0x01/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 189819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 160(*/0xA0, 0x01/*)*/,
     /* 189822 */   GIR_MakeTempReg, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189826 */   GIR_BuildMI, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 189831 */   GIR_AddTempRegister, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189838 */   GIR_Copy, /*NewInsnID*//* 159(*/0x9F, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 189843 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/1,
     /* 189847 */   GIR_AddImm8, /*InsnID*//* 159(*/0x9F, 0x01/*)*/, /*Imm*/62,
     /* 189851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189854 */   GIR_MakeTempReg, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189858 */   GIR_BuildMI, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 189863 */   GIR_AddTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189870 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189875 */   GIR_AddSimpleTempRegister, /*InsnID*//* 158(*/0x9E, 0x01/*)*/, /*TempRegID*//* 159(*/0x9F, 0x01/*)*/,
     /* 189880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 158(*/0x9E, 0x01/*)*/,
     /* 189883 */   GIR_MakeTempReg, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189887 */   GIR_BuildMI, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 189892 */   GIR_AddTempRegister, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189899 */   GIR_AddImm, /*InsnID*//* 157(*/0x9D, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 157(*/0x9D, 0x01/*)*/,
     /* 189913 */   GIR_MakeTempReg, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 189917 */   GIR_BuildMI, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 189922 */   GIR_AddTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189929 */   GIR_AddSimpleTempRegister, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*TempRegID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189934 */   GIR_AddImm, /*InsnID*//* 156(*/0x9C, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 189945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 156(*/0x9C, 0x01/*)*/,
     /* 189948 */   GIR_MakeTempReg, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189952 */   GIR_BuildMI, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 189957 */   GIR_AddTempRegister, /*InsnID*//* 155(*/0x9B, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189964 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189967 */   GIR_MakeTempReg, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 189971 */   GIR_BuildMI, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 189976 */   GIR_AddTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 189983 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 154(*/0x9A, 0x01/*)*/,
     /* 189988 */   GIR_AddSimpleTempRegister, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*TempRegID*//* 155(*/0x9B, 0x01/*)*/,
     /* 189993 */   GIR_AddImm8, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Imm*/1,
     /* 189997 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190003 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190009 */   GIR_ConstrainOperandRC, /*InsnID*//* 154(*/0x9A, 0x01/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190015 */   GIR_MakeTempReg, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190019 */   GIR_BuildMI, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190024 */   GIR_AddTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190031 */   GIR_AddSimpleTempRegister, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*TempRegID*//* 153(*/0x99, 0x01/*)*/,
     /* 190036 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/32,
     /* 190040 */   GIR_AddImm8, /*InsnID*//* 153(*/0x99, 0x01/*)*/, /*Imm*/31,
     /* 190044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 153(*/0x99, 0x01/*)*/,
     /* 190047 */   GIR_MakeTempReg, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190051 */   GIR_BuildMI, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190056 */   GIR_AddTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190063 */   GIR_AddSimpleTempRegister, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*TempRegID*//* 152(*/0x98, 0x01/*)*/,
     /* 190068 */   GIR_AddImm, /*InsnID*//* 152(*/0x98, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 152(*/0x98, 0x01/*)*/,
     /* 190082 */   GIR_MakeTempReg, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190086 */   GIR_BuildMI, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190091 */   GIR_AddTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190098 */   GIR_AddSimpleTempRegister, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*TempRegID*//* 151(*/0x97, 0x01/*)*/,
     /* 190103 */   GIR_AddImm, /*InsnID*//* 151(*/0x97, 0x01/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 190114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 151(*/0x97, 0x01/*)*/,
     /* 190117 */   GIR_MakeTempReg, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190121 */   GIR_BuildMI, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190126 */   GIR_AddTempRegister, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190133 */   GIR_Copy, /*NewInsnID*//* 150(*/0x96, 0x01/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 190138 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/63,
     /* 190142 */   GIR_AddImm8, /*InsnID*//* 150(*/0x96, 0x01/*)*/, /*Imm*/1,
     /* 190146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 150(*/0x96, 0x01/*)*/,
     /* 190149 */   GIR_MakeTempReg, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190153 */   GIR_BuildMI, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190158 */   GIR_AddTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190165 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 149(*/0x95, 0x01/*)*/,
     /* 190170 */   GIR_AddSimpleTempRegister, /*InsnID*//* 149(*/0x95, 0x01/*)*/, /*TempRegID*//* 150(*/0x96, 0x01/*)*/,
     /* 190175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 149(*/0x95, 0x01/*)*/,
     /* 190178 */   GIR_MakeTempReg, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190182 */   GIR_BuildMI, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190187 */   GIR_AddTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190194 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 148(*/0x94, 0x01/*)*/,
     /* 190199 */   GIR_AddSimpleTempRegister, /*InsnID*//* 148(*/0x94, 0x01/*)*/, /*TempRegID*//* 157(*/0x9D, 0x01/*)*/,
     /* 190204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 148(*/0x94, 0x01/*)*/,
     /* 190207 */   GIR_MakeTempReg, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190211 */   GIR_BuildMI, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190216 */   GIR_AddTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190223 */   GIR_AddSimpleTempRegister, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*TempRegID*//* 147(*/0x93, 0x01/*)*/,
     /* 190228 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/62,
     /* 190232 */   GIR_AddImm8, /*InsnID*//* 147(*/0x93, 0x01/*)*/, /*Imm*/2,
     /* 190236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 147(*/0x93, 0x01/*)*/,
     /* 190239 */   GIR_MakeTempReg, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190243 */   GIR_BuildMI, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190248 */   GIR_AddTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190255 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 146(*/0x92, 0x01/*)*/,
     /* 190260 */   GIR_AddSimpleTempRegister, /*InsnID*//* 146(*/0x92, 0x01/*)*/, /*TempRegID*//* 166(*/0xA6, 0x01/*)*/,
     /* 190265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 146(*/0x92, 0x01/*)*/,
     /* 190268 */   GIR_MakeTempReg, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190272 */   GIR_BuildMI, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190277 */   GIR_AddTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190284 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 145(*/0x91, 0x01/*)*/,
     /* 190289 */   GIR_AddSimpleTempRegister, /*InsnID*//* 145(*/0x91, 0x01/*)*/, /*TempRegID*//* 173(*/0xAD, 0x01/*)*/,
     /* 190294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 145(*/0x91, 0x01/*)*/,
     /* 190297 */   GIR_MakeTempReg, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190301 */   GIR_BuildMI, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 190306 */   GIR_AddTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190313 */   GIR_AddSimpleTempRegister, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*TempRegID*//* 144(*/0x90, 0x01/*)*/,
     /* 190318 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/60,
     /* 190322 */   GIR_AddImm8, /*InsnID*//* 144(*/0x90, 0x01/*)*/, /*Imm*/4,
     /* 190326 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 144(*/0x90, 0x01/*)*/,
     /* 190329 */   GIR_MakeTempReg, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190333 */   GIR_BuildMI, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 190338 */   GIR_AddTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190345 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190350 */   GIR_AddSimpleTempRegister, /*InsnID*//* 143(*/0x8F, 0x01/*)*/, /*TempRegID*//* 201(*/0xC9, 0x01/*)*/,
     /* 190355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 143(*/0x8F, 0x01/*)*/,
     /* 190358 */   GIR_MakeTempReg, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TypeID*/GILLT_s64,
     /* 190362 */   GIR_BuildMI, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 190367 */   GIR_AddTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190374 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190379 */   GIR_AddSimpleTempRegister, /*InsnID*//* 142(*/0x8E, 0x01/*)*/, /*TempRegID*//* 208(*/0xD0, 0x01/*)*/,
     /* 190384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 142(*/0x8E, 0x01/*)*/,
     /* 190387 */   GIR_MakeTempReg, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190391 */   GIR_BuildMI, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190396 */   GIR_AddTempRegister, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190403 */   GIR_AddImm, /*InsnID*//* 408(*/0x98, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 408(*/0x98, 0x03/*)*/,
     /* 190417 */   GIR_MakeTempReg, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190421 */   GIR_BuildMI, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190426 */   GIR_AddTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190433 */   GIR_AddSimpleTempRegister, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*TempRegID*//* 407(*/0x97, 0x03/*)*/,
     /* 190438 */   GIR_AddImm, /*InsnID*//* 407(*/0x97, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190449 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 407(*/0x97, 0x03/*)*/,
     /* 190452 */   GIR_MakeTempReg, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190456 */   GIR_BuildMI, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190461 */   GIR_AddTempRegister, /*InsnID*//* 406(*/0x96, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 406(*/0x96, 0x03/*)*/,
     /* 190471 */   GIR_MakeTempReg, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190475 */   GIR_BuildMI, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190480 */   GIR_AddTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190487 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 405(*/0x95, 0x03/*)*/,
     /* 190492 */   GIR_AddSimpleTempRegister, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*TempRegID*//* 406(*/0x96, 0x03/*)*/,
     /* 190497 */   GIR_AddImm8, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Imm*/1,
     /* 190501 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190507 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190513 */   GIR_ConstrainOperandRC, /*InsnID*//* 405(*/0x95, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190519 */   GIR_MakeTempReg, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190523 */   GIR_BuildMI, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190528 */   GIR_AddTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190535 */   GIR_AddSimpleTempRegister, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*TempRegID*//* 404(*/0x94, 0x03/*)*/,
     /* 190540 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/32,
     /* 190544 */   GIR_AddImm8, /*InsnID*//* 404(*/0x94, 0x03/*)*/, /*Imm*/31,
     /* 190548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 404(*/0x94, 0x03/*)*/,
     /* 190551 */   GIR_MakeTempReg, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190555 */   GIR_BuildMI, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190560 */   GIR_AddTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190567 */   GIR_AddSimpleTempRegister, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*TempRegID*//* 403(*/0x93, 0x03/*)*/,
     /* 190572 */   GIR_AddImm, /*InsnID*//* 403(*/0x93, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 403(*/0x93, 0x03/*)*/,
     /* 190586 */   GIR_MakeTempReg, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190590 */   GIR_BuildMI, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190595 */   GIR_AddTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190602 */   GIR_AddSimpleTempRegister, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*TempRegID*//* 402(*/0x92, 0x03/*)*/,
     /* 190607 */   GIR_AddImm, /*InsnID*//* 402(*/0x92, 0x03/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 190618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 402(*/0x92, 0x03/*)*/,
     /* 190621 */   GIR_MakeTempReg, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190625 */   GIR_BuildMI, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190630 */   GIR_AddTempRegister, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190637 */   GIR_AddImm, /*InsnID*//* 401(*/0x91, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190648 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 401(*/0x91, 0x03/*)*/,
     /* 190651 */   GIR_MakeTempReg, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190655 */   GIR_BuildMI, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190660 */   GIR_AddTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190667 */   GIR_AddSimpleTempRegister, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*TempRegID*//* 400(*/0x90, 0x03/*)*/,
     /* 190672 */   GIR_AddImm, /*InsnID*//* 400(*/0x90, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 400(*/0x90, 0x03/*)*/,
     /* 190686 */   GIR_MakeTempReg, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190690 */   GIR_BuildMI, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190695 */   GIR_AddTempRegister, /*InsnID*//* 399(*/0x8F, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190705 */   GIR_MakeTempReg, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190709 */   GIR_BuildMI, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190714 */   GIR_AddTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190721 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 398(*/0x8E, 0x03/*)*/,
     /* 190726 */   GIR_AddSimpleTempRegister, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*TempRegID*//* 399(*/0x8F, 0x03/*)*/,
     /* 190731 */   GIR_AddImm8, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Imm*/1,
     /* 190735 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190741 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190747 */   GIR_ConstrainOperandRC, /*InsnID*//* 398(*/0x8E, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190753 */   GIR_MakeTempReg, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190757 */   GIR_BuildMI, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190762 */   GIR_AddTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190769 */   GIR_AddSimpleTempRegister, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*TempRegID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190774 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/32,
     /* 190778 */   GIR_AddImm8, /*InsnID*//* 397(*/0x8D, 0x03/*)*/, /*Imm*/31,
     /* 190782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 397(*/0x8D, 0x03/*)*/,
     /* 190785 */   GIR_MakeTempReg, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190789 */   GIR_BuildMI, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 190794 */   GIR_AddTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190801 */   GIR_AddSimpleTempRegister, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*TempRegID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190806 */   GIR_AddImm, /*InsnID*//* 396(*/0x8C, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 396(*/0x8C, 0x03/*)*/,
     /* 190820 */   GIR_MakeTempReg, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190824 */   GIR_BuildMI, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 190829 */   GIR_AddTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190836 */   GIR_AddSimpleTempRegister, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*TempRegID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190841 */   GIR_AddImm, /*InsnID*//* 395(*/0x8B, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 190852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 395(*/0x8B, 0x03/*)*/,
     /* 190855 */   GIR_MakeTempReg, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190859 */   GIR_BuildMI, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 190864 */   GIR_AddTempRegister, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190871 */   GIR_AddImm, /*InsnID*//* 394(*/0x8A, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 394(*/0x8A, 0x03/*)*/,
     /* 190885 */   GIR_MakeTempReg, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 190889 */   GIR_BuildMI, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 190894 */   GIR_AddTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*TempRegID*//* 393(*/0x89, 0x03/*)*/,
     /* 190906 */   GIR_AddImm, /*InsnID*//* 393(*/0x89, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 190917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 393(*/0x89, 0x03/*)*/,
     /* 190920 */   GIR_MakeTempReg, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190924 */   GIR_BuildMI, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 190929 */   GIR_AddTempRegister, /*InsnID*//* 392(*/0x88, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 392(*/0x88, 0x03/*)*/,
     /* 190939 */   GIR_MakeTempReg, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190943 */   GIR_BuildMI, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 190948 */   GIR_AddTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 190955 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 391(*/0x87, 0x03/*)*/,
     /* 190960 */   GIR_AddSimpleTempRegister, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*TempRegID*//* 392(*/0x88, 0x03/*)*/,
     /* 190965 */   GIR_AddImm8, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Imm*/1,
     /* 190969 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190975 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 190981 */   GIR_ConstrainOperandRC, /*InsnID*//* 391(*/0x87, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 190987 */   GIR_MakeTempReg, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 190991 */   GIR_BuildMI, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 190996 */   GIR_AddTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191003 */   GIR_AddSimpleTempRegister, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*TempRegID*//* 390(*/0x86, 0x03/*)*/,
     /* 191008 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/32,
     /* 191012 */   GIR_AddImm8, /*InsnID*//* 390(*/0x86, 0x03/*)*/, /*Imm*/31,
     /* 191016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 390(*/0x86, 0x03/*)*/,
     /* 191019 */   GIR_MakeTempReg, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191023 */   GIR_BuildMI, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191028 */   GIR_AddTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191035 */   GIR_AddSimpleTempRegister, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*TempRegID*//* 389(*/0x85, 0x03/*)*/,
     /* 191040 */   GIR_AddImm, /*InsnID*//* 389(*/0x85, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 389(*/0x85, 0x03/*)*/,
     /* 191054 */   GIR_MakeTempReg, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191058 */   GIR_BuildMI, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191063 */   GIR_AddTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191070 */   GIR_AddSimpleTempRegister, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*TempRegID*//* 388(*/0x84, 0x03/*)*/,
     /* 191075 */   GIR_AddImm, /*InsnID*//* 388(*/0x84, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 388(*/0x84, 0x03/*)*/,
     /* 191089 */   GIR_MakeTempReg, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191093 */   GIR_BuildMI, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191098 */   GIR_AddTempRegister, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191105 */   GIR_Copy, /*NewInsnID*//* 387(*/0x83, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191110 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/1,
     /* 191114 */   GIR_AddImm8, /*InsnID*//* 387(*/0x83, 0x03/*)*/, /*Imm*/62,
     /* 191118 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 387(*/0x83, 0x03/*)*/,
     /* 191121 */   GIR_MakeTempReg, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 191125 */   GIR_BuildMI, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191130 */   GIR_AddTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191137 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 386(*/0x82, 0x03/*)*/,
     /* 191142 */   GIR_AddSimpleTempRegister, /*InsnID*//* 386(*/0x82, 0x03/*)*/, /*TempRegID*//* 387(*/0x83, 0x03/*)*/,
     /* 191147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 386(*/0x82, 0x03/*)*/,
     /* 191150 */   GIR_MakeTempReg, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 191154 */   GIR_BuildMI, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191159 */   GIR_AddTempRegister, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191166 */   GIR_AddImm, /*InsnID*//* 385(*/0x81, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 385(*/0x81, 0x03/*)*/,
     /* 191180 */   GIR_MakeTempReg, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191184 */   GIR_BuildMI, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191189 */   GIR_AddTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191196 */   GIR_AddSimpleTempRegister, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*TempRegID*//* 384(*/0x80, 0x03/*)*/,
     /* 191201 */   GIR_AddImm, /*InsnID*//* 384(*/0x80, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 384(*/0x80, 0x03/*)*/,
     /* 191215 */   GIR_MakeTempReg, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191219 */   GIR_BuildMI, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191224 */   GIR_AddTempRegister, /*InsnID*//* 383(*/0xFF, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 383(*/0xFF, 0x02/*)*/,
     /* 191234 */   GIR_MakeTempReg, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191238 */   GIR_BuildMI, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191243 */   GIR_AddTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191250 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 382(*/0xFE, 0x02/*)*/,
     /* 191255 */   GIR_AddSimpleTempRegister, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*TempRegID*//* 383(*/0xFF, 0x02/*)*/,
     /* 191260 */   GIR_AddImm8, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Imm*/1,
     /* 191264 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191270 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191276 */   GIR_ConstrainOperandRC, /*InsnID*//* 382(*/0xFE, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191282 */   GIR_MakeTempReg, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191286 */   GIR_BuildMI, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191291 */   GIR_AddTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191298 */   GIR_AddSimpleTempRegister, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*TempRegID*//* 381(*/0xFD, 0x02/*)*/,
     /* 191303 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/32,
     /* 191307 */   GIR_AddImm8, /*InsnID*//* 381(*/0xFD, 0x02/*)*/, /*Imm*/31,
     /* 191311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 381(*/0xFD, 0x02/*)*/,
     /* 191314 */   GIR_MakeTempReg, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191318 */   GIR_BuildMI, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191323 */   GIR_AddTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191330 */   GIR_AddSimpleTempRegister, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*TempRegID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191335 */   GIR_AddImm, /*InsnID*//* 380(*/0xFC, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 380(*/0xFC, 0x02/*)*/,
     /* 191349 */   GIR_MakeTempReg, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191353 */   GIR_BuildMI, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191358 */   GIR_AddTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191365 */   GIR_AddSimpleTempRegister, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*TempRegID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191370 */   GIR_AddImm, /*InsnID*//* 379(*/0xFB, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 191381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 379(*/0xFB, 0x02/*)*/,
     /* 191384 */   GIR_MakeTempReg, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191388 */   GIR_BuildMI, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 191393 */   GIR_AddTempRegister, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191400 */   GIR_Copy, /*NewInsnID*//* 378(*/0xFA, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 191405 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/63,
     /* 191409 */   GIR_AddImm8, /*InsnID*//* 378(*/0xFA, 0x02/*)*/, /*Imm*/1,
     /* 191413 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191416 */   GIR_MakeTempReg, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191420 */   GIR_BuildMI, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191425 */   GIR_AddTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191432 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191437 */   GIR_AddSimpleTempRegister, /*InsnID*//* 377(*/0xF9, 0x02/*)*/, /*TempRegID*//* 378(*/0xFA, 0x02/*)*/,
     /* 191442 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 377(*/0xF9, 0x02/*)*/,
     /* 191445 */   GIR_MakeTempReg, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191449 */   GIR_BuildMI, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 191454 */   GIR_AddTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191461 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191466 */   GIR_AddSimpleTempRegister, /*InsnID*//* 376(*/0xF8, 0x02/*)*/, /*TempRegID*//* 385(*/0x81, 0x03/*)*/,
     /* 191471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 376(*/0xF8, 0x02/*)*/,
     /* 191474 */   GIR_MakeTempReg, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191478 */   GIR_BuildMI, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191483 */   GIR_AddTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191490 */   GIR_AddSimpleTempRegister, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*TempRegID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191495 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/2,
     /* 191499 */   GIR_AddImm8, /*InsnID*//* 375(*/0xF7, 0x02/*)*/, /*Imm*/61,
     /* 191503 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 375(*/0xF7, 0x02/*)*/,
     /* 191506 */   GIR_MakeTempReg, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191510 */   GIR_BuildMI, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 191515 */   GIR_AddTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191522 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191527 */   GIR_AddSimpleTempRegister, /*InsnID*//* 374(*/0xF6, 0x02/*)*/, /*TempRegID*//* 394(*/0x8A, 0x03/*)*/,
     /* 191532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 374(*/0xF6, 0x02/*)*/,
     /* 191535 */   GIR_MakeTempReg, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191539 */   GIR_BuildMI, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191544 */   GIR_AddTempRegister, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191551 */   GIR_AddImm, /*InsnID*//* 373(*/0xF5, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 373(*/0xF5, 0x02/*)*/,
     /* 191565 */   GIR_MakeTempReg, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191569 */   GIR_BuildMI, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191574 */   GIR_AddTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191581 */   GIR_AddSimpleTempRegister, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*TempRegID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191586 */   GIR_AddImm, /*InsnID*//* 372(*/0xF4, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 372(*/0xF4, 0x02/*)*/,
     /* 191600 */   GIR_MakeTempReg, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191604 */   GIR_BuildMI, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191609 */   GIR_AddTempRegister, /*InsnID*//* 371(*/0xF3, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191619 */   GIR_MakeTempReg, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191623 */   GIR_BuildMI, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191628 */   GIR_AddTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191635 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 370(*/0xF2, 0x02/*)*/,
     /* 191640 */   GIR_AddSimpleTempRegister, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*TempRegID*//* 371(*/0xF3, 0x02/*)*/,
     /* 191645 */   GIR_AddImm8, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Imm*/1,
     /* 191649 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191655 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191661 */   GIR_ConstrainOperandRC, /*InsnID*//* 370(*/0xF2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191667 */   GIR_MakeTempReg, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191671 */   GIR_BuildMI, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191676 */   GIR_AddTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191683 */   GIR_AddSimpleTempRegister, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*TempRegID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191688 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/32,
     /* 191692 */   GIR_AddImm8, /*InsnID*//* 369(*/0xF1, 0x02/*)*/, /*Imm*/31,
     /* 191696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 369(*/0xF1, 0x02/*)*/,
     /* 191699 */   GIR_MakeTempReg, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191703 */   GIR_BuildMI, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191708 */   GIR_AddTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191715 */   GIR_AddSimpleTempRegister, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*TempRegID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191720 */   GIR_AddImm, /*InsnID*//* 368(*/0xF0, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 368(*/0xF0, 0x02/*)*/,
     /* 191734 */   GIR_MakeTempReg, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191738 */   GIR_BuildMI, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191743 */   GIR_AddTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191750 */   GIR_AddSimpleTempRegister, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*TempRegID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191755 */   GIR_AddImm, /*InsnID*//* 367(*/0xEF, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 191766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 367(*/0xEF, 0x02/*)*/,
     /* 191769 */   GIR_MakeTempReg, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191773 */   GIR_BuildMI, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 191778 */   GIR_AddTempRegister, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191785 */   GIR_AddImm, /*InsnID*//* 366(*/0xEE, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 366(*/0xEE, 0x02/*)*/,
     /* 191799 */   GIR_MakeTempReg, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 191803 */   GIR_BuildMI, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 191808 */   GIR_AddTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191815 */   GIR_AddSimpleTempRegister, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*TempRegID*//* 365(*/0xED, 0x02/*)*/,
     /* 191820 */   GIR_AddImm, /*InsnID*//* 365(*/0xED, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 365(*/0xED, 0x02/*)*/,
     /* 191834 */   GIR_MakeTempReg, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191838 */   GIR_BuildMI, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 191843 */   GIR_AddTempRegister, /*InsnID*//* 364(*/0xEC, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191853 */   GIR_MakeTempReg, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191857 */   GIR_BuildMI, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 191862 */   GIR_AddTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191869 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 363(*/0xEB, 0x02/*)*/,
     /* 191874 */   GIR_AddSimpleTempRegister, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*TempRegID*//* 364(*/0xEC, 0x02/*)*/,
     /* 191879 */   GIR_AddImm8, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Imm*/1,
     /* 191883 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191889 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 191895 */   GIR_ConstrainOperandRC, /*InsnID*//* 363(*/0xEB, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 191901 */   GIR_MakeTempReg, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191905 */   GIR_BuildMI, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 191910 */   GIR_AddTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191917 */   GIR_AddSimpleTempRegister, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*TempRegID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191922 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/32,
     /* 191926 */   GIR_AddImm8, /*InsnID*//* 362(*/0xEA, 0x02/*)*/, /*Imm*/31,
     /* 191930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 362(*/0xEA, 0x02/*)*/,
     /* 191933 */   GIR_MakeTempReg, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191937 */   GIR_BuildMI, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 191942 */   GIR_AddTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191949 */   GIR_AddSimpleTempRegister, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*TempRegID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191954 */   GIR_AddImm, /*InsnID*//* 361(*/0xE9, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 191965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 361(*/0xE9, 0x02/*)*/,
     /* 191968 */   GIR_MakeTempReg, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 191972 */   GIR_BuildMI, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 191977 */   GIR_AddTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 191984 */   GIR_AddSimpleTempRegister, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*TempRegID*//* 360(*/0xE8, 0x02/*)*/,
     /* 191989 */   GIR_AddImm, /*InsnID*//* 360(*/0xE8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 192000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 360(*/0xE8, 0x02/*)*/,
     /* 192003 */   GIR_MakeTempReg, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192007 */   GIR_BuildMI, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192012 */   GIR_AddTempRegister, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192019 */   GIR_Copy, /*NewInsnID*//* 359(*/0xE7, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192024 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/1,
     /* 192028 */   GIR_AddImm8, /*InsnID*//* 359(*/0xE7, 0x02/*)*/, /*Imm*/62,
     /* 192032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 359(*/0xE7, 0x02/*)*/,
     /* 192035 */   GIR_MakeTempReg, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192039 */   GIR_BuildMI, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192044 */   GIR_AddTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192051 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 358(*/0xE6, 0x02/*)*/,
     /* 192056 */   GIR_AddSimpleTempRegister, /*InsnID*//* 358(*/0xE6, 0x02/*)*/, /*TempRegID*//* 359(*/0xE7, 0x02/*)*/,
     /* 192061 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 358(*/0xE6, 0x02/*)*/,
     /* 192064 */   GIR_MakeTempReg, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192068 */   GIR_BuildMI, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192073 */   GIR_AddTempRegister, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192080 */   GIR_AddImm, /*InsnID*//* 357(*/0xE5, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 357(*/0xE5, 0x02/*)*/,
     /* 192094 */   GIR_MakeTempReg, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192098 */   GIR_BuildMI, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192103 */   GIR_AddTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192110 */   GIR_AddSimpleTempRegister, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*TempRegID*//* 356(*/0xE4, 0x02/*)*/,
     /* 192115 */   GIR_AddImm, /*InsnID*//* 356(*/0xE4, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 356(*/0xE4, 0x02/*)*/,
     /* 192129 */   GIR_MakeTempReg, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192133 */   GIR_BuildMI, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192138 */   GIR_AddTempRegister, /*InsnID*//* 355(*/0xE3, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 355(*/0xE3, 0x02/*)*/,
     /* 192148 */   GIR_MakeTempReg, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192152 */   GIR_BuildMI, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192157 */   GIR_AddTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192164 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 354(*/0xE2, 0x02/*)*/,
     /* 192169 */   GIR_AddSimpleTempRegister, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*TempRegID*//* 355(*/0xE3, 0x02/*)*/,
     /* 192174 */   GIR_AddImm8, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Imm*/1,
     /* 192178 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192184 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192190 */   GIR_ConstrainOperandRC, /*InsnID*//* 354(*/0xE2, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192196 */   GIR_MakeTempReg, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192200 */   GIR_BuildMI, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192205 */   GIR_AddTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192212 */   GIR_AddSimpleTempRegister, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*TempRegID*//* 353(*/0xE1, 0x02/*)*/,
     /* 192217 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/32,
     /* 192221 */   GIR_AddImm8, /*InsnID*//* 353(*/0xE1, 0x02/*)*/, /*Imm*/31,
     /* 192225 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 353(*/0xE1, 0x02/*)*/,
     /* 192228 */   GIR_MakeTempReg, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192232 */   GIR_BuildMI, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192237 */   GIR_AddTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192244 */   GIR_AddSimpleTempRegister, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*TempRegID*//* 352(*/0xE0, 0x02/*)*/,
     /* 192249 */   GIR_AddImm, /*InsnID*//* 352(*/0xE0, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 352(*/0xE0, 0x02/*)*/,
     /* 192263 */   GIR_MakeTempReg, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192267 */   GIR_BuildMI, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192272 */   GIR_AddTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192279 */   GIR_AddSimpleTempRegister, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*TempRegID*//* 351(*/0xDF, 0x02/*)*/,
     /* 192284 */   GIR_AddImm, /*InsnID*//* 351(*/0xDF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 192295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 351(*/0xDF, 0x02/*)*/,
     /* 192298 */   GIR_MakeTempReg, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192302 */   GIR_BuildMI, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192307 */   GIR_AddTempRegister, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192314 */   GIR_Copy, /*NewInsnID*//* 350(*/0xDE, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 192319 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/63,
     /* 192323 */   GIR_AddImm8, /*InsnID*//* 350(*/0xDE, 0x02/*)*/, /*Imm*/1,
     /* 192327 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192330 */   GIR_MakeTempReg, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192334 */   GIR_BuildMI, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192339 */   GIR_AddTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192346 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192351 */   GIR_AddSimpleTempRegister, /*InsnID*//* 349(*/0xDD, 0x02/*)*/, /*TempRegID*//* 350(*/0xDE, 0x02/*)*/,
     /* 192356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 349(*/0xDD, 0x02/*)*/,
     /* 192359 */   GIR_MakeTempReg, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192363 */   GIR_BuildMI, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192368 */   GIR_AddTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192375 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192380 */   GIR_AddSimpleTempRegister, /*InsnID*//* 348(*/0xDC, 0x02/*)*/, /*TempRegID*//* 357(*/0xE5, 0x02/*)*/,
     /* 192385 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 348(*/0xDC, 0x02/*)*/,
     /* 192388 */   GIR_MakeTempReg, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192392 */   GIR_BuildMI, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 192397 */   GIR_AddTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192404 */   GIR_AddSimpleTempRegister, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*TempRegID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192409 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/62,
     /* 192413 */   GIR_AddImm8, /*InsnID*//* 347(*/0xDB, 0x02/*)*/, /*Imm*/2,
     /* 192417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 347(*/0xDB, 0x02/*)*/,
     /* 192420 */   GIR_MakeTempReg, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192424 */   GIR_BuildMI, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192429 */   GIR_AddTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192436 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192441 */   GIR_AddSimpleTempRegister, /*InsnID*//* 346(*/0xDA, 0x02/*)*/, /*TempRegID*//* 366(*/0xEE, 0x02/*)*/,
     /* 192446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 346(*/0xDA, 0x02/*)*/,
     /* 192449 */   GIR_MakeTempReg, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192453 */   GIR_BuildMI, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 192458 */   GIR_AddTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192465 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192470 */   GIR_AddSimpleTempRegister, /*InsnID*//* 345(*/0xD9, 0x02/*)*/, /*TempRegID*//* 373(*/0xF5, 0x02/*)*/,
     /* 192475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 345(*/0xD9, 0x02/*)*/,
     /* 192478 */   GIR_MakeTempReg, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192482 */   GIR_BuildMI, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192487 */   GIR_AddTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192494 */   GIR_AddSimpleTempRegister, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*TempRegID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192499 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/4,
     /* 192503 */   GIR_AddImm8, /*InsnID*//* 344(*/0xD8, 0x02/*)*/, /*Imm*/59,
     /* 192507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 344(*/0xD8, 0x02/*)*/,
     /* 192510 */   GIR_MakeTempReg, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192514 */   GIR_BuildMI, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 192519 */   GIR_AddTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192526 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192531 */   GIR_AddSimpleTempRegister, /*InsnID*//* 343(*/0xD7, 0x02/*)*/, /*TempRegID*//* 401(*/0x91, 0x03/*)*/,
     /* 192536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 343(*/0xD7, 0x02/*)*/,
     /* 192539 */   GIR_MakeTempReg, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192543 */   GIR_BuildMI, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192548 */   GIR_AddTempRegister, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192555 */   GIR_AddImm, /*InsnID*//* 342(*/0xD6, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 342(*/0xD6, 0x02/*)*/,
     /* 192569 */   GIR_MakeTempReg, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192573 */   GIR_BuildMI, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192578 */   GIR_AddTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192585 */   GIR_AddSimpleTempRegister, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*TempRegID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192590 */   GIR_AddImm, /*InsnID*//* 341(*/0xD5, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192601 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 341(*/0xD5, 0x02/*)*/,
     /* 192604 */   GIR_MakeTempReg, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192608 */   GIR_BuildMI, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192613 */   GIR_AddTempRegister, /*InsnID*//* 340(*/0xD4, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192623 */   GIR_MakeTempReg, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192627 */   GIR_BuildMI, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192632 */   GIR_AddTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192639 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 339(*/0xD3, 0x02/*)*/,
     /* 192644 */   GIR_AddSimpleTempRegister, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*TempRegID*//* 340(*/0xD4, 0x02/*)*/,
     /* 192649 */   GIR_AddImm8, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Imm*/1,
     /* 192653 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192659 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192665 */   GIR_ConstrainOperandRC, /*InsnID*//* 339(*/0xD3, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192671 */   GIR_MakeTempReg, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192675 */   GIR_BuildMI, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192680 */   GIR_AddTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192687 */   GIR_AddSimpleTempRegister, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*TempRegID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192692 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/32,
     /* 192696 */   GIR_AddImm8, /*InsnID*//* 338(*/0xD2, 0x02/*)*/, /*Imm*/31,
     /* 192700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 338(*/0xD2, 0x02/*)*/,
     /* 192703 */   GIR_MakeTempReg, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192707 */   GIR_BuildMI, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192712 */   GIR_AddTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192719 */   GIR_AddSimpleTempRegister, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*TempRegID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192724 */   GIR_AddImm, /*InsnID*//* 337(*/0xD1, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192735 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 337(*/0xD1, 0x02/*)*/,
     /* 192738 */   GIR_MakeTempReg, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192742 */   GIR_BuildMI, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192747 */   GIR_AddTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192754 */   GIR_AddSimpleTempRegister, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*TempRegID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192759 */   GIR_AddImm, /*InsnID*//* 336(*/0xD0, 0x02/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 192770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 336(*/0xD0, 0x02/*)*/,
     /* 192773 */   GIR_MakeTempReg, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192777 */   GIR_BuildMI, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 192782 */   GIR_AddTempRegister, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192789 */   GIR_AddImm, /*InsnID*//* 335(*/0xCF, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 335(*/0xCF, 0x02/*)*/,
     /* 192803 */   GIR_MakeTempReg, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 192807 */   GIR_BuildMI, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 192812 */   GIR_AddTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192819 */   GIR_AddSimpleTempRegister, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*TempRegID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192824 */   GIR_AddImm, /*InsnID*//* 334(*/0xCE, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 334(*/0xCE, 0x02/*)*/,
     /* 192838 */   GIR_MakeTempReg, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192842 */   GIR_BuildMI, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 192847 */   GIR_AddTempRegister, /*InsnID*//* 333(*/0xCD, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192857 */   GIR_MakeTempReg, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192861 */   GIR_BuildMI, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 192866 */   GIR_AddTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192873 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 332(*/0xCC, 0x02/*)*/,
     /* 192878 */   GIR_AddSimpleTempRegister, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*TempRegID*//* 333(*/0xCD, 0x02/*)*/,
     /* 192883 */   GIR_AddImm8, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Imm*/1,
     /* 192887 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192893 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 192899 */   GIR_ConstrainOperandRC, /*InsnID*//* 332(*/0xCC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 192905 */   GIR_MakeTempReg, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192909 */   GIR_BuildMI, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 192914 */   GIR_AddTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192921 */   GIR_AddSimpleTempRegister, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*TempRegID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192926 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/32,
     /* 192930 */   GIR_AddImm8, /*InsnID*//* 331(*/0xCB, 0x02/*)*/, /*Imm*/31,
     /* 192934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 331(*/0xCB, 0x02/*)*/,
     /* 192937 */   GIR_MakeTempReg, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192941 */   GIR_BuildMI, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 192946 */   GIR_AddTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192953 */   GIR_AddSimpleTempRegister, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*TempRegID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192958 */   GIR_AddImm, /*InsnID*//* 330(*/0xCA, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 192969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 330(*/0xCA, 0x02/*)*/,
     /* 192972 */   GIR_MakeTempReg, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 192976 */   GIR_BuildMI, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 192981 */   GIR_AddTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 192988 */   GIR_AddSimpleTempRegister, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*TempRegID*//* 329(*/0xC9, 0x02/*)*/,
     /* 192993 */   GIR_AddImm, /*InsnID*//* 329(*/0xC9, 0x02/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 193004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 329(*/0xC9, 0x02/*)*/,
     /* 193007 */   GIR_MakeTempReg, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193011 */   GIR_BuildMI, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193016 */   GIR_AddTempRegister, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193023 */   GIR_AddImm, /*InsnID*//* 328(*/0xC8, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 328(*/0xC8, 0x02/*)*/,
     /* 193037 */   GIR_MakeTempReg, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193041 */   GIR_BuildMI, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193046 */   GIR_AddTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193053 */   GIR_AddSimpleTempRegister, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*TempRegID*//* 327(*/0xC7, 0x02/*)*/,
     /* 193058 */   GIR_AddImm, /*InsnID*//* 327(*/0xC7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 327(*/0xC7, 0x02/*)*/,
     /* 193072 */   GIR_MakeTempReg, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193076 */   GIR_BuildMI, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193081 */   GIR_AddTempRegister, /*InsnID*//* 326(*/0xC6, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 326(*/0xC6, 0x02/*)*/,
     /* 193091 */   GIR_MakeTempReg, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193095 */   GIR_BuildMI, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193100 */   GIR_AddTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193107 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 325(*/0xC5, 0x02/*)*/,
     /* 193112 */   GIR_AddSimpleTempRegister, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*TempRegID*//* 326(*/0xC6, 0x02/*)*/,
     /* 193117 */   GIR_AddImm8, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Imm*/1,
     /* 193121 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193127 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193133 */   GIR_ConstrainOperandRC, /*InsnID*//* 325(*/0xC5, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193139 */   GIR_MakeTempReg, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193143 */   GIR_BuildMI, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193148 */   GIR_AddTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193155 */   GIR_AddSimpleTempRegister, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*TempRegID*//* 324(*/0xC4, 0x02/*)*/,
     /* 193160 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/32,
     /* 193164 */   GIR_AddImm8, /*InsnID*//* 324(*/0xC4, 0x02/*)*/, /*Imm*/31,
     /* 193168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 324(*/0xC4, 0x02/*)*/,
     /* 193171 */   GIR_MakeTempReg, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193175 */   GIR_BuildMI, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193180 */   GIR_AddTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193187 */   GIR_AddSimpleTempRegister, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*TempRegID*//* 323(*/0xC3, 0x02/*)*/,
     /* 193192 */   GIR_AddImm, /*InsnID*//* 323(*/0xC3, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 323(*/0xC3, 0x02/*)*/,
     /* 193206 */   GIR_MakeTempReg, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193210 */   GIR_BuildMI, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193215 */   GIR_AddTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193222 */   GIR_AddSimpleTempRegister, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*TempRegID*//* 322(*/0xC2, 0x02/*)*/,
     /* 193227 */   GIR_AddImm, /*InsnID*//* 322(*/0xC2, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 322(*/0xC2, 0x02/*)*/,
     /* 193241 */   GIR_MakeTempReg, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193245 */   GIR_BuildMI, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193250 */   GIR_AddTempRegister, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193257 */   GIR_Copy, /*NewInsnID*//* 321(*/0xC1, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193262 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/1,
     /* 193266 */   GIR_AddImm8, /*InsnID*//* 321(*/0xC1, 0x02/*)*/, /*Imm*/62,
     /* 193270 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 321(*/0xC1, 0x02/*)*/,
     /* 193273 */   GIR_MakeTempReg, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193277 */   GIR_BuildMI, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193282 */   GIR_AddTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193289 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 320(*/0xC0, 0x02/*)*/,
     /* 193294 */   GIR_AddSimpleTempRegister, /*InsnID*//* 320(*/0xC0, 0x02/*)*/, /*TempRegID*//* 321(*/0xC1, 0x02/*)*/,
     /* 193299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 320(*/0xC0, 0x02/*)*/,
     /* 193302 */   GIR_MakeTempReg, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193306 */   GIR_BuildMI, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193311 */   GIR_AddTempRegister, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193318 */   GIR_AddImm, /*InsnID*//* 319(*/0xBF, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193329 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193332 */   GIR_MakeTempReg, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193336 */   GIR_BuildMI, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193341 */   GIR_AddTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193348 */   GIR_AddSimpleTempRegister, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*TempRegID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193353 */   GIR_AddImm, /*InsnID*//* 318(*/0xBE, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 318(*/0xBE, 0x02/*)*/,
     /* 193367 */   GIR_MakeTempReg, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193371 */   GIR_BuildMI, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193376 */   GIR_AddTempRegister, /*InsnID*//* 317(*/0xBD, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193386 */   GIR_MakeTempReg, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193390 */   GIR_BuildMI, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193395 */   GIR_AddTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193402 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 316(*/0xBC, 0x02/*)*/,
     /* 193407 */   GIR_AddSimpleTempRegister, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*TempRegID*//* 317(*/0xBD, 0x02/*)*/,
     /* 193412 */   GIR_AddImm8, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Imm*/1,
     /* 193416 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193422 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193428 */   GIR_ConstrainOperandRC, /*InsnID*//* 316(*/0xBC, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193434 */   GIR_MakeTempReg, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193438 */   GIR_BuildMI, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193443 */   GIR_AddTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193450 */   GIR_AddSimpleTempRegister, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*TempRegID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193455 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/32,
     /* 193459 */   GIR_AddImm8, /*InsnID*//* 315(*/0xBB, 0x02/*)*/, /*Imm*/31,
     /* 193463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 315(*/0xBB, 0x02/*)*/,
     /* 193466 */   GIR_MakeTempReg, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193470 */   GIR_BuildMI, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193475 */   GIR_AddTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193482 */   GIR_AddSimpleTempRegister, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*TempRegID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193487 */   GIR_AddImm, /*InsnID*//* 314(*/0xBA, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 314(*/0xBA, 0x02/*)*/,
     /* 193501 */   GIR_MakeTempReg, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193505 */   GIR_BuildMI, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193510 */   GIR_AddTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193517 */   GIR_AddSimpleTempRegister, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*TempRegID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193522 */   GIR_AddImm, /*InsnID*//* 313(*/0xB9, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 193533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 313(*/0xB9, 0x02/*)*/,
     /* 193536 */   GIR_MakeTempReg, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193540 */   GIR_BuildMI, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 193545 */   GIR_AddTempRegister, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193552 */   GIR_Copy, /*NewInsnID*//* 312(*/0xB8, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 193557 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/63,
     /* 193561 */   GIR_AddImm8, /*InsnID*//* 312(*/0xB8, 0x02/*)*/, /*Imm*/1,
     /* 193565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193568 */   GIR_MakeTempReg, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193572 */   GIR_BuildMI, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193577 */   GIR_AddTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193584 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193589 */   GIR_AddSimpleTempRegister, /*InsnID*//* 311(*/0xB7, 0x02/*)*/, /*TempRegID*//* 312(*/0xB8, 0x02/*)*/,
     /* 193594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 311(*/0xB7, 0x02/*)*/,
     /* 193597 */   GIR_MakeTempReg, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193601 */   GIR_BuildMI, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 193606 */   GIR_AddTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193613 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193618 */   GIR_AddSimpleTempRegister, /*InsnID*//* 310(*/0xB6, 0x02/*)*/, /*TempRegID*//* 319(*/0xBF, 0x02/*)*/,
     /* 193623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 310(*/0xB6, 0x02/*)*/,
     /* 193626 */   GIR_MakeTempReg, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193630 */   GIR_BuildMI, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193635 */   GIR_AddTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193642 */   GIR_AddSimpleTempRegister, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*TempRegID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193647 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/2,
     /* 193651 */   GIR_AddImm8, /*InsnID*//* 309(*/0xB5, 0x02/*)*/, /*Imm*/61,
     /* 193655 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 309(*/0xB5, 0x02/*)*/,
     /* 193658 */   GIR_MakeTempReg, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193662 */   GIR_BuildMI, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 193667 */   GIR_AddTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193674 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193679 */   GIR_AddSimpleTempRegister, /*InsnID*//* 308(*/0xB4, 0x02/*)*/, /*TempRegID*//* 328(*/0xC8, 0x02/*)*/,
     /* 193684 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 308(*/0xB4, 0x02/*)*/,
     /* 193687 */   GIR_MakeTempReg, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193691 */   GIR_BuildMI, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193696 */   GIR_AddTempRegister, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193703 */   GIR_AddImm, /*InsnID*//* 307(*/0xB3, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 307(*/0xB3, 0x02/*)*/,
     /* 193717 */   GIR_MakeTempReg, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193721 */   GIR_BuildMI, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193726 */   GIR_AddTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193733 */   GIR_AddSimpleTempRegister, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*TempRegID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193738 */   GIR_AddImm, /*InsnID*//* 306(*/0xB2, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 306(*/0xB2, 0x02/*)*/,
     /* 193752 */   GIR_MakeTempReg, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193756 */   GIR_BuildMI, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193761 */   GIR_AddTempRegister, /*InsnID*//* 305(*/0xB1, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193771 */   GIR_MakeTempReg, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193775 */   GIR_BuildMI, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 193780 */   GIR_AddTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193787 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 304(*/0xB0, 0x02/*)*/,
     /* 193792 */   GIR_AddSimpleTempRegister, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*TempRegID*//* 305(*/0xB1, 0x02/*)*/,
     /* 193797 */   GIR_AddImm8, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Imm*/1,
     /* 193801 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193807 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 193813 */   GIR_ConstrainOperandRC, /*InsnID*//* 304(*/0xB0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 193819 */   GIR_MakeTempReg, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193823 */   GIR_BuildMI, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 193828 */   GIR_AddTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193835 */   GIR_AddSimpleTempRegister, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*TempRegID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193840 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/32,
     /* 193844 */   GIR_AddImm8, /*InsnID*//* 303(*/0xAF, 0x02/*)*/, /*Imm*/31,
     /* 193848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 303(*/0xAF, 0x02/*)*/,
     /* 193851 */   GIR_MakeTempReg, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193855 */   GIR_BuildMI, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 193860 */   GIR_AddTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193867 */   GIR_AddSimpleTempRegister, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*TempRegID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193872 */   GIR_AddImm, /*InsnID*//* 302(*/0xAE, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193883 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 302(*/0xAE, 0x02/*)*/,
     /* 193886 */   GIR_MakeTempReg, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193890 */   GIR_BuildMI, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 193895 */   GIR_AddTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193902 */   GIR_AddSimpleTempRegister, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*TempRegID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193907 */   GIR_AddImm, /*InsnID*//* 301(*/0xAD, 0x02/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 193918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 301(*/0xAD, 0x02/*)*/,
     /* 193921 */   GIR_MakeTempReg, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193925 */   GIR_BuildMI, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 193930 */   GIR_AddTempRegister, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193937 */   GIR_AddImm, /*InsnID*//* 300(*/0xAC, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 300(*/0xAC, 0x02/*)*/,
     /* 193951 */   GIR_MakeTempReg, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 193955 */   GIR_BuildMI, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 193960 */   GIR_AddTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 193967 */   GIR_AddSimpleTempRegister, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*TempRegID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193972 */   GIR_AddImm, /*InsnID*//* 299(*/0xAB, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 193983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 299(*/0xAB, 0x02/*)*/,
     /* 193986 */   GIR_MakeTempReg, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 193990 */   GIR_BuildMI, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 193995 */   GIR_AddTempRegister, /*InsnID*//* 298(*/0xAA, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 298(*/0xAA, 0x02/*)*/,
     /* 194005 */   GIR_MakeTempReg, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194009 */   GIR_BuildMI, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194014 */   GIR_AddTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194021 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 297(*/0xA9, 0x02/*)*/,
     /* 194026 */   GIR_AddSimpleTempRegister, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*TempRegID*//* 298(*/0xAA, 0x02/*)*/,
     /* 194031 */   GIR_AddImm8, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Imm*/1,
     /* 194035 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194041 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194047 */   GIR_ConstrainOperandRC, /*InsnID*//* 297(*/0xA9, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194053 */   GIR_MakeTempReg, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194057 */   GIR_BuildMI, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194062 */   GIR_AddTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194069 */   GIR_AddSimpleTempRegister, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*TempRegID*//* 296(*/0xA8, 0x02/*)*/,
     /* 194074 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/32,
     /* 194078 */   GIR_AddImm8, /*InsnID*//* 296(*/0xA8, 0x02/*)*/, /*Imm*/31,
     /* 194082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 296(*/0xA8, 0x02/*)*/,
     /* 194085 */   GIR_MakeTempReg, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194089 */   GIR_BuildMI, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194094 */   GIR_AddTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194101 */   GIR_AddSimpleTempRegister, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*TempRegID*//* 295(*/0xA7, 0x02/*)*/,
     /* 194106 */   GIR_AddImm, /*InsnID*//* 295(*/0xA7, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194117 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 295(*/0xA7, 0x02/*)*/,
     /* 194120 */   GIR_MakeTempReg, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194124 */   GIR_BuildMI, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194129 */   GIR_AddTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194136 */   GIR_AddSimpleTempRegister, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*TempRegID*//* 294(*/0xA6, 0x02/*)*/,
     /* 194141 */   GIR_AddImm, /*InsnID*//* 294(*/0xA6, 0x02/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 194152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 294(*/0xA6, 0x02/*)*/,
     /* 194155 */   GIR_MakeTempReg, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194159 */   GIR_BuildMI, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194164 */   GIR_AddTempRegister, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194171 */   GIR_Copy, /*NewInsnID*//* 293(*/0xA5, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194176 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/1,
     /* 194180 */   GIR_AddImm8, /*InsnID*//* 293(*/0xA5, 0x02/*)*/, /*Imm*/62,
     /* 194184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 293(*/0xA5, 0x02/*)*/,
     /* 194187 */   GIR_MakeTempReg, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194191 */   GIR_BuildMI, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194196 */   GIR_AddTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194203 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 292(*/0xA4, 0x02/*)*/,
     /* 194208 */   GIR_AddSimpleTempRegister, /*InsnID*//* 292(*/0xA4, 0x02/*)*/, /*TempRegID*//* 293(*/0xA5, 0x02/*)*/,
     /* 194213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 292(*/0xA4, 0x02/*)*/,
     /* 194216 */   GIR_MakeTempReg, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 194220 */   GIR_BuildMI, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194225 */   GIR_AddTempRegister, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194232 */   GIR_AddImm, /*InsnID*//* 291(*/0xA3, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194243 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 291(*/0xA3, 0x02/*)*/,
     /* 194246 */   GIR_MakeTempReg, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 194250 */   GIR_BuildMI, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194255 */   GIR_AddTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194262 */   GIR_AddSimpleTempRegister, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*TempRegID*//* 290(*/0xA2, 0x02/*)*/,
     /* 194267 */   GIR_AddImm, /*InsnID*//* 290(*/0xA2, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 290(*/0xA2, 0x02/*)*/,
     /* 194281 */   GIR_MakeTempReg, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194285 */   GIR_BuildMI, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194290 */   GIR_AddTempRegister, /*InsnID*//* 289(*/0xA1, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194297 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 289(*/0xA1, 0x02/*)*/,
     /* 194300 */   GIR_MakeTempReg, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194304 */   GIR_BuildMI, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194309 */   GIR_AddTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194316 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 288(*/0xA0, 0x02/*)*/,
     /* 194321 */   GIR_AddSimpleTempRegister, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*TempRegID*//* 289(*/0xA1, 0x02/*)*/,
     /* 194326 */   GIR_AddImm8, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Imm*/1,
     /* 194330 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194336 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194342 */   GIR_ConstrainOperandRC, /*InsnID*//* 288(*/0xA0, 0x02/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194348 */   GIR_MakeTempReg, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194352 */   GIR_BuildMI, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194357 */   GIR_AddTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194364 */   GIR_AddSimpleTempRegister, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*TempRegID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194369 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/32,
     /* 194373 */   GIR_AddImm8, /*InsnID*//* 287(*/0x9F, 0x02/*)*/, /*Imm*/31,
     /* 194377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 287(*/0x9F, 0x02/*)*/,
     /* 194380 */   GIR_MakeTempReg, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194384 */   GIR_BuildMI, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194389 */   GIR_AddTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194396 */   GIR_AddSimpleTempRegister, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*TempRegID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194401 */   GIR_AddImm, /*InsnID*//* 286(*/0x9E, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 286(*/0x9E, 0x02/*)*/,
     /* 194415 */   GIR_MakeTempReg, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194419 */   GIR_BuildMI, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194424 */   GIR_AddTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194431 */   GIR_AddSimpleTempRegister, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*TempRegID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194436 */   GIR_AddImm, /*InsnID*//* 285(*/0x9D, 0x02/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 194447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 285(*/0x9D, 0x02/*)*/,
     /* 194450 */   GIR_MakeTempReg, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194454 */   GIR_BuildMI, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194459 */   GIR_AddTempRegister, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194466 */   GIR_Copy, /*NewInsnID*//* 284(*/0x9C, 0x02/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 194471 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/63,
     /* 194475 */   GIR_AddImm8, /*InsnID*//* 284(*/0x9C, 0x02/*)*/, /*Imm*/1,
     /* 194479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194482 */   GIR_MakeTempReg, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194486 */   GIR_BuildMI, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194491 */   GIR_AddTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194498 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194503 */   GIR_AddSimpleTempRegister, /*InsnID*//* 283(*/0x9B, 0x02/*)*/, /*TempRegID*//* 284(*/0x9C, 0x02/*)*/,
     /* 194508 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 283(*/0x9B, 0x02/*)*/,
     /* 194511 */   GIR_MakeTempReg, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194515 */   GIR_BuildMI, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194520 */   GIR_AddTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194527 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194532 */   GIR_AddSimpleTempRegister, /*InsnID*//* 282(*/0x9A, 0x02/*)*/, /*TempRegID*//* 291(*/0xA3, 0x02/*)*/,
     /* 194537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 282(*/0x9A, 0x02/*)*/,
     /* 194540 */   GIR_MakeTempReg, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194544 */   GIR_BuildMI, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194549 */   GIR_AddTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194556 */   GIR_AddSimpleTempRegister, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*TempRegID*//* 281(*/0x99, 0x02/*)*/,
     /* 194561 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/62,
     /* 194565 */   GIR_AddImm8, /*InsnID*//* 281(*/0x99, 0x02/*)*/, /*Imm*/2,
     /* 194569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 281(*/0x99, 0x02/*)*/,
     /* 194572 */   GIR_MakeTempReg, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194576 */   GIR_BuildMI, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194581 */   GIR_AddTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194588 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 280(*/0x98, 0x02/*)*/,
     /* 194593 */   GIR_AddSimpleTempRegister, /*InsnID*//* 280(*/0x98, 0x02/*)*/, /*TempRegID*//* 300(*/0xAC, 0x02/*)*/,
     /* 194598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 280(*/0x98, 0x02/*)*/,
     /* 194601 */   GIR_MakeTempReg, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194605 */   GIR_BuildMI, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194610 */   GIR_AddTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194617 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 279(*/0x97, 0x02/*)*/,
     /* 194622 */   GIR_AddSimpleTempRegister, /*InsnID*//* 279(*/0x97, 0x02/*)*/, /*TempRegID*//* 307(*/0xB3, 0x02/*)*/,
     /* 194627 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 279(*/0x97, 0x02/*)*/,
     /* 194630 */   GIR_MakeTempReg, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194634 */   GIR_BuildMI, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 194639 */   GIR_AddTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194646 */   GIR_AddSimpleTempRegister, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*TempRegID*//* 278(*/0x96, 0x02/*)*/,
     /* 194651 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/60,
     /* 194655 */   GIR_AddImm8, /*InsnID*//* 278(*/0x96, 0x02/*)*/, /*Imm*/4,
     /* 194659 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 278(*/0x96, 0x02/*)*/,
     /* 194662 */   GIR_MakeTempReg, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194666 */   GIR_BuildMI, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 194671 */   GIR_AddTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194678 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 277(*/0x95, 0x02/*)*/,
     /* 194683 */   GIR_AddSimpleTempRegister, /*InsnID*//* 277(*/0x95, 0x02/*)*/, /*TempRegID*//* 335(*/0xCF, 0x02/*)*/,
     /* 194688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 277(*/0x95, 0x02/*)*/,
     /* 194691 */   GIR_MakeTempReg, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TypeID*/GILLT_s64,
     /* 194695 */   GIR_BuildMI, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 194700 */   GIR_AddTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194707 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 276(*/0x94, 0x02/*)*/,
     /* 194712 */   GIR_AddSimpleTempRegister, /*InsnID*//* 276(*/0x94, 0x02/*)*/, /*TempRegID*//* 342(*/0xD6, 0x02/*)*/,
     /* 194717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 276(*/0x94, 0x02/*)*/,
     /* 194720 */   GIR_MakeTempReg, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194724 */   GIR_BuildMI, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194729 */   GIR_AddTempRegister, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194736 */   GIR_AddImm, /*InsnID*//* 548(*/0xA4, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 548(*/0xA4, 0x04/*)*/,
     /* 194750 */   GIR_MakeTempReg, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194754 */   GIR_BuildMI, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194759 */   GIR_AddTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194766 */   GIR_AddSimpleTempRegister, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*TempRegID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194771 */   GIR_AddImm, /*InsnID*//* 547(*/0xA3, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 547(*/0xA3, 0x04/*)*/,
     /* 194785 */   GIR_MakeTempReg, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194789 */   GIR_BuildMI, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 194794 */   GIR_AddTempRegister, /*InsnID*//* 546(*/0xA2, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194804 */   GIR_MakeTempReg, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194808 */   GIR_BuildMI, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 194813 */   GIR_AddTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194820 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 545(*/0xA1, 0x04/*)*/,
     /* 194825 */   GIR_AddSimpleTempRegister, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*TempRegID*//* 546(*/0xA2, 0x04/*)*/,
     /* 194830 */   GIR_AddImm8, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Imm*/1,
     /* 194834 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194840 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 194846 */   GIR_ConstrainOperandRC, /*InsnID*//* 545(*/0xA1, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 194852 */   GIR_MakeTempReg, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194856 */   GIR_BuildMI, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 194861 */   GIR_AddTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194868 */   GIR_AddSimpleTempRegister, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*TempRegID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194873 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/32,
     /* 194877 */   GIR_AddImm8, /*InsnID*//* 544(*/0xA0, 0x04/*)*/, /*Imm*/31,
     /* 194881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 544(*/0xA0, 0x04/*)*/,
     /* 194884 */   GIR_MakeTempReg, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194888 */   GIR_BuildMI, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 194893 */   GIR_AddTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194900 */   GIR_AddSimpleTempRegister, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*TempRegID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194905 */   GIR_AddImm, /*InsnID*//* 543(*/0x9F, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 543(*/0x9F, 0x04/*)*/,
     /* 194919 */   GIR_MakeTempReg, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 194923 */   GIR_BuildMI, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 194928 */   GIR_AddTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194935 */   GIR_AddSimpleTempRegister, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*TempRegID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194940 */   GIR_AddImm, /*InsnID*//* 542(*/0x9E, 0x04/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 194951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 542(*/0x9E, 0x04/*)*/,
     /* 194954 */   GIR_MakeTempReg, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194958 */   GIR_BuildMI, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 194963 */   GIR_AddTempRegister, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 194970 */   GIR_AddImm, /*InsnID*//* 541(*/0x9D, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 194981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 541(*/0x9D, 0x04/*)*/,
     /* 194984 */   GIR_MakeTempReg, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 194988 */   GIR_BuildMI, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 194993 */   GIR_AddTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195000 */   GIR_AddSimpleTempRegister, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*TempRegID*//* 540(*/0x9C, 0x04/*)*/,
     /* 195005 */   GIR_AddImm, /*InsnID*//* 540(*/0x9C, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 195016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 540(*/0x9C, 0x04/*)*/,
     /* 195019 */   GIR_MakeTempReg, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195023 */   GIR_BuildMI, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195028 */   GIR_AddTempRegister, /*InsnID*//* 539(*/0x9B, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 539(*/0x9B, 0x04/*)*/,
     /* 195038 */   GIR_MakeTempReg, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195042 */   GIR_BuildMI, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195047 */   GIR_AddTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195054 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 538(*/0x9A, 0x04/*)*/,
     /* 195059 */   GIR_AddSimpleTempRegister, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*TempRegID*//* 539(*/0x9B, 0x04/*)*/,
     /* 195064 */   GIR_AddImm8, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Imm*/1,
     /* 195068 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195074 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195080 */   GIR_ConstrainOperandRC, /*InsnID*//* 538(*/0x9A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195086 */   GIR_MakeTempReg, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195090 */   GIR_BuildMI, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195095 */   GIR_AddTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195102 */   GIR_AddSimpleTempRegister, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*TempRegID*//* 537(*/0x99, 0x04/*)*/,
     /* 195107 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/32,
     /* 195111 */   GIR_AddImm8, /*InsnID*//* 537(*/0x99, 0x04/*)*/, /*Imm*/31,
     /* 195115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 537(*/0x99, 0x04/*)*/,
     /* 195118 */   GIR_MakeTempReg, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195122 */   GIR_BuildMI, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195127 */   GIR_AddTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195134 */   GIR_AddSimpleTempRegister, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*TempRegID*//* 536(*/0x98, 0x04/*)*/,
     /* 195139 */   GIR_AddImm, /*InsnID*//* 536(*/0x98, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 195150 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 536(*/0x98, 0x04/*)*/,
     /* 195153 */   GIR_MakeTempReg, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195157 */   GIR_BuildMI, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195162 */   GIR_AddTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195169 */   GIR_AddSimpleTempRegister, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*TempRegID*//* 535(*/0x97, 0x04/*)*/,
     /* 195174 */   GIR_AddImm, /*InsnID*//* 535(*/0x97, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 195185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 535(*/0x97, 0x04/*)*/,
     /* 195188 */   GIR_MakeTempReg, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195192 */   GIR_BuildMI, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195197 */   GIR_AddTempRegister, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195204 */   GIR_AddImm, /*InsnID*//* 534(*/0x96, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 534(*/0x96, 0x04/*)*/,
     /* 195218 */   GIR_MakeTempReg, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195222 */   GIR_BuildMI, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195227 */   GIR_AddTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195234 */   GIR_AddSimpleTempRegister, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*TempRegID*//* 533(*/0x95, 0x04/*)*/,
     /* 195239 */   GIR_AddImm, /*InsnID*//* 533(*/0x95, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 533(*/0x95, 0x04/*)*/,
     /* 195253 */   GIR_MakeTempReg, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195257 */   GIR_BuildMI, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195262 */   GIR_AddTempRegister, /*InsnID*//* 532(*/0x94, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 532(*/0x94, 0x04/*)*/,
     /* 195272 */   GIR_MakeTempReg, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195276 */   GIR_BuildMI, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195281 */   GIR_AddTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195288 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 531(*/0x93, 0x04/*)*/,
     /* 195293 */   GIR_AddSimpleTempRegister, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*TempRegID*//* 532(*/0x94, 0x04/*)*/,
     /* 195298 */   GIR_AddImm8, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Imm*/1,
     /* 195302 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195308 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195314 */   GIR_ConstrainOperandRC, /*InsnID*//* 531(*/0x93, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195320 */   GIR_MakeTempReg, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195324 */   GIR_BuildMI, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195329 */   GIR_AddTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195336 */   GIR_AddSimpleTempRegister, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*TempRegID*//* 530(*/0x92, 0x04/*)*/,
     /* 195341 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/32,
     /* 195345 */   GIR_AddImm8, /*InsnID*//* 530(*/0x92, 0x04/*)*/, /*Imm*/31,
     /* 195349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 530(*/0x92, 0x04/*)*/,
     /* 195352 */   GIR_MakeTempReg, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195356 */   GIR_BuildMI, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195361 */   GIR_AddTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195368 */   GIR_AddSimpleTempRegister, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*TempRegID*//* 529(*/0x91, 0x04/*)*/,
     /* 195373 */   GIR_AddImm, /*InsnID*//* 529(*/0x91, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 529(*/0x91, 0x04/*)*/,
     /* 195387 */   GIR_MakeTempReg, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195391 */   GIR_BuildMI, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195396 */   GIR_AddTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195403 */   GIR_AddSimpleTempRegister, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*TempRegID*//* 528(*/0x90, 0x04/*)*/,
     /* 195408 */   GIR_AddImm, /*InsnID*//* 528(*/0x90, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 195419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 528(*/0x90, 0x04/*)*/,
     /* 195422 */   GIR_MakeTempReg, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195426 */   GIR_BuildMI, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195431 */   GIR_AddTempRegister, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195438 */   GIR_Copy, /*NewInsnID*//* 527(*/0x8F, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195443 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/1,
     /* 195447 */   GIR_AddImm8, /*InsnID*//* 527(*/0x8F, 0x04/*)*/, /*Imm*/62,
     /* 195451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195454 */   GIR_MakeTempReg, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195458 */   GIR_BuildMI, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195463 */   GIR_AddTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195470 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195475 */   GIR_AddSimpleTempRegister, /*InsnID*//* 526(*/0x8E, 0x04/*)*/, /*TempRegID*//* 527(*/0x8F, 0x04/*)*/,
     /* 195480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 526(*/0x8E, 0x04/*)*/,
     /* 195483 */   GIR_MakeTempReg, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195487 */   GIR_BuildMI, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195492 */   GIR_AddTempRegister, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195499 */   GIR_AddImm, /*InsnID*//* 525(*/0x8D, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195513 */   GIR_MakeTempReg, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195517 */   GIR_BuildMI, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195522 */   GIR_AddTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195529 */   GIR_AddSimpleTempRegister, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*TempRegID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195534 */   GIR_AddImm, /*InsnID*//* 524(*/0x8C, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 524(*/0x8C, 0x04/*)*/,
     /* 195548 */   GIR_MakeTempReg, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195552 */   GIR_BuildMI, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195557 */   GIR_AddTempRegister, /*InsnID*//* 523(*/0x8B, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195567 */   GIR_MakeTempReg, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195571 */   GIR_BuildMI, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195576 */   GIR_AddTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195583 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 522(*/0x8A, 0x04/*)*/,
     /* 195588 */   GIR_AddSimpleTempRegister, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*TempRegID*//* 523(*/0x8B, 0x04/*)*/,
     /* 195593 */   GIR_AddImm8, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Imm*/1,
     /* 195597 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195603 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195609 */   GIR_ConstrainOperandRC, /*InsnID*//* 522(*/0x8A, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 195615 */   GIR_MakeTempReg, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195619 */   GIR_BuildMI, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195624 */   GIR_AddTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195631 */   GIR_AddSimpleTempRegister, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*TempRegID*//* 521(*/0x89, 0x04/*)*/,
     /* 195636 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/32,
     /* 195640 */   GIR_AddImm8, /*InsnID*//* 521(*/0x89, 0x04/*)*/, /*Imm*/31,
     /* 195644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 521(*/0x89, 0x04/*)*/,
     /* 195647 */   GIR_MakeTempReg, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195651 */   GIR_BuildMI, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 195656 */   GIR_AddTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195663 */   GIR_AddSimpleTempRegister, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*TempRegID*//* 520(*/0x88, 0x04/*)*/,
     /* 195668 */   GIR_AddImm, /*InsnID*//* 520(*/0x88, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 520(*/0x88, 0x04/*)*/,
     /* 195682 */   GIR_MakeTempReg, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195686 */   GIR_BuildMI, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 195691 */   GIR_AddTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195698 */   GIR_AddSimpleTempRegister, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*TempRegID*//* 519(*/0x87, 0x04/*)*/,
     /* 195703 */   GIR_AddImm, /*InsnID*//* 519(*/0x87, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 195714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 519(*/0x87, 0x04/*)*/,
     /* 195717 */   GIR_MakeTempReg, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195721 */   GIR_BuildMI, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 195726 */   GIR_AddTempRegister, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195733 */   GIR_Copy, /*NewInsnID*//* 518(*/0x86, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 195738 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/63,
     /* 195742 */   GIR_AddImm8, /*InsnID*//* 518(*/0x86, 0x04/*)*/, /*Imm*/1,
     /* 195746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 518(*/0x86, 0x04/*)*/,
     /* 195749 */   GIR_MakeTempReg, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195753 */   GIR_BuildMI, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195758 */   GIR_AddTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195765 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 517(*/0x85, 0x04/*)*/,
     /* 195770 */   GIR_AddSimpleTempRegister, /*InsnID*//* 517(*/0x85, 0x04/*)*/, /*TempRegID*//* 518(*/0x86, 0x04/*)*/,
     /* 195775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 517(*/0x85, 0x04/*)*/,
     /* 195778 */   GIR_MakeTempReg, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195782 */   GIR_BuildMI, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 195787 */   GIR_AddTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195794 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 516(*/0x84, 0x04/*)*/,
     /* 195799 */   GIR_AddSimpleTempRegister, /*InsnID*//* 516(*/0x84, 0x04/*)*/, /*TempRegID*//* 525(*/0x8D, 0x04/*)*/,
     /* 195804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 516(*/0x84, 0x04/*)*/,
     /* 195807 */   GIR_MakeTempReg, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195811 */   GIR_BuildMI, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 195816 */   GIR_AddTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195823 */   GIR_AddSimpleTempRegister, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*TempRegID*//* 515(*/0x83, 0x04/*)*/,
     /* 195828 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/2,
     /* 195832 */   GIR_AddImm8, /*InsnID*//* 515(*/0x83, 0x04/*)*/, /*Imm*/61,
     /* 195836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 515(*/0x83, 0x04/*)*/,
     /* 195839 */   GIR_MakeTempReg, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 195843 */   GIR_BuildMI, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 195848 */   GIR_AddTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195855 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 514(*/0x82, 0x04/*)*/,
     /* 195860 */   GIR_AddSimpleTempRegister, /*InsnID*//* 514(*/0x82, 0x04/*)*/, /*TempRegID*//* 534(*/0x96, 0x04/*)*/,
     /* 195865 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 514(*/0x82, 0x04/*)*/,
     /* 195868 */   GIR_MakeTempReg, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 195872 */   GIR_BuildMI, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 195877 */   GIR_AddTempRegister, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195884 */   GIR_AddImm, /*InsnID*//* 513(*/0x81, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 513(*/0x81, 0x04/*)*/,
     /* 195898 */   GIR_MakeTempReg, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 195902 */   GIR_BuildMI, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 195907 */   GIR_AddTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195914 */   GIR_AddSimpleTempRegister, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*TempRegID*//* 512(*/0x80, 0x04/*)*/,
     /* 195919 */   GIR_AddImm, /*InsnID*//* 512(*/0x80, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 195930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 512(*/0x80, 0x04/*)*/,
     /* 195933 */   GIR_MakeTempReg, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195937 */   GIR_BuildMI, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 195942 */   GIR_AddTempRegister, /*InsnID*//* 511(*/0xFF, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195952 */   GIR_MakeTempReg, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 195956 */   GIR_BuildMI, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 195961 */   GIR_AddTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 195968 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 510(*/0xFE, 0x03/*)*/,
     /* 195973 */   GIR_AddSimpleTempRegister, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*TempRegID*//* 511(*/0xFF, 0x03/*)*/,
     /* 195978 */   GIR_AddImm8, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Imm*/1,
     /* 195982 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195988 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 195994 */   GIR_ConstrainOperandRC, /*InsnID*//* 510(*/0xFE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196000 */   GIR_MakeTempReg, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196004 */   GIR_BuildMI, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196009 */   GIR_AddTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196016 */   GIR_AddSimpleTempRegister, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*TempRegID*//* 509(*/0xFD, 0x03/*)*/,
     /* 196021 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/32,
     /* 196025 */   GIR_AddImm8, /*InsnID*//* 509(*/0xFD, 0x03/*)*/, /*Imm*/31,
     /* 196029 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 509(*/0xFD, 0x03/*)*/,
     /* 196032 */   GIR_MakeTempReg, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196036 */   GIR_BuildMI, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196041 */   GIR_AddTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196048 */   GIR_AddSimpleTempRegister, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*TempRegID*//* 508(*/0xFC, 0x03/*)*/,
     /* 196053 */   GIR_AddImm, /*InsnID*//* 508(*/0xFC, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 196064 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 508(*/0xFC, 0x03/*)*/,
     /* 196067 */   GIR_MakeTempReg, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196071 */   GIR_BuildMI, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196076 */   GIR_AddTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196083 */   GIR_AddSimpleTempRegister, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*TempRegID*//* 507(*/0xFB, 0x03/*)*/,
     /* 196088 */   GIR_AddImm, /*InsnID*//* 507(*/0xFB, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 196099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 507(*/0xFB, 0x03/*)*/,
     /* 196102 */   GIR_MakeTempReg, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196106 */   GIR_BuildMI, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196111 */   GIR_AddTempRegister, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196118 */   GIR_AddImm, /*InsnID*//* 506(*/0xFA, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 506(*/0xFA, 0x03/*)*/,
     /* 196132 */   GIR_MakeTempReg, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196136 */   GIR_BuildMI, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196141 */   GIR_AddTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196148 */   GIR_AddSimpleTempRegister, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*TempRegID*//* 505(*/0xF9, 0x03/*)*/,
     /* 196153 */   GIR_AddImm, /*InsnID*//* 505(*/0xF9, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 505(*/0xF9, 0x03/*)*/,
     /* 196167 */   GIR_MakeTempReg, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196171 */   GIR_BuildMI, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196176 */   GIR_AddTempRegister, /*InsnID*//* 504(*/0xF8, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 504(*/0xF8, 0x03/*)*/,
     /* 196186 */   GIR_MakeTempReg, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196190 */   GIR_BuildMI, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196195 */   GIR_AddTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196202 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 503(*/0xF7, 0x03/*)*/,
     /* 196207 */   GIR_AddSimpleTempRegister, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*TempRegID*//* 504(*/0xF8, 0x03/*)*/,
     /* 196212 */   GIR_AddImm8, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Imm*/1,
     /* 196216 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196222 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196228 */   GIR_ConstrainOperandRC, /*InsnID*//* 503(*/0xF7, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196234 */   GIR_MakeTempReg, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196238 */   GIR_BuildMI, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196243 */   GIR_AddTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196250 */   GIR_AddSimpleTempRegister, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*TempRegID*//* 502(*/0xF6, 0x03/*)*/,
     /* 196255 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/32,
     /* 196259 */   GIR_AddImm8, /*InsnID*//* 502(*/0xF6, 0x03/*)*/, /*Imm*/31,
     /* 196263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 502(*/0xF6, 0x03/*)*/,
     /* 196266 */   GIR_MakeTempReg, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196270 */   GIR_BuildMI, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196275 */   GIR_AddTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196282 */   GIR_AddSimpleTempRegister, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*TempRegID*//* 501(*/0xF5, 0x03/*)*/,
     /* 196287 */   GIR_AddImm, /*InsnID*//* 501(*/0xF5, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 501(*/0xF5, 0x03/*)*/,
     /* 196301 */   GIR_MakeTempReg, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196305 */   GIR_BuildMI, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196310 */   GIR_AddTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196317 */   GIR_AddSimpleTempRegister, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*TempRegID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196322 */   GIR_AddImm, /*InsnID*//* 500(*/0xF4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 196333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 500(*/0xF4, 0x03/*)*/,
     /* 196336 */   GIR_MakeTempReg, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196340 */   GIR_BuildMI, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196345 */   GIR_AddTempRegister, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196352 */   GIR_Copy, /*NewInsnID*//* 499(*/0xF3, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196357 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/1,
     /* 196361 */   GIR_AddImm8, /*InsnID*//* 499(*/0xF3, 0x03/*)*/, /*Imm*/62,
     /* 196365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196368 */   GIR_MakeTempReg, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196372 */   GIR_BuildMI, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196377 */   GIR_AddTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196384 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196389 */   GIR_AddSimpleTempRegister, /*InsnID*//* 498(*/0xF2, 0x03/*)*/, /*TempRegID*//* 499(*/0xF3, 0x03/*)*/,
     /* 196394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 498(*/0xF2, 0x03/*)*/,
     /* 196397 */   GIR_MakeTempReg, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196401 */   GIR_BuildMI, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196406 */   GIR_AddTempRegister, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196413 */   GIR_AddImm, /*InsnID*//* 497(*/0xF1, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196427 */   GIR_MakeTempReg, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196431 */   GIR_BuildMI, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196436 */   GIR_AddTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196443 */   GIR_AddSimpleTempRegister, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*TempRegID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196448 */   GIR_AddImm, /*InsnID*//* 496(*/0xF0, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 496(*/0xF0, 0x03/*)*/,
     /* 196462 */   GIR_MakeTempReg, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196466 */   GIR_BuildMI, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196471 */   GIR_AddTempRegister, /*InsnID*//* 495(*/0xEF, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196481 */   GIR_MakeTempReg, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196485 */   GIR_BuildMI, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196490 */   GIR_AddTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196497 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 494(*/0xEE, 0x03/*)*/,
     /* 196502 */   GIR_AddSimpleTempRegister, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*TempRegID*//* 495(*/0xEF, 0x03/*)*/,
     /* 196507 */   GIR_AddImm8, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Imm*/1,
     /* 196511 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196517 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196523 */   GIR_ConstrainOperandRC, /*InsnID*//* 494(*/0xEE, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 196529 */   GIR_MakeTempReg, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196533 */   GIR_BuildMI, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196538 */   GIR_AddTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*TempRegID*//* 493(*/0xED, 0x03/*)*/,
     /* 196550 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/32,
     /* 196554 */   GIR_AddImm8, /*InsnID*//* 493(*/0xED, 0x03/*)*/, /*Imm*/31,
     /* 196558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 493(*/0xED, 0x03/*)*/,
     /* 196561 */   GIR_MakeTempReg, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196565 */   GIR_BuildMI, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 196570 */   GIR_AddTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196577 */   GIR_AddSimpleTempRegister, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*TempRegID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196582 */   GIR_AddImm, /*InsnID*//* 492(*/0xEC, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196593 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 492(*/0xEC, 0x03/*)*/,
     /* 196596 */   GIR_MakeTempReg, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196600 */   GIR_BuildMI, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 196605 */   GIR_AddTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196612 */   GIR_AddSimpleTempRegister, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*TempRegID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196617 */   GIR_AddImm, /*InsnID*//* 491(*/0xEB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 196628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 491(*/0xEB, 0x03/*)*/,
     /* 196631 */   GIR_MakeTempReg, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196635 */   GIR_BuildMI, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196640 */   GIR_AddTempRegister, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196647 */   GIR_Copy, /*NewInsnID*//* 490(*/0xEA, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 196652 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/63,
     /* 196656 */   GIR_AddImm8, /*InsnID*//* 490(*/0xEA, 0x03/*)*/, /*Imm*/1,
     /* 196660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196663 */   GIR_MakeTempReg, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196667 */   GIR_BuildMI, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196672 */   GIR_AddTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196679 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196684 */   GIR_AddSimpleTempRegister, /*InsnID*//* 489(*/0xE9, 0x03/*)*/, /*TempRegID*//* 490(*/0xEA, 0x03/*)*/,
     /* 196689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 489(*/0xE9, 0x03/*)*/,
     /* 196692 */   GIR_MakeTempReg, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196696 */   GIR_BuildMI, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196701 */   GIR_AddTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196708 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196713 */   GIR_AddSimpleTempRegister, /*InsnID*//* 488(*/0xE8, 0x03/*)*/, /*TempRegID*//* 497(*/0xF1, 0x03/*)*/,
     /* 196718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 488(*/0xE8, 0x03/*)*/,
     /* 196721 */   GIR_MakeTempReg, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196725 */   GIR_BuildMI, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 196730 */   GIR_AddTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196737 */   GIR_AddSimpleTempRegister, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*TempRegID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196742 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/62,
     /* 196746 */   GIR_AddImm8, /*InsnID*//* 487(*/0xE7, 0x03/*)*/, /*Imm*/2,
     /* 196750 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 487(*/0xE7, 0x03/*)*/,
     /* 196753 */   GIR_MakeTempReg, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196757 */   GIR_BuildMI, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196762 */   GIR_AddTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196769 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196774 */   GIR_AddSimpleTempRegister, /*InsnID*//* 486(*/0xE6, 0x03/*)*/, /*TempRegID*//* 506(*/0xFA, 0x03/*)*/,
     /* 196779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 486(*/0xE6, 0x03/*)*/,
     /* 196782 */   GIR_MakeTempReg, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196786 */   GIR_BuildMI, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 196791 */   GIR_AddTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196798 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196803 */   GIR_AddSimpleTempRegister, /*InsnID*//* 485(*/0xE5, 0x03/*)*/, /*TempRegID*//* 513(*/0x81, 0x04/*)*/,
     /* 196808 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 485(*/0xE5, 0x03/*)*/,
     /* 196811 */   GIR_MakeTempReg, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196815 */   GIR_BuildMI, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 196820 */   GIR_AddTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196827 */   GIR_AddSimpleTempRegister, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*TempRegID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196832 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/4,
     /* 196836 */   GIR_AddImm8, /*InsnID*//* 484(*/0xE4, 0x03/*)*/, /*Imm*/59,
     /* 196840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 484(*/0xE4, 0x03/*)*/,
     /* 196843 */   GIR_MakeTempReg, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196847 */   GIR_BuildMI, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 196852 */   GIR_AddTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196859 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196864 */   GIR_AddSimpleTempRegister, /*InsnID*//* 483(*/0xE3, 0x03/*)*/, /*TempRegID*//* 541(*/0x9D, 0x04/*)*/,
     /* 196869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 483(*/0xE3, 0x03/*)*/,
     /* 196872 */   GIR_MakeTempReg, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196876 */   GIR_BuildMI, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 196881 */   GIR_AddTempRegister, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196888 */   GIR_AddImm, /*InsnID*//* 482(*/0xE2, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 482(*/0xE2, 0x03/*)*/,
     /* 196902 */   GIR_MakeTempReg, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 196906 */   GIR_BuildMI, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 196911 */   GIR_AddTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196918 */   GIR_AddSimpleTempRegister, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*TempRegID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196923 */   GIR_AddImm, /*InsnID*//* 481(*/0xE1, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 196934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 481(*/0xE1, 0x03/*)*/,
     /* 196937 */   GIR_MakeTempReg, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196941 */   GIR_BuildMI, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 196946 */   GIR_AddTempRegister, /*InsnID*//* 480(*/0xE0, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196953 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196956 */   GIR_MakeTempReg, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 196960 */   GIR_BuildMI, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 196965 */   GIR_AddTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 196972 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 479(*/0xDF, 0x03/*)*/,
     /* 196977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*TempRegID*//* 480(*/0xE0, 0x03/*)*/,
     /* 196982 */   GIR_AddImm8, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Imm*/1,
     /* 196986 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196992 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 196998 */   GIR_ConstrainOperandRC, /*InsnID*//* 479(*/0xDF, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197004 */   GIR_MakeTempReg, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197008 */   GIR_BuildMI, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197013 */   GIR_AddTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197020 */   GIR_AddSimpleTempRegister, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*TempRegID*//* 478(*/0xDE, 0x03/*)*/,
     /* 197025 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/32,
     /* 197029 */   GIR_AddImm8, /*InsnID*//* 478(*/0xDE, 0x03/*)*/, /*Imm*/31,
     /* 197033 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 478(*/0xDE, 0x03/*)*/,
     /* 197036 */   GIR_MakeTempReg, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197040 */   GIR_BuildMI, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197045 */   GIR_AddTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197052 */   GIR_AddSimpleTempRegister, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*TempRegID*//* 477(*/0xDD, 0x03/*)*/,
     /* 197057 */   GIR_AddImm, /*InsnID*//* 477(*/0xDD, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 197068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 477(*/0xDD, 0x03/*)*/,
     /* 197071 */   GIR_MakeTempReg, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197075 */   GIR_BuildMI, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197080 */   GIR_AddTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197087 */   GIR_AddSimpleTempRegister, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*TempRegID*//* 476(*/0xDC, 0x03/*)*/,
     /* 197092 */   GIR_AddImm, /*InsnID*//* 476(*/0xDC, 0x03/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 197103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 476(*/0xDC, 0x03/*)*/,
     /* 197106 */   GIR_MakeTempReg, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197110 */   GIR_BuildMI, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197115 */   GIR_AddTempRegister, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197122 */   GIR_AddImm, /*InsnID*//* 475(*/0xDB, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 475(*/0xDB, 0x03/*)*/,
     /* 197136 */   GIR_MakeTempReg, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197140 */   GIR_BuildMI, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197145 */   GIR_AddTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197152 */   GIR_AddSimpleTempRegister, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*TempRegID*//* 474(*/0xDA, 0x03/*)*/,
     /* 197157 */   GIR_AddImm, /*InsnID*//* 474(*/0xDA, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 474(*/0xDA, 0x03/*)*/,
     /* 197171 */   GIR_MakeTempReg, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197175 */   GIR_BuildMI, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197180 */   GIR_AddTempRegister, /*InsnID*//* 473(*/0xD9, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 473(*/0xD9, 0x03/*)*/,
     /* 197190 */   GIR_MakeTempReg, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197194 */   GIR_BuildMI, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197199 */   GIR_AddTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197206 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 472(*/0xD8, 0x03/*)*/,
     /* 197211 */   GIR_AddSimpleTempRegister, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*TempRegID*//* 473(*/0xD9, 0x03/*)*/,
     /* 197216 */   GIR_AddImm8, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Imm*/1,
     /* 197220 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197226 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197232 */   GIR_ConstrainOperandRC, /*InsnID*//* 472(*/0xD8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197238 */   GIR_MakeTempReg, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197242 */   GIR_BuildMI, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197247 */   GIR_AddTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197254 */   GIR_AddSimpleTempRegister, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*TempRegID*//* 471(*/0xD7, 0x03/*)*/,
     /* 197259 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/32,
     /* 197263 */   GIR_AddImm8, /*InsnID*//* 471(*/0xD7, 0x03/*)*/, /*Imm*/31,
     /* 197267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 471(*/0xD7, 0x03/*)*/,
     /* 197270 */   GIR_MakeTempReg, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197274 */   GIR_BuildMI, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197279 */   GIR_AddTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197286 */   GIR_AddSimpleTempRegister, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*TempRegID*//* 470(*/0xD6, 0x03/*)*/,
     /* 197291 */   GIR_AddImm, /*InsnID*//* 470(*/0xD6, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 470(*/0xD6, 0x03/*)*/,
     /* 197305 */   GIR_MakeTempReg, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197309 */   GIR_BuildMI, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197314 */   GIR_AddTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197321 */   GIR_AddSimpleTempRegister, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*TempRegID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197326 */   GIR_AddImm, /*InsnID*//* 469(*/0xD5, 0x03/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 197337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 469(*/0xD5, 0x03/*)*/,
     /* 197340 */   GIR_MakeTempReg, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197344 */   GIR_BuildMI, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197349 */   GIR_AddTempRegister, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197356 */   GIR_AddImm, /*InsnID*//* 468(*/0xD4, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 468(*/0xD4, 0x03/*)*/,
     /* 197370 */   GIR_MakeTempReg, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197374 */   GIR_BuildMI, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197379 */   GIR_AddTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197386 */   GIR_AddSimpleTempRegister, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*TempRegID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197391 */   GIR_AddImm, /*InsnID*//* 467(*/0xD3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 467(*/0xD3, 0x03/*)*/,
     /* 197405 */   GIR_MakeTempReg, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197409 */   GIR_BuildMI, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197414 */   GIR_AddTempRegister, /*InsnID*//* 466(*/0xD2, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197421 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197424 */   GIR_MakeTempReg, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197428 */   GIR_BuildMI, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197433 */   GIR_AddTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197440 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 465(*/0xD1, 0x03/*)*/,
     /* 197445 */   GIR_AddSimpleTempRegister, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*TempRegID*//* 466(*/0xD2, 0x03/*)*/,
     /* 197450 */   GIR_AddImm8, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Imm*/1,
     /* 197454 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197460 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197466 */   GIR_ConstrainOperandRC, /*InsnID*//* 465(*/0xD1, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197472 */   GIR_MakeTempReg, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197476 */   GIR_BuildMI, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197481 */   GIR_AddTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197488 */   GIR_AddSimpleTempRegister, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*TempRegID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197493 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/32,
     /* 197497 */   GIR_AddImm8, /*InsnID*//* 464(*/0xD0, 0x03/*)*/, /*Imm*/31,
     /* 197501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 464(*/0xD0, 0x03/*)*/,
     /* 197504 */   GIR_MakeTempReg, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197508 */   GIR_BuildMI, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197513 */   GIR_AddTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197520 */   GIR_AddSimpleTempRegister, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*TempRegID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197525 */   GIR_AddImm, /*InsnID*//* 463(*/0xCF, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 463(*/0xCF, 0x03/*)*/,
     /* 197539 */   GIR_MakeTempReg, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197543 */   GIR_BuildMI, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197548 */   GIR_AddTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197555 */   GIR_AddSimpleTempRegister, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*TempRegID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197560 */   GIR_AddImm, /*InsnID*//* 462(*/0xCE, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 197571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 462(*/0xCE, 0x03/*)*/,
     /* 197574 */   GIR_MakeTempReg, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197578 */   GIR_BuildMI, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197583 */   GIR_AddTempRegister, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197590 */   GIR_Copy, /*NewInsnID*//* 461(*/0xCD, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197595 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/1,
     /* 197599 */   GIR_AddImm8, /*InsnID*//* 461(*/0xCD, 0x03/*)*/, /*Imm*/62,
     /* 197603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197606 */   GIR_MakeTempReg, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197610 */   GIR_BuildMI, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197615 */   GIR_AddTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197622 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197627 */   GIR_AddSimpleTempRegister, /*InsnID*//* 460(*/0xCC, 0x03/*)*/, /*TempRegID*//* 461(*/0xCD, 0x03/*)*/,
     /* 197632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 460(*/0xCC, 0x03/*)*/,
     /* 197635 */   GIR_MakeTempReg, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197639 */   GIR_BuildMI, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 197644 */   GIR_AddTempRegister, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197651 */   GIR_AddImm, /*InsnID*//* 459(*/0xCB, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197665 */   GIR_MakeTempReg, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 197669 */   GIR_BuildMI, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 197674 */   GIR_AddTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197681 */   GIR_AddSimpleTempRegister, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*TempRegID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197686 */   GIR_AddImm, /*InsnID*//* 458(*/0xCA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 458(*/0xCA, 0x03/*)*/,
     /* 197700 */   GIR_MakeTempReg, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197704 */   GIR_BuildMI, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 197709 */   GIR_AddTempRegister, /*InsnID*//* 457(*/0xC9, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197719 */   GIR_MakeTempReg, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197723 */   GIR_BuildMI, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 197728 */   GIR_AddTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197735 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 456(*/0xC8, 0x03/*)*/,
     /* 197740 */   GIR_AddSimpleTempRegister, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*TempRegID*//* 457(*/0xC9, 0x03/*)*/,
     /* 197745 */   GIR_AddImm8, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Imm*/1,
     /* 197749 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197755 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 197761 */   GIR_ConstrainOperandRC, /*InsnID*//* 456(*/0xC8, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 197767 */   GIR_MakeTempReg, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197771 */   GIR_BuildMI, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197776 */   GIR_AddTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197783 */   GIR_AddSimpleTempRegister, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*TempRegID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197788 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/32,
     /* 197792 */   GIR_AddImm8, /*InsnID*//* 455(*/0xC7, 0x03/*)*/, /*Imm*/31,
     /* 197796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 455(*/0xC7, 0x03/*)*/,
     /* 197799 */   GIR_MakeTempReg, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197803 */   GIR_BuildMI, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 197808 */   GIR_AddTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197815 */   GIR_AddSimpleTempRegister, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*TempRegID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197820 */   GIR_AddImm, /*InsnID*//* 454(*/0xC6, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 454(*/0xC6, 0x03/*)*/,
     /* 197834 */   GIR_MakeTempReg, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197838 */   GIR_BuildMI, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 197843 */   GIR_AddTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197850 */   GIR_AddSimpleTempRegister, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*TempRegID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197855 */   GIR_AddImm, /*InsnID*//* 453(*/0xC5, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 197866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 453(*/0xC5, 0x03/*)*/,
     /* 197869 */   GIR_MakeTempReg, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197873 */   GIR_BuildMI, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 197878 */   GIR_AddTempRegister, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197885 */   GIR_Copy, /*NewInsnID*//* 452(*/0xC4, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 197890 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/63,
     /* 197894 */   GIR_AddImm8, /*InsnID*//* 452(*/0xC4, 0x03/*)*/, /*Imm*/1,
     /* 197898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197901 */   GIR_MakeTempReg, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197905 */   GIR_BuildMI, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 197910 */   GIR_AddTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197917 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197922 */   GIR_AddSimpleTempRegister, /*InsnID*//* 451(*/0xC3, 0x03/*)*/, /*TempRegID*//* 452(*/0xC4, 0x03/*)*/,
     /* 197927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 451(*/0xC3, 0x03/*)*/,
     /* 197930 */   GIR_MakeTempReg, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197934 */   GIR_BuildMI, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 197939 */   GIR_AddTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197946 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197951 */   GIR_AddSimpleTempRegister, /*InsnID*//* 450(*/0xC2, 0x03/*)*/, /*TempRegID*//* 459(*/0xCB, 0x03/*)*/,
     /* 197956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 450(*/0xC2, 0x03/*)*/,
     /* 197959 */   GIR_MakeTempReg, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197963 */   GIR_BuildMI, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 197968 */   GIR_AddTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 197975 */   GIR_AddSimpleTempRegister, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*TempRegID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197980 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/2,
     /* 197984 */   GIR_AddImm8, /*InsnID*//* 449(*/0xC1, 0x03/*)*/, /*Imm*/61,
     /* 197988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 449(*/0xC1, 0x03/*)*/,
     /* 197991 */   GIR_MakeTempReg, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 197995 */   GIR_BuildMI, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198000 */   GIR_AddTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198007 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 448(*/0xC0, 0x03/*)*/,
     /* 198012 */   GIR_AddSimpleTempRegister, /*InsnID*//* 448(*/0xC0, 0x03/*)*/, /*TempRegID*//* 468(*/0xD4, 0x03/*)*/,
     /* 198017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 448(*/0xC0, 0x03/*)*/,
     /* 198020 */   GIR_MakeTempReg, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198024 */   GIR_BuildMI, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198029 */   GIR_AddTempRegister, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198036 */   GIR_AddImm, /*InsnID*//* 447(*/0xBF, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198047 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 447(*/0xBF, 0x03/*)*/,
     /* 198050 */   GIR_MakeTempReg, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198054 */   GIR_BuildMI, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198059 */   GIR_AddTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*TempRegID*//* 446(*/0xBE, 0x03/*)*/,
     /* 198071 */   GIR_AddImm, /*InsnID*//* 446(*/0xBE, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 446(*/0xBE, 0x03/*)*/,
     /* 198085 */   GIR_MakeTempReg, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198089 */   GIR_BuildMI, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198094 */   GIR_AddTempRegister, /*InsnID*//* 445(*/0xBD, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 445(*/0xBD, 0x03/*)*/,
     /* 198104 */   GIR_MakeTempReg, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198108 */   GIR_BuildMI, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198113 */   GIR_AddTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198120 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 444(*/0xBC, 0x03/*)*/,
     /* 198125 */   GIR_AddSimpleTempRegister, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*TempRegID*//* 445(*/0xBD, 0x03/*)*/,
     /* 198130 */   GIR_AddImm8, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Imm*/1,
     /* 198134 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198140 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198146 */   GIR_ConstrainOperandRC, /*InsnID*//* 444(*/0xBC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198152 */   GIR_MakeTempReg, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198156 */   GIR_BuildMI, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198161 */   GIR_AddTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198168 */   GIR_AddSimpleTempRegister, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*TempRegID*//* 443(*/0xBB, 0x03/*)*/,
     /* 198173 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/32,
     /* 198177 */   GIR_AddImm8, /*InsnID*//* 443(*/0xBB, 0x03/*)*/, /*Imm*/31,
     /* 198181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 443(*/0xBB, 0x03/*)*/,
     /* 198184 */   GIR_MakeTempReg, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198188 */   GIR_BuildMI, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198193 */   GIR_AddTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198200 */   GIR_AddSimpleTempRegister, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*TempRegID*//* 442(*/0xBA, 0x03/*)*/,
     /* 198205 */   GIR_AddImm, /*InsnID*//* 442(*/0xBA, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 442(*/0xBA, 0x03/*)*/,
     /* 198219 */   GIR_MakeTempReg, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198223 */   GIR_BuildMI, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198228 */   GIR_AddTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198235 */   GIR_AddSimpleTempRegister, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*TempRegID*//* 441(*/0xB9, 0x03/*)*/,
     /* 198240 */   GIR_AddImm, /*InsnID*//* 441(*/0xB9, 0x03/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 198251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 441(*/0xB9, 0x03/*)*/,
     /* 198254 */   GIR_MakeTempReg, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198258 */   GIR_BuildMI, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198263 */   GIR_AddTempRegister, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198270 */   GIR_AddImm, /*InsnID*//* 440(*/0xB8, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 440(*/0xB8, 0x03/*)*/,
     /* 198284 */   GIR_MakeTempReg, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198288 */   GIR_BuildMI, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198293 */   GIR_AddTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198300 */   GIR_AddSimpleTempRegister, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*TempRegID*//* 439(*/0xB7, 0x03/*)*/,
     /* 198305 */   GIR_AddImm, /*InsnID*//* 439(*/0xB7, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 439(*/0xB7, 0x03/*)*/,
     /* 198319 */   GIR_MakeTempReg, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198323 */   GIR_BuildMI, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198328 */   GIR_AddTempRegister, /*InsnID*//* 438(*/0xB6, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198338 */   GIR_MakeTempReg, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198342 */   GIR_BuildMI, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198347 */   GIR_AddTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198354 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 437(*/0xB5, 0x03/*)*/,
     /* 198359 */   GIR_AddSimpleTempRegister, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*TempRegID*//* 438(*/0xB6, 0x03/*)*/,
     /* 198364 */   GIR_AddImm8, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Imm*/1,
     /* 198368 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198374 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198380 */   GIR_ConstrainOperandRC, /*InsnID*//* 437(*/0xB5, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198386 */   GIR_MakeTempReg, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198390 */   GIR_BuildMI, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198395 */   GIR_AddTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198402 */   GIR_AddSimpleTempRegister, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*TempRegID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198407 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/32,
     /* 198411 */   GIR_AddImm8, /*InsnID*//* 436(*/0xB4, 0x03/*)*/, /*Imm*/31,
     /* 198415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 436(*/0xB4, 0x03/*)*/,
     /* 198418 */   GIR_MakeTempReg, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198422 */   GIR_BuildMI, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198427 */   GIR_AddTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198434 */   GIR_AddSimpleTempRegister, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*TempRegID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198439 */   GIR_AddImm, /*InsnID*//* 435(*/0xB3, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 435(*/0xB3, 0x03/*)*/,
     /* 198453 */   GIR_MakeTempReg, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198457 */   GIR_BuildMI, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198462 */   GIR_AddTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198469 */   GIR_AddSimpleTempRegister, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*TempRegID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198474 */   GIR_AddImm, /*InsnID*//* 434(*/0xB2, 0x03/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 198485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 434(*/0xB2, 0x03/*)*/,
     /* 198488 */   GIR_MakeTempReg, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198492 */   GIR_BuildMI, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198497 */   GIR_AddTempRegister, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198504 */   GIR_Copy, /*NewInsnID*//* 433(*/0xB1, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198509 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/1,
     /* 198513 */   GIR_AddImm8, /*InsnID*//* 433(*/0xB1, 0x03/*)*/, /*Imm*/62,
     /* 198517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198520 */   GIR_MakeTempReg, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198524 */   GIR_BuildMI, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198529 */   GIR_AddTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198536 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198541 */   GIR_AddSimpleTempRegister, /*InsnID*//* 432(*/0xB0, 0x03/*)*/, /*TempRegID*//* 433(*/0xB1, 0x03/*)*/,
     /* 198546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 432(*/0xB0, 0x03/*)*/,
     /* 198549 */   GIR_MakeTempReg, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198553 */   GIR_BuildMI, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 198558 */   GIR_AddTempRegister, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198565 */   GIR_AddImm, /*InsnID*//* 431(*/0xAF, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198579 */   GIR_MakeTempReg, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 198583 */   GIR_BuildMI, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 198588 */   GIR_AddTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198595 */   GIR_AddSimpleTempRegister, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*TempRegID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198600 */   GIR_AddImm, /*InsnID*//* 430(*/0xAE, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 430(*/0xAE, 0x03/*)*/,
     /* 198614 */   GIR_MakeTempReg, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198618 */   GIR_BuildMI, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 198623 */   GIR_AddTempRegister, /*InsnID*//* 429(*/0xAD, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198630 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198633 */   GIR_MakeTempReg, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198637 */   GIR_BuildMI, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 198642 */   GIR_AddTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198649 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 428(*/0xAC, 0x03/*)*/,
     /* 198654 */   GIR_AddSimpleTempRegister, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*TempRegID*//* 429(*/0xAD, 0x03/*)*/,
     /* 198659 */   GIR_AddImm8, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Imm*/1,
     /* 198663 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198669 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 198675 */   GIR_ConstrainOperandRC, /*InsnID*//* 428(*/0xAC, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 198681 */   GIR_MakeTempReg, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198685 */   GIR_BuildMI, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 198690 */   GIR_AddTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198697 */   GIR_AddSimpleTempRegister, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*TempRegID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198702 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/32,
     /* 198706 */   GIR_AddImm8, /*InsnID*//* 427(*/0xAB, 0x03/*)*/, /*Imm*/31,
     /* 198710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 427(*/0xAB, 0x03/*)*/,
     /* 198713 */   GIR_MakeTempReg, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198717 */   GIR_BuildMI, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 198722 */   GIR_AddTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198729 */   GIR_AddSimpleTempRegister, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*TempRegID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198734 */   GIR_AddImm, /*InsnID*//* 426(*/0xAA, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 426(*/0xAA, 0x03/*)*/,
     /* 198748 */   GIR_MakeTempReg, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198752 */   GIR_BuildMI, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 198757 */   GIR_AddTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198764 */   GIR_AddSimpleTempRegister, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*TempRegID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198769 */   GIR_AddImm, /*InsnID*//* 425(*/0xA9, 0x03/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 198780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 425(*/0xA9, 0x03/*)*/,
     /* 198783 */   GIR_MakeTempReg, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198787 */   GIR_BuildMI, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198792 */   GIR_AddTempRegister, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198799 */   GIR_Copy, /*NewInsnID*//* 424(*/0xA8, 0x03/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 198804 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/63,
     /* 198808 */   GIR_AddImm8, /*InsnID*//* 424(*/0xA8, 0x03/*)*/, /*Imm*/1,
     /* 198812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198815 */   GIR_MakeTempReg, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198819 */   GIR_BuildMI, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198824 */   GIR_AddTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198831 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198836 */   GIR_AddSimpleTempRegister, /*InsnID*//* 423(*/0xA7, 0x03/*)*/, /*TempRegID*//* 424(*/0xA8, 0x03/*)*/,
     /* 198841 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 423(*/0xA7, 0x03/*)*/,
     /* 198844 */   GIR_MakeTempReg, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198848 */   GIR_BuildMI, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198853 */   GIR_AddTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198860 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198865 */   GIR_AddSimpleTempRegister, /*InsnID*//* 422(*/0xA6, 0x03/*)*/, /*TempRegID*//* 431(*/0xAF, 0x03/*)*/,
     /* 198870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 422(*/0xA6, 0x03/*)*/,
     /* 198873 */   GIR_MakeTempReg, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198877 */   GIR_BuildMI, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198882 */   GIR_AddTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198889 */   GIR_AddSimpleTempRegister, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*TempRegID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198894 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/62,
     /* 198898 */   GIR_AddImm8, /*InsnID*//* 421(*/0xA5, 0x03/*)*/, /*Imm*/2,
     /* 198902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 421(*/0xA5, 0x03/*)*/,
     /* 198905 */   GIR_MakeTempReg, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198909 */   GIR_BuildMI, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 198914 */   GIR_AddTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198921 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198926 */   GIR_AddSimpleTempRegister, /*InsnID*//* 420(*/0xA4, 0x03/*)*/, /*TempRegID*//* 440(*/0xB8, 0x03/*)*/,
     /* 198931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 420(*/0xA4, 0x03/*)*/,
     /* 198934 */   GIR_MakeTempReg, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198938 */   GIR_BuildMI, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 198943 */   GIR_AddTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198950 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198955 */   GIR_AddSimpleTempRegister, /*InsnID*//* 419(*/0xA3, 0x03/*)*/, /*TempRegID*//* 447(*/0xBF, 0x03/*)*/,
     /* 198960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 419(*/0xA3, 0x03/*)*/,
     /* 198963 */   GIR_MakeTempReg, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198967 */   GIR_BuildMI, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 198972 */   GIR_AddTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 198979 */   GIR_AddSimpleTempRegister, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*TempRegID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198984 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/60,
     /* 198988 */   GIR_AddImm8, /*InsnID*//* 418(*/0xA2, 0x03/*)*/, /*Imm*/4,
     /* 198992 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 418(*/0xA2, 0x03/*)*/,
     /* 198995 */   GIR_MakeTempReg, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 198999 */   GIR_BuildMI, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199004 */   GIR_AddTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199011 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 417(*/0xA1, 0x03/*)*/,
     /* 199016 */   GIR_AddSimpleTempRegister, /*InsnID*//* 417(*/0xA1, 0x03/*)*/, /*TempRegID*//* 475(*/0xDB, 0x03/*)*/,
     /* 199021 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 417(*/0xA1, 0x03/*)*/,
     /* 199024 */   GIR_MakeTempReg, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 199028 */   GIR_BuildMI, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 199033 */   GIR_AddTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199040 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 416(*/0xA0, 0x03/*)*/,
     /* 199045 */   GIR_AddSimpleTempRegister, /*InsnID*//* 416(*/0xA0, 0x03/*)*/, /*TempRegID*//* 482(*/0xE2, 0x03/*)*/,
     /* 199050 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 416(*/0xA0, 0x03/*)*/,
     /* 199053 */   GIR_MakeTempReg, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 199057 */   GIR_BuildMI, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 199062 */   GIR_AddTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199069 */   GIR_AddSimpleTempRegister, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*TempRegID*//* 415(*/0x9F, 0x03/*)*/,
     /* 199074 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 199078 */   GIR_AddImm8, /*InsnID*//* 415(*/0x9F, 0x03/*)*/, /*Imm*/32,
     /* 199082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 415(*/0x9F, 0x03/*)*/,
     /* 199085 */   GIR_MakeTempReg, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199089 */   GIR_BuildMI, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199094 */   GIR_AddTempRegister, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199101 */   GIR_AddImm, /*InsnID*//* 683(*/0xAB, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 683(*/0xAB, 0x05/*)*/,
     /* 199115 */   GIR_MakeTempReg, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199119 */   GIR_BuildMI, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199124 */   GIR_AddTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199131 */   GIR_AddSimpleTempRegister, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*TempRegID*//* 682(*/0xAA, 0x05/*)*/,
     /* 199136 */   GIR_AddImm, /*InsnID*//* 682(*/0xAA, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 682(*/0xAA, 0x05/*)*/,
     /* 199150 */   GIR_MakeTempReg, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199154 */   GIR_BuildMI, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199159 */   GIR_AddTempRegister, /*InsnID*//* 681(*/0xA9, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 681(*/0xA9, 0x05/*)*/,
     /* 199169 */   GIR_MakeTempReg, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199173 */   GIR_BuildMI, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199178 */   GIR_AddTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199185 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 680(*/0xA8, 0x05/*)*/,
     /* 199190 */   GIR_AddSimpleTempRegister, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*TempRegID*//* 681(*/0xA9, 0x05/*)*/,
     /* 199195 */   GIR_AddImm8, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Imm*/1,
     /* 199199 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199205 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199211 */   GIR_ConstrainOperandRC, /*InsnID*//* 680(*/0xA8, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199217 */   GIR_MakeTempReg, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199221 */   GIR_BuildMI, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199226 */   GIR_AddTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199233 */   GIR_AddSimpleTempRegister, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*TempRegID*//* 679(*/0xA7, 0x05/*)*/,
     /* 199238 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/32,
     /* 199242 */   GIR_AddImm8, /*InsnID*//* 679(*/0xA7, 0x05/*)*/, /*Imm*/31,
     /* 199246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 679(*/0xA7, 0x05/*)*/,
     /* 199249 */   GIR_MakeTempReg, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199253 */   GIR_BuildMI, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199258 */   GIR_AddTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199265 */   GIR_AddSimpleTempRegister, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*TempRegID*//* 678(*/0xA6, 0x05/*)*/,
     /* 199270 */   GIR_AddImm, /*InsnID*//* 678(*/0xA6, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 678(*/0xA6, 0x05/*)*/,
     /* 199284 */   GIR_MakeTempReg, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199288 */   GIR_BuildMI, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199293 */   GIR_AddTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199300 */   GIR_AddSimpleTempRegister, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*TempRegID*//* 677(*/0xA5, 0x05/*)*/,
     /* 199305 */   GIR_AddImm, /*InsnID*//* 677(*/0xA5, 0x05/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 199316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 677(*/0xA5, 0x05/*)*/,
     /* 199319 */   GIR_MakeTempReg, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199323 */   GIR_BuildMI, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199328 */   GIR_AddTempRegister, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199335 */   GIR_AddImm, /*InsnID*//* 676(*/0xA4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 676(*/0xA4, 0x05/*)*/,
     /* 199349 */   GIR_MakeTempReg, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199353 */   GIR_BuildMI, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199358 */   GIR_AddTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199365 */   GIR_AddSimpleTempRegister, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*TempRegID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199370 */   GIR_AddImm, /*InsnID*//* 675(*/0xA3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199381 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 675(*/0xA3, 0x05/*)*/,
     /* 199384 */   GIR_MakeTempReg, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199388 */   GIR_BuildMI, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199393 */   GIR_AddTempRegister, /*InsnID*//* 674(*/0xA2, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199403 */   GIR_MakeTempReg, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199407 */   GIR_BuildMI, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199412 */   GIR_AddTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199419 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 673(*/0xA1, 0x05/*)*/,
     /* 199424 */   GIR_AddSimpleTempRegister, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*TempRegID*//* 674(*/0xA2, 0x05/*)*/,
     /* 199429 */   GIR_AddImm8, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Imm*/1,
     /* 199433 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199439 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199445 */   GIR_ConstrainOperandRC, /*InsnID*//* 673(*/0xA1, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199451 */   GIR_MakeTempReg, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199455 */   GIR_BuildMI, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199460 */   GIR_AddTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199467 */   GIR_AddSimpleTempRegister, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*TempRegID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199472 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/32,
     /* 199476 */   GIR_AddImm8, /*InsnID*//* 672(*/0xA0, 0x05/*)*/, /*Imm*/31,
     /* 199480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 672(*/0xA0, 0x05/*)*/,
     /* 199483 */   GIR_MakeTempReg, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199487 */   GIR_BuildMI, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199492 */   GIR_AddTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199499 */   GIR_AddSimpleTempRegister, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*TempRegID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199504 */   GIR_AddImm, /*InsnID*//* 671(*/0x9F, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 671(*/0x9F, 0x05/*)*/,
     /* 199518 */   GIR_MakeTempReg, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199522 */   GIR_BuildMI, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199527 */   GIR_AddTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199534 */   GIR_AddSimpleTempRegister, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*TempRegID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199539 */   GIR_AddImm, /*InsnID*//* 670(*/0x9E, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 199550 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 670(*/0x9E, 0x05/*)*/,
     /* 199553 */   GIR_MakeTempReg, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199557 */   GIR_BuildMI, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199562 */   GIR_AddTempRegister, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199569 */   GIR_AddImm, /*InsnID*//* 669(*/0x9D, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 669(*/0x9D, 0x05/*)*/,
     /* 199583 */   GIR_MakeTempReg, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199587 */   GIR_BuildMI, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199592 */   GIR_AddTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199599 */   GIR_AddSimpleTempRegister, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*TempRegID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199604 */   GIR_AddImm, /*InsnID*//* 668(*/0x9C, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 668(*/0x9C, 0x05/*)*/,
     /* 199618 */   GIR_MakeTempReg, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199622 */   GIR_BuildMI, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199627 */   GIR_AddTempRegister, /*InsnID*//* 667(*/0x9B, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199637 */   GIR_MakeTempReg, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199641 */   GIR_BuildMI, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199646 */   GIR_AddTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199653 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 666(*/0x9A, 0x05/*)*/,
     /* 199658 */   GIR_AddSimpleTempRegister, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*TempRegID*//* 667(*/0x9B, 0x05/*)*/,
     /* 199663 */   GIR_AddImm8, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Imm*/1,
     /* 199667 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199673 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199679 */   GIR_ConstrainOperandRC, /*InsnID*//* 666(*/0x9A, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199685 */   GIR_MakeTempReg, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199689 */   GIR_BuildMI, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199694 */   GIR_AddTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199701 */   GIR_AddSimpleTempRegister, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*TempRegID*//* 665(*/0x99, 0x05/*)*/,
     /* 199706 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/32,
     /* 199710 */   GIR_AddImm8, /*InsnID*//* 665(*/0x99, 0x05/*)*/, /*Imm*/31,
     /* 199714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 665(*/0x99, 0x05/*)*/,
     /* 199717 */   GIR_MakeTempReg, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199721 */   GIR_BuildMI, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 199726 */   GIR_AddTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199733 */   GIR_AddSimpleTempRegister, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*TempRegID*//* 664(*/0x98, 0x05/*)*/,
     /* 199738 */   GIR_AddImm, /*InsnID*//* 664(*/0x98, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199749 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 664(*/0x98, 0x05/*)*/,
     /* 199752 */   GIR_MakeTempReg, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199756 */   GIR_BuildMI, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 199761 */   GIR_AddTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199768 */   GIR_AddSimpleTempRegister, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*TempRegID*//* 663(*/0x97, 0x05/*)*/,
     /* 199773 */   GIR_AddImm, /*InsnID*//* 663(*/0x97, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 199784 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 663(*/0x97, 0x05/*)*/,
     /* 199787 */   GIR_MakeTempReg, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199791 */   GIR_BuildMI, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199796 */   GIR_AddTempRegister, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199803 */   GIR_Copy, /*NewInsnID*//* 662(*/0x96, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 199808 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/1,
     /* 199812 */   GIR_AddImm8, /*InsnID*//* 662(*/0x96, 0x05/*)*/, /*Imm*/62,
     /* 199816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 662(*/0x96, 0x05/*)*/,
     /* 199819 */   GIR_MakeTempReg, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199823 */   GIR_BuildMI, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 199828 */   GIR_AddTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199835 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 661(*/0x95, 0x05/*)*/,
     /* 199840 */   GIR_AddSimpleTempRegister, /*InsnID*//* 661(*/0x95, 0x05/*)*/, /*TempRegID*//* 662(*/0x96, 0x05/*)*/,
     /* 199845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 661(*/0x95, 0x05/*)*/,
     /* 199848 */   GIR_MakeTempReg, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199852 */   GIR_BuildMI, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 199857 */   GIR_AddTempRegister, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199864 */   GIR_AddImm, /*InsnID*//* 660(*/0x94, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 660(*/0x94, 0x05/*)*/,
     /* 199878 */   GIR_MakeTempReg, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 199882 */   GIR_BuildMI, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 199887 */   GIR_AddTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199894 */   GIR_AddSimpleTempRegister, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*TempRegID*//* 659(*/0x93, 0x05/*)*/,
     /* 199899 */   GIR_AddImm, /*InsnID*//* 659(*/0x93, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 199910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 659(*/0x93, 0x05/*)*/,
     /* 199913 */   GIR_MakeTempReg, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199917 */   GIR_BuildMI, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 199922 */   GIR_AddTempRegister, /*InsnID*//* 658(*/0x92, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 658(*/0x92, 0x05/*)*/,
     /* 199932 */   GIR_MakeTempReg, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199936 */   GIR_BuildMI, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 199941 */   GIR_AddTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199948 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 657(*/0x91, 0x05/*)*/,
     /* 199953 */   GIR_AddSimpleTempRegister, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*TempRegID*//* 658(*/0x92, 0x05/*)*/,
     /* 199958 */   GIR_AddImm8, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Imm*/1,
     /* 199962 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199968 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 199974 */   GIR_ConstrainOperandRC, /*InsnID*//* 657(*/0x91, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 199980 */   GIR_MakeTempReg, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 199984 */   GIR_BuildMI, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 199989 */   GIR_AddTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 199996 */   GIR_AddSimpleTempRegister, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*TempRegID*//* 656(*/0x90, 0x05/*)*/,
     /* 200001 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/32,
     /* 200005 */   GIR_AddImm8, /*InsnID*//* 656(*/0x90, 0x05/*)*/, /*Imm*/31,
     /* 200009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 656(*/0x90, 0x05/*)*/,
     /* 200012 */   GIR_MakeTempReg, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200016 */   GIR_BuildMI, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200021 */   GIR_AddTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200028 */   GIR_AddSimpleTempRegister, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*TempRegID*//* 655(*/0x8F, 0x05/*)*/,
     /* 200033 */   GIR_AddImm, /*InsnID*//* 655(*/0x8F, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 655(*/0x8F, 0x05/*)*/,
     /* 200047 */   GIR_MakeTempReg, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200051 */   GIR_BuildMI, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200056 */   GIR_AddTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200063 */   GIR_AddSimpleTempRegister, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*TempRegID*//* 654(*/0x8E, 0x05/*)*/,
     /* 200068 */   GIR_AddImm, /*InsnID*//* 654(*/0x8E, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 654(*/0x8E, 0x05/*)*/,
     /* 200082 */   GIR_MakeTempReg, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200086 */   GIR_BuildMI, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 200091 */   GIR_AddTempRegister, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200098 */   GIR_Copy, /*NewInsnID*//* 653(*/0x8D, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200103 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/63,
     /* 200107 */   GIR_AddImm8, /*InsnID*//* 653(*/0x8D, 0x05/*)*/, /*Imm*/1,
     /* 200111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 653(*/0x8D, 0x05/*)*/,
     /* 200114 */   GIR_MakeTempReg, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200118 */   GIR_BuildMI, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200123 */   GIR_AddTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200130 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 652(*/0x8C, 0x05/*)*/,
     /* 200135 */   GIR_AddSimpleTempRegister, /*InsnID*//* 652(*/0x8C, 0x05/*)*/, /*TempRegID*//* 653(*/0x8D, 0x05/*)*/,
     /* 200140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 652(*/0x8C, 0x05/*)*/,
     /* 200143 */   GIR_MakeTempReg, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200147 */   GIR_BuildMI, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 200152 */   GIR_AddTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200159 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 651(*/0x8B, 0x05/*)*/,
     /* 200164 */   GIR_AddSimpleTempRegister, /*InsnID*//* 651(*/0x8B, 0x05/*)*/, /*TempRegID*//* 660(*/0x94, 0x05/*)*/,
     /* 200169 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 651(*/0x8B, 0x05/*)*/,
     /* 200172 */   GIR_MakeTempReg, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200176 */   GIR_BuildMI, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200181 */   GIR_AddTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200188 */   GIR_AddSimpleTempRegister, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*TempRegID*//* 650(*/0x8A, 0x05/*)*/,
     /* 200193 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/2,
     /* 200197 */   GIR_AddImm8, /*InsnID*//* 650(*/0x8A, 0x05/*)*/, /*Imm*/61,
     /* 200201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 650(*/0x8A, 0x05/*)*/,
     /* 200204 */   GIR_MakeTempReg, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200208 */   GIR_BuildMI, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200213 */   GIR_AddTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200220 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 649(*/0x89, 0x05/*)*/,
     /* 200225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 649(*/0x89, 0x05/*)*/, /*TempRegID*//* 669(*/0x9D, 0x05/*)*/,
     /* 200230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 649(*/0x89, 0x05/*)*/,
     /* 200233 */   GIR_MakeTempReg, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200237 */   GIR_BuildMI, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200242 */   GIR_AddTempRegister, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200249 */   GIR_AddImm, /*InsnID*//* 648(*/0x88, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 648(*/0x88, 0x05/*)*/,
     /* 200263 */   GIR_MakeTempReg, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200267 */   GIR_BuildMI, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200272 */   GIR_AddTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200279 */   GIR_AddSimpleTempRegister, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*TempRegID*//* 647(*/0x87, 0x05/*)*/,
     /* 200284 */   GIR_AddImm, /*InsnID*//* 647(*/0x87, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200295 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 647(*/0x87, 0x05/*)*/,
     /* 200298 */   GIR_MakeTempReg, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200302 */   GIR_BuildMI, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200307 */   GIR_AddTempRegister, /*InsnID*//* 646(*/0x86, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 646(*/0x86, 0x05/*)*/,
     /* 200317 */   GIR_MakeTempReg, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200321 */   GIR_BuildMI, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200326 */   GIR_AddTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200333 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 645(*/0x85, 0x05/*)*/,
     /* 200338 */   GIR_AddSimpleTempRegister, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*TempRegID*//* 646(*/0x86, 0x05/*)*/,
     /* 200343 */   GIR_AddImm8, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Imm*/1,
     /* 200347 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200353 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200359 */   GIR_ConstrainOperandRC, /*InsnID*//* 645(*/0x85, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200365 */   GIR_MakeTempReg, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200369 */   GIR_BuildMI, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200374 */   GIR_AddTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200381 */   GIR_AddSimpleTempRegister, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*TempRegID*//* 644(*/0x84, 0x05/*)*/,
     /* 200386 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/32,
     /* 200390 */   GIR_AddImm8, /*InsnID*//* 644(*/0x84, 0x05/*)*/, /*Imm*/31,
     /* 200394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 644(*/0x84, 0x05/*)*/,
     /* 200397 */   GIR_MakeTempReg, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200401 */   GIR_BuildMI, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200406 */   GIR_AddTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200413 */   GIR_AddSimpleTempRegister, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*TempRegID*//* 643(*/0x83, 0x05/*)*/,
     /* 200418 */   GIR_AddImm, /*InsnID*//* 643(*/0x83, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 643(*/0x83, 0x05/*)*/,
     /* 200432 */   GIR_MakeTempReg, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 200436 */   GIR_BuildMI, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200441 */   GIR_AddTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200448 */   GIR_AddSimpleTempRegister, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*TempRegID*//* 642(*/0x82, 0x05/*)*/,
     /* 200453 */   GIR_AddImm, /*InsnID*//* 642(*/0x82, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 200464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 642(*/0x82, 0x05/*)*/,
     /* 200467 */   GIR_MakeTempReg, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 200471 */   GIR_BuildMI, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200476 */   GIR_AddTempRegister, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200483 */   GIR_AddImm, /*InsnID*//* 641(*/0x81, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 641(*/0x81, 0x05/*)*/,
     /* 200497 */   GIR_MakeTempReg, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200501 */   GIR_BuildMI, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200506 */   GIR_AddTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200513 */   GIR_AddSimpleTempRegister, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*TempRegID*//* 640(*/0x80, 0x05/*)*/,
     /* 200518 */   GIR_AddImm, /*InsnID*//* 640(*/0x80, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 640(*/0x80, 0x05/*)*/,
     /* 200532 */   GIR_MakeTempReg, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200536 */   GIR_BuildMI, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200541 */   GIR_AddTempRegister, /*InsnID*//* 639(*/0xFF, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200548 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200551 */   GIR_MakeTempReg, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200555 */   GIR_BuildMI, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200560 */   GIR_AddTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200567 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 638(*/0xFE, 0x04/*)*/,
     /* 200572 */   GIR_AddSimpleTempRegister, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*TempRegID*//* 639(*/0xFF, 0x04/*)*/,
     /* 200577 */   GIR_AddImm8, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Imm*/1,
     /* 200581 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200587 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200593 */   GIR_ConstrainOperandRC, /*InsnID*//* 638(*/0xFE, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200599 */   GIR_MakeTempReg, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200603 */   GIR_BuildMI, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200608 */   GIR_AddTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200615 */   GIR_AddSimpleTempRegister, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*TempRegID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200620 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/32,
     /* 200624 */   GIR_AddImm8, /*InsnID*//* 637(*/0xFD, 0x04/*)*/, /*Imm*/31,
     /* 200628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 637(*/0xFD, 0x04/*)*/,
     /* 200631 */   GIR_MakeTempReg, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200635 */   GIR_BuildMI, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200640 */   GIR_AddTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200647 */   GIR_AddSimpleTempRegister, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*TempRegID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200652 */   GIR_AddImm, /*InsnID*//* 636(*/0xFC, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 636(*/0xFC, 0x04/*)*/,
     /* 200666 */   GIR_MakeTempReg, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200670 */   GIR_BuildMI, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200675 */   GIR_AddTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200682 */   GIR_AddSimpleTempRegister, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*TempRegID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200687 */   GIR_AddImm, /*InsnID*//* 635(*/0xFB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 200698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 635(*/0xFB, 0x04/*)*/,
     /* 200701 */   GIR_MakeTempReg, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200705 */   GIR_BuildMI, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200710 */   GIR_AddTempRegister, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200717 */   GIR_Copy, /*NewInsnID*//* 634(*/0xFA, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 200722 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/1,
     /* 200726 */   GIR_AddImm8, /*InsnID*//* 634(*/0xFA, 0x04/*)*/, /*Imm*/62,
     /* 200730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200733 */   GIR_MakeTempReg, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200737 */   GIR_BuildMI, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 200742 */   GIR_AddTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200749 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200754 */   GIR_AddSimpleTempRegister, /*InsnID*//* 633(*/0xF9, 0x04/*)*/, /*TempRegID*//* 634(*/0xFA, 0x04/*)*/,
     /* 200759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 633(*/0xF9, 0x04/*)*/,
     /* 200762 */   GIR_MakeTempReg, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200766 */   GIR_BuildMI, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 200771 */   GIR_AddTempRegister, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200778 */   GIR_AddImm, /*InsnID*//* 632(*/0xF8, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200789 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 632(*/0xF8, 0x04/*)*/,
     /* 200792 */   GIR_MakeTempReg, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 200796 */   GIR_BuildMI, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 200801 */   GIR_AddTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200808 */   GIR_AddSimpleTempRegister, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*TempRegID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200813 */   GIR_AddImm, /*InsnID*//* 631(*/0xF7, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 631(*/0xF7, 0x04/*)*/,
     /* 200827 */   GIR_MakeTempReg, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200831 */   GIR_BuildMI, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200836 */   GIR_AddTempRegister, /*InsnID*//* 630(*/0xF6, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200846 */   GIR_MakeTempReg, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200850 */   GIR_BuildMI, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200855 */   GIR_AddTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200862 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 629(*/0xF5, 0x04/*)*/,
     /* 200867 */   GIR_AddSimpleTempRegister, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*TempRegID*//* 630(*/0xF6, 0x04/*)*/,
     /* 200872 */   GIR_AddImm8, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Imm*/1,
     /* 200876 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200882 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 200888 */   GIR_ConstrainOperandRC, /*InsnID*//* 629(*/0xF5, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 200894 */   GIR_MakeTempReg, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200898 */   GIR_BuildMI, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 200903 */   GIR_AddTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200910 */   GIR_AddSimpleTempRegister, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*TempRegID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200915 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/32,
     /* 200919 */   GIR_AddImm8, /*InsnID*//* 628(*/0xF4, 0x04/*)*/, /*Imm*/31,
     /* 200923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 628(*/0xF4, 0x04/*)*/,
     /* 200926 */   GIR_MakeTempReg, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200930 */   GIR_BuildMI, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 200935 */   GIR_AddTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*TempRegID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200947 */   GIR_AddImm, /*InsnID*//* 627(*/0xF3, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 627(*/0xF3, 0x04/*)*/,
     /* 200961 */   GIR_MakeTempReg, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 200965 */   GIR_BuildMI, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 200970 */   GIR_AddTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200977 */   GIR_AddSimpleTempRegister, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*TempRegID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200982 */   GIR_AddImm, /*InsnID*//* 626(*/0xF2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 200993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 626(*/0xF2, 0x04/*)*/,
     /* 200996 */   GIR_MakeTempReg, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201000 */   GIR_BuildMI, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201005 */   GIR_AddTempRegister, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201012 */   GIR_Copy, /*NewInsnID*//* 625(*/0xF1, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201017 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/63,
     /* 201021 */   GIR_AddImm8, /*InsnID*//* 625(*/0xF1, 0x04/*)*/, /*Imm*/1,
     /* 201025 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 625(*/0xF1, 0x04/*)*/,
     /* 201028 */   GIR_MakeTempReg, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201032 */   GIR_BuildMI, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201037 */   GIR_AddTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201044 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 624(*/0xF0, 0x04/*)*/,
     /* 201049 */   GIR_AddSimpleTempRegister, /*InsnID*//* 624(*/0xF0, 0x04/*)*/, /*TempRegID*//* 625(*/0xF1, 0x04/*)*/,
     /* 201054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 624(*/0xF0, 0x04/*)*/,
     /* 201057 */   GIR_MakeTempReg, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201061 */   GIR_BuildMI, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201066 */   GIR_AddTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201073 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 623(*/0xEF, 0x04/*)*/,
     /* 201078 */   GIR_AddSimpleTempRegister, /*InsnID*//* 623(*/0xEF, 0x04/*)*/, /*TempRegID*//* 632(*/0xF8, 0x04/*)*/,
     /* 201083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 623(*/0xEF, 0x04/*)*/,
     /* 201086 */   GIR_MakeTempReg, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201090 */   GIR_BuildMI, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 201095 */   GIR_AddTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201102 */   GIR_AddSimpleTempRegister, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*TempRegID*//* 622(*/0xEE, 0x04/*)*/,
     /* 201107 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/62,
     /* 201111 */   GIR_AddImm8, /*InsnID*//* 622(*/0xEE, 0x04/*)*/, /*Imm*/2,
     /* 201115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 622(*/0xEE, 0x04/*)*/,
     /* 201118 */   GIR_MakeTempReg, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201122 */   GIR_BuildMI, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201127 */   GIR_AddTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201134 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 621(*/0xED, 0x04/*)*/,
     /* 201139 */   GIR_AddSimpleTempRegister, /*InsnID*//* 621(*/0xED, 0x04/*)*/, /*TempRegID*//* 641(*/0x81, 0x05/*)*/,
     /* 201144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 621(*/0xED, 0x04/*)*/,
     /* 201147 */   GIR_MakeTempReg, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201151 */   GIR_BuildMI, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 201156 */   GIR_AddTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201163 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 620(*/0xEC, 0x04/*)*/,
     /* 201168 */   GIR_AddSimpleTempRegister, /*InsnID*//* 620(*/0xEC, 0x04/*)*/, /*TempRegID*//* 648(*/0x88, 0x05/*)*/,
     /* 201173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 620(*/0xEC, 0x04/*)*/,
     /* 201176 */   GIR_MakeTempReg, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201180 */   GIR_BuildMI, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201185 */   GIR_AddTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201192 */   GIR_AddSimpleTempRegister, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*TempRegID*//* 619(*/0xEB, 0x04/*)*/,
     /* 201197 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/4,
     /* 201201 */   GIR_AddImm8, /*InsnID*//* 619(*/0xEB, 0x04/*)*/, /*Imm*/59,
     /* 201205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 619(*/0xEB, 0x04/*)*/,
     /* 201208 */   GIR_MakeTempReg, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201212 */   GIR_BuildMI, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201217 */   GIR_AddTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201224 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 618(*/0xEA, 0x04/*)*/,
     /* 201229 */   GIR_AddSimpleTempRegister, /*InsnID*//* 618(*/0xEA, 0x04/*)*/, /*TempRegID*//* 676(*/0xA4, 0x05/*)*/,
     /* 201234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 618(*/0xEA, 0x04/*)*/,
     /* 201237 */   GIR_MakeTempReg, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201241 */   GIR_BuildMI, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201246 */   GIR_AddTempRegister, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201253 */   GIR_AddImm, /*InsnID*//* 617(*/0xE9, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 617(*/0xE9, 0x04/*)*/,
     /* 201267 */   GIR_MakeTempReg, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201271 */   GIR_BuildMI, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201276 */   GIR_AddTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201283 */   GIR_AddSimpleTempRegister, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*TempRegID*//* 616(*/0xE8, 0x04/*)*/,
     /* 201288 */   GIR_AddImm, /*InsnID*//* 616(*/0xE8, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 616(*/0xE8, 0x04/*)*/,
     /* 201302 */   GIR_MakeTempReg, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201306 */   GIR_BuildMI, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201311 */   GIR_AddTempRegister, /*InsnID*//* 615(*/0xE7, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201318 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201321 */   GIR_MakeTempReg, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201325 */   GIR_BuildMI, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201330 */   GIR_AddTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201337 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 614(*/0xE6, 0x04/*)*/,
     /* 201342 */   GIR_AddSimpleTempRegister, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*TempRegID*//* 615(*/0xE7, 0x04/*)*/,
     /* 201347 */   GIR_AddImm8, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Imm*/1,
     /* 201351 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201357 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201363 */   GIR_ConstrainOperandRC, /*InsnID*//* 614(*/0xE6, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201369 */   GIR_MakeTempReg, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201373 */   GIR_BuildMI, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201378 */   GIR_AddTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201385 */   GIR_AddSimpleTempRegister, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*TempRegID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201390 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/32,
     /* 201394 */   GIR_AddImm8, /*InsnID*//* 613(*/0xE5, 0x04/*)*/, /*Imm*/31,
     /* 201398 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 613(*/0xE5, 0x04/*)*/,
     /* 201401 */   GIR_MakeTempReg, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201405 */   GIR_BuildMI, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201410 */   GIR_AddTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201417 */   GIR_AddSimpleTempRegister, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*TempRegID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201422 */   GIR_AddImm, /*InsnID*//* 612(*/0xE4, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201433 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 612(*/0xE4, 0x04/*)*/,
     /* 201436 */   GIR_MakeTempReg, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201440 */   GIR_BuildMI, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201445 */   GIR_AddTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201452 */   GIR_AddSimpleTempRegister, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*TempRegID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201457 */   GIR_AddImm, /*InsnID*//* 611(*/0xE3, 0x04/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 201468 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 611(*/0xE3, 0x04/*)*/,
     /* 201471 */   GIR_MakeTempReg, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201475 */   GIR_BuildMI, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201480 */   GIR_AddTempRegister, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201487 */   GIR_AddImm, /*InsnID*//* 610(*/0xE2, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 610(*/0xE2, 0x04/*)*/,
     /* 201501 */   GIR_MakeTempReg, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201505 */   GIR_BuildMI, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201510 */   GIR_AddTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201517 */   GIR_AddSimpleTempRegister, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*TempRegID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201522 */   GIR_AddImm, /*InsnID*//* 609(*/0xE1, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 609(*/0xE1, 0x04/*)*/,
     /* 201536 */   GIR_MakeTempReg, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201540 */   GIR_BuildMI, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201545 */   GIR_AddTempRegister, /*InsnID*//* 608(*/0xE0, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201555 */   GIR_MakeTempReg, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201559 */   GIR_BuildMI, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201564 */   GIR_AddTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201571 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 607(*/0xDF, 0x04/*)*/,
     /* 201576 */   GIR_AddSimpleTempRegister, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*TempRegID*//* 608(*/0xE0, 0x04/*)*/,
     /* 201581 */   GIR_AddImm8, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Imm*/1,
     /* 201585 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201591 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201597 */   GIR_ConstrainOperandRC, /*InsnID*//* 607(*/0xDF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201603 */   GIR_MakeTempReg, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201607 */   GIR_BuildMI, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201612 */   GIR_AddTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201619 */   GIR_AddSimpleTempRegister, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*TempRegID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201624 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/32,
     /* 201628 */   GIR_AddImm8, /*InsnID*//* 606(*/0xDE, 0x04/*)*/, /*Imm*/31,
     /* 201632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 606(*/0xDE, 0x04/*)*/,
     /* 201635 */   GIR_MakeTempReg, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201639 */   GIR_BuildMI, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201644 */   GIR_AddTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201651 */   GIR_AddSimpleTempRegister, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*TempRegID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201656 */   GIR_AddImm, /*InsnID*//* 605(*/0xDD, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 605(*/0xDD, 0x04/*)*/,
     /* 201670 */   GIR_MakeTempReg, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201674 */   GIR_BuildMI, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201679 */   GIR_AddTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201686 */   GIR_AddSimpleTempRegister, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*TempRegID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201691 */   GIR_AddImm, /*InsnID*//* 604(*/0xDC, 0x04/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 201702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 604(*/0xDC, 0x04/*)*/,
     /* 201705 */   GIR_MakeTempReg, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201709 */   GIR_BuildMI, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 201714 */   GIR_AddTempRegister, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201721 */   GIR_AddImm, /*InsnID*//* 603(*/0xDB, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 603(*/0xDB, 0x04/*)*/,
     /* 201735 */   GIR_MakeTempReg, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 201739 */   GIR_BuildMI, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 201744 */   GIR_AddTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201751 */   GIR_AddSimpleTempRegister, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*TempRegID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201756 */   GIR_AddImm, /*InsnID*//* 602(*/0xDA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 602(*/0xDA, 0x04/*)*/,
     /* 201770 */   GIR_MakeTempReg, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201774 */   GIR_BuildMI, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 201779 */   GIR_AddTempRegister, /*InsnID*//* 601(*/0xD9, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201789 */   GIR_MakeTempReg, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201793 */   GIR_BuildMI, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 201798 */   GIR_AddTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201805 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 600(*/0xD8, 0x04/*)*/,
     /* 201810 */   GIR_AddSimpleTempRegister, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*TempRegID*//* 601(*/0xD9, 0x04/*)*/,
     /* 201815 */   GIR_AddImm8, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Imm*/1,
     /* 201819 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201825 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 201831 */   GIR_ConstrainOperandRC, /*InsnID*//* 600(*/0xD8, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 201837 */   GIR_MakeTempReg, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201841 */   GIR_BuildMI, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201846 */   GIR_AddTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201853 */   GIR_AddSimpleTempRegister, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*TempRegID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201858 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/32,
     /* 201862 */   GIR_AddImm8, /*InsnID*//* 599(*/0xD7, 0x04/*)*/, /*Imm*/31,
     /* 201866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 599(*/0xD7, 0x04/*)*/,
     /* 201869 */   GIR_MakeTempReg, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201873 */   GIR_BuildMI, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 201878 */   GIR_AddTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201885 */   GIR_AddSimpleTempRegister, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*TempRegID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201890 */   GIR_AddImm, /*InsnID*//* 598(*/0xD6, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 598(*/0xD6, 0x04/*)*/,
     /* 201904 */   GIR_MakeTempReg, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201908 */   GIR_BuildMI, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 201913 */   GIR_AddTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201920 */   GIR_AddSimpleTempRegister, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*TempRegID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201925 */   GIR_AddImm, /*InsnID*//* 597(*/0xD5, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 201936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 597(*/0xD5, 0x04/*)*/,
     /* 201939 */   GIR_MakeTempReg, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201943 */   GIR_BuildMI, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 201948 */   GIR_AddTempRegister, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201955 */   GIR_Copy, /*NewInsnID*//* 596(*/0xD4, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 201960 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/1,
     /* 201964 */   GIR_AddImm8, /*InsnID*//* 596(*/0xD4, 0x04/*)*/, /*Imm*/62,
     /* 201968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201971 */   GIR_MakeTempReg, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 201975 */   GIR_BuildMI, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 201980 */   GIR_AddTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 201987 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 595(*/0xD3, 0x04/*)*/,
     /* 201992 */   GIR_AddSimpleTempRegister, /*InsnID*//* 595(*/0xD3, 0x04/*)*/, /*TempRegID*//* 596(*/0xD4, 0x04/*)*/,
     /* 201997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 595(*/0xD3, 0x04/*)*/,
     /* 202000 */   GIR_MakeTempReg, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202004 */   GIR_BuildMI, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202009 */   GIR_AddTempRegister, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202016 */   GIR_AddImm, /*InsnID*//* 594(*/0xD2, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 594(*/0xD2, 0x04/*)*/,
     /* 202030 */   GIR_MakeTempReg, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202034 */   GIR_BuildMI, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202039 */   GIR_AddTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202046 */   GIR_AddSimpleTempRegister, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*TempRegID*//* 593(*/0xD1, 0x04/*)*/,
     /* 202051 */   GIR_AddImm, /*InsnID*//* 593(*/0xD1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 593(*/0xD1, 0x04/*)*/,
     /* 202065 */   GIR_MakeTempReg, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202069 */   GIR_BuildMI, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202074 */   GIR_AddTempRegister, /*InsnID*//* 592(*/0xD0, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 592(*/0xD0, 0x04/*)*/,
     /* 202084 */   GIR_MakeTempReg, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202088 */   GIR_BuildMI, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202093 */   GIR_AddTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202100 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 591(*/0xCF, 0x04/*)*/,
     /* 202105 */   GIR_AddSimpleTempRegister, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*TempRegID*//* 592(*/0xD0, 0x04/*)*/,
     /* 202110 */   GIR_AddImm8, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Imm*/1,
     /* 202114 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202120 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202126 */   GIR_ConstrainOperandRC, /*InsnID*//* 591(*/0xCF, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202132 */   GIR_MakeTempReg, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202136 */   GIR_BuildMI, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202141 */   GIR_AddTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202148 */   GIR_AddSimpleTempRegister, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*TempRegID*//* 590(*/0xCE, 0x04/*)*/,
     /* 202153 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/32,
     /* 202157 */   GIR_AddImm8, /*InsnID*//* 590(*/0xCE, 0x04/*)*/, /*Imm*/31,
     /* 202161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 590(*/0xCE, 0x04/*)*/,
     /* 202164 */   GIR_MakeTempReg, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202168 */   GIR_BuildMI, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202173 */   GIR_AddTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202180 */   GIR_AddSimpleTempRegister, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*TempRegID*//* 589(*/0xCD, 0x04/*)*/,
     /* 202185 */   GIR_AddImm, /*InsnID*//* 589(*/0xCD, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 589(*/0xCD, 0x04/*)*/,
     /* 202199 */   GIR_MakeTempReg, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202203 */   GIR_BuildMI, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202208 */   GIR_AddTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202215 */   GIR_AddSimpleTempRegister, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*TempRegID*//* 588(*/0xCC, 0x04/*)*/,
     /* 202220 */   GIR_AddImm, /*InsnID*//* 588(*/0xCC, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 588(*/0xCC, 0x04/*)*/,
     /* 202234 */   GIR_MakeTempReg, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202238 */   GIR_BuildMI, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 202243 */   GIR_AddTempRegister, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202250 */   GIR_Copy, /*NewInsnID*//* 587(*/0xCB, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202255 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/63,
     /* 202259 */   GIR_AddImm8, /*InsnID*//* 587(*/0xCB, 0x04/*)*/, /*Imm*/1,
     /* 202263 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 587(*/0xCB, 0x04/*)*/,
     /* 202266 */   GIR_MakeTempReg, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202270 */   GIR_BuildMI, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202275 */   GIR_AddTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202282 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 586(*/0xCA, 0x04/*)*/,
     /* 202287 */   GIR_AddSimpleTempRegister, /*InsnID*//* 586(*/0xCA, 0x04/*)*/, /*TempRegID*//* 587(*/0xCB, 0x04/*)*/,
     /* 202292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 586(*/0xCA, 0x04/*)*/,
     /* 202295 */   GIR_MakeTempReg, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202299 */   GIR_BuildMI, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 202304 */   GIR_AddTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202311 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202316 */   GIR_AddSimpleTempRegister, /*InsnID*//* 585(*/0xC9, 0x04/*)*/, /*TempRegID*//* 594(*/0xD2, 0x04/*)*/,
     /* 202321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 585(*/0xC9, 0x04/*)*/,
     /* 202324 */   GIR_MakeTempReg, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202328 */   GIR_BuildMI, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202333 */   GIR_AddTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202340 */   GIR_AddSimpleTempRegister, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*TempRegID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202345 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/2,
     /* 202349 */   GIR_AddImm8, /*InsnID*//* 584(*/0xC8, 0x04/*)*/, /*Imm*/61,
     /* 202353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 584(*/0xC8, 0x04/*)*/,
     /* 202356 */   GIR_MakeTempReg, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202360 */   GIR_BuildMI, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202365 */   GIR_AddTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202372 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202377 */   GIR_AddSimpleTempRegister, /*InsnID*//* 583(*/0xC7, 0x04/*)*/, /*TempRegID*//* 603(*/0xDB, 0x04/*)*/,
     /* 202382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 583(*/0xC7, 0x04/*)*/,
     /* 202385 */   GIR_MakeTempReg, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202389 */   GIR_BuildMI, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202394 */   GIR_AddTempRegister, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202401 */   GIR_AddImm, /*InsnID*//* 582(*/0xC6, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 582(*/0xC6, 0x04/*)*/,
     /* 202415 */   GIR_MakeTempReg, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202419 */   GIR_BuildMI, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202424 */   GIR_AddTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202431 */   GIR_AddSimpleTempRegister, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*TempRegID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202436 */   GIR_AddImm, /*InsnID*//* 581(*/0xC5, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 581(*/0xC5, 0x04/*)*/,
     /* 202450 */   GIR_MakeTempReg, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202454 */   GIR_BuildMI, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202459 */   GIR_AddTempRegister, /*InsnID*//* 580(*/0xC4, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202469 */   GIR_MakeTempReg, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202473 */   GIR_BuildMI, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202478 */   GIR_AddTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202485 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 579(*/0xC3, 0x04/*)*/,
     /* 202490 */   GIR_AddSimpleTempRegister, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*TempRegID*//* 580(*/0xC4, 0x04/*)*/,
     /* 202495 */   GIR_AddImm8, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Imm*/1,
     /* 202499 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202505 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202511 */   GIR_ConstrainOperandRC, /*InsnID*//* 579(*/0xC3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202517 */   GIR_MakeTempReg, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202521 */   GIR_BuildMI, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202526 */   GIR_AddTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202533 */   GIR_AddSimpleTempRegister, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*TempRegID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202538 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/32,
     /* 202542 */   GIR_AddImm8, /*InsnID*//* 578(*/0xC2, 0x04/*)*/, /*Imm*/31,
     /* 202546 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 578(*/0xC2, 0x04/*)*/,
     /* 202549 */   GIR_MakeTempReg, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202553 */   GIR_BuildMI, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202558 */   GIR_AddTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202565 */   GIR_AddSimpleTempRegister, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*TempRegID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202570 */   GIR_AddImm, /*InsnID*//* 577(*/0xC1, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202581 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 577(*/0xC1, 0x04/*)*/,
     /* 202584 */   GIR_MakeTempReg, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202588 */   GIR_BuildMI, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202593 */   GIR_AddTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202600 */   GIR_AddSimpleTempRegister, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*TempRegID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202605 */   GIR_AddImm, /*InsnID*//* 576(*/0xC0, 0x04/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 202616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 576(*/0xC0, 0x04/*)*/,
     /* 202619 */   GIR_MakeTempReg, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202623 */   GIR_BuildMI, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202628 */   GIR_AddTempRegister, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202635 */   GIR_AddImm, /*InsnID*//* 575(*/0xBF, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 575(*/0xBF, 0x04/*)*/,
     /* 202649 */   GIR_MakeTempReg, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202653 */   GIR_BuildMI, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202658 */   GIR_AddTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202665 */   GIR_AddSimpleTempRegister, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*TempRegID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202670 */   GIR_AddImm, /*InsnID*//* 574(*/0xBE, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 574(*/0xBE, 0x04/*)*/,
     /* 202684 */   GIR_MakeTempReg, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202688 */   GIR_BuildMI, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202693 */   GIR_AddTempRegister, /*InsnID*//* 573(*/0xBD, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202703 */   GIR_MakeTempReg, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202707 */   GIR_BuildMI, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 202712 */   GIR_AddTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202719 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 572(*/0xBC, 0x04/*)*/,
     /* 202724 */   GIR_AddSimpleTempRegister, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*TempRegID*//* 573(*/0xBD, 0x04/*)*/,
     /* 202729 */   GIR_AddImm8, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Imm*/1,
     /* 202733 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202739 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 202745 */   GIR_ConstrainOperandRC, /*InsnID*//* 572(*/0xBC, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 202751 */   GIR_MakeTempReg, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202755 */   GIR_BuildMI, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202760 */   GIR_AddTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202767 */   GIR_AddSimpleTempRegister, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*TempRegID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202772 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/32,
     /* 202776 */   GIR_AddImm8, /*InsnID*//* 571(*/0xBB, 0x04/*)*/, /*Imm*/31,
     /* 202780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 571(*/0xBB, 0x04/*)*/,
     /* 202783 */   GIR_MakeTempReg, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202787 */   GIR_BuildMI, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 202792 */   GIR_AddTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202799 */   GIR_AddSimpleTempRegister, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*TempRegID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202804 */   GIR_AddImm, /*InsnID*//* 570(*/0xBA, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 570(*/0xBA, 0x04/*)*/,
     /* 202818 */   GIR_MakeTempReg, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202822 */   GIR_BuildMI, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 202827 */   GIR_AddTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202834 */   GIR_AddSimpleTempRegister, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*TempRegID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202839 */   GIR_AddImm, /*InsnID*//* 569(*/0xB9, 0x04/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 202850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 569(*/0xB9, 0x04/*)*/,
     /* 202853 */   GIR_MakeTempReg, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202857 */   GIR_BuildMI, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 202862 */   GIR_AddTempRegister, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202869 */   GIR_Copy, /*NewInsnID*//* 568(*/0xB8, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 202874 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/1,
     /* 202878 */   GIR_AddImm8, /*InsnID*//* 568(*/0xB8, 0x04/*)*/, /*Imm*/62,
     /* 202882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202885 */   GIR_MakeTempReg, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202889 */   GIR_BuildMI, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 202894 */   GIR_AddTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202901 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202906 */   GIR_AddSimpleTempRegister, /*InsnID*//* 567(*/0xB7, 0x04/*)*/, /*TempRegID*//* 568(*/0xB8, 0x04/*)*/,
     /* 202911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 567(*/0xB7, 0x04/*)*/,
     /* 202914 */   GIR_MakeTempReg, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202918 */   GIR_BuildMI, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 202923 */   GIR_AddTempRegister, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202930 */   GIR_AddImm, /*InsnID*//* 566(*/0xB6, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202941 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 566(*/0xB6, 0x04/*)*/,
     /* 202944 */   GIR_MakeTempReg, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 202948 */   GIR_BuildMI, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 202953 */   GIR_AddTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202960 */   GIR_AddSimpleTempRegister, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*TempRegID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202965 */   GIR_AddImm, /*InsnID*//* 565(*/0xB5, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 202976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 565(*/0xB5, 0x04/*)*/,
     /* 202979 */   GIR_MakeTempReg, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 202983 */   GIR_BuildMI, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 202988 */   GIR_AddTempRegister, /*InsnID*//* 564(*/0xB4, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 202995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 564(*/0xB4, 0x04/*)*/,
     /* 202998 */   GIR_MakeTempReg, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203002 */   GIR_BuildMI, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203007 */   GIR_AddTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203014 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 563(*/0xB3, 0x04/*)*/,
     /* 203019 */   GIR_AddSimpleTempRegister, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*TempRegID*//* 564(*/0xB4, 0x04/*)*/,
     /* 203024 */   GIR_AddImm8, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Imm*/1,
     /* 203028 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203034 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203040 */   GIR_ConstrainOperandRC, /*InsnID*//* 563(*/0xB3, 0x04/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203046 */   GIR_MakeTempReg, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203050 */   GIR_BuildMI, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203055 */   GIR_AddTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203062 */   GIR_AddSimpleTempRegister, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*TempRegID*//* 562(*/0xB2, 0x04/*)*/,
     /* 203067 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/32,
     /* 203071 */   GIR_AddImm8, /*InsnID*//* 562(*/0xB2, 0x04/*)*/, /*Imm*/31,
     /* 203075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 562(*/0xB2, 0x04/*)*/,
     /* 203078 */   GIR_MakeTempReg, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203082 */   GIR_BuildMI, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203087 */   GIR_AddTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203094 */   GIR_AddSimpleTempRegister, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*TempRegID*//* 561(*/0xB1, 0x04/*)*/,
     /* 203099 */   GIR_AddImm, /*InsnID*//* 561(*/0xB1, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203110 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 561(*/0xB1, 0x04/*)*/,
     /* 203113 */   GIR_MakeTempReg, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203117 */   GIR_BuildMI, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203122 */   GIR_AddTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203129 */   GIR_AddSimpleTempRegister, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*TempRegID*//* 560(*/0xB0, 0x04/*)*/,
     /* 203134 */   GIR_AddImm, /*InsnID*//* 560(*/0xB0, 0x04/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 203145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 560(*/0xB0, 0x04/*)*/,
     /* 203148 */   GIR_MakeTempReg, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203152 */   GIR_BuildMI, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203157 */   GIR_AddTempRegister, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203164 */   GIR_Copy, /*NewInsnID*//* 559(*/0xAF, 0x04/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 203169 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/63,
     /* 203173 */   GIR_AddImm8, /*InsnID*//* 559(*/0xAF, 0x04/*)*/, /*Imm*/1,
     /* 203177 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 559(*/0xAF, 0x04/*)*/,
     /* 203180 */   GIR_MakeTempReg, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203184 */   GIR_BuildMI, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203189 */   GIR_AddTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203196 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 558(*/0xAE, 0x04/*)*/,
     /* 203201 */   GIR_AddSimpleTempRegister, /*InsnID*//* 558(*/0xAE, 0x04/*)*/, /*TempRegID*//* 559(*/0xAF, 0x04/*)*/,
     /* 203206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 558(*/0xAE, 0x04/*)*/,
     /* 203209 */   GIR_MakeTempReg, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203213 */   GIR_BuildMI, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203218 */   GIR_AddTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203225 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 557(*/0xAD, 0x04/*)*/,
     /* 203230 */   GIR_AddSimpleTempRegister, /*InsnID*//* 557(*/0xAD, 0x04/*)*/, /*TempRegID*//* 566(*/0xB6, 0x04/*)*/,
     /* 203235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 557(*/0xAD, 0x04/*)*/,
     /* 203238 */   GIR_MakeTempReg, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203242 */   GIR_BuildMI, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203247 */   GIR_AddTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203254 */   GIR_AddSimpleTempRegister, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*TempRegID*//* 556(*/0xAC, 0x04/*)*/,
     /* 203259 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/62,
     /* 203263 */   GIR_AddImm8, /*InsnID*//* 556(*/0xAC, 0x04/*)*/, /*Imm*/2,
     /* 203267 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 556(*/0xAC, 0x04/*)*/,
     /* 203270 */   GIR_MakeTempReg, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203274 */   GIR_BuildMI, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203279 */   GIR_AddTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203286 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 555(*/0xAB, 0x04/*)*/,
     /* 203291 */   GIR_AddSimpleTempRegister, /*InsnID*//* 555(*/0xAB, 0x04/*)*/, /*TempRegID*//* 575(*/0xBF, 0x04/*)*/,
     /* 203296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 555(*/0xAB, 0x04/*)*/,
     /* 203299 */   GIR_MakeTempReg, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203303 */   GIR_BuildMI, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203308 */   GIR_AddTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203315 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203320 */   GIR_AddSimpleTempRegister, /*InsnID*//* 554(*/0xAA, 0x04/*)*/, /*TempRegID*//* 582(*/0xC6, 0x04/*)*/,
     /* 203325 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 554(*/0xAA, 0x04/*)*/,
     /* 203328 */   GIR_MakeTempReg, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203332 */   GIR_BuildMI, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203337 */   GIR_AddTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203344 */   GIR_AddSimpleTempRegister, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*TempRegID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203349 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/60,
     /* 203353 */   GIR_AddImm8, /*InsnID*//* 553(*/0xA9, 0x04/*)*/, /*Imm*/4,
     /* 203357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 553(*/0xA9, 0x04/*)*/,
     /* 203360 */   GIR_MakeTempReg, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203364 */   GIR_BuildMI, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 203369 */   GIR_AddTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203376 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203381 */   GIR_AddSimpleTempRegister, /*InsnID*//* 552(*/0xA8, 0x04/*)*/, /*TempRegID*//* 610(*/0xE2, 0x04/*)*/,
     /* 203386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 552(*/0xA8, 0x04/*)*/,
     /* 203389 */   GIR_MakeTempReg, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203393 */   GIR_BuildMI, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 203398 */   GIR_AddTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203405 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203410 */   GIR_AddSimpleTempRegister, /*InsnID*//* 551(*/0xA7, 0x04/*)*/, /*TempRegID*//* 617(*/0xE9, 0x04/*)*/,
     /* 203415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 551(*/0xA7, 0x04/*)*/,
     /* 203418 */   GIR_MakeTempReg, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TypeID*/GILLT_s64,
     /* 203422 */   GIR_BuildMI, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 203427 */   GIR_AddTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203434 */   GIR_AddSimpleTempRegister, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*TempRegID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203439 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203443 */   GIR_AddImm8, /*InsnID*//* 550(*/0xA6, 0x04/*)*/, /*Imm*/32,
     /* 203447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 550(*/0xA6, 0x04/*)*/,
     /* 203450 */   GIR_MakeTempReg, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203454 */   GIR_BuildMI, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203459 */   GIR_AddTempRegister, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203466 */   GIR_AddImm, /*InsnID*//* 818(*/0xB2, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 818(*/0xB2, 0x06/*)*/,
     /* 203480 */   GIR_MakeTempReg, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203484 */   GIR_BuildMI, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203489 */   GIR_AddTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203496 */   GIR_AddSimpleTempRegister, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*TempRegID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203501 */   GIR_AddImm, /*InsnID*//* 817(*/0xB1, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 817(*/0xB1, 0x06/*)*/,
     /* 203515 */   GIR_MakeTempReg, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203519 */   GIR_BuildMI, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203524 */   GIR_AddTempRegister, /*InsnID*//* 816(*/0xB0, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203534 */   GIR_MakeTempReg, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203538 */   GIR_BuildMI, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203543 */   GIR_AddTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203550 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 815(*/0xAF, 0x06/*)*/,
     /* 203555 */   GIR_AddSimpleTempRegister, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*TempRegID*//* 816(*/0xB0, 0x06/*)*/,
     /* 203560 */   GIR_AddImm8, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Imm*/1,
     /* 203564 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203570 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203576 */   GIR_ConstrainOperandRC, /*InsnID*//* 815(*/0xAF, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203582 */   GIR_MakeTempReg, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203586 */   GIR_BuildMI, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203591 */   GIR_AddTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203598 */   GIR_AddSimpleTempRegister, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*TempRegID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203603 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/32,
     /* 203607 */   GIR_AddImm8, /*InsnID*//* 814(*/0xAE, 0x06/*)*/, /*Imm*/31,
     /* 203611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 814(*/0xAE, 0x06/*)*/,
     /* 203614 */   GIR_MakeTempReg, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203618 */   GIR_BuildMI, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203623 */   GIR_AddTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203630 */   GIR_AddSimpleTempRegister, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*TempRegID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203635 */   GIR_AddImm, /*InsnID*//* 813(*/0xAD, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 813(*/0xAD, 0x06/*)*/,
     /* 203649 */   GIR_MakeTempReg, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203653 */   GIR_BuildMI, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203658 */   GIR_AddTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203665 */   GIR_AddSimpleTempRegister, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*TempRegID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203670 */   GIR_AddImm, /*InsnID*//* 812(*/0xAC, 0x06/*)*/, /*Imm*/GIMT_Encode8(61680),
     /* 203681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 812(*/0xAC, 0x06/*)*/,
     /* 203684 */   GIR_MakeTempReg, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203688 */   GIR_BuildMI, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203693 */   GIR_AddTempRegister, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203700 */   GIR_AddImm, /*InsnID*//* 811(*/0xAB, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 811(*/0xAB, 0x06/*)*/,
     /* 203714 */   GIR_MakeTempReg, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203718 */   GIR_BuildMI, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203723 */   GIR_AddTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203730 */   GIR_AddSimpleTempRegister, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*TempRegID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203735 */   GIR_AddImm, /*InsnID*//* 810(*/0xAA, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 810(*/0xAA, 0x06/*)*/,
     /* 203749 */   GIR_MakeTempReg, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203753 */   GIR_BuildMI, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203758 */   GIR_AddTempRegister, /*InsnID*//* 809(*/0xA9, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203768 */   GIR_MakeTempReg, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203772 */   GIR_BuildMI, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 203777 */   GIR_AddTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203784 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 808(*/0xA8, 0x06/*)*/,
     /* 203789 */   GIR_AddSimpleTempRegister, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*TempRegID*//* 809(*/0xA9, 0x06/*)*/,
     /* 203794 */   GIR_AddImm8, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Imm*/1,
     /* 203798 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203804 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 203810 */   GIR_ConstrainOperandRC, /*InsnID*//* 808(*/0xA8, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 203816 */   GIR_MakeTempReg, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203820 */   GIR_BuildMI, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 203825 */   GIR_AddTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203832 */   GIR_AddSimpleTempRegister, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*TempRegID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203837 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/32,
     /* 203841 */   GIR_AddImm8, /*InsnID*//* 807(*/0xA7, 0x06/*)*/, /*Imm*/31,
     /* 203845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 807(*/0xA7, 0x06/*)*/,
     /* 203848 */   GIR_MakeTempReg, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203852 */   GIR_BuildMI, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 203857 */   GIR_AddTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203864 */   GIR_AddSimpleTempRegister, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*TempRegID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203869 */   GIR_AddImm, /*InsnID*//* 806(*/0xA6, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 806(*/0xA6, 0x06/*)*/,
     /* 203883 */   GIR_MakeTempReg, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203887 */   GIR_BuildMI, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 203892 */   GIR_AddTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203899 */   GIR_AddSimpleTempRegister, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*TempRegID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203904 */   GIR_AddImm, /*InsnID*//* 805(*/0xA5, 0x06/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 203915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 805(*/0xA5, 0x06/*)*/,
     /* 203918 */   GIR_MakeTempReg, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203922 */   GIR_BuildMI, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 203927 */   GIR_AddTempRegister, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203934 */   GIR_AddImm, /*InsnID*//* 804(*/0xA4, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 804(*/0xA4, 0x06/*)*/,
     /* 203948 */   GIR_MakeTempReg, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 203952 */   GIR_BuildMI, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 203957 */   GIR_AddTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203964 */   GIR_AddSimpleTempRegister, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*TempRegID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203969 */   GIR_AddImm, /*InsnID*//* 803(*/0xA3, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 203980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 803(*/0xA3, 0x06/*)*/,
     /* 203983 */   GIR_MakeTempReg, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 203987 */   GIR_BuildMI, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 203992 */   GIR_AddTempRegister, /*InsnID*//* 802(*/0xA2, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 203999 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 802(*/0xA2, 0x06/*)*/,
     /* 204002 */   GIR_MakeTempReg, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204006 */   GIR_BuildMI, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204011 */   GIR_AddTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204018 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 801(*/0xA1, 0x06/*)*/,
     /* 204023 */   GIR_AddSimpleTempRegister, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*TempRegID*//* 802(*/0xA2, 0x06/*)*/,
     /* 204028 */   GIR_AddImm8, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Imm*/1,
     /* 204032 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204038 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204044 */   GIR_ConstrainOperandRC, /*InsnID*//* 801(*/0xA1, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204050 */   GIR_MakeTempReg, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204054 */   GIR_BuildMI, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204059 */   GIR_AddTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204066 */   GIR_AddSimpleTempRegister, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*TempRegID*//* 800(*/0xA0, 0x06/*)*/,
     /* 204071 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/32,
     /* 204075 */   GIR_AddImm8, /*InsnID*//* 800(*/0xA0, 0x06/*)*/, /*Imm*/31,
     /* 204079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 800(*/0xA0, 0x06/*)*/,
     /* 204082 */   GIR_MakeTempReg, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204086 */   GIR_BuildMI, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204091 */   GIR_AddTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204098 */   GIR_AddSimpleTempRegister, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*TempRegID*//* 799(*/0x9F, 0x06/*)*/,
     /* 204103 */   GIR_AddImm, /*InsnID*//* 799(*/0x9F, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 799(*/0x9F, 0x06/*)*/,
     /* 204117 */   GIR_MakeTempReg, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204121 */   GIR_BuildMI, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204126 */   GIR_AddTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204133 */   GIR_AddSimpleTempRegister, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*TempRegID*//* 798(*/0x9E, 0x06/*)*/,
     /* 204138 */   GIR_AddImm, /*InsnID*//* 798(*/0x9E, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 798(*/0x9E, 0x06/*)*/,
     /* 204152 */   GIR_MakeTempReg, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204156 */   GIR_BuildMI, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204161 */   GIR_AddTempRegister, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204168 */   GIR_Copy, /*NewInsnID*//* 797(*/0x9D, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204173 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/1,
     /* 204177 */   GIR_AddImm8, /*InsnID*//* 797(*/0x9D, 0x06/*)*/, /*Imm*/62,
     /* 204181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 797(*/0x9D, 0x06/*)*/,
     /* 204184 */   GIR_MakeTempReg, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204188 */   GIR_BuildMI, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204193 */   GIR_AddTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204200 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 796(*/0x9C, 0x06/*)*/,
     /* 204205 */   GIR_AddSimpleTempRegister, /*InsnID*//* 796(*/0x9C, 0x06/*)*/, /*TempRegID*//* 797(*/0x9D, 0x06/*)*/,
     /* 204210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 796(*/0x9C, 0x06/*)*/,
     /* 204213 */   GIR_MakeTempReg, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204217 */   GIR_BuildMI, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204222 */   GIR_AddTempRegister, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204229 */   GIR_AddImm, /*InsnID*//* 795(*/0x9B, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 795(*/0x9B, 0x06/*)*/,
     /* 204243 */   GIR_MakeTempReg, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204247 */   GIR_BuildMI, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204252 */   GIR_AddTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204259 */   GIR_AddSimpleTempRegister, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*TempRegID*//* 794(*/0x9A, 0x06/*)*/,
     /* 204264 */   GIR_AddImm, /*InsnID*//* 794(*/0x9A, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 794(*/0x9A, 0x06/*)*/,
     /* 204278 */   GIR_MakeTempReg, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204282 */   GIR_BuildMI, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204287 */   GIR_AddTempRegister, /*InsnID*//* 793(*/0x99, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 793(*/0x99, 0x06/*)*/,
     /* 204297 */   GIR_MakeTempReg, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204301 */   GIR_BuildMI, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204306 */   GIR_AddTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204313 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 792(*/0x98, 0x06/*)*/,
     /* 204318 */   GIR_AddSimpleTempRegister, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*TempRegID*//* 793(*/0x99, 0x06/*)*/,
     /* 204323 */   GIR_AddImm8, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Imm*/1,
     /* 204327 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204333 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204339 */   GIR_ConstrainOperandRC, /*InsnID*//* 792(*/0x98, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204345 */   GIR_MakeTempReg, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204349 */   GIR_BuildMI, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204354 */   GIR_AddTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204361 */   GIR_AddSimpleTempRegister, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*TempRegID*//* 791(*/0x97, 0x06/*)*/,
     /* 204366 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/32,
     /* 204370 */   GIR_AddImm8, /*InsnID*//* 791(*/0x97, 0x06/*)*/, /*Imm*/31,
     /* 204374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 791(*/0x97, 0x06/*)*/,
     /* 204377 */   GIR_MakeTempReg, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204381 */   GIR_BuildMI, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204386 */   GIR_AddTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204393 */   GIR_AddSimpleTempRegister, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*TempRegID*//* 790(*/0x96, 0x06/*)*/,
     /* 204398 */   GIR_AddImm, /*InsnID*//* 790(*/0x96, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 790(*/0x96, 0x06/*)*/,
     /* 204412 */   GIR_MakeTempReg, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204416 */   GIR_BuildMI, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204421 */   GIR_AddTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204428 */   GIR_AddSimpleTempRegister, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*TempRegID*//* 789(*/0x95, 0x06/*)*/,
     /* 204433 */   GIR_AddImm, /*InsnID*//* 789(*/0x95, 0x06/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 204444 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 789(*/0x95, 0x06/*)*/,
     /* 204447 */   GIR_MakeTempReg, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204451 */   GIR_BuildMI, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 204456 */   GIR_AddTempRegister, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204463 */   GIR_Copy, /*NewInsnID*//* 788(*/0x94, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 204468 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/63,
     /* 204472 */   GIR_AddImm8, /*InsnID*//* 788(*/0x94, 0x06/*)*/, /*Imm*/1,
     /* 204476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 788(*/0x94, 0x06/*)*/,
     /* 204479 */   GIR_MakeTempReg, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204483 */   GIR_BuildMI, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204488 */   GIR_AddTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204495 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 787(*/0x93, 0x06/*)*/,
     /* 204500 */   GIR_AddSimpleTempRegister, /*InsnID*//* 787(*/0x93, 0x06/*)*/, /*TempRegID*//* 788(*/0x94, 0x06/*)*/,
     /* 204505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 787(*/0x93, 0x06/*)*/,
     /* 204508 */   GIR_MakeTempReg, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204512 */   GIR_BuildMI, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 204517 */   GIR_AddTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204524 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 786(*/0x92, 0x06/*)*/,
     /* 204529 */   GIR_AddSimpleTempRegister, /*InsnID*//* 786(*/0x92, 0x06/*)*/, /*TempRegID*//* 795(*/0x9B, 0x06/*)*/,
     /* 204534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 786(*/0x92, 0x06/*)*/,
     /* 204537 */   GIR_MakeTempReg, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204541 */   GIR_BuildMI, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204546 */   GIR_AddTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204553 */   GIR_AddSimpleTempRegister, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*TempRegID*//* 785(*/0x91, 0x06/*)*/,
     /* 204558 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/2,
     /* 204562 */   GIR_AddImm8, /*InsnID*//* 785(*/0x91, 0x06/*)*/, /*Imm*/61,
     /* 204566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 785(*/0x91, 0x06/*)*/,
     /* 204569 */   GIR_MakeTempReg, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204573 */   GIR_BuildMI, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 204578 */   GIR_AddTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204585 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 784(*/0x90, 0x06/*)*/,
     /* 204590 */   GIR_AddSimpleTempRegister, /*InsnID*//* 784(*/0x90, 0x06/*)*/, /*TempRegID*//* 804(*/0xA4, 0x06/*)*/,
     /* 204595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 784(*/0x90, 0x06/*)*/,
     /* 204598 */   GIR_MakeTempReg, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204602 */   GIR_BuildMI, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204607 */   GIR_AddTempRegister, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204614 */   GIR_AddImm, /*InsnID*//* 783(*/0x8F, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204625 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 783(*/0x8F, 0x06/*)*/,
     /* 204628 */   GIR_MakeTempReg, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204632 */   GIR_BuildMI, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204637 */   GIR_AddTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204644 */   GIR_AddSimpleTempRegister, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*TempRegID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204649 */   GIR_AddImm, /*InsnID*//* 782(*/0x8E, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 782(*/0x8E, 0x06/*)*/,
     /* 204663 */   GIR_MakeTempReg, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204667 */   GIR_BuildMI, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204672 */   GIR_AddTempRegister, /*InsnID*//* 781(*/0x8D, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204679 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204682 */   GIR_MakeTempReg, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204686 */   GIR_BuildMI, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204691 */   GIR_AddTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204698 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 780(*/0x8C, 0x06/*)*/,
     /* 204703 */   GIR_AddSimpleTempRegister, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*TempRegID*//* 781(*/0x8D, 0x06/*)*/,
     /* 204708 */   GIR_AddImm8, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Imm*/1,
     /* 204712 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204718 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204724 */   GIR_ConstrainOperandRC, /*InsnID*//* 780(*/0x8C, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204730 */   GIR_MakeTempReg, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204734 */   GIR_BuildMI, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204739 */   GIR_AddTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204746 */   GIR_AddSimpleTempRegister, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*TempRegID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204751 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/32,
     /* 204755 */   GIR_AddImm8, /*InsnID*//* 779(*/0x8B, 0x06/*)*/, /*Imm*/31,
     /* 204759 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 779(*/0x8B, 0x06/*)*/,
     /* 204762 */   GIR_MakeTempReg, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204766 */   GIR_BuildMI, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 204771 */   GIR_AddTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204778 */   GIR_AddSimpleTempRegister, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*TempRegID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204783 */   GIR_AddImm, /*InsnID*//* 778(*/0x8A, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 778(*/0x8A, 0x06/*)*/,
     /* 204797 */   GIR_MakeTempReg, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204801 */   GIR_BuildMI, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 204806 */   GIR_AddTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204813 */   GIR_AddSimpleTempRegister, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*TempRegID*//* 777(*/0x89, 0x06/*)*/,
     /* 204818 */   GIR_AddImm, /*InsnID*//* 777(*/0x89, 0x06/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 204829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 777(*/0x89, 0x06/*)*/,
     /* 204832 */   GIR_MakeTempReg, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204836 */   GIR_BuildMI, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 204841 */   GIR_AddTempRegister, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204848 */   GIR_AddImm, /*InsnID*//* 776(*/0x88, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 776(*/0x88, 0x06/*)*/,
     /* 204862 */   GIR_MakeTempReg, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TypeID*/GILLT_s32,
     /* 204866 */   GIR_BuildMI, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 204871 */   GIR_AddTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204878 */   GIR_AddSimpleTempRegister, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*TempRegID*//* 775(*/0x87, 0x06/*)*/,
     /* 204883 */   GIR_AddImm, /*InsnID*//* 775(*/0x87, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 204894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 775(*/0x87, 0x06/*)*/,
     /* 204897 */   GIR_MakeTempReg, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204901 */   GIR_BuildMI, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 204906 */   GIR_AddTempRegister, /*InsnID*//* 774(*/0x86, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 774(*/0x86, 0x06/*)*/,
     /* 204916 */   GIR_MakeTempReg, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204920 */   GIR_BuildMI, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 204925 */   GIR_AddTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204932 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 773(*/0x85, 0x06/*)*/,
     /* 204937 */   GIR_AddSimpleTempRegister, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*TempRegID*//* 774(*/0x86, 0x06/*)*/,
     /* 204942 */   GIR_AddImm8, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Imm*/1,
     /* 204946 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204952 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 204958 */   GIR_ConstrainOperandRC, /*InsnID*//* 773(*/0x85, 0x06/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 204964 */   GIR_MakeTempReg, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 204968 */   GIR_BuildMI, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 204973 */   GIR_AddTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 204980 */   GIR_AddSimpleTempRegister, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*TempRegID*//* 772(*/0x84, 0x06/*)*/,
     /* 204985 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/32,
     /* 204989 */   GIR_AddImm8, /*InsnID*//* 772(*/0x84, 0x06/*)*/, /*Imm*/31,
     /* 204993 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 772(*/0x84, 0x06/*)*/,
     /* 204996 */   GIR_MakeTempReg, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 205000 */   GIR_BuildMI, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205005 */   GIR_AddTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205012 */   GIR_AddSimpleTempRegister, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*TempRegID*//* 771(*/0x83, 0x06/*)*/,
     /* 205017 */   GIR_AddImm, /*InsnID*//* 771(*/0x83, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 771(*/0x83, 0x06/*)*/,
     /* 205031 */   GIR_MakeTempReg, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 205035 */   GIR_BuildMI, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205040 */   GIR_AddTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205047 */   GIR_AddSimpleTempRegister, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*TempRegID*//* 770(*/0x82, 0x06/*)*/,
     /* 205052 */   GIR_AddImm, /*InsnID*//* 770(*/0x82, 0x06/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 205063 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 770(*/0x82, 0x06/*)*/,
     /* 205066 */   GIR_MakeTempReg, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TypeID*/GILLT_s64,
     /* 205070 */   GIR_BuildMI, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205075 */   GIR_AddTempRegister, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205082 */   GIR_Copy, /*NewInsnID*//* 769(*/0x81, 0x06/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 205087 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/1,
     /* 205091 */   GIR_AddImm8, /*InsnID*//* 769(*/0x81, 0x06/*)*/, /*Imm*/62,
     /* 205095 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 769(*/0x81, 0x06/*)*/,
     /* 205098 */   GIR_MakeTempReg, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205102 */   GIR_BuildMI, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205107 */   GIR_AddTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205114 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 768(*/0x80, 0x06/*)*/,
     /* 205119 */   GIR_AddSimpleTempRegister, /*InsnID*//* 768(*/0x80, 0x06/*)*/, /*TempRegID*//* 769(*/0x81, 0x06/*)*/,
     /* 205124 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 768(*/0x80, 0x06/*)*/,
     /* 205127 */   GIR_MakeTempReg, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205131 */   GIR_BuildMI, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205136 */   GIR_AddTempRegister, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205143 */   GIR_AddImm, /*InsnID*//* 767(*/0xFF, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 767(*/0xFF, 0x05/*)*/,
     /* 205157 */   GIR_MakeTempReg, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205161 */   GIR_BuildMI, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205166 */   GIR_AddTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205173 */   GIR_AddSimpleTempRegister, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*TempRegID*//* 766(*/0xFE, 0x05/*)*/,
     /* 205178 */   GIR_AddImm, /*InsnID*//* 766(*/0xFE, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 766(*/0xFE, 0x05/*)*/,
     /* 205192 */   GIR_MakeTempReg, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205196 */   GIR_BuildMI, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205201 */   GIR_AddTempRegister, /*InsnID*//* 765(*/0xFD, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205208 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 765(*/0xFD, 0x05/*)*/,
     /* 205211 */   GIR_MakeTempReg, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205215 */   GIR_BuildMI, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205220 */   GIR_AddTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205227 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 764(*/0xFC, 0x05/*)*/,
     /* 205232 */   GIR_AddSimpleTempRegister, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*TempRegID*//* 765(*/0xFD, 0x05/*)*/,
     /* 205237 */   GIR_AddImm8, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Imm*/1,
     /* 205241 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205247 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205253 */   GIR_ConstrainOperandRC, /*InsnID*//* 764(*/0xFC, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205259 */   GIR_MakeTempReg, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205263 */   GIR_BuildMI, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205268 */   GIR_AddTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205275 */   GIR_AddSimpleTempRegister, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*TempRegID*//* 763(*/0xFB, 0x05/*)*/,
     /* 205280 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/32,
     /* 205284 */   GIR_AddImm8, /*InsnID*//* 763(*/0xFB, 0x05/*)*/, /*Imm*/31,
     /* 205288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 763(*/0xFB, 0x05/*)*/,
     /* 205291 */   GIR_MakeTempReg, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205295 */   GIR_BuildMI, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205300 */   GIR_AddTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205307 */   GIR_AddSimpleTempRegister, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*TempRegID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205312 */   GIR_AddImm, /*InsnID*//* 762(*/0xFA, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 762(*/0xFA, 0x05/*)*/,
     /* 205326 */   GIR_MakeTempReg, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205330 */   GIR_BuildMI, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205335 */   GIR_AddTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205342 */   GIR_AddSimpleTempRegister, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*TempRegID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205347 */   GIR_AddImm, /*InsnID*//* 761(*/0xF9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 205358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 761(*/0xF9, 0x05/*)*/,
     /* 205361 */   GIR_MakeTempReg, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205365 */   GIR_BuildMI, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205370 */   GIR_AddTempRegister, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205377 */   GIR_Copy, /*NewInsnID*//* 760(*/0xF8, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 205382 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/63,
     /* 205386 */   GIR_AddImm8, /*InsnID*//* 760(*/0xF8, 0x05/*)*/, /*Imm*/1,
     /* 205390 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205393 */   GIR_MakeTempReg, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205397 */   GIR_BuildMI, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205402 */   GIR_AddTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205409 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205414 */   GIR_AddSimpleTempRegister, /*InsnID*//* 759(*/0xF7, 0x05/*)*/, /*TempRegID*//* 760(*/0xF8, 0x05/*)*/,
     /* 205419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 759(*/0xF7, 0x05/*)*/,
     /* 205422 */   GIR_MakeTempReg, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205426 */   GIR_BuildMI, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205431 */   GIR_AddTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205438 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205443 */   GIR_AddSimpleTempRegister, /*InsnID*//* 758(*/0xF6, 0x05/*)*/, /*TempRegID*//* 767(*/0xFF, 0x05/*)*/,
     /* 205448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 758(*/0xF6, 0x05/*)*/,
     /* 205451 */   GIR_MakeTempReg, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205455 */   GIR_BuildMI, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 205460 */   GIR_AddTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205467 */   GIR_AddSimpleTempRegister, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*TempRegID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205472 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/62,
     /* 205476 */   GIR_AddImm8, /*InsnID*//* 757(*/0xF5, 0x05/*)*/, /*Imm*/2,
     /* 205480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 757(*/0xF5, 0x05/*)*/,
     /* 205483 */   GIR_MakeTempReg, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205487 */   GIR_BuildMI, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205492 */   GIR_AddTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205499 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205504 */   GIR_AddSimpleTempRegister, /*InsnID*//* 756(*/0xF4, 0x05/*)*/, /*TempRegID*//* 776(*/0x88, 0x06/*)*/,
     /* 205509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 756(*/0xF4, 0x05/*)*/,
     /* 205512 */   GIR_MakeTempReg, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205516 */   GIR_BuildMI, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 205521 */   GIR_AddTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205528 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205533 */   GIR_AddSimpleTempRegister, /*InsnID*//* 755(*/0xF3, 0x05/*)*/, /*TempRegID*//* 783(*/0x8F, 0x06/*)*/,
     /* 205538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 755(*/0xF3, 0x05/*)*/,
     /* 205541 */   GIR_MakeTempReg, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205545 */   GIR_BuildMI, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205550 */   GIR_AddTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205557 */   GIR_AddSimpleTempRegister, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*TempRegID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205562 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/4,
     /* 205566 */   GIR_AddImm8, /*InsnID*//* 754(*/0xF2, 0x05/*)*/, /*Imm*/59,
     /* 205570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 754(*/0xF2, 0x05/*)*/,
     /* 205573 */   GIR_MakeTempReg, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205577 */   GIR_BuildMI, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 205582 */   GIR_AddTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205589 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205594 */   GIR_AddSimpleTempRegister, /*InsnID*//* 753(*/0xF1, 0x05/*)*/, /*TempRegID*//* 811(*/0xAB, 0x06/*)*/,
     /* 205599 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 753(*/0xF1, 0x05/*)*/,
     /* 205602 */   GIR_MakeTempReg, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205606 */   GIR_BuildMI, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205611 */   GIR_AddTempRegister, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205618 */   GIR_AddImm, /*InsnID*//* 752(*/0xF0, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205629 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 752(*/0xF0, 0x05/*)*/,
     /* 205632 */   GIR_MakeTempReg, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205636 */   GIR_BuildMI, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205641 */   GIR_AddTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205648 */   GIR_AddSimpleTempRegister, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*TempRegID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205653 */   GIR_AddImm, /*InsnID*//* 751(*/0xEF, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205664 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 751(*/0xEF, 0x05/*)*/,
     /* 205667 */   GIR_MakeTempReg, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205671 */   GIR_BuildMI, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205676 */   GIR_AddTempRegister, /*InsnID*//* 750(*/0xEE, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205686 */   GIR_MakeTempReg, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205690 */   GIR_BuildMI, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205695 */   GIR_AddTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205702 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 749(*/0xED, 0x05/*)*/,
     /* 205707 */   GIR_AddSimpleTempRegister, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*TempRegID*//* 750(*/0xEE, 0x05/*)*/,
     /* 205712 */   GIR_AddImm8, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Imm*/1,
     /* 205716 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205722 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205728 */   GIR_ConstrainOperandRC, /*InsnID*//* 749(*/0xED, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205734 */   GIR_MakeTempReg, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205738 */   GIR_BuildMI, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205743 */   GIR_AddTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205750 */   GIR_AddSimpleTempRegister, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*TempRegID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205755 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/32,
     /* 205759 */   GIR_AddImm8, /*InsnID*//* 748(*/0xEC, 0x05/*)*/, /*Imm*/31,
     /* 205763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 748(*/0xEC, 0x05/*)*/,
     /* 205766 */   GIR_MakeTempReg, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205770 */   GIR_BuildMI, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 205775 */   GIR_AddTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205782 */   GIR_AddSimpleTempRegister, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*TempRegID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205787 */   GIR_AddImm, /*InsnID*//* 747(*/0xEB, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 747(*/0xEB, 0x05/*)*/,
     /* 205801 */   GIR_MakeTempReg, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205805 */   GIR_BuildMI, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 205810 */   GIR_AddTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205817 */   GIR_AddSimpleTempRegister, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*TempRegID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205822 */   GIR_AddImm, /*InsnID*//* 746(*/0xEA, 0x05/*)*/, /*Imm*/GIMT_Encode8(3855),
     /* 205833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 746(*/0xEA, 0x05/*)*/,
     /* 205836 */   GIR_MakeTempReg, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205840 */   GIR_BuildMI, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 205845 */   GIR_AddTempRegister, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205852 */   GIR_AddImm, /*InsnID*//* 745(*/0xE9, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 745(*/0xE9, 0x05/*)*/,
     /* 205866 */   GIR_MakeTempReg, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 205870 */   GIR_BuildMI, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 205875 */   GIR_AddTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205882 */   GIR_AddSimpleTempRegister, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*TempRegID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205887 */   GIR_AddImm, /*InsnID*//* 744(*/0xE8, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 205898 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 744(*/0xE8, 0x05/*)*/,
     /* 205901 */   GIR_MakeTempReg, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205905 */   GIR_BuildMI, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 205910 */   GIR_AddTempRegister, /*InsnID*//* 743(*/0xE7, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205920 */   GIR_MakeTempReg, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205924 */   GIR_BuildMI, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 205929 */   GIR_AddTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205936 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 742(*/0xE6, 0x05/*)*/,
     /* 205941 */   GIR_AddSimpleTempRegister, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*TempRegID*//* 743(*/0xE7, 0x05/*)*/,
     /* 205946 */   GIR_AddImm8, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Imm*/1,
     /* 205950 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205956 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 205962 */   GIR_ConstrainOperandRC, /*InsnID*//* 742(*/0xE6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 205968 */   GIR_MakeTempReg, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 205972 */   GIR_BuildMI, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 205977 */   GIR_AddTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 205984 */   GIR_AddSimpleTempRegister, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*TempRegID*//* 741(*/0xE5, 0x05/*)*/,
     /* 205989 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/32,
     /* 205993 */   GIR_AddImm8, /*InsnID*//* 741(*/0xE5, 0x05/*)*/, /*Imm*/31,
     /* 205997 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 741(*/0xE5, 0x05/*)*/,
     /* 206000 */   GIR_MakeTempReg, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206004 */   GIR_BuildMI, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206009 */   GIR_AddTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206016 */   GIR_AddSimpleTempRegister, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*TempRegID*//* 740(*/0xE4, 0x05/*)*/,
     /* 206021 */   GIR_AddImm, /*InsnID*//* 740(*/0xE4, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 206032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 740(*/0xE4, 0x05/*)*/,
     /* 206035 */   GIR_MakeTempReg, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206039 */   GIR_BuildMI, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206044 */   GIR_AddTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206051 */   GIR_AddSimpleTempRegister, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*TempRegID*//* 739(*/0xE3, 0x05/*)*/,
     /* 206056 */   GIR_AddImm, /*InsnID*//* 739(*/0xE3, 0x05/*)*/, /*Imm*/GIMT_Encode8(52428),
     /* 206067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 739(*/0xE3, 0x05/*)*/,
     /* 206070 */   GIR_MakeTempReg, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206074 */   GIR_BuildMI, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206079 */   GIR_AddTempRegister, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206086 */   GIR_AddImm, /*InsnID*//* 738(*/0xE2, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 738(*/0xE2, 0x05/*)*/,
     /* 206100 */   GIR_MakeTempReg, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206104 */   GIR_BuildMI, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206109 */   GIR_AddTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206116 */   GIR_AddSimpleTempRegister, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*TempRegID*//* 737(*/0xE1, 0x05/*)*/,
     /* 206121 */   GIR_AddImm, /*InsnID*//* 737(*/0xE1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 737(*/0xE1, 0x05/*)*/,
     /* 206135 */   GIR_MakeTempReg, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206139 */   GIR_BuildMI, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206144 */   GIR_AddTempRegister, /*InsnID*//* 736(*/0xE0, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 736(*/0xE0, 0x05/*)*/,
     /* 206154 */   GIR_MakeTempReg, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206158 */   GIR_BuildMI, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206163 */   GIR_AddTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206170 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 735(*/0xDF, 0x05/*)*/,
     /* 206175 */   GIR_AddSimpleTempRegister, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*TempRegID*//* 736(*/0xE0, 0x05/*)*/,
     /* 206180 */   GIR_AddImm8, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Imm*/1,
     /* 206184 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206190 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206196 */   GIR_ConstrainOperandRC, /*InsnID*//* 735(*/0xDF, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206202 */   GIR_MakeTempReg, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206206 */   GIR_BuildMI, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206211 */   GIR_AddTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206218 */   GIR_AddSimpleTempRegister, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*TempRegID*//* 734(*/0xDE, 0x05/*)*/,
     /* 206223 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/32,
     /* 206227 */   GIR_AddImm8, /*InsnID*//* 734(*/0xDE, 0x05/*)*/, /*Imm*/31,
     /* 206231 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 734(*/0xDE, 0x05/*)*/,
     /* 206234 */   GIR_MakeTempReg, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206238 */   GIR_BuildMI, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206243 */   GIR_AddTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206250 */   GIR_AddSimpleTempRegister, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*TempRegID*//* 733(*/0xDD, 0x05/*)*/,
     /* 206255 */   GIR_AddImm, /*InsnID*//* 733(*/0xDD, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 733(*/0xDD, 0x05/*)*/,
     /* 206269 */   GIR_MakeTempReg, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206273 */   GIR_BuildMI, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206278 */   GIR_AddTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206285 */   GIR_AddSimpleTempRegister, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*TempRegID*//* 732(*/0xDC, 0x05/*)*/,
     /* 206290 */   GIR_AddImm, /*InsnID*//* 732(*/0xDC, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 206301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 732(*/0xDC, 0x05/*)*/,
     /* 206304 */   GIR_MakeTempReg, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206308 */   GIR_BuildMI, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206313 */   GIR_AddTempRegister, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206320 */   GIR_Copy, /*NewInsnID*//* 731(*/0xDB, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206325 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/1,
     /* 206329 */   GIR_AddImm8, /*InsnID*//* 731(*/0xDB, 0x05/*)*/, /*Imm*/62,
     /* 206333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206336 */   GIR_MakeTempReg, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206340 */   GIR_BuildMI, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206345 */   GIR_AddTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206352 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206357 */   GIR_AddSimpleTempRegister, /*InsnID*//* 730(*/0xDA, 0x05/*)*/, /*TempRegID*//* 731(*/0xDB, 0x05/*)*/,
     /* 206362 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 730(*/0xDA, 0x05/*)*/,
     /* 206365 */   GIR_MakeTempReg, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206369 */   GIR_BuildMI, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206374 */   GIR_AddTempRegister, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206381 */   GIR_AddImm, /*InsnID*//* 729(*/0xD9, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206392 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206395 */   GIR_MakeTempReg, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206399 */   GIR_BuildMI, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206404 */   GIR_AddTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206411 */   GIR_AddSimpleTempRegister, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*TempRegID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206416 */   GIR_AddImm, /*InsnID*//* 728(*/0xD8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 728(*/0xD8, 0x05/*)*/,
     /* 206430 */   GIR_MakeTempReg, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206434 */   GIR_BuildMI, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206439 */   GIR_AddTempRegister, /*InsnID*//* 727(*/0xD7, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206449 */   GIR_MakeTempReg, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206453 */   GIR_BuildMI, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206458 */   GIR_AddTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206465 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 726(*/0xD6, 0x05/*)*/,
     /* 206470 */   GIR_AddSimpleTempRegister, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*TempRegID*//* 727(*/0xD7, 0x05/*)*/,
     /* 206475 */   GIR_AddImm8, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Imm*/1,
     /* 206479 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206485 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206491 */   GIR_ConstrainOperandRC, /*InsnID*//* 726(*/0xD6, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206497 */   GIR_MakeTempReg, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206501 */   GIR_BuildMI, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206506 */   GIR_AddTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206513 */   GIR_AddSimpleTempRegister, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*TempRegID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206518 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/32,
     /* 206522 */   GIR_AddImm8, /*InsnID*//* 725(*/0xD5, 0x05/*)*/, /*Imm*/31,
     /* 206526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 725(*/0xD5, 0x05/*)*/,
     /* 206529 */   GIR_MakeTempReg, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206533 */   GIR_BuildMI, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206538 */   GIR_AddTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206545 */   GIR_AddSimpleTempRegister, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*TempRegID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206550 */   GIR_AddImm, /*InsnID*//* 724(*/0xD4, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 724(*/0xD4, 0x05/*)*/,
     /* 206564 */   GIR_MakeTempReg, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206568 */   GIR_BuildMI, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206573 */   GIR_AddTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206580 */   GIR_AddSimpleTempRegister, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*TempRegID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206585 */   GIR_AddImm, /*InsnID*//* 723(*/0xD3, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 206596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 723(*/0xD3, 0x05/*)*/,
     /* 206599 */   GIR_MakeTempReg, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206603 */   GIR_BuildMI, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 206608 */   GIR_AddTempRegister, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206615 */   GIR_Copy, /*NewInsnID*//* 722(*/0xD2, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 206620 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/63,
     /* 206624 */   GIR_AddImm8, /*InsnID*//* 722(*/0xD2, 0x05/*)*/, /*Imm*/1,
     /* 206628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206631 */   GIR_MakeTempReg, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206635 */   GIR_BuildMI, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206640 */   GIR_AddTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206647 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206652 */   GIR_AddSimpleTempRegister, /*InsnID*//* 721(*/0xD1, 0x05/*)*/, /*TempRegID*//* 722(*/0xD2, 0x05/*)*/,
     /* 206657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 721(*/0xD1, 0x05/*)*/,
     /* 206660 */   GIR_MakeTempReg, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206664 */   GIR_BuildMI, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 206669 */   GIR_AddTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206676 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206681 */   GIR_AddSimpleTempRegister, /*InsnID*//* 720(*/0xD0, 0x05/*)*/, /*TempRegID*//* 729(*/0xD9, 0x05/*)*/,
     /* 206686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 720(*/0xD0, 0x05/*)*/,
     /* 206689 */   GIR_MakeTempReg, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206693 */   GIR_BuildMI, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206698 */   GIR_AddTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206705 */   GIR_AddSimpleTempRegister, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*TempRegID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206710 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/2,
     /* 206714 */   GIR_AddImm8, /*InsnID*//* 719(*/0xCF, 0x05/*)*/, /*Imm*/61,
     /* 206718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 719(*/0xCF, 0x05/*)*/,
     /* 206721 */   GIR_MakeTempReg, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206725 */   GIR_BuildMI, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 206730 */   GIR_AddTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206737 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206742 */   GIR_AddSimpleTempRegister, /*InsnID*//* 718(*/0xCE, 0x05/*)*/, /*TempRegID*//* 738(*/0xE2, 0x05/*)*/,
     /* 206747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 718(*/0xCE, 0x05/*)*/,
     /* 206750 */   GIR_MakeTempReg, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206754 */   GIR_BuildMI, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206759 */   GIR_AddTempRegister, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206766 */   GIR_AddImm, /*InsnID*//* 717(*/0xCD, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206777 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 717(*/0xCD, 0x05/*)*/,
     /* 206780 */   GIR_MakeTempReg, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206784 */   GIR_BuildMI, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 206789 */   GIR_AddTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206796 */   GIR_AddSimpleTempRegister, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*TempRegID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206801 */   GIR_AddImm, /*InsnID*//* 716(*/0xCC, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 716(*/0xCC, 0x05/*)*/,
     /* 206815 */   GIR_MakeTempReg, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206819 */   GIR_BuildMI, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 206824 */   GIR_AddTempRegister, /*InsnID*//* 715(*/0xCB, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206834 */   GIR_MakeTempReg, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206838 */   GIR_BuildMI, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 206843 */   GIR_AddTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206850 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 714(*/0xCA, 0x05/*)*/,
     /* 206855 */   GIR_AddSimpleTempRegister, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*TempRegID*//* 715(*/0xCB, 0x05/*)*/,
     /* 206860 */   GIR_AddImm8, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Imm*/1,
     /* 206864 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206870 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 206876 */   GIR_ConstrainOperandRC, /*InsnID*//* 714(*/0xCA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 206882 */   GIR_MakeTempReg, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206886 */   GIR_BuildMI, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 206891 */   GIR_AddTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206898 */   GIR_AddSimpleTempRegister, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*TempRegID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206903 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/32,
     /* 206907 */   GIR_AddImm8, /*InsnID*//* 713(*/0xC9, 0x05/*)*/, /*Imm*/31,
     /* 206911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 713(*/0xC9, 0x05/*)*/,
     /* 206914 */   GIR_MakeTempReg, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206918 */   GIR_BuildMI, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 206923 */   GIR_AddTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206930 */   GIR_AddSimpleTempRegister, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*TempRegID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206935 */   GIR_AddImm, /*InsnID*//* 712(*/0xC8, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 712(*/0xC8, 0x05/*)*/,
     /* 206949 */   GIR_MakeTempReg, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 206953 */   GIR_BuildMI, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 206958 */   GIR_AddTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 206965 */   GIR_AddSimpleTempRegister, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*TempRegID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206970 */   GIR_AddImm, /*InsnID*//* 711(*/0xC7, 0x05/*)*/, /*Imm*/GIMT_Encode8(13107),
     /* 206981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 711(*/0xC7, 0x05/*)*/,
     /* 206984 */   GIR_MakeTempReg, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 206988 */   GIR_BuildMI, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 206993 */   GIR_AddTempRegister, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207000 */   GIR_AddImm, /*InsnID*//* 710(*/0xC6, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 710(*/0xC6, 0x05/*)*/,
     /* 207014 */   GIR_MakeTempReg, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207018 */   GIR_BuildMI, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 207023 */   GIR_AddTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207030 */   GIR_AddSimpleTempRegister, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*TempRegID*//* 709(*/0xC5, 0x05/*)*/,
     /* 207035 */   GIR_AddImm, /*InsnID*//* 709(*/0xC5, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 709(*/0xC5, 0x05/*)*/,
     /* 207049 */   GIR_MakeTempReg, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207053 */   GIR_BuildMI, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207058 */   GIR_AddTempRegister, /*InsnID*//* 708(*/0xC4, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 708(*/0xC4, 0x05/*)*/,
     /* 207068 */   GIR_MakeTempReg, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207072 */   GIR_BuildMI, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207077 */   GIR_AddTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207084 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 707(*/0xC3, 0x05/*)*/,
     /* 207089 */   GIR_AddSimpleTempRegister, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*TempRegID*//* 708(*/0xC4, 0x05/*)*/,
     /* 207094 */   GIR_AddImm8, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Imm*/1,
     /* 207098 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207104 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207110 */   GIR_ConstrainOperandRC, /*InsnID*//* 707(*/0xC3, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207116 */   GIR_MakeTempReg, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207120 */   GIR_BuildMI, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207125 */   GIR_AddTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207132 */   GIR_AddSimpleTempRegister, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*TempRegID*//* 706(*/0xC2, 0x05/*)*/,
     /* 207137 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/32,
     /* 207141 */   GIR_AddImm8, /*InsnID*//* 706(*/0xC2, 0x05/*)*/, /*Imm*/31,
     /* 207145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 706(*/0xC2, 0x05/*)*/,
     /* 207148 */   GIR_MakeTempReg, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207152 */   GIR_BuildMI, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 207157 */   GIR_AddTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207164 */   GIR_AddSimpleTempRegister, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*TempRegID*//* 705(*/0xC1, 0x05/*)*/,
     /* 207169 */   GIR_AddImm, /*InsnID*//* 705(*/0xC1, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 705(*/0xC1, 0x05/*)*/,
     /* 207183 */   GIR_MakeTempReg, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207187 */   GIR_BuildMI, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 207192 */   GIR_AddTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207199 */   GIR_AddSimpleTempRegister, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*TempRegID*//* 704(*/0xC0, 0x05/*)*/,
     /* 207204 */   GIR_AddImm, /*InsnID*//* 704(*/0xC0, 0x05/*)*/, /*Imm*/GIMT_Encode8(43690),
     /* 207215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 704(*/0xC0, 0x05/*)*/,
     /* 207218 */   GIR_MakeTempReg, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207222 */   GIR_BuildMI, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207227 */   GIR_AddTempRegister, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207234 */   GIR_Copy, /*NewInsnID*//* 703(*/0xBF, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 207239 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/1,
     /* 207243 */   GIR_AddImm8, /*InsnID*//* 703(*/0xBF, 0x05/*)*/, /*Imm*/62,
     /* 207247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 703(*/0xBF, 0x05/*)*/,
     /* 207250 */   GIR_MakeTempReg, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207254 */   GIR_BuildMI, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207259 */   GIR_AddTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207266 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 702(*/0xBE, 0x05/*)*/,
     /* 207271 */   GIR_AddSimpleTempRegister, /*InsnID*//* 702(*/0xBE, 0x05/*)*/, /*TempRegID*//* 703(*/0xBF, 0x05/*)*/,
     /* 207276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 702(*/0xBE, 0x05/*)*/,
     /* 207279 */   GIR_MakeTempReg, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207283 */   GIR_BuildMI, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::LIS),
     /* 207288 */   GIR_AddTempRegister, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207295 */   GIR_AddImm, /*InsnID*//* 701(*/0xBD, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207309 */   GIR_MakeTempReg, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207313 */   GIR_BuildMI, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI),
     /* 207318 */   GIR_AddTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207325 */   GIR_AddSimpleTempRegister, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*TempRegID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207330 */   GIR_AddImm, /*InsnID*//* 700(*/0xBC, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207341 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 700(*/0xBC, 0x05/*)*/,
     /* 207344 */   GIR_MakeTempReg, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207348 */   GIR_BuildMI, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 207353 */   GIR_AddTempRegister, /*InsnID*//* 699(*/0xBB, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207363 */   GIR_MakeTempReg, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207367 */   GIR_BuildMI, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 207372 */   GIR_AddTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207379 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 698(*/0xBA, 0x05/*)*/,
     /* 207384 */   GIR_AddSimpleTempRegister, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*TempRegID*//* 699(*/0xBB, 0x05/*)*/,
     /* 207389 */   GIR_AddImm8, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Imm*/1,
     /* 207393 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207399 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207405 */   GIR_ConstrainOperandRC, /*InsnID*//* 698(*/0xBA, 0x05/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207411 */   GIR_MakeTempReg, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207415 */   GIR_BuildMI, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 207420 */   GIR_AddTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207427 */   GIR_AddSimpleTempRegister, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*TempRegID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207432 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/32,
     /* 207436 */   GIR_AddImm8, /*InsnID*//* 697(*/0xB9, 0x05/*)*/, /*Imm*/31,
     /* 207440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 697(*/0xB9, 0x05/*)*/,
     /* 207443 */   GIR_MakeTempReg, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207447 */   GIR_BuildMI, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORIS8),
     /* 207452 */   GIR_AddTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207459 */   GIR_AddSimpleTempRegister, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*TempRegID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207464 */   GIR_AddImm, /*InsnID*//* 696(*/0xB8, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207475 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 696(*/0xB8, 0x05/*)*/,
     /* 207478 */   GIR_MakeTempReg, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207482 */   GIR_BuildMI, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::ORI8),
     /* 207487 */   GIR_AddTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207494 */   GIR_AddSimpleTempRegister, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*TempRegID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207499 */   GIR_AddImm, /*InsnID*//* 695(*/0xB7, 0x05/*)*/, /*Imm*/GIMT_Encode8(21845),
     /* 207510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 695(*/0xB7, 0x05/*)*/,
     /* 207513 */   GIR_MakeTempReg, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207517 */   GIR_BuildMI, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207522 */   GIR_AddTempRegister, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207529 */   GIR_Copy, /*NewInsnID*//* 694(*/0xB6, 0x05/*)*/, /*OldInsnID*/0, /*OpIdx*/1, // A
     /* 207534 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/63,
     /* 207538 */   GIR_AddImm8, /*InsnID*//* 694(*/0xB6, 0x05/*)*/, /*Imm*/1,
     /* 207542 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207545 */   GIR_MakeTempReg, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207549 */   GIR_BuildMI, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207554 */   GIR_AddTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207561 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207566 */   GIR_AddSimpleTempRegister, /*InsnID*//* 693(*/0xB5, 0x05/*)*/, /*TempRegID*//* 694(*/0xB6, 0x05/*)*/,
     /* 207571 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 693(*/0xB5, 0x05/*)*/,
     /* 207574 */   GIR_MakeTempReg, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207578 */   GIR_BuildMI, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207583 */   GIR_AddTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207590 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207595 */   GIR_AddSimpleTempRegister, /*InsnID*//* 692(*/0xB4, 0x05/*)*/, /*TempRegID*//* 701(*/0xBD, 0x05/*)*/,
     /* 207600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 692(*/0xB4, 0x05/*)*/,
     /* 207603 */   GIR_MakeTempReg, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207607 */   GIR_BuildMI, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207612 */   GIR_AddTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207619 */   GIR_AddSimpleTempRegister, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*TempRegID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207624 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/62,
     /* 207628 */   GIR_AddImm8, /*InsnID*//* 691(*/0xB3, 0x05/*)*/, /*Imm*/2,
     /* 207632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 691(*/0xB3, 0x05/*)*/,
     /* 207635 */   GIR_MakeTempReg, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207639 */   GIR_BuildMI, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207644 */   GIR_AddTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207651 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207656 */   GIR_AddSimpleTempRegister, /*InsnID*//* 690(*/0xB2, 0x05/*)*/, /*TempRegID*//* 710(*/0xC6, 0x05/*)*/,
     /* 207661 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 690(*/0xB2, 0x05/*)*/,
     /* 207664 */   GIR_MakeTempReg, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207668 */   GIR_BuildMI, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207673 */   GIR_AddTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207680 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207685 */   GIR_AddSimpleTempRegister, /*InsnID*//* 689(*/0xB1, 0x05/*)*/, /*TempRegID*//* 717(*/0xCD, 0x05/*)*/,
     /* 207690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 689(*/0xB1, 0x05/*)*/,
     /* 207693 */   GIR_MakeTempReg, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207697 */   GIR_BuildMI, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207702 */   GIR_AddTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207709 */   GIR_AddSimpleTempRegister, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*TempRegID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207714 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/60,
     /* 207718 */   GIR_AddImm8, /*InsnID*//* 688(*/0xB0, 0x05/*)*/, /*Imm*/4,
     /* 207722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 688(*/0xB0, 0x05/*)*/,
     /* 207725 */   GIR_MakeTempReg, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207729 */   GIR_BuildMI, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::AND8),
     /* 207734 */   GIR_AddTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207741 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207746 */   GIR_AddSimpleTempRegister, /*InsnID*//* 687(*/0xAF, 0x05/*)*/, /*TempRegID*//* 745(*/0xE9, 0x05/*)*/,
     /* 207751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 687(*/0xAF, 0x05/*)*/,
     /* 207754 */   GIR_MakeTempReg, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207758 */   GIR_BuildMI, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 207763 */   GIR_AddTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207770 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207775 */   GIR_AddSimpleTempRegister, /*InsnID*//* 686(*/0xAE, 0x05/*)*/, /*TempRegID*//* 752(*/0xF0, 0x05/*)*/,
     /* 207780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 686(*/0xAE, 0x05/*)*/,
     /* 207783 */   GIR_MakeTempReg, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TypeID*/GILLT_s64,
     /* 207787 */   GIR_BuildMI, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLDICL),
     /* 207792 */   GIR_AddTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207799 */   GIR_AddSimpleTempRegister, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*TempRegID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207804 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207808 */   GIR_AddImm8, /*InsnID*//* 685(*/0xAD, 0x05/*)*/, /*Imm*/32,
     /* 207812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 685(*/0xAD, 0x05/*)*/,
     /* 207815 */   GIR_MakeTempReg, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TypeID*/GILLT_s32,
     /* 207819 */   GIR_BuildMI, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207824 */   GIR_AddTempRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207831 */   GIR_AddTempSubRegister, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegID*//* 684(*/0xAC, 0x05/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207840 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207846 */   GIR_ConstrainOperandRC, /*InsnID*//* 684(*/0xAC, 0x05/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207852 */   GIR_MakeTempReg, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TypeID*/GILLT_s32,
     /* 207856 */   GIR_BuildMI, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207861 */   GIR_AddTempRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207868 */   GIR_AddTempSubRegister, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegID*//* 549(*/0xA5, 0x04/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207877 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207883 */   GIR_ConstrainOperandRC, /*InsnID*//* 549(*/0xA5, 0x04/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207889 */   GIR_MakeTempReg, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207893 */   GIR_BuildMI, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 207898 */   GIR_AddTempRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207905 */   GIR_AddTempSubRegister, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegID*//* 414(*/0x9E, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 207914 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 207920 */   GIR_ConstrainOperandRC, /*InsnID*//* 414(*/0x9E, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 207926 */   GIR_MakeTempReg, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207930 */   GIR_BuildMI, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 207935 */   GIR_AddTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207942 */   GIR_AddSimpleTempRegister, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*TempRegID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207947 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/24,
     /* 207951 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/0,
     /* 207955 */   GIR_AddImm8, /*InsnID*//* 413(*/0x9D, 0x03/*)*/, /*Imm*/31,
     /* 207959 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 413(*/0x9D, 0x03/*)*/,
     /* 207962 */   GIR_MakeTempReg, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 207966 */   GIR_BuildMI, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 207971 */   GIR_AddTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 207978 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 412(*/0x9C, 0x03/*)*/,
     /* 207983 */   GIR_AddSimpleTempRegister, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*TempRegID*//* 548(*/0xA4, 0x04/*)*/,
     /* 207988 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 207992 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/8,
     /* 207996 */   GIR_AddImm8, /*InsnID*//* 412(*/0x9C, 0x03/*)*/, /*Imm*/15,
     /* 208000 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 412(*/0x9C, 0x03/*)*/,
     /* 208003 */   GIR_MakeTempReg, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TypeID*/GILLT_s32,
     /* 208007 */   GIR_BuildMI, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 208012 */   GIR_AddTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208019 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 411(*/0x9B, 0x03/*)*/,
     /* 208024 */   GIR_AddSimpleTempRegister, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*TempRegID*//* 683(*/0xAB, 0x05/*)*/,
     /* 208029 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/8,
     /* 208033 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/24,
     /* 208037 */   GIR_AddImm8, /*InsnID*//* 411(*/0x9B, 0x03/*)*/, /*Imm*/31,
     /* 208041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 411(*/0x9B, 0x03/*)*/,
     /* 208044 */   GIR_MakeTempReg, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 208048 */   GIR_BuildMI, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208053 */   GIR_AddTempRegister, /*InsnID*//* 410(*/0x9A, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*//* 410(*/0x9A, 0x03/*)*/,
     /* 208063 */   GIR_MakeTempReg, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TypeID*/GILLT_s64,
     /* 208067 */   GIR_BuildMI, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 208072 */   GIR_AddTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 408(*/0x98, 0x03/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208079 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 409(*/0x99, 0x03/*)*/,
     /* 208084 */   GIR_AddSimpleTempRegister, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*TempRegID*//* 410(*/0x9A, 0x03/*)*/,
     /* 208089 */   GIR_AddImm8, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Imm*/1,
     /* 208093 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208099 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208105 */   GIR_ConstrainOperandRC, /*InsnID*//* 409(*/0x99, 0x03/*)*/, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208111 */   GIR_MakeTempReg, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TypeID*/GILLT_s32,
     /* 208115 */   GIR_BuildMI, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208120 */   GIR_AddTempRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 274(*/0x92, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208127 */   GIR_AddTempSubRegister, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*TempRegID*//* 275(*/0x93, 0x02/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 208136 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208142 */   GIR_ConstrainOperandRC, /*InsnID*//* 275(*/0x93, 0x02/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208148 */   GIR_MakeTempReg, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TypeID*/GILLT_s32,
     /* 208152 */   GIR_BuildMI, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208157 */   GIR_AddTempRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208164 */   GIR_AddTempSubRegister, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegID*//* 141(*/0x8D, 0x01/*)*/, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 208173 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208179 */   GIR_ConstrainOperandRC, /*InsnID*//* 141(*/0x8D, 0x01/*)*/, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208185 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s32,
     /* 208188 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208192 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208197 */   GIR_AddTempSubRegister, /*InsnID*/7, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(PPC::sub_32),
     /* 208204 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208209 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208214 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s32,
     /* 208217 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(PPC::RLWINM),
     /* 208221 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208226 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 208229 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/24,
     /* 208232 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/0,
     /* 208235 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/31,
     /* 208238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 208240 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 208243 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 208247 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208252 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 208255 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*//* 140(*/0x8C, 0x01/*)*/,
     /* 208259 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 208262 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/8,
     /* 208265 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/15,
     /* 208268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 208270 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 208273 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(PPC::RLWIMI),
     /* 208277 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208282 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 208285 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*//* 274(*/0x92, 0x02/*)*/,
     /* 208289 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/8,
     /* 208292 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/24,
     /* 208295 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/31,
     /* 208298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 208300 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 208303 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 208307 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 208314 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208317 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 208321 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208326 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 208329 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 208332 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 208335 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208340 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(PPC::G8RCRegClassID),
     /* 208345 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(PPC::GPRCRegClassID),
     /* 208350 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208353 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::RLDICR),
     /* 208357 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208362 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208365 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 208368 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 208371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::OR8),
     /* 208376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RA]
     /* 208378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*//* 408(*/0x98, 0x03/*)*/,
     /* 208385 */   GIR_RootConstrainSelectedInstOperands,
     /* 208386 */   // GIR_Coverage, 4891,
     /* 208386 */   GIR_EraseRootFromParent_Done,
     /* 208387 */ // Label 2770: @208387
     /* 208387 */ GIM_Reject,
     /* 208388 */ // Label 2766: @208388
     /* 208388 */ GIM_Reject,
     /* 208389 */ // Label 71: @208389
     /* 208389 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2776*/ GIMT_Encode4(208663),
     /* 208400 */ /*GILLT_s32*//*Label 2771*/ GIMT_Encode4(208420),
     /* 208404 */ /*GILLT_s64*//*Label 2772*/ GIMT_Encode4(208513),
     /* 208408 */ /*GILLT_s128*//*Label 2773*/ GIMT_Encode4(208561),
     /* 208412 */ /*GILLT_v2s64*//*Label 2774*/ GIMT_Encode4(208592),
     /* 208416 */ /*GILLT_v4s32*//*Label 2775*/ GIMT_Encode4(208615),
     /* 208420 */ // Label 2771: @208420
     /* 208420 */ GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(208512),
     /* 208425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208428 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(208492), // Rule ID 1711 //
     /* 208433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208440 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIP:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208452 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208456 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208473 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208491 */     // GIR_Coverage, 1711,
     /* 208491 */     GIR_EraseRootFromParent_Done,
     /* 208492 */   // Label 2778: @208492
     /* 208492 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(208511), // Rule ID 146 //
     /* 208497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208504 */     // (fceil:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIPS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPS),
     /* 208509 */     GIR_RootConstrainSelectedInstOperands,
     /* 208510 */     // GIR_Coverage, 146,
     /* 208510 */     GIR_Done,
     /* 208511 */   // Label 2779: @208511
     /* 208511 */   GIM_Reject,
     /* 208512 */ // Label 2777: @208512
     /* 208512 */ GIM_Reject,
     /* 208513 */ // Label 2772: @208513
     /* 208513 */ GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(208560),
     /* 208518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208521 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(208540), // Rule ID 913 //
     /* 208526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208533 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIP),
     /* 208538 */     GIR_RootConstrainSelectedInstOperands,
     /* 208539 */     // GIR_Coverage, 913,
     /* 208539 */     GIR_Done,
     /* 208540 */   // Label 2781: @208540
     /* 208540 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(208559), // Rule ID 144 //
     /* 208545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208552 */     // (fceil:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIPD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIPD),
     /* 208557 */     GIR_RootConstrainSelectedInstOperands,
     /* 208558 */     // GIR_Coverage, 144,
     /* 208558 */     GIR_Done,
     /* 208559 */   // Label 2782: @208559
     /* 208559 */   GIM_Reject,
     /* 208560 */ // Label 2780: @208560
     /* 208560 */ GIM_Reject,
     /* 208561 */ // Label 2773: @208561
     /* 208561 */ GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(208591), // Rule ID 2166 //
     /* 208566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208576 */   // (fceil:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 2:{ *:[i32] })
     /* 208576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 208579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 208581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208584 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 208586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 208589 */   GIR_RootConstrainSelectedInstOperands,
     /* 208590 */   // GIR_Coverage, 2166,
     /* 208590 */   GIR_EraseRootFromParent_Done,
     /* 208591 */ // Label 2783: @208591
     /* 208591 */ GIM_Reject,
     /* 208592 */ // Label 2774: @208592
     /* 208592 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(208614), // Rule ID 921 //
     /* 208597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208607 */   // (fceil:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIP),
     /* 208612 */   GIR_RootConstrainSelectedInstOperands,
     /* 208613 */   // GIR_Coverage, 921,
     /* 208613 */   GIR_Done,
     /* 208614 */ // Label 2784: @208614
     /* 208614 */ GIM_Reject,
     /* 208615 */ // Label 2775: @208615
     /* 208615 */ GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(208662),
     /* 208620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208623 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(208642), // Rule ID 929 //
     /* 208628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208635 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIP),
     /* 208640 */     GIR_RootConstrainSelectedInstOperands,
     /* 208641 */     // GIR_Coverage, 929,
     /* 208641 */     GIR_Done,
     /* 208642 */   // Label 2786: @208642
     /* 208642 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(208661), // Rule ID 1420 //
     /* 208647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 208650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208654 */     // (fceil:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIP:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 208654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIP),
     /* 208659 */     GIR_RootConstrainSelectedInstOperands,
     /* 208660 */     // GIR_Coverage, 1420,
     /* 208660 */     GIR_Done,
     /* 208661 */   // Label 2787: @208661
     /* 208661 */   GIM_Reject,
     /* 208662 */ // Label 2785: @208662
     /* 208662 */ GIM_Reject,
     /* 208663 */ // Label 2776: @208663
     /* 208663 */ GIM_Reject,
     /* 208664 */ // Label 72: @208664
     /* 208664 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2793*/ GIMT_Encode4(208880),
     /* 208675 */ /*GILLT_s32*//*Label 2788*/ GIMT_Encode4(208695),
     /* 208679 */ /*GILLT_s64*//*Label 2789*/ GIMT_Encode4(208747),
     /* 208683 */ /*GILLT_s128*//*Label 2790*/ GIMT_Encode4(208803),
     /* 208687 */ /*GILLT_v2s64*//*Label 2791*/ GIMT_Encode4(208826),
     /* 208691 */ /*GILLT_v4s32*//*Label 2792*/ GIMT_Encode4(208853),
     /* 208695 */ // Label 2788: @208695
     /* 208695 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(208746),
     /* 208700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208703 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(208722), // Rule ID 964 //
     /* 208708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 208711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208715 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 208715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 208720 */     GIR_RootConstrainSelectedInstOperands,
     /* 208721 */     // GIR_Coverage, 964,
     /* 208721 */     GIR_Done,
     /* 208722 */   // Label 2795: @208722
     /* 208722 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(208745), // Rule ID 162 //
     /* 208727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208734 */     // (fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208734 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 208739 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208743 */     GIR_RootConstrainSelectedInstOperands,
     /* 208744 */     // GIR_Coverage, 162,
     /* 208744 */     GIR_Done,
     /* 208745 */   // Label 2796: @208745
     /* 208745 */   GIM_Reject,
     /* 208746 */ // Label 2794: @208746
     /* 208746 */ GIM_Reject,
     /* 208747 */ // Label 2789: @208747
     /* 208747 */ GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(208802),
     /* 208752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 208755 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(208778), // Rule ID 813 //
     /* 208760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208767 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 208767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 208772 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208776 */     GIR_RootConstrainSelectedInstOperands,
     /* 208777 */     // GIR_Coverage, 813,
     /* 208777 */     GIR_Done,
     /* 208778 */   // Label 2798: @208778
     /* 208778 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(208801), // Rule ID 160 //
     /* 208783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 208790 */     // (fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 208790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 208795 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208799 */     GIR_RootConstrainSelectedInstOperands,
     /* 208800 */     // GIR_Coverage, 160,
     /* 208800 */     GIR_Done,
     /* 208801 */   // Label 2799: @208801
     /* 208801 */   GIM_Reject,
     /* 208802 */ // Label 2797: @208802
     /* 208802 */ GIM_Reject,
     /* 208803 */ // Label 2790: @208803
     /* 208803 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(208825), // Rule ID 996 //
     /* 208808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 208811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 208814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 208818 */   // (fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 208818 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 208823 */   GIR_RootConstrainSelectedInstOperands,
     /* 208824 */   // GIR_Coverage, 996,
     /* 208824 */   GIR_Done,
     /* 208825 */ // Label 2800: @208825
     /* 208825 */ GIM_Reject,
     /* 208826 */ // Label 2791: @208826
     /* 208826 */ GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(208852), // Rule ID 824 //
     /* 208831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 208837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208841 */   // (fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 208841 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 208846 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208850 */   GIR_RootConstrainSelectedInstOperands,
     /* 208851 */   // GIR_Coverage, 824,
     /* 208851 */   GIR_Done,
     /* 208852 */ // Label 2801: @208852
     /* 208852 */ GIM_Reject,
     /* 208853 */ // Label 2792: @208853
     /* 208853 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(208879), // Rule ID 826 //
     /* 208858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 208864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 208868 */   // (fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 208868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 208873 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 208877 */   GIR_RootConstrainSelectedInstOperands,
     /* 208878 */   // GIR_Coverage, 826,
     /* 208878 */   GIR_Done,
     /* 208879 */ // Label 2802: @208879
     /* 208879 */ GIM_Reject,
     /* 208880 */ // Label 2793: @208880
     /* 208880 */ GIM_Reject,
     /* 208881 */ // Label 73: @208881
     /* 208881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2808*/ GIMT_Encode4(209155),
     /* 208892 */ /*GILLT_s32*//*Label 2803*/ GIMT_Encode4(208912),
     /* 208896 */ /*GILLT_s64*//*Label 2804*/ GIMT_Encode4(209005),
     /* 208900 */ /*GILLT_s128*//*Label 2805*/ GIMT_Encode4(209053),
     /* 208904 */ /*GILLT_v2s64*//*Label 2806*/ GIMT_Encode4(209084),
     /* 208908 */ /*GILLT_v4s32*//*Label 2807*/ GIMT_Encode4(209107),
     /* 208912 */ // Label 2803: @208912
     /* 208912 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(209004),
     /* 208917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 208920 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(208984), // Rule ID 1709 //
     /* 208925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 208928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208932 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIM:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 208932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 208935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208944 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 208948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 208953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 208956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 208960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 208965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 208968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 208970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 208973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 208978 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 208983 */     // GIR_Coverage, 1709,
     /* 208983 */     GIR_EraseRootFromParent_Done,
     /* 208984 */   // Label 2810: @208984
     /* 208984 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(209003), // Rule ID 154 //
     /* 208989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 208992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 208996 */     // (ffloor:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FRIMS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 208996 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMS),
     /* 209001 */     GIR_RootConstrainSelectedInstOperands,
     /* 209002 */     // GIR_Coverage, 154,
     /* 209002 */     GIR_Done,
     /* 209003 */   // Label 2811: @209003
     /* 209003 */   GIM_Reject,
     /* 209004 */ // Label 2809: @209004
     /* 209004 */ GIM_Reject,
     /* 209005 */ // Label 2804: @209005
     /* 209005 */ GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(209052),
     /* 209010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209013 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(209032), // Rule ID 911 //
     /* 209018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209025 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSRDPIM:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 209025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIM),
     /* 209030 */     GIR_RootConstrainSelectedInstOperands,
     /* 209031 */     // GIR_Coverage, 911,
     /* 209031 */     GIR_Done,
     /* 209032 */   // Label 2813: @209032
     /* 209032 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(209051), // Rule ID 152 //
     /* 209037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209044 */     // (ffloor:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FRIMD:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 209044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FRIMD),
     /* 209049 */     GIR_RootConstrainSelectedInstOperands,
     /* 209050 */     // GIR_Coverage, 152,
     /* 209050 */     GIR_Done,
     /* 209051 */   // Label 2814: @209051
     /* 209051 */   GIM_Reject,
     /* 209052 */ // Label 2812: @209052
     /* 209052 */ GIM_Reject,
     /* 209053 */ // Label 2805: @209053
     /* 209053 */ GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(209083), // Rule ID 2168 //
     /* 209058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209068 */   // (ffloor:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 1:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 209071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 209076 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209078 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209081 */   GIR_RootConstrainSelectedInstOperands,
     /* 209082 */   // GIR_Coverage, 2168,
     /* 209082 */   GIR_EraseRootFromParent_Done,
     /* 209083 */ // Label 2815: @209083
     /* 209083 */ GIM_Reject,
     /* 209084 */ // Label 2806: @209084
     /* 209084 */ GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(209106), // Rule ID 919 //
     /* 209089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209099 */   // (ffloor:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVRDPIM:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 209099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIM),
     /* 209104 */   GIR_RootConstrainSelectedInstOperands,
     /* 209105 */   // GIR_Coverage, 919,
     /* 209105 */   GIR_Done,
     /* 209106 */ // Label 2816: @209106
     /* 209106 */ GIM_Reject,
     /* 209107 */ // Label 2807: @209107
     /* 209107 */ GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(209154),
     /* 209112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209115 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(209134), // Rule ID 927 //
     /* 209120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209127 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVRSPIM:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 209127 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIM),
     /* 209132 */     GIR_RootConstrainSelectedInstOperands,
     /* 209133 */     // GIR_Coverage, 927,
     /* 209133 */     GIR_Done,
     /* 209134 */   // Label 2818: @209134
     /* 209134 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(209153), // Rule ID 1419 //
     /* 209139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 209142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209146 */     // (ffloor:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIM:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 209146 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIM),
     /* 209151 */     GIR_RootConstrainSelectedInstOperands,
     /* 209152 */     // GIR_Coverage, 1419,
     /* 209152 */     GIR_Done,
     /* 209153 */   // Label 2819: @209153
     /* 209153 */   GIM_Reject,
     /* 209154 */ // Label 2817: @209154
     /* 209154 */ GIM_Reject,
     /* 209155 */ // Label 2808: @209155
     /* 209155 */ GIM_Reject,
     /* 209156 */ // Label 74: @209156
     /* 209156 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(209367),
     /* 209167 */ /*GILLT_s32*//*Label 2820*/ GIMT_Encode4(209187),
     /* 209171 */ /*GILLT_s64*//*Label 2821*/ GIMT_Encode4(209255),
     /* 209175 */ /*GILLT_s128*//*Label 2822*/ GIMT_Encode4(209282),
     /* 209179 */ /*GILLT_v2s64*//*Label 2823*/ GIMT_Encode4(209313),
     /* 209183 */ /*GILLT_v4s32*//*Label 2824*/ GIMT_Encode4(209340),
     /* 209187 */ // Label 2820: @209187
     /* 209187 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(209254), // Rule ID 1715 //
     /* 209192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209202 */   // (frint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 209202 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 209205 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209209 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209214 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 209218 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209223 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 209226 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209230 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209235 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 209238 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209245 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209253 */   // GIR_Coverage, 1715,
     /* 209253 */   GIR_EraseRootFromParent_Done,
     /* 209254 */ // Label 2826: @209254
     /* 209254 */ GIM_Reject,
     /* 209255 */ // Label 2821: @209255
     /* 209255 */ GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(209281), // Rule ID 1719 //
     /* 209260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209270 */   // (frint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 209270 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209275 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209279 */   GIR_RootConstrainSelectedInstOperands,
     /* 209280 */   // GIR_Coverage, 1719,
     /* 209280 */   GIR_Done,
     /* 209281 */ // Label 2827: @209281
     /* 209281 */ GIM_Reject,
     /* 209282 */ // Label 2822: @209282
     /* 209282 */ GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(209312), // Rule ID 2170 //
     /* 209287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209297 */   // (frint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPIX:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPIX),
     /* 209300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209305 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209310 */   GIR_RootConstrainSelectedInstOperands,
     /* 209311 */   // GIR_Coverage, 2170,
     /* 209311 */   GIR_EraseRootFromParent_Done,
     /* 209312 */ // Label 2828: @209312
     /* 209312 */ GIM_Reject,
     /* 209313 */ // Label 2823: @209313
     /* 209313 */ GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(209339), // Rule ID 1721 //
     /* 209318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209328 */   // (frint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209328 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209333 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209337 */   GIR_RootConstrainSelectedInstOperands,
     /* 209338 */   // GIR_Coverage, 1721,
     /* 209338 */   GIR_Done,
     /* 209339 */ // Label 2829: @209339
     /* 209339 */ GIM_Reject,
     /* 209340 */ // Label 2824: @209340
     /* 209340 */ GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(209366), // Rule ID 1717 //
     /* 209345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209355 */   // (frint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209364 */   GIR_RootConstrainSelectedInstOperands,
     /* 209365 */   // GIR_Coverage, 1717,
     /* 209365 */   GIR_Done,
     /* 209366 */ // Label 2830: @209366
     /* 209366 */ GIM_Reject,
     /* 209367 */ // Label 2825: @209367
     /* 209367 */ GIM_Reject,
     /* 209368 */ // Label 75: @209368
     /* 209368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2836*/ GIMT_Encode4(209604),
     /* 209379 */ /*GILLT_s32*//*Label 2831*/ GIMT_Encode4(209399),
     /* 209383 */ /*GILLT_s64*//*Label 2832*/ GIMT_Encode4(209467),
     /* 209387 */ /*GILLT_s128*//*Label 2833*/ GIMT_Encode4(209494),
     /* 209391 */ /*GILLT_v2s64*//*Label 2834*/ GIMT_Encode4(209525),
     /* 209395 */ /*GILLT_v4s32*//*Label 2835*/ GIMT_Encode4(209552),
     /* 209399 */ // Label 2831: @209399
     /* 209399 */ GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(209466), // Rule ID 1722 //
     /* 209404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209414 */   // (fnearbyint:{ *:[f32] } f32:{ *:[f32] }:$S)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (XSRDPIC:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f64] } ?:{ *:[f32] }:$S, VSFRC:{ *:[i32] })), VSSRC:{ *:[i32] })
     /* 209414 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 209417 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209421 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209426 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // S
     /* 209430 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 209438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 209447 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 209450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 209452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 209455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 209457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 209460 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209465 */   // GIR_Coverage, 1722,
     /* 209465 */   GIR_EraseRootFromParent_Done,
     /* 209466 */ // Label 2837: @209466
     /* 209466 */ GIM_Reject,
     /* 209467 */ // Label 2832: @209467
     /* 209467 */ GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(209493), // Rule ID 1723 //
     /* 209472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209482 */   // (fnearbyint:{ *:[f64] } f64:{ *:[f64] }:$S)  =>  (XSRDPIC:{ *:[f64] } ?:{ *:[f64] }:$S)
     /* 209482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSRDPIC),
     /* 209487 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209491 */   GIR_RootConstrainSelectedInstOperands,
     /* 209492 */   // GIR_Coverage, 1723,
     /* 209492 */   GIR_Done,
     /* 209493 */ // Label 2838: @209493
     /* 209493 */ GIM_Reject,
     /* 209494 */ // Label 2833: @209494
     /* 209494 */ GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(209524), // Rule ID 2160 //
     /* 209499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209509 */   // (fnearbyint:{ *:[f128] } f128:{ *:[f128] }:$vB)  =>  (XSRQPI:{ *:[f128] } 0:{ *:[i32] }, ?:{ *:[f128] }:$vB, 3:{ *:[i32] })
     /* 209509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSRQPI),
     /* 209512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[VRT]
     /* 209514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 209517 */   GIR_RootToRootCopy, /*OpIdx*/1, // vB
     /* 209519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 209522 */   GIR_RootConstrainSelectedInstOperands,
     /* 209523 */   // GIR_Coverage, 2160,
     /* 209523 */   GIR_EraseRootFromParent_Done,
     /* 209524 */ // Label 2839: @209524
     /* 209524 */ GIM_Reject,
     /* 209525 */ // Label 2834: @209525
     /* 209525 */ GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(209551), // Rule ID 1724 //
     /* 209530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209540 */   // (fnearbyint:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$S)  =>  (XVRDPIC:{ *:[v2f64] } ?:{ *:[v2f64] }:$S)
     /* 209540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRDPIC),
     /* 209545 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209549 */   GIR_RootConstrainSelectedInstOperands,
     /* 209550 */   // GIR_Coverage, 1724,
     /* 209550 */   GIR_Done,
     /* 209551 */ // Label 2840: @209551
     /* 209551 */ GIM_Reject,
     /* 209552 */ // Label 2835: @209552
     /* 209552 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(209603),
     /* 209557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209560 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(209583), // Rule ID 1725 //
     /* 209565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209572 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$S)  =>  (XVRSPIC:{ *:[v4f32] } ?:{ *:[v4f32] }:$S)
     /* 209572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVRSPIC),
     /* 209577 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209581 */     GIR_RootConstrainSelectedInstOperands,
     /* 209582 */     // GIR_Coverage, 1725,
     /* 209582 */     GIR_Done,
     /* 209583 */   // Label 2842: @209583
     /* 209583 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(209602), // Rule ID 1422 //
     /* 209588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAltivec),
     /* 209591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209595 */     // (fnearbyint:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$vA)  =>  (VRFIN:{ *:[v4f32] } ?:{ *:[v4f32] }:$vA)
     /* 209595 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::VRFIN),
     /* 209600 */     GIR_RootConstrainSelectedInstOperands,
     /* 209601 */     // GIR_Coverage, 1422,
     /* 209601 */     GIR_Done,
     /* 209602 */   // Label 2843: @209602
     /* 209602 */   GIM_Reject,
     /* 209603 */ // Label 2841: @209603
     /* 209603 */ GIM_Reject,
     /* 209604 */ // Label 2836: @209604
     /* 209604 */ GIM_Reject,
     /* 209605 */ // Label 76: @209605
     /* 209605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2849*/ GIMT_Encode4(209874),
     /* 209616 */ /*GILLT_s32*//*Label 2844*/ GIMT_Encode4(209636),
     /* 209620 */ /*GILLT_s64*//*Label 2845*/ GIMT_Encode4(209710),
     /* 209624 */ /*GILLT_s128*//*Label 2846*/ GIMT_Encode4(209788),
     /* 209628 */ /*GILLT_v2s64*//*Label 2847*/ GIMT_Encode4(209814),
     /* 209632 */ /*GILLT_v4s32*//*Label 2848*/ GIMT_Encode4(209844),
     /* 209636 */ // Label 2844: @209636
     /* 209636 */ GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(209709),
     /* 209641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209647 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(209666), // Rule ID 952 //
     /* 209652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209659 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSADDSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDSP),
     /* 209664 */     GIR_RootConstrainSelectedInstOperands,
     /* 209665 */     // GIR_Coverage, 952,
     /* 209665 */     GIR_Done,
     /* 209666 */   // Label 2851: @209666
     /* 209666 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(209689), // Rule ID 238 //
     /* 209671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209678 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADDS),
     /* 209683 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209687 */     GIR_RootConstrainSelectedInstOperands,
     /* 209688 */     // GIR_Coverage, 238,
     /* 209688 */     GIR_Done,
     /* 209689 */   // Label 2852: @209689
     /* 209689 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(209708), // Rule ID 582 //
     /* 209694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209701 */     // (strict_fadd:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSADD:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209701 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSADD),
     /* 209706 */     GIR_RootConstrainSelectedInstOperands,
     /* 209707 */     // GIR_Coverage, 582,
     /* 209707 */     GIR_Done,
     /* 209708 */   // Label 2853: @209708
     /* 209708 */   GIM_Reject,
     /* 209709 */ // Label 2850: @209709
     /* 209709 */ GIM_Reject,
     /* 209710 */ // Label 2845: @209710
     /* 209710 */ GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(209787),
     /* 209715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209721 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(209744), // Rule ID 769 //
     /* 209726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 209733 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSADDDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 209733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDDP),
     /* 209738 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209742 */     GIR_RootConstrainSelectedInstOperands,
     /* 209743 */     // GIR_Coverage, 769,
     /* 209743 */     GIR_Done,
     /* 209744 */   // Label 2855: @209744
     /* 209744 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(209767), // Rule ID 236 //
     /* 209749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 209756 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 209756 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FADD),
     /* 209761 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209765 */     GIR_RootConstrainSelectedInstOperands,
     /* 209766 */     // GIR_Coverage, 236,
     /* 209766 */     GIR_Done,
     /* 209767 */   // Label 2856: @209767
     /* 209767 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(209786), // Rule ID 561 //
     /* 209772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 209779 */     // (strict_fadd:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDADD:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 209779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDADD),
     /* 209784 */     GIR_RootConstrainSelectedInstOperands,
     /* 209785 */     // GIR_Coverage, 561,
     /* 209785 */     GIR_Done,
     /* 209786 */   // Label 2857: @209786
     /* 209786 */   GIM_Reject,
     /* 209787 */ // Label 2854: @209787
     /* 209787 */ GIM_Reject,
     /* 209788 */ // Label 2846: @209788
     /* 209788 */ GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(209813), // Rule ID 987 //
     /* 209793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 209796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 209799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 209802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 209806 */   // (strict_fadd:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSADDQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 209806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSADDQP),
     /* 209811 */   GIR_RootConstrainSelectedInstOperands,
     /* 209812 */   // GIR_Coverage, 987,
     /* 209812 */   GIR_Done,
     /* 209813 */ // Label 2858: @209813
     /* 209813 */ GIM_Reject,
     /* 209814 */ // Label 2847: @209814
     /* 209814 */ GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(209843), // Rule ID 773 //
     /* 209819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 209825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 209828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209832 */   // (strict_fadd:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVADDDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 209832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDDP),
     /* 209837 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209841 */   GIR_RootConstrainSelectedInstOperands,
     /* 209842 */   // GIR_Coverage, 773,
     /* 209842 */   GIR_Done,
     /* 209843 */ // Label 2859: @209843
     /* 209843 */ GIM_Reject,
     /* 209844 */ // Label 2848: @209844
     /* 209844 */ GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(209873), // Rule ID 775 //
     /* 209849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 209855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 209858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 209862 */   // (strict_fadd:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVADDSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 209862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVADDSP),
     /* 209867 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209871 */   GIR_RootConstrainSelectedInstOperands,
     /* 209872 */   // GIR_Coverage, 775,
     /* 209872 */   GIR_Done,
     /* 209873 */ // Label 2860: @209873
     /* 209873 */ GIM_Reject,
     /* 209874 */ // Label 2849: @209874
     /* 209874 */ GIM_Reject,
     /* 209875 */ // Label 77: @209875
     /* 209875 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2866*/ GIMT_Encode4(210144),
     /* 209886 */ /*GILLT_s32*//*Label 2861*/ GIMT_Encode4(209906),
     /* 209890 */ /*GILLT_s64*//*Label 2862*/ GIMT_Encode4(209980),
     /* 209894 */ /*GILLT_s128*//*Label 2863*/ GIMT_Encode4(210058),
     /* 209898 */ /*GILLT_v2s64*//*Label 2864*/ GIMT_Encode4(210084),
     /* 209902 */ /*GILLT_v4s32*//*Label 2865*/ GIMT_Encode4(210114),
     /* 209906 */ // Label 2861: @209906
     /* 209906 */ GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(209979),
     /* 209911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 209914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 209917 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(209936), // Rule ID 956 //
     /* 209922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 209925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 209929 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSSUBSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 209929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBSP),
     /* 209934 */     GIR_RootConstrainSelectedInstOperands,
     /* 209935 */     // GIR_Coverage, 956,
     /* 209935 */     GIR_Done,
     /* 209936 */   // Label 2868: @209936
     /* 209936 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(209959), // Rule ID 250 //
     /* 209941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 209944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 209948 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 209948 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUBS),
     /* 209953 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 209957 */     GIR_RootConstrainSelectedInstOperands,
     /* 209958 */     // GIR_Coverage, 250,
     /* 209958 */     GIR_Done,
     /* 209959 */   // Label 2869: @209959
     /* 209959 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(209978), // Rule ID 600 //
     /* 209964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 209967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 209971 */     // (strict_fsub:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSSUB:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 209971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSSUB),
     /* 209976 */     GIR_RootConstrainSelectedInstOperands,
     /* 209977 */     // GIR_Coverage, 600,
     /* 209977 */     GIR_Done,
     /* 209978 */   // Label 2870: @209978
     /* 209978 */   GIM_Reject,
     /* 209979 */ // Label 2867: @209979
     /* 209979 */ GIM_Reject,
     /* 209980 */ // Label 2862: @209980
     /* 209980 */ GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(210057),
     /* 209985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 209988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 209991 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(210014), // Rule ID 781 //
     /* 209996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 209999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210003 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSSUBDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBDP),
     /* 210008 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210012 */     GIR_RootConstrainSelectedInstOperands,
     /* 210013 */     // GIR_Coverage, 781,
     /* 210013 */     GIR_Done,
     /* 210014 */   // Label 2872: @210014
     /* 210014 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(210037), // Rule ID 248 //
     /* 210019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210026 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 210026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSUB),
     /* 210031 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210035 */     GIR_RootConstrainSelectedInstOperands,
     /* 210036 */     // GIR_Coverage, 248,
     /* 210036 */     GIR_Done,
     /* 210037 */   // Label 2873: @210037
     /* 210037 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(210056), // Rule ID 579 //
     /* 210042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210049 */     // (strict_fsub:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDSUB:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDSUB),
     /* 210054 */     GIR_RootConstrainSelectedInstOperands,
     /* 210055 */     // GIR_Coverage, 579,
     /* 210055 */     GIR_Done,
     /* 210056 */   // Label 2874: @210056
     /* 210056 */   GIM_Reject,
     /* 210057 */ // Label 2871: @210057
     /* 210057 */ GIM_Reject,
     /* 210058 */ // Label 2863: @210058
     /* 210058 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(210083), // Rule ID 991 //
     /* 210063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210076 */   // (strict_fsub:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSUBQP),
     /* 210081 */   GIR_RootConstrainSelectedInstOperands,
     /* 210082 */   // GIR_Coverage, 991,
     /* 210082 */   GIR_Done,
     /* 210083 */ // Label 2875: @210083
     /* 210083 */ GIM_Reject,
     /* 210084 */ // Label 2864: @210084
     /* 210084 */ GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(210113), // Rule ID 783 //
     /* 210089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210102 */   // (strict_fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVSUBDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBDP),
     /* 210107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210111 */   GIR_RootConstrainSelectedInstOperands,
     /* 210112 */   // GIR_Coverage, 783,
     /* 210112 */   GIR_Done,
     /* 210113 */ // Label 2876: @210113
     /* 210113 */ GIM_Reject,
     /* 210114 */ // Label 2865: @210114
     /* 210114 */ GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(210143), // Rule ID 785 //
     /* 210119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210132 */   // (strict_fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVSUBSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSUBSP),
     /* 210137 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210141 */   GIR_RootConstrainSelectedInstOperands,
     /* 210142 */   // GIR_Coverage, 785,
     /* 210142 */   GIR_Done,
     /* 210143 */ // Label 2877: @210143
     /* 210143 */ GIM_Reject,
     /* 210144 */ // Label 2866: @210144
     /* 210144 */ GIM_Reject,
     /* 210145 */ // Label 78: @210145
     /* 210145 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2883*/ GIMT_Encode4(210414),
     /* 210156 */ /*GILLT_s32*//*Label 2878*/ GIMT_Encode4(210176),
     /* 210160 */ /*GILLT_s64*//*Label 2879*/ GIMT_Encode4(210250),
     /* 210164 */ /*GILLT_s128*//*Label 2880*/ GIMT_Encode4(210328),
     /* 210168 */ /*GILLT_v2s64*//*Label 2881*/ GIMT_Encode4(210354),
     /* 210172 */ /*GILLT_v4s32*//*Label 2882*/ GIMT_Encode4(210384),
     /* 210176 */ // Label 2878: @210176
     /* 210176 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(210249),
     /* 210181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210187 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(210206), // Rule ID 954 //
     /* 210192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210199 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSMULSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULSP),
     /* 210204 */     GIR_RootConstrainSelectedInstOperands,
     /* 210205 */     // GIR_Coverage, 954,
     /* 210205 */     GIR_Done,
     /* 210206 */   // Label 2885: @210206
     /* 210206 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(210229), // Rule ID 246 //
     /* 210211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210218 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)  =>  (FMULS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC)
     /* 210218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMULS),
     /* 210223 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210227 */     GIR_RootConstrainSelectedInstOperands,
     /* 210228 */     // GIR_Coverage, 246,
     /* 210228 */     GIR_Done,
     /* 210229 */   // Label 2886: @210229
     /* 210229 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(210248), // Rule ID 596 //
     /* 210234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 210241 */     // (strict_fmul:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSMUL:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 210241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSMUL),
     /* 210246 */     GIR_RootConstrainSelectedInstOperands,
     /* 210247 */     // GIR_Coverage, 596,
     /* 210247 */     GIR_Done,
     /* 210248 */   // Label 2887: @210248
     /* 210248 */   GIM_Reject,
     /* 210249 */ // Label 2884: @210249
     /* 210249 */ GIM_Reject,
     /* 210250 */ // Label 2879: @210250
     /* 210250 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(210327),
     /* 210255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210261 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(210284), // Rule ID 771 //
     /* 210266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210273 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSMULDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULDP),
     /* 210278 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210282 */     GIR_RootConstrainSelectedInstOperands,
     /* 210283 */     // GIR_Coverage, 771,
     /* 210283 */     GIR_Done,
     /* 210284 */   // Label 2889: @210284
     /* 210284 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(210307), // Rule ID 244 //
     /* 210289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210296 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)  =>  (FMUL:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC)
     /* 210296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMUL),
     /* 210301 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210305 */     GIR_RootConstrainSelectedInstOperands,
     /* 210306 */     // GIR_Coverage, 244,
     /* 210306 */     GIR_Done,
     /* 210307 */   // Label 2890: @210307
     /* 210307 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(210326), // Rule ID 575 //
     /* 210312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210319 */     // (strict_fmul:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDMUL:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDMUL),
     /* 210324 */     GIR_RootConstrainSelectedInstOperands,
     /* 210325 */     // GIR_Coverage, 575,
     /* 210325 */     GIR_Done,
     /* 210326 */   // Label 2891: @210326
     /* 210326 */   GIM_Reject,
     /* 210327 */ // Label 2888: @210327
     /* 210327 */ GIM_Reject,
     /* 210328 */ // Label 2880: @210328
     /* 210328 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(210353), // Rule ID 989 //
     /* 210333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210346 */   // (strict_fmul:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSMULQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSMULQP),
     /* 210351 */   GIR_RootConstrainSelectedInstOperands,
     /* 210352 */   // GIR_Coverage, 989,
     /* 210352 */   GIR_Done,
     /* 210353 */ // Label 2892: @210353
     /* 210353 */ GIM_Reject,
     /* 210354 */ // Label 2881: @210354
     /* 210354 */ GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(210383), // Rule ID 777 //
     /* 210359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210372 */   // (strict_fmul:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVMULDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULDP),
     /* 210377 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210381 */   GIR_RootConstrainSelectedInstOperands,
     /* 210382 */   // GIR_Coverage, 777,
     /* 210382 */   GIR_Done,
     /* 210383 */ // Label 2893: @210383
     /* 210383 */ GIM_Reject,
     /* 210384 */ // Label 2882: @210384
     /* 210384 */ GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(210413), // Rule ID 779 //
     /* 210389 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210402 */   // (strict_fmul:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVMULSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVMULSP),
     /* 210407 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210411 */   GIR_RootConstrainSelectedInstOperands,
     /* 210412 */   // GIR_Coverage, 779,
     /* 210412 */   GIR_Done,
     /* 210413 */ // Label 2894: @210413
     /* 210413 */ GIM_Reject,
     /* 210414 */ // Label 2883: @210414
     /* 210414 */ GIM_Reject,
     /* 210415 */ // Label 79: @210415
     /* 210415 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2900*/ GIMT_Encode4(210684),
     /* 210426 */ /*GILLT_s32*//*Label 2895*/ GIMT_Encode4(210446),
     /* 210430 */ /*GILLT_s64*//*Label 2896*/ GIMT_Encode4(210520),
     /* 210434 */ /*GILLT_s128*//*Label 2897*/ GIMT_Encode4(210598),
     /* 210438 */ /*GILLT_v2s64*//*Label 2898*/ GIMT_Encode4(210624),
     /* 210442 */ /*GILLT_v4s32*//*Label 2899*/ GIMT_Encode4(210654),
     /* 210446 */ // Label 2895: @210446
     /* 210446 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(210519),
     /* 210451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210457 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(210476), // Rule ID 958 //
     /* 210462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210469 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)  =>  (XSDIVSP:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVSP),
     /* 210474 */     GIR_RootConstrainSelectedInstOperands,
     /* 210475 */     // GIR_Coverage, 958,
     /* 210475 */     GIR_Done,
     /* 210476 */   // Label 2902: @210476
     /* 210476 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(210499), // Rule ID 242 //
     /* 210481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210488 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)  =>  (FDIVS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRB)
     /* 210488 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIVS),
     /* 210493 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210497 */     GIR_RootConstrainSelectedInstOperands,
     /* 210498 */     // GIR_Coverage, 242,
     /* 210498 */     GIR_Done,
     /* 210499 */   // Label 2903: @210499
     /* 210499 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(210518), // Rule ID 594 //
     /* 210504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::GPRCRegClassID),
     /* 210511 */     // (strict_fdiv:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)  =>  (EFSDIV:{ *:[f32] } f32:{ *:[f32] }:$RA, f32:{ *:[f32] }:$RB)
     /* 210511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFSDIV),
     /* 210516 */     GIR_RootConstrainSelectedInstOperands,
     /* 210517 */     // GIR_Coverage, 594,
     /* 210517 */     GIR_Done,
     /* 210518 */   // Label 2904: @210518
     /* 210518 */   GIM_Reject,
     /* 210519 */ // Label 2901: @210519
     /* 210519 */ GIM_Reject,
     /* 210520 */ // Label 2896: @210520
     /* 210520 */ GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(210597),
     /* 210525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210531 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(210554), // Rule ID 810 //
     /* 210536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210543 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)  =>  (XSDIVDP:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210543 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVDP),
     /* 210548 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210552 */     GIR_RootConstrainSelectedInstOperands,
     /* 210553 */     // GIR_Coverage, 810,
     /* 210553 */     GIR_Done,
     /* 210554 */   // Label 2906: @210554
     /* 210554 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(210577), // Rule ID 240 //
     /* 210559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210566 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)  =>  (FDIV:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRB)
     /* 210566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FDIV),
     /* 210571 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210575 */     GIR_RootConstrainSelectedInstOperands,
     /* 210576 */     // GIR_Coverage, 240,
     /* 210576 */     GIR_Done,
     /* 210577 */   // Label 2907: @210577
     /* 210577 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(210596), // Rule ID 573 //
     /* 210582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSPE),
     /* 210585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::SPERCRegClassID),
     /* 210589 */     // (strict_fdiv:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)  =>  (EFDDIV:{ *:[f64] } f64:{ *:[f64] }:$RA, f64:{ *:[f64] }:$RB)
     /* 210589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::EFDDIV),
     /* 210594 */     GIR_RootConstrainSelectedInstOperands,
     /* 210595 */     // GIR_Coverage, 573,
     /* 210595 */     GIR_Done,
     /* 210596 */   // Label 2908: @210596
     /* 210596 */   GIM_Reject,
     /* 210597 */ // Label 2905: @210597
     /* 210597 */ GIM_Reject,
     /* 210598 */ // Label 2897: @210598
     /* 210598 */ GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(210623), // Rule ID 993 //
     /* 210603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 210606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 210609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 210612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 210616 */   // (strict_fdiv:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)  =>  (XSDIVQP:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 210616 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSDIVQP),
     /* 210621 */   GIR_RootConstrainSelectedInstOperands,
     /* 210622 */   // GIR_Coverage, 993,
     /* 210622 */   GIR_Done,
     /* 210623 */ // Label 2909: @210623
     /* 210623 */ GIM_Reject,
     /* 210624 */ // Label 2898: @210624
     /* 210624 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(210653), // Rule ID 819 //
     /* 210629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 210635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 210638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210642 */   // (strict_fdiv:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)  =>  (XVDIVDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 210642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVDP),
     /* 210647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210651 */   GIR_RootConstrainSelectedInstOperands,
     /* 210652 */   // GIR_Coverage, 819,
     /* 210652 */   GIR_Done,
     /* 210653 */ // Label 2910: @210653
     /* 210653 */ GIM_Reject,
     /* 210654 */ // Label 2899: @210654
     /* 210654 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(210683), // Rule ID 821 //
     /* 210659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 210665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 210668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 210672 */   // (strict_fdiv:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)  =>  (XVDIVSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 210672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVDIVSP),
     /* 210677 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210681 */   GIR_RootConstrainSelectedInstOperands,
     /* 210682 */   // GIR_Coverage, 821,
     /* 210682 */   GIR_Done,
     /* 210683 */ // Label 2911: @210683
     /* 210683 */ GIM_Reject,
     /* 210684 */ // Label 2900: @210684
     /* 210684 */ GIM_Reject,
     /* 210685 */ // Label 80: @210685
     /* 210685 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2917*/ GIMT_Encode4(211242),
     /* 210696 */ /*GILLT_s32*//*Label 2912*/ GIMT_Encode4(210716),
     /* 210700 */ /*GILLT_s64*//*Label 2913*/ GIMT_Encode4(210862),
     /* 210704 */ /*GILLT_s128*//*Label 2914*/ GIMT_Encode4(211008),
     /* 210708 */ /*GILLT_v2s64*//*Label 2915*/ GIMT_Encode4(211086),
     /* 210712 */ /*GILLT_v4s32*//*Label 2916*/ GIMT_Encode4(211164),
     /* 210716 */ // Label 2912: @210716
     /* 210716 */ GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(210861),
     /* 210721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 210724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 210727 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 210730 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(210771), // Rule ID 968 //
     /* 210735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210754 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210756 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, (fneg:{ *:[f32] } f32:{ *:[f32] }:$XTi))  =>  (XSMSUBASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBASP),
     /* 210759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210765 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210767 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210769 */     GIR_RootConstrainSelectedInstOperands,
     /* 210770 */     // GIR_Coverage, 968,
     /* 210770 */     GIR_EraseRootFromParent_Done,
     /* 210771 */   // Label 2919: @210771
     /* 210771 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(210796), // Rule ID 966 //
     /* 210776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 210779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 210783 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB, f32:{ *:[f32] }:$XTi)  =>  (XSMADDASP:{ *:[f32] } f32:{ *:[f32] }:$XTi, f32:{ *:[f32] }:$XA, f32:{ *:[f32] }:$XB)
     /* 210783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDASP),
     /* 210786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210788 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210790 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210792 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210794 */     GIR_RootConstrainSelectedInstOperands,
     /* 210795 */     // GIR_Coverage, 966,
     /* 210795 */     GIR_EraseRootFromParent_Done,
     /* 210796 */   // Label 2920: @210796
     /* 210796 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(210837), // Rule ID 224 //
     /* 210801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 210820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210822 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, (fneg:{ *:[f32] } f32:{ *:[f32] }:$FRB))  =>  (FMSUBS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUBS),
     /* 210825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210827 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210829 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210835 */     GIR_RootConstrainSelectedInstOperands,
     /* 210836 */     // GIR_Coverage, 224,
     /* 210836 */     GIR_EraseRootFromParent_Done,
     /* 210837 */   // Label 2921: @210837
     /* 210837 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(210860), // Rule ID 220 //
     /* 210842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 210849 */     // (strict_fma:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)  =>  (FMADDS:{ *:[f32] } f32:{ *:[f32] }:$FRA, f32:{ *:[f32] }:$FRC, f32:{ *:[f32] }:$FRB)
     /* 210849 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADDS),
     /* 210854 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 210858 */     GIR_RootConstrainSelectedInstOperands,
     /* 210859 */     // GIR_Coverage, 220,
     /* 210859 */     GIR_Done,
     /* 210860 */   // Label 2922: @210860
     /* 210860 */   GIM_Reject,
     /* 210861 */ // Label 2918: @210861
     /* 210861 */ GIM_Reject,
     /* 210862 */ // Label 2913: @210862
     /* 210862 */ GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(211007),
     /* 210867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 210870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 210873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 210876 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(210917), // Rule ID 789 //
     /* 210881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210902 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, (fneg:{ *:[f64] } f64:{ *:[f64] }:$XTi))  =>  (XSMSUBADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBADP),
     /* 210905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 210911 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210913 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210915 */     GIR_RootConstrainSelectedInstOperands,
     /* 210916 */     // GIR_Coverage, 789,
     /* 210916 */     GIR_EraseRootFromParent_Done,
     /* 210917 */   // Label 2924: @210917
     /* 210917 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(210942), // Rule ID 787 //
     /* 210922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 210925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 210929 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB, f64:{ *:[f64] }:$XTi)  =>  (XSMADDADP:{ *:[f64] } f64:{ *:[f64] }:$XTi, f64:{ *:[f64] }:$XA, f64:{ *:[f64] }:$XB)
     /* 210929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDADP),
     /* 210932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 210934 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 210936 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 210938 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 210940 */     GIR_RootConstrainSelectedInstOperands,
     /* 210941 */     // GIR_Coverage, 787,
     /* 210941 */     GIR_EraseRootFromParent_Done,
     /* 210942 */   // Label 2925: @210942
     /* 210942 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(210983), // Rule ID 222 //
     /* 210947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 210958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 210962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 210966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 210968 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, (fneg:{ *:[f64] } f64:{ *:[f64] }:$FRB))  =>  (FMSUB:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::FMSUB),
     /* 210971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[FRT]
     /* 210973 */     GIR_RootToRootCopy, /*OpIdx*/1, // FRA
     /* 210975 */     GIR_RootToRootCopy, /*OpIdx*/2, // FRC
     /* 210977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // FRB
     /* 210981 */     GIR_RootConstrainSelectedInstOperands,
     /* 210982 */     // GIR_Coverage, 222,
     /* 210982 */     GIR_EraseRootFromParent_Done,
     /* 210983 */   // Label 2926: @210983
     /* 210983 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(211006), // Rule ID 218 //
     /* 210988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 210991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 210995 */     // (strict_fma:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)  =>  (FMADD:{ *:[f64] } f64:{ *:[f64] }:$FRA, f64:{ *:[f64] }:$FRC, f64:{ *:[f64] }:$FRB)
     /* 210995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FMADD),
     /* 211000 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211004 */     GIR_RootConstrainSelectedInstOperands,
     /* 211005 */     // GIR_Coverage, 218,
     /* 211005 */     GIR_Done,
     /* 211006 */   // Label 2927: @211006
     /* 211006 */   GIM_Reject,
     /* 211007 */ // Label 2923: @211007
     /* 211007 */ GIM_Reject,
     /* 211008 */ // Label 2914: @211008
     /* 211008 */ GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(211085),
     /* 211013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 211016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s128,
     /* 211019 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s128,
     /* 211022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 211026 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(211063), // Rule ID 999 //
     /* 211031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 211038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 211042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s128,
     /* 211046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211048 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, (fneg:{ *:[f128] } f128:{ *:[f128] }:$RSTi))  =>  (XSMSUBQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 211048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMSUBQP),
     /* 211051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 211053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RSTi
     /* 211057 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 211059 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 211061 */     GIR_RootConstrainSelectedInstOperands,
     /* 211062 */     // GIR_Coverage, 999,
     /* 211062 */     GIR_EraseRootFromParent_Done,
     /* 211063 */   // Label 2929: @211063
     /* 211063 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(211084), // Rule ID 997 //
     /* 211068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211071 */     // (strict_fma:{ *:[f128] } f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB, f128:{ *:[f128] }:$RSTi)  =>  (XSMADDQP:{ *:[f128] } f128:{ *:[f128] }:$RSTi, f128:{ *:[f128] }:$RA, f128:{ *:[f128] }:$RB)
     /* 211071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XSMADDQP),
     /* 211074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RST]
     /* 211076 */     GIR_RootToRootCopy, /*OpIdx*/3, // RSTi
     /* 211078 */     GIR_RootToRootCopy, /*OpIdx*/1, // RA
     /* 211080 */     GIR_RootToRootCopy, /*OpIdx*/2, // RB
     /* 211082 */     GIR_RootConstrainSelectedInstOperands,
     /* 211083 */     // GIR_Coverage, 997,
     /* 211083 */     GIR_EraseRootFromParent_Done,
     /* 211084 */   // Label 2930: @211084
     /* 211084 */   GIM_Reject,
     /* 211085 */ // Label 2928: @211085
     /* 211085 */ GIM_Reject,
     /* 211086 */ // Label 2915: @211086
     /* 211086 */ GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(211163),
     /* 211091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 211097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 211100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211104 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(211141), // Rule ID 799 //
     /* 211109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 211116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 211120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211126 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, (fneg:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi))  =>  (XVMSUBADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 211126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBADP),
     /* 211129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 211135 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211137 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211139 */     GIR_RootConstrainSelectedInstOperands,
     /* 211140 */     // GIR_Coverage, 799,
     /* 211140 */     GIR_EraseRootFromParent_Done,
     /* 211141 */   // Label 2932: @211141
     /* 211141 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(211162), // Rule ID 795 //
     /* 211146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211149 */     // (strict_fma:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB, v2f64:{ *:[v2f64] }:$XTi)  =>  (XVMADDADP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XTi, v2f64:{ *:[v2f64] }:$XA, v2f64:{ *:[v2f64] }:$XB)
     /* 211149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDADP),
     /* 211152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211154 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 211156 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211158 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211160 */     GIR_RootConstrainSelectedInstOperands,
     /* 211161 */     // GIR_Coverage, 795,
     /* 211161 */     GIR_EraseRootFromParent_Done,
     /* 211162 */   // Label 2933: @211162
     /* 211162 */   GIM_Reject,
     /* 211163 */ // Label 2931: @211163
     /* 211163 */ GIM_Reject,
     /* 211164 */ // Label 2916: @211164
     /* 211164 */ GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(211241),
     /* 211169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 211175 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 211178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211182 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(211219), // Rule ID 801 //
     /* 211187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 211194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 211198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 211204 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, (fneg:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi))  =>  (XVMSUBASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 211204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMSUBASP),
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // XTi
     /* 211213 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211215 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211217 */     GIR_RootConstrainSelectedInstOperands,
     /* 211218 */     // GIR_Coverage, 801,
     /* 211218 */     GIR_EraseRootFromParent_Done,
     /* 211219 */   // Label 2935: @211219
     /* 211219 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(211240), // Rule ID 797 //
     /* 211224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211227 */     // (strict_fma:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB, v4f32:{ *:[v4f32] }:$XTi)  =>  (XVMADDASP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XTi, v4f32:{ *:[v4f32] }:$XA, v4f32:{ *:[v4f32] }:$XB)
     /* 211227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(PPC::XVMADDASP),
     /* 211230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[XT]
     /* 211232 */     GIR_RootToRootCopy, /*OpIdx*/3, // XTi
     /* 211234 */     GIR_RootToRootCopy, /*OpIdx*/1, // XA
     /* 211236 */     GIR_RootToRootCopy, /*OpIdx*/2, // XB
     /* 211238 */     GIR_RootConstrainSelectedInstOperands,
     /* 211239 */     // GIR_Coverage, 797,
     /* 211239 */     GIR_EraseRootFromParent_Done,
     /* 211240 */   // Label 2936: @211240
     /* 211240 */   GIM_Reject,
     /* 211241 */ // Label 2934: @211241
     /* 211241 */ GIM_Reject,
     /* 211242 */ // Label 2917: @211242
     /* 211242 */ GIM_Reject,
     /* 211243 */ // Label 81: @211243
     /* 211243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(6), /*)*//*default:*//*Label 2942*/ GIMT_Encode4(211459),
     /* 211254 */ /*GILLT_s32*//*Label 2937*/ GIMT_Encode4(211274),
     /* 211258 */ /*GILLT_s64*//*Label 2938*/ GIMT_Encode4(211326),
     /* 211262 */ /*GILLT_s128*//*Label 2939*/ GIMT_Encode4(211382),
     /* 211266 */ /*GILLT_v2s64*//*Label 2940*/ GIMT_Encode4(211405),
     /* 211270 */ /*GILLT_v4s32*//*Label 2941*/ GIMT_Encode4(211432),
     /* 211274 */ // Label 2937: @211274
     /* 211274 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(211325),
     /* 211279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 211282 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(211301), // Rule ID 963 //
     /* 211287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP8Vector_HasVSX),
     /* 211290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSSRCRegClassID),
     /* 211294 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$XB)  =>  (XSSQRTSP:{ *:[f32] } f32:{ *:[f32] }:$XB)
     /* 211294 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTSP),
     /* 211299 */     GIR_RootConstrainSelectedInstOperands,
     /* 211300 */     // GIR_Coverage, 963,
     /* 211300 */     GIR_Done,
     /* 211301 */   // Label 2944: @211301
     /* 211301 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(211324), // Rule ID 161 //
     /* 211306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F4RCRegClassID),
     /* 211313 */     // (strict_fsqrt:{ *:[f32] } f32:{ *:[f32] }:$RB)  =>  (FSQRTS:{ *:[f32] } f32:{ *:[f32] }:$RB)
     /* 211313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRTS),
     /* 211318 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211322 */     GIR_RootConstrainSelectedInstOperands,
     /* 211323 */     // GIR_Coverage, 161,
     /* 211323 */     GIR_Done,
     /* 211324 */   // Label 2945: @211324
     /* 211324 */   GIM_Reject,
     /* 211325 */ // Label 2943: @211325
     /* 211325 */ GIM_Reject,
     /* 211326 */ // Label 2938: @211326
     /* 211326 */ GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(211381),
     /* 211331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 211334 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(211357), // Rule ID 812 //
     /* 211339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSFRCRegClassID),
     /* 211346 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$XB)  =>  (XSSQRTDP:{ *:[f64] } f64:{ *:[f64] }:$XB)
     /* 211346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTDP),
     /* 211351 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211355 */     GIR_RootConstrainSelectedInstOperands,
     /* 211356 */     // GIR_Coverage, 812,
     /* 211356 */     GIR_Done,
     /* 211357 */   // Label 2947: @211357
     /* 211357 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(211380), // Rule ID 159 //
     /* 211362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPU),
     /* 211365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::F8RCRegClassID),
     /* 211369 */     // (strict_fsqrt:{ *:[f64] } f64:{ *:[f64] }:$RB)  =>  (FSQRT:{ *:[f64] } f64:{ *:[f64] }:$RB)
     /* 211369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::FSQRT),
     /* 211374 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211378 */     GIR_RootConstrainSelectedInstOperands,
     /* 211379 */     // GIR_Coverage, 159,
     /* 211379 */     GIR_Done,
     /* 211380 */   // Label 2948: @211380
     /* 211380 */   GIM_Reject,
     /* 211381 */ // Label 2946: @211381
     /* 211381 */ GIM_Reject,
     /* 211382 */ // Label 2939: @211382
     /* 211382 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(211404), // Rule ID 995 //
     /* 211387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasP9Vector_HasVSX),
     /* 211390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 211393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VRRCRegClassID),
     /* 211397 */   // (strict_fsqrt:{ *:[f128] } f128:{ *:[f128] }:$RB)  =>  (XSSQRTQP:{ *:[f128] } f128:{ *:[f128] }:$RB)
     /* 211397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XSSQRTQP),
     /* 211402 */   GIR_RootConstrainSelectedInstOperands,
     /* 211403 */   // GIR_Coverage, 995,
     /* 211403 */   GIR_Done,
     /* 211404 */ // Label 2949: @211404
     /* 211404 */ GIM_Reject,
     /* 211405 */ // Label 2940: @211405
     /* 211405 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(211431), // Rule ID 823 //
     /* 211410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 211416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211420 */   // (strict_fsqrt:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)  =>  (XVSQRTDP:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$XB)
     /* 211420 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTDP),
     /* 211425 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211429 */   GIR_RootConstrainSelectedInstOperands,
     /* 211430 */   // GIR_Coverage, 823,
     /* 211430 */   GIR_Done,
     /* 211431 */ // Label 2950: @211431
     /* 211431 */ GIM_Reject,
     /* 211432 */ // Label 2941: @211432
     /* 211432 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(211458), // Rule ID 825 //
     /* 211437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVSX),
     /* 211440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 211443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(PPC::VSRCRegClassID),
     /* 211447 */   // (strict_fsqrt:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)  =>  (XVSQRTSP:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$XB)
     /* 211447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::XVSQRTSP),
     /* 211452 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(PPC::RM),
     /* 211456 */   GIR_RootConstrainSelectedInstOperands,
     /* 211457 */   // GIR_Coverage, 825,
     /* 211457 */   GIR_Done,
     /* 211458 */ // Label 2951: @211458
     /* 211458 */ GIM_Reject,
     /* 211459 */ // Label 2942: @211459
     /* 211459 */ GIM_Reject,
     /* 211460 */ // Label 82: @211460
     /* 211460 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(211472), // Rule ID 72 //
     /* 211465 */   // (trap)  =>  (TRAP)
     /* 211465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(PPC::TRAP),
     /* 211470 */   GIR_RootConstrainSelectedInstOperands,
     /* 211471 */   // GIR_Coverage, 72,
     /* 211471 */   GIR_Done,
     /* 211472 */ // Label 2952: @211472
     /* 211472 */ GIM_Reject,
     /* 211473 */ // Label 83: @211473
     /* 211473 */ GIM_Reject,
     /* 211474 */ }; // Size: 211474 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const PPCSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const PPCSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
