/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    (void)numBits;
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 157, 1, // Skip to: 420
/* 7 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 10 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 22
/* 14 */      MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 18 */      MCD::OPC_Decode, 174, 6, 0, // Opcode: UNIMP, DecodeIdx: 0
/* 22 */      MCD::OPC_FilterValue, 1, 101, 0, // Skip to: 127
/* 26 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 29 */      MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 54
/* 33 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 36 */      MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 46
/* 40 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 42 */      MCD::OPC_Decode, 237, 2, 1, // Opcode: BPICCNT, DecodeIdx: 1
/* 46 */      MCD::OPC_FilterValueOrFail, 1, 
/* 48 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 50 */      MCD::OPC_Decode, 236, 2, 1, // Opcode: BPICCANT, DecodeIdx: 1
/* 54 */      MCD::OPC_FilterValue, 1, 21, 0, // Skip to: 79
/* 58 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 61 */      MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 71
/* 65 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 67 */      MCD::OPC_Decode, 234, 2, 1, // Opcode: BPICC, DecodeIdx: 1
/* 71 */      MCD::OPC_FilterValueOrFail, 1, 
/* 73 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 75 */      MCD::OPC_Decode, 235, 2, 1, // Opcode: BPICCA, DecodeIdx: 1
/* 79 */      MCD::OPC_FilterValue, 4, 21, 0, // Skip to: 104
/* 83 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 86 */      MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 96
/* 90 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 92 */      MCD::OPC_Decode, 245, 2, 1, // Opcode: BPXCCNT, DecodeIdx: 1
/* 96 */      MCD::OPC_FilterValueOrFail, 1, 
/* 98 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 100 */     MCD::OPC_Decode, 244, 2, 1, // Opcode: BPXCCANT, DecodeIdx: 1
/* 104 */     MCD::OPC_FilterValueOrFail, 5, 
/* 106 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 109 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 119
/* 113 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 115 */     MCD::OPC_Decode, 242, 2, 1, // Opcode: BPXCC, DecodeIdx: 1
/* 119 */     MCD::OPC_FilterValueOrFail, 1, 
/* 121 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 123 */     MCD::OPC_Decode, 243, 2, 1, // Opcode: BPXCCA, DecodeIdx: 1
/* 127 */     MCD::OPC_FilterValue, 2, 27, 0, // Skip to: 158
/* 131 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 134 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 152
/* 138 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, // Skip to: 148
/* 144 */     MCD::OPC_Decode, 224, 2, 2, // Opcode: BA, DecodeIdx: 2
/* 148 */     MCD::OPC_Decode, 225, 2, 3, // Opcode: BCOND, DecodeIdx: 3
/* 152 */     MCD::OPC_FilterValueOrFail, 1, 
/* 154 */     MCD::OPC_Decode, 226, 2, 3, // Opcode: BCONDA, DecodeIdx: 3
/* 158 */     MCD::OPC_FilterValue, 3, 111, 0, // Skip to: 273
/* 162 */     MCD::OPC_ExtractField, 28, 1,  // Inst{28} ...
/* 165 */     MCD::OPC_FilterValue, 0, 51, 0, // Skip to: 220
/* 169 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 172 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 197
/* 176 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 179 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 189
/* 183 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 185 */     MCD::OPC_Decode, 241, 2, 4, // Opcode: BPRNT, DecodeIdx: 4
/* 189 */     MCD::OPC_FilterValueOrFail, 1, 
/* 191 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 193 */     MCD::OPC_Decode, 240, 2, 4, // Opcode: BPRANT, DecodeIdx: 4
/* 197 */     MCD::OPC_FilterValueOrFail, 1, 
/* 199 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 202 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 212
/* 206 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 208 */     MCD::OPC_Decode, 238, 2, 4, // Opcode: BPR, DecodeIdx: 4
/* 212 */     MCD::OPC_FilterValueOrFail, 1, 
/* 214 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 216 */     MCD::OPC_Decode, 239, 2, 4, // Opcode: BPRA, DecodeIdx: 4
/* 220 */     MCD::OPC_FilterValueOrFail, 1, 
/* 222 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 225 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 250
/* 229 */     MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 232 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 242
/* 236 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 238 */     MCD::OPC_Decode, 135, 3, 5, // Opcode: CWBCONDrr, DecodeIdx: 5
/* 242 */     MCD::OPC_FilterValueOrFail, 1, 
/* 244 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 246 */     MCD::OPC_Decode, 137, 3, 5, // Opcode: CXBCONDrr, DecodeIdx: 5
/* 250 */     MCD::OPC_FilterValueOrFail, 1, 
/* 252 */     MCD::OPC_ExtractField, 21, 1,  // Inst{21} ...
/* 255 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 265
/* 259 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 261 */     MCD::OPC_Decode, 134, 3, 6, // Opcode: CWBCONDri, DecodeIdx: 6
/* 265 */     MCD::OPC_FilterValueOrFail, 1, 
/* 267 */     MCD::OPC_CheckPredicateOrFail, 1, 
/* 269 */     MCD::OPC_Decode, 136, 3, 6, // Opcode: CXBCONDri, DecodeIdx: 6
/* 273 */     MCD::OPC_FilterValue, 4, 20, 0, // Skip to: 297
/* 277 */     MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 293
/* 283 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, // Skip to: 293
/* 289 */     MCD::OPC_Decode, 142, 5, 7, // Opcode: NOP, DecodeIdx: 7
/* 293 */     MCD::OPC_Decode, 185, 5, 8, // Opcode: SETHIi, DecodeIdx: 8
/* 297 */     MCD::OPC_FilterValue, 5, 79, 0, // Skip to: 380
/* 301 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 304 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 329
/* 308 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 311 */     MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 321
/* 315 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 317 */     MCD::OPC_Decode, 233, 2, 9, // Opcode: BPFCCNT, DecodeIdx: 9
/* 321 */     MCD::OPC_FilterValueOrFail, 1, 
/* 323 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 325 */     MCD::OPC_Decode, 232, 2, 9, // Opcode: BPFCCANT, DecodeIdx: 9
/* 329 */     MCD::OPC_FilterValueOrFail, 1, 
/* 331 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 334 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 358
/* 338 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 352
/* 342 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 352
/* 348 */     MCD::OPC_Decode, 167, 3, 1, // Opcode: FBCOND_V9, DecodeIdx: 1
/* 352 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 354 */     MCD::OPC_Decode, 230, 2, 9, // Opcode: BPFCC, DecodeIdx: 9
/* 358 */     MCD::OPC_FilterValueOrFail, 1, 
/* 360 */     MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 374
/* 364 */     MCD::OPC_CheckField, 20, 2, 0, 4, 0, // Skip to: 374
/* 370 */     MCD::OPC_Decode, 166, 3, 1, // Opcode: FBCONDA_V9, DecodeIdx: 1
/* 374 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 376 */     MCD::OPC_Decode, 231, 2, 9, // Opcode: BPFCCA, DecodeIdx: 9
/* 380 */     MCD::OPC_FilterValue, 6, 17, 0, // Skip to: 401
/* 384 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 387 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 395
/* 391 */     MCD::OPC_Decode, 164, 3, 3, // Opcode: FBCOND, DecodeIdx: 3
/* 395 */     MCD::OPC_FilterValueOrFail, 1, 
/* 397 */     MCD::OPC_Decode, 165, 3, 3, // Opcode: FBCONDA, DecodeIdx: 3
/* 401 */     MCD::OPC_FilterValueOrFail, 7, 
/* 403 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 406 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 414
/* 410 */     MCD::OPC_Decode, 132, 3, 3, // Opcode: CPBCOND, DecodeIdx: 3
/* 414 */     MCD::OPC_FilterValueOrFail, 1, 
/* 416 */     MCD::OPC_Decode, 133, 3, 3, // Opcode: CPBCONDA, DecodeIdx: 3
/* 420 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 428
/* 424 */     MCD::OPC_Decode, 247, 2, 10, // Opcode: CALL, DecodeIdx: 10
/* 428 */     MCD::OPC_FilterValue, 2, 202, 16, // Skip to: 4730
/* 432 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 435 */     MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 460
/* 439 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 442 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 454
/* 446 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 450 */     MCD::OPC_Decode, 209, 2, 11, // Opcode: ADDrr, DecodeIdx: 11
/* 454 */     MCD::OPC_FilterValueOrFail, 1, 
/* 456 */     MCD::OPC_Decode, 208, 2, 12, // Opcode: ADDri, DecodeIdx: 12
/* 460 */     MCD::OPC_FilterValue, 1, 21, 0, // Skip to: 485
/* 464 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 467 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 479
/* 471 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 475 */     MCD::OPC_Decode, 220, 2, 11, // Opcode: ANDrr, DecodeIdx: 11
/* 479 */     MCD::OPC_FilterValueOrFail, 1, 
/* 481 */     MCD::OPC_Decode, 219, 2, 12, // Opcode: ANDri, DecodeIdx: 12
/* 485 */     MCD::OPC_FilterValue, 2, 21, 0, // Skip to: 510
/* 489 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 492 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 504
/* 496 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 500 */     MCD::OPC_Decode, 151, 5, 11, // Opcode: ORrr, DecodeIdx: 11
/* 504 */     MCD::OPC_FilterValueOrFail, 1, 
/* 506 */     MCD::OPC_Decode, 150, 5, 12, // Opcode: ORri, DecodeIdx: 12
/* 510 */     MCD::OPC_FilterValue, 3, 21, 0, // Skip to: 535
/* 514 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 517 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 529
/* 521 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 525 */     MCD::OPC_Decode, 205, 6, 11, // Opcode: XORrr, DecodeIdx: 11
/* 529 */     MCD::OPC_FilterValueOrFail, 1, 
/* 531 */     MCD::OPC_Decode, 204, 6, 12, // Opcode: XORri, DecodeIdx: 12
/* 535 */     MCD::OPC_FilterValue, 4, 21, 0, // Skip to: 560
/* 539 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 542 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 554
/* 546 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 550 */     MCD::OPC_Decode, 133, 6, 11, // Opcode: SUBrr, DecodeIdx: 11
/* 554 */     MCD::OPC_FilterValueOrFail, 1, 
/* 556 */     MCD::OPC_Decode, 132, 6, 12, // Opcode: SUBri, DecodeIdx: 12
/* 560 */     MCD::OPC_FilterValue, 5, 21, 0, // Skip to: 585
/* 564 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 567 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 579
/* 571 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 575 */     MCD::OPC_Decode, 218, 2, 11, // Opcode: ANDNrr, DecodeIdx: 11
/* 579 */     MCD::OPC_FilterValueOrFail, 1, 
/* 581 */     MCD::OPC_Decode, 217, 2, 12, // Opcode: ANDNri, DecodeIdx: 12
/* 585 */     MCD::OPC_FilterValue, 6, 21, 0, // Skip to: 610
/* 589 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 592 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 604
/* 596 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 600 */     MCD::OPC_Decode, 149, 5, 11, // Opcode: ORNrr, DecodeIdx: 11
/* 604 */     MCD::OPC_FilterValueOrFail, 1, 
/* 606 */     MCD::OPC_Decode, 148, 5, 12, // Opcode: ORNri, DecodeIdx: 12
/* 610 */     MCD::OPC_FilterValue, 7, 21, 0, // Skip to: 635
/* 614 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 617 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 629
/* 621 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 625 */     MCD::OPC_Decode, 201, 6, 11, // Opcode: XNORrr, DecodeIdx: 11
/* 629 */     MCD::OPC_FilterValueOrFail, 1, 
/* 631 */     MCD::OPC_Decode, 200, 6, 12, // Opcode: XNORri, DecodeIdx: 12
/* 635 */     MCD::OPC_FilterValue, 8, 21, 0, // Skip to: 660
/* 639 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 642 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 654
/* 646 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 650 */     MCD::OPC_Decode, 203, 2, 11, // Opcode: ADDCrr, DecodeIdx: 11
/* 654 */     MCD::OPC_FilterValueOrFail, 1, 
/* 656 */     MCD::OPC_Decode, 202, 2, 12, // Opcode: ADDCri, DecodeIdx: 12
/* 660 */     MCD::OPC_FilterValue, 9, 25, 0, // Skip to: 689
/* 664 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 667 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 681
/* 671 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 673 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 677 */     MCD::OPC_Decode, 141, 5, 13, // Opcode: MULXrr, DecodeIdx: 13
/* 681 */     MCD::OPC_FilterValueOrFail, 1, 
/* 683 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 685 */     MCD::OPC_Decode, 140, 5, 14, // Opcode: MULXri, DecodeIdx: 14
/* 689 */     MCD::OPC_FilterValue, 10, 21, 0, // Skip to: 714
/* 693 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 696 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 708
/* 700 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 704 */     MCD::OPC_Decode, 173, 6, 11, // Opcode: UMULrr, DecodeIdx: 11
/* 708 */     MCD::OPC_FilterValueOrFail, 1, 
/* 710 */     MCD::OPC_Decode, 172, 6, 12, // Opcode: UMULri, DecodeIdx: 12
/* 714 */     MCD::OPC_FilterValue, 11, 21, 0, // Skip to: 739
/* 718 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 721 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 733
/* 725 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 729 */     MCD::OPC_Decode, 198, 5, 11, // Opcode: SMULrr, DecodeIdx: 11
/* 733 */     MCD::OPC_FilterValueOrFail, 1, 
/* 735 */     MCD::OPC_Decode, 197, 5, 12, // Opcode: SMULri, DecodeIdx: 12
/* 739 */     MCD::OPC_FilterValue, 12, 21, 0, // Skip to: 764
/* 743 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 746 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 758
/* 750 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 754 */     MCD::OPC_Decode, 129, 6, 11, // Opcode: SUBCrr, DecodeIdx: 11
/* 758 */     MCD::OPC_FilterValueOrFail, 1, 
/* 760 */     MCD::OPC_Decode, 128, 6, 12, // Opcode: SUBCri, DecodeIdx: 12
/* 764 */     MCD::OPC_FilterValue, 13, 25, 0, // Skip to: 793
/* 768 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 771 */     MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 785
/* 775 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 777 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 781 */     MCD::OPC_Decode, 164, 6, 13, // Opcode: UDIVXrr, DecodeIdx: 13
/* 785 */     MCD::OPC_FilterValueOrFail, 1, 
/* 787 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 789 */     MCD::OPC_Decode, 163, 6, 14, // Opcode: UDIVXri, DecodeIdx: 14
/* 793 */     MCD::OPC_FilterValue, 14, 21, 0, // Skip to: 818
/* 797 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 800 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 812
/* 804 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 808 */     MCD::OPC_Decode, 166, 6, 11, // Opcode: UDIVrr, DecodeIdx: 11
/* 812 */     MCD::OPC_FilterValueOrFail, 1, 
/* 814 */     MCD::OPC_Decode, 165, 6, 12, // Opcode: UDIVri, DecodeIdx: 12
/* 818 */     MCD::OPC_FilterValue, 15, 21, 0, // Skip to: 843
/* 822 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 825 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 837
/* 829 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 833 */     MCD::OPC_Decode, 184, 5, 11, // Opcode: SDIVrr, DecodeIdx: 11
/* 837 */     MCD::OPC_FilterValueOrFail, 1, 
/* 839 */     MCD::OPC_Decode, 183, 5, 12, // Opcode: SDIVri, DecodeIdx: 12
/* 843 */     MCD::OPC_FilterValue, 16, 21, 0, // Skip to: 868
/* 847 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 850 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 862
/* 854 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 858 */     MCD::OPC_Decode, 201, 2, 11, // Opcode: ADDCCrr, DecodeIdx: 11
/* 862 */     MCD::OPC_FilterValueOrFail, 1, 
/* 864 */     MCD::OPC_Decode, 200, 2, 12, // Opcode: ADDCCri, DecodeIdx: 12
/* 868 */     MCD::OPC_FilterValue, 17, 21, 0, // Skip to: 893
/* 872 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 875 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 887
/* 879 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 883 */     MCD::OPC_Decode, 214, 2, 11, // Opcode: ANDCCrr, DecodeIdx: 11
/* 887 */     MCD::OPC_FilterValueOrFail, 1, 
/* 889 */     MCD::OPC_Decode, 213, 2, 12, // Opcode: ANDCCri, DecodeIdx: 12
/* 893 */     MCD::OPC_FilterValue, 18, 21, 0, // Skip to: 918
/* 897 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 900 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 912
/* 904 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 908 */     MCD::OPC_Decode, 145, 5, 11, // Opcode: ORCCrr, DecodeIdx: 11
/* 912 */     MCD::OPC_FilterValueOrFail, 1, 
/* 914 */     MCD::OPC_Decode, 144, 5, 12, // Opcode: ORCCri, DecodeIdx: 12
/* 918 */     MCD::OPC_FilterValue, 19, 21, 0, // Skip to: 943
/* 922 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 925 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 937
/* 929 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 933 */     MCD::OPC_Decode, 203, 6, 11, // Opcode: XORCCrr, DecodeIdx: 11
/* 937 */     MCD::OPC_FilterValueOrFail, 1, 
/* 939 */     MCD::OPC_Decode, 202, 6, 12, // Opcode: XORCCri, DecodeIdx: 12
/* 943 */     MCD::OPC_FilterValue, 20, 21, 0, // Skip to: 968
/* 947 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 950 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 962
/* 954 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 958 */     MCD::OPC_Decode, 255, 5, 11, // Opcode: SUBCCrr, DecodeIdx: 11
/* 962 */     MCD::OPC_FilterValueOrFail, 1, 
/* 964 */     MCD::OPC_Decode, 254, 5, 12, // Opcode: SUBCCri, DecodeIdx: 12
/* 968 */     MCD::OPC_FilterValue, 21, 21, 0, // Skip to: 993
/* 972 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 975 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 987
/* 979 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 983 */     MCD::OPC_Decode, 216, 2, 11, // Opcode: ANDNCCrr, DecodeIdx: 11
/* 987 */     MCD::OPC_FilterValueOrFail, 1, 
/* 989 */     MCD::OPC_Decode, 215, 2, 12, // Opcode: ANDNCCri, DecodeIdx: 12
/* 993 */     MCD::OPC_FilterValue, 22, 21, 0, // Skip to: 1018
/* 997 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1000 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1012
/* 1004 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1008 */    MCD::OPC_Decode, 147, 5, 11, // Opcode: ORNCCrr, DecodeIdx: 11
/* 1012 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1014 */    MCD::OPC_Decode, 146, 5, 12, // Opcode: ORNCCri, DecodeIdx: 12
/* 1018 */    MCD::OPC_FilterValue, 23, 21, 0, // Skip to: 1043
/* 1022 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1025 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1037
/* 1029 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1033 */    MCD::OPC_Decode, 199, 6, 11, // Opcode: XNORCCrr, DecodeIdx: 11
/* 1037 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1039 */    MCD::OPC_Decode, 198, 6, 12, // Opcode: XNORCCri, DecodeIdx: 12
/* 1043 */    MCD::OPC_FilterValue, 24, 21, 0, // Skip to: 1068
/* 1047 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1050 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1062
/* 1054 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1058 */    MCD::OPC_Decode, 205, 2, 11, // Opcode: ADDErr, DecodeIdx: 11
/* 1062 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1064 */    MCD::OPC_Decode, 204, 2, 12, // Opcode: ADDEri, DecodeIdx: 12
/* 1068 */    MCD::OPC_FilterValue, 26, 21, 0, // Skip to: 1093
/* 1072 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1075 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1087
/* 1079 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1083 */    MCD::OPC_Decode, 170, 6, 11, // Opcode: UMULCCrr, DecodeIdx: 11
/* 1087 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1089 */    MCD::OPC_Decode, 169, 6, 12, // Opcode: UMULCCri, DecodeIdx: 12
/* 1093 */    MCD::OPC_FilterValue, 27, 21, 0, // Skip to: 1118
/* 1097 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1100 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1112
/* 1104 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1108 */    MCD::OPC_Decode, 196, 5, 11, // Opcode: SMULCCrr, DecodeIdx: 11
/* 1112 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1114 */    MCD::OPC_Decode, 195, 5, 12, // Opcode: SMULCCri, DecodeIdx: 12
/* 1118 */    MCD::OPC_FilterValue, 28, 21, 0, // Skip to: 1143
/* 1122 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1125 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1137
/* 1129 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1133 */    MCD::OPC_Decode, 131, 6, 11, // Opcode: SUBErr, DecodeIdx: 11
/* 1137 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1139 */    MCD::OPC_Decode, 130, 6, 12, // Opcode: SUBEri, DecodeIdx: 12
/* 1143 */    MCD::OPC_FilterValue, 30, 21, 0, // Skip to: 1168
/* 1147 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1150 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1162
/* 1154 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1158 */    MCD::OPC_Decode, 162, 6, 11, // Opcode: UDIVCCrr, DecodeIdx: 11
/* 1162 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1164 */    MCD::OPC_Decode, 161, 6, 12, // Opcode: UDIVCCri, DecodeIdx: 12
/* 1168 */    MCD::OPC_FilterValue, 31, 21, 0, // Skip to: 1193
/* 1172 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1175 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1187
/* 1179 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1183 */    MCD::OPC_Decode, 180, 5, 11, // Opcode: SDIVCCrr, DecodeIdx: 11
/* 1187 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1189 */    MCD::OPC_Decode, 179, 5, 12, // Opcode: SDIVCCri, DecodeIdx: 12
/* 1193 */    MCD::OPC_FilterValue, 32, 21, 0, // Skip to: 1218
/* 1197 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1200 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1212
/* 1204 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1208 */    MCD::OPC_Decode, 144, 6, 11, // Opcode: TADDCCrr, DecodeIdx: 11
/* 1212 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1214 */    MCD::OPC_Decode, 143, 6, 12, // Opcode: TADDCCri, DecodeIdx: 12
/* 1218 */    MCD::OPC_FilterValue, 33, 21, 0, // Skip to: 1243
/* 1222 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1225 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1237
/* 1229 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1233 */    MCD::OPC_Decode, 158, 6, 11, // Opcode: TSUBCCrr, DecodeIdx: 11
/* 1237 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1239 */    MCD::OPC_Decode, 157, 6, 12, // Opcode: TSUBCCri, DecodeIdx: 12
/* 1243 */    MCD::OPC_FilterValue, 34, 21, 0, // Skip to: 1268
/* 1247 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1250 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1262
/* 1254 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1258 */    MCD::OPC_Decode, 142, 6, 11, // Opcode: TADDCCTVrr, DecodeIdx: 11
/* 1262 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1264 */    MCD::OPC_Decode, 141, 6, 12, // Opcode: TADDCCTVri, DecodeIdx: 12
/* 1268 */    MCD::OPC_FilterValue, 35, 21, 0, // Skip to: 1293
/* 1272 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1275 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1287
/* 1279 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1283 */    MCD::OPC_Decode, 156, 6, 11, // Opcode: TSUBCCTVrr, DecodeIdx: 11
/* 1287 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1289 */    MCD::OPC_Decode, 155, 6, 12, // Opcode: TSUBCCTVri, DecodeIdx: 12
/* 1293 */    MCD::OPC_FilterValue, 36, 21, 0, // Skip to: 1318
/* 1297 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1300 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1312
/* 1304 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1308 */    MCD::OPC_Decode, 139, 5, 11, // Opcode: MULSCCrr, DecodeIdx: 11
/* 1312 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1314 */    MCD::OPC_Decode, 138, 5, 12, // Opcode: MULSCCri, DecodeIdx: 12
/* 1318 */    MCD::OPC_FilterValue, 37, 37, 0, // Skip to: 1359
/* 1322 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1325 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1333
/* 1329 */    MCD::OPC_Decode, 192, 5, 11, // Opcode: SLLrr, DecodeIdx: 11
/* 1333 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 1343
/* 1337 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1339 */    MCD::OPC_Decode, 190, 5, 15, // Opcode: SLLXrr, DecodeIdx: 15
/* 1343 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1351
/* 1347 */    MCD::OPC_Decode, 191, 5, 16, // Opcode: SLLri, DecodeIdx: 16
/* 1351 */    MCD::OPC_FilterValueOrFail, 3, 
/* 1353 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1355 */    MCD::OPC_Decode, 189, 5, 17, // Opcode: SLLXri, DecodeIdx: 17
/* 1359 */    MCD::OPC_FilterValue, 38, 37, 0, // Skip to: 1400
/* 1363 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1366 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1374
/* 1370 */    MCD::OPC_Decode, 206, 5, 11, // Opcode: SRLrr, DecodeIdx: 11
/* 1374 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 1384
/* 1378 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1380 */    MCD::OPC_Decode, 204, 5, 15, // Opcode: SRLXrr, DecodeIdx: 15
/* 1384 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1392
/* 1388 */    MCD::OPC_Decode, 205, 5, 16, // Opcode: SRLri, DecodeIdx: 16
/* 1392 */    MCD::OPC_FilterValueOrFail, 3, 
/* 1394 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1396 */    MCD::OPC_Decode, 203, 5, 17, // Opcode: SRLXri, DecodeIdx: 17
/* 1400 */    MCD::OPC_FilterValue, 39, 37, 0, // Skip to: 1441
/* 1404 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1407 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1415
/* 1411 */    MCD::OPC_Decode, 202, 5, 11, // Opcode: SRArr, DecodeIdx: 11
/* 1415 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 1425
/* 1419 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1421 */    MCD::OPC_Decode, 200, 5, 15, // Opcode: SRAXrr, DecodeIdx: 15
/* 1425 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1433
/* 1429 */    MCD::OPC_Decode, 201, 5, 16, // Opcode: SRAri, DecodeIdx: 16
/* 1433 */    MCD::OPC_FilterValueOrFail, 3, 
/* 1435 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1437 */    MCD::OPC_Decode, 199, 5, 17, // Opcode: SRAXri, DecodeIdx: 17
/* 1441 */    MCD::OPC_FilterValue, 40, 48, 0, // Skip to: 1493
/* 1445 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1448 */    MCD::OPC_FilterValue, 0, 25, 0, // Skip to: 1477
/* 1452 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 1455 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1457 */    MCD::OPC_CheckField, 25, 5, 0, 10, 0, // Skip to: 1473
/* 1463 */    MCD::OPC_CheckField, 14, 5, 15, 4, 0, // Skip to: 1473
/* 1469 */    MCD::OPC_Decode, 209, 5, 7, // Opcode: STBAR, DecodeIdx: 7
/* 1473 */    MCD::OPC_Decode, 162, 5, 18, // Opcode: RDASR, DecodeIdx: 18
/* 1477 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1479 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1481 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 1485 */    MCD::OPC_CheckFieldOrFail, 14, 5, 15, 
/* 1489 */    MCD::OPC_Decode, 252, 4, 19, // Opcode: MEMBARi, DecodeIdx: 19
/* 1493 */    MCD::OPC_FilterValue, 41, 8, 0, // Skip to: 1505
/* 1497 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1501 */    MCD::OPC_Decode, 165, 5, 20, // Opcode: RDPSR, DecodeIdx: 20
/* 1505 */    MCD::OPC_FilterValue, 42, 34, 0, // Skip to: 1543
/* 1509 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 1512 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1514 */    MCD::OPC_ExtractField, 14, 5,  // Inst{18-14} ...
/* 1517 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1525
/* 1521 */    MCD::OPC_Decode, 167, 5, 20, // Opcode: RDWIM, DecodeIdx: 20
/* 1525 */    MCD::OPC_FilterValue, 15, 8, 0, // Skip to: 1537
/* 1529 */    MCD::OPC_CheckPredicate, 0, 4, 0, // Skip to: 1537
/* 1533 */    MCD::OPC_Decode, 163, 5, 20, // Opcode: RDFQ, DecodeIdx: 20
/* 1537 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1539 */    MCD::OPC_Decode, 164, 5, 21, // Opcode: RDPR, DecodeIdx: 21
/* 1543 */    MCD::OPC_FilterValue, 43, 23, 0, // Skip to: 1570
/* 1547 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 1550 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1552 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1566
/* 1556 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1566
/* 1562 */    MCD::OPC_Decode, 202, 3, 7, // Opcode: FLUSHW, DecodeIdx: 7
/* 1566 */    MCD::OPC_Decode, 166, 5, 20, // Opcode: RDTBR, DecodeIdx: 20
/* 1570 */    MCD::OPC_FilterValue, 44, 109, 0, // Skip to: 1683
/* 1574 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1577 */    MCD::OPC_FilterValue, 0, 50, 0, // Skip to: 1631
/* 1581 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1584 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 1608
/* 1588 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1602
/* 1592 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1602
/* 1598 */    MCD::OPC_Decode, 255, 4, 22, // Opcode: MOVFCCrr, DecodeIdx: 22
/* 1602 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1604 */    MCD::OPC_Decode, 185, 6, 23, // Opcode: V9MOVFCCrr, DecodeIdx: 23
/* 1608 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1610 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1613 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 1623
/* 1617 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1619 */    MCD::OPC_Decode, 129, 5, 22, // Opcode: MOVICCrr, DecodeIdx: 22
/* 1623 */    MCD::OPC_FilterValueOrFail, 2, 
/* 1625 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1627 */    MCD::OPC_Decode, 136, 5, 22, // Opcode: MOVXCCrr, DecodeIdx: 22
/* 1631 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1633 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 1636 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 1660
/* 1640 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 1654
/* 1644 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 1654
/* 1650 */    MCD::OPC_Decode, 254, 4, 24, // Opcode: MOVFCCri, DecodeIdx: 24
/* 1654 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1656 */    MCD::OPC_Decode, 184, 6, 25, // Opcode: V9MOVFCCri, DecodeIdx: 25
/* 1660 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1662 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 1665 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 1675
/* 1669 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1671 */    MCD::OPC_Decode, 128, 5, 24, // Opcode: MOVICCri, DecodeIdx: 24
/* 1675 */    MCD::OPC_FilterValueOrFail, 2, 
/* 1677 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1679 */    MCD::OPC_Decode, 135, 5, 24, // Opcode: MOVXCCri, DecodeIdx: 24
/* 1683 */    MCD::OPC_FilterValue, 45, 25, 0, // Skip to: 1712
/* 1687 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1690 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1704
/* 1694 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1696 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1700 */    MCD::OPC_Decode, 182, 5, 13, // Opcode: SDIVXrr, DecodeIdx: 13
/* 1704 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1706 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1708 */    MCD::OPC_Decode, 181, 5, 14, // Opcode: SDIVXri, DecodeIdx: 14
/* 1712 */    MCD::OPC_FilterValue, 46, 10, 0, // Skip to: 1726
/* 1716 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1718 */    MCD::OPC_CheckFieldOrFail, 5, 14, 0, 
/* 1722 */    MCD::OPC_Decode, 155, 5, 26, // Opcode: POPCrr, DecodeIdx: 26
/* 1726 */    MCD::OPC_FilterValue, 47, 25, 0, // Skip to: 1755
/* 1730 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1733 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1747
/* 1737 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1739 */    MCD::OPC_CheckFieldOrFail, 5, 5, 0, 
/* 1743 */    MCD::OPC_Decode, 131, 5, 27, // Opcode: MOVRrr, DecodeIdx: 27
/* 1747 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1749 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1751 */    MCD::OPC_Decode, 130, 5, 28, // Opcode: MOVRri, DecodeIdx: 28
/* 1755 */    MCD::OPC_FilterValue, 48, 41, 0, // Skip to: 1800
/* 1759 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1762 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 1774
/* 1766 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 1770 */    MCD::OPC_Decode, 187, 6, 29, // Opcode: WRASRrr, DecodeIdx: 29
/* 1774 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1776 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1796
/* 1780 */    MCD::OPC_CheckField, 25, 5, 15, 10, 0, // Skip to: 1796
/* 1786 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, // Skip to: 1796
/* 1792 */    MCD::OPC_Decode, 188, 5, 30, // Opcode: SIR, DecodeIdx: 30
/* 1796 */    MCD::OPC_Decode, 186, 6, 31, // Opcode: WRASRri, DecodeIdx: 31
/* 1800 */    MCD::OPC_FilterValue, 49, 153, 0, // Skip to: 1957
/* 1804 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 1807 */    MCD::OPC_FilterValue, 0, 42, 0, // Skip to: 1853
/* 1811 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1814 */    MCD::OPC_FilterValue, 0, 29, 0, // Skip to: 1847
/* 1818 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1821 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1823 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1843
/* 1827 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 1843
/* 1833 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 1843
/* 1839 */    MCD::OPC_Decode, 176, 5, 7, // Opcode: SAVED, DecodeIdx: 7
/* 1843 */    MCD::OPC_Decode, 191, 6, 32, // Opcode: WRPSRrr, DecodeIdx: 32
/* 1847 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1849 */    MCD::OPC_Decode, 190, 6, 33, // Opcode: WRPSRri, DecodeIdx: 33
/* 1853 */    MCD::OPC_FilterValue, 1, 46, 0, // Skip to: 1903
/* 1857 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1860 */    MCD::OPC_FilterValue, 0, 31, 0, // Skip to: 1895
/* 1864 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1867 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1869 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 1889
/* 1873 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 1889
/* 1879 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 1889
/* 1885 */    MCD::OPC_Decode, 168, 5, 7, // Opcode: RESTORED, DecodeIdx: 7
/* 1889 */    MCD::OPC_CheckPredicateOrFail, 2, 
/* 1891 */    MCD::OPC_Decode, 161, 5, 32, // Opcode: PWRPSRrr, DecodeIdx: 32
/* 1895 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1897 */    MCD::OPC_CheckPredicateOrFail, 2, 
/* 1899 */    MCD::OPC_Decode, 160, 5, 33, // Opcode: PWRPSRri, DecodeIdx: 33
/* 1903 */    MCD::OPC_FilterValue, 2, 10, 0, // Skip to: 1917
/* 1907 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1909 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1913 */    MCD::OPC_Decode, 212, 2, 7, // Opcode: ALLCLEAN, DecodeIdx: 7
/* 1917 */    MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 1931
/* 1921 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1923 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1927 */    MCD::OPC_Decode, 152, 5, 7, // Opcode: OTHERW, DecodeIdx: 7
/* 1931 */    MCD::OPC_FilterValue, 4, 10, 0, // Skip to: 1945
/* 1935 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1937 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1941 */    MCD::OPC_Decode, 143, 5, 7, // Opcode: NORMALW, DecodeIdx: 7
/* 1945 */    MCD::OPC_FilterValueOrFail, 5, 
/* 1947 */    MCD::OPC_CheckPredicateOrFail, 3, 
/* 1949 */    MCD::OPC_CheckFieldOrFail, 0, 19, 0, 
/* 1953 */    MCD::OPC_Decode, 190, 4, 7, // Opcode: INVALW, DecodeIdx: 7
/* 1957 */    MCD::OPC_FilterValue, 50, 46, 0, // Skip to: 2007
/* 1961 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1964 */    MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 1989
/* 1968 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1971 */    MCD::OPC_FilterValueOrFail, 0, 
/* 1973 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 1983
/* 1979 */    MCD::OPC_Decode, 195, 6, 32, // Opcode: WRWIMrr, DecodeIdx: 32
/* 1983 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 1985 */    MCD::OPC_Decode, 189, 6, 34, // Opcode: WRPRrr, DecodeIdx: 34
/* 1989 */    MCD::OPC_FilterValueOrFail, 1, 
/* 1991 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, // Skip to: 2001
/* 1997 */    MCD::OPC_Decode, 194, 6, 33, // Opcode: WRWIMri, DecodeIdx: 33
/* 2001 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2003 */    MCD::OPC_Decode, 188, 6, 35, // Opcode: WRPRri, DecodeIdx: 35
/* 2007 */    MCD::OPC_FilterValue, 51, 29, 0, // Skip to: 2040
/* 2011 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2014 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 2030
/* 2018 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 2022 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 2026 */    MCD::OPC_Decode, 193, 6, 32, // Opcode: WRTBRrr, DecodeIdx: 32
/* 2030 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2032 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 2036 */    MCD::OPC_Decode, 192, 6, 33, // Opcode: WRTBRri, DecodeIdx: 33
/* 2040 */    MCD::OPC_FilterValue, 52, 113, 2, // Skip to: 2669
/* 2044 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2047 */    MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 2059
/* 2051 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2055 */    MCD::OPC_Decode, 219, 3, 36, // Opcode: FMOVS, DecodeIdx: 36
/* 2059 */    MCD::OPC_FilterValue, 2, 10, 0, // Skip to: 2073
/* 2063 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2065 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2069 */    MCD::OPC_Decode, 208, 3, 37, // Opcode: FMOVD, DecodeIdx: 37
/* 2073 */    MCD::OPC_FilterValue, 3, 10, 0, // Skip to: 2087
/* 2077 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2079 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2083 */    MCD::OPC_Decode, 212, 3, 38, // Opcode: FMOVQ, DecodeIdx: 38
/* 2087 */    MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 2099
/* 2091 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2095 */    MCD::OPC_Decode, 241, 3, 36, // Opcode: FNEGS, DecodeIdx: 36
/* 2099 */    MCD::OPC_FilterValue, 6, 10, 0, // Skip to: 2113
/* 2103 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2105 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2109 */    MCD::OPC_Decode, 239, 3, 37, // Opcode: FNEGD, DecodeIdx: 37
/* 2113 */    MCD::OPC_FilterValue, 7, 10, 0, // Skip to: 2127
/* 2117 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2119 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2123 */    MCD::OPC_Decode, 240, 3, 38, // Opcode: FNEGQ, DecodeIdx: 38
/* 2127 */    MCD::OPC_FilterValue, 9, 8, 0, // Skip to: 2139
/* 2131 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2135 */    MCD::OPC_Decode, 153, 3, 36, // Opcode: FABSS, DecodeIdx: 36
/* 2139 */    MCD::OPC_FilterValue, 10, 10, 0, // Skip to: 2153
/* 2143 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2145 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2149 */    MCD::OPC_Decode, 151, 3, 37, // Opcode: FABSD, DecodeIdx: 37
/* 2153 */    MCD::OPC_FilterValue, 11, 10, 0, // Skip to: 2167
/* 2157 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2159 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2163 */    MCD::OPC_Decode, 152, 3, 38, // Opcode: FABSQ, DecodeIdx: 38
/* 2167 */    MCD::OPC_FilterValue, 41, 8, 0, // Skip to: 2179
/* 2171 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2175 */    MCD::OPC_Decode, 163, 4, 36, // Opcode: FSQRTS, DecodeIdx: 36
/* 2179 */    MCD::OPC_FilterValue, 42, 8, 0, // Skip to: 2191
/* 2183 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2187 */    MCD::OPC_Decode, 161, 4, 37, // Opcode: FSQRTD, DecodeIdx: 37
/* 2191 */    MCD::OPC_FilterValue, 43, 8, 0, // Skip to: 2203
/* 2195 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2199 */    MCD::OPC_Decode, 162, 4, 38, // Opcode: FSQRTQ, DecodeIdx: 38
/* 2203 */    MCD::OPC_FilterValue, 65, 4, 0, // Skip to: 2211
/* 2207 */    MCD::OPC_Decode, 156, 3, 39, // Opcode: FADDS, DecodeIdx: 39
/* 2211 */    MCD::OPC_FilterValue, 66, 4, 0, // Skip to: 2219
/* 2215 */    MCD::OPC_Decode, 154, 3, 40, // Opcode: FADDD, DecodeIdx: 40
/* 2219 */    MCD::OPC_FilterValue, 67, 4, 0, // Skip to: 2227
/* 2223 */    MCD::OPC_Decode, 155, 3, 41, // Opcode: FADDQ, DecodeIdx: 41
/* 2227 */    MCD::OPC_FilterValue, 69, 4, 0, // Skip to: 2235
/* 2231 */    MCD::OPC_Decode, 178, 4, 39, // Opcode: FSUBS, DecodeIdx: 39
/* 2235 */    MCD::OPC_FilterValue, 70, 4, 0, // Skip to: 2243
/* 2239 */    MCD::OPC_Decode, 176, 4, 40, // Opcode: FSUBD, DecodeIdx: 40
/* 2243 */    MCD::OPC_FilterValue, 71, 4, 0, // Skip to: 2251
/* 2247 */    MCD::OPC_Decode, 177, 4, 41, // Opcode: FSUBQ, DecodeIdx: 41
/* 2251 */    MCD::OPC_FilterValue, 73, 4, 0, // Skip to: 2259
/* 2255 */    MCD::OPC_Decode, 234, 3, 39, // Opcode: FMULS, DecodeIdx: 39
/* 2259 */    MCD::OPC_FilterValue, 74, 4, 0, // Skip to: 2267
/* 2263 */    MCD::OPC_Decode, 230, 3, 40, // Opcode: FMULD, DecodeIdx: 40
/* 2267 */    MCD::OPC_FilterValue, 75, 4, 0, // Skip to: 2275
/* 2271 */    MCD::OPC_Decode, 233, 3, 41, // Opcode: FMULQ, DecodeIdx: 41
/* 2275 */    MCD::OPC_FilterValue, 77, 4, 0, // Skip to: 2283
/* 2279 */    MCD::OPC_Decode, 185, 3, 39, // Opcode: FDIVS, DecodeIdx: 39
/* 2283 */    MCD::OPC_FilterValue, 78, 4, 0, // Skip to: 2291
/* 2287 */    MCD::OPC_Decode, 183, 3, 40, // Opcode: FDIVD, DecodeIdx: 40
/* 2291 */    MCD::OPC_FilterValue, 79, 4, 0, // Skip to: 2299
/* 2295 */    MCD::OPC_Decode, 184, 3, 41, // Opcode: FDIVQ, DecodeIdx: 41
/* 2299 */    MCD::OPC_FilterValue, 81, 6, 0, // Skip to: 2309
/* 2303 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2305 */    MCD::OPC_Decode, 236, 3, 39, // Opcode: FNADDS, DecodeIdx: 39
/* 2309 */    MCD::OPC_FilterValue, 82, 6, 0, // Skip to: 2319
/* 2313 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2315 */    MCD::OPC_Decode, 235, 3, 40, // Opcode: FNADDD, DecodeIdx: 40
/* 2319 */    MCD::OPC_FilterValue, 89, 6, 0, // Skip to: 2329
/* 2323 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2325 */    MCD::OPC_Decode, 249, 3, 39, // Opcode: FNMULS, DecodeIdx: 39
/* 2329 */    MCD::OPC_FilterValue, 90, 6, 0, // Skip to: 2339
/* 2333 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2335 */    MCD::OPC_Decode, 248, 3, 40, // Opcode: FNMULD, DecodeIdx: 40
/* 2339 */    MCD::OPC_FilterValue, 97, 6, 0, // Skip to: 2349
/* 2343 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2345 */    MCD::OPC_Decode, 193, 3, 39, // Opcode: FHADDS, DecodeIdx: 39
/* 2349 */    MCD::OPC_FilterValue, 98, 6, 0, // Skip to: 2359
/* 2353 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2355 */    MCD::OPC_Decode, 192, 3, 40, // Opcode: FHADDD, DecodeIdx: 40
/* 2359 */    MCD::OPC_FilterValue, 101, 6, 0, // Skip to: 2369
/* 2363 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2365 */    MCD::OPC_Decode, 195, 3, 39, // Opcode: FHSUBS, DecodeIdx: 39
/* 2369 */    MCD::OPC_FilterValue, 102, 6, 0, // Skip to: 2379
/* 2373 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2375 */    MCD::OPC_Decode, 194, 3, 40, // Opcode: FHSUBD, DecodeIdx: 40
/* 2379 */    MCD::OPC_FilterValue, 105, 4, 0, // Skip to: 2387
/* 2383 */    MCD::OPC_Decode, 160, 4, 42, // Opcode: FSMULD, DecodeIdx: 42
/* 2387 */    MCD::OPC_FilterValue, 110, 4, 0, // Skip to: 2395
/* 2391 */    MCD::OPC_Decode, 186, 3, 43, // Opcode: FDMULQ, DecodeIdx: 43
/* 2395 */    MCD::OPC_FilterValue, 113, 6, 0, // Skip to: 2405
/* 2399 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2401 */    MCD::OPC_Decode, 243, 3, 39, // Opcode: FNHADDS, DecodeIdx: 39
/* 2405 */    MCD::OPC_FilterValue, 114, 6, 0, // Skip to: 2415
/* 2409 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2411 */    MCD::OPC_Decode, 242, 3, 40, // Opcode: FNHADDD, DecodeIdx: 40
/* 2415 */    MCD::OPC_FilterValue, 121, 6, 0, // Skip to: 2425
/* 2419 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 2421 */    MCD::OPC_Decode, 128, 4, 42, // Opcode: FNSMULD, DecodeIdx: 42
/* 2425 */    MCD::OPC_FilterValue, 129, 1, 10, 0, // Skip to: 2440
/* 2430 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2432 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2436 */    MCD::OPC_Decode, 175, 4, 44, // Opcode: FSTOX, DecodeIdx: 44
/* 2440 */    MCD::OPC_FilterValue, 130, 1, 10, 0, // Skip to: 2455
/* 2445 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2447 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2451 */    MCD::OPC_Decode, 190, 3, 37, // Opcode: FDTOX, DecodeIdx: 37
/* 2455 */    MCD::OPC_FilterValue, 131, 1, 10, 0, // Skip to: 2470
/* 2460 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2462 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2466 */    MCD::OPC_Decode, 155, 4, 45, // Opcode: FQTOX, DecodeIdx: 45
/* 2470 */    MCD::OPC_FilterValue, 132, 1, 10, 0, // Skip to: 2485
/* 2475 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2477 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2481 */    MCD::OPC_Decode, 185, 4, 46, // Opcode: FXTOS, DecodeIdx: 46
/* 2485 */    MCD::OPC_FilterValue, 136, 1, 10, 0, // Skip to: 2500
/* 2490 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2492 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2496 */    MCD::OPC_Decode, 183, 4, 37, // Opcode: FXTOD, DecodeIdx: 37
/* 2500 */    MCD::OPC_FilterValue, 140, 1, 10, 0, // Skip to: 2515
/* 2505 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2507 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2511 */    MCD::OPC_Decode, 184, 4, 47, // Opcode: FXTOQ, DecodeIdx: 47
/* 2515 */    MCD::OPC_FilterValue, 196, 1, 8, 0, // Skip to: 2528
/* 2520 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2524 */    MCD::OPC_Decode, 198, 3, 36, // Opcode: FITOS, DecodeIdx: 36
/* 2528 */    MCD::OPC_FilterValue, 198, 1, 8, 0, // Skip to: 2541
/* 2533 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2537 */    MCD::OPC_Decode, 189, 3, 46, // Opcode: FDTOS, DecodeIdx: 46
/* 2541 */    MCD::OPC_FilterValue, 199, 1, 8, 0, // Skip to: 2554
/* 2546 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2550 */    MCD::OPC_Decode, 154, 4, 48, // Opcode: FQTOS, DecodeIdx: 48
/* 2554 */    MCD::OPC_FilterValue, 200, 1, 8, 0, // Skip to: 2567
/* 2559 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2563 */    MCD::OPC_Decode, 196, 3, 44, // Opcode: FITOD, DecodeIdx: 44
/* 2567 */    MCD::OPC_FilterValue, 201, 1, 8, 0, // Skip to: 2580
/* 2572 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2576 */    MCD::OPC_Decode, 172, 4, 44, // Opcode: FSTOD, DecodeIdx: 44
/* 2580 */    MCD::OPC_FilterValue, 203, 1, 8, 0, // Skip to: 2593
/* 2585 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2589 */    MCD::OPC_Decode, 152, 4, 45, // Opcode: FQTOD, DecodeIdx: 45
/* 2593 */    MCD::OPC_FilterValue, 204, 1, 8, 0, // Skip to: 2606
/* 2598 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2602 */    MCD::OPC_Decode, 197, 3, 49, // Opcode: FITOQ, DecodeIdx: 49
/* 2606 */    MCD::OPC_FilterValue, 205, 1, 8, 0, // Skip to: 2619
/* 2611 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2615 */    MCD::OPC_Decode, 174, 4, 49, // Opcode: FSTOQ, DecodeIdx: 49
/* 2619 */    MCD::OPC_FilterValue, 206, 1, 8, 0, // Skip to: 2632
/* 2624 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2628 */    MCD::OPC_Decode, 188, 3, 47, // Opcode: FDTOQ, DecodeIdx: 47
/* 2632 */    MCD::OPC_FilterValue, 209, 1, 8, 0, // Skip to: 2645
/* 2637 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2641 */    MCD::OPC_Decode, 173, 4, 36, // Opcode: FSTOI, DecodeIdx: 36
/* 2645 */    MCD::OPC_FilterValue, 210, 1, 8, 0, // Skip to: 2658
/* 2650 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2654 */    MCD::OPC_Decode, 187, 3, 46, // Opcode: FDTOI, DecodeIdx: 46
/* 2658 */    MCD::OPC_FilterValueOrFail, 211, 1, 
/* 2661 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 2665 */    MCD::OPC_Decode, 153, 4, 48, // Opcode: FQTOI, DecodeIdx: 48
/* 2669 */    MCD::OPC_FilterValue, 53, 73, 1, // Skip to: 3002
/* 2673 */    MCD::OPC_ExtractField, 5, 5,  // Inst{9-5} ...
/* 2676 */    MCD::OPC_FilterValue, 1, 68, 0, // Skip to: 2748
/* 2680 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2683 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 2717
/* 2687 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2690 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2692 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2695 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2697 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2711
/* 2701 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2711
/* 2707 */    MCD::OPC_Decode, 220, 3, 50, // Opcode: FMOVS_FCC, DecodeIdx: 50
/* 2711 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2713 */    MCD::OPC_Decode, 183, 6, 51, // Opcode: V9FMOVS_FCC, DecodeIdx: 51
/* 2717 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2719 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2722 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 2736
/* 2726 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2728 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2732 */    MCD::OPC_Decode, 221, 3, 50, // Opcode: FMOVS_ICC, DecodeIdx: 50
/* 2736 */    MCD::OPC_FilterValueOrFail, 4, 
/* 2738 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2740 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2744 */    MCD::OPC_Decode, 222, 3, 50, // Opcode: FMOVS_XCC, DecodeIdx: 50
/* 2748 */    MCD::OPC_FilterValue, 2, 68, 0, // Skip to: 2820
/* 2752 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2755 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 2789
/* 2759 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2762 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2764 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2767 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2769 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2783
/* 2773 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2783
/* 2779 */    MCD::OPC_Decode, 209, 3, 52, // Opcode: FMOVD_FCC, DecodeIdx: 52
/* 2783 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2785 */    MCD::OPC_Decode, 181, 6, 53, // Opcode: V9FMOVD_FCC, DecodeIdx: 53
/* 2789 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2791 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2794 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 2808
/* 2798 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2800 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2804 */    MCD::OPC_Decode, 210, 3, 52, // Opcode: FMOVD_ICC, DecodeIdx: 52
/* 2808 */    MCD::OPC_FilterValueOrFail, 4, 
/* 2810 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2812 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2816 */    MCD::OPC_Decode, 211, 3, 52, // Opcode: FMOVD_XCC, DecodeIdx: 52
/* 2820 */    MCD::OPC_FilterValue, 3, 68, 0, // Skip to: 2892
/* 2824 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2827 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 2861
/* 2831 */    MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 2834 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2836 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2839 */    MCD::OPC_FilterValueOrFail, 0, 
/* 2841 */    MCD::OPC_CheckPredicate, 0, 10, 0, // Skip to: 2855
/* 2845 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, // Skip to: 2855
/* 2851 */    MCD::OPC_Decode, 213, 3, 54, // Opcode: FMOVQ_FCC, DecodeIdx: 54
/* 2855 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2857 */    MCD::OPC_Decode, 182, 6, 55, // Opcode: V9FMOVQ_FCC, DecodeIdx: 55
/* 2861 */    MCD::OPC_FilterValueOrFail, 1, 
/* 2863 */    MCD::OPC_ExtractField, 10, 3,  // Inst{12-10} ...
/* 2866 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 2880
/* 2870 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2872 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2876 */    MCD::OPC_Decode, 214, 3, 54, // Opcode: FMOVQ_ICC, DecodeIdx: 54
/* 2880 */    MCD::OPC_FilterValueOrFail, 4, 
/* 2882 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2884 */    MCD::OPC_CheckFieldOrFail, 18, 1, 0, 
/* 2888 */    MCD::OPC_Decode, 215, 3, 54, // Opcode: FMOVQ_XCC, DecodeIdx: 54
/* 2892 */    MCD::OPC_FilterValue, 5, 10, 0, // Skip to: 2906
/* 2896 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2898 */    MCD::OPC_CheckFieldOrFail, 13, 1, 0, 
/* 2902 */    MCD::OPC_Decode, 218, 3, 56, // Opcode: FMOVRS, DecodeIdx: 56
/* 2906 */    MCD::OPC_FilterValue, 6, 10, 0, // Skip to: 2920
/* 2910 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 2912 */    MCD::OPC_CheckFieldOrFail, 13, 1, 0, 
/* 2916 */    MCD::OPC_Decode, 216, 3, 57, // Opcode: FMOVRD, DecodeIdx: 57
/* 2920 */    MCD::OPC_FilterValue, 7, 8, 0, // Skip to: 2932
/* 2924 */    MCD::OPC_CheckFieldOrFail, 13, 1, 0, 
/* 2928 */    MCD::OPC_Decode, 217, 3, 58, // Opcode: FMOVRQ, DecodeIdx: 58
/* 2932 */    MCD::OPC_FilterValue, 17, 8, 0, // Skip to: 2944
/* 2936 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2940 */    MCD::OPC_Decode, 180, 6, 59, // Opcode: V9FCMPS, DecodeIdx: 59
/* 2944 */    MCD::OPC_FilterValue, 18, 8, 0, // Skip to: 2956
/* 2948 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2952 */    MCD::OPC_Decode, 175, 6, 60, // Opcode: V9FCMPD, DecodeIdx: 60
/* 2956 */    MCD::OPC_FilterValue, 19, 8, 0, // Skip to: 2968
/* 2960 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2964 */    MCD::OPC_Decode, 179, 6, 61, // Opcode: V9FCMPQ, DecodeIdx: 61
/* 2968 */    MCD::OPC_FilterValue, 21, 8, 0, // Skip to: 2980
/* 2972 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2976 */    MCD::OPC_Decode, 178, 6, 59, // Opcode: V9FCMPES, DecodeIdx: 59
/* 2980 */    MCD::OPC_FilterValue, 22, 8, 0, // Skip to: 2992
/* 2984 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2988 */    MCD::OPC_Decode, 176, 6, 60, // Opcode: V9FCMPED, DecodeIdx: 60
/* 2992 */    MCD::OPC_FilterValueOrFail, 23, 
/* 2994 */    MCD::OPC_CheckFieldOrFail, 10, 4, 2, 
/* 2998 */    MCD::OPC_Decode, 177, 6, 61, // Opcode: V9FCMPEQ, DecodeIdx: 61
/* 3002 */    MCD::OPC_FilterValue, 54, 246, 4, // Skip to: 4276
/* 3006 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 3009 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 3019
/* 3013 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3015 */    MCD::OPC_Decode, 147, 3, 13, // Opcode: EDGE8, DecodeIdx: 13
/* 3019 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 3029
/* 3023 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3025 */    MCD::OPC_Decode, 150, 3, 13, // Opcode: EDGE8N, DecodeIdx: 13
/* 3029 */    MCD::OPC_FilterValue, 2, 6, 0, // Skip to: 3039
/* 3033 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3035 */    MCD::OPC_Decode, 148, 3, 13, // Opcode: EDGE8L, DecodeIdx: 13
/* 3039 */    MCD::OPC_FilterValue, 3, 6, 0, // Skip to: 3049
/* 3043 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3045 */    MCD::OPC_Decode, 149, 3, 13, // Opcode: EDGE8LN, DecodeIdx: 13
/* 3049 */    MCD::OPC_FilterValue, 4, 6, 0, // Skip to: 3059
/* 3053 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3055 */    MCD::OPC_Decode, 139, 3, 13, // Opcode: EDGE16, DecodeIdx: 13
/* 3059 */    MCD::OPC_FilterValue, 5, 6, 0, // Skip to: 3069
/* 3063 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3065 */    MCD::OPC_Decode, 142, 3, 13, // Opcode: EDGE16N, DecodeIdx: 13
/* 3069 */    MCD::OPC_FilterValue, 6, 6, 0, // Skip to: 3079
/* 3073 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3075 */    MCD::OPC_Decode, 140, 3, 13, // Opcode: EDGE16L, DecodeIdx: 13
/* 3079 */    MCD::OPC_FilterValue, 7, 6, 0, // Skip to: 3089
/* 3083 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3085 */    MCD::OPC_Decode, 141, 3, 13, // Opcode: EDGE16LN, DecodeIdx: 13
/* 3089 */    MCD::OPC_FilterValue, 8, 6, 0, // Skip to: 3099
/* 3093 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3095 */    MCD::OPC_Decode, 143, 3, 13, // Opcode: EDGE32, DecodeIdx: 13
/* 3099 */    MCD::OPC_FilterValue, 9, 6, 0, // Skip to: 3109
/* 3103 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3105 */    MCD::OPC_Decode, 146, 3, 13, // Opcode: EDGE32N, DecodeIdx: 13
/* 3109 */    MCD::OPC_FilterValue, 10, 6, 0, // Skip to: 3119
/* 3113 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3115 */    MCD::OPC_Decode, 144, 3, 13, // Opcode: EDGE32L, DecodeIdx: 13
/* 3119 */    MCD::OPC_FilterValue, 11, 6, 0, // Skip to: 3129
/* 3123 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3125 */    MCD::OPC_Decode, 145, 3, 13, // Opcode: EDGE32LN, DecodeIdx: 13
/* 3129 */    MCD::OPC_FilterValue, 16, 6, 0, // Skip to: 3139
/* 3133 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3135 */    MCD::OPC_Decode, 223, 2, 13, // Opcode: ARRAY8, DecodeIdx: 13
/* 3139 */    MCD::OPC_FilterValue, 17, 6, 0, // Skip to: 3149
/* 3143 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3145 */    MCD::OPC_Decode, 206, 2, 13, // Opcode: ADDXC, DecodeIdx: 13
/* 3149 */    MCD::OPC_FilterValue, 18, 6, 0, // Skip to: 3159
/* 3153 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3155 */    MCD::OPC_Decode, 221, 2, 13, // Opcode: ARRAY16, DecodeIdx: 13
/* 3159 */    MCD::OPC_FilterValue, 19, 6, 0, // Skip to: 3169
/* 3163 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3165 */    MCD::OPC_Decode, 207, 2, 13, // Opcode: ADDXCCC, DecodeIdx: 13
/* 3169 */    MCD::OPC_FilterValue, 20, 6, 0, // Skip to: 3179
/* 3173 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3175 */    MCD::OPC_Decode, 222, 2, 13, // Opcode: ARRAY32, DecodeIdx: 13
/* 3179 */    MCD::OPC_FilterValue, 22, 6, 0, // Skip to: 3189
/* 3183 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3185 */    MCD::OPC_Decode, 171, 6, 13, // Opcode: UMULXHI, DecodeIdx: 13
/* 3189 */    MCD::OPC_FilterValue, 23, 10, 0, // Skip to: 3203
/* 3193 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3195 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3199 */    MCD::OPC_Decode, 251, 4, 62, // Opcode: LZCNT, DecodeIdx: 62
/* 3203 */    MCD::OPC_FilterValue, 24, 6, 0, // Skip to: 3213
/* 3207 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3209 */    MCD::OPC_Decode, 210, 2, 13, // Opcode: ALIGNADDR, DecodeIdx: 13
/* 3213 */    MCD::OPC_FilterValue, 25, 6, 0, // Skip to: 3223
/* 3217 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3219 */    MCD::OPC_Decode, 229, 2, 13, // Opcode: BMASK, DecodeIdx: 13
/* 3223 */    MCD::OPC_FilterValue, 26, 6, 0, // Skip to: 3233
/* 3227 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3229 */    MCD::OPC_Decode, 211, 2, 13, // Opcode: ALIGNADDRL, DecodeIdx: 13
/* 3233 */    MCD::OPC_FilterValue, 27, 14, 0, // Skip to: 3251
/* 3237 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3239 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 3243 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3247 */    MCD::OPC_Decode, 131, 3, 63, // Opcode: CMASK8, DecodeIdx: 63
/* 3251 */    MCD::OPC_FilterValue, 29, 14, 0, // Skip to: 3269
/* 3255 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3257 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 3261 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3265 */    MCD::OPC_Decode, 129, 3, 63, // Opcode: CMASK16, DecodeIdx: 63
/* 3269 */    MCD::OPC_FilterValue, 31, 14, 0, // Skip to: 3287
/* 3273 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3275 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 3279 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3283 */    MCD::OPC_Decode, 130, 3, 63, // Opcode: CMASK32, DecodeIdx: 63
/* 3287 */    MCD::OPC_FilterValue, 32, 6, 0, // Skip to: 3297
/* 3291 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3293 */    MCD::OPC_Decode, 175, 3, 64, // Opcode: FCMPLE16, DecodeIdx: 64
/* 3297 */    MCD::OPC_FilterValue, 33, 6, 0, // Skip to: 3307
/* 3301 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3303 */    MCD::OPC_Decode, 158, 4, 40, // Opcode: FSLL16, DecodeIdx: 40
/* 3307 */    MCD::OPC_FilterValue, 34, 6, 0, // Skip to: 3317
/* 3311 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3313 */    MCD::OPC_Decode, 177, 3, 64, // Opcode: FCMPNE16, DecodeIdx: 64
/* 3317 */    MCD::OPC_FilterValue, 35, 6, 0, // Skip to: 3327
/* 3321 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3323 */    MCD::OPC_Decode, 170, 4, 40, // Opcode: FSRL16, DecodeIdx: 40
/* 3327 */    MCD::OPC_FilterValue, 36, 6, 0, // Skip to: 3337
/* 3331 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3333 */    MCD::OPC_Decode, 176, 3, 64, // Opcode: FCMPLE32, DecodeIdx: 64
/* 3337 */    MCD::OPC_FilterValue, 37, 6, 0, // Skip to: 3347
/* 3341 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3343 */    MCD::OPC_Decode, 159, 4, 40, // Opcode: FSLL32, DecodeIdx: 40
/* 3347 */    MCD::OPC_FilterValue, 38, 6, 0, // Skip to: 3357
/* 3351 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3353 */    MCD::OPC_Decode, 178, 3, 64, // Opcode: FCMPNE32, DecodeIdx: 64
/* 3357 */    MCD::OPC_FilterValue, 39, 6, 0, // Skip to: 3367
/* 3361 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3363 */    MCD::OPC_Decode, 171, 4, 40, // Opcode: FSRL32, DecodeIdx: 40
/* 3367 */    MCD::OPC_FilterValue, 40, 6, 0, // Skip to: 3377
/* 3371 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3373 */    MCD::OPC_Decode, 173, 3, 64, // Opcode: FCMPGT16, DecodeIdx: 64
/* 3377 */    MCD::OPC_FilterValue, 41, 6, 0, // Skip to: 3387
/* 3381 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3383 */    MCD::OPC_Decode, 156, 4, 40, // Opcode: FSLAS16, DecodeIdx: 40
/* 3387 */    MCD::OPC_FilterValue, 42, 6, 0, // Skip to: 3397
/* 3391 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3393 */    MCD::OPC_Decode, 171, 3, 64, // Opcode: FCMPEQ16, DecodeIdx: 64
/* 3397 */    MCD::OPC_FilterValue, 43, 6, 0, // Skip to: 3407
/* 3401 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3403 */    MCD::OPC_Decode, 164, 4, 40, // Opcode: FSRA16, DecodeIdx: 40
/* 3407 */    MCD::OPC_FilterValue, 44, 6, 0, // Skip to: 3417
/* 3411 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3413 */    MCD::OPC_Decode, 174, 3, 64, // Opcode: FCMPGT32, DecodeIdx: 64
/* 3417 */    MCD::OPC_FilterValue, 45, 6, 0, // Skip to: 3427
/* 3421 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3423 */    MCD::OPC_Decode, 157, 4, 40, // Opcode: FSLAS32, DecodeIdx: 40
/* 3427 */    MCD::OPC_FilterValue, 46, 6, 0, // Skip to: 3437
/* 3431 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3433 */    MCD::OPC_Decode, 172, 3, 64, // Opcode: FCMPEQ32, DecodeIdx: 64
/* 3437 */    MCD::OPC_FilterValue, 47, 6, 0, // Skip to: 3447
/* 3441 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3443 */    MCD::OPC_Decode, 165, 4, 40, // Opcode: FSRA32, DecodeIdx: 40
/* 3447 */    MCD::OPC_FilterValue, 49, 6, 0, // Skip to: 3457
/* 3451 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3453 */    MCD::OPC_Decode, 227, 3, 65, // Opcode: FMUL8X16, DecodeIdx: 65
/* 3457 */    MCD::OPC_FilterValue, 51, 6, 0, // Skip to: 3467
/* 3461 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3463 */    MCD::OPC_Decode, 229, 3, 42, // Opcode: FMUL8X16AU, DecodeIdx: 42
/* 3467 */    MCD::OPC_FilterValue, 53, 6, 0, // Skip to: 3477
/* 3471 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3473 */    MCD::OPC_Decode, 228, 3, 42, // Opcode: FMUL8X16AL, DecodeIdx: 42
/* 3477 */    MCD::OPC_FilterValue, 54, 6, 0, // Skip to: 3487
/* 3481 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3483 */    MCD::OPC_Decode, 225, 3, 40, // Opcode: FMUL8SUX16, DecodeIdx: 40
/* 3487 */    MCD::OPC_FilterValue, 55, 6, 0, // Skip to: 3497
/* 3491 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3493 */    MCD::OPC_Decode, 226, 3, 40, // Opcode: FMUL8ULX16, DecodeIdx: 40
/* 3497 */    MCD::OPC_FilterValue, 56, 6, 0, // Skip to: 3507
/* 3501 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3503 */    MCD::OPC_Decode, 231, 3, 42, // Opcode: FMULD8SUX16, DecodeIdx: 42
/* 3507 */    MCD::OPC_FilterValue, 57, 6, 0, // Skip to: 3517
/* 3511 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3513 */    MCD::OPC_Decode, 232, 3, 42, // Opcode: FMULD8ULX16, DecodeIdx: 42
/* 3517 */    MCD::OPC_FilterValue, 58, 6, 0, // Skip to: 3527
/* 3521 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3523 */    MCD::OPC_Decode, 138, 4, 40, // Opcode: FPACK32, DecodeIdx: 40
/* 3527 */    MCD::OPC_FilterValue, 59, 10, 0, // Skip to: 3541
/* 3531 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3533 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3537 */    MCD::OPC_Decode, 137, 4, 37, // Opcode: FPACK16, DecodeIdx: 37
/* 3541 */    MCD::OPC_FilterValue, 61, 10, 0, // Skip to: 3555
/* 3545 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3547 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3551 */    MCD::OPC_Decode, 139, 4, 46, // Opcode: FPACKFIX, DecodeIdx: 46
/* 3555 */    MCD::OPC_FilterValue, 62, 6, 0, // Skip to: 3565
/* 3559 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3561 */    MCD::OPC_Decode, 153, 5, 40, // Opcode: PDIST, DecodeIdx: 40
/* 3565 */    MCD::OPC_FilterValue, 63, 6, 0, // Skip to: 3575
/* 3569 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3571 */    MCD::OPC_Decode, 154, 5, 64, // Opcode: PDISTN, DecodeIdx: 64
/* 3575 */    MCD::OPC_FilterValue, 64, 6, 0, // Skip to: 3585
/* 3579 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3581 */    MCD::OPC_Decode, 207, 3, 40, // Opcode: FMEAN16, DecodeIdx: 40
/* 3585 */    MCD::OPC_FilterValue, 66, 6, 0, // Skip to: 3595
/* 3589 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3591 */    MCD::OPC_Decode, 144, 4, 40, // Opcode: FPADD64, DecodeIdx: 40
/* 3595 */    MCD::OPC_FilterValue, 68, 6, 0, // Skip to: 3605
/* 3599 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 3601 */    MCD::OPC_Decode, 168, 3, 40, // Opcode: FCHKSM16, DecodeIdx: 40
/* 3605 */    MCD::OPC_FilterValue, 72, 6, 0, // Skip to: 3615
/* 3609 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3611 */    MCD::OPC_Decode, 157, 3, 40, // Opcode: FALIGNADATA, DecodeIdx: 40
/* 3615 */    MCD::OPC_FilterValue, 75, 6, 0, // Skip to: 3625
/* 3619 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3621 */    MCD::OPC_Decode, 147, 4, 42, // Opcode: FPMERGE, DecodeIdx: 42
/* 3625 */    MCD::OPC_FilterValue, 76, 6, 0, // Skip to: 3635
/* 3629 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 3631 */    MCD::OPC_Decode, 246, 2, 40, // Opcode: BSHUFFLE, DecodeIdx: 40
/* 3635 */    MCD::OPC_FilterValue, 77, 10, 0, // Skip to: 3649
/* 3639 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3641 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3645 */    MCD::OPC_Decode, 191, 3, 44, // Opcode: FEXPAND, DecodeIdx: 44
/* 3649 */    MCD::OPC_FilterValue, 80, 6, 0, // Skip to: 3659
/* 3653 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3655 */    MCD::OPC_Decode, 140, 4, 40, // Opcode: FPADD16, DecodeIdx: 40
/* 3659 */    MCD::OPC_FilterValue, 81, 6, 0, // Skip to: 3669
/* 3663 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3665 */    MCD::OPC_Decode, 141, 4, 39, // Opcode: FPADD16S, DecodeIdx: 39
/* 3669 */    MCD::OPC_FilterValue, 82, 6, 0, // Skip to: 3679
/* 3673 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3675 */    MCD::OPC_Decode, 142, 4, 40, // Opcode: FPADD32, DecodeIdx: 40
/* 3679 */    MCD::OPC_FilterValue, 83, 6, 0, // Skip to: 3689
/* 3683 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3685 */    MCD::OPC_Decode, 143, 4, 39, // Opcode: FPADD32S, DecodeIdx: 39
/* 3689 */    MCD::OPC_FilterValue, 84, 6, 0, // Skip to: 3699
/* 3693 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3695 */    MCD::OPC_Decode, 148, 4, 40, // Opcode: FPSUB16, DecodeIdx: 40
/* 3699 */    MCD::OPC_FilterValue, 85, 6, 0, // Skip to: 3709
/* 3703 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3705 */    MCD::OPC_Decode, 149, 4, 39, // Opcode: FPSUB16S, DecodeIdx: 39
/* 3709 */    MCD::OPC_FilterValue, 86, 6, 0, // Skip to: 3719
/* 3713 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3715 */    MCD::OPC_Decode, 150, 4, 40, // Opcode: FPSUB32, DecodeIdx: 40
/* 3719 */    MCD::OPC_FilterValue, 87, 6, 0, // Skip to: 3729
/* 3723 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3725 */    MCD::OPC_Decode, 151, 4, 39, // Opcode: FPSUB32S, DecodeIdx: 39
/* 3729 */    MCD::OPC_FilterValue, 96, 14, 0, // Skip to: 3747
/* 3733 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3735 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3739 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3743 */    MCD::OPC_Decode, 186, 4, 66, // Opcode: FZERO, DecodeIdx: 66
/* 3747 */    MCD::OPC_FilterValue, 97, 14, 0, // Skip to: 3765
/* 3751 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3753 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3757 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3761 */    MCD::OPC_Decode, 187, 4, 67, // Opcode: FZEROS, DecodeIdx: 67
/* 3765 */    MCD::OPC_FilterValue, 98, 6, 0, // Skip to: 3775
/* 3769 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3771 */    MCD::OPC_Decode, 250, 3, 40, // Opcode: FNOR, DecodeIdx: 40
/* 3775 */    MCD::OPC_FilterValue, 99, 6, 0, // Skip to: 3785
/* 3779 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3781 */    MCD::OPC_Decode, 251, 3, 39, // Opcode: FNORS, DecodeIdx: 39
/* 3785 */    MCD::OPC_FilterValue, 100, 6, 0, // Skip to: 3795
/* 3789 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3791 */    MCD::OPC_Decode, 161, 3, 40, // Opcode: FANDNOT2, DecodeIdx: 40
/* 3795 */    MCD::OPC_FilterValue, 101, 6, 0, // Skip to: 3805
/* 3799 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3801 */    MCD::OPC_Decode, 162, 3, 39, // Opcode: FANDNOT2S, DecodeIdx: 39
/* 3805 */    MCD::OPC_FilterValue, 102, 10, 0, // Skip to: 3819
/* 3809 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3811 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3815 */    MCD::OPC_Decode, 254, 3, 37, // Opcode: FNOT2, DecodeIdx: 37
/* 3819 */    MCD::OPC_FilterValue, 103, 10, 0, // Skip to: 3833
/* 3823 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3825 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 3829 */    MCD::OPC_Decode, 255, 3, 36, // Opcode: FNOT2S, DecodeIdx: 36
/* 3833 */    MCD::OPC_FilterValue, 104, 6, 0, // Skip to: 3843
/* 3837 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3839 */    MCD::OPC_Decode, 159, 3, 40, // Opcode: FANDNOT1, DecodeIdx: 40
/* 3843 */    MCD::OPC_FilterValue, 105, 6, 0, // Skip to: 3853
/* 3847 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3849 */    MCD::OPC_Decode, 160, 3, 39, // Opcode: FANDNOT1S, DecodeIdx: 39
/* 3853 */    MCD::OPC_FilterValue, 106, 10, 0, // Skip to: 3867
/* 3857 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3859 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3863 */    MCD::OPC_Decode, 252, 3, 68, // Opcode: FNOT1, DecodeIdx: 68
/* 3867 */    MCD::OPC_FilterValue, 107, 10, 0, // Skip to: 3881
/* 3871 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3873 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3877 */    MCD::OPC_Decode, 253, 3, 69, // Opcode: FNOT1S, DecodeIdx: 69
/* 3881 */    MCD::OPC_FilterValue, 108, 6, 0, // Skip to: 3891
/* 3885 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3887 */    MCD::OPC_Decode, 181, 4, 40, // Opcode: FXOR, DecodeIdx: 40
/* 3891 */    MCD::OPC_FilterValue, 109, 6, 0, // Skip to: 3901
/* 3895 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3897 */    MCD::OPC_Decode, 182, 4, 39, // Opcode: FXORS, DecodeIdx: 39
/* 3901 */    MCD::OPC_FilterValue, 110, 6, 0, // Skip to: 3911
/* 3905 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3907 */    MCD::OPC_Decode, 237, 3, 40, // Opcode: FNAND, DecodeIdx: 40
/* 3911 */    MCD::OPC_FilterValue, 111, 6, 0, // Skip to: 3921
/* 3915 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3917 */    MCD::OPC_Decode, 238, 3, 39, // Opcode: FNANDS, DecodeIdx: 39
/* 3921 */    MCD::OPC_FilterValue, 112, 6, 0, // Skip to: 3931
/* 3925 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3927 */    MCD::OPC_Decode, 158, 3, 40, // Opcode: FAND, DecodeIdx: 40
/* 3931 */    MCD::OPC_FilterValue, 113, 6, 0, // Skip to: 3941
/* 3935 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3937 */    MCD::OPC_Decode, 163, 3, 39, // Opcode: FANDS, DecodeIdx: 39
/* 3941 */    MCD::OPC_FilterValue, 114, 6, 0, // Skip to: 3951
/* 3945 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3947 */    MCD::OPC_Decode, 179, 4, 40, // Opcode: FXNOR, DecodeIdx: 40
/* 3951 */    MCD::OPC_FilterValue, 115, 6, 0, // Skip to: 3961
/* 3955 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3957 */    MCD::OPC_Decode, 180, 4, 39, // Opcode: FXNORS, DecodeIdx: 39
/* 3961 */    MCD::OPC_FilterValue, 116, 10, 0, // Skip to: 3975
/* 3965 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3967 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3971 */    MCD::OPC_Decode, 166, 4, 68, // Opcode: FSRC1, DecodeIdx: 68
/* 3975 */    MCD::OPC_FilterValue, 117, 10, 0, // Skip to: 3989
/* 3979 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3981 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 3985 */    MCD::OPC_Decode, 167, 4, 69, // Opcode: FSRC1S, DecodeIdx: 69
/* 3989 */    MCD::OPC_FilterValue, 118, 6, 0, // Skip to: 3999
/* 3993 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 3995 */    MCD::OPC_Decode, 134, 4, 40, // Opcode: FORNOT2, DecodeIdx: 40
/* 3999 */    MCD::OPC_FilterValue, 119, 6, 0, // Skip to: 4009
/* 4003 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4005 */    MCD::OPC_Decode, 135, 4, 39, // Opcode: FORNOT2S, DecodeIdx: 39
/* 4009 */    MCD::OPC_FilterValue, 120, 10, 0, // Skip to: 4023
/* 4013 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4015 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4019 */    MCD::OPC_Decode, 168, 4, 37, // Opcode: FSRC2, DecodeIdx: 37
/* 4023 */    MCD::OPC_FilterValue, 121, 10, 0, // Skip to: 4037
/* 4027 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4029 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4033 */    MCD::OPC_Decode, 169, 4, 36, // Opcode: FSRC2S, DecodeIdx: 36
/* 4037 */    MCD::OPC_FilterValue, 122, 6, 0, // Skip to: 4047
/* 4041 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4043 */    MCD::OPC_Decode, 132, 4, 40, // Opcode: FORNOT1, DecodeIdx: 40
/* 4047 */    MCD::OPC_FilterValue, 123, 6, 0, // Skip to: 4057
/* 4051 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4053 */    MCD::OPC_Decode, 133, 4, 39, // Opcode: FORNOT1S, DecodeIdx: 39
/* 4057 */    MCD::OPC_FilterValue, 124, 6, 0, // Skip to: 4067
/* 4061 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4063 */    MCD::OPC_Decode, 131, 4, 40, // Opcode: FOR, DecodeIdx: 40
/* 4067 */    MCD::OPC_FilterValue, 125, 6, 0, // Skip to: 4077
/* 4071 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4073 */    MCD::OPC_Decode, 136, 4, 39, // Opcode: FORS, DecodeIdx: 39
/* 4077 */    MCD::OPC_FilterValue, 126, 14, 0, // Skip to: 4095
/* 4081 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4083 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4087 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 4091 */    MCD::OPC_Decode, 129, 4, 66, // Opcode: FONE, DecodeIdx: 66
/* 4095 */    MCD::OPC_FilterValue, 127, 14, 0, // Skip to: 4113
/* 4099 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4101 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4105 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 4109 */    MCD::OPC_Decode, 130, 4, 67, // Opcode: FONES, DecodeIdx: 67
/* 4113 */    MCD::OPC_FilterValue, 128, 1, 18, 0, // Skip to: 4136
/* 4118 */    MCD::OPC_CheckPredicateOrFail, 5, 
/* 4120 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4124 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4128 */    MCD::OPC_CheckFieldOrFail, 0, 5, 0, 
/* 4132 */    MCD::OPC_Decode, 186, 5, 7, // Opcode: SHUTDOWN, DecodeIdx: 7
/* 4136 */    MCD::OPC_FilterValue, 129, 1, 18, 0, // Skip to: 4159
/* 4141 */    MCD::OPC_CheckPredicateOrFail, 6, 
/* 4143 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4147 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4151 */    MCD::OPC_CheckFieldOrFail, 3, 2, 0, 
/* 4155 */    MCD::OPC_Decode, 187, 5, 70, // Opcode: SIAM, DecodeIdx: 70
/* 4159 */    MCD::OPC_FilterValue, 144, 2, 10, 0, // Skip to: 4174
/* 4164 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4166 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4170 */    MCD::OPC_Decode, 253, 4, 71, // Opcode: MOVDTOX, DecodeIdx: 71
/* 4174 */    MCD::OPC_FilterValue, 145, 2, 10, 0, // Skip to: 4189
/* 4179 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4181 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4185 */    MCD::OPC_Decode, 133, 5, 72, // Opcode: MOVSTOUW, DecodeIdx: 72
/* 4189 */    MCD::OPC_FilterValue, 147, 2, 10, 0, // Skip to: 4204
/* 4194 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4196 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4200 */    MCD::OPC_Decode, 132, 5, 72, // Opcode: MOVSTOSW, DecodeIdx: 72
/* 4204 */    MCD::OPC_FilterValue, 149, 2, 6, 0, // Skip to: 4215
/* 4209 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4211 */    MCD::OPC_Decode, 196, 6, 13, // Opcode: XMULX, DecodeIdx: 13
/* 4215 */    MCD::OPC_FilterValue, 150, 2, 6, 0, // Skip to: 4226
/* 4220 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4222 */    MCD::OPC_Decode, 197, 6, 13, // Opcode: XMULXHI, DecodeIdx: 13
/* 4226 */    MCD::OPC_FilterValue, 152, 2, 10, 0, // Skip to: 4241
/* 4231 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4233 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4237 */    MCD::OPC_Decode, 137, 5, 73, // Opcode: MOVXTOD, DecodeIdx: 73
/* 4241 */    MCD::OPC_FilterValue, 153, 2, 10, 0, // Skip to: 4256
/* 4246 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4248 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4252 */    MCD::OPC_Decode, 134, 5, 74, // Opcode: MOVWTOS, DecodeIdx: 74
/* 4256 */    MCD::OPC_FilterValue, 209, 2, 6, 0, // Skip to: 4267
/* 4261 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4263 */    MCD::OPC_Decode, 200, 3, 59, // Opcode: FLCMPS, DecodeIdx: 59
/* 4267 */    MCD::OPC_FilterValueOrFail, 210, 2, 
/* 4270 */    MCD::OPC_CheckPredicateOrFail, 4, 
/* 4272 */    MCD::OPC_Decode, 199, 3, 60, // Opcode: FLCMPD, DecodeIdx: 60
/* 4276 */    MCD::OPC_FilterValue, 55, 101, 0, // Skip to: 4381
/* 4280 */    MCD::OPC_ExtractField, 5, 4,  // Inst{8-5} ...
/* 4283 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 4293
/* 4287 */    MCD::OPC_CheckPredicateOrFail, 1, 
/* 4289 */    MCD::OPC_Decode, 145, 4, 75, // Opcode: FPMADDX, DecodeIdx: 75
/* 4293 */    MCD::OPC_FilterValue, 1, 6, 0, // Skip to: 4303
/* 4297 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4299 */    MCD::OPC_Decode, 206, 3, 76, // Opcode: FMADDS, DecodeIdx: 76
/* 4303 */    MCD::OPC_FilterValue, 2, 6, 0, // Skip to: 4313
/* 4307 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4309 */    MCD::OPC_Decode, 205, 3, 75, // Opcode: FMADDD, DecodeIdx: 75
/* 4313 */    MCD::OPC_FilterValue, 4, 6, 0, // Skip to: 4323
/* 4317 */    MCD::OPC_CheckPredicateOrFail, 1, 
/* 4319 */    MCD::OPC_Decode, 146, 4, 75, // Opcode: FPMADDXHI, DecodeIdx: 75
/* 4323 */    MCD::OPC_FilterValue, 5, 6, 0, // Skip to: 4333
/* 4327 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4329 */    MCD::OPC_Decode, 224, 3, 76, // Opcode: FMSUBS, DecodeIdx: 76
/* 4333 */    MCD::OPC_FilterValue, 6, 6, 0, // Skip to: 4343
/* 4337 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4339 */    MCD::OPC_Decode, 223, 3, 75, // Opcode: FMSUBD, DecodeIdx: 75
/* 4343 */    MCD::OPC_FilterValue, 9, 6, 0, // Skip to: 4353
/* 4347 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4349 */    MCD::OPC_Decode, 247, 3, 76, // Opcode: FNMSUBS, DecodeIdx: 76
/* 4353 */    MCD::OPC_FilterValue, 10, 6, 0, // Skip to: 4363
/* 4357 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4359 */    MCD::OPC_Decode, 246, 3, 75, // Opcode: FNMSUBD, DecodeIdx: 75
/* 4363 */    MCD::OPC_FilterValue, 13, 6, 0, // Skip to: 4373
/* 4367 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4369 */    MCD::OPC_Decode, 245, 3, 76, // Opcode: FNMADDS, DecodeIdx: 76
/* 4373 */    MCD::OPC_FilterValueOrFail, 14, 
/* 4375 */    MCD::OPC_CheckPredicateOrFail, 7, 
/* 4377 */    MCD::OPC_Decode, 244, 3, 75, // Opcode: FNMADDD, DecodeIdx: 75
/* 4381 */    MCD::OPC_FilterValue, 56, 21, 0, // Skip to: 4406
/* 4385 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4388 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4400
/* 4392 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4396 */    MCD::OPC_Decode, 192, 4, 77, // Opcode: JMPLrr, DecodeIdx: 77
/* 4400 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4402 */    MCD::OPC_Decode, 191, 4, 78, // Opcode: JMPLri, DecodeIdx: 78
/* 4406 */    MCD::OPC_FilterValue, 57, 29, 0, // Skip to: 4439
/* 4410 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4413 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 4429
/* 4417 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4421 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4425 */    MCD::OPC_Decode, 175, 5, 79, // Opcode: RETTrr, DecodeIdx: 79
/* 4429 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4431 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4435 */    MCD::OPC_Decode, 174, 5, 80, // Opcode: RETTri, DecodeIdx: 80
/* 4439 */    MCD::OPC_FilterValue, 58, 86, 0, // Skip to: 4529
/* 4443 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 4446 */    MCD::OPC_FilterValue, 16, 14, 0, // Skip to: 4464
/* 4450 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 4452 */    MCD::OPC_CheckFieldOrFail, 29, 1, 0, 
/* 4456 */    MCD::OPC_CheckFieldOrFail, 5, 3, 0, 
/* 4460 */    MCD::OPC_Decode, 160, 6, 81, // Opcode: TXCCrr, DecodeIdx: 81
/* 4464 */    MCD::OPC_FilterValue, 32, 49, 0, // Skip to: 4517
/* 4468 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 4471 */    MCD::OPC_FilterValue, 1, 12, 0, // Skip to: 4487
/* 4475 */    MCD::OPC_CheckFieldOrFail, 25, 5, 8, 
/* 4479 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4483 */    MCD::OPC_Decode, 138, 6, 7, // Opcode: TA1, DecodeIdx: 7
/* 4487 */    MCD::OPC_FilterValue, 3, 12, 0, // Skip to: 4503
/* 4491 */    MCD::OPC_CheckFieldOrFail, 25, 5, 8, 
/* 4495 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4499 */    MCD::OPC_Decode, 139, 6, 7, // Opcode: TA3, DecodeIdx: 7
/* 4503 */    MCD::OPC_FilterValueOrFail, 5, 
/* 4505 */    MCD::OPC_CheckFieldOrFail, 25, 5, 8, 
/* 4509 */    MCD::OPC_CheckFieldOrFail, 14, 5, 0, 
/* 4513 */    MCD::OPC_Decode, 140, 6, 7, // Opcode: TA5, DecodeIdx: 7
/* 4517 */    MCD::OPC_FilterValueOrFail, 48, 
/* 4519 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 4521 */    MCD::OPC_CheckFieldOrFail, 29, 1, 0, 
/* 4525 */    MCD::OPC_Decode, 159, 6, 82, // Opcode: TXCCri, DecodeIdx: 82
/* 4529 */    MCD::OPC_FilterValue, 59, 47, 0, // Skip to: 4580
/* 4533 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4536 */    MCD::OPC_FilterValue, 0, 30, 0, // Skip to: 4570
/* 4540 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 4543 */    MCD::OPC_FilterValueOrFail, 0, 
/* 4545 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 4548 */    MCD::OPC_FilterValueOrFail, 0, 
/* 4550 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 4566
/* 4556 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 4566
/* 4562 */    MCD::OPC_Decode, 201, 3, 7, // Opcode: FLUSH, DecodeIdx: 7
/* 4566 */    MCD::OPC_Decode, 204, 3, 79, // Opcode: FLUSHrr, DecodeIdx: 79
/* 4570 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4572 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 4576 */    MCD::OPC_Decode, 203, 3, 80, // Opcode: FLUSHri, DecodeIdx: 80
/* 4580 */    MCD::OPC_FilterValue, 60, 21, 0, // Skip to: 4605
/* 4584 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4587 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4599
/* 4591 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4595 */    MCD::OPC_Decode, 178, 5, 11, // Opcode: SAVErr, DecodeIdx: 11
/* 4599 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4601 */    MCD::OPC_Decode, 177, 5, 12, // Opcode: SAVEri, DecodeIdx: 12
/* 4605 */    MCD::OPC_FilterValue, 61, 21, 0, // Skip to: 4630
/* 4609 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4612 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4624
/* 4616 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4620 */    MCD::OPC_Decode, 170, 5, 11, // Opcode: RESTORErr, DecodeIdx: 11
/* 4624 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4626 */    MCD::OPC_Decode, 169, 5, 12, // Opcode: RESTOREri, DecodeIdx: 12
/* 4630 */    MCD::OPC_FilterValue, 62, 73, 0, // Skip to: 4707
/* 4634 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4637 */    MCD::OPC_FilterValue, 0, 60, 0, // Skip to: 4701
/* 4641 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 4644 */    MCD::OPC_FilterValueOrFail, 0, 
/* 4646 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 4649 */    MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 4673
/* 4653 */    MCD::OPC_CheckPredicate, 0, 40, 0, // Skip to: 4697
/* 4657 */    MCD::OPC_CheckField, 14, 5, 0, 34, 0, // Skip to: 4697
/* 4663 */    MCD::OPC_CheckField, 0, 5, 0, 28, 0, // Skip to: 4697
/* 4669 */    MCD::OPC_Decode, 138, 3, 7, // Opcode: DONE, DecodeIdx: 7
/* 4673 */    MCD::OPC_FilterValue, 1, 20, 0, // Skip to: 4697
/* 4677 */    MCD::OPC_CheckPredicate, 0, 16, 0, // Skip to: 4697
/* 4681 */    MCD::OPC_CheckField, 14, 5, 0, 10, 0, // Skip to: 4697
/* 4687 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, // Skip to: 4697
/* 4693 */    MCD::OPC_Decode, 173, 5, 7, // Opcode: RETRY, DecodeIdx: 7
/* 4697 */    MCD::OPC_Decode, 168, 6, 11, // Opcode: UMACrr, DecodeIdx: 11
/* 4701 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4703 */    MCD::OPC_Decode, 167, 6, 12, // Opcode: UMACri, DecodeIdx: 12
/* 4707 */    MCD::OPC_FilterValueOrFail, 63, 
/* 4709 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4712 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4724
/* 4716 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4720 */    MCD::OPC_Decode, 194, 5, 11, // Opcode: SMACrr, DecodeIdx: 11
/* 4724 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4726 */    MCD::OPC_Decode, 193, 5, 12, // Opcode: SMACri, DecodeIdx: 12
/* 4730 */    MCD::OPC_FilterValueOrFail, 3, 
/* 4732 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 4735 */    MCD::OPC_FilterValue, 0, 21, 0, // Skip to: 4760
/* 4739 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4742 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4754
/* 4746 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4750 */    MCD::OPC_Decode, 250, 4, 77, // Opcode: LDrr, DecodeIdx: 77
/* 4754 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4756 */    MCD::OPC_Decode, 249, 4, 78, // Opcode: LDri, DecodeIdx: 78
/* 4760 */    MCD::OPC_FilterValue, 1, 21, 0, // Skip to: 4785
/* 4764 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4767 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4779
/* 4771 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4775 */    MCD::OPC_Decode, 238, 4, 77, // Opcode: LDUBrr, DecodeIdx: 77
/* 4779 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4781 */    MCD::OPC_Decode, 237, 4, 78, // Opcode: LDUBri, DecodeIdx: 78
/* 4785 */    MCD::OPC_FilterValue, 2, 21, 0, // Skip to: 4810
/* 4789 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4792 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4804
/* 4796 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4800 */    MCD::OPC_Decode, 242, 4, 77, // Opcode: LDUHrr, DecodeIdx: 77
/* 4804 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4806 */    MCD::OPC_Decode, 241, 4, 78, // Opcode: LDUHri, DecodeIdx: 78
/* 4810 */    MCD::OPC_FilterValue, 3, 21, 0, // Skip to: 4835
/* 4814 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4817 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4829
/* 4821 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4825 */    MCD::OPC_Decode, 208, 4, 83, // Opcode: LDDrr, DecodeIdx: 83
/* 4829 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4831 */    MCD::OPC_Decode, 207, 4, 84, // Opcode: LDDri, DecodeIdx: 84
/* 4835 */    MCD::OPC_FilterValue, 4, 21, 0, // Skip to: 4860
/* 4839 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4842 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4854
/* 4846 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4850 */    MCD::OPC_Decode, 253, 5, 85, // Opcode: STrr, DecodeIdx: 85
/* 4854 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4856 */    MCD::OPC_Decode, 252, 5, 86, // Opcode: STri, DecodeIdx: 86
/* 4860 */    MCD::OPC_FilterValue, 5, 21, 0, // Skip to: 4885
/* 4864 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4867 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4879
/* 4871 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4875 */    MCD::OPC_Decode, 213, 5, 85, // Opcode: STBrr, DecodeIdx: 85
/* 4879 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4881 */    MCD::OPC_Decode, 212, 5, 86, // Opcode: STBri, DecodeIdx: 86
/* 4885 */    MCD::OPC_FilterValue, 6, 21, 0, // Skip to: 4910
/* 4889 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4892 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4904
/* 4896 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4900 */    MCD::OPC_Decode, 241, 5, 85, // Opcode: STHrr, DecodeIdx: 85
/* 4904 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4906 */    MCD::OPC_Decode, 240, 5, 86, // Opcode: STHri, DecodeIdx: 86
/* 4910 */    MCD::OPC_FilterValue, 7, 21, 0, // Skip to: 4935
/* 4914 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4917 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4929
/* 4921 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4925 */    MCD::OPC_Decode, 231, 5, 87, // Opcode: STDrr, DecodeIdx: 87
/* 4929 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4931 */    MCD::OPC_Decode, 230, 5, 88, // Opcode: STDri, DecodeIdx: 88
/* 4935 */    MCD::OPC_FilterValue, 8, 25, 0, // Skip to: 4964
/* 4939 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4942 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 4956
/* 4946 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 4948 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4952 */    MCD::OPC_Decode, 234, 4, 89, // Opcode: LDSWrr, DecodeIdx: 89
/* 4956 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4958 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 4960 */    MCD::OPC_Decode, 233, 4, 90, // Opcode: LDSWri, DecodeIdx: 90
/* 4964 */    MCD::OPC_FilterValue, 9, 21, 0, // Skip to: 4989
/* 4968 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4971 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 4983
/* 4975 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 4979 */    MCD::OPC_Decode, 222, 4, 77, // Opcode: LDSBrr, DecodeIdx: 77
/* 4983 */    MCD::OPC_FilterValueOrFail, 1, 
/* 4985 */    MCD::OPC_Decode, 221, 4, 78, // Opcode: LDSBri, DecodeIdx: 78
/* 4989 */    MCD::OPC_FilterValue, 10, 21, 0, // Skip to: 5014
/* 4993 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 4996 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5008
/* 5000 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5004 */    MCD::OPC_Decode, 226, 4, 77, // Opcode: LDSHrr, DecodeIdx: 77
/* 5008 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5010 */    MCD::OPC_Decode, 225, 4, 78, // Opcode: LDSHri, DecodeIdx: 78
/* 5014 */    MCD::OPC_FilterValue, 11, 25, 0, // Skip to: 5043
/* 5018 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5021 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5035
/* 5025 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5027 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5031 */    MCD::OPC_Decode, 248, 4, 89, // Opcode: LDXrr, DecodeIdx: 89
/* 5035 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5037 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5039 */    MCD::OPC_Decode, 247, 4, 90, // Opcode: LDXri, DecodeIdx: 90
/* 5043 */    MCD::OPC_FilterValue, 13, 21, 0, // Skip to: 5068
/* 5047 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5050 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5062
/* 5054 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5058 */    MCD::OPC_Decode, 230, 4, 77, // Opcode: LDSTUBrr, DecodeIdx: 77
/* 5062 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5064 */    MCD::OPC_Decode, 229, 4, 78, // Opcode: LDSTUBri, DecodeIdx: 78
/* 5068 */    MCD::OPC_FilterValue, 14, 25, 0, // Skip to: 5097
/* 5072 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5075 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5089
/* 5079 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5081 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5085 */    MCD::OPC_Decode, 251, 5, 91, // Opcode: STXrr, DecodeIdx: 91
/* 5089 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5091 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5093 */    MCD::OPC_Decode, 250, 5, 92, // Opcode: STXri, DecodeIdx: 92
/* 5097 */    MCD::OPC_FilterValue, 15, 21, 0, // Skip to: 5122
/* 5101 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5104 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5116
/* 5108 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5112 */    MCD::OPC_Decode, 137, 6, 93, // Opcode: SWAPrr, DecodeIdx: 93
/* 5116 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5118 */    MCD::OPC_Decode, 136, 6, 94, // Opcode: SWAPri, DecodeIdx: 94
/* 5122 */    MCD::OPC_FilterValue, 16, 19, 0, // Skip to: 5145
/* 5126 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5129 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5137
/* 5133 */    MCD::OPC_Decode, 194, 4, 95, // Opcode: LDArr, DecodeIdx: 95
/* 5137 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5139 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5141 */    MCD::OPC_Decode, 193, 4, 78, // Opcode: LDAri, DecodeIdx: 78
/* 5145 */    MCD::OPC_FilterValue, 17, 19, 0, // Skip to: 5168
/* 5149 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5152 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5160
/* 5156 */    MCD::OPC_Decode, 236, 4, 95, // Opcode: LDUBArr, DecodeIdx: 95
/* 5160 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5162 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5164 */    MCD::OPC_Decode, 235, 4, 78, // Opcode: LDUBAri, DecodeIdx: 78
/* 5168 */    MCD::OPC_FilterValue, 18, 19, 0, // Skip to: 5191
/* 5172 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5175 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5183
/* 5179 */    MCD::OPC_Decode, 240, 4, 95, // Opcode: LDUHArr, DecodeIdx: 95
/* 5183 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5185 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5187 */    MCD::OPC_Decode, 239, 4, 78, // Opcode: LDUHAri, DecodeIdx: 78
/* 5191 */    MCD::OPC_FilterValue, 19, 19, 0, // Skip to: 5214
/* 5195 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5198 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5206
/* 5202 */    MCD::OPC_Decode, 200, 4, 96, // Opcode: LDDArr, DecodeIdx: 96
/* 5206 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5208 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5210 */    MCD::OPC_Decode, 199, 4, 84, // Opcode: LDDAri, DecodeIdx: 84
/* 5214 */    MCD::OPC_FilterValue, 20, 19, 0, // Skip to: 5237
/* 5218 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5221 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5229
/* 5225 */    MCD::OPC_Decode, 208, 5, 97, // Opcode: STArr, DecodeIdx: 97
/* 5229 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5231 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5233 */    MCD::OPC_Decode, 207, 5, 86, // Opcode: STAri, DecodeIdx: 86
/* 5237 */    MCD::OPC_FilterValue, 21, 19, 0, // Skip to: 5260
/* 5241 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5244 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5252
/* 5248 */    MCD::OPC_Decode, 211, 5, 97, // Opcode: STBArr, DecodeIdx: 97
/* 5252 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5254 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5256 */    MCD::OPC_Decode, 210, 5, 86, // Opcode: STBAri, DecodeIdx: 86
/* 5260 */    MCD::OPC_FilterValue, 22, 19, 0, // Skip to: 5283
/* 5264 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5267 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5275
/* 5271 */    MCD::OPC_Decode, 239, 5, 97, // Opcode: STHArr, DecodeIdx: 97
/* 5275 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5277 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5279 */    MCD::OPC_Decode, 238, 5, 86, // Opcode: STHAri, DecodeIdx: 86
/* 5283 */    MCD::OPC_FilterValue, 23, 19, 0, // Skip to: 5306
/* 5287 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5290 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5298
/* 5294 */    MCD::OPC_Decode, 219, 5, 98, // Opcode: STDArr, DecodeIdx: 98
/* 5298 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5300 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5302 */    MCD::OPC_Decode, 218, 5, 88, // Opcode: STDAri, DecodeIdx: 88
/* 5306 */    MCD::OPC_FilterValue, 24, 21, 0, // Skip to: 5331
/* 5310 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5313 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5323
/* 5317 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5319 */    MCD::OPC_Decode, 232, 4, 99, // Opcode: LDSWArr, DecodeIdx: 99
/* 5323 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5325 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5327 */    MCD::OPC_Decode, 231, 4, 90, // Opcode: LDSWAri, DecodeIdx: 90
/* 5331 */    MCD::OPC_FilterValue, 25, 19, 0, // Skip to: 5354
/* 5335 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5338 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5346
/* 5342 */    MCD::OPC_Decode, 220, 4, 95, // Opcode: LDSBArr, DecodeIdx: 95
/* 5346 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5348 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5350 */    MCD::OPC_Decode, 219, 4, 78, // Opcode: LDSBAri, DecodeIdx: 78
/* 5354 */    MCD::OPC_FilterValue, 26, 19, 0, // Skip to: 5377
/* 5358 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5361 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5369
/* 5365 */    MCD::OPC_Decode, 224, 4, 95, // Opcode: LDSHArr, DecodeIdx: 95
/* 5369 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5371 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5373 */    MCD::OPC_Decode, 223, 4, 78, // Opcode: LDSHAri, DecodeIdx: 78
/* 5377 */    MCD::OPC_FilterValue, 27, 21, 0, // Skip to: 5402
/* 5381 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5384 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5394
/* 5388 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5390 */    MCD::OPC_Decode, 244, 4, 99, // Opcode: LDXArr, DecodeIdx: 99
/* 5394 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5396 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5398 */    MCD::OPC_Decode, 243, 4, 90, // Opcode: LDXAri, DecodeIdx: 90
/* 5402 */    MCD::OPC_FilterValue, 29, 19, 0, // Skip to: 5425
/* 5406 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5409 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5417
/* 5413 */    MCD::OPC_Decode, 228, 4, 95, // Opcode: LDSTUBArr, DecodeIdx: 95
/* 5417 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5419 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5421 */    MCD::OPC_Decode, 227, 4, 78, // Opcode: LDSTUBAri, DecodeIdx: 78
/* 5425 */    MCD::OPC_FilterValue, 30, 21, 0, // Skip to: 5450
/* 5429 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5432 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5442
/* 5436 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5438 */    MCD::OPC_Decode, 247, 5, 100, // Opcode: STXArr, DecodeIdx: 100
/* 5442 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5444 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5446 */    MCD::OPC_Decode, 246, 5, 92, // Opcode: STXAri, DecodeIdx: 92
/* 5450 */    MCD::OPC_FilterValue, 31, 19, 0, // Skip to: 5473
/* 5454 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5457 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5465
/* 5461 */    MCD::OPC_Decode, 135, 6, 101, // Opcode: SWAPArr, DecodeIdx: 101
/* 5465 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5467 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5469 */    MCD::OPC_Decode, 134, 6, 94, // Opcode: SWAPAri, DecodeIdx: 94
/* 5473 */    MCD::OPC_FilterValue, 32, 21, 0, // Skip to: 5498
/* 5477 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5480 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5492
/* 5484 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5488 */    MCD::OPC_Decode, 214, 4, 102, // Opcode: LDFrr, DecodeIdx: 102
/* 5492 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5494 */    MCD::OPC_Decode, 213, 4, 103, // Opcode: LDFri, DecodeIdx: 103
/* 5498 */    MCD::OPC_FilterValue, 33, 55, 0, // Skip to: 5557
/* 5502 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5505 */    MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 5536
/* 5509 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5512 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5524
/* 5516 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5520 */    MCD::OPC_Decode, 212, 4, 79, // Opcode: LDFSRrr, DecodeIdx: 79
/* 5524 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5526 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5528 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5532 */    MCD::OPC_Decode, 246, 4, 79, // Opcode: LDXFSRrr, DecodeIdx: 79
/* 5536 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5538 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5541 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5549
/* 5545 */    MCD::OPC_Decode, 211, 4, 80, // Opcode: LDFSRri, DecodeIdx: 80
/* 5549 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5551 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5553 */    MCD::OPC_Decode, 245, 4, 80, // Opcode: LDXFSRri, DecodeIdx: 80
/* 5557 */    MCD::OPC_FilterValue, 35, 21, 0, // Skip to: 5582
/* 5561 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5564 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5576
/* 5568 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5572 */    MCD::OPC_Decode, 206, 4, 104, // Opcode: LDDFrr, DecodeIdx: 104
/* 5576 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5578 */    MCD::OPC_Decode, 205, 4, 105, // Opcode: LDDFri, DecodeIdx: 105
/* 5582 */    MCD::OPC_FilterValue, 36, 21, 0, // Skip to: 5607
/* 5586 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5589 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5601
/* 5593 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5597 */    MCD::OPC_Decode, 237, 5, 106, // Opcode: STFrr, DecodeIdx: 106
/* 5601 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5603 */    MCD::OPC_Decode, 236, 5, 107, // Opcode: STFri, DecodeIdx: 107
/* 5607 */    MCD::OPC_FilterValue, 37, 55, 0, // Skip to: 5666
/* 5611 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5614 */    MCD::OPC_FilterValue, 0, 27, 0, // Skip to: 5645
/* 5618 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5621 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5633
/* 5625 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5629 */    MCD::OPC_Decode, 235, 5, 79, // Opcode: STFSRrr, DecodeIdx: 79
/* 5633 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5635 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5637 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5641 */    MCD::OPC_Decode, 249, 5, 79, // Opcode: STXFSRrr, DecodeIdx: 79
/* 5645 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5647 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 5650 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 5658
/* 5654 */    MCD::OPC_Decode, 234, 5, 80, // Opcode: STFSRri, DecodeIdx: 80
/* 5658 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5660 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5662 */    MCD::OPC_Decode, 248, 5, 80, // Opcode: STXFSRri, DecodeIdx: 80
/* 5666 */    MCD::OPC_FilterValue, 38, 29, 0, // Skip to: 5699
/* 5670 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5673 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5689
/* 5677 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5681 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5685 */    MCD::OPC_Decode, 227, 5, 79, // Opcode: STDFQrr, DecodeIdx: 79
/* 5689 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5691 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5695 */    MCD::OPC_Decode, 226, 5, 80, // Opcode: STDFQri, DecodeIdx: 80
/* 5699 */    MCD::OPC_FilterValue, 39, 21, 0, // Skip to: 5724
/* 5703 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5706 */    MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 5718
/* 5710 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5714 */    MCD::OPC_Decode, 229, 5, 108, // Opcode: STDFrr, DecodeIdx: 108
/* 5718 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5720 */    MCD::OPC_Decode, 228, 5, 109, // Opcode: STDFri, DecodeIdx: 109
/* 5724 */    MCD::OPC_FilterValue, 45, 25, 0, // Skip to: 5753
/* 5728 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5731 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 5745
/* 5735 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5737 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5741 */    MCD::OPC_Decode, 159, 5, 110, // Opcode: PREFETCHr, DecodeIdx: 110
/* 5745 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5747 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5749 */    MCD::OPC_Decode, 158, 5, 111, // Opcode: PREFETCHi, DecodeIdx: 111
/* 5753 */    MCD::OPC_FilterValue, 49, 29, 0, // Skip to: 5786
/* 5757 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5760 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5776
/* 5764 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5768 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5772 */    MCD::OPC_Decode, 196, 4, 79, // Opcode: LDCSRrr, DecodeIdx: 79
/* 5776 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5778 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5782 */    MCD::OPC_Decode, 195, 4, 80, // Opcode: LDCSRri, DecodeIdx: 80
/* 5786 */    MCD::OPC_FilterValue, 53, 29, 0, // Skip to: 5819
/* 5790 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5793 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5809
/* 5797 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5801 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5805 */    MCD::OPC_Decode, 215, 5, 79, // Opcode: STCSRrr, DecodeIdx: 79
/* 5809 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5811 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5815 */    MCD::OPC_Decode, 214, 5, 80, // Opcode: STCSRri, DecodeIdx: 80
/* 5819 */    MCD::OPC_FilterValue, 54, 29, 0, // Skip to: 5852
/* 5823 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5826 */    MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 5842
/* 5830 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5834 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5838 */    MCD::OPC_Decode, 221, 5, 79, // Opcode: STDCQrr, DecodeIdx: 79
/* 5842 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5844 */    MCD::OPC_CheckFieldOrFail, 25, 5, 0, 
/* 5848 */    MCD::OPC_Decode, 220, 5, 80, // Opcode: STDCQri, DecodeIdx: 80
/* 5852 */    MCD::OPC_FilterValue, 60, 25, 0, // Skip to: 5881
/* 5856 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5859 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5869
/* 5863 */    MCD::OPC_CheckPredicateOrFail, 8, 
/* 5865 */    MCD::OPC_Decode, 254, 2, 112, // Opcode: CASArr, DecodeIdx: 112
/* 5869 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5871 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5873 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5877 */    MCD::OPC_Decode, 253, 2, 113, // Opcode: CASAri, DecodeIdx: 113
/* 5881 */    MCD::OPC_FilterValue, 61, 21, 0, // Skip to: 5906
/* 5885 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5888 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5898
/* 5892 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5894 */    MCD::OPC_Decode, 157, 5, 114, // Opcode: PREFETCHAr, DecodeIdx: 114
/* 5898 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5900 */    MCD::OPC_CheckPredicateOrFail, 0, 
/* 5902 */    MCD::OPC_Decode, 156, 5, 111, // Opcode: PREFETCHAi, DecodeIdx: 111
/* 5906 */    MCD::OPC_FilterValueOrFail, 62, 
/* 5908 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 5911 */    MCD::OPC_FilterValue, 0, 6, 0, // Skip to: 5921
/* 5915 */    MCD::OPC_CheckPredicateOrFail, 9, 
/* 5917 */    MCD::OPC_Decode, 128, 3, 115, // Opcode: CASXArr, DecodeIdx: 115
/* 5921 */    MCD::OPC_FilterValueOrFail, 1, 
/* 5923 */    MCD::OPC_CheckPredicateOrFail, 9, 
/* 5925 */    MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 5929 */    MCD::OPC_Decode, 255, 2, 116, // Opcode: CASXAri, DecodeIdx: 116
/* 5933 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 48, 29, 0, // Skip to: 36
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 26
/* 14 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 18 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 22 */      MCD::OPC_Decode, 198, 4, 117, // Opcode: LDCrr, DecodeIdx: 117
/* 26 */      MCD::OPC_FilterValueOrFail, 1, 
/* 28 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 32 */      MCD::OPC_Decode, 197, 4, 118, // Opcode: LDCri, DecodeIdx: 118
/* 36 */      MCD::OPC_FilterValue, 51, 29, 0, // Skip to: 69
/* 40 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 43 */      MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 59
/* 47 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 51 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 55 */      MCD::OPC_Decode, 202, 4, 119, // Opcode: LDDCrr, DecodeIdx: 119
/* 59 */      MCD::OPC_FilterValueOrFail, 1, 
/* 61 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 65 */      MCD::OPC_Decode, 201, 4, 120, // Opcode: LDDCri, DecodeIdx: 120
/* 69 */      MCD::OPC_FilterValue, 52, 29, 0, // Skip to: 102
/* 73 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 76 */      MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 92
/* 80 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 84 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 88 */      MCD::OPC_Decode, 217, 5, 121, // Opcode: STCrr, DecodeIdx: 121
/* 92 */      MCD::OPC_FilterValueOrFail, 1, 
/* 94 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 98 */      MCD::OPC_Decode, 216, 5, 122, // Opcode: STCri, DecodeIdx: 122
/* 102 */     MCD::OPC_FilterValue, 55, 29, 0, // Skip to: 135
/* 106 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 109 */     MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 125
/* 113 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 117 */     MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 121 */     MCD::OPC_Decode, 223, 5, 123, // Opcode: STDCrr, DecodeIdx: 123
/* 125 */     MCD::OPC_FilterValueOrFail, 1, 
/* 127 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 131 */     MCD::OPC_Decode, 222, 5, 124, // Opcode: STDCri, DecodeIdx: 124
/* 135 */     MCD::OPC_FilterValueOrFail, 58, 
/* 137 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 140 */     MCD::OPC_FilterValue, 0, 12, 0, // Skip to: 156
/* 144 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 148 */     MCD::OPC_CheckFieldOrFail, 5, 3, 0, 
/* 152 */     MCD::OPC_Decode, 154, 6, 81, // Opcode: TRAPrr, DecodeIdx: 81
/* 156 */     MCD::OPC_FilterValueOrFail, 32, 
/* 158 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 162 */     MCD::OPC_Decode, 153, 6, 82, // Opcode: TRAPri, DecodeIdx: 82
/* 166 */     MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 3 */       MCD::OPC_FilterValue, 34, 33, 0, // Skip to: 40
/* 7 */       MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 10 */      MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 28
/* 14 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 16 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 20 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 24 */      MCD::OPC_Decode, 218, 4, 125, // Opcode: LDQFrr, DecodeIdx: 125
/* 28 */      MCD::OPC_FilterValueOrFail, 1, 
/* 30 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 32 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 36 */      MCD::OPC_Decode, 217, 4, 126, // Opcode: LDQFri, DecodeIdx: 126
/* 40 */      MCD::OPC_FilterValue, 38, 34, 0, // Skip to: 78
/* 44 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 47 */      MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 65
/* 51 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 53 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 57 */      MCD::OPC_CheckFieldOrFail, 5, 8, 0, 
/* 61 */      MCD::OPC_Decode, 245, 5, 127, // Opcode: STQFrr, DecodeIdx: 127
/* 65 */      MCD::OPC_FilterValueOrFail, 1, 
/* 67 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 69 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 73 */      MCD::OPC_Decode, 244, 5, 128, 1, // Opcode: STQFri, DecodeIdx: 128
/* 78 */      MCD::OPC_FilterValue, 48, 30, 0, // Skip to: 112
/* 82 */      MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 85 */      MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 100
/* 89 */      MCD::OPC_CheckPredicateOrFail, 0, 
/* 91 */      MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 95 */      MCD::OPC_Decode, 210, 4, 129, 1, // Opcode: LDFArr, DecodeIdx: 129
/* 100 */     MCD::OPC_FilterValueOrFail, 1, 
/* 102 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 104 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 108 */     MCD::OPC_Decode, 209, 4, 103, // Opcode: LDFAri, DecodeIdx: 103
/* 112 */     MCD::OPC_FilterValue, 50, 30, 0, // Skip to: 146
/* 116 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 119 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 134
/* 123 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 125 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 129 */     MCD::OPC_Decode, 216, 4, 130, 1, // Opcode: LDQFArr, DecodeIdx: 130
/* 134 */     MCD::OPC_FilterValueOrFail, 1, 
/* 136 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 138 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 142 */     MCD::OPC_Decode, 215, 4, 126, // Opcode: LDQFAri, DecodeIdx: 126
/* 146 */     MCD::OPC_FilterValue, 51, 30, 0, // Skip to: 180
/* 150 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 153 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 168
/* 157 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 159 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 163 */     MCD::OPC_Decode, 204, 4, 131, 1, // Opcode: LDDFArr, DecodeIdx: 131
/* 168 */     MCD::OPC_FilterValueOrFail, 1, 
/* 170 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 172 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 176 */     MCD::OPC_Decode, 203, 4, 105, // Opcode: LDDFAri, DecodeIdx: 105
/* 180 */     MCD::OPC_FilterValue, 52, 30, 0, // Skip to: 214
/* 184 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 187 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 202
/* 191 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 193 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 197 */     MCD::OPC_Decode, 233, 5, 132, 1, // Opcode: STFArr, DecodeIdx: 132
/* 202 */     MCD::OPC_FilterValueOrFail, 1, 
/* 204 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 206 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 210 */     MCD::OPC_Decode, 232, 5, 107, // Opcode: STFAri, DecodeIdx: 107
/* 214 */     MCD::OPC_FilterValue, 54, 31, 0, // Skip to: 249
/* 218 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 221 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 236
/* 225 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 227 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 231 */     MCD::OPC_Decode, 243, 5, 133, 1, // Opcode: STQFArr, DecodeIdx: 133
/* 236 */     MCD::OPC_FilterValueOrFail, 1, 
/* 238 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 240 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 244 */     MCD::OPC_Decode, 242, 5, 128, 1, // Opcode: STQFAri, DecodeIdx: 128
/* 249 */     MCD::OPC_FilterValue, 55, 30, 0, // Skip to: 283
/* 253 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 256 */     MCD::OPC_FilterValue, 0, 11, 0, // Skip to: 271
/* 260 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 262 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 266 */     MCD::OPC_Decode, 225, 5, 134, 1, // Opcode: STDFArr, DecodeIdx: 134
/* 271 */     MCD::OPC_FilterValueOrFail, 1, 
/* 273 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 275 */     MCD::OPC_CheckFieldOrFail, 30, 2, 3, 
/* 279 */     MCD::OPC_Decode, 224, 5, 109, // Opcode: STDFAri, DecodeIdx: 109
/* 283 */     MCD::OPC_FilterValueOrFail, 58, 
/* 285 */     MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 288 */     MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 306
/* 292 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 294 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 298 */     MCD::OPC_CheckFieldOrFail, 5, 3, 0, 
/* 302 */     MCD::OPC_Decode, 148, 6, 81, // Opcode: TICCrr, DecodeIdx: 81
/* 306 */     MCD::OPC_FilterValueOrFail, 32, 
/* 308 */     MCD::OPC_CheckPredicateOrFail, 0, 
/* 310 */     MCD::OPC_CheckFieldOrFail, 29, 3, 4, 
/* 314 */     MCD::OPC_Decode, 147, 6, 82, // Opcode: TICCri, DecodeIdx: 82
/* 318 */     MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeatureOSA2011]);
  case 2:
    return (Bits[Sparc::FeaturePWRPSR]);
  case 3:
    return (Bits[Sparc::FeatureUA2005]);
  case 4:
    return (Bits[Sparc::FeatureVIS3]);
  case 5:
    return (Bits[Sparc::FeatureVIS]);
  case 6:
    return (Bits[Sparc::FeatureVIS2]);
  case 7:
    return (Bits[Sparc::FeatureUA2007]);
  case 8:
    return (Bits[Sparc::LeonCASA] || Bits[Sparc::FeatureV9]);
  case 9:
    return (Bits[Sparc::FeatureV9] && Bits[Sparc::FeatureV9]);
  }
}

// Handling 135 cases.
template <typename InsnType>
static DecodeStatus decodeToMCInst(unsigned Idx, DecodeStatus S, InsnType insn, MCInst &MI, uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    if (!Check(S, DecodeDisp<19>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    if (!Check(S, DecodeDisp<22>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 0, 22);
    if (!Check(S, DecodeDisp<22>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 14), 0, 14);
    insertBits(tmp, fieldFromInstruction(insn, 20, 2), 14, 2);
    if (!Check(S, DecodeDisp<16>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 5, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 19, 2), 8, 2);
    if (!Check(S, DecodeDisp<10>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 29, 1), 3, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 5, 8), 0, 8);
    insertBits(tmp, fieldFromInstruction(insn, 19, 2), 8, 2);
    if (!Check(S, DecodeDisp<10>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 25, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 29, 1), 3, 1);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeSIMM5(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 7:
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 0, 19);
    if (!Check(S, DecodeDisp<19>(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (!Check(S, DecodeCall(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodePRRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 10, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 63:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 64:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 67:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 68:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 69:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 70:
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 71:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 73:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 74:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 75:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 76:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 9, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 77:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 78:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 79:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 80:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 81:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 82:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 86:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 87:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 88:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 89:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 90:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 91:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 92:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 93:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 94:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 95:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 96:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 97:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 98:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 99:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 100:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 101:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 102:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 103:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 104:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 105:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 106:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 107:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 108:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 109:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 110:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 111:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 112:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 113:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 114:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 115:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 116:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 117:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 118:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 119:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 120:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 121:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 122:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 123:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 124:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeCoprocPairRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 125:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 126:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 127:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 128:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (!Check(S, DecodeSIMM13(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 129:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 130:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 131:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 132:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 133:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 134:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (!Check(S, DecodePointerLikeRegClass0(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (!Check(S, DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    const uint8_t DecoderOp = *Ptr++;
    switch (DecoderOp) {
    default:
      errs() << Loc << ": Unexpected decode table opcode: "
             << (int)DecoderOp << '\n';
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue:
    case MCD::OPC_FilterValueOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_FilterValueOrFail;
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);

      // Note: Print NumToSkip even for OPC_FilterValueOrFail to simplify debug
      // prints.
      LLVM_DEBUG({
        StringRef OpName = IsFail ? "OPC_FilterValueOrFail" : "OPC_FilterValue";
        dbgs() << Loc << ": " << OpName << '(' << Val << ", " << NumToSkip
                << ") " << (Failed ? "FAIL:" : "PASS:")
                << " continuing at " << (Ptr - DecodeTable) << '\n';
      });

      // Perform the filter operation.
      if (Failed) {
        if (IsFail)
          return MCDisassembler::Fail;
        Ptr += NumToSkip;
      }
      break;
    }
    case MCD::OPC_CheckField:
    case MCD::OPC_CheckFieldOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_CheckFieldOrFail;
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);

      LLVM_DEBUG({
        StringRef OpName = IsFail ? "OPC_CheckFieldOrFail" : "OPC_CheckField";
        dbgs() << Loc << ": " << OpName << '(' << Start << ", " << Len << ", "
                << ExpectedValue << ", " << NumToSkip << "): FieldValue = "
                << FieldValue << ", ExpectedValue = " << ExpectedValue << ": "
                << (Failed ? "FAIL\n" : "PASS\n");
      });

      // If the actual and expected values don't match, skip or fail.
      if (Failed) {
        if (IsFail)
          return MCDisassembler::Fail;
        Ptr += NumToSkip;
      }
      break;
    }
    case MCD::OPC_CheckPredicate:
    case MCD::OPC_CheckPredicateOrFail: {
      bool IsFail = DecoderOp == MCD::OPC_CheckPredicateOrFail;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = IsFail ? 0 : decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);

      LLVM_DEBUG({
        StringRef OpName = IsFail ? "OPC_CheckPredicateOrFail" : "OPC_CheckPredicate";
        dbgs() << Loc << ": " << OpName << '(' << PIdx << ", " << NumToSkip
               << "): " << (Failed ? "FAIL\n" : "PASS\n");
      });

      if (Failed) {
        if (IsFail)
          return MCDisassembler::Fail;
        Ptr += NumToSkip;
      }
      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(DecodeIdx, S, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS\n" : "FAIL\n"));
      return S;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
